if(typeof kony == "undefined") {
    kony = {
        api: {},
        app: {},
        globals: {},
        system: {},
        widgets: {},
        io: {},
        apm: {},
        cop: {},
        automation: {},
        isformRenderd: true, 
        enableGetterSetters: false, 
        constants: {
            KONY_WIDGET_TYPE: "kwidgettype",
            SELECTED_ITEM: "selecteditem",
            IMAGE_PATH: "images",
            RESOURCES_PATH: "resources",
            TRANSLATION_PATH: "strings",
            TRANSLATION_EXT: "js",
            MODE: "s",
            RUNMODE: "debug",
            APPSTATE: 0
        }
    };
    spaAPM = null;
    $KAR = null;
    _kony = {
        mvc: {}
    };
    com = {};
    com.kony = {};
    konychannel = "wap"; 
    kiden = "useragent"; 
    $KC = kony.cop;
    $KI = kony.api;
    $KW = kony.widgets;
    $KG = kony.globals;
    $KIO = kony.io;
    $KA = kony.apm;
    $KAU = kony.automation;
    $KG.allforms = {};
    $KG.allTemplates = {};
    $KG.appbehaviors = {};
    $KG.widgetPositions = {};
    $KG["cwtexists"] = [];
    $KG["retina"] = "";
    $KG["imagecat"] = "";
    $KG["uniqueId"] = 0; 
    $KG["animStyleSheet"] = "";
    $KG["listBoxEditableInstances"] = [];
}
app = {
    headers: {},
    footers: {}
}

$KI.print = kony.print = function(str) {
    if(kony.constants.RUNMODE == "debug") {
        
        if(kony.constants.MODE == "s") {
            if(typeof JSON != "undefined" && typeof str == "object")
                console.log(JSON.stringify(str, $KU.jsonReplacer));
            else
                console.log(str);
        } else {
            alert(str);
        }
    }
};

kony.web = {};
kony.web.logger = function(level, msg) {
    var shouldUseLogger = ($KG.appbehaviors.enableLoggerFramework === true && kony.perflog.logger) ? true : false;

    switch(level) {
        case "log":
            if(shouldUseLogger) {
                kony.perflog.log('info', msg);
            } else {
                kony.print(msg);
            }
            break;

        case "warn":
            if(shouldUseLogger) {
                kony.perflog.log('warn', msg);
            } else {
                console.warn(msg);
            }
            break;
        case "error":
            if(shouldUseLogger) {
                kony.perflog.log('error', msg);
            } else {
                console.error(msg);
            }
            break;
        case "trace":
            if(shouldUseLogger) {
                kony.perflog.log('trace', msg);
            } else {
                kony.print(msg);
            }
            break;
        case "debug":
            if(shouldUseLogger) {
                kony.perflog.log('debug', msg);
            } else {
                kony.print(msg);
            }
            break;
        case "perf":
            if(shouldUseLogger) {
                kony.perflog.log('perf', msg);
            } else {
                kony.print(msg);
            }
            break;
        default:
            if(shouldUseLogger) {
                kony.perflog.log('info', msg);
            } else {
                kony.print(msg);
            }
    }
};

kony.perflog = {
    logger: null,

    loggerInit: function() {
        this.logger = kony.logger.createNewLogger("KonyFrameworkLogger", new kony.logger.createLoggerConfig());
        if(appConfig.isDebug === true) {
            kony.logger.activatePersistors(kony.logger.consolePersistor);
            kony.logger.currentLogLevel = kony.logger.logLevel.ALL;
            this.logger.setIndirectionLevel(3);
        }
    },

    log: function(logLevel, message) {
        this.logger[logLevel](message);
    }
};




if(typeof console === "undefined") {
    var alertFallback = false;
    var warnFallback = false;
    var errorFallback = false;

    console = {};
    console.log = function(msg) {
        alertFallback && alert(msg);
    };
    console.warn = function(msg) {
        warnFallback && alert(msg);
    };
    console.error = function(msg) {
        errorFallback && alert(msg);
    };
}
kony.appinit = {
    index: 0,
    JSMapFileCount: 0,
    head: document.getElementsByTagName('head')[0],
    debugFilesCount: 0,
    foldertype: "JSFiles",


    vendor: (/trident/gi).test(navigator.userAgent) ? 'ms' : ((/webkit/i).test(navigator.userAgent) && !(/edge/i).test(navigator.userAgent)) ? 'webkit' : (/firefox/i).test(navigator.userAgent) ? 'Moz' : 'opera' in window ? 'o' : ((/msie/i).test(navigator.userAgent) || (/rv:([1][1-9])/i).test(navigator.userAgent)) ? 'ms' : '',
    isIE: window.navigator.appVersion.match(/MSIE (\d+)/) != null || (/rv:([1][1-9])/i).test(navigator.userAgent),
    isIE7: window.navigator.appVersion.match(/MSIE (\d+)/) != null && RegExp.$1 == "7",
    isIE8: window.navigator.appVersion.match(/MSIE (\d+)/) != null && RegExp.$1 == "8",
    isIE9: window.navigator.appVersion.match(/MSIE (\d+)/) != null && RegExp.$1 == "9",
    isIE10: navigator.userAgent.match(/MSIE (\d+)/) != null && RegExp.$1 == "10",
    isIE11: (/rv:([1][1-9])/i).test(navigator.userAgent),
    isEdge: (/edge/gi).test(navigator.userAgent),
    isFirefox: window.navigator.userAgent.indexOf("Firefox") >= 0,
    isChrome: window.navigator.userAgent.indexOf("Chrome") >= 0,
    isSafari: (window.navigator.userAgent.indexOf("Safari") >= 0) && !((window.navigator.userAgent.indexOf("Chrome") >= 0) || (window.navigator.userAgent.indexOf("CriOS") >= 0) || (window.navigator.userAgent.indexOf("GSA") >= 0)), 
    isOpera: window.navigator.userAgent.indexOf("Opera") >= 0,
    isAndroid: (/android/gi).test(navigator.userAgent) && !((/trident/gi).test(navigator.userAgent)) && !((/edge/gi).test(navigator.userAgent)),
    isIDevice: (/iphone|ipad/gi).test(navigator.userAgent) && !((/trident/gi).test(navigator.userAgent)),
    isiPhone: (/iphone/gi).test(navigator.userAgent) && !((/trident/gi).test(navigator.userAgent)),
    isiPod: (/ipod/gi).test(navigator.userAgent),
    isiPad: (/ipad/gi).test(navigator.userAgent),
    isPlaybook: (/playbook/gi).test(navigator.userAgent),
    isBlackBerry: ((/bb10/gi).test(navigator.userAgent) || (/blackberry/gi).test(navigator.userAgent)) && typeof bbnth == "undefined",
    isBlackBerry10: (/bb10/gi).test(navigator.userAgent),
    isBlackBerryNTH: (/blackberry/gi).test(navigator.userAgent) && typeof bbnth != "undefined" && bbnth,
    isTouchPad: (/hp-tablet/gi).test(navigator.userAgent),
    isWindowsPhone: (/Windows Phone/gi).test(navigator.userAgent),
    isWindowsTouch: (/Windows/gi).test(navigator.userAgent) && (/Touch/gi).test(navigator.userAgent) || ((/trident/gi).test(navigator.userAgent)),
    isWindowsTablet: (/Windows NT/gi).test(navigator.userAgent) && (/Touch/gi).test(navigator.userAgent),
    isTablet: (/hp-tablet|ipad|playbook/gi).test(navigator.userAgent) || ((/android/gi).test(navigator.userAgent) && !(/mobile/gi).test(navigator.userAgent)),
    isMob: (/mobile/gi).test(navigator.userAgent),
    transition: ((/edge/gi).test(navigator.userAgent)) ? "transition" : "Transition",
    isCameraSupported: false,

    syncFiles: ["jslib/konytextfieldwidget.js"],
    syncJSFiles: ["jslib/konyconstants.js", "jslib/konywidgetdefault.js", "jslib/konyJSLib/ui/konyuiBaseClasses.js", "jslib/konyJSLib/ui/konyuiForm.js"], 
    syncLuaFiles: ["jslib/konyLuaLib/ui/windowBaseClasses.js", "jslib/konyLuaLib/ui/windowForm.js", "jslib/konyLuaLib/ui/windowBox.js"],
    asyncViewFiles: ["jslib/konyconstcommon.js", "jslib/konymodel.js", "jslib/konycore.js", "jslib/konysystem.js", "jslib/konyapi.js", "jslib/konymodule.js", "jslib/konytableapi.js", "jslib/konyosapi.js", "jslib/konymathapi.js", "jslib/konyutils.js", "jslib/konyi18n.js", "jslib/konywidgets.js", "jslib/konyskinutils.js", "jslib/konyflexutils.js", "jslib/konywidgetapiutils.js", "jslib/konyimageutils.js", "jslib/konytouchwidgets.js", "jslib/konyformwidget.js", "jslib/konyappmenu.js", "jslib/konynetwork.js", "jslib/konyworker.js", "jslib/konylabelwidget.js", "jslib/konybuttonwidget.js", "jslib/konysliderwidget.js", "jslib/konytextfieldautocomplete.js", "jslib/konytextfieldpassword.js", "jslib/konyradiobuttongroup.js", "jslib/konylistboxgroup.js", "jslib/konytextareawidget.js", "jslib/konycheckboxgroup.js",  "jslib/konyflexlayoutengine.js", "jslib/konyflexcontainerwidget.js", "jslib/konyflexscrollcontainerwidget.js", "jslib/konylinewidget.js", "jslib/konysegmentwidget.js", "jslib/konyimagewidget.js", "jslib/konyslotviewwidget.js", "jslib/konybrowserwidget.js", "jslib/konycanvaswidget.js", "jslib/konydatagridwidget.js", "jslib/konymapwidget.js", "jslib/konytabwidget.js", "jslib/konyswitchwidget.js", "jslib/konyphone.js", "jslib/konyscrollerwidget.js", "jslib/konyrichtextwidget.js", "jslib/konymediawidget.js", "jslib/konythemesapi.js", "jslib/konycalendarwidget.js", "jslib/konyanimations.js", "jslib/konyhybridapi.js",
        "jslib/konydatabaseapi.js", "jslib/konydatastoreapi.js", "jslib/konygeolocationapi.js", "jslib/konyphoneapi.js", "jslib/konytimerapi.js", "jslib/konyapm.js", "jslib/konycrypto.js", "jslib/tparty/crypto/cryptojslib-min.js", "jslib/tparty/requirejs/require.js",
        "jslib/konymvc.js", "jslib/konyuserwidget.js", "jslib/konycollectionview.js", "jslib/konynosqlapi.js",
        "jslib/konyimagepinchzoom.js", "jslib/konycamerawidget.js", "jslib/konycop.js"
    ],
    asyncDebugFiles: ["jslib/tparty/jasmine/jasmine.js","jslib/tparty/jasmine/jamsinecucumber.js","jslib/tparty/jasmine/jasmine-feature-runner.js","jslib/tparty/jasmine/testDefinitions.js","jslib/automation/konyautomationutils.js", "jslib/automation/konyautomationwidgets.js",
        "jslib/automation/konyautomationtouchevents.js", "jslib/automation/konyautomationrecorder.js"],
    asyncJSFiles: ["jslib/konyJSLib/core/konyJSUtils.js", "jslib/konyJSLib/ui/konyuiBasicWidgets.js", "jslib/konyJSLib/ui/konyuiFlexContainer.js", "jslib/konyJSLib/ui/konyuiCalendar.js", "jslib/konyJSLib/ui/konyuiDataGrid.js", "jslib/konyJSLib/ui/konyuiGroupWidgets.js", "jslib/konyJSLib/ui/konyuiImage.js", "jslib/konyJSLib/ui/konyuiMap.js", "jslib/konyJSLib/ui/konyuiBrowser.js", "jslib/konyJSLib/ui/konyuiCanvas.js", "jslib/konyJSLib/ui/konyuiRichText.js", "jslib/konyJSLib/ui/konyuiSegmentedUI.js", "jslib/konyJSLib/ui/konyuiCollectionView.js", "jslib/konyJSLib/ui/konyuiText.js", "jslib/konyJSLib/ui/konyuiTabPane.js", "jslib/konyJSLib/ui/konyuiSlider.js", "jslib/konyJSLib/ui/konyuiVideo.js", "jslib/konyJSLib/ui/konyuiUserWidget.js", "jslib/konyJSLib/ui/konyuiCamera.js"],
    JSMapList: ["jslib/konyJSLib/core/konyJSMapping.js", "jslib/konyJSLib/core/konyapplication.js", "jslib/konymvc_sdk.js"],

    isLocalBuild: false,

    initializeWidgets: function() {
        
        var widgetsSupported = [$KW.Form, $KW.Button, $KW.Image, $KW.Label, $KW.TextField, $KW.ListBox, $KW.RichText, $KW.CheckBoxGroup, $KW.RadioButtonGroup, $KW.Map, $KW.Phone, $KW.Segment, $KW.Appmenu, $KW.TabPane, $KW.Calendar, $KW.Switch, $KW.TextArea, $KW.DataGrid, $KW.FlexScrollContainer, $KW.Slider, $KW.Line, $KW.FlexContainer, $KW.FlexScrollContainer, $KW.Camera];
        for(var i = 0; i < widgetsSupported.length; i++) {
            if(widgetsSupported[i]) {
                widgetsSupported[i].initialize && widgetsSupported[i].initialize();
            }
        }
    },

    loadlibrarysync: function() {
        
        var appInit = kony.appinit;
        if(!($KI.themes)) {

            if(appInit.index > 0)
                kony.web.logger("log", "File loaded in sync: " + appInit.syncFiles[appInit.index - 1] + "  number: " + appInit.index);

            if(appInit.index == appInit.syncFiles.length) {
                appInit.loadlibraryasync(appInit.asyncViewFiles, appInit.ondone);
                return;
            }
            kony.appinit.loadScript(kony.appinit.syncFiles[kony.appinit.index], kony.appinit.loadlibrarysync);
            appInit.index++;
        } else {
            $KG["skipproxy"] = true;
            appInit.verifyhref();

        }
    },

    ondone: function() {
        var appInit = kony.appinit;
        kony.web.logger("log", "File loaded in async: " + appInit.asyncViewFiles[appInit.index] + "  number: " + appInit.index);
        appInit.index++;
        if(appInit.index == appInit.asyncViewFiles.length) {
            
            IndexJL ? appInit.verifyhref() : kony.appinit.loadJSMap();
            return;
        }
    },

    loadlibraryasync: function(files, cb) {
        var appInit = kony.appinit;
        appInit.index = 0;
        for(var i = 0; i < files.length; i++) {
            appInit.loadScript(files[i], cb);
        }
    },

    loadJSMap: function() {
        var appInit = kony.appinit;

        appInit.JSMapList[appInit.JSMapFileCount] && appInit.loadScript(appInit.JSMapList[appInit.JSMapFileCount], appInit.loadJSMap);
        appInit.JSMapFileCount++;
        (appInit.JSMapFileCount == 3) && appInit.verifyhref();
    },

    
    getStaticContentPath: function() {
        return $KG["staticContentPath"] ? $KG["staticContentPath"] : "";
    },

    loadScript: function(src, callback) {
        var script = document.createElement('script');
        script.src = kony.appinit.getStaticContentPath() + $KG["platformver"] + src;
        script.type = "text/javascript";
        if(!script.addEventListener) {
            script.onreadystatechange = function() {
                (this.readyState == 'complete' || this.readyState == 'loaded') && callback();
            };
        } else
            script.onload = callback;
        kony.appinit.head.appendChild(script);
    },

    mergeDownloadLists: function() {
        var appInit = kony.appinit;
        var synctype = "sync" + appInit.foldertype;
        var asynctype = "async" + appInit.foldertype;
        appInit.syncFiles = appInit.syncFiles.concat(appInit[synctype]);
        appInit.asyncViewFiles = appInit.asyncViewFiles.concat(appInit[asynctype]);
    },


    appcacheeventhndlr: function(event) {
        if(!event)
            event = window.event;

        switch(event.type) {
            case "checking":
                kony.web.logger("log", "Checking for Manifest Version");
                break;

            case "downloading":
                kony.web.logger("log", "Downloading of Manifest Resources");
                break;

            case "progress":
                break;

            case "cached":
                kony.web.logger("log", "Manifest Resources loading done");
                break;

            case "noupdate":
                kony.web.logger("log", "No Change in Manifest File");
                break;

            case "updateready":
                kony.web.logger("log", "New manifest resources downloaded,swap the cache");
                try {
                    window.applicationCache.swapCache();
                    window.location.reload();
                } catch(e) {
                    kony.web.logger("log", "invalid state: swapping the cache");
                }
                break;

            case "obsolete":
                kony.web.logger("warn", "Cache Manifest file not found. So deleting app cache");
                break;

            case "error":
                kony.web.logger("warn", "Error while loading app cache");
                
                break;

            default:
                kony.web.logger("warn", "Appcache Event not supported");
        }
    },

    
    
    verifyhref: function(skiploadappjs) {
        
        kony.appinit.useTransition = (typeof(document.body || document.documentElement).style[kony.appinit.vendor + kony.appinit.transition] == "string");

        
        var konyappprops = document.getElementsByName('_konyAppProperties')[0];
        if(konyappprops && konyappprops.value && konyappprops.value !== 'null') {
            try {
                window["_konyAppProperties"] = JSON.parse(konyappprops.value); 
            } catch(e) {
                kony.web.logger("warn", "Error while loading application properties. i.e <appId>.properties");
            }
        } else
            window["_konyAppProperties"] = undefined;
        var konyParams = document.getElementsByName('_reqParams')[0];
        if(konyParams && konyParams.value && konyParams.value !== 'null') {
            kony.globals["konyParams"] = JSON.parse($KU.getDecodedPropValue(konyParams.value))
        }
        var reqhdrs = document.getElementsByName('_reqHeaders')[0];
        if(reqhdrs && reqhdrs.value && reqhdrs.value !== 'null') {
            var keys = [];
            var headersJSON = "";
            headersJSON = JSON.parse($KU.getDecodedPropValue(reqhdrs.value).replace(/"="/g, "\":\""));
            for(p in headersJSON) {
                headersJSON[p] = decodeURIComponent(headersJSON[p]);
            }
            kony.globals["httpheaders"] = headersJSON;
            if(Object.keys)
                keys = Object.keys(kony.globals["httpheaders"]);
            else
                for(var j in kony.globals["httpheaders"])
                    keys.push(j);

            for(var i = 0; i < keys.length; i++)
                kony.globals["httpheaders"][keys[i]] = unescape(kony.globals["httpheaders"][keys[i]]);
        }

        var searchstr = window.location.search.slice(1);
        
        if(searchstr == "") {
            var hash = window.location.hash.slice(2);
            var lform = null;
            try {
                lform = sessionStorage.getItem("klastform");
            } catch(err) {}
            
            $KG["__launchmode"] = 1;

            if(hash != "") {
                
                if(lform == hash) {
                    kony.logfer("log", "verifyhref:Last Form Stored: " + lform);
                } else {
                    kony.web.logger("log", "verifyhref:Last Form Stored: " + lform + " Hash: " + hash);
                }

                if(skiploadappjs)
                    kony.appinit.hashflowshowform();
                else
                    kony.appinit.loadappjs(kony.appinit.hashflowshowform);
                

            } else {
                
                if(lform != null) {
                    
                    try {
                        sessionStorage.removeItem("klastform");
                        sessionStorage.removeItem("kmodel");
                    } catch(err) {}
                    kony.print("verifyhref: Deleted Existing sessionStorage");
                }


                if(skiploadappjs)
                    kony.appinit.deeplinkflow();
                else
                    kony.appinit.loadappjs(kony.appinit.deeplinkflow);

            }
        } else {
            
            $KG["__launchmode"] = 3;

            if(skiploadappjs)
                kony.appinit.deeplinkflow();
            else
                kony.appinit.loadappjs(kony.appinit.deeplinkflow);

        }
    },

    restorespamodel: function() {
        
        try {
            var modelstr = sessionStorage.getItem("kmodel");
            var modelobj = "";
        } catch(err) {}
        if(modelstr)
            modelobj = JSON.parse(modelstr);

        if(modelobj) {
            
            kony.print("restorespamodel:Model Reloaded");
            
            return true;
        } else {
            kony.print("restorespamodel:Case of Corrupt Model");
            
            return true;
        }
    },

    appstartup: function() {
        
        setTimeout(function() {
            kony.appinit.disablesplash();
        }, 100);
    },

    hashflowshowform: function() {
        var form = null;
        try {
            form = sessionStorage.getItem("klastform");
        } catch(err) {}
        
        if(kony.appinit.restorespamodel() && form) {
            var formobj = $KG.allforms[form];
            kony.print("hashflowshowform: Display Form " + formobj.id);
            formobj && $KW.Form.show(formobj);
        } else {
            kony.print("hashflowshowform:ERROR recovering model so landing on Home Page");
            
            kony.appinit.deeplinkflow();
        }
    },

    deeplinkflow: function() {
        
        var searchstring = window.location.search.slice(1);

        var deepobj = {};
        var queryString = searchstring.split("&");

        kony.print("deeplinkflow: args:" + queryString.join());

        for(var i = 0; i < queryString.length; i++) {
            var s = queryString[i].replace(/\+/g, ' ').split("=");
            var key = decodeURIComponent(s[0]);
            var value = decodeURIComponent(s[1]);
            if(key) deepobj[key] = value;
        }

        var path = window.location.href.split("?");
        var sessionflag = searchstring.search("kdeeplink=");

        deepobj["deeplinkpath"] = path[0];
        
        deepobj["deepLinkPath"] = path[0];
        
        deepobj['reqheaders'] = kony.globals["httpheaders"];
        if(kony.globals["konyParams"]) {
            for(var param in kony.globals["konyParams"])
                deepobj[param] = kony.globals["konyParams"][param];
        }
        $KG["kdeepobj"] = deepobj;

        if(sessionflag == -1)
            kony.print("deeplinkflow:newsession");
        else
            kony.print("deeplinkflow:insession");

        setTimeout(function() {
            kony.appinit.disablesplash();
        }, 100);

    },

    
    loadappjs: function(cb) {
        kony.appinit.loadScript("jslib/konylicense.js");
        kony.appinit.loadScript("appjs/app.js", cb);
    },

    initLocalStorage: function() {
        try {
            if(typeof(localStorage) === "object") {
                var store = $KU.getLocalStorage(),
                    l = 0,
                    len = 0,
                    key = '',
                    value = '';

                if(typeof store === 'object' && store &&
                    store.migrated === true &&
                    $KU.isArray(store.data)) {
                    return;
                } else if(store !== '' && store !== null) {
                    $KG.localStorageBackup = store; 
                }

                store = $KU.createBlankLocalStorage();
                localStorage.setItem($KG.appid, JSON.stringify(store));
            }
        } catch(e) {}
    },

    migrateLocalStorage: function() {
        try {
            if(typeof(localStorage) === "object") {
                var store = $KU.getLocalStorage(),
                    keysToBeRemoved = [],
                    l = 0,
                    len = 0,
                    parsed = null,
                    key = '',
                    value = '';

                
                
                if(store.migrated === true) return;

                store.migrated = true;

                if($KG.appbehaviors[constants.API_LEVEL] < constants.API_LEVEL_8200) {
                    localStorage.removeItem("i18nVersion");

                    len = localStorage.length;
                    for(l = 0; l < len; l++) {
                        key = localStorage.key(l);

                        if(key === $KG.appid) {
                            if($KG.hasOwnProperty('localStorageBackup')) {
                                
                                store.data.push({
                                    key: key,
                                    value: $KG.localStorageBackup
                                });
                            }
                        } else {
                            
                            if(key.indexOf($KG.appid + '_') !== 0 &&
                                key.split('_').length < 2) {
                                value = localStorage.getItem(key);
                                try {
                                    parsed = JSON.parse(value);
                                } catch(e) {
                                    parsed = value;
                                }

                                
                                if(!(typeof parsed === 'object' && parsed &&
                                        parsed.migrated === true &&
                                        $KU.isArray(parsed.data))) {
                                    keysToBeRemoved.push(key);
                                    store.data.push({
                                        key: key,
                                        value: parsed
                                    });
                                }
                            }
                        }
                    }

                    
                    len = keysToBeRemoved.length;
                    for(l = 0; l < len; l++) {
                        localStorage.removeItem(keysToBeRemoved[l]);
                    }
                }

                localStorage.setItem($KG.appid, JSON.stringify(store));
            }
        } catch(e) {}
    },

    disableForceRepaint: function() {
        if(($KG.appbehaviors["disableForceRepaint"] != true) && (kony.appinit.isiPhone || kony.appinit.isiPad)) {
            var styleSheet = $KG["animStyleSheet"];
            styleSheet.insertRule('div[kwidgettype="FlexContainer"], div[kwidgettype="FlexScrollContainer"] {transform: translateZ(0);}', styleSheet.cssRules.length);
        }
    },

    disablesplash: function() {
        kony.print("disabling splash");
        $KG["animStyleSheet"] = $KU.createStyleSheet("animSheet"); 
        
        kony.appinit.initializeheaders();
        var eventobj = $KG["__konyappevents"];
        kony.appinit.initLocalStorage();
        
        kony.appinit.konyLoadFunctionalModules();
        kony.print("appmode:not hybrid,invoking initializeapp");
        kony.perflog.loggerInit();
        if(appConfig.testAutomation && kony.appinit.isLocalBuild) {
            kony.appinit.loadlibraryasync(kony.appinit.asyncDebugFiles, kony.appinit.debugfilesonDone);
        } else {
            initializeApp && initializeApp();
        }
    },
    debugfilesonDone: function() {
        var appInit = kony.appinit;
        kony.web.logger("log", "File loaded in async: " + appInit.asyncDebugFiles[appInit.debugFilesCount] + "  number: " + appInit.debugFilesCount);
        appInit.debugFilesCount++;
        if(appInit.debugFilesCount == appInit.asyncDebugFiles.length) {
            initializeApp && initializeApp();
        }
    },

    setAppHeaderRef: function() {
        var setRef = function(headers) {
            for(var hbox in headers) {
                var header = headers[hbox];
                var box = headers[hbox] = window[header][hbox];
                $KU.setChildren(header, box, box.children);
            }
        }
        var headers = kony.app.headers;
        headers && setRef(headers);

        var footers = kony.app.footers;
        footers && setRef(footers);
    },

    setChildren: function(header, box, children) {
        if(children && children.length > 0) {
            for(var i = 0; i < children.length; i++) {
                box[children[i]] = window[header][children[i]];
                this.setChildren(header, box, window[header][children[i]].children);
            }
        }
    },

    setImageBasedDP: function() {
        var imageCat = "";

        if($KU.isAndroid) {
            var dpratio = window.devicePixelRatio;
            if(!$KU.isTablet) {
                if(dpratio <= 1)
                    imageCat = "320/";
                else if(dpratio > 1 && dpratio <= 1.5)
                    imageCat = "360/";
                else if(dpratio > 1.5 && dpratio <= 2)
                    imageCat = "400/";
                else if(dpratio > 2)
                    imageCat = "440/";
            } else {
                if(dpratio <= 1) {
                    imageCat = "mdpi/";
                } else if(dpratio <= 1.5) {
                    imageCat = "hdpi/";
                } else if(dpratio > 1.5) {
                    imageCat = "xhdpi/";
                }
            }
        }
        
        else if($KU.isWindowsPhone) {

            imageCat = "320/";
        } else if($KU.isBlackBerry || $KU.isBlackBerryNTH) {
            var orientation = window.orientation;
            var imageCat = window.innerWidth + "/";
            if(orientation)
                imageCat = Math.min(window.innerWidth, window.innerHeight);
            if(orientation && parseInt(imageCat, 10) > 250)
                imageCat = "360/"
            else if(orientation || parseInt(imageCat, 10) < 340)
                imageCat = "320/";
            else
                imageCat = "360/";

            if(window.devicePixelRatio > 2)
                imageCat = "440/";
        }
        if(typeof spaMarkup != "undefined" &&
            spaMarkup && spaMarkup === "spaiphone") {
            imageCat = "";
        }

        
        $KG["imagecat"] = imageCat;

        
        if($KG["imagewhiledownloading"])
            new Image().src = $KU.getImageURL($KG["imagewhiledownloading"]);
        new Image().src = $KU.getImageURL("imgload.gif");
    },

    initializeheaders: function(eventObject) {
        if(kony.constants.APPSTATE == 0) {
            kony.app && kony.appinit.setAppHeaderRef();
        }
    },

    initializeMainContainer: function() {
        var main = $KU.getElementById('__MainContainer');
        if(!main) {
            
            var mainContainerEle = document.createElement('div');
            mainContainerEle.setAttribute("id", "__MainContainer");
            document.body.appendChild(mainContainerEle);
        }
        kony.events.registerDocumentEvents();
    },

    prepareHttpHeaders: function() {
        
        var isnewsession = document.getElementById("isnewsession");
        if(isnewsession != null)
            kony.appinit.isNewSession = isnewsession.innerHTML;
        var sessionId = document.getElementById("sessionId");
        if(sessionId != null)
            kony.appinit.sessionId = isnewsession.innerHTML;
    },

    initappcache: function() {
        kony.appinit.prepareHttpHeaders();


        $KG["imagecat"] = "";
        $KG["retina"] = "";
        kony.appinit.useTransition = (typeof(document.body || document.documentElement).style[kony.appinit.vendor + kony.appinit.transition] == "string");
        kony.appinit.mergeDownloadLists();
        
        
        
        if(document.documentElement.getAttribute("manifest") && !!window.applicationCache) {
            var appcacheevents = ["checking", "downloading", "progress", "cached", "noupdate", "updateready", "obsolete", "error"];

            for(var i = 0; i < appcacheevents.length; i++) {
                window.applicationCache.addEventListener(appcacheevents[i], kony.appinit.appcacheeventhndlr, false);
            }
        } else {
            
        }
        kony.appinit.isLocalBuild = true;
        kony.appinit.loadlibrarysync();
    },

    
    konyLoadFunctionalModules: function() {
        if($KG["functionalModules"]) {
            var fms = $KG["functionalModules"];
            for(var fm in fms) {
                if(fm && (fm !== "KonydefaultModules") && (fms[fm].cache || fms[fm].loadOnStartUp)) {
                    kony.modules.loadModule(fm);
                }
            }
        }
    },

    setApplicationMetaConfiguration: function(ckey, cval) {
        var putIntoAppConfig = function(id, val) {
            if(id === 'appid') kony.globals[id] = val;
            else if(id === 'locales') kony.globals[id] = val;
            else if(id === 'build') kony.globals[id] = val;
            else if(id === 'i18nArray') {
                kony.globals[id] = val;
            } else {
                kony.globals[id] = val;
            }
        };

        if(typeof ckey === 'string') {
            putIntoAppConfig(ckey, cval);
        } else if(typeof ckey === 'object' && ckey) {
            for(var k in ckey) {if(ckey.hasOwnProperty(k)) {
                putIntoAppConfig(k, ckey[k]);
            }}
        }
    },

    
    isPWAStandalone: function() {
        if((window.matchMedia && window.matchMedia('(display-mode: standalone)').matches) || window.navigator.standalone) {
            return true;
        } else {
            return false;
        }
    }
};


$KI.os = {
    platform: function() {
        $KU.logExecuting('kony.os.deviceInfo');
        $KU.logExecutingWithParams('kony.os.deviceInfo');
        var params = {};

        var imagecat = $KG["imagecat"];
        imagecat = imagecat.substring(0, imagecat.length - 1);
        var platform = $KU.getPlatform();
        if(platform.name == "iphone")
            if(window.devicePixelRatio == 1)
                imagecat = "320";
            else
                imagecat = "640";

        params["name"] = "thinclient";
        params["model"] = ""
        params["version"] = platform.version;
        params["deviceWidth"] = screen.availWidth;
        params["deviceHeight"] = screen.availHeight;
        params["screenWidth"] = $KU.getWindowWidth();
        params["screenHeight"] = $KU.getWindowHeight();
        params["hascamera"] = kony.appinit.isCameraSupported;
        params["hasgps"] = (navigator.geolocation != undefined ? true : false);
        params["hastouchsupport"] = $KU.isTouchSupported;
        params["hasorientationsupport"] = $KU.isOrientationSupported;
        params["iswifiavailable"] = (navigator.onLine != undefined ? navigator.onLine : true);
        params["type"] = "spa";
        params["imagecat"] = imagecat;
        params["deviceid"] = $KU.getDeviceId();
        params["category"] = platform.name;
        params["userAgent"] = navigator.userAgent;
        params["osName"] = platform.deviceOSType;
        params["osVersion"] = platform.deviceOSVersion;

        params["ip"] = "";
        if($KG["httpheaders"])
            params["httpheaders"] = JSON.stringify($KG["httpheaders"]);

        $KU.logExecutingFinished('kony.os.deviceInfo');
        return params;
    },

    useragent: function() {
        $KU.logExecuting('kony.os.userAgent');
        $KU.logExecutingWithParams('kony.os.userAgent');
        $KU.logExecutingFinished('kony.os.userAgent');
        return navigator.userAgent;
    },

    setapplicationmode: function(mode) {
        $KU.logExecuting('kony.application.setApplicationMode');
        $KU.logExecutingWithParams('kony.application.setApplicationMode', mode);
        $KG["appmode"] = mode;
        if(mode == 2 || mode == 3) {
            $KG["platformver"] = "";
        }
        $KU.logExecutingFinished('kony.application.setApplicationMode');
    },

    getapplicationmode: function(mode) {
        $KU.logExecuting('kony.application.getApplicationMode');
        $KU.logExecutingWithParams('kony.application.getApplicationMode', mode);
        var mode = $KG["appmode"];
        $KU.logExecutingFinished('kony.application.getApplicationMode');
        return !!mode ? mode : 1;
    }
};

kony.decrement = function(num) {
    if(typeof(num) === "number") {
        return num - 1;
    } else {
        return num;
    }
};

kony.increment = function(num) {
    if(typeof(num) === "number") {
        return num + 1;
    } else {
        return num;
    }
};

kony.decrementIndices = function(arr) {
    var tArr = [];
    for(var i = 0; i < arr.length; i++) {
        tArr[i] = arr[i] - 1;
    }
    return tArr;
};

kony.incrementIndices = function(arr) {
    var tArr = [];
    for(var i = 0; i < arr.length; i++) {
        tArr[i] = arr[i] + 1;
    }
    return tArr;
};

function containerWidgetExtendAdd(widgetarray) {
    this.ownchildrenref = this.ownchildrenref.concat(widgetarray);
    this.createhierarchy(widgetarray);
    this.setparent(widgetarray); 
};


function containerWidgetExtendAddAt(widgetref, index) {
    index = index < IndexJL ? IndexJL : (index - IndexJL > this.ownchildrenref.length ? this.ownchildrenref.length + 1 : index - IndexJL);
    this.children.splice(index, 0, widgetref.id);
    this.ownchildrenref.splice(index, 0, widgetref);
    widgetref.parent = this;
    this.createhierarchy([widgetref]);
};

function containerWidgetExtendRemove(widgetref) {
    _konyConstNS.ContainerWidget.prototype.removeReferences.call(this, widgetref);
    boxWidgetExtendRemoveUpdate.call(this, widgetref, true);
};

function containerWidgetExtendRemoveAt(index) {
    var remwidgetref = null;
    if(index >= IndexJL && index - IndexJL <= this.ownchildrenref.length) {
        var remwidgetref = this.ownchildrenref[index - IndexJL];
        remwidgetref && _konyConstNS.ContainerWidget.prototype.remove.call(this, remwidgetref);
    }
    boxWidgetExtendRemoveUpdate.call(this, remwidgetref, true);
    return remwidgetref;
};

function containerWidgetExtendSetParent(widgetarray) {
    for(var i = 0; i < widgetarray.length; i++) {
        this.children.push(widgetarray[i].id);
        widgetarray[i].parent = this;
        
        if(widgetarray[i].defineContainerGetter) {
            widgetarray[i].defineContainerGetter(this);
            widgetarray[i].defineContainerSetter(this);
        }
    }
};


function __createHierarchy(that, widgetref, containerType) {
    if(widgetref.id == undefined) {
        throw new KonyError(1102, 'WidgetError', 'Widget ID cannot be null, please provide proper ID');
    }
    if(($KG.appbehaviors[constants.API_LEVEL] >= constants.API_LEVEL_7000) && that[widgetref.id] && !widgetref.childHierarchy) {
        throw new KonyError(1102, 'WidgetError', 'Duplicate widget ID found while added to Form, Widget ID:-' + widgetref.id);
    } else if(!widgetref.immediateMaster) {
        if( that.wType == 'Form' && (that[widgetref.id] && that[widgetref.id] != widgetref)) {
            containerWidgetExtendRemoveReferences.call(widgetref.parent, widgetref);
            throw new KonyError(1102, 'WidgetError', 'Duplicate widget ID found while added to Form, Widget ID:-' + widgetref.id);
        }
        that[widgetref.id] = widgetref;
        widgetref.childHierarchy = true;
    }


    if(that.wType == "TabPane")
        widgetref.pf = that.pf;
    else
        widgetref.pf = that.id;

    if(widgetref.wType == 'Map') {
        that[widgetref.id] = widgetref;
    }


}

function containerWidgetExtendCreateHierarchy(widgetarray) {
    for(var i = 0; i < widgetarray.length; i++) {
        var widgetref = widgetarray[i];
        __createHierarchy(this, widgetref, "container");
        widgetref.layoutConfig = {
            self: true,
            children: false
        }; 
        
        if(this.isMaster) {
            updateImmediateMasterToChilds(widgetref, this);
        }
        
        if(this.immediateMaster) {
            updateImmediateMasterToChilds(widgetref, $KW.Utils.getMasterWidgetModel(this));
        }
    }
};


function updateImmediateMasterToChilds(widgetModel, immediateMaster) {
    if(!widgetModel.immediateMaster) {
        if(immediateMaster[widgetModel.id] &&  immediateMaster[widgetModel.id] != widgetModel) {
            containerWidgetExtendRemoveReferences.call(immediateMaster[widgetModel.pf], widgetModel);
            throw new KonyError(1102, 'WidgetError', 'Duplicate widget ID found while adding to Container, Widget ID:-' + widgetModel.id);
        }
        immediateMaster[widgetModel.id] = widgetModel;
        widgetModel.immediateMaster = immediateMaster.id;
    }
    if(widgetModel.isMaster) {
        immediateMaster = widgetModel;
    }
    if(widgetModel.isContainerWidget) {
        for(var i = 0; i < widgetModel.children.length; i++) {
            var childModel = widgetModel[widgetModel.children[i]];
            updateImmediateMasterToChilds(childModel, immediateMaster);
        }
    }
};


function generateKMasterID(widgetModel) {
    var proxyModel = $KW.Utils.getActualWidgetModel(widgetModel, true);
    if(proxyModel.isContainerWidget) {
        var childArrLen = proxyModel.children.length;
        for(var i = 0; i < childArrLen; i++) {
            var childModel = proxyModel[proxyModel.children[i]];
            generateKMasterID(childModel);
        }
    }
    setKMasterIDToWidgetModel(proxyModel);
}

function setKMasterIDToWidgetModel(widgetModel) {
    var str = [];
    var pMaster = widgetModel.parent;
    if(widgetModel._userWidget) {
        pMaster = widgetModel.kComponentModel.parent;
    }
    while(pMaster) {
        if(pMaster.isMaster) {
            str.push(pMaster.id);
        }
        if(pMaster._userWidget) {
            pMaster = pMaster.kComponentModel.parent;
        } else {
            pMaster = pMaster.parent;
        }
    }
    var kmasterid = str.reverse().join("_");
    if(kmasterid != "") {
        widgetModel.kmasterid = kmasterid;
    }
}

function containerWidgetExtendRemoveReferences(widgetref) {
    delete this[widgetref.id];

    if(this.children.remove)
        this.children.remove(widgetref.id);
    else {
        var chld = this.children;
        if(chld.indexOf(widgetref.id) >= 0) {
            chld && chld.splice(chld.indexOf(widgetref.id), 1);
        }
    }
    var chldref = this.ownchildrenref;
    var index = chldref.indexOf(widgetref);
    chldref && chldref.splice(index, 1);
    removeReferencesFromTopLevelModel(widgetref);
    removeImmediateMasterProperty(widgetref);
};


function removeAllReferences(widgetRef) {
    var topLevelModel = $KG.allforms[widgetRef.pf];
    if(topLevelModel) {
        if(widgetRef instanceof _konyConstNS.ContainerWidget && !widgetRef.isMaster) {
            var widgets = widgetRef.widgets();
            for(var i = 0; i < widgets.length; i++) {
                delete topLevelModel[widgets[i].id];
                if(widgets[i] instanceof _konyConstNS.ContainerWidget)
                    removeAllReferences(widgets[i]);
            }
        } else
            delete topLevelModel[widgetRef.id];
    }
}

function containerWidgetExtendRemoveAll() {
    containerWidgetExtendRemoveAllReferences.call(this);
    this.ownchildrenref = [];
    this.children = [];
};

function containerWidgetExtendRemoveAllReferences() {
    var widgets = this.widgets();
    for(var i = 0; i < widgets.length; i++) {
        var widget = widgets[i];
        delete this[widget.id];
        removeReferencesFromTopLevelModel(widget);
        removeImmediateMasterProperty(widget);
    }
}

function boxWidgetExtendAdd(widgetarray) {
    _konyConstNS.ContainerWidget.prototype.add.call(this, widgetarray);
    if($KG.allforms[this.pf]) {
        $KG.allforms[this.pf].createFormLevelHierarchy(widgetarray);
    } else if(window[this.pf]) {
        var tempRef = window[this.pf];
        _konyConstNS.Form2.prototype.createFormLevelHierarchy.call(tempRef, tempRef.ownchildrenref);
    }

    $KW.FlexContainer.addChild(this, widgetarray);
};

function boxWidgetExtendAddAt(widgetref, index) {
    _konyConstNS.ContainerWidget.prototype.addAt.call(this, widgetref, index);
    if($KG.allforms[this.pf]) {
        $KG.allforms[this.pf].createFormLevelHierarchy([widgetref]);
    } else if(window[this.pf]) {
        var tempRef = window[this.pf];
        _konyConstNS.Form2.prototype.createFormLevelHierarchy.call(tempRef, tempRef.ownchildrenref);
    }

    $KW.FlexContainer.addChildat(this, [widgetref], index);
};

function boxWidgetExtendRemove(widgetref) {
    if(widgetref) {
        $KW.FlexContainer.DOMremove(this, widgetref);
        var widgetIndex = this.ownchildrenref.indexOf(widgetref);
        _konyConstNS.ContainerWidget.prototype.remove.call(this, widgetref);
        if(widgetIndex != -1)
            $KW.FlexUtils.onWidgetRemove(this, widgetIndex);
    }
};

function boxWidgetExtendRemoveAt(index) {
    $KW.FlexContainer.DOMremove(this, this.ownchildrenref[index - IndexJL]);
    var widgetRef = _konyConstNS.ContainerWidget.prototype.removeAt.call(this, index);
    $KW.FlexUtils.onWidgetRemove(this, index);
    return widgetRef;
};

function boxWidgetExtendRemoveAll() {
    if(this.widgets().length > 0) {
        $KW.FlexContainer.DOMremoveAll(this);
        _konyConstNS.ContainerWidget.prototype.removeAll.call(this);
    }
}

function boxWidgetExtendUpdateBoxWeight(widgetarray) {
    if(widgetarray.length) {
        for(var i = 0; i < widgetarray.length; ++i) {
            this.totalWt += widgetarray[i].containerweight;
        }
    } else if(widgetarray.containerweight) {
        this.totalWt += widgetarray.containerweight;
    }
    $KW[this.wType]["updateView"](this, "totalWt", this.totalWt);
};

function boxWidgetExtendRemoveUpdate(widgetarray, remove) {

}

function formWidgetExtendAdd(widgetarray) {
    _konyConstNS.ContainerWidget.prototype.add.call(this, widgetarray);
    this.createFormLevelHierarchy(widgetarray);

    try {
        $KW.Form.addChild(this, widgetarray);
    } catch(ex) {
        
    }
};

function formWidgetExtendAddAt(widgetref, index) {
    _konyConstNS.ContainerWidget.prototype.addAt.call(this, widgetref, index);
    this.createFormLevelHierarchy([widgetref]);

    
    index = index < IndexJL ? 0 : ((index > this.children.length) ? this.children.length : index - IndexJL);
    $KW.Form.addChildAt(this, widgetref, index);
};

function formWidgetExtendRemove(widgetref) {
    if(widgetref) {
        $KW.Form.DOMremove(this, widgetref);
        var widgetIndex = this.ownchildrenref.indexOf(widgetref);
        _konyConstNS.ContainerWidget.prototype.remove.call(this, widgetref);
        if(widgetIndex != -1)
            $KW.FlexUtils.onWidgetRemove(this, widgetIndex);
    }
};

function formWidgetExtendRemoveAt(index) {
    $KW.Form.DOMremoveAt(this, index - IndexJL)
    var widgetRef = _konyConstNS.ContainerWidget.prototype.removeAt.call(this, index);
    $KW.FlexUtils.onWidgetRemove(this, index);
    return widgetRef;
};


function formWidgetExtendRemoveAll(formModel) {
    if(this.widgets().length > 0) {
        $KW.Form.DOMremoveAll(this);
        _konyConstNS.ContainerWidget.prototype.removeAll.call(this);
    }
}

function formWidgetExtendCreateFormLevelHierarchy(widgetarray) {
    for(var i = 0; i < widgetarray.length; i++) {
        var widgetref = widgetarray[i];
        __createHierarchy(this, widgetref, "form");
    }

    _konyConstNS.Form2.getallboxes.call(this, widgetarray);

    for(var i = 0; i < this.allboxes.length; i++) {
        var boxWidget = this.allboxes[i];
        var childwidgets = boxWidget.ownchildrenref;
        this.createhierarchy.call(this, childwidgets);
        
        if(boxWidget instanceof kony.ui.FlexContainer) {
            
            if(!this.initdone && this._registerForAddWidgetsEvent) {
                boxWidget.addWidgets && this._registerForAddWidgetsEvent(boxWidget);
                boxWidget.init && this._registerForInitEvent(boxWidget);
            } else {
                $KU.invokeAddWidgets(boxWidget);
                $KU.invokeWidgetInit(boxWidget);
            }
            if(boxWidget.defineContainerGetter) {
                boxWidget.defineContainerGetter(this);
                boxWidget.defineContainerSetter(this);
            }
        }
    }

    generateKMasterID(this);
    this.allboxes = [];
};

function formWidgetExtendCommonHeaderFooterSetup(containertype) {
    var __container = {};
    __container.children = [];

    for(var list = 0; list < this[containertype].length; list++) {
        if(typeof this[containertype][list] == "string") {
            this[containertype][list] = _kony.mvc.initializeSubViewController(this[containertype][list]);
        }
    }

    for(var i = IndexJL; i < this[containertype].length; i++) {
        if(app && (app[containertype][this[containertype][i].id] && (app[containertype][this[containertype][i].id] != this[containertype][i]) || !app[containertype][this[containertype][i].id]))
            app[containertype][this[containertype][i].id] = this[containertype][i];

        
        var box = this[containertype][i];
        if(box.wType == 'VBox' && this.wType == 'Form')
            throw new KonyError(1102, 'WidgetError', 'Widget cannot be created due to invalid input data');

        _konyConstNS.Form2.prototype.createFormLevelHierarchy.call(this, [box]);
        _konyConstNS.ContainerWidget.prototype.createhierarchy.call(box, [box]);
        app[containertype][this[containertype][i].id].isheader = true;

        _konyConstNS.Form2.prototype.createFormLevelHierarchy.call(this[containertype][i], [].slice.call([this[containertype][i]]));

        __container.children[i] = this[containertype][i].id;
        __container[this[containertype][i].id] = this[containertype][i];
        if(!window[this[containertype][i].id])
            window[this[containertype][i].id] = this[containertype][i];
    }

    __container.pf = this.id;
    __container.id = this[containertype.substr(0, 6)] = [this.id, containertype.substr(0, 6)].join('_');
    $KG[__container.id] = __container;
};

function formWidgetExtendGetAllBoxes(widgetarray) {
    for(var i = 0; i < widgetarray.length; i++) {
        var widget = widgetarray[i];
        if(widget.ownchildrenref) {
            this.allboxes.push(widget)
            _konyConstNS.Form2.getallboxes.call(this, widget.ownchildrenref);
        }
    }
};

function formWidgetExtendaddHeaderorFooter() {
    var widgetarray = [].slice.call(arguments[0]);

    for(var i = 0; i < widgetarray.length; i++) {
        if(widgetarray[i].wType == 'VBox' && this.wType == 'Form')
            throw new KonyError(1102, 'WidgetError', 'Widget cannot be created due to invalid input data');
    }

    _konyConstNS.ContainerWidget.prototype.createhierarchy.call(this, widgetarray);
    _konyConstNS.Form2.prototype.createFormLevelHierarchy.call(this, widgetarray);
};

function removeImmediateMasterProperty(widgetref) {
    var i = 0, proxyModel, childArrLen, childModel;
    delete widgetref['immediateMaster'];
    proxyModel = $KW.Utils.getActualWidgetModel(widgetref);
    if(proxyModel.isContainerWidget && !proxyModel.isMaster) {
        childArrLen = proxyModel.children.length;
        for(i = 0; i < childArrLen; i++) {
            childModel = proxyModel[proxyModel.children[i]];
            removeImmediateMasterProperty(childModel);
        }
    }
}

function getTopLevelModel(widgetModel) {
    var topLevelModel = null;
    if(widgetModel.immediateMaster) {
        topLevelModel = $KW.Utils.getMasterWidgetModel(widgetModel);
    } else {
        topLevelModel = $KG.allforms[widgetModel.pf] || window[widgetModel.pf];
    }
    return topLevelModel;
}

function removeReferencesFromTopLevelModel(widgetModel, topLevelModel) {
    var i = 0, proxyModel, childArrLen, childModel;
    topLevelModel = topLevelModel || getTopLevelModel(widgetModel);
    if(topLevelModel) {
        delete topLevelModel[widgetModel.id];
        proxyModel = $KW.Utils.getActualWidgetModel(widgetModel);
        if(proxyModel.isContainerWidget && !proxyModel.isMaster) {
            childArrLen = proxyModel.children.length;
            for(i = 0; i < childArrLen; i++) {
                childModel = proxyModel[proxyModel.children[i]];
                removeReferencesFromTopLevelModel(childModel, topLevelModel);
            }
        }
    }
}
kony.model = (function() {
    
    

    var module = {
        
        update: function(model, prop, value) {
            if(model == undefined || model == null) {
                kony.print("kony.model.update:Error in Model,value is undefined or null");
                return;
            }
            if(model["wType"] == undefined || (model[prop] && model[prop]["wType"])) {
                model[prop] = value;
            } else {
                var widgetModel = model;
                var wType = widgetModel.wType;
                if(wType == "TPW") {
                    var nsArr = widgetModel.widgetName.split('.');
                    var namespace = window;
                    for(var j = 0; j < nsArr.length; j++) {
                        namespace = namespace[nsArr[j]];
                    }
                    namespace["modelChange"] && namespace["modelChange"](model, prop, value);
                } else {
                    prop = prop.toLowerCase();
                    var oldValue = widgetModel[prop];
                    $KI.i18n && $KI.i18n.checkI18nStatus(widgetModel, prop);
                    widgetModel[prop] = value;
                    this.updateView(widgetModel, prop, value, oldValue);
                }
            }
        },

        updateView: function(widgetModel, propertyName, propertyValue, oldPropertyValue) {
            var element;
            if(widgetModel.wType == "Form")
                element = document.getElementById(widgetModel.id);
            else if(widgetModel.wType == "Popup")
                element = document.getElementById(widgetModel.id + "_body");
            else
                element = $KU.getNodeByModel(widgetModel);

            if(widgetModel.wType == "TabPane" && widgetModel.viewtype == constants.TABPANE_VIEW_TYPE_TABVIEW)
                element = document.getElementById(widgetModel.pf + "_" + widgetModel.id + "_Body"); 

            element = $KW.Utils.getClonedTemplateNode(element, widgetModel, propertyName);

            switch(propertyName) {
                case "onhover":
                    new $KI.HoverInit(widgetModel);
                    break;

                case "skin":
                    this.updateWidgetSkin(widgetModel, element, propertyValue, oldPropertyValue);
                    break;

                case "focusskin":
                case "rowfocusskin":
                case "activefocusskin":
                    $KW.skins.updateFocusSkin(widgetModel, widgetModel.rowfocusskin ? "rowfocusskin" : "focusskin");
                    break;
                case "hoverskin":
                    $KW.skins.updateFocusSkin(widgetModel, "hoverskin");
                    break;

                case "tooltip":
                    element && (element.title = propertyValue);
                    break;

                case "isvisible":
                    $KW.APIUtils.setvisibility(widgetModel, propertyValue);
                    break;

                case "margin":
                    if(element && !$KW.FlexUtils.isFlexWidget(widgetModel)) {
                        $KW.skins.setMarginPadding(element, propertyName, widgetModel, propertyValue);
                    }
                    break;

                case "padding":
                    this.updateWidgetPadding(widgetModel, element, propertyValue, oldPropertyValue);
                    break;

                case "containerweight":
                    this.updateWidgetContainerWeight(widgetModel, element, propertyValue, oldPropertyValue);
                    break;

                case "containerheightreference":
                case "containerheight":
                    this.updateContainerHeight(widgetModel, element, propertyValue, oldPropertyValue);
                    break;

                case "backgroundimage":
                    $KW.Utils.updateNormalImage(widgetModel);
                    break;

                case "contentalignment":
                    this.updateWidgetContentAlignment(widgetModel, element, propertyValue, oldPropertyValue);
                    break;

                case "accessibilityConfig":
                    if(!element || widgetModel.wType == "RadioButtonGroup" || widgetModel.wType == "CheckBoxGroup") return;

                    $KU.addAriatoElement(element, propertyValue, widgetModel, oldPropertyValue);

                    break;

                case "zindex":
                case "opacity":
                case "transform":
                case "anchorpoint":
                case "backgroundcolor":
                case "bordercolor":
                    this.updateLayoutProps(widgetModel, propertyName, propertyValue);
                    break;

                
                case "touchstart":
                case "touchmove":
                case "touchend":
                    if(widgetModel.touches && widgetModel.touches[propertyName] && widgetModel.touches[propertyName].callback === propertyValue)
                        break;
                    $KW.Utils.removetouch(widgetModel, propertyName, false);
                    $KW.Utils.updateModelWithTouches(widgetModel, propertyName, propertyValue);
                    var element = $KW.Utils.getWidgetNode(widgetModel);
                    if(element && widgetModel.touches[propertyName]) {
                        
                        if(element.id && element.id.indexOf("_scroller") > 0) {
                            element = element.childNodes[0];
                        }
                        widgetModel.touches[propertyName]["instance"] = new $KW.touch.TouchEvents(widgetModel, element, propertyName, propertyValue);
                    }
                    break;

                case "borderwidth":
                case "cornerradius":
                    var element = $KW.Utils.getWidgetNode(widgetModel);
                    element = $KW.Utils.getClonedTemplateNode(element, widgetModel, propertyName);
                    if(propertyName == "borderwidth")
                        element && (element.style.borderWidth = propertyValue + "px");
                    if(propertyName == "cornerradius")
                        element && (element.style.borderRadius = propertyValue + "px");
                    break;

                case "shadowcolor":
                case "shadowoffset":
                case "shadowradius":
                    this.updateShadowProps(widgetModel, propertyName);
                    break;

                case "cursortype":
                    element && this.updateWidgetCursor(widgetModel, element);
                    break;
                case "flexblur":
                    if($KW.FlexUtils.isFlexWidget(widgetModel)) {
                        if(widgetModel.wType == "FlexContainer") element = element.parentNode;

                        var blur = $KW.skins.getBlurStyle(widgetModel);

                        if(blur) {
                            blur = blur.replace('filter:', '').replace(';', '');
                            element.style.filter = blur;
                        } else {
                            element.style.removeProperty('filter');
                        }
                    }
                    break;
                case "widgetSwipeMove":
                    element && $KW.Utils.applyGesturestoDOM(widgetModel, element);
                    break;

                default:
                    var wType = (widgetModel.wType == "Tab") ? "TabPane" : widgetModel.wType;
                    var widget = $KW[wType];
                    widget["updateView"] && widget["updateView"](widgetModel, propertyName, propertyValue, oldPropertyValue);
            }
        },

        updateWidgetCursor: function(widgetModel, element) {
            var cursor = $KW.Utils.getCursorStyle(widgetModel);
            if(cursor) {
                element.style.cursor = cursor;
            }
        },

        updateShadowProps: function(widgetModel, propertyName) {
            var element = $KW.Utils.getWidgetNode(widgetModel);
            if(!element)
                return;
            element = $KW.Utils.getClonedTemplateNode(element, widgetModel, propertyName);
            var boxStyle = $KW.Utils.getBoxShadowStyle(widgetModel);

            if($KW.FlexUtils.isFlexWidget(widgetModel))
                element.parentNode.style["box-shadow"] = boxStyle;
            else
                element.style["box-shadow"] = boxStyle;
        },

        updateLayoutProps: function(widgetModel, propertyName, propertyValue, node, animType) {
            var element = node || $KW.Utils.getWidgetNode(widgetModel);
            element = $KW.Utils.getClonedTemplateNode(element, widgetModel, propertyName);
            switch(propertyName) {
                case "zindex":
                    if(element) {
                        if($KW.FlexUtils.isFlexWidget(widgetModel))
                            element.parentNode.style.zIndex = propertyValue;
                        else
                            element.style.zIndex = propertyValue;
                    }
                    break;

                case "opacity":
                    if(element) {
                        if($KW.FlexUtils.isFlexWidget(widgetModel))
                            element.parentNode.style.opacity = propertyValue;
                        else
                            element.style.opacity = propertyValue;
                    }
                    break;

                case "transform":
                    if(element) {
                        var style = $KW.animUtils.applyTransform(widgetModel, propertyValue);
                        var target;
                        if(animType == 'segmentRow')
                            target = element;
                        else {
                            if($KW.FlexUtils.isFlexWidget(widgetModel))
                                target = element.parentNode;
                            else
                                target = element;
                        }

                        target.style[vendor + "Transform"] = style;
                        target.style["transform"] = style;
                    }
                    break;

                case "anchorpoint":
                    if(element) {
                        var target;
                        if(animType == 'segmentRow')
                            target = element;
                        else {
                            if($KW.FlexUtils.isFlexWidget(widgetModel))
                                target = element.parentNode;
                            else
                                target = element;
                        }
                        if(propertyValue) {
                            if((propertyValue.x < 0) || (propertyValue.x > 1) || (propertyValue.y < 0) || (propertyValue.y > 1))
                                return;
                            target.style[vendor + "TransformOrigin"] = (propertyValue.x * 100) + "% " + (propertyValue.y * 100) + "% ";
                        } else {
                            target.style[vendor + "TransformOrigin"] = "50% 50%";
                        }
                    }
                    break;

                case "backgroundcolor":
                case "bordercolor":
                    var validate = $KW.skins.validateHexValue(propertyValue);
                    if(validate) {
                        var result = $KW.skins.convertHexValuetoRGBA(propertyValue);
                    }
                    var element = $KW.Utils.getWidgetNode(widgetModel);
                    element = $KW.Utils.getClonedTemplateNode(element, widgetModel, propertyName);
                    if(propertyName == "backgroundcolor")
                        element && (element.style.background = result);
                    else if(propertyName == "bordercolor")
                        element && (element.style.borderColor = result);
                    break;
            }
        },

        
        updateWidgetSkin: function(widgetModel, element, propertyValue, oldPropertyValue) {
            if(widgetModel.wType == "Form") {
                var formNode;
                if(!$KG.needScroller && !$KU.isBlackBerryNTH)
                    document.body.className = propertyValue || "";
                else if($KU.isBlackBerryNTH)
                    formNode = document.getElementById(widgetModel.id + "_container");
                else
                    formNode = document.getElementById(widgetModel.id + "_scroller");

                if(formNode) {
                    $KU.removeClassName(formNode, oldPropertyValue);
                    $KU.addClassName(formNode, propertyValue);
                }
            } else if(widgetModel.wType == "Tab")
                element = $KU.getElementById(widgetModel.pf + '_' + widgetModel.id + '_Body');
            else if(element && widgetModel.wType == "Image")
                element = element.parentNode;
            if(element) {
                var widgets = ["Phone", "Switch"];
                var wType = widgetModel.wType;
                if((widgets.indexOf(wType)) == -1) {
                    var defaultSkin = $KW.skins.getDefaultSkin(widgetModel);
                    $KU.removeClassName(element, oldPropertyValue || defaultSkin);
                    $KU.addClassName(element, propertyValue || defaultSkin);

                    if(widgetModel.wType == "Line")
                        $KW.Line.applySkin(element, propertyValue);
                    if(widgetModel.wType == "Calendar")
                        element.children[0].style.color = "inherit";

                    if($KW.FlexUtils.isFlexWidget(widgetModel) && !(widgetModel.wType == 'FlexContainer' && !widgetModel.clipbounds)) {
                        element = $KW.Utils.getWidgetNodeFromNodeByModel(widgetModel, element).parentNode;
                        if(!element) return;
                        $KU.removeClassName(element, oldPropertyValue || defaultSkin);
                        $KU.addClassName(element, propertyValue || defaultSkin);
                    }
                } else {
                    $KW.skins.updateDOMSkin(widgetModel, propertyValue, oldPropertyValue, element);
                }
            }

            
            if(widgetModel.wType == "Label") {
                $KW.Label.updateView(widgetModel, "linespacing", widgetModel.linespacing);
            }
        },

        
        updateWidgetPadding: function(widgetModel, element, propertyValue, oldPropertyValue) {
            if($KW.FlexUtils.isFlexContainer(widgetModel) || widgetModel.wType == 'Slider' || widgetModel.wType == 'Switch')
                return;
            var propertyName = "padding";
            var unit = (widgetModel.paddingInPixel) ? 'px' : '%';
            if(widgetModel.wType == "Segment") {
                if(widgetModel.viewtype == constants.SEGUI_VIEW_TYPE_PAGEVIEW && element) {
                    var segRows = element.childNodes[0].childNodes;
                    
                    for(var i = IndexJL; i < segRows.length; i++) {
                        element = segRows[i].childNodes[0];
                        element.style[propertyName] = $KU.joinArray(propertyValue, (unit+" ")) + unit;
                    }
                    return; 
                }
            }
            if(widgetModel.wType == "DataGrid" && element) {
                var isFlexWidget = $KW.FlexUtils.isFlexWidget(widgetModel);
                var rows = element.rows;
                for(var i = 0; i < rows.length; i++) {
                    for(var j = 0; j < rows[i].cells.length; j++) {
                        if(isFlexWidget)
                            $KW.FlexUtils.setPaddingByParent(widgetModel, rows[i].cells[j]);
                        else
                            rows[i].cells[j].style[propertyName] = $KU.joinArray(propertyValue, (unit+" ")) + unit;
                    }
                }
                return;
            }

            if(widgetModel.wType == "Image" && element)
                element = element.parentNode;
            if(element) {
                var e = element;
                element = (widgetModel.wType == "Form") ? element.parentNode : element;
                if($KW.FlexUtils.isFlexWidget(widgetModel))
                    $KW.FlexUtils.setPaddingByParent(widgetModel, element);
                else
                    element.style[propertyName] = $KU.joinArray(propertyValue, (unit+" ")) + unit;
            }
        },

        
        updateWidgetContainerWeight: function(widgetModel, element, propertyValue, oldPropertyValue) {
            return;
        },

        updateContainerHeight: function(widgetModel, element, propertyValue, oldPropertyValue) {

        },

        updateWidgetContentAlignment: function(widgetModel, element, propertyValue, oldPropertyValue) {
            var childNodes, cAlign = $KW.skins.getContentAlignment(widgetModel);
            if(element) {
                if(['Calendar', 'Label'].indexOf(widgetModel.wType) != -1 && $KW.FlexUtils.isFlexWidget(widgetModel)) {
                    var oldAlignClass = $KW.skins.getFlexContentAlignmentSkin(oldPropertyValue);
                    var newAlignClass = $KW.skins.getFlexContentAlignmentSkin(propertyValue);
                    if($KU.hasClassName(element, oldAlignClass)) {
                        $KU.removeClassName(element, oldAlignClass);
                    }
                    $KU.addClassName(element, newAlignClass);
                    if(widgetModel.wType === "Calendar" && widgetModel.calendarIconAlignment === constants.CALENDAR_ICON_ALIGN_AUTO) {
                        childNodes = element.childNodes;
                        if((propertyValue === constants.CONTENT_ALIGN_MIDDLE_LEFT || propertyValue === constants.CONTENT_ALIGN_CENTER)
                           && childNodes[0].tagName === "IMG") {
                            element.insertBefore(childNodes[0], childNodes[2]);
                        } else if(propertyValue === constants.CONTENT_ALIGN_MIDDLE_RIGHT && childNodes[1].tagName === "IMG") {
                            element.insertBefore(childNodes[1], childNodes[0]);
                        }

                    }
                } else {
                    element.style.textAlign = cAlign;
                }
            }
        },

        
        getWidgetModel: function(formID, widgetID, immediateParentID, tabID) {
            if(!formID)
                return null;

            var formModel = module.getWidgetRef(formID); 
            if(immediateParentID && formModel) {
                if(widgetID) {
                    var widgetModel = formModel[immediateParentID];
                    if(tabID)
                        return widgetModel[tabID]["header"][widgetID];
                    else
                        return widgetModel[widgetID];
                }
            }

            if(widgetID && formID != widgetID) {
                
                var widgetModel;
                if(typeof formModel != "undefined")
                    widgetModel = formModel[widgetID];
                else
                    widgetModel = window[widgetID];
                return widgetModel;
            }

            return formModel;
        },

        getWidgetRef: function(widgetID) {
            var obj = $KG.allforms[widgetID];
            if(obj && ["Form", "Form2"].contains(obj.wType))
                return obj;
            else
                return($KG[widgetID] || window[widgetID] || $KG.allTemplates[widgetID]);
        }
    };


    return module;
}());

kony.events = {
    widgetEventMap: {},
    hiddenIFrame: null,
    isFrameworkEventsRegistered: false,

    addEvent: function(kEventType, kWidgetType, kEventHandler) {
        kony.events.widgetEventMap[kWidgetType] = kony.events.widgetEventMap[kWidgetType] || {};
        kony.events.widgetEventMap[kWidgetType][kEventType] = kEventHandler;
    },

    getEventHandler: function(eventObject) {
        eventObject = eventObject || window.event;
        
        
        var targetWidget = eventObject.target || eventObject.srcElement;
        var preventDefault = true, widget;
        var eventData, cellTemplateNode = null;

        
        if($KG["__idletimeout"] && $KG["__idletimeout"]["enabled"]) {
            var reset = $KI.appevents.resettimer();
            if(reset === false) return;
        }


        if(eventObject.type != "mousedown")
            $KW.Appmenu && $KW.Appmenu.hidemoreappmenuitems();

        cellTemplateNode = $KU.getParentByAttribute(targetWidget, 'kcelltemplate');
        if(cellTemplateNode != null) {
            targetWidget = cellTemplateNode.parentElement;
        }

        
        if(targetWidget.getAttribute('w-type') != "Calendar" && targetWidget.getAttribute('kwidgettype') != "Calendar") {
            $KW.Calendar && $KW.Calendar.destroyCalendar(null, null, targetWidget);
        }
        if(targetWidget.getAttribute('w-type-inactive')) {
            return;
        }


        
        if(eventObject.type == "click" && typeof cvox == "undefined" && ($KU.isTouchSupported || $KU.isPointerSupported) && $KG["targetWidget"] && ($KG["moved"] || ($KG["targetWidget"] && targetWidget != $KG["targetWidget"] && (targetWidget.getAttribute('w-type') != "Calendar")))) {
            
            if(targetWidget.tagName == 'A' && targetWidget.getAttribute('href')) {
                kony.events.stopPropagation(eventObject);
                kony.events.preventDefault(eventObject);
            }
            
            $KG["targetWidget"] = "";
            $KG["moved"] = false;

            var src = eventObject.srcElement;
            
            if((src.getAttribute && src.getAttribute("kwidgettype") == "Calendar") || (src.parentNode && src.parentNode.getAttribute && src.parentNode.getAttribute("kwidgettype") == "Calendar")) {
                
            } else {
                return;
            }
        }

        if(targetWidget) {
            var targetWidgetType = targetWidget.getAttribute(kony.constants.KONY_WIDGET_TYPE);

            if(targetWidget.tagName == 'A')
                eventData = [targetWidget.innerText, targetWidget.getAttribute('href')];

            if(targetWidget.getAttribute('tpwidgettype')) {
                return;
            } else if(!targetWidgetType) {
                
                var targetChild = targetWidget.childNodes[0];
                if(targetWidget.getAttribute("index") && targetChild && targetChild.getAttribute("kwidgettype") == "Segment") {
                    targetWidget = targetChild;
                    targetWidgetType = "Segment";
                } else {
                    
                    var konyWidget = $KU.getParentByAttribute(targetWidget, kony.constants.KONY_WIDGET_TYPE);
                    
                    if(targetWidget && targetWidget.tagName == "CANVAS" && $KU.isIE11 && konyWidget && konyWidget.getAttribute("kwidgettype") == "googlemap") {
                        return;
                    }
                    var thirdPartyWidget = $KU.getParentByAttribute(targetWidget, 'tpwidgettype');
                    targetWidget = konyWidget;
                    
                    if(!targetWidget || thirdPartyWidget) {
                        return;
                    }
                    targetWidgetType = targetWidget.getAttribute(kony.constants.KONY_WIDGET_TYPE);
                }
            }

            if(targetWidgetType == 'RadioButtonGroup' || targetWidgetType == 'CheckBoxGroup' || targetWidgetType == 'ListBox') {
                
                if($KU.preventClickEvent(eventObject, targetWidget))
                    return;
            }

            
            var widgetModel = $KU.getModelByNode(targetWidget);
            if(widgetModel && widgetModel.disabled)
                return;


            var widgetEventObj = kony.events.widgetEventMap[targetWidgetType];
            if(widgetEventObj && widgetEventObj[eventObject.type]) {
                

                
                if(!$KW.Utils.isWidgetInteractable(targetWidget, true)) {
                    return;
                }

                
                var eventHandler = widgetEventObj[eventObject.type];
                if(targetWidgetType == 'RichText') {
                    
                    if(!widgetModel.onclick)
                        preventDefault = false;
                }
                var target = eventObject.target || eventObject.srcElement;
                if(!(targetWidgetType == "TextField" || targetWidgetType == "CheckBoxGroup" || targetWidgetType == "TextArea" ||
                        targetWidgetType == "RadioButtonGroup" || targetWidgetType == "ListBox" || (targetWidgetType == "DataGrid" && target.type == "checkbox"))) {
                    if(eventObject.type == 'keydown' ) {
                        preventDefault = false;
                        if(eventObject.keyCode == 13 || eventObject.keyCode == 32) {
                            preventDefault = true;
                        }
                    }
                    if(preventDefault) {
                        kony.events.stopPropagation(eventObject);
                        kony.events.preventDefault(eventObject);
                    }
                }

                var editableCombos = document.querySelectorAll("div[name='SelectOptions']");
                if(editableCombos) {
                    for(var i = 0; i < editableCombos.length; i++) {
                        if(editableCombos[i].style.display == "block") {
                            if(targetWidget.id != editableCombos[i].parentNode.id)
                                editableCombos[i].style.display = "none";
                        }
                    }
                }

                
                
                if(targetWidgetType == 'RichText' && eventData) 
                    eventHandler(eventObject, targetWidget, eventData);
                else
                    eventHandler(eventObject, targetWidget, target);

                if(!kony.system.activity.hasActivity()) {
                    $KW.unLoadWidget();
                }
            }
        }
    },

    addEventListener: function(object, type, listener, bCapture) {
        if(!object)
            return;
        if(!listener)
            listener = kony.events.getEventHandler;
        if(!bCapture)
            bCapture = false;

        if(object.addEventListener)
            object.addEventListener(type, listener, bCapture); 
        else if(object.attachEvent)
            object.attachEvent('on' + type, listener); 
    },

    removeEventListener: function(object, type, listener, bCapture) {
        if(!object)
            return;
        if(!listener)
            listener = kony.events.getEventHandler;
        if(!bCapture)
            bCapture = false;

        if(object.removeEventListener)
            object.removeEventListener(type, listener, bCapture); 
        else if(object.attachEvent)
            object.detachEvent('on' + type, listener); 
    },

    preventDefault: function(eventObject) {
        if(!eventObject)
            return;

        if(eventObject.preventDefault)
            eventObject.preventDefault();
        else
            eventObject.returnValue = false;
    },

    stopPropagation: function(eventObject) {
        if(!eventObject)
            return;
        if(eventObject.stopPropagation) {
            eventObject.stopPropagation();
            eventObject.stopImmediatePropagation && eventObject.stopImmediatePropagation();
        } else
            eventObject.cancelBubble = true;
    },

    ontouchstartHandler: function(e) {
        if(($KU.isIE || $KU.isPointerSupported ? e : e.changedTouches)) {
            var target = e.changedTouches ? (e.changedTouches[0].target || e.changedTouches[0].srcElement) : (e.target || e.srcElement);
            var widgetNode;
            if(target.nodeType == 3)
                target = target.parentNode;
            $KG["targetWidget"] = target;
            $KG["moved"] = false;
        }
    },

    ontouchmoveHandler: function(e) {
        var up = false;
        var down = false;
            $KG["moved"] = true;

    },

    registerDocumentEvents: function() {
        var main = ($KU.isWindowsPhone && $KU.isIE9) ? document : document.getElementById("__MainContainer");

        kony.events.addEventListener(main, 'click');
        kony.events.addEventListener(main, 'contextmenu');
        kony.events.addEventListener(main, 'mousedown');
        kony.events.addEventListener(main, 'mouseup');
        kony.events.addEventListener(main, 'input');
        kony.events.addEventListener(main, 'change');
        kony.events.addEventListener(main, 'keydown');
        kony.events.addEventListener(main, 'keyup');
        if($KG["useNativeScroll"]) {
            kony.events.addEventListener(main, 'touchstart', function() {});
            kony.events.addEventListener(main, 'touchmove', function() {});
        }
        kony.appinit.initializeWidgets();
        kony.events.orientationregistration();
        kony.events.addEventListener(window, 'unload', kony.events.unregisterListeners);
        window.onbeforeunload = function(e) {
            if(window.refreshMessage) {
                setTimeout(function() {
                    $KG["__appservice"] && $KG["__appservice"]({
                        isRefresh: true,
                        refreshForm: $KG["__currentForm"]
                    });
                }, 500);
                return refreshMessage;
            }
        }
        kony.events.isFrameworkEventsRegistered = true;
        kony.events.formDisableonModalPopup();
    },

    formDisableonModalPopup: function() {
        kony.events.addEventListener(document, "focus", function(event) {
            var modalpopup = document.querySelector("div.popupcontainer form");

            if(modalpopup) {
                kony.web.logger("log", modalpopup + " " + modalpopup.id);
                var dialog = document.getElementById(modalpopup.id);
                if(dialog && !dialog.contains(event.target)) {
                    event.stopPropagation();
                    
                    if(kony.appinit.isChrome) {
                        var inpElement = dialog.querySelector('select,input,a,textarea');
                        inpElement && inpElement.focus();
                    } else {
                        dialog.tabIndex = -1;
                        dialog.focus();
                    }
                }
            }
        }, true);
    },

    unregisterListeners: function(formID) {
        var main = $KU.isWindowsPhone ? document : document.getElementById("__MainContainer");
        kony.events.removeEventListener(main, 'click');
        kony.events.removeEventListener(main, 'touchstart');
        kony.events.removeEventListener(main, 'touchmove');
        kony.events.removeEventListener(main, 'change');
        kony.events.removeEventListener(main, 'keydown');
        kony.events.removeEventListener(main, 'keyup');
        kony.events.removeEventListener(main, 'touchstart');
        kony.events.removeEventListener(main, 'mousedown');
        kony.events.removeEventListener(main, 'mouseup');



        
        if($KU.hashChange) {
            kony.events.removeEventListener(window, 'hashchange');
        }

        
        $KW.Form.delistSystemTimerActions();
    },

    windowSizeChange: function() {
        if($KG.appbehaviors["responsive"] === true) {
            var resizeDelay =  $KU.orientationDelay;
            
            
            if(kony.appinit.isIDevice && kony.appinit.isPWAStandalone()) {
                resizeDelay = 100;
            }
            setTimeout(function () {
                if($KW.FlexUtils.isFlexContainer($KG["__currentForm"])) {
                    $KW.Form.initializeFlexContainersIfNeeded($KG["__currentForm"], function(formNode) {
                        formNode.style.height = $KW.Form.getFormHeight();
                        $KW.Form.resizeHandler($KG["__currentForm"], $KU.getWindowWidth());
                    });
                    $KG.__currentForm.forceLayout();
                } else {
                    $KW.Form.resizeHandler($KG["__currentForm"], $KU.getWindowWidth());
                }
            }, resizeDelay);
        }
    },
    

    windowOrientationChange: function() {
        var event = window.event;
        var orientation = $KU.detectOrientation();
        var winNewWidth = $KU.getWindowWidth();
        var winNewHeight = $KU.getWindowHeight();

        if(orientation != undefined && orientation == $KG["__orientation"]) {
            if(kony.appinit.isMob || kony.appinit.isTablet) {
                $KW.Form.initializeFlexContainersIfNeeded($KG["__currentForm"], function() {
                    $KW.Form.setFormDimensions($KG["__currentForm"]);
                });
            }
            return;
        }
        else
            $KG["__orientation"] = orientation;
        if($KG["__currentForm"]) {

            
            window.clearTimeout(kony.events.orientationTimeoutId);
            kony.events.orientationTimeoutId = setTimeout(function() {
                
                var eventList = kony.events.widgetEventMap || {};
                for(var k in eventList) {
                    var widgetType = eventList[k];
                    var eventHandler = widgetType["onorientationchange"] || widgetType["onresize"];
                    eventHandler && eventHandler($KG["__currentForm"].id, $KG["__orientation"]);
                }

                $KW.Form.resizeForm($KG["__currentForm"].id, true);

            }, $KU.orientationDelay);
        }
        

    },

    orientationregistration: function() {
        $KG["__orientation"] = $KU.detectOrientation();
        kony.events.addEventListener(window, "resize", kony.events.windowSizeChange);
        if(!kony.appinit.isMob && !kony.appinit.isTablet) {
            return;
        }
        var orientationEvent = ($KU.isOrientationSupported && !$KU.isAndroid) ? "orientationchange" : "resize";
        kony.events.addEventListener(window, orientationEvent, kony.events.windowOrientationChange);
        if($KU.isOrientationSupported && $KU.isAndroid)
            kony.events.addEventListener(window, "orientationchange", kony.events.windowOrientationChange);
    },

    canExecuteEventHandler: function(widgetModel, event) {
        if(widgetModel[event]) {
            return true;
        }
        return false;
    },

    executeBoxEvent: function(wModel, rowdata, containerModel) {
        if(rowdata && containerModel) { 
            var rowModelData = null,
                clickHandler = null,
                extendedModel = null,
                context;

            if(containerModel.wType == 'Segment' || containerModel.wType == "CollectionView") {
                var sectionIndex = containerModel.currentIndex[0];
                var rowIndex = containerModel.currentIndex[1];
                var clonedTemplate = $KW.Utils.getClonedModelByContainerUsingIndex(containerModel, rowIndex, sectionIndex);

                if(!clonedTemplate) {
                    return false;
                }
                wModel = $KU.getValueFromObjectByPath($KW.Utils.getWidgetPathByModel(wModel), clonedTemplate);
                if(containerModel.wType == 'Segment') {
                    context = {
                        sectionIndex: sectionIndex,
                        rowIndex: rowIndex,
                        widgetInfo: containerModel
                    };
                } else {
                    context = {
                        sectionIndex: sectionIndex,
                        itemIndex: rowIndex,
                        widgetInfo: containerModel
                    };
                }
            }

            parentModel = wModel;

            while(parentModel) {
                var widgetData = containerModel.widgetdatamap ? rowdata[containerModel.widgetdatamap[parentModel.id]] : rowdata[parentModel.id];

                if(widgetData && (containerModel.wType != 'Segment') && (containerModel.wType != 'CollectionView')) {
                    rowModelData = $KU.cloneObj(widgetData);
                    if(typeof rowModelData === 'string') {
                        rowModelData = (parentModel.wType === 'Image') ? {
                            "src": rowModelData
                        } : {
                            "text": rowModelData
                        };
                    }
                    if(!IndexJL) {
                        for(var p in rowModelData) {
                            if(rowModelData.hasOwnProperty(p) && p !== p.toLowerCase()) {
                                rowModelData[p.toLowerCase()] = rowModelData[p];
                            }
                        }
                    }

                    clickHandler = rowModelData.onclick || parentModel.onclick;
                    if(clickHandler && rowModelData.enable !== false) {
                        extendedModel = $KU.extend(rowModelData, parentModel);
                        this.fireBoxEvent(extendedModel, context);
                        return true;
                    }
                } else if(this.canExecuteEventHandler(parentModel, "onclick") && parentModel.enable !== false) {
                    this.fireBoxEvent(parentModel, context);
                    return true;
                }

                parentModel = parentModel.parent;
                if(!parentModel) return false;
            }
        } else {
            var formId = wModel.pf;
            var pModel = wModel;
            var form = $KG.allforms[formId] || $KG.allTemplates[formId] || $KG.__currentForm;
            while(pModel) {
                
                if(this.canExecuteEventHandler(pModel, "onclick") || (pModel.parent && formId == pModel.parent.id && pModel.parent.wType != 'HBox') || pModel.id == form.id) {
                    if(this.canExecuteEventHandler(pModel, "onclick")) {
                        this.fireBoxEvent(pModel);
                        return true;
                    }
                    return false;
                }
                
                if(form.topLayerFCModal && pModel === form.topLayerFCModal) {
                    return true;
                }
                pModel = pModel.parent;
            }
            return false;
        }
    },



    
    fireBoxEvent: function(widgetModel, context) {
        var eventReference = $KU.returnEventReference(widgetModel.onclick);
        eventReference && (context ? $KU.executeWidgetEventHandler(widgetModel, eventReference, context) : $KU.executeWidgetEventHandler(widgetModel, eventReference));
        $KU.onEventHandler(widgetModel);
    },

    
    executeActionOnContainer: function(containerModel, action, execActionBeforeChildFlag) {
        for(var i = 0; i < containerModel.children.length; i++) {
            var childModel = containerModel[containerModel.children[i]];
            childModel = $KW.Utils.getActualWidgetModel(childModel);

            if(childModel.isContainerWidget) {
                if(execActionBeforeChildFlag)
                    kony.events.executeActionEvt(childModel, childModel[action]);
                kony.events.executeActionOnContainer(childModel, action, execActionBeforeChildFlag);
                if(!execActionBeforeChildFlag)
                    kony.events.executeActionEvt(childModel, childModel[action]);
            }
        }
    },

    
    executeActionOnComponent: function(wArray, action, execActionBeforeChildFlag){
        var i = 0,
            wModel = null;
        for(i; i < wArray.length; i++) {
            if(wArray[i].isContainerWidget) {
                wModel = $KW.Utils.getActualWidgetModel(wArray[i]);
                if(execActionBeforeChildFlag) {
                    kony.events.executeActionEvt(wModel, wModel[action]);
                }
                kony.events.executeActionOnContainer(wModel, action, execActionBeforeChildFlag);
                if(!execActionBeforeChildFlag) {
                    kony.events.executeActionEvt(wModel, wModel[action]);
                }
            }
        }
    },

    executeActionEvt: function(widgetModel, actionEvt) {
        if(!actionEvt) return;
        if(widgetModel.isMaster) {
            var actionref = $KU.returnEventReference(actionEvt);
            actionref && $KU.executeWidgetEventHandler(widgetModel, actionref);
        }
    },

    browserback: {
        currentHash: window.location.hash,

        HASH_PREFIX: '#_',

        
        handleBrowserBackEvent: function() {

            var showForm = false;
            var previousFormID;
            
            

            if(location.hash && kony.events.browserback.currentHash && location.hash !== kony.events.browserback.currentHash) {
                showForm = true;
                previousFormID = kony.bm.getFormId(location.hash);
            }

            var formModel = $KG["__currentForm"];
            if(showForm) {
                var ondeviceback = $KG["__currentForm"] && $KU.returnEventReference(formModel.ondeviceback);
                if(ondeviceback) {
                    
                    location.hash = kony.events.browserback.HASH_PREFIX + formModel.id;
                    ondeviceback();
                    return;
                }
                var previousFormModel = $KG.allforms[previousFormID];
                if(previousFormModel && previousFormModel.wType == "Form" && previousFormID !== formModel.id) {
                    previousFormModel["isfromBrowserBack"] = true;
                    $KW.Form.show(previousFormModel);
                } else if(!previousFormModel) { 
                    
                    location.hash = kony.events.browserback.HASH_PREFIX + formModel.id;
                }
                
            }
        },

        
        
        updateURLWithLocation: function(formID) {
            if(formID) {
                var currentFormID = kony.bm.getFormId(kony.events.browserback.currentHash);
                if(currentFormID !== formID) {
                    location.hash = kony.events.browserback.currentHash = this.HASH_PREFIX + formID;
                }
            }
        },

        setHistory: function() {
            if(kony.events.hiddenIFrame.location.hash != location.hash) {
                
                kony.events.hiddenIFrame.document.open();
                kony.events.hiddenIFrame.document.close();
                kony.events.hiddenIFrame.location.hash = location.hash;
            }
        }
    }
};


window.onload = function() {
    setTimeout(function() {
        window.scrollTo(0, 1);
    }, 100);
};

window.onbeforeprint = function(e) {
    var formModel = kony.application.getCurrentForm(),
        formNode = $KU.getNodeByModel(formModel);

    formModel.media = {type:'print', height:formNode.style.height, width:document.body.style.width};
    formNode.style.height = formNode.scrollHeight + 'px';
    document.body.style.width = formModel.media.width;
};

window.onafterprint = function(e) {
    var formModel = kony.application.getCurrentForm(),
        formNode = $KU.getNodeByModel(formModel);

    document.body.style.width = formModel.media.width;
    formNode.style.height = formModel.media.height;
    delete formModel.media;
};

kony.system = (function() {
    
    

    var module = {
        activity: {
            activityCounter: 0,

            increment: function() {
                this.activityCounter++;
            },

            decrement: function() {
                if(this.activityCounter != 0)
                    this.activityCounter--;
            },

            hasActivity: function() {
                if(this.activityCounter > 0)
                    return true;
                else
                    return false;
            }
        },

        timers: {
            timerActions: new Array(),

            TimerAction: function(actionName, frequency) {
                this.actionName = actionName;
                this.frequency = frequency;
                this.timer = null;
                
                this.elapsedTimeSinceLastCall = 0;
            },

            registerTimerAction: function(timerAction) {
                if(this.timerActions.containsTimerAction(timerAction) === false) {
                    this.timerActions.push(timerAction);
                }
            },

            executeTimerActions: function() {
                if(this.timerActions.length > 0) {
                    for(var i = 0; i < this.timerActions.length; i++) {
                        var timerAction = this.timerActions[i];
                        timerAction.timer = setInterval(timerAction.actionName, timerAction.frequency);
                    }
                }
            },

            removeTimerAction: function(timerAction) {
                var tempActions = new Array();
                if(this.timerActions.length > 0) {
                    for(var i = 0; i < this.timerActions.length; i++) {
                        if(this.timerActions[i].actionName !== timerAction.actionName) {
                            tempActions.push(this.timerActions[i]);
                        }
                    }

                    this.timerActions = tempActions;
                }
            },

            clearTimerAction: function(timerAction) {
                if(this.timerActions.length > 0) {
                    for(var i = 0; i < this.timerActions.length; i++) {
                        timerAction = this.timerActions[i];
                        clearTimeout(timerAction.timer);
                    }
                }
            }
        }
    };


    return module;
}());

$KI.push = (function() {
    var module = {};
    var onsuccessfulregistration, onfailureregistration;
    var onlinenotification, offlinenotification;
    var onsuccessfulderegistration, onfailurederegistration;
    var messaging;

    (function(){
        var pusInterval = setInterval(function() {
            if(kony.isformRenderd) {
                clearInterval(pusInterval);
                var config = localStorage.getItem($KG["appid"] + "_" + "pushConfig");
                if(config) {
                    config = JSON.parse(config);
                    if(!messaging) {
                        firebase.initializeApp(config);
                        messaging = firebase.messaging();
                        messaging.usePublicVapidKey(config.publicKey);
                    }
                    messaging.onMessage(function(payload) {
                        kony.web.logger("log", 'Push notification received data is '+ JSON.stringify(payload));
                        onlinenotification && onlinenotification(payload);
                    });
                }
            }
        }, 1000);
    })();

    
    
    module.setCallbacks = function(data) {
        $KU.logExecuting('kony.push.setCallbacks');
        $KU.logExecutingWithParams('kony.push.setCallbacks', data);
        onsuccessfulregistration  = data.onsuccessfulregistration;
        onfailureregistration = data.onfailureregistration;
        onlinenotification = data.onlinenotification;
        offlinenotification = data.offlinenotification;
        onsuccessfulderegistration = data.onsuccessfulderegistration;
        onfailurederegistration = data.onfailurederegistration;
        $KU.logExecutingFinished('kony.push.setCallbacks');
    };

    module.register = function (config) {
        $KU.logExecuting('kony.push.register');
        if (!firebase.messaging.isSupported()) {
            $KU.logWarnMessage('Browser does not have the Push Notifications');
            return;
        }
        if(!messaging) {
            $KU.logExecutingWithParams('kony.push.register', config);
            firebase.initializeApp(config);
            messaging = firebase.messaging();
            messaging.usePublicVapidKey(config.publicKey);
            __getPermission(config);
            $KU.logExecutingFinished('kony.push.register');
        }
    };

    function __getPermission(config) {
        messaging.requestPermission().then(function() {
            kony.web.logger("log", 'Notification permission granted.');
            
            if(konySwRegistration) {
                kony.web.logger("log", 'Service worker registration succeeded.');
                messaging.useServiceWorker(konySwRegistration);
                localStorage.setItem($KG["appid"] + "_" + "pushConfig", JSON.stringify(config));
                __getToken(messaging);
            } else {
                kony.web.logger("log", "Service worker registration failed:"+ error);
                onfailureregistration && onfailureregistration({"errorCode": "1406",
                                                                "errormessage": "Service worker registration failed"});
            }
         }).catch(function(err) {
            kony.web.logger("log", "Unable to get permission to notify."+ err);
            onfailureregistration && onfailureregistration({"errorCode": "1403",
                                                            "errormessage": "permission is not available"});
        });
    }


    function __getToken(messaging) {
        messaging.getToken().then(function(token) {
            if(token) {
                localStorage.setItem($KG["appid"] + "_" + "pushId", token);
                kony.web.logger("log", "token is "+ token);
                messaging.onMessage(function(payload) {
                    kony.web.logger("log", 'Push notification received. Data is '+ JSON.stringify(payload));
                    onlinenotification && onlinenotification(payload);
                });
                onsuccessfulregistration(token);
            } else {
                kony.web.logger("log", "No Instance ID token available. Request permission to generate one.");
                onfailureregistration && onfailureregistration({"errorCode": "1403",
                                                                "errormessage": "Unknown Error"});
            }
        }).catch(function(err) {
            kony.web.logger("log", "An error occurred while retrieving token. "+ err);
            onfailureregistration && onfailureregistration({"errorCode": "1402",
                                                            "errormessage": "PNS token is not available"});

        })
    }

   module.deregister = function() {
        $KU.logExecuting('kony.push.deRegister');
        var config = localStorage.getItem($KG["appid"] + "_" + "pushConfig");
        config =  JSON.parse(config);
        var token =localStorage.getItem($KG["appid"] + "_" + "pushId");

        if(config && token) {
            $KU.logExecutingWithParams('kony.push.deRegister');
            messaging.deleteToken(token).then(function() {
                kony.web.logger("log", "succssfully unregistered from FCM.");
                onsuccessfulderegistration && onsuccessfulderegistration();
                localStorage.removeItem($KG["appid"] + "_" + "pushId");
                localStorage.removeItem($KG["appid"] + "_" + "pushConfig");
            }).catch(function(err) {
                $KU.logErrorMessage("unable to unregister from FCM."+ JSON.stringify(err));
                onfailurederegistration && onfailurederegistration();
            })
        } else {
            $KU.logWarnMessage('User is not subscribed for FCM');
        }
        $KU.logExecutingFinished('kony.push.deRegister');
    };

    return module;
}());

$KI.HoverInit = function(widgetModel) {
    var node = this.node = $KU.getNodeByModel(widgetModel);
    if(node) {
        var nodeList = document.querySelectorAll("#" + node.id);
        for(var i = 0; i < nodeList.length; i++) {
            nodeList[i].onmouseenter = nodeList[i].onmousemove = nodeList[i].onmouseout = this.eventListener.bind(this);
        }
    }
};

$KI.HoverInit.prototype = {
    eventListener: function(event) {
        $KI.HoverEvent.executeHoverEvent(event, this.node);
    }
};

$KI.HoverEvent = {
    mouseOut: function(target, totg) {
        if(target == totg) return false;
        var node = totg;
        while(node) {
            node = node.parentNode;
            if(node == target) return false;
        }
        return true;
    },

    mouseIn: function(target, fromtg, totg) {

        if(target.contains(fromtg))
            return false;
        else
            return true;
    },

    executeHoverEvent: function(event, node) {
        var event = event || window.event;
        var target = event.currentTarget || node;
        if(!target) return;

        var widgetModel = $KU.getModelByNode(target),
            containerId = target.getAttribute("kcontainerID");
        if(!widgetModel) return;

        if(containerId) {
            var containerNode = $KU.getParentByAttributeValue(target, "kwidgettype", "Segment");
            if(!containerNode) {
                containerNode = $KU.getParentByAttributeValue(target, "kwidgettype", "DataGrid");
            }
            if(!containerNode) {
                
                kony.events.removeEventListener(target, 'mouseenter');
                kony.events.removeEventListener(target, 'mousemove');
                kony.events.removeEventListener(target, 'mouseout');
                return;
            }
        }

        if(event.type === "mouseout") {
            var totg = event.relatedTarget;
            var fromtg = event.target;
        } else if(event.type === "mouseenter") {
            var totg = event.target;
            var fromtg = event.relatedTarget;
        }

        if(event.type == "mousemove" || (event.type == "mouseenter" && $KI.HoverEvent.mouseIn(target, fromtg, totg)) ||
            (event.type == "mouseout" && $KI.HoverEvent.mouseOut(target, totg))) {
            

            var context = {};
            context.event = event.type;
            if(event.type === "mouseenter") {
                context.eventType = 0;
            } else if(event.type === "mousemove") {
                context.eventType = 1;
            } else if(event.type === "mouseout") {
                context.eventType = 2;
            }
            context.pageX = event.pageX || event.clientX;
            context.pageY = event.pageY || event.clientY;
            context.screenX = event.clientX || null;
            context.screenY = event.clientY || null;

            if(containerId) {
                var containerModel = $KW.Utils.getContainerModelById(target, containerId);
                if(!containerModel)
                    return;
                var eventReference = $KU.returnEventReference(widgetModel.onhover);

                if(containerModel.wType == "DataGrid") {
                    var indexNode = $KU.getParentByAttribute(target, "colindex");
                    var headerNode = $KU.getParentByAttribute(target, "index");
                    if(headerNode && headerNode.getAttribute("index")) {
                        if(parseInt(headerNode.getAttribute("index")) == 0) {
                            context.rowIndex = -1;
                        } else {
                            context.rowIndex = parseInt(indexNode.getAttribute("colindex").split(",")[0]);
                        }
                        context.columnIndex = parseInt(indexNode.getAttribute("colindex").split(",")[1]);
                    }

                    
                    var colheadInfo = containerModel.columnids[context.columnIndex];
                    var coldata = context.rowIndex == -1 ? containerModel.columnHeadersConfig[context.columnIndex] : containerModel.data[context.rowIndex][colheadInfo];
                    var widgetData = context.rowIndex == -1 ? coldata.columnheadertemplate.data : (containerModel.widgetdatamap ? coldata[containerModel.widgetdatamap[widgetModel.id]] : coldata[widgetModel.id]);
                    
                    if(widgetData && widgetData.onHover) {
                        eventReference = widgetData.onHover;
                    }

                } else if(containerModel.wType == "Segment") {
                    if(containerModel.viewtype == "pageview") {
                        var parentIndexNode = $KU.getParentByAttribute(target, "index");
                        context.sectionIndex = 0;
                        context.rowIndex = parentIndexNode.getAttribute("index");
                    } else {
                        var parentIndexNode = $KU.getParentByTagName(target, 'li');
                        if(parentIndexNode.getAttribute("secindex")) {
                            context.sectionIndex = parentIndexNode.getAttribute("secindex") ? parseInt(parentIndexNode.getAttribute("secindex").split(",")[0]) : "";
                            context.rowIndex = parentIndexNode.getAttribute("secindex") ? parseInt(parentIndexNode.getAttribute("secindex").split(",")[1]) : "";
                        } else if(parentIndexNode.getAttribute("index")) {
                            context.sectionIndex = 0;
                            context.rowIndex = parentIndexNode.getAttribute("index") ? parseInt(parentIndexNode.getAttribute("index").split(",")[0]) : "";
                        }
                        if((containerModel.selectionbehavior == constants.SEGUI_SINGLE_SELECT_BEHAVIOR) || (containerModel.selectionbehavior == constants.SEGUI_MULTI_SELECT_BEHAVIOR)) {
                            context.selectionState = false;
                            var selectedIndices = containerModel.selectedIndices;
                            if(selectedIndices) {
                                for(var i = 0; i < selectedIndices.length; i++) {
                                    if(context.sectionIndex == selectedIndices[i][0]) {
                                        var selectedRowArray = selectedIndices[i][1];
                                        for(var j = 0; j < selectedRowArray.length; j++) {
                                            if(context.rowIndex == selectedRowArray[j])
                                                context.selectionState = true;
                                        }
                                    }
                                }
                            }
                        }
                    }

                    
                    var rowdata = containerModel.hasSections ? (context.rowIndex == -1 ? containerModel.data[context.sectionIndex][IndexJL + 0] : containerModel.data[context.sectionIndex][IndexJL + 1][context.rowIndex]) : containerModel.data[context.rowIndex];
                    var widgetData = containerModel.widgetdatamap ? rowdata[containerModel.widgetdatamap[widgetModel.id]] : rowdata[widgetModel.id];
                    
                    if(widgetData && widgetData.onHover) {
                        eventReference = widgetData.onHover;
                    }

                }
                eventReference && $KU.executeWidgetEventHandler(widgetModel, eventReference, context);

            } else {
                if(widgetModel.onhover) {
                    widgetModel.onhover(widgetModel, context);
                }
            }
        }
    }
};

$KI.setappevents = function(eventobj) {
    $KU.logExecuting('kony.application.setApplicationInitializationEvents');
    $KU.logExecutingWithParams('kony.application.setApplicationInitializationEvents', eventobj);
    
    if($KG["appmode"] == constants.APPLICATION_MODE_HYBRID) {
        var initfunc;
        if(IndexJL)
            initfunc = window["appinit"];
        else
            initfunc = window["appInit"];

        initfunc && initfunc();
        $KU.logExecutingFinished('kony.application.setApplicationInitializationEvents VIA $KG["appmode"] == constants.APPLICATION_MODE_HYBRID ');
        return;
    }

    $KG["__konyappevents"] = eventobj;
    
    var preappinit = eventobj["preappinit"] || null;
    var appinit = eventobj["init"] || null;
    var postappinit = eventobj["postappinit"] || null;
    var appservice = eventobj["appservice"] || null;
    var showstartref = eventobj["showstartupform"] || null;
    var deepfunc = eventobj["deeplink"] || null;
    var launchparams = {};
    var startform = null;
    var launchobj = {};
    launchobj["launchparams"] = {};
    var formmodel;
    var testAutomationScriptURL, konyAutomationPath;

    
    if(kony.appinit.isSafari) {
        var metTag = document.querySelector("meta[name=viewport]");
        var oldContent = metTag.getAttribute('content');
        metTag.setAttribute('content', oldContent + ', shrink-to-fit=no');
    }


    
    if(window.location.hash) {
        
        var formId = kony.bm.getFormId(window.location.hash);
        if(formId) {
            launchparams['formID'] = formId;
            var formState = kony.bm.getBMState(formId);
            if(formState) {
                for(var k in formState) {
                    launchparams[k] = formState[k];
                }
            }
        }
    }

    launchobj["launchmode"] = $KG["__launchmode"];

    if($KG["kdeepobj"]) {
        launchobj["launchparams"] = $KG["kdeepobj"];
    }

    
    
    for(var prop in launchparams) {
        launchobj["launchparams"][prop] = launchparams[prop];
    }
    preappinit && preappinit(launchobj);
    if($KG.appbehaviors && $KG.appbehaviors["stopLoadingScreenDismissOnFormNavigation"] === true && !($KU.getElementById("__MainContainer"))) {
        document.body.innerHTML = "<div id='__MainContainer'></div>";
    }

    if($KC.isRecording == true) {
        $KC.widgetDataRecording = true;
    }


    $KU.setorientationDelay();


    appinit = $KU.returnEventReference(appinit);
    appinit && appinit(launchparams);

    if(appConfig.testAutomation) {
        testAutomationScriptURL = appConfig.testAutomation.scriptsURL;

        if(testAutomationScriptURL && testAutomationScriptURL.length !== 0
        && testAutomationScriptURL.startsWith('http')) {
            konyAutomationPath = appConfig.testAutomation.scriptsURL;
            konyAutomationPath = appConfig.testAutomation.scriptsURL + "Desktop";

            setTimeout(function() {
                $KAR && $KAR.invokeJasmineAutomation(konyAutomationPath);
            }, 1000);
        } else {
            kony.web.logger('log', 'Invalid test automation configuration.');
        }
    }

    kony.appinit.migrateLocalStorage();
    kony.appinit.disableForceRepaint();

    $KG.isMVC = $KG.appbehaviors.isMVC || false;
    launchparams["isRefresh"] = false;
    launchparams["isNewSPASession"] = (kony.appinit.isNewSession == "true") ? true : false;
    if(window.location.hash) {
        var formObj = window[window.location.hash.substring(2)];
        if(formObj && !launchparams["isNewSPASession"]) {
            launchparams["isRefresh"] = true;
            launchparams["refreshForm"] = formObj;
        }
    }
    for(var prop in launchparams) {
        launchobj["launchparams"][prop] = launchparams[prop];
    }



    if(postappinit) {
        startform = postappinit(launchobj);
    }
    
    if(kony.appinit.isiPhone && kony.appinit.isSafari) {
        document.addEventListener('focusout', function() {
            if(window.scrollY) {
                window.scrollTo(0, 0);
            }
        });
    }

    if(deepfunc || appservice) {
        
        if(appservice) {
            $KG["__appservice"] = appservice; 
            startform = appservice(launchobj);
        } else if(deepfunc) {
            startform = deepfunc($KG["kdeepobj"]);
        }
    }

    if((startform == null) || (startform.length == 0)) {
        showstartref && showstartref(launchobj);
    } else {
        if(typeof startform == "string") {
            var homeform = $KG.allforms[startform];
            if(homeform) {
                homeform.show();
            } else {
                homeform = new kony.mvc.Navigation(startform);
                homeform.navigate();
            }

        } else {
            formmodel = startform;
            formmodel && formmodel.show();
        }

    }
    
    document.body.setAttribute('aria-busy', 'false');
    if($KG.appbehaviors["responsive"] === true) {
        $KU.addClassName(document.documentElement, 'responsive');
    }
    $KU.logExecutingFinished('kony.application.setApplicationInitializationEvents VIA end of the function ');
};


$KI.window = {
    openURL: function(url, params, name) {
        
        
        $KU.logExecuting('kony.application.openURL');
        $KU.logExecutingWithParams('kony.application.openURL', url, params, name);
        $KW.unLoadWidget();
        if(params) {
            if(params.innewwindow == true) {
                var newurl = "_blank";
                var newurloptions = "";
                newurloptions = (params.width ? "width =" + params.width + "px," : "") + (params.height ? "height=" + params.height + "px," : "");
                if(!params.menubar && typeof params.menubar !== "undefined")
                    newurloptions = newurloptions + "menubar = no, ";
                if(!params.statusbar && typeof params.statusbar !== "undefined")
                    newurloptions = newurloptions + "statusbar = no, ";
                if(!params.toolbar && typeof params.toolbar !== "undefined")
                    newurloptions = newurloptions + "toolbar = no, ";
                if(!params.titlebar && typeof params.titlebar !== "undefined")
                    newurloptions = newurloptions + "titlebar = no";
                $KU.logExecutingFinished('kony.application.openURL');

                window.open(url, newurl, newurloptions);
            } else {
                $KU.logExecutingFinished('kony.application.openURL');
                window.open(url);
            }
        } else {
            $KU.logExecutingFinished('kony.application.openURL');
            window.open(url);
        }
    },

    openURLAsync: function(config) {
        $KU.logExecuting('kony.application.openURLAsync');
        var url, callback;
        if(!config) {
            $KU.logErrorMessage('Invalid parameter');
            return;
        }
        $KU.logExecutingWithParams('kony.application.openURLAsync', config);
        url = config.url;
        callback = config.callback;
        window.open(url, "_blank");
        $KU.logExecutingFinished('kony.application.openURLAsync');
        callback && callback(constants.OPEN_URL_UNKNOWN);
    },

    alert: function(message, alertHandler, alertType) {
        if(message === null) return;

        var msgstr = message;
        var hndlr = alertHandler || null;
        var alerttype = alertType || null;

        if(message.message || message.alerttype || message.alertType) {
            alerttype = message.alerttype || message.alertType;
            msgstr = message.message;
            hndlr = message.alerthandler || message.alertHandler || null;
        }

        if(alerttype === constants.ALERT_TYPE_INFO || alerttype === constants.ALERT_TYPE_ERROR || !alerttype) {
            alert(msgstr);
            hndlr && hndlr();
        } else if(alerttype === constants.ALERT_TYPE_CONFIRMATION) {
            var answer = confirm(msgstr);
            hndlr && hndlr(answer);
        }
    },

    openMediaURL: function() {
        $KU.logWarnMessage('openMediaURL not supported in SPA');
    },


    
    showLoadingScreen: function() {
        var skin = arguments[0];
        var text = arguments[1] || "";
        var position = arguments[2] || "fullscreen";
        var isBlocked = (arguments[3] === false) ? false : true;
        var showProgressIndicator = (arguments[4] === false) ? false : true;

        text = text ? "<label style='padding-left:20px; font-size: 16px; text-align:center;width:100%;display:inline-block'>" + text + "</label>" : "";
        var wrapperDiv = "<div id ='__wrapperDiv' style='top:50%;width:100%;position:fixed;'>";
        var loadingDiv = document.getElementById("__loadingScreenDiv");
        var divTag = loadingDiv || document.createElement("div");
        divTag.id = "__loadingScreenDiv";
        divTag.setAttribute("style", "");
        divTag.style.zIndex = "100";
        divTag.style.backgroundPosition = "center";
        divTag.style.width = "100%";
        divTag.style.position = "fixed";
        divTag.style.outline = "none";
        if(!skin && showProgressIndicator) {
            divTag.style.backgroundImage = "url('" + $KU.getImageURL("loading.gif") + "')";
            divTag.style.backgroundRepeat = "no-repeat";
        }

        divTag.innerHTML = wrapperDiv + text + "</div>";
        divTag.style.display = "block";

        var mainContainer = document.getElementById("__MainContainer");
        if($KG.appbehaviors && $KG.appbehaviors["stopLoadingScreenDismissOnFormNavigation"] === true) {
            document.body.appendChild(divTag);
        } else {
            if(mainContainer) {
                mainContainer.appendChild(divTag);
            } else {
                return;
            }
        };
        var wrapper = divTag.childNodes[0];
        if(wrapper.childNodes[0])
            wrapper.style.marginTop = -(wrapper.childNodes[0].offsetHeight / 2) + "px";

        if(position == "fullscreen" || isBlocked) {
            divTag.className = skin || "";
            divTag.style.top = 0;
            divTag.style.left = 0;
            divTag.style.bottom = 0;
            divTag.style.height = "100%";
        } else {
            wrapper.className = skin || "";
            divTag.style.top = "50%";
        }
        divTag.tabIndex = -1;
        divTag.focus();
        
        kony.events.addEventListener(document, "keydown", $KI.window.preventBGFocus);
    },

    preventBGFocus: function(event) {
        if(!event)
            event = window.event;
        var dialog = document.getElementById('__loadingScreenDiv');
        if(dialog && dialog.style.display != "none") {
            kony.events.preventDefault(event);
            
            
        }
    },

    dismissLoadingScreen: function() {
        var loadingDiv = document.getElementById("__loadingScreenDiv");
        if(loadingDiv) {
            loadingDiv.style.display = "none";
        }
        
        kony.events.removeEventListener(document, "keydown", $KI.window.preventBGFocus);

    }
};

$KI.exit = function() {
    $KU.logExecuting('kony.application.exit');
    $KU.logExecutingWithParams('kony.application.exit');
    if($KU.isIDevice || !$KU.isMob) {
        window.open('about:blank', '_self', '');
        $KU.logExecutingFinished('kony.application.exit');
        window.close();
    }

};

$KI.appreset = function() {
    kony.web.logger("warn", "appreset not supported in SPA");
};

$KI.assert = function(arg1, arg2) {
    if(null === args1 || false === args2) {
        if(arguments.length > 1) {
            if(typeof(args2) === "string") {
                throw new Error(args2);
            } else {
                throw new Error("Invalid argument to assert");
            }
        } else {
            throw new Error("Assertion failed");
        }
    } else {
        return arg1;
    }
};

$KI.type = function(arg) {
    var result;

    if(typeof(arg) == "undefined" || arg + "" == "null") {
        result = IndexJL ? "nil" : "null";
    } else
    if(typeof(arg) === "boolean") {
        result = "boolean";
    } else
    if(typeof(arg) === "number") {
        result = "number";
    } else
    if(typeof(arg) === "string") {
        result = "string";
    } else
    if(typeof(arg) === "function") {
        result = "function";
    } else {
        result = IndexJL ? "table" : "object";
    }
    return result;
};

$KI.converttobase64 = function(rawbytes) {
    $KU.logExecuting('kony.convertToBase64');
    $KU.logExecutingWithParams('kony.convertToBase64', rawbytes);
    $KU.logExecutingFinished('kony.convertToBase64');
    return $KU.getBase64(rawbytes);
};

$KI.converttorawbytes = function() {
    $KU.logWarnMessage('converttorawbytes api not supported in SPA');
};

$KI.setappheaders = function(headers) {
    kony.app.headers = {};

    if(IndexJL) headers.splice(0, 1);

    for(i = 0; i < headers.length; i++) {
        kony.app.headers[headers[i].id] = headers[i];
        _konyConstNS.Form2.prototype.createFormLevelHierarchy.call(headers[i], headers[i].ownchildrenref);
    }
};

$KI.setappfooters = function(footers) {
    kony.app.footers = {};

    if(IndexJL) footers.splice(0, 1);

    for(i = 0; i < footers.length; i++) {
        kony.app.footers[footers[i].id] = footers[i];
        _konyConstNS.Form2.prototype.createFormLevelHierarchy.call(footers[i], footers[i].ownchildrenref);
    }
};

$KI.setapplicationcallbacks = function() {
    kony.web.logger("warn", "setApplicationCallbacks API is not supported on SPA, DesktopWeb and Responsive Web");
};

$KI.addapplicationcallbacks = function() {
    kony.web.logger("warn", "addApplicationCallbacks API is not supported on SPA, DesktopWeb and Responsive Web");
};

$KI.removeapplicationcallbacks = function() {
    kony.web.logger("warn", "removeApplicationCallbacks API is not supported on SPA, DesktopWeb and Responsive Web");
};

$KI.setapplicationbehaviors = function(appbehavior) {
    var prop, FORMCONTROLLERSYNCLOAD = 'FormControllerSyncLoad';
    $KU.logExecuting('kony.application.setApplicationBehaviors');
    $KU.logExecutingWithParams('kony.application.setApplicationBehaviors', appbehavior);
    if(!$KG.appbehaviors) {
        $KG.appbehaviors = appbehavior;
    } else {
        for(prop in appbehavior) {
            if(FORMCONTROLLERSYNCLOAD === prop && undefined === $KG.appbehaviors[prop]) {
                Object.defineProperty($KG.appbehaviors, FORMCONTROLLERSYNCLOAD, {
                    value: appbehavior[prop],
                    writable: false
                });
            } else {
                $KG.appbehaviors[prop] = appbehavior[prop];
            }
        }
    }
    $KU.logExecutingFinished('kony.application.setApplicationBehaviors');
};

$KI.getapplicationbehavior = function(prop) {
    return $KG.appbehaviors && $KG.appbehaviors[prop];
};

$KI.setupWidgetDataRecording = function(XMLmode) {
    
    if(appConfig.isDebug && (XMLmode.mode === 0 || XMLmode.mode === 1)) {
        var XMLbutton = document.createElement("BUTTON");
        XMLbutton.innerHTML = "Generate XML";
        XMLbutton.style.zIndex = 100000;
        XMLbutton.style.position = "fixed";
        XMLbutton.style.top = "0px";
        document.body.appendChild(XMLbutton);
        XMLbutton.addEventListener('click', function() {
            console.log($KC.generateXMLFormJSON());
        });
        $KC.isRecording = true;
    }
};

$KI.setSeoDataReadyFlag = function() {
    $KU.logExecuting('kony.application.setSeoDataReadyFlag');
    $KU.logExecutingWithParams('kony.application.setSeoDataReadyFlag');
    document.body.setAttribute('data-ready', 1);
    $KU.logExecutingFinished('kony.application.setSeoDataReadyFlag');
};

$KI.removeSeoDataReadyFlag = function() {
    $KU.logExecuting('kony.application.removeSeoDataReadyFlag');
    $KU.logExecutingWithParams('kony.application.removeSeoDataReadyFlag');
    document.body.removeAttribute('data-ready');
    $KU.logExecutingFinished('kony.application.removeSeoDataReadyFlag');
};

function tobeimplemented(str) {
    str = (typeof str === 'string') ? str : "";
    kony.web.logger("warn", str + "  API is either not implemented or unsupported");
}

KonyError = function(errorcode, name, message) {
    this.errorCode = this.errorcode = errorcode;
    this.name = name;
    this.message = message;
};


KonyError.prototype = new Error();
KonyError.prototype.constructor = KonyError;

kony.getError = function(e) {
    $KU.logExecuting('kony.getError');
    $KU.logExecutingWithParams('kony.getError', e);
    $KU.logExecutingFinished('kony.getError');
    return e;
};

kony.bm = {
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    

    
    
    FORM_PREFIX: '#_',
    GSTATE_PREFIX: '/',

    __global_state__: {},
    __check_args__: function(args, count) {
        if(args.length != count) {
            $KU.logErrorMessage("Invalid number of arguments. Expected: " + count + ", Given: " + args.length);
            throw new Error("Invalid number of arguments. Expected: " + count + ", Given: " + args.length);
        }

        
        
        
        for(var i in args) {
            if(typeof(args[i]) === 'undefined') {
                throw new Error("Invalid arg[" + i + "] in " + args);
            }
        }
    },

    


    __initialized__: false,
    
    
    __init__: function() {
        var hp = window.location.href;
        if(hp.indexOf("http") == 0) {
            hp = kony.bm.__get_hash__(hp);
        }
        var stateStr = kony.bm.__get_raw_state__(hp);
        if(stateStr) {
            kony.bm.__global_state__ = JSON.parse(decodeURI(stateStr));
        }
        kony.bm.__initialized__ = true;
    },

    
    
    __update_hash__: function() {
        var jsonStr = JSON.stringify(kony.bm.__global_state__);
        var currentFormId = kony.bm.getFormId(window.location.hash);
        window.location.hash = kony.bm.FORM_PREFIX + currentFormId + kony.bm.GSTATE_PREFIX + encodeURI(jsonStr);
    },

    __get_hash__: function(href) {
        return href.substr(href.indexOf(kony.bm.FORM_PREFIX));
    },

    __get_raw_state__: function(hash_part) {
        var hp = hash_part; 
        var indexOfStateBegin = hp.indexOf(kony.bm.GSTATE_PREFIX);
        var rawState = ""; 
        if(indexOfStateBegin > 0) { 
            rawState = hp.substr(hp.indexOf(kony.bm.GSTATE_PREFIX) + kony.bm.GSTATE_PREFIX.length);
        }
        return rawState;
    },


    
    

    getFormId: function(hash_part) {
        var hp = hash_part; 
        if(!hp) { 
            hp = location.hash;
        }
        var formAndState = hp.substr(hp.indexOf(kony.bm.FORM_PREFIX) + kony.bm.FORM_PREFIX.length);
        var indexOfStateBegin = formAndState.indexOf(kony.bm.GSTATE_PREFIX);

        var formId;
        if(indexOfStateBegin < 0) { 
            formId = formAndState;
        } else {
            formId = formAndState.substr(0, indexOfStateBegin);
        }
        return formId;
    },

    
    

    
    
    
    
    
    setBMState: function(formId, json) {
        $KU.logExecuting('kony.application.setBMState');
        $KU.logExecutingWithParams("kony.application.setBMState", formId, json);
        kony.bm.__check_args__(arguments, 2);
        if(!kony.bm.__initialized__) {
            kony.bm.__init__();
        }
        kony.bm.__global_state__[formId] = json;
        kony.bm.__update_hash__();
        $KU.logExecutingFinished('kony.application.setBMState');
    },

    
    
    resetBMState: function(formId) {
        $KU.logExecuting('kony.application.resetBMState');
        $KU.logExecutingWithParams('kony.application.resetBMState', formId);
        kony.bm.__check_args__(arguments, 1);
        if(!kony.bm.__initialized__) {
            kony.bm.__init__();
        }
        delete kony.bm.__global_state__[formId];
        kony.bm.__update_hash__();
        $KU.logExecutingFinished('kony.application.resetBMState');
    },

    
    
    
    
    
    
    addBMState: function(formId, name, value) {
        $KU.logExecuting('kony.application.addBMState');
        kony.bm.__check_args__(arguments, 3);
        if(!kony.bm.__initialized__) {
            kony.bm.__init__();
        }
        $KU.logExecutingWithParams('kony.application.addBMState', formId, name, value);
        var s = kony.bm.getBMState(formId);
        if(!s) {
            s = {};
            kony.bm.setBMState(formId, s);
        }
        s[name] = value;
        kony.bm.__update_hash__();
        $KU.logExecutingFinished('kony.application.addBMState');
    },

    
    
    
    removeBMState: function(formId, name) {
        $KU.logExecuting('kony.application.removeBMState');
        $KU.logExecutingWithParams('kony.application.removeBMState', formId, name);
        kony.bm.__check_args__(arguments, 2);

        if(!kony.bm.__initialized__) {
            kony.bm.__init__();
        }
        var s = kony.bm.getBMState(formId);
        if(s) {
            delete s[name];
            kony.bm.__update_hash__();
        }
        $KU.logExecutingFinished('kony.application.removeBMState');
    },

    
    
    getBMState: function(formId) {
        $KU.logExecuting('kony.application.getBMState');
        $KU.logExecutingWithParams('kony.application.getBMState', formId);
        kony.bm.__check_args__(arguments, 1);

        if(!kony.bm.__initialized) {
            kony.bm.__init__();
        }
        $KU.logExecutingFinished('kony.application.getBMState');
        return kony.bm.__global_state__[formId];
    }
};

$KI.setUncaughtExceptionHandler = function(uncaughtExceptionHandler) {
    if(uncaughtExceptionHandler === null) {
        $KI.uncaughtExceptionHandler = null;
    } else if(typeof uncaughtExceptionHandler === 'function') {
        $KI.uncaughtExceptionHandler = uncaughtExceptionHandler;
    }
};

$KI.getUncaughtExceptionHandler = function() {
    return $KI.uncaughtExceptionHandler;
};

window.onerror = function(message, url, line, column, error) {
    var exceptionObject, stack;

    if($KI.uncaughtExceptionHandler) {
        exceptionObject = {
            "message": message,
            "sourceURL": url,
            "line": line,
            "column": column,
            "error": error
        };

        $KI.uncaughtExceptionHandler(exceptionObject);
    } else if(spaAPM) {
        spaAPM.apmErrorHandler(message, url, line, column, error);
    }

    if(appConfig.isDebug && appConfig.testAutomation && window.jasmineOnError) {
        if(arguments instanceof KonyError) {
            window.jasmineOnError(arguments);
        } else {
            stack = error ? error.stack : null;
            window.jasmineOnError({
                'name': 'jasmineException',
                'errorCode': '200', 
                'message': message,
                'sourceURL': url,
                'line': line,
                'stack': stack
            });
        }
    }
};

$KI.screenrecorder = (function() {
    var ScreenRecorder = [];
    var videoData = [];
    var tracks = [];
    var module = {
        start: function(config) {
            $KU.logExecuting('kony.screenrecorder.start');
            var framerate = 30;
            if(config && config.frameRate) {
                framerate = config.frameRate;
            }
            var constraints = { video: { frameRate: framerate } };
            if(!(navigator.mediaDevices && navigator.mediaDevices.getDisplayMedia && typeof MediaRecorder != 'undefined')) {
                config.onFailure && config.onFailure('ScreenRecorder API is not supported by your browser');
            } else {
                navigator.mediaDevices.getDisplayMedia(constraints).then(function(stream) {
                    ScreenRecorder = new MediaRecorder(stream);
                    ScreenRecorder.start();
                    kony.web.logger('info', 'Recording Screen');
                    Videotracks = ScreenRecorder.stream.getVideoTracks();
                    Videotracks[0].onended = function() {
                        if(ScreenRecorder.state === 'recording'){
                            module.stop();
                        } else if (ScreenRecorder.state === 'paused') {
                            module.resume();
                            module.stop();
                        }
                    }
                    $KU.logExecutingFinished('kony.screenrecorder.start');
                }).catch( function(err) {
                    config.onFailure && config.onFailure(err);
                });
            }
        },

        stop: function() {
            var i = 0;
            if(ScreenRecorder && !(ScreenRecorder.state === 'inactive')) {
                $KU.logExecuting('kony.screenrecorder.stop');
                ScreenRecorder.stop();
                kony.web.logger('info', 'Recording stopped');
                tracks = ScreenRecorder.stream.getTracks();
                ScreenRecorder.ondataavailable = function(e) {
                    videoData.push(e.data);
                }
                for(i = 0; i < tracks.length; i++) {
                    tracks[i].stop();
                }
                $KU.logExecutingFinished('kony.screenrecorder.stop')
            }
        },

        pause: function() {
            if(ScreenRecorder && ScreenRecorder.state === 'recording') {
                $KU.logExecuting('kony.screenrecorder.pause');
                ScreenRecorder.pause();
                $KU.logExecutingFinished('kony.screenrecorder.pause');
            }
        },

        resume: function() {
            if(ScreenRecorder && ScreenRecorder.state === 'paused') {
                $KU.logExecuting('kony.screenrecorder.resume');
                ScreenRecorder.resume();
                $KU.logExecutingFinished('kony.screenrecorder.resume');
            }
        }
    }
    module.getrecordeddata = function() {
        if(ScreenRecorder && ScreenRecorder.state && ScreenRecorder.state === 'inactive') {
            $KU.logExecuting('kony.screenrecorder.getrecordeddata');
            var blob = new Blob(videoData, { type:'video/webm' });
            window.URL = window.URL || window.webkitURL;
            var videoBlobURL = window.URL.createObjectURL(blob);
            $KU.logExecutingFinished('kony.screenrecorder.getrecordeddata');
            return videoBlobURL;
        }
    }
    module.getrecordingstate = function() {
        $KU.logExecuting('kony.screenrecorder.getrecordingstate');
        if(ScreenRecorder && ScreenRecorder.state) {
            $KU.logExecutingFinished('kony.screenrecorder.getrecordingstate VIA screenrecorder played atleast Once');
            return ScreenRecorder.state;
        } else {
            $KU.logExecutingFinished('kony.screenrecorder.getrecordingstate VIA screenrecorder not played atleast once');
            return "inactive";
        }
    }
    return module;
}());

$KI.screenshot = function(config) {
    var filereader = new FileReader();
    var cssscript = '',
        i = 0,
        j = 0,
        data = '',
        svg = [];
    var formModel = kony.application.getCurrentForm(),
        formNode = $KU.getNodeByModel(formModel),
        clone = formNode.cloneNode([true]),
        headerNode = document.getElementById('header_container'),
        footerNode = document.getElementById('footer_container'),
        appmenuNode = document.getElementById('konyappmenudiv');
    var sWidth = formNode.scrollWidth;
    var sHeight = formNode.scrollHeight;
    var Script = '';
    var tempCSS = document.styleSheets;
    if(kony.appinit.isIE11) {
        return;
    }
    for(i = 0; i < tempCSS.length; i++) {
        if(tempCSS[i].href) {
            for(j = 0; j < tempCSS[i].rules.length; j++) {
                cssscript = cssscript + tempCSS[i].rules[j].cssText;
            }
        }
    }
    if(headerNode) {
        sHeight = sHeight + headerNode.clientHeight;
        Script = Script + (new XMLSerializer).serializeToString(headerNode);
    }
    for(i = 0; i < clone.childNodes.length; i++) {
        Script = Script + (new XMLSerializer).serializeToString(clone.childNodes[i]);
    }
    if(footerNode) {
        sHeight = sHeight + footerNode.clientHeight;
        Script = Script + (new XMLSerializer).serializeToString(footerNode);
    }
    if(appmenuNode) {
        sHeight = sHeight + appmenuNode.clientHeight;
        Script = Script + (new XMLSerializer).serializeToString(appmenuNode.parentElement);
    }
    data =  '<svg xmlns="http://www.w3.org/2000/svg" width="' + sWidth + '" height="' + sHeight + '">' +
            '<foreignObject width="100%" height="100%">' +
            '<div xmlns="http://www.w3.org/1999/xhtml" style="font-size:40px">' +
            '<style>' +
            cssscript +
            '</style>'+
            Script +
            '</div>' +
            '</foreignObject>' +
            '</svg>';
    svg = new Blob([data], {type: 'image/svg+xml;charset=utf-8'});
    filereader.readAsDataURL(svg);
    filereader.onload = function() {
        var img = new Image();
        img.setAttribute('crossOrigin', 'anonymous');
        img.src = filereader.result;
        img.height = sHeight;
        img.width = sWidth;
        img.style.display = 'none';
        document.body.appendChild(img);
        img.onload = function() {
                var canvas = document.createElement('canvas'),
                    ctx = [];
                canvas.width = img.width ;
                canvas.height = img.height;
                canvas.style.display = 'none';
                document.body.appendChild(canvas);
                ctx = canvas.getContext('2d');
                ctx.imageSmoothingEnabled = true;
                ctx.drawImage(img, 0, 0);
                document.body.removeChild(img);
                document.body.removeChild(canvas);
                config.callback && config.callback(canvas.toDataURL().split(",")[1]);
        }
    }
}
$KI.phone = (function() {
    
    

    var module = {
        dial: function(phoneno) {
            $KW.unLoadWidget();
            var href;
            var platform = $KU.getPlatform();
            if(platform.name == "iphone" && platform.version >= "5" && platform.version < "8")
                href = "tel://" + phoneno;
            else
                href = "tel:" + phoneno;

            window.location.href = href;
        },
        myLocation: function() {
            kony.web.logger("warn", "DEPRECATED API. Instead use geolocation.");
        },
        openmediagallery: function(onselectioncallback, querycontext, widgetref) {

            if(!window.File || !window.FileReader || !window.FileList) { 
                kony.print("openMediaGallery error:: 2103, Cannot open media gallery. Not supported."); 
                return;
            }

            var input = document.createElement('input');
            input.type = 'file';
            input.setAttribute('style', 'display:none;');
            input.setAttribute('id', 'openmediagallery');
            if(querycontext && querycontext.mimetype) { 
                input.setAttribute('accept', querycontext.mimetype);
            }
            var form = document.getElementsByTagName('form')[0];
            form.appendChild(input); 
            kony.events.addEventListener(input, 'change', handleFiles);
            input.click();

            function handleFiles() {
                kony.events.removeEventListener(input, 'change', handleFiles);
                form.removeChild(input); 

                if(onselectioncallback && onselectioncallback instanceof Function) {
                    var reader = new FileReader();
                    var mimetype = this.files[0].type;
                    var info;

                    reader.onload = function(evt) { 
                        var chars = new Uint8Array(evt.target.result);
                        var CHUNK_SIZE = 0x8000,
                            index = 0,
                            result = '',
                            slice;
                        while(index < chars.length) {
                            slice = chars.subarray(index, Math.min(index + CHUNK_SIZE, chars.length));
                            result += String.fromCharCode.apply(null, slice);
                            index += CHUNK_SIZE;
                        }
                        info = new kony.utils.konyRawBytes(result, "utf8");

                        onselectioncallback(info, kony.application.PERMISSION_GRANTED, mimetype); 
                    };
                    reader.onerror = function(evt) { 
                        if(evt.target.error instanceof FileError) { 
                            switch(evt.target.error.code) {
                                case FileError.NOT_FOUND_ERR:
                                    kony.print("openMediaGallery error:: The file resource couldn't be found at the time the read was processed.");
                                    break;
                                case FileError.NOT_READABLE_ERR:
                                    kony.print("openMediaGallery error:: 2101, The resource couldn't be read. Insufficient Permissions.");
                                    break;
                                case FileError.ENCODING_ERR:
                                    kony.print("openMediaGallery error:: The resource couldn't be encoded.");
                                    break;
                                case FileError.SECURITY_ERR:
                                default:
                                    kony.print("openMediaGallery error:: The file resource is unsafe/changed/other unspecified security error.");
                            }
                        } else 
                            kony.print("openMediaGallery error:: " + evt.target.error.name + ", " + evt.target.error.message);
                    };
                    reader.readAsArrayBuffer(this.files[0]); 
                } else {
                    kony.print("openMediaGallery error:: callback function not provided.");
                }
            }
        },

        addCalendarEvent: function() {
            kony.web.logger("warn", "The addCalendarEvent API is not supported.");
        },

        findCalendarEvents: function() {
            kony.web.logger("warn", "The findCalendarEvents API is not supported.");
        },

        openEmail: function() {
            kony.web.logger("warn", "The openEmail API is not supported.");
        },

        removeCalendarEvent: function() {
            kony.web.logger("warn", "The removeCalendarEvent API is not supported.");
        },

        sendSMS: function() {
            kony.web.logger("warn", "The sendSMS API is not supported.");
        }
    };


    return module;
}());

$KI.timer = (function() {
    
    

    var module = {
        timerinfo: {},

        callbackclosure: function(id) {
            var tid = id;
            return function() {
                var repeat, _timerInfo, cb = module.timerinfo[tid]["cb"];
                typeof cb == "function" && cb();
                _timerInfo = module.timerinfo[tid];
                if(_timerInfo) {
                    repeat = _timerInfo["repeat"];
                    !repeat && module.cancel(tid);
                }
            };
        },

        schedule: function(id, cb, interval, repeat) {
            $KU.logExecuting('kony.timer.schedule');
            $KU.logExecutingWithParams('kony.timer.schedule', id, cb, interval, repeat);
            var tinfo = module.timerinfo;

            if(id && !tinfo[id]) {
                tinfo[id] = {};
                tinfo[id]["cb"] = cb;
                tinfo[id]["repeat"] = repeat;

                var tcb = module.callbackclosure(id);
                var frequency = interval * 1000; 
                var func = (repeat === true) ? "setInterval" : "setTimeout";

                timerid = window[func](tcb, frequency);
                tinfo[id]["timerid"] = timerid;
                $KU.logExecutingFinished('kony.timer.schedule');
            } else
                $KU.logErrorMessage('timerId is mandatory or duplicate timer id');
        },

        cancel: function(id) {
            $KU.logExecuting('kony.timer.cancel');
            $KU.logExecutingWithParams('kony.timer.cancel', id);
            var tinfo = module.timerinfo;
            if(tinfo[id]) {
                var timerid = tinfo[id].timerid;
                var func = (tinfo[id]["repeat"] === true) ? "clearInterval" : "clearTimeout";
                $KU.logExecutingFinished('kony.timer.cancel');
                window[func](timerid);
                tinfo[id] = null

            } else {
                $KU.logErrorMessage('timerId is mandatory');
                return null;
            }
        },

        setcallback: function(id, cb) {
            $KU.logExecuting('kony.timer.setCallBack');
            $KU.logExecutingWithParams('kony.timer.setCallBack', id, cb);
            var tinfo = module.timerinfo;
            if(tinfo[id]) {
                tinfo[id].cb = cb;
            }
            $KU.logExecutingFinished('kony.timer.setCallBack');
        }
    };


    return module;
}());

$KI.appevents = (function() {
    var idletimeout = {
        id: null,
        value: 0,
        cb: null,
        enabled: false,
        expired: false,
        lastInteraction: 0
    };

    return {
        timercb: function() {
            var currentform = $KW.Form.getCurrentForm();
            var cb = null;

            idletimeout.expired = true;
            idletimeout.enabled = false;

            if(currentform.enabledforidletimeout) {
                
                
                if(idletimeout.cb) {
                    cb = idletimeout.cb;
                    idletimeout.cb = null;
                    cb(currentform);
                }
            }
        },

        registerforidletimeout: function(time, cb) {
            $KU.logExecuting('kony.application.registerForIdleTimeout');
            $KU.logExecutingWithParams('kony.application.registerForIdleTimeout', time, cb);
            if(!idletimeout.enabled) {
                
                idletimeout.value = time * 60 * 1000;
                idletimeout.id = setTimeout($KI.appevents.timercb, idletimeout.value);
                idletimeout.lastInteraction = new Date().getTime();
                idletimeout.enabled = true;
                idletimeout.expired = false;
                idletimeout.cb = cb;
                $KG["__idletimeout"] = idletimeout;
                $KU.logExecutingFinished('kony.application.registerForIdleTimeout');
            }
        },

        unregisterforidletimeout: function() {
            $KU.logExecuting('kony.application.unregisterForIdleTimeout');
            $KU.logExecutingWithParams('kony.application.unregisterForIdleTimeout');
            clearTimeout(idletimeout.id);
            idletimeout.enabled = false;
            $KG["__idletimeout"] = "";
            $KU.logExecutingFinished('kony.application.unregisterForIdleTimeout');
        },

        resettimer: function() {
            
            var curTime = new Date().getTime();
            if((curTime - idletimeout.lastInteraction) >= idletimeout.value) {
                $KI.appevents.timercb();
                return;
            } else {
                clearTimeout(idletimeout.id);
                idletimeout.id = setTimeout($KI.appevents.timercb, idletimeout.value);
                idletimeout.lastInteraction = curTime;
            }
        }
    };
})();

$KI.geolocation = (function() {
    
    

    var module = {
        getcurrentposition: function(successCallback, errorCalback, positionOptions) {
            $KU.logExecuting('kony.location.getCurrentPosition');
            $KU.logExecutingWithParams('kony.location.getCurrentPosition', successCallback, errorCalback, positionOptions);

            if(navigator.geolocation) {
                navigator.geolocation.getCurrentPosition(successCallback, errorCalback, positionOptions);
            }

            $KU.logExecutingFinished('kony.location.getCurrentPosition');
        },

        watchposition: function(successCallback, errorCalback, positionOptions) {
            $KU.logExecuting('kony.location.watchPosition');
            $KU.logExecutingWithParams('kony.location.watchPosition', successCallback, errorCalback, positionOptions);
            if(navigator.geolocation) {
                $KU.logExecutingFinished('kony.location.watchPosition');
                return(navigator.geolocation.watchPosition(successCallback, errorCalback, positionOptions));
            }
        },

        clearwatch: function(watchid) {
            $KU.logExecuting('kony.location.clearWatch');
            $KU.logExecutingWithParams('kony.location.clearWatch', watchid);
            if(navigator.geolocation) {
                navigator.geolocation.clearWatch(watchid);
            }
            $KU.logExecutingFinished('kony.location.clearWatch');
        }
    };


    return module;
}());



$KI.os.time = function() {
    var timeStr = (new Date()).toTimeString();
    return timeStr.slice(0, timeStr.indexOf(" "));
};

$KI.os.diffdatetime = function(time1, time2) {
    if(typeof(time1) !== "string" || typeof(time2) !== "string") {
        throw new Error("Invalid argument(s) to os.diffdatetime");
    }

    var t1 = time1.split(":");
    t1[2] = t1[2] - 0;
    var t2 = time2.split(":");
    t2[2] = t2[2] - 0;
    var one_day = 86400;
    var t1sec = t1[0] * 3600 + t1[1] * 60 + t1[2];
    var t2sec = t2[0] * 3600 + t2[1] * 60 + t2[2];

    return(t1sec > one_day || t2sec > one_day) ? null : t1sec - t2sec;
};

$KI.os.date = function() {
    var result;
    var currentDate = new Date();

    if(0 === arguments.length) {
        var timeStr = currentDate.toTimeString();
        result = $KI.os.padZero(currentDate.getMonth() + 1) + "/" + $KI.os.padZero(currentDate.getDate()) + "/" + $KI.os.padZero(currentDate.getFullYear() % 100) + " " + timeStr.slice(0, timeStr.indexOf(" "));
        return result;
    } else if(typeof(arguments[0]) == "string") {

        if(arguments[0].toLowerCase().indexOf("dd") != -1) {

            return $KI.os.formatDate(arguments[0], currentDate);
        } else {
            var utc = arguments[0].charAt(0) === '!';
            var index = utc ? 1 : 0;
            if('*' === arguments[0].charAt(index) && 't' === arguments[0].charAt(index + 1)) {
                var day = utc ? currentDate.getUTCDate() : currentDate.getDate();
                var mon = (utc ? currentDate.getUTCMonth() : currentDate.getMonth()) + 1;
                var year = utc ? currentDate.getUTCFullYear() : currentDate.getFullYear();

                result = new Object();
                result["year"] = year;
                result["month"] = mon;
                result["day"] = day;
                result["hour"] = utc ? currentDate.getUTCHours() : currentDate.getHours();
                result["min"] = utc ? currentDate.getUTCMinutes() : currentDate.getMinutes();
                result["sec"] = utc ? currentDate.getUTCSeconds() : currentDate.getSeconds();
                result["wday"] = utc ? currentDate.getUTCDay() : currentDate.getDay() + 1;
                result["yday"] = $KU.getDayOfYear(day, mon, year);
                result["isdst"] = utc ? false : $KI.os.checkForDst();
                return result;
            } else
                return null;
        }
    } else
        return null;
};

$KI.os.tocurrency = function(arg) {
    $KU.logExecuting('kony.os.toCurrency');
    arg -= 0;
    if(isNaN(arg)) {
        $KU.logErrorMessage('Invalid argument to os.tocurrency');
        throw new Error("Invalid argument to os.tocurrency");
    }
    $KU.logExecutingWithParams('kony.os.toCurrency', arg);
    if(arg < 0) arg *= -1;
    var str = arg.toFixed(3);
    str = str.substr(0, str.length - 1);
    var outStr = "";
    for(var i = 0; i < str.length - 4; i++) {
        outStr += str.charAt(i);
        if((str.length - i - 1) % 3 === 0) outStr += ",";
    }

    for(; i < str.length; i++) {
        outStr += str.charAt(i);
    }

    $KU.logExecutingFinished('kony.os.toCurrency');
    return "$" + outStr;
};

$KI.os.tonumber = function(arg) {
    $KU.logExecuting('kony.os.toNumber');
    if(arguments.length != 1) {
        $KU.logErrorMessage('Invalid argument to os.number');
        throw new Error("Invalid argument to os.tonumber");
    }
    $KU.logExecutingWithParams('kony.os.toNumber', arg);
    $KU.logExecutingFinished('kony.os.toNumber');
    if(typeof(arg) === "number") {
        return arg;
    } else if(typeof(arg) === "string") {

        var str = arg.replace(/^\s*/, '').replace(/\s*$/, '');
        if(str === '') {
            return null;
        } else {
            var num = str - 0;
            return(isNaN(num) ? null : num);
        }

    } else {
        $KU.logWarnMessage('Request aborted on user request');
        return null;
    }
};

$KI.os.freememory = function() {
    $KU.logExecuting('kony.os.freeMemory');
    $KU.logExecutingWithParams('kony.os.freeMemory');
    $KU.logExecutingFinished('kony.os.freeMemory');
    return 100 * 1024 * 1024;
};


$KI.os.comparedates = function(d1, d2, frmt) {
    if(d1 == null || d2 == null || frmt == null || !$KU.isValidDate(d1, frmt) || !$KU.isValidDate(d2, frmt))
        return null

    var date1 = $KU.getDate(d1, frmt);
    var date2 = $KU.getDate(d2, frmt);
    var oneday = 24 * 60 * 60 * 1000;

    return parseInt((date1.getTime() - date2.getTime()) / oneday);
};



$KI.os.addtodate = function(d1, frmt, unt, cnt) {
    if(d1 == null || frmt == null || unt == null || cnt == null) {
        return null;
    }
    var inputDate = d1;
    var fmt = frmt.split(" ")[0];
    var unit = unt;
    var count = cnt;
    var parts = inputDate.split(" ");
    var dateParts = parts[0].split("/");
    var time = parts[1];

    if(!$KU.isValidDate(parts[0], fmt))
        return null;

    if(time) {
        var t = time.split(":");
        var one_day = 86400;
        var tSec = t[0] * 3600 + t[1] * 60 + (t[2] - 0);
        if(tSec > one_day) return null;
    }

    var dateObj = $KU.getDate(inputDate, fmt);

    if(dateObj) {
        switch(unit) {
            case "years":
                dateObj.setFullYear(dateObj.getFullYear() + count);
                break;
            case "months":
                dateObj.setMonth(dateObj.getMonth() + count);
                break;
            case "days":
                dateObj.setDate(dateObj.getDate() + count);
                break;
            case "hours":
                dateObj.setHours(dateObj.getHours() + count);
                break;
            case "minutes":
                dateObj.setMinutes(dateObj.getMinutes() + count);
                break;
            default:
                break;
        }
        if($KI.os.isleapyear([d1, fmt]) && dateObj.getMonth() >= 1 && (unit == "years" || (unit == "months" && (count == -12 || count == 12))))
            dateObj.setDate(dateObj.getDate() - 1);

        return $KI.os.formatDate(fmt, dateObj) + (time ? " " + dateObj.toTimeString().split(" ")[0] : "");
    }
    return null;
};


$KI.os.isleapyear = function(d1, frmt) {
    var year;
    var date = new Date(); 
    year = date.getFullYear();

    if(typeof(d1) == "string" && typeof(frmt) == "string") {

        if(!$KU.isValidDate(d1, frmt))
            return false;

        var yearPart = d1.split("/")[2];
        year = (yearPart.length == 2) ? parseInt(date.getFullYear().toString().substr(0, 2) + yearPart) : parseInt(yearPart);
    }

    if((year % 400 == 0) || ((year % 4 == 0) && (year % 100 != 0))) {
        return true;
    } else {
        return false;
    }
};


$KI.os.formatdate = function(d1, sfrmt, tgtfrmt) {
    var year;
    if(d1 == null || sfrmt == null || tgtfrmt == null) {
        return null;
    } else if(typeof(d1) === "string" && typeof(sfrmt) === "string" && typeof(tgtfrmt) === "string") {

        var inputDate = d1
        var srcfmt = sfrmt;
        var targetfmt = tgtfrmt;

        var datePos = srcfmt.indexOf("dd");
        var monthPos = srcfmt.indexOf("mm");
        var yearPos = (srcfmt.indexOf("yyyy") != -1) ? srcfmt.indexOf("yyyy") : srcfmt.indexOf("yy");

        if((srcfmt == "dd/mm/yyyy" && !$KU.isValidDate(inputDate, srcfmt)) || datePos == -1 || monthPos == -1 || yearPos == -1 || srcfmt.indexOf("ddd") != -1 || srcfmt.indexOf("mmm") != -1) {
            return null;
        }

        var dateStrSep = srcfmt.charAt(datePos - 1);
        var dateEndSep = srcfmt.charAt(datePos + 2);
        dateEndSep = (dateEndSep == "(") ? "" : dateEndSep;

        var monthStrSep = srcfmt.charAt(monthPos - 1);
        var monthEndSep = srcfmt.charAt(monthPos + 2);

        var yearStrSep = srcfmt.charAt(yearPos - 1);
        var yearEndSep = srcfmt.charAt(yearPos + 4);

        var startDateIndex = (dateStrSep == "") ? inputDate.indexOf(dateStrSep, datePos - 1) : inputDate.indexOf(dateStrSep, datePos - 2) + 1;
        var startMonthIndex = (monthStrSep == "") ? inputDate.indexOf(monthStrSep, monthPos - 1) : inputDate.indexOf(monthStrSep, monthPos - 2) + 1;
        var startYearIndex = (yearStrSep == "") ? inputDate.indexOf(yearStrSep, yearPos - 1) : ((inputDate.indexOf(yearStrSep, yearPos - 2) != -1) ? inputDate.indexOf(yearStrSep, yearPos - 2) + 1 : inputDate.indexOf(yearStrSep, yearPos - 4) + 1);

        var endDateIndex = (dateEndSep != "") ? inputDate.indexOf(dateEndSep, datePos) : inputDate.indexOf(dateEndSep, datePos + 2);
        var endMonthIndex = (monthEndSep != "") ? inputDate.indexOf(monthEndSep, monthPos) : inputDate.indexOf(monthEndSep, monthPos + 2);
        var endYearIndex = (yearEndSep != "") ? inputDate.indexOf(yearEndSep, yearPos) : inputDate.indexOf(yearEndSep, yearPos + 4);

        var dateVal = inputDate.substring(startDateIndex, endDateIndex);
        var monthVal = inputDate.substring(startMonthIndex, endMonthIndex);
        var yearVal = inputDate.substring(startYearIndex, endYearIndex);

        if((yearVal.length == 2 && targetfmt.indexOf("yyyy") != -1))
            var fullyr = new Date().getFullYear().toString().substr(0, 2) + yearVal;

        targetfmt = targetfmt.replace(/dd/, $KI.os.padZero(parseInt(dateVal, 10)));
        targetfmt = targetfmt.replace(/mm/, $KI.os.padZero(parseInt(monthVal, 10)));
        targetfmt = targetfmt.replace(/(yyyy|yy)/, fullyr ? fullyr : ((targetfmt.indexOf("yyyy") == -1 && yearVal.length == 4) ? yearVal.substr(2, 2) : yearVal));

        return targetfmt;
    }
    return null;
};


$KI.os.isvaliddate = function(date, frmt) {
    return(arguments.length != 2 || date == null || frmt == null) ? false : $KU.isValidDate(date, frmt);
};

$KI.os.checkForDst = function() {
    var rightNow = new Date();
    var jan1 = new Date(rightNow.getFullYear(), 0, 1, 0, 0, 0, 0);
    var temp = jan1.toGMTString();
    var jan2 = new Date(temp.substring(0, temp.lastIndexOf(" ") - 1));
    var std_time_offset = (jan1 - jan2) / (1000 * 60 * 60);

    var june1 = new Date(rightNow.getFullYear(), 6, 1, 0, 0, 0, 0);
    temp = june1.toGMTString();
    var june2 = new Date(temp.substring(0, temp.lastIndexOf(" ") - 1));
    var daylight_time_offset = (june1 - june2) / (1000 * 60 * 60);
    var dst;
    if(std_time_offset == daylight_time_offset) {
        
        return false;
    } else {
        
        return true;
    }
};



$KI.os.datecomponents = function(date, frmt) {
    var result;
    var dateObject;
    if(arguments.length == 0) {
        dateObject = new Date();
    } else if(date != null && frmt != null) {
        if(!$KU.isValidDate(date, frmt))
            return null;
        dateObject = $KU.getDate(date, frmt);
        var yearfmt = frmt.split("/")[2];
    }
    if(dateObject) {

        var day = dateObject.getDate();
        var mon = dateObject.getMonth() + 1;
        var year = (yearfmt && yearfmt.length == 2) ? parseInt(dateObject.getFullYear().toString().substr(2, 2)) : dateObject.getFullYear();

        result = new Object();
        result["year"] = year;
        result["month"] = mon;
        result["day"] = day;
        result["hour"] = dateObject.getHours();
        result["min"] = dateObject.getMinutes();
        result["sec"] = dateObject.getSeconds();
        result["wday"] = dateObject.getDay() + 1;
        result["yday"] = $KU.getDayOfYear(day, mon, year);
        result["isdst"] = $KI.os.checkForDst();
        return result;
    } else
        return null;

};

$KI.os.padZero = function(num) {
    return num < 10 ? ("0" + num) : num;
};

$KI.os.formatDate = function(fmt, dateObj) {
    fmt = fmt.toLowerCase();
    fmt = fmt.replace(/dd/, $KI.os.padZero(dateObj.getDate()));
    fmt = fmt.replace(/mm/, $KI.os.padZero(dateObj.getMonth() + 1));
    return fmt.replace(/(yyyy|yy)/, fmt.indexOf("yyyy") == -1 ? dateObj.getFullYear().toString().substr(2, 2) : dateObj.getFullYear());
};

$KI.os.getappcontext = function() {
    var appcontext = {};
    var flag = "standalone" in window.navigator && window.navigator.standalone ? 1 : 0;
    $KU.logExecuting('kony.os.getAppContext');
    $KU.logExecutingWithParams('kony.os.getAppContext');
    $KU.logExecutingFinished('kony.os.getAppContext');
    appcontext["launchmode"] = flag;
    return appcontext;
};

$KI.os.hasgpssupport = function() {
    $KU.logExecuting('kony.os.hasGPSSupport');
    $KU.logExecutingWithParams('kony.os.hasGPSSupport');
    $KU.logExecutingFinished('kony.os.hasGPSSupport');
    return 'navigator' in window && 'geolocation' in navigator;
};

($KI.os.hascamerasupport = function() {
    if(navigator.mediaDevices && navigator.mediaDevices.enumerateDevices) {
        navigator.mediaDevices.enumerateDevices().then(function(device) {
            var i = 0;
            for(i; i < device.length; i++) {
                if(device[i].kind === 'videoinput') {
                    kony.appinit.isCameraSupported = true;
                }
            }
        });
    }
})();

$KI.os.hastouchsupport = function() {
    $KU.logExecuting('kony.os.hasTouchSupport');
    $KU.logExecutingWithParams('kony.os.hasTouchSupport');
    $KU.logExecutingFinished('kony.os.hasTouchSupport');
    $KU.logErrorMessage('hasTouchSupport failed');
    return false;
};

$KI.os.hasorientationsupport = function() {
    $KU.logExecuting('kony.os.hasOrientationSupport');
    $KU.logExecutingWithParams('kony.os.hasOrientationSupport');
    $KU.logExecutingFinished('kony.os.hasOrientationSupport');
    $KU.logErrorMessage('hasOrientationSupport failed');
    return false;
};

$KI.os.hasaccelerometersupport = function() {
    return false;
};

$KI.os.httpheaders = function() {
    if($KG["httpheaders"])
        return JSON.stringify($KG["httpheaders"]);
};

$KI.os.getdevicecurrentorientation = function() {
    $KU.logExecuting('kony.os.getDeviceCurrentOrientation');
    $KU.logExecutingWithParams('kony.os.getDeviceCurrentOrientation');
    var orientation = $KU.detectOrientation();
    $KU.logExecutingFinished('kony.os.getDeviceCurrentOrientation');
    return(orientation == "portrait") ? constants.DEVICE_ORIENTATION_PORTRAIT : constants.DEVICE_ORIENTATION_LANDSCAPE;
};


$KI.os.setapplicationscrollmode = function(paramObj) {
    if(!paramObj)
        return;

    var platform = $KU.getPlatform();
    var platformName = platform.name.toLowerCase();
    var platformVersion = platform.version;

    if(platformName == "blackberryNTH" || (platformName == "windowsphone" && $KU.isIE9))
        return;

    var custom = paramObj.customscroll;
    var mixed = paramObj.mixedscroll;
    var native2 = paramObj.nativescroll;
    var nomodify;

    
    if(mixed) {
        var platforms = mixed.platforms;
        if(platforms) {
            for(var i = IndexJL; i < platforms.length; i++) {
                var platform = platforms[i];
                if(platformName == platform.name.toLowerCase()) {
                    
                    var useragents = platform.useragents;
                    if(useragents) {
                        for(var j = IndexJL; j < useragents.length; j++) {
                            if(navigator.userAgent.toLowerCase().indexOf(useragents[j].toLowerCase()) != -1) {
                                $KG["useMixedScroll"] = true;
                                nomodify = true;
                                break;
                            }
                        }
                        if(nomodify)
                            break;
                    }

                    
                    var versions = platform.versions;
                    if((!useragents && !versions) || versions[IndexJL] == -1) {
                        $KG["useMixedScroll"] = true;
                        break;
                    }
                    for(var j = IndexJL; j < versions.length; j++) {
                        if(platformVersion == versions[j]) {
                            $KG["useMixedScroll"] = true;
                            break;
                        }
                    }
                }
            }
        }
    }
    
    if(native2 && !nomodify) {
        var platforms = native2.platforms;
        if(platforms) {
            for(var i = IndexJL; i < platforms.length; i++) {
                var platform = platforms[i];
                if(platformName == platform.name.toLowerCase()) {
                    
                    var useragents = platform.useragents;
                    if(useragents) {
                        for(var j = IndexJL; j < useragents.length; j++) {
                            if(navigator.userAgent.toLowerCase().indexOf(useragents[j].toLowerCase()) != -1) {
                                $KG["useNativeScroll"] = true;
                                $KG["useMixedScroll"] = false;
                                nomodify = true;
                                break;
                            }
                        }
                        if(nomodify)
                            break;
                    }

                    
                    var versions = platform.versions;
                    if((!useragents && !versions) || versions[IndexJL] == -1) {
                        if(!$KG["useMixedScroll"])
                            $KG["useNativeScroll"] = true;
                        break;
                    }
                    for(var j = IndexJL; j < versions.length; j++) {
                        if(platformVersion == versions[j]) {
                            $KG["useNativeScroll"] = true;
                            $KG["useMixedScroll"] = false;
                            break;
                        }
                    }
                }
            }
        }
    }
    
    if(!$KG["useMixedScroll"] && !$KG["useNativeScroll"])
        $KG["useCustomScroll"] = true;
};

$KI.os.print = function(container, autoClose) {
    $KU.logExecuting('kony.os.print');
    $KU.logExecutingWithParams('kony.os.print', container, container);
    if(container && container.id && !(container.wType === "Form")) {
        var domNode = document.getElementById(container.id);
        if(!domNode)
            domNode = $KU.getNodeByModel(container);
        if(domNode) {
            var printContents = domNode.outerHTML;
            var headTag = document.getElementsByTagName("head")[0];
            var baseTag;
            for(var i = 0; i < headTag.childNodes.length; i++) {
                if(headTag.childNodes[i].nodeName == "BASE") {
                    baseTag = headTag.childNodes[i];
                    break;
                }
            }

            var w = window.open();
            if(w) {
                w.document.write('<!DOCTYPE html><html>');
                w.document.write('<head>');
                
                
                if(baseTag) {
                    w.document.write("<base href='");
                    w.document.write(baseTag.href);
                    w.document.write("' target = '_blank'>");
                }
                var tempCSS = document.styleSheets;
                for(var i = 0; i < tempCSS.length; i++) {
                    if(tempCSS[i].href) {
                        w.document.write("<link rel='stylesheet' href='");
                        w.document.write(tempCSS[i].href);
                        w.document.write("' type='text/css'></link>");
                    }
                }
                if(kony.appinit.isSafari)
                    w.document.write('<style>table{table-layout: auto !important;} .ktable {table-layout: auto !important;} .kcell {display: table !important;}</style>');
                w.document.write('</head>');
                if(kony.appinit.isSafari)
                    w.document.write("<body style='" + window.document.body.style.cssText + "' >");
                else
                    w.document.write('<body>');
                w.document.write(printContents);
                
                setTimeout(function() {
                    w.document.write('</body>');
                    w.document.write('</html>');
                    w.document.close(); 
                    w.focus();
                    w.print();
                }, 1000);

                setTimeout(function() {
                    w.close();
                }, 2000); 
            } else {
                kony.print("Allow popup to open for this site.");
            }
        }
    } else if(container && !(container.wType && container.wType === "Form")) {
        var w = window.open();
        if(w) {
            w.document.write(container);
            w.onload = new function() {
                w.document.close();
                w.focus();
                w.print();
            }

            if(autoClose) {
                setTimeout(function() {
                    w.close();
                }, 2000); 
            }
        } else {
            kony.print("Allow popup to open for this site.");
        }

    } else {
        window.print();
    }
    $KU.logExecutingFinished('kony.os.print');
};

$KI.os.addbookmark = function(url, title, params) {
    var url = url || window.location.href.split("#")[0];
    url = url.split("?")[0];
    if(params && params instanceof Object) {
        var searchStr = "";
        for(var prop in params) {
            searchStr += escape(prop) + "=" + escape(params[prop]) + "&";
        }
        searchStr && (searchStr = searchStr.substring(0, searchStr.length - 1))
    }
    try {
        title = title || document.title;
        url += searchStr ? ("?" + searchStr) : "";
        if((typeof window.sidebar == "object") && (typeof window.sidebar.addPanel == "function")) {
            window.sidebar.addPanel(title, url, ""); 
        } else if(kony.appinit.isIE && typeof window.external == "object") {
            window.external.AddFavorite(url, title); 
        } else if(kony.appinit.isOpera) {
            var elem = document.createElement('a');
            elem.setAttribute('href', url);
            elem.setAttribute('title', title);
            elem.setAttribute('rel', 'sidebar');
            elem.click();
        }
    } catch(err) {
        kony.web.logger("log", err);
    }
};



$KIO.FileSystem = $KIO.fs = {
    callback: function() {}, 

    ieFileUploadObj: {},

    init: function() {
        if(!$KU.isAjaxUploadSupported) {
            var htmlString = "<iframe id='konyiframeElem' name='konyiframeElem' src='about:blank' style='opacity:0;width:0px;height:0px;' ></iframe>";
            var wrapper = document.createElement('div');
            wrapper.innerHTML = htmlString;
            document.body.appendChild(wrapper);
        }
    },

    browse: function(browseConfig, browseCallback) { 

        if(!browseConfig instanceof Object || !browseCallback instanceof Function)
            return;

        this.callback = browseCallback;
        var htmlString = "";

        if($KU.isAjaxUploadSupported) {
            var fileElement = document.getElementById("konyFileElem");
            if(!fileElement) {
                htmlString = "<form name='uploadForm'><input type='file' multiple id='konyFileElem' onchange='$KIO.fs.afterBrowse(arguments[0])' onclick='uploadForm.reset();' style='opacity:0;width:0px;height:0px;display:none;' /></form>";
                var wrapper = document.createElement('div');
                wrapper.innerHTML = htmlString;
                document.body.appendChild(wrapper);
                fileElement = document.getElementById("konyFileElem");
            }

            if(browseConfig.selectMultipleFiles == false)
                fileElement.removeAttribute("multiple");
            else
                fileElement.setAttribute("multiple", "multiple");
            if(browseConfig.filter)
                fileElement.setAttribute("accept", browseConfig.filter.join(","));
            else
                fileElement.removeAttribute("accept");

            fileElement.click();
        } else {
            var iFrameWindow = document.getElementById("konyiframeElem").contentWindow || document.getElementById("konyiframeElem").documentWindow;
            var frmElem = iFrameWindow.document.getElementById("uploadForm");
            if(!frmElem) {
                var wrapper = document.createElement('div');
                wrapper.innerHTML = '<form id="uploadForm" method="POST" action="" enctype="multipart/form-data" ></form>';
                if(iFrameWindow.document.body) iFrameWindow.document.body.appendChild(wrapper);
                frmElem = iFrameWindow.document.getElementById("uploadForm");
            }
            var unique = new Date().getTime();
            var fileInput = document.createElement('input');
            fileInput.setAttribute('type', 'file');
            fileInput.setAttribute('name', 'file_' + unique);
            fileInput.setAttribute('id', 'file_' + unique);
            fileInput.setAttribute('onchange', 'window.parent.$KIO.fs.afterBrowse(this)');
            fileInput.setAttribute('onclick', 'uploadForm.reset()');
            frmElem.appendChild(fileInput);

            var file = iFrameWindow.document.getElementsByTagName("input");
            file = file[file.length - 1];
            if(file) file.click();
        }
    },

    afterBrowse: function(event) { 

        var fileList = [];
        if($KU.isAjaxUploadSupported) {
            for(var i = 0, f; f = event.target.files[i]; ++i) {
                fileList.push(new $KIO.File(f)); 
            }
        } else {
            var path = event.value;
            var fName = path.substring(path.lastIndexOf('\\') + 1);
            var pName = path.substring(0, path.lastIndexOf('\\')); 
            pName = pName.substring(pName.lastIndexOf('\\') + 1); 
            fileList.push(new $KIO.File({
                name: fName,
                fullPath: path,
                parent: pName,
                file: event
            }));
        }
        $KIO.fs.callback(event, fileList); 
    },

    uploadFiles: function(URL, fileList, upLoadCallBack, upLoadConfig) { 
        if(!URL || !fileList || (fileList && fileList.length < 1))
            return;

        var uploadState = [];
        for(var i = 0, f; f = fileList[i]; ++i) {
            uploadState.push({
                file: f,
                status: null,
                uploadBytes: null
            });
        }
        if($KU.isAjaxUploadSupported) {
            for(var index = 0; index < uploadState.length; index++) {
                this.uploadFile(URL, uploadState, index, upLoadCallBack, upLoadConfig); 
            }
        } else {
            var konyFrame = document.getElementById("konyiframeElem");
            if($KU.isIE) {
                konyFrame.attachEvent("onload", $KIO.fs.ieCallback);
                konyFrame.attachEvent("onerror", $KIO.fs.ieErrorCallback);
            } else {
                konyFrame.onload = $KIO.fs.ieCallback;
                konyFrame.onerror = $KIO.fs.ieErrorCallback;
            }

            $KIO.fs.ieFileUploadObj.state = uploadState;
            $KIO.fs.ieFileUploadObj.url = URL;
            $KIO.fs.ieFileUploadObj.callback = upLoadCallBack;

            var re = /^(http|https):\/\/?/;
            if(!re.test(URL)) {
                $KIO.fs.ieErrorCallback();
                return;
            } 

            var frame = document.getElementById('konyiframeElem');
            var iFrameWindow = frame.contentWindow || frame.documentWindow;
            var form = iFrameWindow.document.getElementById("uploadForm");
            form.action = URL;
            form.submit();
        }
    },

    uploadFile: function(url, uploadObj, fIndex, callback, config) { 
        try {
            var f = uploadObj[fIndex].file;
            var formData = new FormData();
            formData.append(f.name, f.file); 

            var re = /^(http|https):\/\/?/;
            if(!re.test(url)) {
                uploadObj[fIndex].status = constants.FILE_UPLOAD_ERROR_STATE;
                callback && callback(url, uploadObj);
                return;
            } 

            var xhr = new XMLHttpRequest();
            xhr.open('POST', url, true);

            xhr.upload.onloadstart = function(e) {
                uploadObj[fIndex].status = constants.FILE_UPLOAD_START_STATE;
                uploadObj[fIndex].uploadBytes = 0;
                callback && callback(url, uploadObj);
            }
            xhr.upload.onprogress = function(e) { 
                if(e.lengthComputable) {
                    uploadObj[fIndex].uploadBytes = e.loaded;
                }
                uploadObj[fIndex].status = constants.FILE_UPLOAD_PROGRESS_STATE;
                callback && callback(url, uploadObj);
            };
            xhr.upload.onerror = function(e) { 
                uploadObj[fIndex].status = constants.FILE_UPLOAD_ERROR_STATE;
                uploadObj[fIndex].uploadBytes = 0;
                callback && callback(url, uploadObj);
            };
            xhr.upload.onabort = function(e) { 
                uploadObj[fIndex].status = constants.FILE_UPLOAD_ERROR_STATE;
                callback && callback(url, uploadObj);
            };
            xhr.onload = function(e) {
                if(this.status == 200) { 
                    uploadObj[fIndex].status = constants.FILE_UPLOAD_COMPLETE_STATE;
                    uploadObj[fIndex].uploadBytes = uploadObj[fIndex].file.size;
                    callback && callback(url, uploadObj);
                }
            };
            xhr.onerror = function(e) { 
                uploadObj[fIndex].status = constants.FILE_UPLOAD_ERROR_STATE;
                uploadObj[fIndex].uploadBytes = 0;
                callback && callback(url, uploadObj);
            };
            var requestTimer = setTimeout(function() { 
                xhr.abort();
            }, constants.UPLOAD_MAX_WAIT_TIME);
            xhr.onreadystatechange = function() { 
                if(xhr.readyState != 4) {
                    return;
                }
                clearTimeout(requestTimer);
                if(xhr.status != 200) {
                    uploadObj[fIndex].status = constants.FILE_UPLOAD_ERROR_STATE;
                    uploadObj[fIndex].uploadBytes = 0;
                    callback && callback(url, uploadObj);
                }
            };
            xhr.send(formData); 
        } catch(e) {
            kony.web.logger("log", e.message);
        }
    },

    ieCallback: function() {
        var uObj = $KIO.fs.ieFileUploadObj;
        try {
            var response = document.getElementById("konyiframeElem").contentWindow.document.body.innerHTML;
            if(response) {
                for(var i = 0; i < uObj.state.length; i++)
                    uObj.state[i].status = constants.FILE_UPLOAD_COMPLETE_STATE;
                uObj.callback && uObj.callback(uObj.url, uObj.state);
                kony.web.logger("log", response);
            }
        } catch(e) {
            kony.web.logger("log", e.message);
            for(var i = 0; i < uObj.state.length; i++)
                uObj.state[i].status = constants.FILE_UPLOAD_ERROR_STATE;
            uObj.callback && uObj.callback(uObj.url, uObj.state);
        }
    },

    ieErrorCallback: function() {
        var uObj = $KIO.fs.ieFileUploadObj;
        for(var i = 0; i < uObj.state.length; i++)
            uObj.state[i].status = constants.FILE_UPLOAD_ERROR_STATE;
        uObj.callback && uObj.callback(uObj.url, uObj.state);
    },

    copyBundledRawFileTo : tobeimplemented,
    getAppGroupDirectoryPath : tobeimplemented,
    getApplicationDirectoryPath : tobeimplemented,
    getCacheDirectoryPath : tobeimplemented,
    getDatabaseDirectoryPath : tobeimplemented,
    getDataDirectoryPath : tobeimplemented,
    getExternalStorageDirectoryPath : tobeimplemented,
    getFile : tobeimplemented,
    getRawDirectoryPath : tobeimplemented,
    getSupportDirectoryPath : tobeimplemented,
    isExternalStorageAvailable : tobeimplemented

};



$KIO.File = function(file) {
    if($KU.isAjaxUploadSupported) {
        this.name = file.name;
        this.file = file; 
    } else {
        for(var prop in file) this[prop] = file[prop];
    }
    this.readable = true;
    this.writable = false;
    if(file.lastModifiedDate)
        this.modificationTime = new Date(file.lastModifiedDate).toISOString();
    if(file.size)
        this.size = file.size;
    return this;
};






function accessorDescriptor(field, fun) {
    var desc = {
        enumerable: true,
        configurable: true
    };
    desc[field] = fun;
    return desc;
}

function defineGetter(obj, prop, get) {
    if(Object.defineProperty)
        return Object.defineProperty(obj, prop, accessorDescriptor("get", get));
    if(Object.prototype.__defineGetter__)
        return obj.__defineGetter__(prop, get);

    throw new Error("browser does not support getters");
}

function defineSetter(obj, prop, set) {
    if(Object.defineProperty)
        return Object.defineProperty(obj, prop, accessorDescriptor("set", set));
    if(Object.prototype.__defineSetter__)
        return obj.__defineSetter__(prop, set);

    throw new Error("browser does not support setters");
}

function ieSetProperty(obj, key, value) {
    kony.model.update(obj, key, value);
}

function ieGetProperty(obj, key) {
    if(!obj) return null;
    if(obj.wType) {
        key = (obj[key] instanceof Object && obj[key].wType) ? key : key.toLowerCase();
    }
    return obj[key];
}


var vendor = ((/webkit/i).test(navigator.userAgent) && !(/edge/i).test(navigator.userAgent)) ? 'webkit' : (/firefox/i).test(navigator.userAgent) ? 'Moz' : 'opera' in window ? 'o' : ((/msie/i).test(navigator.userAgent) || (/rv:([1][0-9])/i).test(navigator.userAgent)) ? 'ms' : '';
var nextFrame = window['requestAnimationFrame'] || window[vendor + 'RequestAnimationFrame'] || function(callback) {
    return setTimeout(callback, 1);
};
var cancelFrame = window['cancelAnimationFrame'] || window[vendor + 'CancelRequestAnimationFrame'] || clearTimeout;
var Rectangle = function(x, y, width, height) {
    this.x = x;
    this.y = y;
    this.width = width;
    this.height = height;
};
Rectangle.prototype.contains = function(targetR) {
    return(targetR.x >= this.x) && (targetR.y >= this.y) &&
        (targetR.x + targetR.width <= this.x + this.width) && (targetR.y + targetR.height <= this.y + this.height);
};
Rectangle.prototype.intersects = function(targetR) {
    return !((targetR.x + targetR.width <= this.x) ||
        (targetR.y + targetR.height <= this.y) ||
        (targetR.x >= this.x + this.width) ||
        (targetR.y >= this.y + this.height)
    );

};
$KU = kony.utils = {
    Rectangle: Rectangle,

    getValueFromObjectByPath: function(keys, obj, delimiter) {
        var k=0, klen = 0, ref = null;

        if(!(typeof delimiter === 'string' && delimiter)) {
            delimiter = '.';
        }

        if(typeof keys === 'string' && keys) {
            keys = keys.split(delimiter);
        }

        if(keys instanceof Array && typeof obj === 'object' && obj) {
            ref = obj;
            klen = keys.length;

            for(k=0; k<klen; k++) {
                if(typeof ref === 'object' && ref && ref[keys[k]]) {
                    ref = ref[keys[k]];
                } else {
                    break;
                }
            }
        }

        return ref;
    },

    deduceTopLevelFlexModal: function(formModel) {
        var flexPopupModals, activePopup, nodes;

        var _dequeue = function(queue) {
            return queue.shift();
        };
        var _enqueue = function(queue, topLevelObject) {
            if(topLevelObject instanceof Array) {
                queue = queue.concat(topLevelObject);
            } else {
                queue.push(topLevelObject);
            }

            return queue;
        };
        var _getActivePopupFlex = function(flexPopupModals) {
            var activePopup = flexPopupModals[0], i;

            if(flexPopupModals.length > 1) {
                for(i = 1; i < flexPopupModals.length; i++) {
                    if(activePopup.zIndex[1] <= flexPopupModals[i].zIndex[1]) {
                        activePopup = flexPopupModals[i];
                    }
                }
            }

            return activePopup;
        };
        var _getPopupPossibleFlexes = function(flexModals) {
            var possiblePopups = [], i, indexLength = flexModals[0].zIndex.length - 1;

            if(flexModals.length > 1) {

                
                flexModals.sort(function (a, b) {
                    a = a.zIndex[indexLength];
                    b = b.zIndex[indexLength];
                    if (a > b) {
                        return -1;
                    } else {
                        return 1;
                    }
                });

                
                for(i = 0; i < flexModals.length; i++) {
                    possiblePopups.push(flexModals[i]);
                    if(flexModals[i].model.isModalContainer) {
                        break;
                    }
                }

                
                possiblePopups.sort(function (a, b) {
                    a = a.path[indexLength];
                    b = b.path[indexLength];
                    if (a <= b) {
                        return -1;
                    } else {
                        return 1;
                    }
                });
            } else {
                possiblePopups = flexModals;
            }

            return possiblePopups;
        };
        var _isContainerVisible = function(widgetModel) {
            var isContainerVisible = false, activePopup;

            if($KW.FlexUtils.canContainFlexModel(widgetModel) && widgetModel.isVisible) {
                isContainerVisible = true;
            }
            return isContainerVisible;
        };
        var _searchHighestIndexedElement = function(formModel) {
            var queue = [{model: formModel, path: [0], zIndex: [0]}], flexObject, path, zIndex,
                parent, child, children, currentChildModel, popupModals = [], tempList, flexPopupNode;

            while(queue.length > 0) {
                parent = _dequeue(queue);
                children = $KW.Utils.getActualWidgetModel(parent.model).widgets();
                tempList = [];

                for(child = 0; child < children.length; child++) {
                    currentChildModel = children[child];
                    if(_isContainerVisible(currentChildModel)) {
                        path = parent.path.slice(0);
                        path.push(child);
                        zIndex = parent.zIndex.slice(0);
                        zIndex.push(currentChildModel.zIndex);
                        flexObject = {
                            model: currentChildModel,
                            path: path,
                            zIndex: zIndex
                        };

                        tempList.push(flexObject);

                        if(currentChildModel.wType === 'FlexContainer' && currentChildModel.isModalContainer) {
                            popupModals.push(flexObject);
                        }
                    }
                }
                if(tempList.length > 0) {
                    tempList = _getPopupPossibleFlexes(tempList);
                    queue = _enqueue(queue, tempList);
                }
            }
            return popupModals;
        };

        if(!formModel.topLayerFCModal) {
            
            nodes = $KU.getNonFlexModalNodes(formModel);
            $KU.setFlexModalAttribute(nodes, false);
            flexPopupModals = _searchHighestIndexedElement(formModel);

            if(flexPopupModals.length > 0) {
                activePopup = _getActivePopupFlex(flexPopupModals);
            }
            if(activePopup) {
                formModel.topLayerFCModal = activePopup.model;
            }
        }

        if(formModel.topLayerFCModal) {
            
            nodes = $KU.getNonFlexModalNodes(formModel);
            $KU.setFlexModalAttribute(nodes, true);
        }

        return formModel.topLayerFCModal;
    },

    
    nodeIterator: function(parentNode, widgetNodes, popupModalID) {
        var children = parentNode.children, i = 0, childLength = children.length,
            currentChild;

        for(i = 0; i < childLength; i++) {
            currentChild = children[i];
            if(currentChild.id !== popupModalID) {
                if(currentChild.getAttribute('kwidgettype') && currentChild.getAttribute('kwidgettype') !== "GridNode") {
                    widgetNodes.push(currentChild);
                }
                if(currentChild.children && currentChild.children.length > 0) {
                    $KU.nodeIterator(currentChild, widgetNodes, popupModalID);
                }
            }
        }
    },

    getNonFlexModalNodes: function(formModel) {
        var currentChild, i, id = formModel.id,
            widgetNodes = [], formNode = document.getElementById(id),
            popupModalID =$KU.getPopupModalID(formModel);

        if(formNode) {
            $KU.nodeIterator(formNode, widgetNodes, popupModalID);
        }

        return widgetNodes;
    },

    getPopupModalID: function(formModel) {
        return formModel.topLayerFCModal ? $KW.Utils.getKMasterWidgetID(formModel.topLayerFCModal) : null;
    },

    setFlexModalAttribute: function(nodes, value) {
        var i, nodeCount = nodes.length;

        for(i = 0; i < nodeCount; i++) {
            $KU.setDisabledProperty(nodes[i], 'notinmodal', 'readonly', value);
        }
    },

    shouldRemoveDisabled: function(node) {
        var shouldRemove = true;

        if((node.getAttribute('kdisabled') && (node.getAttribute('kdisabled')) === "true") || node.getAttribute('notinmodal')) {
            shouldRemove = false;
        }
        return shouldRemove;
    },

    setDisabledProperty: function(node, konyAttribute, htmlAttribute, value, widgetModel) {
        var _getClonedModelByNode = function(widgetModel, widgetNode) {
            var containerId = widgetNode.getAttribute("kcontainerID");

            if(containerId) {
                widgetModel = $KW.Utils.getClonedModelByContainer(widgetModel, widgetNode, containerId);
            }
            return widgetModel;
        };
        var widgettype = node.getAttribute('kwidgettype'), aEle,
            i, attributeFunction = value ? 'setAttribute' : 'removeAttribute', 
            widgetModel = widgetModel || $KU.getModelByNode(node),
            propertyValue, tabHeader, id, removeDisabled;

        widgetModel = _getClonedModelByNode(widgetModel, node);

        
        node[attributeFunction](konyAttribute, value);

        removeDisabled = $KU.shouldRemoveDisabled(node);

        if(konyAttribute === 'kdisabled') {
            widgetModel.disabled = value;
        }

        
        if($KU.isWindowsPhone && $KU.isIE9 && node.tagName === 'SELECT'
        && (removeDisabled || value)) {
            for(i = 0; i < node.childNodes.length; i++) {
                node.children[i].disabled = value;
            }
        }

        
        var widgetlist = ['Label', 'FlexContainer', 'FlexScrollContainer'];
        if((widgetlist.indexOf(widgettype)) == -1) {
            if(value || removeDisabled) {
                node.disabled = value;
            }
        }


        
        if(widgettype === 'RichText') {
            aEle = document.querySelectorAll("#" + node.id + " a");
        }

        if(widgettype == "RichText" && aEle.length && value) {
            node.ishref = true;
            node.innerHTML = node.innerHTML.replace(/href=["'].*?["']/g, "href='javascript:void(0)'");
        } else if(node.ishref) {
            node.innerHTML = widgetModel.text;
        }

        
        if((widgettype == "RadioButtonGroup" || widgettype == "CheckBoxGroup") && node.tagName == "INPUT" && widgetModel.itemorientation == "vertical") {
            node.parentNode[attributeFunction](konyAttribute, value);
        }

        if(widgetModel && widgetModel.wType == "Label") {
            propertyValue = !!(!value && widgetModel.textCopyable) ? "text" : "none";
            if('MozUserSelect' in node.style) {
                node.style.MozUserSelect = propertyValue;
            } else if('webkitUserSelect' in node.style) {
                node.style.webkitUserSelect = propertyValue;
            } else if('msUserSelect' in node.style) {
                node.style.msUserSelect = propertyValue;
            }
        }

        if(widgettype == "Video") {
            if(!value && removeDisabled) {
                node.oncontextmenu = "";
                node.playing && node.paused && node.play();
                if(widgetModel.controls)
                    node.setAttribute("controls", "controls");
            } else {
                node.playing && node.pause();
                node.removeAttribute("controls");
                node.oncontextmenu = function() {
                    return false
                };
            }
        }

        
        if(widgetModel && widgetModel.wType === "Map"
        && (node.getAttribute("kwidgettype") === "Map"
        || node.getAttribute("kwidgettype") === "googlemap")) {
            if(removeDisabled || value) {
                if(konyAttribute === 'kdisabled') {
                    widgetModel.disabled = value;
                }
                $KW.Map.setEnabledMap(widgetModel, node);
            }
        }
    },

    checkAndReCalculateTopFlexModal: function(widgetModel, formModel) {
        var checkRequired = $KW.FlexUtils.canContainFlexModel(widgetModel);

        formModel = formModel || $KG.allforms[widgetModel.pf];
        if(checkRequired && formModel) {
            if(document.getElementById(formModel.id)) {
                formModel.topLayerFCModal = null;
                $KU.deduceTopLevelFlexModal(formModel);
            }
        }
    },

    getWidgetVisibleIndex: function(containerModel, widgetModel) {
        var childCount = containerModel.children.length;
        var counter = 0, i=0, childModel;

        for(i = 0; i < childCount; i++) {
            childModel = containerModel[containerModel.children[i]];
            if(childModel.id == widgetModel.id ) {
                break;
            }

            if(childModel._isRendered == true) {
                counter ++;
            }
        }
        return counter;
    },

    getLocalStorage: function() {
        var store = null,
            data = localStorage.getItem($KG.appid);

        if(typeof data === 'string' && data) {
            try {
                store = JSON.parse(data);
            } catch(e) {
                store = data;
            }
        }

        return store;
    },

    createBlankLocalStorage: function() {
        return {
            migrated: false,
            data: []
        };
    },

    callTargetEventHandler: function(wModel, target, eventType) {
        var containerId = target.getAttribute("kcontainerID");
        if(containerId) {
            $KW.Utils.updateContainerData(wModel, target, false, eventType);
        } else {
            var eventref = $KU.returnEventReference(wModel[eventType]);
            eventref && $KU.executeWidgetEventHandler(wModel, eventref);
        }
    },

    getAllDefaults: function(widget) {
        return kony.defaults.getAllDefaults(widget);
    },

    mergeProperties: function(baseConfig, finalObj, prop) {
        var value = baseConfig[prop];
        if(value && typeof value == "object" && !value.wType) {
            finalObj[prop] = finalObj[prop] || {};
            for(var key in value) {
                $KU.mergeProperties(value, finalObj[prop], key);
            }
        } else {
            finalObj[prop] = value;
        }
    },

    mergeDefaults: function(baseConfig, defaultValuesObject) {
        var finalObj = owl.deepCopy(defaultValuesObject);
        if(baseConfig instanceof Object) {
            for(var prop in baseConfig) {
                if(baseConfig.hasOwnProperty(prop)) {
                    if(typeof finalObj[prop] == "undefined" || finalObj[prop] == null || $KU.isArray(finalObj[prop]))
                        finalObj[prop] = baseConfig[prop];
                    else
                        $KU.mergeProperties(baseConfig, finalObj, prop);
                }
            }
        }

        if(typeof finalObj["id"] == 'undefined' || finalObj["id"] == null) {
            finalObj["id"] = "konyRandomId" + ($KG["uniqueId"]++);
        }

        return finalObj;
    },

    equals: function(arg1, arg2) {
        if(Object.prototype.toString.call(arg1) !== Object.prototype.toString.call(arg2)) {
            return false;
        } else if(Object.prototype.toString.call(arg1) === '[object Array]') {
            if(arg1.length !== arg2.length) {
                return false;
            }
            for(var i = 0; i < arg2.length; i++) {
                if(!$KU.equals(arg1[i], arg2[i])) {
                    return false;
                }
            }
            return true;
        } else if(Object.prototype.toString.call(arg1) === '[object Object]') {
            for(var k in arg2) {
                if(Object.prototype.toString.call(arg2[k]) !== '[object Function]') {
                    if(!$KU.equals(arg1[k], arg2[k])) {
                        return false;
                    }
                }
            }
            return true;
        } else if(Object.prototype.toString.call(arg2) !== '[object Function]') {
            return(arg1 === arg2);
        }
    },

    isMouseEventSupported: function() {
        var flag = false;

        try {
            document.createEvent("MouseEvent");
            flag = true;
        } catch(e) {
            flag = false;
        }

        return flag;
    },

    isArray: function(value) {
        return(Object.prototype.toString.call(value) === '[object Array]');
    },

    addArray: function(srcArray, targetArray) {
        srcArray.push.apply(srcArray, targetArray);
        return srcArray;
    },

    arrayIndex: function(arr, val) {
        for(var i = 0; i < arr.length; i++) {
            if($KU.equals(arr[i], val)) {
                return i;
            }
        }
        return -1;
    },

    inArray: function(array, elem, noindex) {
        var index = -1;
        if(array) {
            index = $KU.arrayIndex(array, elem);
        }
        if(noindex) {
            return(index == -1) ? false : true;
        } else {
            return(index == -1) ? [false, -1] : [true, index];
        }
    },

    removeArray: function(arr) {
        var what, a = arguments,
            L = a.length,
            ax;
        while(L > 1 && arr && arr.length) {
            what = a[--L];
            while((ax = arr.indexOf(what)) != -1) {
                arr.splice(ax, 1);
            }
        }
        return arr;
    },

    joinArray: function(arr, seperator) {
        seperator = seperator || ",";
        return arr[1 + IndexJL] + seperator + arr[2 + IndexJL] + seperator + arr[3 + IndexJL] + seperator + arr[0 + IndexJL];
    },

    mergeObjects: function(target, source) {
        var target = target || {};
        var empty = {};
        if(source) {
            var name, s;
            for(name in source) {
                s = source[name];
                if(empty[name] !== s) {
                    target[name] = s;
                }
            }
        }
        return target;
    },

    convertObjectToArray: function(obj) {
        var arr = [];
        for(var key in obj) {
            arr[key] = obj[key];
        }
        return arr;
    },

    getkeys: function(anobject) {
        return(Object.keys && Object.keys(anobject)) || (function() {
            var keylist = [];
            for(var i in anobject) {
                keylist.push(i);
            }
            return keylist;
        }());
    },

    getKey: function(obj, value) {
        for(var key in obj) {
            if(obj[key] === value) return key;
        }
    },

    adjustNodeIndex: function(node, startIndex, attr) { 
        var rows = node.childNodes;
        startIndex = startIndex - IndexJL;
        startIndex = (rows.length > startIndex) ? startIndex : (rows.length - 1);
        if(rows && rows.length > 0) {
            for(var i = startIndex; i < rows.length; i++) {
                rows[i].setAttribute(attr, i + IndexJL);
            }
        }
    },

    toggleVisibilty: function(node, data, model, needWidgetNode) {
        var isFlexWidget = $KW.FlexUtils.isFlexWidget(model);
        if(needWidgetNode != false) {
            if(isFlexWidget || (model.wType == 'Segment' && model.viewtype === constants.SEGUI_VIEW_TYPE_PAGEVIEW))
                node = node.parentNode;
        }
        if(data && data.length > 0 && model.isvisible) {
            this.removeClassName(node, "hide");
        } else {
            this.addClassName(node, "hide");
        }
    },

    
    removeClassNames: function(elem, selector) {
        
    },

    addClassNames: function(elem, selector) {
        
    },

    removeClassName: function(elem, selector) {
        if(elem.classList && selector) {
            elem.classList.remove(selector);
        } else if($KU.hasClassName(elem, selector)) {
            var className = elem.className;
            elem.className = className.replace(new RegExp("(^|\\s+)" + selector + "(\\s+|$)"), ' ');
        }
    },

    hasClassName: function(elem, className) {
        return(elem.classList && className) ? elem.classList.contains(className) : (elem.className.length > 0 && (elem.className == className || new RegExp("(^|\\s)" + className + "(\\s|$)").test(elem.className)));
    },

    addClassName: function(elem, className) {
        if(elem.classList && className) {
            elem.classList.add(className);
        } else if(!$KU.hasClassName(elem, className))
            elem.className += (elem.className ? ' ' : '') + className;
    },

    getElementById: function(id, doc) {
        return(typeof id == "string") ? ((doc || document).getElementById(id) || null) : null;
    },

    getPosition: function(el, popupModel) {
        var left = 0,
            top = 0,
            box = el.getBoundingClientRect();

        if(box) {
            left = box.left;
            top = box.top;
        }

        
        if(!(popupModel && popupModel.ismodal)) {
            if(window.pageYOffset) {
                left += window.pageXOffset;
                top += window.pageYOffset;
            } else if(el.ownerDocument.documentElement.scrollTop) {
                left += el.ownerDocument.documentElement.scrollLeft;
                top += el.ownerDocument.documentElement.scrollTop;
            } else if(document.body.scrollTop) {
                left += document.body.scrollLeft;
                top += document.body.scrollTop;
            }
        }

        if(el.ownerDocument.documentElement.clientTop) {
            left -= el.ownerDocument.documentElement.clientLeft;
            top -= el.ownerDocument.documentElement.clientTop;
        } else if(document.body.clientTop) {
            left -= document.body.clientLeft;
            top -= document.body.clientTop;
        }

        return {
            top: top,
            left: left,
            bottom: top + el.offsetHeight,
            right: left + el.offsetWidth,
            width: el.offsetWidth,
            height: el.offsetHeight
        };
    },

    getAnchorPosition: function(widgetModel, anchorElement, contextWidgetNode) {
        var widgetContext = widgetModel.context;
        var leftPos = 0,
            topPos = 0;
        var bodyWidth = document.getElementsByTagName("body")[0].offsetWidth;
        var bodyHeight = document.getElementsByTagName("body")[0].offsetHeight;
        var bodyAlign = document.getElementsByTagName("body")[0].getAttribute("bodyalign");
        var screenDelta = screen.width - bodyWidth;
        var contextElementPosition = 0;
        if(contextWidgetNode) {
            contextElementPosition = $KU.getPosition(contextWidgetNode);
        } else {
            if(widgetContext.widget.wType == 'Form') {
                contextElementPosition = $KU.getPosition(document.getElementById(widgetContext.widget.id));
            } else {
                contextElementPosition = $KU.getPosition($KU.getNodeByModel(widgetContext.widget, widgetModel));
            }
        }

        if(!bodyAlign)
            bodyAlign = "left";
        if(widgetContext.anchor == "bottom") {
            if((contextElementPosition.bottom + anchorElement.offsetHeight > bodyHeight) && (widgetModel.wType != "Calendar"))
                topPos = contextElementPosition.bottom - (contextElementPosition.bottom + anchorElement.offsetHeight - bodyHeight);
            else
                topPos = contextElementPosition.bottom;

            if(contextElementPosition.left + anchorElement.offsetWidth > bodyWidth)
                leftPos = 0;
            else
                leftPos = contextElementPosition.left;
        }
        if(widgetContext.anchor == "top") {
            if(contextElementPosition.top - anchorElement.offsetHeight < 0)
                topPos = 0;
            else
                topPos = contextElementPosition.top - anchorElement.offsetHeight;

            if(contextElementPosition.left + anchorElement.offsetWidth > bodyWidth)
                leftPos = 0;
            else
                leftPos = contextElementPosition.left;
        }
        if(widgetContext.anchor == "left") {
            if(contextElementPosition.top + anchorElement.offsetHeight > bodyHeight)
                topPos = contextElementPosition.top - (contextElementPosition.top + anchorElement.offsetHeight - bodyHeight);
            else
                topPos = contextElementPosition.top;

            if(bodyAlign == "left") {
                if(contextElementPosition.left - anchorElement.offsetWidth < 0) {
                    leftPos = 0;
                } else {
                    leftPos = contextElementPosition.left - anchorElement.offsetWidth;
                }
            }

            if(bodyAlign == "center") {
                if(contextElementPosition.left - anchorElement.offsetWidth < screenDelta / 2) {
                    leftPos = screenDelta / 2;
                } else {
                    leftPos = contextElementPosition.left - anchorElement.offsetWidth;
                }
            }

            if(bodyAlign == "right") {
                if(contextElementPosition.left - anchorElement.offsetWidth < screenDelta) {
                    leftPos = 0;
                } else {
                    leftPos = contextElementPosition.left - anchorElement.offsetWidth - screenDelta;
                }
            }
        }
        if(widgetContext.anchor == "right") {
            if(contextElementPosition.top + anchorElement.offsetHeight > bodyHeight)
                topPos = contextElementPosition.top - (contextElementPosition.top + anchorElement.offsetHeight - bodyHeight);
            else
                topPos = contextElementPosition.top;

            if(bodyAlign == "left") {
                if(contextElementPosition.left + contextElementPosition.width + anchorElement.offsetWidth > bodyWidth) {
                    leftPos = contextElementPosition.left + contextElementPosition.width - (contextElementPosition.left + contextElementPosition.width + anchorElement.offsetWidth - bodyWidth);
                } else {
                    leftPos = contextElementPosition.left + contextElementPosition.width;
                }
            }
            if(bodyAlign == "center") {
                if(contextElementPosition.left + contextElementPosition.width + anchorElement.offsetWidth > bodyWidth + screenDelta / 2) {
                    leftPos = contextElementPosition.left + contextElementPosition.width - (contextElementPosition.left + contextElementPosition.width + anchorElement.offsetWidth - bodyWidth);
                    leftPos = leftPos + screenDelta / 2;
                } else {
                    leftPos = contextElementPosition.left + contextElementPosition.width;
                }
            }
            if(bodyAlign == "right") {

                if(contextElementPosition.left + contextElementPosition.width + anchorElement.offsetWidth > bodyWidth + screenDelta) {
                    leftPos = contextElementPosition.left + contextElementPosition.width - (contextElementPosition.left + contextElementPosition.width + anchorElement.offsetWidth - bodyWidth);
                } else {
                    leftPos = contextElementPosition.left + contextElementPosition.width - screenDelta;
                }
            }
        }

        return {
            leftPos: leftPos,
            topPos: topPos
        };
    },

    getNodeByModel: function(model) {
        if(model) {
            if(model.isCloned == true && model.kuid) {
                return document.querySelector("*[kuid = '"+model.kuid+"']");
            }
            if(model.kmasterid) {
                return document.getElementById(model.pf + "_" + model.kmasterid + "_" + model.id);
            }
            var widgetTabId = model.tabId || "";
            if(widgetTabId)
                return document.getElementById(model.pf + "_" + widgetTabId + "_" + model.id);
            else
                return document.getElementById(model.pf + "_" + model.id) || document.getElementById(model.id);
        } else {
            return null;
        }
    },

    getElementID: function(id, isheader) {
        return(id && typeof id == "string") ? (isheader ? id.substring(id.lastIndexOf("_") + 1, id.length) : id.substring(id.indexOf("_") + 1, id.length)) : null;
    },

    getModelByNode: function(target) {
        if(target.getAttribute("kmasterid")) {
            return this.getWidgetModelByID(target.getAttribute("id")); 
        }
        var widgetID = (target && target.getAttribute("id") && target.getAttribute("id").split("_").length == 3) ? this.getElementID(target.getAttribute("id"), true) : this.getElementID(target.getAttribute("id"));

        if(target.getAttribute('kwidgettype') == "CalendarText") {
            widgetID = target.id.split("_")[0];
        }
        var tabPaneID = target.getAttribute("ktabpaneid");
        var formID = target.getAttribute("kformname");
        var tabID = target.getAttribute("ktabid")
        return kony.model.getWidgetModel(formID, widgetID, tabPaneID, tabID);
    },
    getModelByScroller: function(_scroller) {
        var srollbox = _scroller.substring(0, _scroller.lastIndexOf("_"));
        var scrollboxNode = $KU.getElementById(srollbox);
        return $KU.getModelByNode(scrollboxNode);
    },

    getNextSibling: function(node) {
        var x = node.nextSibling;
        while(x.nodeType != 1) {
            x = x.nextSibling;
        }
        return x;
    },

    
    getWidgetModelByID: function(targetID) {
        if(!targetID) return;
        var strArr = targetID.split("_");
        var childModel = kony.model.getWidgetRef(strArr.shift());
        while(strArr.length > 0) {
            childModel = $KW.Utils.getActualWidgetModel(childModel);
            childModel = childModel[strArr.shift()];
        }
        return childModel;
    },

    checkHeaderFooterTemplate: function(formModel, flexModel) {
        if(formModel.headers) {
            for(var list = 0; list < formModel.headers.length; list++) {
                if(flexModel.id == formModel.headers[list].id) {
                    return true;
                }
            }
        }
        if(formModel.footers) {
            for(var list = 0; list < formModel.footers.length; list++) {
                if(flexModel.id == formModel.footers[list].id) {
                    return true;
                }
            }
        }
        return false;
    },

    updatei18nProperties: function(wArray) {
        for(var model in wArray) {
            var widgetref = wArray[model];
            $KI.i18n && $KI.i18n.translateFormModel(widgetref);
        }
    },

    applyFade: function(elem, trans, dur) {
        elem.style[$KU.animationDuration] = dur + "ms";
        elem.style[$KU.animationName] = trans;
        if(trans == "fadeIn")
            elem.style.display = "";
        else {
            elem.style.display = "none";
            elem.style[$KU.animationName] = "none";
        }
    },

    getParentByAttribute: function(node, attribute) {
        var cur = node;
        while(cur) {
            var type = cur.getAttribute && cur.getAttribute(attribute);
            if(type) {
                return cur;
            }
            cur = cur.parentNode;
        }
    },

    getParentByAttributeValue: function(node, attribute, value) {
        var cur = node;
        while(cur) {
            var type = cur.getAttribute && cur.getAttribute(attribute);
            if(type == value) {
                return cur;
            }
            cur = cur.parentNode;
        }
    },

    getParentByTagName: function(node, localName) {
        while(node && (node.nodeType != 1 || node.nodeName.toLowerCase() != localName)) {
            node = node.parentNode;
        }
        return node;
    },

    getParentModel: function(childModel) {
        return childModel.parent;
    },

    getContainerForm: function(node) {
        var containerId = node.getAttribute("kcontainerid");
        if(containerId) {
            var cur = node;
            var id;
            while(cur) {
                id = cur.id && cur.id.split("_")[1];
                if(id == containerId && cur.getAttribute("kformname")) {
                    return cur.getAttribute("kformname");
                }
                cur = cur.parentNode;
            }
        } else {
            var formName = node.getAttribute("kformname");
            if(formName) {
                var topModel = kony.model.getWidgetRef(formName); 
                if(topModel.wType == 'Form') {
                    return formName;
                } else { 
                    var topNode = $KU.getNodeByModel(topModel);
                    return topNode.parentNode.getAttribute("kformname");
                }
            }
        }
        return "";
    },

    cloneObj: function(srcInstance) {
        if(typeof(srcInstance) != "object" || srcInstance == null)
            return srcInstance;
        var newInstance = srcInstance.constructor();
        for(var i in srcInstance) {
            if(srcInstance.hasOwnProperty(i))
                newInstance[i] = this.cloneObj(srcInstance[i]);
        }
        return newInstance;
    },

    
    invokeAddWidgets: function(widget) {
        if(!widget.addWidgetsdone) {
            widget.addWidgetsdone = true;
            widget.ownchildrenref = [];
            widget.children = [];
            if(widget.addWidgets) {
                if(typeof widget.addWidgets == "string") {
                    window[widget.addWidgets](widget);
                } else if(typeof widget.addWidgets == "function") {
                    widget.addWidgets(widget);
                }
            }
        }
    },

    
    invokeWidgetInit: function(widget) {
        !widget.initdone && widget.init && $KU.executeWidgetEventHandler(widget, widget.init);
        widget.initdone = true;
    },

    returnEventReference: function(eventObj) {
        return typeof(eventObj) == 'function' ? eventObj : (typeof(eventObj) == 'string' ? window[eventObj] : undefined);
    },

    returnObjectReference: function(obj) {
        return typeof(obj) == 'object' ? obj : (typeof(obj) == 'string' ? window[obj] : undefined);
    },

    
    getStringFromBase64: function(s) {
        var e = {},
            i, b = 0,
            c, x, l = 0,
            a, r = '',
            w = String.fromCharCode,
            L = s.length;
        var A = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
        for(i = 0; i < 64; i++) {
            e[A.charAt(i)] = i;
        }
        for(x = 0; x < L; x++) {
            c = e[s.charAt(x)];
            b = (b << 6) + c;
            l += 6;
            while(l >= 8) {
                ((a = (b >>> (l -= 8)) & 0xff) || (x < (L - 2))) && (r += w(a));
            }
        }
        return r;
    },

    
    getDecodedPropValue: function(propValue) {
        if(!(propValue.substr(0, 1) == "{")) {
            propValue = $KU.getStringFromBase64(propValue);
        }
        return propValue;
    },

     konyRawBytes: function(rawBytes, type) {
        this.rawBytes = rawBytes;
        this.type = type;
    },

    getBase64: function(data) {
        
        
        
        
        
        
        
        if(data instanceof kony.utils.konyRawBytes) {
            if(data.type == "utf8") {
                return btoa(data.rawBytes);
            }
        }

        if(!data) return data;

        if(typeof data != "string") {
            return data;
        }

        if('btoa' in window)
            return window.btoa(unescape(encodeURIComponent(data)));

        var b64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
        var o1, o2, o3, h1, h2, h3, h4, bits, i = 0,
            ac = 0,
            enc = "",
            tmp_arr = [];

        do { 
            o1 = data.charCodeAt(i++) & 0xff;
            o2 = data.charCodeAt(i++) & 0xff;
            o3 = data.charCodeAt(i++) & 0xff;

            bits = o1 << 16 | o2 << 8 | o3;

            h1 = bits >> 18 & 0x3f;
            h2 = bits >> 12 & 0x3f;
            h3 = bits >> 6 & 0x3f;
            h4 = bits & 0x3f;

            tmp_arr[ac++] = b64.charAt(h1) + b64.charAt(h2) + b64.charAt(h3) + b64.charAt(h4);
        } while (i < data.length);

        enc = tmp_arr.join('');

        switch(data.length % 3) {
            case 1:
                enc = enc.slice(0, -2) + '==';
                break;
            case 2:
                enc = enc.slice(0, -1) + '=';
                break;
        }

        return enc;
    },

    
    isValidDate: function(dtStr, format) {
        var dEY = {};
        dtStr = dtStr.split('/');
        format = format.split('/');
        for(var i = 0, l = format.length; i < l; i++) {
            dEY[format[i]] = dtStr[i];
        }
        var date = new Date(dEY.yyyy || ((dEY.yy * 1) + 2000), dEY.mm - 1, dEY.dd);
        if(Object.prototype.toString.call(date) === "[object Date]" && (date.getFullYear() == (dEY.yyyy || ((dEY.yy * 1) + 2000)) && date.getFullYear() >= 1900 && date.getFullYear() <= 2100 && date.getMonth() + 1 == dEY.mm && date.getDate() == dEY.dd)) {
            return true;
        } else {
            return false;
        }
    },

    daysArray: function(n) {
        var y = new Date().getFullYear();
        for(var i = 1; i <= n; i++) {
            this[i] = new Date(y, n, 0).getDate();
        }
        return this;
    },

    daysInFebruary: function(year) {
        return new Date(year, 2, 0).getDate();
    },

    isInteger: function(s) {
        var i;
        for(i = 0; i < s.length; i++) {
            
            var c = s.charAt(i);
            if(((c < "0") || (c > "9")))
                return false;
        }
        
        return true;
    },

    getInt: function(i) {
        var n = parseInt(i);
        return n == null || isNaN(n) ? 0 : n;
    },

    getDate: function(date, format) {
        var dateObj;
        if(typeof date === "string" && typeof format === "string") {
            var dateParts = date.split("/");
            var yr = new Date().getFullYear().toString().substr(0, 2);
            if(format.indexOf("yyyy") == -1 || dateParts[2].length == 2)
                dateParts[2] = yr + dateParts[2];

            if(format == "mm/dd/yyyy" || format == "mm/dd/yy")
                dateObj = new Date(dateParts[0] + "/" + dateParts[1] + "/" + dateParts[2]);
            else
                dateObj = new Date(dateParts[1] + "/" + dateParts[0] + "/" + dateParts[2]);

            return dateObj;
        }
    },

    getDayOfYear: function(day, month, year) {
        return(Math.ceil((new Date(year, month - 1, day) - new Date(year, 0, 1)) / 86400000)) + 1;
    },

    
    getIntegerDirection: function(strDirection) {
        switch(strDirection) {
            case "LEFT":
                return 1;
            case "RIGHT":
                return 2;
            case "UP":
                return 3;
            case "DOWN":
                return 4;
        }
    },

    getSwipeDirection: function(deltaX, deltaY) {
        
        var radians = Math.atan2(-deltaY, -deltaX); 
        var angle = Math.round(radians * 180 / Math.PI); 

        
        if(angle < 0)
            angle = 360 - Math.abs(angle);

        var direction;

        if((angle <= 45) && (angle >= 0))
            direction = $KW.touch.TouchContext.LEFT;
        else if((angle <= 360) && (angle >= 315))
            direction = $KW.touch.TouchContext.LEFT;
        else if((angle >= 135) && (angle <= 225))
            direction = $KW.touch.TouchContext.RIGHT;
        else if((angle > 45) && (angle < 135))
            direction = $KW.touch.TouchContext.UP;
        else
            direction = $KW.touch.TouchContext.DOWN;

        return direction;
    },

    getDistanceMoved: function(deltaX, deltaY) {
        var absDeltaX = Math.abs(deltaX);
        var absDeltaY = Math.abs(deltaY);
        return(Math.round(Math.sqrt(Math.pow(absDeltaX, 2) + Math.pow(absDeltaY, 2))));
    },

    isMobile: function() {
        if(navigator.userAgent.match(/Mobile/i) && (navigator.userAgent.match(/AppleWebKit/i) || navigator.userAgent.match(/Phone/i))) {
            return true;
        }
    },

    getPlatform: function() {
        if(!$KU.platform) {
            var platform = {};
            platform.name = $KU.getPlatformName();
            platform.version = $KU.getPlatformVersion(platform.name);
            platform.deviceOSType = $KU.getPlatformDeviceOS();
            platform.deviceOSVersion = $KU.getPlatformDeviceOSVersion(platform.deviceOSType);
            $KU.platform = platform
        }
        return $KU.platform;
    },


    getDeviceId: function() {
        var id = '', store = null, data = null;

        function generateGUID() {
            var guid = '';

            if(window.crypto) {
                guid = ([1e7]+-1e3+-4e3+-8e3+-1e11).replace(/[018]/g, function (c) {
                    return (c ^ crypto.getRandomValues(new Uint8Array(1))[0] & 15 >> c / 4).toString(16);
                });
            } else {
                guid = new Date().getTime();

                if(window.performance && typeof performance.now === 'function') {
                    guid += performance.now();
                }

                guid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
                    var r = (guid + Math.random() * 16) % 16 | 0;

                    guid = Math.floor(guid / 16);

                    return (c === 'x' ? r : (r & 0x3 | 0x8)).toString(16);
                });
            }

            return guid.toUpperCase();
        }

        if(window.localStorage && typeof localStorage.getItem === 'function') {
            data = localStorage.getItem($KG.appid);

            if(typeof data === 'string' && data) {
                try {
                    store = JSON.parse(data);
                } catch(e) {
                    store = data;
                }
            }

            if(typeof store === 'object' && store) {
                if(typeof store.deviceId === 'string' && store.deviceId) {
                    id = store.deviceId;
                } else {
                    store.deviceId = id = generateGUID();
                    localStorage.setItem($KG.appid, JSON.stringify(store));
                }
            }
        } else if(typeof $KG.appid === 'string' && $KG.appid) {
            id = generateGUID();
        }

        return id;
    },

    generateKUID: function() {
        var guid = '';

        if(window.crypto) {
            guid = ([1e7]+-1e3+-4e3+-8e3+-1e11).replace(/[018]/g, function (c) {
                return (c ^ crypto.getRandomValues(new Uint8Array(1))[0] & 15 >> c / 4).toString(16);
            });
        } else {
            guid = new Date().getTime();

            if(window.performance && typeof performance.now === 'function') {
                guid += performance.now();
            }

            guid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
                var r = (guid + Math.random() * 16) % 16 | 0;

                guid = Math.floor(guid / 16);

                return (c === 'x' ? r : (r & 0x3 | 0x8)).toString(16);
            });
        }

        return guid.toUpperCase();
    },

    getPlatformName: function() {
        if(kony.appinit.isIE)
            return "IE";
        if(kony.appinit.isFirefox)
            return "Firefox";
        if(kony.appinit.isChrome)
            return "Chrome";
        if(kony.appinit.isSafari)
            return "Safari";
        if(kony.appinit.isOpera)
            return "Opera";
        if(kony.appinit.isEdge)
            return "Edge";
        else
            return "";
    },

    getPlatformVersion: function(name) {
        var ver = "";
        var userAgent = navigator.userAgent;
        switch(name) {
            case "IE":
                userAgent.match(/MSIE ([0-9]+)/) || userAgent.match(/rv:(\d+)/);
                ver = RegExp.$1;
                break;
            case "Firefox":
                userAgent.match(/Firefox[\/\s](\d+\.\d+)/);
                ver = RegExp.$1;
                break;
            case "Chrome":
                userAgent.match(/Chrome\/([0-9]+)/);
                ver = RegExp.$1;
                break;
            case "Safari":
            case "Opera":
                userAgent.match(/Version\/(\d+\.\d+)/);
                ver = RegExp.$1;
                break;
            case "Edge":
                userAgent.match(/Edge\/(\d+\.\d+)/);
                ver = RegExp.$1;
                break;
            default:
                ver = 0;
        }
        return ver;
    },

    getPlatformDeviceOS: function() {
        if(navigator.userAgent.indexOf('Android') >= 0) {
            return constants.DEVICE_OSNAME_ANDROID;
        }
        if(navigator.userAgent.indexOf('Android') >= 0 && !(navigator.userAgent.indexOf('mobile') >= 0)) {
            return constants.DEVICE_OSNAME_ANDROIDTABLET;
        }
        if(navigator.userAgent.indexOf('iPhone') >= 0) {
            return constants.DEVICE_OSNAME_IPHONE;
        }
        if(navigator.userAgent.indexOf('iPad') >= 0) {
            return constants.DEVICE_OSNAME_IPAD;
        }
        if(navigator.userAgent.indexOf('Macintosh') >= 0) {
            return constants.DEVICE_OSNAME_MACINTOSH;
        }
        if(navigator.userAgent.indexOf('Windows NT') >= 0 && !kony.appinit.isWindowsTablet) {
            return constants.DEVICE_OSNAME_WINDOWS;
        } else if (kony.appinit.isWindowsTablet) {
            return constants.DEVICE_OSNAME_WINDOWSTABLET;
        }
        if(navigator.userAgent.indexOf('Windows Phone') >=0 && !(navigator.userAgent.indexOf('Android') >= 0)) {
            return constants.DEVICE_OSNAME_WINDOWPHONE;
        }
        if((navigator.userAgent.indexOf('X11') >= 0) || ((navigator.userAgent.indexOf('Linux') >= 0) && !(navigator.userAgent.indexOf('Android') >= 0))) {
            return constants.DEVICE_OSNAME_LINUX;
        }
        if(kony.appinit.isBlackBerryNTH) {
            return constants.DEVICE_OSNAME_BLACKBERRYNTH;
        }
        if(kony.appinit.isBlackBerry || kony.appinit.isPlaybook) {
            return constants.DEVICE_OSNAME_BLACKBERRY;
        }
        return "";
    },

    getPlatformDeviceOSVersion: function(name) {
        var ver = "";
        var winOS = {
            '10.0': '10',
            '6.3': '8.1',
            '6.2': '8',
            '6.1': '7',
            '6.0': 'vista',
            '5.1': 'windows XP'
        }
        var userAgent = navigator.userAgent;
        switch(name) {
            case 'android':
            case 'androidtablet':
                userAgent.match(/Android ([0-9.]+)/);
                ver = RegExp.$1;
                break;
            case 'iPhone':
                userAgent.match(/iPhone OS ([0-9_]+)/);
                ver = RegExp.$1.replace(/_/g, '.');
                break;
            case 'iPad':
                userAgent.match(/CPU OS ([0-9_]+)/);
                ver = RegExp.$1.replace(/_/g, '.');
                break;
            case 'blackberryNTH':
            case 'blackberry':
                userAgent.match(/Version\/([0-9.]+)/);
                ver = RegExp.$1;
                break;
            case 'windowsphone':
                userAgent.match(/(Windows Phone OS|Windows Phone) ([0-9]{1,}[\.0-9]{0,})/) || userAgent.match(/rv:(\d+)/);
                ver = RegExp.$2;
                break;
            case 'windowstablet':
                userAgent.match(/MSIE ([0-9]{1,}[\.0-9]{0,})/) || userAgent.match(/rv:(\d+)/);
                ver = RegExp.$1;
                break;
            case 'Macintosh':
                userAgent.match(/OS X ([0-9_]+)/);
                ver = RegExp.$1.replace(/_/g, '.');
                break;
            case 'windows':
                userAgent.match(/Windows NT ([0-9.]+)/);
                ver = winOS[RegExp.$1];
                break;
            default:
                ver = 0;
        }
        return ver;
    },
    
    
    
    setorientationDelay: function() {
        var delay = 100;
        if(kony.appinit.isIDevice && kony.appinit.isSafari) {
            delay = 0;
        }
        $KU.orientationDelay = delay;
    },

    detectDevice: function() {
        var platform = $KU.getPlatform();
        var platformName = platform.name;
        var platformVersion = platform.version;

        

        if(platformName == "iphone" || platformName == "ipad") {
            $KU.iOS = true;
            if(platformVersion < "5")
                $KU.iOS4 = true;
        }

        var delay = $KU.orientationDelayMatrix[platformName];
        if($KU.isAndroid) {
            if($KU.isAndroid_SonyXPeria)
                delay = $KU.orientationDelayMatrix["SonyXPeria"];
            else if($KU.isAndroid_Galaxy && $KU.isMob) {
                if(window.devicePixelRatio && window.devicePixelRatio > 1.5)
                    delay = 500; 
                else
                    delay = $KU.orientationDelayMatrix["GT"];
            } else if($KU.isAndroid_Nexus)
                delay = $KU.orientationDelayMatrix["Nexus"];
        }
        $KU.orientationDelay = delay || 100;

        if(platformName == "blackberryNTH") {
            $KG["nativeScroll"] = true;
            $KG["disableTransition"] = true;
        } else if(platformName == "windowsphone" && $KU.isIE9) {
            $KG["nativeScroll"] = true;
            $KG["disableTransition"] = true;
        }

        
        if($KG["useNativeScroll"]) {
            $KG["nativeScroll"] = true;
            $KG["disableTransition"] = false;
        }

        if($KG["nativeScroll"])
            $KG["needScroller"] = false;
        else {
            $KG["needScroller"] = true;
            document.body.style.overflowY = "hidden";
        }

    },

    detectOrientation: function() {
        var orientation = window.orientation;
        if(typeof orientation == "undefined" && window.matchMedia) { 
            if(window.matchMedia("(orientation: portrait)").matches)
                orientation = "portrait";
            else if(window.matchMedia("(orientation: landscape)").matches)
                orientation = "landscape";
            else
                orientation = "";
        } else {
            switch(orientation) {
                case 0:
                case 180:
                    orientation = ($KU.isAndroid && $KU.isTablet) ? "landscape" : "portrait";
                    break;
                case 90:
                case -90:
                    orientation = ($KU.isAndroid && $KU.isTablet) ? "portrait" : "landscape";
                    break;
            }
        }
        return orientation;
    },

    getBrowserLanguage: function() {
        var language;
        var httpheaders = kony.globals["httpheaders"];
        if(httpheaders && httpheaders["Accept-Language"]) {
            language = httpheaders["Accept-Language"].split(",")[0];
        } else {
            language = navigator.language || navigator.userLanguage || $KG["defaultlocale"];
        }

        return language;
    },

    domRefresh: function(element) {
        if(element) {
            var currentMargin = element.style["margin"];
            element.style["margin"] = "1px";
            setTimeout(function() {
                element.style["margin"] = currentMargin;
            }, 10);
        }
    },

    convertjsontoluaobject: function(jsonobj) {
        
    },

    getWindowWidth: function() {
        return window.innerWidth || document.documentElement.clientWidth || document.body.clientWidth;
    },

    getWindowHeight: function() {
        return window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
    },

    
    getScrollBarWidth: function() {
        var inner = document.createElement('p');
        inner.style.width = "100%";
        inner.style.height = "200px";

        var outer = document.createElement('div');
        outer.style.position = "absolute";
        outer.style.top = "0px";
        outer.style.left = "0px";
        outer.style.visibility = "hidden";
        outer.style.width = "200px";
        outer.style.height = "150px";
        outer.style.overflow = "hidden";
        outer.appendChild(inner);

        document.body.appendChild(outer);
        var w1 = inner.offsetWidth;
        outer.style.overflow = 'scroll';
        var w2 = inner.offsetWidth;
        if(w1 == w2)
            w2 = outer.clientWidth;

        document.body.removeChild(outer);

        return(w1 - w2);
    },

    convertluatojsonobject: function(luaobj) {

    },

    getImageCenterAlign: function(imgNode, updateUI, dimensions) {
        
        if(imgNode.naturalWidth) {
            var spanHeight = dimensions ? dimensions.spanHeight : imgNode.parentNode.clientHeight;
            var imgHeight = dimensions ? dimensions.imgHeight : imgNode.offsetHeight;
            var mtop = parseInt(spanHeight, 10) - parseInt(imgHeight, 10);
            if(updateUI) {
                if(mtop > 0) {
                    imgNode.style.marginTop = mtop / 2 + "px";
                } else {
                    imgNode.style.marginTop = "";
                }
            } else {
                return mtop / 2;
            }
        }
    },

    setImgAspectRatio: function(widgetModel, img, dimensions, updateUI) {
        if(!img) return;
        var isFlexWidget = $KW.FlexUtils.isFlexWidget(widgetModel);
        var referencewidth, referenceheight, explicitlyMadeVisible;
        if(widgetModel.wType == 'Image' && isFlexWidget) {
            referencewidth = $KU.getReferenceWidth(widgetModel, img, dimensions.width);
            referenceheight = $KU.getReferenceHeight(widgetModel, img, dimensions.height);
        } else {
            referencewidth = widgetModel.referencewidth;
            referenceheight = widgetModel.referenceheight;
        }

        var actimgdim = $KW.Image.getNaturalDimensions(img);
        var nWidth = actimgdim.width;
        var nHeight = actimgdim.height;

        var aspectRatio = nWidth / nHeight;
        var hasWidth = $KU.isPositiveInteger(referencewidth);
        var hasHeight = $KU.isPositiveInteger(referenceheight);
        if(!isNaN(aspectRatio) && (hasWidth || hasHeight)) {
            referencewidth = referencewidth;
            referenceheight = referenceheight;
            if(nWidth > referencewidth || nHeight > referenceheight) {
                var width = (hasWidth && (nWidth > referencewidth) && referencewidth > 0) ? referencewidth : nWidth;
                var height = referenceheight > 0 ? referenceheight : nHeight;
                var imgdim = ((width / aspectRatio) < height || !hasHeight) ? (width / aspectRatio) : false;
                if(imgdim == false)
                    width = (height * aspectRatio <= referencewidth || !hasWidth) ? height * aspectRatio : width;
                else
                    height = imgdim;

                if(height > 0 && height < 1)
                    height = 1;

                if(width > 0 && width < 1)
                    width = 1;

                if(typeof updateUI == 'undefined') {
                    if(isFlexWidget) {
                        img.style.width = width + "px";
                        img.style.height = height + "px";
                    } else {
                        img.style.width = img.parentNode.style.width = width + "px";
                        img.style.height = img.parentNode.style.height = height + "px";
                    }
                } else if(isFlexWidget) {
                    dimensions.width = width + "px";
                    dimensions.height = height + "px";
                }
            } else if(updateUI == false && isFlexWidget) {
                dimensions.width = nWidth + "px";
                dimensions.height = nHeight + "px";
            }
        }
        if(updateUI == false)
            return dimensions;
    },

    setImgDimensions: function(imageModel, imgNode, dimensions, updateUI) {
        var referencewidth = $KU.getReferenceWidth(imageModel, imgNode, dimensions.width);
        var referenceheight = $KU.getReferenceHeight(imageModel, imgNode, dimensions.height);
        if(updateUI == false)
            return {
                width: "100%",
                height: +"100%"
            };
        if(referencewidth >= 0) {
            imgNode.style.width = "100%"
            if(referenceheight >= 0) {
                imgNode.style.height = "100%";
            }
        }
    },

    getReferenceWidth: function(imgModel, imgNode, width) {
        var refWidth = imgModel.referencewidth;
        if(imgModel.wType == 'Image' && $KW.FlexUtils.isFlexWidget(imgModel)) {
            var valueObj = {
                value: parseFloat(width),
                unit: $KW.FlexUtils.getUnit(width)
            };
            refWidth = $KW.FlexUtils.getValueByParentFrame(imgModel, valueObj, 'x');
            var span = imgNode.parentNode;
            var computedStyle = $KU.getComputedStyle(span);
            if(computedStyle) {
                
                
                var hBorder = parseInt(computedStyle["border-left-width"], 10) + parseInt(computedStyle["border-right-width"], 10);
                var hPadding = parseInt(computedStyle["padding-left"], 10) + parseInt(computedStyle["padding-right"], 10);
                refWidth = refWidth - hPadding - hBorder;
            }

        }
        return refWidth;
    },

    getReferenceHeight: function(imgModel, imgNode, height) {
        var refheight = imgModel.referenceheight;
        if(imgModel.wType == 'Image' && $KW.FlexUtils.isFlexWidget(imgModel)) {
            var valueObj = {
                value: parseFloat(height),
                unit: $KW.FlexUtils.getUnit(height)
            };
            refheight = $KW.FlexUtils.getValueByParentFrame(imgModel, valueObj, 'y');
            var span = imgNode.parentNode;
            var computedStyle = $KU.getComputedStyle(span);
            if(computedStyle) {
                
                
                var vBorder = parseInt(computedStyle["border-top-width"], 10) + parseInt(computedStyle["border-bottom-width"], 10);
                var vPadding = parseInt(computedStyle["padding-top"], 10) + parseInt(computedStyle["padding-bottom"], 10);
                refheight = refheight - vBorder - vPadding;
            }
        }
        return refheight;
    },

    imgLoadHandler: function(event, img) {
        event = event || window.event;
        img = event.target ? event.target : event.srcElement;

        if(!img) return;
        
        if(!document.body.contains(img)) {
            return;
        }

        
        if(!img.parentNode || (img.parentNode && !img.parentNode.parentNode)) return;

        var tabPaneID = img.getAttribute("ktabpaneid");
        var type = img.getAttribute("kwidgettype");
        var targetWidgetID = (type == 'Image') ? $KU.getElementID(img.getAttribute("id")) : img.getAttribute("id");
        var src;
        if(type != "Image") { 
            targetWidgetID = targetWidgetID.split("_")[1];
            src = img.src;
            src && (src = src.substring(src.lastIndexOf("/") + 1, src.length));
        }
        var tabID = img.getAttribute("ktabid");
        var widgetModel;

        if(tabID) {
            widgetModel = kony.model.getWidgetModel(img.getAttribute("kformname"), $KU.getElementID(targetWidgetID), tabPaneID, tabID);
        } else {
            widgetModel = kony.model.getWidgetModel(img.getAttribute("kformname"), targetWidgetID, tabPaneID);
        }

        if(!widgetModel) {
            widgetModel = $KU.getModelByNode(img); 
        }

        if(type == "Image") src = widgetModel.src;

        if(event.type == "load") {
            var isWaitAllowed = true;
            if($KU.inArray($KU.imgCache, src, true))
                isWaitAllowed = false;
            else
                $KU.imgCache.push(src);

            if(widgetModel.imagescalemode == constants.IMAGE_SCALE_MODE_MAINTAIN_ASPECT_RATIO) {
                $KU.setImgAspectRatio(widgetModel, img);
            }


            img.style.visibility = "visible";
            img.style.opacity = 1;
            
            widgetModel.loaded = true;
            if(widgetModel.animInfo) {
                var info = widgetModel.animInfo;
                info.instance.animate(widgetModel, info.animConfig, info.animCallback);
            }
            if(isWaitAllowed || (img && img.parentNode && img.parentNode.style.background.indexOf("url") != -1)) {
                var span = img.parentNode;
                if(span) {
                    if(span.style.removeProperty)
                        span.style.removeProperty("background");
                    else
                        span.style.background = "none";
                }
            }

            if(type == "Image") {
                if(widgetModel.scrollBoxID) {
                    var scrollerID = widgetModel.pf + "_" + widgetModel.scrollBoxID + "_scroller";
                    var scrollerNode = $KU.getElementById(scrollerID);
                    if(scrollerNode) {
                        
                        
                        var scrollerInstance = $KG[scrollerID];
                        scrollerInstance && scrollerInstance.refresh();
                    }
                }

                var ondownloadcompleteref = $KU.returnEventReference(img.getAttribute("ondownloadcomplete"));
                ondownloadcompleteref && ondownloadcompleteref.call(widgetModel, widgetModel, src, true);
            }
        } else { 
            img.onerror = "";
            img.style.opacity = 1;
            var imgParentNode = img.parentNode;
            imgParentNode && (imgParentNode.style.background = "none");
            if(type == "Image")
                widgetModel.base64 = null;
            if(widgetModel.imagewhenfailed)
                img.src = $KU.getImageURL(widgetModel.imagewhenfailed);
            var ondownloadcompleteref = $KU.returnEventReference(img.getAttribute("ondownloadcomplete"));
            ondownloadcompleteref && ondownloadcompleteref.call(widgetModel, widgetModel, src, false);
        }
        if(img.parentNode)
            img.parentNode.parentNode.style["font-size"] = "0px";
        $KU.onImageLoadComplete(widgetModel, img);
    },

    onImageLoadComplete: function(widgetModel, img) {
        var containerId = img.getAttribute("kcontainerID");
        var parentModel, containerModel, flexNode, context, widgetNode;

        if(containerId) {
            containerModel = $KW.Utils.getContainerModelById(img, containerId);
        }

        parentModel = widgetModel.parent;

        if($KW.FlexUtils.isFlexWidget(widgetModel)) {
            if((typeof widgetModel.height === 'number' || (typeof widgetModel.height === 'string' && widgetModel.height))
            && (typeof widgetModel.width === 'number' || (typeof widgetModel.width === 'string' && widgetModel.width))) {
                $KW.FlexUtils.handleImageScaleMode(widgetModel, img, {
                    width: (widgetModel.frame.width + 'px'),
                    height: (widgetModel.frame.height + 'px')
                });
            } else if(containerModel) {
                flexNode = $KU.getParentByAttributeValue(img, "kwidgettype", parentModel.wType);

                if(flexNode) {
                    if(['Segment', 'CollectionView'].indexOf(containerModel.wType) != -1
                    && $KW.FlexUtils.isFlexWidget(containerModel) && containerModel.autoGrowHeight) {
                        containerModel.layoutConfig = {
                            self: true,
                            children: false
                        };
                        $KW.FlexContainer.forceLayout(containerModel.parent);
                    } else {
                        if(containerModel.wType == 'Segment') {
                            context = $KW.Segment.getContextByNode(containerModel, flexNode);
                            parentModel = $KW.Segment.getClonedModel(containerModel, context.rowIndex, context.sectionIndex);

                            if(parentModel) {
                                widgetModel = parentModel[widgetModel.id];
                                widgetModel.layoutConfig = {
                                    self: true,
                                    children: false
                                };
                                widgetModel.loaded = true;
                                parentModel = $KW.FlexUtils.getAutoGrowFlexConfigContainer(widgetModel);
                                flexNode = $KW.Segment.getNodeByContext(containerModel, context, parentModel);
                            }
                        }

                        if(containerModel.wType == 'CollectionView') { 
                            context = $KW.CollectionView.Utils.getContextByNode(containerModel, flexNode);
                            parentModel = $KW.CollectionView.Utils.getClonedModel(containerModel, context.itemIndex, context.sectionIndex);

                            if(parentModel) {
                                widgetModel = parentModel[widgetModel.id];
                                widgetModel.layoutConfig = {
                                    self: true,
                                    children: false
                                };
                                widgetModel.loaded = true;
                                parentModel = $KW.FlexUtils.getAutoGrowFlexConfigContainer(widgetModel);
                                flexNode = $KW.CollectionView.Utils.getNodeByContext(containerModel, context, parentModel);
                            }
                        }

                        $KW.FlexContainer.forceLayout(parentModel, flexNode);
                    }
                }
            } else {
                $KW.FlexUtils.updateLayoutConfig(widgetModel);
                parentModel = $KW.FlexUtils.getAutoGrowFlexConfigContainer(widgetModel);
                $KW.FlexContainer.forceLayout(parentModel);
            }
        }
    },

    
    getImageURL: function(imageSrc) {
        
        if(imageSrc) {
            if(imageSrc.startsWith("http"))
                return imageSrc;
            else {
                if((imageSrc.match(/^([^.]+)$/) != null)) {
                    imageSrc = imageSrc + ".svg";
                }
                var imageCat = "";
                var platformver = "";
                if($KG["imagecat"])
                    imageCat = $KG["imagecat"];
                if($KG["platformver"])
                    platformver = $KG["platformver"];
                return kony.appinit.getStaticContentPath() + platformver + "images/" + $KG["retina"] + imageCat + imageSrc;
            }
        }
        return "";
    },

    getCSSPropertyFromRule: function(ruleName, propertyName) {
        var styleSheetIndex = $KW.skins.getKonyStyleSheetIndex(document.styleSheets);
        var styleSheet = document.styleSheets[styleSheetIndex];
        var cssRuleObjects = styleSheet.rules || styleSheet.cssRules;

        for(var i = 0; i < cssRuleObjects.length; i++) {
            var rule = cssRuleObjects[i];
            if(rule.selectorText == ("." + ruleName))
                return((rule.style.getPropertyValue && rule.style.getPropertyValue(propertyName)) || rule.style[propertyName]);
        }
        return null;
    },

    imagePreloader: function(imageSrc, callback) {
        var imagePreLoad = new Image();
        imagePreLoad.src = imageSrc;
        imagePreLoad.onload = callback;
        imagePreLoad.onerror = callback;
    },

    
    getInnerHeight: function(timeInterval) {
        setTimeout(function() {
            $KG['__innerHeight'] = window.innerHeight;
        }, timeInterval);
    },

    getgesturePosition: function(x, y, x2, y2, x1, y1) {
        var position;
        if(x <= (x2 - x1) / 3 && y <= (y2 - y1) / 3) {
            position = 1;
        } else if(x > (x2 - x1) / 3 && x <= (x2 - x1) * 2 / 3 && y <= (y2 - y1) / 3) {
            position = 2;
        } else if(x > (x2 - x1) * 2 / 3 && y <= (y2 - y1) / 3) {
            position = 3;
        } else if(x <= (x2 - x1) / 3 && y > (y2 - y1) / 3 && y <= (y2 - y1) * 2 / 3) {
            position = 4;
        } else if(x > (x2 - x1) / 3 && x <= (x2 - x1) * 2 / 3 && y > (y2 - y1) / 3 && y <= (y2 - y1) * 2 / 3) {
            position = 5;
        } else if(x > (x2 - x1) * 2 / 3 && y > (y2 - y1) / 3 && y <= (y2 - y1) * 2 / 3) {
            position = 6;
        } else if(x <= (x2 - x1) / 3 && y > (y2 - y1) * 2 / 3) {
            position = 7;
        } else if(x > (x2 - x1) / 3 && x <= (x2 - x1) * 2 / 3 && y > (y2 - y1) * 2 / 3) {
            position = 8;
        } else if(x > (x2 - x1) * 2 / 3 && y > (y2 - y1) * 2 / 3) {
            position = 9;
        } else if(x == (x2 - x1) / 2 && y == (y2 - y1) / 2) {
            position = 10;
        }
        return position;
    },

    addThirdPartyMeta: function(meta) {
        if(meta && typeof meta == 'object') {
            if(!$KG['thirdPartyWidgetsMeta']) {
                $KG['thirdPartyWidgetsMeta'] = {};
            }
            $KG['thirdPartyWidgetsMeta'][meta.id] = meta;
        }
    },

    getWidgetTypeByNameSapce: function(namespace) {
        if(namespace && typeof namespace == 'string') {
            namespace = namespace.split('.');
            return namespace[namespace.length - 1];
        } else {
            return "";
        }
    },

    getStyle: function(el, cssprop) {
        try {
            var value = "";
            if(document.defaultView && document.defaultView.getComputedStyle) {
                value = document.defaultView.getComputedStyle(el, "").getPropertyValue(cssprop);
            } else if(el.currentStyle) { 
                cssprop = cssprop.replace(/\-(\w)/g, function(strMatch, p1) {
                    return p1.toUpperCase();
                });
                value = el.currentStyle[cssprop];
            } else 
                value = el.style[cssprop];
        } catch(e) {

        }
        return value;
    },

    getComputedStyle: function(el) {
        var value;
        if(document.defaultView && document.defaultView.getComputedStyle) {
            value = document.defaultView.getComputedStyle(el, "");
        }
        return value;
    },

    getContainerParentDivMappings: function() {
        return {
            Form: 1,
            Line: 0,
            TabPane: 0,
            Image: 2,
            Slider: 3,
            FlexContainer: 1,
            FlexScrollContainer: 0
        };
    },

    returnParentChildBloatAdjustedNode: function(childModel, node) {
        var map = $KU.getContainerParentDivMappings();
        for(var i = typeof map[childModel.wType] == 'undefined' ? 1 : map[childModel.wType]; i > 0; --i)
            node = node.parentNode;
        return node;
    },

    extend: function(sub, sup) {
        for(var k in sup) {
            if(typeof sub[k] == 'undefined') {
                sub[k] = sup[k];
            }
        }

        return sub;
    },

    fireEvent: function(el, type, data) {
        if(document.createEventObject) {
            var evt = document.createEventObject();
            evt.data = data;
            return el.fireEvent('on' + type, evt);
        } else {
            var evt = document.createEvent("HTMLEvents");
            evt.data = data;
            evt.initEvent(type, true, true);
            return !el.dispatchEvent(evt);
        }
    },

    elementIndex: function(el) {
        var index = 0;
        while(el && el.previousSibling) {
            el = el.previousSibling;
            index++;
        }
        return index;
    },

    closestElement: function(el, attrName, attrValue) {
        while(el && el.tagName) {
            var val = el.getAttribute(attrName);
            if(attrName === 'class') {
                if($KU.hasClassName(el, attrValue)) {
                    return el;
                }
            } else {
                if(arguments.length === 3) {
                    if(el.getAttribute(attrName) === attrValue) {

                        return el;
                    }
                } else if(arguments.length === 2) {
                    if(el.hasAttribute(attrName)) {
                        return el;
                    }
                }
            }
            el = el.parentNode;
        }
        return null;
    },

    filterElements: function(els, type) {
        var elms = [];
        if(els.length) {
            if(type === 'visible') {
                for(var i = 0; i < els.length; i++) {
                    if(els[i].style.display !== 'none') {
                        elms.push(els[i]);
                    }
                }
            }
        }
        return elms;
    },


    mediaSupport: function() {
        var video = document.createElement('video');
        return {
            mpeg4: "" !== video.canPlayType('video/mp4; codecs="mp4v.20.8"'),
            h264: "" !== (video.canPlayType('video/mp4; codecs="avc1.42E01E"') || video.canPlayType('video/mp4; codecs="avc1.42E01E, mp4a.40.2"')),
            ogg: "" !== video.canPlayType('video/ogg; codecs="theora"'),
            webm: "" !== video.canPlayType('video/webm; codecs="vp8, vorbis"')
        }
    },



    getFunctionName: function(func) {
        return func.name ? func.name : func.toString().match(/^\s*function\s*(\S*)\s*\(/)[1];
    },

    
    cssPrefix: (vendor) ? "-" + vendor + "-" : "",
    nativeScrollMatrix: {
        iphone: "5",
        ipad: "5",
        android: "2.3.6",
        blackberry: "7",
        desktop: "0"
    },
    isAndroid: (/android/gi).test(navigator.userAgent) && !((/trident/gi).test(navigator.userAgent)) && !((/edge/gi).test(navigator.userAgent)),
    isIDevice: (/iphone|ipad/gi).test(navigator.userAgent) && !((/trident/gi).test(navigator.userAgent)),
    isiPhone: (/iphone/gi).test(navigator.userAgent) && !((/trident/gi).test(navigator.userAgent)),
    isiPod: (/ipod/gi).test(navigator.userAgent),
    isiPad: (/ipad/gi).test(navigator.userAgent),
    isIOS7: (/(iPad|iPhone);.*CPU.*OS 7_\d/i).test(navigator.userAgent),
    isIOSgt6: (/(iPad|iPhone);.*CPU.*OS ([7-9]|[1-9][0-9])_\d/i).test(navigator.userAgent), 
    isPlaybook: (/playbook/gi).test(navigator.userAgent),
    isBlackBerry: ((/blackberry/gi).test(navigator.userAgent) || (/BB10/gi).test(navigator.userAgent)) && typeof bbnth == "undefined",
    isBlackBerryNTH: (/blackberry/gi).test(navigator.userAgent) && typeof bbnth != "undefined" && bbnth,
    isTouchPad: (/hp-tablet/gi).test(navigator.userAgent),
    isWindowsPhone: (/Windows Phone/gi).test(navigator.userAgent),
    isWindowsTouch: ((/Windows/gi).test(navigator.userAgent) && (/Touch/gi).test(navigator.userAgent)) || ((/trident/gi).test(navigator.userAgent)),
    isWindowsTablet: ((/Windows NT/gi).test(navigator.userAgent) && (/Touch/gi).test(navigator.userAgent)) || (typeof spaMarkup != "undefined" && spaMarkup == "spawindowstablet"),
    isIE: (/MSIE/gi).test(navigator.userAgent),
    isIE9: navigator.userAgent.match(/MSIE (\d+)/) != null && RegExp.$1 == "9",
    isIE10: navigator.userAgent.match(/MSIE (\d+)/) != null && RegExp.$1 == "10",
    isIE11: (/rv:([1][1-9])/i).test(navigator.userAgent),
    isMob: (/mobile/gi).test(navigator.userAgent),
    isTablet: (/hp-tablet|ipad|playbook/gi).test(navigator.userAgent) || (((/android/gi).test(navigator.userAgent) || ((/Windows NT/gi).test(navigator.userAgent) && (/Touch/gi).test(navigator.userAgent) || (typeof spaMarkup != "undefined" && spaMarkup == "spawindowstablet"))) && !(/mobile/gi).test(navigator.userAgent)),
    isEdge: (/edge/gi).test(navigator.userAgent),
    
    isAndroid_SonyXPeria: (/android/gi).test(navigator.userAgent) && (/SonyEricsson/gi).test(navigator.userAgent),
    isAndroid_Galaxy: (/android/gi).test(navigator.userAgent) && (/GT/gi).test(navigator.userAgent),
    isAndroid_HTC: (/android/gi).test(navigator.userAgent) && (/HTC/gi).test(navigator.userAgent),
    isAndroid_Nexus: (/android/gi).test(navigator.userAgent) && (/Nexus/gi).test(navigator.userAgent),
    orientationDelayMatrix: {
        iphone: 100,
        ipad: 100,
        blackberry: 100,
        android: 250,
        GT: 150,
        SonyXPeria: 100,
        Nexus: 500,
        androidtablet: 300
    },
    isTouchSupported: (('ontouchstart' in window) || window.DocumentTouch && document instanceof DocumentTouch) && typeof bbnth == "undefined",
    isPointerSupported: navigator.msPointerEnabled || navigator.pointerEnabled,
    isOrientationSupported: 'onorientationchange' in window,

    placeholderSupported: ("placeholder" in document.createElement('input')),


    
    has3d: 'WebKitCSSMatrix' in window && 'm11' in new WebKitCSSMatrix() || 'MSCSSMatrix' in window && 'm11' in new MSCSSMatrix(),
    hasTransform: 'webkitTransform' in document.documentElement.style || 'msTransform' in document.documentElement.style || 'transform' in document.documentElement.style,
    hasWebkitTransform: 'webkitTransform' in document.documentElement.style,
    hasMsTransform: 'msTransform' in document.documentElement.style,
    hashChange: "onhashchange" in window,

    translatableWidgets: ["Button", "Label", "RichText", "TextArea", "TextField", "Phone", "Switch", "Form", "FlexContainer"],
    segmentKeyMap: {
        visible: "isvisible",
        enable: "disabled",
        multiSelect: "multiple",
        blur: "flexblur"
    },
    dpi: 1,
    minTouchMoveDisplacement: (window.devicePixelRatio || 1) * 6,
    swipeDuration: 500,
    imgCache: [],
    isAjaxUploadSupported: window.File && window.FileList && new XMLHttpRequest().upload,
    defaultunit: '%',
    flexUnits: ['%', 'px', 'dp'],
    contentDrivenWidgets: ["Label", "Button", "RichText", "Phone"],
    widgetsWidthMap: {
        TabPane: '100%',
        Calendar: '200dp',
        DataGrid: '100%',
        CheckBoxGroup: '100%',
        RadioButtonGroup: '260dp',
        Slider: '260dp',
        Switch: '200dp',
        Segment: '100%',
        Browser: '100%',
        Line: '50dp',
        Map: '100%',
        FlexContainer: '100%',
        FlexScrollContainer: '100%',
        TPW: '200dp',
        TextField: '260dp',
        TextArea: '260dp',
        ListBox: '260dp',
        CollectionView: '120dp',
        Canvas: '100%'
    },
    widgetsHeightMap: {
        Segment: '120dp',
        Browser: '220dp',
        Map: '75%',
        TabPane: '220dp',
        FlexContainer: '220dp',
        FlexScrollContainer: '220dp',
        Line: '2dp',
        Slider: '100dp',
        ListBox: '40dp',
        CheckBoxGroup: '120dp',
        RadioButtonGroup: '40dp',
        TextArea: '120dp',
        TextField: '40dp',
        DataGrid: '120dp',
        CollectionView: '120dp',
        Canvas: '220dp'
    },
    changeFlag: false,
    needOptimization: true,

    animationDuration: (vendor) ? vendor + "AnimationDuration" : "animationDuration",
    animationName: (vendor) ? vendor + "AnimationName" : "animationName",
    transition: (vendor) ? vendor + "Transition" : "transition",
    transform: (vendor) ? vendor + "Transform" : "transform",
    transitionDelay: (vendor) ? vendor + "TransitionDelay" : "transitionDelay",
    transitionDuration: (vendor) ? vendor + "TransitionDuration" : "transitionDuration",
    transitionProperty: (vendor) ? vendor + "TransitionProperty" : "transitionProperty",
    transformOrigin: (vendor) ? vendor + "TransformOrigin" : "transformOrigin",
    animationStart: (vendor) ? vendor + "AnimationStart" : "animationstart",
    animationEnd: (vendor) ? vendor + "AnimationEnd" : "animationend",
    animationIteration: (vendor) ? vendor + "AnimationIteration" : "animationiteration",
    animation: (vendor) ? vendor + "Animation" : "animation",


    setMainHeight: function() {
        var main = $KU.getElementById("__MainContainer");
        if(main) {
            main.style.height = window.innerHeight + "px";
        }
    },

    getI18NValue: function(value) {
        var regExp = /\((\'|\")([^)]+)(\'|\")\)/;
        var matches = regExp.exec(value);
        var key = "";
        if(matches && matches[2]) {
            key = matches[2];
        }
        return(key && $KI.i18n.getlocalizedstring(key)) || "";
    },

    
    createa11yDynamicElement: function() {
        var ariaDiv = document.getElementById("ariaTag");
        if(!ariaDiv) {
            var ariaText = "<span  id='ariaTag' style='opacity:0;display:inline-block;height:0;width:0'  aria-live='assertive'></span>";
            ariaDiv = ariaDiv || document.createElement('div');
            ariaDiv.innerHTML = ariaText;
            document.body.appendChild(ariaDiv.firstChild);
        }
    },

    
    changea11yDynamicElement: function(title) {
        var ariaEle = document.getElementById('ariaTag');
        window.setTimeout(function() {
            if(ariaEle) {
                ariaEle.removeAttribute('aria-hidden');
                ariaEle.innerHTML = title;
                window.setTimeout(function() {
                    ariaEle.setAttribute('aria-hidden', 'true')
                }, 10);
            }
        }, 100);
        if(ariaEle) ariaEle.innerHTML = "title set";
    },

    
    isRoleRequired: function(widgetModel) {
        if($KU.isIDevice && ["Label", "Segment", "Slider", "RichText", "FlexContainer", "FlexScrollContainer"].indexOf(widgetModel.wType) != -1) {
            return true;
        }
        else
            return false;
    },

    isTabIndexRequired: function(widgetModel) {
        if(["Image", "Switch", "Label", "RichText", "FlexContainer"].indexOf(widgetModel.wType) >= 0) {
            return true;
        }
        return false;
    },

    addAriatoElement: function(element, propertyValue, widgetModel, oldPropertyValue) {
        var inputNode = null, calImgNode = null;
        
        if(element && oldPropertyValue && oldPropertyValue.a11yARIA) {
            for(attr in oldPropertyValue.a11yARIA)
                element.removeAttribute(attr);
        }
        if(widgetModel.wType === 'Calendar') {
            inputNode = (element.firstChild.tagName === 'INPUT') ? element.childNodes[0]:element.childNodes[1];
            calImgNode = (element.firstChild.tagName === 'IMG') ? element.childNodes[0]:element.childNodes[1];
            element = calImgNode;
        }
        
        if(element && propertyValue) {
            
            
            var accessLabel = (propertyValue.a11yLabel || propertyValue.a11yLabel == "") ? propertyValue.a11yLabel : propertyValue.hint;

            var accessValue = propertyValue.a11yValue;

            if(accessLabel != null && typeof accessLabel != undefined && accessLabel.trim() == "") {
                if(widgetModel.wType != "Calendar") {
                    accessLabel = " ";
                } else {
                    accessLabel = widgetModel.date ? widgetModel.date : widgetModel.placeholder;
                }

            }

            if(accessValue != null && typeof accessValue != undefined && accessValue.trim() == "") {
                accessValue = " ";
            }

            if(widgetModel.wType != 'Calendar') {

                accessLabel = accessLabel ? accessLabel + " " + (accessValue ? accessValue : "") : (accessValue ? accessValue : null);
            }


            if(accessLabel) {
                if(widgetModel.wType == "Image") {
                    element.setAttribute("alt", accessLabel);
                } else {
                    element.setAttribute("aria-label", accessLabel);
                }
                if($KU.isRoleRequired(widgetModel)) {
                    element.setAttribute("role", "option");
                }
                if($KU.isTabIndexRequired(widgetModel)) {
                    element.setAttribute("tabindex", 0);
                }


            } else {
                if(widgetModel.wType == "Image") {
                    element.removeAttribute("alt");
                } else {
                    if(widgetModel.wType != "Calendar") {
                        element.removeAttribute("aria-label");
                    } else {
                        accessLabel = widgetModel.date ? widgetModel.date : widgetModel.placeholder;
                        element.setAttribute("aria-label", accessLabel);
                    }
                }
                if($KU.isRoleRequired(widgetModel)) {
                    element.removeAttribute("role");
                }
                if($KU.isTabIndexRequired(widgetModel)) {
                    element.removeAttribute("tabindex");
                }
                if(!accessLabel && widgetModel.wType == "Switch") {
                    $KW.Switch.addA11YAttribute(widgetModel, element, true);
                }
            }

            var accessHint = propertyValue.a11yHint || "";
            if(accessHint.trim() != "") {
                if(!($KU.isBlackBerryNTH || $KU.isBlackBerry)) {
                    var widgetId = widgetModel.pf + "_" + widgetModel.id;
                    var kmasterObj = $KW.Utils.getMasterIDObj(widgetModel);
                    if(kmasterObj.id != "") {
                        widgetId = kmasterObj.id;
                    }
                    var hintID = widgetId + "-hint";
                    element.setAttribute("aria-describedby", hintID);
                    $KU.createHintWrapper(widgetModel, hintID, accessHint);
                    if($KU.isRoleRequired(widgetModel))
                        element.setAttribute("role", "option");
                    if($KU.isTabIndexRequired(widgetModel))

                        element.setAttribute("tabindex", 0);
                }
            } else {
                element.removeAttribute("aria-describedby");
                if($KU.isRoleRequired(widgetModel) && !accessLabel)
                    element.removeAttribute("role");
                if(!accessLabel && widgetModel.wType == "Switch")
                    $KW.Switch.addA11YAttribute(widgetModel, element, true);
            }
            propertyValue.a11yHidden ? element.setAttribute("aria-hidden", true) : element.removeAttribute("aria-hidden");
            propertyValue.required ? element.setAttribute("aria-required", propertyValue.required) : element.removeAttribute("aria-required");

            
            if(propertyValue.a11yARIA) {
                if(widgetModel.wType === 'Calendar') {
                    for(attr in propertyValue.a11yARIA) {
                        if(attr === 'tabindex') {
                            inputNode.setAttribute(attr, propertyValue.a11yARIA[attr]);
                            calImgNode.setAttribute(attr, propertyValue.a11yARIA[attr]);
                        } else {
                            calImgNode.setAttribute(attr, propertyValue.a11yARIA[attr]);
                        }
                    }
                } else {
                    for(attr in propertyValue.a11yARIA) {
                        element.setAttribute(attr, propertyValue.a11yARIA[attr]);
                    }
                }
            }
        } else {
            
            if(widgetModel.wType == "Image") {
                element.removeAttribute("alt");
            } else if(widgetModel.wType == "Calendar") {
                element.alt = "Calendar";
            } else {
                element.removeAttribute("aria-label");
                if(widgetModel.wType == "Switch") {
                    $KW.Switch.addA11YAttribute(widgetModel, element);
                }
            }
            element.removeAttribute("aria-hidden");
            element.removeAttribute("aria-describedby");
            element.removeAttribute("aria-required");
            if($KU.isRoleRequired(widgetModel)) {
                element.removeAttribute("role");
            }
            if($KU.isTabIndexRequired(widgetModel)) {
                element.removeAttribute("tabindex");
            }
        }
    },

    
    createHintWrapper: function(widgetModel, id, desc) {
        var wrapperId = widgetModel.pf + "-hint";
        var wrapper = document.getElementById(wrapperId);
        if(desc) {
            var hintString = "<div id='" + id + "'>" + desc + "</div>";
            var hintElem = document.getElementById(id);
            if(!wrapper) {
                var wrapper = document.createElement('div');
                wrapper.id = wrapperId;
                wrapper.style.display = 'none';
                document.body.appendChild(wrapper);
            }
            if(hintElem) {
                if(hintElem.textContent)
                    hintElem.textContent = desc;
                else
                    hintElem.innerText = desc;
            } else {
                wrapper.innerHTML += hintString;
            }
        }
    },

    
    getAccessibilityValues: function(widgetModel, accessibilityObj, groupWidgetValue, rowIndex) {
        var accessObj = accessibilityObj || widgetModel.accessibilityconfig;

        
        if(groupWidgetValue && groupWidgetValue != "") {
            groupWidgetValue = groupWidgetValue ? "_" + groupWidgetValue : "";
            
            accessObj = accessibilityObj;
        }
        
        var accessAttr = " ";
        if(accessObj) {
            
            var accessLabel = (accessObj.a11yLabel || accessObj.a11yLabel == "") ? accessObj.a11yLabel : accessObj.hint;
            accessLabel = $KU.escapeHTMLSpecialEntities(accessLabel);
            var accessValue = $KU.escapeHTMLSpecialEntities(accessObj.a11yValue);

            var accessHint = accessObj.a11yHint;
            var segrowIndex = rowIndex || "";
            var hintID = "";
            var widgetId = widgetModel.pf + "_" + widgetModel.id;
            var kmasterObj = $KW.Utils.getMasterIDObj(widgetModel);
            if(kmasterObj.id != "") {
                widgetId = kmasterObj.id;
            }
            if(groupWidgetValue)
                hintID = widgetId + segrowIndex + groupWidgetValue + "-hint";
            else
                hintID = widgetId + segrowIndex + "-hint";

            if(accessLabel != null && typeof accessLabel != undefined && accessLabel.trim() == "") {
                accessLabel = " ";
            }
            if(accessValue != null && typeof accessValue != undefined && accessValue.trim() == "") {
                accessValue = " ";
            }
            if(widgetModel.wType != 'Calendar') {
                accessLabel = accessLabel ? accessLabel + " " + (accessValue ? accessValue : "") : (accessValue ? accessValue : null);
                accessLabel = accessLabel ? (widgetModel.wType == "Image" ? "  alt='" + accessLabel + "' " : "  aria-label='" + accessLabel + "' ") : "";
            } else {
                accessLabel = accessLabel ? accessLabel : "";
                accessLabel = accessLabel + ' ' + (widgetModel.date ? widgetModel.date : widgetModel.placeholder);
                accessLabel = accessLabel ? ("aria-label='" + accessLabel + "' ") : "";
            }
            if(accessLabel && $KU.isRoleRequired(widgetModel)) 
                accessLabel += "  role='option'";

            var accessHintAttr = "";
            if(accessHint) {
                accessHintAttr = " aria-describedby='" + hintID + "' ";
                if($KU.isRoleRequired(widgetModel))
                    accessLabel += "  role='option'";
            }

            var accessHidden = accessObj.a11yHidden ? " aria-hidden ='" + true + "'" : "";

            $KU.createHintWrapper(widgetModel, hintID, accessHint);

            
            if(accessObj.a11yARIA) {
                for(attr in accessObj.a11yARIA) {
                    accessAttr += attr + "= '" + accessObj.a11yARIA[attr] + "' ";
                }
                if(widgetModel.wType === 'Calendar' && !(accessObj.a11yARIA.tabindex)) {
                    accessAttr +='tabindex=0';
                }
            }

            accessAttr += (accessLabel + "  " + accessHintAttr + " " + accessHidden);
        } else {
            if(widgetModel.wType == 'Calendar') {
                accessLabel = "Calendar " + widgetModel.placeholder;
                accessLabel = ("aria-label='" + accessLabel + "' ");
                accessAttr = (accessLabel);
            }
        }
        if(accessAttr.trim().length > 0 && $KU.isTabIndexRequired(widgetModel)) {
                accessAttr += " tabindex='0'";
        }
        return accessAttr;
    },

    setScrollBoxesHeight: function(formID, widgetType) {
        
        var scrollBoxes = document.querySelectorAll("#" + formID + " div[kwidgettype='" + widgetType + "']");
        for(var i = 0; i < scrollBoxes.length; i++) {
            var boxModel = $KU.getModelByNode(scrollBoxes[i]);
            $KU.setScrollHeight(boxModel, scrollBoxes[i]);
        }
    },

    setScrollHeight: function(boxModel, scrollBox) {
        var parentModel = boxModel.parent;
        var topLevelModel = $KG.allforms[boxModel.pf];

        scrollBox = scrollBox || $KU.getNodeByModel(boxModel);
        var scroller = scrollBox;
        if(!scroller) return;
        
        if((parentModel && (parentModel.wType == 'FlexContainer' || parentModel.wType == 'FlexScrollContainer')) || (topLevelModel && topLevelModel.wType == 'Form' && topLevelModel.layouttype != kony.flex.VBOX_LAYOUT)) {
            scroller.style.overflowY = "auto";
            if(boxModel.wType == 'Segment') scroller.style.overflowX = "hidden";

            if(boxModel.wType == 'Browser') {
                var checkExternalUrl = (boxModel.url) ? $KW.Browser.isExternalUrl(boxModel.url) : true;
                if(!checkExternalUrl) scroller.style.overflowY = "hidden";
            }
            return;
        }


        var parentNode = $KU.getElementById(scrollBox.id + "_parent");
        var scrolldirection = $KW.stringifyScrolldirection[boxModel.scrolldirection];
        var pageIndicator;
        if(boxModel.wType == "Segment" && boxModel.viewType == "pageview" && boxModel.needpageindicator) {
            pageIndicator = document.getElementById($KW.Utils.getKMasterWidgetID(boxModel) + "_footer");
            pageIndicator && $KU.removeClassName(pageIndicator, "hide")
        }
        
        
        
        if((scrolldirection != "horizontal" && boxModel.wType == 'ScrollBox') || boxModel.needScroller) {
            var boxhtPercent = boxModel.containerheight >= 0 ? boxModel.containerheight : boxModel.container_height;
            boxhtPercent = parseFloat(boxhtPercent);
            var kht = 0;
            if($KU.isPositiveInteger(boxhtPercent) && (boxModel.containerheightreference || boxModel.heightreference)) {
                if([boxModel.containerheightreference, boxModel.heightreference].contains(1)) 
                {
                    
                    var formScroller = document.getElementById($KG["__currentForm"].id + '_scroller');
                    var formHeight = (formScroller && formScroller.offsetHeight) || $KU.getWindowHeight();
                    kht = Math.round((boxhtPercent * formHeight) / 100);
                } else if([boxModel.containerheightreference, boxModel.heightreference].contains(2)) 
                {
                    var parentModel = $KU.getParentModel(boxModel);
                    var parent = $KU.getNodeByModel(parentModel);
                    var parentWidth = (parent && parent.offsetWidth) || scroller.parentNode.offsetWidth;
                    kht = Math.round((boxhtPercent * parentWidth) / 100);
                } else if([boxModel.containerheightreference, boxModel.heightreference].contains(3)) 
                {
                    kht = Math.round((boxhtPercent * screen.height) / 100);
                }

                var border = padding = 0;
                if(parentNode) {
                    border = parseInt($KU.getStyle(parentNode, "border-top-width").replace("px", ""), 10) + parseInt($KU.getStyle(parentNode, "border-bottom-width").replace("px", ""), 10);
                    padding = parseInt($KU.getStyle(parentNode, "padding-top").replace("px", ""), 10) + parseInt($KU.getStyle(parentNode, "padding-bottom").replace("px", ""), 10);
                    parentNode.style.height = kht + "px";
                }

                kht = kht - border - padding;
                scroller.style.height = kht + "px";

                if(boxModel.wType == "Segment" && boxModel.viewType == "pageview" && boxModel.containerheight == 0) {
                    pageIndicator && $KU.addClassName(pageIndicator, "hide");
                }
            }

        } else {
            if(boxModel.wType == "Segment" && boxModel.screenLevelWidget == true)
                return;
            if(boxModel.wType == "Segment" || boxModel.wType == "TabPane" || boxModel.wType == "Browser") {
                kht = 'auto';
            } else if(boxModel.wType == "Map") {
                kht = '500px';
            }
            scroller.style.height = kht;
        }

        if((boxModel.containerheight || boxModel.containerheight == 0) && boxModel.wType != "ScrollBox") {
            scrollBox.style.overflowY = 'auto';
        }
    },

    isFlexWidget: function(wModel) {
        var parentModel = wModel.parent;
        if(parentModel) {
            var wType = parentModel.wType;
            if(wType == "FlexContainer" || wType == "FlexScrollContainer" || (wType == 'Form' && parentModel.layouttype && parentModel.layouttype != kony.flex.VBOX_LAYOUT && parentModel.layouttype != constants.CONTAINER_LAYOUT_GRID))
                return true;
        }
        return false;
    },

    isFlexContainer: function(wModel) {
        if(wModel) {
            var wType = wModel.wType;
            if(wType == "FlexContainer" || wType == "FlexScrollContainer" || (wType == 'Form' && wModel.layouttype && wModel.layouttype != kony.flex.VBOX_LAYOUT && wModel.layouttype != constants.CONTAINER_LAYOUT_GRID))
                return true;
        }
        return false;
    },

    isMasterContainer: function(wModel) {
        if(wModel) {
            return ['KComponent', 'FlexContainer', 'FlexScrollContainer'].indexOf(wModel.wType) > -1;
        }
    },

    onEventHandler: function(wModel) {
        var topLevelModel;
        if(wModel && !wModel.isCloned) { 
            var isFlexWidget = $KW.FlexUtils.isFlexWidget(wModel);
            if(isFlexWidget) {
                topLevelModel = $KG.allforms[wModel.pf];
            }
        } else {
            topLevelModel = $KG["__currentForm"];
        }

        if(topLevelModel) {
            $KW.Form.initializeAllFlexContainers(topLevelModel);
            $KW.Form.initializeFlexContainersInTemplate(topLevelModel);
        }
    },

    setMainHeight: function() {
        var main = $KU.getElementById("__MainContainer");
        if(main) {
            main.style.height = window.innerHeight + "px";
        }
    },

    
    escapeHTMLSpecialEntities: function(text) {
        if(typeof text !== 'string') return text;
        
        if($KG.appbehaviors && $KG.appbehaviors["skipEscapeHtml"] == true)
            return text;

        var escapedText = "";
        var escapeAllHtmlEntities = ($KG.appbehaviors && $KG.appbehaviors["escapeHtml"] == true) ? true : false;

        
        if(!escapeAllHtmlEntities) {
            escapedText = text.replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/'/g, '&rsquo;').replace(/"/g, '&rdquo;');
        } else { 
            var entityMap = {
                34: 'quot',
                38: 'amp',
                39: 'apos',
                60: 'lt',
                62: 'gt',
                160: 'nbsp',
                161: 'iexcl',
                162: 'cent',
                163: 'pound',
                164: 'curren',
                165: 'yen',
                166: 'brvbar',
                167: 'sect',
                168: 'uml',
                169: 'copy',
                170: 'ordf',
                171: 'laquo',
                172: 'not',
                173: 'shy',
                174: 'reg',
                175: 'macr',
                176: 'deg',
                177: 'plusmn',
                178: 'sup2',
                179: 'sup3',
                180: 'acute',
                181: 'micro',
                182: 'para',
                183: 'middot',
                184: 'cedil',
                185: 'sup1',
                186: 'ordm',
                187: 'raquo',
                188: 'frac14',
                189: 'frac12',
                190: 'frac34',
                191: 'iquest',
                192: 'Agrave',
                193: 'Aacute',
                194: 'Acirc',
                195: 'Atilde',
                196: 'Auml',
                197: 'Aring',
                198: 'AElig',
                199: 'Ccedil',
                200: 'Egrave',
                201: 'Eacute',
                202: 'Ecirc',
                203: 'Euml',
                204: 'Igrave',
                205: 'Iacute',
                206: 'Icirc',
                207: 'Iuml',
                208: 'ETH',
                209: 'Ntilde',
                210: 'Ograve',
                211: 'Oacute',
                212: 'Ocirc',
                213: 'Otilde',
                214: 'Ouml',
                215: 'times',
                216: 'Oslash',
                217: 'Ugrave',
                218: 'Uacute',
                219: 'Ucirc',
                220: 'Uuml',
                221: 'Yacute',
                222: 'THORN',
                223: 'szlig',
                224: 'agrave',
                225: 'aacute',
                226: 'acirc',
                227: 'atilde',
                228: 'auml',
                229: 'aring',
                230: 'aelig',
                231: 'ccedil',
                232: 'egrave',
                233: 'eacute',
                234: 'ecirc',
                235: 'euml',
                236: 'igrave',
                237: 'iacute',
                238: 'icirc',
                239: 'iuml',
                240: 'eth',
                241: 'ntilde',
                242: 'ograve',
                243: 'oacute',
                244: 'ocirc',
                245: 'otilde',
                246: 'ouml',
                247: 'divide',
                248: 'oslash',
                249: 'ugrave',
                250: 'uacute',
                251: 'ucirc',
                252: 'uuml',
                253: 'yacute',
                254: 'thorn',
                255: 'yuml',
                402: 'fnof',
                913: 'Alpha',
                914: 'Beta',
                915: 'Gamma',
                916: 'Delta',
                917: 'Epsilon',
                918: 'Zeta',
                919: 'Eta',
                920: 'Theta',
                921: 'Iota',
                922: 'Kappa',
                923: 'Lambda',
                924: 'Mu',
                925: 'Nu',
                926: 'Xi',
                927: 'Omicron',
                928: 'Pi',
                929: 'Rho',
                931: 'Sigma',
                932: 'Tau',
                933: 'Upsilon',
                934: 'Phi',
                935: 'Chi',
                936: 'Psi',
                937: 'Omega',
                945: 'alpha',
                946: 'beta',
                947: 'gamma',
                948: 'delta',
                949: 'epsilon',
                950: 'zeta',
                951: 'eta',
                952: 'theta',
                953: 'iota',
                954: 'kappa',
                955: 'lambda',
                956: 'mu',
                957: 'nu',
                958: 'xi',
                959: 'omicron',
                960: 'pi',
                961: 'rho',
                962: 'sigmaf',
                963: 'sigma',
                964: 'tau',
                965: 'upsilon',
                966: 'phi',
                967: 'chi',
                968: 'psi',
                969: 'omega',
                977: 'thetasym',
                978: 'upsih',
                982: 'piv',
                8226: 'bull',
                8230: 'hellip',
                8242: 'prime',
                8243: 'Prime',
                8254: 'oline',
                8260: 'frasl',
                8472: 'weierp',
                8465: 'image',
                8476: 'real',
                8482: 'trade',
                8501: 'alefsym',
                8592: 'larr',
                8593: 'uarr',
                8594: 'rarr',
                8595: 'darr',
                8596: 'harr',
                8629: 'crarr',
                8656: 'lArr',
                8657: 'uArr',
                8658: 'rArr',
                8659: 'dArr',
                8660: 'hArr',
                8704: 'forall',
                8706: 'part',
                8707: 'exist',
                8709: 'empty',
                8711: 'nabla',
                8712: 'isin',
                8713: 'notin',
                8715: 'ni',
                8719: 'prod',
                8721: 'sum',
                8722: 'minus',
                8727: 'lowast',
                8730: 'radic',
                8733: 'prop',
                8734: 'infin',
                8736: 'ang',
                8743: 'and',
                8744: 'or',
                8745: 'cap',
                8746: 'cup',
                8747: 'int',
                8756: 'there4',
                8764: 'sim',
                8773: 'cong',
                8776: 'asymp',
                8800: 'ne',
                8801: 'equiv',
                8804: 'le',
                8805: 'ge',
                8834: 'sub',
                8835: 'sup',
                8836: 'nsub',
                8838: 'sube',
                8839: 'supe',
                8853: 'oplus',
                8855: 'otimes',
                8869: 'perp',
                8901: 'sdot',
                8968: 'lceil',
                8969: 'rceil',
                8970: 'lfloor',
                8971: 'rfloor',
                9001: 'lang',
                9002: 'rang',
                9674: 'loz',
                9824: 'spades',
                9827: 'clubs',
                9829: 'hearts',
                9830: 'diams',
                338: 'OElig',
                339: 'oelig',
                352: 'Scaron',
                353: 'scaron',
                376: 'Yuml',
                710: 'circ',
                732: 'tilde',
                8194: 'ensp',
                8195: 'emsp',
                8201: 'thinsp',
                8204: 'zwnj',
                8205: 'zwj',
                8206: 'lrm',
                8207: 'rlm',
                8211: 'ndash',
                8212: 'mdash',
                8216: 'lsquo',
                8217: 'rsquo',
                8218: 'sbquo',
                8220: 'ldquo',
                8221: 'rdquo',
                8222: 'bdquo',
                8224: 'dagger',
                8225: 'Dagger',
                8240: 'permil',
                8249: 'lsaquo',
                8250: 'rsaquo',
                8364: 'euro'
            }

            for(var i = 0; i < text.length; i++) {
                var charCode = text.charCodeAt(i);

                if(entityMap[charCode])
                    escapedText += "&" + entityMap[charCode] + ";";
                else
                    escapedText += text[i];
            }
        }

        return escapedText;
    },

    createStyleSheet: function(id) {
        var stylesheet = document.createElement('style');
        stylesheet.type = "text/css";
        stylesheet.rel = "stylesheet";
        stylesheet.id = id;
        document.head && document.head.appendChild(stylesheet);
        return stylesheet.sheet;
    },

    updateScrollFlag: function(wModel) {
        var parentModel = wModel.parent || wModel;
        var height = parseFloat(wModel.containerheight);
        wModel.needScroller = $KW.FlexUtils.isFlexContainer(parentModel) || !!($KU.isPositiveInteger(height) && wModel.containerheightreference);
    },

    isValidCSSLength: function(value) {
        return /^[-+]?([0-9]+)(\.[0-9]+)?(px|%|dp)?$/.test(value);
    },

    isPositiveInteger: function(value) {
        return(typeof value == "number" && value >= 0);
    },

    layoutNewWidgets: function(boxModel, wArray) {
        if(wArray && wArray.length > 0) {
            $KW.FlexUtils.updateWidgetsConfig(boxModel, wArray);
            var isFlexContainer = $KW.FlexUtils.isFlexContainer(boxModel);
            if(isFlexContainer) {
                $KW.FlexUtils.updateLayoutConfig(boxModel);
                $KW.FlexUtils.updateAutoGrowFlexConfig(boxModel);
                $KW.FlexContainer.adjustFlexContainer(boxModel);
            }
            else
                $KW.Form.initializeFlexContainersInBox(boxModel);
        }
    },

    checkProp: function(prop, value, skipValueTest) {
        var prefixes = 'Webkit Moz O ms';
        var cssPrefixes = prefixes.split(' ');
        var ucProp = prop.charAt(0).toUpperCase() + prop.slice(1),
            props = (prop + ' ' + cssPrefixes.join(ucProp + ' ') + ucProp).split(' ');

        
        var result = this.nativeTestProps(props, value);
        if(typeof result != 'undefined') {
            return result;
        }

        var i, prop, before;
        if(!$KU.testNode)
            $KU.testNode = document.createElement('test');
        var nStyle = $KU.testNode.style;

        for(i in props) {
            prop = props[i];
            before = nStyle[prop];

            if(!this.contains(prop, "-") && nStyle[prop] !== undefined) {
                
                
                
                if(!skipValueTest && typeof value != 'undefined') {
                    
                    
                    try {
                        nStyle[prop] = value;
                    } catch(e) {}

                    if(nStyle[prop] != before) {
                        return true;
                    }
                }
                
                
                else {
                    return true;
                }
            }
        }
        return false;
    },

    nativeTestProps: function(props, value) {
        var i = props.length;
        if('CSS' in window && 'supports' in window.CSS) {
            
            while(i--) {
                if(window.CSS.supports(this.domToHyphenated(props[i]), value)) {
                    return true;
                }
            }
            return false;
        }
        return undefined;
    },

    domToHyphenated: function(name) {
        return name.replace(/([A-Z])/g, function(str, m1) {
            return '-' + m1.toLowerCase();
        }).replace(/^ms-/, '-ms-');
    },

    
    jsonReplacer: function(key, value) {
        if(key === "parent" || key == "rowtemplate" || key == "rowTemplate") {
            return value && (value.id || value);
        } else if(key == "scrollerInstance" || key == "scrollingevents" || key == "scrollingEvents" || key == "ownchildrenref" || key == "touches") {
            return undefined;
        }
        return value;
    },

    
    contains: function(str, substr) {
        return !!~('' + str).indexOf(substr);
    },

    preventClickEvent: function(event, target) {
        var eType = event.type;
        var tagName = target.tagName;
        if(tagName == 'INPUT' || tagName == 'SELECT') {
            if(eType == 'change')
                $KU.changeFlag = true;
            else if(eType == 'click' && $KU.changeFlag) {
                $KU.changeFlag = false;
                return true;
            }
        }
        return false;
    },

    getTextTrasform: function(wModel, needValue) {
        var value = '';
        switch(wModel.autocapitalize) {
            case constants.TEXTBOX_AUTO_CAPITALIZE_WORDS:
            case constants.TEXTAREA_AUTO_CAPITALIZE_WORDS:
                value = "capitalize";
                break;
            case constants.TEXTBOX_AUTO_CAPITALIZE_ALL:
            case constants.TEXTAREA_AUTO_CAPITALIZE_ALL:
                value = "uppercase";
                break;
            case constants.TEXTBOX_AUTO_CAPITALIZE_SENTENCES:
            case constants.TEXTBOX_AUTO_CAPITALIZE_NONE:
            case constants.TEXTAREA_AUTO_CAPITALIZE_SENTENCES:
            case constants.TEXTAREA_AUTO_CAPITALIZE_NONE:
                value = "none";
                break;
        }
        return value;
    },

    isDefined: function(value) {
        return(typeof value == 'undefined') ? false : true;
    },

    logExecuting: function(apiName) {
        kony.web.logger('trace', 'ENTER '+ apiName);
    },

    logExecutingWithParams: function(apiName) {
    },

    logExecutingFinished: function(apiName) {
        kony.web.logger('trace', 'EXIT '+ apiName);
    },

    logWarnMessage: function(msg) {
        kony.web.logger('warn', msg);
    },

    logErrorMessage: function(msg) {
        kony.web.logger('error', msg);
    },

    logDebugMessage: function(msg) {
        kony.web.logger('debug', msg);
    },

    logPerfMessage: function(msg) {
        kony.web.logger('perf', msg);
    }


};



Object.defineProperty($KU, 'executeWidgetEventHandler', {
    value: function () {
        var widgetModel = arguments[0];
        var widgetHandler = arguments[1];
        var args = [].slice.call(arguments);
        var contextParams = [widgetModel];
        if(arguments.length > 2) {
            contextParams = contextParams.concat(args.slice(2, args.length));
        }

        return widgetHandler.apply(widgetModel, contextParams);
    },
    writable: false,
    enumerable: false,
    configurable: false
});


$KU.widgets = {
    
    invokeAddWidgetsEventForInternalWidgets: function(widgetsList) {
        if(widgetsList && widgetsList.length > 0) {
            var widget;
            while(widget = widgetsList.shift()) {
                $KU.invokeAddWidgets(widget);
            }
        }
    },

    
    invokeInitEventForInternalWidgets: function(widgetsList) {
        if(widgetsList && widgetsList.length > 0) {
            var widget;
            while(widget = widgetsList.shift()) {
                $KU.invokeWidgetInit(widget);
            }
        }
    }
};








var Arraycontains = function(val) {
    var len = this.length;
    if(len == 0)
        return false;
    else {
        for(var i = 0; i < len; i++) {
            if(this[i] == val)
                return true;
        }
    }
    return false;
};

var ArraycontainsTimerAction = function(val) {
    var len = this.length;
    if(len == 0)
        return false;
    else {
        for(var i = 0; i < len; i++) {
            if((this[i].actionName == val.actionName))
                return true;
        }
    }
    return false;
};

var Arrayremove = function(val) {
    var len = this.length;
    if(len == 0)
        return null;
    else {
        for(var i = 0; i < len; i++) {
            if(this[i] == val) {
                return this.removeRange(i);
            }
        }
    }
    return this;
};

var ArrayremoveRange = function(from, to) {
    var rest = this.slice((to || from) + 1 || this.length);
    this.length = from < 0 ? this.length + from : from;
    return this.push.apply(this, rest);
};

if(!Array.prototype.contains) {
    Object.defineProperty(Array.prototype, "contains", {
        value: Arraycontains,
        enumerable: false
    });
}
if(!Array.prototype.containsTimerAction) {
    Object.defineProperty(Array.prototype, "containsTimerAction", {
        value: ArraycontainsTimerAction,
        enumerable: false
    });
}
if(!Array.prototype.remove) {
    Object.defineProperty(Array.prototype, "remove", {
        value: Arrayremove,
        enumerable: false
    });
}
if(!Array.prototype.removeRange) {
    Object.defineProperty(Array.prototype, "removeRange", {
        value: ArrayremoveRange,
        enumerable: false
    });
}


String.prototype.trim = function() {
    return this.replace(/^\s+|\s+$/g, "");
};

String.prototype.ltrim = function() {
    return this.replace(/^\s+/, "");
};

String.prototype.rtrim = function() {
    return this.replace(/\s+$/, "");
};

String.prototype.startsWith = function(str) {
    return this.slice(0, str.length) === str;
};

kony.json = {
    concat: function(obj1, obj2) {

        for(var key in obj2) {
            obj1[key] = obj2[key];
        }

        return obj1;
    }
};


if(!Function.prototype.bind) {
    Function.prototype.bind = function(oThis) {
        if(typeof this !== "function")
            throw new TypeError("Function.prototype.bind - what is trying to be fBound is not callable");

        var aArgs = Array.prototype.slice.call(arguments, 1),
            fToBind = this,
            fNOP = function() {},
            fBound = function() {
                return fToBind.apply(this instanceof fNOP ? this : oThis || window, aArgs.concat(Array.prototype.slice.call(arguments)));
            };

        fNOP.prototype = this.prototype;
        fBound.prototype = new fNOP();

        return fBound;
    };
}


var elemInput = document.createElement("input");
$KU.isAutoCapitalizeSupported = "autocapitalize" in elemInput;

var translateOpen = 'translate' + ($KU.has3d ? '3d(' : '(');
var translateClose = $KU.has3d ? ',0)' : ')';
$KU.flexbox = false; 



owl = (function() {
    
    function Clone() {}

    
    function clone(target) {
        if(typeof target == 'object') {
            Clone.prototype = target;
            return new Clone();
        } else {
            return target;
        }
    }


    
    function copy(target) {
        if(typeof target !== 'object') {
            return target; 
        } else {
            var value = target.valueOf();
            if(target != value) {
                
                
                return new target.constructor(value);
            } else {
                
                
                
                
                if(target instanceof target.constructor && target.constructor !== Object) {
                    var c = clone(target.constructor.prototype);

                    
                    
                    for(var property in target) {
                        if(target.hasOwnProperty(property)) {
                            c[property] = target[property];
                        }
                    }
                } else {
                    var c = {};
                    for(var property in target) c[property] = target[property];
                }

                return c;
            }
        }
    }

    
    var deepCopiers = [];

    function DeepCopier(config) {
        for(var key in config) this[key] = config[key];
    }
    DeepCopier.prototype = {
        constructor: DeepCopier,

        
        canCopy: function(source) {
            return false;
        },

        
        
        
        create: function(source) {},

        
        
        
        
        
        populate: function(deepCopyAlgorithm, source, result) {}
    };

    function DeepCopyAlgorithm() {
        
        
        this.copiedObjects = [];
        thisPass = this;
        this.recursiveDeepCopy = function(source) {
            return thisPass.deepCopy(source);
        }
        this.depth = 0;
    }
    DeepCopyAlgorithm.prototype = {
        constructor: DeepCopyAlgorithm,

        maxDepth: 256,

        
        
        cacheResult: function(source, result) {
            this.copiedObjects.push([source, result]);
        },

        
        
        getCachedResult: function(source) {
            var copiedObjects = this.copiedObjects;
            var length = copiedObjects.length;
            for(var i = 0; i < length; i++) {
                if(copiedObjects[i][0] === source) {
                    return copiedObjects[i][1];
                }
            }
            return undefined;
        },

        
        
        
        deepCopy: function(source) {
            
            if(source === null) return null;

            
            if(typeof source !== 'object') return source;

            var cachedResult = this.getCachedResult(source);

            
            
            
            if(cachedResult) return cachedResult;

            
            
            
            for(var i = 0; i < deepCopiers.length; i++) {
                var deepCopier = deepCopiers[i];
                if(deepCopier.canCopy(source, this.newIdPrefix)) {
                    return this.applyDeepCopier(deepCopier, source);
                }
            }
            
            throw new Error("no DeepCopier is able to copy " + source);
        },

        
        
        
        
        
        applyDeepCopier: function(deepCopier, source) {
            
            var result = deepCopier.create(source);

            
            
            
            this.cacheResult(source, result);

            
            
            
            this.depth++;
            if(this.depth > this.maxDepth) {
                throw new Error("Exceeded max recursion depth in deep copy.");
            }

            
            deepCopier.populate(this.recursiveDeepCopy, source, result, this.newIdPrefix);

            this.depth--;

            return result;
        }
    };

    
    
    
    function deepCopy(source, maxDepth, newIdPrefix) {
        var deepCopyAlgorithm = new DeepCopyAlgorithm();
        if(maxDepth) deepCopyAlgorithm.maxDepth = maxDepth;
        if(typeof newIdPrefix != 'undefined') deepCopyAlgorithm.newIdPrefix = newIdPrefix;
        return deepCopyAlgorithm.deepCopy(source);
    }

    
    deepCopy.DeepCopier = DeepCopier;

    
    deepCopy.deepCopiers = deepCopiers;

    
    
    deepCopy.register = function(deepCopier) {
        if(!(deepCopier instanceof DeepCopier)) {
            deepCopier = new DeepCopier(deepCopier);
        }
        deepCopiers.unshift(deepCopier);
    }

    
    
    
    deepCopy.register({
        canCopy: function(source) {
            return true;
        },

        create: function(source) {
            if(source instanceof source.constructor) {
                return clone(source.constructor.prototype);
            } else {
                return {};
            }
        },

        populate: function(deepCopy, source, result) {
            for(var key in source) {
                if(source.hasOwnProperty(key) && key != 'gestures') {

                    var g = source.__lookupGetter__(key),
                        s = source.__lookupSetter__(key);

                    if(kony.enableGettersSetters && (g || s)) {
                        if(g)
                            result.__defineGetter__(key, g);
                        if(s)
                            result.__defineSetter__(key, s);
                    } else {
                        result[key] = deepCopy(source[key]);
                    }
                }
                if(key === 'gestures') {
                    result[key] = source[key];
                }
            }
            if(result.wType) {
                result.isCloned = true;
            }

            return result;
        }
    });

    
    
    deepCopy.register({
        canCopy: function(source, newIdPrefix) {
            return newIdPrefix !== false && (source instanceof kony.ui.Widget)
        },

        create: function(source) {
            var constructor = source.constructor;
            var instance = Object.create(constructor.prototype);
            constructor.apply(instance, source.constructorList);
            return instance;
        },

        populate: function(deepCopy, source, result, newIdPrefix) {

            if(newIdPrefix && source.id) {
                result.id = newIdPrefix + source.id;
                result.constructorList[0].id = result.id;
            }
            for(var key in source) {
                if(source.hasOwnProperty(key) && !this.excludeList[key]) {
                    var srcObj = source[key];
                    if(srcObj && !(srcObj instanceof kony.ui.Widget)) {
                        result[key] = deepCopy(srcObj);
                    }
                }
            }

            if(source instanceof kony.ui.ContainerWidget && source.ownchildrenref && source.ownchildrenref.length > 0) {
                for(var i = 0; i < source.ownchildrenref.length; i++) {
                    var child = source.ownchildrenref[i];
                    result.add(child.clone(newIdPrefix));
                }
            }

            

            return result;
        },

        excludeList: {
            "constructorList": true,
            "children": true,
            "ownchildrenref": true,
            "parent": true,
            "pf": true,
            "layoutConfig": true,
            "gestures": true,
            "id": true,
            "_isRendered": true,
            "immediateMaster": true
        }
    });

    
    deepCopy.register({
        canCopy: function(source) {
            return(source instanceof Array);
        },

        create: function(source) {
            return new source.constructor();
        },

        populate: function(deepCopy, source, result) {
            for(var i = 0; i < source.length; i++) {
                result.push(deepCopy(source[i]));
            }
            return result;
        }
    });

    
    deepCopy.register({
        canCopy: function(source) {
            return(source instanceof Date);
        },

        create: function(source) {
            return new Date(source);
        }
    });

    

    
    
    
    function isNode(source) {
        if(window.Node) {
            return source instanceof Node;
        } else {
            
            
            if(source === document) return true;
            return(
                typeof source.nodeType === 'number' &&
                source.attributes &&
                source.childNodes &&
                source.cloneNode
            );
        }
    }

    
    deepCopy.register({
        canCopy: function(source) {
            return isNode(source);
        },

        create: function(source) {
            
            if(source === document) return document;

            
            
            return source.cloneNode(false);
        },

        populate: function(deepCopy, source, result) {
            
            if(source === document) return document;

            
            if(source.childNodes && source.childNodes.length) {
                for(var i = 0; i < source.childNodes.length; i++) {
                    var childCopy = deepCopy(source.childNodes[i]);
                    result.appendChild(childCopy);
                }
            }
        }
    });

    return {
        DeepCopyAlgorithm: DeepCopyAlgorithm,
        copy: copy,
        clone: clone,
        deepCopy: deepCopy
    };
})();

$KI.i18n = (function() {
    
    

    var module = {
        setcurrentlocaleasync: function(locale, onsuccess, onfailure, info) {
            $KU.logExecuting('kony.i18n.setCurrentLocaleAsync');
            if(!locale) {
                $KU.logWarnMessage('No locale specified');
                return;
            }
            $KU.logExecutingWithParams('kony.i18n.setCurrentLocaleAsync', locale, onsuccess, onfailure, info);
            $KG["oldlocale"] = module.getcurrentlocale();
            
            module.initializeI18n(locale, null, onsuccess, onfailure, info);
            $KU.logExecutingFinished('kony.i18n.setCurrentLocaleAsync');
        },

        setdefaultlocaleasync: function(locale, onsuccess, onfailure, info) {
            $KU.logExecuting('kony.i18n.setDefaultLocaleAsync');
            if(!locale) {
                $KU.logWarnMessage('No locale specified');
                return;
            }
            $KU.logExecutingWithParams('kony.i18n.setDefaultLocaleAsync', locale, onsuccess, onfailure, info);
            try {
                var localeVersion = (localStorage && localStorage.getItem($KG["appid"] + "_" + "i18nVersion")) || "";
                if(!$KG["i18nVersion"] || localeVersion != $KG["i18nVersion"]) {
                    try {
                        localStorage.setItem($KG["appid"] + "_" + "i18nVersion", $KG["i18nVersion"]);
                    } catch(e) {
                        if(localStorage && (e.name == "QUOTA_EXCEEDED_ERR" || e.name == "QuotaExceededError")) {
                            if(localStorage.length === 0) {
                                $KU.logWarnMessage('Private Browsing is switched ON');
                            } else {
                                $KU.logWarnMessage('Data storage limit has exceeded');
                            }
                        } else
                            $KU.logWarnMessage('localStorage is not available');
                    }
                    module.cleanupI18nCache();
                }
            } catch(err) {
                $KU.logErrorMessage('unknown error' + err);
            }

            $KG["oldlocale"] = $KG["defaultlocale"];
            $KG["defaultlocale"] = locale;

            
            var locale = module.determineCurrentLocale();
            module.initializeI18n(locale, null, onsuccess, onfailure, info);
            $KU.logExecutingFinished('kony.i18n.setDefaultLocaleAsync');
        },

        setdefaultlocale: function() {
            $KU.logExecuting('kony.i18n.setDefaultLocale');
            var locale = arguments[0] || null,
                successcallback = arguments[1] || null,
                errorcallback = arguments[2] || null,
                initializeFn = arguments[3] || null;
            $KU.logExecutingWithParams('kony.i18n.setDefaultLocale');
            if(!locale) {
                kony.web.logger("warn", "No locale specified");
                return;
            }
            if(initializeFn) {
                $KG["locales"] = $KG["locales"].split(",");
                try {
                    var localeVersion = (localStorage && localStorage.getItem($KG["appid"] + "_" + "i18nVersion")) || "";
                    if(!$KG["i18nVersion"] || localeVersion != $KG["i18nVersion"]) {
                        try {
                            localStorage.setItem($KG["appid"] + "_" + "i18nVersion", $KG["i18nVersion"]);
                        } catch(e) {
                            if(localStorage && (e.name == "QUOTA_EXCEEDED_ERR" || e.name == "QuotaExceededError")) {
                                if(localStorage.length === 0) {
                                    kony.web.logger("warn", "Private Browsing is switched ON");
                                } else {
                                    kony.web.logger("warn", "Data storage limit has exceeded");
                                }
                            } else
                                kony.web.logger("warn", "localStorage is not available");
                        }
                        module.cleanupI18nCache();
                    }
                } catch(err) {
                    kony.web.logger('error', 'unknown error' + err);
                }
            }

            
            var locale = module.determineCurrentLocale();
            module.initializeI18n(locale, initializeFn, successcallback, errorcallback);
            $KU.logExecutingFinished('kony.i18n.setDefaultLocale');
        },

        setcurrentlocale: function(locale) {
            $KU.logExecuting('kony.i18n.setCurrentLocale');
            if(!locale)
                return;
            $KU.logExecutingWithParams('kony.i18n.setCurrentLocale', locale);
            
            module.initializeI18n(locale);
            $KU.logExecutingFinished('kony.i18n.setCurrentLocale');
        },

        getcurrentlocale: function() {
            $KU.logExecuting('kony.i18n.getCurrentLocale');
            $KU.logExecutingWithParams('kony.i18n.getCurrentLocale');
            $KU.logExecutingFinished('kony.i18n.getCurrentLocale');
            return $KG["currentlocale"];
        },

        getsupportedlocales: function() {
            $KU.logExecuting('kony.i18n.getSupportedLocales');
            $KU.logExecutingWithParams('kony.i18n.getSupportedLocales');
            $KU.logWarnMessage(' getSupportedLocales is not supported');
            var lang = $KU.getBrowserLanguage();
            $KU.logExecutingFinished('kony.i18n.getSupportedLocales');
            return IndexJL ? [null, lang] : [lang];
        },

        getcurrentdevicelocale: function() {
            $KU.logExecuting('kony.i18n.getCurrentDeviceLocale');
            $KU.logExecutingWithParams('kony.i18n.getCurrentDeviceLocale');
            var lang = $KU.getBrowserLanguage();
            var languageArr = lang.split("-");
            var retObj = {};
            retObj.language = languageArr[0];
            retObj.country = languageArr[1];
            retObj.name = lang;
            $KU.logExecutingFinished('kony.i18n.getCurrentDeviceLocale');
            return retObj;
        },

        updateresourcebundle: function(bundle, locale) {
            
            
            $KU.logExecuting('kony.i18n.updateResourceBundle');
            if(!locale || !bundle) {
                $KU.logErrorMessage('Invaid bundle and loacale as arguments');
                return;
            }
            $KU.logExecutingWithParams('kony.i18n.updateResourceBundle', bundle, locale);
            var existingBundle = {};
            var lsKey = $KG["appid"] + "_" + locale;

            try {
                if($KG[lsKey]) {
                    existingBundle = $KG[lsKey];
                } else if(localStorage) {
                    var strRetrieved = localStorage.getItem(lsKey);
                    if(strRetrieved)
                        existingBundle = JSON.parse(strRetrieved);
                }
            } catch(err) {
                $KU.logErrorMessage('unknown error ' + err);
            }

            $KU.mergeObjects(existingBundle, bundle);

            try {
                try {
                    if(!$KG[lsKey]) {
                        var bundleString = JSON.stringify(existingBundle);
                        localStorage.setItem(lsKey, bundleString);
                    }
                } catch(e) {
                    $KG[lsKey] = existingBundle;
                    if(localStorage && (e.name == "QUOTA_EXCEEDED_ERR" || e.name == "QuotaExceededError")) {
                        if(localStorage.length === 0) {
                            $KU.logWarnMessage('Private Browsing is switched ON');
                        } else {
                            $KU.logWarnMessage('Data storage limit has exceeded');
                        }
                    } else
                        $KU.logWarnMessage('localStorage is not available');
                }
            } catch(err) {
                $KU.logErrorMessage('unknown error' + err);
            }

            if($KG[lsKey]) {
                $KG[lsKey] = existingBundle;
            }
            if($KG["currentlocale"] == locale)
                $KG["i18nArray"] = $KU.convertObjectToArray(existingBundle);
            var locales = $KG["locales"];
            if(!$KU.inArray(locales, locale, true))
                locales.push(locale);
            $KU.logExecutingFinished('kony.i18n.updateResourceBundle');
        },

        setresourcebundle: function(bundle, locale) {
            
            $KU.logExecuting('kony.i18n.setResourceBundle');
            if(!locale || !bundle) {
                $KU.logErrorMessage('Invaid bundle and loacale as arguments');
                return;
            }
            $KU.logExecutingWithParams('kony.i18n.setResourceBundle', bundle, locale);
            var bundleString = JSON.stringify(bundle);

            var lsKey = $KG["appid"] + "_" + locale;
            try {
                try {
                    localStorage.setItem(lsKey, bundleString); 
                } catch(e) {
                    $KG[lsKey] = bundle;
                    if(localStorage && (e.name == "QUOTA_EXCEEDED_ERR" || e.name == "QuotaExceededError")) {
                        if(localStorage.length === 0) {
                            $KU.logWarnMessage('Privatebrowsing is Switched on');
                        } else {
                            $KU.logWarnMessage('Data storage limit has exceeded');
                        }
                    } else
                        $KU.logWarnMessage('localStorage is not available');

                }
            } catch(err) {
                $KU.logErrorMessage('unknown error' + err);
            }

            if($KG["currentlocale"] == locale) {
                var JSONObj = JSON.parse(bundleString);
                $KG["i18nArray"] = $KU.convertObjectToArray(JSONObj);
            }
            var locales = $KG["locales"];
            if(!$KU.inArray(locales, locale, true))
                locales.push(locale);
            $KU.logExecutingFinished('kony.i18n.setResourceBundle');
        },

        deleteresourcebundle: function(locale) {
            
            $KU.logExecuting('kony.i18n.deleteResourceBundle');
            var lsKey = $KG["appid"] + "_" + locale;
            try {
                localStorage && localStorage.removeItem(lsKey);
            } catch(err) {
                $KU.logErrorMessage('unknown error' + err);
            }
            $KG[lsKey] = "";
            $KU.logExecutingWithParams('kony.i18n.deleteResourceBundle', locale);
            if($KG["currentlocale"] == locale) {
                $KG["i18nArray"] = [];
            }
            $KU.removeArray($KG["locales"], locale);
            $KU.logExecutingFinished('kony.i18n.deleteResourceBundle');
        },

        isresourcebundlepresent: function(locale) {
            
            $KU.logExecuting('kony.i18n.isResourceBundlePresent');
            if(!locale) {
                $KU.logErrorMessage('Invalid arguments');
                return false;
            }
            $KU.logExecutingWithParams('kony.i18n.isResourceBundlePresent', locale);
            var res = $KU.inArray($KG["locales"], locale, true);
            if(res)
            {
                $KU.logExecutingFinished('kony.i18n.isResourceBundlePresent VIA if it is a pre-defined locale bundle');
                return true;
            }
            else {
                
                var lsKey = $KG["appid"] + "_" + locale;
                var strRetrieved = null;
                try {
                    strRetrieved = (localStorage && localStorage.getItem(lsKey)) || $KG[lsKey];
                } catch(err) {
                    kony.web.logger('error', 'unknown error' + err);
                }
                $KU.logExecutingFinished('kony.i18n.isResourceBundlePresent VIA if locale bundle is dynamically handled');
                if(strRetrieved)
                    return true;
                else {
                    $KU.logErrorMessage('String not recieved');
                    return false;
                }
            }
        },

        islocalesupportedbydevice: function(locale) {
            $KU.logWarnMessage('islocalesupportedbydevice: Method Not supported');
            return false;
        },

        getlocalizedstring: function(i18nkey) {
            
            $KU.logExecuting('kony.i18n.getLocalizedString');
            var i18nValue = $KG["i18nArray"][i18nkey];
            $KU.logExecutingWithParams('kony.i18n.getLocalizedString', i18nkey);
            $KU.logExecutingFinished('kony.i18n.getLocalizedString');
            return typeof(i18nValue) == "undefined" ? null : i18nValue;
        },

        
        determineCurrentLocale: function() {
            var supportedLocales = $KG["locales"];
            var defaultlocale = $KG["defaultlocale"];
            var lang = $KU.getBrowserLanguage();
            var deviceLocale = lang.replace("-", "_");
            var currentLocale = "";

            var res = $KU.inArray(supportedLocales, deviceLocale, true);
            if(res)
                currentLocale = deviceLocale;
            else {
                var lang = deviceLocale.split("_")[0];
                var res2 = $KU.inArray(supportedLocales, lang, true);
                if(res2)
                    currentLocale = lang;
                else
                    currentLocale = defaultlocale;
            }
            return currentLocale;
        },

        initializeI18n: function(locale, initializeFn, successcallback, errorcallback, info) {
            if(!$KG["i18nArray"])
                $KG["i18nArray"] = [];

            var lsKey = $KG["appid"] + "_" + locale;
            var strRetrieved;

            try {
                if(localStorage)
                    strRetrieved = localStorage.getItem(lsKey);
            } catch(err) {}

            if(!strRetrieved)
                module.getResource(locale, initializeFn, successcallback, errorcallback, info);
            else {
                var JSONObj = JSON.parse(strRetrieved);
                $KG["i18nArray"] = $KU.convertObjectToArray(JSONObj);
                $KG["i18nInitialized"] = true;
                $KG["currentlocale"] = locale;
                initializeFn && initializeFn();
                successcallback && successcallback($KG["oldlocale"], locale, info);
            }
        },

        
        getResource: function(locale, initializeFn, successcallback, errorcallback, info) {
            var filePath = "";

            if($KG["appmode"] == constants.APPLICATION_MODE_NATIVE)
                filePath = kony.appinit.getStaticContentPath() + $KG["platformver"] + kony.constants.RESOURCES_PATH + "/" + kony.constants.TRANSLATION_PATH + "/" + locale + "." + kony.constants.TRANSLATION_EXT + "?ver=" + $KG["version"];
            else
                filePath = kony.constants.RESOURCES_PATH + "/" + kony.constants.TRANSLATION_PATH + "/" + locale + "." + kony.constants.TRANSLATION_EXT + "?ver=" + $KG["version"];

            
            var head = document.getElementsByTagName('head')[0];
            var script = document.createElement('script');
            script.src = filePath;

            var timer = setTimeout(function() {
                kony.web.logger("error", "Timeout while loading resource bundle.");
                $KG["i18nInitialized"] = true;
                initializeFn && initializeFn();
            }, 60000);

            var sCallback = function() {
                
                kony.print("i18n resource loaded successfully");
                clearTimeout(timer);
                $KG.i18nInitialized = true;
                $KG["currentlocale"] = locale;
                if(typeof i18nObject != "undefined" && i18nObject) {
                    module.insertDB(i18nObject, locale);
                    i18nObject = "";
                }
                initializeFn && initializeFn();
                successcallback && successcallback($KG["oldlocale"], module.getcurrentlocale(), info);
            };

            var eCallback = function() {
                kony.web.logger("error", "An error has occurred while loading i18 locales");
                clearTimeout(timer);
                $KG.i18nInitialized = true;
                initializeFn && initializeFn();
                errorcallback && errorcallback($KG["oldlocale"], module.getcurrentlocale(), info);
            };

            if(!script.addEventListener) {
                script.onreadystatechange = function() {
                    if(this.readyState == 'complete' || this.readyState == 'loaded') {
                        script.onreadystatechange = null;
                        sCallback();
                    }
                }
            } else {
                script.onload = sCallback;
                script.onerror = eCallback;
            }
            head.appendChild(script);
        },

        insertDB: function(JSONData, locale) {
            var lsKey = $KG["appid"] + "_" + locale;
            var JSONObj, lsStr;
            if(typeof JSONData == "string") {
                JSONObj = JSON.parse(JSONData);
                lsStr = JSONData;
            } else {
                JSONObj = JSONData;
                lsStr = JSON.stringify(JSONData);
            }

            try {
                try {
                    localStorage.setItem(lsKey, lsStr);
                } catch(e) {

                    $KG[lsKey] = JSONObj;
                    localStorage && localStorage.removeItem($KG["appid"] + "_" + "i18nVersion");
                    if(localStorage && (e.name == "QUOTA_EXCEEDED_ERR" || e.name == "QuotaExceededError")) {
                        if(localStorage.length === 0) {
                            kony.web.logger("warn", "Private Browsing is switched ON");
                        } else {
                            kony.web.logger("warn", "Data storage limit has exceeded");
                        }
                    } else
                        kony.web.logger("warn", "localStorage is not available");
                }
            } catch(err) {}
            $KG["i18nArray"] = $KU.convertObjectToArray(JSONObj);
        },

        _addi18nPropsForWidget: function(widgetModel) {
            if($KU.inArray($KU.translatableWidgets, widgetModel.wType, true)) {
                widgetModel.canUpdateUI = false;
                var widget_i18n_properties = [];
                switch(widgetModel.wType) {
                    case "Switch":
                        i18n_properties = ["leftsidetext", "rightsidetext"];
                        break;
                    case "Form":
                        i18n_properties = ["title"];
                        break;
                    case "FlexContainer":
                    case "Box":
                        i18n_properties = ["tabname"];
                    default:
                        i18n_properties = ["text", "placeholder"];

                }
                this._updateWidgetModelWithi18n(widgetModel, i18n_properties);
                widgetModel.canUpdateUI = true;
            }
        },

        _updateWidgetModelWithi18n: function(widgetModel, i18n_properties) {
            for(var val in i18n_properties) {
                var property = i18n_properties[val];
                var i18n_property = "i18n_" + property
                if(widgetModel[i18n_property] && widgetModel[i18n_property].toLowerCase().indexOf("i18n.getlocalizedstring") != -1) {
                    widgetModel[property] = $KU.getI18NValue(widgetModel[i18n_property]);
                }
            }
        },


        _addi18nPropsForContainer: function(containerModel, childList) {
            for(var child in childList) {
                var widget = childList[child];
                var i18n_properties = [];
                var widgetModel = containerModel[widget];
                if(!widgetModel) {
                    continue;
                }
                if(widgetModel && widgetModel.children && widgetModel.children.length != 0) {
                    this._addi18nPropsForContainer(widgetModel, widgetModel.children);
                }
                this._addi18nPropsForWidget(widgetModel);
            }
        },

        
        translateFormModel: function(containerModel) {
            var childList = containerModel.children;
            if(!childList) {
                this._addi18nPropsForWidget(containerModel);
            } else {
                this._addi18nPropsForContainer(containerModel, childList);
            }
        },

        
        checkI18nStatus: function(widgetModel, attribute) {
            if(!$KG["localization"] || typeof widgetModel != "object" || $KU.isArray(widgetModel))
                return;

            if(attribute == "text" && widgetModel.i18n_text) {
                widgetModel.i18n_text = "";
            }
        },

        cleanupI18nCache: function() {
            var supportedLocales = $KG["locales"];
            for(var i = 0; i < supportedLocales.length; i++) {
                var locale = supportedLocales[i];
                var lsKey = $KG["appid"] + "_" + locale;
                try {
                    localStorage && localStorage.removeItem(lsKey);
                } catch(err) {}
                $KG[lsKey] = "";
            }
        },

        getI18nTitle: function(formModel) {
            var title = formModel.title;
            if(formModel.i18n_title && formModel.i18n_title.toLowerCase().indexOf("i18n.getlocalizedstring") != -1) {
                return $KU.getI18NValue(formModel.i18n_title);
            } else
                return title;
        },

        
        setlocalelayoutconfig: function(localeConfigObject) {
            $KU.logExecuting('kony.i18n.setLocaleLayoutConfig');
            $KU.logExecutingWithParams('kony.i18n.setLocaleLayoutConfig', localeConfigObject);
            if(localeConfigObject && localeConfigObject instanceof Object) {
                $KG['localeLayoutConfig'] = localeConfigObject;
            }
            $KU.logExecutingFinished('kony.i18n.setLocaleLayoutConfig');
        }
    };


    return module;
}());



$KW.formTransitionsMatrix = {
    "topCenter": "slidetopin",
    "bottomCenter": "slidebottomin",
    "rightCenter": "sliderightin",
    "leftCenter": "slideleftin",
    "fadeAnimation": "fadein",
    "anim1": "slidetopin",
    "anim2": "sliderightin",
    "anim3": "slideleftin",
    "anim4": "sliderightout",
    "anim5": "slideleftout",
    "anim6": "scalein",
    "anim7": "slidetoprightin",
    "anim8": "slidebottomleftin",
    "anim9": "expandvertically",
    "anim10": "slidebottomin"
};
$KW.formEndTransitionsMatrix = {
    "rightCenter": "sliderightout",
    "leftCenter": "slideleftout",
    "topCenter": "slidetopout",
    "bottomCenter": "slidebottomout",
    "fadeAnimation": "fadeout",
    "anim1": "slidetopout",
    "anim2": "sliderightout",
    "anim3": "slideleftout",
    "anim4": "sliderightin",
    "anim5": "slideleftin",
    "anim6": "scaleout",
    "anim7": "slidetoprightout",
    "anim8": "slidebottomleftout",
    "anim9": "shrinkvertically",
    "anim10": "slidebottomout"
};
$KW.stringifyScrolldirection = {
    1: "horizontal",
    2: "vertical",
    3: "both",
    4: "none"
};

$KW.Widget = {
    
    addgesturerecognizer: function(widgetModel, gestureType, gestureObj, callback) {
        if(!widgetModel)
            return null;

        var gestureEventObject = $KW.Utils.updateModelWithGesture(widgetModel, gestureType, gestureObj, callback);
        return(new $KW.touch.gesture(widgetModel, gestureEventObject)).gestureIdentifier;
    },
    
    setgesturerecognizer: function(widgetModel, gestureType, gestureObj, callback) {
        if(!widgetModel)
            return null;

        
        var _gestureType = (gestureType == 1 ? (gestureObj.taps == 1 ? 10 : 11) : gestureType);
        $KW.Widget.removegesturerecognizer(widgetModel, _gestureType);
        var gestureEventObject = $KW.Utils.updateModelWithGesture(widgetModel, gestureType, gestureObj, callback);
        return(new $KW.touch.gesture(widgetModel, gestureEventObject)).gestureIdentifier;
    },

    removegesturerecognizer: function(widgetModel, gestureType) {
        var identifier = gestureType;
        if(typeof(gestureType) === "string") {
            var gestureIdentifier = ($KG.gestures && $KG.gestures[gestureType]) ? $KG.gestures[gestureType] : null;
            if(!gestureIdentifier) return;
            widgetModel = gestureIdentifier.widgetModel;
            gestureType = gestureIdentifier.gestureType;
            delete $KG.gestures[identifier];
        }

        if(!widgetModel)
            return;

        if(gestureType == constants.GESTURE_TYPE_TAP) {
            
            $KW.Utils.removegesture(widgetModel, 10, true, identifier);
            $KW.Utils.removegesture(widgetModel, 11, true, identifier);
        } else
            $KW.Utils.removegesture(widgetModel, gestureType, true, identifier);
    },

    setgesturerecognizerforallforms: function(gestureType, gestureObj, callback) {
        $KU.logExecuting('kony.application.setGestureRecognizerForAllForms');
        $KU.logExecutingWithParams('kony.application.setGestureRecognizerForAllForms', gestureType, gestureObj, callback);
        var _gestureType = (gestureType == 1 ? (gestureObj.taps == 1 ? 10 : 11) : gestureType);
        $KW.Widget.removegesturerecognizerforallforms(_gestureType);
        var gestureEventObject = $KW.Utils.updateModelWithGesture("", gestureType, gestureObj, callback);
        $KU.logExecutingFinished('kony.application.setGestureRecognizerForAllForms');
        return(new $KW.touch.gesture("", gestureEventObject)).gestureIdentifier;
    },

    addgesturerecognizerforallforms: function(gestureType, gestureObj, callback) {
        var gestureEventObject = $KW.Utils.updateModelWithGesture("", gestureType, gestureObj, callback);
        return(new $KW.touch.gesture("", gestureEventObject)).gestureIdentifier;
    },

    removegesturerecognizerforallforms: function(gestureType) {
        $KU.logExecuting('kony.application.removeGestureRecognizerForAllForms');
        if(typeof gestureType == "string") {
            var gestureIdentifier = ($KG.gestures && $KG.gestures[gestureType]) ? $KG.gestures[gestureType] : null;
            if(!gestureIdentifier) {
                $KU.logErrorMessage('Invalid gestureType');
                return;
            }
            var identifier = gestureType;
            gestureType = gestureIdentifier.gestureType;
            delete $KG.gestures[identifier];
        }
        $KU.logExecutingWithParams('kony.application.removeGestureRecognizerForAllForms', gestureType);
        $KW.Widget.removegesturerecognizer($KG, gestureType);
        $KU.logExecutingFinished('kony.application.removeGestureRecognizerForAllForms');
    },
};


$KW.Utils = {
    isWidgetInteractable: function(widgetNode, forced) {
        var interactable = true;

        if((($KG.appbehaviors[constants.API_LEVEL] >= constants.API_LEVEL_8300 || forced)
        && widgetNode.getAttribute('kdisabled') === 'true')
        || widgetNode.getAttribute('notinmodal') === 'true') {
            interactable = false;
        }

        return interactable;
    },

    getBaseHtml: function(widgetModel, context, type, accessObj, rowIndex) {
        if($KG.appbehaviors["lazyLoadDOM"] == true) {
            widgetModel._isRendered = true;
        }

        var widgetTabId = widgetModel.tabId || "";
        var tabID = context.tabID || "";
        var id = type ? widgetModel.id : (widgetModel.pf + (widgetTabId && ("_" + widgetTabId)) + "_" + widgetModel.id);
        var tabpaneID = context.tabpaneID || "";
        var containerID = (context.container && context.container.id) || "";
        var toolTip = $KU.escapeHTMLSpecialEntities(widgetModel.tooltip);
        var isDisabled = this.isWidgetDisabled(widgetModel, context) || false;
        if(tabpaneID)
            widgetModel.tabpaneId = tabpaneID;
        if(containerID)
            widgetModel.containerId = containerID;
        var disable = isDisabled ? (" kdisabled='true' " + ((widgetModel.wType != "Image" && widgetModel.wType != "Label") ? "disabled=" + isDisabled : "")) : "";
        var contextmenu = widgetModel.contextmenu || "";
        var kuid = "";
        if(widgetModel.isCloned == true && widgetModel.kuid) {
            kuid = "kuid = '"+widgetModel.kuid +"'";
        }

        
        var kmasterObj = this.getMasterIDObj(widgetModel);
            if(kmasterObj.id != "") {
                id = kmasterObj.id;
            }
        if(widgetModel.wType == "Segment") {
            
            widgetModel.formPathId = id;
        }
        
        var accessAttr = "";
        if(widgetModel.wType != 'Calendar') {
            accessAttr = $KU.getAccessibilityValues(widgetModel);
        }
        var hoverString = ""
        if(widgetModel.onhover) {
            hoverString = "onmouseenter= '$KI.HoverEvent.executeHoverEvent(event, this)' onmousemove= '$KI.HoverEvent.executeHoverEvent(event, this)' onmouseout= '$KI.HoverEvent.executeHoverEvent(event, this)'";
        }

        return accessAttr + " id='" + id + "' kwidgettype='" + widgetModel.wType + "' kformname='" + widgetModel.pf + "'" + (tabpaneID && " ktabpaneid='" + tabpaneID + "'") + kmasterObj.kmasterid + (tabID && " ktabid='" + tabID + "'") + (containerID && " kcontainerID = '" + containerID + "'") + (contextmenu && " kcontextmenuid = '" + contextmenu.id + "'") + disable + (toolTip ? " title= '" + toolTip + "'" : "") + hoverString + " " + kuid + " ";
    },

    
    getMasterIDObj: function(widgetModel) {
        var kmasterid = widgetModel.kmasterid;
        var id = "";
        if(kmasterid && kmasterid != "") {
            widgetModel.kmasterid = kmasterid;
            id = widgetModel.pf + "_" + kmasterid + "_" + widgetModel.id;
            kmasterid = " kmasterid = '" + kmasterid + "' ";
        } else {
            kmasterid = "";
        }
        return {
            id: id,
            kmasterid: kmasterid
        };
    },

    getWidgetPathByModel: function(model) {
        var path = model.id;

        if(model.kmasterid) {
            path = model.kmasterid.split('_').join('.') + '.' + path;
        }

        return path;
    },

    getMasterWidgetModel: function(widgetModel) {
        while(widgetModel) {
            if(widgetModel.isMaster) {
                return widgetModel;
            }
            widgetModel = widgetModel.parent;
        }
    },

    getKMasterWidgetID: function(widgetModel) {
        var id = widgetModel.pf + "_" + widgetModel.id;
        if(widgetModel.kmasterid && widgetModel.kmasterid != "") {
            id = widgetModel.pf + "_" + widgetModel.kmasterid + "_" + widgetModel.id;
        }
        return id;
    },
    
    getActualWidgetModel: function(givenWidgetModel, updateUDWChildsPFFlag) {
        if(givenWidgetModel.wType == 'KComponent') {
            var proxyModel = givenWidgetModel.userWidgetProxyObject;
            if(updateUDWChildsPFFlag) {
                proxyModel.kComponentModel = givenWidgetModel;
                this.updatePFForUDWChilds(proxyModel, givenWidgetModel.pf);
            }
            return proxyModel;
        }
        return givenWidgetModel;
    },

    updatePFForUDWChilds: function(widgetModel, pf) {
        widgetModel.pf = pf;
        if(widgetModel.isContainerWidget) {
            for(var i = 0; i < widgetModel.children.length; i++) {
                var childModel = widgetModel[widgetModel.children[i]];
                this.updatePFForUDWChilds(childModel, pf);
            }
        }
    },

    isWidgetDisabled: function(wModel, context) {
        if(context && context.container && context.container.widgetsData)
            return this.isContainerWidgetDisabled(wModel, context);
        if(wModel.disabled)
            return true;
        var formId = wModel.pf;
        var pModel = wModel.parent;
        while(pModel) {
            if(pModel.disabled || (formId == (pModel.parent && pModel.parent.id))) {
                return pModel.disabled;
            }
            pModel = pModel.parent;
        }
    },

    isContainerWidgetDisabled: function(wModel, context) {

        var data = context.container.widgetsData;
        var wData = data[wModel.id];
        if(wData && wData.enable != undefined && wData.enable == false)
            return true;
        var formId = wModel.pf;
        var pData, pDisabled;
        var pModel = wModel.parent;
        while(pModel) {
            pData = data[pModel.id];
            pDisabled = (pData && pData.enable != undefined && pData.enable == false);
            if(pDisabled || (context.container.id == pModel.id)) {
                return pDisabled;
            }
            pModel = pModel.parent;
        }
    },

    isWidgetVisible: function(wModel, context) {
        if(context && context.container && context.container.widgetsData) {
            var data = context.container.widgetsData;
            var wData = data[wModel.id];
            if(wData)
                return(wData.visible != undefined ? wData.visible : wModel.isvisible);
        }
        return wModel.isvisible;
    },

    
    initializeNewWidgets: function(wArray) {


        if(wArray && wArray.length > 0) {
            for(var i = 0; i < wArray.length; i++) {
                var widgetModel = wArray[i];
                widgetModel = $KW.Utils.getActualWidgetModel(widgetModel);
                var wType = widgetModel.wType;
                switch(wType) {
                    case "Segment":
                        var segment = $KU.getNodeByModel(widgetModel);
                        if(segment) {
                            if(widgetModel.viewtype == constants.SEGUI_VIEW_TYPE_PAGEVIEW) {
                                $KG[segment.id] = new $KW.touch.pageviewScroller(segment, {
                                    widgetModel: widgetModel
                                });
                                $KW.touch.computeWidths(segment, widgetModel);
                            }
                            if(widgetModel.screenLevelWidget || widgetModel.needScroller) {
                                widgetModel.needScroller && $KU.setScrollHeight(widgetModel, segment);
                            }
                            $KW.Segment.initializeNewWidgets(segment);
                        }
                        break;
                    case "CollectionView":
                        var cvNode = $KU.getNodeByModel(widgetModel);
                        if(cvNode) {
                            if(widgetModel.needScroller) {
                                $KU.setScrollHeight(widgetModel, cvNode);
                                var pNode = cvNode.firstChild;
                            }
                            $KW.CollectionView.initializeNewWidgets(cvNode);
                        }
                        break;

                    case "FlexScrollContainer":
                        break;

                    case "Slider":
                        var slider = $KU.getNodeByModel(widgetModel);
                        if(slider) {
                            $KW.Slider.attachSliderEvents(slider.childNodes[0]);
                            kony.events.addEventListener(slider.parentNode, "click", $KW.Slider.slideClick);
                        }
                        break;

                    case "Switch":
                        var switchNode = $KU.getNodeByModel(widgetModel);
                        if(switchNode) {
                            $KW.Switch.adjustWidth(widgetModel, switchNode, true);
                            $KW.Switch.adjustHeight(widgetModel, switchNode);
                        }
                        break;

                    case "Video":
                        if($KU.isAndroid) {
                            var video = $KU.getNodeByModel(widgetModel);
                            kony.events.addEventListener(video, 'click', function(event) {
                                event = event || window.event;
                                event.srcElement.play();
                            }, false);
                        }
                        break

                    case "TabPane":
                        var tabPane = $KU.getNodeByModel(widgetModel);
                        tabPane && $KW.TabPane.setTabsHeight(tabPane.id);
                        $KW.touch.computeSnapWidths(tabPane.id, "Tabpane");
                        if(widgetModel.needScroller && tabPane) {
                            $KU.setScrollHeight(widgetModel, tabPane);
                        }
                        break

                    case "Map":
                        $KW.Map.loadMapScripts();
                        $KW.Map.setUpInteractiveCanvasMap();
                        $KW.Map.setMapsHeight(widgetModel.pf);
                        break

                    case "Browser":
                        var browser = $KU.getNodeByModel(widgetModel);
                        if(browser && widgetModel.needScroller)
                            $KU.setScrollHeight(widgetModel, browser);
                        break
                        
                    case "Label":
                        var label = $KU.getNodeByModel(widgetModel);
                        if(label && widgetModel.linespacing)
                            $KW.Label.updateLineHeight(widgetModel, label);
                        break;
                    case "ListBox":
                        if(widgetModel.viewtype == constants.LISTBOX_VIEW_TYPE_EDITVIEW) {
                            var listNode = $KU.getNodeByModel(widgetModel);
                            $KW.ListBox.initializeEditableList(listNode);
                        }
                        break;
                }

                
                $KW.Utils.initializeGesturesForWidget(widgetModel);
                if(widgetModel.ownchildrenref) {
                    this.initializeNewWidgets(widgetModel.ownchildrenref);
                }

            }
        }
        
    },

    
    reinitializeWidgets: function(containerModel) {

        var wArray = containerModel.ownchildrenref;
        for(var i = 0; i < wArray.length; i++) {
            var widgetModel = wArray[i];
            var wType = widgetModel.wType;
            if(widgetModel.isvisible == false) {
                continue;
            }

            switch(wType) {
                case "Slider":
                    var slider = $KU.getNodeByModel(widgetModel);
                    $KW.Slider.imgLoad(slider.childNodes[0]);
                    
                    break;

                case "Calendar":
                    var calendar = $KU.getNodeByModel(widgetModel);
                    $KW.Calendar.setCalElementStyle(calendar.childNodes[0], true);
                    break;

                case "Switch":
                    var element = $KU.getNodeByModel(widgetModel);
                    $KW.Switch.adjustWidth(widgetModel, element, false);
                    $KW.Switch.adjustHeight(widgetModel, element);
                    break;

                case "DataGrid":
                    
                    break;
            }

            if(widgetModel.ownchildrenref) {
                this.reinitializeWidgets(widgetModel);
            }
        }
    },

    
    resizeMap: function(wModel) {
        var map = document.querySelector("#" + wModel.pf + " div[kwidgettype='googlemap']");
        if(map) {
            var mapModel = $KU.getModelByNode(map);
            if(mapModel.mapSource == "non-native")
                google.maps.event.trigger($KW.Map.map, 'resize');
        }
    },

    updateContent: function(widgetModel, property, dataArray, action, index, secIndex, count) {
        
        var widgetData = widgetModel[property];

        if(widgetModel.wType == "Segment" && widgetModel.hasSections && widgetData && !["setdata", "removeall"].contains(action)) {
            $KW.Segment.updateSectionContent(widgetData, dataArray, action, index, secIndex);
            return;
        }

        if(widgetModel.wType == "CollectionView" && widgetModel.hasSections && widgetData && !["setdata", "removeall"].contains(action)) {
            $KW.CollectionView.Data.updateSectionContent(widgetData, dataArray, action, index, secIndex, count);
            return;
        }

        switch(action) {
            case "setdata":
                widgetModel.canUpdateUI = false;
                widgetModel[property] = dataArray;
                widgetModel.canUpdateUI = true;
                break;

            case "setdataat":
                widgetModel[property] && widgetModel[property].length > index
                if(widgetModel.wType == "CollectionView") {
                    for(var i = 0; i < dataArray.length; i++) {
                        widgetModel[property].splice(index++, 1, dataArray[i]);
                    }
                } else {
                    widgetModel[property].splice(index, 1, dataArray)
                }
                break;

            case "addall":
                var fillarray = IndexJL ? [null] : [];
                var newDataArray;
                widgetModel.canUpdateUI = false
                widgetModel[property] = widgetModel[property] || fillarray;

                
                
                if(IndexJL && !dataArray[0] && (dataArray[1] && !dataArray[1].template)) {
                    newDataArray = $KU.cloneObj(dataArray);
                    newDataArray.shift();
                }
                widgetModel.canUpdateUI = true
                $KU.addArray(widgetModel[property], newDataArray || dataArray);
                break;

            case "addat":
            case "adddataat":
                if(widgetModel[property]) {
                    var noOfRows = widgetModel[property].length - IndexJL;
                    index = (index <= IndexJL) ? IndexJL : (index > noOfRows ? noOfRows + 1 : index);
                    if($KU.isArray(dataArray)) {
                        for(var i = IndexJL; i < dataArray.length; i++) {
                            widgetModel[property].splice(index++, 0, dataArray[i]);
                        }
                    } else {
                        if(!widgetModel[property] || widgetModel[property].length <= IndexJL) {
                            widgetModel[property] = (IndexJL) ? [null] : [];
                            widgetModel[property].push(dataArray);
                        } else {
                            widgetModel[property].splice(index, 0, dataArray);
                        }
                    }
                }
                break;

            case "removeall":
                widgetModel.canUpdateUI = false;
                widgetModel[property] = dataArray;
                widgetModel.canUpdateUI = true;
                if(widgetModel.wType == "Segment" && widgetModel.behavior != "default")
                    widgetModel.selectedindices = null;
                break;

            case "removeat":
                (widgetModel[property] && widgetModel[property].length >= index && widgetModel[property][index]) && widgetModel[property].splice(index, 1);
                break;

            case "removedataat":
                if(widgetModel.wType == "CollectionView") {
                    (widgetModel[property] && widgetModel[property].length >= index && widgetModel[property][index]) && widgetModel[property].splice(index, count);
                }
                break;

        }
    },
    updateContainerData: function(childModel, childNode, canExecute, eventType) {
        var row = $KU.getParentByAttribute(childNode, "index");
        if(row) {
            var container = row.parentNode.parentNode;
            var containerModel = $KU.getModelByNode(container);
            $KW[containerModel.wType].updateData(childModel, childNode, containerModel, row, canExecute, eventType);
        }
    },

    
    updateContainerMasterData: function(containerModel, item, childModel, childNode, eventType) {
        var map = containerModel.widgetdatamap; 
        var context;
        
        if(map) {
            map = $KU.isArray(map) ? map[IndexJL] : map;
        }
        var clonedModel = childModel;
        if(containerModel.wType == 'Segment' || containerModel.wType == 'CollectionView') {
            context = {};
            var sectionIndex = context.sectionIndex = containerModel.currentIndex[0];
            var clonedTemplate;
            if(containerModel.wType == 'Segment') {
                var rowIndex = context.rowIndex = containerModel.currentIndex[1];
                clonedTemplate = $KW.Segment.getClonedModel(containerModel, rowIndex, sectionIndex);
            } else {
                var itemIndex = context.itemIndex = containerModel.currentIndex[1];
                clonedTemplate = $KW.CollectionView.Utils.getClonedModel(containerModel, itemIndex, sectionIndex);
            }
            if(!clonedTemplate) {
                return;
            }
            clonedModel = $KU.getValueFromObjectByPath($KW.Utils.getWidgetPathByModel(childModel), clonedTemplate);
            context.widgetInfo = containerModel;
        }
        var childMap = map ? map[$KW.Utils.getWidgetPathByModel(childModel)] : $KW.Utils.getWidgetPathByModel(childModel);
        var content = item[childMap];
        if(content instanceof Object) {
            if(childModel.wType == "Calendar") {
                if($KW.Calendar.isMultiRangeCalendar(childModel)) {
                    content.selectedDates = childModel.selecteddates;
                } else {
                    content.dateComponents = childModel.datecomponents;
                }
            } else if(childModel.wType == "CheckBoxGroup") {
                $KW.Utils.setSelectedKeys(content, childNode.checked, (content.selectedkeys || content.selectedKeys) || (IndexJL == 1 ? [null] : []), childNode.value);
                $KW.Utils.setSelectedValueProperty(content, (content.masterData || content.masterdata), "selectedkeys");
                content.selectedKeys = content.selectedkeys;
                content.selectedKeyValues = content.selectedkeyvalues;
            } else if(childModel.wType == "RadioButtonGroup") {
                content.selectedkey = childModel.selectedkey;
                content.selectedKey = childModel.selectedkey;
                $KW.Utils.setSelectedValueProperty(content, content.masterData || content.masterdata, "selectedkey");
            } else if(childModel.wType == 'TextField' || childModel.wType == 'TextArea'){ 
                if(clonedModel.restrictcharactersset && eventType == "input"){
                    content.text = $KW.Utils.restrictCharactersSet(childNode, clonedModel);
                } else{
                    content.text = childModel.text;
                }
            }
            else if(childModel.wType == 'Switch')
                content.selectedIndex = childModel.selectedindex;
            else if(childModel.wType == 'Slider')
                content.selectedValue = childModel.selectedvalue;
            else if(childModel.wType == 'ListBox') {
                if(clonedModel.multiple == true) {
                    $KW.Utils.setSelectedKeysListBox(content, childNode);
                    $KW.Utils.setSelectedValueProperty(content, (content.masterData || content.masterdata), "selectedkeys");
                    content.selectedKeys = content.selectedkeys;
                    content.selectedKeyValues = content.selectedkeyvalues;
                } else {
                    content.selectedkey = childModel.selectedkey;
                    content.selectedKey = childModel.selectedkey;
                    $KW.Utils.setSelectedValueProperty(content, content.masterData || content.masterdata, "selectedkey");
                }
               if(clonedModel.viewType == constants.LISTBOX_VIEW_TYPE_EDITVIEW){
                   
               }
            }
            this.updateChildModel(clonedModel, content);
        } else {
            if(childModel.wType == 'TextField' || childModel.wType == 'TextArea') {
                item[childMap] = childModel.text;
            } else if(childModel.wType == 'Switch') {
                item[childMap] = childModel.selectedindex;
            } else if(childModel.wType == 'Slider') {
                item[childMap] = childModel.selectedvalue;
            } else if(childModel.wType == "Calendar") {
                if($KW.Calendar.isMultiRangeCalendar(childModel)) {
                    item[childMap] = {
                        selectedDates: childModel.selecteddates,
                        dateFormat: childModel.dateformat
                    };
                } else {
                    item[childMap] = {
                        dateComponents: childModel.datecomponents,
                        dateFormat: childModel.dateformat
                    };
                }
            }
            this.updateChildModel(clonedModel, item[childMap]);
        }

        var callback;
        if(clonedModel.onSelection || clonedModel.onselection) {
            callback = $KU.returnEventReference(clonedModel.onselection || clonedModel.onSelection); 
        } else {
            callback = eventType && $KU.returnEventReference(clonedModel[eventType]);
        }

        if(callback) {
            if(context) {
                $KU.executeWidgetEventHandler(clonedModel, callback, context);
            } else {
                $KU.executeWidgetEventHandler(clonedModel, callback);
            }

        }
    },
    
    
    updateContainerDataInDOM: function(node, containerId) {
        
        var containerModel = $KW.Utils.getContainerModelById(node, containerId);
        if(containerModel) {
            if(containerModel.wType == 'Segment' || containerModel.wType == 'CollectionView') {
                var rowData;
                var row = $KU.getParentByAttribute(node, "index");
                var index = parseInt(row.getAttribute("index"));
                if(containerModel.hasSections) {
                    var secIndices = row.getAttribute("secindex").split(',');
                    var secIndex = parseInt(secIndices[0]);
                    var rowIndex = parseInt(secIndices[1]);
                    if(containerModel.wType == 'Segment') {
                        rowData = (rowIndex == -1) ? containerModel.data[secIndex][IndexJL] : containerModel.data[secIndex][IndexJL + 1][rowIndex];
                    } else {
                        if(node.getAttribute('type') == 'HeaderBox') {
                            rowData = containerModel.data[secIndex][IndexJL];
                        } else if(node.getAttribute('type') == 'FooterBox') {
                            rowData = containerModel.data[secIndex][IndexJL + 2];
                        } else {
                            rowData = containerModel.data[secIndex][IndexJL + 1][rowIndex];
                        }
                    }
                } else
                    rowData = containerModel.data[index];

                node.dataObj = {
                    data: rowData,
                    map: containerModel.widgetdatamap,
                    containerModel: containerModel
                };
            }
        }
    },

    getContainerNodeByparent: function(node, containerId) {
        var cur = node;
        if(containerId) {
            var id;
            while(cur) {
                id = cur.id;
                if(id) {
                    id = id.substring(id.lastIndexOf("_") + 1);
                }
                if(id == containerId) {
                    break
                }
                cur = cur.parentNode;
            }
        }
        return cur;

    },

    getContainerModelById: function(node, containerId) {
        var model = '';
        var cur = this.getContainerNodeByparent(node, containerId);
        while(cur) {
            model = $KU.getModelByNode(cur);
            if(model.wType == "Segment" || model.wType == "CollectionView") {
                break;
            } else {
                cur = this.getContainerNodeByparent(cur.parentNode, containerId);

            }
        }
        return model;
    },


    getSegProperty: function(prop) {
        var key = $KU.segmentKeyMap[prop];
        return key || prop;
    },
    getScrollerInstance: function(widgetModel) {
        var scrollerId = (widgetModel.pf ? widgetModel.pf + "_" : "") + widgetModel.id + "_scroller";
        if(widgetModel.kmasterid) {
            scrollerId = $KW.Utils.getKMasterWidgetID(widgetModel) + "_scroller"; 
        }
        return $KG[scrollerId];
    },



    
    updateChildModel: function(childModel, data) {
        childModel.canUpdateUI = false;

        if(data instanceof Object) {
            var isGroupWidget = (childModel.wType == "RadioButtonGroup" || childModel.wType == "CheckBoxGroup" || childModel.wType == "ListBox");
            if(isGroupWidget) {
                childModel.masterdata = "";
                childModel.masterdatamap = "";
                if(childModel.wType == "RadioButtonGroup") {
                    childModel.selectedkey = null;
                    !IndexJL && (data.selectedkey = data.selectedKey);
                }
                if(childModel.wType == "CheckBoxGroup" || childModel.wType == "ListBox") {
                    childModel.selectedkeys = null;
                    !IndexJL && (data.selectedkeys = data.selectedKeys);
                }
            }
            if(data instanceof Array) {
                if(childModel.wType == "Calendar") {
                    if($KW.Calendar.isMultiRangeCalendar(childModel)) {
                        if($KW.Calendar.isSelectedDatesValid(childModel, data)) {
                            childModel.selecteddates = $KW.Calendar.setTimeInDateComponents(data);
                        } else {
                            kony.web.logger("error", "Invalid date selection");
                        }
                    } else {
                        childModel.datecomponents = data;
                        childModel.date = data.slice(0, 3);
                    }
                }
            } else {
                for(var prop in data) {
                    var key = $KW.Utils.getSegProperty(prop).toLowerCase();
                    if(key == "disabled")
                        childModel[key] = !data[prop];
                    else {
                        if(childModel.wType == "Calendar" && key == "selecteddates" &&
                            $KW.Calendar.isMultiRangeCalendar(childModel)) {
                            if($KW.Calendar.isSelectedDatesValid(childModel, data[prop])) {
                                childModel.selecteddates = $KW.Calendar.setTimeInDateComponents(data[prop]);
                            } else {
                                kony.web.logger("error", "Invalid date selection");
                            }
                        } else {
                            childModel[key] = data[prop];
                        }
                    }

                    if(childModel.wType == "Image") {
                        if(prop == "base64")
                            childModel.srcType = 2;
                        else if(prop == "src")
                            childModel.srcType = 1;
                    }

                    if(childModel.wType == "Calendar" && key == "datecomponents") {
                        if(data[prop] == null) {
                            childModel.date = data[prop];
                        } else {
                            childModel.date = data[prop].slice(0, 3);
                        }
                    }
                    
                    if(isGroupWidget && data.masterData && data.masterData.length > IndexJL && (key == 'selectedkeys' || key == 'selectedkey')) {
                        $KW.Utils.setSelectedValueProperty(data, data.masterData, key, data[prop]);
                    }
                }
            }
            
            if(childModel.text) {
                var textValue = childModel.text;
                var isI18NCallExists = /i18n.getlocalizedstring/gi.test(textValue);
                if(isI18NCallExists)
                    childModel.text = $KU.getI18NValue(textValue);
            }
        } else if(childModel.wType == "Slider") {
            childModel.selectedvalue = data;
        } else if(childModel.wType == "Switch") {
            childModel.selectedindex = data;
        } else if(childModel.wType != "Image") { 
            childModel.text = data;
        } else { 
            childModel.src = data;
            childModel.srcType = 1;
        }
        childModel.canUpdateUI = true;
    },

    
    updateLayoutData: function(container, layoutModel, data) {
        if(data instanceof Object) {
            for(var ele in data) {
                if(ele != 'template' && ele != 'children' && ele != 'metaInfo') {
                    var mapkey = ele;
                    if(container.widgetdatamap) mapkey = kony.utils.getKey(container.widgetdatamap, ele);
                    var tempModel = layoutModel.parent;
                    var eleModel = tempModel ? tempModel[mapkey] : layoutModel[mapkey];
                    if(eleModel) {
                        this.updateChildModel(eleModel, data[ele]);
                    }
                }
            }
        }
    },

    
    getClonedTemplateNode: function(element, widgetModel, propertyName) {
        var containerId = element && element.getAttribute("kcontainerID");
        if(containerId) {
            var containerModel = $KW.Utils.getContainerModelById(element, containerId);
            if(containerModel.wType == "CollectionView") {
                var context = widgetModel.rowContext;
                element = $KW.CollectionView.Utils.getNodeByContext(containerModel, {
                    "sectionIndex": context.secIndex,
                    "itemIndex": context.itemIndex
                }, widgetModel);
                propertyName && $KW.Utils.updateClonedModelData(widgetModel, containerModel, propertyName);
            }
        }
        return element;
    },

    updateClonedModelData: function(widgetModel, containerModel, propertyName) {
        var context, itemData;
        if(containerModel.wType != "CollectionView") {
            return;
        }
        context = widgetModel.rowContext;
        var itemData = $KW.CollectionView.Data.getRowDataByIndex(containerModel, [context.secIndex, context.itemIndex]);
        var widgetData = itemData[widgetModel.id];
        if(typeof widgetData == "object") {
            if((widgetModel.wTpe == "FlexContainer" || widgetModel.wTpe == "FlexScrollContainer") && (!widgetData)) {
                widgetData = {};
            }
            widgetData[propertyName] = widgetModel[propertyName];
        } else {
            var newData = {};
            var defaultProp = this.getDefaultProperyForContanierWidgets(widgetModel);
            newData[defaultProp] = widgetData;
            newData[propertyName] = widgetModel[propertyName];

            itemData[widgetModel.id] = newData;
        }

    },

    getDefaultProperyForContanierWidgets: function(model) {
        var defaultProperty = "text";
        if(model.wType == "Image") {
            defaultProperty = "src";
        } else if(model.wType == "Switch") {
            defaultProperty = "selectedIndex";
        } else if(model.wType == "Slider") {
            defaultProperty = "selectedValue";
        } else if(model.wType == "Calendar") {
            defaultProperty = "dateComponents";
        } else if(this.isGroupWidget(model)) {
            defaultProperty = "masterdata";
        }
        return defaultProperty;
    },

    isGroupWidget: function(model) {
        return(['CheckBoxGroup', 'RadioButtonGroup', 'ListBox'].contains(model.wType));
    },

    setSelectedKeys: function(widgetModel, checked, keys, value) {

        var result = $KU.inArray(keys, value);
        if(checked && !result[0]) {
            keys.push(value);
        } else if(result[0]) {
            keys.splice(result[1], 1);
        }
        widgetModel.selectedkeys = keys.length > IndexJL ? keys : null;
    },
    setSelectedKeysListBox: function(widgetModel, node) {
        var keys = [];
        for(var i = 0; i < node.children.length; i++) {
            if(node.children[i].selected) {
                keys.push(node.children[i].value);
            }
        }
        widgetModel.selectedkeys = keys.length > IndexJL ? keys : null;
    },
    

    setSelectedValueProperty: function(widgetModel, choices, property, value) {

        switch(property) {

            case "selectedkey":
                var selectedKey = value || widgetModel.selectedkey;
                for(var i = IndexJL; i < (choices.length); i++) {
                    var key = choices[i][IndexJL];
                    if(selectedKey == key) {
                        widgetModel["selectedkeyvalue"] = choices[i];
                        if(value) {
                            widgetModel.selectedKeyValue = widgetModel.selectedkeyvalue;
                        }
                        break;
                    }
                }
                break;

            case "selectedkeys":
                var retVal = [];
                var selectedKeys = value || widgetModel.selectedkeys;
                var flag = false;
                if(IndexJL == 1) retVal = [null]; 

                for(i = IndexJL; i < (choices.length); i++) {
                    var key = choices[i][IndexJL];
                    if($KU.inArray(selectedKeys, key)[0]) {
                        retVal.push(choices[i]);
                        flag = true
                    }
                }
                widgetModel["selectedkeyvalues"] = flag ? retVal : null;
                if(value) {
                    widgetModel["selectedKeyValues"] = widgetModel["selectedkeyvalues"];
                }
                break;
        }
    },

    restrictCharactersSet: function(target, textModel) {
        var restrictCharactersSet = "";
        var pos = target.selectionStart;
        var data = target.value[pos-1];
        restrictCharactersSet = textModel.restrictcharactersset;
        if(restrictCharactersSet) {
            if(restrictCharactersSet.indexOf(data) != -1) {
                target.value = target.value.slice(0, pos-1) + target.value.slice(pos, target.value.length);
                target.selectionStart = target.selectionEnd = pos-1;
            }
        }
        return target.value;
    },

    getMasterData: function(widgetModel) {

        var choices = $KU.cloneObj(widgetModel.masterdata);
        if(!choices || (choices && choices.length == 0)) {
            var map = widgetModel.masterdatamap;
            if(map)
                choices = this.convertmap(widgetModel.masterdatamap);
        }
        if(choices) {
            var data;
            if(widgetModel.needsectionheaders) {
                var innerChoices;
                for(var i = IndexJL; i < choices.length; i++) {
                    innerChoices = choices[i][1 + IndexJL];
                    for(var j = IndexJL; j < innerChoices.length; j++) {
                        if(choices[i][1 + IndexJL] && typeof(data) != "number" && choices[i][1 + IndexJL].toLowerCase().indexOf("i18n.getlocalizedstring") != -1)
                            choices[i][1 + IndexJL] = $KU.getI18NValue(choices[i][1 + IndexJL]);
                    }
                }
            } else {
                for(var i = IndexJL; i < choices.length; i++) {
                    if(choices[i][1 + IndexJL] && typeof(choices[i][1 + IndexJL]) != "number" && choices[i][1 + IndexJL].toLowerCase().indexOf("i18n.getlocalizedstring") != -1)
                        choices[i][1 + IndexJL] = $KU.getI18NValue(choices[i][1 + IndexJL]);
                }
            }
        }
        return choices || [];
    },

    
    convertmap: function(map) {

        var len = map.length;
        var key = map[len - 2];
        var value = map[len - 1];
        var innerMap = map[IndexJL];
        var choices = [];

        if(IndexJL == 1) 
            choices = [null];

        for(var i = IndexJL; i < (innerMap.length); i++) {
            var key1 = innerMap[i][key];
            var displayValue1 = innerMap[i][value];
            var accessConfig = innerMap[i]['accessibilityConfig'];
            if(displayValue1 != "" && key1 != "") {
                if(IndexJL == 1) 
                    choices.push([null, key1, displayValue1]);
                else
                    choices.push(accessConfig ? [key1, displayValue1, accessConfig] : [key1, displayValue1]);
            }
        }
        return choices;
    },




    
    getScrolledHeight: function() {
        var isNetScape = (navigator.appName.indexOf("Netscape") != -1);
        var scrolledHeight = isNetScape ? pageYOffset : document.documentElement && document.documentElement.scrollTop ? document.documentElement.scrollTop : document.body.scrollTop;
        return scrolledHeight;
    },

    
    getViewPortHeight: function() {
        var isNetScape = (navigator.appName.indexOf("Netscape") != -1);
        var viewportHeight = isNetScape ? innerHeight : document.documentElement && document.documentElement.clientHeight ? document.documentElement.clientHeight : document.body.clientHeight;
        return viewportHeight;
    },

    
    getViewPortWidth: function() {
        var isNetScape = (navigator.appName.indexOf("Netscape") != -1);
        var viewportWidth = isNetScape ? innerWidth : document.documentElement && document.documentElement.clientWidth ? document.documentElement.clientWidth : document.body.clientWidth;
        return viewportWidth;
    },


    setProgressIndicator: function(node, model) {
        var progressdivcontainer = $KU.getElementById("__progressdiv");
        if(progressdivcontainer)
            progressdivcontainer.parentNode.removeChild(progressdivcontainer);
        var konymodel = $KU.getModelByNode(node);
        var skin = (model && model.skin) || (konymodel && konymodel.skin);
        var progressdiv = document.createElement('div');
        progressdiv.setAttribute('id', '__progressdiv');
        progressdiv.setAttribute("progressindicator", "true");
        progressdiv.setAttribute("progressskin", skin);
        progressdiv.setAttribute('style', 'width:' + node.clientWidth + 'px' + ';height:' + node.clientHeight + 'px' + ';position:absolute;opacity:0.6;');
        return progressdiv;
    },

    updateNormalImage: function(model) {
        var node = $KU.getNodeByModel(model);
        if(!node || !model.backgroundimage)
            return;

        
        var backgroundimage = model.backgroundimage;
        var style = $KW.Utils.getNormalImageStyle(model);
        
        if(backgroundimage.index)
            node = document.querySelectorAll("#" + node.id)[backgroundimage.index - 1];

        var imagesrc = $KU.getImageURL(backgroundimage.imageurl);
        $KU.imagePreloader(imagesrc, function(node, style) {
            return function(event) {
                event = event || window.event;
                var srcElement = event.target || event.srcElement;

                var model = $KU.getModelByNode(node);
                var backgroundimage = model.backgroundimage;

                if(event.type == "error") {
                    if(backgroundimage.imagewhenfailed) {
                        var imagesrc = $KU.getImageURL(backgroundimage.imagewhenfailed);
                        var heightwidth = backgroundimage.heightwidth;
                        node.style.background = "url(" + imagesrc + ") no-repeat center center";

                        if(heightwidth) {
                            
                            node.style.height = heightwidth[1] + 'px';
                        }
                        return;
                    }
                }

                node.setAttribute('style', style);
                
                node.style.display = (model.isvisible ? "" : "none");

                if(backgroundimage && backgroundimage.maintainaspectratio) {
                    var naturalHeight = srcElement.naturalHeight || srcElement.height;
                    var naturalWidth = srcElement.naturalWidth || srcElement.width;
                    var aspectratio = naturalWidth / naturalHeight;
                    if(!isNaN(aspectratio)) {
                        node.setAttribute('aspect-ratio', aspectratio);
                        var width = node.clientWidth;
                        var newHeight = Math.round(1 / aspectratio * width);
                        node.style.height = newHeight + 'px';
                    }
                }
            }
        }(node, style));
    },

    
    getNormalImageStyle: function(model) {
        var style = '';
        var backgroundimage = model.backgroundimage;
        if(backgroundimage) {
            var maintainaspectratio = backgroundimage.maintainaspectratio;
            var heightwidth = backgroundimage.heightwidth;
            var imagesrc = $KU.getImageURL(backgroundimage.imageurl);
            style += 'background-image: url(' + imagesrc + '); background-repeat: no-repeat; ';
        }
        if(maintainaspectratio)
            style += 'background-size:contain; ';

        if(heightwidth)
            style += (maintainaspectratio ? '' : ' width:' + heightwidth[2] + 'px;') + 'height:' + heightwidth[1] + 'px;';
        return style;
    },

    convertPhoneAlphabetToNumber: function(input) {
        var inputlength = input.length;
        input = input.toLowerCase();
        var phonenumber = "";
        for(var i = 0; i < inputlength; i++) {
            var character = input.charAt(i);
            if(phonenumber.length > 10)
                break;
            switch(character) {
                case '0':
                    phonenumber += "0";
                    break;
                case '1':
                    phonenumber += "1";
                    break;
                case '2':
                    phonenumber += "2";
                    break;
                case '3':
                    phonenumber += "3";
                    break;
                case '4':
                    phonenumber += "4";
                    break;
                case '5':
                    phonenumber += "5";
                    break;
                case '6':
                    phonenumber += "6";
                    break;
                case '7':
                    phonenumber += "7";
                    break;
                case '8':
                    phonenumber += "8";
                    break;
                case '9':
                    phonenumber += "9";
                    break;
                    
                case 'a':
                case 'b':
                case 'c':
                    phonenumber += "2";
                    break;
                case 'd':
                case 'e':
                case 'f':
                    phonenumber += "3";
                    break;
                case 'g':
                case 'h':
                case 'i':
                    phonenumber += "4";
                    break;
                case 'j':
                case 'k':
                case 'l':
                    phonenumber += "5";
                    break;
                case 'm':
                case 'n':
                case 'o':
                    phonenumber += "6";
                    break;
                case 'p':
                case 'q':
                case 'r':
                case 's':
                    phonenumber += "7";
                    break;
                case 't':
                case 'u':
                case 'v':
                    phonenumber += "8";
                    break;
                case 'w':
                case 'x':
                case 'y':
                case 'z':
                    phonenumber += "9";
                    break;
            }
        }
        return phonenumber;
    },


    getCurrentPosition: function() {
        if(self.pageYOffset)
            return self.pageYOffset;
        if(document.documentElement && document.documentElement.scrollTop)
            return document.documentElement.scrollTop;
        if(document.body.scrollTop)
            return document.body.scrollTop;
        return 0;
    },

    scrollTo: function(y, popup) {
        if(popup && popup != "undefined") {
            popup = $KU.getElementById(popup);
            popup.scrollTop = y;
        } else
            window.scrollTo(0, y);
    },

    checkViewport: function(ele) {
        var eleDimensions, parentDimensions, parentNode;
        var html = document.documentElement;
        eleDimensions = ele.getBoundingClientRect();
        parentNode = ele.parentNode;
        parentDimensions = parentNode.getBoundingClientRect();
        while(parentNode.tagName != "FORM") {
            if(((eleDimensions.top >= parentDimensions.top) && (eleDimensions.top <= parentDimensions.bottom)) && ((eleDimensions.right >= parentDimensions.left) && (eleDimensions.left >= parentDimensions.left) && (eleDimensions.left <= parentDimensions.right))) {
                return true;
            }
            parentNode = parentNode.parentNode;
        }
    },

    checkElementViewportHeight: function(el) {
        var parentDimensions, checkdiff, formele;
        var parent = el.parentNode;
        var eleDimensions = el.getBoundingClientRect();
        var formchk = false;
        while(parent && !formchk) {
            formele = parent.tagName;
            if(formele == "FORM") {
                formchk = true;
            }
            parentDimensions = parent.getBoundingClientRect();
            diff_top = eleDimensions.bottom - parentDimensions.top;
            diff_bottom = parentDimensions.bottom - eleDimensions.top;
            diff_left = eleDimensions.right - parentDimensions.left;
            diff_right = parentDimensions.right - eleDimensions.left;

            checkdiff = (diff_bottom >= eleDimensions.height / 2) && (diff_top >= eleDimensions.height / 2) && (diff_left >= eleDimensions.width / 2) && (diff_right >= eleDimensions.width / 2);

            if(formchk) {
                if(Math.round(diff_top) >= parentDimensions.bottom) {
                    return false;
                }
            }

            if(!checkdiff) {
                return false;
            }
            parent = parent.parentNode;
        }
        return true;
    },

    scrollToElement: function(widgetModel, el) {
        var startY, stopY = 0;
        var popup = false;
        var scrollElement = el;
        var focusElement = el;
        var parentModel = $KG.allforms[widgetModel.pf];
        if(parentModel && parentModel.wType == "Popup") {
            popup = true;
        }
        while(scrollElement) {
            if(Math.abs(scrollElement.offsetHeight - scrollElement.scrollHeight) > 1 || (scrollElement.tagName == "HTML" && !popup)) {
                var boxId = scrollElement.id;
                startY = scrollElement.scrollTop;
                stopY = startY + stopY + focusElement.getBoundingClientRect().top - scrollElement.getBoundingClientRect().top;
                var scrollTop = Math.abs(startY);
                var scrollHeight = (scrollElement.tagName == 'BODY') ? $KU.getWindowHeight() : scrollElement.offsetHeight;
                var scrollBottom = scrollTop + scrollHeight;
                var tempHeight = focusElement.offsetHeight;
                var tempTop = focusElement.offsetTop - scrollElement.getBoundingClientRect().top;
                var tempBottom = tempTop + tempHeight;
                if(stopY > scrollHeight || scrollBottom < tempBottom || (scrollTop > 0 && scrollTop > tempBottom) || (scrollElement.tagName == "HTML")) {
                    this.animateY(startY, stopY, boxId);
                    stopY = 0;
                }

                focusElement = scrollElement;
            }
            scrollElement = scrollElement.parentNode;
        }
        try {
            
            el.focus();
        } catch(e) {}

    },

    animateY: function(startY, stopY, popupID) {

        var distance = stopY > startY ? stopY - startY : startY - stopY;
        if(distance < 100) {
            $KW.Utils.scrollTo(stopY, popupID);
            try {
                el.focus();
            } catch(e) {}
            return;
        }
        var speed = Math.round(distance / 100);
        if(speed >= 20)
            speed = 20;
        var step = Math.round(distance / 25);
        var leapY = stopY > startY ? startY + step : startY - step;
        var timer = 0;
        if(stopY > startY) {
            for(var i = startY; i < stopY; i += step) {
                setTimeout("$KW.Utils.scrollTo(" + leapY + ", '" + popupID + "')", timer * speed);
                leapY += step;
                if(leapY > stopY)
                    leapY = stopY;
                timer++;
            }
        } else {
            for(var i = startY; i > stopY; i -= step) {
                setTimeout("$KW.Utils.scrollTo(" + leapY + ", '" + popupID + "')", timer * speed);
                leapY -= step;
                if(leapY < stopY)
                    leapY = stopY;
                timer++;
            }
        }
    },
    getOffset: function(el) {
        var left = el.offsetLeft,
            top = el.offsetTop;

        while(el = el.offsetParent) {
            left += el.offsetLeft;
            top += el.offsetTop;
        }

        return {
            left: left,
            top: top
        };
    },

    initializeFormGestures: function(formModel) {
        var i;

        
        if(formModel.headers && formModel.headers.length > 0) {
            for(i = 0; i < formModel.headers.length; i++) {
                $KW.Utils.initializeGestures(formModel.headers[i]);
            }
        }
        
        $KW.Utils.initializeGestures(formModel);
        
        if(formModel.footers && formModel.footers.length > 0) {
            for(i = 0; i < formModel.footers.length; i++) {
                $KW.Utils.initializeGestures(formModel.footers[i]);
            }
        }

    },

    initializeGestures: function(containerModel) {

        $KW.Utils.initializeGesturesForWidget(containerModel);
        var childList = containerModel.children;
        for(var i = 0; i < childList.length; i++) {
            var childModel = containerModel[childList[i]];
            childModel = $KW.Utils.getActualWidgetModel(childModel);

            if(childModel && childModel.children && childModel.children.length != 0) {
                $KW.Utils.initializeGestures(childModel);
            } else {
                $KW.Utils.initializeGesturesForWidget(childModel);
            }
        }
    },

    initializeGesturesForWidget: function(widgetModel) {
        if(widgetModel.wType == "Segment" || widgetModel.wType == "CollectionView") {
            $KW.Utils.initializeContainerGestures(widgetModel);
        } else {
            var element = $KU.getNodeByModel(widgetModel)
            $KW.Utils.addGesturesToWidget(widgetModel, element);
        }
    },

    initializeContainerGestures: function(widgetModel) {
        var clonedTemplates = widgetModel.clonedTemplates;
        var template, rowNode;
        
        if(widgetModel.hasSections) {
            
            for( var i = 0; i < clonedTemplates.length; i++) {
                var sectionData = clonedTemplates[i];
                if(sectionData[0]){
                    template = sectionData[0];
                    if(widgetModel.wType === 'Segment') {
                        rowNode = $KW.Segment.getNodeByContext(widgetModel, template.rowContext, template);
                    } else if(widgetModel.wType === 'CollectionView') {
                        rowNode = $KW.CollectionView.Utils.getNodeByContext(widgetModel, template.rowContext, template);
                    }
                    rowNode && $KW.Utils.processContainerGestures(template, rowNode);
                }

                for(var j = 0; j< sectionData[1].length; j++) {
                    template = sectionData[1][j];
                    if(widgetModel.wType === 'Segment') {
                        rowNode = $KW.Segment.getNodeByContext(widgetModel, template.rowContext, template);
                    } else if(widgetModel.wType === 'CollectionView') {
                        rowNode = $KW.CollectionView.Utils.getNodeByContext(widgetModel, template.rowContext, template);
                    }
                    rowNode && $KW.Utils.processContainerGestures(template, rowNode);
                }
                if(widgetModel.wType === 'CollectionView' && sectionData[2]) {
                    template = sectionData[2];
                    rowNode = $KW.CollectionView.Utils.getNodeByContext(widgetModel, template.rowContext, template);
                    rowNode && $KW.Utils.processContainerGestures(template, rowNode);
                }
            }
        }
        else {
            for( var i = 0; i < clonedTemplates.length; i++) {
                template = clonedTemplates[i];
                if(widgetModel.wType === 'Segment') {
                    rowNode = $KW.Segment.getNodeByContext(widgetModel, template.rowContext, template);
                } else if(widgetModel.wType === 'CollectionView') {
                    rowNode = $KW.CollectionView.Utils.getNodeByContext(widgetModel, template.rowContext, template);
                }
                rowNode && $KW.Utils.processContainerGestures(template, rowNode);
            }
        }
    },

    processContainerGestures: function(containerModel, rowNode) {
        var element =  rowNode.querySelector('#' + $KW.Utils.getKMasterWidgetID(containerModel));
        if(element) {
            
            $KW.Utils.addGesturesToWidget(containerModel, element);
        }

        var childList = containerModel.children;
        for(var i = 0; i < childList.length; i++) {
            var childModel = containerModel[childList[i]];
            childModel = $KW.Utils.getActualWidgetModel(childModel);

            if(childModel && childModel.children && childModel.children.length != 0) {
                $KW.Utils.processContainerGestures(childModel, rowNode);
            } else {
                if(childModel.wType == "Calendar") {
                    element = rowNode.querySelector("div[kwidgetid = " + $KW.Utils.getKMasterWidgetID(childModel) + "]");
                } else {
                    element = rowNode.querySelector('#' + $KW.Utils.getKMasterWidgetID(childModel));
                }

                if(element) {
                    $KW.Utils.addGesturesToWidget(childModel, element);
                }
            }
        }
    },

    addGesturesToWidget: function(widgetModel, element) {
        $KW.Utils.applyGesturestoDOM(widgetModel, element);
        $KW.Utils.applyTouchestoDOM(widgetModel, element);
    },

    applyGesturestoDOM: function(widgetModel, widgetNode){
        var gestures = widgetModel.gestures;
        if(gestures) {
            for(var k in gestures) {
                var gesture = gestures[k];
                if(gesture) {
                    for(var i in gesture) {
                        var gEObj = gesture[i];
                        $KW.Utils.removegesture(widgetModel, gEObj.gestureType, false,
                            gEObj.gestureIdentifier, gEObj.gestureObj);
                        new $KW.touch.gesture(widgetModel, gEObj);
                    }
                }
            }
        }
    },

    applyTouchestoDOM: function(widgetModel, element) {
        var touches = widgetModel.touches;
        if(element && touches) {
            for(var k in touches) {
                var touch = touches[k];
                if(touch) {
                    if(widgetModel.wType == "DataGrid" ) {
                        var elements = document.querySelectorAll('#' + $KW.Utils.getKMasterWidgetID(widgetModel));
                        for (var i = 0; i < elements.length; i++) {
                            if(i == 0) {
                                continue;
                            }
                            $KW.Utils.removetouch(widgetModel, k, false);
                            widgetModel.touches[k]["instance"] = new $KW.touch.TouchEvents(widgetModel, elements[i], k, touch.callback);
                        }
                    } else {
                        $KW.Utils.removetouch(widgetModel, k, false);
                        widgetModel.touches[k]["instance"] = new $KW.touch.TouchEvents(widgetModel, element, k, touch.callback);
                    }
                }
            }
        }
    },

    updateModelWithGesture: function(widgetModel, gestureType, gestureObj, callback) {
        
        if(!widgetModel)
            widgetModel = $KG;
        if(!widgetModel.gestures)
            widgetModel.gestures = {};
        var _gestureType = (gestureType == 1 ? (gestureObj.taps == 1 ? 10 : 11) : gestureType);
        if(!widgetModel.gestures[_gestureType])
            widgetModel.gestures[_gestureType] = [];
        var gestureEventObject = {
            gestureObj: gestureObj,
            callback: callback,
            gestureType: gestureType
        }
        gestureEventObject.gestureIdentifier = (Math.round(new Date().valueOf() * Math.random())) + "";

        widgetModel.gestures[_gestureType][gestureEventObject.gestureIdentifier] = gestureEventObject;
        return gestureEventObject;
    },

    removegesture: function(widgetModel, gestureType, updateModel, gestureIdentifier, gestureObj) {
        var _gestureType = (gestureType == 1 ? (gestureObj.taps == 1 ? 10 : 11) : gestureType);
        if(widgetModel.gestures && widgetModel.gestures[_gestureType]) {
            var gestureList = widgetModel.gestures[_gestureType];
            if(gestureIdentifier && typeof(gestureIdentifier) === "string") {
                gestureList[gestureIdentifier]["instance"].removeGesture(gestureType, updateModel);
                if(updateModel)
                    delete gestureList[gestureIdentifier];
                return;
            }
            for(var k in gestureList) {
                try {
                    gestureList[k]["instance"].removeGesture(gestureType, updateModel);
                } catch(e) {
                    if(console && console.error)
                        kony.web.logger("error", 'unable to remove Gesture ' + e);
                }
            }
            if(updateModel)
                widgetModel.gestures[_gestureType] = [];
        }
    },

    updateModelWithTouches: function(widgetModel, touchEventType, callback) {
        
        if(!widgetModel)
            widgetModel = $KG;
        if(!widgetModel.touches)
            widgetModel.touches = {};
        if(callback)
            widgetModel.touches[touchEventType] = {
                callback: callback
            };
        else
            widgetModel.touches[touchEventType] = undefined;
    },

    removetouch: function(widgetModel, touchEventType, updateModel) {
        if(widgetModel.touches && widgetModel.touches[touchEventType] && widgetModel.touches[touchEventType]["instance"])
            widgetModel.touches[touchEventType]["instance"].removeTouch && widgetModel.touches[touchEventType]["instance"].removeTouch(touchEventType, updateModel);
    },

    initializeScrollEvents: function(scrollNodes, model) {
        var wModel = null;
        for(var i = 0; i < scrollNodes.length; i++) {
            var scrollNode = scrollNodes[i];
            wModel = model || $KU.getModelByNode(scrollNode);
            wModel.scrollInstance = new $KW.touch.TouchEvents(wModel, scrollNode, "scroll");
        }
    },

    scrollInterface: (function() {
        var global = this;
        var notSetUp = true;
        var readScroll = {
            scrollLeft: NaN,
            scrollTop: NaN,
            clientHeight: NaN,
            clientWidth: NaN
        };
        var readScrollX = 'scrollLeft';
        var readScrollY = 'scrollTop';
        var readClientH = 'clientHeight';
        var readClientW = 'clientWidth';

        var itrface = {
            getScrollX: function() {
                return readScroll[readScrollX];
            },
            getScrollY: function() {
                return readScroll[readScrollY];
            },
            getClientH: function() {
                return readScroll[readClientH];
            },
            getClientW: function() {
                return readScroll[readClientW];
            }
        };

        function setUp() {
            if(typeof global.pageXOffset == 'number') {
                readScroll = global;
                readScrollY = 'pageYOffset';
                readScrollX = 'pageXOffset';
                readClientH = 'innerHeight';
                readClientW = 'innerWidth';
            } else {
                if((typeof document.compatMode == 'string') &&
                    (document.compatMode.indexOf('CSS') >= 0) &&
                    (document.documentElement) &&
                    (typeof document.documentElement.scrollLeft == 'number')) {
                    readScroll = document.documentElement;
                } else if((document.body) &&
                    (typeof document.body.scrollLeft == 'number')) {
                    readScroll = document.body;
                }
            }
            notSetUp = false; 
        }
        return(function() {
            if(notSetUp) { 
                setUp(); 
            }
            return itrface; 
        });
    })()(),

    handleLayout: function(container, boxModel, layoutData) {
        var context = container.context;
        var tabpaneID = context.tabpaneID; 
        context.container = container;
        context.template_generator = boxModel;
        context.tabpaneID = "";
        if(!boxModel.pf) {
            _konyConstNS.Form2.addHeaderorFooter.call(boxModel, boxModel);
        }
        boxModel.isTemplate = true;
        var clonedBoxModel = owl.deepCopy(boxModel, null, false);
        $KW.Utils.updateLayoutData(container, clonedBoxModel, layoutData);
        context.setTopLevelBox(true);
        var htmlString = $KW[clonedBoxModel.wType].render(clonedBoxModel, context);
        context.setTopLevelBox(false);
        context.tabpaneID = tabpaneID;
        context.container = "";
        context.template_generator = "";
        return htmlString;
    },

    
    getContainerModel: function(widgetModel, element) {
        if(!(widgetModel || element)) {
            return null;
        }
        var containerId = null;
        var containerModel = null;
        if(!element) {
            element = $KU.getNodeByModel(widgetModel);
        }
        containerId = element && element.getAttribute("kcontainerID");
        containerModel = $KW.Utils.getContainerModelById(element, containerId);

        return containerModel;
    },

    belongsToSegment: function(element) {
        var containerId = element && element.getAttribute("kcontainerID");
        if(containerId) {
            var containerModel = $KW.Utils.getContainerModelById(element, containerId);
            if(containerModel.wType == "Segment") return true;
        }
        return false;
    },

    isBelongsToCollectionView: function(wModel, element) {
        element = element || $KU.getNodeByModel(wModel);
        var containerId = element && element.getAttribute("kcontainerID");
        if(containerId) {
            var containerModel = $KW.Utils.getContainerModelById(element, containerId);
            if(containerModel.wType == "CollectionView") return true;
        }
        return false;
    },

    setScrollWidth: function(widgetModel, element) {
        var scroller = (widgetModel.scrollbar == "arrows") ? element.childNodes[1] : element.childNodes[0];

        scroller.style.width = (scroller.clientWidth - parseInt($KU.getStyle(element, "padding-right").replace("px", ""), 10) - parseInt($KU.getStyle(element, "padding-left").replace("px", ""), 10)) + "px";
        var scrollerInstance = $KG[$KW.Utils.getKMasterWidgetID(widgetModel) + "_scroller"];
        scrollerInstance && scrollerInstance.refresh();
    },

    getTemplateByContainerModelAndRowData: function(model, rowdata, isSection, index) {
        if(model.wType == "Segment") {
            if(isSection) {
                return model.sectionheadertemplate;
            } else {
                return rowdata.template || model.rowtemplate;
            }
        } else if(model.wType == "DataGrid") {
            if(model.selectedIndex >= IndexJL) {
                var colConfig = model.columnheadersconfig[model.selectedcellindex[0]];
                if(index == '0') {
                    return colConfig.columnheadertemplate.template;
                }
                return colConfig.columndatatemplate;
            }
        }
    },

    getRowDataByContainerModelAndIndex: function(model, index) { 
        if(model.wType === "Segment") {
            return $KW.Segment.getRowDataByIndex(model, index);
        } else if(model.wType === "DataGrid") {
            
        }
    },

    getIndexAttrNameByContainerModel: function(model) {
        if(model.wType === "Segment") {
            return 'index';
        } else if(model.wType === "DataGrid") {
            return 'index';
        }
    },

    getOffsetParent: function(elem) {
        var offsetParent = elem.offsetParent || document.documentElement;
        while(offsetParent && (!(elem.nodeName && elem.nodeName.toLowerCase() == "html") && $KU.getStyle(elem, "position") === "static")) {
            offsetParent = offsetParent.offsetParent;
        }
        return offsetParent || document.documentElement;
    },

    
    getOffset: function(elem) {
        var offsetParent, offset, parentOffset = {
            top: 0,
            left: 0
        };
        offsetParent = this.getOffsetParent(elem);
        offset = this.getPosition(elem);
        parentOffset = this.getPosition(offsetParent);
        
        parentOffset.top += $KU.getStyle(offsetParent, "borderTopWidth");
        parentOffset.left += $KU.getStyle(offsetParent, "borderLeftWidth");

        return {
            top: offset.top + offsetParent.scrollTop - parentOffset.top,
            left: offset.left + offsetParent.scrollLeft - parentOffset.left
        };
    },

    
    getPosition: function(elem) {
        var box = {
                top: 0,
                left: 0
            },
            docElem = document.documentElement;
        if(typeof elem.getBoundingClientRect !== "undefined") {
            box = elem.getBoundingClientRect();
        }
        return {
            top: box.top + window.pageYOffset - docElem.clientTop,
            left: box.left + window.pageXOffset - docElem.clientLeft
        };
    },
    getCursorStyle: function(widgetModel) {
        var value = widgetModel.cursortype;
        if(value) {
            if(value.match(/([.]+)/) != null) {
                return "url(" + $KU.getImageURL(value) + ") ,auto";
            } else {
                return value;
            }
        }
    },

    getBoxShadowStyle: function(wModel) {
        var shadowColor = "#000000";
        if(wModel.shadowradius == undefined && (wModel.shadowoffset == undefined ||
                (wModel.shadowoffset && wModel.shadowoffset.x == undefined && wModel.shadowoffset.y == undefined))) {
            return ""
        }
        var shadowOffsetX = (wModel.shadowoffset && wModel.shadowoffset.x || 0) + "px ";
        var shadowOffsetY = (wModel.shadowoffset && wModel.shadowoffset.y || 0) + "px ";
        var shadowRadius = (wModel.shadowradius || 0) + "px ";

        if(wModel.shadowcolor) {
            var validate = $KW.skins.validateHexValue(wModel.shadowcolor);
            if(validate) {
                shadowColor = $KW.skins.convertHexValuetoRGBA(wModel.shadowcolor);
            }
        }
        return shadowOffsetX + shadowOffsetY + shadowRadius + shadowColor;
    },

    getAnchorPoint: function(wModel) {
        if(wModel && wModel.anchorpoint) {
            var value = wModel.anchorpoint;
            if(value) {
                if((value.x < 0) || (value.x > 1) || (value.y < 0) || (value.y > 1))
                    return '';
                return $KU.cssPrefix + "transform-origin:" + (value.x * 100) + "% " + (value.y * 100) + "%; ";
            }
        }
        return '';
    },

    

    getView: function(model, parentNode) {

        
        if(!model)
            return null;

        var widgetID;
        var widgetTabId = model.tabId;
        var wID = model.id;
        if(model.kmasterid) {
            
            widgetID = model.pf + "_" + model.kmasterid + "_" + wID;
        } else if(widgetTabId) {
            widgetID = model.pf + "_" + widgetTabId + "_" + wID;
        } else {
            widgetID = (model.pf ? model.pf + "_" : "") + wID;
        }

        if(model.wType == 'Calendar')
            return parentNode ? parentNode.querySelector('div[kwidgetid=' + widgetID + ']') : document.querySelector('div[kwidgetid=' + widgetID + ']');
        var node = parentNode ? parentNode.querySelector('#' + widgetID) : document.getElementById(widgetID);
        
        if(!node && $KU.isAndroid)
            node = parentNode ? parentNode.querySelectorAll('#' + widgetID)[0] : document.getElementById(widgetID);
        return node;
    },


    getWidgetNode: function(model, parentNode) {
        
        if(!model)
            return null;

        var widgetID;
        var widgetTabId = model.tabId;
        var wID = model.id;
        if(model.kmasterid) {
            
            widgetID = model.pf + "_" + model.kmasterid + "_" + wID;
        } else if(widgetTabId) {
            widgetID = model.pf + "_" + widgetTabId + "_" + wID;
        } else {
            widgetID = (model.pf ? model.pf + "_" : "") + wID;
        }

        if(model.wType == 'Calendar')
            return parentNode ? parentNode.querySelector('div[kwidgetid=' + widgetID + ']') : document.querySelector('div[kwidgetid=' + widgetID + ']');
        var node = parentNode ? parentNode.querySelector('#' + widgetID) : document.getElementById(widgetID);
        
        if(!node && $KU.isAndroid)
            node = parentNode ? parentNode.querySelectorAll('#' + widgetID)[0] : document.getElementById(widgetID);
        return $KW.Utils.getWidgetNodeFromNodeByModel(model, node);
    },

    
    getWidgetNodeFromNodeByModel: function(model, node) {
        if(node) {
            var map = {
                Image: 1,
                Slider: 2,
                FlexContainer: 1
            };

            if(model.wType == 'Segment' && model.viewtype == constants.SEGUI_VIEW_TYPE_PAGEVIEW) {
                map.Segment = 1;
            }

            if(model.wType == 'DataGrid' && ((model.enablescrollbar == 1 && !model.dockingheader) || $KW.FlexUtils.isFlexWidget(model))) {
                map.DataGrid = 1;
            }

            for(var i = typeof map[model.wType] == 'undefined' ? 0 : map[model.wType]; i > 0; --i)
                node = node.parentNode;
            return node;
        } else
            return null;
    },

    getContentNodeFromNodeByModel: function(model) {
        var widgetNode = $KU.getNodeByModel(model);
        if(widgetNode) {
            var contentNode = widgetNode;
            var map = {};
            for(var i = typeof map[model.wType] == 'undefined' ? 0 : map[model.wType]; i > 0; --i)
                contentNode = contentNode.firstChild;
            return contentNode;
        }
    },

    getWidgetIndex: function(wModel) {
        var parentModel = wModel.parent;
        if(parentModel) {
            var widgets = parentModel.widgets();
            for(var i = 0; i < widgets.length; i++) {
                if(wModel.id == widgets[i].id) {
                    return i;
                }
            }
        }
        return -1;
    },

    getClonedModelByContainer: function(model, node, containerId) {
        var clonedModel;
        var containerModel = $KW.Utils.getContainerModelById(node, containerId);
        if(containerModel.wType == "CollectionView") {
            clonedModel = $KW.CollectionView.Utils.getClonedModelOfWidget(model, node, containerId);
        } else if(containerModel.wType == "Segment"){
            clonedModel = $KW.Segment.getClonedModelOfWidget(model, node, containerId);
        } else if(containerModel.wType == "DataGrid") {
            clonedModel = $KW.DataGrid.getClonedModelOfWidget(model, node, containerId);
        }
        return clonedModel;
    },

    getClonedModelByContainerUsingIndex: function(containerModel, rowIndex, secIndex) {
        var clonedModel;
        if(containerModel.wType == "CollectionView") {
            clonedModel = $KW.CollectionView.Utils.getClonedModel(containerModel, rowIndex, secIndex);
        } else if(containerModel.wType == "Segment") {
            clonedModel = $KW.Segment.getClonedModel(containerModel, rowIndex, secIndex);
        } else if(containerModel.wType == "DataGrid") {
            clonedModel = $KW.DataGrid.getClonedModel(containerModel, rowIndex, secIndex);
        }
        return clonedModel;
    },

    
    getMirrorAlignment: function(alignmentType) {
        var mirrorMap = {
                '1': constants.CONTENT_ALIGN_TOP_RIGHT,
                '2': constants.CONTENT_ALIGN_TOP_CENTER,
                '3': constants.CONTENT_ALIGN_TOP_LEFT,
                '4': constants.CONTENT_ALIGN_MIDDLE_RIGHT,
                '5': constants.CONTENT_ALIGN_CENTER,
                '6': constants.CONTENT_ALIGN_MIDDLE_LEFT,
                '7': constants.CONTENT_ALIGN_BOTTOM_RIGHT,
                '8': constants.CONTENT_ALIGN_BOTTOM_CENTER,
                '9': constants.CONTENT_ALIGN_BOTTOM_LEFT
            },
            mirroredAlignment;
        mirroredAlignment = mirrorMap[alignmentType]
        return mirroredAlignment;
    },

    
    getMirroredMarginPadding: function(marginPaddingValue) {
        var temp;
        temp = marginPaddingValue[0];
        marginPaddingValue[0] = marginPaddingValue[2];
        marginPaddingValue[2] = temp;
        return marginPaddingValue;
    }
};


$KW.WidgetGenerationContext = function(formID) {
    this.formID = formID;
    this.topLevelBox = null;
};

$KW.WidgetGenerationContext.prototype.setTopLevelBox = function(topLevel) {
    this.topLevelBox = topLevel;
};

$KW.unLoadWidget = function() {
    
    var progressnode = document.querySelector('[selected="progress"]') || document.querySelector('[selected="progressindtr"]');
    if(progressnode)
        progressnode.removeAttribute("selected");
    progressnode = document.querySelector('[progressindicator="true"]');
    if(progressnode)
        progressnode.parentNode.removeChild(progressnode);

    var selectedItem = $KG[kony.constants.SELECTED_ITEM];
    if(selectedItem) {
        var selectedWidget = $KU.getElementById(selectedItem.kWidgetID);
        var widgetEventHandler = selectedItem.kEventHandler;
        widgetEventHandler && widgetEventHandler(selectedWidget)
    }
    
    delete $KG[kony.constants.SELECTED_ITEM];
};


$KW.Advertisement = {
    render: function(widgetID, context) {
        return "";
    }
};

$KW.SeatMap = {
    render: function(widgetID, context) {
        return "";
    }
};

$KW.MenuItem = {
    render: function(widgetID, context) {
        return "";
    }
};

$KW.TPW = {
    render: function(widgetModel, context) {
        var html = "";
        if(typeof widgetModel == 'object') {
            
            var id = widgetModel.pf + '_' + widgetModel.id;
            var kmasterObj = $KW.Utils.getMasterIDObj(widgetModel);

            if(kmasterObj.id != "") {
                id = kmasterObj.id;
            }

            $KU.addThirdPartyMeta({
                id: id,
                tpwModel: widgetModel
            });
            var tpwidgettype = $KU.getWidgetTypeByNameSapce(widgetModel.widgetName);
            var computedSkin = $KW.skins.getWidgetSkin(widgetModel, context) + " " + $KW.skins.getMarPadAdjustedContainerWeightSkin(widgetModel, 100);
            var marginpaddingvisible = "";
            marginpaddingvisible += $KW.skins.getMarginSkin(widgetModel, context) + " " + $KW.skins.getPaddingSkin(widgetModel);
            
            
            if(widgetModel.isvisible == false || !widgetModel.isvisible == "false" || widgetModel.isVisible == false || !widgetModel.isVisible == "false")
                marginpaddingvisible += "display:none;";
            html += "<div id='" + id + "' "+ kmasterObj.kmasterid +" class='" + computedSkin + "' tpwidgettype='" + tpwidgettype + "' style='" + marginpaddingvisible + "'></div>";
            return html;
        }
    },

    renderWidget: function(formOrPopup) {
        if($KG.thirdPartyWidgetsMeta) {
            for(var key in $KG.thirdPartyWidgetsMeta) {
                var placeholder = document.getElementById($KG.thirdPartyWidgetsMeta[key].id);
                
                if(placeholder && $KG.thirdPartyWidgetsMeta[key].tpwModel.pf == formOrPopup) {
                    var tpwModel = $KG.thirdPartyWidgetsMeta[key].tpwModel;
                    var nsArr = tpwModel.widgetName.split('.');
                    var namespace = window;
                    for(var j = 0; j < nsArr.length; j++) {
                        namespace = namespace[nsArr[j]];
                    }
                    if(namespace && typeof namespace['initializeWidget'] == 'function') {
                        namespace['initializeWidget'](placeholder, tpwModel);
                    } else {
                        
                    }
                }
            }
        }
    }
};

if(!Array.prototype.indexOf) {
    Array.prototype.indexOf = function(obj, fromIndex) {
        if(fromIndex == null) {
            fromIndex = 0;
        } else if(fromIndex < 0) {
            fromIndex = Math.max(0, this.length + fromIndex);
        }
        for(var i = fromIndex, j = this.length; i < j; i++) {
            if(this[i] === obj)
                return i;
        }
        return -1;
    };
}


$KW.skins = (function() {
    
    

    var module = {
        
        getBaseStyle: function(widgetModel, context) {
            var style = "";
            if(widgetModel.backgroundColor) {
                var validate = module.validateHexValue(widgetModel.backgroundColor);
                if(validate) {
                    style += "background : " + module.convertHexValuetoRGBA(widgetModel.backgroundColor) + "; ";
                }
            }
            if(widgetModel.borderColor) {
                var validate = module.validateHexValue(widgetModel.borderColor);
                if(validate) {
                    style += "border-color : " + module.convertHexValuetoRGBA(widgetModel.borderColor) + "; ";
                }
            }

            if(widgetModel.borderWidth) {
                style += "border-width : " + widgetModel.borderWidth + "px; ";
            }

            if(widgetModel.cornerRadius) {
                style += "border-radius : " + widgetModel.cornerRadius + "px; ";
            }

            if(widgetModel.cursortype) {
                style += "cursor : " + $KW.Utils.getCursorStyle(widgetModel);
            }

            if(widgetModel.wType != "DataGrid")
                style += module.getMarginSkin(widgetModel, context);

            if(widgetModel.wType != "Browser" && widgetModel.wType != "Segment" && widgetModel.wType != "FlexContainer" && widgetModel.wType != "FlexScrollContainer")
                style += module.getPaddingSkin(widgetModel);

            style += this.getBlurStyle(widgetModel);

            return style;
        },

        
        getMarginSkin: function(widgetModel, context) {
            return "";
        },

        

        
        getChildMarginAsPaddingSkin: function(widgetModel) {
            var parentmodel = $KU.getParentModel(widgetModel);
            if(($KG.appbehaviors["applyMarginPaddingInBCGMode"] == true))
                return "";
            var margin = widgetModel.margin;
            var i = 0;
            
            if($KU.isArray(margin) && parentmodel && parentmodel.wType == "ScrollBox" && parentmodel.orientation == constants.BOX_LAYOUT_HORIZONTAL) {
                var totalWt = parentmodel.totalWt;
                while(i < 4) {
                    margin[i] = totalWt && (margin[i] * 100) / totalWt;
                    i++;
                }
                return "padding:" + $KU.joinArray(margin, "% ") + "%;";
            }
            if($KU.isArray(margin))
                return "padding:" + $KU.joinArray(margin, "% ") + "%;";
            else
                return "";
        },

        
        getPaddingSkin: function(widgetModel) {
            if(widgetModel.wType != "DataGrid" && ($KW.FlexUtils.isFlexContainer(widgetModel) || $KW.FlexUtils.isFlexWidget(widgetModel)))
                return "";
        },

        setMarginPadding: function(element, propertyName, widgetModel, propertyValue, referenceCWt) {

        },

        
        getMarAdjustedContainerWeightSkin: function(widgetModel, referenceCWt) {
            return "";
        },

        addWidthRule: function(cwt) {
            if(cwt > 100 && $KG["cwtexists"].indexOf(cwt) == -1) {
                $KG["cwtexists"].push(cwt);
                var styleSheetObjs = window.document.styleSheets;
                var konyStyleSheetIndex = module.getKonyStyleSheetIndex(styleSheetObjs);
                if(konyStyleSheetIndex != -1) {
                    var styleSheetObj = styleSheetObjs[konyStyleSheetIndex];
                    var rules = styleSheetObj.cssRules || styleSheetObj.rules;
                    if(styleSheetObj.insertRule)
                        styleSheetObj.insertRule(".kwt" + cwt + "{width:" + cwt + "%;}", rules.length);
                    else
                        styleSheetObj.addRule(".kwt" + cwt, "width:" + cwt + "%;");
                }
            }
        },

        
        getMarPadAdjustedContainerWeightSkin: function(widgetModel, referenceCWt) {
            var cwt = referenceCWt || widgetModel.containerweight;

            if(cwt) {
                try {
                    var margin = widgetModel.margin;
                    if(margin) {
                        cwt -= (parseInt(margin[0 + IndexJL]) + parseInt(margin[2 + IndexJL]));
                    }
                    return "kwt" + cwt;
                } catch(e) {
                    kony.web.logger("error", "Error occured in getting container weight " + e);
                }
            } else
                return "kwt100";
        },

        
        getWidgetSkin: function(widgetModel, context) {
            var skin;
            if(context && context.container && context.container.widgetsData) {
                var data = context.container.widgetsData;
                var wData = data[widgetModel.id];
                if(wData && wData.skin)
                    skin = wData.skin;
            }
            return skin || widgetModel.skin || this.getDefaultSkin(widgetModel) || "";
        },

        getDefaultSkin: function(widgetModel) {
            var skin = "";

            if(widgetModel.wType == "Label" || widgetModel.wType == "Button" || widgetModel.wType == "DataGrid" || widgetModel.wType == "RichText" || widgetModel.wType == "CheckBoxGroup" || widgetModel.wType == "RadioButtonGroup" || widgetModel.wType == "ListBox" || widgetModel.wType == "Switch")
                skin = 'konycustomcss';
            return skin;
        },

        
        getWidgetSkinList: function(widgetModel, context, data) {
            var skins = [];
            context = context || {};

            
            skins.push(this.getWidgetWeight(widgetModel, context));
            if(widgetModel.wType != "Form")
                skins.push(this.getWidgetSkin(widgetModel, context));
            if(['Calendar', 'Label'].indexOf(widgetModel.wType) != -1 && $KW.FlexUtils.isFlexWidget(widgetModel))
                skins.push(this.getFlexContentAlignmentSkin(widgetModel.contentalignment));
            skins.push(this.getWidgetSelectionSkin(widgetModel));

            var isFlexWidget = $KW.FlexUtils.isFlexWidget(widgetModel);
            if(!isFlexWidget && (!$KW.Utils.isWidgetVisible(widgetModel, context) || (data && data.length <= IndexJL))) 
                skins.push("hide");
            return skins.join(" ");
        },

        getVisibilitySkin: function(wModel) {
            var isFlexWidget = $KW.FlexUtils.isFlexWidget(wModel);
            return(!isFlexWidget && !wModel.isvisible) ? ' hide ' : '';
        },

        getWidgetWeight: function(widgetModel, context) {
            return "";
        },

        getWidgetSelectionSkin: function(widgetModel) {
            if(widgetModel.wType == "Label" || widgetModel.wType == "Button" || widgetModel.wType == "Line" || widgetModel.wType == "Switch" || widgetModel.wType == "ListBox" || widgetModel.wType == "CheckBoxGroup" || widgetModel.wType == "RadioButtonGroup" || widgetModel.wType == "Calendar") {
                return(widgetModel.wType == "Label" && widgetModel.textcopyable) ? "enableSelection" : "disableSelection";
            }
            return "";
        },

        getSplitSkinsBetweenWidgetAndParentDiv: function(widgetModel, context) {
            var splitSkins = new Array();
            var marginSkin = "";
            var paddingSkin = "";
            var weightSkin = "";
            if(widgetModel.wType == "HBox" || widgetModel.wType == "VBox") {
                weightSkin = this.getMarPadAdjustedContainerWeightSkin(widgetModel, 100)
            } else {
                weightSkin = module.getMarAdjustedContainerWeightSkin(widgetModel, 100);
            }
            var widgetSkin = this.getWidgetSkin(widgetModel, context);
            splitSkins[0] = marginSkin + " " + paddingSkin + " " + " " + widgetSkin + " ";
            splitSkins[1] = weightSkin;
            splitSkins[2] = marginSkin + " " + paddingSkin + " " + " " + widgetSkin + " " + weightSkin;

            return splitSkins;
        },

        getWidgetAlignmentSkin: function(widgetModel) {
            var alignment = "middlecenteralign";
            return this.getAlignment(widgetModel.widgetalign || widgetModel.widgetalignment) || alignment;
        },

        getBlurStyle: function(widgetModel) {
            var filter = '', blur = widgetModel.flexblur,
                enabled = (blur) ? blur.enabled : false,
                value = (enabled) ? blur.value : 0;

            if(enabled) {
                value = (value < 0) ? 0 : (value > 100) ? 100 : value;

                if(value) {
                    filter = 'filter:blur(' + value + 'px);';
                }
            }

            return filter;
        },

        getAlignment: function(align) {
            switch(parseInt(align)) {
                case 1:
                    return "topleftalign";

                case 2:
                    return "topcenteralign";

                case 3:
                    return "toprightalign";

                case 4:
                    return "middleleftalign";

                case 5:
                    return "middlecenteralign";

                case 6:
                    return "middlerightalign";

                case 7:
                    return "bottomleftalign";

                case 8:
                    return "bottomcenteralign";

                case 9:
                    return "bottomrightalign";
            }
            return "";
        },

        
        getFlexContentAlignmentSkin: function(align) {
            switch(parseInt(align)) {
                case 1:
                    return "cnttopleftalign";

                case 2:
                    return "cnttopcenteralign";

                case 3:
                    return "cnttoprightalign";

                case 4:
                    return "cntmiddleleftalign";

                case 5:
                    return "cntmiddlecenteralign";

                case 6:
                    return "cntmiddlerightalign";

                case 7:
                    return "cntbottomleftalign";

                case 8:
                    return "cntbottomcenteralign";

                case 9:
                    return "cntbottomrightalign";
            }
            return "";
        },

        getContentAlignment: function(widgetModel, align) {
            var align = align || widgetModel.contentalignment;
            if(widgetModel.wType == "DataGrid") {
                return this.getAlignment(align);
            }
            switch(parseInt(align)) {
                case 1:
                case 4:
                case 7:
                    return "left";

                case 2:
                case 5:
                case 8:
                    return "center";

                case 3:
                case 6:
                case 9:
                    return "right";
            }
            return "left"; 
        },


        validateHexValue: function(value) {
            return(/(^[0-9A-F]{8}$)|(^[0-9A-F]{6}$)/i.test(value));
        },


        convertHexValuetoRGBA: function(value) {
            var r = value.charAt(0) + value.charAt(1);
            var g = value.charAt(2) + value.charAt(3);
            var b = value.charAt(4) + value.charAt(5);
            var a = 0;
            if(value.length == 6) {
                return "#" + r + g + b;
            }
            if(value.length > 6 && value.length <= 8)
                a = value.charAt(6) + value.charAt(7);

            r = parseInt(r, 16);
            g = parseInt(g, 16);
            b = parseInt(b, 16);
            a = ((100 - parseInt(a, 16)) / 100).toFixed(2);
            return "rgba(" + r + "," + g + "," + b + "," + a + ")";
        },

        convertHexValuetoRGBAForMap: function(value) {
            var r = '',
                g = '',
                b = '',
                a = '';
            if(value.substr(0, 2) === '0x') {
                value = value.substr(2, value.length);
            }
            if(module.validateHexValue(value)) {
                r = value.substr(0, 2);
                g = value.substr(2, 2);
                b = value.substr(4, 2);
                a = 0;
            } else {
                kony.web.logger('error', 'Invalid color code');
            }
            if(value.length === 6) {
                return "#" + r + g + b;
            }
            if(value.length > 6 && value.length <= 8)
                a = value.substr(6, 2);

            r = parseInt(r, 16);
            g = parseInt(g, 16);
            b = parseInt(b, 16);
            a = (parseInt(a, 16) / 255).toFixed(2);
            return "rgba(" + r + "," + g + "," + b + "," + a + ")";
        },

        
        updateDOMSkin: function(widgetModel, newSkin, oldSkin, element) {
            if(widgetModel.wType == "Phone") {
                var childElement = element.childNodes[0];
                $KU.removeClassName(childElement, oldSkin);
                $KU.addClassName(childElement, newSkin);
            }
            if(widgetModel.wType == "Switch") {
                if($KW.Switch.isCustomSwitch(widgetModel)) {
                    var switchState = ['on', 'off'][widgetModel.selectedIndex];
                    var switchTrackElement = element.childNodes[0];
                    $KU.removeClassName(switchTrackElement, oldSkin + switchState);
                    $KU.addClassName(switchTrackElement, newSkin + switchState);
                } else {
                    var switchOnElement = element.childNodes[0];
                    $KU.removeClassName(switchOnElement, oldSkin + 'on');
                    $KU.addClassName(switchOnElement, newSkin + 'on');
                    var switchOffElement = element.childNodes[2];
                    $KU.removeClassName(switchOffElement, oldSkin + 'off');
                    $KU.addClassName(switchOffElement, newSkin + 'off');
                }
            }
            

            $KU.removeClassName(element, oldSkin);
            $KU.addClassName(element, newSkin);
        },

        
        updateFocusSkin: function(widgetModel, type) {
            if(widgetModel.isCloned == true && $KW.Utils.isBelongsToCollectionView(widgetModel)) {
                var containerModel = $KW.Utils.getContainerModel(widgetModel);
                $KW.CollectionView.Skin.applyWidgetFocusSkin(null, widgetModel, containerModel);
                return;
            }

            var focusskin = widgetModel[type];
            var focusskin2;
            if(widgetModel.wType === "TabPane")
                focusskin = widgetModel.activefocusskin;
            var classSelector, classSelector2;
            var wID = "#" + $KW.Utils.getKMasterWidgetID(widgetModel); 

            switch(widgetModel.wType) {
                case "TextArea":
                case "RichText":
                case "TextField":
                    classSelector = wID;
                    break;
                case "RadioButtonGroup":
                case "CheckBoxGroup":
                    classSelector = wID + ">div";
                    break;
                case "DataGrid":
                    classSelector = wID + " tbody tr";
                    break;
                case "Segment":
                    classSelector = wID + " [index]";
                    break;
                case "Calendar":
                    classSelector = wID;
                    break;

                case "TabPane":
                    if(widgetModel.viewtype && (widgetModel.viewtype === 'tabview')) {
                        focusskin = focusskin + "lia";
                        focusskin2 = widgetModel.activefocusskin + "li";
                        classSelector = wID + "_Header li div[kwidgettype]";
                        classSelector2 = wID + "_Header li";
                    } else {
                        classSelector = wID + " div[active]";
                    }
                    break;
                default:
                    classSelector = wID;
            }
            var pseudo = (type == "focusskin" || type == "rowfocusskin") ? ":active" : ":hover";

            
            if(widgetModel.wType == "TextField" || widgetModel.wType == "TextArea") {
                pseudo = (type == "focusskin") ? ":focus" : ":hover";
                pseudo += (pseudo == ":focus" ? ":not([kdisabled='true'])" : "");
            } else {
                pseudo = (type == "focusskin" || type == "rowfocusskin") ? ":active" : ":hover";
                pseudo += (pseudo == ":active" ? ":not([kdisabled='true'])" : "");
            }
            classSelector += pseudo;
            module.applyStyle(focusskin, classSelector, widgetModel.wType);


            if(widgetModel.viewtype && (widgetModel.viewtype == 'tabview')) {
                classSelector2 += pseudo;
                module.applyStyle(focusskin2, classSelector2);
            }
            if(widgetModel.wType == "ListBox")
                module.applyStyle(focusskin + " option", classSelector + " option");
        },

        applyStyle: function(skin, classSelector, wType) {
            var styleSheetObjs = window.document.styleSheets;
            var konyStyleSheetIndex = module.getKonyStyleSheetIndex(styleSheetObjs);
            if(konyStyleSheetIndex != -1) {
                var styleSheetObj = styleSheetObjs[konyStyleSheetIndex];
                var skinRuleIndex = module.getClassIndex(styleSheetObj, skin, wType);
                module.removeCSSRule(styleSheetObj, classSelector, wType);
                if(skinRuleIndex != -1) {
                    var rules = styleSheetObj.cssRules || styleSheetObj.rules;
                    if(styleSheetObj.insertRule)
                        styleSheetObj.insertRule(classSelector + "{" + rules.item(skinRuleIndex).style.cssText + "}", rules.length);
                    else
                        styleSheetObj.addRule(classSelector, rules.item(skinRuleIndex).style.cssText);
                } else {
                    kony.print("Specified skin: " + skin + " is  not defined in kony.css");
                }
            } else {
                kony.print("Style class not found!");
            }
        },

        removeCSSRule: function(styleSheetObj, classSelector) {
            var elementFocusRuleIndex = module.getClassIndex(styleSheetObj, classSelector);
            
            if(elementFocusRuleIndex != -1) {
                if(styleSheetObj.deleteRule)
                    styleSheetObj.deleteRule(elementFocusRuleIndex);
                else
                    styleSheetObj.removeRule(elementFocusRuleIndex);
            }
        },

        getKonyStyleSheetIndex: function(styleObjs) {
            var category = $KG["imagecat"];
            for(var k = 0; k < styleObjs.length; k++) {
                var hrefObj = styleObjs[k].href;
                if(hrefObj) {
                    var cssurl = hrefObj && hrefObj.split('/');
                    var lastname = cssurl[cssurl.length - 1];
                    if(lastname && lastname.indexOf("kony") != -1 && lastname.indexOf("konyspaiphoneretina") == -1) {
                        if(category) {
                            if(hrefObj.match(category.substring(0, category.length - 1) + ".css"))
                                return k;
                        } else
                            return k;
                    }
                }
            }
            kony.web.logger("warn", "SPA Stylesheet could not be loaded");
            return -1;
        },

        getClassIndex: function(styleObj, className, wType) {
            var rules = styleObj.cssRules || styleObj.rules;
            var count = 1; 
            
            var ruleNo = 0;
            if(className.indexOf("#") == -1) { 
                className = "." + className;
            }
            for(var k = 0; k < rules.length; k++) {
                if(rules[k].selectorText == className) {
                    count--;
                    ruleNo = k;
                    if(count == 0)
                        return k;
                }
            }
            return -1;
        },
    };


    return module;
}());


$KW.FlexUtils = (function() {
    
    

    var module = {
        
        
        getPreferredSize: function(widgetModel, conf) {
            var preferredSize = {
                width: 0,
                height: 0
            };
            var element = $KW.Utils.getWidgetNode(widgetModel);
            if(element && conf) {
                preferredSize.width = this.getPreferredWidth(widgetModel, element, conf.width);
                preferredSize.height = this.getPreferredHeight(widgetModel, element, conf.height);
                var wrapper = element.parentNode;
                wrapper.style.maxWidth = wrapper.style.maxHeight = '';
            }
            return preferredSize;
        },

        getPreferredWidth: function(widgetModel, element, maxWidth, updateUI) {
            var wrapper = element.parentNode;
            var initialWidth = wrapper.style.width;


            var defaultWidth = module.getDefaultWidth(widgetModel);
            wrapper.style.width = defaultWidth ? defaultWidth : 'auto';

            if(maxWidth != Number.MAX_VALUE)
                wrapper.style.maxWidth = maxWidth + 'px';

            if(!defaultWidth) { 
                var initialWrap = element.style.whiteSpace;
                element.style.whiteSpace = 'nowrap';
                element.style.whiteSpace = (wrapper.offsetWidth >= Math.floor(maxWidth)) ? 'pre-wrap' : 'nowrap';
            }

            var finalWidth = wrapper.offsetWidth;
            if(updateUI == false) {
                wrapper.style.width = initialWidth;
                if(!defaultWidth)
                    element.style.whiteSpace = initialWrap;
            }
            return finalWidth;
        },

        getPreferredHeight: function(widgetModel, element, maxHeight, updateUI) {
            var imgWidth, imgHeight, flexHeight;
            var wrapper = element.parentNode;
            var initialHeight = wrapper.style.height;
            var defaultHeight = module.getDefaultHeight(widgetModel);
            if(widgetModel.wType == "Segment" && widgetModel.viewtype == constants.SEGUI_VIEW_TYPE_TABLEVIEW) {
                if(widgetModel.autogrowMode == kony.flex.AUTOGROW_HEIGHT) {
                    defaultHeight = 'auto';
                    if(maxHeight == Number.MAX_VALUE) {
                        widgetModel.needScroller = false;
                        var scrollerInstance = $KG[element.id];
                        scrollerInstance && scrollerInstance.destroy();
                    }
                    else {
                        
                        if(element.scrollHeight > maxHeight) {
                            defaultHeight = maxHeight + 'px';
                        }
                    }
                }
            }
            if(widgetModel.wType == "FlexContainer" && widgetModel.autogrowMode == kony.flex.AUTOGROW_HEIGHT && widgetModel.canMeasureChildrenHeight) {
                
                widgetModel.autogrowHeight = true;
                var pModel = widgetModel.parent;
                if(pModel && pModel.autogrowHeight && pModel.canMeasureChildrenHeight)
                    return wrapper.offsetHeight;
                flexHeight = $KW.FlexLayoutEngine.getAutoGrowFlexHeight(widgetModel, element, widgetModel.widgets());
                defaultHeight =  module.getComputedPreferredHeight(widgetModel, element, flexHeight) + 'px';
            }
            wrapper.style.height = defaultHeight ? defaultHeight : "auto";

            if(widgetModel.wType == 'Image') {
                var imgNode = element.childNodes[0];
                if(updateUI == false) {
                    imgWidth = imgNode.style.width;
                    imgHeight = imgNode.style.height;
                }
                imgNode.style.height = imgNode.style.width = 'auto';
            }

            if(maxHeight != Number.MAX_VALUE)
                wrapper.style.maxHeight = maxHeight + "px";

            var finalHeight = wrapper.offsetHeight;
            if(updateUI == false) {
                if(widgetModel.wType == 'Image') {
                    imgNode.style.width = imgWidth;
                    imgNode.style.height = imgHeight;
                }
                wrapper.style.height = initialHeight;
            }
            return finalHeight;
        },

        convertPointToWidget: function(containerModel, point, toWidget) {
            var x = $KW.FlexLayoutEngine.toPointwidget(toWidget, containerModel, point.x, "x");
            var y = $KW.FlexLayoutEngine.toPointwidget(toWidget, containerModel, point.y, "y");

            return {
                "x": x.value + x.unit,
                "y": y.value + y.unit
            };
        },

        convertPointFromWidget: function(containerModel, point, fromWidget) {
            var x = $KW.FlexLayoutEngine.toPointwidget(containerModel, fromWidget, point.x, "x");
            var y = $KW.FlexLayoutEngine.toPointwidget(containerModel, fromWidget, point.y, "y");

            return {
                "x": x.value + x.unit,
                "y": y.value + y.unit
            };
        },

        
        setFlexContainerStyle: function(flexModel, flexNode) {
            var value, unit, parentNode, containerModel, viewportHeight;
            var width = flexModel.width;

            width = $KU.isValidCSSLength(width) ? width : module.getDefaultWidth(flexModel, false);
            var parentModel = flexModel.parent;

            
            var containerId = (flexModel.wType == 'FlexContainer') ? flexNode.childNodes[0].getAttribute("kcontainerID") : '';

            if(!parentModel && (flexNode.dataObj || containerId)) {
                if(containerId) {
                    containerModel = $KW.Utils.getContainerModelById(flexNode, containerId);
                    parentModel = containerModel.parent;
                } else {
                    containerModel = flexNode.dataObj.containerModel;
                    parentModel = containerModel.parent;
                }
                parentNode = $KW.Utils.getWidgetNode(containerModel);
            } else if(!parentModel) { 
                parentNode = flexNode.parentNode;
                if(flexModel.isheader) {
                    viewportHeight = $KU.getWindowHeight();
                }
            } else
                parentNode = $KW.Utils.getWidgetNode(parentModel);

            if(!parentNode)
                return;

            if(parentModel && parentModel.wType == 'TabPane' && module.isFlexWidget(parentModel)) {
                containerModel = parentModel;
                parentModel = parentModel.parent;
            }

            var node = flexNode;

            if(parentModel && width) {
                var obj = module.getValueAndUnit(flexModel, width);
                value = obj.value;
                unit = obj.unit;
                if(unit == kony.flex.PERCENTAGE) {
                    value = (value * parentNode.offsetWidth) / 100;
                }

                if(parentModel.percent == false || (containerModel && containerModel.wType == "CollectionView")) {
                    node.style.width = value + 'px';
                    module.updateWidthOnFrame(flexModel, value);
                }
                else if(flexModel.hexpand == false) {
                    var targetParentNode = node.parentNode;
                    
                    if(targetParentNode.tagName == 'LI') {
                        targetParentNode = targetParentNode.parentNode.parentNode;
                    }
                    var delta = Math.abs(value - targetParentNode.offsetWidth);
                    
                    if(value <= targetParentNode.offsetWidth || delta == 1) {
                        node.style.width = value + 'px';
                        module.updateWidthOnFrame(flexModel, value);
                    }
                }
            }

            var height = flexModel.height;
            if(!$KU.isValidCSSLength(height)) {
                
                if(flexModel.wType == 'FlexContainer' && flexModel.autogrowMode == kony.flex.AUTOGROW_HEIGHT) {
                    flexModel.layoutModel = {};
                    flexModel.autogrowHeight = true;
                    height = this.getComputedPreferredHeight(flexModel, flexNode, $KW.FlexLayoutEngine.getAutoGrowFlexHeight(flexModel, flexNode)) + 'dp';
                } else
                    height = module.getDefaultHeight(flexModel, false);
            }

            if(height) {
                var obj = module.getValueAndUnit(flexModel, height);
                value = obj.value;
                unit = obj.unit;
                if(unit == kony.flex.PERCENTAGE) {
                    if(containerModel && containerModel.wType == 'Segment' && containerModel.autoGrowHeight) {
                        
                        value = 100;
                    } else if(parentModel && (module.isFlexContainer(parentModel) || parentModel.wType == 'CollectionView'))
                        value = (value * parentNode.offsetHeight) / 100;
                    else if(viewportHeight)
                        value = (value * viewportHeight) / 100;
                    else
                        value = (value * parentNode.offsetWidth) / 100;
                }
                if(containerModel && containerModel.wType == 'Segment' && containerModel.viewtype == constants.SEGUI_VIEW_TYPE_PAGEVIEW && containerModel.needpageindicator) {
                    var calHeight = value;
                    if(unit == kony.flex.PERCENTAGE) {
                        var border = parseInt($KU.getStyle(parentNode, "border-top-width"), 10) + parseInt($KU.getStyle(parentNode, "border-bottom-width"), 10);
                        calHeight = (value - parentNode.childNodes[1].offsetHeight - border);
                    }
                    node.style.height = calHeight + 'px';

                } else if(containerModel && (containerModel.wType == 'TabPane') && (!(containerModel.viewconfig.tabViewConfig) || (containerModel.viewconfig.tabViewConfig && (containerModel.viewconfig.tabViewConfig.headerPosition == constants.TAB_HEADER_POSITION_TOP || containerModel.viewconfig.tabViewConfig.headerPosition == constants.TAB_HEADER_POSITION_BOTTOM)))) {
                    var headerHeight = 0, footerHeight = 0, footer = null;
                    if(containerModel.viewtype === 'tabview' || containerModel.viewtype === 'pageview') {
                        var header = $KU.getElementById($KW.Utils.getKMasterWidgetID(containerModel) + "_Header");
                        headerHeight = header.offsetHeight;
                        if(containerModel.viewtype === 'pageview'
                        && $KG.appbehaviors[constants.API_LEVEL] >= constants.API_LEVEL_8400) {
                            footer = $KU.getElementById($KW.Utils.getKMasterWidgetID(containerModel) + "_footer");
                            footerHeight = footer.offsetHeight;
                        }
                    } else {
                        var header = $KU.getElementById($KW.Utils.getKMasterWidgetID(flexModel) + "_Header");
                        headerHeight = header.offsetHeight;
                    }
                    node.style.height = (value - headerHeight - footerHeight) + 'px';
                } else
                    node.style.height = value + 'px';
            }

            if(flexModel.wType == 'FlexContainer') {
                node.childNodes[0].style.height = '100%';
            }
        },

        getFlexLayoutStyle: function(wModel) {
            var style = [];
            
            style.push('position:absolute');
            wModel.zindex && style.push('z-index:' + wModel.zindex);
            if($KU.hasTransform) {
                if($KU.hasWebkitTransform)
                    style.push("-webkit-transform:" + $KW.animUtils.applyTransform(wModel, wModel.transform));
                else
                    style.push("transform:" + $KW.animUtils.applyTransform(wModel, wModel.transform));
            }
            (typeof wModel.opacity != 'undefined') && style.push('opacity:' + wModel.opacity);
            if(wModel.wType != 'FlexContainer' || wModel.clipbounds) {
                style.push('border: 0px !important');
                style.push('background: transparent !important');
                
                if($KU.isIDevice || kony.appinit.isSafari) {
                    style.push('border-radius: 0px !important');
                }
            }

            if(module.isFlexWidget(wModel)) {
                var boxShadow = $KW.Utils.getBoxShadowStyle(wModel);
                if(boxShadow.length > 0) {
                    style.push("box-shadow: " + boxShadow);
                }

            }

            return style.join(";");
        },

        
        getWidth: function(wModel, layoutModel, wNode, flexNode, updateUI) {
            var flexContainer = wModel.parent;
            var isWidthSet = false;
            var width;

            var widthObj = layoutModel.width;

            if(widthObj) {
                width = (widthObj.value < 0 ? 0 : widthObj.value) + widthObj.unit;
                isWidthSet = true;
                var w = module.getValueByParentFrame(wModel, widthObj, 'x');
                if(w) module.updateWidthOnFrame(wModel, w);
            }

            if(!isWidthSet) {
                var implicitWidth;
                var minWidth = 0;
                var maxWidth = Number.MAX_VALUE;
                var minWidthObj = layoutModel.minWidth;
                var maxWidthObj = layoutModel.maxWidth;

                if(minWidthObj) {
                    minWidth = module.getValueByParentFrame(wModel, minWidthObj, 'x');
                    minWidth = minWidth < 0 ? 0 : minWidth;
                }
                if(maxWidthObj) {
                    maxWidth = module.getValueByParentFrame(wModel, maxWidthObj, 'x');
                    maxWidth = maxWidth < 0 ? 0 : maxWidth;
                }

                
                if(flexContainer.layouttype == kony.flex.FREE_FORM) {
                    var flexWidth = flexContainer.frame.width;
                    var centerX, left, right;

                    if(layoutModel.centerX) {
                        centerX = module.getValueByParentFrame(wModel, layoutModel.centerX, 'x');
                    }
                    if(layoutModel.left) {
                        left = module.getValueByParentFrame(wModel, layoutModel.left, 'x');
                    }
                    if(layoutModel.right) {
                        right = module.getValueByParentFrame(wModel, layoutModel.right, 'x');
                    }
                    if(layoutModel.centerX && layoutModel.left)
                        implicitWidth = (centerX - left) * 2;
                    else if(layoutModel.centerX && layoutModel.right)
                        implicitWidth = (flexWidth - centerX - right) * 2;
                    else if(layoutModel.left && layoutModel.right)
                        implicitWidth = flexWidth - left - right;

                    if(implicitWidth != undefined) {
                        var border = parseInt($KU.getStyle(flexNode, "border-right-width"), 10);
                        implicitWidth = implicitWidth - border;
                        implicitWidth = (implicitWidth < 0 ? 0 : implicitWidth);
                    }
                }
                var calWidth = (implicitWidth != undefined) ? implicitWidth : module.getPreferredWidth(wModel, wNode.childNodes[0], maxWidth, updateUI);
                module.updateWidthOnFrame(wModel, calWidth);
                width = this.enforceGivenDimension(calWidth, minWidth, maxWidth) + 'px';
            }
            if(widthObj || implicitWidth != undefined)
                module.setPreferredWidth(wModel, wNode);

            if(updateUI == undefined)
                wNode.style.width = width;
            else {
                var style = [];
                style.push('width:' + width);
                return style;
            }
        },

        getHeight: function(wModel, layoutModel, wNode, flexNode, updateUI) {
            var flexContainer = wModel.parent;
            var isHeightSet = false;
            var height;

            if(wModel.wType == 'FlexContainer')
                wModel.autogrowHeight = false;

            var heightObj = layoutModel.height;
            if(heightObj) {
                height = (heightObj.value < 0 ? 0 : heightObj.value) + heightObj.unit;
                isHeightSet = true;
            }

            if(!isHeightSet) {
                var implicitHeight;
                var minHeight = 0;
                var maxHeight = Number.MAX_VALUE;

                var minHeightObj = layoutModel.minHeight;
                var maxHeightObj = layoutModel.maxHeight;

                if(minHeightObj) {
                    minHeight = module.getValueByParentFrame(wModel, minHeightObj, 'y');
                    minHeight = minHeight < 0 ? 0 : minHeight;
                }

                if(maxHeightObj) {
                    maxHeight = module.getValueByParentFrame(wModel, maxHeightObj, 'y');
                    maxHeight = maxHeight < 0 ? 0 : maxHeight;
                }

                if(flexContainer.layouttype == kony.flex.FREE_FORM) {
                    var flexHeight = flexContainer.frame.height;
                    var centerY, top, bottom;

                    if(layoutModel.centerY) {
                        centerY = module.getValueByParentFrame(wModel, layoutModel.centerY, 'y');
                    }
                    if(layoutModel.top) {
                        top = module.getValueByParentFrame(wModel, layoutModel.top, 'y');
                    }
                    if(layoutModel.bottom) {
                        bottom = module.getValueByParentFrame(wModel, layoutModel.bottom, 'y');
                    }

                    if(layoutModel.centerY && layoutModel.top)
                        implicitHeight = (centerY - top) * 2;
                    else if(layoutModel.centerY && layoutModel.bottom)
                        implicitHeight = (flexHeight - centerY - bottom) * 2;
                    else if(layoutModel.top && layoutModel.bottom)
                        implicitHeight = flexHeight - top - bottom;

                    if(typeof implicitHeight != 'undefined') {
                        var border = parseInt($KU.getStyle(flexNode, "border-bottom-width"), 10);
                        implicitHeight = implicitHeight - border;
                        height = (implicitHeight < 0 ? 0 : implicitHeight);
                    }
                }
                var calHeight = (typeof implicitHeight != "undefined") ? implicitHeight : module.getPreferredHeight(wModel, wNode.childNodes[0], maxHeight, updateUI);

                if(wModel.wType == 'Image' && wModel.imagescalemode == constants.IMAGE_SCALE_MODE_MAINTAIN_ASPECT_RATIO) {
                    if(typeof implicitHeight == 'undefined') {
                        var span = wNode.childNodes[0];
                        var dimensions = {
                            width: span.offsetWidth + 'px',
                            height: span.offsetHeight + 'px'
                        };
                        dimensions = $KU.setImgAspectRatio(wModel, span.childNodes[0], dimensions, false);
                        calHeight = parseInt(dimensions.height, 10);
                    }
                }
                height = this.enforceGivenDimension(calHeight, minHeight, maxHeight) + 'px';
            }

            if(updateUI == undefined) {
                wNode.style.height = height;
                if(wModel.wType == "Segment" && wModel.viewtype == constants.SEGUI_VIEW_TYPE_TABLEVIEW) {
                    if(isHeightSet || typeof implicitHeight != "undefined") {
                        wModel.autoGrowHeight = false;
                    } else {
                        wModel.autoGrowHeight = true;
                    }
                    if(!wModel.needScroller && (isHeightSet || typeof implicitHeight != "undefined" || maxHeightObj)) {
                        wModel.needScroller = true;
                    }
                }
            } else {
                var style = [];
                style.push('height:' + height);
                return style;
            }
        },

        enforceGivenDimension: function(givenDimension, minDimension, maxDimension) {
            var returnDimension = givenDimension;
            if(minDimension <= maxDimension) {
                if(givenDimension < minDimension) {
                    returnDimension = minDimension;
                }
                if(givenDimension > maxDimension) {
                    returnDimension = maxDimension;
                }
            }
            return returnDimension;
        },

        setDimensions: function(wModel, wNode, flexNode) {
            if(wNode) {
                wNode = wNode.childNodes[0]; 
                var parentModel = wModel.parent;
                if(wNode && wModel.wType != 'Switch') {
                    wNode.style.width = '100%';
                    wNode.style.height = '100%';
                    if(wModel.wType == 'FlexContainer' && !(wModel.isTemplate && wModel.containerType == 'CollectionView')) {
                        wNode.childNodes[0].style.height = '100%'
                    }
                }

                if(wModel.wType == 'Image') {
                    
                    wNode.style.display = 'block';

                    var imgNode = wNode.childNodes[0];
                    var dimensions = {
                        width: wNode.offsetWidth + 'px',
                        height: wNode.offsetHeight + 'px'
                    };

                    this.handleImageScaleMode(wModel, imgNode, dimensions);
                } else if(wModel.wType == 'Switch') {
                    $KW.Switch.adjustWidth(wModel, wNode, true);
                    $KW.Switch.adjustHeight(wModel, wNode);
                } else if(wModel.wType == "Slider") {
                    var slider = $KU.getNodeByModel(wModel);
                    $KW.Slider.imgLoad(slider.childNodes[0]);
                }
                else if(wModel.wType == "ListBox" && wModel.viewtype == constants.LISTBOX_VIEW_TYPE_EDITVIEW) {
                    $KW.ListBox.adjustHeight(wNode);
                    $KW.ListBox.adjustWidth(wModel, wNode);
                }
            }
        },

        
        getDefaultWidth: function(wModel, needComplutedValue) {
            if(wModel.wType == 'Browser' && !wModel.htmlstring)
                return "";

            var defaultWidth = $KU.widgetsWidthMap[wModel.wType];
            if(defaultWidth)
                return(needComplutedValue == false) ? defaultWidth : module.getComputedValue(wModel, defaultWidth);

            return "";
        },

        
        getDefaultHeight: function(wModel, needComplutedValue) {
            var defaultHeight = $KU.widgetsHeightMap[wModel.wType];
            if(defaultHeight)
                return(needComplutedValue == false) ? defaultHeight : module.getComputedValue(wModel, defaultHeight);

            return "";
        },

        
        setPreferredWidth: function(wModel, wNode) {
            var iscontentDriven = $KU.inArray($KU.contentDrivenWidgets, wModel.wType)[0];
            if(iscontentDriven) {
                var node = wNode.childNodes[0];
                node.style.whiteSpace = 'pre-wrap';
            }
        },

        getChildHeight: function(wModel, wNode) {
            var maxHeight, defaultHeight = 'auto';
            if(wModel.autogrowMode == kony.flex.AUTOGROW_HEIGHT) {
                if(wModel.wType == "FlexContainer") {
                    wModel.autogrowHeight = true;
                    var containerId = wNode.childNodes[0].getAttribute("kcontainerID");
                    containerId && $KW.Utils.updateContainerDataInDOM(wNode, containerId);
                    return this.getComputedPreferredHeight(wModel, wNode, $KW.FlexLayoutEngine.getAutoGrowFlexHeight(wModel, wNode));
                } else if(wModel.wType == "Segment") {
                    if(wModel.layoutModel.maxHeight) {
                        maxHeight = module.getValueByParentFrame(wModel, wModel.layoutModel.maxHeight, 'y');
                        if(wNode.scrollHeight > maxHeight) {
                            defaultHeight = maxHeight + 'px';
                        }
                    }
                    wNode.parentNode.style.height = defaultHeight;
                    return this.getComputedPreferredHeight(wModel, wNode, $KW.Segment.getAutoGrowSegmentHeight(wModel, wNode));
                }
            } else {
                
                module.setPaddingByParent(wModel, wNode);
                return this.getComputedPreferredHeight(wModel, wNode);
            }

        },

        getComputedPreferredHeight: function(wModel, wNode, computedheight) {
            if(wModel.wType == 'Image') {
                var imgNode = wNode.childNodes[0];
                imgNode.autoGrowHeight = true;
                if(!wNode.childNodes[0].complete)
                    return 0;
            }
            var layoutModel = wModel.layoutModel;
            var minHeight = 0;
            var maxHeight = Number.MAX_VALUE;

            var minHeightObj = layoutModel.minHeight;
            var maxHeightObj = layoutModel.maxHeight;

            if(minHeightObj) {
                minHeight = module.getValueByParentFrame(wModel, minHeightObj, 'y');
                minHeight = minHeight < 0 ? 0 : minHeight;
            }

            if(maxHeightObj) {
                maxHeight = module.getValueByParentFrame(wModel, maxHeightObj, 'y');
                maxHeight = maxHeight < 0 ? 0 : maxHeight;
            }

            if(typeof computedheight == "undefined") {
                computedheight = module.getPreferredHeight(wModel, wNode, maxHeight);
                if(wModel.wType == 'Image' && wModel.imagescalemode == constants.IMAGE_SCALE_MODE_MAINTAIN_ASPECT_RATIO) {
                    var dimensions = {
                        width: wNode.offsetWidth + 'px',
                        height: wNode.offsetHeight + 'px'
                    };
                    var img = wNode.childNodes[0];
                    dimensions = $KU.setImgAspectRatio(wModel, img, dimensions, false);
                    computedheight = parseInt(dimensions.height, 10);
                    if(img) {
                        img.style.width = dimensions.width;
                        img.style.height = dimensions.height;
                    }
                }
            }
            return this.enforceGivenDimension(computedheight, minHeight, maxHeight);
        },

        getWidgetDimensions: function(wModel, wNode) {
            var parentModel = wModel.parent;
            if(parentModel && parentModel.frame && typeof parentModel.frame.x != 'undefined') {
                var width = wNode.style.width;
                var widthObj = {
                    value: parseFloat(width),
                    unit: module.getUnit(width)
                };
                width = module.getValueByParentFrame(wModel, widthObj, 'x');
                var height = wNode.style.height;
                var heightObj = {
                    value: parseFloat(height),
                    unit: module.getUnit(height)
                };
                height = module.getValueByParentFrame(wModel, heightObj, 'y');
            } else {
                var width = wNode.offsetWidth;
                var height = wNode.offsetHeight;
            }
            return {
                width: width,
                height: height
            };
        },

        getWidgetFrame: function(wModel, wNode, needOffset) {
            var offset = (typeof needOffset == "undefined") ? $KW.Utils.getOffset(wNode) : {
                top: 0,
                left: 0
            };
            var dimensions = this.getWidgetDimensions(wModel, wNode);
            return {
                x: parseInt(offset.left, 10),
                y: parseInt(offset.top, 10),
                width: dimensions.width,
                height: dimensions.height
            };
        },

        setWidgetPosition: function(wModel, frame, wNode) {
            wNode = wNode || $KU.getNodeByModel(wModel);
            wNode.style.left = wNode.style.right = wNode.style.top = wNode.style.bottom = "";
            for(var pos in frame) {
                wNode.style[pos] = frame[pos]; 
            }
            if(!wNode.style.left)
                wNode.style.left = '0%';
            if(!wNode.style.top)
                wNode.style.top = '0%';
        },

        getPercentValue: function(wModel, value, prop) {
            var parent = wModel.parent;
            if(!parent)
                return;
            if(typeof value != 'undefined' && value.indexOf('px') != -1 && prop == 'left') {
                var pFrame = parent.frame;
                var refValue;
                if(prop == 'left') {
                    var width = pFrame.width;
                    if(parent.wType == 'FlexContainer')
                        width = width - parent.hBorder;
                    refValue = width;
                } else if(prop == 'top') {
                    refValue = pFrame.height;
                }
                if(refValue) {
                    var result = (parseInt(value, 10) * 100) / refValue;
                    return isNaN(result) ? '0%' : (result.toFixed(1) + '%');
                }
            } else
                return value;
        },

        saveWidgetFrame: function(wModel) {
            if(wModel.wType == 'FlexContainer' || wModel.wType == 'FlexScrollContainer') {
                wModel.oldFrame = owl.deepCopy(wModel.frame);
            }
        },

        updateWidthOnFrame: function(wModel, width) {
            var layoutModel = wModel.layoutModel || {};
            var minWidth = 0;
            var maxWidth = Number.MAX_VALUE;
            var minWidthObj = layoutModel.minWidth;
            var maxWidthObj = layoutModel.maxWidth;

            if(minWidthObj) {
                minWidth = module.getValueByParentFrame(wModel, minWidthObj, 'x');
                minWidth = minWidth < 0 ? 0 : minWidth;
            }
            if(maxWidthObj) {
                maxWidth = module.getValueByParentFrame(wModel, maxWidthObj, 'x');
                maxWidth = maxWidth < 0 ? 0 : maxWidth;
            }
            if(!wModel.width) {
                width = module.enforceGivenDimension(width, minWidth, maxWidth);
            }
            wModel.frame = {x: wModel.frame.x, y: wModel.frame.y, width: width, height: wModel.frame.height};
        },

        setPaddingByParent: function(wModel, wNode) {
            if(module.isFlexContainer(wModel) || wModel.wType == 'Slider' || wModel.wType == 'Switch')
                return;
            var parent = wModel.parent;
            var padding = wModel.padding;
            if(parent && padding && $KU.isArray(padding)) {
                var result = '';
                var parentWidth = parent.frame.width;
                for(var i = 1; i < padding.length; i++) {
                    if(wModel.paddingInPixel) {
                        result += (padding[i] + 'px ');
                    } else {
                        result += parseInt((padding[i] * parentWidth) / 100, 10) + 'px ';
                    }
                }
                if(wModel.paddingInPixel) {
                    result += (padding[0] + 'px ');
                } else {
                    result += parseInt((padding[0] * parentWidth) / 100, 10) + 'px ';
                }
                wNode.style.padding = result;
            }
        },

        
        isFlexWidget: function(wModel) {
            var parentModel = wModel.parent;
            if(parentModel) {
                var wType = parentModel.wType;
                if(wType == "FlexContainer" || wType == "FlexScrollContainer" || (wType == 'Form' && parentModel.layouttype && parentModel.layouttype != kony.flex.VBOX_LAYOUT && parentModel.layouttype != constants.CONTAINER_LAYOUT_GRID))
                    return true;

            }
            return false;
        },

        isFlexContainer: function(wModel) {
            if(wModel) {
                var wType = wModel.wType;
                if(wType == "FlexContainer" || wType == "FlexScrollContainer" || (wType == 'Form' && wModel.layouttype && wModel.layouttype != kony.flex.VBOX_LAYOUT && wModel.layouttype != constants.CONTAINER_LAYOUT_GRID))
                    return true;
            }
            return false;
        },

        canContainFlexModel: function(wModel) {
            var isFlexModelContainer = false;
            var containerList = [
                'Form',
                'FlexContainer',
                'FlexScrollContainer',
                'Tab',
                'TabPane',
                'KComponent'
            ];

            if(containerList.indexOf(wModel.wType) !== -1) {
                isFlexModelContainer = true;
            }
            return isFlexModelContainer;
        },

        getComputedValue: function(wModel, value) {
            if(!$KU.isValidCSSLength(value))
                return null;
            var obj = this.getValueAndUnit(wModel, value);
            return obj.value + obj.unit;
        },

        splitValueAndUnit: function(value) {
            if(value && typeof value == 'string') {
                var units = $KU.flexUnits;
                for(var i = 0; i < units.length; i++) { 
                    if(value.lastIndexOf(units[i]) != -1) {
                        value = parseFloat(value);
                        unit = units[i];
                        break;
                    }
                }
            }
            return {
                value: value,
                unit: unit
            };
        },

        getValueAndUnit: function(wModel, value) {
            var flexModel = module.isFlexContainer(wModel) ? wModel : wModel.parent;
            var unit = flexModel.defaultunit || kony.flex.DEFAULT_UNIT;
            if(value && typeof value == 'string') {
                var units = $KU.flexUnits;
                for(var i = 0; i < units.length; i++) { 
                    if(value.lastIndexOf(units[i]) != -1) {
                        value = parseFloat(value);
                        unit = units[i];
                        break;
                    }
                }
            }
            value = parseFloat(value); 
            if(unit == kony.flex.PX) {
                value = value / $KU.dpi;
            }
            if(unit == kony.flex.DP) {
                
                unit = 'px';
            }
            return {
                value: value,
                unit: unit
            };
        },

        getUnit: function(value) {
            var units = $KU.flexUnits;
            for(var i = 0; i < units.length; i++) { 
                if(value.lastIndexOf(units[i]) != -1) {
                    unit = units[i];
                    return unit;
                }
            }
        },

        getValueByParentFrame: function(wModel, valueObj, axis, exisitinsParentFrame) {
            var parentFrame = exisitinsParentFrame || wModel.parent.frame;
            var value = valueObj.value;
            var unit = valueObj.unit;
            var pModel = wModel.parent;
            if(unit == kony.flex.PERCENTAGE && parentFrame) {
                if(axis == 'x') {
                    var width = parentFrame.width;
                    if(pModel && pModel.wType == 'FlexContainer')
                        width = width - pModel.hBorder;
                    value = (value * width) / 100;
                } else if(axis == 'y') {
                    var height = parentFrame.height;
                    if(pModel && pModel.wType == 'FlexContainer')
                        height = height - pModel.vBorder;
                    value = (value * height) / 100;
                }
            }
            return value;
        },

        getValueByWidgetFrame: function(valueObj, axis, widgetFrame) {
            var value = valueObj.value, unit = valueObj.unit,
                width = null, height = null;

            if(unit == kony.flex.PERCENTAGE && widgetFrame) {
                if(axis == 'x') {
                    width = widgetFrame.width;
                    value = (value * width) / 100;
                } else if(axis == 'y') {
                    height = widgetFrame.height;
                    value = (value * height) / 100;
                }
            } else if(unit == kony.flex.PX) {
                value = value / $KU.dpi;
            }
            return value;
        },

        setLayoutConfig: function(wModel, val, oldValue) {
            if(val != oldValue) {
                wModel.layoutConfig = {
                    self: true,
                    children: false
                };

                this.updateAutoGrowFlexConfig(wModel);
            }
        },

        handleContainerData: function(widgetModel, value, propertyName) {
            var wNode, containerModel, containerId;

            if(widgetModel.isCloned == true) {
                containerId = widgetModel.containerId;

                if(containerId) {
                    wNode = $KW.Utils.getWidgetNode(widgetModel);

                    if(wNode) {
                        containerModel = $KW.Utils.getContainerModelById(wNode, containerId);
                    }

                    if(containerModel && containerModel.wType == "CollectionView") {
                        containerModel.layoutConfig = {
                            self: true,
                            children: false
                        };

                        $KW.Utils.updateClonedModelData(widgetModel, containerModel, propertyName);
                    }
                }
            }
        },

        setChildrenConfig: function(wModel, val, oldValue) {
            if(val != oldValue
            && (wModel.layouttype === kony.flex.FLOW_VERTICAL
            || wModel.layouttype === kony.flex.FLOW_HORIZONTAL)) {
                this.setLayoutConfig(wModel, val, oldValue);
                wModel.layoutConfig.children = true;
            }
        },

        updateAutoGrowFlexConfig: function(wModel) {
            var pModel = wModel.parent;

            if(pModel && pModel.autogrowMode
            && ['FlexContainer', 'FlexScrollContainer'].indexOf(pModel.wType) >= 0) {
                pModel.layoutConfig = {
                    self: true,
                    children: true
                };

                this.updateAutoGrowFlexConfig(pModel);
            }
        },

        getAutoGrowFlexConfigContainer: function(wModel) {
            var pModel = wModel;
            while(pModel.parent) {
                pModel = pModel.parent;
                if((pModel.wType == 'FlexContainer' || pModel.wType == 'FlexScrollContainer') && pModel.autogrowHeight) {
                    pModel.layoutConfig = {
                        self: true,
                        children: true
                    };
                } else {
                    break;
                }
            }
            return pModel;
        },

        
        updateLayoutConfig: function(wModel) {
            wModel.layoutConfig = {
                self: true,
                children: false
            };
        },

        updateFlexScrollLayout: function(wModel) {
            var widgetModel, widgetNode, widgets, parentModel, parentNode;
            parentModel = wModel.parent;
            parentNode = $KU.getNodeByModel(parentModel);
            if((parentNode.offsetHeight != parentNode.scrollHeight) || (parentNode.offsetWidth != parentNode.scrollWidth)) {
                widgets = parentModel.widgets();
                for(i = 0; i < widgets.length; i++) {
                    widgetModel = widgets[i];
                    widgetModel = $KW.Utils.getActualWidgetModel(widgetModel);
                    widgetNode = $KU.getNodeByModel(widgetModel);
                    module.updateLayoutConfig(widgetModel, widgetNode);
                }
            }
        },

        
        updateWidgetsConfig: function(boxModel, wArray) {
            if(wArray && wArray.length > 0) {
                for(var i = 0; i < wArray.length; i++) {
                    var wModel = wArray[i];
                    wModel = $KW.Utils.getActualWidgetModel(wModel);
                    var isFlexWidget = module.isFlexWidget(wModel);
                    (isFlexWidget || wModel.wType == "Segment") && this.updateLayoutConfig(wModel);
                    if(wModel.wType == "FlexContainer" || wModel.wType == "FlexScrollContainer")
                        wModel.layoutConfig.children = true;
                    wModel.ownchildrenref && this.updateWidgetsConfig(wModel, wModel.ownchildrenref);
                }
            }
        },

        
        onWidgetRemove: function(boxModel, index) {
            if(module.isFlexContainer(boxModel) && boxModel.layouttype) {
                if(boxModel.layouttype != kony.flex.FREE_FORM) {
                    var nextSibiling = boxModel.ownchildrenref[index];
                    if(nextSibiling) {
                        nextSibiling = $KW.Utils.getActualWidgetModel(nextSibiling);
                        this.updateLayoutConfig(nextSibiling);
                        
                    }
                }
                this.updateLayoutConfig(boxModel);
                this.updateAutoGrowFlexConfig(boxModel);
            }
        },

        
        shouldApplyRTL: function(widgetModel, propertyName) {
            var currentlocale = $KI.i18n && $KG["currentlocale"],
                layoutConfig = $KG['localeLayoutConfig'],
                appPropertyName, widgetPropertyName, localeLevelPropertyMap = {
                    'flexPosition': 'mirrorFlexPositionProperties',
                    'contentAligment': 'mirrorContentAlignment',
                    'layoutAlignment': 'mirrorFlowHorizontalAlignment'
                },
                widgetLevelPropertyMap = {
                    'flexPosition': 'retainFlexPositionProperties',
                    'contentAligment': 'retainContentAlignment',
                    'layoutAlignment': 'retainFlowHorizontalAlignment'
                };
            if($KG.appbehaviors['isI18nLayoutConfigEnabled'] && layoutConfig 
                &&
                currentlocale && layoutConfig[currentlocale]) { 
                layoutConfig = layoutConfig[currentlocale];
                appPropertyName = localeLevelPropertyMap[propertyName];
                widgetPropertyName = widgetLevelPropertyMap[propertyName];
                if(layoutConfig[appPropertyName] && !widgetModel[widgetPropertyName]) {
                    return true;
                }
            }
            return false;
        },

        
        resetRTL: function(widgetModel) {
            var requireFlexRTL = module.shouldApplyRTL(widgetModel, "flexPosition"),
                requireContentAlignment = module.shouldApplyRTL(widgetModel, "contentAligment"),
                temp;
            if((widgetModel.isContentAlignmentMirrored && !requireContentAlignment) ||
                (!widgetModel.isContentAlignmentMirrored && requireContentAlignment)) {
                widgetModel.contentalignment = $KW.Utils.getMirrorAlignment(widgetModel.contentAlignment);
                widgetModel.isContentAlignmentMirrored = true;
            }
            if((widgetModel.isFlexPositionPropertiesMirrored && !requireFlexRTL) ||
                (!widgetModel.isFlexPositionPropertiesMirrored && requireFlexRTL)) {
                temp = widgetModel.left;
                widgetModel.left = widgetModel.right;
                widgetModel.right = temp;
                widgetModel.padding = $KW.Utils.getMirroredMarginPadding(widgetModel.padding);
                widgetModel.margin = $KW.Utils.getMirroredMarginPadding(widgetModel.margin);
                widgetModel.isFlexPositionPropertiesMirrored = true;
            }
        },

        
        setRTLtoTemplates: function(templateModel) {
            var childrenList, childrenLength, childCount = 0,
                childModel, containerChild;

            if(templateModel.widgets) {
                childrenList = templateModel.widgets();
            }
            if(childrenList) {
                childrenLength = childrenList.length;
                for(childCount = 0; childCount < childrenLength; childCount++) {
                    childModel = childrenList[childCount];
                    module.setRTLtoTemplates(childModel);
                    module.resetRTL(childModel);
                }
            }
        },

        handleImageScaleMode: function(imageModel, imageNode, imageSize) {
            if(imageModel.imagescalemode === constants.IMAGE_SCALE_MODE_MAINTAIN_ASPECT_RATIO) {
                $KU.setImgAspectRatio(imageModel, imageNode, imageSize);
                $KU.getImageCenterAlign(imageNode, true);
            } else if(imageModel.imagescalemode === constants.IMAGE_SCALE_MODE_FIT_TO_DIMENSIONS) {
                $KU.setImgDimensions(imageModel, imageNode, imageSize);
            }
        }
    };


    return module;
}());


$KW.APIUtils = (function() {
    
    

    var module = {
        setvisibility: function(widgetModel, value) {
            if(widgetModel) {
                widgetModel = $KW.Utils.getActualWidgetModel(widgetModel);
                if(widgetModel.parent && widgetModel.parent.wType == "TabPane") 
                    return;

                widgetModel.isvisible = value;
                var element, element2, tabpaneWidgetModel;

                if(widgetModel.wType == "Tab") {
                    if(widgetModel.kmasterid) {
                        tabpaneWidgetModel = $KU.getWidgetModelByID(widgetModel.id);
                    } else {
                        tabpaneWidgetModel = kony.model.getWidgetModel(widgetModel.pf, widgetModel.parent && widgetModel.parent.id);
                    }
                    if(tabpaneWidgetModel.view === 'tabview') {
                        element = $KU.getElementById($KW.Utils.getKMasterWidgetID(widgetModel) + "_Li");
                        element2 = $KU.getElementById($KW.Utils.getKMasterWidgetID(widgetModel) + "_Body");
                    } else
                        element = $KU.getNodeByModel(widgetModel);
                } else
                    element = $KW.Utils.getWidgetNode(widgetModel);

                element = $KW.Utils.getClonedTemplateNode(element, widgetModel, "isvisible");

                if(element) {
                    var isFlexWidget = $KW.FlexUtils.isFlexWidget(widgetModel);
                    if(widgetModel.wType == 'CheckBoxGroup' || widgetModel.wType == 'RadioButtonGroup' || widgetModel.wType == 'ListBox' || (widgetModel.wType == 'Segment' && !isFlexWidget)) {

                        var data = widgetModel.masterdata || widgetModel.data || $KW.Utils.getMasterData(widgetModel);
                        if(!data || (data && data.length <= 0))
                            value = false;
                    }

                    
                    var displayNode = isFlexWidget ? element.parentNode : element;
                    if(value.toString() == "false") {
                        $KU.addClassName(displayNode, "hide");
                    } else {
                        $KU.removeClassName(displayNode, "hide");
                        if(widgetModel.wType == "Tab" && tabpaneWidgetModel.view === 'tabview') {
                            element.style.display = "inline";
                        }
                    }

                    this.onVisibilityChange(widgetModel, value);

                    if(widgetModel.viewtype && widgetModel.viewtype == "pageview") {
                        
                        widgetModel.isvisible && $KW.touch.computeWidths($KU.getNodeByModel(widgetModel), widgetModel);
                    }

                    if(value && widgetModel.wType === "Switch") { 
                        $KW.Switch.adjustWidth(widgetModel, element, false);
                        $KW.Switch.adjustHeight(widgetModel, element);
                    }

                    if(value && widgetModel.wType === "Calendar") { 
                        $KW.Calendar.setCalElementStyle(element.childNodes[0], true);
                        value && $KW.Calendar.adjustCalendars(widgetModel);
                    }

                    if(value && widgetModel.wType == "Slider") {
                        var slider = $KU.getNodeByModel(widgetModel);
                        $KW.Slider.imgLoad(slider.childNodes[0]);
                    }

                    value && widgetModel.ownchildrenref && $KW.Utils.reinitializeWidgets(widgetModel);
                    if(typeof google != "undefined")
                        $KW.Utils.resizeMap(widgetModel);
                } else {
                    if(widgetModel.kmasterid) {
                        tabpaneWidgetModel = $KU.getWidgetModelByID(widgetModel.id);
                    } else {
                        tabpaneWidgetModel = kony.model.getWidgetModel(widgetModel.pf, widgetModel.parent && widgetModel.parent.id);
                    }
                    if(tabpaneWidgetModel && tabpaneWidgetModel.viewtype === 'tabview') {
                        element = $KU.getElementById($KW.Utils.getKMasterWidgetID(widgetModel) + "_Li");
                        element2 = $KU.getElementById($KW.Utils.getKMasterWidgetID(widgetModel) + "_Body");

                        if(value.toString() == "false")
                            $KU.addClassName(element, "hide");
                        else {
                            $KU.removeClassName(element, "hide");
                            if(tabpaneWidgetModel.viewtype === 'tabview') {
                                element.style.display = "inline";
                            }
                        }
                    } else
                        element = $KU.getNodeByModel(widgetModel);
                }

                if(element2) {
                    var index = element.getAttribute("index");
                    if(value == false || value == "false")
                        $KU.addClassName(element2, "hide");
                    else {
                        if(tabpaneWidgetModel && ((tabpaneWidgetModel.activetab - IndexJL) == parseInt(index))) {
                            $KU.removeClassName(element2, "hide");
                        }
                    }
                }
                

                if(value) {
                    if(widgetModel.id) {
                        var currentFormId = widgetModel.pf || "";
                        var widgetElement = $KU.getElementById(currentFormId + "_" + widgetModel.id);
                        var lineNodes = widgetElement && widgetElement.querySelectorAll("#" + currentFormId + " div[kwidgettype='Line'][direction='V']");
                        if(lineNodes && lineNodes.length > 0) {
                            $KW.Line.initializeView(currentFormId);
                        }
                    }
                    if(widgetModel.wType == "FlexContainer" || widgetModel.wType == "FlexScrollContainer") {
                        setTimeout(function() {
                            $KG.isUILayedOut = false;
                            widgetModel.forceLayout();
                            $KW.Image.imgOrientationHandler(widgetModel);
                            $KG.isUILayedOut = true;
                        }, 1);
                    }
                }
                
                setTimeout(function() {
                    $KW.Map && $KW.Map.map && google.maps.event.trigger($KW.Map.map, 'resize');
                }, 1);
            }
        },

        
        onVisibilityChange: function(wModel, value) {
            $KW.FlexUtils.updateLayoutConfig(wModel);
            $KW.FlexUtils.updateAutoGrowFlexConfig(wModel);
            value && wModel.ownchildrenref && $KW.FlexUtils.updateWidgetsConfig(wModel, wModel.ownchildrenref);
        },

        setenabled: function(widgetModel, value) {
            if(!widgetModel || typeof value != "boolean")
                return;

            widgetModel.disabled = !value;
            var id = $KW.Utils.getKMasterWidgetID(widgetModel); 
            if((widgetModel.wType == "Tab" || widgetModel.name == "kony.ui.Tab")) {
                if(widgetModel.parent.viewtype == "tabview") {
                    var tabHeader = $KU.getElementById(id + "_A");
                    if(tabHeader) {
                        tabHeader.disabled = !value;
                        tabHeader.setAttribute("kdisabled", !value);
                        var tabBody = $KU.getElementById(id + "_Body");
                        tabBody.setAttribute("kdisabled", !value);
                        id = id + "_Body";
                    }
                }
                if(widgetModel.parent.viewtype == "collapsibleview") {
                    id = id + "_Tab";
                }
            }
            var children = document.querySelectorAll("#" + id + ", #" + id + " [kwidgettype]");
            var node, widgettype, tpwidgettype;
            for(i = 0; i < children.length; i++) {
                node = children[i];
                widgettype = node.getAttribute("kwidgettype");
                tpwidgettype = node.getAttribute("tpwidgettype");
                
                if($KU.isWindowsPhone && $KU.isIE9 && node.tagName == 'SELECT') {
                    for(var j = 0; j < node.childNodes.length; j++) {
                        node.children[j].disabled = !value;
                    }
                }
                if(widgettype != "Label") 
                    node.disabled = !value;
                
                if(widgettype == "RichText")
                    var aEle = document.querySelectorAll("#" + node.id + " a");
                if(widgettype == "RichText" && aEle && !value) {
                    node.ishref = true;
                    node.innerHTML = node.innerHTML.replace(/href=["'].*?["']/g, "href='javascript:void(0)'");
                } else if(node.ishref) {
                    node.innerHTML = widgetModel.text;
                }
                if((widgettype == "RadioButtonGroup" || widgettype == "CheckBoxGroup") && node.tagName == "INPUT" && widgetModel.itemorientation == "vertical") 
                    node.parentNode.setAttribute("kdisabled", !value);

                if(widgetModel.wType == "Label") {
                    var propertyValue = !!(value && widgetModel.textCopyable) ? "text" : "none";
                    if('MozUserSelect' in node.style) {
                        node.style.MozUserSelect = propertyValue;
                    } else if('webkitUserSelect' in node.style) {
                        node.style.webkitUserSelect = propertyValue;
                    } else if('msUserSelect' in node.style) {
                        node.style.msUserSelect = propertyValue;
                    }
                }
                if(widgettype == "Video") {

                    if(value) {
                        node.oncontextmenu = "";
                        node.playing && node.paused && node.play();
                        if(widgetModel.controls)
                            node.setAttribute("controls", "controls");
                    } else {
                        node.playing && node.pause();
                        node.removeAttribute("controls");
                        node.oncontextmenu = function() {
                            return false
                        };
                    }
                }

                node.setAttribute("kdisabled", !value); 

                
                if(widgetModel.wType === "Map" && (node.getAttribute("kwidgettype") === "Map" || node.getAttribute("kwidgettype") === "googlemap")) {
                    widgetModel.disabled = !value;
                    $KW.Map.setEnabledMap(widgetModel, node);
                }
            }
        },

        setfocus: function(widgetModel, popupModel, element, needToSetCursor) {
            var widgetHTMLObj = (element) ? element : $KU.getNodeByModel(widgetModel);
            if(widgetModel.wType == "TextArea" || widgetModel.wType == "TextField") {
                widgetHTMLObj && widgetHTMLObj.focus();
            } else {
                widgetHTMLObj && $KW.Utils.scrollToElement(widgetModel, widgetHTMLObj);
            }
        },

        
        
        
        
        getContentOffsetMeasured: function(model, widgetNode) {
            var contentOffSet = {
                x: 0,
                y: 0
            };

            var node = widgetNode || $KU.getNodeByModel(model);
            if(model.wType == 'Segment' && model.viewType == 'pageview') {
                if(node) {
                    contentOffSet.x = model.data.length * model.swipeContext.imageWidth - node.scrollWidth;
                    contentOffSet.y = 0;
                }
            } else {
                if(node) {
                    contentOffSet.x = node.scrollLeft;
                    contentOffSet.y = node.scrollTop;
                }
            }
            return contentOffSet;
        },

        getModelForContentOffset: function(formId, widgetType) {
            var widgetNodes = document.querySelectorAll("#" + formId + " div[kwidgettype='" + widgetType + "']");
            for(var i = 0; i < widgetNodes.length; i++) {
                var model = $KU.getModelByNode(widgetNodes[i]);
                model.contentoffset && module.setContentOffSet(model, model.contentoffset, false);
            };
        },

        setContentOffSet: function(model, contentOffSet, animate) {
            _setTopLeftToNode = function(model, node, left, top) {
                module.setfocus(model);
                node.scrollLeft = left;
                node.scrollTop = top;
            }
            var scrollerInstance;
            var element = $KU.getNodeByModel(model);
            var left = 0,
                top = 0;
            left = $KW.FlexUtils.getValueByParentFrame(model, $KW.FlexUtils.getValueAndUnit(model, contentOffSet.x), 'x', model.frame);
            top = $KW.FlexUtils.getValueByParentFrame(model, $KW.FlexUtils.getValueAndUnit(model, contentOffSet.y), 'y', model.frame);

            if(model.wType == 'Segment' && model.viewType == constants.SEGUI_VIEW_TYPE_PAGEVIEW && model.swipeContext) {
                var pageIndex = left && parseInt(left / model.swipeContext.imageWidth);
                if(pageIndex < 0) pageIndex = 0;
                if(pageIndex > model.data.length) pageIndex = model.data.length - 1;
                var imgsElement = element.children[0];
                $KW.touch.scrollImages(imgsElement, model.swipeContext.imageWidth * pageIndex, $KU.swipeDuration, false);
                model.swipeContext.currentPage = pageIndex;
                $KW.touch.updatePageIndicator(element, model.swipeContext, model);
                return;
            }
            var node = $KU.getNodeByModel(model);
            if(model.wType == 'Segment' && $KW.Segment.isLazyLoadingApplicable(model)) {
                node && $KW.Segment.generateAndAdjustSegmentTillContentOffSetReached(model, node, top);
            }
            if(node) {
                _setTopLeftToNode(model, node, left, top);
            }
        },

        getOnScrollWidgets: function(widgetModel, onScrollWidgets) {
            var childModel = null,
                i = 0,
                length = 0,
                children = [];

            if($KW.FlexUtils.isFlexContainer(widgetModel)) {
                children = widgetModel.widgets();
            }

            length = children.length;

            for(i = 0; i < length; i++) {
                childModel = children[i];

                if(childModel.onscrollwidgetposition) {
                    onScrollWidgets.push(childModel);
                }

                if($KW.FlexUtils.isFlexContainer(childModel)) {
                    this.getOnScrollWidgets(childModel, onScrollWidgets);
                }
            }

            return onScrollWidgets;
        },

        executeOnScrollingWidgetPosition: function(parentModel) {
            var onScrollWidgets, parentNode, i, widgetModel, widgetNode, pos, onScrollWidgetPositionEvent;

            onScrollWidgets = this.getOnScrollWidgets(parentModel, []);
            parentNode = $KU.getNodeByModel(parentModel);

            for(i = 0; i < onScrollWidgets.length; i++) {
                widgetModel = onScrollWidgets[i];
                widgetNode = $KU.getNodeByModel(widgetModel);
                pos = $KW.Utils.getPosition(widgetNode);
                onScrollWidgetPositionEvent = widgetModel.onscrollwidgetposition;
                onScrollWidgetPositionEvent && $KU.executeWidgetEventHandler(widgetModel, onScrollWidgetPositionEvent, pos.left, pos.top, widgetModel.frame.x, widgetModel.frame.y);
            }
            $KW.FlexContainer.forceLayout(parentModel);
        }
    };


    return module;
}());


$KW.ImageUtils = (function() {



    var module = {
        
    };


    return module;
}());

$KW.touch = (function() {
    
    

    var module = {
        
        computeSnapWidths: function(formId, widgetType, initialize) {
            
            var swipeElements = document.querySelectorAll("#" + formId + " div[name='touchcontainer_" + widgetType + "']");
            for(var i = 0; i < swipeElements.length; i++) {
                var swipeElement = swipeElements[i];
                var widgetModel = $KU.getModelByNode(swipeElement);
                if(widgetType == "Tabpane") {
                    widgetModel = $KU.getModelByNode(swipeElement.parentNode);
                }
                module.computeWidths(swipeElement, widgetModel);
            }
        },

        computeWidths: function(swipeElement, widgetModel) {
            var imgsElement = swipeElement.children[0];
            var slides = imgsElement.children;
            var noOfSwipePages = slides.length;
            imgsElement.style.width = noOfSwipePages * 100 + "%";
            var widthRatio = 0;
            var IMG_WIDTH = 0;
            var percent = 100 / noOfSwipePages;

            if(slides.length > 0) {
                for(var j = 0; j < slides.length; j++) {
                    slides[j].style.display = "inline";

                    if(widgetModel.wType == "Segment" || widgetModel.wType == "TabPane") {
                        slides[j].style.width = percent + "%"; 
                        if(widgetModel.wType == "TabPane") {
                            if($KU.isIE)
                                slides[j].style.styleFloat = "left";
                            else
                                slides[j].style.cssFloat = "left";
                        }
                    } else {
                        slides[j].style.width = Math.floor(slides[j].offsetWidth / noOfSwipePages) + 'px';
                    }
                }
                slides[0].style.display = "block";
                IMG_WIDTH = slides[0].offsetWidth;
            }

            if(window.orientation === 90 || window.orientation === -90) { 
                widthRatio = IMG_WIDTH / screen.height;
            } else if(window.orientation === 0 || window.orientation === 180) { 
                widthRatio = IMG_WIDTH / screen.width;
            }
            swipeElement.setAttribute("imageWidth", IMG_WIDTH);
            swipeElement.setAttribute("ratio", widthRatio);

            
            if(!widgetModel.swipeContext) widgetModel.swipeContext = {};
            var swipeContext = widgetModel.swipeContext;
            swipeContext.imageWidth = IMG_WIDTH;
            swipeContext.widthRatio = widthRatio;
            swipeContext.wType = widgetModel.wType;

            if(widgetModel.focusedindex) {
                if(widgetModel.wType === "Segment") {
                    swipeContext.currentPage = widgetModel.focusedindex - IndexJL;
                } else {
                    swipeContext.currentPage = Math.ceil(widgetModel.focusedindex / widgetModel.recperpage) - IndexJL;
                }
            } else {
                swipeContext.currentPage = 0;
            }

            if(widgetModel.wType == "TabPane") {
                swipeContext.currentPage = widgetModel.activetab;
                widgetModel.swipeContext.currentPage = swipeContext.currentPage;
            }

            module.scrollImages(imgsElement, swipeContext.imageWidth * swipeContext.currentPage, $KU.swipeDuration, true);
            module.updatePageIndicator(swipeElement, swipeContext, widgetModel);
            if(widgetModel.wType == 'Segment') {
                module.updateFocusedIndex(widgetModel);
            }
        },

        updateFocusedIndex: function(widgetModel, dir) {
            
            widgetModel.focusedindex = widgetModel.swipeContext.currentPage + IndexJL;
            widgetModel.focuseditem = (widgetModel.data && widgetModel.data[widgetModel.focusedindex]) || (widgetModel.masterdata && widgetModel.masterdata[widgetModel.focusedindex]);
            if(widgetModel.wType == 'Segment') {
                widgetModel.selecteditems = (IndexJL) ? [null, widgetModel.focuseditem] : [widgetModel.focuseditem];
            }

            if(dir && widgetModel.ongesture) {
                var ongestureEventHandler = $KU.returnEventReference(widgetModel.ongesture);
                var gesturecode = (dir == "next" ? 1 : (dir == "previous" ? 2 : -1));
                $KU.executeWidgetEventHandler(widgetModel, ongestureEventHandler);
            }
        },

        updatePageIndicator: function(touchContainerElement, swipeContext, widgetModel) {
            var index = swipeContext.currentPage;
            var navTable = kony.utils.getElementById(touchContainerElement.id + "_footer");
            if(navTable && navTable.childNodes[0]) {
                var row = navTable.childNodes[0];
                var cell = row.childNodes[0];
                var spans = cell.childNodes;
                for(var j = 0; j < spans.length; j++) {
                    var img = spans[j].childNodes[0];
                    var src = (j == index) ? (widgetModel.pageondotimage ? widgetModel.pageondotimage : "whitedot.gif") : (widgetModel.pageoffdotimage ? widgetModel.pageoffdotimage : "blackdot.gif");
                    if(img.src && img.src.substring(img.src.lastIndexOf("/") + 1) == src) continue;
                    img.src = $KU.getImageURL(src);
                }
            }

        },

        previousPage: function(src) {
            var wType = src.parentNode.getAttribute("wType");
            var widgetID = src.id.substr(0, src.id.lastIndexOf('_'));
            var node = document.getElementById(widgetID);
            var wModel = $KU.getModelByNode(node);
            var scroller = src.parentNode.parentNode.childNodes[1];
            var vScroll = src.childNodes[0].getAttribute("type") == "VImg" ? true : false;
            var sInstance = wModel.scrollInstance || $KG[scroller.id];
            if(sInstance) {
                var scrolle = scroller.childNodes[0];
                if(vScroll) {
                    var y = Math.abs(sInstance.y) < scroller.clientHeight ? 0 : (sInstance.y + scroller.clientHeight);
                    sInstance.animateTo(0, y);
                } else {
                    var x = Math.abs(sInstance.x) < scroller.clientWidth ? 0 : (sInstance.x + scroller.clientWidth);
                    sInstance.animateTo(x, 0);
                }
            }
        },

        nextPage: function(src) {
            var wType = src.parentNode.getAttribute("wType");
            var widgetID = src.id.substr(0, src.id.lastIndexOf('_'));
            var node = document.getElementById(widgetID);
            var wModel = $KU.getModelByNode(node);
            var scroller = src.parentNode.parentNode.childNodes[1];
            var vScroll = src.childNodes[0].getAttribute("type") == "VImg" ? true : false;
            var sInstance = wModel.scrollInstance || $KG[scroller.id];
            if(sInstance) {
                var scrolle = scroller.childNodes[0];
                scrolle.style[$KU.transition] = $KU.cssPrefix + "transform " + "0.5s ";
                if(vScroll) {
                    var delta = scrolle.clientHeight - Math.abs(sInstance.y) - scroller.clientHeight;
                    var y = delta < scroller.clientHeight ? (sInstance.y - delta) : (sInstance.y - scroller.clientHeight);
                    sInstance.animateTo(0, y);
                } else {
                    var delta = scrolle.clientWidth - Math.abs(sInstance.x) - scroller.clientWidth;
                    var x = delta < scroller.clientWidth ? (sInstance.x - delta) : (sInstance.x - scroller.clientWidth);
                    sInstance.animateTo(x, 0);
                }
            }
        },

        fadeHImages: function(boxModel) {
            var style = "display:none;";
            var leftSrc = $KU.getImageURL(boxModel.leftarrowimage);
            var rightSrc = $KU.getImageURL(boxModel.rightarrowimage);
            var wID = $KW.Utils.getKMasterWidgetID(boxModel);

            var str = "<div id='" + wID + "_scrollFades_H' class='scroll_view' wType='" + boxModel.wType + "'>" +
                "<div id='" + wID + "_leftimg' class='scroll_fades leftfade' style='" + style + "'" + (($KU.isBlackBerryNTH || ($KU.isWindowsPhone && $KU.isIE9)) ? " onclick='module.previousPage(this)'" : "") +
                "><img type='HImg' src='" + leftSrc + "' onload='module.setHeight(this)' >" +
                "</div>" +
                "<div id='" + wID + "_rightimg' class='scroll_fades rightfade' style='" + style + "'" + (($KU.isBlackBerryNTH || ($KU.isWindowsPhone && $KU.isIE9)) ? " onclick='module.nextPage(this)'" : "") + "><img type='HImg' src='" + rightSrc + "' onload='module.setHeight(this)' >" +
                "</div>" +
                "</div>";
            return str;
        },

        fadeVImages: function(boxModel) {
            var style = "display:none;";
            var topSrc = $KU.getImageURL(boxModel.toparrowimage);
            var bottomSrc = $KU.getImageURL(boxModel.bottomarrowimage);
            var wID = $KW.Utils.getKMasterWidgetID(boxModel);
            var str = "<div id='" + wID + "_scrollFades_V' class='scroll_view' style='height:inherit;' wType='" + boxModel.wType + "'>" +
                "<div id='" + wID + "_topimg' class='scroll_fades topfade' style='" + style + "'" + (($KU.isBlackBerryNTH || ($KU.isWindowsPhone && $KU.isIE9)) ? " onclick='module.previousPage(this)'" : "") +
                "><img type='VImg' src='" + topSrc + "' onload='module.setHeight(this)' >" +
                "</div>" +
                "<div id='" + wID + "_bottomimg' class='scroll_fades bottomfade' style='" + style + "'" + (($KU.isBlackBerryNTH || ($KU.isWindowsPhone && $KU.isIE9)) ? " onclick='module.nextPage(this)'" : "") +
                "><img type='VImg' src='" + bottomSrc + "' onload='module.setHeight(this)' >" +
                "</div>" +
                "</div>";
            return str;
        },

        setHeight: function(src) {
            var parentDiv = src.parentNode;
            src.naturalHeight = src.naturalHeight || src.height;
            src.naturalWidth = src.naturalWidth || src.width;
            parentDiv.style.height = src.naturalHeight + "px";
            parentDiv.style.width = src.naturalWidth + "px";
            var type = src.getAttribute("type");
            if(type == 'HImg')
                parentDiv.style.top = Math.floor((parentDiv.parentNode.offsetHeight - src.naturalHeight) / 2) + "px";
            else
                parentDiv.style.left = Math.floor((parentDiv.parentNode.offsetWidth - src.naturalWidth) / 2) + "px";
        },

        orientationHandler: function(formId, orientation, widgetType) {
            var swipeElements = document.querySelectorAll("#" + formId + " div[name='touchcontainer_" + widgetType + "']");
            var platform = $KU.getPlatform().name;
            for(var i = 0; i < swipeElements.length; i++) {
                var swipeElement = swipeElements[i];
                var id = swipeElement.id;
                var widgetModel = $KU.getModelByNode(swipeElement);
                var swipeContext = widgetModel.swipeContext;

                if(!swipeContext) continue;

                var imgsElement = swipeElement.children[0];
                
                var individualImages = imgsElement.children;
                var noOfSwipePages = individualImages.length;
                if(noOfSwipePages > 0) {
                    imgsElement.style.width = noOfSwipePages * 100 + "%";
                    var IMG_WIDTH = 0;

                    
                    for(var j = 0; j < individualImages.length; j++) {
                        if(j != (swipeContext.currentPage + 1)) {
                            individualImages[j].style.display = "none";
                        }

                    }

                    var pageWidthInLandScape = screen.height * swipeContext.widthRatio + 'px';
                    var pageWidthInPortrait = screen.width * swipeContext.widthRatio + 'px';


                    for(var k = 0; k < individualImages.length; k++) {
                        if(platform == "android" || platform == "blackberry") {
                            if(orientation === "landscape")
                                individualImages[k].style.width = pageWidthInPortrait;
                            else if(orientation === "portrait")
                                individualImages[k].style.width = pageWidthInPortrait;
                        } else {
                            if(orientation === "landscape")
                                individualImages[k].style.width = pageWidthInLandScape;
                            else if(orientation === "portrait")
                                individualImages[k].style.width = pageWidthInPortrait;
                        }
                    }

                    IMG_WIDTH = individualImages[0].parentNode.clientWidth / noOfSwipePages;
                    swipeContext.imageWidth = IMG_WIDTH;
                    swipeElement.setAttribute("imageWidth", IMG_WIDTH);

                    if(swipeContext.currentPage === (noOfSwipePages - 1)) {
                        module.previousImage(swipeElement, swipeContext, true);
                        module.nextImage(swipeElement, swipeContext, true);
                    } else {
                        module.nextImage(swipeElement, swipeContext, true);
                        module.previousImage(swipeElement, swipeContext, true);
                    }

                    for(var j = 0; j < individualImages.length; j++) {
                        individualImages[j].style.display = "inline";
                    }
                }
            }
        },

        
        previousImage: function(touchContainerElement, swipeContext, orientationChanged) {
            var imgsElement = touchContainerElement.children[0];
            swipeContext.currentPage = Math.max(swipeContext.currentPage - 1, 0);
            module.scrollImages(imgsElement, swipeContext.imageWidth * swipeContext.currentPage, $KU.swipeDuration, orientationChanged);
            if(swipeContext.wType == "TabPane") {
                var tabPaneModel = $KU.getModelByNode(imgsElement.parentNode.parentNode);
                tabPaneModel.activetab = Math.max(tabPaneModel.activetab - 1, 0);
                tabPaneModel.activetabs[IndexJL] = tabPaneModel.activetab;

                var tabID = tabPaneModel.children[tabPaneModel.activetab];
                $KW.TabPane.changeActiveTabSkin(tabPaneModel, tabID);
                module.updatePageIndicator(touchContainerElement.parentNode, swipeContext, tabPaneModel);
            }
        },

        
        nextImage: function(touchContainerElement, swipeContext, orientationChanged) {
            var elem = touchContainerElement.children[0];
            var noOfSwipePages = elem.children.length;
            swipeContext.currentPage = Math.min(swipeContext.currentPage + 1, noOfSwipePages - 1);
            module.scrollImages(elem, swipeContext.imageWidth * swipeContext.currentPage, $KU.swipeDuration, orientationChanged);
            if(swipeContext.wType == "TabPane") {
                var tabPaneModel = $KU.getModelByNode(elem.parentNode.parentNode);
                tabPaneModel.activetab = Math.min(tabPaneModel.activetab + 1, noOfSwipePages - 1);
                tabPaneModel.activetabs[IndexJL] = tabPaneModel.activetab;

                var tabID = tabPaneModel.children[tabPaneModel.activetab];
                $KW.TabPane.changeActiveTabSkin(tabPaneModel, tabID);
                module.updatePageIndicator(touchContainerElement.parentNode, swipeContext, tabPaneModel);
            }
        },

        
        scrollImages: function(elem, distance, duration, isOriented, isTabContext) {
            if(!isOriented)
                elem.style[$KU.transition] = $KU.cssPrefix + "transform " + (duration / 1000).toFixed(1) + "s ";
            else
                elem.style[$KU.transition] = $KU.cssPrefix + "transform 0 0";

            
            var value = (distance < 0 ? "" : "-") + Math.abs(distance).toString();
            if(kony.appinit.useTransition)
                elem.style[$KU.transform] = translateOpen + value + "px,0" + translateClose;
            else {
                $("#" + elem.parentNode.id + " div:first").animate({
                    left: value + 'px'
                }, duration);
            }

            if(isTabContext && isTabContext.tabPaneModel && isTabContext.tabID) {
                $KW.TabPane.changeActiveTabSkin(isTabContext.tabPaneModel, isTabContext.tabID);
            }

        },

        navigationDotsHandler: function(src) {
            
            var index = parseInt(src.getAttribute("index"), 10);
            var id = src.parentNode.parentNode.parentNode.getAttribute('id');
            id = id.substr(0, id.lastIndexOf("_footer"));
            var widElement = $KU.getElementById(id);
            var widgetModel = $KU.getModelByNode(widElement);
            if(!widgetModel)
                return;
            var imgsElement = null;
            if(widgetModel.wType == 'Segment') {
                if(!$KW.Utils.isWidgetInteractable(widElement, true)) {
                    return;
                }
                imgsElement = widElement.children[0];
                widgetModel.selectedRows = (IndexJL) ? [null, [null, IndexJL, index]] : [
                    [IndexJL, index]
                ];
                $KW.Segment.setSelectedItemsAndIndices(widgetModel);
            } else {
                imgsElement = widElement.children[1].children[0];
                widgetModel.activetab = widgetModel.currentPage;
                widgetModel.activetabs[IndexJL] = widgetModel.activetab;
            }
            var swipeContext = widgetModel.swipeContext;
            swipeContext.currentPage = parseInt(index) - IndexJL;
            module.scrollImages(imgsElement, swipeContext.imageWidth * swipeContext.currentPage, $KU.swipeDuration, false);
            module.updatePageIndicator(widElement, swipeContext, widgetModel);

            
            if(widgetModel.wType == "Segment" && widgetModel.viewType == constants.SEGUI_VIEW_TYPE_PAGEVIEW) {
                widgetModel.onswipe && widgetModel.onswipe(widgetModel, -1, widgetModel.focusedindex, widgetModel.selectedState); 
            }
        },

        events: {},

        
        TouchContext: {
            UP: "UP",
            DOWN: "DOWN",
            LEFT: "LEFT",
            RIGHT: "RIGHT"
        },

        preventDefault: function(e) {
            kony.events.preventDefault(e);
        },

        
        pageviewScroller: function(element, options) {
            this.element = element;
            this.handleEventListener = this.handleEvent.bind(this);

            
            if('ontouchstart' in window)
                kony.events.addEventListener(element, "touchstart", this, false);
            else if($KU.isPointerSupported) {
                if("onpointerdown" in window)
                    kony.events.addEventListener(element, "pointerdown", this, false);
                else
                    kony.events.addEventListener(element, "MSPointerDown", this, false);
            } else {
                kony.events.addEventListener(element, "mousedown", this.handleEventListener);
            }

            this.widgetModel = options.widgetModel;
        },

        
        
        
        konyScroller: function(el, options) {
            var that = this;
            that.wrapper = el;
            var widgetModel = options.widgetModel;
            that.scroller = that.wrapper.children[0];

            
            that.options = {
                hScroll: false,
                vScroll: false,

                
                hScrollbar: false,
                vScrollbar: false,
                bounce: true,
                hBounce: true,
                vBounce: true,

                fixedScrollbar: !$KU.isIDevice, 
                hideScrollbar: true,
                fadeScrollbar: $KU.isIDevice && $KU.has3d,
                scrollbarClass: '',
                checkDOMChanges: false, 

                useTransform: true, 

                x: 0,
                y: 0,
                topOffset: 0,
                bottomOffset: 0,

                
                onBeforeScrollStart: function(e) {  },
                onRefresh: null,
                onScrollStart: null,
                onScrollMove: null,
                onScrollEnd: null
            };

            
            for(var i in options) that.options[i] = options[i];

            
            that.x = that.options.x;
            that.y = that.options.y;
            that.pullDownOffset = that.options.topOffset || 0;
            that.pullUpOffset = that.options.bottomOffset || 0;
            
            that.options.hBounce = that.options.bounce ? (typeof options.hBounce === "undefined" ? true : options.hBounce) : false;
            that.options.vBounce = that.options.bounce ? (typeof options.vBounce === "undefined" ? true : options.vBounce) : false;

            that.options.vScrollbar = that.options.vScroll && that.options.vScrollbar;
            that.options.hScrollbar = that.options.hScroll && that.options.hScrollbar;

            that.options.useTransform = $KU.hasTransform ? that.options.useTransform : false;

            

            that.scroller.style[$KU.transitionProperty] = that.options.useTransform ? ($KU.cssPrefix + 'transform') : 'top left';
            that.scroller.style[$KU.transitionDuration] = '0';
            that.scroller.style[$KU.transformOrigin] = '0 0';

            

            if(that.options.useTransform) {
                that.scroller.style[$KU.transform] = translateOpen + (that.x - (that.options.hScroll ? that.pullDownOffset : 0)) + "px," + (that.y - (that.options.vScroll ? that.pullDownOffset : 0)) + "px" + translateClose;
                if(!that.options.scrollbox)
                    that.scroller.style.position = "absolute";
            } else {
                

                if(kony.appinit.isFirefox || kony.appinit.isOpera) {
                    that.scroller.style.cssText += ';position:relative;top:' + (that.y - (that.options.vScroll ? that.pullDownOffset : 0)) + 'px;left:' + (that.x - (that.options.hScroll ? that.pullDownOffset : 0)) + 'px';
                } else {
                    that.scroller.style.cssText += ';position:absolute;top:' + (that.y - (that.options.vScroll ? that.pullDownOffset : 0)) + 'px;left:' + (that.x - (that.options.hScroll ? that.pullDownOffset : 0)) + 'px';
                }
            }
            that.refresh();

            if(that.options.showImages) {
                
                
                if(that.options.hScroll)
                    that.toggleFadeImgs();
            }


            
            var isPopup = that.wrapper.getAttribute("kformname");
            if(!isPopup && !that.options.scrollbox)
                kony.events.addEventListener(document, 'touchmove', module.preventDefault);

            that.handleEventListener = that.handleEvent.bind(that);
            
            if(!that.options.disableUserScroll) {
                if($KU.isTouchSupported) 
                    kony.events.addEventListener(that.scroller, "touchstart", that, false);
                else if($KU.isPointerSupported) {
                    if("onpointerdown" in window) {
                        kony.events.addEventListener(that.scroller, "pointerdown", that, false);
                    } else {
                        kony.events.addEventListener(that.scroller, "MSPointerDown", that, false);
                    }
                } else {
                    kony.events.addEventListener(that.scroller, "mousedown", that.handleEventListener);
                    kony.events.addEventListener(that.scroller, "mouseout", that.handleEventListener);
                }
            }

            if($KU.isOrientationSupported && !$KU.isAndroid) {
                kony.events.addEventListener(window, "orientationchange", that, false);
            } else {
                kony.events.addEventListener(window, "resize", that.handleEventListener);
            }

            if(that.options.checkDOMChanges) that.checkDOMTime = setInterval(function() {
                that._checkDOMChanges();
            }, 1000);
        },

        
        StickyScroller: function() {
            var that = this;

            var forms = document.forms;
            var curForm = forms[0];
            if(forms.length == 2)
                curForm = forms[1]; 
            var wrapperId = curForm.id;


            var headerId = $KG["__currentForm"].header;
            var footerId = $KG["__currentForm"].footer;
            var appmenuId = "konyappmenudiv";

            this.wrapper = document.getElementById(wrapperId);
            this.header = document.getElementById(headerId);
            this.footer = document.getElementById(footerId);
            this.appmenu = document.getElementById(appmenuId);

            if(this.appmenu && this.footer) {
                this.footer.style.bottom = this.appmenu.clientHeight + 'px';
            }

            setTimeout(function() {
                that.follow();
            }, 0);

            kony.events.addEventListener(window, 'scroll', this, false);
        },

        
        
        
        
        
        gesture: function(widgetModel, gestureEventObject) {
            var gestureType = gestureEventObject.gestureType,
            gestureObj = gestureEventObject.gestureObj,
            callback = gestureEventObject.callback;
            var widget = (widgetModel ? document.querySelectorAll('#' + $KW.Utils.getKMasterWidgetID(widgetModel)) : document);
            if(["Form", "Form2"].contains(widgetModel.wType)) {
                if($KG["nativeScroll"])
                    widget = document.getElementById(widgetModel.id);
                else
                    widget = document.querySelector('div[id="' + widgetModel.id + '_scroller"]');
            }

            if(!widgetModel)
                widgetModel = $KG;

            if(!$KG.gestures) $KG.gestures = {};
            this.gestureIdentifier = gestureEventObject.gestureIdentifier;
            $KG.gestures[this.gestureIdentifier] = {
                "widgetModel": widgetModel,
                "gestureType": gestureType
            };

            this.widgetModel = widgetModel;
            this.gestureType = gestureType;

            switch(this.gestureType) {
                case constants.GESTURE_TYPE_TAP:
                case 10:
                case 11:
                    this.TAP = true;
                    break;
                case constants.GESTURE_TYPE_SWIPE:
                    this.SWIPE = true;
                    break;
                case constants.GESTURE_TYPE_LONGPRESS:
                    this.LONGPRESS = true;
                    break;
                case constants.GESTURE_TYPE_PAN:
                    this.PAN = true;
                    break;
                case constants.GESTURE_TYPE_ROTATION:
                    this.ROTATION = true;
                    break;
                case constants.GESTURE_TYPE_PINCH:
                    this.PINCH = true;
                    break;
            }

            this.gestureObj = gestureObj;
            this.callback = callback;

            
            this.fingers = gestureObj.fingers || 1;

            this.taps = gestureObj.taps || 1;
            this.longTapDelay = parseInt(gestureObj.pressDuration, 10) * 1000 || 1000; 
            this.swipedistance = (gestureObj.swipedistance || 50) * $KU.dpi;
            this.continuousEvents = gestureObj.continuousEvents || false;
            gestureEventObject["instance"] = this;

            if(!widget || (typeof widget.length == 'number' && widget.length == 0))
                return this.gestureIdentifier;

            
            if(typeof widget.length != 'number' || ($KG["nativeScroll"] && ["Form", "Form2"].contains(widgetModel.wType)))
                this.widget = [widget];
            else
                this.widget = widget;

            for(var i = 0; i < this.widget.length; i++) {
                if(this.gestureType === constants.GESTURE_TYPE_PAN ||
                    this.gestureType === constants.GESTURE_TYPE_ROTATION ||
                    this.gestureType === constants.GESTURE_TYPE_PINCH) {
                    kony.events.addEventListener(this.widget[i], "gesturestart", this, false);
                } else {
                    if($KU.isPointerSupported)
                        if("onpointerdown" in window)
                            kony.events.addEventListener(this.widget[i], "pointerdown", this, false);
                        else
                            kony.events.addEventListener(this.widget[i], "MSPointerDown", this, false);
                    else
                        kony.events.addEventListener(this.widget[i], "touchstart", this, false);
                }
            }
            return this.gestureIdentifier;
        },

        TouchEvents: function(widgetModel, widgetNode, eventType, callback) {
            var touchEvent = module.events.touchstart;
            var mouseEvent = module.events.mousestart;
            switch(eventType) {
                case "touchstart":
                    touchEvent = module.events.touchstart;
                    mouseEvent = module.events.mousestart;
                    break;
                case "touchmove":
                    touchEvent = module.events.touchmove;
                    mouseEvent = module.events.mousemove;
                    break;
                case "touchend":
                    touchEvent = module.events.touchend;
                    mouseEvent = module.events.mouseend;
                    break;
                case "touchcancel":
                    touchEvent = module.events.touchcancel;
                    mouseEvent = module.events.mousecancel;
                    break;
                case "scroll":
                    touchEvent = "scroll"
                    break;
            }

            if(callback || eventType == 'scroll') {
                if(callback)
                    this.callback = callback;
                this.widgetModel = widgetModel;
                this.widgetNode = widgetNode;
                this.widgetTopNode = $KW.Utils.getWidgetNodeFromNodeByModel(widgetModel, widgetNode) || widgetNode;
                this.handleEventListener = this.handleEvent.bind(this);

                if(eventType == "scroll") {
                    kony.events.addEventListener(widgetNode, "scroll", this.handleEventListener, false);
                    this.isScrolling = false;
                } else {
                    
                    kony.events.addEventListener(widgetNode, mouseEvent, this.handleEventListener, false);
                    kony.events.addEventListener(widgetNode, touchEvent, this.handleEventListener, false);
                }
            } else {
                kony.events.removeEventListener(widgetNode, mouseEvent, this.handleEventListener, false);
                kony.events.removeEventListener(widgetNode, touchEvent, this.handleEventListener, false);
            }
        },

        Drag: function(model, widget, dragableElement, containerElement, dragEvent, moveElement) {
            this.model = model;
            this.widget = widget;
            this.dragEvent = dragEvent;
            this.dragableElement = dragableElement;
            this.containerElement = containerElement || document;
            this.moveElement = moveElement || dragableElement;

            if(dragableElement) {
                kony.events.addEventListener(dragableElement, module.events.touchstart, this.handleEvent.bind(this));
            }
        }
    };

    module.pageviewScroller.prototype = {
        
        handleEvent: function(e) {
            switch(e.type) {
                case "touchstart":
                case "mousedown":
                case "MSPointerDown":
                case "pointerdown":
                    this.onTouchStart(e);
                    break;
                case "touchmove":
                case "mousemove":
                case "MSPointerMove":
                case "pointermove":
                    this.onTouchMove(e);
                    break;
                case "touchend":
                case "touchcancel":
                case "mouseup":
                case "MSPointerUp":
                case "MSPointerCancel":
                case "pointerup":
                case "pointercancel":
                    this.onTouchEnd(e);
                    break;
                case 'mouseout':
                    this.onMouseOut(e);
                    break;
            }
        },

        refresh: function() {
            var that = this;

            if(this.refreshDisabled)
                return;

            that.wrapperW = that.element.clientWidth || 1;
            that.minScrollX = 0;
            that.scrollerW = Math.round(that.minScrollX + that.scroller.scrollWidth);
            that.maxScrollX = (that.wrapperW - that.scrollerW) + that.minScrollX;
            that.scroller.style[$KU.transitionDuration] = '0';
        },

        
        onTouchStart: function(event) {
            

            var touch = event.touches && event.touches[0] || event;
            if($KU.isTouchSupported) {
                kony.events.addEventListener(this.element, "touchmove", this, false);
                kony.events.addEventListener(this.element, "touchend", this, false);
                kony.events.addEventListener(this.element, "touchcancel", this, false);
            } else if($KU.isPointerSupported) {
                if("onpointerdown" in window) {
                    kony.events.addEventListener(this.element, "pointermove", this, false);
                    kony.events.addEventListener(this.element, "pointerup", this, false);
                    kony.events.addEventListener(this.element, "pointercancel", this, false);
                } else {
                    kony.events.addEventListener(this.element, "MSPointerMove", this, false);
                    kony.events.addEventListener(this.element, "MSPointerUp", this, false);
                    kony.events.addEventListener(this.element, "MSPointerCancel", this, false);
                }
            } else {
                kony.events.addEventListener(this.element, "mousemove", this.handleEventListener);
                kony.events.addEventListener(this.element, "mouseup", this.handleEventListener);
                kony.events.addEventListener(this.element, "mouseout", this.handleEventListener);
            }

            
            this.x = this.lastx = this.startX = touch.pageX || touch.clientX;
            this.y = this.lasty = this.startY = touch.pageY || touch.clientY;

            var swipeContext = this.widgetModel.swipeContext;
            if(!swipeContext) {
                swipeContext = new Object();
                swipeContext.imageWidth = this.element.getAttribute("imageWidth");
                swipeContext.widthRatio = this.element.getAttribute("ratio");
                swipeContext.currentPage = 0;
            }
        },

        
        onTouchMove: function(event) {
            var touch = event.touches && event.touches[0] || event;
            var newX = touch.pageX || touch.clientX;
            var newY = touch.pageY || touch.clientY;

            var deltaX = newX - this.startX;
            var deltaY = newY - this.startY;

            this.lastx = this.x;
            this.lasty = this.y;
            this.x = newX;
            this.y = newY;

            var direction = $KU.getSwipeDirection(deltaX, deltaY);
            var distance = $KU.getDistanceMoved(deltaX, deltaY);
            var imgsElement = this.element.children[0];
            var swipeContext = this.widgetModel.swipeContext;

            if($KG["nativeScroll"]) {
                
                if(Math.abs(deltaX) >= Math.abs(deltaY))
                    kony.events.preventDefault(event);
                else
                    return;
            } else
                kony.events.preventDefault(event);

            if(direction == module.TouchContext.LEFT)
                module.scrollImages(imgsElement, (swipeContext.imageWidth * swipeContext.currentPage) + distance, 0);
            else if(direction == module.TouchContext.RIGHT)
                module.scrollImages(imgsElement, (swipeContext.imageWidth * swipeContext.currentPage) - distance, 0);

            if(this.widgetModel.wType != "TabPane")
            module.updateFocusedIndex(this.widgetModel);
        },

        onTouchEnd: function(event) {
            
            this.detachEvents();
            var touch = event.changedTouches && event.changedTouches[0] || event;

            var newX = touch.pageX || touch.clientX;
            var newY = touch.pageY || touch.clientY;

            var deltaX = newX - this.startX;
            var deltaY = newY - this.startY;


            var swipeContext = this.widgetModel.swipeContext;
            var dir;
            


            if(Math.abs(deltaX) > Math.abs(deltaY)) {
                if(deltaX <= -7) {
                    module.nextImage(this.element, swipeContext, false);
                    dir = "next";
                } else if(deltaX >= 7) {
                    module.previousImage(this.element, swipeContext, false);
                    dir = "previous";
                }
            }

            module.updatePageIndicator(this.element, swipeContext, this.widgetModel);
            if(this.widgetModel.wType != "TabPane")
            module.updateFocusedIndex(this.widgetModel, dir);

            if(dir) {
                if(this.widgetModel.wType == "Segment" && this.widgetModel.viewType == constants.SEGUI_VIEW_TYPE_PAGEVIEW) {
                    this.widgetModel.onswipe && this.widgetModel.onswipe(this.widgetModel, -1, this.widgetModel.focusedindex, this.widgetModel.selectedState); 
                } else {
                    this.widgetModel.onswipe && this.widgetModel.onswipe(this.widgetModel); 
                }
            }
        },


        detachEvents: function() {
            
            if($KU.isTouchSupported) {
                kony.events.removeEventListener(this.element, "touchmove", this, false);
                kony.events.removeEventListener(this.element, "touchend", this, false);
                kony.events.removeEventListener(this.element, "touchcancel", this, false);
            } else if($KU.isPointerSupported) {
                if("onpointerdown" in window) {
                    kony.events.removeEventListener(this.element, "pointermove", this, false);
                    kony.events.removeEventListener(this.element, "pointerup", this, false);
                    kony.events.removeEventListener(this.element, "pointercancel", this, false);
                } else {
                    kony.events.removeEventListener(this.element, "MSPointerMove", this, false);
                    kony.events.removeEventListener(this.element, "MSPointerUp", this, false);
                    kony.events.removeEventListener(this.element, "MSPointerCancel", this, false);
                }

            } else {
                kony.events.removeEventListener(this.element, "mousemove", this.handleEventListener);
                kony.events.removeEventListener(this.element, "mouseup", this.handleEventListener);
                kony.events.removeEventListener(this.element, "mouseout", this.handleEventListener);
            }
        },

        onMouseOut: function(event) {
            this.onTouchEnd(event);
        },

        destroy: function() {
            
            if(this.element) {
                if($KU.isTouchSupported) {
                    kony.events.removeEventListener(this.element, "touchstart", this, false);
                    kony.events.removeEventListener(this.element, "touchcancel", this, false);
                } else if($KU.isPointerSupported) {
                    if("onpointerdown" in window) {
                        kony.events.removeEventListener(this.element, "pointerdown", this, false);
                        kony.events.removeEventListener(this.element, "pointercancel", this, false);
                    } else {
                        kony.events.removeEventListener(this.element, "MSPointerDown", this, false);
                        kony.events.removeEventListener(this.element, "MSPointerCancel", this, false);
                    }
                } else {
                    kony.events.removeEventListener(this.element, "mousedown", this.handleEventListener);
                    kony.events.removeEventListener(this.element, "mouseout", this.handleEventListener);
                }
            }
        }
    };

    module.konyScroller.prototype = {
        x: 0,
        y: 0,
        steps: [],
        aniTime: null,

        _checkDOMChanges: function() {
            var scroller = document.getElementById(this.scroller.id);
            if(scroller === null) {
                return;
            }
            
            
            var contentHeight, contentWidth;
            var wModel = this.options.widgetModel;
            var wType = wModel.wType;
            var formAsFlex = (wType == 'Form' && $KW.FlexUtils.isFlexContainer(wModel));
            var main = $KU.getElementById("__MainContainer");
            if(formAsFlex) {
                var formNode = document.getElementById(wModel.id);
                contentHeight = formNode.scrollHeight;
                contentWidth = formNode.scrollWidth;
            } else if(wType == 'FlexScrollContainer') {
                if(this.options.pullDownEl) {
                    contentHeight = scroller.childNodes[1].scrollHeight;
                    contentWidth = scroller.childNodes[1].scrollWidth;
                }
                else {
                    contentHeight = scroller.childNodes[0].scrollHeight;
                    contentWidth = scroller.childNodes[0].scrollWidth;
                }
            }
            else if (wType == 'Image' && wModel.zoomenabled) {
                contentHeight = scroller.childNodes[0].scrollHeight;
                contentWidth = scroller.childNodes[0].scrollWidth;

            } else if(wType == 'CollectionView') {
                var cvNode = $KW.CollectionView.getCollectionViewBaseNode(wModel, scroller);
                contentHeight = cvNode.scrollHeight;
                if(wModel.layouttype == kony.collectionview.LAYOUT_HORIZONTAL)
                    contentHeight += scroller.children[0].offsetHeight;
                contentWidth = cvNode.scrollWidth;
                if(wModel.layouttype == kony.collectionview.LAYOUT_VERTICAL)
                    contentWidth += scroller.children[0].offsetWidth;
            } else {
                contentHeight = scroller.offsetHeight;
                contentWidth = scroller.offsetWidth;
            }
            if(kony.appinit.isiPhone && kony.appinit.isSafari) {
                if(wType == 'Form' && !$KG.activeInput && window.pageYOffset) {
                   window.scrollTo(0, 0);
                   $KW.Form.setFormDimensions(wModel);
                   $KW.Form.initializeFlexContainers(wModel);
                }
            }

            if(this.moved || this.animating || (this.scrollerW == contentWidth * 1 && this.scrollerH == contentHeight * 1))
                return;

            if(this.options.hScroll == true) {
                if(formAsFlex || wType == 'FlexScrollContainer' || wType == 'CollectionView') {
                    
                    scroller.style.width = (contentWidth / scroller.parentNode.offsetWidth) * 100 + "%";
                } else
                    scroller.style.width = (scroller.scrollWidth / scroller.parentNode.offsetWidth) * 100 + "%"; 

                if(wType == 'Image' && wModel.zoomenabled) {
                    scroller.style.width = contentWidth + "px";
                }
                if(wType == 'CollectionView') {
                    scroller.children[2].style.marginLeft = contentWidth - wModel.frame.width - scroller.children[0].offsetWidth + 'px';
                }
            }

            if(this.options.vScroll == true) {
                if(formAsFlex || wType == 'FlexScrollContainer' || wType == 'CollectionView' || (wType == 'Image' && wModel.zoomenabled)) {
                    if(wType == 'CollectionView') {
                        scroller.children[2].style.marginTop = contentHeight - wModel.frame.height - scroller.children[0].offsetHeight + 'px';
                    }
                    scroller.style.height = contentHeight + "px";
                }
            }
            this.refresh();
        },

        
        refresh: function() {
            var that = this;

            if(this.refreshDisabled)
                return;

            
            that.wrapperW = that.wrapper.clientWidth || 1;
            that.wrapperH = that.wrapper.clientHeight || 1;

            that.minScrollY = that.options.vScroll ? -that.pullDownOffset : 0;
            that.maxBiasY = that.options.vScroll ? -that.pullUpOffset : 0;
            that.minScrollX = that.options.hScroll ? -that.pullDownOffset : 0;
            that.maxBiasX = that.options.hScroll ? -that.pullUpOffset : 0;

            
            that.scrollerW = Math.round(that.minScrollX + that.scroller.scrollWidth + that.maxBiasX);
            
            that.scrollerH = Math.round(that.minScrollY + that.scroller.scrollHeight + +that.maxBiasY);

            var wModel = that.options.widgetModel;
            var right = 0;
            var bottom = 0;
            var parentFrame = wModel.frame;
            
            if(wModel.wType == 'FlexScrollContainer' && parentFrame) {
                var widgets = wModel.widgets();
                if(widgets.length > 0) {
                    var lastWidget = widgets[widgets.length - 1];
                    if(wModel.layouttype == kony.flex.FLOW_HORIZONTAL) {
                        var valueObj = $KW.FlexLayoutEngine.getComputedValue(lastWidget, parentFrame, lastWidget.right, 'x');
                        if(valueObj)
                            right = $KW.FlexUtils.getValueByParentFrame(lastWidget, valueObj, 'x');
                    }
                    if(wModel.layouttype == kony.flex.FLOW_VERTICAL) {
                        var valueObj = $KW.FlexLayoutEngine.getComputedValue(lastWidget, parentFrame, lastWidget.bottom, 'y');
                        if(valueObj)
                            bottom = $KW.FlexUtils.getValueByParentFrame(lastWidget, valueObj, 'y');
                    }
                }
            }

            that.maxScrollX = (that.wrapperW - that.scrollerW) + that.minScrollX - right;
            that.maxScrollY = (that.wrapperH - that.scrollerH) + that.minScrollY - bottom;

            that.dirX = 0;
            that.dirY = 0;

            if(that.options.onRefresh) that.options.onRefresh.call(that);

            that.hScroll = that.options.hScroll && that.maxScrollX < 0;
            that.vScroll = that.options.vScroll && (!that.hScroll || that.scrollerH > that.wrapperH);

            that.hScrollbar = that.hScroll && that.options.hScrollbar;
            that.vScrollbar = that.vScroll && that.options.vScrollbar && that.scrollerH > that.wrapperH;

            var offset = that._offset(that.wrapper);
            that.wrapperOffsetLeft = -offset.left;
            that.wrapperOffsetTop = -offset.top;

            that.scroller.style[$KU.transitionDuration] = '0';

            
            that._scrollbar('h');
            that._scrollbar('v');


            
            that._resetPos(200);

            if(that.options.showImages) {
                if(that.options.vScroll)
                    that.toggleVFadeImgs();
                if(that.options.hScroll)
                    that.toggleFadeImgs();
            }
        },

        
        handleEvent: function(e) {
            var that = this;
            
            if($KG["__idletimeout"] && $KG["__idletimeout"].enabled) {
                $KI.appevents.resettimer();
            }

            
            


            
            if(e.type != "orientationchange" && e.type != "resize") {
                
                if(e && e.target && e.target.getAttribute && (e.target.getAttribute("kwidgettype") == "ScrollBox"))
                    this.angularDirection = true;
            } else
                this.angularDirection = false;

            switch(e.type) {
                case "touchstart":
                case "mousedown":
                case "MSPointerDown":
                case "pointerdown":
                    that.onTouchStart(e);
                    break;
                case "touchmove":
                case "mousemove":
                case "MSPointerMove":
                case "pointermove":
                    that.onTouchMove(e);
                    break;
                case "touchend":
                case "touchcancel":
                case "mouseup":
                case "MSPointerUp":
                case "MSPointerCancel":
                case "pointerup":
                case "pointercancel":
                    that.onTouchEnd(e);
                    break;
                case 'mouseout':
                    that.onMouseOut(e);
                    break;
                case 'orientationchange':
                case 'resize':
                    that.resize(e);
                    break;
            }
        },

        
        resize: function() {
            var that = this;
            if(!that.options.scrollbox) {
                $KW.Scroller.setHeight(that.options.formid);
            }
            setTimeout(function() {
                that.refresh();
            }, $KU.isAndroid ? 200 : 0);
        },

        
        onTouchStart: function(event) {
            var targetWidget = event.target || event.srcElement;
            targetWidget = $KU.getParentByAttribute(targetWidget, kony.constants.KONY_WIDGET_TYPE);


            
            var touch = event.touches && event.touches[0] || event;
            if(this.options.scrollbox) {
                kony.events.ontouchstartHandler(event);
                if(!this.options.HStrip && (typeof this.options.bubbleEvents == "undefined" ||
                        !this.options.bubbleEvents))
                    kony.events.stopPropagation(event); 
            }
            
            if(this.options.onBeforeScrollStart)
                this.options.onBeforeScrollStart.call(this, event);

            this.extendTouchStart(touch);
            this.dragging = false;
            this.startfired = false;
            this.tracking = true;

        },

        
        onTouchMove: function(event) {

            this.dragging = true;
            this.tracking = true;
            

            var touch = event.touches && event.touches[0] || event;
            if(this.options.scrollbox)
                kony.events.ontouchmoveHandler(event);
            this.extendTouchMove(touch, event);
        },

        onTouchEnd: function(event) {
            this.dragging = false;
            this.tracking = false;
            
            var touch = event.touches && event.touches[0] || event;
            this.extendTouchEnd(touch);
        },

        onMouseOut: function(e) {
            var t = e.relatedTarget || e.srcElement;
            if(!t) {
                this.onTouchEnd(e);
                return;
            }
            while(t = t.parentNode)
                if(t == this.wrapper) return;

            this.onTouchEnd(e);
        },

        extendTouchStart: function(touch) {
            
            this.moved = false;
            this.animating = false;
            this.distX = 0;
            this.distY = 0;
            this.absDistX = 0;
            this.absDistY = 0;

            var x, y;

            if(this.options.useTransform) {
                
                
                var matrix = getComputedStyle(this.scroller, null)[$KU.transform].replace(/[^0-9-.,]/g, '').split(',');
                x = matrix[4] * 1; 
                y = matrix[5] * 1;
            } else {
                x = $KU.getStyle(this.scroller, "left").replace(/[^0-9-]/g, '') * 1;
                y = $KU.getStyle(this.scroller, "top").replace(/[^0-9-]/g, '') * 1;
            }

            this.startX = this.x;
            this.startY = this.y;

            
            this.pointX = touch.pageX || touch.clientX;
            this.pointY = touch.pageY || touch.clientY;

            this.startTime = new Date().valueOf();

            if($KU.isTouchSupported) {
                kony.events.addEventListener(this.scroller, "touchmove", this, false);
                kony.events.addEventListener(this.scroller, "touchend", this, false);
                kony.events.addEventListener(this.scroller, "touchcancel", this, false);
            } else if($KU.isPointerSupported) {
                if("onpointerdown" in window) {
                    kony.events.addEventListener(window, "pointermove", this, false);
                    kony.events.addEventListener(window, "pointerup", this, false);
                    kony.events.addEventListener(window, "pointercancel", this, false);
                } else {
                    kony.events.addEventListener(window, "MSPointerMove", this, false);
                    kony.events.addEventListener(window, "MSPointerUp", this, false);
                    kony.events.addEventListener(window, "MSPointerCancel", this, false);
                }
            } else {
                kony.events.addEventListener(this.scroller, "mousemove", this.handleEventListener);
                kony.events.addEventListener(this.scroller, "mouseup", this.handleEventListener);
            }
            this.startEventFired = false;
            this.direction = "";
        },

        extendTouchMove: function(touch, event) {
            event = event || touch;
            var deltaX = (touch.pageX || touch.clientX) - this.pointX,
                deltaY = (touch.pageY || touch.clientY) - this.pointY,
            newX = this.x + deltaX,
                newY = this.y + deltaY,
                c1, c2,
                timestamp = new Date().valueOf();

            var direction = $KU.getSwipeDirection(deltaX, deltaY);
            
            if(this.angularDirection) {
                
                if((this.vScroll && (direction != module.TouchContext.UP && direction != module.TouchContext.DOWN)) || (this.hScroll && (direction != module.TouchContext.LEFT && direction != module.TouchContext.RIGHT)))
                    return;
            }

            if(this.options.onScrollStart && !this.startEventFired && ((this.vScroll && (direction == module.TouchContext.UP || direction == module.TouchContext.DOWN)) ||
                    (this.hScroll && (direction == module.TouchContext.LEFT || direction == module.TouchContext.RIGHT)))) {
                this.options.onScrollStart.call(this, event);
            }
            this.startEventFired = true;

            if(typeof this.options.bubbleEvents != "undefined" && this.options.bubbleEvents) {
                if((this.options.vBounce && this.vScroll && (direction == module.TouchContext.UP || direction == module.TouchContext.DOWN)) ||
                    (this.options.hBounce && this.hScroll && (direction == module.TouchContext.LEFT || direction == module.TouchContext.RIGHT))) {

                    kony.events.stopPropagation(event);
                }
            }

            if($KG["nativeScroll"]) {
                
                if(Math.abs(deltaX) >= Math.abs(deltaY))
                    kony.events.preventDefault(touch);
                else
                    return;
            } else
                kony.events.preventDefault(event);


            if($KG.appbehaviors[constants.API_LEVEL] >= constants.API_LEVEL_6000 && !this.vScroll && !this.hScroll) {
                
                return;
            }

            this.direction = direction;

            this.pointX = touch.pageX || touch.clientX;
            this.pointY = touch.pageY || touch.clientY;


            
            if(newX > this.minScrollX || newX < this.maxScrollX) {
                newX = this.options.hBounce ? this.x + (deltaX / 2) : newX >= this.minScrollX || this.maxScrollX >= 0 ? this.minScrollX : this.maxScrollX;
            } else if(!this.options.hBounce && (direction == module.TouchContext.LEFT || direction == module.TouchContext.RIGHT)) {
                kony.events.stopPropagation(event);
            }

            if(newY > this.minScrollY || newY < this.maxScrollY) {
                newY = this.options.vBounce ? this.y + (deltaY / 2) : newY >= this.minScrollY || this.maxScrollY >= 0 ? this.minScrollY : this.maxScrollY;
            } else if(!this.options.vBounce && (direction == module.TouchContext.UP || direction == module.TouchContext.DOWN)) {
                kony.events.stopPropagation(event);
            }

            

            var isABSorDeltaScrollingEnabled = ($KG.appbehaviors && $KG.appbehaviors["minTouchDisplacementScroll"] == true) ? true : false;
            
            var valX = 0;
            var valY = 0;
            if(isABSorDeltaScrollingEnabled) {
                valX = this.absDistX || Math.abs(deltaX);
                valY = this.absDistY || Math.abs(deltaY);
            } else {
                valX = this.absDistX;
                valY = this.absDistY;
            }
            if(valX < $KU.minTouchMoveDisplacement && valY < $KU.minTouchMoveDisplacement) {
                this.distX += deltaX;
                this.distY += deltaY;
                this.absDistX = Math.abs(this.distX);
                this.absDistY = Math.abs(this.distY);

                return;
            }

            
            if(this.absDistX > this.absDistY + 5) {
                newY = this.y;
                deltaY = 0;
            } else if(this.absDistY > this.absDistX + 5) {
                newX = this.x;
                deltaX = 0;
            }

            
            

            this.moved = true;
            this.animateTo(newX, newY);

            if(timestamp - this.startTime > 300) {
                this.startTime = timestamp;
                this.startX = this.x;
                this.startY = this.y;
            }

            if(this.options.onScrollMove &&
                ((this.vScroll && (direction == module.TouchContext.UP || direction == module.TouchContext.DOWN)) ||
                    (this.hScroll && (direction == module.TouchContext.LEFT || direction == module.TouchContext.RIGHT)))
            ) {

                this.options.onScrollMove.call(this, event);
            }

        },

        extendTouchEnd: function(touch) {
            
            if($KU.isTouchSupported) {
                kony.events.removeEventListener(this.scroller, "touchmove", this, false);
                kony.events.removeEventListener(this.scroller, "touchend", this, false);
                kony.events.removeEventListener(this.scroller, "touchcancel", this, false);
            } else if($KU.isPointerSupported) {
                if("onpointerdown" in window) {
                    kony.events.removeEventListener(window, "pointermove", this, false);
                    kony.events.removeEventListener(window, "pointerdown", this, false);
                    kony.events.removeEventListener(window, "pointercancel", this, false);
                } else {
                    kony.events.removeEventListener(window, "MSPointerMove", this, false);
                    kony.events.removeEventListener(window, "MSPointerDown", this, false);
                    kony.events.removeEventListener(window, "MSPointerCancel", this, false);
                }
            } else {
                kony.events.removeEventListener(this.scroller, "mousemove", this.handleEventListener);
                kony.events.removeEventListener(this.scroller, "mouseup", this.handleEventListener);
            }
            
            if(this.moved && this.options.onScrollTouchReleased && ((this.vScroll && (this.direction == module.TouchContext.UP || this.direction == module.TouchContext.DOWN)) ||
                    (this.hScroll && (this.direction == module.TouchContext.LEFT || this.direction == module.TouchContext.RIGHT)))) {
                this.options.onScrollTouchReleased.call(this);
            }

            var momentumX = {
                    dist: 0,
                    time: 0
                },
                momentumY = {
                    dist: 0,
                    time: 0
                },
                duration = (new Date().valueOf()) - this.startTime,
                newPosX = this.x,
                newPosY = this.y,
                newDuration;

            
            
            var direction = this.direction;

            if(this.angularDirection) {
                
                if((this.vScroll && (direction != module.TouchContext.UP && direction != module.TouchContext.DOWN)) || (this.hScroll && (direction != module.TouchContext.LEFT && direction != module.TouchContext.RIGHT)))
                    return;
            }

            this.direction = direction;

            
            if(duration < 300) {
                
                momentumX = newPosX ? this._momentum(newPosX - this.startX, duration, -this.x, (this.maxScrollX < 0 ? this.scrollerW - this.wrapperW + this.x - this.minScrollX : 0), this.options.hBounce ? this.wrapperW : 0) : momentumX;
                momentumY = newPosY ? this._momentum(newPosY - this.startY, duration, -this.y, (this.maxScrollY < 0 ? this.scrollerH - this.wrapperH + this.y - this.minScrollY : 0), this.options.vBounce ? this.wrapperH : 0) : momentumY;

                newPosX = this.x + momentumX.dist;
                newPosY = this.y + momentumY.dist;

                if((this.x > this.minScrollX && newPosX > this.minScrollX) || (this.x < this.maxScrollX && newPosX < this.maxScrollX))
                    momentumX = {
                        dist: 0,
                        time: 0
                    };
                if((this.y > this.minScrollY && newPosY > this.minScrollY) || (this.y < this.maxScrollY && newPosY < this.maxScrollY))
                    momentumY = {
                        dist: 0,
                        time: 0
                    };
            }

            if(momentumX.dist || momentumY.dist) {
                newDuration = Math.max(Math.max(momentumX.time, momentumY.time), 10);
                this.scrollTo(Math.round(newPosX), Math.round(newPosY), newDuration);
                return;
            }

            this._resetPos(200);
        },

        
        animateTo: function(offsetX, offsetY) {
            var x = (this.options.hScroll || this.contentoffsetmove) && !isNaN(offsetX) ? offsetX : 0;
            var y = (this.options.vScroll || this.contentoffsetmove) && !isNaN(offsetY) ? offsetY : 0;

            x = Math.round(x);
            y = Math.round(y);

            if(this.x === x && this.y === y) return;

            if(this.options.useTransform) {
                this.scroller.style[$KU.transform] = translateOpen + x + "px," + y + "px" + translateClose;
            } else {
                this.scroller.style.left = x + 'px';
                this.scroller.style.top = y + 'px';
            }

            this.x = x;
            this.y = y;

            if(this.options.showImages) {
                if(this.options.vScroll)
                    this.toggleVFadeImgs();
                if(this.options.hScroll)
                    this.toggleFadeImgs();
            }

            
            this._scrollbarPos('h');
            this._scrollbarPos('v');

            if(this.options.onScrollMove) this.options.onScrollMove.call(this);

            
            if(this.options.widgetModel.enableonscrollwidgetpositionforsubwidgets) {
                $KW.APIUtils.executeOnScrollingWidgetPosition(this.options.widgetModel);
            }
        },

        toggleFadeImgs: function() {
            
            var id = this.options.widgetID;
            var formId = this.options.formid;
            var wID = formId + "_" + id;
            var sn = $KU.getElementById(wID + "_scrollee");
            if(!sn)
                return;

            
            var w = sn.scrollWidth + sn.offsetLeft + (sn.offsetWidth - sn.clientWidth);
            var right = Math.min(0, $KU.getElementById(wID + "_scroller").clientWidth - w);
            var leftImg = $KU.getElementById(wID + "_leftimg");
            var rightImg = $KU.getElementById(wID + "_rightimg");
            leftImg && module.setHeight(leftImg.childNodes[0]); 
            rightImg && module.setHeight(rightImg.childNodes[0]);
            var l = -this.x;
            if(l > sn.offsetLeft)
                leftImg && $KU.applyFade(leftImg, "fadeIn", 500);
            else
                leftImg && $KU.applyFade(leftImg, "fadeOut", 1000);

            if(l < -right)
                rightImg && $KU.applyFade(rightImg, "fadeIn", 500);
            else
                rightImg && $KU.applyFade(rightImg, "fadeOut", 1000);
        },

        toggleVFadeImgs: function() {
            
            var id = this.options.widgetID;
            var formId = this.options.formid;
            var wID = formId + "_" + id;
            var sn = $KU.getElementById(wID + "_scrollee");
            
            var h = sn.scrollHeight + sn.offsetTop + (sn.offsetHeight - sn.clientHeight);
            var bottom = Math.min(0, $KU.getElementById(wID + "_scroller").clientHeight - h);
            var topImg = $KU.getElementById(wID + "_topimg");
            var bottomImg = $KU.getElementById(wID + "_bottomimg");
            var l = -this.y;
            if(l > sn.offsetTop)
                topImg && $KU.applyFade(topImg, "fadeIn", 500);
            else
                topImg && $KU.applyFade(topImg, "fadeOut", 1000);
            if(l < -bottom)
                bottomImg && $KU.applyFade(bottomImg, "fadeIn", 500);
            else
                bottomImg && $KU.applyFade(bottomImg, "fadeOut", 1000);

        },

        
        _scrollbarPos: function(dir, hidden) {
            var that = this,
                pos = dir == 'h' ? that.x : that.y,
                size;

            if(!that[dir + 'Scrollbar'] || ((this.direction == "LEFT" || this.direction == "RIGHT") && !this.options.scrollbox)) return;

            pos = that[dir + 'ScrollbarProp'] * pos;

            if(pos < 0) {
                if(!that.options.fixedScrollbar) {
                    size = that[dir + 'ScrollbarIndicatorSize'] + Math.round(pos * 3);
                    if(size < 8) size = 8;
                    that[dir + 'ScrollbarIndicator'].style[dir == 'h' ? 'width' : 'height'] = size + 'px';
                }
                pos = 0;
            } else if(pos > that[dir + 'ScrollbarMaxScroll']) {
                if(!that.options.fixedScrollbar) {
                    size = that[dir + 'ScrollbarIndicatorSize'] - Math.round((pos - that[dir + 'ScrollbarMaxScroll']) * 3);
                    if(size < 8) size = 8;
                    that[dir + 'ScrollbarIndicator'].style[dir == 'h' ? 'width' : 'height'] = size + 'px';
                    pos = that[dir + 'ScrollbarMaxScroll'] + (that[dir + 'ScrollbarIndicatorSize'] - size);
                } else {
                    pos = that[dir + 'ScrollbarMaxScroll'];
                }
            }

            that[dir + 'ScrollbarWrapper'].style[$KU.transitionDelay] = '0';
            that[dir + 'ScrollbarWrapper'].style.opacity = hidden && that.options.hideScrollbar ? '0' : '1';
            if(that.options.useTransform)
                that[dir + 'ScrollbarIndicator'].style[$KU.transform] = translateOpen + (dir == 'h' ? pos + 'px,0' : '0,' + pos + 'px') + translateClose;
            else {
                if(dir == 'h') {
                    that[dir + 'ScrollbarIndicator'].style.left = pos + 'px';
                    that[dir + 'ScrollbarIndicator'].style.top = 0;
                } else {
                    that[dir + 'ScrollbarIndicator'].style.left = 0;
                    that[dir + 'ScrollbarIndicator'].style.top = pos + 'px';
                }
            }
        },

        
        _scrollbar: function(dir) {
            var that = this,
                doc = document,
                bar;

            if(!that[dir + 'Scrollbar']) {
                if(that[dir + 'ScrollbarWrapper']) {
                    if($KU.hasTransform)
                        that[dir + 'ScrollbarIndicator'].style[$KU.transform] = '';
                    that[dir + 'ScrollbarWrapper'].parentNode.removeChild(that[dir + 'ScrollbarWrapper']);
                    that[dir + 'ScrollbarWrapper'] = null;
                    that[dir + 'ScrollbarIndicator'] = null;
                }

                return;
            }

            if(!that[dir + 'ScrollbarWrapper']) {
                
                bar = doc.createElement('div');

                if(that.options.scrollbarClass) bar.className = that.options.scrollbarClass + dir.toUpperCase();
                else bar.style.cssText = 'position:absolute;z-index:100;' + (dir == 'h' ? 'height:7px;bottom:1px;left:2px;right:' + (that.vScrollbar ? '7' : '2') + 'px' : 'width:7px;bottom:' + (that.hScrollbar ? '7' : '2') + 'px;top:2px;right:1px');

                bar.style.cssText += ';pointer-events:none;' + $KU.cssPrefix + 'transition-property:opacity;' + $KU.cssPrefix + 'transition-duration:' + (that.options.fadeScrollbar ? '350ms' : '0') + ';overflow:hidden; opacity:' + (that.options.hideScrollbar ? '0' : '1');

                that.wrapper.appendChild(bar);
                that[dir + 'ScrollbarWrapper'] = bar;

                
                bar = doc.createElement('div');
                if(!that.options.scrollbarClass) {
                    bar.style.cssText = 'position:absolute;z-index:100;background:rgba(0,0,0,0.5);border:1px solid rgba(255,255,255,0.9); ' + $KU.cssPrefix + 'background-clip:padding-box;' + $KU.cssPrefix + 'box-sizing:border-box; ' + (dir == 'h' ? 'height:100%' : 'width:100%') + '; ' + $KU.cssPrefix + 'border-radius:3px;border-radius:3px';
                }

                if(that.options.useTransform)
                    bar.style.cssText += ';pointer-events:none;' + $KU.cssPrefix + 'transition-property:' + $KU.cssPrefix + 'transform; ' + $KU.cssPrefix + 'transition-timing-function:cubic-bezier(0.33,0.66,0.66,1);' + $KU.cssPrefix + 'transition-duration:0;' + $KU.cssPrefix + 'transform:' + translateOpen + '0,0' + translateClose;

                

                that[dir + 'ScrollbarWrapper'].appendChild(bar);
                that[dir + 'ScrollbarIndicator'] = bar;
            }

            if(dir == 'h') {
                that.hScrollbarSize = that.hScrollbarWrapper.clientWidth;
                that.hScrollbarIndicatorSize = Math.max(Math.round(that.hScrollbarSize * that.hScrollbarSize / that.scrollerW), 8);
                that.hScrollbarIndicator.style.width = that.hScrollbarIndicatorSize + 'px';
                that.hScrollbarMaxScroll = that.hScrollbarSize - that.hScrollbarIndicatorSize;
                that.hScrollbarProp = that.hScrollbarMaxScroll / that.maxScrollX;
            } else {
                that.vScrollbarSize = that.vScrollbarWrapper.clientHeight;
                that.vScrollbarIndicatorSize = Math.max(Math.round(that.vScrollbarSize * that.vScrollbarSize / that.scrollerH), 8);
                that.vScrollbarIndicator.style.height = that.vScrollbarIndicatorSize + 'px';
                that.vScrollbarMaxScroll = that.vScrollbarSize - that.vScrollbarIndicatorSize;
                that.vScrollbarProp = that.vScrollbarMaxScroll / that.maxScrollY;
            }

            
            that._scrollbarPos(dir, true);
        },

        
        _resetPos: function(time) {
            var that = this,
                resetX = that.x >= that.minScrollX ? that.minScrollX : that.x < that.maxScrollX ? that.maxScrollX : that.x,
                resetY = that.y >= that.minScrollY || that.maxScrollY > 0 ? that.minScrollY : that.y < that.maxScrollY ? that.maxScrollY : that.y;

            if(resetX == that.x && resetY == that.y) {
                if(that.moved) {
                    that.moved = false;
                    if(that.options.onScrollEnd && !that.contentoffsetmove && ((this.vScroll && (this.direction == module.TouchContext.UP || this.direction == module.TouchContext.DOWN)) ||
                            (this.hScroll && (this.direction == module.TouchContext.LEFT || this.direction == module.TouchContext.RIGHT)))) {
                        that.options.onScrollEnd.call(that);
                    }
                }

                if(that.hScrollbar && that.options.hideScrollbar) {
                    that.hScrollbarWrapper.style[$KU.transitionDelay] = '100ms';
                    that.hScrollbarWrapper.style.opacity = '0';
                }
                if(that.vScrollbar && that.options.hideScrollbar) {
                    that.vScrollbarWrapper.style[$KU.transitionDelay] = '100ms';
                    that.vScrollbarWrapper.style.opacity = '0';
                }
                return;
            }

            that.scrollTo(resetX, resetY, time || 0);
        },

        scrollTo: function(x, y, time, relative) {
            var that = this,
                step = x,
                i, l;

            that.stop();

            if(!step.length) step = [{
                x: x,
                y: y,
                time: time,
                relative: relative
            }];

            for(i = 0, l = step.length; i < l; i++) {
                if(step[i].relative) {
                    step[i].x = that.x - step[i].x;
                    step[i].y = that.y - step[i].y;
                }
                that.steps.push({
                    x: step[i].x,
                    y: step[i].y,
                    time: step[i].time || 0
                });
            }

            that._startAni();
        },

        
        scrollToElement: function(el, time, returnTop, isFlex, needToSetCursor) {
            if(!el) return;
            if(!time) time = 1000; 

            var that = this;

            pos = that._offset(el);
            pos.left += that.wrapperOffsetLeft;
            pos.top += that.wrapperOffsetTop;

            pos.left = pos.left >= that.minScrollX ? that.minScrollX : pos.left <= that.maxScrollX ? that.maxScrollX : pos.left;
            pos.top = pos.top >= that.minScrollY ? that.minScrollY : pos.top <= that.maxScrollY ? that.maxScrollY : pos.top;
            time = time === undefined ? Math.max(Math.abs(pos.left) * 2, Math.abs(pos.top) * 2) : time;

            
            if(this.scrollerH > this.wrapperH || this.scrollerW > this.wrapperW) {
                var scrolly = 0;
                var scrollx = 0;
                var updateScrollPosition = false;
                
                if(((Math.abs(this.y) + this.wrapperH) < (el.offsetTop + el.offsetHeight)) || (el.offsetTop < Math.abs(this.y)) || (($KU.isWindowsPhone || $KU.isEdge) && !returnTop && !isFlex)) {
                    if(returnTop)
                        return pos.top;
                    scrolly = pos.top;
                    updateScrollPosition = true;
                }
                if(((Math.abs(this.x) + this.wrapperW) < (el.offsetLeft + el.offsetWidth)) || (el.offsetLeft < Math.abs(this.x)) || (($KU.isWindowsPhone || $KU.isEdge) && !isFlex)) {
                    scrollx = pos.left;
                    updateScrollPosition = true;
                }
                if(updateScrollPosition)
                    that.scrollTo(scrollx, scrolly, time);
                
                var widgetType = el.getAttribute("kWidgetType");
                if(kony.appinit.isiPhone && (widgetType == "TextField" || widgetType == "TextArea")) {
                    el.focus();
                    needToSetCursor && $KW.TextField.setCaretPosition(el);
                } else {
                    setTimeout(function() {
                        try {
                            
                            el.focus();
                            needToSetCursor && $KW.TextField.setCaretPosition(el);
                        } catch(e) {}
                    }, time);
                }
            } else if($KU.isWindowsTablet) {

                
                setTimeout(function() {
                    try {
                        el.focus();
                        needToSetCursor && $KW.TextField.setCaretPosition(el);
                    } catch(e) {}
                }, 0);
            } else {
                try {
                    el.focus();
                    needToSetCursor && $KW.TextField.setCaretPosition(el);
                } catch(e) {}
            }
            if(returnTop) {
                return null;
            }
            return pos;
        },

        
        stop: function() {
            cancelFrame(this.aniTime);
            this.steps = [];
            this.moved = false;
            this.animating = false;
        },

        _startAni: function() {
            var that = this,
                startX = that.x,
                startY = that.y,
                startTime = new Date().valueOf(),
                step, easeOut;

            if(that.animating) return;

            if(!that.steps.length) {
                that._resetPos(400);
                return;
            }

            step = that.steps.shift();

            if(step.x == startX && step.y == startY) step.time = 0;

            that.animating = true;
            that.moved = true;

            (function animate() {
                var now = new Date().valueOf(),
                    newX, newY;

                if(now >= startTime + step.time) {
                    that.animateTo(step.x, step.y);
                    that.animating = false;
                    that._startAni();
                    return;
                }
                
                if(now === startTime) now++;
                now = (now - startTime) / step.time - 1;
                easeOut = Math.sqrt(1 - now * now);
                newX = (step.x - startX) * easeOut + startX;
                newY = (step.y - startY) * easeOut + startY;
                that.animateTo(newX, newY);
                if(that.animating) that.aniTime = nextFrame(animate);
            })();
        },

        
        _momentum: function(dist, time, maxDistUpper, maxDistLower, size) {
            var factor = ($KU.isWindowsTouch ? 4 : 1);
            var deceleration = 0.0006,
                speed = Math.abs(dist) / time * factor,
                
                newDist = (speed * speed) / (2 * deceleration),
                newTime = 0,
                outsideDist = 0;

            
            if(dist > 0 && newDist > maxDistUpper) {
                outsideDist = size / (6 / (newDist / speed * deceleration));
                maxDistUpper = maxDistUpper + outsideDist;
                speed = speed * maxDistUpper / newDist;
                newDist = maxDistUpper;
            } else if(dist < 0 && newDist > maxDistLower) {
                outsideDist = size / (6 / (newDist / speed * deceleration));
                maxDistLower = maxDistLower + outsideDist;
                speed = speed * maxDistLower / newDist;
                newDist = maxDistLower;
            }

            newDist = newDist * (dist < 0 ? -1 : 1);
            newTime = speed / deceleration;

            return {
                dist: newDist,
                time: Math.round(newTime)
            };
        },

        _offset: function(el) {
            var left = -el.offsetLeft,
                top = -el.offsetTop;

            try { 
                while(el = el.offsetParent) {
                    if(this.options.useTransform == false && el.id && el.id.lastIndexOf("_scrollee") != -1)
                        continue;
                    left -= el.offsetLeft;
                    top -= el.offsetTop;
                }
            } catch(err) {};

            return {
                left: left,
                top: top
            };
        },

        destroy: function() {
            
            
            this.hScrollbar = false;
            this.vScrollbar = false;
            this._scrollbar('h');
            this._scrollbar('v');
            
            if(this.scroller) {
                if($KU.isTouchSupported) {
                    kony.events.removeEventListener(this.scroller, "touchstart", this, false);
                    kony.events.removeEventListener(this.scroller, "touchcancel", this, false);
                } else if($KU.isPointerSupported) {
                    if("onpointerdown" in window) {
                        kony.events.removeEventListener(this.scroller, "pointerdown", this, false);
                        kony.events.removeEventListener(this.scroller, "pointercancel", this, false);
                    } else {
                        kony.events.removeEventListener(this.scroller, "MSPointerDown", this, false);
                        kony.events.removeEventListener(this.scroller, "MSPointerCancel", this, false);
                    }
                } else {
                    kony.events.removeEventListener(this.scroller, "mousedown", this);
                    kony.events.removeEventListener(this.scroller, "mouseout", this);
                }
            }

            if($KU.isOrientationSupported)
                kony.events.removeEventListener(window, "orientationchange", this, false);
            else
                kony.events.removeEventListener(window, "resize", this);


            if(this.options.checkDOMChanges) clearInterval(this.checkDOMTime);
            var wModel = this.options.widgetModel;
            if(wModel && wModel.wType == 'Segment') {
                var listAnimation = wModel.listAnimation;
                listAnimation && listAnimation.destroy();
            }

            var isPopup = this.wrapper.getAttribute("kformname");
            if(!isPopup && !this.options.scrollbox)
                kony.events.removeEventListener(document, "touchmove", module.preventDefault);
        }
    };

    module.StickyScroller.prototype = {
        handleEvent: function(e) {
            switch(e.type) {
                case "scroll":
                    this.follow(e);
                    break;
            }
        },

        follow: function() {
            

            var scrollX = window.scrollX || document.documentElement.scrollLeft;
            var scrollY = window.scrollY || document.documentElement.scrollTop;

            this.headerH = this.header ? this.header.clientHeight : 0;
            this.footerH = this.footer ? this.footer.clientHeight : 0;
            this.appmenuH = this.appmenu ? this.appmenu.clientHeight : 0;

            this.wrapper.style.top = -(this.footerH + this.appmenuH) + 'px';
            

            if(this.header) {
                var scrollY_h = scrollY;
                this.header.style[$KU.transform] = translateOpen + scrollX + 'px,' + scrollY_h + 'px' + translateClose;
            }
            if(this.footer) {
                var scrollY_f = (window.innerHeight || document.body.clientHeight) + scrollY - (this.footerH) - (this.headerH);
                this.footer.style.bottom = this.y1 + this.appmenuH + 'px';
                this.footer.style[$KU.transform] = translateOpen + scrollX + 'px,' + scrollY_f + 'px' + translateClose;
            }
            if(this.appmenu) {
                var scrollY_a = (window.innerHeight || document.body.clientHeight) + scrollY - (this.footerH) - (this.headerH) - (this.appmenuH);
                this.appmenu.style[$KU.transform] = translateOpen + scrollX + 'px,' + scrollY_a + 'px' + translateClose;
            }
        },

        destroy: function() {
            kony.events.removeEventListener(window, 'scroll', this, false);
        }
    };

    module.gesture.prototype = {
        removeGesture: function(gestureType, updateModel) {
            
            clearTimeout(this.touchTimer);
            clearTimeout(this.longPressTimer);

            if(updateModel != false)
                this.widgetModel.gestures[gestureType] = "";

            var widget = this.widget;

            for(var i = 0; widget && i < widget.length; i++) {
                
                if($KU.isPointerSupported) {
                    if("onpointerdown" in window) {
                        kony.events.removeEventListener(widget[i], "pointerdown", this, false);
                        kony.events.removeEventListener(widget[i], "pointermove", this, false);
                        kony.events.removeEventListener(widget[i], "pointerup", this, false);
                        kony.events.removeEventListener(widget[i], "pointercancel", this, false);

                    } else {
                        kony.events.removeEventListener(widget[i], "MSPointerDown", this, false);
                        kony.events.removeEventListener(widget[i], "MSPointerMove", this, false);
                        kony.events.removeEventListener(widget[i], "MSPointerUp", this, false);
                        kony.events.removeEventListener(widget[i], "MSPointerCancel", this, false);
                    }

                    
                } else {
                    kony.events.removeEventListener(widget[i], "touchstart", this, false);
                    kony.events.removeEventListener(widget[i], "touchmove", this, false);
                    kony.events.removeEventListener(widget[i], "touchend", this, false);
                    kony.events.removeEventListener(widget[i], "gesturestart", this, false);
                    kony.events.removeEventListener(widget[i], "gesturechange", this, false);
                    kony.events.removeEventListener(widget[i], "gestureend", this, false);
                    kony.events.removeEventListener(widget[i], "touchcancel", this, false);
                }
            }

            
        },

        handleEvent: function(e) {
            switch(e.type) {
                case "touchstart":
                case "MSPointerDown":
                case "pointerdown":
                    this.onTouchStart(e);
                    break;
                case "touchmove":
                case "MSPointerMove":
                case "pointermove":
                    this.onTouchMove(e);
                    break;
                case "touchend":
                case "MSPointerUp":
                case "pointerup":
                case "touchcancel":
                case "MSPointerCancel":
                case "pointercancel":
                    
                    
                    this.onTouchEnd(e);
                    break;
                case "gesturestart":
                    this.onGestureStart(e);
                    break;
                case "gesturechange":
                    this.onGestureChange(e);
                    break;
                case "gestureend":
                    this.onGestureEnd(e);
                    break;
            }
        },

        onTouchStart: function(event) {
            var touch = event.touches && event.touches[0] || event;
            this.currentTouch = event;

            if($KU.isPointerSupported) {
                if("onpointerdown" in window) {
                    kony.events.addEventListener(event.currentTarget, "pointermove", this, false);
                    kony.events.addEventListener(event.currentTarget, "pointerup", this, false);
                    kony.events.addEventListener(event.currentTarget, "pointercancel", this, false);
                } else {
                    kony.events.addEventListener(event.currentTarget, "MSPointerMove", this, false);
                    kony.events.addEventListener(event.currentTarget, "MSPointerUp", this, false);
                    kony.events.addEventListener(event.currentTarget, "MSPointerCancel", this, false);
                }
            } else {
                kony.events.addEventListener(event.currentTarget, "touchmove", this, false);
                kony.events.addEventListener(event.currentTarget, "touchend", this, false);
                kony.events.addEventListener(event.currentTarget, "touchcancel", this, false);
            }

            this.x1 = touch.pageX;
            this.y1 = touch.pageY;

            var now = new Date().valueOf();
            var delta = now - (this.doubleTimer || now);
            this.last = this.doubleTimer = now;

            
            if(delta > 0 && delta <= 250) 
                this.isDoubleTap = true;
            else
                this.isDoubleTap = false;
            
            this.touchTimer && clearTimeout(this.touchTimer);
            this.curTarget = event.currentTarget;
            
            var that = this;
            this.LONGPRESS && (this.longPressTimer = setTimeout(function() {
                that.onLongTap(that.curTarget);
            }, this.longTapDelay));
        },

        onTouchMove: function(event) {
            var touch = event.touches && event.touches[0] || event;
            this.x2 = touch.pageX;
            this.y2 = touch.pageY;
        },

        onTouchEnd: function(event) {
            var touch = event.touches && event.touches[0] || event;

            var that = this;
            this.currentTouch = event;

            if($KU.isPointerSupported) {
                if("onpointerdown" in window) {
                    kony.events.removeEventListener(event.currentTarget, "pointermove", this, false);
                    kony.events.removeEventListener(event.currentTarget, "pointerup", this, false);
                    kony.events.removeEventListener(event.currentTarget, "pointercancel", this, false);
                } else {
                    kony.events.removeEventListener(event.currentTarget, "MSPointerMove", this, false);
                    kony.events.removeEventListener(event.currentTarget, "MSPointerUp", this, false);
                    kony.events.removeEventListener(event.currentTarget, "MSPointerCancel", this, false);

                }
            } else {
                kony.events.removeEventListener(event.currentTarget, "touchmove", this, false);
                kony.events.removeEventListener(event.currentTarget, "touchend", this, false);
                kony.events.removeEventListener(event.currentTarget, "touchcancel", this, false);
            }

            if(this.isDoubleTap && this.TAP && this.taps == 2) {
                kony.print("DOUBLE TAP");
                spaAPM && spaAPM.sendMsg(event.currentTarget, 'Gesture Tap');
                this.executeCallback(event.currentTarget);
                delete this.doubleTimer;
            }

            var deltaX = (this.x2 ? this.x2 : this.x1) - this.x1;
            var deltaY = (this.y2 ? this.y2 : this.y1) - this.y1;

            if((this.x2 > 0 && deltaX != 0) || (this.y2 > 0 && deltaY != 0)) {
                if(this.SWIPE) {

                    var absDeltaX = Math.abs(deltaX);
                    var absDeltaY = Math.abs(deltaY);

                    if(absDeltaX > this.swipedistance || absDeltaY > this.swipedistance) 
                    {
                        var dir = $KU.getSwipeDirection(deltaX, deltaY);
                        kony.print("SWIPE: " + dir);
                        spaAPM && spaAPM.sendMsg(event.currentTarget, 'Gesture Swipe', {
                            "swipeDirection": dir
                        });
                        
                        this.executeCallback(event.currentTarget, dir);
                    }
                }
                
                this.x1 = this.x2 = this.y1 = this.y2 = 0;
            } else if(this.last) {
                if(this.TAP && this.taps == 1) {
                    if(this.widgetModel.gestures && this.widgetModel.gestures[10] && this.widgetModel.gestures[11]) {
                        this.touchTimer = setTimeout(function() {
                            if($KG.gestures[that.gestureIdentifier]) {
                                var isDoubleTapFired = false;
                                var doubleTapInstances = that.widgetModel.gestures[11];
                                for(var prop in doubleTapInstances) {
                                    isDoubleTapFired = doubleTapInstances[prop].instance.isDoubleTap;
                                }
                                if(!isDoubleTapFired)
                                    spaAPM && spaAPM.sendMsg(event.currentTarget, 'Gesture Tap');
                                that.executeCallback(event.currentTarget);
                                
                            }
                        }, 250);
                    } else if($KG.gestures[that.gestureIdentifier]) {
                        kony.print("TAP");
                        spaAPM && spaAPM.sendMsg(event.currentTarget, 'Gesture Tap');
                        that.executeCallback(event.currentTarget);
                        
                    }
                }
            }
            this.last = 0;
        },

        onTouchCancel: function() {
            
        },

        
        onGestureStart: function(event) {
            var touch = event.touches && event.touches[0] || event;
            this.currentTouch = event;

            kony.events.addEventListener(event.currentTarget, "gesturechange", this, false);
            kony.events.addEventListener(event.currentTarget, "gestureend", this, false);

            this.x1 = touch.pageX;
            this.y1 = touch.pageY;

            this.gestureStartTime = new Date().valueOf();

            this.excecuteGestureEvent(event, 1);
        },

        onGestureChange: function(event) {
            if(!event) return;

            if(this.continuousEvents) {
                var touch = event.touches && event.touches[0] || event;
                this.x2 = touch.pageX;
                this.y2 = touch.pageY;

                this.excecuteGestureEvent(event, 2);

            }
        },

        onGestureEnd: function(event) {
            kony.events.removeEventListener(event.currentTarget, "gesturechange", this, false);
            kony.events.removeEventListener(event.currentTarget, "gestureend", this, false);

            var touch = event.touches && event.touches[0] || event;
            this.x2 = touch.pageX;
            this.y2 = touch.pageY;

            this.excecuteGestureEvent(event, 3);
        },

        excecuteGestureEvent: function(event, gestureState) {

            if(this.ROTATION) {
                this.rotation = event.rotation;
                spaAPM && spaAPM.sendMsg(event.currentTarget, 'Gesture Rotation');
                
                this.executeCallback(event.currentTarget, null, gestureState);
            }

            this.scale = event.scale;

            
            if(this.PINCH && event.scale !== 1) {

                if(gestureState && gestureState > 1) {
                    var now = new Date().valueOf();
                    var secElapsed = (now - this.gestureStartTime) / 1000;
                    
                    this.velocity = (1 - event.scale) / secElapsed
                    this.velocityX = (this.x2 - this.x1) / secElapsed;
                    this.velocityY = (this.y2 - this.y1) / secElapsed;
                }
                try {
                    spaAPM && spaAPM.sendMsg(event.currentTarget, 'Gesture Pinch');
                    
                    this.executeCallback(event.currentTarget, null, gestureState);

                } catch(e) {
                    
                }
            }

            if(this.PAN) {
                spaAPM && spaAPM.sendMsg(event.currentTarget, 'Gesture Pan');
                
                this.executeCallback(event.currentTarget, null, gestureState);
            }
        },

        onLongTap: function(curTarget) {
            if(this.last && this.LONGPRESS) {
                var duration = new Date().valueOf() - this.last;
                if(duration >= this.longTapDelay) {
                    if($KG.gestures[this.gestureIdentifier]) {
                        kony.print("LONGPRESS: " + this.longTapDelay + "ms");
                        spaAPM && spaAPM.sendMsg(curTarget, 'Gesture LongPress');
                        
                        this.executeCallback(curTarget);
                    }
                }
            }
        },

        executeCallback: function(curTarget, dir, gestureState) {
            if(this.callback) {
                var gestureInfoObj = {};

                var setupParams = $KU.cloneObj(this.gestureObj);
                gestureInfoObj.gestureType = this.gestureType;
                gestureInfoObj.gesturesetUpParams = setupParams;

                
                gestureInfoObj.gestureState = gestureState;
                gestureInfoObj.rotation = this.rotation ? (-this.rotation) : 0;
                gestureInfoObj.velocity = this.velocity || 0;
                gestureInfoObj.velocityX = this.velocityX || 0;
                gestureInfoObj.velocityY = this.velocityY || 0;
                gestureInfoObj.scale = this.scale || 1;

                
                var widget = curTarget && (curTarget !== document) ? curTarget : (this.widget.length ? this.widget[0] : this.widget);

                var coords = $KW.Utils.getOffset(widget);
                
                var touch = (this.currentTouch.touches && this.currentTouch.touches[0]) || this.currentTouch;
                gestureInfoObj.gesturePosition = $KU.getgesturePosition(touch.pageX, touch.pageY, widget.clientWidth, widget.clientHeight, coords.left, coords.top);

                if(gestureInfoObj.gestureType == constants.GESTURE_TYPE_SWIPE)
                    gestureInfoObj.swipeDirection = $KU.getIntegerDirection(dir);

                gestureInfoObj.gestureX = this.x2 || this.x1;
                gestureInfoObj.gestureY = this.y2 || this.y1;

                gestureInfoObj.widgetWidth = widget.clientWidth;
                gestureInfoObj.widgetHeight = widget.clientHeight;
                if(gestureInfoObj.gestureType == constants.GESTURE_TYPE_PAN) {
                    gestureInfoObj.translationX = Math.abs(gestureInfoObj.gestureX - this.x1);
                    gestureInfoObj.translationY = Math.abs(gestureInfoObj.gestureY - this.y1);
                }
                var widgetModel = this.widgetModel;
                if(curTarget && (curTarget !== document)) {
                    var containerID = curTarget.getAttribute('kcontainerid');
                    if(containerID) {
                        var segmentModel = $KW.Utils.getContainerModelById(curTarget, containerID);
                        var context = {};
                        if(segmentModel.wType === "Segment") {
                            if(segmentModel.viewtype == "pageview") {
                                var targetNode = $KU.getParentByAttribute(curTarget, "index");
                            } else {
                                var targetNode = $KU.getParentByTagName(curTarget, 'li');
                            }
                            

                            var rowData;
                            context.widgetInfo = segmentModel;
                            if(segmentModel.hasSections) {
                                var secIndices = targetNode.getAttribute("secindex").split(',');
                                context.rowIndex = +secIndices[1];
                                context.sectionIndex = +secIndices[0];
                                rowdata = segmentModel.data[context.sectionIndex][IndexJL + 1][context.rowIndex];
                            } else {
                                context.rowIndex = +targetNode.getAttribute('index');
                                context.sectionIndex = 0;
                                rowdata = segmentModel.data[context.rowIndex];
                            }
                            var rowModelData = rowdata && rowdata[segmentModel.widgetdatamap[this.widgetModel.id]];
                            widgetModel = $KU.extend({}, this.widgetModel);
                            if(rowModelData)
                                widgetModel = $KU.extend(widgetModel, rowModelData);
                        }
                    }
                }
                var currentForm = this.widgetModel["__currentForm"];
                if(currentForm) {
                    
                    $KU.executeWidgetEventHandler(currentForm, this.callback, gestureInfoObj);
                } else {
                    if(curTarget) {
                        
                        $KU.executeWidgetEventHandler(widgetModel, this.callback, gestureInfoObj, context);
                    } else {
                        
                        $KU.executeWidgetEventHandler(this.widgetModel, this.callback, gestureInfoObj);
                    }
                }
            }
        }
    };

    (function(pkg) {
        pkg.events.touchstart = "touchstart";
        pkg.events.touchmove = "touchmove";
        pkg.events.touchend = "touchend";
        pkg.events.touchcancel = "touchcancel";

        pkg.events.mousestart = "mousedown";
        pkg.events.mousemove = "mousemove";
        pkg.events.mouseend = "mouseup";
        pkg.events.mousecancel = "mouseout";

        if(document.addEventListener) {
            pkg.events.eventListener = "addEventListener";
        } else {
            pkg.events.eventListener = "attachEvent";
            pkg.events.touchstart = "mousedown";
            pkg.events.touchmove = "mousemove";
            pkg.events.touchend = "mouseup";
            pkg.events.touchcancel = "mouseout";
        }

        var isPointerSupported = navigator.msPointerEnabled;
        if(isPointerSupported) {
            if("onpointerdown" in window) {
                pkg.events.touchstart = "pointerdown";
                pkg.events.touchmove = "pointermove";
                pkg.events.touchend = "pointerup";

            } else {
                pkg.events.touchstart = "MSPointerDown";
                pkg.events.touchmove = "MSPointerMove";
                pkg.events.touchend = "MSPointerUp";
            }
        }
        if(document.removeEventListener) {
            pkg.events.removeEventListener = "removeEventListener";
        } else {
            pkg.events.removeEventListener = "detachEvent";
        }
    })(module);

    module.TouchEvents.prototype = {
        removeTouch: function(eventType, updateModel) {
            if(updateModel != false)
                this.widgetModel.touches[eventType] = "";

            var widgetNode = this.widgetNode;
            var touchEvent = module.events.touchstart;
            var mouseEvent = module.events.mousestart;
            switch(eventType) {
                case "touchstart":
                    touchEvent = module.events.touchstart;
                    mouseEvent = module.events.mousestart;
                    break;
                case "touchmove":
                    touchEvent = module.events.touchmove;
                    mouseEvent = module.events.mousemove;
                    break;
                case "touchend":
                    touchEvent = module.events.touchend;
                    mouseEvent = module.events.mouseend;
                    break;
                case "touchcancel":
                    touchEvent = module.events.touchcancel;
                    mouseEvent = module.events.mousecancel;
                    break;
            }
            kony.events.removeEventListener(widgetNode, touchEvent, this.handleEventListener, false);
            kony.events.removeEventListener(widgetNode, mouseEvent, this.handleEventListener, false);

        },

        handleEvent: function(event) {
            var widgetModel, containerId, coords, callbackExecutionTime;

            if(event.type == "scroll" || event.type == "mousewheel" || event.type == "DOMMouseScroll") {
                this.handleScrollEvent(event);
            } else {
                
                var touch = (event.touches && event.touches[0]) || (event.changedTouches && event.changedTouches[0]) || event;
                var x1 = touch.pageX || touch.clientX;
                var y1 = touch.pageY || touch.clientY;

                
                if(event.type == "touchstart" || event.type == "pointerdown") {
                    this.touchStartFired = true;
                }
                if(event.type == "touchend" || event.type == "pointerup") {
                    this.touchEndFired = true;
                }

                if(this.touchStartFired && event.type == 'mousedown') {
                    this.touchStartFired = false;
                    return;
                }
                if(this.touchEndFired && event.type == 'mouseup') {
                    this.touchEndFired = false;
                    return;
                }

                
                coords = $KW.Utils.getPosition(this.widgetTopNode);
                x1 = x1 - coords.left;
                y1 = y1 - coords.top;

                widgetModel = this.widgetModel;
                spaAPM && spaAPM.sendMsg(widgetModel, 'TouchEvent', {
                    "eventtype": event.type
                });
                $KAR && $KAR.sendRecording(widgetModel, event.type, {
                    'target': this.widgetNode,
                    'eventObject': event,
                    'eventType': 'touch',
                    'x': x1,
                    'y': y1
                });
                if($KC.widgetDataRecording == true) {
                    callbackExecutionTime = performance.now();
                }
                this.callback && $KU.executeWidgetEventHandler(widgetModel, this.callback, x1, y1);
                if($KC.widgetDataRecording == true) {
                    callbackExecutionTime = performance.now() - callbackExecutionTime;
                    widgetModel._internals.touchEventsTimeConsumed = widgetModel._internals.touchEventsTimeConsumed || {};

                    widgetModel._internals.touchEventsTimeConsumed[event.type] = callbackExecutionTime;
                }
            }
        },

        handleScrollEvent: function(eventObject) {
            var widgetModel = this.widgetModel;
            if(!widgetModel.enableScrolling)
                return;

            var frame = widgetModel.frame;
            var target = this.widgetNode;
            var width = frame.width;
            var height = frame.height;
            var scrolldirection = (widgetModel.wType == "Form") ? "vertical" : $KW.stringifyScrolldirection[widgetModel.scrolldirection];
            var isScrollingAllowed = true;
            var scrolledWidth = width + target.scrollLeft;
            var scrolledHeight = height + target.scrollTop;
            var scrolledUp = false;

            if((eventObject.wheelDelta && eventObject.wheelDelta > 0) || (eventObject.detail && eventObject.detail < 0)) {
                scrolledUp = true;
            }

            var reachedTop = (target.scrollTop == 0 && scrolledUp);
            var reachedLeft = (target.scrollLeft == 0 && scrolledUp);

            if(scrolldirection == "horizontal") {
                if(scrolledWidth >= target.scrollWidth || reachedLeft) {
                    isScrollingAllowed = false;
                }
            } else if(scrolldirection == "vertical") {
                if(scrolledHeight >= target.scrollHeight || reachedTop) {
                    isScrollingAllowed = false;
                }
            } else if(scrolldirection == "both") {
                if(scrolledWidth >= target.scrollWidth && scrolledHeight >= target.scrollHeight || (reachedTop && reachedLeft)) {
                    isScrollingAllowed = false;
                }
            } else if(scrolldirection == "none") {
                isScrollingAllowed = false;
            }

            if(isScrollingAllowed) {

                
                if(this.widgetModel.enableonscrollwidgetpositionforsubwidgets) {
                    $KW.APIUtils.executeOnScrollingWidgetPosition(this.widgetModel);
                }

                if(!this.isScrolling) {
                    var scrollStartEvent = widgetModel.onScrollStart;
                    if(scrollStartEvent) {
                        scrollStartEvent && $KU.executeWidgetEventHandler(widgetModel, scrollStartEvent);
                    }
                    this.isScrolling = true;
                }
                var scrollingEvent = widgetModel.onScrolling;
                scrollingEvent && $KU.executeWidgetEventHandler(widgetModel, scrollingEvent);
                if(widgetModel.wType == 'CollectionView') {
                    $KW.CollectionView.Animation.handleOnItemDisplay(widgetModel);
                }
                if(widgetModel && widgetModel.wType == 'Segment') {
                    $KW.Segment.updateScrollTopOnScroll(widgetModel);
                }
                this.timer && clearTimeout(this.timer);
                this.timer = setTimeout(this.scrollEndCaller.bind(this), 100);
            }
        },

        scrollEndCaller: function() {
            var widgetModel = this.widgetModel;
            this.isScrolling = false;
            var onScrollEnd = widgetModel.onScrollEnd;
            
            onScrollEnd && $KU.executeWidgetEventHandler(widgetModel, onScrollEnd);
            if(widgetModel && widgetModel.wType == 'Segment') {
                var handler;
                $KW.Segment.updateScrollTopOnScroll(widgetModel);
                if(this.widgetNode.scrollTop == 0) {
                    handler = $KU.returnEventReference(widgetModel.scrollingevents.onreachingbeginning);
                    handler && $KU.executeWidgetEventHandler(widgetModel, handler);
                }
                if(Math.round(this.widgetNode.scrollTop + this.widgetNode.offsetHeight) >= this.widgetNode.scrollHeight) {
                    handler = $KU.returnEventReference(widgetModel.scrollingevents.onreachingend);
                    handler && $KU.executeWidgetEventHandler(widgetModel, handler);
                }
            }
            
        }
    };

    module.Drag.prototype = {
        addDrag: function() {
            if(this.dragableElement) {
                kony.events.addEventListener(this.dragableElement, module.events.touchstart, this.handleEvent.bind(this));
            }
        },

        removeDrag: function() {
            
            this.dragableElement[kony.widgets.touch.events.removeEventListener](module.events.touchstart, this, false);
        },

        handleEvent: function(e) {
            switch(e.type) {
                case module.events.touchstart:
                    return this.onTouchStart(e);
                    break;
                case module.events.touchmove:
                    return this.onTouchMove(e);

                    break;
                case module.events.touchend:
                    return this.onTouchEnd(e);
                    break;
                case module.events.touchcancel:
                    return this.onTouchCancel(e);
                    break;
            }
        },

        onTouchStart: function(event) {
            var touch = event.touches && event.touches[0] || event;

            this.x1 = touch.pageX || touch.clientX;
            this.y1 = touch.pageY || touch.clientY;

            if(this.model && this.model.wType == 'Popup') {
                if(this.dragableElement.className == "resizearea") {
                    this.offsetX = this.moveElement.offsetWidth;
                    this.offsetY = this.moveElement.childNodes[0].children[1].clientHeight;
                } else {
                    this.dragableElement.style.cursor = "move";
                    this.offsetX = $KU.getInt(this.moveElement.offsetLeft);
                    this.offsetY = $KU.getInt(this.moveElement.offsetTop);
                }
                this.dragEvent(this, module.events.touchstart);
            } else {
                kony.events.stopPropagation(event);
                this.dragEvent(this.moveElement, this.x1, this.y1, "1");
            }

            this.handleEventListener = this.handleEvent.bind(this);
            kony.events.addEventListener(this.containerElement, module.events.touchmove, this.handleEventListener);
            kony.events.addEventListener(this.containerElement, module.events.touchend, this.handleEventListener);
            kony.events.addEventListener(document, kony.widgets.touch.events.touchcancel, this.handleEventListener);

            
            document.onselectstart = function() {
                return false;
            };
            
            this.dragableElement.ondragstart = function() {
                return false;
            };

            
            return false;
        },

        onTouchMove: function(event) {
            var touch = event.touches && event.touches[0] || event;
            this.x2 = touch.pageX || touch.clientX;
            this.y2 = touch.pageY || touch.clientY;

            if(this.model && this.model.wType == 'Popup') {
                var horizontalMoveDistance = this.offsetX + this.x2 - this.x1;
                var verticalMoveDistance = this.offsetY + this.y2 - this.y1;
                var verticalAvailableDistance = (document.documentElement.clientHeight || window.innerHeight || document.body.clientHeight) - this.widget.clientHeight;
                var horizontalAvailableDistance = (document.documentElement.clientWidth || window.innerWidth || document.body.clientWidth) - this.widget.clientWidth;

                if(this.dragableElement.className == "resizearea") {
                    this.moveElement.style.width = Math.max(horizontalMoveDistance, 150) + "px";
                    this.moveElement.childNodes[0].children[1].style.height = Math.max(verticalMoveDistance, 100) + "px";
                } else {
                    if(horizontalMoveDistance < 0)
                        this.moveElement.style.left = '0px';
                    else if(horizontalMoveDistance > horizontalAvailableDistance)
                        this.moveElement.style.left = horizontalAvailableDistance + 'px';
                    else
                        this.moveElement.style.left = (this.offsetX + this.x2 - this.x1) + 'px';

                    if(verticalMoveDistance < 0)
                        this.moveElement.style.top = '0px';
                    else if(verticalMoveDistance > verticalAvailableDistance)
                        this.moveElement.style.top = verticalAvailableDistance + 'px';
                    else
                        this.moveElement.style.top = (this.offsetY + this.y2 - this.y1) + 'px';
                }

                this.dragEvent(this, module.events.touchmove);
            } else
                this.dragEvent(this.moveElement, this.x2, this.y2, "2");
        },

        onTouchEnd: function(event) {
            var touch = event.touches && event.touches[0] || event;
            this.x3 = touch.pageX || touch.clientX;
            this.y3 = touch.pageY || touch.clientY;

            if(this.model && this.model.wType == 'Popup')
                this.dragEvent(this, module.events.touchend);
            else
                this.dragEvent(this.moveElement, this.x3, this.y3, "3");
            document.onselectstart = null;
            this.dragableElement.ondragstart = null;
            this.removeEvents();
        },

        onTouchCancel: function(event) {
            this.dragEvent(this, module.events.touchend);
            var from = event.relatedTarget || event.toElement;
            if(!from || from.nodeName == "HTML")
                this.removeEvents();
        },

        removeEvents: function() {
            
            kony.events.removeEventListener(this.containerElement, kony.widgets.touch.events.touchmove, this.handleEventListener);
            kony.events.removeEventListener(this.containerElement, kony.widgets.touch.events.touchend, this.handleEventListener);
            kony.events.removeEventListener(document, kony.widgets.touch.events.touchcancel, this.handleEventListener);
        }
    };



    return module;
}());


constants = {
    
    ALERT_TYPE_CONFIRMATION: "confirmation",
    ALERT_TYPE_ERROR: "error",
    ALERT_TYPE_INFO: "info",

    
    APPLICATION_MODE_NATIVE: 1,
    APPLICATION_MODE_HYBRID: 2,
    APPLICATION_MODE_WRAPPER: 3,

    API_LEVEL: "APILevel",
    API_LEVEL_6000: 6000,
    API_LEVEL_7000: 7000,
    API_LEVEL_8200: 8200,
    API_LEVEL_8300: 8300,
    API_LEVEL_8400: 8400,

    
    BOX_LAYOUT_HORIZONTAL: 1,
    BOX_LAYOUT_VERTICAL: 2,
    BOX_LAYOUT_ALIGN_FROM_LEFT: 3,
    BOX_LAYOUT_ALIGN_FROM_CENTER: 4,
    BOX_LAYOUT_ALIGN_FROM_RIGHT: 5,

    BOX_POSITION_AS_HEADER: 1,
    BOX_POSTION_AS_FOOTER: 2,
    BOX_POSITION_AS_NORMAL: 3,
    BOX_POSITION_AS_SCREENLEVEL_SEG_HEADER: 4,
    BOX_POSITION_AS_SCREENLEVEL_SEG_FOOTER: 5,

    
    CHECKBOX_ITEM_ORIENTATION_VERTICAL: "vertical",
    CHECKBOX_ITEM_ORIENTATION_HORIZONTAL: 2,

    CHECKBOX_VIEW_TYPE_DEFAULTTVIEW: "defaultview",
    CHECKBOX_VIEW_TYPE_CUSTOMVIEW: "customview",


    CHECKBOX_VIEW_TYPE_LISTVIEW: 0,
    CHECKBOX_VIEW_TYPE_TABLEVIEW: "tableview",
    CHECKBOX_VIEW_TYPE_TOGGLEVIEW: "toggleview",
    CHECKBOX_VIEW_TYPE_ONSCREENWHEEL: 3,



    

    CONTAINER_HEIGHT_BY_FORM_REFERENCE: 1,
    CONTAINER_HEIGHT_BY_PARENT_WIDTH: 2,
    CONTAINER_HEIGHT_BY_DEVICE_REFERENCE: 3,


    
    CALENDAR_VIEW_TYPE_DEFAULT: "default",
    CALENDAR_VIEW_TYPE_GRID_POPUP: "popup",
    CALENDAR_VIEW_TYPE_GRID_ONSCREEN: "onscreen",
    CALENDAR_DATE_FORMAT_DEFAULT: "dd/MM/yyyy",
    CALENDAR_SELECTION_TYPE_SINGLE_SELECT: 1,
    CALENDAR_SELECTION_TYPE_MULTI_SELECT: 2,
    CALENDAR_SELECTION_TYPE_RANGE_SELECT: 3,


    
    CALENDAR_ICON_ALIGN_LEFT: "left",
    CALENDAR_ICON_ALIGN_RIGHT: "right",
    CALENDAR_ICON_ALIGN_AUTO: "auto",

    
    CAMERA_SOURCE_DEFAULT: "Front",
    CAMERA_SOURCE_FRONT: "Front",
    CAMERA_SOURCE_REAR: "Rear",
    CAMERA_SOURCE_REAR_UNAVAILABLE: 102,
    CAMERA_SOURCE_FRONT_UNAVAILABLE: 103,
    CAMERA_CAPTURE_FAILED: 104,
    CAMERA_VIDEO_RECORDING_FAILED : 105,
    CAMERA_PERMISSION_DENIED: 106,
    CAMERA_NOT_SUPPORTED:107,

    
    DEVICE_ORIENTATION_PORTRAIT: 1,
    DEVICE_ORIENTATION_LANDSCAPE: 2,

    
    DEVICE_OSNAME_ANDROID: "android",
    DEVICE_OSNAME_ANDROIDTABLET: "androidtablet",
    DEVICE_OSNAME_IPHONE: "iPhone",
    DEVICE_OSNAME_IPAD: "iPad",
    DEVICE_OSNAME_MACINTOSH: "Macintosh",
    DEVICE_OSNAME_WINDOWS: "windows",
    DEVICE_OSNAME_WINDOWSTABLET: "windowstablet",
    DEVICE_OSNAME_WINDOWPHONE: "windowsphone",
    DEVICE_OSNAME_LINUX: "Linux",
    DEVICE_OSNAME_BLACKBERRY: "blackberryNTH",
    DEVICE_OSNAME_BLACKBERRYNTH: "blackberry",

    
    FORM_TYPE_STATIC: 1,
    FORM_TYPE_DYNAMIC: 2,
    FORM_TYPE_NATIVE: 3,

    FORM_DISPLAY_ORIENTATION_PORTRAIT: 1,
    FORM_DISPLAY_ORIENTATION_LANDSCAPE: 2,
    FORM_DISPLAY_ORIENTATION_BOTH: 3,

    FORM_DEVICE_ORIENTATION_PORTRAIT: 1,
    FORM_DEVICE_ORIENTATION_LANDSCAPE: 2,

    FORM_ADJUST_RESIZE: 1,
    FORM_ADJUST_PAN: 2,

    FORM_FORWARD_NAVIGATION: 1,


    

    HTTP_METHOD_GET: "get",
    HTTP_METHOD_POST: "post",
    HTTP_RESPONSE_TYPE_TEXT: "text",
    HTTP_RESPONSE_TYPE_JSON: "json",
    HTTP_RESPONSE_TYPE_DOCUMENT: "document",
    HTTP_RESPONSE_TYPE_RAWDATA: "image/png",
    HTTP_RESPONSE_TYPE_ARRAYBUFFER: "arraybuffer",
    HTTP_RESPONSE_TYPE_BLOB: "blob",

    HTTP_READY_STATE_UNSENT: 0,
    HTTP_READY_STATE_OPENED: 1,
    HTTP_READY_STATE_HEADERS_RECEIVED: 2,
    HTTP_READY_STATE_LOADING: 3,
    HTTP_READY_STATE_DONE: 4,

    HTTP_INTEGRITY_CHECK_NOT_DONE : 0,
    HTTP_INTEGRITY_CHECK_SUCCESSFUL : 1,
    HTTP_INTEGRITY_CHECK_FAILED : 2,

    
    OPEN_URL_SUCCESS: 1,
    OPEN_URL_FAILURE: 0,
    OPEN_URL_UNKNOWN: -1,

    
    IMAGE_SCALE_MODE_FIT_TO_DIMENSIONS: 0,
    IMAGE_SCALE_MODE_MAINTAIN_ASPECT_RATIO: "maintainaspectratio",
    IMAGE_SCALE_MODE_CROP: 2,
    IMAGE_GLOSSY_EFFECT_DEFAULT: 0,
    IMAGE_GLOSSY_EFFECT_RADIAL: 1,
    IMAGE_GLOSSY_EFFECT_LINEAR: 2,

    
    LOADING_SCREEN_POSITION_FULL_SCREEN: "fullscreen",

    LOADING_SCREEN_POSITION_ONLY_CENTER: "center",

    
    LISTBOX_VIEW_TYPE_LISTVIEW: 0,
    LISTBOX_VIEW_TYPE_TABLEVIEW: 1,
    LISTBOX_VIEW_TYPE_TOGGLEVIEW: 2,
    LISTBOX_VIEW_TYPE_ONSCREENWHEEL: 3,
    LISTBOX_VIEW_TYPE_SPINNER: 4,

    
    MAP_PROVIDER_GOOGLE: "google",
    MAP_SOURCE_NON_NATIVE: "non-native",
    MAP_SOURCE_NATIVE: "native",
    MAP_SOURCE_STATIC: "static",
    MAP_VIEW_MODE_NORMAL: 1,
    MAP_VIEW_MODE_SATELLITE: 2,
    MAP_VIEW_MODE_HYBRID: 3,
    MAP_VIEW_MODE_TERRAIN: 7,
    MAP_VIEW_MODE_POLYGON: 5,
    MAP_HEIGHT_BY_FORM_REFERENCE: 1, 
    MAP_HEIGHT_BY_PARENT_WIDTH: 2, 

    
    NETWORK_TYPE_ANY: "ANY",
    NETWORK_TYPE_ETHERNET: "ETHERNET",
    NETWORK_TYPE_WIFI: "WIFI",
    NETWORK_TYPE_3G: "3G",

    
    POPUP_TYPE_NATIVE: 1,
    POPUP_TYPE_SPA: 2,
    POPUP_TYPE_TC: 3,

    

    
    RADIOGROUP_ITEM_ORIENTATION_VERTICAL: "vertical",
    RADIOGROUP_ITEM_ORIENTATION_HORIZONTAL: 2,

    RADIOBUTTON_VIEW_TYPE_DEFAULTTVIEW: "defaultview",
    RADIOBUTTON_VIEW_TYPE_CUSTOMVIEW: "customview",
    



    
    SEGUI_VIEW_TYPE_TABLEVIEW: "tableview",
    SEGUI_VIEW_TYPE_PAGEVIEW: "pageview",
    
    SEGUI_DEFAULT_BEHAVIOR: 0,
    SEGUI_SINGLE_SELECT_BEHAVIOR: 1,
    SEGUI_MULTI_SELECT_BEHAVIOR: 2,


    
    SEGUI_SCROLL_POSITION_DEFAULT: 0,
    SEGUI_SCROLL_POSITION_RETAIN: 1,
    SEGUI_SCROLL_POSITION_TOP: 2,


    
    TEXTBOX_INPUT_MODE_ANY: "A",
    TEXTBOX_INPUT_MODE_NUMERIC: "N",
    TEXTBOX_INPUT_MODE_PASSWORD: "P",

    TEXTBOX_KEY_BOARD_STYLE_DEFAULT: "A",
    TEXTBOX_KEY_BOARD_STYLE_EMAIL: "emailpad",
    TEXTBOX_KEY_BOARD_STYLE_URL: "urlpad",
    TEXTBOX_KEY_BOARD_STYLE_CHAT: "chatpad",

    TEXTBOX_KEY_BOARD_STYLE_DECIMAL: "number",
    TEXTBOX_KEY_BOARD_STYLE_NUMBER_PAD: "digitpad",
    TEXTBOX_KEY_BOARD_STYLE_PHONE_PAD: "telpad",

    TEXTBOX_VIEW_TYPE_DEFAULT: "default",
    TEXTBOX_VIEW_TYPE_SEARCH_VIEW: "search",

    TEXTBOX_AUTO_CAPITALIZE_NONE: "none",
    TEXTBOX_AUTO_CAPITALIZE_WORDS: "words",
    TEXTBOX_AUTO_CAPITALIZE_SENTENCES: "sentences",
    TEXTBOX_AUTO_CAPITALIZE_ALL: "characters",

    TEXTBOX_DEFAULT_PLATFORM_HEIGHT: 1,
    TEXTBOX_FONT_METRICS_DRIVEN_HEIGHT: 2,
    TEXTBOX_CUSTOM_HEIGHT: 3,
    CONTAINER_HEIGHT_BY_FORM_REFERENCE: 1,
    CONTAINER_HEIGHT_BY_PARENT_WIDTH: 2,
    

    
    TEXTAREA_INPUT_MODE_ANY: "A",
    TEXTAREA_INPUT_MODE_NUMERIC: "N",

    TEXTAREA_KEY_BOARD_STYLE_DEFAULT: "A",
    TEXTAREA_KEY_BOARD_STYLE_EMAIL: "emailpad",
    TEXTAREA_KEY_BOARD_STYLE_URL: "urlpad",
    TEXTAREA_KEY_BOARD_STYLE_CHAT: "chatpad",

    TEXTAREA_KEY_BOARD_STYLE_DECIMAL: "number",
    TEXTAREA_KEY_BOARD_STYLE_NUMBER_PAD: "number",
    TEXTAREA_KEY_BOARD_STYLE_PHONE_PAD: "telpad",

    TEXTAREA_AUTO_CAPITALIZE_NONE: "none",
    TEXTAREA_AUTO_CAPITALIZE_WORDS: "words",
    TEXTAREA_AUTO_CAPITALIZE_SENTENCES: "sentences",
    TEXTAREA_AUTO_CAPITALIZE_ALL: "characters",
    
    HORIZONTAL_IMAGESTRIP_VIEW_TYPE_STRIPVIEW: "stripview",
    HORIZONTAL_IMAGESTRIP_VIEW_TYPE_SLOTVIEW: "slotview",
    HORIZONTAL_IMAGESTRIP_VIEW_TYPE_PAGEVIEW: "pageview",

    
    WIDGET_ALIGN_TOP_LEFT: 1,
    WIDGET_ALIGN_TOP_CENTER: 2,
    WIDGET_ALIGN_TOP_RIGHT: 3,
    WIDGET_ALIGN_MIDDLE_LEFT: 4,
    WIDGET_ALIGN_CENTER: 5,
    WIDGET_ALIGN_MIDDLE_RIGHT: 6,
    WIDGET_ALIGN_BOTTOM_LEFT: 7,
    WIDGET_ALIGN_BOTTOM_CENTER: 8,
    WIDGET_ALIGN_BOTTOM_RIGHT: 9,

    
    CONTENT_ALIGN_TOP_LEFT: 1,
    CONTENT_ALIGN_TOP_CENTER: 2,
    CONTENT_ALIGN_TOP_RIGHT: 3,
    CONTENT_ALIGN_MIDDLE_LEFT: 4,
    CONTENT_ALIGN_CENTER: 5,
    CONTENT_ALIGN_MIDDLE_RIGHT: 6,
    CONTENT_ALIGN_BOTTOM_LEFT: 7,
    CONTENT_ALIGN_BOTTOM_CENTER: 8,
    CONTENT_ALIGN_BOTTOM_RIGHT: 9,

    GESTURE_TYPE_TAP: 1,
    GESTURE_TYPE_SWIPE: 2,
    GESTURE_TYPE_LONGPRESS: 3,
    GESTURE_TYPE_PAN: 4,
    GESTURE_TYPE_ROTATION: 5,
    GESTURE_TYPE_PINCH: 6,

    BROWSER_REQUEST_METHOD_GET: "get",
    BROWSER_REQUEST_METHOD_POST: "post",

    TABPANE_VIEW_TYPE_TABVIEW: "tabview",
    TABPANE_VIEW_TYPE_COLLAPSIBLEVIEW: "collapsibleview",

    TABPANE_VIEW_TYPE_PAGEVIEW: "pageview",

    MASTER_TYPE_DEFAULT: 0,
    MASTER_TYPE_USERWIDGET: 1,

    TABPANE_COLLAPSIBLE_IMAGE_POSITION_RIGHT: "right",
    TABPANE_COLLAPSIBLE_IMAGE_POSITION_LEFT: "left",
    TABPANE_COLLAPSIBLE_TABNAME_ALIGNMENT_RIGHT: "right",
    TABPANE_COLLAPSIBLE_TABNAME_ALIGNMENT_LEFT: "left",
    TABPANE_COLLAPSIBLE_TABNAME_ALIGNMENT_CENTER: "center",

    TAB_HEADER_POSITION_TOP: "top",
    TAB_HEADER_POSITION_BOTTOM: "bottom",
    TAB_HEADER_POSITION_LEFT: "left",
    TAB_HEADER_POSITION_RIGHT: "right",
    
    ONHOVER_MOUSE_ENTER: 0,
    ONHOVER_MOUSE_MOVE: 1,
    ONHOVER_MOUSE_LEAVE: 2,

    BREAKPOINT_MAX_VALUE: Number.MAX_VALUE,

    DATAGRID_COLUMN_TYPE_TEXT: "text",
    DATAGRID_COLUMN_TYPE_IMAGE: "image",
    DATAGRID_COLUMN_TYPE_TEMPLATE: "template",

    CONTAINER_LAYOUT_GRID: 5,
    IMAGE_GALLERY_VIEW_TYPE_PAGEVIEW: "pageview",
    LISTBOX_VIEW_TYPE_EDITVIEW: "editableview",
    DATAGRID_SCROLLBAR_NONE: 0,
    DATAGRID_SCROLLBAR_VERTICAL: 1,

    
    FILE_UPLOAD_START_STATE: 0,
    FILE_UPLOAD_PROGRESS_STATE: 1,
    FILE_UPLOAD_COMPLETE_STATE: 2,
    FILE_UPLOAD_ERROR_STATE: 3,
    UPLOAD_MAX_WAIT_TIME: 120000, 

    
    MENU_CONTAINER_VIEW_TYPE_DROPDOWNVIEW: 1,
    MENU_CONTAINER_VIEW_TYPE_DROPLINEVIEW: 2,
    MENU_CONTAINER_VIEW_TYPE_TREEVIEW: 3,
    MENU_CONTAINER_VIEW_TYPE_CONTEXTVIEW: 4,

    MENUCONTAINER_POSITION_AS_HORIZONTAL: "horizontal",
    MENUCONTAINER_POSITION_AS_VERTICAL: "vertical",

    SLIDER_HORIZONTAL_ORIENTATION: "horizontal",
    SLIDER_VERTICAL_ORIENTATION: "vertical",

    SLIDER_VIEW_TYPE_DEFAULT: "default",
    SLIDER_VIEW_TYPE_PROGRESS: "progress",

    SEGUI_SEARCH_CRITERIA_CONTAINS: "CONTAINS",
    SEGUI_SEARCH_CRITERIA_ENDSWITH: "ENDSWITH",
    SEGUI_SEARCH_CRITERIA_STARTSWITH: "STARTSWITH",
    SEGUI_SEARCH_CRITERIA_NOT_CONTAINS: "NOT_CONTAINS",
    SEGUI_SEARCH_CRITERIA_NOT_ENDSWITH: "NOT_ENDSWITH",
    SEGUI_SEARCH_CRITERIA_NOT_STARTSWITH: "NOT_STARTSWITH",
    SEGUI_SEARCH_CRITERIA_GREATER: "GREATER",
    SEGUI_SEARCH_CRITERIA_GREATER_EQUAL:"GREATER_EQUAL",
    SEGUI_SEARCH_CRITERIA_LESSER: "LESSER",
    SEGUI_SEARCH_CRITERIA_LESSER_EQUAL: "LESSER_EQUAL",
    SEGUI_SEARCH_CRITERIA_STRICT_EQUAL: "STRICT_EQUAL",
    SEGUI_SEARCH_CRITERIA_NOT_EQUAL: "NOT_EQUAL",

    SEGUI_SEARCH_CRITERIA_OPERATOR_AND: "AND",
    SEGUI_SEARCH_CRITERIA_OPERATOR_OR: "OR"

};



kony.flex = {
    DEFAULT_UNIT: '%',
    DP: 'dp',
    PX: 'px',
    PERCENTAGE: '%',
    FREE_FORM: 1,
    FLOW_HORIZONTAL: 2,
    FLOW_VERTICAL: 3,
    VBOX_LAYOUT: 4,
    USE_PREFERRED_SIZE: "preferred",
    USE_AVAILABLE_SPACE: "available",
    SCROLL_HORIZONTAL: 1,
    SCROLL_VERTICAL: 2,
    SCROLL_BOTH: 3,
    SCROLL_NONE: 4,
    AUTOGROW_HEIGHT: 1,
    AUTOGROW_NONE: 0
};

kony.canvas = {
    SHAPE_TYPE_LINE: "line",
    LINE_STYLE_SOLID: "solidline",
    LINE_STYLE_DASHED: "dashedline",
    LINE_STYLE_DOTTED: "dottedline"
};

kony.anim = {
    FILL_MODE_FORWARDS: "forwards",
    FILL_MODE_BACKWARDS: "backwards",
    FILL_MODE_BOTH: "both",
    FILL_MODE_NONE: "none",

    DIRECTION_NONE: "normal",
    DIRECTION_REVERSE: "reverse",
    DIRECTION_ALTERNATE: "alternate",
    DIRECTION_ALTERNATE_REVERSE: "alternate-reverse",

    EASE: "ease",
    EASE_IN: "ease-in",
    EASE_OUT: "ease-out",
    EASE_IN_OUT: "ease-in-out",
    LINEAR: "linear"
};

kony.segment = {
    ADD: 0,
    REMOVE: 1,
    UPDATE: 2,
    VISIBLE: 3,
    INVISIBLE: 4,
    PORTIONS_PER_SEGMENT: 2
};

kony.map = {
    MAP_PROVIDER_GOOGLE: "google",
    MAP_VIEW_MODE_NORMAL: 1,
    MAP_VIEW_MODE_SATELLITE: 2,
    PIN_IMG_ANCHOR_TOP_LEFT: 3,
    PIN_IMG_ANCHOR_TOP_RIGHT: 4,
    PIN_IMG_ANCHOR_TOP_CENTER: 5,
    PIN_IMG_ANCHOR_CENTER: 6,
    PIN_IMG_ANCHOR_BOTTOM_LEFT: 7,
    PIN_IMG_ANCHOR_BOTTOM_RIGHT: 8,
    PIN_IMG_ANCHOR_BOTTOM_CENTER: 9,
    PIN_IMG_ANCHOR_MIDDLE_LEFT: 10,
    PIN_IMG_ANCHOR_MIDDLE_RIGHT: 11
};

kony.collectionview = {
    SINGLE_SELECT: 1,
    MULTI_SELECT: 2,
    LAYOUT_HORIZONTAL: 0,
    LAYOUT_VERTICAL: 1,
    LAYOUT_CUSTOM: 2,
    SCROLL_DIRECTION_BOTH: "both",
    SCROLL_DIRECTION_VERTICAL: "vertical",
    SCROLL_DIRECTION_HORIZONTAL: "horizontal"
};

kony.calendar = {
    LEGACY: "legacy",
    MODERN: "modern"
};

var kony = kony || {};

var constants = constants || {};

kony.defaults = {};
kony.defaults.widget = {};


kony.defaults.merge = function(config1, config2, config3) {
    var merge = {};

    for(x in config1) {
        merge[x] = config1[x];
    }
    for(x in config2) {
        merge[x] = config2[x];
    }
    for(x in config3) {
        merge[x] = config3[x];
    }

    return merge;
};

kony.defaults.getAllDefaults = function(widget) {
    var defaultValues = kony.defaults["widget"][widget];
    
    defaultValues.id = null;
    
    if(defaultValues.data)
        defaultValues.data = null;
    if(defaultValues.masterData)
        defaultValues.masterData = null;
    return defaultValues;
};



kony.defaults.Form2 = function(config1, config2, config3) {
    kony.formDefaults = kony.defaults.merge(config1, config2, config3);
    kony.defaults.widget.Form2 = kony.formDefaults;
};

kony.defaults.Form09ed48c1d517041 = new kony.defaults.Form2({
    "id": "Form2",
    "type": constants.FORM_TYPE_NATIVE,
    "title": null,
    "skin": "slForm",
    "needAppMenu": true,
    "enabledForIdleTimeout": false,
    "addWidgets": null,
    "init": null,
    "preShow": null,
    "postShow": null,
    "onHide": null,
    "onOrientationChange": null,
    "onDestroy": null
}, {
    "displayOrientation": constants.FORM_DISPLAY_ORIENTATION_PORTRAIT,
    "padding": [0, 0, 0, 0],
    "paddingInPixel": false
}, {
    "titleBar": true,
    "titleBarSkin": "slTitleBar",
    "titleBarConfig": {
        "renderTitleText": true,
        "titleBarLeftSideView": "button",
        "labelLeftSideView": "Back",
        "titleBarRightSideView": "button",
        "labelRightSideView": "Edit"
    },
    "menuPosition": constants.FORM_MENU_POSITION_AFTER_APPMENU,
    "windowSoftInputMode": constants.FORM_ADJUST_RESIZE,
    "onDeviceBack": null,
    "onDeviceMenu": null,
    "footerOverlap": false,
    "headerOverlap": false,
    "retainScrollPosition": false,
    "inTransitionConfig": {
        "formTransition": "None"
    },
    "outTransitionConfig": {
        "formTransition": "None"
    },
    "configureExtendTop": false,
    "configureExtendBottom": false,
    "configureStatusBarStyle": false,
    "bounces": true
});





kony.defaults.TextArea2 = function(config1, config2, config3) {
    kony.textAreaDefaults = kony.defaults.merge(config1, config2, config3);
    kony.defaults.widget.TextArea2 = kony.textAreaDefaults;
};

kony.defaults.TextArea0a4bbfc9a405e43 = new kony.defaults.TextArea2({
    "id": "TextArea2",
    "skin": "slTextArea",
    "onDone": null,
    "isVisible": true,
    "text": "Textarea text ",
    "textInputMode": constants.TEXTAREA_INPUT_MODE_ANY,
    "keyBoardStyle": constants.TEXTAREA_KEY_BOARD_STYLE_DEFAULT,
    "secureTextEntry": false,
    "onTextChange": null,
    "autoCapitalize": constants.TEXTAREA_AUTO_CAPITALIZE_NONE,
    "placeholder": null,
    "numberOfVisibleLines": 3
}, {
    "widgetAlignment": constants.WIDGET_ALIGN_CENTER,
    "contentAlignment": constants.CONTENT_ALIGN_TOP_LEFT,
    "containerWeight": 100,
    "padding": [2, 2, 2, 2],
    "paddingInPixel": false,
    "margin": [2, 2, 2, 2],
    "marginInPixel": false,
    "hExpand": true
}, {
    "onBeginEditing": null,
    "onEndEditing": null
});






kony.defaults.TextBox2 = function(config1, config2, config3) {
    kony.textBoxDefaults = kony.defaults.merge(config1, config2, config3);
    kony.defaults.widget.TextBox2 = kony.textBoxDefaults;
};

kony.defaults.TextField04aca556080344f = new kony.defaults.TextBox2({
    "id": "TextBox2",
    "skin": "slTextBox",
    "onDone": null,
    "isVisible": true,
    "text": "to verify the text field",
    "textInputMode": constants.TEXTBOX_INPUT_MODE_ANY,
    "keyBoardStyle": constants.TEXTBOX_KEY_BOARD_STYLE_DEFAULT,
    "secureTextEntry": false,
    "onTextChange": null,
    "autoCapitalize": constants.TEXTBOX_AUTO_CAPITALIZE_NONE,
    "placeholder": null
}, {
    "widgetAlignment": constants.WIDGET_ALIGN_CENTER,
    "contentAlignment": constants.CONTENT_ALIGN_MIDDLE_LEFT,
    "containerWeight": 100,
    "padding": [3, 6, 1, 6],
    "paddingInPixel": false,
    "margin": [0, 0, 0, 0],
    "marginInPixel": false,
    "hExpand": true,
    "containerHeightMode": constants.TEXTBOX_FONT_METRICS_DRIVEN_HEIGHT,
    "containerHeight": null
}, {
    "autoFilter": false
});







kony.defaults.Button = function(config1, config2, config3) {
    kony.buttonDefaults = kony.defaults.merge(config1, config2, config3);
    kony.defaults.widget.Button = kony.buttonDefaults;
};


kony.defaults.Button06920f593d51b4c = new kony.defaults.Button({
    "id": "Button",
    "skin": "btnNormal",
    "focusSkin": "btnFocus",
    "onClick": null,
    "isVisible": true,
    "text": "Testthis"
}, {
    "widgetAlignment": constants.WIDGET_ALIGN_CENTER,
    "contentAlignment": constants.CONTENT_ALIGN_CENTER,
    "containerWeight": 100,
    "padding": [4, 4, 4, 4],
    "paddingInPixel": false,
    "margin": [6, 6, 6, 6],
    "marginInPixel": false,
    "hExpand": true,
    "vExpand": false,
    "displayText": true
}, {});




kony.defaults.CheckBoxGroup = function(config1, config2, config3) {
    kony.checkBoxGroupDefaults = kony.defaults.merge(config1, config2, config3);
    kony.defaults.widget.CheckBoxGroup = kony.checkBoxGroupDefaults;

}



kony.defaults.CheckBoxGroup0e0355477e5b741 = new kony.defaults.CheckBoxGroup({
    "id": "CheckBoxGroup",
    "skin": "slCheckBoxGroup",
    "onSelection": null,
    "isVisible": true,
    "masterData": [
        ["cbg1", "Checkbox One"],
        ["cbg2", "Checkbox Two"],
        ["cbg3", "Checkbox Three"]
    ],
    "selectedKeys": null,
    "selectedKeyValues": null
}, {
    "widgetAlignment": constants.WIDGET_ALIGN_CENTER,
    "containerWeight": 100,
    "padding": [0, 0, 0, 0],
    "paddingInPixel": false,
    "margin": [0, 0, 0, 0],
    "marginInPixel": false,
    "itemOrientation": constants.CHECKBOX_ITEM_ORIENTATION_VERTICAL
}, {});



kony.defaults.ListBox = function(config1, config2, config3) {
    kony.listBoxDefaults = kony.defaults.merge(config1, config2, config3);
    kony.defaults.widget.ListBox = kony.listBoxDefaults;

}


kony.defaults.ListBox02f4edc04ce8c44 = new kony.defaults.ListBox({
    "id": "ListBox",
    "skin": "slListBox",
    "onSelection": null,
    "isVisible": true,
    "masterData": [
        ["lb1", "Listbox One"],
        ["lb2", "Listbox Two"],
        ["lb3", "Listbox Three"]
    ],
    "selectedKey": "lb1",
    "selectedKeyValue": ["lb1", "Listbox One"],
    "onDone": null
}, {
    "widgetAlignment": constants.WIDGET_ALIGN_CENTER,
    "contentAlignment": constants.CONTENT_ALIGN_MIDDLE_LEFT,
    "containerWeight": 100,
    "padding": [0, 0, 0, 0],
    "paddingInPixel": false,
    "margin": [0, 0, 0, 0],
    "marginInPixel": false,
    "hExpand": true,
    "vExpand": false
}, {
    "applySkinsToPopup": true,
    "viewType": constants.LISTBOX_VIEW_TYPE_LISTVIEW,
    "placeholder": null
});





kony.defaults.Label = function(config1, config2, config3) {
    kony.labelDefaults = kony.defaults.merge(config1, config2, config3);
    kony.defaults.widget.Label = kony.labelDefaults;
}


kony.defaults.Label011bd5c1421a849 = new kony.defaults.Label({
    "id": "Label",
    "skin": "lblNormal",
    "text": "Label",
    "isVisible": true
}, {
    "widgetAlignment": constants.WIDGET_ALIGN_CENTER,
    "contentAlignment": constants.CONTENT_ALIGN_MIDDLE_LEFT,
    "containerWeight": 100,
    "padding": [0, 0, 0, 0],
    "paddingInPixel": false,
    "margin": [1, 1, 1, 1],
    "marginInPixel": false,
    "hExpand": true,
    "vExpand": false
}, {
    "textCopyable": false
});






kony.defaults.RadioButtonGroup = function(config1, config2, config3) {
    kony.radioButtonGroupDefaults = kony.defaults.merge(config1, config2, config3);
    kony.defaults.widget.RadioButtonGroup = kony.radioButtonGroupDefaults;

}


kony.defaults.RadioButtonGroup07b5a00f7a5464a = new kony.defaults.RadioButtonGroup({
    "id": "RadioButtonGroup",
    "skin": "slRadioButtonGroup",
    "onSelection": null,
    "isVisible": true,
    "masterData": [
        ["rbg1", "Table view of iTems on Radio button"],
        ["rbg2", "Radiobutton Two"],
        ["rbg3", "Radiobutton Three"]
    ],
    "selectedKey": null,
    "selectedKeyValue": null
}, {
    "widgetAlignment": constants.WIDGET_ALIGN_CENTER,
    "containerWeight": 100,
    "padding": [0, 0, 0, 0],
    "paddingInPixel": false,
    "margin": [0, 0, 0, 0],
    "marginInPixel": false,
    "hExpand": true,
    "vExpand": false,
    "itemOrientation": constants.RADIOGROUP_ITEM_ORIENTATION_VERTICAL
}, {});





kony.defaults.SegmentedUI2 = function(config1, config2, config3) {
    kony.segmentedUI2Defaults = kony.defaults.merge(config1, config2, config3);
    kony.defaults.widget.SegmentedUI2 = kony.segmentedUI2Defaults;
}


kony.defaults.Segment0d6ae5ed6c4e14d = new kony.defaults.SegmentedUI2({
    "id": "SegmentedUI2",
    "rowSkin": "seg2Normal",
    "rowFocusSkin": "seg2Focus",
    "sectionHeaderSkin": "sliPhoneSegmentHeader",
    "widgetDataMap": null,
    "rowTemplate": null,
    "isVisible": true,
    "sectionHeaderTemplate": null,
    "data": null,
    "separatorRequired": true,
    "separatorThickness": 1,
    "separatorColor": "E9E9E900",
    "viewType": constants.SEGUI_VIEW_TYPE_TABLEVIEW,
    "onRowClick": null,
    "screenLevelWidget": false,
    "groupCells": false,
    "retainSelection": false,
    "needPageIndicator": true,
    "pageOnDotImage": "pageOnDot.png",
    "pageOffDotImage": "pageOffDot.png",
    "onSwipe": null,
    "showScrollbars": false,
    "scrollingEvents": {
        "onPull": null,
        "onPush": null,
        "onReachingBegining": null,
        "onReachingEnd": null
    },
    "selectionBehavior": constants.SEGUI_DEFAULT_BEHAVIOR,
    "selectedIndex": null,
    "selectedItems": null,
    "selectedIndices": null
}, {
    "margin": [0, 0, 0, 0],
    "marginInPixel": false,
    "padding": [0, 0, 0, 0],
    "paddingInPixel": false,
    "widgetAlignment": constants.WIDGET_ALIGN_CENTER,
    "containerWeight": 100
}, {
    "indicator": constants.SEGUI_ROW_SELECT,
    "enableDictionary": false,
    "showProgressIndicator": false,
    "progressIndicatorColor": constants.PROGRESS_INDICATOR_COLOR_WHITE,
    "bounces": true,
    "searchCriteria": constants.SEGUI_SEARCH_CRITERIA_STARTSWITH,
    "editStyle": constants.SEGUI_EDITING_STYLE_NONE,
    "onEditing": null
});





kony.defaults.Browser = function(config1, config2, config3) {
    kony.Browser = kony.defaults.merge(config1, config2, config3);
    kony.defaults.widget.Browser = kony.Browser;
}

kony.defaults.Browser0d2862f0e24a549 = new kony.defaults.Browser({
    "id": "Browser",
    "onSuccess": null,
    "onFailure": null,
    "htmlString": null,
    "screenLevelWidget": false,
    "enableZoom": false,
    "detectTelNumber": true,
    "isVisible": true
}, {
    "containerWeight": 100,
    "margin": [0, 0, 0, 0],
    "marginInPixel": false
}, {});




kony.defaults.Canvas = function(config1, config2, config3) {
    kony.Canvas = kony.defaults.merge(config1, config2, config3);
    kony.defaults.widget.Canvas = kony.Canvas;
}

kony.defaults.Canvas0d2862f0e24a549 = new kony.defaults.Canvas({
    "id": "Canvas",
    "isVisible": true
}, {
    "containerWeight": 100,
    "margin": [0, 0, 0, 0],
    "marginInPixel": false
}, {});




kony.defaults.Camera = function(config1, config2, config3) {
    kony.Camera = kony.defaults.merge(config1, config2, config3);
    kony.defaults.widget.Camera = kony.Camera;
}

kony.defaults.Camera01313e592e53c4e = new kony.defaults.Camera({
    "id": "Camera",
    "skin": "slCamera",
    "text": "Camera",
    "isVisible": true,
    "onCapture": null
}, {
    "widgetAlignment": constants.WIDGET_ALIGN_CENTER,
    "contentAlignment": constants.CONTENT_ALIGN_CENTER,
    "containerWeight": 100,
    "padding": [0, 0, 0, 0],
    "paddingInPixel": false,
    "margin": [0, 0, 0, 0],
    "marginInPixel": false,
    "hExpand": true,
    "vExpand": false
}, {
    "enableOverlay": false,
    "accessMode": constants.CAMERA_IMAGE_ACCESS_MODE_PUBLIC,
    "enablePhotoCropFeature": false,
    "nativeUserInterface": true
});






kony.defaults.Phone = function(config1, config2, config3) {
    kony.Phone = kony.defaults.merge(config1, config2, config3);
    kony.defaults.widget.Phone = kony.Phone;
}

kony.defaults.Phone0e0761018182e43 = new kony.defaults.Phone({
    "id": "Phone",
    "skin": "slPhone",
    "onClick": null,
    "isVisible": true,
    "text": "+91-999-999-8888"
}, {
    "widgetAlignment": constants.WIDGET_ALIGN_CENTER,
    "contentAlignment": constants.CONTENT_ALIGN_CENTER,
    "containerWeight": 100,
    "padding": [2, 2, 2, 2],
    "paddingInPixel": false,
    "margin": [3, 3, 3, 3],
    "marginInPixel": false,
    "hExpand": true,
    "vExpand": false,
    "displayText": true
}, {

    "glowEffect": false,
    "showProgressIndicator": false

});






kony.defaults.PickerView = function(config1, config2, config3) {
    kony.PickerView = kony.defaults.merge(config1, config2, config3);
    kony.defaults.widget.PickerView = kony.PickerView;
}

kony.defaults.PickerView0356232459d694c = new kony.defaults.PickerView({
    "id": "PickerView",
    "skin": "slPickerView",
    "masterData": [
        [
            ["y1", "2009"],
            ["y2", "2010"],
            ["y3", "2011"], 40
        ],
        [
            ["m1", "Jan"],
            ["m2", "Feb"],
            ["m3", "Mar"],
            ["m4", "Apr"],
            ["m5", "May"],
            ["m6", "Jun"],
            ["m7", "Jul"], 60
        ]
    ],
    "isVisible": true,
    "onSelection": null,
    "selectedKeyValues": ["2009", "Jan"],
    "selectedKeys": null
}, {
    "widgetAlignment": constants.WIDGET_ALIGN_CENTER,
    "containerWeight": 100,
    "margin": [0, 0, 0, 0],
    "marginInPixel": false,
    "hExpand": true
}, {});





kony.defaults.Switch = function(config1, config2, config3) {
    kony.Switch = kony.defaults.merge(config1, config2, config3);
    kony.defaults.widget.Switch = kony.Switch;
}

kony.defaults.Switch09683e5aca10244 = new kony.defaults.Switch({
    "id": "Switch",
    "skin": "slSwitch",
    "leftSideText": "ON",
    "rightSideText": "OFF",
    "onSlide": null,
    "selectedIndex": 0,
    "isVisible": true
}, {
    "containerWeight": 100,
    "widgetAlignment": constants.WIDGET_ALIGN_CENTER,
    "margin": [0, 0, 0, 0],
    "marginInPixel": false,
    "padding": [0, 0, 0, 0],
    "paddingInPixel": false
}, {});







kony.defaults.Image2 = function(config1, config2, config3) {
    kony.Image2 = kony.defaults.merge(config1, config2, config3);
    kony.defaults.widget.Image2 = kony.Image2;
}

kony.defaults.Image01ec4259a156040 = new kony.defaults.Image2({
    "id": "Image2",
    "isVisible": true,
    "onDownloadComplete": null,
    "src": "imagedrag.png"
}, {
    "padding": [0, 0, 0, 0],
    "paddingInPixel": false,
    "margin": [0, 0, 0, 0],
    "marginInPixel": false,
    "imageScaleMode": constants.IMAGE_SCALE_MODE_MAINTAIN_ASPECT_RATIO,
    "containerWeight": 100,
    "widgetAlignment": constants.WIDGET_ALIGN_CENTER
}, {});





kony.defaults.Line = function(config1, config2, config3) {
    kony.Line = kony.defaults.merge(config1, config2, config3);
    kony.defaults.widget.Line = kony.Line;
}


kony.defaults.Line014280b6840c84d = new kony.defaults.Line({
    "id": "Line",
    "skin": "slLine",
    "isVisible": true
}, {
    "margin": [0, 0, 0, 0],
    "marginInPixel": false,
    "thickness": 1
}, {});







kony.defaults.RichText = function(config1, config2, config3) {
    kony.RichText = kony.defaults.merge(config1, config2, config3);
    kony.defaults.widget.RichText = kony.RichText;
}

kony.defaults.RichText0af113743c6c049 = new kony.defaults.RichText({
    "id": "RichText",
    "skin": "slRichText",
    "onClick": null,
    "text": "RichText",
    "isVisible": true
}, {
    "widgetAlignment": constants.WIDGET_ALIGN_CENTER,
    "contentAlignment": constants.CONTENT_ALIGN_MIDDLE_LEFT,
    "containerWeight": 100,
    "padding": [0, 0, 0, 0],
    "paddingInPixel": false,
    "margin": [0, 0, 0, 0],
    "marginInPixel": false,
    "hExpand": true,
    "vExpand": false
}, {});






kony.defaults.Slider = function(config1, config2, config3) {
    kony.Slider = kony.defaults.merge(config1, config2, config3);
    kony.defaults.widget.Slider = kony.Slider;
}


kony.defaults.Slider054a9c1893eae41 = new kony.defaults.Slider({
    "id": "Slider",
    "min": 0,
    "max": 100,
    "step": 1,
    "selectedValue": 40,
    "onSlide": null,
    "onSelection": null,
    "leftSkin": "konysliderleft",
    "rightSkin": "konysliderright",
    "thumbImage": "slider.png",
    "isVisible": true
}, {
    "widgetAlignment": constants.WIDGET_ALIGN_CENTER,
    "containerWeight": 100,
    "margin": [0, 0, 0, 0],
    "marginInPixel": false,
    "hExpand": true,
    "vExpand": false
}, {
    "thickness": 15
});






kony.defaults.Calendar = function(config1, config2, config3) {
    kony.Calendar = kony.defaults.merge(config1, config2, config3);
    kony.defaults.widget.Calendar = kony.Calendar;
}


kony.defaults.Calendar08566e3be5ea045 = new kony.defaults.Calendar({
    "id": "Calendar",
    "skin": "calNormal",
    "isVisible": true,
    "date": [1, 8, 2014],
    "day": 1,
    "month": 8,
    "year": 2014,
    "hour": 12,
    "minutes": 59,
    "seconds": 59,
    "dateComponents": [1, 8, 2014, 12, 59, 59],
    "dateFormat": "dd/MM/yyyy",
    "formattedDate": "",
    "calendarIcon": "calbtn.png",
    "viewType": constants.CALENDAR_VIEW_TYPE_DEFAULT,
    "onSelection": null
}, {
    "widgetAlignment": constants.WIDGET_ALIGN_CENTER,
    "contentAlignment": constants.CONTENT_ALIGN_CENTER,
    "containerWeight": 100,
    "padding": [0, 0, 0, 0],
    "paddingInPixel": false,
    "margin": [0, 0, 0, 0],
    "marginInPixel": false,
    "hExpand": true,
    "vExpand": false
}, {});






kony.defaults.DataGrid = function(config1, config2, config3) {
    kony.DataGrid = kony.defaults.merge(config1, config2, config3);
    kony.defaults.widget.DataGrid = kony.DataGrid;
}


kony.defaults.DataGrid05af006b031d349 = new kony.defaults.DataGrid({
    "id": "DataGrid",
    "isVisible": true,
    "headerSkin": "slDataGridHead",
    "rowNormalSkin": "slDataGridRow",
    "rowFocusSkin": "slDataGridFocusedRow",
    "rowAlternateSkin": "slDataGridAltRow",
    "showColumnHeaders": true,
    "columnHeadersConfig": [{
        "columnContentAlignment": constants.CONTENT_ALIGN_CENTER,
        "columnHeaderText": "Col 1",
        "columnID": "col1",
        "columnOnClick": null,
        "columnType": constants.DATAGRID_COLUMN_TYPE_TEXT,
        "columnWidthInPercentage": 33,
        "isColumnSortable": false
    }, {
        "columnContentAlignment": constants.CONTENT_ALIGN_CENTER,
        "columnHeaderText": "Col 2",
        "columnID": "col2",
        "columnOnClick": null,
        "columnType": constants.DATAGRID_COLUMN_TYPE_TEXT,
        "columnWidthInPercentage": 34,
        "isColumnSortable": false
    }, {
        "columnContentAlignment": constants.CONTENT_ALIGN_CENTER,
        "columnHeaderText": "Col 3",
        "columnID": "col3",
        "columnOnClick": null,
        "columnType": constants.DATAGRID_COLUMN_TYPE_TEXT,
        "columnWidthInPercentage": 33,
        "isColumnSortable": false
    }, ],
    "onRowSelected": null,
    "isMultiSelect": false,
    "selectedItem": {
        "col1": "RC 41",
        "col2": "RC 42",
        "col3": "RC 43"
    },
    "selectedItems": [{
        "col1": "RC 41",
        "col2": "RC 42",
        "col3": "RC 43"
    }],
    "selectedIndices": [3],
    "selectedIndex": 3,
    "rowCount": 4,
    "data": [{
        "col1": "RC 11",
        "col2": "RC 12",
        "col3": "RC 13"
    }, {
        "col1": "RC 21",
        "col2": "RC 22",
        "col3": "RC 23"
    }, {
        "col1": "RC 31",
        "col2": "RC 32",
        "col3": "RC 33"
    }, {
        "col1": "RC 41",
        "col2": "RC 42",
        "col3": "RC 43"
    }]
}, {
    "widgetAlignment": constants.WIDGET_ALIGN_CENTER,
    "contentAlignment": constants.CONTENT_ALIGN_CENTER,
    "containerWeight": 100,
    "margin": [0, 0, 0, 0],
    "padding": [4, 4, 4, 4],
    "marginInPixel": false,
    "paddingInPixel": false
}, {
    "gridlineColor": "F4F4F4"
});







kony.defaults.Map = function(config1, config2, config3) {
    kony.Map = kony.defaults.merge(config1, config2, config3);
    kony.defaults.widget.Map = kony.Map;
}

kony.defaults.Map05662dfdfdfa642 = new kony.defaults.Map({
    "id": "Map",
    "provider": constants.MAP_PROVIDER_GOOGLE,
    "defaultPinImage": "pinb.png",
    "isVisible": true,
    "onSelection": null,
    "onPinClick": null,
    "onClick": null,
    "locationData": [{
        "desc": "Phoenix infocity, Gachibowli",
        "lat": "17.447326",
        "lon": "78.371358",
        "name": "KonyLabs(New)"
    }, {
        "desc": "Mindspace, Hitech City",
        "lat": "17.441839",
        "lon": "78.380928",
        "name": "KonyLabs(Old)"
    }, {
        "desc": "Jaihind Enclave, Madhapur",
        "lat": "17.450378",
        "lon": "78.388398",
        "name": "My Residence"
    }],
    "screenLevelWidget": false,
    "calloutWidth": 80
}, {
    "margin": [0, 0, 0, 0],
    "marginInPixel": false,
    "containerWeight": 100
}, {
    "showZoomControl": true,
    "zoomLevel": 15,
    "mode": constants.MAP_VIEW_MODE_NORMAL
});






kony.defaults.TabPane = function(config1, config2, config3) {
    kony.TabPane = kony.defaults.merge(config1, config2, config3);
    kony.defaults.widget.TabPane = kony.TabPane;
}

kony.defaults.TabPane0d9081410504040 = new kony.defaults.TabPane({
    "id": "TabPane",
    "activeSkin": "tabCanvas",
    "inactiveSkin": "tabCanvasInactive",
    "isVisible": true,
    "viewType": constants.TABPANE_VIEW_TYPE_TABVIEW,
    "viewConfig": {
        "collapsibleViewConfig": {
            "collapsedImage": "",
            "collapsedimage": "",
            "expandedImage": "",
            "expandedimage": "",
            "imagePosition": constants.TABPANE_COLLAPSIBLE_IMAGE_POSITION_RIGHT,
            "imageposition": "right",
            "tabNameAlignment": constants.TABPANE_COLLAPSIBLE_TABNAME_ALIGNMENT_LEFT,
            "tabnamealignment": "left",
            "toggleTabs": false,
            "toggletabs": false
        },
        "collapsibleviewconfig": {
            "collapsedImage": "",
            "collapsedimage": "",
            "expandedImage": "",
            "expandedimage": "",
            "imagePosition": constants.TABPANE_COLLAPSIBLE_IMAGE_POSITION_RIGHT,
            "imageposition": "right",
            "tabNameAlignment": constants.TABPANE_COLLAPSIBLE_TABNAME_ALIGNMENT_LEFT,
            "tabnamealignment": "left",
            "toggleTabs": false,
            "toggletabs": false
        },
        "pageViewConfig": {
            "needPageIndicator": true,
            "pageOffDotImage": "",
            "pageOnDotImage": ""
        },
        "panoramaViewConfig": {
            "panoramaImage": "",
            "panoramaTitle": "",
            "panoramaTitleImage": ""
        },
        "tabViewConfig": {
            "headerPosition": constants.TAB_HEADER_POSITION_TOP,
            "image1": "arrow-left.png",
            "image2": "arrow-right.png"
        },
    },
    "screenLevelWidget": false,
    "activeTabs": [0]
}, {
    "margin": [0, 0, 0, 0],
    "marginInPixel": false,
    "padding": [0, 0, 0, 0],
    "paddingInPixel": false,
    "widgetAlignment": constants.WIDGET_ALIGN_CENTER,
    "layoutType": constants.CONTAINER_LAYOUT_BOX,
    "containerWeight": 100
}, {
    "tabHeaderHeight": 64
});






kony.defaults.Video = function(config1, config2, config3) {
    kony.Video = kony.defaults.merge(config1, config2, config3);
    kony.defaults.widget.Video = kony.Video;
}

kony.defaults.Video0ec83655440d845 = new kony.defaults.Video({
    "id": "Video",
    "isVisible": true,
    "skin": "slVideo",
    "text": "Video"
}, {
    "widgetAlignment": constants.WIDGET_ALIGN_CENTER,
    "containerWeight": 100,
    "margin": [0, 0, 0, 0],
    "padding": [0, 0, 0, 0],
    "marginInPixel": false,
    "paddingInPixel": false
}, {
    "controls": true,
    "poster": "defvideoposter.png"
});




kony.defaults.FlexContainer = function(config1, config2, config3) {
    kony.FlexContainer = kony.defaults.merge(config1, config2, config3);
    kony.defaults.widget.FlexContainer = kony.FlexContainer;
}


kony.defaults.FlexContainer08a3676260d2e546 = new kony.defaults.FlexContainer({
    "id": "FlexContainer",
    "isVisible": true,
    "skin": "slFbox",
    "layoutType": kony.flex.FREE_FORM,
    "clipBounds": true,
    "onSwipe": null
}, {
    "widgetAlignment": constants.WIDGET_ALIGN_TOP_LEFT,
    "containerWeight": 100,
    "padding": [0, 0, 0, 0],
    "hExpand": true,
    "vExpand": false,
    "layoutType": kony.flex.FREE_FORM
}, {});






kony.defaults.FlexScrollContainer = function(config1, config2, config3) {
    kony.FlexScrollContainer = kony.defaults.merge(config1, config2, config3);
    kony.defaults.widget.FlexScrollContainer = kony.FlexScrollContainer;
}


kony.defaults.FlexScroll08a3353460d2e546 = new kony.defaults.FlexScrollContainer({
    "id": "FlexScrollContainer",
    "isVisible": true,
    "skin": "slFSbox",
    "enableScrolling": true,
    "scrollDirection": kony.flex.SCROLL_HORIZONTAL,
    "horizontalScrollIndicator": true,
    "verticalScrollIndicator": true,
    "left": "159dp",
    "top": "215dp",
    "width": "150dp",
    "height": "200dp",
    "zIndex": 1,
    "layoutType": kony.flex.FREE_FORM,
    "clipBounds": true,
    "bounces": true,
    "allowHorizontalBounce": true,
    "allowVerticalBounce": true,
    "onSwipe": null
}, {
    "widgetAlignment": constants.WIDGET_ALIGN_TOP_LEFT,
    "containerWeight": 100,
    "padding": [0, 0, 0, 0],
    "hExpand": true,
    "vExpand": false,
    "layoutType": kony.flex.FREE_FORM
}, {});



$KI.net = {

    integrityProperties: null,

    postdataparams: function(postobj) {
        var postdata = "",
            value;

        for(var i in postobj) {

            if(postobj.hasOwnProperty(i) && i != "httpheaders") {
                value = postobj[i];
                kony.print("postdataparams:key  = " + i + "  value  =  " + value);
                postdata += i + '=' + encodeURIComponent(value);
                postdata += "&";
            }
        }
        return postdata;
    },
    
    FormData: function(formdataparam) {

        function makeIterator(_formdata, arg) {
            var arrKey = Object.keys(_formdata);
            var index =0;
            var index1=0;
            if(arg == "entries") {
                return {
                    next: function() {
                        if(index < arrKey.length && index1 >= _formdata[arrKey[index]].length) {
                            index1 = 0;
                            index++;
                        }
                        return (index < arrKey.length)? {done: false, value: [arrKey[index],_formdata[arrKey[index]][index1++]]} : {done: true, value: undefined};
                    }
                };
            } else if (arg == "keys") {
                return {
                    next: function() {
                        return (index < arrKey.length)? {done: false, value: arrKey[index++]} : {done: true, value: undefined};
                    }
                };
            } else if(arg == "values") {
                return {
                    next: function() {
                        if(index < arrKey.length && index1 >= _formdata[arrKey[index]].length) {
                            index1 = 0;
                            index++;
                        }
                        return (index < arrKey.length)? {done: false, value: _formdata[arrKey[index]][index1++]} : {done: true, value: undefined};
                    }
                };
            }
        }
        $KU.logExecuting('kony.net.FormData');
        if(formdataparam && formdataparam.isMultiPart && (window.FormData != undefined)) {
            $KU.logExecutingWithParams('kony.net.FormData', formdataparam);
            $KU.logExecutingFinished('kony.net.FormData VIA if (formdataparam && formdataparam.isMultiPart && (window.FormData != undefined)) is true');
            return new FormData();
        } else {
            $KU.logExecutingWithParams('kony.net.FormData', formdataparam);
            var _formdata = {},
            that = this;
            that.append = function(key, value) {
                if(key == "undefined" || key == "") {
                    $KU.logErrorMessage('FormData append Error: key cannot be empty');
                    throw new Error("FormData append Error: key cannot be empty");
                }
                
                
                if(!$KG.appbehaviors.doNotEncodeFormValue) {
                    value = encodeURIComponent(value);
                }
                if(!_formdata[key]) {
                    _formdata[key] = [value];
                } else {
                    _formdata[key].push(value);
                }
            },
            that.toString = function() {
                var formdata = "";
                for(var key in _formdata) {
                    if(formdata == "") {
                        formdata = key + '=' + _formdata[key].join('&' + key + '=');
                    } else {
                        formdata += '&' + key + '=' + _formdata[key].join('&' + key + '=');
                    }
                }
                return formdata;
            },
            that.delete = function(key) {
                delete _formdata[key];
            },
            that.entries = function() {
                return makeIterator(_formdata, "entries");
            },
            that.get = function(key) {
                return _formdata[key][0];
            },
            that.getAll = function(key) {
                return _formdata[key];
            },
            that.has = function(key) {
                return _formdata.hasOwnProperty(key);
            },
            that.keys = function() {
                return makeIterator(_formdata, "keys");
            },
            that.set = function(key, value) {
                if(_formdata.hasOwnProperty(key)) {
                    delete _formdata[key];
                }
                _formdata[key] = [value];
            },
            that.values = function() {
                return makeIterator(_formdata, "values");
            }
            $KU.logExecutingFinished('kony.net.FormData VIA VIA if (formdataparam && formdataparam.isMultiPart && (window.FormData != undefined)) is false');
        }
    },

    HttpRequest: function() {
        var _openflag = false,
            _requestMethod = null,
            _sendcount = 0,
            that = this,
            _xhr = null,
            _isIntegrityCheckRequired = false,
            _url = null,
            _xhrtimeout = null;
        $KU.logExecuting('kony.net.HttpRequest');
        $KU.logExecutingWithParams('kony.net.HttpRequest');
        if(window.XMLHttpRequest) {
            _xhr = new XMLHttpRequest();
        } else {
            _xhr = new ActiveXObject("Microsoft.XMLHTTP");
        }

        that.onReadyStateChange = null;
        that.disableIntegrityCheck = false;
        that.readyState = undefined;
        that.response = "";
        that._ismultipart = false;
        that.responseType = "";
        that.status = null;
        that.statusText = null;
        that.timeout = 0;
        that.enableWithCredentials = false; 
        that.randomString = '';
        that.integrityStatus = constants.HTTP_INTEGRITY_CHECK_NOT_DONE;

        _xhr.onreadystatechange = function() {
            
            that.status = _xhr.status;
            switch(_xhr.readyState) {
                case 0: 
                case 1: 
                case 2: 
                case 3: 
                    that.readyState = _xhr.readyState;
                    that.response = "";
                    !!that.onReadyStateChange && that.onReadyStateChange(that);
                    break;

                case 4: 
                    that.statusText = "Request Completed";
                    that.readyState = _xhr.readyState;
                    
                    if(_xhr.responseType == "" || _xhr.responseType == "text") {
                        that.response = _xhr.responseText;
                    } else {
                        that.response = _xhr.response;
                    }
                    if(_isIntegrityCheckRequired) {
                        $KI.net.generateResponseCheckSumAndCheckIntegrity($KI.net.integrityProperties, that, that.response);
                    }
                    if(_xhr.status === 200) {
                        that.statusText += ": OK";
                        if(_xhrtimeout) clearTimeout(_xhrtimeout);
                    }
                    if(_xhr.status === 400) {
                        that.statusText += ": Error";
                        if(_xhrtimeout) clearTimeout(_xhrtimeout);
                    }!!that.onReadyStateChange && that.onReadyStateChange(that); 
                    break;

                default:
                    $KU.logErrorMessage('Unknown Error : XMLHttpRequest error');
                    throw new Error("Unknown Error : XMLHttpRequest Error");
            }
        };

        that.timeoutFunction = function() {
            that.abort();
            that.readyState = _xhr.readyState;
            that.status = 0;
            that.statusText = "Request timed out";
            that.response = "";
            !!that.onReadyStateChange && that.onReadyStateChange();
        };

        that.open = function(requestMethod, url, async, username, password) {
            if(!requestMethod && requestMethod !== "GET" && requestMethod !== "POST") {
                $KU.logErrorMessage('Syntax Error : Request Method is not defined');
                throw new Error("Syntax Error : Request Method is not defined");
                return;
            }
            if(!url) {
                $KU.logErrorMessage('Syntax Error : URL is not defined');
                throw new Error("Syntax Error : URL is not defined");
                return;
            }
            _url = url;
            async = ((async === true) || (async === false)) && async || true;
            _requestMethod = requestMethod;
            _openflag = true;
            _xhr.open(_requestMethod, url, async, username, password);
        };

        that.send = function(data) {
            if(_openflag === false) {
                $KU.logErrorMessage("InvalidStateError : 'send' called before 'open'");
                throw new Error("InvalidStateError : 'send' called before 'open' ");
                return;
            }

            if(_sendcount > 1) {
                $KU.logErrorMessage("InvalidStateError : 'send' called more than once ");
                throw new Error("InvalidStateError : 'send' called more than once ");
                return;
            }

            if(data instanceof kony.net.FormData) {
                data = data.toString(); 
            } else if(!data) {
                data = "";
            } else if((window.FormData !== undefined) && data instanceof window.FormData) {
                that._ismultipart = true;
            }

            if(that.enableWithCredentials) {
                _xhr.withCredentials = true;
            }
            _sendcount++;
            _xhr.timeout = !!that.timeout && that.timeout;
            if(_xhr.timeout) {
                _xhrtimeout = setTimeout(that.timeoutFunction, that.timeout);
            }
            _xhr.responseType = that.responseType;
            _isIntegrityCheckRequired = $KI.net.isIntegrityCheckRequired(_url, that.disableIntegrityCheck);
            if(_isIntegrityCheckRequired) {
                $KI.net.generateRequestCheckSumAndSetRequestHeader($KI.net.integrityProperties, that, data);
            }
            _xhr.send(data);
        };

        that.abort = function() {
            _xhr.abort();
        };

        that.setRequestHeader = function(header, value) {
            if(_openflag === false) {
                $KU.logErrorMessage("InvalidStateError : 'setRequestHeader' called before 'open' ");
                throw new Error("InvalidStateError : 'setRequestHeader' called before 'open' ");
                return;
            }
            if(_sendcount > 1) {
                $KU.logErrorMessage("InvalidStateError : 'setRequestHeader' called after 'send' ");
                throw new Error("InvalidStateError : 'setRequestHeader' called after 'send' ");
                return;
            }

            _xhr.setRequestHeader(header, value);

        };
        that.getResponseHeader = function(headerfield) {
            return !!_xhr.getResponseHeader(headerfield) && _xhr.getResponseHeader(headerfield) || null;
        };
        that.getAllResponseHeaders = function() {
            var headers, arr, parts, header, value, line, count = 0,
                headerMap = {}; 
            headers = !!_xhr.getAllResponseHeaders() && _xhr.getAllResponseHeaders() || null;
            
            if($KG.appbehaviors.isResponseHeaderString) {
                return headers;
            }
            
            
            if(headers) {
                arr = headers.trim().split(/[\r\n]+/);
                for(count = 0; count < arr.length; count++) {
                    line = arr[count];
                    parts = line.split(': ');
                    header = parts.shift();
                    value = parts.join(': ');
                    headerMap[header] = value;
                }
            }
            return headerMap;
        };
        $KU.logExecutingFinished('kony.net.HttpRequest');
    },

    generateRequestCheckSumAndSetRequestHeader: function(integrityProperties, ajaxobj, data) {
        var algo = integrityProperties.algo, salt = integrityProperties.salt,
            headerName = integrityProperties.headerName, createCheckSumOnReq = null,
            requestChecksum = '', headerValue = '' ;

        ajaxobj.randomString = $KI.crypto.generateRandomString();
        if(ajaxobj._ismultipart) {
            createCheckSumOnReq = ajaxobj.randomString;
        }

        requestChecksum = $KI.net.generateRequestCheckSum(algo, salt, data, ajaxobj, createCheckSumOnReq);
        headerValue = ajaxobj.randomString + ";" + requestChecksum;
        ajaxobj.setRequestHeader(headerName, headerValue);
    },

    generateResponseCheckSumAndCheckIntegrity: function(integrityProperties, ajaxobj, response) {
        var responseChecksum = '', headers = {}, createCheckSumOnResp = null,
            integrityHeaderName = integrityProperties.headerName,
            passthroughHeaderName = integrityProperties.passthroughHeaderName,
            responseContentTypes = ["application/text", "application/json", "application/xml",
            "text/xml", "text/html", "application/rss+xml", "text/plain"];

        var _getResponseHeader = function(headerName) {
            var headerVal = '';
            if(headerName
            && (headers.hasOwnProperty(headerName) || headers.hasOwnProperty(headerName.toLowerCase()))) {
                headerVal = ajaxobj.getResponseHeader(headerName);
            }
            return headerVal;
        };

        if(integrityProperties.validateResp) {
            headers = ajaxobj.getAllResponseHeaders();
            if(_getResponseHeader(passthroughHeaderName).trim().toLowerCase() == 'true') {
                createCheckSumOnResp = ajaxobj.randomString;
            } else if(responseContentTypes.indexOf(_getResponseHeader('Content-Type').split(';')[0]) == -1) {
                createCheckSumOnResp = ajaxobj.randomString;
            }
            responseChecksum = $KI.net.generateResponseCheckSum(integrityProperties.algo, integrityProperties.salt, response, ajaxobj.randomString, createCheckSumOnResp);
            $KI.net.setIntegrityStatus(responseChecksum, _getResponseHeader(integrityHeaderName), ajaxobj);
        }
    },

    isIntegrityCheckRequired: function(url, userDisabledIntegrityCheck) {
        var returnCheckRequired = false, properties = $KI.net.integrityProperties,
            currHost = null, hyperLink = null;

        if(properties && !userDisabledIntegrityCheck) {
            if(properties.hostNamesList) {
                if(typeof document !== 'undefined') {
                    hyperLink = document.createElement('a');
                    hyperLink.href = url;
                    currHost = hyperLink.host;
                } else {
                    currHost = url.replace('http://', '').replace('https://', '').replace('wwww.','').split('/')[0];
                }
                currHost = currHost.toLowerCase();
                returnCheckRequired = $KI.net.isIntegrityCheckRequiredForThisHost(properties.hostNamesList, currHost);
            } else {
                returnCheckRequired = true;
            }
        }

        return returnCheckRequired;
    },

    isIntegrityCheckRequiredForThisHost: function(hostNamesList, currHost) {
        var i = 0, host = '', hostsLen = 0, returnCheckRequired = false;

        hostsLen = hostNamesList.length;
        if(hostsLen > 0) {
            for(i = 0; i < hostsLen; i++) {
                host = hostNamesList[i];
                if(host.startsWith('*.')) {
                    host = host.replace('*.', '').toLowerCase();
                    if(currHost.endsWith(host)) {
                        returnCheckRequired = true;
                        break;
                    }
                } else if(host == currHost) {
                    returnCheckRequired = true;
                    break;
                }
            }
        } else {
            returnCheckRequired = true;
        }

        return returnCheckRequired;
    },


    setIntegrityStatus: function(responseChecksum, checkSum, ajaxobj) {
        if(responseChecksum == checkSum) {
            kony.print("Integrity Successful");
            ajaxobj.integrityStatus = constants.HTTP_INTEGRITY_CHECK_SUCCESSFUL;
        } else {
            ajaxobj.integrityStatus = constants.HTTP_INTEGRITY_CHECK_FAILED;
        }
    },

    checkIntegrityPropertyType: function(propertyName, propertyValue, propertyType) {
        if(typeof propertyValue != propertyType) {
            throw new KonyError("100", "Error", "Invalid argument :- " + propertyName);
        }
        return true;
    },

    validateHostNamesList: function(properties) {
        var i = 0, j = 0, domain = null, domainArr = null, domainLen = 0,
            regex = /^[A-Za-z0-9\\\-]+$/;

        if(typeof properties.hostNamesList !== 'undefined' && properties.hostNamesList !== 'null') {
            if(!$KU.isArray(properties.hostNamesList)) {
                throw new KonyError('100', 'Error', 'Invalid argument :- hostNamesList');
            }
            for (i = properties.hostNamesList.length - 1; i >= 0; i--) {
                domain = properties.hostNamesList[i];
                if(typeof domain === 'undefined' || domain === null || domain.trim() === '') {
                    throw new KonyError('100', 'Error', 'Invalid argument :- hostNamesList');
                }
                if(domain.startsWith('*.')){
                    domain = domain.replace('*.', '');
                }
                domainArr = domain.split('.');
                domainLen = domainArr.length;
                if(domainLen <= 1) {
                     throw new KonyError('100', 'Error', 'Invalid argument :- hostNamesList');
                }
                for (j = domainLen - 1; j >= 0; j--) {
                    if(!regex.test(domainArr[j])) {
                        throw new KonyError('100', 'Error', 'Invalid argument :- hostNamesList');
                    }
                }
            }
        }
    },

    validateIntegrityParams: function(properties) {
        var algoList;

        if(Object.keys(properties).length > 0) {
            if(($KI.net.checkIntegrityPropertyType('validateResp', properties.validateResp, 'boolean'))
            &&($KI.net.checkIntegrityPropertyType('algo', properties.algo, 'string'))
            &&($KI.net.checkIntegrityPropertyType('salt', properties.salt, 'string'))
            &&($KI.net.checkIntegrityPropertyType('headerName', properties.headerName, 'string'))) {

                algoList = ["md5", "sha1", "sha256", "sha512"];
                if((algoList.indexOf(properties.algo.toLowerCase())) == -1) {
                    throw new KonyError("100", "Error", "Invalid argument" + properties.algo);
                }

                if(properties.salt.length > 1024) {
                    properties.salt = properties.salt.substring(0, 1024);
                }

                if(properties.headerName.length > 64) {
                    properties.headerName = properties.headerName.substring(0, 64);
                }

                if(properties.passthroughHeaderName) {
                    $KI.net.checkIntegrityPropertyType('passthroughHeaderName', properties.passthroughHeaderName, 'string');
                    if(properties.passthroughHeaderName.length > 64) {
                        properties.passthroughHeaderName = properties.passthroughHeaderName.substring(0, 64);
                    }
                }

                $KI.net.validateHostNamesList(properties);
            }

        } else {
            throw new KonyError("101", "Error", "Invalid number of arguments");
        }
        return true;
    },

    generateRequestCheckSum: function(algo, salt, requestBody, ajaxobj, passThroughOrFileMultipart) {
      var requestCheckSum, toHash,
          requestBodyHash = 'EMPTY_BODY';

      if(passThroughOrFileMultipart !== null) {
          requestBodyHash = passThroughOrFileMultipart;
      } else if(requestBody) {
          requestBodyHash = $KI.crypto.createHashToUpperCase(algo, requestBody);
      }

      toHash = "Request:" + salt + ":" + ajaxobj.randomString + ":" + requestBodyHash;
      requestCheckSum = $KI.crypto.createHashToUpperCase(algo, toHash);
      return requestCheckSum;
    },

    generateResponseCheckSum: function(algo, salt, responseBody, randomString, passThroughOrFileMultipart) {
      var responseBodyHash, responseCheckSum, toHash,
          responseBodyHash = 'EMPTY_BODY';

        if(passThroughOrFileMultipart !== null) {
            responseBodyHash = passThroughOrFileMultipart;
        } else if(responseBody) {
            responseBodyHash = $KI.crypto.createHashToUpperCase(algo, responseBody);
        }
      toHash = "Response:" + salt + ":" + randomString + ":" + responseBodyHash;
      responseCheckSum = $KI.crypto.createHashToUpperCase(algo, toHash);
      return responseCheckSum;
    },

    setIntegrityCheck: function(properties) {
        var checkIntegrityParams = $KI.net.validateIntegrityParams(properties);
        $KU.logExecuting('kony.net.setIntegrityCheck');
        if(checkIntegrityParams) {
            $KU.logExecutingWithParams('kony.net.setIntegrityCheck', properties);
            $KI.net.integrityProperties = properties;
        }
        $KU.logExecutingFinished('kony.net.setIntegrityCheck');
    },

    removeIntegrityCheck: function() {
        $KU.logExecuting('kony.net.removeIntegrityCheck');
        $KU.logExecutingWithParams('kony.net.removeIntegrityCheck');
        $KI.net.integrityProperties = null;
        $KU.logExecutingFinished('kony.net.removeIntegrityCheck');
    },

    sethttpheaders: function(ajaxobj, headers) {

        var headerdata = [],
            value, index = 0;

        for(var i in headers) {
            if(headers.hasOwnProperty(i) && headers[i]) {
                value = headers[i] ? headers[i] : "";
                headerdata.push(i);
                kony.print("sethttpheaders: key: " + i + "value: " + value);
                ajaxobj.setRequestHeader(i, value);
            }
        }
        return headerdata;
    },

    loadJSFile: function(fileurl, async, callback) {
        var status = 0;
        var timeout = 30000;
        var options = {
            type: "GET",
            url: fileurl,
            timeout: timeout,
            paramstr: null,
            callback: callback,
            info: ""
        };
        kony.print("loadJSFile: options: " + options);

        return(function ajax() {

            function invokecallback(callback) {
                if(callback) callback();
            };

            var requestDone = false; 
            var ajaxobj = new XMLHttpRequest(); 
            ajaxobj.open(options.type, options.url, async);
            ajaxobj.onLoaded = function() {
                if(this.userCancelled) {
                    kony.print(" onLoaded: on Abort Mission");
                    this.onAbort();
                }
            };

            ajaxobj.onInteractive = function() {
                if(this.userCancelled) {
                    kony.print(" onInteractive: on Abort Mission");
                    this.onAbort();
                } else
                if(!this.firstByte) {
                    this.firstByte = true;
                }
            };

            
            ajaxobj.onAbort = function(transport) {

                
                kony.print(" onInteractive: <- Abort Mission");
                if(this.userCancelled) {

                    this.userCancelled = false;
                    this.ignoreCallback = true;
                    rettable = {
                        "opstatus": 1,
                        "errcode": 1022,
                        "errmsg": "Request cancelled by user"
                    };
                    kony.print(" onInteractive: Abort Mission Success");
                }
                kony.print(" onInteractive: -> Abort Mission");
            };

            ajaxobj.onTimeout = function() {

                requestDone = true;
                rettable = {
                    "opstatus": 1,
                    "errcode": 1014,
                    "errmsg": "Request timed out"
                };
                kony.print("Request timed out.");
            };

            ajaxobj.onreadystatechange = function() {
                
                switch(!this.ignoreCallback && ajaxobj.readyState) {

                    case 1:
                        kony.print("onreadystatechange: ReadyState 1");
                        ajaxobj.onLoaded(ajaxobj);
                        break;

                    case 2:
                        kony.print("onreadystatechange: ReadyState 2");
                        ajaxobj.onInteractive(ajaxobj);
                        break;

                    case 3:
                        kony.print("onreadystatechange: ReadyState 3");
                        ajaxobj.onAbort(ajaxobj);
                        break;

                    case 4:
                        kony.print("onreadystatechange: ReadyState 4");
                        if(!requestDone) {
                            ajaxobj.onComplete(ajaxobj);
                            
                            ajaxobj = null;
                        }
                        break;

                    default:
                        kony.print("onreadystatechange: ReadyState Invalid: " + ajaxobj.readyState);
                }
            };

            ajaxobj.addResponseText = function(transport) {
                
                rettable = transport.responseText;
                
                if(typeof document != "undefined") {
                    var script = document.createElement('script');
                    script.type = "text/javascript";
                    script.text = transport.responseText;
                    document.getElementsByTagName('head')[0].appendChild(script);
                    if(options.callback) options.callback();
                    document.getElementsByTagName('head')[0].removeChild(script);
                }
            };

            ajaxobj.onComplete = function(transport) {

                
                window.clearTimeout(transport.timeoutid);
                kony.print("status: " + transport.status + "readystate: " + transport.readyState);

                this.firstByte = false;

                if(this.userCancelled) {
                    kony.print(" onComplete: on Abort Mission");
                    this.onAbort();
                    return;
                }

                if(transport.status == 200) {
                    if(transport.responseText && transport.responseText.length > 0) {
                        if(options.callback) {
                            options.callback(transport.responseText);
                        }
                    }
                    
                    else {
                        kony.print("errcode: 1013, No JS Code");
                        rettable = {
                            "opstatus": "1",
                            "errcode": "1013",
                            "errmsg": "Request returned no JS code"
                        };
                    }
                } else {
                    
                    if(transport.status == 0 || (/5+/.test(transport.status.toString()) == true)) {
                        
                        if(transport.responseText && transport.responseText.length > 0) {
                            if(options.callback) {
                                options.callback(transport.responseText);
                            }
                            return;
                        }
                        kony.print("errcode: 1012, Request Failed");
                        rettable = {
                            "opstatus": 1,
                            "errcode": "1012",
                            "errmsg": "Request Failed"
                        };
                    } else {
                        
                        if(/4+/.test(transport.status.toString()) == true) {
                            kony.print("errcode: 1012, Request Failed");
                            rettable = {
                                "opstatus": 1,
                                "errcode": "1015",
                                "errmsg": "Request Failed"
                            };
                        } else {
                            if(transport.responseText != "") {
                                kony.print("Status != 200 but response exists");
                                rettable = transport.responseText;
                            } else
                                kony.print("Empty response received.");
                        }
                    }
                }
            };

            
            ajaxobj.timeoutid = setTimeout(ajaxobj.onTimeout, options.timeout);
            ajaxobj.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
            
            if(typeof(headerobj) == "object")
                options.httpheaders = $KI.net.sethttpheaders(ajaxobj, headerobj);

            
            ajaxobj.send(options.paramstr);

            return ajaxobj;
        })();
    },

    invokeserviceasync: function(posturl, postdata, Callback, info, method, timeout) {
        var status = 0;
        var rettable = null;
        var usertimeout = timeout || 60000; 
        var origin = window.location.protocol + "//" + window.location.host;
        var proxyurl = "";
        var postorigin = "";
        var appmode = $KG["appmode"];
        var middlewarecontext = $KI.props.getProperty(null, 'appmiddlewarecontext') || ((typeof appConfig != "undefined") && appConfig && appConfig.middlewareContext) || ((typeof config != "undefined") && config && config.middlewarecontext) || "middleware";

        kony.print("invokeServiceAsync<- " + posturl);
        kony.print("middlewarecontext<- " + middlewarecontext);
        if(appmode == constants.APPLICATION_MODE_NATIVE) {

            var i = posturl.indexOf(middlewarecontext);
            if(i != -1) {
                postorigin = posturl.slice(0, i);
            }
            
            if($KG["skipproxy"] || ($KI.net.checkOriginandPostOrigin(origin, postorigin) && posturl)) {
                proxyurl = origin + "/" + middlewarecontext + "/MWServlet"; 
            } else {
                proxyurl = origin + "/" + $KG["appid"] + "/spa";
                kony.print("using proxy: URL " + proxyurl);

                if(postdata) {
                    postdata["_desturl"] = posturl;
                } else {
                    postdata = {};
                    postdata["_desturl"] = posturl;
                    kony.print("Without postdata " + posturl);
                }
            }
            postdata["rcid"] = $KG["rcid"] || "";
        }

        var headerobj = postdata && postdata["httpheaders"];
        var postdatastr = (postdata && $KI.net.postdataparams(postdata)) || "";

        kony.print("invokeServiceAsync: URL: " + posturl);
        kony.print("invokeServiceAsync: Args are: " + postdatastr);
        kony.print("middleware origin: " + postorigin);
        kony.print("location origin: " + origin);

        
        if(posturl && posturl.indexOf("/IST") != -1 || posturl.indexOf("/CMS") != -1) {
            proxyurl = posturl;
        } else if(posturl) {
            if(typeof document != "undefined") {
                var anchor = document.createElement('a');
                anchor.href = posturl;
                
                var posturlorigin = anchor.protocol + "//" + anchor.host;
                if($KI.net.checkOriginandPostOrigin(posturlorigin, origin)) {
                    proxyurl = posturl;
                }
            }
        }

        if(appmode == constants.APPLICATION_MODE_HYBRID || appmode == constants.APPLICATION_MODE_WRAPPER) {
            proxyurl = posturl;
            kony.print("!!!!!!!!!!appmode hybrid/wrapper: " + proxyurl);
        }

        var httpconfig = postdata && postdata["httpconfig"];
        if(httpconfig && httpconfig.timeout && !isNaN(httpconfig.timeout))
            usertimeout = parseInt(httpconfig.timeout) * 1000;

        var options = {
            type: "POST",
            url: proxyurl,
            timeout: usertimeout,
            paramstr: postdatastr,
            callback: Callback,
            info: info || null
        };

        if(method && typeof method != "undefined" && "GET".toLowerCase() === method.toLowerCase()) {
            options.type = "GET";
            options.url = options.url + "?" + postdatastr;
        }

        kony.print("invokeServiceAsync: options: " + options);
        kony.system.activity.increment();

        return(function ajax() {

            
            if(spaAPM !== null) {
                var timeTaken = new Date().getTime();
                var urlOrID = null;
                if(postdata["serviceID"])
                    urlOrID = postdata["serviceID"];
                else
                    urlOrID = options.url;
                spaAPM.sendMsg(urlOrID, 'servicerequest');
            }

            function invokecallback(callback, status, rettable, info) {
                
                kony.system.activity.decrement();
                if(!kony.system.activity.hasActivity()) {
                    if(typeof $KW !== "undefined") {
                        $KW.unLoadWidget();
                    }
                }
                
                if(callback) {
                    callback(status, rettable, info);
                    $KU.onEventHandler();
                }

                
                if(spaAPM !== null) {
                    if(timeTaken)
                        var ts = new Date().getTime() - timeTaken;
                    else
                        var ts = null;
                    spaAPM.sendMsg(urlOrID, 'serviceresponse', {
                        "opstatus": (rettable && rettable.opstatus) ? rettable.opstatus : null,
                        "httpcode": status ? status : null,
                        "resptime": ts
                    });
                }
            };

            var requestDone = false; 
            var ajaxobj = new XMLHttpRequest(); 
            ajaxobj.open(options.type, options.url, true);
            ajaxobj.onLoaded = function() {
                if(this.userCancelled) {
                    kony.print(" onLoaded: on Abort Mission");
                    this.onAbort();
                } else
                    invokecallback(options.callback, 100, null);
            };

            ajaxobj.onInteractive = function() {
                if(this.userCancelled) {
                    kony.print(" onInteractive: on Abort Mission");
                    this.onAbort();
                } else
                if(!this.firstByte) {
                    this.firstByte = true;
                    invokecallback(options.callback, 200, null);
                }
            };

            
            ajaxobj.onAbort = function(transport) {

                
                kony.print(" onInteractive: <- Abort Mission");
                if(this.userCancelled) {

                    this.userCancelled = false;
                    this.ignoreCallback = true;
                    rettable = {
                        "opstatus": 1,
                        "errcode": 1022,
                        "errmsg": "Request cancelled by user"
                    };
                    invokecallback(options.callback, 300, rettable);
                    kony.print(" onInteractive: Abort Mission Success");
                }
                kony.print(" onInteractive: -> Abort Mission");
            };

            ajaxobj.onTimeout = function() {
                if(ajaxobj.userCancelled) {
                    ajaxobj.onAbort();
                } else {
                    requestDone = true;
                    rettable = {
                        "opstatus": 1,
                        "errcode": 1014,
                        "errmsg": "Request timed out"
                    };
                    invokecallback(options.callback, 400, rettable);
                }
            };

            ajaxobj.onreadystatechange = function() {
                
                switch(!this.ignoreCallback && ajaxobj.readyState) {

                    case 1:
                        kony.print("onreadystatechange: ReadyState 1");
                        ajaxobj.onLoaded(ajaxobj);
                        break;

                    case 2:
                        kony.print("onreadystatechange: ReadyState 2");
                        ajaxobj.onInteractive(ajaxobj);
                        break;

                    case 3:
                        kony.print("onreadystatechange: ReadyState 3");
                        ajaxobj.onAbort(ajaxobj);
                        break;

                    case 4:
                        kony.print("onreadystatechange: ReadyState 4");
                        if(!requestDone) {
                            ajaxobj.onComplete(ajaxobj);
                            
                            ajaxobj = null; 
                        }
                        break;

                    default:
                        kony.print("onreadystatechange: ReadyState Invalid: " + ajaxobj.readyState);
                }
            };

            ajaxobj.onComplete = function(transport) {

                
                window.clearTimeout(transport.timeoutid);
                kony.print("status: " + transport.status + "readystate: " + transport.readyState + "res: " + transport.response);

                this.firstByte = false;

                if(this.userCancelled) {
                    kony.print(" onComplete: on Abort Mission");
                    this.onAbort();
                    return;
                }

                if(transport.status == 200) {
                    if(transport.responseText && transport.responseText.length > 0) {
                        
                        rettable = transport.responseText;
                        try {
                            if(IndexJL == 1)
                                rettable = $KU.convertjsontoluaobject(rettable);
                            else
                                rettable = JSON.parse(rettable);
                        } catch(error) {
                            kony.print("errcode: 1013, Invalid JSON string - Unable to parse the returned JSON from server");
                            
                            rettable = {
                                "opstatus": "1",
                                "errcode": "1013",
                                "errmsg": "Middleware returned invalid JSON string",
                                "response": rettable
                            };
                        }
                        

                    }
                    
                    else {
                        kony.print("errcode: 1013, Invalid JSON string");
                        rettable = {
                            "opstatus": "1",
                            "errcode": "1013",
                            "errmsg": "Middleware returned invalid JSON string"
                        };
                    }
                } else {
                    
                    
                    if(transport.status == 0 || transport.status == 12200 || (/5+/.test(transport.status.toString()) == true)) {
                        if(typeof navigator.onLine !== "undefined" && !navigator.onLine) {
                            kony.print("errcode: 1011, Device has no WIFI or mobile connectivity. Please try the operation after establishing connectivity.");
                            rettable = {
                                "opstatus": 1,
                                "errcode": "1011",
                                "errmsg": "Device has no WIFI or mobile connectivity. Please try the operation after establishing connectivity."
                            };
                        } else {
                            kony.print("errcode: 1012, Request Failed");
                            rettable = {
                                "opstatus": 1,
                                "errcode": "1012",
                                "errmsg": "Request Failed"
                            };
                        }
                    } else {
                        
                        if(/4+/.test(transport.status.toString()) == true) {
                            kony.print("errcode: 1015, Cannot find host");
                            rettable = {
                                "opstatus": 1,
                                "errcode": "1015",
                                "errmsg": "Cannot find host"
                            };
                        } else {
                            if(transport.responseText != "") {
                                kony.print("Status != 200 but response exists");
                                rettable = transport.responseText;
                            } else
                                kony.print("Empty response received.");
                        }
                    }
                }
                invokecallback(options.callback, 400, rettable, options.info);
            };

            
            ajaxobj.timeoutid = setTimeout(ajaxobj.onTimeout, options.timeout);
            
            if(typeof(headerobj) == "object") {
                if(options.url.indexOf("/spa") > 0) {
                    ajaxobj.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
                    var contentType = headerobj["Content-Type"];
                    if(typeof contentType != "undefined")
                        delete headerobj["Content-Type"];
                } else {
                    if(typeof headerobj["Content-Type"] == "undefined") {
                        headerobj["Content-Type"] = "application/x-www-form-urlencoded";
                    }
                }
                options.httpheaders = $KI.net.sethttpheaders(ajaxobj, headerobj);
                if(options.httpheaders.length > 0 && options.url.indexOf("/spa") > 0) {
                    if(typeof contentType != "undefined") {
                        options.httpheaders["Content-Type"] = contentType;
                    }
                    options.paramstr = options.paramstr + "kCustomHeaders=" + options.httpheaders;
                }
            }


            if("POST".toLowerCase() === (options.type).toLowerCase()) {
                
                ajaxobj.send(options.paramstr);
            } else {
                ajaxobj.send();
            }

            return ajaxobj;
        })();
        kony.print("invokeServiceAsync-> ");
    },
    
    invokeService: function(posturl, postdata, Callback, info, timeout) {
        var status = 0;
        var rettable = null;
        var usertimeout = timeout || 60000; 
        var origin = window.location.protocol + "//" + window.location.host;
        var proxyurl = "";
        var postorigin = "";
        var appmode = $KG["appmode"];
        var middlewarecontext = $KI.props.getProperty(null, 'appmiddlewarecontext') || ((typeof appConfig != "undefined") && appConfig && appConfig.middlewareContext) || ((typeof config != "undefined") && config && config.middlewarecontext) || "middleware";

        kony.print("invokeServiceAsync<- ");
        if(appmode == constants.APPLICATION_MODE_NATIVE) {

            var i = posturl.indexOf(middlewarecontext);
            if(i != -1) {
                postorigin = posturl.slice(0, i);
            }
            
            if($KG["skipproxy"] || ($KI.net.checkOriginandPostOrigin(origin, postorigin) && posturl)) {
                proxyurl = origin + "/" + middlewarecontext + "/MWServlet"; 
            } else {
                proxyurl = origin + "/" + $KG["appid"] + "/spa";
                kony.print("using proxy: URL " + proxyurl);

                if(postdata) {
                    postdata["_desturl"] = posturl;
                } else {
                    postdata = {};
                    postdata["_desturl"] = posturl;
                    kony.print("Without postdata " + posturl);
                }
            }
            postdata["rcid"] = $KG["rcid"] || "";
        }

        var headerobj = postdata && postdata["httpheaders"];
        var postdatastr = (postdata && $KI.net.postdataparams(postdata)) || "";

        
        if(posturl.indexOf("/IST") != -1 || posturl.indexOf("/CMS") != -1) {
            proxyurl = posturl;
        }

        kony.print("invokeServiceAsync: URL: " + posturl);
        kony.print("invokeServiceAsync: Args are: " + postdatastr);
        kony.print("middleware origin: " + postorigin);
        kony.print("location origin: " + origin);

        if(appmode == constants.APPLICATION_MODE_HYBRID || appmode == constants.APPLICATION_MODE_WRAPPER) {
            proxyurl = posturl;
            kony.print("!!!!!!!!!!appmode hybrid/wrapper: " + proxyurl);
        }

        var options = {
            type: "POST",
            url: proxyurl,
            timeout: usertimeout,
            paramstr: postdatastr,
            callback: Callback,
            info: info || null
        };

        kony.system.activity.increment();


        var requestDone = false; 
        var ajaxobj = new XMLHttpRequest(); 
        ajaxobj.open(options.type, options.url, false);

        if(typeof(headerobj) == "object") {
            if(options.url.indexOf("/spa") > 0) {
                ajaxobj.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
                var contentType = headerobj["Content-Type"];
                if(typeof contentType != "undefined")
                    delete headerobj["Content-Type"];
            } else {
                if(typeof headerobj["Content-Type"] == "undefined") {
                    headerobj["Content-Type"] = "application/x-www-form-urlencoded";
                }
            }
            options.httpheaders = $KI.net.sethttpheaders(ajaxobj, headerobj);
            if(options.httpheaders.length > 0 && options.url.indexOf("/spa") > 0) {
                if(typeof contentType != "undefined") {
                    options.httpheaders["Content-Type"] = contentType;
                }
                options.paramstr = options.paramstr + "kCustomHeaders=" + options.httpheaders;
            }
        }

        
        if(spaAPM !== null) {
            var timeTaken = new Date().getTime();
            var urlOrID = null;
            if(postdata["serviceID"])
                urlOrID = postdata["serviceID"];
            else
                urlOrID = options.url;
            spaAPM.sendMsg(urlOrID, 'servicerequest');
        }

        
        ajaxobj.send(options.paramstr);

        kony.print("status: " + ajaxobj.status + "readystate: " + ajaxobj.readyState + "res: " + ajaxobj.response);

        if(ajaxobj.status == 200) {
            if(ajaxobj.responseText && ajaxobj.responseText.length > 0) {
                kony.print(" onComplete: JSON obj: " + ajaxobj.responseText);
                rettable = ajaxobj.responseText;
                try {
                    if(IndexJL == 1)
                        rettable = $KU.convertjsontoluaobject(rettable);
                    else
                        rettable = JSON.parse(rettable);

                    kony.print(" onComplete: Lua obj: " + JSON.stringify(rettable));
                } catch(error) {
                    kony.print("errcode: 1013, Invalid JSON string - Unable to parse the returned JSON from server");
                    
                    rettable = {
                        "opstatus": "1",
                        "errcode": "1013",
                        "errmsg": "Middleware returned invalid JSON string",
                        "response": rettable
                    };
                }
            }
            
            else {
                kony.print("errcode: 1013, Invalid JSON string");
                rettable = {
                    "opstatus": "1",
                    "errcode": "1013",
                    "errmsg": "Middleware returned invalid JSON string"
                };
            }
        } else {
            
            if(ajaxobj.status == 0 || (/5+/.test(ajaxobj.status.toString()) == true)) {
                if(typeof navigator.onLine !== "undefined" && !navigator.onLine) {
                    kony.print("errcode: 1011, Device has no WIFI or mobile connectivity. Please try the operation after establishing connectivity.");
                    rettable = {
                        "opstatus": 1,
                        "errcode": "1011",
                        "errmsg": "Device has no WIFI or mobile connectivity. Please try the operation after establishing connectivity."
                    };
                } else {
                    kony.print("errcode: 1012, Request Failed");
                    rettable = {
                        "opstatus": 1,
                        "errcode": "1012",
                        "errmsg": "Request Failed"
                    };
                }
            } else {
                
                if(/4+/.test(ajaxobj.status.toString()) == true) {
                    kony.print("errcode: 1015, Cannot find host");
                    rettable = {
                        "opstatus": 1,
                        "errcode": "1015",
                        "errmsg": "Cannot find host"
                    };
                } else {
                    if(ajaxobj.responseText != "") {
                        kony.print("Status != 200 but response exists");
                        rettable = ajaxobj.responseText;
                    } else
                        kony.print("Empty response received.");
                }
            }
        }

        if(typeof $KW !== "undefined") {
            $KW.unLoadWidget();
        }
        
        if(spaAPM !== null) {
            if(timeTaken)
                var ts = new Date().getTime() - timeTaken;
            else
                var ts = null;
            spaAPM.sendMsg(urlOrID, 'serviceresponse', {
                "opstatus": (rettable && rettable.opstatus) ? rettable.opstatus : null,
                "httpcode": status ? status : null,
                "resptime": ts
            });
        }

        return rettable;
    },

    cancel: function(nwhndl) {
        $KU.logExecuting('kony.net.cancel');
        kony.print("networkcancel<- ");
        
        if(nwhndl) {
            
            $KU.logExecutingWithParams('kony.net.cancel', nwhndl);
            nwhndl.userCancelled = true;
            nwhndl.abort();
            $KU.logWarnMessage('Request aborted on user request');
            kony.print("Request aborted on user request");
        }
        kony.print("networkcancel-> ");
        $KU.logExecutingFinished('kony.net.cancel');
    },

    checkOriginandPostOrigin: function(origin, postorigin) {
        return origin.replace(/([^=]*):(80|443){1}(.*)/, '$1$3') == postorigin.replace(/([^=]*):(80|443){1}(.*)/, '$1$3') ? true : false;
    },

    
    isNetworkAvailable: function(connectionType) {
        $KU.logExecuting('kony.net.isNetworkAvailable');
        if(!!connectionType) {
            $KU.logExecutingWithParams('kony.net.isNetworkAvailable', connectionType);
            if(connectionType === constants.NETWORK_TYPE_ANY) {
                if(typeof navigator.onLine !== "undefined") {
                    $KU.logExecutingFinished('kony.net.isNetworkAvailable');
                    return navigator.onLine;
                } else {
                    $KU.logWarnMessage('navigator.online is undefined');
                    return false;
                }
            } else if(connectionType === constants.NETWORK_TYPE_3G ||connectionType === constants.NETWORK_TYPE_WIFI || connectionType === constants.NETWORK_TYPE_ETHERNET) {
                $KU.logWarnMessage('Invalid connectionType');
                return false;
            } else {
                $KU.logErrorMessage('Invalid Network Type or connectionType');
                throw new Error("Invalid Network Type");
            }
        } else {
            $KU.logErrorMessage('Invalid arguments');
            throw new Error("Invalid Network Type");
        }
    },

    setNetworkCallbacks: function(config) {
        $KU.logExecuting('kony.net.setNetworkCallbacks');
        if(config && config.statusChange) {
            $KU.logExecutingWithParams('kony.net.setNetworkCallbacks', config);
            if(typeof window.ononline === "object") {
                window.addEventListener("online", function() {
                    config.statusChange(navigator.onLine)
                }, false);
            }
            if(typeof window.onoffline === "object") {
                window.addEventListener("offline", function() {
                    config.statusChange(navigator.onLine)
                }, false);
            }
            $KU.logExecutingFinished('kony.net.setNetworkCallbacks');
        } else {
            $KU.logErrorMessage('Invalid argument or argument is not of valid type');
            throw new Error("Invalid Input : config is not of valid type");
        }
    },

    getActiveNetworkType: function() {
        $KU.logExecuting('kony.net.getActiveNetworkType');
        $KU.logExecutingWithParams('kony.net.getActiveNetworkType');
        $KU.logExecutingFinished('kony.net.getActiveNetworkType');
        if(typeof navigator.onLine === "undefined") {
            return constants.NETWORK_TYPE_ANY;
        } else {
            if(navigator.onLine) {
                return constants.NETWORK_TYPE_ANY;
            } else {
                $KU.logWarnMessage('problem with network status');
                return null;
            }
        }
    },

    
    getCookies: function(url) {
        $KU.logExecuting('kony.net.getCookies');
        if(url) {
            $KU.logExecutingWithParams('kony.net.getCookies', url);
            if(window && url.indexOf(window.location.origin) != -1) {
                var allCookies = document && document.cookie;
                if(allCookies && allCookies.length > 0) {
                    $KU.logExecutingFinished('kony.net.getCookies');
                    return allCookies.split(";");
                }
            }
        }
        $KU.logWarnMessage('Invalid argument');
        return null;
    },

    clearCookies: function(url, cookies) {
        $KU.logExecuting('kony.net.clearCookies');
        var allCookies = document && document.cookie.split(";");
        url = url || document.URL;
        if(window && url.indexOf(window.location.origin) != -1) {
            cookies = cookies || allCookies;
            if(cookies) {
                $KU.logExecutingWithParams('kony.net.clearCookies', url, cookies);
                var pathBits = window.location.pathname.split("/");
                for(var i = 0; i < cookies.length; i++) {
                    var pathCurrent = "/";
                    var cookieName = cookies[i].trim();
                    if(document.cookie.indexOf(cookieName) != -1)
                        for(var j = 0; j < pathBits.length; j++) {
                            pathCurrent += ((pathCurrent.substr(-1) != '/') ? '/' : '') + pathBits[j];
                            if(cookieName.indexOf('=') != -1) {
                                document.cookie = cookieName + '; expires=Thu, 01-Jan-1970 00:00:01 GMT;path=' + pathCurrent + ';';
                            } else
                                document.cookie = cookieName + '=; expires=Thu, 01-Jan-1970 00:00:01 GMT;path=' + pathCurrent + ';';
                            if(document.cookie.indexOf(cookieName) == -1)
                                break;
                        }
                }
            }
            $KU.logExecutingFinished('kony.net.clearCookies');
        } else {
            $KU.logErrorMessage('Invalid input url');
            throw new KonyError(1005, "invalid input url", "invalid input url");
        }
    },

    loadClientCertificate: function() {
        $KU.logWarnMessage('The loadClientCertificate API is not supported.');
    },

    removeClientCertificate: function() {
        $KU.logWarnMessage('The removeClientCertificate API is not supported.');
    },

    removeAllCachedResponses: function() {
        $KU.logWarnMessage('The removeAllCachedResponses API is not supported.');
    },

    urlDecode: function() {
        $KU.logWarnMessage('The urlDecode API is not supported.');
    },

    urlEncode: function() {
        $KU.logWarnMessage('The urlEncode API is not supported.');
    }
};


$KI.props = {
    getProperty: function(group, key) {
        $KU.logExecuting('kony.props.getProperty');
        $KU.logExecutingWithParams('kony.props.getProperty', group, key);
        if(typeof _konyAppProperties != "undefined" && _konyAppProperties != null && key) {
            $KU.logExecutingFinished('kony.props.getProperty');
            return _konyAppProperties[key] || null;
        }
    }
};

kony.modules = (function() {
    
    

    var module = {
        
        loadModule: function(moduleid) {
            $KU.logExecuting('kony.modules.loadFunctionalModule');
            if(typeof $KG.functionalModules[moduleid] === "undefined") {
                $KU.logErrorMessage('Invalid type functionalModules ');
                return false;
            }
            $KU.logExecutingWithParams('kony.modules.loadFunctionalModule', moduleid);
            try {
                var fm = $KG.functionalModules[moduleid];
                if(fm.loaded == 1) return true;

                fm.loaded = 1;
                if(module.preInitCheck(moduleid)) {
                    $KU.logExecutingFinished('kony.modules.loadFunctionalModule VIA if module.preInitCheck(moduleid) exists ')
                    return true;
                }
                
                if(typeof importScripts === "function") {
                    importScripts(moduleid + "_kfm.js");
                    module.moduleCallback(moduleid);
                } else {
                    var url = kony.appinit.getStaticContentPath() + $KG.platformver + "appjs/" + moduleid + "_kfm.js";
                    $KI.net.loadJSFile(url, false, function(moduleScript) {
                        try {
                            module.addScript(moduleScript);
                            module.moduleCallback(moduleid);
                        } catch(e) {
                            $KU.logErrorMessage('Unable to load module ' + moduleid + '. Error ' + e.message);
                            kony.print('Unable to load module ' + moduleid + '. Error ' + e.message);
                        }
                    });
                }

                if($KG.functionalModules[moduleid].loaded === 1) {
                    $KU.logExecutingFinished('kony.modules.loadFunctionalModule VIA if $KG.functionalModules[moduleid].loaded === 1');
                    return true;
                } else {
                    $KU.logErrorMessage('functionalModules not loaded');
                    return false;
                }
            } catch(e) {
                $KU.logErrorMessage(e.message);
                kony.print(e.message);
                return false;
            }
        },

        
        preInitCheck: function(moduleid) {
            var fm = $KG.functionalModules[moduleid];
            
            for(var i = 0; i < fm.depends.length; i++) {
                var m = fm.depends[i];
                if(typeof $KG.functionalModules[m] == "undefined") {
                    throw new Error('Invalid module : ' + m);
                }
                if(typeof $KG.functionalModules[m].loaded == "undefined") {
                    if(!module.loadModule(m)) {
                        throw new Error('Unable to load module : ' + m);
                    }
                }
            }
            return false;
        },

        
        moduleCallback: function(m) {
            var fm = $KG.functionalModules[m];
            if(typeof fm !== "undefined") {
                var init = null;
                if(typeof(fm.init) === "string") {
                    init = window[fm.init];
                    if(typeof init !== "function") {
                        fm.inProgress = false;
                        fm.loaded = undefined;
                        throw new Error('Invalid module init function : ' + m);
                    }
                }

                
                if(typeof fm.errorcode === "undefined" && init !== null) {
                    init();
                }
                fm.inProgress = false;
                fm.loaded = 1;


            }
        },

        
        loadModuleAsync: function(moduleid, callback, errorcallback) {
            $KU.logExecuting('kony.modules.loadFunctionalModuleAsync');
            $KU.logExecutingWithParams('kony.modules.loadFunctionalModuleAsync', moduleid, callback, errorcallback);
            try {
                var fm = $KG.functionalModules[moduleid];
                if(typeof fm === "undefined") {
                    $KU.logErrorMessage('Invalid type functionalModules');
                    return errorcallback(moduleid, 1250);
                }
                var loadComplete = function(e) {
                    if(typeof fm.loaded == "undefined") {
                        try {
                            module.moduleCallback(moduleid);
                        } catch(exp) {
                            
                            $KU.logErrorMessage('unknown error' + exp);
                            e = 1251;
                        }
                    }
                    if(e) {
                        errorcallback(moduleid, e);
                    } else {
                        callback(moduleid);
                    }
                };

                if(fm.loaded == 1) {
                    $KU.logExecutingFinished('kony.modules.loadFunctionalModuleAsync');
                    callback(moduleid);
                    return true;
                }
                if(fm.inProgress) {
                    
                    $KU.logWarnMessage('unable to load functionalModules or still in progress ');
                    return;
                }

                fm.inProgress = true;
                module.loadDependentModules(moduleid, callback, errorcallback);

                

                if(typeof importScripts === "function") {
                    importScripts(moduleid + "_kfm.js");
                    loadComplete();
                } else {
                    var url = kony.appinit.getStaticContentPath() + $KG.platformver + "appjs/" + moduleid + "_kfm.js";
                    $KI.net.loadJSFile(url, true, function(moduleScript) {
                        module.checkForDependents(moduleid, moduleScript, loadComplete);
                    });
                }
            } catch(e) {
                kony.web.logger('error', 'unknown error' + e);
                errorcallback(moduleid, 1251);
            }
        },

        checkForDependents: function(moduleid, moduleScript, loadComplete, counter) {
            var dependentsLoaded = true;
            var errorOnLoad = null;
            var fm = $KG.functionalModules[moduleid];
            if(typeof fm.errorcode !== "undefined") {
                errorOnLoad = fm.errorcode;
            }

            
            if(typeof counter === "undefined") {
                counter = 0;
            } else {
                if(counter > 30) {
                    loadComplete(1251);
                    return;
                } else {
                    counter++;
                }
            }

            for(var i = 0; i < fm.depends.length; i++) {
                var m = fm.depends[i];
                if(typeof $KG.functionalModules[m] !== "undefined") {
                    if(typeof $KG.functionalModules[m].loaded == "undefined") {
                        dependentsLoaded = false;
                    }
                    if(typeof $KG.functionalModules[m].errorcode !== "undefined") {
                        errorOnLoad = $KG.functionalModules[m].errorcode;
                    }
                }
            }

            
            if(dependentsLoaded && errorOnLoad === null) {
                if(moduleScript === null) {
                    loadComplete();
                } else {
                    module.addScript(moduleScript, loadComplete);
                }
            } else if(errorOnLoad !== null) {
                loadComplete(errorOnLoad);
            } else {
                setTimeout(function() {
                    module.checkForDependents(moduleid, moduleScript, loadComplete, counter);
                }, 100);
            }
        },

        loadDependentModules: function(moduleid, sc, ec) {
            var mod = $KG.functionalModules[moduleid];
            
            

            
            for(var i = 0; i < mod.depends.length; i++) {
                var m = mod.depends[i];
                if(typeof $KG.functionalModules[m] === "undefined") {
                    ec(moduleid, 1250); 
                } else if(typeof $KG.functionalModules[m].loaded == "undefined" && $KG.functionalModules[m].inProgress !== true) {
                    module.loadModuleAsync(m, module.onLoadComplete, module.onLoadComplete);
                }
            }
            return false;
        },

        onLoadComplete: function(moduleid, errorcode) {
            $KG.functionalModules[moduleid].errorcode = errorcode;
        },

        addScript: function(moduleScript, callback) {
            
            var script = document.createElement('script');
            script.type = "text/javascript";
            script.text = moduleScript;
            try {
                document.getElementsByTagName('head')[0].appendChild(script);
                if(callback) {
                    callback();
                }
            } catch(e) {
                if(callback) {
                    callback(e);
                }
            } finally {
                document.getElementsByTagName('head')[0].removeChild(script);
            }
        }
    };

    module.loadFunctionalModule = module.loadModule;

    module.loadFunctionalModuleAsync = module.loadModuleAsync;


    return module;
}());

$KI.db = {
    changeversion: function(db, oldver, newver, transcb, ecb, vcb) {
        $KU.logExecuting('kony.db.changeVersion');
        $KU.logExecutingWithParams('kony.db.changeVersion', db, oldver, newver, transcb, ecb, vcb);
        if(window.openDatabase) {
            if(db) {
                db.changeVersion(oldver, newver, transcb, ecb, vcb);
            }
        } else {
            $KU.logWarnMessage('Web Databases not supported');
            kony.print("Web Databases not supported");
        }
        $KU.logExecutingFinished('kony.db.changeVersion');
    },

    executesql: function(transid, sqlstmt, args, scb, ecb) {
        $KU.logExecuting('kony.db.executeSql');
        $KU.logExecutingWithParams('kony.db.executeSql', transid, sqlstmt, args, scb, ecb);
        if(window.openDatabase) {
            if(transid) {
                if(args && args[0] === null) {
                    args = args.slice(1);
                }
                transid.executeSql(sqlstmt, args, scb, ecb);
            }
        } else {
            $KU.logWarnMessage('Web Databases not supported');
            kony.print("Web Databases not supported");
        }
        $KU.logExecutingFinished('kony.db.executeSql');
    },

    opendatabase: function(name, version, dname, size, cb) {
        var db = this.db || null;
        cb = cb || kony_dummyForDBCallback;
        $KU.logExecuting('kony.db.openDatabase');
        $KU.logExecutingWithParams('kony.db.openDatabase', name, version, dname, size, cb);
        try {
            if(window.openDatabase) {
                if(!db) {
                    db = openDatabase(name, version, dname, size, cb);
                    this.db = db;
                }
            } else {
                $KU.logWarnMessage('Web Databases not supported');
                kony.print("Web Databases not supported");
            }
        } catch(e) {
            if(e == 2) {
                
                $KU.logErrorMessage('opendatabase:Invalid database version.');
                kony.print("opendatabase:Invalid database version.");
            } else {
                $KU.logErrorMessage('opendatabase:Unknown error ' + e + '.');
                kony.print("opendatabase:Unknown error " + e + ".");
            }
            $KU.logErrorMessage('Invalid database version or Unknown error');
            return null;
        }
        $KU.logExecutingFinished('kony.db.openDatabase');
        return db;
    },

    readtransaction: function(db, transcb, ecb, vcb) {
        $KU.logExecuting('kony.db.readTransaction');
        $KU.logExecutingWithParams('kony.db.readTransaction', db, transcb, ecb, vcb);
        if(window.openDatabase) {
            if(db) {
                db.readTransaction(transcb, ecb, vcb);
            }
        } else {
            $KU.logWarnMessage('Web Databases not supported');
            kony.print("Web Databases not supported");
        }
        $KU.logExecutingFinished('kony.db.readTransaction');
    },

    sqlresultsetrowitem: function(transid, sqlresultset, index) {
        $KU.logExecuting('kony.db.sqlResultsetRowItem');
        $KU.logExecutingWithParams('kony.db.sqlResultsetRowItem', transid, sqlresultset, index);
        if(window.openDatabase) {
            
            if(index < sqlresultset.rows.length) {
                $KU.logExecutingFinished('kony.db.sqlResultsetRowItem VIA if index < sqlresultset.rows.length');
                return sqlresultset.rows.item(index);
            } else {
                $KU.logErrorMessage('Index position exceeds row length');
                return null;
            }
        } else {
            $KU.logWarnMessage('Web Databases not supported');
            kony.print("Web Databases not supported");
        }
        $KU.logExecutingFinished('kony.db.sqlResultsetRowItem VIA end of the function');
    },

    transaction: function(db, transcb, ecb, vcb) {
        $KU.logExecuting('kony.db.transaction');

        if(window.openDatabase) {
            if(db) {
                $KU.logExecutingWithParams('kony.db.transaction', db, transcb, ecb, vcb);
                db.transaction(transcb, ecb, vcb);
            }
        } else {
            $KU.logWarnMessage('Web Databases not supported');
            kony.print("Web Databases not supported");
        }
        $KU.logExecutingFinished('kony.db.transaction');
    }
};

function kony_dummyForDBCallback() {}

$KI.ds = (function() {
    var module = null;

    var _clear = function() {
        localStorage.clear(); 
        localStorage.setItem(kony.globals.appid, JSON.stringify($KU.createBlankLocalStorage()));
    };

    var _getItem = function(key) {
        var store = $KU.getLocalStorage(),
            data = store.data,
            i = 0,
            item = null,
            len = data.length;

        for(i = 0; i < len; i++) {
            if(data[i].key === key) {
                item = data[i].value;
                break;
            }
        }

        return item;
    };

    var _getKeyAt = function(index) {
        var store = $KU.getLocalStorage(),
            data = store.data[index];
        return(data) ? data.key : null;
    };

    var _getLength = function() {
        var store = $KU.getLocalStorage();
        return store.data.length;
    };

    var _getValueAt = function(index) {
        var store = $KU.getLocalStorage(),
            data = store.data[index];
        return(data) ? data.value : null;
    };

    var _removeItem = function(key) {
        var store = $KU.getLocalStorage(),
            data = store.data,
            i = 0,
            index = -1,
            len = data.length;

        for(i = 0; i < len; i++) {
            if(data[i].key === key) {
                index = i;
                break;
            }
        }
        
        if(index >= 0) {
            store.data.splice(index, 1);
            localStorage.setItem(kony.globals.appid, JSON.stringify(store));
        }
    };

    var _setItem = function(key, value) {
        var store = $KU.getLocalStorage(),
            data = store.data,
            i = 0,
            index = -1,
            len = data.length;

        for(i = 0; i < len; i++) {
            if(data[i].key === key) {
                index = i;
                break;
            }
        }

        if(index === -1) { 
            store.data.push({
                key: key,
                value: value
            });
        } else { 
            store.data[index].value = value;
        }

        localStorage.setItem(kony.globals.appid, JSON.stringify(store));
    };

    try {
        if(typeof(localStorage) === "object") {
            module = {
                save: function(tbl, dbname, metainfo) {
                    $KU.logExecuting('kony.ds.save');
                    if(localStorage) {
                        try {
                            $KU.logExecutingWithParams('kony.ds.save', tbl, dbname, metainfo);
                            _setItem(dbname, tbl);
                        } catch(e) {
                            if(e.name == "QUOTA_EXCEEDED_ERR") {
                                var errcode = 0,
                                    errmsg = "";

                                if(localStorage.length === 0) {
                                    $KU.logErrorMessage('Private Browsing is switched ON');
                                    errcode = 707;
                                    errmsg = "Private Browsing is switched ON";
                                } else {
                                    $KU.logErrorMessage('Data storage limit has exceeded');
                                    errcode = 708;
                                    errmsg = "Data storage limit has exceeded";
                                }
                                return {
                                    "errcode": errcode,
                                    "errmsg": errmsg
                                };
                            }
                        }
                    } else {
                        $KU.logWarnMessage('localstorage is not supported');
                        kony.print("localStorage not supported");
                    }
                    $KU.logExecutingFinished('kony.ds.save');
                },

                read: function(dbname) {
                    $KU.logExecuting('kony.ds.read');
                    $KU.logExecutingWithParams('kony.ds.read', dbname);
                    if(localStorage) {
                        $KU.logExecutingFinished('kony.ds.read');
                        return _getItem(dbname);
                    } else {
                        $KU.logWarnMessage('localStorage readitem failed');
                        kony.print("localStorage readitem failed");
                        return null;
                    }
                },

                Delete: function(dbname) {
                    if(localStorage) {
                        _removeItem(dbname);
                        return true;
                    } else {
                        kony.print("localStorage delete failed");
                        return false;
                    }
                }
            };

            $KI.localstorage = {
                key: function(index) {
                    $KU.logExecuting('kony.store.key');
                    $KU.logExecutingWithParams('kony.store.key', index);
                    $KU.logExecutingFinished('kony.store.key');
                    return _getKeyAt(index);
                },

                getitem: function(keyname) {
                    $KU.logExecuting('kony.store.getItem');
                    $KU.logExecutingWithParams('kony.store.getItem', keyname);
                    $KU.logExecutingFinished('kony.store.getItem');
                    return _getItem(keyname);
                },

                setitem: function(keyname, value) {
                    $KU.logExecuting('kony.store.setitem');
                    $KU.logExecutingWithParams('kony.store.setitem', keyname, value);
                    try {
                        _setItem(keyname, value);
                    } catch(e) {
                        if(e.name == "QUOTA_EXCEEDED_ERR") {
                            if(localStorage.length === 0) {
                                kony.web.logger("warn", "Private Browsing is switched ON");
                            } else {
                                kony.web.logger("warn", "Data storage limit has exceeded");
                            }
                        }
                    }
                    $KU.logExecutingFinished('kony.store.setitem');
                },

                removeitem: function(keyname) {
                    $KU.logExecuting('kony.store.removeitem');
                    $KU.logExecutingWithParams('kony.store.removeitem', keyname);
                    $KU.logExecutingFinished('kony.store.removeitem');
                    _removeItem(keyname);
                },

                clear: function() {
                    _clear();
                },

                length: function() {
                    $KU.logExecuting('kony.store.length');
                    $KU.logExecutingWithParams('kony.store.length');
                    $KU.logExecutingFinished('kony.store.length');
                    return _getLength();
                }
            };
        } else {
            kony.print("localStorage not supported");
        }
    } catch(e) {
        module = {
            save: function() {},
            read: function(dbname) {},
            Delete: function(dbname) {}
        };
    }


    return module;
}());


$KW.Scroller = (function() {
    
    

    var module = {
        initializeFormScroller: function(formId) {
            var scrollerNodes = document.querySelectorAll("#" + formId + "[kwidgettype='KFormScroller'] ,#" + formId + " div[kwidgettype='KFormScroller']");
            scrollerNodes && this.initialize(scrollerNodes, "Form");
        },

        initializeScrollBoxes: function(formId) {
            var scrollerNodes = document.querySelectorAll("#" + formId + " div[kwidgettype='KScrollBox']");
            scrollerNodes && this.initialize(scrollerNodes, "ScrollBox");
        },

        initializeFlexScrollContainers: function(formId) {
            var scrollerNodes = document.querySelectorAll("#" + formId + " div[kwidgettype='KFlexScrollContainer']");
            scrollerNodes && this.initialize(scrollerNodes, "FlexScrollContainer");
        },

        initializeCollectionViewContainers: function(formId) {
            var scrollerNodes = document.querySelectorAll("#" + formId + " div[kwidgettype='KCollectionView']");
            scrollerNodes && this.initialize(scrollerNodes, "CollectionView");
        },

        initialize: function(scrollerNodes, type) {
            var _setOnScrollStart = function(widgetModel, options) {
                options.onScrollStart = function() {
                    var options = this.options;
                    options.widgetModel.contentoffset = {
                        x: -this.x,
                        y: -this.y
                    };
                    options.widgetModel.onscrollstart && $KU.executeWidgetEventHandler(options.widgetModel, options.widgetModel.onscrollstart);
                };
            };
            var _setOnScrolling = function(widgetModel, options) {
                options.onScrollMove = function() {
                    var options = this.options;
                    options.widgetModel.contentoffset = {
                        x: -this.x,
                        y: -this.y
                    };
                    options.widgetModel.onscrolling && $KU.executeWidgetEventHandler(options.widgetModel, options.widgetModel.onscrolling);
                };
            };
            var _setOnScrollTouchReleased = function(widgetModel, options) {
                options.onScrollTouchReleased = function() {
                    var options = this.options;
                    options.widgetModel.contentoffset = {
                        x: -this.x,
                        y: -this.y
                    };
                    options.widgetModel.onscrolltouchreleased && $KU.executeWidgetEventHandler(options.widgetModel, options.widgetModel.onscrolltouchreleased);
                };
            };
            var _setonScrollEnd = function(widgetModel, options) {
                options.onScrollEnd = function() {
                    var options = this.options;
                    options.widgetModel.contentoffset = {
                        x: -this.x,
                        y: -this.y
                    };
                    options.widgetModel.onscrollend && $KU.executeWidgetEventHandler(options.widgetModel, options.widgetModel.onscrollend);
                };
            };

            if($KG["stickyScroll"]) {
                var scrollerInstance = new $KW.touch.StickyScroller();
                $KG[$KG["__currentForm"] + '_scroller'] = scrollerInstance;
                return;
            } else if($KG["nativeScroll"] && type == "Form") {
                var forms = document.forms;
                var curForm = forms[0];
                if(forms.length == 2)
                    curForm = forms[1]; 
                
                var formModel = $KG.allforms[curForm.id];
                if(formModel && $KW.FlexUtils.isFlexContainer(formModel)) {
                    this.initializeNativeScroller(formModel, curForm);
                }
                return;
            }


            for(var i = 0; i < scrollerNodes.length; i++) {
                var _scrollerId = scrollerNodes[i].id;
                var scrollerId = _scrollerId.substring(0, _scrollerId.lastIndexOf("_"));

                
                var _scrollerDOMNode = scrollerNodes[i];
                var scrollerDOMNode = document.getElementById(scrollerId);
                var widgetType = _scrollerDOMNode.getAttribute("widgetType");
                var swipeDirection = _scrollerDOMNode.getAttribute("swipeDirection");

                var widgetModel;
                if(type == 'Form')
                    widgetModel = $KG.allforms[scrollerId];
                else
                    widgetModel = $KU.getModelByNode(scrollerDOMNode);

                var formModel;
                widgetModel.pf && (formModel = $KG.allforms[widgetModel.pf]);

                var options = {};
                options.checkDOMChanges = true;
                options.widgetModel = widgetModel;

                if(type == 'Form' && $KW.FlexUtils.isFlexContainer(widgetModel))
                    swipeDirection = "vertical";

                if(swipeDirection == "vertical") {
                    options.vScroll = true;
                    options.scrollbox = true;
                } else if(swipeDirection == "horizontal") {
                    options.hScroll = true;
                    options.scrollbox = true;
                } else if(swipeDirection == "both") 
                {
                    options.vScroll = true;
                    options.hScroll = true;
                    options.scrollbox = true;
                } else if(type !== "FlexScrollContainer") {
                    
                    options.vScroll = true;
                    options.hScroll = true;
                    options.scrollbox = true;
                }

                if(widgetModel.wType == 'Segment') {
                    var listAnimation = widgetModel.listAnimation;
                    if(listAnimation && !listAnimation.initialized) {
                        listAnimation.init();
                    }
                }

                if(type == 'Form')
                    options.scrollbox = false;

                if(type == "FlexScrollContainer" || (type == 'Form' && $KW.FlexUtils.isFlexContainer(widgetModel))) {
                    if($KG["nativeScroll"]) {
                        this.initializeNativeScroller(widgetModel, _scrollerDOMNode.childNodes[0].childNodes[0]);
                        continue;
                    }
                    (type == 'Form') && module.setHeight(scrollerId);
                    
                    options.formid = widgetModel.pf;

                    options.vBounce = widgetModel.allowverticalbounce;
                    options.hBounce = widgetModel.allowhorizontalbounce;
                    options.bounce = widgetModel.bounces;

                    
                    options.disableUserScroll = !widgetModel.enablescrolling;
                    
                    options.hideScrollbar = true;

                    if(swipeDirection == "horizontal")
                        options.hScrollbar = widgetModel.horizontalscrollindicator;
                    else if(swipeDirection == "vertical")
                        options.vScrollbar = widgetModel.verticalscrollindicator;
                    else if(swipeDirection == "both") {
                        options.hScrollbar = widgetModel.horizontalscrollindicator;
                        options.vScrollbar = widgetModel.verticalscrollindicator;
                    } else {
                        options.hScrollbar = false;
                        options.vScrollbar = false;
                    }

                    
                    if(widgetModel.scrollingevents) {
                        _setOnScrollStart(widgetModel, options);
                        _setOnScrollTouchReleased(widgetModel, options);
                        module.initializeFlexScrollEvents(widgetModel, options);
                    } else {
                        
                        _setOnScrollStart(widgetModel, options);
                        _setOnScrolling(widgetModel, options);
                        _setOnScrollTouchReleased(widgetModel, options);
                        _setonScrollEnd(widgetModel, options);
                    }

                } else if(widgetType == "form") {
                    module.setHeight(scrollerId);
                    options.vScrollbar = true;
                    options.formid = scrollerId;
                    options.scrollbox = false;
                    options.bounce = (widgetModel.scrollbounce != undefined) ? widgetModel.scrollbounce : true;
                } else 
                {
                    var widgetModel = $KU.getModelByNode(scrollerDOMNode);

                    
                    if($KG["nativeScroll"] && widgetModel) {
                        var overflowX, overflowY;
                        switch(widgetModel.scrollDirection) {
                            case 1:
                                overflowX = "auto";
                                overflowY = "hidden";
                                break;
                            case 2:
                                overflowX = "hidden";
                                overflowY = "auto";
                                break;
                            case 3:
                                overflowX = "auto";
                                overflowY = "auto";
                                break;
                            case 4:
                                overflowX = "hidden";
                                overflowY = "hidden";
                            default:
                                overflowX = "";
                                overflowY = "";
                        }
                        var scrollerStyle = _scrollerDOMNode.style;
                        scrollerStyle.overflowX = overflowX;
                        scrollerStyle.overflowY = overflowY;


                        this.initializeNativeScroller(widgetModel, _scrollerDOMNode);
                        continue;
                    }

                    options.scrollbox = true;
                    options.formid = widgetModel.pf;
                    options.bounce = widgetModel.scrollbounce != undefined ? widgetModel.scrollbounce : true;
                    options.disableUserScroll = (widgetModel.scrolldirection == constants.SCROLLBOX_SCROLL_NONE);
                    

                    if(widgetModel.scrollbar == "arrows") {
                        options.showImages = true;
                        options.widgetID = widgetModel.id;
                    } else if(widgetModel.scrollbar == "scrollbar") {
                        if(widgetModel.autohidescrollbar === false)
                            options.hideScrollbar = false;
                        if(swipeDirection == "horizontal")
                            options.hScrollbar = true;
                        else if(swipeDirection == "vertical")
                            options.vScrollbar = true;
                        else if(swipeDirection == "both") {
                            options.hScrollbar = true;
                            options.vScrollbar = true;
                        }
                    }

                    if(widgetModel.wType === "Segment" && widgetModel.showScrollbars) {
                        options.vScrollbar = true;
                    }

                    if(type == 'CollectionView' && widgetModel.showScrollbars) {
                        if(swipeDirection == "horizontal")
                            options.hScrollbar = true;
                        else if(swipeDirection == "vertical")
                            options.vScrollbar = true;
                        else if(swipeDirection == "both") {
                            options.hScrollbar = true;
                            options.vScrollbar = true;
                        }
                    }

                    
                    var scrollingEvents = widgetModel.scrollingevents;
                    if(scrollingEvents) {
                        var pullDownEl, pullUpEl, pullInitFlag, pushInitFlag;
                        var pullDownOffset = 0,
                            pullUpOffset = 0;
                        var onRefresh = "",
                            onScrollStart = "",
                            onScrollMove = "",
                            onScrollEnd = "";
                        var pullDownId = "#" + $KW.Utils.getKMasterWidgetID(widgetModel) + "_pullDown";
                        var pullUpId = "#" + $KW.Utils.getKMasterWidgetID(widgetModel) + "_pullUp";

                        pullDownEl = document.querySelector(pullDownId);
                        pullUpEl = document.querySelector(pullUpId);
                        if(widgetModel.wType == 'CollectionView' && widgetModel.layouttype == kony.collectionview.LAYOUT_VERTICAL) {
                            pullDownEl && (pullDownOffset = pullDownEl.offsetWidth);
                            pullUpEl && (pullUpOffset = pullUpEl.offsetWidth);
                        } else {
                            pullDownEl && (pullDownOffset = pullDownEl.offsetHeight);
                            pullUpEl && (pullUpOffset = pullUpEl.offsetHeight);
                        }

                        !scrollingEvents.onpull && (pullInitFlag = true);
                        !scrollingEvents.onpush && (pushInitFlag = true);

                        onRefresh = function() {
                            var pullDownEl = this.options.pullDownEl;
                            var pullUpEl = this.options.pullUpEl;
                            var widgetModel = this.options.widgetModel;
                            if(pullDownEl && pullDownEl.className.match('loading')) {
                                pullDownEl.className = '';
                                if(widgetModel.wType == 'CollectionView') {
                                    pullDownEl.children[0] && $KU.removeClassName(pullDownEl.children[0], 'hide');
                                    pullDownEl.children[1] && $KU.addClassName(pullDownEl.children[1], 'hide');
                                } else {
                                    pullDownEl.querySelector(".pullDownLabel").innerHTML = "Pull down to refresh..";
                                }
                            } else if(pullUpEl && pullUpEl.className.match('loading')) {
                                pullUpEl.className = '';
                                if(widgetModel.wType == 'CollectionView') {
                                    pullUpEl.children[0] && $KU.removeClassName(pullUpEl.children[0], 'hide');
                                    pullUpEl.children[1] && $KU.addClassName(pullUpEl.children[1], 'hide');
                                } else {
                                    pullUpEl.querySelector(".pullUpLabel").innerHTML = "Pull up to refresh..";
                                }
                            }
                        };
                        onScrollStart = function() {
                            this.options.widgetModel.wType == 'Segment' && $KW.Segment.handleLazyLoadingOnScrollStart(this.options.widgetModel);
                        }
                        onScrollMove = function() {
                            var pullDownEl = this.options.pullDownEl;
                            var pullUpEl = this.options.pullUpEl;
                            var widgetModel = this.options.widgetModel;
                            if(widgetModel.wType == 'Segment') {
                                $KW.Segment.updateScrollTopOnScroll(widgetModel);
                                $KW.Segment.handleLazyLoadingOnScrollMove(widgetModel);
                            }
                            if(pullDownEl) {
                                if(((this.options.vScroll && this.y > 5) || (this.options.hScroll && this.x > 5)) && !pullDownEl.className.match('flip')) {
                                    pullDownEl.className = 'flip';
                                    pullInitFlag = false;
                                    if(widgetModel.wType == 'CollectionView') {
                                        pullDownEl.children[1] && $KU.removeClassName(pullDownEl.children[1], 'hide');
                                        pullDownEl.children[0] && $KU.addClassName(pullDownEl.children[0], 'hide');
                                    } else {
                                        pullDownEl.querySelector(".pullDownLabel").innerHTML = "Release to refresh..";
                                    }
                                    if(this.options.vScroll)
                                        this.minScrollY = 0;
                                    else
                                        this.minScrollX = 0;
                                } else if(((this.options.vScroll && this.y < 5) || (this.options.hScroll && this.x < 5)) && pullDownEl.className.match('flip')) {
                                    if(this.options.vScroll)
                                        this.minScrollY = -this.pullDownOffset;
                                    else
                                        this.minScrollX = -this.pullDownOffset;
                                }
                            }
                            if(pullUpEl) {
                                if(((this.options.vScroll && this.y < (this.maxScrollY - 5 - this.pullUpOffset)) || (this.options.hScroll && this.x < (this.maxScrollX - 5 - this.pullUpOffset))) && !pullUpEl.className.match('flip')) {
                                    pullUpEl.className = 'flip';
                                    pushInitFlag = false;
                                    if(widgetModel.wType == 'CollectionView') {
                                        pullUpEl.children[1] && $KU.removeClassName(pullUpEl.children[1], 'hide');
                                        pullUpEl.children[0] && $KU.addClassName(pullUpEl.children[0], 'hide');
                                    } else {
                                        pullUpEl.querySelector(".pullUpLabel").innerHTML = "Release to refresh..";
                                    }
                                    if(this.options.vScroll)
                                        this.maxScrollY -= this.pullUpOffset;
                                    else
                                        this.maxScrollX -= this.pullUpOffset;
                                } else if(((this.options.vScroll && this.y > (this.maxScrollY + 5)) || (this.options.hScroll && this.x > (this.maxScrollX + 5))) && pullUpEl.className.match('flip')) {
                                    this.maxScrollY = this.maxScrollY  ;
                                }
                            }
                            if(this.options.widgetModel.wType == 'CollectionView') {
                                var model = $KU.getModelByScroller(this.wrapper.id);
                                var handler = model && $KU.returnEventReference(model.onscrolling);
                                handler && $KU.executeWidgetEventHandler(model, handler);
                                $KW.CollectionView.Animation.handleOnItemDisplay(model);
                            }
                        };
                        onScrollEnd = function() {
                            var pullDownEl = this.options.pullDownEl;
                            var pullUpEl = this.options.pullUpEl;
                            var reachingbeginningoffset = 0;
                            var reachingendoffset = 0;
                            var widgetModel = this.options.widgetModel;
                            if(widgetModel.wType == 'Segment') {
                                $KW.Segment.updateScrollTopOnScroll(widgetModel);
                                $KW.Segment.handleLazyLoadingOnScrollEnd(widgetModel);
                            }
                            if(this.options.widgetModel.wType == 'CollectionView') {
                                var wModel = this.options.widgetModel;
                                if(wModel.layouttype != kony.collectionview.LAYOUT_CUSTOM) {
                                    reachingbeginningoffset = wModel.reachingbeginningoffsetinPX;
                                    reachingendoffset = wModel.reachingendoffsetinPX;
                                } else {
                                    if(this.direction == $KW.touch.TouchContext.UP || this.direction == $KW.touch.TouchContext.DOWN) {
                                        reachingbeginningoffset = wModel.reachingbeginningoffsetV;
                                        reachingendoffset = wModel.reachingendoffsetV;
                                    } else { 
                                        reachingbeginningoffset = wModel.reachingbeginningoffsetH;
                                        reachingendoffset = wModel.reachingendoffsetH;
                                    }

                                }
                            }
                            if(((this.options.vScroll && this.y >= this.minScrollY - reachingbeginningoffset) ||
                                    (this.options.hScroll && this.x >= this.minScrollX - reachingbeginningoffset)) && this.options.pullInitFlag) {
                                var model = $KU.getModelByScroller(this.wrapper.id);
                                if(typeof model === "undefined")
                                    return;
                                
                                if(this.scrollerH > 0) {
                                    kony.web.logger("log", "On Reach beginning");
                                    
                                    var handler = $KU.returnEventReference(model.scrollingevents.onreachingbeginning);
                                    if(model.wType == 'CollectionView') {
                                        if(!this.options.onreachingbeginningVFired || !this.options.onreachingbeginningHFired) {
                                            var scrollDirection = kony.collectionview.SCROLL_DIRECTION_HORIZONTAL;
                                            if(this.direction == $KW.touch.TouchContext.UP || this.direction == $KW.touch.TouchContext.DOWN) {
                                                scrollDirection = kony.collectionview.SCROLL_DIRECTION_VERTICAL;
                                                if(!this.options.onreachingbeginningVFired) {
                                                    if(this.options.vScroll && this.y >= this.minScrollY - reachingbeginningoffset) {
                                                        handler && $KU.executeWidgetEventHandler(model, handler, scrollDirection, model.contentOffsetMeasured);
                                                        this.options.onreachingbeginningVFired = true;
                                                    }
                                                }
                                            } else {
                                                if(!this.options.onreachingbeginningHFired) {
                                                    if(this.options.hScroll && this.x >= this.minScrollX - reachingbeginningoffset) {
                                                        handler && $KU.executeWidgetEventHandler(model, handler, scrollDirection, model.contentOffsetMeasured);
                                                        this.options.onreachingbeginningHFired = true;
                                                    }
                                                }
                                            }
                                        }
                                    } else {
                                        handler && $KU.executeWidgetEventHandler(model, handler);
                                    }
                                }
                            }
                            if((this.options.vScroll && this.y < this.minScrollY - reachingbeginningoffset) ||
                                (this.options.hScroll && this.x < this.minScrollX - reachingbeginningoffset)) {
                                if(this.direction == $KW.touch.TouchContext.UP || this.direction == $KW.touch.TouchContext.DOWN)
                                    this.options.onreachingbeginningVFired = false;
                                else
                                    this.options.onreachingbeginningHFired = false;
                            }
                            if(pullDownEl && pullDownEl.className.match('flip')) {
                                pullDownEl.className = 'loading';
                                if(widgetModel.wType == 'CollectionView') {
                                    
                                } else {
                                    pullDownEl.querySelector(".pullDownLabel").innerHTML = 'Loading..';
                                }
                                module.pullAction.call(this, "DOWN"); 
                            }

                            if(((this.options.vScroll && this.y <= this.maxScrollY + reachingendoffset) ||
                                    (this.options.hScroll && this.x <= this.maxScrollX + reachingendoffset)) && this.options.pushInitFlag) {
                                var model = $KU.getModelByScroller(this.wrapper.id);
                                if(typeof model === "undefined")
                                    return;
                                
                                if((this.options.vScroll && Math.abs(this.y) >= 20) || (this.options.hScroll && Math.abs(this.x) >= 20)) {
                                    kony.web.logger("log", "On Reach end");
                                    
                                    var handler = $KU.returnEventReference(model.scrollingevents.onreachingend);
                                    if(model.wType == 'CollectionView') {
                                        if(!this.options.onreachingendVFired || !this.options.onreachingendHFired) {
                                            var scrollDirection = kony.collectionview.SCROLL_DIRECTION_HORIZONTAL;
                                            if(this.direction == $KW.touch.TouchContext.UP || this.direction == $KW.touch.TouchContext.DOWN) {
                                                scrollDirection = kony.collectionview.SCROLL_DIRECTION_VERTICAL;
                                                if(!this.options.onreachingendVFired) {
                                                    if(this.options.vScroll && this.y <= this.maxScrollY + reachingendoffset) {
                                                        handler && $KU.executeWidgetEventHandler(model, handler, scrollDirection, model.contentOffsetMeasured);
                                                        this.options.onreachingendVFired = true;
                                                    }
                                                }
                                            } else {
                                                if(!this.options.onreachingendHFired) {
                                                    if(this.options.hScroll && this.x <= this.maxScrollX + reachingendoffset) {
                                                        handler && $KU.executeWidgetEventHandler(model, handler, scrollDirection, model.contentOffsetMeasured);
                                                        this.options.onreachingendHFired = true;
                                                    }
                                                }
                                            }
                                        }
                                    } else {
                                        handler && $KU.executeWidgetEventHandler(model, handler);
                                    }
                                }
                            }
                            if((this.options.vScroll && this.y > this.maxScrollY + reachingendoffset) ||
                                (this.options.hScroll && this.x > this.maxScrollX + reachingendoffset)) {
                                if(this.direction == $KW.touch.TouchContext.UP || this.direction == $KW.touch.TouchContext.DOWN)
                                    this.options.onreachingendVFired = false;
                                else
                                    this.options.onreachingendHFired = false;
                            }
                            if(pullUpEl && pullUpEl.className.match('flip')) {
                                pullUpEl.className = 'loading';
                                if(widgetModel.wType == 'CollectionView') {
                                    
                                } else {
                                    pullUpEl.querySelector(".pullUpLabel").innerHTML = 'Loading..';
                                }
                                module.pullAction.call(this, "UP"); 
                            }

                            
                            if(!this.options.pullInitFlag)
                                this.options.pullInitFlag = true;
                            if(!this.options.pushInitFlag)
                                this.options.pushInitFlag = true;
                            if(this.options.widgetModel.wType == 'CollectionView') {
                                var model = $KU.getModelByScroller(this.wrapper.id);
                                var handler = model && $KU.returnEventReference(model.onscrollend);
                                handler && $KU.executeWidgetEventHandler(model, handler);
                            }

                        };
                        if(widgetModel.wType == 'CollectionView') {
                            _setOnScrollTouchReleased(widgetModel, options);
                            _setOnScrollStart(widgetModel, options);
                        } else if(widgetModel.wType == 'Segment') {
                            options.onScrollStart = onScrollStart;
                        }
                        
                        $KU.extend(options, {
                            topOffset: pullDownOffset,
                            bottomOffset: pullUpOffset,
                            onRefresh: onRefresh,
                            onScrollMove: onScrollMove,
                            onScrollEnd: onScrollEnd,
                            pullDownEl: pullDownEl,
                            pullUpEl: pullUpEl,
                            pullInitFlag: pullInitFlag,
                            pushInitFlag: pushInitFlag
                        });
                    }
                }

                
                if(formModel && typeof(formModel.useTransform) == 'boolean')
                    options.useTransform = formModel.useTransform;

                var selects = document.querySelectorAll("#" + $KG["__currentForm"].id + " select");
                if(selects.length > 0 && widgetType == "form") {
                    
                    options.useTransform = false;
                }

                if((type == "ScrollBox" && $KW.FlexUtils.isFlexContainer(formModel)) || $KW.FlexUtils.isFlexContainer(formModel) || (type == "FlexScrollContainer" && (widgetModel.parent.wType === "FlexScrollContainer" || widgetModel.parent.wType == "FlexContainer"))) {
                    options.bubbleEvents = true;
                }

                
                var scrollerInstance = new $KW.touch.konyScroller(_scrollerDOMNode, options);


                if(widgetType == "form") {
                    var headerId = $KG.allforms[scrollerId].header;
                    var footerId = $KG.allforms[scrollerId].footer;

                    
                    $KG.allforms[scrollerId].scrollerTimer = setInterval(function(sID) {
                        return function() {
                            module.checkDOMChanges(sID + "_scroller", headerId, footerId);
                        };
                    }(scrollerId), 1000);

                }

                if(swipeDirection == "horizontal" || swipeDirection == "both") {
                    if(_scrollerDOMNode.children[0].scrollWidth != 0) {
                        _scrollerDOMNode.children[0].style.width = _scrollerDOMNode.children[0].scrollWidth + "px";
                        scrollerInstance.refresh();
                    }
                }
                if(type == 'CollectionView' && (swipeDirection == "vertical" || swipeDirection == "both") && scrollHeight != 0) {
                    if(_scrollerDOMNode.children[0].scrollHeight != 0) {
                        _scrollerDOMNode.children[0].style.height = _scrollerDOMNode.children[0].scrollHeight + "px";
                        scrollerInstance.refresh();
                    }
                }

                if(type == "FlexScrollContainer" || (type == 'Form' && $KW.FlexUtils.isFlexContainer(widgetModel))) {
                    var scrollHeight;
                    if(type == 'Form') {
                        $KW.Form.setFormDimensions(widgetModel);
                        var formNode = document.getElementById(widgetModel.id);
                        scrollHeight = formNode.scrollHeight;
                    } else {
                        var contentNode, pushNode;
                        var sEvents = widgetModel.scrollingevents;
                        var scrolldirection = $KW.stringifyScrolldirection[widgetModel.scrolldirection];
                        contentNode = _scrollerDOMNode.children[0].children[0];
                        if(sEvents) {
                            if(sEvents.onpull) {
                                contentNode = _scrollerDOMNode.children[0].children[1];
                            }
                            if(sEvents.onpull && sEvents.onpush) {
                                pushNode = _scrollerDOMNode.children[0].children[2]
                            }
                            else if(sEvents.onpush) {
                              pushNode = _scrollerDOMNode.children[0].children[1];
                            }
                        }

                        scrollHeight = contentNode.scrollHeight;
                        
                        if(options.hScroll == true) {
                            contentNode.style.width = _scrollerDOMNode.clientWidth + "px";
                        }
                        contentNode.style.height = _scrollerDOMNode.clientHeight + "px";
                        contentNode.style.flexShrink = 0;
                        if(pushNode) {
                            if(scrolldirection == "vertical") {
                                pushNode.style.marginTop = contentNode.scrollHeight -contentNode.offsetHeight + "px"
                            }
                            else {
                                pushNode.style.marginLeft = contentNode.scrollWidth - contentNode.offsetWidth + "px"
                            }
                        }

                    }

                    if((swipeDirection == "vertical" || swipeDirection == "both") && scrollHeight != 0) {
                        var parentModel = widgetModel.parent;
                        if(!parentModel || (parentModel && parentModel.wType !== "FlexScrollContainer" && parentModel.wType !== "FlexContainer"))
                            _scrollerDOMNode.children[0].style.height = scrollHeight + "px";
                        scrollerInstance.refresh();
                    }
                    $KW.FlexScrollContainer.setContentOffSet(widgetModel, widgetModel.contentoffset, 0, scrollerInstance);
                    widgetModel.scrollerInstance = scrollerInstance;
                }

                
                $KG[scrollerId + '_scroller'] = scrollerInstance;
            }
        },


        
        initializeFlexScrollEvents: function(widgetModel, options) {


            var scrollingEvents = widgetModel.scrollingevents;

            var pullDownEl, pullUpEl, pullInitFlag, pushInitFlag;
            var pullDownOffset = 0,
                pullUpOffset = 0;
            var onRefresh = "",
                onScrollStart = "",
                onScrollMove = "",
                onScrollEnd = "";
            var widgetNode = $KU.getNodeByModel(widgetModel);
            var pullDownId = "#" + $KW.Utils.getKMasterWidgetID(widgetModel) + "_pullDown";
            var pullUpId = "#" + $KW.Utils.getKMasterWidgetID(widgetModel) + "_pullUp";
            var scrolldirection = $KW.stringifyScrolldirection[widgetModel.scrolldirection];

            pullDownEl = document.querySelector(pullDownId);
            pullUpEl = document.querySelector(pullUpId);

            if(scrolldirection == "horizontal") {
                pullDownEl && (pullDownOffset = pullDownEl.offsetWidth);
                pullUpEl && (pullUpOffset = pullUpEl.offsetWidth);
            } else {
                pullDownEl && (pullDownOffset = pullDownEl.offsetHeight);
                pullUpEl && (pullUpOffset = pullUpEl.offsetHeight);
            }




            !scrollingEvents.onpull && (pullInitFlag = true);
            !scrollingEvents.onpush && (pushInitFlag = true);

            onRefresh = function() {
                var pullDownEl = this.options.pullDownEl;
                var pullUpEl = this.options.pullUpEl;
                var widgetModel = this.options.widgetModel;
                var contentNode =$KU.getNodeByModel(widgetModel);
                if(pullDownEl && pullDownEl.className.match('loading')) {
                    pullDownEl.className = '';
                    if(widgetModel._pullPreference == "text") {
                        var pullText = widgetModel.pullkey || "Pull to refresh" ;
                        pullDownEl.querySelector(".pullDownLabel").innerHTML = pullText;
                    }

                } else if(pullUpEl && pullUpEl.className.match('loading')) {
                    pullUpEl.className = '';
                    if(widgetModel._pushPreference == "text") {
                        var pushText = widgetModel.pushkey || "Push to refresh" ;
                        pullUpEl.querySelector(".pullUpLabel").innerHTML = pushText;
                    }

                }
                if(pullUpEl) {
                    pullUpEl.style.marginTop = contentNode.scrollHeight - contentNode.offsetHeight + "px";
                }
            };

            onScrollMove = function() {
                var options = this.options;
                options.widgetModel.contentoffset = {
                    x: -this.x,
                    y: -this.y
                };
                options.widgetModel.onscrolling && $KU.executeWidgetEventHandler(options.widgetModel, options.widgetModel.onscrolling);

                var pullDownEl = this.options.pullDownEl;
                var pullUpEl = this.options.pullUpEl;
                var widgetModel = this.options.widgetModel;

                if(pullDownEl) {
                    if(((this.options.vScroll && this.y > 5) || (this.options.hScroll && this.x > 5)) && !pullDownEl.className.match('flip')) {
                        pullDownEl.className = 'flip';
                        pullInitFlag = false;
                        if(widgetModel._pullPreference == "text") {
                            var releasetext = widgetModel.releasepullkey || "Release to refresh";
                            pullDownEl.querySelector(".pullDownLabel").innerHTML = releasetext;
                        }

                        if(this.options.vScroll)
                            this.minScrollY = 0;
                        else
                            this.minScrollX = 0;
                    } else if(((this.options.vScroll && this.y < 5) || (this.options.hScroll && this.x < 5)) && pullDownEl.className.match('flip')) {
                        if(this.options.vScroll)
                            this.minScrollY = -this.pullDownOffset;
                        else
                            this.minScrollX = -this.pullDownOffset;
                    }
                }
                if(pullUpEl) {
                    if(((this.options.vScroll && this.y < (this.maxScrollY - 5 - this.pullUpOffset)) || (this.options.hScroll && this.x < (this.maxScrollX - 5 - this.pullUpOffset))) && !pullUpEl.className.match('flip')) {
                        pullUpEl.className = 'flip';
                        pushInitFlag = false;
                        if(widgetModel._pushPreference == "text") {
                            var releasetext = widgetModel.releasepushkey || "Release to refresh";
                            pullUpEl.querySelector(".pullUpLabel").innerHTML = releasetext;
                        }

                        if(this.options.vScroll)
                            this.maxScrollY -= this.pullUpOffset;
                        else
                            this.maxScrollX -= this.pullUpOffset;
                    } else if(((this.options.vScroll && this.y > (this.maxScrollY + 5)) || (this.options.hScroll && this.x > (this.maxScrollX + 5))) && pullUpEl.className.match('flip')) {
                        this.maxScrollY = this.maxScrollY  ;
                    }
                }
            };

            onScrollEnd = function() {
                var options = this.options;
                options.widgetModel.contentoffset = {
                    x: -this.x,
                    y: -this.y
                };
                options.widgetModel.onscrollend && $KU.executeWidgetEventHandler(options.widgetModel, options.widgetModel.onscrollend);

                var pullDownEl = this.options.pullDownEl;
                var pullUpEl = this.options.pullUpEl;
                var reachingbeginningoffset = 0;
                var reachingendoffset = 0;
                var widgetModel = this.options.widgetModel;

                if(((this.options.vScroll && this.y >= this.minScrollY - reachingbeginningoffset) ||
                        (this.options.hScroll && this.x >= this.minScrollX - reachingbeginningoffset)) && this.options.pullInitFlag) {

                    if(this.scrollerH > 0) {
                        kony.web.logger("log", "On Reach beginning");
                        var handler = $KU.returnEventReference(widgetModel.scrollingevents.onreachingbeginning);
                        handler && $KU.executeWidgetEventHandler(widgetModel, handler);
                    }
                }

                if((this.options.vScroll && this.y < this.minScrollY - reachingbeginningoffset) ||
                    (this.options.hScroll && this.x < this.minScrollX - reachingbeginningoffset)) {
                    if(this.direction == $KW.touch.TouchContext.UP || this.direction == $KW.touch.TouchContext.DOWN)
                        this.options.onreachingbeginningVFired = false;
                    else
                        this.options.onreachingbeginningHFired = false;
                }
                if(pullDownEl && pullDownEl.className.match('flip')) {
                    pullDownEl.className = 'loading';
                    module.pullAction.call(this, "DOWN"); 
                }

                if(((this.options.vScroll && this.y <= this.maxScrollY + reachingendoffset) ||
                        (this.options.hScroll && this.x <= this.maxScrollX + reachingendoffset)) && this.options.pushInitFlag) {
                    if((this.options.vScroll && Math.abs(this.y) >= 20) || (this.options.hScroll && Math.abs(this.x) >= 20)) {
                        kony.web.logger("log", "On Reach end");
                        
                        var handler = $KU.returnEventReference(widgetModel.scrollingevents.onreachingend);
                        handler && $KU.executeWidgetEventHandler(widgetModel, handler);

                    }
                }
                if((this.options.vScroll && this.y > this.maxScrollY + reachingendoffset) ||
                    (this.options.hScroll && this.x > this.maxScrollX + reachingendoffset)) {
                    if(this.direction == $KW.touch.TouchContext.UP || this.direction == $KW.touch.TouchContext.DOWN)
                        this.options.onreachingendVFired = false;
                    else
                        this.options.onreachingendHFired = false;
                }
                if(pullUpEl && pullUpEl.className.match('flip')) {
                    pullUpEl.className = 'loading';
                    module.pullAction.call(this, "UP"); 
                }

                
                if(!this.options.pullInitFlag)
                    this.options.pullInitFlag = true;
                if(!this.options.pushInitFlag)
                    this.options.pushInitFlag = true;
            };

            
            $KU.extend(options, {
                topOffset: pullDownOffset,
                bottomOffset: pullUpOffset,
                onRefresh: onRefresh,
                onScrollMove: onScrollMove,
                onScrollEnd: onScrollEnd,
                pullDownEl: pullDownEl,
                pullUpEl: pullUpEl,
                pullInitFlag: pullInitFlag,
                pushInitFlag: pushInitFlag
            });


        },

        initializeNativeScroller: function(widgetModel, _scrollerDOMNode) {
            var overflowX, overflowY;
            var scrollerStyle = _scrollerDOMNode.style;
            
            if($KW.FlexUtils.isFlexContainer(widgetModel) && !widgetModel.enableScrolling) {
                scrollerStyle.overflow = "hidden";
                return;
            }
            var direction = widgetModel.needScroller ? 2 : widgetModel.scrollDirection;
            switch(direction) {
                case 1:
                    overflowX = "auto";
                    overflowY = "hidden";
                    break;
                case 2:
                    overflowX = "hidden";
                    overflowY = "auto";
                    break;
                case 3:
                    overflowX = "auto";
                    overflowY = "auto";
                    break;
                case 4:
                    overflowX = "hidden";
                    overflowY = "hidden";
                default:
                    overflowX = "";
                    overflowY = "";
            }
            scrollerStyle.overflowX = overflowX;
            scrollerStyle.overflowY = overflowY;
            scrollerStyle['-webkit-overflow-scrolling'] = 'touch';
        },

        destroyFormScroller: function(formId) {
            if($KG["stickyScroll"]) {
                var scrollerInstance = $KG[formId + '_scroller'];
                scrollerInstance && scrollerInstance.destroy();
                $KG[formId + '_scroller'] = "";
            }

            var scrollerNodes = document.querySelectorAll("#" + formId + "[kwidgettype='KFormScroller'] ,#" + formId + " div[kwidgettype='KFormScroller']")
            for(var i = 0; i < scrollerNodes.length; i++) {
                module.destroyInstance(scrollerNodes[i]);
            }
        },

        destroyScrollBoxes: function(formId) {
            var scrollerNodes = document.querySelectorAll("#" + formId + " div[kwidgettype='KScrollBox']")
            for(var i = 0; i < scrollerNodes.length; i++) {
                module.destroyInstance(scrollerNodes[i]);
            }
        },

        destroyCollectionViewScroller: function(formId) {
            var scrollerNodes = document.querySelectorAll("#" + formId + " div[kwidgettype='KCollectionView']")
            for(var i = 0; i < scrollerNodes.length; i++) {
                module.destroyInstance(scrollerNodes[i]);
            }
        },

        destroyListBoxEditableInstances: function() {
            var listBoxEditableInstances = $KG["listBoxEditableInstances"];
            for (var i = 0; i< listBoxEditableInstances.length; i++) {
                $KW.Scroller.destroyInstance(listBoxEditableInstances[i]);
            }
            $KG["listBoxEditableInstances"] = [];
        },

        destroyInstance: function(scrollerNode) {
            if(!scrollerNode) {
                kony.web.logger("warn", "it should not happen");
                return;
            }
            var _scrollerId = scrollerNode.id;
            var scrollerInstance = $KG[_scrollerId];
            scrollerInstance && scrollerInstance.destroy();
            $KG[_scrollerId] = "";
        },

        destroyImageStripStripViews: function(formId) {
            var stripNodes = document.querySelectorAll("#" + formId + " div[name='ImageStrip_StripView']");
            for(var i = 0; i < stripNodes.length; i++) {
                var widgetModel = $KU.getModelByNode(stripNodes[i]);
                if(widgetModel) {
                    var scrollerInstance = widgetModel.scrollInstance;
                    if(scrollerInstance) {
                        scrollerInstance.destroy();
                        
                        widgetModel.scrollInstance = null;
                    }
                }
            }
        },

        initializePageViews: function(formId) {
            
            if($KG["disableTransition"])
                return;
            var swipeElements = document.querySelectorAll("#" + formId + " div[name='touchcontainer_Segment'], #" + formId + " div[name='touchcontainer_Tabpane']");
            for(var i = 0; i < swipeElements.length; i++) {
                var swipeElement = swipeElements[i];
                var widgetModel = $KU.getModelByNode(swipeElement);
                if(!widgetModel)
                    widgetModel = $KU.getModelByNode(swipeElement.parentNode);
                
                var options = {};
                options.widgetModel = widgetModel;
                var pScrollerInstance = new $KW.touch.pageviewScroller(swipeElement, options);
                $KG[swipeElement.id] = pScrollerInstance;
            }
        },

        destroyPageViews: function(formId) {
            var scrollerNodes = document.querySelectorAll("#" + formId + " div[name='touchcontainer_Segment']");
            for(var i = 0; i < scrollerNodes.length; i++) {
                module.destroyInstance(scrollerNodes[i]);
            }
        },

        checkDOMChanges: function(_scrollerId, headerId, footerId) {
            var headerNode = document.getElementById(headerId);
            var footerNode = document.getElementById(footerId);
            var appmenuNode = document.getElementById("konyappmenudiv");

            var formModel = $KG.allforms[_scrollerId.split("_")[0]];
            var heightChanged = false;

            if(headerNode && (this.headerH != headerNode.offsetHeight) && formModel.dockableheader) {
                var _scrollerDOMNode = document.getElementById(_scrollerId);
                var scrollerInstance = $KG[_scrollerId];

                if(_scrollerDOMNode && scrollerInstance) {
                    this.headerH = headerNode.offsetHeight;
                    _scrollerDOMNode.style.top = headerNode.offsetHeight + "px";
                    scrollerInstance.refresh();
                }
            }
            if(footerNode && (this.footerH != footerNode.offsetHeight) && formModel.dockablefooter) {
                var _scrollerDOMNode = document.getElementById(_scrollerId);
                var scrollerInstance = $KG[_scrollerId];

                if(_scrollerDOMNode && scrollerInstance) {
                    this.footerH = footerNode.offsetHeight;
                    _scrollerDOMNode.style.bottom = footerNode.offsetHeight + "px";
                    scrollerInstance.refresh();
                }
            }
            if(formModel.wType != "Popup" && appmenuNode && (this.appmenuH != appmenuNode.offsetHeight) && formModel.dockableappmenu) {
                var _scrollerDOMNode = document.getElementById(_scrollerId);
                var scrollerInstance = $KG[_scrollerId];

                if(_scrollerDOMNode && scrollerInstance) {
                    this.appmenuH = appmenuNode.offsetHeight;
                    _scrollerDOMNode.style.bottom = appmenuNode.offsetHeight + "px";
                    scrollerInstance.refresh();
                }
            }
            
            if(formModel.wType == 'Form' && $KW.FlexUtils.isFlexContainer(formModel)) {
                var _scrollerDOMNode = document.getElementById(_scrollerId);
                var formNode = document.getElementById(formModel.id);
                if(formNode && formNode.clientHeight != _scrollerDOMNode.clientHeight) {
                    formNode.style.height = _scrollerDOMNode.clientHeight + 'px';
                    $KU.needOptimization = false;
                    formModel.forceLayout();
                    $KU.needOptimization = true;
                }
            }



            if($KG._domchanges) {
                $KU.onEventHandler();
                $KG._domchanges = false;
            }
        },


        setHeight: function(scrollerId, nativeScroll) {
            

            var _scrollerDOMNode;
            if(nativeScroll)
                _scrollerDOMNode = document.getElementById(scrollerId);
            else
                _scrollerDOMNode = document.getElementById(scrollerId + "_scroller");
            if(!_scrollerDOMNode)
                return;

            this.headerH = 0;
            this.footerH = 0;
            this.appmenuH = 0;


            var formModel = $KG.allforms[scrollerId];
            var headerId = formModel.header;
            var footerId = formModel.footer;
            var appmenuId = "konyappmenudiv";
            var main = null;

            header = $KG.needScroller ? $KU.getElementById(scrollerId + "_header") : $KU.getElementById("header_container");
            footer = $KG.needScroller ? $KU.getElementById(scrollerId + "_footer") : $KU.getElementById("footer_container");

            var appmenu = document.getElementById(appmenuId);

            if(header && formModel.dockableheader)
                this.headerH = header.offsetHeight;

            if(formModel.wType != "Popup" && appmenu && formModel.dockableappmenu) {
                this.appmenuH = appmenu.offsetHeight;
            }
            if(footer && formModel.dockablefooter) {
                this.footerH = footer.offsetHeight;
                footer.style.bottom = this.appmenuH + "px";
            }

            _scrollerDOMNode.style.top = this.headerH + 'px';
            _scrollerDOMNode.style.bottom = this.footerH + this.appmenuH + 'px';
            if(kony.appinit.isiPhone && kony.appinit.isSafari) {
                main = document.getElementById("__MainContainer");
                main.style.height = window.innerHeight + "px";
                main.style.position = "relative";
            }
            $KW.Form.setFormDimensions(formModel);


            nativeScroll && (_scrollerDOMNode.style.paddingBottom = this.footerH + this.appmenuH + 'px');


        },

        onBeforeScrollStartHandler: function() {
            return function(e) {
                
                kony.events.stopPropagation(e);
            }
        },

        pullAction: function(dir) {
            var that = this;
            that.refreshDisabled = true;
            setTimeout(function() {
                var model = $KU.getModelByScroller(that.wrapper.id);
                if(typeof model === "undefined")
                    return;
                
                if(model.scrollingevents) {
                    var handler;
                    if(dir == "UP") {
                        kony.web.logger("log", "On Push");
                        handler = $KU.returnEventReference(model.scrollingevents.onpush);
                        if(model.wType === 'Segment') {
                            $KAR && $KAR.sendRecording(model, 'push', {'eventType': 'uiAction'});
                        }
                    } else {
                        kony.web.logger("log", "On Pull");
                        handler = $KU.returnEventReference(model.scrollingevents.onpull);
                        if(model.wType === 'Segment') {
                            $KAR && $KAR.sendRecording(model, 'pull', {'eventType': 'uiAction'});
                        }
                    }
                    handler && $KU.executeWidgetEventHandler(model, handler);
                    that.refreshDisabled = false;
                }
                that.refresh();
            }, 500);
        }
    };


    return module;
}());


$KW.FlexLayoutEngine = (function() {
    
    

    var module = {
        
        performFlexLayout: function(layoutType, container, flexNode, widgets) {
            switch(layoutType) {
                case kony.flex.FLOW_HORIZONTAL:
                    this.performHorizontalLayout(container, flexNode, widgets);
                    break;

                case kony.flex.FLOW_VERTICAL:
                    this.performVerticalLayout(container, flexNode, widgets);
                    break;

                default: 
                    this.performFreeFlowLayout(container, flexNode, widgets);
                    break;
            }
        },

        
        performAutogrowFlexLayout: function(container, flexNode, widgets) {
            var flexHeight = this.getAutoGrowFlexHeight(container, flexNode, widgets);
            if(container.canMeasureChildrenHeight) {
                var wrapperNode = $KW.FlexUtils.isFlexWidget(container) ? flexNode.parentNode : flexNode;
                var previousHeight = wrapperNode.style.height;
                wrapperNode.style.height = $KW.FlexUtils.getComputedPreferredHeight(container, flexNode, flexHeight) + 'px';
                container.frame = $KW.FlexUtils.getWidgetFrame(container, wrapperNode);
                container.layoutConfig.children = true;
                if(wrapperNode.style.height != previousHeight && container.parent)
                    container.parent.layoutConfig = {
                        self: true,
                        children: true
                    };
                module.performFlexLayout(container.layouttype, container, flexNode, widgets);
            }
        },

        getAutoGrowFlexHeight: function(flexModel, flexNode, widgets) {
            var layoutType = flexModel.layouttype;
            var parentFrame = flexModel.frame;
            var wModel, wNode;
            var flexHeight = 0;
            flexModel.canMeasureChildrenHeight = true;
            widgets = widgets || flexModel.widgets();

            for(var i = 0; i < widgets.length; i++) {
                wModel = widgets[i];
                wModel = $KW.Utils.getActualWidgetModel(wModel);
                if(!this.isVisible(wModel, flexNode))
                    continue;

                wNode = $KW.Utils.getWidgetNode(wModel, flexNode);
                if(!wNode)
                    continue;

                this.computeLayoutValues(wModel, flexNode, parentFrame);
                
                if(!flexModel.canMeasureChildrenHeight) {
                    var wrapperNode = $KW.FlexUtils.isFlexWidget(flexModel) ? flexNode.parentNode : flexNode;
                    wrapperNode.style.height = $KW.FlexUtils.getComputedPreferredHeight(flexModel, flexNode) + 'px';
                    flexModel.frame = $KW.FlexUtils.getWidgetFrame(flexModel, wrapperNode);
                    flexModel.layoutConfig.children = true;
                    module.performFlexLayout(layoutType, flexModel, flexNode, widgets);
                    return flexModel.frame.height;
                }

                var layoutModel = wModel.layoutModel;
                var wrapperNode = wNode.parentNode;

                
                $KW.FlexUtils.getWidth(wModel, layoutModel, wrapperNode, flexNode);

                var centerY = layoutModel.centerY;
                var top = layoutModel.top;
                var bottom = layoutModel.bottom;
                var height = layoutModel.height;
                var widgetHeight = 0;
                var cph, implicitHeight;

                if(centerY) {
                    if(height) {
                        widgetHeight = centerY.value + (height.value / 2);
                    } else {
                        if(top && layoutType == kony.flex.FREE_FORM) {
                            implicitHeight = (centerY.value - top.value) * 2;
                            widgetHeight = implicitHeight + top.value;
                        } else {
                            cph = $KW.FlexUtils.getChildHeight(wModel, wNode);
                            widgetHeight = centerY.value + (cph / 2);
                        }
                    }
                } else if(top) {
                    if(height) {
                        widgetHeight = top.value + height.value;
                    } else {
                        cph = $KW.FlexUtils.getChildHeight(wModel, wNode);
                        widgetHeight = top.value + cph;
                    }
                } else {
                    if(height) {
                        widgetHeight = height.value;
                    } else {
                        cph = $KW.FlexUtils.getChildHeight(wModel, wNode);
                        widgetHeight = cph;
                    }
                }

                if(bottom) {
                    widgetHeight += bottom.value;
                }

                wrapperNode.style.height = (height ? height.value : (implicitHeight != undefined ? implicitHeight : cph)) + 'px';
                wrapperNode.style.maxWidth = wrapperNode.style.maxHeight = '';
                var dimensions = $KW.FlexUtils.getWidgetDimensions(wModel, wrapperNode);
                wModel.finalFrame = {};

                if(layoutType != kony.flex.FREE_FORM) {
                    var prevModel, prevSibling, prevFrame;
                    var prevWidgetInfo = this.getPreviousNode(wModel, wrapperNode, flexNode)
                    if(prevWidgetInfo) {
                        prevModel = prevWidgetInfo[0];
                        prevSibling = prevWidgetInfo[1];
                    }
                    prevFrame = prevSibling && prevModel.frame;
                }

                if(layoutType == kony.flex.FREE_FORM || layoutType == kony.flex.FLOW_VERTICAL)
                    this.determineX(wModel, dimensions, flexNode, parentFrame);
                else
                    this.determineHorizontalFlowX(wModel, dimensions, prevModel, prevFrame);

                if(layoutType == kony.flex.FREE_FORM || layoutType == kony.flex.FLOW_HORIZONTAL)
                    this.determineY(wModel, dimensions, flexNode, parentFrame);
                else
                    this.determineVerticalFlowY(wModel, dimensions, prevModel, prevFrame);

                $KW.FlexUtils.setWidgetPosition(wModel, wModel.finalFrame, wrapperNode);
                wModel.frame = this.getWidgetFrame(wModel, dimensions, wModel.finalFrame);
                wModel.dolayout && $KU.executeWidgetEventHandler(wModel, wModel.dolayout);
                if(layoutType == kony.flex.FLOW_VERTICAL) {
                    flexHeight += widgetHeight;
                } else { 
                    if(flexHeight < widgetHeight)
                        flexHeight = widgetHeight;
                }
            }
            if(flexModel.vBorder)
                flexHeight += flexModel.vBorder;
            return flexHeight;
        },

        
        performFreeFlowLayout: function(container, flexNode, widgets) {
            var parentFrame = container.frame;
            var wModel, wNode, dimensions;

            for(var i = 0; i < widgets.length; i++) {

                wModel = widgets[i];

                wModel = $KW.Utils.getActualWidgetModel(wModel);

                if(!this.canLayoutUI(container, wModel, flexNode))
                    continue;
                wNode = $KW.Utils.getWidgetNode(wModel, flexNode);

                if(!wNode)
                    continue;

                wNode = wNode.parentNode;
                wModel.finalFrame = {};

                this.computeLayoutValues(wModel, flexNode, parentFrame);
                this.determineSize(flexNode, wModel, wNode);

                dimensions = $KW.FlexUtils.getWidgetDimensions(wModel, wNode);

                this.determineX(wModel, dimensions, flexNode, parentFrame);
                this.determineY(wModel, dimensions, flexNode, parentFrame);

                $KW.FlexUtils.setWidgetPosition(wModel, wModel.finalFrame, wNode);
                if(wModel.parent.wType == "FlexScrollContainer") {
                    $KW.FlexUtils.updateFlexScrollLayout(wModel);
                }
                $KW.FlexUtils.saveWidgetFrame(wModel);
                wModel.frame = this.getWidgetFrame(wModel, dimensions, wModel.finalFrame);
                this.onWidgetLayout(wModel, wNode);
            }
            this.onFlexContainerLayout(container);
        },

        performHorizontalLayout: function(container, flexNode, widgets) {
            var parentFrame = container.frame;
            var wModel, wNode, dimensions, prevFrame;

            for(var i = 0; i < widgets.length; i++) {

                wModel = widgets[i];

                wModel = $KW.Utils.getActualWidgetModel(wModel);

                if(!this.canLayoutUI(container, wModel, flexNode))
                    continue;

                wNode = $KW.Utils.getWidgetNode(wModel, flexNode);

                if(!wNode)
                    continue;

                wNode = wNode.parentNode
                wModel.finalFrame = {};

                this.computeLayoutValues(wModel, flexNode, parentFrame);

                var prevModel, prevSibling;
                var prevWidgetInfo = this.getPreviousNode(wModel, wNode, flexNode)
                if(prevWidgetInfo) {
                    prevModel = prevWidgetInfo[0];
                    prevSibling = prevWidgetInfo[1];
                }
                prevFrame = prevSibling && prevModel.frame;

                this.determineSize(flexNode, wModel, wNode);
                dimensions = $KW.FlexUtils.getWidgetDimensions(wModel, wNode);

                this.determineHorizontalFlowX(wModel, dimensions, prevModel, prevFrame);
                this.determineY(wModel, dimensions, flexNode, parentFrame);

                $KW.FlexUtils.setWidgetPosition(wModel, wModel.finalFrame, wNode);
                if(wModel.parent.wType == "FlexScrollContainer") {
                    $KW.FlexUtils.updateFlexScrollLayout(wModel);
                }
                $KW.FlexUtils.saveWidgetFrame(wModel);
                wModel.frame = this.getWidgetFrame(wModel, dimensions, wModel.finalFrame);
                this.onWidgetLayout(wModel, wNode);
            }
            if(container.reverselayoutdirection) {
                this.applyReverStacking(container, flexNode)
            }
            this.onFlexContainerLayout(container);
        },

        performVerticalLayout: function(container, flexNode, widgets) {
            var parentFrame = container.frame;
            var wModel, wNode, dimensions, prevFrame;

            for(var i = 0; i < widgets.length; i++) {

                wModel = widgets[i];
                wModel = $KW.Utils.getActualWidgetModel(wModel);
                if(!this.canLayoutUI(container, wModel, flexNode))
                    continue;

                wNode = $KW.Utils.getWidgetNode(wModel, flexNode);

                if(!wNode)
                    continue;

                wNode = wNode.parentNode
                wModel.finalFrame = {};

                this.computeLayoutValues(wModel, flexNode, parentFrame);

                var prevModel, prevSibling;
                var prevWidgetInfo = this.getPreviousNode(wModel, wNode, flexNode)
                if(prevWidgetInfo) {
                    prevModel = prevWidgetInfo[0];
                    prevSibling = prevWidgetInfo[1];
                }
                prevFrame = prevSibling && prevModel.frame;

                this.determineSize(flexNode, wModel, wNode);
                dimensions = $KW.FlexUtils.getWidgetDimensions(wModel, wNode);
                this.determineX(wModel, dimensions, flexNode, parentFrame);
                this.determineVerticalFlowY(wModel, dimensions, prevModel, prevFrame);

                $KW.FlexUtils.setWidgetPosition(wModel, wModel.finalFrame, wNode);
                if(wModel.parent.wType == "FlexScrollContainer") {
                    $KW.FlexUtils.updateFlexScrollLayout(wModel);
                }
                $KW.FlexUtils.saveWidgetFrame(wModel);
                wModel.frame = this.getWidgetFrame(wModel, dimensions, wModel.finalFrame);
                this.onWidgetLayout(wModel, wNode);
            }
            if(container.reverselayoutdirection) {
                this.applyReverStacking(container, flexNode)
            }
            this.onFlexContainerLayout(container);
        },

        applyReverStacking: function(containerModel, containerNode) {
            var counter, prevModel, parentFrame = containerModel.frame,
                wModel, widgets = containerModel.widgets(),
                wNode, dimensions, prevFrame, propertyValue, prevWidget;
            for(counter = 0; counter < widgets.length; counter++) {
                wModel = widgets[counter];
                wModel = $KW.Utils.getActualWidgetModel(wModel);
                if(this.canLayoutUI(containerModel, wModel, containerNode)) {
                    wNode = $KW.Utils.getWidgetNode(wModel, containerNode);
                    wNode = wNode.parentNode;
                    prevWidget = this.getPreviousNode(wModel, wNode, containerNode);
                    prevModel = prevWidget ? prevWidget[0] : null;
                    prevFrame = prevWidget ? prevWidget[0].frame : null;
                    propertyValue = this.alignWidgets(wModel, wModel.frame, prevModel, prevFrame, containerModel, containerNode);
                    wModel.finalFrame[propertyValue[0]] = propertyValue[1];
                    $KW.FlexUtils.setWidgetPosition(wModel, wModel.finalFrame, wNode);
                    $KW.FlexUtils.saveWidgetFrame(wModel);
                    wModel.frame = this.getWidgetFrame(wModel, {
                        width: wModel.frame.width,
                        height: wModel.frame.height
                    }, wModel.finalFrame);
                }
            }
        },

        
        alignWidgets: function(wModel, wFrame, prevWModel, prevFrame, containerModel, containerNode) {
            var left, top, border, width, height, centerXvalue, centerYvalue;
            if(containerModel.layouttype == kony.flex.FLOW_HORIZONTAL) {
                border = (containerModel.hBorder) ? containerModel.hBorder : 0;
                
                
                if(containerModel.wType === "FlexContainer") {
                    prevFrame = prevFrame || {
                        x: (containerModel.frame.width - border),
                        y: 0,
                        width: 0,
                        height: 0
                    };
                } else if(containerModel.wType === "FlexScrollContainer") {
                    
                    prevFrame = prevFrame || {
                        x: containerNode.scrollWidth - border,
                        y: 0,
                        width: 0,
                        height: 0
                    };
                }
                
                left = prevFrame.x;

                
                
                if(typeof wFrame.width == "string" && wFrame.width.indexOf('%') != -1) {
                    left -= $KW.FlexUtils.getValueByParentFrame(wModel, {
                        value: parseInt(wFrame.width, 10),
                        unit: '%'
                    }, 'x');
                } else {
                    left -= parseInt(wFrame.width, 10);
                }

                
                if(wModel.layoutModel && wModel.layoutModel.right) {
                    left -= $KW.FlexUtils.getValueByParentFrame(wModel, wModel.layoutModel.right, 'x');
                }

                
                if(prevWModel && prevWModel.layoutModel && prevWModel.layoutModel.centerX) {
                    centerXvalue = $KW.FlexUtils.getValueByParentFrame(wModel, prevWModel.layoutModel.centerX, 'x');
                    left -= (centerXvalue - (prevWModel.frame.width/2));
                } else if(prevWModel && prevWModel.layoutModel && prevWModel.layoutModel.left) {
                    left -= $KW.FlexUtils.getValueByParentFrame(wModel, prevWModel.layoutModel.left, 'x');
                }
                left = parseInt(left, 10) + kony.flex.PX;
                return ["left", left];
            } else if(containerModel.layouttype == kony.flex.FLOW_VERTICAL) {
                border = (containerModel.vBorder) ? containerModel.vBorder : 0;
                
                
                if(containerModel.wType === "FlexContainer") {
                    prevFrame = prevFrame || {
                        x: 0,
                        y: containerModel.frame.height - border,
                        width: 0,
                        height: 0
                    };
                } else if(containerModel.wType === "FlexScrollContainer") {
                    
                    prevFrame = prevFrame || {
                        x: 0,
                        y: containerNode.scrollHeight - border,
                        width: 0,
                        height: 0
                    };
                }
                
                top = prevFrame.y;

                
                
                if(typeof wFrame.height == "string" && wFrame.height.indexOf('%') != -1) {
                    top -= $KW.FlexUtils.getValueByParentFrame(wModel, {
                        value: parseInt(wFrame.height, 10),
                        unit: '%'
                    }, 'y');
                } else {
                    top -= parseInt(wFrame.height, 10);
                }

                
                if(wModel.layoutModel && wModel.layoutModel.bottom) {
                    top -= $KW.FlexUtils.getValueByParentFrame(wModel, wModel.layoutModel.bottom, 'y');
                }

                
                if(prevWModel && prevWModel.layoutModel && prevWModel.layoutModel.centerY){
                    centerYvalue = $KW.FlexUtils.getValueByParentFrame(wModel, prevWModel.layoutModel.centerY, 'y');
                    top -= (centerYvalue - (prevWModel.frame.height/2));
                } else if(prevWModel && prevWModel.layoutModel && prevWModel.layoutModel.top) {
                    top -= $KW.FlexUtils.getValueByParentFrame(wModel, prevWModel.layoutModel.top, 'y');
                }
                top = parseInt(top, 10) + kony.flex.PX;
                return ["top", top];
            }
        },

        
        applyAnimationFrameReverseStacking: function(frames, widgetIndex, containerModel, containerNode) {
            var i, frame, prevFrame, counter = 0,
                height, width, frameObj, prop, widgets = containerModel.widgets();
            for(i = widgetIndex; i < widgets.length; i++) {
                frameObj = {};
                
                
                if(widgets[i - 1]) {
                    height = widgets[i - 1].finalFrame.height ? parseInt(widgets[i - 1].finalFrame.height, 10) : widgets[i - 1].frame.height;
                    width = widgets[i - 1].finalFrame.width ? parseInt(widgets[i - 1].finalFrame.width, 10) : widgets[i - 1].frame.width;
                    prevFrame = this.getWidgetFrame(widgets[i - 1], {
                        width: width,
                        height: height
                    }, widgets[i - 1].finalFrame);
                }
                for(prop in frames[counter])
                    frameObj[prop] = frames[counter][prop];
                
                if(!frameObj.width) {
                    frameObj.width = widgets[i].frame.width + kony.flex.PX;
                }
                
                if(!frameObj.height) {
                    frameObj.height = widgets[i].frame.height + kony.flex.PX;
                }
                frame = this.alignWidgets(widgets[i], frameObj, widgets[i - 1], prevFrame, containerModel, containerNode);
                frames[counter++][frame[0]] = frame[1];
                widgets[i].finalFrame[frame[0]] = frame[1];
            }
            return frames;
        },

        onFlexContainerLayout: function(flexModel) {
            flexModel.layoutConfig.children = false;
        },

        onWidgetLayout: function(wModel, wNode) {
            var onWidgetLayoutRef = null;
            if(wModel.kComponentModel) {
                wModel.kComponentModel.frame = wModel.frame;
            }
            wModel.dolayout && $KU.executeWidgetEventHandler(wModel, wModel.dolayout);
            if(wModel.wType == "CollectionView") {
                $KW.CollectionView.Utils.setCollectionViewHeightAndWidth(wModel);
                $KW.CollectionView.Utils.updateReachingOffsetValuesInPx(wModel);
            }
            onWidgetLayoutRef = $KW[wModel.wType].onWidgetLayout;
            onWidgetLayoutRef && onWidgetLayoutRef(wModel, wNode.childNodes[0]);
            this.compareFrames(wModel);
            this.layoutNestedConatiners(wModel, wNode);
            if($KC.widgetDataRecording == true) {
                $KC.setClientBoundsForXML(wModel, wNode);
            }
            wModel.layoutConfig.self = false;
        },

        compareFrames: function(wModel) {
            if(wModel.wType == 'FlexContainer' || wModel.wType == 'FlexScrollContainer') {
                var oldFrame = wModel.oldFrame;
                var frame = wModel.frame;
                if(oldFrame.width != frame.width || oldFrame.height != frame.height)
                    wModel.layoutConfig.children = true;
            }
        },

        layoutNestedConatiners: function(wModel, wNode) {
            if(wModel.wType == 'FlexContainer' || wModel.wType == 'FlexScrollContainer')
                $KW.FlexContainer.forceLayout(wModel, wNode ? wNode.childNodes[0] : null);
            if(wModel.wType == 'Segment' || wModel.wType == 'CollectionView') {
                var segNode = $KU.getNodeByModel(wModel);
                if(wModel.wType == 'CollectionView')
                    segNode = $KW.Utils.getContentNodeFromNodeByModel(wModel);
                if(segNode) {
                    
                    if(wModel.layoutConfig.self || !$KG.isUILayedOut) {
                        $KU.needOptimization = false;
                        $KW.FlexContainer.adjustFlexContainers(wModel, segNode);
                        if(wModel.viewtype == constants.SEGUI_VIEW_TYPE_PAGEVIEW)
                            $KW.touch.computeWidths(segNode, wModel);
                        $KU.needOptimization = true;
                    }
                    
                    if(wModel.layoutModel && wModel.autoGrowHeight === true) {
                        var wNode = $KW.Utils.getWidgetNode(wModel);
                        var cph = $KW.FlexUtils.getComputedPreferredHeight(wModel, wNode);
                        wNode.parentNode.style.height = cph + 'px';
                        wModel.frame.height = cph;
                    }
                }
            }
            if(wModel.wType == 'DataGrid') {
                var wNode = $KU.getNodeByModel(wModel);
                if(wModel.layoutConfig.self) {
                    $KU.needOptimization = false;
                    $KW.FlexContainer.adjustFlexContainers(wModel, wNode);
                    $KU.needOptimization = true;
                }
            }
            if(wModel.wType == 'TabPane') {
                var wNode = $KU.getNodeByModel(wModel);
                if(wModel.layoutConfig.self)
                    $KU.needOptimization = false;
                $KW.FlexContainer.adjustFlexContainers(wModel, wNode);
                $KU.needOptimization = true;
                $KW.Form.initializeFlexContainersInBox(wModel);
            }
        },

        
        determineSize: function(flexNode, wModel, wNode, updateUI) {

            
            var parent = wModel.parent;

            if(typeof updateUI == "undefined")
                $KW.FlexUtils.setPaddingByParent(wModel, wNode.childNodes[0]);

            var layoutModel = wModel.layoutModel;
            var wStyle = $KW.FlexUtils.getWidth(wModel, layoutModel, wNode, flexNode, updateUI);
            var hStyle = $KW.FlexUtils.getHeight(wModel, layoutModel, wNode, flexNode, updateUI);

            wNode.style.maxWidth = wNode.style.maxHeight = '';
            if(typeof updateUI == "undefined") {
                $KW.FlexUtils.setDimensions(wModel, wNode, flexNode);
            } else {
                var dimensions = wStyle.concat(hStyle);
                for(var i = 0; i < dimensions.length; i++) {
                    var parts = dimensions[i].split(':');
                    wModel.finalFrame[parts[0]] = parts[1];
                }
            }
        },

        
        determineX: function(wModel, widgetFrame, flexNode, parentFrame) {
            var layoutModel = wModel.layoutModel;
            var finalFrame = wModel.finalFrame;
            var flexContainer = wModel.parent;

            if(layoutModel.centerX) {
                var centerX = layoutModel.centerX.value;
                var parentWidth = parentFrame.width;
                var width = widgetFrame.width;
                if(layoutModel.centerX.unit == kony.flex.PERCENTAGE && flexContainer.layouttype == kony.flex.FREE_FORM) {
                    if(wModel.parent && wModel.parent.hBorder) {
                        parentWidth = parentWidth - wModel.parent.hBorder;
                    }
                    width = Math.floor((width / parentWidth) * 100);
                }
                finalFrame.left = parseInt((centerX - (width / 2)), 10) + layoutModel.centerX.unit;
            } else if(layoutModel.left) {
                finalFrame.left = layoutModel.left.value + layoutModel.left.unit;
            } else if(layoutModel.right) { 
                var parentWidth = flexNode.clientWidth;
                var value = $KW.FlexUtils.getValueByParentFrame(wModel, layoutModel.right, 'x');
                value = parentWidth - parseInt(widgetFrame.width + value, 10);
                finalFrame.left = value + kony.flex.PX;
            }
        },

        
        determineHorizontalFlowX: function(wModel, widgetFrame, prevModel, prevFrame) {
            var layoutModel = wModel.layoutModel;
            var finalFrame = wModel.finalFrame;
            prevFrame = prevFrame || {
                x: 0,
                y: 0,
                width: 0,
                height: 0
            };
            var left = prevFrame.x + prevFrame.width;

            if(layoutModel.centerX) {
                left += layoutModel.centerX.value - (widgetFrame.width / 2);
            } else if(layoutModel.left) {
                left += layoutModel.left.value;
            }

            if(prevModel && prevModel.layoutModel && prevModel.layoutModel.right) {
                left += prevModel.layoutModel.right.value;
            }

            finalFrame.left = parseInt(left, 10) + kony.flex.PX;
        },

        
        determineY: function(wModel, widgetFrame, flexNode, parentFrame) {
            var layoutModel = wModel.layoutModel;
            var finalFrame = wModel.finalFrame;
            var flexContainer = wModel.parent;

            if(layoutModel.centerY) {
                var centerY = layoutModel.centerY.value;
                var parentHeight = parentFrame.height;
                var height = widgetFrame.height;
                if(layoutModel.centerY.unit == kony.flex.PERCENTAGE && flexContainer.layouttype == kony.flex.FREE_FORM) {
                    if(wModel.parent && wModel.parent.vBorder) {
                        parentHeight = parentHeight - wModel.parent.vBorder;
                    }
                    height = Math.floor((height / parentHeight) * 100);
                }
                finalFrame.top = parseInt(centerY - (height / 2)) + layoutModel.centerY.unit;
            } else if(layoutModel.top) {
                finalFrame.top = layoutModel.top.value + layoutModel.top.unit;
            } else if(layoutModel.bottom) {
                var parentHeight = flexNode.clientHeight;
                var value = $KW.FlexUtils.getValueByParentFrame(wModel, layoutModel.bottom, 'y');
                value = parentHeight - parseInt(widgetFrame.height + value, 10);
                finalFrame.top = value + kony.flex.PX;
            }
        },

        
        determineVerticalFlowY: function(wModel, widgetFrame, prevModel, prevFrame) {
            var layoutModel = wModel.layoutModel;
            var finalFrame = wModel.finalFrame;
            prevFrame = prevFrame || {
                x: 0,
                y: 0,
                width: 0,
                height: 0
            };
            var top = prevFrame.y + prevFrame.height;

            if(layoutModel.centerY) {
                top += layoutModel.centerY.value - (widgetFrame.height / 2);
            } else if(layoutModel.top) {
                top += layoutModel.top.value;
            }

            if(prevModel && prevModel.layoutModel && prevModel.layoutModel.bottom) {
                top += prevModel.layoutModel.bottom.value;
            }
            finalFrame.top = top + kony.flex.PX;
        },

        
        getComputedValue: function(wModel, parentFrame, value, axis, property) {
            if(!$KU.isValidCSSLength(value))
                return null;
            var resultObj = $KW.FlexUtils.getValueAndUnit(wModel, value);
            var value = resultObj.value;
            var unit = resultObj.unit;
            var parentModel = wModel.parent;
            if(parentModel.wType == 'FlexContainer' && parentModel.autogrowHeight && unit == kony.flex.PERCENTAGE && axis == 'y') {
                parentModel.autogrowHeight = false;
                parentModel.canMeasureChildrenHeight = false;
            }

            if(parentModel.layouttype != kony.flex.FREE_FORM && unit == kony.flex.PERCENTAGE && !property) {
                if(axis == 'x') {
                    var width = parentFrame.width;
                    if(parentModel.wType == 'FlexContainer')
                        width = width - parentModel.hBorder;
                    value = (value * width) / 100;
                } else if(axis == 'y') {
                    var height = parentFrame.height;
                    if(parentModel.wType == 'FlexContainer')
                        height = height - parentModel.vBorder;
                    value = (value * parentFrame.height) / 100;
                }
                unit = kony.flex.PX;
            }
            return {
                value: value,
                unit: unit
            };
        },

        computeLayoutValues: function(wModel, flexNode, parentFrame, frameObj) {
            var model = wModel.layoutModel = {};
            var dataModel = frameObj || wModel;

            model.centerX = this.getComputedValue(wModel, parentFrame, dataModel.centerX, 'x');
            model.centerY = this.getComputedValue(wModel, parentFrame, dataModel.centerY, 'y');
            model.left = this.getComputedValue(wModel, parentFrame, dataModel.left, 'x');
            model.right = this.getComputedValue(wModel, parentFrame, dataModel.right, 'x');
            model.top = this.getComputedValue(wModel, parentFrame, dataModel.top, 'y');
            model.bottom = this.getComputedValue(wModel, parentFrame, dataModel.bottom, 'y');

            model.width = this.getComputedValue(wModel, parentFrame, dataModel.width, 'x', 'width');
            model.minWidth = this.getComputedValue(wModel, parentFrame, dataModel.minWidth, 'x');
            model.maxWidth = this.getComputedValue(wModel, parentFrame, dataModel.maxWidth, 'x');

            model.height = this.getComputedValue(wModel, parentFrame, dataModel.height, 'y', 'height');
            model.minHeight = this.getComputedValue(wModel, parentFrame, dataModel.minHeight, 'y');
            model.maxHeight = this.getComputedValue(wModel, parentFrame, dataModel.maxHeight, 'y');
        },

        computeKeyFrameValues: function(wModel, wNode, flexNode, frameObj) {
            var framesArray = [];
            var result = {};
            if(frameObj) {
                wModel.finalFrame = {};

                
                if(!(wModel.isTemplate && wModel.containerType == 'CollectionView')) {
                    wNode = wNode.parentNode;
                }
                var parentModel = wModel.parent;
                flexNode = flexNode || $KW.Utils.getWidgetNode(parentModel);
                var parentFrame = parentModel.frame;

                this.computeLayoutValues(wModel, flexNode, parentFrame, frameObj);
                this.determineSize(flexNode, wModel, wNode, false);

                var widgetFrame = $KW.FlexUtils.getWidgetFrame(wModel, wNode, false);
                var layoutModel = wModel.layoutModel;

                
                if(wModel.finalFrame.width && (layoutModel.centerX || layoutModel.right)) {
                    var width = wModel.finalFrame.width;
                    var valueObj = {
                        value: parseFloat(width),
                        unit: $KW.FlexUtils.getUnit(width)
                    };
                    widgetFrame.width = $KW.FlexUtils.getValueByParentFrame(wModel, valueObj, 'x');
                }

                if(wModel.finalFrame.height && (layoutModel.centerY || layoutModel.bottom)) {
                    var height = wModel.finalFrame.height;
                    var valueObj = {
                        value: parseFloat(height),
                        unit: $KW.FlexUtils.getUnit(height)
                    };
                    widgetFrame.height = $KW.FlexUtils.getValueByParentFrame(wModel, valueObj, 'y');
                }
                if(wModel.isTemplate && wModel.containerType == 'CollectionView') {
                    this.determineX(wModel, widgetFrame, flexNode, parentFrame);
                    this.determineY(wModel, widgetFrame, flexNode, parentFrame);
                } else {
                    var widgetIndex = $KW.Utils.getWidgetIndex(wModel);
                    var widgets = parentModel.widgets();
                    var prevModel, prevSibling;
                    var prevWidgetInfo = this.getPreviousNode(wModel, wNode, flexNode)
                    if(prevWidgetInfo) {
                        prevModel = prevWidgetInfo[0];
                        prevSibling = prevWidgetInfo[1];
                    }
                    var prevFrame = prevSibling && $KW.FlexUtils.getWidgetFrame(prevModel, prevSibling);

                    if(parentModel.layouttype == kony.flex.FLOW_HORIZONTAL) {
                        this.determineHorizontalFlowX(wModel, widgetFrame, prevModel, prevFrame);
                    } else
                        this.determineX(wModel, widgetFrame, flexNode, parentFrame);

                    if(parentModel.layouttype == kony.flex.FLOW_VERTICAL) {
                        this.determineVerticalFlowY(wModel, widgetFrame, prevModel, prevFrame);
                    } else
                        this.determineY(wModel, widgetFrame, flexNode, parentFrame);
                }
                if(!wModel.finalFrame.left)
                    wModel.finalFrame.left = '0px';

                if(!wModel.finalFrame.top)
                    wModel.finalFrame.top = '0px';

                for(var prop in wModel.finalFrame)
                    result[prop] = wModel.finalFrame[prop];

                framesArray.push(result);
                if(wModel.isTemplate && wModel.containerType == 'CollectionView') return framesArray;
                
                if(parentModel.layouttype == kony.flex.FLOW_HORIZONTAL) {
                    if(result.left || result.width || result["min-width"] || result["max-width"]) {
                        for(var i = widgetIndex + 1; i < widgets.length; i++) {
                            var nextWidget = widgets[i];
                            var prevWidget = widgets[i - 1];
                            var frame = nextWidget.frame;
                            if(nextWidget.isvisible && frame) {
                                var prevFrame = {};
                                var width;

                                prevFrame.x = result.left ? parseInt(result.left, 10) : prevWidget.frame.x;

                                if(result.width) {
                                    if(result.width.indexOf('%') != -1)
                                        width = $KW.FlexUtils.getValueByParentFrame(wModel, {
                                            value: parseInt(result.width, 10),
                                            unit: '%'
                                        }, 'x');
                                    else
                                        width = parseInt(result.width, 10);
                                } else if(result["min-width"]) {
                                    width = parseInt(result["min-width"], 10);
                                    if(width < prevWidget.frame.width) {
                                        width = prevWidget.frame.width;
                                        result["min-width"] = prevWidget.frame.width + 'px';
                                    }
                                } else if(result["max-width"]) {
                                    width = parseInt(result["max-width"], 10);
                                    if(width > prevWidget.frame.width) {
                                        width = prevWidget.frame.width;
                                        result["max-width"] = prevWidget.frame.width + 'px';
                                    }
                                } else
                                    width = prevWidget.frame.width;

                                prevFrame.width = width;
                                this.computeLayoutValues(nextWidget, flexNode, parentFrame);
                                nextWidget.finalFrame && this.determineHorizontalFlowX(nextWidget, frame, prevWidget, prevFrame);
                                if(nextWidget.finalFrame)
                                    result = {
                                        left: nextWidget.finalFrame.left
                                    };
                                framesArray.push(result);
                            }
                        }
                    }
                    if(parentModel.reverselayoutdirection) {
                        framesArray = this.applyAnimationFrameReverseStacking(framesArray, widgetIndex, parentModel, flexNode);
                    }
                }

                if(parentModel.layouttype == kony.flex.FLOW_VERTICAL) {
                    if(result.top || result.height || result["min-height"] || result["max-height"]) {
                        for(var i = widgetIndex + 1; i < widgets.length; i++) {
                            var nextWidget = widgets[i];
                            var prevWidget = widgets[i - 1];
                            var frame = nextWidget.frame;
                            if(nextWidget.isvisible && frame) {
                                var prevFrame = {};
                                var height;

                                prevFrame.y = result.top ? parseInt(result.top, 10) : prevWidget.frame.y;

                                if(result.height) {
                                    if(result.height.indexOf('%') != -1)
                                        height = $KW.FlexUtils.getValueByParentFrame(wModel, {
                                            value: parseInt(result.height, 10),
                                            unit: '%'
                                        }, 'y');
                                    else
                                        height = parseInt(result.height, 10);
                                } else if(result["min-height"]) {
                                    height = parseInt(result["min-height"], 10);
                                    if(height < prevWidget.frame.height) {
                                        height = prevWidget.frame.height;
                                        result["min-height"] = prevWidget.frame.height + 'px';
                                    }
                                } else if(result["max-height"]) {
                                    height = parseInt(result["max-height"], 10);
                                    if(height > prevWidget.frame.height) {
                                        height = prevWidget.frame.height;
                                        result["max-height"] = prevWidget.frame.height + 'px';
                                    }
                                } else
                                    height = prevWidget.frame.height;

                                prevFrame.height = height;
                                this.computeLayoutValues(nextWidget, flexNode, parentFrame);
                                nextWidget.finalFrame && this.determineVerticalFlowY(nextWidget, frame, prevWidget, prevFrame);
                                if(nextWidget.finalFrame) 
                                    result = {
                                        top: nextWidget.finalFrame.top
                                    };
                                framesArray.push(result);
                            }
                        }
                    }
                    if(parentModel.reverselayoutdirection) {
                        framesArray = this.applyAnimationFrameReverseStacking(framesArray, widgetIndex, parentModel, flexNode);
                    }
                }
            }
            return framesArray;
        },

        isAvailable: function(value) {
            return value == undefined ? false : true;
        },

        toPointwidget: function(wModel, parentModel, value, axis) {
            if(!$KU.isValidCSSLength(value))
                return null;
            var resultObj = $KW.FlexUtils.getValueAndUnit(wModel, value);
            var value = resultObj.value;
            var unit = resultObj.unit;

            var wNode = $KW.Utils.getWidgetNode(wModel);
            var elePos = $KW.Utils.getPosition(wNode);
            var parentNode = $KW.Utils.getWidgetNode(parentModel);
            var parPos = $KW.Utils.getPosition(parentNode);

            if(axis == "x") {
                value = parPos.left - elePos.left + value;
            } else if(axis == "y") {
                value = parPos.top - elePos.top + value;
            }

            return {
                value: value,
                unit: unit
            };
        },

        
        getPreviousNode: function(wModel, wNode, flexNode) {
            var widgetIndex = $KW.Utils.getWidgetIndex(wModel);
            if(widgetIndex == 0)
                return null;

            var parentModel = wModel.parent;
            var widgets = parentModel.widgets();
            var prevIndex = widgetIndex - 1;
            var previousNode = wNode.previousSibling;
            if(!previousNode)
                return null;

            for(var i = prevIndex; i >= 0; i--) {
                var prevModel = $KW.Utils.getActualWidgetModel(widgets[i]);
                if(!this.isVisible(prevModel, flexNode)) {
                    if(!flexNode.dataObj) { 
                        
                        if($KG.appbehaviors["lazyLoadDOM"] != true) {
                            var flexNode = $KU.getNodeByModel(parentModel);
                            if(!flexNode.getAttribute("kcontainerID"))
                                previousNode = previousNode.previousSibling;
                        }
                    }
                    continue;
                }
                return [prevModel, previousNode];
            }
        },

        
        canLayoutUI: function(flexModel, wModel, flexNode) {
            if(!$KU.needOptimization) {
                if(!this.isVisible(wModel, flexNode)) {
                    return false;
                }

                return true;
            }

            if($KG.isUILayedOut) {
                var widgetConfig = wModel.layoutConfig;
                var containerConfig = flexModel.layoutConfig;
                var layoutType = flexModel.layouttype;

                if(layoutType == kony.flex.FLOW_HORIZONTAL
                || layoutType == kony.flex.FLOW_VERTICAL) {
                    if(widgetConfig.self) {
                        containerConfig.children = true;
                    }
                }

                if(widgetConfig.self || containerConfig.children) {
                    if(!this.isVisible(wModel, flexNode)) { 
                        widgetConfig.self = false;
                        return false;
                    }

                    return true;
                } else if(['FlexContainer', 'FlexScrollContainer', 'Segment', 'CollectionView', 'TabPane'].indexOf(wModel.wType) >= 0) { 
                    this.layoutNestedConatiners(wModel);
                    return false;
                } else {
                    return false;
                }
            } else if(!this.isVisible(wModel, flexNode)) {
                return false;
            }

            return true;
        },

        getWidgetFrame: function(wModel, dimensions, position) {
            var left = position.left || '0px';
            var leftObj = {
                value: parseFloat(left),
                unit: $KW.FlexUtils.getUnit(left)
            };
            left = $KW.FlexUtils.getValueByParentFrame(wModel, leftObj, 'x');
            var top = position.top || '0px';
            var topObj = {
                value: parseFloat(top),
                unit: $KW.FlexUtils.getUnit(top)
            };
            top = $KW.FlexUtils.getValueByParentFrame(wModel, topObj, 'y');
            return {
                x: left,
                y: top,
                width: dimensions.width,
                height: dimensions.height
            };
        },

        isVisible: function(wModel, flexNode) {
            if(flexNode && flexNode.dataObj) {
                
                var dataObj = flexNode.dataObj;
                var rowData = dataObj.data;
                var map = dataObj.map;
                var path = $KW.Utils.getWidgetPathByModel(wModel);
                var data = rowData[map[path]];

                
                if(data && data instanceof Object
                && typeof data.isVisible != "undefined") {
                    return data.isVisible;
                } else if(wModel.wType != 'FlexContainer'
                && (typeof data === "undefined" || data === "")) {
                    return false;
                }

                if(wModel.wType == 'FlexContainer' && wModel.widgets().length == 0) return false;
            }
            return wModel.isvisible;
        }
    };


    return module;
}());


$KW.Animator = function(animationDef) {
    this.validateKeyFrame(animationDef);
    this.animationDef = animationDef;
};

$KW.Animator.prototype = {
    getNextAnimationValue: function() {
        return($KW.Animator.indexCounter >= 0) ? (++$KW.Animator.indexCounter) : ($KW.Animator.indexCounter = 0);
    },

    getAnimationTime: function() {
        return new Date().getTime();
    },

    validateKeyFrame: function(animationDef) {
        for(var i in animationDef) {
            if(i > 100) {
                throw new KonyError(1000, "AnimationError", "Invalid Animation Definition Exception: Animation Definition can not be greater than 100");
            }
        }
        if(animationDef["100"] == undefined) {
            throw new KonyError(1000, "AnimationError", "Invalid Animation Definition Exception: Animation Definition does not have 100 value");
        }
    },

    
    getComputedAnimationFrames: function(widgetModel, node, flexNode) {
        var stepFrame = {};
        var animationDef = this.animationDef;
        var widgetAnimationDef = {};
        var layoutFrames = {};
        var skinFrames = {};
        widgetModel.originalFrames = {};
        this.flexDepFrames = {};
        var imageFrames = {};
        var flexprops = ["width", "height", "centerX", "centerY", "left", "top", "bottom", "left", "right", "minWidth", "maxWidth", "minHeight", "maxHeight", "transform", "opacity", "zIndex", "anchorPoint", "shadowColor", "shadowRadius", "shadowOffset"];

        var flexFrame = {};
        var flexComputedFrame = null;

        
        for(var i = 0; i < flexprops.length; i++) {
            var j = flexprops[i];
            flexFrame[j] = widgetModel[j];
        }

        
        if(!animationDef[0]) {
            this.flexDepFrames[0] = $KW.FlexLayoutEngine.computeKeyFrameValues(widgetModel, node, flexNode, flexFrame);
            flexComputedFrame = this.flexDepFrames[0][0];

            if(widgetModel.wType == "Image") {
                var imgNode = node.childNodes[0];
                var dimensions = {
                    width: flexComputedFrame.width,
                    height: flexComputedFrame.height
                };
                if(widgetModel.imagescalemode == constants.IMAGE_SCALE_MODE_MAINTAIN_ASPECT_RATIO) {
                    dimensions = $KU.setImgAspectRatio(widgetModel, imgNode, dimensions, false);
                    var margintop = $KU.getImageCenterAlign(imgNode, false, {
                        spanHeight: flexComputedFrame.height,
                        imgHeight: dimensions.height
                    });
                    if(margintop > 0) {
                        stepFrame.margintop = margintop;
                    }
                } else
                    dimensions = $KU.setImgDimensions(widgetModel, imgNode, dimensions, false);
                stepFrame.width = dimensions.width;
                stepFrame.height = dimensions.height;
            }

            layoutFrames[0] = flexComputedFrame;
            skinFrames[0] = stepFrame;
            if(widgetModel.wType == "Slider") {
                imageFrames[0] = {};
                imageFrames[0].left = $KW.Slider.animSlider(layoutFrames[0].width, widgetModel, "left");
                skinFrames[0].width = $KW.Slider.animSlider(layoutFrames[0].width, widgetModel, "width");
            }
        }

        var animsteps = [];
        for(var i in animationDef) {
            animsteps.push(i);
        }
        animsteps.sort(function(a, b) {
            return a - b
        });

        for(var i = 0; i < animsteps.length; i++) {
            var step = animsteps[i];
            stepFrame = $KU.cloneObj(animationDef[step]);
            for(var j in stepFrame) {
                if(flexprops.contains(j)) {
                    flexFrame[j] = stepFrame[j];
                    delete stepFrame[j];
                }
            }

            
            
            this.flexDepFrames[step] = $KW.FlexLayoutEngine.computeKeyFrameValues(widgetModel, node, flexNode, flexFrame);
            flexComputedFrame = this.flexDepFrames[step][0];

            
            if(widgetModel.wType == "Image") {
                var imgNode = node.childNodes[0];
                var dimensions = {
                    width: flexComputedFrame.width,
                    height: flexComputedFrame.height
                };
                if(widgetModel.imagescalemode == constants.IMAGE_SCALE_MODE_MAINTAIN_ASPECT_RATIO) {
                    dimensions = $KU.setImgAspectRatio(widgetModel, imgNode, dimensions, false);
                    var margintop = $KU.getImageCenterAlign(imgNode, false, {
                        spanHeight: flexComputedFrame.height,
                        imgHeight: dimensions.height
                    });
                    if(margintop > 0) {
                        stepFrame.margintop = margintop;
                    }
                } else
                    dimensions = $KU.setImgDimensions(widgetModel, imgNode, dimensions, false);
                stepFrame.width = dimensions.width;
                stepFrame.height = dimensions.height;
            }

            if(flexFrame.transform)
                flexComputedFrame.transform = flexFrame.transform;
            if(typeof(flexFrame.opacity) != "undefined")
                flexComputedFrame.opacity = flexFrame.opacity;
            if(flexFrame.zIndex)
                flexComputedFrame.zIndex = flexFrame.zIndex;
            if(flexFrame.anchorPoint)
                flexComputedFrame.anchorPoint = flexFrame.anchorPoint;
            if(flexFrame.shadowColor || flexFrame.shadowRadius || flexFrame.shadowOffset)
                flexComputedFrame.shadow = $KW.animUtils.getComputedShadowString(flexFrame);

            if(stepFrame["stepConfig"]) {
                stepFrame.timingFunction = flexComputedFrame.timingFunction = stepFrame["stepConfig"].timingFunction;
                for(var k in this.flexDepFrames[step]) {
                    this.flexDepFrames[step][k].timingFunction = stepFrame["stepConfig"].timingFunction;
                }
            }

            
            if(flexComputedFrame["min-height"] != undefined) {
                stepFrame["min-height"] = flexComputedFrame["min-height"];
            }

            layoutFrames[step] = flexComputedFrame;
            skinFrames[step] = stepFrame;
            var cloneFrame = owl.deepCopy(flexFrame);
            cloneFrame.backgroundColor = stepFrame.backgroundColor;
            widgetModel.originalFrames[step] = cloneFrame;

            if(widgetModel.wType == "Slider") {
                imageFrames[step] = {};
                imageFrames[step].left = $KW.Slider.animSlider(layoutFrames[step].width, widgetModel, "left");
                skinFrames[step].width = $KW.Slider.animSlider(layoutFrames[step].width, widgetModel, "width");
            }
        }
        this.cellFrame = layoutFrames;
        this.skinFrame = skinFrames;
        if(widgetModel.wType == "Slider")
            this.imageFrame = imageFrames;
    },

    createKeyFrames: function(widgetModel, animationFrames, animationName, frametype) {
        var currentStyleSheet = $KG["animStyleSheet"];
        if(currentStyleSheet && animationFrames) {
            var cssFrame = "";
            for(var i in animationFrames) {
                var stepFrame = "",
                    stepAnimation = "";
                var stepObj = animationFrames[i];
                var isPresent = {
                    transform: false,
                    anchorPoint: false
                };
                for(var j in stepObj) {
                    if(j == "timingFunction") {
                        if(typeof stepObj[j] == "string") {
                            stepAnimation += $KU.cssPrefix + "animation-timing-function :" + stepObj[j] + ";";
                        } else {
                            stepAnimation += $KU.cssPrefix + "animation-timing-function : cubic-bezier(" + stepObj[j] + ");";
                        }
                    } else if(j == "zIndex") {
                        stepFrame += "z-index" + ":" + stepObj[j] + ";";
                    } else if(j == "transform") {
                        var style = $KW.animUtils.applyTransform(widgetModel, stepObj[j]);
                        stepFrame += $KU.cssPrefix + "transform" + ":" + style + ";";
                        isPresent.transform = true;
                    } else if(j == "anchorPoint") {
                        if(stepObj[j]) {
                            if((stepObj[j].x >= 0) && (stepObj[j].x <= 1) && (stepObj[j].y >= 0) || (stepObj[j].y <= 1))
                                stepFrame += $KU.cssPrefix + "transform-origin" + ":" + (stepObj[j].x * 100) + "% " + (stepObj[j].y * 100) + "%; ";
                            isPresent.anchorPoint = true;
                        }
                    } else if(j == "backgroundColor" || j == "borderColor") {
                        if(j == "backgroundColor" && typeof stepObj[j] == "object") {
                            stepFrame += $KW.animUtils.parseGradientParams(stepObj[j]);
                        } else {
                            var validate = $KW.skins.validateHexValue(stepObj[j]);
                            if(validate) {
                                var result = $KW.skins.convertHexValuetoRGBA(stepObj[j]);
                            }
                            if(j == "backgroundColor") {
                                if(widgetModel.wType == "ListBox")
                                    stepFrame += "background-color:" + result + ";";
                                else
                                    stepFrame += "background:" + result + ";";
                            } else if(j == "borderColor")
                                stepFrame += "border-color:" + result + ";";
                        }
                    } else if(j == "margintop") {
                        stepFrame += "margin-top:" + stepObj[j] + "px;";
                    } else if(j == "shadow") {
                        stepFrame += "box-shadow:" + stepObj[j];
                    } else if(j == "borderWidth") {
                        stepFrame += "border-width : " + stepObj[j] + ";";
                    } else if(j == "cornerRadius") {
                        stepFrame += "border-radius : " + stepObj[j] + ";";
                    } else {
                        stepFrame += j + ":" + stepObj[j] + ";";
                    }
                }
                if(isPresent.transform && !isPresent.anchorPoint) 
                    stepFrame += $KU.cssPrefix + "transform-origin" + ": 50% 50%;";

                cssFrame += " " + i + "%{" + stepFrame + " " + stepAnimation + "}";
            }
            
            if($KG.appbehaviors["captureAniamtionData"]) {
                $KG.animataionData[this.animatorID].data[frametype] = cssFrame;
            }
            currentStyleSheet.insertRule("@" + $KU.cssPrefix + "keyframes " + animationName + " { " + cssFrame + "}", currentStyleSheet.cssRules.length);

        } else {
            kony.web.logger("warn", "kony css style sheet is not found");
        }
    },

    
    animate: function(widgetModel, animationConfig, callBackConfig, context) {
        if(widgetModel) {
            var node, flexNode;
            if(context) {
                node = context.node;
                flexNode = context.flexNode;
            } else if($KW.Utils.isBelongsToCollectionView(widgetModel)) {
                context = $KW.CollectionView.Animation.getAnimationContext(widgetModel);
                node = context.node;
                flexNode = context.flexNode;
            } else {
                node = $KW.Utils.getWidgetNode(widgetModel);
            }
            if(!node) {
                return;
            }

            this.animatorID = "anim_" + widgetModel.id + "_" + this.getNextAnimationValue();
            this.animator1ID = this.animatorID + "_skin";
            if($KG.appbehaviors["captureAniamtionData"]) {
                if(!$KG.animataionData) {
                    $KG.animataionData = {};
                }
                $KG.animataionData[this.animatorID] = {};
                var animInfo = $KG.animataionData[this.animatorID];
                animInfo.animationID = this.animatorID
                animInfo.data = {
                    startFrame: widgetModel.frame
                };
                animInfo.animationRequestTime = animInfo.animationRequestHandleBeginTime = this.getAnimationTime();
            }
            if(widgetModel.wType == 'Image' && !widgetModel.loaded) {
                widgetModel.animInfo = {
                    instance: this,
                    animConfig: animationConfig,
                    animCallback: callBackConfig
                };
                return;
            }
            if((widgetModel.isTemplate && widgetModel.containerType == 'CollectionView') || (widgetModel.parent.wType == "FlexContainer" || widgetModel.parent.wType == "FlexScrollContainer" || (widgetModel.parent.wType == 'Form' && widgetModel.parent.layouttype != kony.flex.VBOX_LAYOUT))) {
                this.getComputedAnimationFrames(widgetModel, node, flexNode);
                var depKeyFrames = this.flexDepFrames;

                this.createKeyFrames(widgetModel, this.cellFrame, this.animatorID, "widgetFrame");
                this.createKeyFrames(widgetModel, this.skinFrame, this.animator1ID, "skinFrame");

                
                
                var wrapper;
                if(widgetModel.isTemplate && widgetModel.containerType == 'CollectionView') {
                    wrapper = node;
                    node = node.firstChild;
                } else {
                    wrapper = node.parentNode;
                    if(widgetModel.wType == "FlexContainer" || widgetModel.wType == "FlexScrollContainer") {
                        node = node.firstChild;
                    }
                }
                wrapper.wModel = widgetModel;
                wrapper.context = context;
                var animConfig = this.getAnimConfig(animationConfig, wrapper);

                var animKey = $KU.animation;
                var animSkinDef = this.animator1ID + " " + animConfig;
                var animCellDef = this.animatorID + " " + animConfig;

                if(widgetModel.wType == "Slider") {
                    this.animator2ID = this.animatorID + "_image";
                    this.createKeyFrames(widgetModel, this.imageFrame, this.animator2ID);
                    var imgCellDef = this.animator2ID + " " + animConfig;
                    node.childNodes[0].childNodes[0].childNodes[0].style[animKey] = imgCellDef;
                }

                if(widgetModel.wType == "Image") {
                    node.childNodes[0].style[animKey] = animSkinDef;
                } else if(widgetModel.wType == "Slider") {
                    node.childNodes[0].childNodes[0].style[animKey] = animSkinDef;
                } else {
                    node.style[animKey] = animSkinDef;
                }

                if($KW.animUtils.isTransform3D(this.cellFrame) && wrapper.style.transform) {
                    wrapper.initialTransform = wrapper.style.transform;
                    wrapper.style.transform = "";
                }
                wrapper.style[animKey] = animCellDef;

                if($KG.appbehaviors["captureAniamtionData"]) {
                    animInfo.animationRequestHandleEndTime = animInfo.animationInvokeTime = this.getAnimationTime();
                }

                this.saveWidgetState(widgetModel, wrapper, animationConfig);
                this.registerAnimCallbacks(wrapper, callBackConfig);
                if(widgetModel.isTemplate && widgetModel.containerType == 'CollectionView') return;
                var parentModel = widgetModel.parent;
                if(parentModel.layoutType == kony.flex.FLOW_HORIZONTAL || parentModel.layoutType == kony.flex.FLOW_VERTICAL) {
                    widgetIndex = $KW.Utils.getWidgetIndex(widgetModel);
                    
                    if(widgetIndex != -1) {
                        var widgets = parentModel.widgets();
                        var length = widgets.length;
                        var j = 1;
                        for(var i = (widgetIndex + 1); i < length; i++) {
                            var siblingModel = widgets[i];
                            if(!siblingModel.isvisible)
                                continue;
                            var animFrame = {};
                            for(var k in depKeyFrames) {
                                animFrame[k] = depKeyFrames[k][j];
                            }

                            var siblingNode;
                            if(context) {
                                siblingNode = $KW.Segment.getNodeByContext(context.containerModel, context, siblingModel);
                            } else
                                siblingNode = $KW.Utils.getWidgetNode(siblingModel);
                            if(siblingNode) {
                                var depAnimId = "dep_" + widgetModel.id + "_" + this.getNextAnimationValue(); 
                                var depAnimDef = depAnimId + " " + animConfig;
                                this.createKeyFrames(widgetModel, animFrame, depAnimId, "depFrame" + i);
                                j++;

                                siblingNode.parentNode.style[animKey] = depAnimDef;
                                var endEvent;
                                if(kony.appinit.isFirefox || kony.appinit.isIE11) {
                                    endEvent = "animationend";
                                } else {
                                    endEvent = $KU.animationEnd;
                                }
                                kony.events.addEventListener(siblingNode.parentNode, endEvent, function(e) {
                                    var ct = e.currentTarget;
                                    setTimeout(function() {
                                        ct.style[$KU.animation] = "";
                                    },500);
                                }, false);
                            }
                        }
                    }
                }

            }
        }
    },

    saveWidgetState: function(widgetModel, wrapper, animationConfig, animType) {
        
        var fillMode = animationConfig["fillMode"] || "none";
        if(fillMode == kony.anim.FILL_MODE_BACKWARDS || fillMode == kony.anim.FILL_MODE_BOTH) {
            var applyFrame = [];
            var initialPosition = [];
            var direction = animationConfig["direction"] || "normal";
            if(direction == kony.anim.DIRECTION_NONE || direction == kony.anim.DIRECTION_ALTERNATE) {
                applyFrame = this.animationDef[0];
            }

            for(var i in applyFrame) {
                initialPosition[i] = widgetModel[i];
                if(animType != 'segmentRow') 
                    widgetModel[i] = applyFrame[i];
            }
            wrapper.initialPosition = initialPosition;
        }
    },

    getAnimConfig: function(animConfig, node) {
        if(!animConfig)
            return "";
        var duration = animConfig["duration"] || 0;
        var iterations = animConfig["iterationCount"] || 1;
        if(animConfig["iterationCount"] == 0)
            iterations = "infinite";
        var direction = animConfig["direction"] || "normal";
        var animationDelay = animConfig["delay"] || 0;
        var fillMode = animConfig["fillMode"] || "none";

        if(node) {
            node.direction = direction;
            node.fillMode = fillMode;
            node.iterations = iterations;
        }

        return duration + "s " + animationDelay + "s " + iterations + " " + direction + " " + fillMode + " ";
    },

    registerAnimCallbacks: function(wrapper, callBackConfig) {
        wrapper.callBackConfig = callBackConfig || {};
        var startEvent, iterEvent, endEvent;
        if(kony.appinit.isFirefox || kony.appinit.isIE11) {
            startEvent = "animationstart";
            iterEvent = "animationiteration";
            endEvent = "animationend";
        } else {
            startEvent = $KU.animationStart;
            iterEvent = $KU.animationIteration;
            endEvent = $KU.animationEnd;
        }
        kony.events.addEventListener(wrapper, startEvent, this, false);
        kony.events.addEventListener(wrapper, iterEvent, this, false);
        kony.events.addEventListener(wrapper, endEvent, this, false);
    },

    handleEvent: function(event) {
        var node = event.target;
        if(!node.childNodes[0])
            return;

        var widgetModel = node.wModel;
        if(!widgetModel)
            return;

        
        switch(event.type) {
            case $KU.animationStart:
            case "animationstart":
                this.start(node);
                break;

            case $KU.animationIteration:
                this.move(node);
                break;

            case $KU.animationEnd:
            case "animationend":
                this.end(node);

        }
    },


    start: function(node) {
        var widgetModel = node.wModel;
        if($KG.appbehaviors["captureAniamtionData"]) {
            $KG.animataionData[this.animatorID].animationBeginTime = this.getAnimationTime();
        }
        
        var context = node.context;
        if(context) {
            var animInstance = context.instance;
            if(animInstance && typeof animInstance.startEventCounter != 'undefined') {
                animInstance.startEventCounter++;
                if(animInstance.animatableNodesCounter != animInstance.startEventCounter)
                    return;
            }
        }
        var eventhandler = node.callBackConfig && $KU.returnEventReference(node.callBackConfig.animationStart);
        this.execute(eventhandler, widgetModel);
    },

    move: function(node) {
        
    },

    end: function(node, eventhandler) {
        var widgetModel = node.wModel;
        var fillMode = node.fillMode;
        var direction = node.direction;
        var iterations = node.iterations;
        var context = node.context;

        if(!widgetModel)
            return;

        var animType;
        var needToUpdateModel = true;

        var flexprops = ["width", "height", "centerX", "centerY", "left", "top", "bottom", "right", "minWidth", "maxWidth", "minHeight", "maxHeight", "transform", "opacity", "zIndex", "anchorPoint", "backgroundColor", "shadowColor", "shadowRadius", "shadowOffset"];
        if($KG.appbehaviors["captureAniamtionData"]) {
            $KG.animataionData[this.animatorID].animationEndTime = this.getAnimationTime();
        }

        
        var applyFrame = [];
        if(fillMode == kony.anim.FILL_MODE_FORWARDS || fillMode == kony.anim.FILL_MODE_BOTH) {
            if(direction == kony.anim.DIRECTION_NONE) {
                applyFrame = widgetModel.originalFrames[100];
            } else if(direction == kony.anim.DIRECTION_ALTERNATE) {
                if(iterations % 2 == 0) {
                    applyFrame = widgetModel.originalFrames[0];
                } else {
                    applyFrame = widgetModel.originalFrames[100];
                }
            }
        }
        if(fillMode == kony.anim.FILL_MODE_BACKWARDS) {
            
            applyFrame = node.initialPosition;
        }

        for(var i in applyFrame) {
            if(flexprops.contains(i)) {
                widgetModel[i] = applyFrame[i];
            }
        }

        if(context) {
            animType = context.animType;
            var animInstance = context.instance;
            if(animInstance) {
                var action = animInstance.action;
                if(action == 'removeall' || action == 'removeat' || action == 'removesectionat')
                    needToUpdateModel = false;
            }
            needToUpdateModel && $KW.Segment.updateDataByContext(context, applyFrame);
        }

        this.removeListeners(node);
        
        if(fillMode != kony.anim.FILL_MODE_NONE && context && needToUpdateModel) {
            this.updateLayoutProps(widgetModel, node, applyFrame, animType);
        }

        if(fillMode != kony.anim.FILL_MODE_NONE && animType != 'segmentRow') {
            if(context)
                $KW.FlexUtils.updateLayoutConfig(widgetModel);
            if(widgetModel.parent.forceLayout) {
                if(context)
                    $KW.FlexContainer.forceLayout(widgetModel.parent, context.flexNode);
                else
                    widgetModel.parent.forceLayout();
            }
        }
        node.style[$KU.animation] = "";
        if($KG.appbehaviors["captureAniamtionData"]) {
            $KG.animataionData[this.animatorID].data["endFrame"] = widgetModel.frame;
        }
        if(widgetModel.wType == 'Image')
            delete widgetModel.animInfo;

        if(context) {
            var animInstance = context.instance;
            if(animInstance) {
                if(typeof animInstance.endEventCounter != 'undefined') {
                    animInstance.endEventCounter++;
                    if(animInstance.animatableNodesCounter != animInstance.endEventCounter)
                        return;
                }
                animInstance.onAnimationEnd && animInstance.onAnimationEnd(node);
            }
        }

        var eventhandler = node.callBackConfig && $KU.returnEventReference(node.callBackConfig.animationEnd);
        this.execute(eventhandler, widgetModel);
    },

    execute: function(eventhandler, widgetModel) {
        var animationHandle = {};
        eventhandler && setTimeout(function() {
            $KU.executeWidgetEventHandler(widgetModel, eventhandler, animationHandle);
            $KU.onEventHandler(widgetModel);
        }, 0)
    },

    updateLayoutProps: function(wModel, wNode, frameObj, animType) {
        var props = ['zIndex', 'opacity', 'transform', 'anchorPoint', 'backgroundColor'];
        if(wNode.context && wNode.context.containerModel.wType == 'CollectionView') {
            for(var property in frameObj) {
                var value = frameObj[property];
                var node = wNode.firstChild;
                if(value) {
                    wModel[property] = value;
                    if(props.indexOf(property) != -1) {
                        kony.model.updateLayoutProps(wModel, property.toLowerCase(), value, node, animType);
                    } else {
                        $KW.Utils.updateClonedModelData(wModel, wNode.context.containerModel, property);
                    }
                }
            }
            $KW.FlexUtils.isFlexContainer(wModel) && $KW.FlexContainer.forceLayout(wModel, wNode);
            var cvModel = wNode.context.containerModel;
            $KW.CollectionView.applyLineSpaceAndItemSpace(cvModel, $KW.Utils.getContentNodeFromNodeByModel(cvModel));
        } else {
            for(var i = 0; i < props.length; i++) {
                var prop = props[i];
                if(prop in frameObj) {
                    var node = wNode;
                    var value = frameObj[prop];
                    if(typeof value != 'undefined')
                        kony.model.updateLayoutProps(wModel, prop.toLowerCase(), value, node, animType);
                }
            }
            $KW.FlexUtils.isFlexContainer(wModel) && $KW.FlexContainer.forceLayout(wModel, wNode);
        }

    },

    removeListeners: function(target) {
        if(kony.appinit.isFirefox || kony.appinit.isIE11) {
            kony.events.removeEventListener(target, "animationstart", this, false);
            kony.events.removeEventListener(target, "animationiteration", this, false);
            kony.events.removeEventListener(target, "animationend", this, false);
        } else {
            kony.events.removeEventListener(target, $KU.animationStart, this, false);
            kony.events.removeEventListener(target, $KU.animationIteration, this, false);
            kony.events.removeEventListener(target, $KU.animationEnd, this, false);
        }

    },

    cancel: function(widgetModel) {
        
    },

    applyRowAnimation: function(rowNode, config, callbacks) {
        var widgetModel = rowNode.wModel;
        var animName = "anim_" + this.getNextAnimationValue();
        var animationDef = this.processRowAnimationKeyFrames(widgetModel, this.animationDef);
        this.createKeyFrames('', animationDef, animName, "rowFrame");
        var animConfig = this.getAnimConfig(config, rowNode);
        var animKey = $KU.animation;
        var animDef = animName + " " + animConfig;
        rowNode.style[animKey] = animDef;

        widgetModel.originalFrames = this.animationDef;
        this.saveWidgetState(widgetModel, rowNode, config);
        this.registerAnimCallbacks(rowNode, callbacks);
    },

    processRowAnimationKeyFrames: function(wModel, animDef) {
        var animFrame = {};
        for(var i in animDef) {
            var stepObj = animDef[i];
            stepFrame = {};
            for(j in stepObj) {
                stepFrame[j] = stepObj[j];
                if(j == "height") {
                    var resultObj = $KW.FlexUtils.getValueAndUnit(wModel, stepObj[j]);
                    stepFrame[j] = resultObj.value + resultObj.unit;
                }
            }
            animFrame[i] = stepFrame;
        }
        return animFrame;
    },

    getAnimationName: function(config, name) {
        var animName = name + "_" + this.getNextAnimationValue();
        this.createKeyFrames('', this.animationDef, animName, name + "Frame");
        var animConfig = this.getAnimConfig(config);
        var animKey = $KU.animation;
        return animName + " " + animConfig;
    }
};


$KW.Transform = function() {
    this.transform = {};
    this.is3D = false;
};

$KW.Transform.prototype = {
    rotate: function(angle) {
        if(angle == "undefined")
            angle = 0;
        if(angle <= 0)
            this.transform.rotate = "rotate(" + Math.abs(angle) + "deg) ";
        else
            this.transform.rotate = "rotate( -" + angle + "deg) ";
        return this;

    },

    translate: function(x, y) {
        if(x == "undefined")
            x = 0;
        if(y == "undefined")
            y = 0;
        var translate = {};
        translate.x = x;
        translate.y = y;
        this.transform.translate = "translate(" + translate.x + "px, " + translate.y + "px) ";
        return this;
    },

    scale: function(x, y) {
        if(x == "undefined")
            x = 1;
        if(y == "undefined")
            y = 1;
        this.transform.scale = "scale(" + x + ", " + y + ") ";
        return this;
    },

    
    setPerspective: function(p) {
        if(arguments.length < 1)
            throw new KonyError(101, "Transform3D Error", "Set perspective Exception: Incomplete input");
        else if(typeof p != "number" || p <= 0)
            throw new KonyError(100, "Transform3D Error", "Set perspective Exception: Invalid input.");

        this.transform.perspective = "perspective(" + p + "px) ";
        return this;
    },

    rotate3D: function(angle, x, y, z) {
        if(arguments.length < 4)
            throw new KonyError(101, "Transform3D Error", "Set rotate3D Exception: Incomplete input");
        if(typeof angle != "number" || typeof x != "number" || typeof y != "number" || typeof z != "number")
            throw new KonyError(100, "Transform3D Error", "Set rotate3D Exception: Invalid input.");
        if((x < 0 || x > 1) || (y < 0 || y > 1) || (z < 0 || z > 1))
            throw new KonyError(100, "Transform3D Error", "Set rotate3D Exception: Invalid input.");

        if(angle <= 0)
            angle = Math.abs(angle) + "deg";
        else
            angle = "-" + angle + "deg";

        this.transform.rotate = "rotate3d(" + x + ", " + y + ", " + z + ", " + angle + ") ";
        this.is3D = true;
        return this;
    },

    translate3D: function(x, y, z) {
        if(arguments.length < 3)
            throw new KonyError(101, "Transform3D Error", "Set translate3D Exception: Incomplete input");
        if(typeof x != "number" || typeof y != "number" || typeof z != "number")
            throw new KonyError(100, "Transform3D Error", "Set translate3D Exception: Invalid input.");

        this.transform.translate = "translate3d(" + x + "px, " + y + "px, " + z + "px) ";
        this.is3D = true;
        return this;
    },

    scale3D: function(x, y, z) {
        if(arguments.length < 3)
            throw new KonyError(101, "Transform3D Error", "Set scale3D Exception: Incomplete input");
        if(typeof x != "number" || typeof y != "number" || typeof z != "number")
            throw new KonyError(100, "Transform3D Error", "Set scale3D Exception: Invalid input.");
        
        

        this.transform.scale = "scale3d(" + x + ", " + y + ", " + z + ") ";
        this.is3D = true;
        return this;
    }
};

$KW.animUtils = {
    isTransform3D: function(frames) { 
        var have3D = false;
        if(!frames) return have3D;

        for(var i in frames) {
            if(frames[i].transform && frames[i].transform.is3D) {
                have3D = true;
                break;
            }
        }
        return have3D;
    },

    applyTransform: function(widgetModel, propertyValue) {
        if(!propertyValue) {
            
            
            return "";
        }

        var style = "";

        if(propertyValue.transform.perspective) 
            style += propertyValue.transform.perspective;
        if(propertyValue.transform.scale)
            style += propertyValue.transform.scale;
        if(propertyValue.transform.translate)
            style += propertyValue.transform.translate;
        if(propertyValue.transform.rotate)
            style += propertyValue.transform.rotate;

        return style;
    },

    AnimationDataComapre: function(mode) {
        if(mode == "record") {
            var recordedInfo = JSON.stringify($KG["animataionData"]);
            localStorage.setItem("animataionData", recordedInfo);
        } else if(mode == "play") {
            var recordedStr = localStorage.getItem("animataionData");
            var recordedInfo = JSON.parse(recordedStr);
            var capturedInfo = $KG["animataionData"];
            for(var anim in recordedInfo) {
                kony.web.logger("log", "Animation Testing for: " + recordedInfo[anim].animationID);
                var recordedData = recordedInfo[anim].data;
                var capturedData = capturedInfo[anim].data;

                for(var frames in recordedData) {
                    if(frames != "startFrame" && frames != "endFrame") {
                        if(recordedData[frames] == capturedData[frames]) {
                            kony.web.logger("log", "PASSED Frame is \n" + recordedData[frames] + " \n" + capturedData[frames]);
                        } else
                            kony.web.logger("log", "FAILED Frame is \n" + recordedData[frames] + " \n" + capturedData[frames]);
                    }
                }
            }

        }
    },

    getComputedShadowString: function(flexFrame) {
        var shadowColor = flexFrame.shadowColor || "#000000";
        var shadowRadius = (flexFrame.shadowRadius || 0) + "px ";
        var shadowOffsetX = (flexFrame.shadowOffset.x || 0) + "px ";
        var shadowOffsetY = (flexFrame.shadowOffset.y || 0) + "px ";
        if(flexFrame.shadowColor) {
            var validate = $KW.skins.validateHexValue(flexFrame.shadowColor);
            if(validate) {
                shadowColor = $KW.skins.convertHexValuetoRGBA(flexFrame.shadowColor);
            }
        }

        return shadowOffsetX + shadowOffsetY + shadowRadius + shadowColor;
    },

    parseGradientParams: function(gradientModel) {
        var stepGradientAnimation = "";
        var validate = (gradientModel.colors && gradientModel.colorStops) && (gradientModel.colors.length == gradientModel.colorStops.length);
        var angle = gradientModel.angle ? gradientModel.angle : "0";
        var prefix = $KU.cssPrefix;
        if(prefix == "-Moz-") {
            prefix = "";
        }
        angle += "deg";
        stepGradientAnimation += "background:" + prefix + "linear-gradient(" + angle;
        if(validate) {
            for(var j in gradientModel['colors']) {
                stepGradientAnimation += ", #" + gradientModel['colors'][j] + " " + gradientModel['colorStops'][j] + "%";
            }
        } else {
            kony.web.logger("warn", "colors or colorStops are either undefined or unequal in length");
        }
        return stepGradientAnimation += ");";
    }
};


$KI.themes = (function() {
    
    

    var module = {

        initialCssLoadDone: false,

        setcurrenttheme: function(themeid, successcallback, errorcallback) {
            var dwCssFile = "konydesktop.css", headTag = null, link = null,
                i = 0, cssFile = null, existingTag = null, linktags = null,
                currentTheme = null;

            $KU.logExecuting('kony.theme.setCurrentTheme');
            $KU.logExecutingWithParams('kony.theme.setCurrentTheme', themeid, successcallback, errorcallback);
            if(!($KU.inArray($KG["themes"], themeid, true))) {
                errorcallback();
                $KU.logExecutingFinished('kony.theme.setCurrentTheme VIA if !($KU.inArray($KG["themes"], themeid, true)) is true');
            } else  if(module.initialCssLoadDone && themeid == module.getcurrenttheme()) {
                successcallback();
                $KU.logExecutingFinished('kony.theme.setCurrentTheme VIA if themeid == module.getcurrenttheme() is true');
            } else {
                headTag = document.head;
                cssFile = $KG.platformver + (themeid == "default" ? '' : themeid+'/') + dwCssFile;
                if($KG[themeid+'remoteurl']) cssFile = $KG[themeid+'remoteurl'];
                currentTheme = $KG["theme"];
                if($KG[currentTheme+'remoteurl']) dwCssFile = $KG[currentTheme+'remoteurl'];
                link = document.createElement("link");
                link.rel = "stylesheet";
                link.type = "text/css";
                link.href = cssFile;
                if(module.initialCssLoadDone) {
                    link.onload = function() {
                        $KG["theme"] = themeid;
                        successcallback();
                    };
                    link.onerror = function() {
                        errorcallback();
                    };
                }

                linktags = headTag.querySelectorAll('link');
                for(i = 0;i < linktags.length; i++) {
                    if(linktags[i].href.indexOf(dwCssFile) >= 0) {
                       existingTag = linktags[i];
                       break;
                    }
                }
                if(existingTag != null) {
                    headTag.replaceChild(link, existingTag);
                } else {
                    existingTag = headTag.querySelector('style');
                    headTag.insertBefore(link, existingTag);
                }

                if(!module.initialCssLoadDone) {
                    module.initialCssLoadDone = true;
                    $KG["theme"] = themeid;
                    successcallback();
                }

                $KU.logExecutingFinished('kony.theme.setCurrentTheme return 3');
            }
        },

        deletetheme: function(theme, successcallback, errorcallback) {
            $KU.logExecuting('kony.theme.deleteTheme');
            $KU.logExecutingWithParams('kony.theme.deleteTheme', theme, successcallback, errorcallback);
            var themeList = $KG["themes"];
            var initialThemeListLength = themeList.length;
            var finalThemeListLength = themeList.length;
            try {
                for(var i = 0; i < themeList.length; i++) {
                    if(themeList[i] == theme)
                        themeList.splice(i, 1);
                }
                $KG["themes"] = themeList;
                if($KG["theme"] == theme) {
                    module.setcurrenttheme("default", successcallback, errorcallback);
                    $KU.logExecutingFinished('kony.theme.deleteTheme VIA if ($KG["theme"] == theme) is true');
                    return;
                }
                finalThemeListLength = themeList.length;
                $KU.logExecutingFinished('kony.theme.deleteTheme VIA end of the function');
                if(initialThemeListLength - 1 == finalThemeListLength)
                    successcallback();
                else
                    errorcallback();
            } catch(e) {
                $KU.logErrorMessage('Error' + e);
                errorcallback();
            }
        },

        isthemepresent: function(theme) {
            $KU.logExecuting('kony.theme.isThemePresent');
            $KU.logExecutingWithParams('kony.theme.isThemePresent', theme);
            $KU.logExecutingFinished('kony.theme.isThemePresent');
            return $KU.inArray($KG["themes"], theme, true);
        },

        createtheme: function(url, themeIdentifer, onsuccesscallback, onerrorcallback) {
            
            $KU.logExecuting('kony.theme.createTheme');
            $KU.logExecutingWithParams('kony.theme.createTheme', url, themeIdentifer, onsuccesscallback, onerrorcallback);
            if(($KU.inArray($KG["themes"], themeIdentifer, true))) {
                onsuccesscallback();
                $KU.logExecutingFinished('kony.theme.createTheme VIA if ($KU.inArray($KG["themes"], themeIdentifer, true)) is true');
                return;
            }
            try {
                var req = new XMLHttpRequest();
                var cssFile = url;
                req.open("GET", cssFile, true);
                req.timeout = 60000;
                var headTag = document.getElementsByTagName("head");
                $KG[themeIdentifer + 'remoteurl'] = url;

                req.onreadystatechange = function() {
                    if(this.readyState == 4) {
                        if(this.status == 200) {
                            $KG["themes"].push(themeIdentifer);
                            onsuccesscallback();
                            req = null;
                        } else {
                            onerrorcallback();
                        }

                    }
                };
                req.ontimeout = function() {
                    onerrorcallback();
                };
                req.send(null);
                $KU.logExecutingFinished('kony.theme.createTheme VIA try block');
            } catch(e) {
                $KU.logErrorMessage('Error ' + e);
                onerrorcallback();
            }
        },

        allthemes: function() {
            return $KG["themes"];
        },

        getcurrentthemedata: function() {
            $KU.logExecuting('kony.theme.getCurrentThemeData');
            $KU.logExecutingWithParams('kony.theme.getCurrentThemeData');
            $KU.logExecutingFinished('kony.theme.getCurrentThemeData');
            return true;
        },

        getcurrenttheme: function() {
            $KU.logExecuting('kony.theme.getCurrentTheme');
            $KU.logExecutingWithParams('kony.theme.getCurrentTheme');
            $KU.logExecutingFinished('kony.theme.getCurrentTheme');
            return $KG["theme"];
        },

        packagedthemes: function(list) {
            var themeArray = ['default'];
            if(IndexJL == 1) themeArray.push(null);
            for(var i = IndexJL; i < (list.length); i++) {
                themeArray.push(list[i]);
            }
            $KG["themes"] = themeArray;
            $KG["theme"] = "default";
        }
    };


    return module;
}());






$KI.crypto = (function() {
    
    var _generateRandomNumber = function(min, max) {
        min = Math.ceil(min);
        max = Math.floor(max);
        return Math.floor(Math.random() * (max - min + 1)) + min;
    };

    var _generateRandomString = function() {
        var randomLength = 0, randomString = '', i = 0,
            possibleString = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';

        randomLength = _generateRandomNumber(8, 16);
        for(i = 0; i < randomLength; i++) {
          randomString += possibleString.charAt(Math.floor(Math.random() * possibleString.length));
        }
        return randomString.toUpperCase();
    };

    var _createHashToUpperCase = function(algo, toHash) {
        var hashValueToUpperCase = $KI.crypto.createhash(algo, toHash);

        if(typeof hashValueToUpperCase == 'string') {
            hashValueToUpperCase = hashValueToUpperCase.toUpperCase();
        }
        return hashValueToUpperCase;
    };
    

    var module = {
        stringify: function(cipherParams) {
            
            var jsonObj = {
                ct: cipherParams.ciphertext.toString(CryptoJS.enc.Base64)
            };
            
            if(cipherParams.iv) {
                jsonObj.iv = cipherParams.iv.toString();
            }
            if(cipherParams.salt) {
                jsonObj.s = cipherParams.salt.toString();
            }
            
            return JSON.stringify(jsonObj);
        },

        parse: function(jsonStr) {
            
            var jsonObj = JSON.parse(jsonStr);
            
            var cipherParams = CryptoJS.lib.CipherParams.create({
                ciphertext: CryptoJS.enc.Base64.parse(jsonObj.ct)
            });
            
            if(jsonObj.iv) {
                cipherParams.iv = CryptoJS.enc.Hex.parse(jsonObj.iv)
            }
            if(jsonObj.s) {
                cipherParams.salt = CryptoJS.enc.Hex.parse(jsonObj.s)
            }
            return cipherParams;
        },

        
        createhash: function(algotype, inputmessage) {
            var msg;
            var statuscode;
            $KU.logExecuting('kony.crypto.createhash');
            if(typeof(inputmessage) != "string") {
                $KU.logErrorMessage('invalid input ' + inputmessage);
                return {
                    errcode: 100,
                    errmessage: "invalid input parameters"
                };
            }
            $KU.logExecutingWithParams('kony.crypto.createhash', algotype, inputmessage);
            try {
                switch(algotype.toLowerCase()) {
                    case "md5":
                        msg = CryptoJS.MD5(inputmessage);
                        break;
                    case "sha256":
                        msg = CryptoJS.SHA256(inputmessage);
                        break;
                    case "sha1":
                        msg = CryptoJS.SHA1(inputmessage);
                        break;
                    case "sha512":
                        msg = CryptoJS.SHA512(inputmessage);
                        break;
                    default:
                        $KU.logErrorMessage('unsupported algorithm');
                        msg = {
                            errcode: 101,
                            errmessage: "unsupported algorithm"
                        }
                        break;
                }
                if(typeof msg != 'string') {
                    msg = msg.toString(CryptoJS.enc.UTF8);
                }
                $KU.logExecutingFinished('kony.crypto.createhash');
                return msg;
            } catch(ex) {
                $KU.logErrorMessage('unknown error' + ex);
                return {
                    errcode: 102,
                    errmessage: "unknown  error"
                };
            }
        },

        encrypt: function(algo, generatedkey, inputstring, propertiesTable) {
            $KU.logExecuting('kony.crypto.encrypt');
            if(typeof(algo) != "string" && inputstring && generatedkey) {
                $KU.logErrorMessage('invalid input parameters');
                return {
                    errcode: 100,
                    errmessage: "invalid input parameters"
                };
            }
            $KU.logExecutingWithParams('kony.crypto.encrypt', algo, generatedkey, inputstring, propertiesTable);
            var mode = CryptoJS.mode.CBC;
            var padding = CryptoJS.pad.Pkcs7;
            try {
                if(propertiesTable) {
                    if(propertiesTable.mode) {
                        switch(propertiesTable.mode.toLowerCase()) {
                            case 'cfb':
                                mode = CryptoJS.mode.CFB;
                                break;
                            case 'ctr':
                                mode = CryptoJS.mode.CTR;
                                break;
                            case 'ofb':
                                mode = CryptoJS.mode.OFB;
                                break;
                            case 'ecb':
                                mode = CryptoJS.mode.ECB;
                                break;
                        }
                    }
                    if(propertiesTable.padding) {
                        switch(propertiesTable.padding.toLowerCase()) {
                            case 'iso97971':
                                padding = CryptoJS.pad.Iso97971;
                                break;
                            case 'iso10126':
                                padding = CryptoJS.pad.Iso10126;
                                break;
                            case 'zeropadding':
                                padding = CryptoJS.pad.ZeroPadding;
                                break;
                            case 'nopadding':
                                padding = CryptoJS.pad.NoPadding;
                                break;
                        }
                    }
                }
                if(algo.toLowerCase() == "aes") {
                    var encryptedObj = CryptoJS.AES.encrypt(inputstring, generatedkey, {
                        mode: mode,
                        padding: padding
                    });
                    $KU.logExecutingFinished('kony.crypto.encrypt VIA encrypting using AES algorithm');
                    return module.stringify(encryptedObj);
                } else if(algo.toLowerCase() == "tripledes") {
                    var encryptedObj = CryptoJS.TripleDES.encrypt(inputstring, generatedkey, {
                        mode: mode,
                        padding: padding,
                        format: module.JsonFormatter
                    });
                    $KU.logExecutingFinished('kony.crypto.encrypt VIA encrypting using TripleDES algorithm');
                    return module.stringify(encryptedObj);
                } else {
                    $KU.logErrorMessage('unsupported algorithm');
                    return {
                        errcode: 101,
                        errmessage: "unsupported algorithm"
                    };
                }
            } catch(ex) {
                $KU.logErrorMessage('unknown error');
                return {
                    errcode: 102,
                    errmessage: "unknown  error"
                };
            }
        },

        decrypt: function(algo, generatedkey, inputstring, propertiesTable) {
            $KU.logExecuting('kony.crypto.decrypt');
            if(typeof(algo) != "string" && inputstring && generatedkey) {
                $KU.logErrorMessage('invalid input parameters');
                return {
                    errcode: 100,
                    errmessage: "invalid input parameters"
                };
            }
            $KU.logExecutingWithParams('kony.crypto.decrypt', algo, generatedkey, inputstring, propertiesTable);
            var mode = CryptoJS.mode.CBC;
            var padding = CryptoJS.pad.Pkcs7;
            try {
                if(propertiesTable) {
                    if(propertiesTable.mode) {
                        switch(propertiesTable.mode.toLowerCase()) {
                            case 'cfb':
                                mode = CryptoJS.mode.CFB;
                                break;
                            case 'ctr':
                                mode = CryptoJS.mode.CTR;
                                break;
                            case 'ofb':
                                mode = CryptoJS.mode.OFB;
                                break;
                            case 'ecb':
                                mode = CryptoJS.mode.ECB;
                                break;
                        }
                    }
                    if(propertiesTable.padding) {
                        switch(propertiesTable.padding.toLowerCase()) {
                            case 'iso97971':
                                padding = CryptoJS.pad.Iso97971;
                                break;
                            case 'iso10126':
                                padding = CryptoJS.pad.Iso10126;
                                break;
                            case 'zeropadding':
                                padding = CryptoJS.pad.ZeroPadding;
                                break;
                            case 'nopadding':
                                padding = CryptoJS.pad.NoPadding;
                                break;
                        }
                    }
                }
                inputstring = module.parse(inputstring);
                if(algo.toLowerCase() == "aes") {
                    var message = CryptoJS.AES.decrypt(inputstring, generatedkey, {
                        mode: mode,
                        padding: padding
                    });
                    $KU.logExecutingFinished('kony.crypto.decrypt VIA decryting using AES algorithm');
                    return message.toString(CryptoJS.enc.Utf8)
                } else if(algo.toLowerCase() == "tripledes") {
                    var message = CryptoJS.TripleDES.decrypt(inputstring, generatedkey, {
                        mode: mode,
                        padding: padding
                    });
                    $KU.logExecutingFinished('kony.crypto.decrypt VIA decryting using TripleDES algorithm');
                    return message.toString(CryptoJS.enc.Utf8)
                } else {
                    $KU.logErrorMessage('unsupported algorithm');
                    return {
                        errcode: 101,
                        errmessage: "unsupported algorithm"
                    }
                }
            } catch(ex) {
                $KU.logErrorMessage('unknown  error' + ex);
                return {
                    errcode: 102,
                    errmessage: "unknown  error"
                }
            }
        },

        retrievepublickey: function() {
            $KU.logWarnMessage('retrievepublickey is not supported in SPA');
            return;
        },

        newkey: function(phrase, optionalBits, algoObject) {
            $KU.logExecuting('kony.crypto.newKey');
            try {
                if(phrase != "passphrase") {
                    $KU.logErrorMessage('invalid input parameters');
                    return {
                        errcode: 100,
                        errmessage: "invalid input parameters"
                    };
                } else if(!algoObject.subalgo) {
                    $KU.logErrorMessage('subalgo parameter is missing');
                    return {
                        errcode: 105,
                        errmessage: "subalgo parameter is missing"
                    };
                }
                $KU.logExecutingWithParams('kony.crypto.newKey', phrase, optionalBits, algoObject);
                if(algoObject.subalgo.toLowerCase() == "aes" || algoObject.subalgo.toLowerCase() == "tripledes") {
                    $KU.logExecutingFinished('kony.crypto.newKey');
                    return algoObject.passphrasetext[IndexJL];
                } else {
                    $KU.logErrorMessage('unsupported algorithm');
                    return {
                        errcode: 101,
                        errmessage: "unsupported algorithm"
                    };
                }
            } catch(ex) {
                $KU.logErrorMessage('unknown error' + ex);
                return {
                    errcode: 102,
                    errmessage: "unknown error"
                };
            }
        },

        savekey: function(name, key, metainfo) {
            $KU.logExecuting('kony.crypto.saveKey');
            if(name == undefined || key == undefined) {
                $KU.logErrorMessage('Invalid input parameters');
                return {
                    "errcode": 100,
                    "errmsg": "Invalid input parameters"
                };
            }
            $KU.logExecutingWithParams('kony.crypto.saveKey', name, key, metainfo);

            try {
                if(localStorage) {
                    try {
                        localStorage.setItem(name, JSON.stringify(key));
                        $KU.logExecutingFinished('kony.crypto.saveKey');
                        return name;
                    } catch(e) {
                        if(e.name == "QUOTA_EXCEEDED_ERR") {
                            var errcode = 0,
                                errmsg = "";
                            if(localStorage.length === 0) {
                                $KU.logErrorMessage('Private Browsing is switched ON');
                                errcode = 102;
                                errmsg = "Private Browsing is switched ON";
                            } else {
                                $KU.logErrorMessage('unable to save the key with the specified name');
                                errcode = 101;
                                errmsg = "unable to save the key with the specified name";
                            }

                            return {
                                "errcode": errcode,
                                "errmsg": errmsg
                            };
                        }
                    }
                } else {
                    $KU.logErrorMessage('unknown error, storage not supported');
                    return {
                        "errcode": 102,
                        "errmsg": "unknown error, storage not supported"
                    };
                }
            } catch(err) {
                $KU.logErrorMessage('unknown error ' + err);
            }
        },

        readkey: function(uniqid) {
            $KU.logExecuting('kony.crypto.readKey');
            if(uniqid == undefined) {
                $KU.logErrorMessage('Invalid input parameters');
                return {
                    "errcode": 100,
                    "errmsg": "Invalid input parameters"
                };
            }
            $KU.logExecutingWithParams('kony.crypto.readKey', uniqid);

            try {
                if(localStorage) {
                    var dataobj = JSON.parse(localStorage.getItem(uniqid) || "null");
                    if(dataobj == null) {
                        $KU.logErrorMessage('unable to find the key with the specified unique ID');
                        return {
                            "errcode": 101,
                            "errmsg": "unable to find the key with the specified unique ID"
                        };
                    } else
                        $KU.logExecutingFinished('kony.crypto.readKey');
                        return dataobj;
                } else {
                    kony.print("crypto readkey failed");
                    $KU.logErrorMessage('unknown error, storage not supported');
                    return {
                        "errcode": 102,
                        "errmsg": "unknown error, storage not supported"
                    };
                }

            } catch(err) {
                $KU.logErrorMessage('unknown error ' + err);
            }

        },

        deletekey: function(uniqid) {

            $KU.logExecuting('kony.crypto.deleteKey');
            $KU.logExecutingWithParams('kony.crypto.deleteKey', uniqid);
            try {
                if(localStorage)
                    localStorage.removeItem(uniqid);
                else
                    kony.print("crypto delete failed");
                $KU.logExecutingFinished('kony.crypto.deleteKey');
            } catch(err) {
                $KU.logErrorMessage('unknown error' + err);
            }
        },

        createHMacHash: function() {
            kony.web.logger("warn", "The createHMacHash API is not supported.");
        },

        createPBKDF2Key: function() {
            kony.web.logger("warn", "The createPBKDF2Key API is not supported.");
        },

        getRandomNumber: function(min, max) {
            return _generateRandomNumber(min, max);
        },

        generateRandomString: function() {
            return _generateRandomString();
        },

        createHashToUpperCase: function(algo, toHash) {
            return _createHashToUpperCase(algo, toHash);
        }
    };

    return module;
}());

if (!document.querySelectorAll) 
    document.querySelectorAll = function(selector){
        return $(selector);
    }
    
if (!document.querySelector || kony.appinit.isIE8) 
    document.querySelector = function(selector){
        var nodes = $(selector);
        return (nodes && nodes[0]) || null;
    }

try{	

if (typeof window.localStorage == 'undefined') 
    (function(){
        var localStorage = function(type){
            var        
            _storage = {}; 
            _storage_elm = null;
            _storage_service = {
                lStorage: "{}"
            };
            function _save(){
                try {
                    _storage_service.lStorage = JSON.stringify(_storage);
                    
                    if (_storage_elm) {
                        _storage_elm.setAttribute("lStorage", _storage_service.lStorage);
                        _storage_elm.save("lStorage");
                    }                    
                } 
                catch (e) {
                }
            }
            function init(){
                _storage_elm = document.createElement('link');
                if (_storage_elm.addBehavior) {
                    
                    _storage_elm.style.behavior = 'url(#default#userData)';
                    
                    document.getElementsByTagName('head')[0].appendChild(_storage_elm);
                    _storage_elm.load("lStorage");
                    var data = "{}";
                    try {
                        data = _storage_elm.getAttribute("lStorage");
                    } 
                    catch (e) {
                    }
                    _storage_service.lStorage = data;
                }
                else {                    
                    return;
                }
                _load_storage();
            }
            function _load_storage(){
                
                if (_storage_service.lStorage) {
                    try {
                        _storage = JSON.parse(String(_storage_service.lStorage));
                    } 
                    catch (e) {
                        _storage_service.lStorage = "{}";
                    }
                }                             
            }
            
            init();
            return {
                clear: function(){
                    _storage = {};
                    _save();
                },
                getItem: function(key){
                    return _storage[key];
                },
                key: function(i){
                    
                    var ctr = 0;
                    for (var k in _storage) {
                        if (ctr == i) 
                            return k;
                        else 
                            ctr++;
                    }
                    return null;
                },
                removeItem: function(key){
                    if (key in _storage) {
                        delete _storage[key];
                        _save();
                    }
                },
                setItem: function(key, value){
                    _storage[key] = value;
                    _save();
                }
            };
        };
        if (typeof window.localStorage == 'undefined') 
            window.localStorage = new localStorage();
    })();



if(typeof sessionStorage === "undefined")(function(window){



var 
    top = window
;
try {
    while(top !== top.top)
        top = top.top;
} catch(e) {
};


 var RC4 = (function(fromCharCode, random){
    return {

        
        decode:function(key, data){
            return this.encode(key, data);
        },

        
        encode:function(key, data){
            
            
            for(var
                length = key.length, len = data.length,
                decode = [], a = [],
                i = 0, j = 0, k = 0, l = 0, $;
                i < 256; ++i
            )   a[i] = i;
            for(i = 0; i < 256; ++i){
                j = (j + ($ = a[i]) + key.charCodeAt(i % length)) % 256;
                a[i] = a[j];
                a[j] = $;
            };
            for(j = 0; k < len; ++k){
                i = k % 256;
                j = (j + ($ = a[i])) % 256;
                length = a[i] = a[j];
                a[j] = $;
                decode[l++] = fromCharCode(data.charCodeAt(k) ^ a[(length + $) % 256]);
            };
            return decode.join("");
        },

        
        key:function(length){
            for(var i = 0, key = []; i < length; ++i)
                key[i] = fromCharCode(1 + ((random() * 255) << 0));
            return key.join("");
        }
    }
    
    
    
})(window.String.fromCharCode, window.Math.random);


var LSS = (function(window){

    
    function LSS(_storage, _key, _data){
        this._i = (this._data = _data || "").length;
        if(this._key = _key)
            this._storage = _storage;
        else {
            this._storage = {_key:_storage || ""};
            this._key = "_key";
        };
    };

    
    LSS.prototype.c = String.fromCharCode(1);

    
    LSS.prototype._c = ".";

    
    LSS.prototype.clear = function(){
        this._storage[this._key] = this._data;
    };

    
    LSS.prototype.del = function(key){
        var data = this.get(key);
        if(data !== null)
            this._storage[this._key] = this._storage[this._key].replace(escape.call(this, key, data), "");
    };

    
    LSS.prototype.escape   = window.escape;

    
    LSS.prototype.get = function(key){
        var _storage = this._storage[this._key],
            c = this.c,
            i = _storage.indexOf(key = c.concat(this._c, this.escape(key), c, c), this._i),
            data = null
        ;
        if(-1 < i){
            i = _storage.indexOf(c, i + key.length - 1) + 1;
            data = _storage.substring(i, i = _storage.indexOf(c, i));
            data = this.unescape(_storage.substr(++i, data));
        };
        return data;
    };

    
    LSS.prototype.key = function(){
        var _storage = this._storage[this._key],
            c = this.c,
            _c = c + this._c,
            i = this._i,
            data = [],
            length = 0,
            l = 0
        ;
        while(-1 < (i = _storage.indexOf(_c, i))){
            data[l++] = this.unescape(_storage.substring(i += 2, length = _storage.indexOf(c, i)));
            i = _storage.indexOf(c, length) + 2;
            length = _storage.indexOf(c, i);
            i = 1 + length + 1 * _storage.substring(i, length);
        };
        return data;
    };

    
    LSS.prototype.set = function(key, data){
        this.del(key);
        this._storage[this._key] += escape.call(this, key, data);
    };

    
    LSS.prototype.unescape = window.unescape;

    
    function escape(key, data){
        var c = this.c;
        return c.concat(this._c, this.escape(key), c, c, (data = this.escape(data)).length, c, data);
    };

    return LSS;

})(window);


 


if(Object.prototype.toString.call(window.opera) === "[object Opera]"){

    
    
    history.navigationMode="compatible";

    
    
    LSS.prototype.escape = window.encodeURIComponent;
    LSS.prototype.unescape = window.decodeURIComponent;
};



function sessionStorage(){
    
    
    
    
    
    function clear(){
        
        document.cookie = [
            "sessionStorage=" + window.encodeURIComponent($key = RC4.key(128))
        ].join(';');
        
        domain = RC4.encode($key, domain);
        
        LSS = new LSS(top, "name", top.name);
    };
    var 
        name = top.name,
        
        document = top.document,
        
        cookie = /\bsessionStorage\b=([^;]+)(;|$)/,
        
        data = cookie.exec(document.cookie),
        
        i
    ;
    
    if(data){
        
        $key = window.decodeURIComponent(data[1]);
        
        domain = RC4.encode($key, domain);
        
        LSS = new LSS(top, "name");
        
        for(var key = LSS.key(), i = 0, length = key.length, $cache = {}; i < length; ++i){
            if((data = key[i]).indexOf(domain) === 0){
                
                cache.push(data);
                $cache[data] = LSS.get(data);
                
                
                LSS.del(data);
            };
        };
        
        LSS = new LSS.constructor(top, "name", top.name);
        
        if(0 < (this.length = cache.length)){
            
            
            for(i = 0, length = cache.length, c = LSS.c, data = []; i < length; ++i)
                
                data[i] = c.concat(LSS._c, LSS.escape(key = cache[i]), c, c, (key = LSS.escape($cache[key])).length, c, key);
            top.name += data.join("");
        };
    } else {
        
        clear();
        
        if(!cookie.exec(document.cookie))
            
            cache = null;
    };
};


sessionStorage.prototype = {

    
    
    length:0,

    
    
    
    
    
    
    key:function(index){
        
        if(typeof index !== "number" || index < 0 || cache.length <= index)
            
            throw "Invalid argument";
        return cache[index];
    },

    
    
    
    getItem:function(key){
        
        
        key = domain + key;
        
        
        
        
        
        
        
        if(hasOwnProperty.call($cache, key))
            return $cache[key];
        
        var data = LSS.get(key);
        if(data !== null)
            
            data = $cache[key] = RC4.decode($key, data);
        return data;
    },

    
    
    
    
    
    setItem:function(key, data){
        
        this.removeItem(key);
        
        key = domain + key;
        
        LSS.set(key, RC4.encode($key, $cache[key] = "" + data));
        
        this.length = cache.push(key);
    },

    
    
    
    removeItem:function(key){
        var data = LSS.get(key = domain + key);
        if(data !== null){
            
            delete $cache[key];
            LSS.del(key);
            
            this.length = cache.remove(key);
        };
    },

    
    
    clear:function(){
        LSS.clear();
        $cache = {};
        cache.length = 0;
    }
};


var
    
    domain = top.document.domain,

    
    cache = [],

    
    $cache = {}, hasOwnProperty = $cache.hasOwnProperty,

    
    $key
;



cache.remove = function(data){
    var i = this.indexOf(data);
    if(-1 < i)
        this.splice(i, 1);
    return this.length;
};


if(!cache.indexOf) cache.indexOf = function(data){
        for(var i = 0, length = this.length; i < length; ++i){
            if(this[i] === data)
                return i;
        };
        return -1;
    };



if(top.sessionStorage){
    
    sessionStorage = function(){};
    sessionStorage.prototype = top.sessionStorage;
};

sessionStorage = new sessionStorage;


if(cache !== null)
    
    window.sessionStorage = sessionStorage;

})(window);
}catch(e){}

kony.worker = (function() {
    
    

    var module = {
        
        WorkerThread: function(sURL, fDefListener, fOnError) {
            $KU.logExecuting('kony.worker.WorkerThread');
            if(sURL === undefined || sURL === null || sURL === '') {
                $KU.logErrorMessage('Invalid parameters');
                throw new KonyError(3001, "WorkerThreadError", "WorkerThread: MissingMandatoryParameter. Failed to construct WorkerThread");
            }
            if(typeof sURL !== "string") {
                $KU.logErrorMessage('Invalid parameters');
                throw new KonyError(3002, "WorkerThreadError", "WorkerThread: InvalidParameter. Invalid script name");
            }
            $KU.logExecutingWithParams('kony.worker.WorkerThread', sURL, fDefListener, fOnError);
            var oInstance = this,
                workerBasePath = kony.appinit.getStaticContentPath() + $KG["platformver"] + "appjs/";
            
            if(typeof nestedWorker === "undefined") {
                this.oWorker = new Worker(workerBasePath + "konyworkerinit.js");
            } else {
                this.oWorker = new Worker("konyworkerinit.js");
            }

            var kgAppMode = $KG["appmode"] || "";
            var kgAppID = $KG["appid"] || "";
            var kgSkipProxy = $KG["skipproxy"] || "";
            var kgRcid = $KG["rcid"] || "";
            var isFMSupported = false;
            var kgUserAgent = kony.os.userAgent();
            if(typeof $KG["functionalModules"] !== "undefined")
                isFMSupported = true;

            
            this.oWorker.postMessage({
                    moduleName: sURL,
                    contextPath: workerBasePath,
                    kgAppMode: kgAppMode,
                    kgAppID: kgAppID,
                    kgSkipProxy: kgSkipProxy,
                    kgRcid: kgRcid,
                    isFMSupported: isFMSupported,
                    kgUserAgent: kgUserAgent
                }),
                
                oInstance.defaultListener = fDefListener || function(event) {
                    kony.print("Data: " + event.data)
                };
            
            oInstance.defaultErrorListener = fOnError || function(e) {
                kony.print(e.message + " : in file - " + e.filename + " at location :" + e.lineno + "," + e.colno);
            };
            this.oWorker.addEventListener("error", oInstance.defaultErrorListener);


            
            $KU.logExecutingFinished('kony.worker.WorkerThread');
        },

        hasWorkerThreadSupport: function() {
            $KU.logExecuting('kony.worker.hasWorkerThreadSupport');
            $KU.logExecutingWithParams('kony.worker.hasWorkerThreadSupport');
            if(typeof Worker === "undefined") {
                $KU.logErrorMessage('Worker not defined');
                return false;
            }
            $KU.logExecutingFinished('kony.worker.hasWorkerThreadSupport');
            return true;
        }
    };

    
    module.WorkerThread.prototype.postMessage = function(vMsg) {
        $KU.logExecuting('worker.postMessage');
        if(vMsg === undefined || vMsg === null || vMsg === '') {
            $KU.logErrorMessage('postMessage: MissingMandatoryParameter. Message undefined');
            throw new KonyError(3001, "WorkerThreadError", "postMessage: MissingMandatoryParameter. Message undefined");
        }
        if(typeof vMsg === "number" || typeof vMsg === "boolean" || typeof vMsg === "function") {
            $KU.logErrorMessage('postMessage: InvalidParameter. Invalid Message');
            throw new KonyError(3002, "WorkerThreadError", "postMessage: InvalidParameter. Invalid Message");
        }
        $KU.logExecutingWithParams('worker.postMessage', vMsg);
        try {
            Worker.prototype.postMessage.call(this.oWorker, vMsg);
            $KU.logExecutingFinished('worker.postMessage');
        } catch(err) {
            $KU.logErrorMessage('postMessage: InvalidParameter. Invalid Message');
            kony.print("Error occured in WorkerThread postMessage: " + err.message);
            throw new KonyError(3002, "WorkerThreadError", "postMessage: InvalidParameter. Invalid Message");
        }
    };

    
    module.WorkerThread.prototype.terminate = function() {
        $KU.logExecuting('worker.terminate');
        $KU.logExecutingWithParams('worker.terminate');
        Worker.prototype.terminate.call(this.oWorker);
        $KU.logExecutingFinished('worker.terminate');
    };

    
    module.WorkerThread.prototype.addEventListener = function(sName, fListener) {
        $KU.logExecuting('worker.addEventListener');
        if(arguments.length < 2) {
            $KU.logErrorMessage('addEventListener: MissingMandatoryParameter. Mandatory arguments missing');
            throw new KonyError(3001, "WorkerThreadError", "addEventListener: MissingMandatoryParameter. Mandatory arguments missing"); 
        }
        if(typeof arguments[0] != "string" || typeof arguments[1] != "function") {
            $KU.logErrorMessage('addEventListener: InvalidParameter. Invalid arguments');
            throw new KonyError(3002, "WorkerThreadError", "addEventListener: InvalidParameter. Invalid arguments");
        }
        if(sName != "message" && sName != "error") {
            $KU.logErrorMessage('addEventListener: InvalidParameter. Invalid arguments');
            throw new KonyError(3002, "WorkerThreadError", "addEventListener: InvalidParameter. Invalid arguments");
        }
        $KU.logExecutingWithParams('worker.addEventListener', sName, fListener);
        fListener = fListener ? fListener : this.defaultListener;
        Worker.prototype.addEventListener.call(this.oWorker, sName, fListener, false);
        if("error" === sName) {
            Worker.prototype.removeEventListener.call(this.oWorker, "error", this.defaultErrorListener, false);
        }
        $KU.logExecutingFinished('worker.addEventListener');
    };

    
    module.WorkerThread.prototype.removeEventListener = function(sName, fListener) {
        $KU.logExecuting('worker.removeEventListener');
        if(arguments.length < 2) {
            $KU.logErrorMessage('removeEventListener: MissingMandatoryParameter. Mandatory arguments missing');
            throw new KonyError(3001, "WorkerThreadError", "removeEventListener: MissingMandatoryParameter. Mandatory arguments missing"); 
        }
        if(typeof arguments[0] != "string" || typeof arguments[1] != "function") {
            $KU.logErrorMessage('removeEventListener: InvalidParameter. Invalid arguments');
            throw new KonyError(3002, "WorkerThreadError", "removeEventListener: InvalidParameter. Invalid arguments");
        }
        if(sName != "message" && sName != "error") {
            $KU.logErrorMessage('removeEventListener: InvalidParameter. Invalid arguments');
            throw new KonyError(3002, "WorkerThreadError", "removeEventListener: InvalidParameter. Invalid arguments");
        }
        $KU.logExecutingWithParams('worker.removeEventListener', sName, fListener);
        Worker.prototype.removeEventListener.call(this.oWorker, sName, fListener, false);
        if("error" === sName) {
            Worker.prototype.addEventListener.call(this.oWorker, "error", this.defaultErrorListener, false);
        }
        $KU.logExecutingFinished('worker.removeEventListener');
    };


    return module;
}());


var requirejs,require,define;(function(global){var req,s,head,baseElement,dataMain,src,interactiveScript,currentlyAddingScript,mainScript,subPath,version="2.2.0",commentRegExp=/(\/\*([\s\S]*?)\*\/|([^:]|^)\/\/(.*)$)/mg,cjsRequireRegExp=/[^.]\s*require\s*\(\s*["']([^'"\s]+)["']\s*\)/g,jsSuffixRegExp=/\.js$/,currDirRegExp=/^\.\//,op=Object.prototype,ostring=op.toString,hasOwn=op.hasOwnProperty,isBrowser=!!(typeof window!=="undefined"&&typeof navigator!=="undefined"&&window.document),isWebWorker=!isBrowser&&typeof importScripts!=="undefined",readyRegExp=isBrowser&&navigator.platform==="PLAYSTATION 3"?/^complete$/:/^(complete|loaded)$/,defContextName="_",isOpera=typeof opera!=="undefined"&&opera.toString()==="[object Opera]",contexts={},cfg={},globalDefQueue=[],useInteractive=false;function commentReplace(match,multi,multiText,singlePrefix){return singlePrefix||""}function isFunction(it){return ostring.call(it)==="[object Function]"}function isArray(it){return ostring.call(it)==="[object Array]"}function each(ary,func){if(ary){var i;for(i=0;i<ary.length;i+=1){if(ary[i]&&func(ary[i],i,ary)){break}}}}function eachReverse(ary,func){if(ary){var i;for(i=ary.length-1;i>-1;i-=1){if(ary[i]&&func(ary[i],i,ary)){break}}}}function hasProp(obj,prop){return hasOwn.call(obj,prop)}function getOwn(obj,prop){return hasProp(obj,prop)&&obj[prop]}function eachProp(obj,func){var prop;for(prop in obj){if(hasProp(obj,prop)){if(func(obj[prop],prop)){break}}}}function mixin(target,source,force,deepStringMixin){if(source){eachProp(source,function(value,prop){if(force||!hasProp(target,prop)){if(deepStringMixin&&typeof value==="object"&&value&&!isArray(value)&&!isFunction(value)&&!(value instanceof RegExp)){if(!target[prop]){target[prop]={}}mixin(target[prop],value,force,deepStringMixin)}else{target[prop]=value}}})}return target}function bind(obj,fn){return function(){return fn.apply(obj,arguments)}}function scripts(){return document.getElementsByTagName("script")}function defaultOnError(err){throw err}function getGlobal(value){if(!value){return value}var g=global;each(value.split("."),function(part){g=g[part]});return g}function makeError(id,msg,err,requireModules){var e=new Error(msg+"\nhttp://requirejs.org/docs/errors.html#"+id);e.requireType=id;e.requireModules=requireModules;if(err){e.originalError=err}return e}if(typeof define!=="undefined"){return}if(typeof requirejs!=="undefined"){if(isFunction(requirejs)){return}cfg=requirejs;requirejs=undefined}if(typeof require!=="undefined"&&!isFunction(require)){cfg=require;require=undefined}function newContext(contextName){var inCheckLoaded,Module,context,handlers,checkLoadedTimeoutId,config={waitSeconds:120,baseUrl:"./",paths:{},bundles:{},pkgs:{},shim:{},config:{}},registry={},enabledRegistry={},undefEvents={},defQueue=[],defined={},urlFetched={},bundlesMap={},requireCounter=1,unnormalizedCounter=1;function trimDots(ary){var i,part;for(i=0;i<ary.length;i++){part=ary[i];if(part==="."){ary.splice(i,1);i-=1}else{if(part===".."){if(i===0||(i===1&&ary[2]==="..")||ary[i-1]===".."){continue}else{if(i>0){ary.splice(i-1,2);i-=2}}}}}}function normalize(name,baseName,applyMap){var pkgMain,mapValue,nameParts,i,j,nameSegment,lastIndex,foundMap,foundI,foundStarMap,starI,normalizedBaseParts,baseParts=(baseName&&baseName.split("/")),map=config.map,starMap=map&&map["*"];if(name){name=name.split("/");lastIndex=name.length-1;if(config.nodeIdCompat&&jsSuffixRegExp.test(name[lastIndex])){name[lastIndex]=name[lastIndex].replace(jsSuffixRegExp,"")}if(name[0].charAt(0)==="."&&baseParts){normalizedBaseParts=baseParts.slice(0,baseParts.length-1);name=normalizedBaseParts.concat(name)}trimDots(name);name=name.join("/")}if(applyMap&&map&&(baseParts||starMap)){nameParts=name.split("/");outerLoop:for(i=nameParts.length;i>0;i-=1){nameSegment=nameParts.slice(0,i).join("/");if(baseParts){for(j=baseParts.length;j>0;j-=1){mapValue=getOwn(map,baseParts.slice(0,j).join("/"));if(mapValue){mapValue=getOwn(mapValue,nameSegment);if(mapValue){foundMap=mapValue;foundI=i;break outerLoop}}}}if(!foundStarMap&&starMap&&getOwn(starMap,nameSegment)){foundStarMap=getOwn(starMap,nameSegment);starI=i}}if(!foundMap&&foundStarMap){foundMap=foundStarMap;foundI=starI}if(foundMap){nameParts.splice(0,foundI,foundMap);name=nameParts.join("/")}}pkgMain=getOwn(config.pkgs,name);return pkgMain?pkgMain:name}function removeScript(name){if(isBrowser){each(scripts(),function(scriptNode){if(scriptNode.getAttribute("data-requiremodule")===name&&scriptNode.getAttribute("data-requirecontext")===context.contextName){scriptNode.parentNode.removeChild(scriptNode);return true}})}}function hasPathFallback(id){var pathConfig=getOwn(config.paths,id);if(pathConfig&&isArray(pathConfig)&&pathConfig.length>1){pathConfig.shift();context.require.undef(id);context.makeRequire(null,{skipMap:true})([id]);return true}}function splitPrefix(name){var prefix,index=name?name.indexOf("!"):-1;if(index>-1){prefix=name.substring(0,index);name=name.substring(index+1,name.length)}return[prefix,name]}function makeModuleMap(name,parentModuleMap,isNormalized,applyMap){var url,pluginModule,suffix,nameParts,prefix=null,parentName=parentModuleMap?parentModuleMap.name:null,originalName=name,isDefine=true,normalizedName="";if(!name){isDefine=false;name="_@r"+(requireCounter+=1)}nameParts=splitPrefix(name);prefix=nameParts[0];name=nameParts[1];if(prefix){prefix=normalize(prefix,parentName,applyMap);pluginModule=getOwn(defined,prefix)}if(name){if(prefix){if(pluginModule&&pluginModule.normalize){normalizedName=pluginModule.normalize(name,function(name){return normalize(name,parentName,applyMap)})}else{normalizedName=name.indexOf("!")===-1?normalize(name,parentName,applyMap):name}}else{normalizedName=normalize(name,parentName,applyMap);nameParts=splitPrefix(normalizedName);prefix=nameParts[0];normalizedName=nameParts[1];isNormalized=true;url=context.nameToUrl(normalizedName)}}suffix=prefix&&!pluginModule&&!isNormalized?"_unnormalized"+(unnormalizedCounter+=1):"";return{prefix:prefix,name:normalizedName,parentMap:parentModuleMap,unnormalized:!!suffix,url:url,originalName:originalName,isDefine:isDefine,id:(prefix?prefix+"!"+normalizedName:normalizedName)+suffix}}function getModule(depMap){var id=depMap.id,mod=getOwn(registry,id);if(!mod){mod=registry[id]=new context.Module(depMap)}return mod}function on(depMap,name,fn){var id=depMap.id,mod=getOwn(registry,id);if(hasProp(defined,id)&&(!mod||mod.defineEmitComplete)){if(name==="defined"){fn(defined[id])}}else{mod=getModule(depMap);if(mod.error&&name==="error"){fn(mod.error)}else{mod.on(name,fn)}}}function onError(err,errback){var ids=err.requireModules,notified=false;if(errback){errback(err)}else{each(ids,function(id){var mod=getOwn(registry,id);if(mod){mod.error=err;if(mod.events.error){notified=true;mod.emit("error",err)}}});if(!notified){req.onError(err)}}}function takeGlobalQueue(){if(globalDefQueue.length){each(globalDefQueue,function(queueItem){var id=queueItem[0];if(typeof id==="string"){context.defQueueMap[id]=true}defQueue.push(queueItem)});globalDefQueue=[]}}handlers={require:function(mod){if(mod.require){return mod.require}else{return(mod.require=context.makeRequire(mod.map))}},exports:function(mod){mod.usingExports=true;if(mod.map.isDefine){if(mod.exports){return(defined[mod.map.id]=mod.exports)}else{return(mod.exports=defined[mod.map.id]={})}}},module:function(mod){if(mod.module){return mod.module}else{return(mod.module={id:mod.map.id,uri:mod.map.url,config:function(){return getOwn(config.config,mod.map.id)||{}},exports:mod.exports||(mod.exports={})})}}};function cleanRegistry(id){delete registry[id];delete enabledRegistry[id]}function breakCycle(mod,traced,processed){var id=mod.map.id;if(mod.error){mod.emit("error",mod.error)}else{traced[id]=true;each(mod.depMaps,function(depMap,i){var depId=depMap.id,dep=getOwn(registry,depId);if(dep&&!mod.depMatched[i]&&!processed[depId]){if(getOwn(traced,depId)){mod.defineDep(i,defined[depId]);mod.check()}else{breakCycle(dep,traced,processed)}}});processed[id]=true}}function checkLoaded(){var err,usingPathFallback,waitInterval=config.waitSeconds*1000,expired=waitInterval&&(context.startTime+waitInterval)<new Date().getTime(),noLoads=[],reqCalls=[],stillLoading=false,needCycleCheck=true;if(inCheckLoaded){return}inCheckLoaded=true;eachProp(enabledRegistry,function(mod){var map=mod.map,modId=map.id;if(!mod.enabled){return}if(!map.isDefine){reqCalls.push(mod)}if(!mod.error){if(!mod.inited&&expired){if(hasPathFallback(modId)){usingPathFallback=true;stillLoading=true}else{noLoads.push(modId);removeScript(modId)}}else{if(!mod.inited&&mod.fetched&&map.isDefine){stillLoading=true;if(!map.prefix){return(needCycleCheck=false)}}}}});if(expired&&noLoads.length){err=makeError("timeout","Load timeout for modules: "+noLoads,null,noLoads);err.contextName=context.contextName;return onError(err)}if(needCycleCheck){each(reqCalls,function(mod){breakCycle(mod,{},{})})}if((!expired||usingPathFallback)&&stillLoading){if((isBrowser||isWebWorker)&&!checkLoadedTimeoutId){checkLoadedTimeoutId=setTimeout(function(){checkLoadedTimeoutId=0;checkLoaded()},50)}}inCheckLoaded=false}Module=function(map){this.events=getOwn(undefEvents,map.id)||{};this.map=map;this.shim=getOwn(config.shim,map.id);this.depExports=[];this.depMaps=[];this.depMatched=[];this.pluginMaps={};this.depCount=0};Module.prototype={init:function(depMaps,factory,errback,options){options=options||{};if(this.inited){return}this.factory=factory;if(errback){this.on("error",errback)}else{if(this.events.error){errback=bind(this,function(err){this.emit("error",err)})}}this.depMaps=depMaps&&depMaps.slice(0);this.errback=errback;this.inited=true;this.ignore=options.ignore;if(options.enabled||this.enabled){this.enable()}else{this.check()}},defineDep:function(i,depExports){if(!this.depMatched[i]){this.depMatched[i]=true;this.depCount-=1;this.depExports[i]=depExports}},fetch:function(){if(this.fetched){return}this.fetched=true;context.startTime=(new Date()).getTime();var map=this.map;if(this.shim){context.makeRequire(this.map,{enableBuildCallback:true})(this.shim.deps||[],bind(this,function(){return map.prefix?this.callPlugin():this.load()}))}else{return map.prefix?this.callPlugin():this.load()}},load:function(){var url=this.map.url;if(!urlFetched[url]){urlFetched[url]=true;context.load(this.map.id,url)}},check:function(){if(!this.enabled||this.enabling){return}var err,cjsModule,id=this.map.id,depExports=this.depExports,exports=this.exports,factory=this.factory;if(!this.inited){if(!hasProp(context.defQueueMap,id)){this.fetch()}}else{if(this.error){this.emit("error",this.error)}else{if(!this.defining){this.defining=true;if(this.depCount<1&&!this.defined){if(isFunction(factory)){if((this.events.error&&this.map.isDefine)||req.onError!==defaultOnError){try{exports=context.execCb(id,factory,depExports,exports)}catch(e){err=e}}else{exports=context.execCb(id,factory,depExports,exports)}if(this.map.isDefine&&exports===undefined){cjsModule=this.module;if(cjsModule){exports=cjsModule.exports}else{if(this.usingExports){exports=this.exports}}}if(err){err.requireMap=this.map;err.requireModules=this.map.isDefine?[this.map.id]:null;err.requireType=this.map.isDefine?"define":"require";return onError((this.error=err))}}else{exports=factory}this.exports=exports;if(this.map.isDefine&&!this.ignore){defined[id]=exports;if(req.onResourceLoad){var resLoadMaps=[];each(this.depMaps,function(depMap){resLoadMaps.push(depMap.normalizedMap||depMap)});req.onResourceLoad(context,this.map,resLoadMaps)}}cleanRegistry(id);this.defined=true}this.defining=false;if(this.defined&&!this.defineEmitted){this.defineEmitted=true;this.emit("defined",this.exports);this.defineEmitComplete=true}}}}},callPlugin:function(){var map=this.map,id=map.id,pluginMap=makeModuleMap(map.prefix);this.depMaps.push(pluginMap);on(pluginMap,"defined",bind(this,function(plugin){var load,normalizedMap,normalizedMod,bundleId=getOwn(bundlesMap,this.map.id),name=this.map.name,parentName=this.map.parentMap?this.map.parentMap.name:null,localRequire=context.makeRequire(map.parentMap,{enableBuildCallback:true});if(this.map.unnormalized){if(plugin.normalize){name=plugin.normalize(name,function(name){return normalize(name,parentName,true)})||""}normalizedMap=makeModuleMap(map.prefix+"!"+name,this.map.parentMap);on(normalizedMap,"defined",bind(this,function(value){this.map.normalizedMap=normalizedMap;this.init([],function(){return value},null,{enabled:true,ignore:true})}));normalizedMod=getOwn(registry,normalizedMap.id);if(normalizedMod){this.depMaps.push(normalizedMap);if(this.events.error){normalizedMod.on("error",bind(this,function(err){this.emit("error",err)}))}normalizedMod.enable()}return}if(bundleId){this.map.url=context.nameToUrl(bundleId);this.load();return}load=bind(this,function(value){this.init([],function(){return value},null,{enabled:true})});load.error=bind(this,function(err){this.inited=true;this.error=err;err.requireModules=[id];eachProp(registry,function(mod){if(mod.map.id.indexOf(id+"_unnormalized")===0){cleanRegistry(mod.map.id)}});onError(err)});load.fromText=bind(this,function(text,textAlt){var moduleName=map.name,moduleMap=makeModuleMap(moduleName),hasInteractive=useInteractive;if(textAlt){text=textAlt}if(hasInteractive){useInteractive=false}getModule(moduleMap);if(hasProp(config.config,id)){config.config[moduleName]=config.config[id]}try{req.exec(text)}catch(e){return onError(makeError("fromtexteval","fromText eval for "+id+" failed: "+e,e,[id]))}if(hasInteractive){useInteractive=true}this.depMaps.push(moduleMap);context.completeLoad(moduleName);localRequire([moduleName],load)});plugin.load(map.name,localRequire,load,config)}));context.enable(pluginMap,this);this.pluginMaps[pluginMap.id]=pluginMap},enable:function(){enabledRegistry[this.map.id]=this;this.enabled=true;this.enabling=true;each(this.depMaps,bind(this,function(depMap,i){var id,mod,handler;if(typeof depMap==="string"){depMap=makeModuleMap(depMap,(this.map.isDefine?this.map:this.map.parentMap),false,!this.skipMap);this.depMaps[i]=depMap;handler=getOwn(handlers,depMap.id);if(handler){this.depExports[i]=handler(this);return}this.depCount+=1;on(depMap,"defined",bind(this,function(depExports){if(this.undefed){return}this.defineDep(i,depExports);this.check()}));if(this.errback){on(depMap,"error",bind(this,this.errback))}else{if(this.events.error){on(depMap,"error",bind(this,function(err){this.emit("error",err)}))}}}id=depMap.id;mod=registry[id];if(!hasProp(handlers,id)&&mod&&!mod.enabled){context.enable(depMap,this)}}));eachProp(this.pluginMaps,bind(this,function(pluginMap){var mod=getOwn(registry,pluginMap.id);if(mod&&!mod.enabled){context.enable(pluginMap,this)}}));this.enabling=false;this.check()},on:function(name,cb){var cbs=this.events[name];if(!cbs){cbs=this.events[name]=[]}cbs.push(cb)},emit:function(name,evt){each(this.events[name],function(cb){cb(evt)});if(name==="error"){delete this.events[name]}}};function callGetModule(args){if(!hasProp(defined,args[0])){getModule(makeModuleMap(args[0],null,true)).init(args[1],args[2],null,{enabled:true})}}function removeListener(node,func,name,ieName){if(node.detachEvent&&!isOpera){if(ieName){node.detachEvent(ieName,func)}}else{node.removeEventListener(name,func,false)}}function getScriptData(evt){var node=evt.currentTarget||evt.srcElement;removeListener(node,context.onScriptLoad,"load","onreadystatechange");removeListener(node,context.onScriptError,"error");return{node:node,id:node&&node.getAttribute("data-requiremodule")}}function intakeDefines(){var args;takeGlobalQueue();while(defQueue.length){args=defQueue.shift();if(args[0]===null){return onError(makeError("mismatch","Mismatched anonymous define() module: "+args[args.length-1]))}else{callGetModule(args)}}context.defQueueMap={}}context={config:config,contextName:contextName,registry:registry,defined:defined,urlFetched:urlFetched,defQueue:defQueue,defQueueMap:{},Module:Module,makeModuleMap:makeModuleMap,nextTick:req.nextTick,onError:onError,configure:function(cfg){if(cfg.baseUrl){if(cfg.baseUrl.charAt(cfg.baseUrl.length-1)!=="/"){cfg.baseUrl+="/"}}if(typeof cfg.urlArgs==="string"){var urlArgs=cfg.urlArgs;cfg.urlArgs=function(id,url){return(url.indexOf("?")===-1?"?":"&")+urlArgs}}var shim=config.shim,objs={paths:true,bundles:true,config:true,map:true};eachProp(cfg,function(value,prop){if(objs[prop]){if(!config[prop]){config[prop]={}}mixin(config[prop],value,true,true)}else{config[prop]=value}});if(cfg.bundles){eachProp(cfg.bundles,function(value,prop){each(value,function(v){if(v!==prop){bundlesMap[v]=prop}})})}if(cfg.shim){eachProp(cfg.shim,function(value,id){if(isArray(value)){value={deps:value}}if((value.exports||value.init)&&!value.exportsFn){value.exportsFn=context.makeShimExports(value)}shim[id]=value});config.shim=shim}if(cfg.packages){each(cfg.packages,function(pkgObj){var location,name;pkgObj=typeof pkgObj==="string"?{name:pkgObj}:pkgObj;name=pkgObj.name;location=pkgObj.location;if(location){config.paths[name]=pkgObj.location}config.pkgs[name]=pkgObj.name+"/"+(pkgObj.main||"main").replace(currDirRegExp,"").replace(jsSuffixRegExp,"")})}eachProp(registry,function(mod,id){if(!mod.inited&&!mod.map.unnormalized){mod.map=makeModuleMap(id,null,true)}});if(cfg.deps||cfg.callback){context.require(cfg.deps||[],cfg.callback)}},makeShimExports:function(value){function fn(){var ret;if(value.init){ret=value.init.apply(global,arguments)}return ret||(value.exports&&getGlobal(value.exports))}return fn},makeRequire:function(relMap,options){options=options||{};function localRequire(deps,callback,errback){var id,map,requireMod;if(options.enableBuildCallback&&callback&&isFunction(callback)){callback.__requireJsBuild=true}if(typeof deps==="string"){if(isFunction(callback)){return onError(makeError("requireargs","Invalid require call"),errback)}if(relMap&&hasProp(handlers,deps)){return handlers[deps](registry[relMap.id])}if(req.get){return req.get(context,deps,relMap,localRequire)}map=makeModuleMap(deps,relMap,false,true);id=map.id;if(!hasProp(defined,id)){if(isWebWorker){requireMod=getModule(makeModuleMap(null,relMap));requireMod.init([id],function(){},function(){},{enabled:true})}else{context.completeLoad(id);if(!defined[id]){return onError(makeError("notloaded",'Module name "'+id+'" has not been loaded yet for context: '+contextName+(relMap?"":". Use require([])")))}}}return defined[id]}intakeDefines();context.nextTick(function(){intakeDefines();requireMod=getModule(makeModuleMap(null,relMap));requireMod.skipMap=options.skipMap;requireMod.init(deps,callback,errback,{enabled:true});checkLoaded()});return localRequire}mixin(localRequire,{isBrowser:isBrowser,toUrl:function(moduleNamePlusExt){var ext,index=moduleNamePlusExt.lastIndexOf("."),segment=moduleNamePlusExt.split("/")[0],isRelative=segment==="."||segment==="..";if(index!==-1&&(!isRelative||index>1)){ext=moduleNamePlusExt.substring(index,moduleNamePlusExt.length);moduleNamePlusExt=moduleNamePlusExt.substring(0,index)}return context.nameToUrl(normalize(moduleNamePlusExt,relMap&&relMap.id,true),ext,true)},defined:function(id){return hasProp(defined,makeModuleMap(id,relMap,false,true).id)},specified:function(id){id=makeModuleMap(id,relMap,false,true).id;return hasProp(defined,id)||hasProp(registry,id)}});if(!relMap){localRequire.undef=function(id){takeGlobalQueue();var map=makeModuleMap(id,relMap,true),mod=getOwn(registry,id);mod.undefed=true;removeScript(id);delete defined[id];delete urlFetched[map.url];delete undefEvents[id];eachReverse(defQueue,function(args,i){if(args[0]===id){defQueue.splice(i,1)}});delete context.defQueueMap[id];if(mod){if(mod.events.defined){undefEvents[id]=mod.events}cleanRegistry(id)}}}return localRequire},enable:function(depMap){var mod=getOwn(registry,depMap.id);if(mod){getModule(depMap).enable()}},completeLoad:function(moduleName){var found,args,mod,shim=getOwn(config.shim,moduleName)||{},shExports=shim.exports;takeGlobalQueue();while(defQueue.length){args=defQueue.shift();if(args[0]===null){args[0]=moduleName;if(found){break}found=true}else{if(args[0]===moduleName){found=true}}callGetModule(args)}context.defQueueMap={};mod=getOwn(registry,moduleName);if(!found&&!hasProp(defined,moduleName)&&mod&&!mod.inited){if(config.enforceDefine&&(!shExports||!getGlobal(shExports))){if(hasPathFallback(moduleName)){return}else{return onError(makeError("nodefine","No define call for "+moduleName,null,[moduleName]))}}else{callGetModule([moduleName,(shim.deps||[]),shim.exportsFn])}}checkLoaded()},nameToUrl:function(moduleName,ext,skipExt){var paths,syms,i,parentModule,url,parentPath,bundleId,pkgMain=getOwn(config.pkgs,moduleName);if(pkgMain){moduleName=pkgMain}bundleId=getOwn(bundlesMap,moduleName);if(bundleId){return context.nameToUrl(bundleId,ext,skipExt)}if(req.jsExtRegExp.test(moduleName)){url=moduleName+(ext||"")}else{paths=config.paths;syms=moduleName.split("/");for(i=syms.length;i>0;i-=1){parentModule=syms.slice(0,i).join("/");parentPath=getOwn(paths,parentModule);if(parentPath){if(isArray(parentPath)){parentPath=parentPath[0]}syms.splice(0,i,parentPath);break}}url=syms.join("/");url+=(ext||(/^data\:|^blob\:|\?/.test(url)||skipExt?"":".js"));url=(url.charAt(0)==="/"||url.match(/^[\w\+\.\-]+:/)?"":config.baseUrl)+url}return config.urlArgs&&!/^blob\:/.test(url)?url+config.urlArgs(moduleName,url):url},load:function(id,url){req.load(context,id,url)},execCb:function(name,callback,args,exports){return callback.apply(exports,args)},onScriptLoad:function(evt){if(evt.type==="load"||(readyRegExp.test((evt.currentTarget||evt.srcElement).readyState))){interactiveScript=null;var data=getScriptData(evt);context.completeLoad(data.id)}},onScriptError:function(evt){var data=getScriptData(evt);if(!hasPathFallback(data.id)){var parents=[];eachProp(registry,function(value,key){if(key.indexOf("_@r")!==0){each(value.depMaps,function(depMap){if(depMap.id===data.id){parents.push(key);return true}})}});return onError(makeError("scripterror",'Script error for "'+data.id+(parents.length?'", needed by: '+parents.join(", "):'"'),evt,[data.id]))}}};context.require=context.makeRequire();return context}req=requirejs=function(deps,callback,errback,optional){var context,config,contextName=defContextName;if(!isArray(deps)&&typeof deps!=="string"){config=deps;if(isArray(callback)){deps=callback;callback=errback;errback=optional}else{deps=[]}}if(config&&config.context){contextName=config.context}context=getOwn(contexts,contextName);if(!context){context=contexts[contextName]=req.s.newContext(contextName)}if(config){context.configure(config)}return context.require(deps,callback,errback)};req.config=function(config){return req(config)};req.nextTick=typeof setTimeout!=="undefined"?function(fn){setTimeout(fn,4)}:function(fn){fn()};if(!require){require=req}req.version=version;req.jsExtRegExp=/^\/|:|\?|\.js$/;req.isBrowser=isBrowser;s=req.s={contexts:contexts,newContext:newContext};req({});each(["toUrl","undef","defined","specified"],function(prop){req[prop]=function(){var ctx=contexts[defContextName];return ctx.require[prop].apply(ctx,arguments)}});if(isBrowser){head=s.head=document.getElementsByTagName("head")[0];baseElement=document.getElementsByTagName("base")[0];if(baseElement){head=s.head=baseElement.parentNode}}req.onError=defaultOnError;req.createNode=function(config,moduleName,url){var node=config.xhtml?document.createElementNS("http://www.w3.org/1999/xhtml","html:script"):document.createElement("script");node.type=config.scriptType||"text/javascript";node.charset="utf-8";node.async=true;return node};req.load=function(context,moduleName,url){var config=(context&&context.config)||{},node;if(isBrowser){node=req.createNode(config,moduleName,url);node.setAttribute("data-requirecontext",context.contextName);node.setAttribute("data-requiremodule",moduleName);if(node.attachEvent&&!(node.attachEvent.toString&&node.attachEvent.toString().indexOf("[native code")<0)&&!isOpera){useInteractive=true;node.attachEvent("onreadystatechange",context.onScriptLoad)}else{node.addEventListener("load",context.onScriptLoad,false);node.addEventListener("error",context.onScriptError,false)}node.src=url;if(config.onNodeCreated){config.onNodeCreated(node,config,moduleName,url)}currentlyAddingScript=node;head.appendChild(node);currentlyAddingScript=null;return node}else{if(isWebWorker){try{importScripts(url);context.completeLoad(moduleName)}catch(e){context.onError(makeError("importscripts","importScripts failed for "+moduleName+" at "+url,e,[moduleName]))}}}};function getInteractiveScript(){if(interactiveScript&&interactiveScript.readyState==="interactive"){return interactiveScript}eachReverse(scripts(),function(script){if(script.readyState==="interactive"){return(interactiveScript=script)}});return interactiveScript}if(isBrowser&&!cfg.skipDataMain){eachReverse(scripts(),function(script){if(!head){head=script.parentNode}dataMain=script.getAttribute("data-main");if(dataMain){mainScript=dataMain;if(!cfg.baseUrl&&mainScript.indexOf("!")===-1){src=mainScript.split("/");mainScript=src.pop();subPath=src.length?src.join("/")+"/":"./";cfg.baseUrl=subPath}mainScript=mainScript.replace(jsSuffixRegExp,"");if(req.jsExtRegExp.test(mainScript)){mainScript=dataMain}cfg.deps=cfg.deps?cfg.deps.concat(mainScript):[mainScript];return true}})}define=function(name,deps,callback){var node,context;if(typeof name!=="string"){callback=deps;deps=name;name=null}if(!isArray(deps)){callback=deps;deps=null}if(!deps&&isFunction(callback)){deps=[];if(callback.length){callback.toString().replace(commentRegExp,commentReplace).replace(cjsRequireRegExp,function(match,dep){deps.push(dep)});deps=(callback.length===1?["require"]:["require","exports","module"]).concat(deps)}}if(useInteractive){node=currentlyAddingScript||getInteractiveScript();if(node){if(!name){name=node.getAttribute("data-requiremodule")}context=contexts[node.getAttribute("data-requirecontext")]}}if(context){context.defQueue.push([name,deps,callback]);context.defQueueMap[name]=true}else{globalDefQueue.push([name,deps,callback])}};define.amd={jQuery:true};req.exec=function(text){return eval(text)};req(cfg)}(this));
var CryptoJS=CryptoJS||function(b,u){var t={},j=t.lib={},a=j.Base=function(){function f(){}return{extend:function(g){f.prototype=this;var h=new f;g&&h.mixIn(g);h.$super=this;return h},create:function(){var g=this.extend();g.init.apply(g,arguments);return g},init:function(){},mixIn:function(g){for(var h in g){g.hasOwnProperty(h)&&(this[h]=g[h])}g.hasOwnProperty("toString")&&(this.toString=g.toString)},clone:function(){return this.$super.extend(this)}}}(),c=j.WordArray=a.extend({init:function(f,g){f=this.words=f||[];this.sigBytes=g!=u?g:4*f.length},toString:function(f){return(f||x).stringify(this)},concat:function(g){var h=this.words,k=g.words,f=this.sigBytes,g=g.sigBytes;this.clamp();if(f%4){for(var i=0;i<g;i++){h[f+i>>>2]|=(k[i>>>2]>>>24-8*(i%4)&255)<<24-8*((f+i)%4)}}else{if(65535<k.length){for(i=0;i<g;i+=4){h[f+i>>>2]=k[i>>>2]}}else{h.push.apply(h,k)}}this.sigBytes+=g;return this},clamp:function(){var f=this.words,g=this.sigBytes;f[g>>>2]&=4294967295<<32-8*(g%4);f.length=b.ceil(g/4)},clone:function(){var f=a.clone.call(this);f.words=this.words.slice(0);return f},random:function(f){for(var g=[],h=0;h<f;h+=4){g.push(4294967296*b.random()|0)}return c.create(g,f)}}),e=t.enc={},x=e.Hex={stringify:function(g){for(var h=g.words,g=g.sigBytes,k=[],f=0;f<g;f++){var i=h[f>>>2]>>>24-8*(f%4)&255;k.push((i>>>4).toString(16));k.push((i&15).toString(16))}return k.join("")},parse:function(g){for(var h=g.length,i=[],f=0;f<h;f+=2){i[f>>>3]|=parseInt(g.substr(f,2),16)<<24-4*(f%8)}return c.create(i,h/2)}},d=e.Latin1={stringify:function(g){for(var h=g.words,g=g.sigBytes,i=[],f=0;f<g;f++){i.push(String.fromCharCode(h[f>>>2]>>>24-8*(f%4)&255))}return i.join("")},parse:function(g){for(var h=g.length,i=[],f=0;f<h;f++){i[f>>>2]|=(g.charCodeAt(f)&255)<<24-8*(f%4)}return c.create(i,h)}},q=e.Utf8={stringify:function(f){try{return decodeURIComponent(escape(d.stringify(f)))}catch(g){throw Error("Malformed UTF-8 data")}},parse:function(f){return d.parse(unescape(encodeURIComponent(f)))}},w=j.BufferedBlockAlgorithm=a.extend({reset:function(){this._data=c.create();this._nDataBytes=0},_append:function(f){"string"==typeof f&&(f=q.parse(f));this._data.concat(f);this._nDataBytes+=f.sigBytes},_process:function(g){var k=this._data,m=k.words,f=k.sigBytes,l=this.blockSize,i=f/(4*l),i=g?b.ceil(i):b.max((i|0)-this._minBufferSize,0),g=i*l,f=b.min(4*g,f);if(g){for(var h=0;h<g;h+=l){this._doProcessBlock(m,h)}h=m.splice(0,g);k.sigBytes-=f}return c.create(h,f)},clone:function(){var f=a.clone.call(this);f._data=this._data.clone();return f},_minBufferSize:0});j.Hasher=w.extend({init:function(){this.reset()},reset:function(){w.reset.call(this);this._doReset()},update:function(f){this._append(f);this._process();return this},finalize:function(f){f&&this._append(f);this._doFinalize();return this._hash},clone:function(){var f=w.clone.call(this);f._hash=this._hash.clone();return f},blockSize:16,_createHelper:function(f){return function(g,h){return f.create(h).finalize(g)}},_createHmacHelper:function(f){return function(g,h){return v.HMAC.create(f,h).finalize(g)}}});var v=t.algo={};return t}(Math);(function(){var b=CryptoJS,a=b.lib.WordArray;b.enc.Base64={stringify:function(e){var d=e.words,g=e.sigBytes,j=this._map;e.clamp();for(var e=[],c=0;c<g;c+=3){for(var f=(d[c>>>2]>>>24-8*(c%4)&255)<<16|(d[c+1>>>2]>>>24-8*((c+1)%4)&255)<<8|d[c+2>>>2]>>>24-8*((c+2)%4)&255,k=0;4>k&&c+0.75*k<g;k++){e.push(j.charAt(f>>>6*(3-k)&63))}}if(d=j.charAt(64)){for(;e.length%4;){e.push(d)}}return e.join("")},parse:function(f){var f=f.replace(/\s/g,""),d=f.length,h=this._map,j=h.charAt(64);j&&(j=f.indexOf(j),-1!=j&&(d=j));for(var j=[],c=0,g=0;g<d;g++){if(g%4){var p=h.indexOf(f.charAt(g-1))<<2*(g%4),e=h.indexOf(f.charAt(g))>>>6-2*(g%4);j[c>>>2]|=(p|e)<<24-8*(c%4);c++}}return a.create(j,c)},_map:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/="}})();(function(b){function q(l,k,i,m,o,h,n){l=l+(k&i|~k&m)+o+n;return(l<<h|l>>>32-h)+k}function j(l,k,i,m,o,h,n){l=l+(k&m|i&~m)+o+n;return(l<<h|l>>>32-h)+k}function f(l,k,i,m,o,h,n){l=l+(k^i^m)+o+n;return(l<<h|l>>>32-h)+k}function a(l,k,i,m,o,h,n){l=l+(i^(k|~m))+o+n;return(l<<h|l>>>32-h)+k}var c=CryptoJS,e=c.lib,t=e.WordArray,e=e.Hasher,d=c.algo,g=[];(function(){for(var h=0;64>h;h++){g[h]=4294967296*b.abs(b.sin(h+1))|0}})();d=d.MD5=e.extend({_doReset:function(){this._hash=t.create([1732584193,4023233417,2562383102,271733878])},_doProcessBlock:function(m,k){for(var i=0;16>i;i++){var n=k+i,p=m[n];m[n]=(p<<8|p>>>24)&16711935|(p<<24|p>>>8)&4278255360}for(var n=this._hash.words,p=n[0],h=n[1],o=n[2],l=n[3],i=0;64>i;i+=4){16>i?(p=q(p,h,o,l,m[k+i],7,g[i]),l=q(l,p,h,o,m[k+i+1],12,g[i+1]),o=q(o,l,p,h,m[k+i+2],17,g[i+2]),h=q(h,o,l,p,m[k+i+3],22,g[i+3])):32>i?(p=j(p,h,o,l,m[k+(i+1)%16],5,g[i]),l=j(l,p,h,o,m[k+(i+6)%16],9,g[i+1]),o=j(o,l,p,h,m[k+(i+11)%16],14,g[i+2]),h=j(h,o,l,p,m[k+i%16],20,g[i+3])):48>i?(p=f(p,h,o,l,m[k+(3*i+5)%16],4,g[i]),l=f(l,p,h,o,m[k+(3*i+8)%16],11,g[i+1]),o=f(o,l,p,h,m[k+(3*i+11)%16],16,g[i+2]),h=f(h,o,l,p,m[k+(3*i+14)%16],23,g[i+3])):(p=a(p,h,o,l,m[k+3*i%16],6,g[i]),l=a(l,p,h,o,m[k+(3*i+7)%16],10,g[i+1]),o=a(o,l,p,h,m[k+(3*i+14)%16],15,g[i+2]),h=a(h,o,l,p,m[k+(3*i+5)%16],21,g[i+3]))}n[0]=n[0]+p|0;n[1]=n[1]+h|0;n[2]=n[2]+o|0;n[3]=n[3]+l|0},_doFinalize:function(){var k=this._data,i=k.words,h=8*this._nDataBytes,l=8*k.sigBytes;i[l>>>5]|=128<<24-l%32;i[(l+64>>>9<<4)+14]=(h<<8|h>>>24)&16711935|(h<<24|h>>>8)&4278255360;k.sigBytes=4*(i.length+1);this._process();k=this._hash.words;for(i=0;4>i;i++){h=k[i],k[i]=(h<<8|h>>>24)&16711935|(h<<24|h>>>8)&4278255360}}});c.MD5=e._createHelper(d);c.HmacMD5=e._createHmacHelper(d)})(Math);(function(){var e=CryptoJS,c=e.lib,b=c.Base,a=c.WordArray,c=e.algo,d=c.EvpKDF=b.extend({cfg:b.extend({keySize:4,hasher:c.MD5,iterations:1}),init:function(f){this.cfg=this.cfg.extend(f)},compute:function(p,l){for(var q=this.cfg,j=q.hasher.create(),o=a.create(),s=o.words,r=q.keySize,q=q.iterations;s.length<r;){u&&j.update(u);var u=j.update(p).finalize(l);j.reset();for(var t=1;t<q;t++){u=j.finalize(u),j.reset()}o.concat(u)}o.sigBytes=4*r;return o}});e.EvpKDF=function(g,f,j){return d.create(j).compute(g,f)}})();CryptoJS.lib.Cipher||function(d){var x=CryptoJS,w=x.lib,u=w.Base,b=w.WordArray,j=w.BufferedBlockAlgorithm,t=x.enc.Base64,D=x.algo.EvpKDF,q=w.Cipher=j.extend({cfg:u.extend(),createEncryptor:function(a,c){return this.create(this._ENC_XFORM_MODE,a,c)},createDecryptor:function(a,c){return this.create(this._DEC_XFORM_MODE,a,c)},init:function(c,f,e){this.cfg=this.cfg.extend(e);this._xformMode=c;this._key=f;this.reset()},reset:function(){j.reset.call(this);this._doReset()},process:function(a){this._append(a);return this._process()},finalize:function(a){a&&this._append(a);return this._doFinalize()},keySize:4,ivSize:4,_ENC_XFORM_MODE:1,_DEC_XFORM_MODE:2,_createHelper:function(){return function(a){return{encrypt:function(c,f,e){return("string"==typeof f?B:A).encrypt(a,c,f,e)},decrypt:function(c,f,e){return("string"==typeof f?B:A).decrypt(a,c,f,e)}}}}()});w.StreamCipher=q.extend({_doFinalize:function(){return this._process(!0)},blockSize:1});var v=x.mode={},z=w.BlockCipherMode=u.extend({createEncryptor:function(c,e){return this.Encryptor.create(c,e)},createDecryptor:function(c,e){return this.Decryptor.create(c,e)},init:function(c,e){this._cipher=c;this._iv=e}}),v=v.CBC=function(){function c(f,g,i){var k=this._iv;k?this._iv=d:k=this._prevBlock;for(var h=0;h<i;h++){f[g+h]^=k[h]}}var e=z.extend();e.Encryptor=e.extend({processBlock:function(f,h){var i=this._cipher,g=i.blockSize;c.call(this,f,h,g);i.encryptBlock(f,h);this._prevBlock=f.slice(h,h+g)}});e.Decryptor=e.extend({processBlock:function(g,k){var l=this._cipher,i=l.blockSize,h=g.slice(k,k+i);l.decryptBlock(g,k);c.call(this,g,k,i);this._prevBlock=h}});return e}(),y=(x.pad={}).Pkcs7={pad:function(h,i){for(var n=4*i,n=n-h.sigBytes%n,m=n<<24|n<<16|n<<8|n,l=[],k=0;k<n;k+=4){l.push(m)}n=b.create(l,n);h.concat(n)},unpad:function(a){a.sigBytes-=a.words[a.sigBytes-1>>>2]&255}};w.BlockCipher=q.extend({cfg:q.cfg.extend({mode:v,padding:y}),reset:function(){q.reset.call(this);var e=this.cfg,f=e.iv,e=e.mode;if(this._xformMode==this._ENC_XFORM_MODE){var g=e.createEncryptor}else{g=e.createDecryptor,this._minBufferSize=1}this._mode=g.call(e,this,f&&f.words)},_doProcessBlock:function(c,e){this._mode.processBlock(c,e)},_doFinalize:function(){var c=this.cfg.padding;if(this._xformMode==this._ENC_XFORM_MODE){c.pad(this._data,this.blockSize);var e=this._process(!0)}else{e=this._process(!0),c.unpad(e)}return e},blockSize:4});var C=w.CipherParams=u.extend({init:function(c){this.mixIn(c)},toString:function(c){return(c||this.formatter).stringify(this)}}),v=(x.format={}).OpenSSL={stringify:function(c){var e=c.ciphertext,c=c.salt,e=(c?b.create([1398893684,1701076831]).concat(c).concat(e):e).toString(t);return e=e.replace(/(.{64})/g,"$1\n")},parse:function(a){var a=t.parse(a),e=a.words;if(1398893684==e[0]&&1701076831==e[1]){var f=b.create(e.slice(2,4));e.splice(0,4);a.sigBytes-=16}return C.create({ciphertext:a,salt:f})}},A=w.SerializableCipher=u.extend({cfg:u.extend({format:v}),encrypt:function(a,i,k,h){var h=this.cfg.extend(h),g=a.createEncryptor(k,h),i=g.finalize(i),g=g.cfg;return C.create({ciphertext:i,key:k,iv:g.iv,algorithm:a,mode:g.mode,padding:g.padding,blockSize:a.blockSize,formatter:h.format})},decrypt:function(g,k,i,h){h=this.cfg.extend(h);k=this._parse(k,h.format);return g.createDecryptor(i,h).finalize(k.ciphertext)},_parse:function(e,f){return"string"==typeof e?f.parse(e):e}}),x=(x.kdf={}).OpenSSL={compute:function(a,i,h,g){g||(g=b.random(8));a=D.create({keySize:i+h}).compute(a,g);h=b.create(a.words.slice(i),4*h);a.sigBytes=4*i;return C.create({key:a,iv:h,salt:g})}},B=w.PasswordBasedCipher=A.extend({cfg:A.cfg.extend({kdf:x}),encrypt:function(e,i,h,g){g=this.cfg.extend(g);h=g.kdf.compute(h,e.keySize,e.ivSize);g.iv=h.iv;e=A.encrypt.call(this,e,i,h.key,g);e.mixIn(h);return e},decrypt:function(e,i,h,g){g=this.cfg.extend(g);i=this._parse(i,g.format);h=g.kdf.compute(h,e.keySize,e.ivSize,i.salt);g.iv=h.iv;return A.decrypt.call(this,e,i,h.key,g)}})}();(function(){var c=CryptoJS,w=c.lib.BlockCipher,v=c.algo,t=[],b=[],d=[],q=[],B=[],j=[],u=[],y=[],x=[],A=[];(function(){for(var n=[],o=0;256>o;o++){n[o]=128>o?o<<1:o<<1^283}for(var m=0,l=0,o=0;256>o;o++){var f=l^l<<1^l<<2^l<<3^l<<4,f=f>>>8^f&255^99;t[m]=f;b[f]=m;var g=n[m],k=n[g],a=n[k],r=257*n[f]^16843008*f;d[m]=r<<24|r>>>8;q[m]=r<<16|r>>>16;B[m]=r<<8|r>>>24;j[m]=r;r=16843009*a^65537*k^257*g^16843008*m;u[f]=r<<24|r>>>8;y[f]=r<<16|r>>>16;x[f]=r<<8|r>>>24;A[f]=r;m?(m=g^n[n[n[a^g]]],l^=n[n[l]]):m=l=1}})();var z=[0,1,2,4,8,16,32,64,128,27,54],v=v.AES=w.extend({_doReset:function(){for(var l=this._key,a=l.words,k=l.sigBytes/4,l=4*((this._nRounds=k+6)+1),f=this._keySchedule=[],e=0;e<l;e++){if(e<k){f[e]=a[e]}else{var g=f[e-1];e%k?6<k&&4==e%k&&(g=t[g>>>24]<<24|t[g>>>16&255]<<16|t[g>>>8&255]<<8|t[g&255]):(g=g<<8|g>>>24,g=t[g>>>24]<<24|t[g>>>16&255]<<16|t[g>>>8&255]<<8|t[g&255],g^=z[e/k|0]<<24);f[e]=f[e-k]^g}}a=this._invKeySchedule=[];for(k=0;k<l;k++){e=l-k,g=k%4?f[e]:f[e-4],a[k]=4>k||4>=e?g:u[t[g>>>24]]^y[t[g>>>16&255]]^x[t[g>>>8&255]]^A[t[g&255]]}},encryptBlock:function(f,e){this._doCryptBlock(f,e,this._keySchedule,d,q,B,j,t)},decryptBlock:function(f,a){var e=f[a+1];f[a+1]=f[a+3];f[a+3]=e;this._doCryptBlock(f,a,this._invKeySchedule,u,y,x,A,b);e=f[a+1];f[a+1]=f[a+3];f[a+3]=e},_doCryptBlock:function(T,S,R,Q,P,N,M,O){for(var K=this._nRounds,L=T[S]^R[0],J=T[S+1]^R[1],H=T[S+2]^R[2],I=T[S+3]^R[3],G=4,F=1;F<K;F++){var E=Q[L>>>24]^P[J>>>16&255]^N[H>>>8&255]^M[I&255]^R[G++],D=Q[J>>>24]^P[H>>>16&255]^N[I>>>8&255]^M[L&255]^R[G++],C=Q[H>>>24]^P[I>>>16&255]^N[L>>>8&255]^M[J&255]^R[G++],I=Q[I>>>24]^P[L>>>16&255]^N[J>>>8&255]^M[H&255]^R[G++],L=E,J=D,H=C}E=(O[L>>>24]<<24|O[J>>>16&255]<<16|O[H>>>8&255]<<8|O[I&255])^R[G++];D=(O[J>>>24]<<24|O[H>>>16&255]<<16|O[I>>>8&255]<<8|O[L&255])^R[G++];C=(O[H>>>24]<<24|O[I>>>16&255]<<16|O[L>>>8&255]<<8|O[J&255])^R[G++];I=(O[I>>>24]<<24|O[L>>>16&255]<<16|O[J>>>8&255]<<8|O[H&255])^R[G++];T[S]=E;T[S+1]=D;T[S+2]=C;T[S+3]=I},keySize:8});c.AES=w._createHelper(v)})();(function(){var a=CryptoJS;var b=a.lib;var h=b.WordArray;var m=b.BlockCipher;var i=a.algo;var n=[57,49,41,33,25,17,9,1,58,50,42,34,26,18,10,2,59,51,43,35,27,19,11,3,60,52,44,36,63,55,47,39,31,23,15,7,62,54,46,38,30,22,14,6,61,53,45,37,29,21,13,5,28,20,12,4];var l=[14,17,11,24,1,5,3,28,15,6,21,10,23,19,12,4,26,8,16,7,27,20,13,2,41,52,31,37,47,55,30,40,51,45,33,48,44,49,39,56,34,53,46,42,50,36,29,32];var k=[1,2,4,6,8,10,12,14,15,17,19,21,23,25,27,28];var j=[{0:8421888,268435456:32768,536870912:8421378,805306368:2,1073741824:512,1342177280:8421890,1610612736:8389122,1879048192:8388608,2147483648:514,2415919104:8389120,2684354560:33280,2952790016:8421376,3221225472:32770,3489660928:8388610,3758096384:0,4026531840:33282,134217728:0,402653184:8421890,671088640:33282,939524096:32768,1207959552:8421888,1476395008:512,1744830464:8421378,2013265920:2,2281701376:8389120,2550136832:33280,2818572288:8421376,3087007744:8389122,3355443200:8388610,3623878656:32770,3892314112:514,4160749568:8388608,1:32768,268435457:2,536870913:8421888,805306369:8388608,1073741825:8421378,1342177281:33280,1610612737:512,1879048193:8389122,2147483649:8421890,2415919105:8421376,2684354561:8388610,2952790017:33282,3221225473:514,3489660929:8389120,3758096385:32770,4026531841:0,134217729:8421890,402653185:8421376,671088641:8388608,939524097:512,1207959553:32768,1476395009:8388610,1744830465:2,2013265921:33282,2281701377:32770,2550136833:8389122,2818572289:514,3087007745:8421888,3355443201:8389120,3623878657:0,3892314113:33280,4160749569:8421378},{0:1074282512,16777216:16384,33554432:524288,50331648:1074266128,67108864:1073741840,83886080:1074282496,100663296:1073758208,117440512:16,134217728:540672,150994944:1073758224,167772160:1073741824,184549376:540688,201326592:524304,218103808:0,234881024:16400,251658240:1074266112,8388608:1073758208,25165824:540688,41943040:16,58720256:1073758224,75497472:1074282512,92274688:1073741824,109051904:524288,125829120:1074266128,142606336:524304,159383552:0,176160768:16384,192937984:1074266112,209715200:1073741840,226492416:540672,243269632:1074282496,260046848:16400,268435456:0,285212672:1074266128,301989888:1073758224,318767104:1074282496,335544320:1074266112,352321536:16,369098752:540688,385875968:16384,402653184:16400,419430400:524288,436207616:524304,452984832:1073741840,469762048:540672,486539264:1073758208,503316480:1073741824,520093696:1074282512,276824064:540688,293601280:524288,310378496:1074266112,327155712:16384,343932928:1073758208,360710144:1074282512,377487360:16,394264576:1073741824,411041792:1074282496,427819008:1073741840,444596224:1073758224,461373440:524304,478150656:0,494927872:16400,511705088:1074266128,528482304:540672},{0:260,1048576:0,2097152:67109120,3145728:65796,4194304:65540,5242880:67108868,6291456:67174660,7340032:67174400,8388608:67108864,9437184:67174656,10485760:65792,11534336:67174404,12582912:67109124,13631488:65536,14680064:4,15728640:256,524288:67174656,1572864:67174404,2621440:0,3670016:67109120,4718592:67108868,5767168:65536,6815744:65540,7864320:260,8912896:4,9961472:256,11010048:67174400,12058624:65796,13107200:65792,14155776:67109124,15204352:67174660,16252928:67108864,16777216:67174656,17825792:65540,18874368:65536,19922944:67109120,20971520:256,22020096:67174660,23068672:67108868,24117248:0,25165824:67109124,26214400:67108864,27262976:4,28311552:65792,29360128:67174400,30408704:260,31457280:65796,32505856:67174404,17301504:67108864,18350080:260,19398656:67174656,20447232:0,21495808:65540,22544384:67109120,23592960:256,24641536:67174404,25690112:65536,26738688:67174660,27787264:65796,28835840:67108868,29884416:67109124,30932992:67174400,31981568:4,33030144:65792},{0:2151682048,65536:2147487808,131072:4198464,196608:2151677952,262144:0,327680:4198400,393216:2147483712,458752:4194368,524288:2147483648,589824:4194304,655360:64,720896:2147487744,786432:2151678016,851968:4160,917504:4096,983040:2151682112,32768:2147487808,98304:64,163840:2151678016,229376:2147487744,294912:4198400,360448:2151682112,425984:0,491520:2151677952,557056:4096,622592:2151682048,688128:4194304,753664:4160,819200:2147483648,884736:4194368,950272:4198464,1015808:2147483712,1048576:4194368,1114112:4198400,1179648:2147483712,1245184:0,1310720:4160,1376256:2151678016,1441792:2151682048,1507328:2147487808,1572864:2151682112,1638400:2147483648,1703936:2151677952,1769472:4198464,1835008:2147487744,1900544:4194304,1966080:64,2031616:4096,1081344:2151677952,1146880:2151682112,1212416:0,1277952:4198400,1343488:4194368,1409024:2147483648,1474560:2147487808,1540096:64,1605632:2147483712,1671168:4096,1736704:2147487744,1802240:2151678016,1867776:4160,1933312:2151682048,1998848:4194304,2064384:4198464},{0:128,4096:17039360,8192:262144,12288:536870912,16384:537133184,20480:16777344,24576:553648256,28672:262272,32768:16777216,36864:537133056,40960:536871040,45056:553910400,49152:553910272,53248:0,57344:17039488,61440:553648128,2048:17039488,6144:553648256,10240:128,14336:17039360,18432:262144,22528:537133184,26624:553910272,30720:536870912,34816:537133056,38912:0,43008:553910400,47104:16777344,51200:536871040,55296:553648128,59392:16777216,63488:262272,65536:262144,69632:128,73728:536870912,77824:553648256,81920:16777344,86016:553910272,90112:537133184,94208:16777216,98304:553910400,102400:553648128,106496:17039360,110592:537133056,114688:262272,118784:536871040,122880:0,126976:17039488,67584:553648256,71680:16777216,75776:17039360,79872:537133184,83968:536870912,88064:17039488,92160:128,96256:553910272,100352:262272,104448:553910400,108544:0,112640:553648128,116736:16777344,120832:262144,124928:537133056,129024:536871040},{0:268435464,256:8192,512:270532608,768:270540808,1024:268443648,1280:2097152,1536:2097160,1792:268435456,2048:0,2304:268443656,2560:2105344,2816:8,3072:270532616,3328:2105352,3584:8200,3840:270540800,128:270532608,384:270540808,640:8,896:2097152,1152:2105352,1408:268435464,1664:268443648,1920:8200,2176:2097160,2432:8192,2688:268443656,2944:270532616,3200:0,3456:270540800,3712:2105344,3968:268435456,4096:268443648,4352:270532616,4608:270540808,4864:8200,5120:2097152,5376:268435456,5632:268435464,5888:2105344,6144:2105352,6400:0,6656:8,6912:270532608,7168:8192,7424:268443656,7680:270540800,7936:2097160,4224:8,4480:2105344,4736:2097152,4992:268435464,5248:268443648,5504:8200,5760:270540808,6016:270532608,6272:270540800,6528:270532616,6784:8192,7040:2105352,7296:2097160,7552:0,7808:268435456,8064:268443656},{0:1048576,16:33555457,32:1024,48:1049601,64:34604033,80:0,96:1,112:34603009,128:33555456,144:1048577,160:33554433,176:34604032,192:34603008,208:1025,224:1049600,240:33554432,8:34603009,24:0,40:33555457,56:34604032,72:1048576,88:33554433,104:33554432,120:1025,136:1049601,152:33555456,168:34603008,184:1048577,200:1024,216:34604033,232:1,248:1049600,256:33554432,272:1048576,288:33555457,304:34603009,320:1048577,336:33555456,352:34604032,368:1049601,384:1025,400:34604033,416:1049600,432:1,448:0,464:34603008,480:33554433,496:1024,264:1049600,280:33555457,296:34603009,312:1,328:33554432,344:1048576,360:1025,376:34604032,392:33554433,408:34603008,424:0,440:34604033,456:1049601,472:1024,488:33555456,504:1048577},{0:134219808,1:131072,2:134217728,3:32,4:131104,5:134350880,6:134350848,7:2048,8:134348800,9:134219776,10:133120,11:134348832,12:2080,13:0,14:134217760,15:133152,2147483648:2048,2147483649:134350880,2147483650:134219808,2147483651:134217728,2147483652:134348800,2147483653:133120,2147483654:133152,2147483655:32,2147483656:134217760,2147483657:2080,2147483658:131104,2147483659:134350848,2147483660:0,2147483661:134348832,2147483662:134219776,2147483663:131072,16:133152,17:134350848,18:32,19:2048,20:134219776,21:134217760,22:134348832,23:131072,24:0,25:131104,26:134348800,27:134219808,28:134350880,29:133120,30:2080,31:134217728,2147483664:131072,2147483665:2048,2147483666:134348832,2147483667:133152,2147483668:32,2147483669:134348800,2147483670:134217728,2147483671:134219808,2147483672:134350880,2147483673:134217760,2147483674:134219776,2147483675:0,2147483676:133120,2147483677:2080,2147483678:131104,2147483679:134350848}];var f=[4160749569,528482304,33030144,2064384,129024,8064,504,2147483679];var c=i.DES=m.extend({_doReset:function(){var w=this._key;var q=w.words;var v=[];for(var u=0;u<56;u++){var s=n[u]-1;v[u]=(q[s>>>5]>>>(31-s%32))&1}var o=this._subKeys=[];for(var r=0;r<16;r++){var t=o[r]=[];var x=k[r];for(var u=0;u<24;u++){t[(u/6)|0]|=v[((l[u]-1)+x)%28]<<(31-u%6);t[4+((u/6)|0)]|=v[28+(((l[u+24]-1)+x)%28)]<<(31-u%6)}t[0]=(t[0]<<1)|(t[0]>>>31);for(var u=1;u<7;u++){t[u]=t[u]>>>((u-1)*4+3)}t[7]=(t[7]<<5)|(t[7]>>>27)}var p=this._invSubKeys=[];for(var u=0;u<16;u++){p[u]=o[15-u]}},encryptBlock:function(p,o){this._doCryptBlock(p,o,this._subKeys)},decryptBlock:function(p,o){this._doCryptBlock(p,o,this._invSubKeys)},_doCryptBlock:function(w,r,p){this._lBlock=w[r];this._rBlock=w[r+1];d.call(this,4,252645135);d.call(this,16,65535);e.call(this,2,858993459);e.call(this,8,16711935);d.call(this,1,1431655765);for(var y=0;y<16;y++){var u=p[y];var q=this._lBlock;var o=this._rBlock;var v=0;for(var s=0;s<8;s++){v|=j[s][((o^u[s])&f[s])>>>0]}this._lBlock=o;this._rBlock=q^v}var x=this._lBlock;this._lBlock=this._rBlock;this._rBlock=x;d.call(this,1,1431655765);e.call(this,8,16711935);e.call(this,2,858993459);d.call(this,16,65535);d.call(this,4,252645135);w[r]=this._lBlock;w[r+1]=this._rBlock},keySize:64/32,ivSize:64/32,blockSize:64/32});function d(q,o){var p=((this._lBlock>>>q)^this._rBlock)&o;this._rBlock^=p;this._lBlock^=p<<q}function e(q,o){var p=((this._rBlock>>>q)^this._lBlock)&o;this._lBlock^=p;this._rBlock^=p<<q}a.DES=m._createHelper(c);var g=i.TripleDES=m.extend({_doReset:function(){var o=this._key;var p=o.words;this._des1=c.createEncryptor(h.create(p.slice(0,2)));this._des2=c.createEncryptor(h.create(p.slice(2,4)));this._des3=c.createEncryptor(h.create(p.slice(4,6)))},encryptBlock:function(p,o){this._des1.encryptBlock(p,o);this._des2.decryptBlock(p,o);this._des3.encryptBlock(p,o)},decryptBlock:function(p,o){this._des3.decryptBlock(p,o);this._des2.encryptBlock(p,o);this._des1.decryptBlock(p,o)},keySize:192/32,ivSize:64/32,blockSize:64/32});a.TripleDES=m._createHelper(g)}());(function(c){var a=CryptoJS;var b=a.lib;var i=b.WordArray;var e=b.Hasher;var j=a.algo;var f=[];(function(){for(var m=0;m<64;m++){f[m]=(c.abs(c.sin(m+1))*4294967296)|0}}());var k=j.MD5=e.extend({_doReset:function(){this._hash=i.create([1732584193,4023233417,2562383102,271733878])},_doProcessBlock:function(p,m){for(var n=0;n<16;n++){var v=m+n;var q=p[v];p[v]=((((q<<8)|(q>>>24))&16711935)|(((q<<24)|(q>>>8))&4278255360))}var u=this._hash.words;var t=u[0];var s=u[1];var r=u[2];var o=u[3];for(var n=0;n<64;n+=4){if(n<16){t=h(t,s,r,o,p[m+n],7,f[n]);o=h(o,t,s,r,p[m+n+1],12,f[n+1]);r=h(r,o,t,s,p[m+n+2],17,f[n+2]);s=h(s,r,o,t,p[m+n+3],22,f[n+3])}else{if(n<32){t=d(t,s,r,o,p[m+((n+1)%16)],5,f[n]);o=d(o,t,s,r,p[m+((n+6)%16)],9,f[n+1]);r=d(r,o,t,s,p[m+((n+11)%16)],14,f[n+2]);s=d(s,r,o,t,p[m+(n%16)],20,f[n+3])}else{if(n<48){t=l(t,s,r,o,p[m+((n*3+5)%16)],4,f[n]);o=l(o,t,s,r,p[m+((n*3+8)%16)],11,f[n+1]);r=l(r,o,t,s,p[m+((n*3+11)%16)],16,f[n+2]);s=l(s,r,o,t,p[m+((n*3+14)%16)],23,f[n+3])}else{t=g(t,s,r,o,p[m+((n*3)%16)],6,f[n]);o=g(o,t,s,r,p[m+((n*3+7)%16)],10,f[n+1]);r=g(r,o,t,s,p[m+((n*3+14)%16)],15,f[n+2]);s=g(s,r,o,t,p[m+((n*3+5)%16)],21,f[n+3])}}}}u[0]=(u[0]+t)|0;u[1]=(u[1]+s)|0;u[2]=(u[2]+r)|0;u[3]=(u[3]+o)|0},_doFinalize:function(){var r=this._data;var s=r.words;var m=this._nDataBytes*8;var q=r.sigBytes*8;s[q>>>5]|=128<<(24-q%32);s[(((q+64)>>>9)<<4)+14]=((((m<<8)|(m>>>24))&16711935)|(((m<<24)|(m>>>8))&4278255360));r.sigBytes=(s.length+1)*4;this._process();var o=this._hash.words;for(var n=0;n<4;n++){var p=o[n];o[n]=(((p<<8)|(p>>>24))&16711935)|(((p<<24)|(p>>>8))&4278255360)}}});function h(p,o,w,u,m,r,q){var v=p+((o&w)|(~o&u))+m+q;return((v<<r)|(v>>>(32-r)))+o}function d(p,o,w,u,m,r,q){var v=p+((o&u)|(w&~u))+m+q;return((v<<r)|(v>>>(32-r)))+o}function l(p,o,w,u,m,r,q){var v=p+(o^w^u)+m+q;return((v<<r)|(v>>>(32-r)))+o}function g(p,o,w,u,m,r,q){var v=p+(w^(o|~u))+m+q;return((v<<r)|(v>>>(32-r)))+o}a.MD5=e._createHelper(k);a.HmacMD5=e._createHmacHelper(k)}(Math));(function(h){var g=CryptoJS;var c=g.lib;var b=c.Base;var f=c.WordArray;var a=g.x64={};var d=a.Word=b.extend({init:function(j,i){this.high=j;this.low=i}});var e=a.WordArray=b.extend({init:function(j,i){j=this.words=j||[];if(i!=h){this.sigBytes=i}else{this.sigBytes=j.length*8}},toX32:function(){var l=this.words;var k=l.length;var n=[];for(var j=0;j<k;j++){var m=l[j];n.push(m.high);n.push(m.low)}return f.create(n,this.sigBytes)},clone:function(){var m=b.clone.call(this);var l=m.words=this.words.slice(0);var k=l.length;for(var j=0;j<k;j++){l[j]=l[j].clone()}return m}})}());(function(){var g=CryptoJS;var d=g.lib;var f=d.WordArray;var b=d.Hasher;var e=g.algo;var a=[];var c=e.SHA1=b.extend({_doReset:function(){this._hash=f.create([1732584193,4023233417,2562383102,271733878,3285377520])},_doProcessBlock:function(m,j){var s=this._hash.words;var r=s[0];var q=s[1];var p=s[2];var o=s[3];var l=s[4];for(var k=0;k<80;k++){if(k<16){a[k]=m[j+k]|0}else{var h=a[k-3]^a[k-8]^a[k-14]^a[k-16];a[k]=(h<<1)|(h>>>31)}var u=((r<<5)|(r>>>27))+l+a[k];if(k<20){u+=((q&p)|(~q&o))+1518500249}else{if(k<40){u+=(q^p^o)+1859775393}else{if(k<60){u+=((q&p)|(q&o)|(p&o))-1894007588}else{u+=(q^p^o)-899497514}}}l=o;o=p;p=(q<<30)|(q>>>2);q=r;r=u}s[0]=(s[0]+r)|0;s[1]=(s[1]+q)|0;s[2]=(s[2]+p)|0;s[3]=(s[3]+o)|0;s[4]=(s[4]+l)|0},_doFinalize:function(){var j=this._data;var k=j.words;var h=this._nDataBytes*8;var i=j.sigBytes*8;k[i>>>5]|=128<<(24-i%32);k[(((i+64)>>>9)<<4)+15]=h;j.sigBytes=k.length*4;this._process()}});g.SHA1=b._createHelper(c);g.HmacSHA1=b._createHmacHelper(c)}());(function(c){var a=CryptoJS;var b=a.lib;var g=b.WordArray;var e=b.Hasher;var h=a.algo;var j=[];var i=[];(function(){function m(r){var q=c.sqrt(r);for(var p=2;p<=q;p++){if(!(r%p)){return false}}return true}function l(p){return((p-(p|0))*4294967296)|0}var o=2;var k=0;while(k<64){if(m(o)){if(k<8){j[k]=l(c.pow(o,1/2))}i[k]=l(c.pow(o,1/3));k++}o++}}());var d=[];var f=h.SHA256=e.extend({_doReset:function(){this._hash=g.create(j.slice(0))},_doProcessBlock:function(n,m){var q=this._hash.words;var D=q[0];var C=q[1];var B=q[2];var A=q[3];var z=q[4];var y=q[5];var x=q[6];var w=q[7];for(var v=0;v<64;v++){if(v<16){d[v]=n[m+v]|0}else{var l=d[v-15];var F=((l<<25)|(l>>>7))^((l<<14)|(l>>>18))^(l>>>3);var r=d[v-2];var E=((r<<15)|(r>>>17))^((r<<13)|(r>>>19))^(r>>>10);d[v]=F+d[v-7]+E+d[v-16]}var s=(z&y)^(~z&x);var k=(D&C)^(D&B)^(C&B);var u=((D<<30)|(D>>>2))^((D<<19)|(D>>>13))^((D<<10)|(D>>>22));var t=((z<<26)|(z>>>6))^((z<<21)|(z>>>11))^((z<<7)|(z>>>25));var p=w+t+s+i[v]+d[v];var o=u+k;w=x;x=y;y=z;z=(A+p)|0;A=B;B=C;C=D;D=(p+o)|0}q[0]=(q[0]+D)|0;q[1]=(q[1]+C)|0;q[2]=(q[2]+B)|0;q[3]=(q[3]+A)|0;q[4]=(q[4]+z)|0;q[5]=(q[5]+y)|0;q[6]=(q[6]+x)|0;q[7]=(q[7]+w)|0},_doFinalize:function(){var m=this._data;var n=m.words;var k=this._nDataBytes*8;var l=m.sigBytes*8;n[l>>>5]|=128<<(24-l%32);n[(((l+64)>>>9)<<4)+15]=k;m.sigBytes=n.length*4;this._process()}});a.SHA256=e._createHelper(f);a.HmacSHA256=e._createHmacHelper(f)}(Math));(function(){var a=CryptoJS;var b=a.lib;var e=b.Hasher;var f=a.x64;var d=f.Word;var j=f.WordArray;var i=a.algo;function g(){return d.create.apply(d,arguments)}var k=[g(1116352408,3609767458),g(1899447441,602891725),g(3049323471,3964484399),g(3921009573,2173295548),g(961987163,4081628472),g(1508970993,3053834265),g(2453635748,2937671579),g(2870763221,3664609560),g(3624381080,2734883394),g(310598401,1164996542),g(607225278,1323610764),g(1426881987,3590304994),g(1925078388,4068182383),g(2162078206,991336113),g(2614888103,633803317),g(3248222580,3479774868),g(3835390401,2666613458),g(4022224774,944711139),g(264347078,2341262773),g(604807628,2007800933),g(770255983,1495990901),g(1249150122,1856431235),g(1555081692,3175218132),g(1996064986,2198950837),g(2554220882,3999719339),g(2821834349,766784016),g(2952996808,2566594879),g(3210313671,3203337956),g(3336571891,1034457026),g(3584528711,2466948901),g(113926993,3758326383),g(338241895,168717936),g(666307205,1188179964),g(773529912,1546045734),g(1294757372,1522805485),g(1396182291,2643833823),g(1695183700,2343527390),g(1986661051,1014477480),g(2177026350,1206759142),g(2456956037,344077627),g(2730485921,1290863460),g(2820302411,3158454273),g(3259730800,3505952657),g(3345764771,106217008),g(3516065817,3606008344),g(3600352804,1432725776),g(4094571909,1467031594),g(275423344,851169720),g(430227734,3100823752),g(506948616,1363258195),g(659060556,3750685593),g(883997877,3785050280),g(958139571,3318307427),g(1322822218,3812723403),g(1537002063,2003034995),g(1747873779,3602036899),g(1955562222,1575990012),g(2024104815,1125592928),g(2227730452,2716904306),g(2361852424,442776044),g(2428436474,593698344),g(2756734187,3733110249),g(3204031479,2999351573),g(3329325298,3815920427),g(3391569614,3928383900),g(3515267271,566280711),g(3940187606,3454069534),g(4118630271,4000239992),g(116418474,1914138554),g(174292421,2731055270),g(289380356,3203993006),g(460393269,320620315),g(685471733,587496836),g(852142971,1086792851),g(1017036298,365543100),g(1126000580,2618297676),g(1288033470,3409855158),g(1501505948,4234509866),g(1607167915,987167468),g(1816402316,1246189591)];var c=[];(function(){for(var l=0;l<80;l++){c[l]=g()}}());var h=i.SHA512=e.extend({_doReset:function(){this._hash=j.create([g(1779033703,4089235720),g(3144134277,2227873595),g(1013904242,4271175723),g(2773480762,1595750129),g(1359893119,2917565137),g(2600822924,725511199),g(528734635,4215389547),g(1541459225,327033209)])},_doProcessBlock:function(ao,C){var ap=this._hash.words;var y=ap[0];var v=ap[1];var t=ap[2];var s=ap[3];var q=ap[4];var o=ap[5];var m=ap[6];var l=ap[7];var T=y.high;var R=y.low;var K=v.high;var I=v.low;var A=t.high;var x=t.low;var aM=s.high;var aK=s.low;var aE=q.high;var aB=q.low;var an=o.high;var ak=o.low;var V=m.high;var U=m.low;var N=l.high;var L=l.low;var ay=T;var av=R;var ag=K;var ae=I;var S=A;var Q=x;var J=aM;var G=aK;var z=aE;var r=aB;var aL=an;var aJ=ak;var aC=V;var az=U;var am=N;var ai=L;for(var X=0;X<80;X++){var P=c[X];if(X<16){var au=P.high=ao[C+X*2]|0;var ar=P.low=ao[C+X*2+1]|0}else{var aq=c[X-15];var F=aq.high;var E=aq.low;var aA=((E<<31)|(F>>>1))^((E<<24)|(F>>>8))^(F>>>7);var ax=((F<<31)|(E>>>1))^((F<<24)|(E>>>8))^((F<<25)|(E>>>7));var aa=c[X-2];var D=aa.high;var B=aa.low;var aj=((B<<13)|(D>>>19))^((D<<3)|(B>>>29))^(D>>>6);var af=((D<<13)|(B>>>19))^((B<<3)|(D>>>29))^((D<<26)|(B>>>6));var aN=c[X-7];var ad=aN.high;var ab=aN.low;var aD=c[X-16];var ac=aD.high;var Z=aD.low;var ar=ax+ab;var au=aA+ad+((ar>>>0)<(ax>>>0)?1:0);var ar=ar+af;var au=au+aj+((ar>>>0)<(af>>>0)?1:0);var ar=ar+Z;var au=au+ac+((ar>>>0)<(Z>>>0)?1:0);P.high=au;P.low=ar}var Y=(z&aL)^(~z&aC);var W=(r&aJ)^(~r&az);var w=(ay&ag)^(ay&S)^(ag&S);var p=(av&ae)^(av&Q)^(ae&Q);var aP=((av<<4)|(ay>>>28))^((ay<<30)|(av>>>2))^((ay<<25)|(av>>>7));var aO=((ay<<4)|(av>>>28))^((av<<30)|(ay>>>2))^((av<<25)|(ay>>>7));var aG=((r<<18)|(z>>>14))^((r<<14)|(z>>>18))^((z<<23)|(r>>>9));var aF=((z<<18)|(r>>>14))^((z<<14)|(r>>>18))^((r<<23)|(z>>>9));var O=k[X];var u=O.high;var n=O.low;var aH=ai+aF;var aI=am+aG+((aH>>>0)<(ai>>>0)?1:0);var aH=aH+W;var aI=aI+Y+((aH>>>0)<(W>>>0)?1:0);var aH=aH+n;var aI=aI+u+((aH>>>0)<(n>>>0)?1:0);var aH=aH+ar;var aI=aI+au+((aH>>>0)<(ar>>>0)?1:0);var at=aO+p;var aw=aP+w+((at>>>0)<(aO>>>0)?1:0);am=aC;ai=az;aC=aL;az=aJ;aL=z;aJ=r;r=(G+aH)|0;z=(J+aI+((r>>>0)<(G>>>0)?1:0))|0;J=S;G=Q;S=ag;Q=ae;ag=ay;ae=av;av=(aH+at)|0;ay=(aI+aw+((av>>>0)<(aH>>>0)?1:0))|0}R=y.low=(R+av)|0;y.high=(T+ay+((R>>>0)<(av>>>0)?1:0))|0;I=v.low=(I+ae)|0;v.high=(K+ag+((I>>>0)<(ae>>>0)?1:0))|0;x=t.low=(x+Q)|0;t.high=(A+S+((x>>>0)<(Q>>>0)?1:0))|0;aK=s.low=(aK+G)|0;s.high=(aM+J+((aK>>>0)<(G>>>0)?1:0))|0;aB=q.low=(aB+r)|0;q.high=(aE+z+((aB>>>0)<(r>>>0)?1:0))|0;ak=o.low=(ak+aJ)|0;o.high=(an+aL+((ak>>>0)<(aJ>>>0)?1:0))|0;U=m.low=(U+az)|0;m.high=(V+aC+((U>>>0)<(az>>>0)?1:0))|0;L=l.low=(L+ai)|0;l.high=(N+am+((L>>>0)<(ai>>>0)?1:0))|0},_doFinalize:function(){var n=this._data;var o=n.words;var l=this._nDataBytes*8;var m=n.sigBytes*8;o[m>>>5]|=128<<(24-m%32);o[(((m+128)>>>10)<<5)+31]=l;n.sigBytes=o.length*4;this._process();this._hash=this._hash.toX32()},blockSize:1024/32});a.SHA512=e._createHelper(h);a.HmacSHA512=e._createHmacHelper(h)}());CryptoJS.mode.CFB=(function(){var b=CryptoJS.lib.BlockCipherMode.extend();b.Encryptor=b.extend({processBlock:function(f,e){var c=this._cipher;var d=c.blockSize;a.call(this,f,e,d,c);this._prevBlock=f.slice(e,e+d)}});b.Decryptor=b.extend({processBlock:function(g,f){var c=this._cipher;var e=c.blockSize;var d=g.slice(f,f+e);a.call(this,g,f,e,c);this._prevBlock=d}});function a(j,h,f,c){var d=this._iv;if(d){var g=d.slice(0);this._iv=undefined}else{var g=this._prevBlock}c.encryptBlock(g,0);for(var e=0;e<f;e++){j[h+e]^=g[e]}}return b}());CryptoJS.mode.ECB=(function(){var a=CryptoJS.lib.BlockCipherMode.extend();a.Encryptor=a.extend({processBlock:function(c,b){this._cipher.encryptBlock(c,b)}});a.Decryptor=a.extend({processBlock:function(c,b){this._cipher.decryptBlock(c,b)}});return a}());CryptoJS.mode.OFB=(function(){var b=CryptoJS.lib.BlockCipherMode.extend();var a=b.Encryptor=b.extend({processBlock:function(j,h){var c=this._cipher;var f=c.blockSize;var d=this._iv;var g=this._keystream;if(d){g=this._keystream=d.slice(0);this._iv=undefined}c.encryptBlock(g,0);for(var e=0;e<f;e++){j[h+e]^=g[e]}}});b.Decryptor=a;return b}());CryptoJS.mode.CTR=(function(){var b=CryptoJS.lib.BlockCipherMode.extend();var a=b.Encryptor=b.extend({processBlock:function(k,j){var c=this._cipher;var g=c.blockSize;var e=this._iv;var d=this._counter;if(e){d=this._counter=e.slice(0);this._iv=undefined}var h=d.slice(0);c.encryptBlock(h,0);d[g-1]=(d[g-1]+1)|0;for(var f=0;f<g;f++){k[j+f]^=h[f]}}});b.Decryptor=a;return b}());CryptoJS.pad.ZeroPadding={pad:function(c,a){var b=a*4;c.clamp();c.sigBytes+=b-((c.sigBytes%b)||b)},unpad:function(b){var c=b.words;var a=b.sigBytes-1;while(!((c[a>>>2]>>>(24-(a%4)*8))&255)){a--}b.sigBytes=a+1}};CryptoJS.pad.NoPadding={pad:function(){},unpad:function(){}};CryptoJS.pad.Iso97971={pad:function(b,a){b.concat(CryptoJS.lib.WordArray.create([2147483648],1));CryptoJS.pad.ZeroPadding.pad(b,a)},unpad:function(a){CryptoJS.pad.ZeroPadding.unpad(a);a.sigBytes--}};CryptoJS.pad.Iso10126={pad:function(c,a){var b=a*4;var d=b-c.sigBytes%b;c.concat(CryptoJS.lib.WordArray.random(d-1)).concat(CryptoJS.lib.WordArray.create([d<<24],1))},unpad:function(a){var b=a.words[(a.sigBytes-1)>>>2]&255;a.sigBytes-=b}};

$KW.Form = (function() {
    
    var _newFormTransitionApplicable = function(model, type) {
        var applicable = false, transition = model[(type+'transitionconfig')];

        if(!transition) return applicable;

        if(typeof transition.formAnimation === 'number'
        || typeof transition.formanimation === 'number') {
            applicable = true;
        }

        return applicable;
    };

    var _normalizeTransition = {
        number: function(inConfig, outConfig) {
            var inTrans = {effect:'none', duration:'0.5s'},
                outTrans = {effect:'none', duration:'0.5s'};

            if(typeof inConfig.formAnimation === 'number') {
                inTrans.effect = inConfig.formAnimation.toString();
            } else if(typeof inConfig.formanimation === 'number') {
                inTrans.effect = inConfig.formanimation.toString();
            }
            if(inTrans.effect === '0') inTrans.effect = 'none';
            else inTrans.effect = $KW.formTransitionsMatrix[('anim'+inTrans.effect)];

            if(outConfig) {
                if(typeof outConfig.formAnimation === 'number') {
                    outTrans.effect = outConfig.formAnimation.toString();
                } else if(typeof outConfig.formAnimation === 'number') {
                    outTrans.effect = outConfig.formanimation.toString();
                }
            }
            if(outTrans.effect === '0') outTrans.effect = 'none';
            else outTrans.effect = $KW.formEndTransitionsMatrix[('anim'+outTrans.effect)];

            if(!inTrans.effect || inTrans.effect === 'none') inTrans = null;
            if(!outTrans.effect || outTrans.effect === 'none') outTrans = null;

            return {inTrans:inTrans, outTrans:outTrans};
        },

        string: function(inConfig) {
            var inTrans = {effect:'none', duration:'0.5s'},
                effect = inConfig.formTransition || inConfig.formtransition;

            if(!effect || effect === 'none') inTrans = null;
            else inTrans.effect = $KW.formTransitionsMatrix[effect];

            return {inTrans:inTrans, outTrans:null};
        }
    };
    

    var module = {
        initialize: function() {
            kony.events.addEvent("onresize", "Form", this.resizeHandler);
            kony.events.addEvent("onorientationchange", "Form", this.orientationHandler);
        },

        initializeView: function(formId, isForm) {
            
            var widgetsSupported = [$KW.Label, $KW.Calendar, $KW.Segment, $KW.TabPane, $KW.Line, $KW.Switch, $KW.TextField, $KW.DataGrid, $KW.Media, $KW.Slider, $KW.Map, $KW.FlexContainer, $KW.FlexScrollContainer, $KW.Browser, $KW.CollectionView, $KW.ListBox];
            for(var i = 0; i < widgetsSupported.length; i++) {
                if(widgetsSupported[i]) {
                    widgetsSupported[i].initializeView && widgetsSupported[i].initializeView(formId);
                }
            }
            if(isForm) {
                module.resizeForm(formId);
            }

            var pageBody = document.getElementsByTagName('body')[0];
            var bodywidth = pageBody.style.width;
            if(!pageBody.hasAttribute("bodywidth") && bodywidth.indexOf("%") !== -1) {
                pageBody.setAttribute("bodywidth", bodywidth);
            }
            var width = ($KG.appbehaviors["responsive"] === true) ? $KU.getWindowWidth() : screen.width;
            module.adjustBodyWidth(formId, width);
        },

        updateView: function(formModel, propertyName, propertyValue, oldPropertyValue) {
            switch(propertyName) {
                case "title":
                    document.title = propertyValue || $KG.apptitle || $KG.appid;
                    formModel.i18n_title = "";
                    break;

                case "padding":
                    var element = document.getElementById(formModel.id);
                    if(!$KG.needScroller)
                        element && (element.style[propertyName] = $KU.joinArray(propertyValue, "% ") + "%");
                    break;
            }
        },

        breakpointChanged: function(formModel, width) {
            var flag = false,
                previousBreakPoint = -1,
                currentBreakpoint = -1;

            previousBreakPoint = (typeof $KG["__currentFormBreakpoint"] === 'number') ? $KG["__currentFormBreakpoint"] : -1;
            currentBreakpoint = module.getCurrentBreakpoint(formModel, width);

            if(previousBreakPoint !== currentBreakpoint) {
                flag = true;
                $KG["__currentFormBreakpoint"] = currentBreakpoint;
            }
            return flag;
        },

        resizeHandler: function(formModel, width) {
            var frameworkReturnValue = false,
                resizeReturnValue = true,
                resizeEventRef = null,
                breakpointChangeReturnValue = false;

            if($KG.appbehaviors["responsive"] !== true) return;

            if(module.breakpointChanged(formModel, width)) {
                frameworkEventRef = $KU.returnEventReference(formModel.onbreakpointhandler);
                breakpointEventRef = $KU.returnEventReference(formModel.onbreakpointchange);

                if(frameworkEventRef) {
                    frameworkReturnValue = $KU.executeWidgetEventHandler(formModel, frameworkEventRef, $KG["__currentFormBreakpoint"]);
                }
                if(breakpointEventRef) {
                    breakpointChangeReturnValue = $KU.executeWidgetEventHandler(formModel, breakpointEventRef, $KG["__currentFormBreakpoint"]);
                }
            }

            resizeEventRef = $KU.returnEventReference(formModel.onresize);
            if(resizeEventRef) {
                resizeReturnValue = $KU.executeWidgetEventHandler(formModel, resizeEventRef, width);
            }

            if(frameworkReturnValue !== false) {
                frameworkReturnValue = true;
            }
            if(breakpointChangeReturnValue !== false) {
                breakpointChangeReturnValue = true;
            }
            if(resizeReturnValue !== false) {
                resizeReturnValue = true;
            }

            if(frameworkReturnValue ||
                breakpointChangeReturnValue ||
                resizeReturnValue) {
                module.adjustBodyWidth(formModel.id, width);
            }
            if(window.scrollY && kony.appinit.isiPhone && kony.appinit.isSafari) {
                window.scrollTo(0, 0);
            }
        },
        orientationHandler: function(formId, orientation) {
            var formModel = $KG.allforms[formId];
            var formevntref = $KU.returnEventReference(formModel.preorientationchange);
            formevntref && $KU.executeWidgetEventHandler(formModel, formevntref, orientation);
            
            if(formModel) {
                spaAPM && spaAPM.sendMsg(formModel, 'onorientationchange', {
                    "orientation": orientation
                });
                var formref = $KU.returnEventReference(formModel.onorientationchange);
                formref && $KU.executeWidgetEventHandler(formModel, formref, orientation);
                module.initializeFlexContainersIfNeeded(formModel, function() {
                    module.setFormDimensions($KG["__currentForm"]);
                });
            }
        },

        setFormDimensions: function(formModel) {
            if($KW.FlexUtils.isFlexContainer(formModel)) {
                var formNode = document.getElementById(formModel.id);
                if(formNode) {
                    formNode.style.height = module.getFormHeight();
                    module.adjustBodyWidth(formModel.id, $KU.getWindowWidth());
                }
            }
        },

        generateAppmenu: function(formModel) {
            var more_container = document.getElementById('appmenumore_container');
            if(more_container)
                more_container.parentNode.removeChild(more_container);
            if($KG.__appmenu && formModel.needappmenu)
                return $KW["Appmenu"] && $KW["Appmenu"].render($KG.__appmenu);
            else
                return "";
        },

        initializeTemplates: function(tempID) {
            $KW.touch.computeSnapWidths(tempID, "Segment");
            this.initializeTouchWidgets(tempID);
        },

        initializeTouchWidgets: function(formId, isForm) {
            $KW.Scroller.initializeScrollBoxes(formId); 
            $KW.Scroller.initializePageViews(formId); 
            this.initializeView(formId, isForm);
        },

        initializeFlexContainers: function(formModel) {
            $KG.isUILayedOut = false;
            if(!formModel)
                return;
            var formId = $KG.needScroller ? formModel.id + "_container" : formModel.id;
            $KW.touch.computeSnapWidths(formId, "Segment"); 
            this.initializeFlexContainersInTemplate(formModel);
            
            if($KG[formModel.id + '_scroller']) 
                $KW.Scroller.setHeight(formModel.id);
            this.initializeAllFlexContainers(formModel);
            $KG.isUILayedOut = true;
        },

        initializeFlexContainersInTemplate: function(formModel) {
            if(formModel.headers && formModel.headers.length > 0) {
                this.initializeBox(formModel.headers[0], $KG["needScroller"] ? formModel.id + "_header" : 'header_container');
            }
            if(formModel.footers && formModel.footers.length > 0) {
                this.initializeBox(formModel.footers[0], $KG["needScroller"] ? formModel.id + "_footer" : 'footer_container');
            }
        },

        initializeBox: function(boxModel, id){
            var flexNode;
            if(boxModel.wType == 'FlexContainer') {
                flexNode = document.querySelector('#' + id + ' div[kwidgettype="FlexContainer"]');
                if(flexNode) {
                    flexNode = flexNode.parentNode;
                }
                $KW.FlexContainer.forceLayout(boxModel, flexNode);
            } else {
                this.initializeFlexContainersInBox(boxModel);
            }
        },

        initializeAllFlexContainers: function(containerModel) {
            if($KW.FlexUtils.isFlexContainer(containerModel)) {
                containerModel.forceLayout();
                module.initializeAllFlexScrollContainers(containerModel);
                return;
            }
            this.initializeFlexContainersInBox(containerModel);
        },

        initializeAllFlexScrollContainers: function(formModel) {
            var flexNode, flexScrollModel, id, flexScrollElements, i, flexScrollNode;
            id = formModel.id;
            flexScrollElements = document.querySelectorAll('#' + id + ' div[kwidgettype="FlexScrollContainer"]');
            if(flexScrollElements) {
                for(i = 0; i < flexScrollElements.length; i++) {
                    flexScrollNode = flexScrollElements[i];
                    flexScrollModel = $KU.getModelByNode(flexScrollNode);
                    $KW.FlexContainer.forceLayout(flexScrollModel);
                }
            }
        },

        initializeFlexContainersInBox: function(boxModel) {
            var wArray = boxModel.ownchildrenref;
            var containerType = boxModel.wType;
            for(var i = 0; i < wArray.length; i++) {
                var widgetModel = wArray[i];
                var wType = widgetModel.wType;
                if(containerType == 'TabPane' && !$KW.TabPane.isActiveTab(boxModel, widgetModel)) {
                    if(boxModel.viewtype != constants.TABPANE_VIEW_TYPE_PAGEVIEW)
                        continue;
                }
                switch(wType) {
                    case "FlexContainer":
                    case "FlexScrollContainer":
                        widgetModel.forceLayout();
                        break;
                    case "Segment":
                        var segNode = $KU.getNodeByModel(widgetModel);
                        if(segNode) {
                            if(widgetModel.layoutConfig.self)
                                $KU.needOptimization = false;
                            widgetModel.isvisible && $KW.FlexContainer.adjustFlexContainers(widgetModel, segNode);
                            if(widgetModel.viewtype == constants.SEGUI_VIEW_TYPE_PAGEVIEW)
                                $KW.touch.computeWidths(segNode, widgetModel);
                            $KU.needOptimization = true;
                        }
                        break;
                }

                if((widgetModel.wType == 'TabPane') && widgetModel.ownchildrenref) {
                    this.initializeFlexContainersInBox(widgetModel);
                }
            }
        },

        updateContaineri18nProperties: function(formModel) {
            if(formModel.headers && formModel.headers.length > 0) {
                for(var header in formModel.headers) {
                    $KI.i18n.translateFormModel(formModel.headers[header]);
                }
            }

            if(formModel.footers && formModel.footers.length > 0) {
                for(var footer in formModel.footers) {
                    $KI.i18n.translateFormModel(formModel.footers[footer]);
                }
            }
        },

        destroyTouchWidgets: function(formId, isNonForm) {
            if(!isNonForm)
                $KW.Scroller.destroyFormScroller(formId);

            $KW.Scroller.destroyScrollBoxes(formId);
            $KW.Scroller.destroyCollectionViewScroller(formId);
            $KW.Scroller.destroyImageStripStripViews(formId);
            $KW.Scroller.destroyPageViews(formId);
            $KW.Segment && $KW.Segment.destroyAnimations(formId);
            $KW.Scroller.destroyListBoxEditableInstances();
        },

        handleFormVisibility: function(containerModel) {
            var childList, i, childModel;
            childList = containerModel.children;
            for(i = 0; i < childList.length; i++) {
                childModel = containerModel[containerModel.children[i]];
                childModel = $KW.Utils.getActualWidgetModel(childModel);
                delete childModel._isRendered;
                
                if(childModel.children && childModel.children.length > 0) {
                    module.handleFormVisibility(childModel)
                }
            }
        },


        formRendered: function(formId) {
            kony.events.browserback.updateURLWithLocation(formId);
            module.enlistSystemTimerActions();
            if($KU.isWindowsPhone && $KU.isIE9)
                window.scrollTo(0, 0);
            else if($KG.nativeScroll)
                window.scrollTo(0, 1);
        },

        resizeForm: function(formId, orientation) {
            var formModel = $KG.allforms[formId];
            
            if($KG["nativeScroll"]) {
                var viewPortHeight = ($KU.isWindowsPhone && $KU.getPlatform().version == "7.5") ? ($KW.Utils.getViewPortHeight() + 10) : $KW.Utils.getViewPortHeight();
                document.body.style.minHeight = viewPortHeight + "px";
            }

            if(kony.appinit.isTablet && kony.appinit.isAndroid && (kony.constants.APPLICATION_MODE_HYBRID || kony.constants.APPLICATION_MODE_WRAPPER)) {
                document.body.style.minHeight = (screen.height / window.devicePixelRatio - window.screenTop) + 'px';
            }

            if(formModel.resizeForm && $KG["nativeScroll"]) {
                var windowHeight = window.innerHeight || document.body.clientHeight;
                var formNode = document.getElementById(formId);
                var totalHeight, formHeight;

                var totalHeight = __MainContainer.clientHeight;
                var formHeight = formNode.clientHeight;

                
                if(!orientation) {
                    totalHeight = __MainContainer.__clientHeight = __MainContainer.clientHeight;
                    formHeight = formNode.__clientHeight = formNode.clientHeight;
                } else {
                    totalHeight = __MainContainer.__clientHeight;
                    formHeight = formNode.__clientHeight;
                }

                
                if(totalHeight < windowHeight) {
                    var bias = windowHeight - totalHeight;
                    formHeight = formHeight + bias;
                    formNode.style.minHeight = formHeight + "px";

                    if($KU.isWindowsPhone && $KU.isIE9)
                        setTimeout(function() {
                            window.scrollTo(0, 0)
                        }, 10);
                    else
                        setTimeout(function() {
                            window.scrollTo(0, 1)
                        }, 10);
                }
            }
        },

        enlistSystemTimerActions: function() {
            
            if($KU.hashChange) {
                kony.events.addEventListener(window, 'hashchange', kony.events.browserback.handleBrowserBackEvent);
            } else {
                var browserBackAction = new kony.system.timers.TimerAction(kony.events.browserback.handleBrowserBackEvent, 300);
                kony.system.timers.registerTimerAction(browserBackAction);
            }
        },

        delistSystemTimerActions: function() {
            kony.system.timers.clearTimerAction();
        },

        addChild: function(formModel, wArray, bVisibility) {
            if($KG["__currentForm"] && formModel.id == $KG["__currentForm"].id) {

                var formNode = $KU.getElementById(formModel.id);

                kony.events.executeActionOnComponent(wArray, "preshow", true);


                if(!formNode)
                    return;
                $KU.updatei18nProperties(wArray);
                var htmlString = "";
                if(wArray.length > 0) {
                    htmlString = this.renderChildren(formModel, wArray);
                }

                    var wrapper = document.createElement("div");
                wrapper.innerHTML = htmlString;
                while(wrapper.children.length > 0) {
                    formNode.appendChild(wrapper.children[0]);
                }
                $KU.layoutNewWidgets(formModel, wArray);
                $KW.Utils.initializeNewWidgets(wArray);
                kony.events.executeActionOnComponent(wArray, "postshow", false);
            }
        },

        addChildAt: function(formModel, widget, index) {
            if($KG["__currentForm"] && formModel.id == $KG["__currentForm"].id) {
                var formNode = $KU.getElementById(formModel.id);

                kony.events.executeActionOnComponent(widget, "preshow", true);

                if(!formNode)
                    return;
                $KU.updatei18nProperties(wArray);

                var htmlString = "";
                var isFlexContainer = $KW.FlexUtils.isFlexContainer(formModel);
                if(isFlexContainer)
                    htmlString = $KW.FlexContainer.renderChildren(formModel, [formModel[widget.id]], {});
                else
                    htmlString = module.generateWidget(formModel, formModel[widget.id]);

                
                var outerDiv = document.createElement("div");
                outerDiv.innerHTML = htmlString;
                var wArray = [widget];

                formNode.insertBefore(outerDiv.childNodes[0], formNode.children[index] || null);
                $KU.layoutNewWidgets(formModel, wArray);
                $KW.Utils.initializeNewWidgets(wArray);
                kony.events.executeActionOnComponent(wArray, "postshow", false);
            }
        },

        DOMremove: function(formModel, widgetref) {
            if($KG["__currentForm"] && (formModel.id == $KG["__currentForm"].id) && widgetref) {
                var isFlexContainer = $KW.FlexUtils.isFlexContainer(formModel);
                if(isFlexContainer) {
                    var node = $KW.Utils.getWidgetNode(widgetref);
                    if(node) {
                        node = node.parentNode;
                        node.parentNode.removeChild(node);
                    }
                } else {
                    var node = document.getElementById(formModel.id + "_" + widgetref.id);
                    if(node) {
                        node = $KU.returnParentChildBloatAdjustedNode(widgetref, node);
                        node.parentNode.removeChild(node);
                    }
                }
            }
        },

        DOMremoveAt: function(formModel, index) {
            module.DOMremove(formModel, formModel.ownchildrenref[index]);
        },

        DOMremoveAll: function(formModel) {
            var form = document.getElementById(formModel.id);
            if(form) {
                form.innerHTML = "";
            }
        },

        
        add: function() {
            var formmodel = arguments[0];
            if("add" in formmodel) {
                var widarray = [].slice.call(arguments, 1);
                formmodel.add(widarray)
            }
        },

        addAt: function(formModel, widgetref, index) {
            if(widgetref == null) return;
            formModel.addAt && formModel.addAt(widgetref, index);
        },

        remove: function(formModel, widgetref) {
            formModel.remove && formModel.remove(widgetref);
        },

        removeAt: function(formModel, index) {
            if(formModel.removeAt)
                return formModel.removeAt(index);
        },

        widgets: function(formModel) {
            return formModel.widgets && formModel.widgets();
        },

        scrollToBeginning: function(formModel) {
            var form = $KU.getElementById(formModel.id + "_container");
            form && $KW.Utils.animateY(window.pageYOffset, 0);
        },

        scrollToEnd: function(formModel) {
            var form = $KU.getElementById(formModel.id + "_container");
            form && $KW.Utils.animateY(window.pageYOffset, form.scrollHeight);
        },

        scrollToWidget: function(formref, widgetref) {
            $KW.APIUtils.setfocus(widgetref);
        },

        destroy: function(formID) {
            if(formID && "destroy" in formID) formID.destroy();
        },

        getCurrentBreakpoint: function() {
            var formModel = null,
                width = -1,
                breakpoints = [],
                b = 0,
                blen = 0,
                currentBreakpoint = -1;

            if($KG.appbehaviors["responsive"] === true) {
                if(typeof $KG["__currentFormBreakpoint"] === 'number' &&
                    $KG["__currentFormBreakpoint"] >= 0 && arguments.length < 2) {
                    currentBreakpoint = $KG["__currentFormBreakpoint"];
                } else {
                    formModel = (arguments.length >= 1) ? arguments[0] : $KG["__currentForm"];
                    breakpoints = (formModel) ? formModel.breakpoints : null;

                    if(!(breakpoints instanceof Array && breakpoints.length > 0)) {
                        breakpoints = $KG.appbehaviors["breakpoints"];

                        if(!(breakpoints instanceof Array && breakpoints.length > 0)) {
                            breakpoints = null;
                        }
                    }

                    if(breakpoints && breakpoints.length > 0) {
                        width = (arguments.length >= 2) ? arguments[1] : $KU.getWindowWidth();
                        blen = breakpoints.length;

                        if(width > breakpoints[(blen - 1)]) {
                            currentBreakpoint = constants.BREAKPOINT_MAX_VALUE;
                        } else if(width <= breakpoints[0]) {
                            currentBreakpoint = breakpoints[0];
                        } else {
                            for(b = 1; b < blen; b++) {
                                if(width <= breakpoints[b]) {
                                    currentBreakpoint = breakpoints[b];
                                    break;
                                }
                            }
                        }
                    }
                }
            }

            return currentBreakpoint;
        },

        getCurrentForm: function() {
            $KU.logExecuting('kony.application.getCurrentForm');
            $KU.logExecutingWithParams('kony.application.getCurrentForm');
            $KU.logExecutingFinished('kony.application.getCurrentForm');
            return $KG["__currentForm"];
        },

        getPreviousForm: function() {

            $KU.logExecuting('kony.application.getPreviousForm');
            $KU.logExecutingWithParams('kony.application.getPreviousForm');
            $KU.logExecutingFinished('kony.application.getPreviousForm');
            return $KG["__previousForm"];
        },

        
        handleshow: function(formModel) {
            if("show" in formModel)
                formModel.show();
        },

        
        generateWidget: function(formModel, childModel) {
            var context = new $KW.WidgetGenerationContext(formModel.id);
            var childType = childModel.wType;
            var htmlString = "";

            
            if(childType == "Line" || childType == "TabPane") {
                context.setTopLevelBox(true);
                htmlString += $KW[childType] && $KW[childType].render(childModel, context);
                context.setTopLevelBox(false);
            } else {
                if(childType == "Image") childModel.containerweight = 100;
                var layoutDirection = $KW.skins.getWidgetAlignmentSkin(childModel);
                htmlString += "<div class = ' kwt100 " + layoutDirection + "' >";
                htmlString += $KW[childType] && $KW[childType].render(childModel, context);
                htmlString += "</div>";
            }
            return htmlString;
        },



        

        

        getDeviceSpecificClass: function() {
            var deviceName = this.getDeviceDetails(),
            browserName = this.getBrowserDetails(),
            clientDetails = deviceName + ' ' + browserName;

            return clientDetails;
        },

        getDeviceDetails: function() {
            var deviceName = '';

            if(kony.appinit.isiPhone) {
                deviceName = 'iPhone';
            } else if(kony.appinit.isiPad) {
                deviceName = 'iPad';
            }

            return deviceName;
        },

        getBrowserDetails: function() {
            var browserName = '';

            if(kony.appinit.isSafari) {
                browserName = 'safari';
            } else if(kony.appinit.isChrome) {
                browserName = 'chrome';
            }

            return browserName;
        },
        render: function(formModel) {
            var htmlString = "", fClass = "", tempDiv = null;
            var pageBody = document.getElementsByTagName('body')[0];

            var main = $KU.getElementById("__MainContainer"); 
            if(!($KG.appbehaviors && $KG.appbehaviors["stopLoadingScreenDismissOnFormNavigation"] === true) && !main) {
                pageBody.innerHTML = "<div id='__MainContainer'>";
                main = $KU.getElementById("__MainContainer");
            }
            
            if($KG["__previousForm"]) {
                var prevformhintid = $KG["__previousForm"].id + "-hint";
                var hintwraper = document.getElementById(prevformhintid);
                if(hintwraper) {
                    document.body.removeChild(hintwraper);
                }
            }

            htmlString += "<div id='" + formModel.id + "_container'"+(formModel.skin ? (" class='"+formModel.skin+"'") : "")+" style='padding:" + $KU.joinArray(formModel.padding, "% ") + "%" + "'>";
            htmlString += formModel.header ? this.generateHeader(formModel.header, "header") : "";
            htmlString += this.generateForm(formModel);
            htmlString += formModel.footer ? this.generateHeader(formModel.footer, "footer") : "";
            htmlString += "</div>";

            if(_newFormTransitionApplicable(formModel, 'in')
            || _newFormTransitionApplicable(formModel, 'out')) {
                tempDiv = document.createElement('DIV');
                tempDiv.innerHTML = htmlString;
                main.appendChild(tempDiv.firstChild);
            } else {
                main.innerHTML = htmlString;
            }

            var wrapper = document.createElement("div");
            var appMenuHtml = "<div id='appmenu_container' style='position:fixed;bottom:0px;width:100%'>" + this.generateAppmenu(formModel) + "</div>";
            wrapper.innerHTML = appMenuHtml;

            main.appendChild(wrapper.firstChild);

            if($KW.Map && $KW.Map.isMainContaineraVailable == false)
                $KW.Map.loadMapScripts();

            var appMenu = $KU.getElementById("appmenu_container");
            if(appMenu) { 
                appMenu.parentNode.style.paddingBottom = appMenu.offsetHeight + "px";
            }

            formModel.header && this.initializeTemplates(formModel.header);
            formModel.footer && this.initializeTemplates(formModel.footer);
            pageBody.className = this.getDeviceSpecificClass();
            document.title = formModel.title || $KG["apptitle"] || $KG["appid"];

            $KU.deduceTopLevelFlexModal(formModel);
        },

        generateForm: function(formModel) {
            var htmlString = "";

            htmlString += "<form id='" + formModel.id + "' action= 'javascript:;' class='kwt100' style='position:relative;' " + ">";

            
            if(formModel.children) {

                if(formModel.layouttype == constants.CONTAINER_LAYOUT_GRID) { 
                    var context = new $KW.WidgetGenerationContext(formModel.id);
                    htmlString += $KW.Grid.render(formModel, context);
                } else {

                    var wArrary = formModel.widgets();
                    htmlString += this.renderChildren(formModel, wArrary);
                }
            }


            htmlString += "</form>";
            return htmlString;
        },

        renderChildren: function(formModel, wArrary) {
            var htmlString = "";
            if(formModel.layouttype == kony.flex.VBOX_LAYOUT) {
                for(var i = 0; i < wArrary.length; i++) {
                    var childModel = wArrary[i];
                    htmlString += module.generateWidget(formModel, childModel);
                }
            } else {
                var context = new $KW.WidgetGenerationContext(formModel.id);
                htmlString += $KW.FlexContainer.renderChildren(formModel, wArrary, context);
            }
            return htmlString;
        },

        generateHeader: function(headerID, type) {
            var htmlString = "";
            htmlString += "<div id='" + type + "_container' class='kwt100'>";
            htmlString += this.generateTemplate(headerID, type);
            htmlString += "</div>";
            return htmlString;
        },

        
        generateTemplate: function(headerID, type, context) {
            var headerModel = kony.model.getWidgetModel(headerID);
            var htmlString = "";
            if(headerModel.children) {
                if(context && context.rowtemplate) {
                    return $KW[context.rowtemplate.wType].render(headerModel, context);
                }
                htmlString = "<div id='" + headerModel.id + "' kformname='" + headerModel.pf + "'";
                if(type == "menu" || type == "menuitem") {
                    if(headerModel.skin) htmlString += " class='" + headerModel.skin + "'";
                    htmlString += " mtype='" + type + "' ";
                }

                if(context && context.menuType === constants.MENU_CONTAINER_VIEW_TYPE_TREEVIEW && type == "menu") {
                    htmlString += " class='toggle' ";
                }

                htmlString += ">";
                for(var i = IndexJL; i < headerModel.children.length; i++) {
                    var childModel = headerModel[headerModel.children[i]];
                    var tempContext = new $KW.WidgetGenerationContext(headerModel.id);
                    if(context) {
                        tempContext.tabpaneID = context.tabpaneID;
                        tempContext.container = context.container;
                    }
                    tempContext.setTopLevelBox(true);
                    htmlString += $KW[childModel.wType].render(childModel, tempContext);
                    tempContext.setTopLevelBox(false);
                }
                htmlString += "</div>"
            }
            return htmlString;
        },

        show: function(formModel) {
            if($KG.appbehaviors["recording"] == true) {
                this.removeDomChangeEvents();
            }

            if($KG["localization"] && !$KG["i18nInitialized"])
                $KI.i18n.setdefaultlocale($KG["defaultlocale"], module.extendShow(formModel))
            else
                module.extendShow(formModel)();
        },

        extendShow: function(formModel) {
            return function() {
                var formNode = null,
                    fHeight = '',
                    prevNode = null;

                if(formModel) {
                    
                    if(formModel.enabledforidletimeout && $KG["__idletimeout"] && $KG["__idletimeout"].expired && $KG["__idletimeout"].enabled) {
                        $KG["__idletimeout"].cb && $KG["__idletimeout"].cb(formModel);
                        $KG["__idletimeout"].expired = false;
                        $KG["__idletimeout"].cb = null;
                        return;
                    }

                    
                    
                    if(!$KG["transitAll"])
                        $KG["transitAll"] = true;

                    if(!formModel.initialized) {
                        
                        
                        
                        
                        
                        
                        
                    }

                    var curForm = $KG["__currentForm"];
                    if(curForm && curForm.id != formModel.id) {
                        kony.events.executeActionOnContainer(curForm, "onhide", false);
                        spaAPM && spaAPM.sendMsg(curForm, 'onhide');
                    }
                    if(curForm && curForm.onhide && curForm.id != formModel.id) {
                        var curref = $KU.returnEventReference(curForm.onhide);
                        curref && $KU.executeWidgetEventHandler(curForm, curref);
                    }

                    if($KG["__currentForm"])
                        $KG["__previousForm"] = $KG["__currentForm"];

                    var rendered = false;
                    kony.isformRendered = false;
                    $KG["__currentForm"] = formModel;
                    $KG["__currentFormBreakpoint"] = -1;

                    var prevForm = $KG["__previousForm"];
                    if(prevForm && prevForm.id == formModel.id) {
                        rendered = true;
                        kony.isformRendered = true;
                    }

                    if(formModel.preshow) {
                        var preref = $KU.returnEventReference(formModel.preshow);
                        $KU.executeWidgetEventHandler(formModel, preref);
                    }

                    kony.events.executeActionOnContainer(formModel, "preshow", true);

                    
                    if(!rendered) {
                        if($KG["localization"]) {
                            $KI.i18n.translateFormModel(formModel);
                            module.updateContaineri18nProperties(formModel);
                        }
                        if(prevForm) {
                            if(prevForm.retainscrollposition) {
                                var isFlexForm = $KW.FlexUtils.isFlexContainer(prevForm);
                                if(isFlexForm) {
                                    var prevformid = document.getElementById(prevForm.id);
                                    if(prevformid)
                                        prevForm.y =   document.getElementById(prevForm.id).scrollTop;
                                }
                                else {
                                    prevForm.y = window.pageYOffset || document.documentElement.scrollTop;
                                }
                            }
                            module.destroyTouchWidgets(prevForm.id, "");
                            if($KG.appbehaviors["lazyLoadDOM"] == true && prevForm) {
                                module.handleFormVisibility(prevForm);
                            }
                        }
                        module.resizeHandler(formModel, $KU.getWindowWidth());
                        if(prevForm && (kony.appinit.isMob || kony.appinit.isTablet)) { 
                            prevNode = $KU.getNodeByModel(prevForm);
                            fHeight = prevNode.style.height;
                        }
                        module.render(formModel);
                        module.formRendered(formModel.id);
                        module.adjustBodyWidth(formModel.id);
                        if((kony.appinit.isMob || kony.appinit.isTablet) && prevForm && $KW.FlexUtils.isFlexContainer(formModel) && $KW.FlexUtils.isFlexContainer(prevForm)) {
                            formNode = $KU.getNodeByModel(formModel);
                            formNode.style.height = fHeight;
                            formNode.style.overflowY = "auto";
                            formNode.style.overflowX = "hidden";
                        } else {
                            module.setFormHeight(formModel);
                        }
                        module.initializeFlexContainers(formModel);
                        $KW.Utils.initializeFormGestures(formModel);

                        if($KW.FlexUtils.isFlexContainer(formModel)) {
                            $KW.Utils.initializeScrollEvents(document.querySelectorAll('#' + formModel.id), formModel);
                        }

                        module.applyTransition($KG["__previousForm"], formModel);


                        if(!kony.system.activity.hasActivity()) {
                            $KW.unLoadWidget();
                        }
                        if(appConfig.testAutomation && window.jasmineOnload) {
                            window.jasmineOnload();
                        }
                        if(kony.constants.APPSTATE === 0) {
                            kony.constants.APPSTATE = 1;
                            if(!kony.events.isFrameworkEventsRegistered)
                                kony.events.registerDocumentEvents();
                            $KIO.fs.init(); 
                        }
                        kony.isformRendered = true;
                        spaAPM && spaAPM.sendMsg(formModel, 'show');
                    } else {
                        module.resizeHandler(formModel, $KU.getWindowWidth());
                        kony.events.executeActionOnContainer(formModel, "postshow", false);
                        if(formModel.postshow) {
							var postref = $KU.returnEventReference(formModel.postshow);
							$KU.executeWidgetEventHandler(formModel, postref);
						}
                        $KW.FlexUtils.isFlexContainer(formModel) && formModel.forceLayout();
                        if($KC.widgetDataRecording == true) {
                            $KC.generateFormJSONAfterRender(formModel);
                        }
                    }

                    if($KC.widgetDataRecording == true) {
                        $KI.setupWidgetDataRecording({mode:1}); 
                    }

                    $KW.TPW.renderWidget(formModel.id);
                    formModel.initialized = true;
                }
            }
        },

        applyTransition: function(previousForm, currentForm) {
            var src, dest, ev, outTrans, inTrans, trans;

            src = previousForm && $KU.getElementById(previousForm.id + "_container");
            dest = $KU.getElementById(currentForm.id + "_container");

            if(previousForm && $KW.FlexUtils.isFlexContainer(previousForm)) {
                clearInterval(previousForm.scrollerTimer);
            }

            inTrans = currentForm.intransitionconfig;
            outTrans = (previousForm && inTrans) ? previousForm.outtransitionconfig : null;

            if(inTrans) {
                if(_newFormTransitionApplicable(currentForm, 'in')) {
                    if(typeof inTrans.formAnimation === 'number'
                    || typeof inTrans.formanimation === 'number') {
                        trans = _normalizeTransition.number(inTrans, outTrans);
                    }
                } else {
                    trans = _normalizeTransition.string(inTrans);
                }

                inTrans = trans.inTrans;
                outTrans = trans.outTrans;
            }

            if(!$KG["disableTransition"] && (inTrans || outTrans)) {
                ev = (kony.appinit.isFirefox || kony.appinit.isIE11) ? "animationend" : $KU.animationEnd;

                currentForm.__ev = function(srcForm, destForm, currForm, prevForm, ev) {
                    return function(event) {
                        if(!event)
                            event = window.event;
                        currForm.__ev = "";
                        if(event.type == ev) {
                            kony.events.removeEventListener(destForm, event.type, arguments.callee);
                            destForm.style[$KU.animationName] = "";
                            destForm.style[$KU.animationDuration] = "";
                        }
                        module.endTransition(srcForm, destForm, currForm, prevForm);
                    }
                }(src, dest, currentForm, previousForm, ev);

                kony.events.addEventListener(dest, ev, currentForm.__ev);
                var isFlexForm = $KW.FlexUtils.isFlexContainer(currentForm);
                if(isFlexForm) {
                    document.body.style.overflowX = document.body.style.overflowY = 'hidden';
                    dest.parentNode.style.height = dest.firstChild.style.height;
                }

                if(src && outTrans) {
                    src.style.position = 'absolute';
                    src.style.left = '0px';
                    src.style.top = '0px';
                    src.style.overflow = 'hidden';
                    src.style.width = '100%';
                }

                if(inTrans) {
                    dest.style.zIndex = 2147483646;
                    dest.style.position = 'absolute';
                    dest.style.left = '0px';
                    dest.style.top = '0px';
                    dest.style.overflow = 'hidden';
                    dest.style.width = '100%';
                }

                if(src && outTrans) {
                    src.style[$KU.animationDuration] = outTrans.duration;
                    src.style[$KU.animationName] = outTrans.effect;
                }

                if(inTrans) {
                    dest.style[$KU.animationDuration] = inTrans.duration;
                    dest.style[$KU.animationName] = inTrans.effect;
                }
            } else {
                $KU.removeClassName(dest, "hidden");
                dest.style.display = "";
                this.endTransition(src, dest, currentForm, previousForm);
            }
        },

        endTransition: function(src, dest, currentForm, previousForm) {
            var main = $KU.getElementById("__MainContainer");

            if(src) {
                if(previousForm.__ev) {
                    
                    previousForm.__ev();

                }

                if(src.nextSibling.id === 'appmenu_container') {
                    main.removeChild(src.nextSibling);
                }
                main.removeChild(src);
            }

            
            
            document.body.style.removeProperty('overflow-y');
            main.style.removeProperty('height');
            dest.style.removeProperty('position');
            dest.style.removeProperty('left');
            dest.style.removeProperty('right');
            dest.style.removeProperty('width');
            dest.style.removeProperty('overflow');
            dest.style.removeProperty('z-index');

            module.initializeTouchWidgets(currentForm.id);
            var mapCanvasElement = document.querySelectorAll('[name=map_canvas]')[0];
            var scriptloaded = $KG["mapScriptLoaded"];
            if(mapCanvasElement && scriptloaded)
                $KW.Map.setUpInteractiveCanvasMap();

            $KG["__previousForm"] && window.scrollTo(0, 0);
            
            if(currentForm.retainscrollposition) {
                if(typeof currentForm.y == "undefined")
                    currentForm.y = 0;
                var isFlexForm = $KW.FlexUtils.isFlexContainer(currentForm);
                if(isFlexForm) {
                    var currformid = currentForm.id;
                    document.getElementById(currformid).scrollTop = currentForm.y;
                }
                else {
                    window.scrollTo(0, currentForm.y);
                }
            }
            kony.events.executeActionOnContainer(currentForm, "postshow", false);
            if($KC.widgetDataRecording == true) {
                $KC.generateFormJSONAfterRender(currentForm);
            }
            if(currentForm.postshow) {
                var postref = $KU.returnEventReference(currentForm.postshow);
                $KU.executeWidgetEventHandler(currentForm, postref);
            }
            $KW.FlexUtils.isFlexContainer(currentForm) && currentForm.forceLayout();
            if(spaAPM && typeof appStartTime !== "undefined") {
                var curTime = new Date().getTime();
                var timeDiff = curTime - appStartTime;
                spaAPM.sendMsg(currentForm, 'AppLoad', {
                    "loaddur": timeDiff
                });
            }
        },

        getScrollbarWidth: function() {
            var el = document.createElement('div');
            el.style.cssText += 'width:100px;height:100px;overflow:scroll;position:absolute;';
            document.body.appendChild(el);
            var diff = el.offsetWidth - el.clientWidth;
            document.body.removeChild(el);
            return diff;

        },

        adjustBodyWidth: function(formId, width) {
            var pageBody = document.getElementsByTagName('body')[0];
            var formWidth = '',
                bodywidth = pageBody.getAttribute("bodywidth");

            if(($KG.appbehaviors["responsive"] === true) && (!bodywidth || typeof width !== 'number')) {
                return;
            }

            if(!bodywidth) { 
                return;
            }

            if(bodywidth.indexOf("%") != -1) {
                bodywidth = parseInt(bodywidth.replace("%", ""), 10);
                pageBody.setAttribute("percentage", "true");
                formWidth = (width / 100) * bodywidth;
                pageBody.setAttribute("formWidth", formWidth);
            }

            formWidth = pageBody.getAttribute("formWidth");

            pageBody.style["overflow-x"] = "auto";
            pageBody.style["overflowX"] = "auto";

            var scroller = document.getElementById(formId + "_wrapper");

            var scrollerWidth = this.getScrollbarWidth();

            
            
            var hasVScroll = document.body.scrollHeight - (window.innerHeight || document.documentElement.clientHeight);
            
            if(hasVScroll > 1) {
                pageBody.style.width = (formWidth - scrollerWidth) + "px";
            } else {
                pageBody.style.width = formWidth + "px";
            }
        },

        getFormHeight: function() {
            var computedStyle = $KU.getComputedStyle(document.body);
            var formBorderTop = parseInt(computedStyle['border-top-width'], 10);
            var formBorderBottom = parseInt(computedStyle['border-bottom-width'], 10);
            formBorderTop = (isNaN(formBorderTop)) ? 0 : formBorderTop;
            formBorderBottom = (isNaN(formBorderBottom)) ? 0 : formBorderBottom;
            return($KU.getWindowHeight() - (formBorderTop + formBorderBottom)) + "px";
        },

        setFormHeight: function(formModel) {
            if($KW.FlexUtils.isFlexContainer(formModel)) {
                var formNode = $KU.getElementById(formModel.id);
                formNode.style.height = module.getFormHeight();
                formNode.style.overflowY = "auto";
                formNode.style.overflowX = "hidden";
                if(kony.appinit.isMob || kony.appinit.isTablet) {
                    return;
                }
                formModel.scrollerTimer = setInterval(function(formModel) {
                    return function() {
                        var frame = null, formNode = null, previousHeight = null, currentHeight = null;
                        if(formModel.media && formModel.media.type === 'print') return;

                        $KW.Form.initializeFlexContainersIfNeeded(formModel, function(formNode) {
                            formNode.style.height = module.getFormHeight();
                        });
                    };
                }(formModel), 1000);
            }
        },

        initializeFlexContainersIfNeeded: function(formModel, callback) {
            var frame = formModel.frame;
            var formNode = $KU.getElementById(formModel.id);
            var previousHeight = formNode.style.height;
            var currentHeight = module.getFormHeight();

            callback(formNode);

            if(formNode && (frame.width != formNode.offsetWidth || previousHeight != currentHeight)) {
                module.initializeFlexContainers(formModel);
            }
        }

        


        

    };


    return module;
}());


var domChangeObserver = null;


$KW.Appmenu = (function() {
    
    

    var module = {
        focusIndex: "",

        initialize: function() {
            kony.events.addEvent("click", "Appmenu", this.eventHandler);
        },

        updateView: function(currentFormID, widgetModel, propertyName, propertyValue, oldPropertyValue) {
            
        },

        render: function(widgetID, widgetGenerationContext) {
            var appmenuWidgetModel = $KG["__appmenu"]; 
            var appmenuData = appmenuWidgetModel.data;
            var totalItems = appmenuWidgetModel.data.length;
            var moreExists = false;
            var count = 0;
            for(var i = IndexJL; i < appmenuData.length; i++) {
                if(appmenuData[i][IndexJL + 4]){
                    count++;
                }
            }
            
            var widgetWeight = "";
            var weightofItem = 25;
            if((count + IndexJL) > 4) {
                moreExists = true;
                widgetWeight = "kwt" + (100 / 5);
                weightofItem = Math.floor(100 / 5);
            } else {
                widgetWeight = "kwt" + (100 / count);
                weightofItem = Math.floor(100 / count);
            }
            weightofItem = weightofItem + "%";

            var htmlString = "";
            if(!widgetGenerationContext) {
                var className = "";
                if($KU.isTablet || $KU.isMob) {
                    className = "appmenu_scroller";
                    var formModel = $KG["__currentForm"];
                    if(formModel.dockableappmenu === false || $KG["nativeScroll"])
                        className += " relativePos";
                    else {
                        className += " absolutePos";
                    }
                }
                htmlString += "<div id='konyappmenudiv'  class='" + className + "'>";
            }

            htmlString += "<div class='kbasemargin kwt100 ktable' style='table-layout:fixed;' ><div class='kwt100 krow'>";

            if(moreExists)
                totalItems = IndexJL + 4;

            var nxtIndex = 0;

            var focusIndex = module.focusIndex;
            var appmenuSkin;
            for(var i = IndexJL, cnt = IndexJL - 1; i < appmenuData.length; i++) {
                if(focusIndex !== "" && focusIndex === i && appmenuWidgetModel.focusskin)
                    appmenuSkin = appmenuWidgetModel.focusskin || "";
                else
                    appmenuSkin = appmenuWidgetModel.skin || "";

                if(focusIndex !== "" && focusIndex === i && appmenuWidgetModel.focusskin)
                    appmenuSkin = appmenuWidgetModel.focusskin || "";
                else
                    appmenuSkin = appmenuWidgetModel.skin || "";
                if(appmenuData[i][IndexJL + 4]) {
                    cnt++;
                    var closure = ""; 
                    var label = appmenuData[i][1 + IndexJL] || "";
                    var image = $KU.getImageURL(appmenuData[i][2 + IndexJL]) || "";
                    if($KG["localization"] && label.toLowerCase().indexOf("i18n.getlocalizedstring") != -1) {
                        label = $KU.getI18NValue(label);
                    }

                    htmlString += "<div style='width:" + weightofItem + ";' class='" + appmenuSkin + " middlecenteralign kcell' index='" + i + "'><a id='" + appmenuData[i][IndexJL] + "' " + closure + " href='#' kwidgettype='Appmenu' event='yes' index='" + i + "' style='text-decoration:none;'><div>";

                    if(image)
                        htmlString += "<img  style='border:none;' src='" + image + "' width='30px' height='30px' align='middle'/>";

                    htmlString += "</div><div><label class='" + appmenuSkin + "' style='background:inherit; border: none; white-space:pre-wrap;     word-wrap:break-word; '>" + label + "</label></div></a></div>";
                    
                    if(moreExists && cnt == 3) {
                        nxtIndex = i + 1;
                        break;
                    }
                }
            }

            if(moreExists) {
                appmenuSkin = appmenuWidgetModel.skin || "";
                htmlString += "<div id='konyappmenudiv_more' class='" + appmenuSkin + " middlecenteralign " + " kcell' style='width:" + weightofItem + ";'><a id='appmenumore' href='#' kwidgettype='Appmenu' event='yes' index='5' style='text-decoration:none;'><div>";
                htmlString += "<img  style='border:none;' src='" + $KU.getImageURL("appmore.png") + "' width='30px' height='30px' align='middle' kwidgettype='Appmenu'/></div><div><label class='" + appmenuSkin + "' style='background:inherit; border: none;' kwidgettype='Appmenu'>more</label></div></a></div>";

                
                var moreContainerClass = $KG["nativeScroll"] ? 'position:fixed' : 'height:auto;top:0px;';

                var moreHtmlString = "<div id='appmenumore_container' class='popupcontainer absoluteContainer' dummy='' style='display: none;z-index: 11; " + moreContainerClass + "'><div id='__popuplayer' style='opacity:0;filter:alpha(opacity=0);' class='popuplayer absoluteContainer' dummy=''></div><div id='more' class='frm' style='z-index: 9; position: absolute; padding: 0%; right:0%;bottom:0px; -webkit-animation: 1s;' dummy=''><div id='containerLayer' style='display:table;' class='container'>";

                for(var i = nxtIndex; i < appmenuData.length; i++) {
                    if(appmenuData[i][IndexJL + 4]) {
                        var closure = appmenuData[i][IndexJL + 3];
                        if(closure)
                            closure = "closure='" + closure + "'";
                        else
                            closure = "";
                        var label = appmenuData[i][1 + IndexJL] || "";
                        var image = $KU.getImageURL(appmenuData[i][2 + IndexJL]) || "";
                        if($KG["localization"] && label.toLowerCase().indexOf("i18n.getlocalizedstring") != -1)
                            label = $KU.getI18NValue(label);

                        moreHtmlString += "<div class='kwt100 krow " + appmenuSkin + "'><div class='" + appmenuSkin + " middlecenteralign kcell' index ='" + i + "'><a id='" + appmenuData[i][IndexJL] + "' " + closure + " href='#' kwidgettype='Appmenu' event='yes' index='" + i + "' style='text-decoration: none;'><div style='padding:2px;'>";

                        if(image)
                            moreHtmlString += "<img  style='border:none;' src='" + $KU.getImageURL(appmenuData[i][2 + IndexJL]) + "'  width='30px' height='30px' align='middle' kwidgettype='Appmenu'/>";

                        moreHtmlString += "<label class='" + appmenuSkin + "' style='background:inherit; border: none; white-space:pre-wrap;     word-wrap:break-word;margin-left:5px;' kwidgettype='Appmenu' index='" + i + "'>" + label + "</label></div></a></div></div>";
                    }
                }
                moreHtmlString += "</div></div>";
                var mainContainer = document.getElementById('__MainContainer');

                var appmoreCont = document.getElementById("appmenumore_container");
                if(appmoreCont) appmoreCont.parentElement.removeChild(appmoreCont);
                var popupContainer = document.createElement('div');
                popupContainer.innerHTML = moreHtmlString;
                mainContainer.appendChild(popupContainer.firstChild);
            }

            htmlString += "</div></div></div>";
            return htmlString;
        },

        eventHandler: function(eventObject, target, sourceFormID) {
            var appmenuWidgetModel = $KG["__appmenu"]; 
            var appmenuData = appmenuWidgetModel.data;
            var targetNode = $KU.getParentByTagName(target, 'a');
            var closure;
            var appmenuId = targetNode.id;

            if(appmenuId == 'appmenumore') {
                
                closure = module.showmoreappmenuitems;
            } else {
                module.hidemoreappmenuitems();
                var index = targetNode.parentNode.getAttribute("index");
                closure = appmenuData[index][3 + IndexJL];
            }

            if(appmenuWidgetModel.focusskin) {
                if(module.focusIndex != "") {
                    var focusClass = document.querySelectorAll('div.' + appmenuWidgetModel.focusskin + ', a label.' + appmenuWidgetModel.focusskin);
                    var focusLen = focusClass.length;
                    if(!(targetNode.id == "appmenumore")) {
                        
                        for(var k = focusLen - 1; k >= 0; k--) {
                            if(focusClass[k].tagName.toLowerCase() == 'label')
                                focusClass[k].className = appmenuWidgetModel.skin;
                            else
                                focusClass[k].className = appmenuWidgetModel.skin + " middlecenteralign kcell";
                        }
                    }
                }

                module.focusIndex = index;
                
                if(!(targetNode.id == "appmenumore")) {
                    targetNode.parentNode.className = appmenuWidgetModel.focusskin + " middlecenteralign kcell";
                    var labelEle = document.querySelectorAll('#' + targetNode.id + '  label');
                    if(labelEle) labelEle[0].className = appmenuWidgetModel.focusskin;
                }
            }
            if($KU.getPlatformVersion('windowsphone') == "7.5") {
                var moreContainer = document.getElementById('appmenumore_container');
                if(moreContainer) {
                    var mainContainer = document.getElementById('__MainContainer');
                    var appmenuHeight = document.getElementById('konyappmenudiv').offsetHeight;
                    var mainHeight = ((mainContainer.offsetHeight) - (appmenuHeight)) + "px";
                    moreContainer.style.height = mainHeight;
                }
            }
            $KAR && $KAR.sendRecording(appmenuWidgetModel, 'click', {'target': target, 'wType': 'appMenu', 'appmenuid': appmenuId, 'eventType': 'uiAction'});
            var appmenuEvent = $KU.returnEventReference(closure);
            appmenuEvent && appmenuEvent.call(appmenuWidgetModel, appmenuWidgetModel);
            
        },

        setappmenu: function(appmenu, skin, focusSkin) {
            var appmenuWidgetModel = $KG["__appmenu"]; 
            for(var i = IndexJL; i < appmenu.length; i++) {
                appmenu[i][4 + IndexJL] = true;
            }

            if(!appmenuWidgetModel) {
                var tempmenu = new Object();
                tempmenu.data = appmenu;
                tempmenu.skin = skin;
                tempmenu.focusskin = focusSkin;
                $KG["__appmenu"] = tempmenu;
            } else {
                appmenuWidgetModel.data = appmenu;
                appmenuWidgetModel.skin = skin;
                appmenuWidgetModel.focusskin = focusSkin;
            }
        },

        setappmenufocusindex: function(index) {
            var appmenuWidgetModel = $KG["__appmenu"]; 
            var appmenuNode = $KU.getElementById("konyappmenudiv");
            if(!appmenuNode) 
                return;
            var appmenuData = appmenuWidgetModel.data;
            if(appmenuWidgetModel.focusskin) {
                var focusClass = document.querySelectorAll('div.' + appmenuWidgetModel.focusskin + ', a label.' + appmenuWidgetModel.focusskin);
                var focusLen = focusClass.length;
                for(var k = focusLen - 1; k >= 0; k--) {
                    if(focusClass[k].tagName.toLowerCase() == 'label')
                        focusClass[k].className = appmenuWidgetModel.skin;
                    else
                        focusClass[k].className = appmenuWidgetModel.skin + " middlecenteralign kcell";
                }
                var targetNode = document.querySelectorAll("div a[index='" + (index - IndexJL) + "']")[0];
                if(targetNode) targetNode.parentNode.className = appmenuWidgetModel.focusskin + " middlecenteralign kcell";
                var labelEle = document.querySelectorAll('#' + targetNode.id + '  label');
                if(labelEle) labelEle[0].className = appmenuWidgetModel.focusskin;
                module.focusIndex = index - IndexJL;
            }
        },

        hideappmenuitems: function(menulist) {
            var appmenuWidgetModel = $KG["__appmenu"]; 
            var tempmodel = appmenuWidgetModel.data;
            for(var i = IndexJL; i < (menulist.length); i++) {
                for(var j = IndexJL; j < appmenuWidgetModel.data.length; j++) {
                    if(tempmodel[j][IndexJL] == menulist[i]) {
                        tempmodel[j][4 + IndexJL] = false;
                    }
                }
            }
            var appmenuNode = $KU.getElementById("konyappmenudiv");
            var widgetGenerationContext = new $KW.WidgetGenerationContext();
            widgetGenerationContext.setdynamically = true;
            
            appmenuNode && (appmenuNode.innerHTML = module.render("__appmenu", widgetGenerationContext));
        },

        showappmenuitems: function(menulist) {
            var appmenuWidgetModel = $KG["__appmenu"];
            var tempmodel = appmenuWidgetModel.data;
            for(var i = IndexJL; i < appmenuWidgetModel.data.length; i++) {
                var itemexists = false;
                for(var j = IndexJL; j < menulist.length; j++) {
                    if(tempmodel[i][IndexJL] == menulist[j]) {
                        itemexists = true;
                        break;
                    }
                }
                tempmodel[i][4 + IndexJL] = itemexists;
            }
            var appmenuNode = $KU.getElementById("konyappmenudiv");
            var widgetGenerationContext = new $KW.WidgetGenerationContext();
            widgetGenerationContext.setdynamically = true;
            if(appmenuNode) {
                appmenuNode.innerHTML = module.render("__appmenu", widgetGenerationContext);
            } else {
                var appmenu_wrapper = $KU.getElementById("appmenu_container");
                
                if(!appmenu_wrapper)
                    return;
                var temp = document.createElement("DIV");

                var className = "appmenu_scroller";
                if($KG["nativeScroll"])
                    className += " relativePos";
                else
                    className += " absolutePos";

                temp.className = className;
                temp.setAttribute("id", "konyappmenudiv");
                temp.innerHTML = module.render("__appmenu", widgetGenerationContext);
                appmenu_wrapper.appendChild(temp);

            }
        },

        removeappmenuitem: function(id) {
            var appmenuWidgetModel = $KG["__appmenu"]; 
            var appmenuData = appmenuWidgetModel.data;
            
            for(var i = IndexJL; i < appmenuWidgetModel.data.length; i++) {
                if(appmenuData[i][IndexJL] == id) {
                    
                    appmenuData.splice(i, 1);
                    if(module.focusIndex == i)
                        module.focusIndex = "";
                    break;
                }
            }
            var appmenuNode = $KU.getElementById("konyappmenudiv");
            var widgetGenerationContext = new $KW.WidgetGenerationContext();
            widgetGenerationContext.setdynamically = true;
            appmenuNode.innerHTML = module.render("__appmenu", widgetGenerationContext);
        },

        addappmenuitem: function(appmenu, index) {
            var appmenuWidgetModel = $KG["__appmenu"]; 
            var appmenuData = appmenuWidgetModel.data;
            var itemExists = false; 
            for(i = IndexJL; i < (appmenuData.length); i++) {
                if(appmenuData[i][IndexJL] == appmenu[IndexJL]) {
                    itemExists = true;
                    break;
                }
            }
            if(itemExists)
                return;
            appmenu[4 + IndexJL] = true;
            appmenuData.splice(index, 0, appmenu);
            var appmenuNode = $KU.getElementById("konyappmenudiv");
            var widgetGenerationContext = new $KW.WidgetGenerationContext();
            widgetGenerationContext.setdynamically = true;
            appmenuNode.innerHTML = module.render("__appmenu", widgetGenerationContext);
        },

        showmoreappmenuitems: function() {
            var moreContainer = document.getElementById('appmenumore_container');
            if(moreContainer) {
                var appMenuEle = document.getElementById('konyappmenudiv');
                var paddingTop = parseInt($KU.getStyle(appMenuEle, 'padding-top')) || 0;
                var marginTop = parseInt($KU.getStyle(appMenuEle, 'margin-top')) || 0;
                var bottom = document.getElementById('konyappmenudiv').offsetHeight;
                bottom = bottom - (marginTop + paddingTop);
                moreContainer.style.bottom = bottom + "px";
                if(moreContainer.style.display == 'none')
                    moreContainer.style.display = 'block';
                else if(moreContainer.style.display == 'block')
                    moreContainer.style.display = 'none';
            }
        },

        hidemoreappmenuitems: function() {
            var moreContainer = document.getElementById('appmenumore_container');
            if(moreContainer) moreContainer.style.display = 'none';
        },

        createappmenu: function(appmenuid, appmenu, skinid, onfocusSkinid) {
            for(var i = IndexJL; i < appmenu.length; i++) {
                appmenu[i][4 + IndexJL] = true;
            }
            var tempmenu = new Object();
            tempmenu.data = appmenu;
            tempmenu.skin = skinid;
            tempmenu.focusskin = tempmenu.focusSkin = onfocusSkinid;
            if($KG["__appmenu"])
                $KG["__appmenu"][appmenuid] = tempmenu;
            else {
                $KG["__appmenu"] = tempmenu;
            }
        },

        setcurrentappmenu: function(appmenuid) {
            if($KG["__appmenu"][appmenuid])
                $KG["__appmenu"] = $KG["__appmenu"][appmenuid];
            else
                $KG["__appmenu"] = $KG["__appmenu"];

            var appmenuWidgetModel = $KG["__appmenu"]; 
            var appmenuData = appmenuWidgetModel.data;
            
            var appmenuNode = $KU.getElementById("konyappmenudiv");
            var widgetGenerationContext = new $KW.WidgetGenerationContext();
            widgetGenerationContext.setdynamically = true;
            if(appmenuNode) {
                appmenuNode.innerHTML = module.render("__appmenu", widgetGenerationContext);
            } else {
                var appmenu_wrapper = $KU.getElementById("appmenu_container");
                
                if(!appmenu_wrapper) return;

                var temp = document.createElement("DIV");

                var className = "appmenu_scroller";
                if($KG["nativeScroll"])
                    className += " relativePos";
                else
                    className += " absolutePos";

                temp.className = className;
                temp.setAttribute("id", "konyappmenudiv");
                temp.innerHTML = module.render("__appmenu", widgetGenerationContext);

                if($KG["__currentForm"].needappmenu)
                    appmenu_wrapper.appendChild(temp);

                var appmenuEvent = $KU.returnEventReference(appmenuData[IndexJL][3 + IndexJL]);
                appmenuEvent && appmenuEvent.call(appmenuWidgetModel, appmenuWidgetModel);
            }
            $KG["currappmenu"] = appmenuid;
        },

        getcurrentappmenu: function() {
            return $KG["currappmenu"];
        },

        setappmenufocusbyid: function(appMenuItemId) {
            var appmenuData = $KG["__appmenu"].data;
            var i;
            var itemExists = false;
            for(i = IndexJL; i < (appmenuData.length); i++) {
                if(appmenuData[i][IndexJL] == appMenuItemId) {
                    itemExists = true;
                    break;
                }
            }
            if(itemExists)
                module.setappmenufocusindex(i);
        },

        addappmenuitemat: function(appmenuid, index, appmenuitem) {
            module.addappmenuitem(appmenuitem, index);
            module.focusIndex = "";
        },

        removeappmenuitemat: function(appmenuid, index) {
            var appmenuData = $KG["__appmenu"].data;
            module.removeappmenuitem(appmenuData[index][IndexJL]);
            if(module.focusIndex == index)
                module.focusIndex = "";
        }
    };


    return module;
}());


$KW.Label = (function() {
    
    

    var module = {
        initialize: function() {
            kony.events.addEvent("click", "Label", this.eventHandler);
        },

        initializeView: function(formId) {
            module.updateLineSpacing(formId);
        },

        updateView: function(widgetModel, propertyName, propertyValue, oldPropertyValue) {
            var element = $KU.getNodeByModel(widgetModel);
            if(!element)
                return;

            switch(propertyName) {
                
                case "linespacing":
                    this.updateLineHeight(widgetModel, element);
                    break;
                case "textcopyable":
                    if(propertyValue && !widgetModel.disabled) {
                        $KU.addClassName(element, "enableSelection");
                        $KU.removeClassName(element, "disableSelection");
                    } else {
                        $KU.addClassName(element, "disableSelection");
                        $KU.removeClassName(element, "enableSelection");
                    }
                    break;

                case "text":
                    if(!element.firstChild)
                        element.innerHTML = $KU.escapeHTMLSpecialEntities(propertyValue);
                    else
                        element.firstChild.nodeValue = propertyValue;

                    break;
            }
        },

        
        updateLineHeight: function(labWidgetModel, element) {
            var lineSpacingValue = labWidgetModel.linespacing;
            if(lineSpacingValue > 0) {
                var fontSize = parseInt($KU.getStyle(element, "font-size"), 10);
                if(fontSize > 0) {
                    element.style.lineHeight = (fontSize + parseInt(lineSpacingValue, 10)) + "px";
                }
            } else {
                element.style.lineHeight = "";
            }
        },

        
        updateLineSpacing: function(formId) {
            var labelNodes = document.querySelectorAll("#" + formId + " div[kwidgettype='Label']");
            for(var i = 0; i < labelNodes.length; i++) {
                var labelNode = labelNodes[i];
                var labWidgetModel = $KU.getModelByNode(labelNode);
                this.updateLineHeight(labWidgetModel, labelNode);
            }
        },

        render: function(labelModel, context) {
            var computedSkin = $KW.skins.getWidgetSkinList(labelModel, context);
            var cAlign = $KW.skins.getContentAlignment(labelModel);
            var htmlString = "";
            htmlString = "<div" + $KW.Utils.getBaseHtml(labelModel, context) + "class = '" + computedSkin + "' style='text-align:" + cAlign + ";" + $KW.skins.getBaseStyle(labelModel, context);

            if(context.ispercent === false)
                htmlString += "display:inline-block;" + (context.layoutDir ? ("float:" + context.layoutDir) : "");

            htmlString += "'";
            htmlString += ">" + $KU.escapeHTMLSpecialEntities(labelModel.text) + "</div>";
            return htmlString;
        },

        eventHandler: function(eventObject, target) {
            var labWidgetModel = $KU.getModelByNode(target),
                containerId = target.getAttribute("kcontainerID");

            $KAR && $KAR.sendRecording(labWidgetModel, 'click', {'target': target, 'eventType': 'uiAction'});
            
            if(containerId) {
                $KW.Utils.updateContainerData(labWidgetModel, target, true);
            } else {
                var executed = kony.events.executeBoxEvent(labWidgetModel);
                var tabId = target.getAttribute("ktabid");
                if(!executed && tabId) {
                    $KW.TabPane && $KW.TabPane.executeTabEvent(labWidgetModel, target, true);
                }
            }
        }
    };


    return module;
}());


$KW.Button = (function() {
    
    

    var module = {
        
        initialize: function() {
            kony.events.addEvent("click", "Button", this.eventHandler);
        },

        
        updateView: function(widgetModel, propertyName, propertyValue, oldPropertyValue) {

            var element = $KU.getNodeByModel(widgetModel);
            if(!element)
                return;
            element = $KW.Utils.getClonedTemplateNode(element, widgetModel, propertyName);

            switch(propertyName) {
                case "text":
                    if($KU.isWindowsTablet)
                        element.innerHTML = $KU.escapeHTMLSpecialEntities(propertyValue);
                    else
                        element.value = propertyValue;
                    break;
            }
        },

        render: function(buttonModel, context) {

            var computedSkin = $KW.skins.getWidgetSkinList(buttonModel, context);
            var htmlString = "";
            var skin = buttonModel.skin || "";
            var cAlign = $KW.skins.getContentAlignment(buttonModel);

            if($KU.isWindowsTablet) {
                htmlString = "<button" + $KW.Utils.getBaseHtml(buttonModel, context) + "type='button' class = '" + computedSkin + "'" + " style='text-align:" + $KW.skins.getContentAlignment(buttonModel) + ";white-space:normal;word-wrap:break-word;" + $KW.skins.getBaseStyle(buttonModel, context) + (context.layoutDir && context.ispercent === false ? ";float:" + context.layoutDir : "") + "' kprogressskin='" + skin + "'>" + (buttonModel.displaytext.toString() == "true" ? $KU.escapeHTMLSpecialEntities(buttonModel.text) : "") + "</button>";
            } else {
                htmlString = "<input" + $KW.Utils.getBaseHtml(buttonModel, context) + "type='button' class = '" + computedSkin + "'" + " style='text-align:" + $KW.skins.getContentAlignment(buttonModel) + ";white-space:normal;word-wrap:break-word;" + $KW.skins.getBaseStyle(buttonModel, context) + (context.layoutDir && context.ispercent === false ? ";float:" + context.layoutDir : "") + "'" + (buttonModel.displaytext.toString() == "true" ? " value='" + $KU.escapeHTMLSpecialEntities(buttonModel.text) + "'" : "") + " kprogressskin='" + skin + "'/>";
            }

            return htmlString;
        },

        
        eventHandler: function(eventObject, target) {
            var buttonModel = $KU.getModelByNode(target),
                containerId = target.getAttribute("kcontainerID");

            spaAPM && spaAPM.sendMsg(buttonModel, 'onclick');
            $KAR && $KAR.sendRecording(buttonModel, 'click', {'target': target, 'eventType': 'uiAction'});
            
            if(containerId) {
                $KW.Utils.updateContainerData(buttonModel, target, true);
            } else if(buttonModel.onclick) {
                var buttonhandler = $KU.returnEventReference(buttonModel.onclick);
                $KU.executeWidgetEventHandler(buttonModel, buttonhandler);
                $KU.onEventHandler(buttonModel);
            }
        }
    };


    return module;
}());


$KW.Phone = (function() {
    
    

    var module = {
        initialize: function() {
            kony.events.addEvent("click", "Phone", this.eventHandler);
        },

        updateView: function(widgetModel, propertyName, propertyValue, oldPropertyValue) {
            var element = $KU.getNodeByModel(widgetModel);
            if(!element)
                return;

            switch(propertyName) {
                case "text":
                    if(element.childNodes[0]) {
                        var anchorNode = element.childNodes[0];
                        if(!widgetModel.image)
                            anchorNode.innerHTML = propertyValue;
                        anchorNode.href = "tel:" + propertyValue;
                    }
                    break;
            }
        },

        render: function(phoneModel, context) {
            var computedSkin = $KW.skins.getWidgetSkinList(phoneModel, context);
            var skin = phoneModel.skin || "";
            var htmlString = "<div" + $KW.Utils.getBaseHtml(phoneModel, context) + "class = '" + computedSkin + "'";

            if(context.ispercent === false)
                htmlString += " style='display:inline-block;' "

            htmlString += "><a class='" + skin + "' style='border:none;min-height:28px;' href='tel:" + phoneModel.text + "' >";
            if(!phoneModel.image) {
                htmlString += phoneModel.text;
            } else {
                var phoneImageSrc = $KU.getImageURL(phoneModel.image);
                htmlString += "<img alt='Call' src='" + phoneImageSrc + "' />";
            }
            htmlString += "</a></div>";
            return htmlString;
        },


        
        eventHandler: function(eventObject, target) {
            var phoneWidgetModel = $KU.getModelByNode(target);
            
            target.getAttribute("kcontainerID") && $KW.Utils.updateContainerData(phoneWidgetModel, target, false);

            var href;
            if(phoneWidgetModel.segmentID)
                href = target.childNodes[0].innerText || "";
            else
                href = phoneWidgetModel.text;

            href = href.replace(/[-\s]+/g, '');
            if(isNaN(href))
                href = $KW.Utils.convertPhoneAlphabetToNumber(href);
            $KI.phone.dial(href);
        }
    };


    return module;
}());


$KW.TextField = (function() {
    
    

    var module = {
        goeventTriggerd: null, 
        focusedTextfieldId: null,

        initialize: function() {
            kony.events.addEvent("keydown", "TextField", this.textfieldGoButtonEventHandler);
            kony.events.addEvent("keyup", "TextField", this.textfieldKeyUpEventHandler);
            kony.events.addEvent("onorientationchange", "TextField", this.adjustHeight);
            kony.events.addEvent("change", "TextField", this.eventHandler);
            kony.events.addEvent("input", "TextField", this.textfieldInputEventHandler);
            
            kony.events.addEvent("click", "TextField", this.clickHandler);
        },

        initializeView: function(formId) {
            this.adjustHeight(formId);
            setTimeout(function() {
                module.initPasswordField(formId);
            }, 1);
        },

        initPasswordField: function(formId) {
            var passElements = document.querySelectorAll("#" + formId + " input[name='konypassword']");
            for(var i = 0; i < passElements.length; i++) {
                var passElement = passElements[i];
            }
        },

        
        updateView: function(widgetModel, propertyName, propertyValue, oldPropertyValue) {
            var element = $KU.getNodeByModel(widgetModel);
            if(!element)
                return;
            element = $KW.Utils.getClonedTemplateNode(element, widgetModel, propertyName);

            switch(propertyName) {
                case "text":
                    if(propertyValue) {
                        element.value = propertyValue;
                        propertyValue && $KU.removeClassName(element, 'konyplaceholder');
                    }
                    else {
                        element.value = "";
                    }
                    this.setPlaceholder(widgetModel, element);
                    break;

                case "placeholder":
                    element.setAttribute("placeholder", propertyValue);
                    this.setPlaceholder(widgetModel, element);
                    break;

                case "placeholderskin":
                    if($KG.appbehaviors[constants.API_LEVEL] >= constants.API_LEVEL_8200) {
                        element.setAttribute("kplaceholderSkin", propertyValue);
                    }
                    break;

                case "maxtextlength":
                    element.maxLength = propertyValue;
                    break;

                case "pattern":
                    element.setAttribute("pattern", propertyValue);
                    break;

                case "autocapitalize":
                    var value = propertyValue;
                    if($KU.isiPhone && parseInt($KU.getPlatformVersion("iphone")) <= 4 && propertyValue != constants.TEXTBOX_AUTO_CAPITALIZE_NONE) {
                        value = 'on';
                    }
                    element.setAttribute("autocapitalize", value);
                    var transform = $KU.getTextTrasform(widgetModel)
                    transform && (element.style.textTransform = transform);
                    break;

                case "mode":
                case "textinputmode":
                    if(propertyValue == constants.TEXTBOX_INPUT_MODE_ANY)
                        element.setAttribute("type", "text");
                    else if(propertyValue == constants.TEXTBOX_INPUT_MODE_NUMERIC)
                        element.setAttribute("type", "number");
                    break;

                case "securetextentry":
                    if(propertyValue)
                        element.setAttribute("type", "password");
                    else {
                        var textsecurity = $KU.cssPrefix + "text-security";
                        element.style.removeProperty(textsecurity);
                        this.updateView(widgetModel, "textinputmode", widgetModel.textinputmode);
                    }
                    break;

                case "keyboardtype":
                case "keyboardstyle":
                    (widgetModel.mode != "P") && element.setAttribute("type", propertyValue);
                    break;

                case "name":
                    element.name = propertyValue;
                    break;
            }
        },

        render: function(textModel, context) {
            if(typeof textModel.keyboardtype == 'undefined') textModel.keyboardtype = textModel.keyboardstyle;
            if(typeof textModel.mode == 'undefined') textModel.mode = textModel.textinputmode;

            var computedSkin = $KW.skins.getWidgetSkinList(textModel, context);
            var placeholderSkin = textModel.placeholderskin;
            if(textModel.containerheightmode == constants.TEXTBOX_DEFAULT_PLATFORM_HEIGHT) computedSkin += " kheight ";
            var tabpaneID = context.tabpaneID || "";

            var type = "text";
            var isDafultPad = false;
            switch(textModel.mode) {
                case constants.TEXTBOX_INPUT_MODE_PASSWORD:
                    type = "password";
                    break;
                case constants.TEXTBOX_INPUT_MODE_NUMERIC:
                    type = "number";
                    break;
                default:
                    type = "text";
            }

            if(textModel.securetextentry)
                type = "password";
            if(textModel.placeholder && !textModel.text && !kony.utils.placeholderSupported && type == "password")
                type = "text";

            if(textModel.keyboardtype && textModel.mode != "P") {
                switch(textModel.keyboardtype) {
                    case constants.TEXTBOX_KEY_BOARD_STYLE_EMAIL:
                        type = "email";
                        break;
                    case constants.TEXTBOX_KEY_BOARD_STYLE_URL:
                        type = "url";
                        break;
                    case constants.TEXTBOX_KEY_BOARD_STYLE_PHONE_PAD:
                        type = "tel";
                        break;
                    case constants.TEXTBOX_KEY_BOARD_STYLE_NUMBER_PAD:
                        type = "number";
                        break;
                    case constants.TEXTBOX_KEY_BOARD_STYLE_DECIMAL:
                        type = "number"; 
                        break;
                    case constants.TEXTBOX_VIEW_TYPE_SEARCH_VIEW:
                        type = "search";
                        break;
                    default:
                        if($KU.isiPhone && textModel.mode == "N") {
                            type = "number"; 
                            isDafultPad = false;
                        }
                        break;
                }
            }
            var htmlString = "";
            var style = $KW.skins.getBaseStyle(textModel, context);

            style += ";text-align:" + $KW.skins.getContentAlignment(textModel) + ";";
            var transform = $KU.getTextTrasform(textModel);
            style += transform ? 'text-transform:' + transform + ';' : '';

            var value = textModel.text;
            var encodedText = "";
            if(value && value != "" && (typeof value == "string" || value instanceof String))
                encodedText = value.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/'/g, '&rsquo;').replace(/"/g, '&rdquo;');
            else
                encodedText = value;

            if(!kony.utils.placeholderSupported) {
                encodedText = encodedText || textModel.placeholder || "";
                computedSkin += (textModel.placeholder && !textModel.text) ? " konyplaceholder " : "";
            }
            var isFlexWidget = $KW.FlexUtils.isFlexWidget(textModel);
            var displayStyle = (context.ispercent === false) ? "display:inline-block;" : "";
            var wrapperDivOpen = ($KU.isiPhone && !isFlexWidget) ? "<div style='" + displayStyle + "overflow:hidden;'>" : "";
            var wrapperDivClose = ($KU.isiPhone && !isFlexWidget) ? "</div>" : "";
            htmlString += wrapperDivOpen + "<input" + $KW.Utils.getBaseHtml(textModel, context) + "value='" + encodedText + "' class = '" + computedSkin + "'";

            htmlString += textModel.name ? " name='" + textModel.name + "'" : "";
            htmlString += " autocapitalize='" + textModel.autocapitalize + "'";
            htmlString += textModel.autocorrect ? " autocorrect='on'" : " autocorrect='off'";
            htmlString += textModel.autocomplete ? " autocomplete='on'" : " autocomplete='off'";
            
            htmlString += " type = '" + type + "'";
            htmlString += (textModel.pattern) ? " pattern=" + textModel.pattern : "";
            if(placeholderSkin && $KG.appbehaviors[constants.API_LEVEL] >= constants.API_LEVEL_8200) {
                htmlString += "kplaceholderSkin = " + placeholderSkin;
            }


            if((textModel.keyboardtype == "digitpad" && textModel.mode == "P") || isDafultPad) {
                var pattern = "[0-9]*";
                htmlString += " pattern = '" + pattern + "'";
            }

            htmlString += (textModel.disabled) ? " disabled='true'" : "";
            htmlString += " onfocus='$KW.TextField.onfocusEventHandler(arguments[0],this)' onblur='$KW.TextField.onblurEventHandler(arguments[0],this)' ";
            htmlString += (textModel.placeholder) ? " placeholder='" + $KU.escapeHTMLSpecialEntities(textModel.placeholder) + "'" : "";

            htmlString += (textModel.maxtextlength) ? " maxlength='" + textModel.maxtextlength + "'" : "";
            htmlString += " style='" + style + (textModel.securetextentry ? $KU.cssPrefix + "text-security:disc" : "") + "'";
            htmlString += "/>" + wrapperDivClose;
            return htmlString;
        },

        clickHandler: function(eventObject, target) {
            var textModel = $KU.getModelByNode(target);
            spaAPM && spaAPM.sendMsg(textModel, 'onclick');
            
            if(target.getAttribute("kcontainerID")) {
                $KW.Utils.updateContainerData(textModel, target, true);
            }
        },


        textfieldGoButtonEventHandler: function(eventObject, target) {
            var textModel = $KU.getModelByNode(target);
            eventObject = eventObject || window.event; 
            if(textModel.ondone && (eventObject.keyCode == 10 || eventObject.keyCode == 13)) {
                textModel.canUpdateUI = false;
                textModel.text = target.value;
                textModel.canUpdateUI = true;
                
                kony.events.preventDefault(eventObject);
                kony.events.stopPropagation(eventObject);
                try {
                    if(eventObject.srcElement)
                        eventObject.srcElement.blur();
                    else
                        eventObject.target.blur();
                } catch(e) {}

                spaAPM && spaAPM.sendMsg(textModel, 'ondone');

                var textondoneref = $KU.returnEventReference(textModel.ondone);
                $KU.callTargetEventHandler(textModel, target, 'ondone');
                if(textondoneref) {
                    $KU.onEventHandler(textModel);
                }
            }
            $KU.callTargetEventHandler(textModel, target, 'onkeydown');
        },

        HandleTextFieldFilterData: function(response, eventObject, target) {
            var textfieldId = target.getAttribute("id");
            response.shift(); 
            var value = target.value;
            value = value.ltrim();

            if(value.length < 1) return;

            if(response.length > 0) {
                this.AutoComplete.AutoComplete_Create(textfieldId, response, 8);
                this.AutoComplete.AutoComplete_ShowDropdown(textfieldId);
            }
        },

        eventHandler: function(eventObject, target) {
            var textModel = $KU.getModelByNode(target);
            if(textModel) {
                textModel.canUpdateUI = false;
                textModel.text = target.value;
                textModel.canUpdateUI = true;
                spaAPM && spaAPM.sendMsg(textModel, 'ontextchange');
                $KU.callTargetEventHandler(textModel, target, "ontextchange");
            }
        },

        textfieldInputEventHandler: function(eventObject, target) {
            var textModel = $KU.getModelByNode(target);

            $KAR && $KAR.sendRecording(textModel, 'enterText', {'text': target.value, 'target': target, 'eventType': 'uiAction'});
            if(target.getAttribute("kcontainerID")) {
                $KW.Utils.updateContainerData(textModel, target, false, "input");
            } else {
                $KW.Utils.restrictCharactersSet(target, textModel);
            }
        },

        textfieldKeyUpEventHandler: function(eventObject, target) {
            var textModel = $KU.getModelByNode(target);
            if(textModel.text != target.value) {
                textModel.canUpdateUI = false;
                textModel.text = target.value;
                textModel.canUpdateUI = true;
            }
            $KU.callTargetEventHandler(textModel, target, 'onkeyup');
        },

        onfocusEventHandler: function(eventObject, target) {
            var textModel = $KU.getModelByNode(target);
            eventObject = eventObject || window.event;
            if(target.className.indexOf('konyplaceholder') > -1 && (textModel.format || textModel.dateformat)) {
                if(target.className.indexOf('konyplaceholder') > -1) {
                    target.value = "";
                    $KU.removeClassName(target, 'konyplaceholder');
                    return;
                } else if(textModel.wType == "Calendar") {
                    return;
                }
            }
            if(!kony.utils.placeholderSupported && !textModel.text && textModel.placeholder && textModel.wType != "Calendar") {
                target.value = '';
                if((textModel.securetextentry || textModel.mode == "TEXTBOX_INPUT_MODE_PASSWORD") && target.type == "text") {
                    var id = target.id;
                    var div = document.createElement('div');
                    div.innerHTML = target.outerHTML.replace('type="text"', 'type="password"').replace('type=text', 'type=password');
                    target.blur(); 
                    target.parentNode.replaceChild(div.firstChild, target);
                    target = document.getElementById(id);
                }
                setTimeout(function() {
                    target.focus();
                }, 1);
                $KU.removeClassName(target, 'konyplaceholder');
            }

            spaAPM && spaAPM.sendMsg(textModel, 'onbeginediting');
            $KU.callTargetEventHandler(textModel, target, 'onbeginediting');
        },

        onblurEventHandler: function(eventObject, target) {
            var textModel = $KU.getModelByNode(target);
            if(textModel && textModel.text != target.value) {
                textModel.canUpdateUI = false;
                textModel.text = target.value;
                textModel.canUpdateUI = true;
            }
            if(kony.utils.placeholderSupported == false) {
                if((!textModel.datecomponents || !textModel.formatteddate) && (textModel.date == null || textModel.date == undefined || textModel.date == "") && (textModel.wType == "Calendar")) {
                    target.value = textModel.placeholder;
                    $KU.addClassName(target, 'konyplaceholder');
                    return;
                } else if(textModel.wType == "Calendar") {
                    return;
                }
            }
            module.setPlaceholder(textModel, target);
            spaAPM && spaAPM.sendMsg(textModel, 'onendediting');
            $KU.callTargetEventHandler(textModel, target, 'onendediting');
            
        },

        setPlaceholder: function(textModel, target) {
            if(!kony.utils.placeholderSupported && textModel.placeholder) {
                var id = target.id;
                if(textModel.text) {
                    if((textModel.securetextentry || textModel.mode == "TEXTBOX_INPUT_MODE_PASSWORD") && target.type == "text") {
                        $KU.removeClassName(target, 'konyplaceholder');
                        var div = document.createElement('div');
                        div.innerHTML = target.outerHTML.replace('type="text"', 'type="password"').replace('type=text', 'type=password');
                        target.parentNode.replaceChild(div.firstChild, target);
                        target = document.getElementById(id);
                        target.value = textModel.text;
                    }
                } else {
                    if((textModel.securetextentry || textModel.mode == "TEXTBOX_INPUT_MODE_PASSWORD") && target.type == "password") {
                        var div = document.createElement('div');
                        div.innerHTML = target.outerHTML.replace('type="password"', 'type="text"').replace('type=password', 'type=text');
                        target.parentNode.replaceChild(div.firstChild, target);
                        target = document.getElementById(id);
                    }
                    target.value = textModel.placeholder;
                    $KU.addClassName(target, 'konyplaceholder');
                }
            }
        },

        getSelection: function(model) {
            var widgetNode = $KU.getNodeByModel(model);
            if(widgetNode) {
                var obj = module.getInputSelection(widgetNode);
                return {
                    startIndex: obj.start,
                    endIndex: obj.end
                };
            } else
                return null;
        },

        setSelection: function(model, startIndex, endIndex) {
            var widgetNode = $KU.getNodeByModel(model);
            model.startIndex = startIndex;
            model.endIndex = endIndex;
            widgetNode && module.setCaretPosition(widgetNode, startIndex, endIndex);
        },

        
        setCaretPosition: function(elem, startcaretPos, endcaretPos) {
            if(arguments.length == 1) {
                if(!elem.getAttribute('kwidgettype'))
                    elem = elem.childNodes[0];
                var wModel = $KU.getModelByNode(elem);
                startcaretPos = wModel.startIndex;
                endcaretPos = wModel.endIndex;
            }
            var needFocus = (arguments.length == 1) ? false : true;
            if(typeof endcaretPos == "undefined")
                endcaretPos = startcaretPos;
            if(elem) {
                if(typeof elem.selectionStart == "number") {
                    needFocus && elem.focus();
                    elem.setSelectionRange(startcaretPos, endcaretPos);
                } else if(elem.createTextRange) {
                    var range = elem.createTextRange();
                    range.collapse(true);
                    range.moveEnd('character', endcaretPos);
                    range.moveStart('character', startcaretPos);
                    range.select();
                } else
                    needFocus && elem.focus();
            }
        },

        
        getInputSelection: function(el) {
            var start = 0,
                end = 0,
                normalizedValue, range,
                textInputRange, len, endRange;

            if(typeof el.selectionStart == "number" && typeof el.selectionEnd == "number") {
                start = el.selectionStart;
                end = el.selectionEnd;
            } else {
                range = document.selection.createRange();

                if(range && range.parentElement() == el) {
                    len = el.value.length;
                    normalizedValue = el.value.replace(/\r\n/g, "\n");

                    
                    textInputRange = el.createTextRange();
                    textInputRange.moveToBookmark(range.getBookmark());

                    
                    
                    
                    endRange = el.createTextRange();
                    endRange.collapse(false);

                    if(textInputRange.compareEndPoints("StartToEnd", endRange) > -1) {
                        start = end = len;
                    } else {
                        start = -textInputRange.moveStart("character", -len);
                        start += normalizedValue.slice(0, start).split("\n").length - 1;

                        if(textInputRange.compareEndPoints("EndToEnd", endRange) > -1) {
                            end = len;
                        } else {
                            end = -textInputRange.moveEnd("character", -len);
                            end += normalizedValue.slice(0, end).split("\n").length - 1;
                        }
                    }
                }
            }

            return {
                start: start,
                end: end
            };
        },


        adjustHeight: function(formId) {
            var formModel = $KG.allforms[formId];
            if(!formModel) return;

        }


    };


    return module;
}());



function MaskedPassword(passfield, symbol) {
    
    
    if(typeof document.getElementById == 'undefined' ||
        typeof document.styleSheets == 'undefined') {
        return false;
    }

    
    if(passfield == null) {
        return false;
    }

    
    this.symbol = symbol;

    
    this.maskingTimerId = null;

    
    this.isIE = typeof document.uniqueID != 'undefined';

    
    passfield.value = '';
    passfield.defaultValue = '';

    
    
    
    
    passfield._contextwrapper = this.createContextWrapper(passfield);

    
    
    
    
    
    
    
    
    
    
    
    this.fullmask = true;

    
    
    
    
    
    
    

    
    var wrapper = passfield._contextwrapper;

    
    
    var hiddenfield = '<input type="hidden" id="' + passfield.id + '_value" name="' + passfield.name + '">';

    
    var textfield = this.convertPasswordFieldHTML(passfield);

    
    wrapper.innerHTML = hiddenfield + textfield;

    
    
    passfield = wrapper.lastChild;
    passfield.className += ' masked';

    
    
    
    
    
    passfield.setAttribute('autocomplete', 'off');

    
    
    passfield._realfield = wrapper.firstChild;

    
    passfield._contextwrapper = wrapper;

    
    
    
    
    
    this.limitCaretPosition(passfield);

    
    var self = this;

    
    this.addListener(passfield, 'change', function(e) {
        self.fullmask = false;
        self.doPasswordMasking(self.getTarget(e));
    });
    this.addListener(passfield, 'input', function(e) {
        self.fullmask = false;
        if(self.maskingTimerId) {
            window.clearTimeout(self.maskingTimerId);
            self.maskingTimerId = null;
        }
        self.doPasswordMasking(self.getTarget(e));
        if(!self.maskingTimerId) {
            self.maskingTimerId = window.setTimeout(function() {
                self.forceMasking(passfield);
            }, 500);
        }
    });
    
    this.addListener(passfield, 'propertychange', function(e) {
        self.doPasswordMasking(self.getTarget(e));
    });

    
    
    
    
    
    
    this.addListener(passfield, 'keyup', function(e) {
        if(!/^(9|1[678]|224|3[789]|40)$/.test(e.keyCode.toString())) {
            self.fullmask = false;
            if(self.maskingTimerId) {
                window.clearTimeout(self.maskingTimerId);
                self.maskingTimerId = null;
            }
            var widgetModel = $KU.getModelByNode(passfield);
            widgetModel.text = passfield.previousSibling.value;
            self.doPasswordMasking(self.getTarget(e));
            if(!self.maskingTimerId) {
                self.maskingTimerId = window.setTimeout(function() {
                    self.forceMasking(passfield);
                }, 500);
            }
        }
    });

    
    
    this.addListener(passfield, 'blur', function(e) {
        self.fullmask = true;
        self.forceMasking(passfield);
    });

    
    
    

    
    
    this.forceFormReset(passfield);

    
    return true;
}


MaskedPassword.prototype = {
    
    doPasswordMasking: function(textbox, fullmask) {
        if(typeof fullmask == 'undefined') {
            fullmask = this.fullmask;
        }

        
        var plainpassword = '';

        
        
        if(textbox._realfield.value != '') {
            
            
            
            for(var i = 0; i < textbox.value.length; i++) {
                if(textbox.value.charAt(i) == this.symbol) {
                    plainpassword += textbox._realfield.value.charAt(i);
                } else {
                    plainpassword += textbox.value.charAt(i);
                }
            }
        }

        
        
        else {
            plainpassword = textbox.value;
        }

        
        
        var maskedstring = this.encodeMaskedPassword(plainpassword, fullmask, textbox);
        

        
        
        
        
        
        
        
        if(textbox._realfield.value != plainpassword || textbox.value != maskedstring) {
            
            textbox._realfield.value = plainpassword;

            
            textbox.value = maskedstring;
        }
    },


    
    encodeMaskedPassword: function(passwordstring, fullmask, textbox) {
        
        
        
        
        var characterlimit = fullmask === true ? 0 : 1;

        
        
        for(var maskedstring = '', i = 0; i < passwordstring.length; i++) {
            
            
            if(i < passwordstring.length - characterlimit) {
                maskedstring += this.symbol;
            }
            
            else {
                maskedstring += passwordstring.charAt(i);
            }
        }

        
        return maskedstring;
    },


    
    forceMasking: function(passfield) {
        var widgetModel = $KU.getModelByNode(passfield);
        widgetModel.text = passfield.previousSibling.value;
        this.doPasswordMasking(passfield, true);
    },


    
    createContextWrapper: function(passfield) {
        
        
        var wrapper = document.createElement('span');

        
        wrapper.style.position = 'relative';

        
        passfield.parentNode.insertBefore(wrapper, passfield);

        
        wrapper.appendChild(passfield);

        
        return wrapper;
    },


    
    forceFormReset: function(textbox) {
        
        
        while(textbox) {
            if(/form/i.test(textbox.nodeName)) {
                break;
            }
            textbox = textbox.parentNode;
        }
        
        
        if(!/form/i.test(textbox.nodeName)) {
            return null;
        }

        
        
        
        
        
        
        this.addSpecialLoadListener(function() {
            textbox.reset();
        });

        
        return textbox;
    },


    
    
    
    convertPasswordFieldHTML: function(passfield, addedattrs) {
        
        var textfield = '<input';

        
        
        
        
        
        
        for(var fieldattributes = passfield.attributes, j = 0; j < fieldattributes.length; j++) {
            
            
            
            if(fieldattributes[j].specified && !/^(_|type|name)/.test(fieldattributes[j].name)) {
                textfield += ' ' + fieldattributes[j].name + '="' + fieldattributes[j].value + '"';
            }
        }

        
        
        
        
        
        textfield += ' type="text" autocomplete="off">';

        
        return textfield;
    },


    
    
    limitCaretPosition: function(textbox) {
        
        var timer = null,
            start = function() {
                
                if(timer == null) {
                    
                    if(this.isIE) {
                        
                        
                        timer = window.setInterval(function() {
                            
                            
                            
                            
                            
                            var range = textbox.createTextRange(),
                                valuelength = textbox.value.length,
                                character = 'character';
                            range.moveEnd(character, valuelength);
                            range.moveStart(character, valuelength);
                            range.select();

                            
                            
                        }, 100);
                    }
                    
                    else {
                        
                        
                        timer = window.setInterval(function() {
                            
                            
                            var valuelength = textbox.value.length;
                            if(!(textbox.selectionEnd == valuelength && textbox.selectionStart <= valuelength)) {
                                textbox.selectionStart = valuelength;
                                textbox.selectionEnd = valuelength;
                            }

                            
                        }, 100);
                    }
                }
            },

            
            stop = function() {
                window.clearInterval(timer);
                timer = null;
            };

        
        this.addListener(textbox, 'focus', function() {
            start();
        });
        this.addListener(textbox, 'blur', function() {
            stop();
        });
    },


    
    
    
    addListener: function(eventnode, eventname, eventhandler) {
        if(typeof document.addEventListener != 'undefined') {
            return eventnode.addEventListener(eventname, eventhandler, false);
        } else if(typeof document.attachEvent != 'undefined') {
            return eventnode.attachEvent('on' + eventname, eventhandler);
        }
    },


    
    
    
    addSpecialLoadListener: function(eventhandler) {
        
        
        
        if(this.isIE) {
            return window.attachEvent('onload', eventhandler);
        } else {
            return document.addEventListener('DOMContentLoaded', eventhandler, false);
        }
    },


    
    
    
    
    getTarget: function(e) {
        
        if(!e) {
            return null;
        }

        
        return e.target ? e.target : e.srcElement;
    }

};


$KW.TextField.AutoComplete = {
    
    __AutoCompleteClass: 'autocomplete_base',
    __AutoComplete: new Array(),
    __AutoCompleteElementId: null,

    
    isIE: document.all ? true : false,
    isGecko: navigator.userAgent.toLowerCase().indexOf('gecko') != -1,
    isOpera: navigator.userAgent.toLowerCase().indexOf('opera') != -1,

    AutoSuggestOrientation: function() {
        if(this.__AutoCompleteElementId != null) {

            this.AutoComplete_HideAll();
            
            this.AutoComplete_CreateDropdownZeroSize(this.__AutoCompleteElementId);
            this.AutoComplete_ShowDropdown(this.__AutoCompleteElementId);
            this.AutoComplete_HideAll();
            this.AutoComplete_CreateDropdown(this.__AutoCompleteElementId);
            this.AutoComplete_ShowDropdown(this.__AutoCompleteElementId);
            
        }
    },

    
    AutoComplete_Create: function(id, data) {
        this.__AutoComplete[id] = {
            'data': data,
            'isVisible': false,
            'element': document.getElementById(id),
            'dropdown': null,
            'highlighted': null,
            'styleclass': this.__AutoCompleteClass
        };

        this.__AutoComplete[id]['element'].setAttribute(this.__AutoCompleteClass, 'off');
        this.__AutoComplete[id]['element'].onkeydown = function(e) {
            return $KW.TextField.AutoComplete.AutoComplete_KeyDown(this.getAttribute('id'), e);
        }
        this.__AutoComplete[id]['element'].onkeyup = function(e) {
            return $KW.TextField.AutoComplete.AutoComplete_KeyUp(this.getAttribute('id'), e);
        }
        this.__AutoComplete[id]['element'].onkeypress = function(e) {
            if(!e) e = window.event;
            if(e.keyCode == 13 || this.isOpera) return false;
        }
        this.__AutoComplete[id]['element'].ondblclick = function() {
            $KW.TextField.AutoComplete.AutoComplete_ShowDropdown(this.getAttribute('id'));
        }
        this.__AutoComplete[id]['element'].onclick = function(e) {
            if(!e) e = window.event;
            e.cancelBubble = true;
            e.returnValue = false;
        }

        
        var docClick = function() {
            for(id in this.__AutoComplete) {
                $KW.TextField.AutoComplete.AutoComplete_HideDropdown(id);
            }
        }

        if(document.addEventListener) {
            document.addEventListener('click', docClick, false);
        } else if(document.attachEvent) {
            document.attachEvent('onclick', docClick, false);
        }


        
        if(arguments[2] != null) {
            this.__AutoComplete[id]['maxitems'] = arguments[2];
            this.__AutoComplete[id]['firstItemShowing'] = 0;
            this.__AutoComplete[id]['lastItemShowing'] = arguments[2] - 1;
        }

        this.AutoComplete_CreateDropdown(id);

        
        if(this.isIE) {
            this.__AutoComplete[id]['iframe'] = document.createElement('iframe');
            this.__AutoComplete[id]['iframe'].id = id + '_iframe';
            this.__AutoComplete[id]['iframe'].style.position = 'absolute';
            this.__AutoComplete[id]['iframe'].style.top = '0';
            this.__AutoComplete[id]['iframe'].style.left = '0';
            this.__AutoComplete[id]['iframe'].style.width = '0px';
            this.__AutoComplete[id]['iframe'].style.height = '0px';
            this.__AutoComplete[id]['iframe'].style.zIndex = '98';
            this.__AutoComplete[id]['iframe'].style.visibility = 'hidden';

            this.__AutoComplete[id]['element'].parentNode.insertBefore(this.__AutoComplete[id]['iframe'], this.__AutoComplete[id]['element']);
        }
    },

    
    AutoComplete_CreateDropdown: function(id) {
        var left = this.AutoComplete_GetLeft(this.__AutoComplete[id]['element']);
        var top = this.AutoComplete_GetTop(this.__AutoComplete[id]['element']) + this.__AutoComplete[id]['element'].offsetHeight;
        var width = this.__AutoComplete[id]['element'].offsetWidth;
        
        this.__AutoComplete[id]['dropdown'] = document.createElement('div');
        this.__AutoComplete[id]['dropdown'].className = this.__AutoCompleteClass; 

        this.AutoComplete_RemoveDivs(id);

        this.__AutoComplete[id]['element'].parentNode.insertBefore(this.__AutoComplete[id]['dropdown'], this.__AutoComplete[id]['element']);
        
        this.__AutoComplete[id]['dropdown'].style.left = left + 'px';
        this.__AutoComplete[id]['dropdown'].style.top = top + 'px';
        this.__AutoComplete[id]['dropdown'].style.width = width + 'px';
        this.__AutoComplete[id]['dropdown'].style.zIndex = '99';
        this.__AutoComplete[id]['dropdown'].style.visibility = 'hidden';

        
        var el = document.getElementById(id);
        if(el.getAttribute('autosuggestskin') != null) {
            this.__AutoComplete[id]['styleclass'] = el.getAttribute('autosuggestskin');
            this.__AutoComplete[id]['dropdown'].className = this.__AutoComplete[id]['styleclass'];
            this.__AutoComplete[id]['dropdown'].style.position = 'absolute';
            this.__AutoComplete[id]['dropdown'].style.borderStyle = 'solid';
            this.__AutoComplete[id]['dropdown'].style.borderWidth = '1px';
            this.__AutoComplete[id]['dropdown'].style.borderColor = 'black';
            this.__AutoComplete[id]['dropdown'].style.backgroundColor = 'white';
            this.__AutoComplete[id]['dropdown'].style.overflow = 'auto';
            this.__AutoComplete[id]['dropdown'].style.overflowX = 'hidden';

        } else {
            this.__AutoComplete[id]['dropdown'].style.fontFamily = this.getElementStyle(el, 'font-family');
            this.__AutoComplete[id]['dropdown'].style.fontSize = this.getElementStyle(el, 'font-size');
            this.__AutoComplete[id]['dropdown'].style.fontStyle = this.getElementStyle(el, 'font-style');
            this.__AutoComplete[id]['dropdown'].style.fontWeight = this.getElementStyle(el, 'font-weight');
            this.__AutoComplete[id]['dropdown'].style.color = this.getElementStyle(el, 'color');
        }
        this.AutoComplete_RemoveDivs(id);

        this.__AutoComplete[id]['element'].parentNode.insertBefore(this.__AutoComplete[id]['dropdown'], this.__AutoComplete[id]['element']);
    },

    getElementStyle: function(el, styleProp) {
        var elementstyle = null;
        if(el.currentStyle)
            elementstyle = el.currentStyle[styleProp];
        else if(window.getComputedStyle)
            elementstyle = document.defaultView.getComputedStyle(el, null).getPropertyValue(styleProp);
        return elementstyle;
    },

    AutoComplete_RemoveDivs: function(id) {
        var autoCompleteParent = document.getElementById(id).parentNode;
        if(this.__AutoComplete[id]) {
            var autoCompleteDivs = document.getElementsByClassName(this.__AutoComplete[id]['styleclass']);
            if(autoCompleteDivs.length > 0) {
                for(var i = 0; i < autoCompleteDivs.length; i++) {
                    if(autoCompleteDivs[i].nextSibling.id === id)
                        autoCompleteParent.removeChild(autoCompleteDivs[i]);
                }
            }
        }
    },

    
    AutoComplete_CreateDropdownZeroSize: function(id) {
        
        this.__AutoComplete[id]['dropdown'].style.left = '1px';
        this.__AutoComplete[id]['dropdown'].style.top = '1px';
        this.__AutoComplete[id]['dropdown'].style.width = '10px';
        this.__AutoComplete[id]['dropdown'].style.zIndex = '99';
        this.__AutoComplete[id]['dropdown'].style.visibility = 'hidden';
    },

    
    AutoComplete_GetLeft: function(element) {
        var curNode = element;
        var left = 0;

        do {
            left += curNode.offsetLeft;
            curNode = curNode.offsetParent;

        } while (curNode.tagName.toLowerCase() != 'body');

        return left;
    },

    
    AutoComplete_GetTop: function(element) {
        var curNode = element;
        var top = 0;

        do {
            top += curNode.offsetTop;
            curNode = curNode.offsetParent;

        } while (curNode.tagName.toLowerCase() != 'body');

        return top;
    },

    
    AutoComplete_ShowDropdown: function(id) {
        this.AutoComplete_HideAll();
        this.__AutoCompleteElementId = id;
        var value = this.__AutoComplete[id]['element'].value;
        var toDisplay = new Array();
        var newDiv = null;
        var text = null;
        var numItems = this.__AutoComplete[id]['dropdown'].childNodes.length;

        
        while(this.__AutoComplete[id]['dropdown'].childNodes.length > 0) {
            this.__AutoComplete[id]['dropdown'].removeChild(this.__AutoComplete[id]['dropdown'].childNodes[0]);
        }

        
        value = value.ltrim().toUpperCase();
        for(i = 0; i < this.__AutoComplete[id]['data'].length; ++i) {
            if(this.__AutoComplete[id]['data'][i].toUpperCase().indexOf(value) != -1) {
                toDisplay[toDisplay.length] = this.__AutoComplete[id]['data'][i];
            }
        }

        
        if(toDisplay.length == 0) {
            this.AutoComplete_HideDropdown(id);
            return;
        }

        var target = document.getElementById(id);
        var space = target.getAttribute('suggestionspace');
        if(space)
            space = parseInt(space) / 2;

        
        for(i = 0; i < toDisplay.length; ++i) {
            newDiv = document.createElement('div');
            newDiv.className = 'autocomplete_item'; 
            newDiv.setAttribute('id', 'autocomplete_item_' + i);
            newDiv.setAttribute('index', i);
            newDiv.style.zIndex = '99';

            
            if(toDisplay.length > this.__AutoComplete[id]['maxitems'] && navigator.userAgent.indexOf('MSIE') == -1) {
                newDiv.style.width = this.__AutoComplete[id]['element'].offsetWidth - 22 + 'px';
            }

            newDiv.onmouseover = function() {
                $KW.TextField.AutoComplete.AutoComplete_HighlightItem($KW.TextField.AutoComplete.__AutoComplete[id]['element'].getAttribute('id'), this.getAttribute('index'));
            };
            newDiv.onclick = function() {
                $KW.TextField.AutoComplete.AutoComplete_SetValue($KW.TextField.AutoComplete.__AutoComplete[id]['element'].getAttribute('id'));
                $KW.TextField.AutoComplete.AutoComplete_RemoveDivs(id);
            }

            text = document.createTextNode(toDisplay[i]);
            newDiv.appendChild(text);

            this.AutoComplete_HideAllDropdowns()

            if(space) {
                newDiv.style.paddingBottom = space + "px";
                newDiv.style.paddingTop = space + "px";
            }
            this.__AutoComplete[id]['dropdown'].appendChild(newDiv);
        }


        
        if(toDisplay.length > this.__AutoComplete[id]['maxitems']) {
            this.__AutoComplete[id]['dropdown'].style.height = (this.__AutoComplete[id]['maxitems'] * 15) + 2 + 'px';

        } else {
            this.__AutoComplete[id]['dropdown'].style.height = '';
        }


        
        this.__AutoComplete[id]['dropdown'].style.left = this.AutoComplete_GetLeft(this.__AutoComplete[id]['element']) + 'px';
        this.__AutoComplete[id]['dropdown'].style.top = this.AutoComplete_GetTop(this.__AutoComplete[id]['element']) + this.__AutoComplete[id]['element'].offsetHeight + 'px';


        
        if(this.isIE) {
            this.__AutoComplete[id]['iframe'].style.top = this.__AutoComplete[id]['dropdown'].style.top;
            this.__AutoComplete[id]['iframe'].style.left = this.__AutoComplete[id]['dropdown'].style.left;
            this.__AutoComplete[id]['iframe'].style.width = this.__AutoComplete[id]['dropdown'].offsetWidth;
            this.__AutoComplete[id]['iframe'].style.height = this.__AutoComplete[id]['dropdown'].offsetHeight;

            this.__AutoComplete[id]['iframe'].style.visibility = 'visible';
        }


        
        if(!this.__AutoComplete[id]['isVisible']) {
            this.__AutoComplete[id]['dropdown'].style.visibility = 'visible';
            this.__AutoComplete[id]['isVisible'] = true;
        }


        
        if(this.__AutoComplete[id]['dropdown'].childNodes.length != numItems) {
            this.__AutoComplete[id]['highlighted'] = null;
        }
    },

    
    AutoComplete_HideDropdown: function(id) {
        if(this.__AutoComplete[id]['iframe']) {
            this.__AutoComplete[id]['iframe'].style.visibility = 'hidden';
        }

        if(this.__AutoComplete[id]['dropdown']) {
            this.__AutoComplete[id]['dropdown'].style.visibility = 'hidden';
        }
        this.__AutoComplete[id]['highlighted'] = null;
        this.__AutoComplete[id]['isVisible'] = false;
    },

    
    AutoComplete_HideAll: function() {
        for(id in this.__AutoComplete) {
            this.AutoComplete_HideDropdown(id);
        }
    },

    AutoComplete_HideAllDropdowns: function() {
        var autocompdivs = document.getElementsByClassName(this.__AutoComplete[id]['styleclass']);
        if(autocompdivs != null) {
            for(var i = 0; i < autocompdivs.length; i++) {
                autocompdivs[i].style.visibility = 'hidden';
            }
        }
    },

    
    AutoComplete_HighlightItem: function(id, index) {
        if(this.__AutoComplete[id]['dropdown'].childNodes[index]) {
            for(var i = 0; i < this.__AutoComplete[id]['dropdown'].childNodes.length; ++i) {
                if(this.__AutoComplete[id]['dropdown'].childNodes[i].className == 'autocomplete_item_highlighted') {
                    this.__AutoComplete[id]['dropdown'].childNodes[i].className = 'autocomplete_item';
                }
            }

            this.__AutoComplete[id]['dropdown'].childNodes[index].className = 'autocomplete_item_highlighted';
            this.__AutoComplete[id]['highlighted'] = index;
        }
    },

    
    AutoComplete_Highlight: function(id, index) {
        
        if(index == 1 && this.__AutoComplete[id]['highlighted'] == this.__AutoComplete[id]['dropdown'].childNodes.length - 1) {
            this.__AutoComplete[id]['dropdown'].childNodes[this.__AutoComplete[id]['highlighted']].className = 'autocomplete_item';
            this.__AutoComplete[id]['highlighted'] = null;

        } else if(index == -1 && this.__AutoComplete[id]['highlighted'] == 0) {
            this.__AutoComplete[id]['dropdown'].childNodes[0].className = 'autocomplete_item';
            this.__AutoComplete[id]['highlighted'] = this.__AutoComplete[id]['dropdown'].childNodes.length;
        }

        
        if(this.__AutoComplete[id]['highlighted'] == null) {
            this.__AutoComplete[id]['dropdown'].childNodes[0].className = 'autocomplete_item_highlighted';
            this.__AutoComplete[id]['highlighted'] = 0;

        } else {
            if(this.__AutoComplete[id]['dropdown'].childNodes[this.__AutoComplete[id]['highlighted']]) {
                this.__AutoComplete[id]['dropdown'].childNodes[this.__AutoComplete[id]['highlighted']].className = 'autocomplete_item';
            }

            var newIndex = this.__AutoComplete[id]['highlighted'] + index;

            if(this.__AutoComplete[id]['dropdown'].childNodes[newIndex]) {
                this.__AutoComplete[id]['dropdown'].childNodes[newIndex].className = 'autocomplete_item_highlighted';

                this.__AutoComplete[id]['highlighted'] = newIndex;
            }
        }
    },

    
    AutoComplete_SetValue: function(id) {
        this.__AutoComplete[id]['element'].value = this.__AutoComplete[id]['dropdown'].childNodes[this.__AutoComplete[id]['highlighted']].innerHTML;
    },
    
    AutoComplete_ScrollCheck: function(id) {
        
        if(this.__AutoComplete[id]['highlighted'] > this.__AutoComplete[id]['lastItemShowing']) {
            this.__AutoComplete[id]['firstItemShowing'] = this.__AutoComplete[id]['highlighted'] - (this.__AutoComplete[id]['maxitems'] - 1);
            this.__AutoComplete[id]['lastItemShowing'] = this.__AutoComplete[id]['highlighted'];
        }

        
        if(this.__AutoComplete[id]['highlighted'] < this.__AutoComplete[id]['firstItemShowing']) {
            this.__AutoComplete[id]['firstItemShowing'] = this.__AutoComplete[id]['highlighted'];
            this.__AutoComplete[id]['lastItemShowing'] = this.__AutoComplete[id]['highlighted'] + (this.__AutoComplete[id]['maxitems'] - 1);
        }

        this.__AutoComplete[id]['dropdown'].scrollTop = this.__AutoComplete[id]['firstItemShowing'] * 15;
    },

    
    AutoComplete_KeyDown: function(id) {
        
        if(arguments[1] != null) {
            event = arguments[1];
        }

        var keyCode = event.keyCode;

        switch(keyCode) {

            
            case 13:
                if(this.__AutoComplete[id]['highlighted'] != null) {
                    this.AutoComplete_SetValue(id);
                    this.AutoComplete_HideAllDropdowns();
                }

                
                break;

                
            case 27:
                this.AutoComplete_HideAllDropdowns();
                event.returnValue = false;
                event.cancelBubble = true;
                break;

                
            case 38:
                if(!this.__AutoComplete[id]['isVisible']) {
                    this.AutoComplete_ShowDropdown(id);
                }

                this.AutoComplete_Highlight(id, -1);
                this.AutoComplete_ScrollCheck(id, -1);
                return false;
                break;

                
            case 9:
                if(this.__AutoComplete[id]['isVisible']) {
                    this.AutoComplete_HideAllDropdowns();
                }
                return;

                
            case 40:
                if(!this.__AutoComplete[id]['isVisible']) {
                    this.AutoComplete_ShowDropdown(id);
                }

                this.AutoComplete_Highlight(id, 1);
                this.AutoComplete_ScrollCheck(id, 1);
                return false;
                break;
        }
    },

    
    AutoComplete_KeyUp: function(id) {
        
        if(arguments[1] != null) {
            event = arguments[1];
        }

        var keyCode = event.keyCode;

        switch(keyCode) {
            case 13:
                event.returnValue = false;
                event.cancelBubble = true;
                break;

            case 27:
                this.AutoComplete_HideAllDropdowns();
                event.returnValue = false;
                event.cancelBubble = true;
                break;

            case 38:
            case 40:
                return false;
                break;

            default:
                this.AutoComplete_ShowDropdown(id);
                break;
        }
    },

    
    AutoComplete_isVisible: function(id) {
        return this__AutoComplete[id]['dropdown'].style.visibility == 'visible';
    }
};


$KW.RadioButtonGroup = (function() {
    
    

    var module = {
        initialize: function() {
            kony.events.addEvent("change", "RadioButtonGroup", this.eventHandler);
        },

        updateView: function(widgetModel, propertyName, propertyValue, oldPropertyValue) {
            var element = $KU.getNodeByModel(widgetModel);
            element = $KW.Utils.getClonedTemplateNode(element, widgetModel, propertyName);
            switch(propertyName) {
                case "masterdatamap":
                case "masterdata":
                    var data = $KW.Utils.getMasterData(widgetModel);
                    widgetModel.selectedkey = data.length > 1 ? data[IndexJL][IndexJL] : null;

                    $KW.Utils.setSelectedValueProperty(widgetModel, data, "selectedkey");
                    if(element) {
                        element.innerHTML = this.generateList(widgetModel, data, widgetModel.context);
                        $KU.toggleVisibilty(element, data, widgetModel);
                    }
                    break;

                case "selectedkey":
                    var choices = document.querySelectorAll("#" + widgetModel.pf + " input[name='" + widgetModel.id + "']");
                    
                    
                    for(var i = 0; i < choices.length; i++) {
                        if(widgetModel.selectedkey == choices[i].value)
                            choices[i].checked = true;
                        else
                            choices[i].checked = false;
                    }
                    widgetModel.selectedkey && $KW.Utils.setSelectedValueProperty(widgetModel, $KW.Utils.getMasterData(widgetModel), "selectedkey");
                    if(!widgetModel.selectedkey) {
                        widgetModel.selectedKeyValue = widgetModel.selectedkeyvalue = null;
                    }
                    break;

                case "viewtype":
                    widgetModel.propertyName = propertyValue;
                    var data = $KW.Utils.getMasterData(widgetModel);
                    if(element) {
                        element.innerHTML = this.generateList(widgetModel, data, widgetModel.context);
                        $KU.toggleVisibilty(element, data, widgetModel);
                    }
                    break;

                case "checkedimage":
                    var data = $KW.Utils.getMasterData(widgetModel);
                    if(element) {
                        element.innerHTML = this.generateList(widgetModel, data, widgetModel.context);
                        $KU.toggleVisibilty(element, data, widgetModel);
                    }
                    break;

                case "uncheckedimage":
                    var data = $KW.Utils.getMasterData(widgetModel);
                    if(element) {
                        element.innerHTML = this.generateList(widgetModel, data, widgetModel.context);
                        $KU.toggleVisibilty(element, data, widgetModel);
                    }
                    break;

                case "size":
                    
                    var data = $KW.Utils.getMasterData(widgetModel);
                    if(element) {
                        element.innerHTML = this.generateList(widgetModel, data, widgetModel.context);
                        $KU.toggleVisibilty(element, data, widgetModel);
                    }
                    break;
            }
        },

        render: function(radiobuttonModel, context) {
            var data = $KW.Utils.getMasterData(radiobuttonModel);
            var computedSkin = $KW.skins.getWidgetSkinList(radiobuttonModel, context, data);

            var htmlString = "<div" + $KW.Utils.getBaseHtml(radiobuttonModel, context) + "class = '" + computedSkin + "' style='" + $KW.skins.getBaseStyle(radiobuttonModel, context) + (context.ispercent === false ? "display:inline-block" : "") + "'>";

            radiobuttonModel.context = context;
            htmlString += this.generateList(radiobuttonModel, data, context);

            htmlString += "</div>";
            return htmlString;
        },

        generateList: function(radiobuttonModel, data, context) {
            var htmlString = "";
            if(data.length > IndexJL) {
                var key = radiobuttonModel.selectedkey;
                radiobuttonModel.selectedkey = key ? key : null; 
                $KW.Utils.setSelectedValueProperty(radiobuttonModel, data, "selectedkey");

                for(var i = IndexJL; i < data.length; i++) {
                    if(data[i][IndexJL] != null && data[i][1 + IndexJL] != null) {
                        var selected = (radiobuttonModel.selectedkey == data[i][IndexJL]) ? "checked" : "";
                        if(radiobuttonModel.viewtype == "customview") {
                            if(radiobuttonModel.itemorientation == "vertical") {
                                htmlString += "<div style = 'height: auto;'  class='kwt100'>";
                            } else {
                                htmlString += "<div style = ' display: inline-block; height: auto;' >";
                            }

                            var imgsrc;
                            if(selected == "checked") {
                                imgsrc = "url(" + $KU.getImageURL(radiobuttonModel.checkedimage) + ")"
                            } else {
                                imgsrc = "url(" + $KU.getImageURL(radiobuttonModel.uncheckedimage) + ")"
                            };

                            var name = (context && context.container ? (radiobuttonModel.id + "_" + context.container.counter) : radiobuttonModel.id); 

                            htmlString += "<input style='display : none;' id ='" + radiobuttonModel.id + "radio" + i + "' class='middlecenteralign' kformname='" + radiobuttonModel.pf + "' kwidgettype='" + radiobuttonModel.wType + "' type='radio' " + selected + ($KW.Utils.isWidgetDisabled(radiobuttonModel, context) ? " disabled='true'" : "") + " value='" + data[i][IndexJL] + "' name='" + name + "' style='  margin-right:3px;' />";
                            htmlString += "<label id ='" + radiobuttonModel.id + "_label" + i + "' selected ='" + selected + "'  for ='" + radiobuttonModel.id + "radio" + i + "'  name = '" + radiobuttonModel.id + "_label" + i + "' style=' background-image: " + imgsrc + "; width: " + radiobuttonModel.size + "px; height: " + radiobuttonModel.size + "px; -webkit-background-size: 100%; background-size:100%; margin-right: 3px; vertical-align: middle; display: inline-block;' ></label>"
                            htmlString += "<label style=' position: relative; padding-left: 5px; vertical-align: middle; display: inline-block;'>"
                            htmlString += $KU.escapeHTMLSpecialEntities(data[i][1 + IndexJL]);
                            htmlString += (radiobuttonModel.itemorientation == constants.RADIOGROUP_ITEM_ORIENTATION_VERTICAL) ? "</label><br/></div>" : "</div></label>&nbsp;";

                        } else {

                            if(radiobuttonModel.itemorientation == "vertical") {
                                htmlString += "<div style = 'height: auto;'  class='kwt100'>";
                            } else {
                                htmlString += "<div style = ' display: inline-block; height: auto; text-decoration: inherit;' >";
                            }
                            var name = (context && context.container ? (radiobuttonModel.id + "_" + context.container.counter) : radiobuttonModel.id); 

                            var ariaString = $KU.getAccessibilityValues(radiobuttonModel, data[i][2 + IndexJL], data[i][IndexJL]);
                            if(ariaString.indexOf('aria-label') < 0)
                                ariaString += " aria-label='" + $KU.escapeHTMLSpecialEntities(data[i][1 + IndexJL]) + "' ";

                            htmlString += "<input  " + ariaString + "type='radio' kwidgettype='" + radiobuttonModel.wType + "' name='" + name + "' " + selected + ($KW.Utils.isWidgetDisabled(radiobuttonModel, context) ? " disabled='true'" : "") + " class='middlecenteralign' value='" + data[i][IndexJL] + "' style='margin-right:3px;' kformname='" + radiobuttonModel.pf + "'/>";
                            htmlString += "<span aria-hidden='true' class='middlecenteralign'>" + $KU.escapeHTMLSpecialEntities(data[i][1 + IndexJL]) + "</span>";

                            htmlString += (radiobuttonModel.itemorientation == "vertical") ? "<br/></div>" : "</div>&nbsp;";

                        }
                    }
                }
            }
            return htmlString;

        },

        changeImage: function(target, radiobuttonModel, newselectedkey) {
            if(radiobuttonModel.selectedkey != newselectedkey) {
                var data = $KW.Utils.getMasterData(radiobuttonModel);
                var checksrc = "url(" + $KU.getImageURL(radiobuttonModel.checkedimage) + ")";
                var unchecksrc = "url(" + $KU.getImageURL(radiobuttonModel.uncheckedimage) + ")";

                for(var i = IndexJL; i < data.length; i++) {
                    if(data[i][IndexJL] != null && data[i][1 + IndexJL] != null) {

                        var node = $KU.getElementById(radiobuttonModel.id + "_label" + i);
                        if(node.getAttribute("selected") == "checked") {
                            node.style.backgroundImage = "url(" + $KU.getImageURL(radiobuttonModel.uncheckedimage) + ")";
                            node.setAttribute("selected", "");
                        }
                    }
                }

                target.style.backgroundImage = "url(" + $KU.getImageURL(radiobuttonModel.checkedimage) + ")";
                target.setAttribute("selected", "checked");
            }
        },

        eventHandler: function(eventObject, target) {
            var radioGrp = target.parentNode.parentNode;
            var radiobuttonModel = $KU.getModelByNode(radioGrp);

            var inputElements = radioGrp.getElementsByTagName("input");
            for(var i = 0; i < inputElements.length; i++) {
                inputElements[i].removeAttribute("checked");
            }

            target.setAttribute("checked", "");

            if(radiobuttonModel) {

                if(radiobuttonModel.viewtype == "customview") {
                    module.changeImage($KU.getNextSibling(target), radiobuttonModel, target.value);
                }

                radiobuttonModel.selectedkey = target.value;
                spaAPM && spaAPM.sendMsg(radiobuttonModel, 'onselection');
                $KAR && $KAR.sendRecording(radiobuttonModel, 'click', {'key': target.value, 'target': radioGrp, 'eventType': 'uiAction'});
                if(radioGrp.getAttribute("kcontainerID"))
                    $KW.Utils.updateContainerData(radiobuttonModel, target, false);
                else {
                    $KW.Utils.setSelectedValueProperty(radiobuttonModel, $KW.Utils.getMasterData(radiobuttonModel), "selectedkey");
                    var radioref = $KU.returnEventReference(radiobuttonModel.onselection);
                    if(radioref) {
                        $KU.executeWidgetEventHandler(radiobuttonModel, radioref);
                        $KU.onEventHandler(radiobuttonModel);
                    }
                }
            }
        }
    };


    return module;
}());


$KW.ListBox = (function() {
    
    

    var module = {
        initialize: function() {
            kony.events.addEvent("change", "ListBox", this.eventHandler);
            kony.events.addEvent("click", "ListBox", this.eventHandler);
        },

        initializeView: function(formId) {
            var editableLists = document.querySelectorAll("div[name='SelectOptionsList']");
            if(editableLists) {
                for(var i = 0; i < editableLists.length; i++) {
                    this.initializeEditableList(editableLists[i].parentNode);
                }
            }
        },

        initializeEditableList: function(editableList) {
            var list = editableList,
                listboxModel = $KU.getModelByNode(list),
                containerNode = null,
                containerWidget = null;
                secIndex = null,
                index = null;
                editableListInstance = list.id + "_autoComplete";

            editableListInstance = module.createEditableListInstance(editableList, editableListInstance);
            $KG["listBoxEditableInstances"].push(editableListInstance);
            $KG[editableListInstance] = new module.autocomplete(list, {
                model: listboxModel
            });
        },

        createEditableListInstance: function(listBoxNode, editableListInstance) {
            var containerWidgets = ['Segment','CollectionView'],
                containerId = listBoxNode.getAttribute("kcontainerID"),
                containerWidget,
                rowNode = null,
                secIndex = null,
                index = null;

            if(containerId) {
                containerWidget = $KW.Utils.getContainerModelById(listBoxNode, containerId).wType;
            }
            if(containerWidgets.indexOf(containerWidget) != -1) {
                rowNode = $KU.getParentByAttribute(listBoxNode, 'index');
                secIndex = rowNode.getAttribute('secindex');
                if(secIndex) {
                    editableListInstance += 'secindex' + secIndex;
                }
                index = rowNode.getAttribute('index');
                if(index) {
                    editableListInstance += 'index' + index;
                }
            }
            return editableListInstance;
        },

        updateView: function(widgetModel, propertyName, propertyValue, oldPropertyValue) {
            var element = $KU.getNodeByModel(widgetModel);
            element = $KW.Utils.getClonedTemplateNode(element, widgetModel, propertyName);
            switch(propertyName) {
                case "multiselectrows":
                    if(element && widgetModel.multiple) {
                        element.setAttribute("size", propertyValue);
                    }
                    break;

                case "masterdatamap":
                case "masterdata":
                    var data = $KW.Utils.getMasterData(widgetModel);
                    widgetModel.selectedkey = widgetModel.selectedkeys = widgetModel.selectedkeyvalue = widgetModel.selectedkeyvalues = null;
                    if(element) {
                        
                        widgetModel.context.ispercent = "";

                        var temp = document.createElement("div");
                        temp.innerHTML = this.generateList(widgetModel, data, widgetModel.context);
                        element.parentNode.replaceChild(temp.firstChild, element);
                        if(widgetModel.viewtype == constants.LISTBOX_VIEW_TYPE_EDITVIEW) {
                            var list = $KU.getNodeByModel(widgetModel);
                            module.initializeEditableList(list);
                        }
                        
                        element = $KU.getNodeByModel(widgetModel);
                        var isFlexWidget = $KW.FlexUtils.isFlexWidget(widgetModel);
                        if(isFlexWidget) {
                            $KW.FlexUtils.setPaddingByParent(widgetModel, element);
                            $KW.FlexUtils.setDimensions(widgetModel, element.parentNode);
                        }
                        $KU.toggleVisibilty(element, data, widgetModel);
                    }
                    break;

                case "selectedkeys":
                    $KW.Utils.setSelectedValueProperty(widgetModel, $KW.Utils.getMasterData(widgetModel), "selectedkeys");
                    if(element) {
                        if(element.tagName == 'SELECT') {
                            var choices = element.options;
                            if(choices.length > 0) {
                                for(var i = 0; i < choices.length; i++) {
                                    if(widgetModel.selectedkeys &&
                                        $KU.inArray(widgetModel.selectedkeys, choices[i].value)[0]) {
                                        choices[i].selected = true;
                                    } else {
                                        choices[i].selected = false;
                                    }
                                }
                                if(!widgetModel.selectedkeys) {
                                    if(!widgetModel.multiple) choices[0].selected = true; 
                                    widgetModel.selectedkeyvalues = null;
                                }
                            }
                        } else if(element.tagName == 'DIV') {
                            if(widgetModel.selectedkeys) {
                                element.innerText = widgetModel.selectedkeyvalues[1][2];
                            } else {
                                element.innerText = widgetModel.masterdata[1][2];
                            }
                        }
                    }
                    break;

                case "selectedkey":
                    var key = widgetModel.selectedkey;
                    if(widgetModel.viewtype == "editableview") {
                        var data = $KW.Utils.getMasterData(widgetModel);
                        var isModified = false;
                        if(data.length > IndexJL) {
                            for(var i = IndexJL; i < data.length; i++) {
                                if(data[i][IndexJL] == key) {
                                    element.children[0].value = data[i][IndexJL + 1];
                                    isModified = true;
                                    widgetModel["selectedkeyvalue"] = [key, data[i][IndexJL + 1]];
                                    IndexJL && widgetModel["selectedkeyvalue"].splice(0, 0, null);
                                }
                            }
                        }
                        if(!isModified || data.length < 0) {
                            element.children[0].value = key;
                            widgetModel["selectedkeyvalue"] = [key, key];
                            IndexJL && widgetModel["selectedkeyvalue"].splice(0, 0, null);
                        }
                    }
                    if(element) {
                        
                        element.value = widgetModel.selectedkey;
                    }
                    $KW.Utils.setSelectedValueProperty(widgetModel, $KW.Utils.getMasterData(widgetModel), "selectedkey");
                    break;
                case "viewtype":
                case "autosuggest":
                    if(element) {
                        var data = $KW.Utils.getMasterData(widgetModel);
                        var temp = document.createElement("div");
                        temp.innerHTML = this.generateList(widgetModel, data, {
                            tabpaneID: element.getAttribute("ktabpaneid")
                        });
                        element.parentNode.replaceChild(temp.firstChild, element);
                        if(widgetModel.viewtype == constants.LISTBOX_VIEW_TYPE_EDITVIEW) {
                            var listNode = $KU.getNodeByModel(widgetModel);
                            module.initializeEditableList(listNode);
                            if(propertyName == "autosuggest" && propertyValue && data && data.length > IndexJL) {
                                element = $KU.getNodeByModel(widgetModel);
                                $KG[element.id + "_autoComplete"] = new module.autocomplete(element, {
                                    data: data,
                                    model: widgetModel
                                });
                            }
                        }
                        element = $KU.getNodeByModel(widgetModel);
                        var isFlexWidget = $KW.FlexUtils.isFlexWidget(widgetModel);
                        if(isFlexWidget) {
                            $KW.FlexUtils.setPaddingByParent(widgetModel, element);
                            $KW.FlexUtils.setDimensions(widgetModel, element.parentNode);
                        }
                    }
                    break;

                case "editableareaskin":
                    if(element && widgetModel.viewtype == "editableview") {
                        element.childNodes[0].className = propertyValue;
                    }
                    break;
            }
        },

        render: function(listboxModel, context) {
            var data = $KW.Utils.getMasterData(listboxModel);
            data.ispercent = context.ispercent;
            listboxModel.context = context;
            return this.generateList(listboxModel, data, context);
        },

        generateList: function(listboxModel, data, context) {
            if(listboxModel.isCloned && data.length == 0) {
                return "";
            }
            var computedSkin = $KW.skins.getWidgetSkinList(listboxModel, context, data);
            var multiple = listboxModel.multiple ? " multiple" : "";
            var size = listboxModel.multiselectrows ? " size=" + parseInt(listboxModel.multiselectrows) : ""
            var htmlString = "";

            if(listboxModel.viewtype == "editableview") {
                var value = "";
                var options = "";
                var cwt = $KW.skins.getMarPadAdjustedContainerWeightSkin(listboxModel, 100);

                if(data.length > IndexJL) {
                    var key = listboxModel.selectedkey;
                    listboxModel.selectedkey = key ? key : data[IndexJL][IndexJL]; 
                    $KW.Utils.setSelectedValueProperty(listboxModel, data, "selectedkey");
                }
                for(var i = IndexJL; i < data.length; i++) {
                    (listboxModel.selectedkey == data[i][IndexJL]) && (value = data[i][1 + IndexJL]);
                    if(!listboxModel.autosuggest) {
                        options += "<div value='" + data[i][IndexJL] + "' name='SelectOptionList' style='padding: 1px; padding-left:3px;" + (listboxModel.selectedkey == data[i][1] ? "background-color:#3169C6;color:#FFFFFF" : "") + "'>" + data[i][1 + IndexJL] + "</div>";
                    }
                }
                value = value || listboxModel.selectedkey || "";
                
                var style = "line-height:16px !important;width:50%;padding-left:2px;font: inherit;border:0px;float:left;" + (!listboxModel.editableareaskin ? "background:transparent;" : "");
                htmlString = "<div " + $KW.Utils.getBaseHtml(listboxModel, context) + "style='position: relative;' class='" + computedSkin + "'><input class='" + listboxModel.editableareaskin + "'" + " style='" + style + "' type='text' value='" + value + "'" + ((listboxModel.length) ? " maxlength='" + listboxModel.length + "'" : "") + "/><img name='SelectImage' src='" + $KU.getImageURL("select_arrow.gif") + "' onmouseover='$KW.ListBox.toggleSelection(arguments[0])' onmouseout='$KW.ListBox.toggleSelection(arguments[0])' style='position: absolute; right:0px; height: 100%;' onload='$KW.ListBox.adjustWidthOnLoad(arguments[0])'/>";
                style = "position: absolute;z-index: 10;display:none;text-align:left;left:-1px;";
                htmlString += "<div id='" + listboxModel.pf + "_" + listboxModel.id + "_options' name='SelectOptionsList' class='" + cwt + " " + (listboxModel.skin || "") + "' style='overflow:auto;max-height:150px;" + style + "' onmouseover='this.parentNode.firstChild.blur();$KW.ListBox.toggleSelection(arguments[0])'>" + options + "</div>";
                htmlString += "</div>";
                return htmlString;
            }
            
            var align = listboxModel.contentalignment == constants.CONTENT_ALIGN_MIDDLE_RIGHT ? " dir='rtl'" : '';
            htmlString = "<select" + align + $KW.Utils.getBaseHtml(listboxModel, context) + "class='" + computedSkin + "' " + (listboxModel.disabled ? "disabled='true' " : "") + multiple + size + " style='" + $KW.skins.getBaseStyle(listboxModel, context) + "'";
            htmlString += ">";

            if(data.length > IndexJL) {
                listboxModel.selectedkey && $KW.Utils.setSelectedValueProperty(listboxModel, data, "selectedkey");
                listboxModel.selectedkeys && $KW.Utils.setSelectedValueProperty(listboxModel, data, "selectedkeys");
                if(listboxModel.needsectionheaders) {
                    htmlString += this.generateGroupOptions(listboxModel, data);
                } else {
                    htmlString += this.generateOptions(listboxModel, data);
                }
            }
            htmlString += "</select>";
            return htmlString;
        },

        generateGroupOptions: function(listboxModel, data) {
            var htmlString = "";
            for(var i = 1; i < data.length; i++) {
                if(data[i][1] != null && $KU.isArray(data[i][2])) {
                    htmlString += "<optgroup label='" + data[i][1] + "' class='" + (listboxModel.sectionskin || "") + "'>";
                    htmlString += this.generateOptions(listboxModel, data[i][2]);
                    htmlString += "</optgroup>";
                }
            }
            return htmlString;
        },

        generateOptions: function(listboxModel, data) {
            var htmlString = "";
            if(data.length > IndexJL) {
                var key = listboxModel.selectedkey;
                listboxModel.selectedkey = key ? key : data[IndexJL][IndexJL]; 
                $KW.Utils.setSelectedValueProperty(listboxModel, data, "selectedkey");
            }
            var selected = false;
            for(var i = IndexJL; i < data.length; i++) {
                if(data[i][IndexJL] != null) {
                    if(listboxModel.multiple)
                        selected = (listboxModel.selectedkeys && $KU.inArray(listboxModel.selectedkeys, data[i][IndexJL])[0]) ? "selected" : "";
                    else
                        selected = (listboxModel.selectedkey && listboxModel.selectedkey == data[i][IndexJL]) ? "selected" : "";
                    var ariaString = $KU.getAccessibilityValues(listboxModel, data[i][2 + IndexJL], data[i][IndexJL]);
                    htmlString += "<option value=\"" + data[i][IndexJL] + "\" " + selected + ariaString + ">" + $KU.escapeHTMLSpecialEntities(data[i][1 + IndexJL]) + "</option>";
                }
            }
            return htmlString;
        },

        printFunctionality: function(listboxModel, target, data) {
            var inputElements = target.childNodes;
            for(var i = 0; i < inputElements.length; i++) {
                inputElements[i].removeAttribute("selected");
            }

            if(listboxModel.multiple) {
                for(var j = 0; j < listboxModel.selectedkeys.length; j++) {
                    for(var i = 0; i < inputElements.length; i++) {
                        var selectElement = (listboxModel.selectedkeys[j] == data[i][0]) ? "selected" : "";
                        if(selectElement == "selected") {
                            target.childNodes[i].setAttribute("selected", "");
                            break;
                        }
                    }
                }
            } else {
                for(var i = 0; i < inputElements.length; i++) {
                    var selectElement = (listboxModel.selectedkey == data[i][0]) ? "selected" : "";
                    if(selectElement == "selected") {
                        target.childNodes[i].setAttribute("selected", "");
                        break;
                    }
                }
            }
        },

        eventHandler: function(eventObject, target, srcElement) {
            var listboxModel = $KU.getModelByNode(target);
            if(!listboxModel) {
                return
            }

            
            if(eventObject.type == 'click' && target.tagName == "SELECT") {
                return;
            }
            var data = $KW.Utils.getMasterData(listboxModel);

            $KAR && $KAR.sendRecording(listboxModel, 'selectItem', {selection: target.value, 'target': target, 'eventType': 'uiAction'});
            if(target.getAttribute("kcontainerID")) {

                
                $KW.ListBox.updateListboxKey(listboxModel, target);
                $KU.callTargetEventHandler(listboxModel, target, 'onselection');
            }
            else {

                if(listboxModel.viewtype == "editableview") {
                    $KW.ListBox.setSelectedKeysEditableListBox(listboxModel, target, eventObject);
                }
                else {
                    $KW.ListBox.updateListboxKey(listboxModel, target);
                    $KW.ListBox.printFunctionality(listboxModel, target, data);

                    $KW.Utils.setSelectedValueProperty(listboxModel, data, "selectedkey");
                    $KW.Utils.setSelectedValueProperty(listboxModel, data, "selectedkeys");
                    $KW.ListBox.processListBoxEvents(listboxModel, target);
                }

            }
        },

        updateListboxKey: function(listboxModel, target) {
            var selectedkeys = (IndexJL == 1 ? [null] : []);
            if(target.tagName == 'SELECT') {
                for(var i = 0; i < target.options.length; i++) {
                    if(target.options[i].selected) {
                        listboxModel.selectedkey = target.options[i].value;
                        selectedkeys.push(target.options[i].value);
                    }
                }
            }
            listboxModel.selectedkeys = selectedkeys;
        },

        processListBoxEvents: function(widgetModel, widgetNode) {

            if(widgetNode.tagName == 'SELECT'
            || widgetNode.tagName == 'DIV') {
                var listboxHandlr = $KU.returnEventReference(widgetModel.ondone || widgetModel.onselection);
                spaAPM && spaAPM.sendMsg(widgetModel, 'onselection');
                
                if(listboxHandlr) {
                    $KU.executeWidgetEventHandler(widgetModel, listboxHandlr);
                    $KU.onEventHandler(widgetModel);
                }
            }

        },
        setSelectedKeysEditableListBox: function(widgetModel, widgetNode, eventRef) {
            var srcEle = eventRef.srcElement,
                instanceId = widgetNode.id + "_autoComplete",
                key,
                instance = null,
                optionsDiv = widgetNode.children[2],
                data = $KW.Utils.getMasterData(widgetModel);

            instanceId = module.createEditableListInstance(widgetNode, instanceId);
            instance = $KG[instanceId];
            if(srcEle.tagName == 'IMG') {
                if(optionsDiv.style.display == 'block') {
                    instance.hideDropdown();
                } else {
                    if(widgetModel.autosuggest) {
                        instance.renderDropdown(data);
                    }
                    instance.showDropdown(widgetNode);
                    module.setSelectedSkin(widgetModel, optionsDiv.children);
                }
            } else if(srcEle.getAttribute("name") == 'SelectOptionList') {
                key = srcEle.getAttribute("value");
                widgetNode.children[0].value = srcEle.innerText || srcEle.textContent;
                srcEle.style.backgroundColor = "#3169C6";
                srcEle.style.color = "#FFFFFF";
                instance.hideDropdown();
                widgetModel["selectedkeyvalue"] = IndexJL ? [null, key, srcEle.innerText || srcEle.textContent] : [key, srcEle.innerText || srcEle.textContent];
                widgetModel.selectedkey = key;
                $KW.ListBox.processListBoxEvents(widgetModel, widgetNode);
            } else { 
                if(eventRef.type == "click") {
                    instance.hideDropdown();
                }
                key = srcEle.value;
                widgetModel["selectedkeyvalue"] = IndexJL ? [null, key, key] : [key, key];
                widgetModel.selectedkey = key;
            }

        },


        adjustHeight: function(list) {
            list.style.height = list.childNodes[0].offsetHeight + 'px';
        },

        adjustWidth: function(listboxModel, list) {
            if(listboxModel && listboxModel.viewtype == "editableview") {
                var pWidth = list.clientWidth;
                var imgWidth = list.children[1].clientWidth;
                if(pWidth && imgWidth)
                    list.firstChild.style.width = ((pWidth - imgWidth) / pWidth) * 100 + '%';
            }
        },

        adjustWidthOnLoad: function(event) {
            var event = event || window.event;
            var target = event.currentTarget || event.srcElement;
            var list = target.parentNode;
            var listboxModel = $KU.getModelByNode(list);
            module.adjustWidth(listboxModel, list);
        },

        setSelectedSkin: function(model, options) {
            for(var i = 0; i < options.length; i++) {
                if(model.selectedkeyvalue && options[i].innerHTML == model.selectedkeyvalue[1]) {
                    options[i].style.backgroundColor = "#3169C6";
                    options[i].style.color = "#FFFFFF";
                } else {
                    options[i].style.backgroundColor = "";
                    options[i].style.color = "";
                }
            }
        },

        toggleSelection: function(event) {
            var event = event || window.event;
            var target = event.currentTarget || event.srcElement;
            if(target.tagName == "IMG") {
                if(event.type == "mouseover") {
                    target.src = $KU.getImageURL("select_arrow_hover.gif");
                } else {
                    target.src = $KU.getImageURL("select_arrow.gif");
                }
            } else {
                var optionsDiv = target;
                var listboxModel = $KU.getModelByNode(optionsDiv.parentNode);
                var options = optionsDiv.children;
                for(var i = 0; i < options.length; i++) {
                    if(listboxModel.selectedkeyvalue && options[i].innerHTML == listboxModel.selectedkeyvalue[1 + IndexJL]) {
                        options[i].style.backgroundColor = "";
                        options[i].style.color = "";
                    }
                }
            }
        }
    };

    module.autocomplete = function(el, options) {
        this.textBox = el.childNodes[0];
        this.dropDown = el.childNodes[2];
        if(options && options.model.autosuggest) {
            for(var i in options) this[i] = options[i];
            kony.events.addEventListener(el, 'keyup', this.handleEvent.bind(this));
            kony.events.addEventListener(el, 'keydown', this.handleEvent.bind(this));
        }
    };

    module.autocomplete.prototype = {
        handleEvent: function(e) {
            e = e || window.event;
            var list = e.target.parentNode;
            var that = this;
            switch(e.type) {
                case "keydown":
                    that.onKeyDown(e, list);
                    break;
                case "keyup":
                    that.onKeyUp(e, list);
                    break;
            }
        },

        onKeyDown: function(event, list) {
            if(!event) event = window.event;

            var keyCode = event.keyCode;
            switch(keyCode) {
                case 38: 
                    this.moveUp(list);
                    break;
                case 40: 
                    this.moveDown(list);
                    break;
            }
        },

        onKeyUp: function(event, list) {
            if(!event) event = window.event;

            var keyCode = event.keyCode;
            if((keyCode >= 33 && keyCode < 46) || (keyCode >= 112 && keyCode <= 123)) {
                
            } else if(keyCode == 13 || keyCode == 27) { 
                this.dropDown.style.display = "none";
            } else {
                this.showOptions(list);
            }
        },

        showOptions: function(list) {
            var txt = this.textBox.value;
            this.cur = -1;
            if(txt.length > 0) {
                var matches = this.getMatches(txt);
                if(matches.length > IndexJL) {
                    this.renderDropdown(matches);
                    this.showDropdown(list);
                } else {
                    this.dropDown.innerHTML = "";
                    this.hideDropdown();
                }
            } else {
                
                var matches = $KW.Utils.getMasterData(this.model);
                if(matches.length > IndexJL) {
                    this.renderDropdown(matches);
                    this.showDropdown(list);
                }
            }
        },

        renderDropdown: function(matches) {
            while(this.dropDown.hasChildNodes()) {
                this.dropDown.removeChild(this.dropDown.firstChild);
            }
            for(var i = IndexJL; i < matches.length; i++) {
                var oNew = document.createElement('div');
                oNew.innerHTML = "<div value='" + matches[i][IndexJL] + "' name='SelectOptionList' style='padding: 1px; padding-left:3px;" + (this.model.selectedkey == matches[i][IndexJL] ? "background-color:#3169C6;color:#FFFFFF" : "") + "'>" + matches[i][1 + IndexJL] + "</div>";
                this.dropDown.appendChild(oNew.firstChild);
            }
        },

        getMatches: function(str) {
            var matches = IndexJL ? [null] : [];
            this.model.selectedkey = null;
            
            var data = $KW.Utils.getMasterData(this.model);
            if(data && data.length > IndexJL) {
                for(var i = IndexJL; i < data.length; i++) {
                    if(data[i][1 + IndexJL].toLowerCase().indexOf(str.toLowerCase()) == 0) { 
                        matches.push(IndexJL ? [null, data[i][IndexJL], data[i][1 + IndexJL]] : [data[i][IndexJL], data[i][1 + IndexJL]]);
                        if(str == data[i][1 + IndexJL]) {
                            this.model.selectedkey = data[i][IndexJL];
                        }
                    }
                }
            }
            return matches;
        },

        moveUp: function(list) {
            this.showDropdown(list);
            var options = this.dropDown.childNodes;
            if(options.length > 0 && this.cur > 0) {
                --this.cur;
                this.setSelectedValue(options);
            }
        },

        moveDown: function(list) {
            this.showDropdown(list);
            var options = this.dropDown.childNodes;
            if(options.length > 0 && this.cur < (options.length - 1)) {
                ++this.cur;
                this.setSelectedValue(options);
            }
        },

        setSelectedValue: function(options) {
            for(var i = 0; i < options.length; i++) {
                if(i == this.cur) {
                    options[i].style.backgroundColor = "#3169C6";
                    options[i].style.color = "#FFFFFF";
                    this.textBox.value = options[i].innerHTML;
                    this.model.selectedkey = options[i].getAttribute("value");
                    this.model.selectedkeyvalue = IndexJL ? [null, this.model.selectedkey, this.textBox.value] : [this.model.selectedkey, this.textBox.value];
                } else {
                    options[i].style.backgroundColor = "";
                    options[i].style.color = "";
                }
            }
        },

        showDropdown: function(list) {
            module.adjustHeight(list);
            this.dropDown.style.top = (list.offsetHeight - 1) + 'px';
            this.dropDown.style.width = list.offsetWidth + 'px';
            this.dropDown.style.display = "block";
            this.dropDown.parentNode.parentNode.style.overflow = "visible";
        },

        hideDropdown: function() {
            this.dropDown.style.display = "none";
            this.dropDown.parentNode.parentNode.style.overflow = "hidden";
        }
    };


    return module;
}());


$KW.TextArea = (function() {
    
    

    var module = {
        initialize: function() {
            kony.events.addEvent("change", "TextArea", this.eventHandler);
            kony.events.addEvent("keyup", "TextArea", this.keyUpEventHandler);
            kony.events.addEvent("keydown", "TextArea", this.keyDownEventHandler);
            kony.events.addEvent("input", "TextArea", this.textAreaInputEventHandler);
        },

        updateView: function(widgetModel, propertyName, propertyValue, oldPropertyValue) {
            var element = $KU.getNodeByModel(widgetModel);
            if(!element)
                return;
            element = $KW.Utils.getClonedTemplateNode(element, widgetModel, propertyName);

            switch(propertyName) {
                case "text":
                    if(propertyValue) {
                        element.value = propertyValue;
                        propertyValue && $KU.removeClassName(element, 'konyplaceholder');
                    } else {
                        element.value = "";
                    }
                    $KW.TextField.setPlaceholder(widgetModel, element);
                    break;

                case "maxtextlength":
                case "length":
                    element.maxLength = propertyValue;
                    break;

                case "placeholder":
                    element.setAttribute("placeholder", propertyValue);
                    $KW.TextField.setPlaceholder(widgetModel, element);
                    break;

                case "placeholderskin":
                    if($KG.appbehaviors[constants.API_LEVEL] >= constants.API_LEVEL_8200) {
                        element.setAttribute("kplaceholderskin", propertyValue);
                    }

                    break;

                case "numberofvisiblelines":
                    element.setAttribute("rows", propertyValue);
                    break;

                    
                case "numberofrows":
                    element.setAttribute("rows", propertyValue);
                    break;

                case "mode":
                case "textinputmode":
                    if(propertyValue == constants.TEXTAREA_INPUT_MODE_ANY)
                        element.setAttribute("type", "text");
                    else if(propertyValue == constants.TEXTAREA_INPUT_MODE_NUMERIC)
                        element.setAttribute("type", "number");
                    break;

                case "autocapitalize":
                    var value = propertyValue;
                    if($KU.isiPhone && parseInt($KU.getPlatformVersion("iphone")) <= 4 && propertyValue != constants.TEXTAREA_AUTO_CAPITALIZE_NONE) {
                        value = 'on';
                    }
                    element.setAttribute("autocapitalize", value);
                    var transform = $KU.getTextTrasform(widgetModel)
                    transform && (element.style.textTransform = transform);
                    break;

                case "keyboardtype":
                case "keyboardstyle":
                    (textModel.mode != "P") && element.setAttribute("type", propertyValue);
                    break;
            }
        },

        render: function(textAreaModel, context) {
            if(typeof textAreaModel.mode == 'undefined') textAreaModel.mode = textAreaModel.textinputmode;
            var computedSkin = $KW.skins.getWidgetSkinList(textAreaModel, context);
            var phstyle = '';
            var placeholderSkin = textAreaModel.placeholderskin;
            if(placeholderSkin && $KG.appbehaviors[constants.API_LEVEL] >= constants.API_LEVEL_8200) {
                phstyle += "kplaceholderskin = " + placeholderSkin;
            }
            switch(textAreaModel.mode) {
                case constants.TEXTAREA_INPUT_MODE_NUMERIC:
                    type = "number";
                    break;
                default:
                    type = "text";
            }
            if(textAreaModel.keyboardtype) {
                switch(textAreaModel.keyboardtype) {
                    case constants.TEXTAREA_KEY_BOARD_STYLE_EMAIL:
                        type = "email";
                        break;
                    case constants.TEXTAREA_KEY_BOARD_STYLE_URL:
                        type = "url";
                        break;
                    case constants.TEXTAREA_KEY_BOARD_STYLE_CHAT:
                        type = "chat";
                        break;
                    case constants.TEXTAREA_KEY_BOARD_STYLE_DECIMAL:
                    case constants.TEXTAREA_KEY_BOARD_STYLE_NUMBER_PAD:
                        type = "number";
                        break;
                    case constants.TEXTAREA_KEY_BOARD_STYLE_PHONE_PAD:
                        type = "tel";
                        break;
                }
            }
            var text = textAreaModel.text;
            if(!('placeholder' in document.createElement('input'))) {
                computedSkin += ((textAreaModel.placeholder && !textAreaModel.text) ? " konyplaceholder " : "");
                text = text || textAreaModel.placeholder || "";
            }
            var style = $KW.skins.getBaseStyle(textAreaModel, context) + $KU.cssPrefix + "text-security:" + (textAreaModel.securetextentry ? "circle;" : "none;") + "resize:none; " + (context.layoutDir && context.ispercent === false ? ";float:" + context.layoutDir : "");

            style += ";text-align:" + $KW.skins.getContentAlignment(textAreaModel) + ";";
            var transform = $KU.getTextTrasform(textAreaModel);
            style += transform ? 'text-transform:' + transform + ';' : '';

            var htmlString = "<textarea" + $KW.Utils.getBaseHtml(textAreaModel, context) + phstyle + " " + "class = '" + computedSkin + "'" + " cols='15' rows='" + textAreaModel.numberofvisiblelines + "' maxlength='" + textAreaModel.maxtextlength + "' style='" + style + "' type = '" + type + "' " + " autocapitalize='" + textAreaModel.autocapitalize + "'";

            if(textAreaModel.maxtextlength && $KU.isIE)
                htmlString += " onpaste='return $KW.TextArea.handlepaste(event, this);' onkeypress='return $KW.TextArea.imposeMaxLength(event, this);'";

            htmlString += " onfocus='$KW.TextField.onfocusEventHandler(arguments[0],this)' onblur='$KW.TextField.onblurEventHandler(arguments[0],this)' ";
            htmlString += (textAreaModel.placeholder) ? " placeholder='" + $KU.escapeHTMLSpecialEntities(textAreaModel.placeholder) + "'" : "";

            htmlString += ">" + text + "</textarea>";
            return htmlString;
        },

        onblurEventHandler: function(eventObject, target) {
            var textModel = $KU.getModelByNode(target);
            textModel && $KU.onHideKeypad(textModel);
        },

        eventHandler: function(eventObject, target) {
            var textModel = $KU.getModelByNode(target);
            if(textModel) {
                textModel.canUpdateUI = false;
                textModel.text = target.value;
                textModel.canUpdateUI = true;
                spaAPM && spaAPM.sendMsg(textModel, 'ontextchange');
                var textref = $KU.returnEventReference(textModel.ontextchange);
                $KU.callTargetEventHandler(textModel, target, 'ontextchange');
                textref && $KU.onEventHandler(textModel);
            }
        },

        textAreaInputEventHandler: function(eventObject, target) {
            var textModel = $KU.getModelByNode(target);

            $KAR && $KAR.sendRecording(textModel, 'enterText', {'text': target.value, 'target': target, 'eventType': 'uiAction'});
            if(target.getAttribute("kcontainerID")) {
                $KW.Utils.updateContainerData(textModel, target, false, "input");
            } else {
                $KW.Utils.restrictCharactersSet(target, textModel);
            }
        },

        keyUpEventHandler: function(eventObject, target) {
            var textModel = $KU.getModelByNode(target);

            if(textModel) {
                textModel.canUpdateUI = false;
                textModel.text = target.value;
                textModel.canUpdateUI = true;
            }

            if(eventObject.keyCode == 10 || eventObject.keyCode == 13) {
                spaAPM && spaAPM.sendMsg(textModel, 'ondone');
                if(textModel.ondone && textModel) {
                    var textref = $KU.returnEventReference(textModel.done || textModel.ondone);
                    $KU.callTargetEventHandler(textModel, target, 'ondone');
                    textref && $KU.onEventHandler(textModel);
                }
            }
            spaAPM && spaAPM.sendMsg(textModel, 'onkeyup');
            $KU.callTargetEventHandler(textModel, target, 'onkeyup');
        },

        keyDownEventHandler: function(eventObject, target) {
            var textModel = $KU.getModelByNode(target);
            spaAPM && spaAPM.sendMsg(textModel, 'onkeydown');
            $KU.callTargetEventHandler(textModel, target, 'onkeydown');
        }

        , handlepaste: function(event, textareaObj) {
            if(!event)
                event = window.event;
            var model = $KU.getModelByNode(textareaObj);
            var maxLen = model.maxtextlength;
            if(maxLen) {
                var data = window.clipboardData.getData("Text");
                data = textareaObj.innerHTML + data;
                if(data.length > maxLen) {
                    textareaObj.innerHTML = data.substring(0, maxLen);
                    return false;
                }
                return true;
            }
        },

        imposeMaxLength: function(event, element) {
            if(!event)
                event = window.event;
            var model = $KU.getModelByNode(element);
            var maxLen = model.maxtextlength;
            return(element.value.length < maxLen) || (event.keyCode == 8 || event.keyCode == 46 || (event.keyCode >= 35 && event.keyCode <= 40))
        }

    };


    return module;
}());


$KW.CheckBoxGroup = (function() {
    
    

    var module = {
        initialize: function() {
            kony.events.addEvent("change", "CheckBoxGroup", this.eventHandler);
        },

        updateView: function(widgetModel, propertyName, propertyValue, oldPropertyValue) {
            var element = $KU.getNodeByModel(widgetModel);
            element = $KW.Utils.getClonedTemplateNode(element, widgetModel, propertyName);
            switch(propertyName) {
                case "masterdatamap":
                case "masterdata":
                    var data = $KW.Utils.getMasterData(widgetModel);
                    widgetModel.selectedkeys && $KW.Utils.setSelectedValueProperty(widgetModel, data, "selectedkeys");
                    if(element) {
                        element.innerHTML = this.generateList(widgetModel, data, widgetModel.context);
                        $KU.toggleVisibilty(element, data, widgetModel);
                    }
                    break;

                case "selectedkeys":
                    var choices = document.querySelectorAll("#" + widgetModel.pf + " input[name='" + widgetModel.id + "']");
                    if(choices.length > 0) {
                        for(var i = 0; i < choices.length; i++) {
                            if($KU.inArray(widgetModel.selectedkeys, choices[i].value)[0])
                                choices[i].checked = true;
                            else
                                choices[i].checked = false;
                        }
                        $KW.Utils.setSelectedValueProperty(widgetModel, $KW.Utils.getMasterData(widgetModel), "selectedkeys");
                    }
                    break;

                case "viewtype":
                    widgetModel.propertyName = propertyValue;
                    var data = $KW.Utils.getMasterData(widgetModel);
                    if(element) {
                        element.innerHTML = this.generateList(widgetModel, data, widgetModel.context);
                        $KU.toggleVisibilty(element, data, widgetModel);
                    }
                    break;

                case "checkedimage":
                    var data = $KW.Utils.getMasterData(widgetModel);
                    if(element) {
                        element.innerHTML = this.generateList(widgetModel, data, widgetModel.context);
                        $KU.toggleVisibilty(element, data, widgetModel);
                    }
                    break;

                case "uncheckedimage":
                    var data = $KW.Utils.getMasterData(widgetModel);
                    if(element) {
                        element.innerHTML = this.generateList(widgetModel, data, widgetModel.context);
                        $KU.toggleVisibilty(element, data, widgetModel);
                    }
                    break;
                case "size":
                    var data = $KW.Utils.getMasterData(widgetModel);
                    if(element) {
                        element.innerHTML = this.generateList(widgetModel, data, widgetModel.context);
                        $KU.toggleVisibilty(element, data, widgetModel);
                    }
                    break;
            }
        },

        render: function(checkBoxModel, context) {

            if(checkBoxModel.itemorientation)
                checkBoxModel.orientation = checkBoxModel.itemorientation;

            var data = $KW.Utils.getMasterData(checkBoxModel);
            var computedSkin = $KW.skins.getWidgetSkinList(checkBoxModel, context, data);

            var htmlString = "<div" + $KW.Utils.getBaseHtml(checkBoxModel, context) + "class = '" + computedSkin + "' style='" + $KW.skins.getBaseStyle(checkBoxModel, context) + (context.ispercent === false ? "display:inline-block" : "") + "'>";

            checkBoxModel.context = context;

            if(checkBoxModel.viewtype == "tableview" || checkBoxModel.viewtype == "toggleview") {
                htmlString += this.renderViews(checkBoxModel, data, context);
            } else {
                htmlString += this.generateList(checkBoxModel, data, context);
            }

            htmlString += "</div>";
            return htmlString;
        },

        renderViews: function(checkBoxModel, data, context) {
            var htmlString = "";
            if(data.length > IndexJL) {
                checkBoxModel.selectedkeys && $KW.Utils.setSelectedValueProperty(checkBoxModel, data, "selectedkeys");

                if(checkBoxModel.viewtype == "toggleview")
                    htmlString += "<div class='ktable kwt100' style='border: 1px solid gray; border-radius: 10px; overflow: hidden; '>"

                for(var i = IndexJL; i < (data.length); i++) {
                    if(data[i][IndexJL] != null && data[i][1 + IndexJL] != null) {
                        var selected = (checkBoxModel.selectedkeys && $KU.inArray(checkBoxModel.selectedkeys, data[i][IndexJL])[0]) ? "checked" : "";
                        var alignment = "middleleftalign"; 
                        if(checkBoxModel.viewtype == "tableview") {
                            htmlString += "<div style = 'background: red; border: none; height: auto;' class =' kwt100 middleleftalign " + checkBoxModel.skin + "' >";
                            var imgsrc;
                            if(selected == "checked") {
                                imgsrc = "url(" + $KU.getImageURL(checkBoxModel.checkedimage) + ")"
                            } else {
                                imgsrc = "url(" + $KU.getImageURL(checkBoxModel.uncheckedimage) + ")"
                            };

                            htmlString += "<input style='display : none;' id ='" + checkBoxModel.id + "_label" + i + "' class='" + alignment + "' kformname='" + checkBoxModel.pf + "' kwidgettype='" + checkBoxModel.wType + "' type='checkbox' " + selected + ($KW.Utils.isWidgetDisabled(checkBoxModel, context) ? " disabled='true'" : "") + " value='" + data[i][IndexJL] + "' name='" + checkBoxModel.id + "' style='  margin-right:3px;' />";

                            htmlString += "<label class='kwt90'  name = '" + checkBoxModel.id + "_label' style=' position: relative; padding-left: 5px; vertical-align: middle; display: inline-block;'>"
                            htmlString += data[i][1 + IndexJL];
                            htmlString += "</label>"

                            htmlString += "<label class='kwt10 middlecenteralign' selected ='" + selected + "'  for ='" + checkBoxModel.id + "_label" + i + "'  name = '" + checkBoxModel.id + "_label' style=' background-image: " + imgsrc + "; width: " + checkBoxModel.size + "px; height: " + checkBoxModel.size + "px; -webkit-background-size: 100%; background-size:100%; margin-right: 3px; margin-botom: 2px; vertical-align: middle; display: inline-block; '></label>"
                            htmlString += "</div>";
                            htmlString += "<div style='border-top: 1px solid gray'></div>";
                        } else if(checkBoxModel.viewtype == "toggleview") {
                            htmlString += "<div style = '  margin-right: 2px; border-right: 1px solid gray; height: auto;' class =' kcell  middlecenteralign " + checkBoxModel.skin + "' >";

                            htmlString += "<input style='display : none;' id ='" + checkBoxModel.id + "_label" + i + "' class='" + alignment + "' kformname='" + checkBoxModel.pf + "' kwidgettype='" + checkBoxModel.wType + "' type='checkbox' " + selected + ($KW.Utils.isWidgetDisabled(checkBoxModel, context) ? " disabled='true'" : "") + " value='" + data[i][IndexJL] + "' name='" + checkBoxModel.id + "' style='  margin-right:3px;' />";

                            htmlString += "<label class='' for ='" + checkBoxModel.id + "_label" + i + "'   name = '" + checkBoxModel.id + "_label' style=' position: relative; padding-left: 5px; vertical-align: middle; display: inline-block;'>"
                            htmlString += data[i][1 + IndexJL];
                            htmlString += "</label>"

                            htmlString += "</div>";
                        }
                    }
                }
                if(checkBoxModel.viewtype == "toggleview")
                    htmlString += "</div>"
            }
            return htmlString;
        },

        generateList: function(checkBoxModel, data, context) {
            var htmlString = "";
            if(data.length > IndexJL) {
                checkBoxModel.selectedkeys && $KW.Utils.setSelectedValueProperty(checkBoxModel, data, "selectedkeys");

                for(var i = IndexJL; i < (data.length); i++) {
                    if(data[i][IndexJL] != null && data[i][1 + IndexJL] != null) {
                        var selected = (checkBoxModel.selectedkeys && $KU.inArray(checkBoxModel.selectedkeys, data[i][IndexJL])[0]) ? "checked" : "";
                        var alignment = "middlecenteralign"; 

                        if(checkBoxModel.viewtype == "customview") {
                            if(checkBoxModel.itemorientation == constants.CHECKBOX_ITEM_ORIENTATION_VERTICAL) {
                                htmlString += "<div style = 'height: auto;" + (context.ispercent === false ? "display:inline'" : "' class='kwt100'") + ">";
                            } else {
                                htmlString += "<div style = ' display: inline-block; height: auto;' >";
                            }

                            var imgsrc;
                            if(selected == "checked") {
                                imgsrc = "url(" + $KU.getImageURL(checkBoxModel.checkedimage) + ")";
                            } else {
                                imgsrc = "url(" + $KU.getImageURL(checkBoxModel.uncheckedimage) + ")";
                            };

                            htmlString += "<input style='display : none;' id ='" + checkBoxModel.id + "_label" + i + "' class='" + alignment + "' kformname='" + checkBoxModel.pf + "' kwidgettype='" + checkBoxModel.wType + "' type='checkbox' " + selected + ($KW.Utils.isWidgetDisabled(checkBoxModel, context) ? " disabled='true'" : "") + " value='" + data[i][IndexJL] + "' name='" + checkBoxModel.id + "' style='  margin-right:3px;' />";
                            htmlString += "<label  selected ='" + selected + "'  for ='" + checkBoxModel.id + "_label" + i + "'  name = '" + checkBoxModel.id + "_label' style=' background-image: " + imgsrc + "; width: " + checkBoxModel.size + "px; height: " + checkBoxModel.size + "px; -webkit-background-size: 100%; background-size:100%; margin-right: 3px; margin-botom: 2px; vertical-align: middle; display: inline-block; '></label>"
                            htmlString += "<label   name = '" + checkBoxModel.id + "_label' style=' position: relative; padding-left: 5px; vertical-align: middle; display: inline-block;'>"
                            htmlString += $KU.escapeHTMLSpecialEntities(data[i][1 + IndexJL]);
                            htmlString += (checkBoxModel.itemorientation == constants.CHECKBOX_ITEM_ORIENTATION_VERTICAL) ? "</label><br/></div>" : "</div></label>&nbsp;";
                        } else {
                            var ariaString = $KU.getAccessibilityValues(checkBoxModel, data[i][2 + IndexJL], data[i][IndexJL]);
                            var preventTextReadOut = "";
                            if(ariaString.indexOf('aria-hidden') > 0)
                                preventTextReadOut = " aria-Hidden='true' ";

                            if(checkBoxModel.itemorientation == constants.CHECKBOX_ITEM_ORIENTATION_VERTICAL) {
                                htmlString += "<div " + preventTextReadOut + " style = 'height: auto;" + (context.ispercent === false ? "display:inline'" : "' class='kwt100'") + ">";
                            } else {
                                htmlString += "<div " + preventTextReadOut + "style = ' display: inline-block; height: auto; text-decoration: inherit;' >";
                            }

                            htmlString += "<input class='" + alignment + "' kformname='" + checkBoxModel.pf + "' kwidgettype='" + checkBoxModel.wType + "' type='checkbox' " + selected + ($KW.Utils.isWidgetDisabled(checkBoxModel, context) ? " disabled='true'" : "") + ariaString + " value='" + data[i][IndexJL] + "' name='" + checkBoxModel.id + "' style='margin-right:3px;' />";
                            htmlString += $KU.escapeHTMLSpecialEntities(data[i][1 + IndexJL]);
                            htmlString += (checkBoxModel.itemorientation == constants.CHECKBOX_ITEM_ORIENTATION_VERTICAL) ? "<br/></div>" : "</div>&nbsp;";

                        }
                    }
                }
            }
            return htmlString;
        },

        changeImage: function(target, checkBoxModel) {

            var checksrc = "url(" + $KU.getImageURL(checkBoxModel.checkedimage) + ")";
            if(target.getAttribute("selected") == "checked") {
                target.style.backgroundImage = "url(" + $KU.getImageURL(checkBoxModel.uncheckedimage) + ")";
                target.setAttribute("selected", "");
            } else {
                target.style.backgroundImage = "url(" + $KU.getImageURL(checkBoxModel.checkedimage) + ")";
                target.setAttribute("selected", "checked");
            }
        },

        eventHandler: function(eventObject, target) {

            var checkGrp = target.parentNode.parentNode;
            var checkBoxModel = $KU.getModelByNode(checkGrp);

            if(target.getAttribute("checked") === "")
                target.removeAttribute("checked");
            else
                target.setAttribute("checked", "");

            if(checkBoxModel) {


                if(checkBoxModel.viewtype == "customview") {
                    module.changeImage($KU.getNextSibling(target), checkBoxModel);
                }
                if(checkBoxModel.viewtype == "tableview") {
                    module.changeImage($KU.getNextSibling($KU.getNextSibling(target)), checkBoxModel);
                }
                spaAPM && spaAPM.sendMsg(checkBoxModel, 'onselection');
                if(checkGrp.getAttribute("kcontainerID"))
                    $KW.Utils.updateContainerData(checkBoxModel, target, false);
                else {
                    var keys = checkBoxModel.selectedkeys || (IndexJL == 1 ? [null] : []);
                    $KW.Utils.setSelectedKeys(checkBoxModel, target.checked, keys, target.value);
                    $KW.Utils.setSelectedValueProperty(checkBoxModel, $KW.Utils.getMasterData(checkBoxModel), "selectedkeys");
                    var checkBoxHandlr = $KU.returnEventReference(checkBoxModel.onselection);
                    if(checkBoxHandlr) {
                        $KU.executeWidgetEventHandler(checkBoxModel, checkBoxHandlr);
                        
                        $KU.onEventHandler(checkBoxModel);
                    }
                }
                $KAR && $KAR.sendRecording(checkBoxModel, 'click', {'selection': target.value, 'target': checkGrp, 'eventType': 'uiAction'});
            }
        }
    };


    return module;
}());


$KW.Line = (function() {
    
    

    var module = {
        initialize: function() {
            kony.events.addEvent("onorientationchange", "Line", this.resizeVLines);
        },

        initializeView: function(formId) {
            module.resizeVLines(formId);
        },

        updateView: function(widgetModel, propertyName, propertyValue, oldPropertyValue) {
            var element = $KU.getNodeByModel(widgetModel);
            if(!element)
                return;

            switch(propertyName) {
                case "thickness":
                    if(widgetModel.parent.wType != 'FlexContainer') {
                        if(element.getAttribute("direction") == "V")
                            element.style.width = propertyValue + "px";
                        else
                            element.style.borderTopWidth = propertyValue + "px";
                    }
                    break;
            }
        },

        render: function(lineModel, context) {
            var skins = $KW.skins.getWidgetSkinList(lineModel, context);
            
            var bgColor = (lineModel.skin && this.getColor(lineModel.skin)) || 'black';

            var htmlString;
            if(context.vLine || $KW.FlexUtils.isFlexWidget(lineModel)) {
                var width = context.vLine ? 'width:' + lineModel.thickness + 'px;' : '';
                var height = context.vLine ? 'height:1px;' : '';
                var direction = context.vLine ? 'V' : 'flex';
                htmlString = "<div" + $KW.Utils.getBaseHtml(lineModel, context) + "class='" + skins + "' direction='" + direction + "' style='background-color:" + bgColor + ";" + width + height + "margin:auto;" + $KW.skins.getBaseStyle(lineModel, context) + (context.ispercent === false ? "display:inline-block" : "") + "'></div>"
            } else {
                htmlString = "<div" + $KW.Utils.getBaseHtml(lineModel, context) + "class='" + skins + "' style='border-top:" + lineModel.thickness + "px solid " + bgColor + ";" + $KW.skins.getBaseStyle(lineModel, context) + "'></div>";
            }

            return htmlString;
        },

        resizeVLines: function(formId, orientation) {
            
            var vLineNodes = document.querySelectorAll("#" + formId + " div[kwidgettype='Line'][direction='V']");

            
            if(orientation) {
                for(var i = 0; i < vLineNodes.length; i++) {
                    var vLineNode = vLineNodes[i];
                    vLineNode.style.height = "1px";
                }
            }
            for(var i = 0; i < vLineNodes.length; i++) {
                module.resizeVLine(vLineNodes[i]);
            }
        },

        resizeVLine: function(vLineNode) {
            vLineNode.style.height = 'auto';
            vLineNode.style.height = vLineNode.parentNode.clientHeight + "px";
            vLineNode.parentNode.style.width = vLineNode.style.width;
        },

        applySkin: function(element, skin) {
            var bgColor = (skin && this.getColor(skin)) || "black";
            if(element.getAttribute("direction") == "V" || element.getAttribute("direction") == "flex")
                element.style.backgroundColor = bgColor;
            else
                element.style.borderTopColor = bgColor;

        },

        getColor: function(skin) {
            if(!$KG['line' + skin]) {
                var temp = document.createElement("div");
                temp.className = skin;
                document.body.appendChild(temp);
                $KG['line' + skin] = $KU.getStyle(temp, "color");
                document.body.removeChild(temp);
            }
            return $KG['line' + skin];
        }
    };


    return module;
}());


$KW.Segment = (function() {
    
    var _setModalAttributeToSegmentNodes= function(segmentModel, segmentNode, newChildNodes) {
        var nonModalNodes = [], formModel, popupModelID;

        if(segmentNode.getAttribute('notinmodal') == 'true') {
            formModel = $KG.allforms[segmentModel.pf];
            popupModelID = $KU.getPopupModalID(formModel);
            $KU.nodeIterator(newChildNodes, nonModalNodes, popupModelID);
            if(nonModalNodes.length > 0) {
                $KU.setFlexModalAttribute(nonModalNodes, true);
            }
        }
    };
    

    var module = {
        segmentCounter: 0,

        initialize: function() {
            kony.events.addEvent("click", "Segment", this.eventHandler);
            kony.events.addEvent("onorientationchange", "Segment", this.orientationHandler);
        },

        initializeView: function(formId) {
            
            $KU.setScrollBoxesHeight(formId, "Segment");
            this.initializeAnimations(formId);
            var scrollNodes = document.querySelectorAll("#" + formId + " div[kwidgettype='Segment']");
            $KW.Utils.initializeScrollEvents(scrollNodes);
            $KW.APIUtils.getModelForContentOffset(formId, "Segment");
        },

        initializeAnimations: function(formId) {
            var segments = document.querySelectorAll("#" + formId + " div[kwidgettype='Segment']");
            for(var i = 0; i < segments.length; i++) {
                var segModel = $KU.getModelByNode(segments[i]);
                var listAnimation = segModel && segModel.listAnimation;
                if(listAnimation && !listAnimation.initialized) {
                    listAnimation.init();
                }
            }
        },

        destroyAnimations: function(formId) {
            var segments = document.querySelectorAll("#" + formId + " div[kwidgettype='Segment']");
            for(var i = 0; i < segments.length; i++) {
                var segModel = $KU.getModelByNode(segments[i]);
                var listAnimation = segModel && segModel.listAnimation;
                if(listAnimation) {
                    listAnimation.destroy();
                }
            }
        },

        orientationHandler: function(formId, orientation) {
            
            $KU.setScrollBoxesHeight(formId, "Segment");
            
        },

        adjustFooter: function(formId) {
            var segments = document.querySelectorAll("#" + formId + " div[kwidgettype='Segment']");
            for(var i = 0; i < segments.length; i++) {
                var segmentModel = $KU.getModelByNode(segments[i]);
                var footer = document.getElementById($KW.Utils.getKMasterWidgetID(segmentModel) + "_footer");
                footer && (footer.style.width = window.innerWidth);
            }
        },

        updateView: function(widgetModel, propertyName, propertyValue, oldPropertyValue) {
            var element = $KU.getNodeByModel(widgetModel);
            switch(propertyName) {
                case "skin":
                case "askin":
                case "rowskin":
                case "alternaterowskin":
                    if(element) {
                        if(propertyName == "skin") {
                            var skin = propertyValue;
                            var oldSkin = oldPropertyValue;
                            $KU.removeClassName(element, oldSkin);
                            $KU.addClassName(element, skin);
                            break;
                        }

                        if(widgetModel.hasSections)
                            this.applySectionRowSkin(widgetModel, element);
                        else {
                            element = element.childNodes[0];
                            this.applyRowSkin(widgetModel, element);
                        }

                    }
                    break;

                case "widgetskin":
                    var element = $KW.Utils.getWidgetNode(widgetModel);
                    if(element) {
                        $KU.removeClassName(element, oldPropertyValue || (widgetModel.skin ? widgetModel.skin : ""));
                        $KU.addClassName(element, propertyValue);
                    }
                    break;

                case "sectionskin":
                case "sectionheaderskin":
                    if(widgetModel.hasSections) module.applySectionHeaderSkin(widgetModel, propertyValue);
                    break;

                case "focusedindex":
                case "selectedindex":
                    if(propertyValue && this.isSelectionOutOfBound(widgetModel, propertyValue)) {
                        return;
                    }
                    
                    widgetModel.__y = 0;
                    if(propertyName == "focusedindex") {
                        propertyValue = IndexJL ? [null, 0, propertyValue] : [0, propertyValue];
                    }
                    if(widgetModel.selectionbehavior != constants.SEGUI_DEFAULT_BEHAVIOR &&
                        widgetModel.viewtype != constants.SEGUI_VIEW_TYPE_PAGEVIEW) {
                        var selectedRows = null;
                        widgetModel.selectedRows = (widgetModel.selectedRows) ? widgetModel.selectedRows : (IndexJL) ? [null] : [];
                        if(propertyValue) {
                            if(widgetModel.selectionbehavior == constants.SEGUI_SINGLE_SELECT_BEHAVIOR) {
                                selectedRows = (IndexJL) ? [null, propertyValue] : [propertyValue];
                                var arrayIndex = $KU.arrayIndex(widgetModel.selectedRows, propertyValue);
                                if(arrayIndex != -1) {
                                    selectedRows.splice(arrayIndex, 1);
                                } else {
                                    selectedRows = selectedRows;
                                }
                            } else if(widgetModel.selectionbehavior == constants.SEGUI_MULTI_SELECT_BEHAVIOR) {
                                var arrayIndex = $KU.arrayIndex(widgetModel.selectedRows, propertyValue);
                                if(arrayIndex != -1) {
                                    widgetModel.selectedRows.splice(arrayIndex, 1);
                                } else {
                                    widgetModel.selectedRows.push(propertyValue);
                                }
                                selectedRows = widgetModel.selectedRows;
                            }
                        }
                        selectedRows = (!selectedRows) ? null : (selectedRows.length > IndexJL) ? selectedRows : null;
                        this.setImages(widgetModel, selectedRows);
                    } else if(widgetModel.selectionbehavior == constants.SEGUI_DEFAULT_BEHAVIOR) {
                        widgetModel.selectedRows = (!propertyValue) ? null : (IndexJL) ? [null, propertyValue] : [propertyValue];
                        this.setSelectedItemsAndIndices(widgetModel);
                    }

                    if(widgetModel.viewtype === constants.SEGUI_VIEW_TYPE_PAGEVIEW) {
                        var swipeContext = widgetModel.swipeContext;
                        if(element) {
                            var imgsElement = element.children[0];
                            var findex = propertyValue[IndexJL + 1];
                            if((findex - IndexJL) <= imgsElement.children.length) {
                                swipeContext.currentPage = parseInt(findex) - IndexJL;
                                $KW.touch.scrollImages(imgsElement, swipeContext.imageWidth * swipeContext.currentPage, $KU.swipeDuration, false);
                                $KW.touch.updatePageIndicator(element, swipeContext, widgetModel);
                            }
                        }
                    } else { 
                        if(element && module.isLazyLoadingApplicable(widgetModel) && module.isSegmentVisible(widgetModel)) {
                            module.generateAndAdjustSegmentTillGivenIndexReached(widgetModel, element, widgetModel.selectedindex);
                            module.renderSegmentTillGivenHeight(widgetModel, element, true, module.getHeightByNumberOfPortions(widgetModel, 3));
                        }
                        (propertyValue && element) && this.setFocus(widgetModel, element, propertyValue);
                    }
                    break;

                case "selectedsectionindex":
                    if(widgetModel.hasSections) {
                        var index = IndexJL ? propertyValue : (propertyValue + 1);
                        if(element) {
                            element = document.querySelector("#" + element.id + " ul:nth-child(" + index + ")");
                            element && $KW.APIUtils.setfocus(widgetModel, null, element);
                        }
                    }
                    break;

                case "selectedindices":
                    if(propertyValue) {
                        var selectedRows = (IndexJL) ? [null] : [];
                        for(var i = IndexJL; i < propertyValue.length; i++) {
                            var secIndex = parseInt(propertyValue[i][0 + IndexJL], 10);
                            var rowIndexes = propertyValue[i][1 + IndexJL];
                            for(var j = IndexJL; j < rowIndexes.length; j++) {
                                var selection = (IndexJL) ? [null, secIndex, rowIndexes[j]] : [secIndex, rowIndexes[j]];
                                if(!this.isSelectionOutOfBound(widgetModel, selection)) {
                                    selectedRows.push(selection);
                                }
                            }
                        }
                        if(widgetModel.selectionbehavior != constants.SEGUI_MULTI_SELECT_BEHAVIOR) {
                            selectedRows = (IndexJL) ? [null, selectedRows[selectedRows.length - 1]] : [selectedRows[selectedRows.length - 1]];
                        }
                        selectedRows = (selectedRows.length > IndexJL) ? selectedRows : null;
                    } else {
                        var selectedRows = null;
                    }
                    if(widgetModel.selectionbehavior == constants.SEGUI_DEFAULT_BEHAVIOR) {
                        widgetModel.selectedRows = selectedRows;
                        this.setSelectedItemsAndIndices(widgetModel);
                    } else {
                        this.setImages(widgetModel, selectedRows);
                    }
                    break;

                case "paginationconfig":
                    module.updatePageFooter(widgetModel);
                    break;

                case "septhickness":
                case "separatorthickness":
                case "sepcolor":
                case "separatorcolor":
                case "separatorrequired":
                    if(element) {
                        var thickness = widgetModel.separatorthickness || widgetModel.septhickness;
                        var color = widgetModel.separatorcolor || widgetModel.sepcolor;
                        var querySelector = "[id='" + element.id + "'] li[index" + (widgetModel.hasSections ? "$='-1']" : "]");
                        var nodes = document.querySelectorAll(querySelector);
                        for(var i = 0; i < nodes.length; ++i) {
                            var node = nodes[i];
                            node.style.border = "none";
                            if(!widgetModel.separatorrequired)
                                continue;
                            var r = parseInt(color.substring(0, 2), 16),
                                g = parseInt(color.substring(2, 4), 16),
                                b = parseInt(color.substring(4, 6), 16);
                            var o = 1 - (parseInt(color.substring(6, 8), 16) / 100);
                            node.style.borderBottom = thickness + "px solid rgba(" + r + "," + g + "," + b + "," + o + ")";
                        }
                    }
                    break;

                case "needpageindicator":
                    if(widgetModel.viewtype == constants.SEGUI_VIEW_TYPE_PAGEVIEW) {
                        var element = document.getElementById($KW.Utils.getKMasterWidgetID(widgetModel) + '_footer');
                        if(element) {
                            if(propertyValue)
                                $KU.removeClassName(element, "hide");
                            else
                                $KU.addClassName(element, "hide");
                        }
                    }
                    break;

                case "pageondotimage":
                case "pageoffdotimage":
                    var element = document.getElementById($KW.Utils.getKMasterWidgetID(widgetModel) + '_footer');
                    if(element)
                        element.innerHTML = module.generatePageFooter(widgetModel, (widgetModel.data || []));
                    break;

                case "data":
                    if($KU.isArray(propertyValue)) {
                        this.setData(widgetModel, propertyValue);
                    } else if(propertyValue === null) {
                        widgetModel.selectedRows = widgetModel.data = null;
                        this.setSelectedItemsAndIndices(widgetModel);
                    }
                    break;

                case "viewtype":
                    var element = $KU.getNodeByModel(widgetModel);
                    if(propertyValue != oldPropertyValue && element) {
                        var parent = element.parentNode;
                        if(oldPropertyValue == constants.SEGUI_VIEW_TYPE_PAGEVIEW)
                            parent = parent.parentNode;
                        parent.innerHTML = this.generateSegment(widgetModel, widgetModel.context);
                        element = $KU.getNodeByModel(widgetModel);
                        if(propertyValue == constants.SEGUI_VIEW_TYPE_PAGEVIEW) {
                            widgetModel.selectionbehavior = constants.SEGUI_DEFAULT_BEHAVIOR;
                            $KW.touch.computeWidths(element, widgetModel);
                            var pScrollerInstance = new $KW.touch.pageviewScroller(element, {
                                widgetModel: widgetModel
                            });
                            $KG[element.id] = pScrollerInstance;
                        }
                        this.adjustFlexContainers(widgetModel, 'setdata');
                        $KU.setScrollHeight(widgetModel, element);
                    }
                    break;

                case "selectionbehavior":
                    if(propertyValue != oldPropertyValue) {
                        this.setData(widgetModel, widgetModel.data);
                    }
                    break;

                case "selectionbehaviorconfig":
                    if(propertyValue instanceof Object) {
                        widgetModel.selectionindicator = propertyValue.imageIdentifier || propertyValue.imageidentifier;
                        widgetModel.selectimage = propertyValue.selectedStateImage || propertyValue.selectedstateimage;
                        widgetModel.unselectimage = propertyValue.unselectedStateImage || propertyValue.unselectedstateimage;
                    }

                    if(widgetModel.selectionbehavior != constants.SEGUI_DEFAULT_BEHAVIOR) {
                        this.setData(widgetModel, widgetModel.data);
                    }
                    break;
            }
        },

        setFocus: function(widgetModel, element, selectedindex) {
            var indexStr = (widgetModel.hasSections) ? "secindex='" + selectedindex[0 + IndexJL] + "," + selectedindex[1 + IndexJL] + "'" : "index='" + selectedindex[1 + IndexJL] + "'";
            element = document.querySelector("#" + element.id + " li[" + indexStr + "]");
            element && $KW.APIUtils.setfocus(widgetModel, null, element);
        },

        render: function(segmentModel, context) {
            var ignoreRetainSelection = false;
            var __y = 0;
            
            if(segmentModel.retainscrollpositionmode === constants.SEGUI_SCROLL_POSITION_RETAIN
            || (segmentModel.retainscrollpositionmode == constants.SEGUI_SCROLL_POSITION_TOP && segmentModel.contentOffset)) {
                    ignoreRetainSelection = true;
            }
            if(segmentModel.retainscrollpositionmode === constants.SEGUI_SCROLL_POSITION_RETAIN) {
                __y = segmentModel.__y;
                if(segmentModel.__y >= 0) {
                    
                    setTimeout(function() {
                        $KW.APIUtils.setContentOffSet(segmentModel, {x:0, y:__y}, false);
                    }, 500);
                }
            }
            if(!segmentModel.retainselection) {
                segmentModel.selectedRows = segmentModel.selectedindices = segmentModel.focusedindex = segmentModel.focuseditem = segmentModel.selectedindex = segmentModel.selecteditems = segmentModel.selectedsectionindex = segmentModel.selectedrowindex = segmentModel.selectedrowindices = null;
            } else if(!ignoreRetainSelection) {
                segmentModel.focusedindex = (segmentModel.focusedindex || segmentModel.focusedindex == 0) ? segmentModel.focusedindex : null;
                segmentModel.selectedindex = segmentModel.selectedindex || null;
                segmentModel.focuseditem = segmentModel.focuseditem || null;
                segmentModel.selecteditems = segmentModel.selecteditems || null;
                segmentModel.selectedsectionindex = (segmentModel.selectedsectionindex || segmentModel.selectedsectionindex == 0) ? segmentModel.selectedsectionindex : null;
                segmentModel.selectedindices = segmentModel.selectedindices || null;
                segmentModel.selectedRows = segmentModel.selectedRows || null;
                if(segmentModel.selectedindex && segmentModel.viewtype == constants.SEGUI_VIEW_TYPE_TABLEVIEW) {
                    setTimeout(function() {
                        module.setFocus(segmentModel, $KU.getNodeByModel(segmentModel), segmentModel.selectedindex)
                    }, 500);
                }
            }

            $KU.updateScrollFlag(segmentModel);

            var sConfig = segmentModel.selectionbehaviorconfig;
            if(sConfig && sConfig instanceof Object) {
                segmentModel.selectionindicator = sConfig.imageIdentifier || sConfig.imageidentifier;
                segmentModel.selectimage = sConfig.selectedStateImage || sConfig.selectedstateimage;
                segmentModel.unselectimage = sConfig.unselectedStateImage || sConfig.unselectedstateimage;
            }

            segmentModel.context = context;
            segmentModel.selectedState = false;
            var parentModel = segmentModel.parent;
            if($KW.FlexUtils.isFlexContainer(parentModel))
                segmentModel.layoutConfig.self = true;
            var listAnimation = segmentModel.listAnimation;
            if(listAnimation)
                listAnimation.initialized = false;
            return this.generateSegment(segmentModel, context);
        },

        generateSegment: function(segmentModel, context) {
            var htmlString = "",
                segData = segmentModel.data || [];
            var pageView = (segmentModel.viewtype == constants.SEGUI_VIEW_TYPE_PAGEVIEW) ? true : false;
            segmentModel.selectedsectionindex = IndexJL;
            var isFlexWidget = $KW.FlexUtils.isFlexWidget(segmentModel);
            var visibility = (!isFlexWidget && (!segmentModel.isvisible || segData.length <= IndexJL)) ? "hide" : ""; 
            var skin = segmentModel.skin;
            
            var widgetSkin = (segmentModel.name == "kony.ui.SegmentedUI2") ? (segmentModel.widgetskin ? segmentModel.widgetskin : "") : (skin ? skin : "");
            var computedSkin = visibility + " " + widgetSkin;
            var margin = $KW.skins.getBaseStyle(segmentModel, context);
            var padding = $KW.skins.getPaddingSkin(segmentModel);
            context.topLevelBox = true;
            
            if(pageView) {
                var rowSkin = segmentModel.rowSkin || "";
                var id = segmentModel.pf + "_" + segmentModel.id;
                var kmasterObj = $KW.Utils.getMasterIDObj(segmentModel);
                if(kmasterObj.id != "") {
                    id = kmasterObj.id;
                }

                htmlString += "<div id='" + id + "_wrapper' style='" + margin + ";position:relative' class='" + " " + computedSkin + "' " + kmasterObj.kmasterid + ">";
                htmlString += "<div" + $KW.Utils.getBaseHtml(segmentModel, context);
                htmlString += "name='touchcontainer_Segment' class='kstripcontainer " + rowSkin + "'";
                
                htmlString += ">";
                htmlString += "<div id='imgs' class='kstrip' style='";
                if(!kony.appinit.useTransition) {
                    htmlString += "position:relative";
                }
                htmlString += "'>";
            } else {
                htmlString += "<div" + $KW.Utils.getBaseHtml(segmentModel, context);
                htmlString += "class='" + computedSkin + "' style='" + margin + padding + "'>";
            }

            if(segData.length > IndexJL) {
                if(!pageView) segmentModel.hasSections = $KU.isArray(segData[IndexJL]);
                if(!pageView && segmentModel.hasSections === false) {
                    htmlString += "<ul style='list-style:none'>"
                }

                if(!module.isLazyLoadingApplicable(segmentModel))
                    htmlString += this.generateRows(segmentModel, context, segData, false, IndexJL, IndexJL);
            }

            
            if(pageView) {
                var footer = module.renderPageFooter(segmentModel);
                if(segmentModel.paginationconfig && segmentModel.paginationconfig.position == "top") {
                    htmlString = footer + htmlString;
                    htmlString += "</div></div>";
                } else {
                    htmlString += "</div></div>";
                    htmlString += footer;
                }
                htmlString += '</div>';
            } else {
                if(segmentModel.hasSections === false) { 
                    htmlString += "</ul></div>";
                } else {
                    htmlString += "</div>";
                }
            }
            return htmlString;
        },

        renderPageFooter: function(segmentModel) {
            
            
            var segData = segmentModel.data || [];
            var visibility = (!segmentModel.isvisible || segData.length <= 1 || !segmentModel.needpageindicator) ? "hide" : "";
            
            var position = $KW.FlexUtils.isFlexWidget(segmentModel) ? 'position:absolute;bottom:0px;' : '';
            var footer = "<div class='ktable kwt100 " + visibility + "' style='" + position + module.getPageFooterStyle(segmentModel) + "' id='" + $KW.Utils.getKMasterWidgetID(segmentModel) + "_footer'>" + this.generatePageFooter(segmentModel, segData) + "</div>";
            return footer;
        },

        getPageFooterStyle: function(segmentModel) {
            var segpag = segmentModel.paginationconfig;
            var top = (segpag && segpag.vdistance) || 30,
                left = (segpag && segpag.hdistance) || 0;
            top = (segpag && segpag.position == "top") ? top : -top;
            return segpag ? ("position: relative;z-index: 999;top: " + top + "px; left: " + left + "px;") : "";
        },

        updatePageFooter: function(segmentModel) {
            var footer = document.getElementById($KW.Utils.getKMasterWidgetID(segmentModel) + '_footer');
            if(footer) {
                footer.setAttribute('style', module.getPageFooterStyle(segmentModel));
                var newfooter = footer.cloneNode(true);
                var parentNode = footer.parentNode;
                if(segmentModel.paginationconfig && segmentModel.paginationconfig.position == "top") {
                    parentNode.removeChild(footer);
                    parentNode.insertBefore(newfooter, document.getElementById($KW.Utils.getKMasterWidgetID(segmentModel)));
                }
            }
        },

        
        generateRows: function(model, context, data, liExists, rowIndex, secIndex, isNew) {
            var htmlString = "",
                seperator = "",
                sectionRows = 0,
                color = model.separatorcolor;
            
            var secRowIndex = 0,
                section = null,
                sectionHtml = "",
                rowHtml = "";
            var secSkin = model.sectionheaderskin || model.sectionskin || "",
                rowSkin = "";
            var rskin = model.rowskin || model.skin || "",
                askin = model.alternaterowskin || model.askin || "";
            var headertemplate, boxModel;
            var pageView = (model.viewtype == constants.SEGUI_VIEW_TYPE_PAGEVIEW) ? true : false;
            data = this.invertMapAndData(model, data);
            model.counter = rowIndex;
            var noOfItemsToRemove = (isNew == false) ? 1 : 0;

            if(color && model.separatorrequired) {
                var r = parseInt(color.substring(0, 2), 16),
                    g = parseInt(color.substring(2, 4), 16),
                    b = parseInt(color.substring(4, 6), 16),
                    o = 1 - (parseInt(color.substring(6, 8), 16) / 100);
                var border = model.separatorthickness + "px solid rgba(" + r + "," + g + "," + b + "," + o + ")";
                
                seperator = "background-clip:padding-box;border-bottom:" + border + ";" + (rowIndex > IndexJL ? "border-top:" + border : "") + ";";

            }

            for(var i = IndexJL; i < data.length; i++) {
                this.segmentCounter = i;
                secRowIndex = (!model.hasSections) ? (i - IndexJL) : (data[i].sectionLabel) ? 0 : (secRowIndex + 1);
                rowSkin = (secRowIndex % 2 == 1 && askin) ? askin : rskin;
                if(data[i].metainfo && data[i].metainfo.skin) rowSkin = data[i].metainfo.skin;
                if(data[i].template || model.rowtemplate) {
                    
                    var tabpaneID = context.tabpaneID;
                    context.tabpaneID = "";
                }

                var accessAttr = "";
                var trasform = "";
                section = data[i].sectionLabel;
                if(section || section === "") { 
                    var clonedHeaderTemplate;
                    if(section instanceof Object) { 
                        headertemplate = section.template || model.sectionheadertemplate;
                        if(typeof headertemplate == "string") {
                            headertemplate = _kony.mvc.initializeSubViewController(headertemplate);
                        }
                        $KG.allTemplates[headertemplate.id] = headertemplate;
                        headertemplate.formPathId = model.formPathId;

                        accessAttr = $KU.getAccessibilityValues(model, section.accessibilityConfig, null, rowIndex);
                        if(headertemplate && $KU.getkeys(section).length > 0) {
                            context.topLevelBox = true;
                            context.container = model;
                            if(!headertemplate.pf) {
                                _konyConstNS.Form2.addHeaderorFooter.call(headertemplate, headertemplate);
                            }
                            headertemplate.isTemplate = true; 
                            clonedHeaderTemplate = owl.deepCopy(headertemplate, null, false);

                            
                            $KW.FlexUtils.setRTLtoTemplates(clonedHeaderTemplate);
                            sectionHtml = this.renderFlexContainer(clonedHeaderTemplate, context, section, model, rowIndex, secIndex);

                            if(sectionHtml === "") {
                                sectionHtml = " ";
                            }
                            context.topLevelBox = false;
                            delete context.container;
                            if(clonedHeaderTemplate.transform)
                                trasform = $KW.animUtils.applyTransform(clonedHeaderTemplate, clonedHeaderTemplate.transform);
                        }

                    } else if(section === "") {
                        sectionHtml = " ";
                    } else { 
                        sectionHtml = "<div " + $KW.Utils.getBaseHtml(model, context) + ">" + section + "</div>";
                    }
                    if(sectionHtml) { 
                        if(i == IndexJL) {
                            htmlString += "<ul style='list-style:none'>";
                        } else if(sectionRows == i - IndexJL) {
                            secIndex++;
                            rowIndex = IndexJL;
                            htmlString += "</ul><ul style='list-style:none'>";
                        }

                        sectionRows += model.data[secIndex][1 + IndexJL].length > IndexJL ? model.data[secIndex][1 + IndexJL].length - IndexJL : 1;
                        htmlString += "<li style='" + seperator + (trasform ? $KU.cssPrefix + "transform:" + trasform : "") + ";" + $KW.Utils.getAnchorPoint(clonedHeaderTemplate) + "' class='" + secSkin + " middleleftalign'  index='" + secIndex + ",-1' secindex='" + secIndex + ",-1'>" + sectionHtml + "</li>";
                    }
                    model.clonedTemplates.splice(secIndex, noOfItemsToRemove, [clonedHeaderTemplate ? clonedHeaderTemplate : section, []]);
                }
                
                
                model.seccounter = secIndex;
                model.rowcounter = rowIndex;

                context.topLevelBox = true;
                context.container = model;
                trasform = "";
                boxModel = data[i].template || model.rowtemplate || model;
                if(typeof boxModel == "string") {
                    boxModel = _kony.mvc.initializeSubViewController(boxModel);
                }

                boxModel.formPathId = model.formPathId;
                $KG.allTemplates[boxModel.id] = boxModel;
                if(boxModel) {
                    !boxModel.pf && _konyConstNS.Form2.addHeaderorFooter.call(boxModel, boxModel); 
                }
                boxModel.isTemplate = true;
                var clonedBoxModel = owl.deepCopy(boxModel, null, false);
                
                $KW.FlexUtils.setRTLtoTemplates(clonedBoxModel);
                accessAttr = $KU.getAccessibilityValues(model, data[i].accessibilityConfig, null, rowIndex);
                rowHtml = this.renderFlexContainer(clonedBoxModel, context, data[i], model, rowIndex, secIndex);
                if(data[i].template || model.rowtemplate) context.tabpaneID = tabpaneID; 
                if(typeof attachEvents == "function") {
                    
                }
                if(model.hasSections) {
                    model.clonedTemplates[secIndex][IndexJL + 1].splice(rowIndex, noOfItemsToRemove, clonedBoxModel);
                } else {
                    model.clonedTemplates.splice(rowIndex, noOfItemsToRemove, clonedBoxModel);
                }
                context.topLevelBox = false;
                delete context.container;
                if(clonedBoxModel.transform)
                    trasform = $KW.animUtils.applyTransform(clonedBoxModel, clonedBoxModel.transform);

                if(!liExists && rowHtml) {
                    if(pageView) {
                        htmlString += "<div index=" + rowIndex + " kwidgettype='KTouchsegment' style='display:none;float: left;width:100%'>";
                    } else {
                        var rowSeperator = '';
                        if(i < data.length - 1) {
                            if(model.hasSections && rowIndex != model.data[secIndex][1 + IndexJL].length - 1)
                                rowSeperator = seperator;
                            else if(!model.hasSections)
                                rowSeperator = seperator;
                        }
                        htmlString += "<li kwidgettype='Segment' style='" + rowSeperator + (trasform ? $KU.cssPrefix + "transform:" + trasform : "") + ";" + $KW.Utils.getAnchorPoint(clonedBoxModel) + "' index=" + rowIndex + " class='" + rowSkin + "'" + (model.hasSections ? " secindex='" + secIndex + "," + rowIndex + "'" : "");
                        htmlString += ">";
                    }
                }
                htmlString += rowHtml;
                if(!liExists && rowHtml) htmlString += pageView ? "</div>" : "</li>";
                if(data.length - IndexJL == i && model.hasSections) htmlString += "</ul>";
                rowIndex++;
                model.counter++;
            }
            return htmlString;
        },

        generatePageFooter: function(segmentModel, data) {
            var htmlString = "";
            var src = "";
            var segpag = segmentModel.paginationconfig;
            var left = (segpag && segpag.hdistance) || 0;
            if(data.length > IndexJL) {
                var alignment = !left || (left == 0);
                var htmlattrs = alignment ? "align='center'" : "style='text-align: left;'";
                htmlString += "<div class='krow kwt100' " + htmlattrs + "><div class='kcell'>";
                segmentModel.pageondotimage = segmentModel.pageondotimage || "whitedot.gif";
                segmentModel.pageoffdotimage = segmentModel.pageoffdotimage || "blackdot.gif";
                for(var i = IndexJL; i < data.length; i++) {
                    var isAriaHidden = data[i].accessibilityConfig && data[i].accessibilityConfig.a11yHidden;
                    var hiddenAttr = isAriaHidden ? " aria-hidden='true'" : " ";
                    src = (typeof segmentModel.focusedindex != "number" && i == IndexJL) ? segmentModel.pageondotimage : (segmentModel.focusedindex == i) ? segmentModel.pageondotimage : segmentModel.pageoffdotimage;
                    htmlString += "<span  " + hiddenAttr + " onclick='$KW.touch.navigationDotsHandler(this)' index='" + i + "'><img style='padding-left:4px' src='" + $KU.getImageURL(src) + "' /></span>";
                }
                htmlString += "</div></div>";
            }
            return htmlString;
        },

        
        setData: function(model, data, animObj) {
            if($KU.isArray(data)) {
                if(data.length > IndexJL) {
                    model.hasSections = $KU.isArray(data[IndexJL]);
                    this.modifyContent(model, data, "setdata", null, null, animObj);
                } else {
                    this.removeAll(model);
                }
            } else {
                throw new KonyError(102, "Error", "Invalid input.");
            }
        },

        
        addAll: function(model, data, animObj) {
            if($KU.isArray(data)) {
                if(!$KU.isArray(model.data)) {
                    model.data = (IndexJL) ? [null] : [];
                }
                if(typeof model.hasSections !== "boolean") model.hasSections = $KU.isArray(data[IndexJL]);
                this.modifyContent(model, data, "addall", null, null, animObj);
            } else {
                throw new KonyError(102, "Error", "Invalid input.");
            }
        },

        
        removeAll: function(model, animObj) {
            this.modifyContent(model, IndexJL ? [null] : [], "removeall", null, null, animObj);
        },

        
        removeAt: function(model, rowIndex, secIndex, animObj) {
            if(!isNaN(rowIndex) || (secIndex && !isNaN(secIndex))) {
                if($KU.isArray(model.data) && model.data.length > IndexJL) {
                    this.modifyContent(model, [], "removeat", rowIndex, secIndex, animObj);
                }
            } else {
                throw new KonyError(102, "Error", "Invalid input.");
            }
        },

        
        setDataAt: function(model, data, rowIndex, secIndex, animObj) {
            if(data instanceof Object && (!isNaN(rowIndex) || (secIndex && !isNaN(secIndex)))) {
                if($KU.isArray(model.data) && model.data.length > IndexJL) {
                    this.modifyContent(model, data, "setdataat", rowIndex, secIndex, animObj);
                }
            } else {
                throw new KonyError(102, "Error", "Invalid input.");
            }
        },

        
        addAt: function(model, data, rowIndex, secIndex) {
            if(model.viewtype === constants.SEGUI_VIEW_TYPE_PAGEVIEW && $KU.isArray(data)) {
                throw new KonyError(103, "Error", "Invalid operation.");
            }

            if(data instanceof Object && (!isNaN(rowIndex) || (secIndex && !isNaN(secIndex)))) {
                if(!$KU.isArray(model.data)) {
                    model.data = (IndexJL) ? [null] : [];
                }
                if(typeof model.hasSections !== "boolean") model.hasSections = $KU.isArray(data);
                this.modifyContent(model, data, "addat", rowIndex, secIndex);
            } else {
                throw new KonyError(102, "Error", "Invalid input.");
            }
        },

        
        addDataAt: function(model, data, rowIndex, secIndex, animObj) {
            if(model.viewtype === constants.SEGUI_VIEW_TYPE_PAGEVIEW && $KU.isArray(data)) {
                throw new KonyError(103, "Error", "Invalid operation.");
            }

            if(data instanceof Object && (!isNaN(rowIndex) || (secIndex && !isNaN(secIndex)))) {
                if(!$KU.isArray(model.data)) {
                    model.data = (IndexJL) ? [null] : [];
                }
                if(typeof model.hasSections !== "boolean") model.hasSections = $KU.isArray(data);
                this.modifyContent(model, data, "adddataat", rowIndex, secIndex, animObj);
            } else {
                throw new KonyError(102, "Error", "Invalid input.");
            }
        },

        
        setDataWithSections: function(model, data) {
            if($KU.isArray(data) && $KU.isArray(data[IndexJL])) {
                this.setData(model, data);
            } else {
                throw new KonyError(102, "Error", "Invalid input.");
            }
        },

        
        addSectionAt: function(model, data, secIndex, animObj) {
            if(typeof model.hasSections !== "boolean" && $KU.isArray(data[IndexJL])) model.hasSections = true;

            if(model.hasSections === false || model.viewtype === constants.SEGUI_VIEW_TYPE_PAGEVIEW) {
                throw new KonyError(103, "Error", "Invalid operation.");
            } else if(!$KU.isArray(data[IndexJL])) {
                throw new KonyError(102, "Error", "Invalid input.");
            }

            if(model.hasSections === true) {
                if(!$KU.isArray(model.data)) {
                    model.data = (IndexJL) ? [null] : [];
                }
                this.modifyContent(model, data, "addsectionat", IndexJL, secIndex, animObj);
            }
        },

        
        setSectionAt: function(model, data, secIndex, animObj) {
            if(model.hasSections) {
                if($KU.isArray(data) && !isNaN(secIndex)) {
                    if($KU.isArray(model.data)) this.modifyContent(model, data, "setsectionat", IndexJL, secIndex, animObj);
                } else {
                    throw new KonyError(102, "Error", "Invalid input.");
                }
            } else {
                throw new KonyError(103, "Error", "Invalid operation.");
            }
        },

        
        removeSectionAt: function(model, secIndex, animObj) {
            if(model.hasSections) {
                if(!isNaN(secIndex)) {
                    if($KU.isArray(model.data)) this.modifyContent(model, null, "removesectionat", IndexJL, secIndex, animObj);
                } else {
                    throw new KonyError(102, "Error", "Invalid input.");
                }
            } else {
                throw new KonyError(103, "Error", "Invalid operation.");
            }
        },

        
        refreshScrollerInstance: function(widgetModel) {
            var element = $KU.getNodeByModel(widgetModel);
            if(element && widgetModel.needScroller) {
                var scrollInstance = $KG[element.id + "_scroller"];
                if(!scrollInstance)
                    return;
                scrollInstance.refresh();
            }
        },

        
        modifyContent: function(model, data, action, rowIndex, secIndex, animObj) {
            var secRowIndexArray = [IndexJL, IndexJL],
                boundaryConditionToBeConsidered = false;


            if(action == "addat" || action == "adddataat" || action == "addsectionat") {
                boundaryConditionToBeConsidered = true;
            } else if(action == "setdata" || action == "removeall") {
                boundaryConditionToBeConsidered = secRowIndexArray;
            } else if(action == "addall") {
                boundaryConditionToBeConsidered = (!model.hasSections) ? [IndexJL, model.data.length] : [model.data.length, IndexJL];
            }

            if(action == "setdataat") {
                
                var oldData = null, newTemplate = null, oldTemplate = null,
                    stopRerender = null;

                if(model.hasSections) {
                    if(rowIndex != -1) {
                        oldData = model.data[secIndex][1][rowIndex]; 
                    } else {
                        oldData = model.data[secIndex][0]; 
                    }
                } else {
                    oldData = model.data[rowIndex];
                }

                if(rowIndex != -1) {
                    oldTemplate = oldData.template || model.rowtemplate;
                    newTemplate = data.template || model.rowtemplate;
                } else {
                    oldTemplate = oldData.template || model.sectionHeaderTemplate;
                    newTemplate = data.template || model.sectionHeaderTemplate;
                }

                if((typeof oldTemplate == "string" && (oldTemplate == newTemplate)) ||
                    (typeof oldTemplate == "object" && (oldTemplate.id == newTemplate.id))) {
                    stopRerender = model.stoprerenderonsetdataat;
                } else {
                    stopRerender = false;
                }
            }

            secRowIndexArray = this.calculateSectionRowIndex(model, rowIndex, secIndex, boundaryConditionToBeConsidered);

            if(!model || secRowIndexArray === false) return;

            secIndex = secRowIndexArray[0], rowIndex = secRowIndexArray[1];

            
            model.canUpdateUI = false;
            $KW.Utils.updateContent(model, "data", data, action, rowIndex, secIndex);
            this.adjustAlreadySelectedProperties(model, action, secIndex, rowIndex);
            model.canUpdateUI = true;
            var segmentNode = $KU.getNodeByModel(model);
            if(model.viewtype == constants.SEGUI_VIEW_TYPE_PAGEVIEW && model.data && model.data.length > IndexJL && action == "setdata") {
                
                
                model.focusedindex = IndexJL; 
                model.selectedindex = (IndexJL) ? [null, IndexJL, IndexJL] : [IndexJL, IndexJL]; 
                model.focuseditem = model.data[model.focusedindex];
                model.selecteditems = model.data[model.selectedindex[1 + IndexJL]];
            }
            if(action === "removeall" || action === "setdata") {
                
                model.__y = 0;
            }
            if(!segmentNode) return; 
            if(module.isLazyLoadingApplicable(model) && ['setdata', 'removeall'].indexOf(action) == -1) { 
                if(!module.isSegmentVisible(model)) return;
                if(!module.isRenderRequired(model, segmentNode, action, {rowIndex: rowIndex, sectionIndex: secIndex})){
                    return;
                }
            }
            model.context = model.context ? model.context : {};
            model.context.tabpaneID = segmentNode.getAttribute("ktabpaneid") || "";

            
            var isFlexWidget = $KW.FlexUtils.isFlexWidget(model);
            
            if(!isFlexWidget)
                $KU.toggleVisibilty(segmentNode, model.data, model);

            
            if(model.hasSections === false && !segmentNode.firstChild) {
                segmentNode.innerHTML = "<ul style='list-style:none'></ul>";
            }
            if(model.hasSections === false || model.viewtype === constants.SEGUI_VIEW_TYPE_PAGEVIEW)
                segmentNode = segmentNode.childNodes[0]; 

            var rowNode = null,
                secNodes = null,
                secNode = null,
                secInnerNodes = null;
            var newSections = 0
            if(model.hasSections) {
                secNodes = segmentNode.childNodes;
                secNode = secNodes[secIndex - IndexJL];
                secInnerNodes = secNode ? secNode.childNodes : null;
            }
            if(action == "setdata")
                model.clonedTemplates = [];
            var onRowDisplayInfo;

            switch(action) {
                case "setdata":
                    if(model.viewtype === constants.SEGUI_VIEW_TYPE_PAGEVIEW || model.hasSections) {
                        segmentNode.innerHTML = this.generateRows(model, model.context, model.data, false, rowIndex, secIndex);
                        _setModalAttributeToSegmentNodes(model, segmentNode, segmentNode);
                    } else {
                        segmentNode.innerHTML = "";
                        this.refreshScrollerInstance(model);
                        var htmlString = '';
                        if(!module.isLazyLoadingApplicable(model))
                            htmlString = this.generateRows(model, model.context, model.data, false, rowIndex, secIndex);
                        segmentNode.parentNode.innerHTML = "<ul style='list-style:none'>" + htmlString + "</ul>";
                        _setModalAttributeToSegmentNodes(model, segmentNode, segmentNode);
                    }
                    if(animObj) {
                        new module.applyRowsAnimationByAPI(model, 'setdata', segmentNode, 0, 0, animObj);
                    }
                    break;

                case "removeall":
                    if(animObj) {
                        new module.applyRowsAnimationByAPI(model, 'removeall', segmentNode, 0, 0, animObj);
                    } else {
                        segmentNode.innerHTML = "";
                        this.refreshScrollerInstance(model);
                    }
                    break;

                case "setsectionat":
                    var wrapper = document.createElement("div");
                    wrapper.innerHTML = this.generateRows(model, model.context, (IndexJL ? [null, data] : [data]), false, rowIndex, secIndex, false);
                    _setModalAttributeToSegmentNodes(model, segmentNode, wrapper);
                    var newSec = wrapper.children[0];
                    new module.applyRowsAnimationByAPI(model, 'setsectionat', newSec, rowIndex, secIndex, animObj);
                    segmentNode.replaceChild(newSec, secNode);
                    break;

                case "removesectionat":
                    if(animObj && animObj.definition) {
                        new module.applyRowsAnimationByAPI(model, 'removesectionat', secNode, rowIndex, secIndex, animObj);
                    } else {
                        segmentNode.removeChild(secNode);
                        model.clonedTemplates.splice(secIndex, 1);
                    }
                    break;

                case "addsectionat":
                    var wrapper = document.createElement("div");
                    wrapper.innerHTML = this.generateRows(model, model.context, data, false, rowIndex, secIndex);
                    _setModalAttributeToSegmentNodes(model, segmentNode, wrapper);
                    newSections = wrapper.children.length;
                    new module.applyRowsAnimationByAPI(model, 'addsectionat', wrapper.childNodes, rowIndex, secIndex, animObj);
                    while(wrapper.children.length > 0) {
                        segmentNode.insertBefore(wrapper.childNodes[0], secNode);
                    }
                    break;

                case "addall":
                    var wrapper = document.createElement("div");
                    if(!model.hasSections) {
                        wrapper.innerHTML = this.generateRows(model, model.context, data, false, rowIndex, secIndex);
                        _setModalAttributeToSegmentNodes(model, segmentNode, wrapper);
                        new module.applyRowsAnimationByAPI(model, 'addall', wrapper.childNodes, rowIndex, secIndex, animObj);
                        while(wrapper.children.length > 0) {
                            segmentNode.appendChild(wrapper.childNodes[0]);
                        }
                    } else {
                        newSections = data.length;
                        var tempSecIndex = secIndex;
                        for(var i = IndexJL; i < data.length; i++) {
                            wrapper.innerHTML = this.generateRows(model, model.context, (IndexJL) ? [null, data[i]] : [data[i]], false, rowIndex, tempSecIndex);
                            _setModalAttributeToSegmentNodes(model, segmentNode, wrapper);
                            new module.applyRowsAnimationByAPI(model, 'addall', wrapper.childNodes, rowIndex, tempSecIndex, animObj);
                            while(wrapper.children.length > 0) {
                                segmentNode.appendChild(wrapper.childNodes[0]);
                            }
                            tempSecIndex++;
                        }
                        
                    }
                    break;

                case "setdataat":
                    if(stopRerender) {
                        if(!model.hasSections) {
                            var rowNode = segmentNode.childNodes[rowIndex - IndexJL];
                            var clonedTemplate = this.getClonedModel(model, rowIndex, secIndex);
                            this.rePaintOnSetdataat(clonedTemplate, rowNode, data);
                            _setModalAttributeToSegmentNodes(model, segmentNode, rowNode);
                        } else {
                            
                            rowNode = secInnerNodes[rowIndex - IndexJL + 1];

                            var clonedTemplate = this.getClonedModel(model, rowIndex, secIndex);
                            this.rePaintOnSetdataat(clonedTemplate, rowNode, data);
                            _setModalAttributeToSegmentNodes(model, segmentNode, rowNode);
                        }
                        if(rowNode) {
                            new module.applyRowsAnimationByAPI(model, 'setdataat', rowNode, rowIndex, secIndex, animObj);
                        }

                    } else {
                        if(!model.hasSections) {
                            var rowNode = segmentNode.childNodes[rowIndex - IndexJL];
                            
                            rowNode.innerHTML = this.generateRows(model, model.context, (IndexJL ? [null, data] : [data]), true, rowIndex, secIndex, false);
                            _setModalAttributeToSegmentNodes(model, segmentNode, rowNode);
                        } else {
                            rowNode = secInnerNodes[rowIndex - IndexJL + 1];
                            rowNode.innerHTML = this.generateRows(model, model.context, (IndexJL ? [null, data] : [data]), true, rowIndex, secIndex, false);
                            _setModalAttributeToSegmentNodes(model, segmentNode, rowNode);
                        }
                        if(rowNode) {
                            new module.applyRowsAnimationByAPI(model, 'setdataat', rowNode, rowIndex, secIndex, animObj);
                        }

                        $KU.addAriatoElement(rowNode.firstChild, data.accessibilityConfig, model);
                    }



                    break;

                case "removeat":
                    if(animObj && animObj.definition) {
                        var nodeToRemove = model.hasSections ? secInnerNodes[rowIndex + 1] : segmentNode.childNodes[rowIndex];
                        nodeToRemove.setAttribute('nodeToBeRemoved', 'true');
                        new module.applyRowsAnimationByAPI(model, 'removeat', nodeToRemove, rowIndex, secIndex, animObj);
                    } else {
                        if(!model.hasSections) {
                            segmentNode.removeChild(segmentNode.childNodes[rowIndex - IndexJL]);
                            model.clonedTemplates.splice(rowIndex, 1);
                        } else {
                            secNode.removeChild(secInnerNodes[rowIndex - IndexJL + 1]);
                            model.clonedTemplates[secIndex][1].splice(rowIndex, 1);
                        }
                    }
                    if(model.hasSections && model._searchCondition) {
                        module.toggleHeaderVisibility(model, secNode);
                    }
                    break;

                case "addat":
                case "adddataat":
                    var refEl, _html = this.generateRows(model, model.context, (IndexJL ? [null, data] : [data]), false, rowIndex, secIndex),
                        newRowHolderNode = document.createElement("div");
                    var showHeaderFooterForAddDataat = true;
                    
                    if(_html) {
                        newRowHolderNode.innerHTML = _html;
                        _setModalAttributeToSegmentNodes(model, segmentNode, newRowHolderNode);
                        new module.applyRowsAnimationByAPI(model, 'adddataat', newRowHolderNode.childNodes[0], rowIndex, secIndex, animObj);
                        if(!model.hasSections) {
                            if(segmentNode.style.display === "none") segmentNode.style.display = '';
                            if(segmentNode.parentNode.style.display === "none") segmentNode.parentNode.style.display = '';
                            refEl = segmentNode.childNodes[rowIndex - IndexJL] || null;
                            
                            segmentNode.insertBefore(newRowHolderNode.childNodes[0], refEl);
                        } else {
                            if(secNode) {
                                if(secNode.style.display === "none") secNode.style.display = '';
                                if(secNode.parentNode.style.display === "none") secNode.parentNode.style.display = '';
                                secNode.insertBefore(newRowHolderNode.childNodes[0], secInnerNodes[rowIndex - IndexJL + 1]);
                            }
                        }
                    }
                    break;
            }

            var needToUpdateDOM = true;
            if((action == 'removeat' || action == 'removeall' || action == 'removesectionat') && animObj)
                needToUpdateDOM = false;
            if((action == "addat" || action == "adddataat" || action == "removeat" || action == "addall" || action == "addsectionat" || action == "removesectionat") && needToUpdateDOM) {
                if(!model.hasSections) {
                    $KU.adjustNodeIndex(segmentNode, rowIndex, "index");
                    this.applyRowSkin(model, segmentNode);
                } else {
                    this.adjustSectionIndex(segmentNode);
                    this.applySectionRowSkin(model, segmentNode);
                }
            }

            if(model.viewtype == constants.SEGUI_VIEW_TYPE_PAGEVIEW) {
                model.isvisible && (model.data.length > IndexJL) && $KW.touch.computeWidths(segmentNode.parentNode, model);
                if(model.needpageindicator) {
                    var footerHolderNode = $KU.getElementById($KW.Utils.getKMasterWidgetID(model) + "_footer");
                    footerHolderNode.innerHTML = this.generatePageFooter(model, model.data);
                }
            }
            
            model.context.tabpaneID = ""; 
            
            if($KW.Line && model.data && model.data.length > IndexJL) $KW.Line.initializeView($KW.Utils.getKMasterWidgetID(model));

            var segData = model.data;

            model.isvisible && this.adjustFlexContainers(model, action, secIndex, rowIndex, newSections, showHeaderFooterForAddDataat);
            module.updateTemplateContextAfterModifyData(model);

            
            var size, upperLimit, i, j, sectionData, widgetModel;
            if(model.clonedTemplates.length) {
                if(model.hasSections) {
                    if(['addsectionat', 'setsectionat', 'adddataat', 'setdataat'].indexOf(action) >= 0) {
                        size = secIndex + 1;
                    } else if(action === 'addall' || action === 'setdata') {
                        size = model.clonedTemplates.length;
                    } else {
                        size = secIndex;
                    }
                    for(i = secIndex; i < size; i++) {
                        sectionData = model.clonedTemplates[i];
                        if(['addsectionat', 'setsectionat', 'addall', 'setdata'].indexOf(action) >= 0) {
                            widgetModel = sectionData[0];
                            rowNode = $KW.Segment.getNodeByContext(model, widgetModel.rowContext, widgetModel);
                            rowNode && $KW.Utils.processContainerGestures(widgetModel, rowNode);
                        }
                        if(action === 'adddataat' || action === 'setdataat') {
                            upperLimit = rowIndex + 1;
                        } else {
                            upperLimit = sectionData[1].length;
                        }
                        for(j = rowIndex; j < upperLimit; j++) {
                            widgetModel= sectionData[1][j];
                            rowNode = $KW.Segment.getNodeByContext(model, widgetModel.rowContext, widgetModel);
                            rowNode && $KW.Utils.processContainerGestures(widgetModel, rowNode);
                        }
                    }
                } else {
                    if(action ===  'addall' || action === 'setdata') {
                        size = model.clonedTemplates.length;
                    } else if(action === 'adddataat' || action ===  'setdataat') {
                        size = rowIndex + 1;
                    } else {
                        size = rowIndex;
                    }
                    for(i = rowIndex; i < size; i++) {
                        widgetModel = model.clonedTemplates[i];
                        rowNode = $KW.Segment.getNodeByContext(model, widgetModel.rowContext, widgetModel);
                        rowNode && $KW.Utils.processContainerGestures(widgetModel, rowNode);
                    }
                }
            }
             
            var listAnimation = model.listAnimation;
            var needToSyncList = true;
            if(listAnimation) {
                
                if((action == 'removeat' || action == 'removeall' || action == 'removesectionat') && animObj)
                    needToSyncList = false;
                needToSyncList && listAnimation.syncList();
                if(model.onrowdisplay && animObj) {
                    onRowDisplayInfo = {
                        action: action,
                        rowIndex: rowIndex,
                        sectionIndex: secIndex,
                        newItems: data ? data.length : null
                    };
                    listAnimation.onRowDisplayHandler(onRowDisplayInfo);
                }
            }
            if(action == "removeall") 
                model.clonedTemplates = [];
            $KW.FlexUtils.updateAutoGrowFlexConfig(model);
        },

        rePaintOnSetdataat: function(containerModel, rowNode, rowData) {
            var element, childList, i, childModel;
            element =  rowNode.querySelector('#' + $KW.Utils.getKMasterWidgetID(containerModel));
            if(element) {
                
               $KW.Segment.readjustViewOnSetdataat(containerModel, element, rowData);
            }

            childList = containerModel.children;
            for(i = 0; i < childList.length; i++) {
                childModel = containerModel[childList[i]];
                childModel = $KW.Utils.getActualWidgetModel(childModel);

                if(childModel && childModel.children && childModel.children.length != 0) {
                    $KW.Segment.rePaintOnSetdataat(childModel, rowNode, rowData);
                } else {
                    if(childModel.wType == "Calendar") {
                        element = rowNode.querySelector("div[kwidgetid = " + $KW.Utils.getKMasterWidgetID(childModel) + "]");
                    } else {
                        element = rowNode.querySelector('#' + $KW.Utils.getKMasterWidgetID(childModel));
                    }

                    if(element) {
                        $KW.Segment.readjustViewOnSetdataat(childModel, element, rowData);
                    }
                }
            }
        },

        readjustViewOnSetdataat: function(widgetModel, widgetNode, rowData) {
            var id = widgetModel.id;
            var propName, val, oldval;
            var widgetData = rowData[id];
            var props = ["accessibilityConfig", "margin", "padding", "skin", "zindex",
                "opacity", "transform", "anchorpoint", "backgroundcolor", "borderwidth",
                "bordercolor", "cornerradius", "flexblur", "shadowradius", "shadowoffset",
                "shadowcolor", "focusskin", "hoverskin", "touchstart", "touchmove", "touchend",
                "cursortype", "tooltip"];

            if(widgetData) {
                if(typeof widgetData == "object") {
                    for(propName in widgetData) {
                        if(widgetData.hasOwnProperty(propName)) {
                            val = widgetData[propName];
                            propName = $KW.Utils.getSegProperty(propName).toLowerCase();
                            oldval = widgetModel[propName];

                            widgetModel[propName] = val;
                            if(props.indexOf(propName) != -1) {
                                kony.model.updateView(widgetModel, propName, val, oldval);
                            } else {
                                $KW[widgetModel.wType]["updateView"](widgetModel,
                                    propName, val, oldval);
                            }
                        }
                    }

                } else {
                    propName = $KW.Utils.getDefaultProperyForContanierWidgets(widgetModel);
                    val = widgetData;
                    propName = $KW.Utils.getSegProperty(propName).toLowerCase();
                    oldval = widgetModel[propName];
                    widgetModel[propName] = val;
                    $KW[widgetModel.wType]["updateView"](widgetModel, propName, val, oldval);
                }
            }
        },

        
        adjustFlexContainers: function(model, action, secIndex, rowIndex, newSections, showHeaderFooterForAddDataat) {
            $KU.needOptimization = false;
            var segNode = $KU.getNodeByModel(model);
            var type = 'FlexContainer';
            var rowNodes, rowLen, visibility, i, j;
            switch(action) {
                case "setdata":
                    this.adjustFlexContainersInSegment(model, segNode);
                    this.initializeNewWidgets(segNode);
                    break;

                case "setdataat":
                case "addat":
                case "adddataat":
                    
                    var row = module.getNodeByContext(model, {
                        rowIndex: rowIndex,
                        sectionIndex: secIndex
                    });
                    if(row) {
                        var flexNode = row.querySelector("div[kwidgettype='" + type + "']");
                        if(flexNode) {
                            var flexModel = this.getClonedModel(model, rowIndex, secIndex);
                            $KW.FlexContainer.forceLayout(flexModel, flexNode.parentNode);
                        }
                        this.initializeNewWidgets(row);

                        if(model._searchCondition && model._config.updateSegment) {
                            visibility = module.isRowVisible(model, row, rowIndex, secIndex);
                            if(model.hasSections && model._config.showSectionHeaderFooter) {
                                if(action === "setdataat" || (action === "adddataat" && showHeaderFooterForAddDataat)) {
                                    module.toggleHeaderVisibility(model, segNode.childNodes[secIndex]);
                                }
                            }
                        }

                    }
                    break;

                case "addall":
                    if(model.hasSections) {
                        var sections = segNode.childNodes;
                        var startIndex = secIndex;
                        var data = model.data;
                        for(var i = 0; i < newSections; i++) {
                            var section = sections[startIndex];
                            var flexNode = section.querySelector('[secIndex="' + startIndex + ',-1"] div[kwidgettype="FlexContainer"]');
                            if(flexNode) {
                                var flexModel = this.getClonedModel(model, -1, startIndex);
                                $KW.FlexContainer.forceLayout(flexModel, flexNode.parentNode);
                            }
                            this.adjustFlexContainersInRows(model, section, data[startIndex][1], startIndex);
                            this.initializeNewWidgets(section);

                            if(model._searchCondition && model._config.updateSegment) {
                                rowNodes = section.childNodes;
                                rowLen = rowNodes.length;

                                for(j = 0; j < rowLen; j++) {
                                    if(!rowNodes[j+1]) break;
                                    rowIndex = rowNodes[j+1].getAttribute("index");
                                    rowIndex = parseInt(rowIndex);
                                    visibility = module.isRowVisible(model, rowNodes[j+1], rowIndex, startIndex);
                                }

                                if(model._config.showSectionHeaderFooter) {
                                    module.toggleHeaderVisibility(model, section);
                                }
                            }

                            startIndex++;
                        }
                    } else {
                        var section = segNode.childNodes[secIndex];
                        var rows = section.childNodes;
                        for(var i = rowIndex; i < rows.length; i++) {
                            var row = rows[i];
                            var flexNode = row.querySelector("div[kwidgettype='" + type + "']");
                            if(flexNode) {
                                var flexModel = this.getClonedModel(model, i, secIndex);
                                $KW.FlexContainer.forceLayout(flexModel, flexNode.parentNode);
                            }
                            this.initializeNewWidgets(row);

                            if(model._searchCondition && model._config.updateSegment) {
                                visibility = module.isRowVisible(model, row, i, secIndex);
                            }

                        }
                    }
                    break;

                case "addsectionat":
                case "setsectionat":
                    var sections = segNode.childNodes;
                    var startIndex = secIndex;
                    if(action == 'setsectionat')
                        newSections = 1;
                    var data = model.data;
                    for(var i = 0; i < newSections; i++) {
                        var section = sections[startIndex];
                        var flexNode = section.querySelector('[secIndex="' + startIndex + ',-1"] div[kwidgettype="FlexContainer"]');
                        if(flexNode) {
                            var flexModel = this.getClonedModel(model, -1, startIndex);
                            $KW.FlexContainer.forceLayout(flexModel, flexNode.parentNode);
                        }
                        this.adjustFlexContainersInRows(model, section, data[startIndex][1], startIndex);
                        this.initializeNewWidgets(section);

                        if(model._searchCondition && model._config.updateSegment) {
                            rowNodes = section.childNodes;
                            rowLen = rowNodes.length;

                            for(j = 0; j < rowLen; j++) {
                                if(!rowNodes[j+1]) break;
                                rowIndex = rowNodes[j+1].getAttribute("index");
                                rowIndex = parseInt(rowIndex);
                                visibility = module.isRowVisible(model, rowNodes[j+1], rowIndex, startIndex);
                            }

                            if(model._config.showSectionHeaderFooter) {
                                module.toggleHeaderVisibility(model, section);
                            }
                        }

                        startIndex++;
                    }
                    break;
            }
            $KU.needOptimization = true;
            if($KW.FlexUtils.isFlexWidget(model) && !model.needScroller && model.autogrowMode == kony.flex.AUTOGROW_HEIGHT && model.viewtype == constants.SEGUI_VIEW_TYPE_TABLEVIEW) {
                var parent = model.parent;
                parent.layoutConfig.children = true;
            }
        },

        initializeNewWidgets: function(node) {
            $KW.Slider && $KW.Slider.initializeView(null, node);
            $KW.Switch && $KW.Switch.initializeView(null, node);
        },

        adjustFlexContainersInSegment: function(segmentModel, segNode) {
            var data = segmentModel.data;

            if(data && data.length > 0) {
                
                if(module.isLazyLoadingApplicable(segmentModel)) {
                    if(!module.isSegmentVisible(segmentModel) || !segmentModel.frame.height) {
                        return;
                    }

                    
                    if((!segmentModel.hasSections && segNode.children[0].children.length == 0)
                    || (segmentModel.hasSections && segNode.children.length == 0)) {
                        module.registerScrollEvents(segmentModel);
                        segmentModel.clonedTemplates = [];
                        module.adjustFlexContainersInSegmentAtRenderTime(segmentModel, segNode);
                        
                        segmentModel.previousHeight = segmentModel.frame.height;
                        return;
                    } else {
                        
                        if(!segmentModel.previousHeight) {
                            module.registerScrollEvents(segmentModel);
                        }
                        if(segmentModel.previousHeight && segmentModel.previousHeight < segmentModel.frame.height) {
                            segmentModel.needToRenderMore = true;
                        }
                        segmentModel.previousHeight = segmentModel.frame.height;
                        segmentModel.currentPortion =  module.getPortionNumber(segmentModel);
                    }
                }

                if(segmentModel.hasSections) {
                    var secLen = data.length;
                    var sectionNodes = segNode.childNodes;
                    for(var i = 0; i < secLen; i++) {
                        var secHeaderNode = module.getNodeByContext(segmentModel, {
                            rowIndex: -1,
                            sectionIndex: i
                        });

                        if(secHeaderNode) {
                            var flexNode = secHeaderNode.querySelector('div[kwidgettype="FlexContainer"]');
                            if(flexNode) {
                                var flexModel = this.getClonedModel(segmentModel, -1, i);
                                $KW.FlexContainer.forceLayout(flexModel, flexNode.parentNode);
                            }
                        }
                        this.adjustFlexContainersInRows(segmentModel, sectionNodes[i], data[i][1], i);
                    }

                    if(segmentModel._searchCondition && segmentModel._config.updateSegment) {
                        module.setFilterResultOnRenderedData(segmentModel, segNode);
                        module.setResultOnSegmentHeader(segmentModel);
                    }

                } else {
                    this.adjustFlexContainersInRows(segmentModel, segNode, data);
                }

                if(segmentModel._searchCondition && segmentModel._config.updateSegment) {
                    module.setFilterResultOnRenderedData(segmentModel, segNode);
                }

            }
            if(module.isLazyLoadingApplicable(segmentModel) && segmentModel.needToRenderMore) {
                segmentModel.currentPortion =  module.getPortionNumber(segmentModel);
                module.renderSegmentTillGivenHeight(segmentModel, segNode, true, module.getHeightByNumberOfPortions(segmentModel, 4));
                segmentModel.needToRenderMore = false;
            } else if(segmentModel.autogrowMode == kony.flex.AUTOGROW_HEIGHT
            && segmentModel.viewtype == constants.SEGUI_VIEW_TYPE_TABLEVIEW
            && $KW.FlexUtils.isFlexWidget(segmentModel) && segmentModel.previousHeight) {
                
                module.onHeightChangedToPreferredFromFixed(segmentModel, segNode);
            }
        },

        adjustFlexContainersInRows: function(segmentModel, segNode, rows, secIndex, needHeight) {
            if(rows && rows.length > 0) {
                var len = rows.length;

                for(var i = 0; i < len; i++) {
                    var rowNode = module.getNodeByContext(segmentModel, {
                        rowIndex: i,
                        sectionIndex: secIndex
                    });
                    
                    if(rowNode) {
                        var flexNode = rowNode.querySelector('div[kwidgettype="FlexContainer"]');

                        if(flexNode) {
                            var flexModel = this.getClonedModel(segmentModel, i, secIndex);
                            flexNode = flexNode.parentNode;

                            if(needHeight) {
                                this.setFlexRowTemplateHeight(flexModel, flexNode);
                            } else{
                                $KW.FlexContainer.forceLayout(flexModel, flexNode);
                            }
                        }
                    }
                }
            }
        },

        getClonedModel: function(segModel, rowIndex, secIndex) {
            if(segModel.hasSections) {
                if(rowIndex == -1 || typeof rowIndex == 'undefined') 
                    return segModel.clonedTemplates[secIndex][0];
                else
                    return segModel.clonedTemplates[secIndex][IndexJL + 1][rowIndex];
            } else
                return segModel.clonedTemplates[rowIndex];
        },

        getContextByNode: function(segModel, wNode) {
            var row = $KU.getParentByAttribute(wNode, "index");
            if(segModel.hasSections) {
                var secIndices = row.getAttribute("secindex").split(',');
                return {
                    sectionIndex: parseInt(secIndices[0]),
                    rowIndex: parseInt(secIndices[1])
                };
            }
            return {
                rowIndex: parseInt(row.getAttribute("index"))
            };
        },

        getClonedModelOfWidget: function(wModel, wNode, containerId) {
            var segModel = $KW.Utils.getContainerModelById(wNode, containerId);
            if(!segModel)
                return;
            var context = module.getContextByNode(segModel, wNode);
            var clonedTemp = module.getClonedModel(segModel, context.rowIndex, context.sectionIndex);
            return clonedTemp[wModel.id];
        },

        
        getNodeByContext: function(segModel, context, wModel) {
            var element = $KU.getNodeByModel(segModel);
            if(!element || !context)
                return;

            var secIndex = context.sectionIndex;
            var rowIndex = context.rowIndex;
            var querySelector;
            if(segModel.hasSections) {
                if($KU.isDefined(secIndex) && $KU.isDefined(rowIndex)) {
                    querySelector = "secindex='" + secIndex + "," + rowIndex + "'";
                } else if($KU.isDefined(secIndex)) {
                    querySelector = "secindex='" + secIndex + ",-1'";
                }
            } else if($KU.isDefined(rowIndex)) {
                querySelector = "index='" + rowIndex + "'";
            }
            if(querySelector) {
                var listItem = element.querySelector("[" + querySelector + "]");
                if(listItem) {
                    if(wModel) {
                        return $KW.Utils.getWidgetNode(wModel, listItem);
                    } else
                        return listItem;
                }
            }
        },

        updateDataByContext: function(context, wData) {
            var segModel = context.containerModel;
            if(!segModel || !context || !wData)
                return;
            var data = segModel.data;
            if(data && data.length > 0) {
                var rowData;
                var secIndex = context.sectionIndex;
                var rowIndex = context.rowIndex;
                if(segModel.hasSections) {
                    if($KU.isDefined(secIndex) && $KU.isDefined(rowIndex)) {
                        rowData = data[secIndex][1][rowIndex];
                    } else if($KU.isDefined(secIndex)) {
                        rowData = data[secIndex][0];
                    }
                } else if($KU.isDefined(rowIndex)) {
                    rowData = data[rowIndex];
                }
                if(rowData) {
                    var wModel = context.widgetModel;
                    if(wModel) {
                        var map = segModel.widgetdatamap;
                        var widgetKey = map ? map[wModel.id] : wModel.id;
                        var content = rowData[widgetKey];
                        if(!(content instanceof Object)) {
                            return;
                        }
                        
                        for(var prop in wData) {
                            
                            if($KU.isDefined(wData[prop]))
                                content[prop] = wData[prop];
                            
                        }
                    }
                }
            }
        },

        getAutoGrowSegmentHeight: function(wModel, wNode) {
            var height = 0;
            var data = wModel.data;
            var segNode = $KU.getNodeByModel(wModel);

            if(data && data.length > 0) {
                if(wModel.hasSections) {
                    var secLen = data.length;
                    var sectionNodes = segNode.childNodes;

                    for(var i = 0; i < secLen; i++) {
                        var secHeaderNode = sectionNodes[i].childNodes[0];
                        if(secHeaderNode) {
                            var flexNode = secHeaderNode.querySelector('div[kwidgettype="FlexContainer"]');

                            if(flexNode) {
                                var flexModel = $KU.getModelByNode(flexNode);

                                flexNode = flexNode.parentNode;
                                this.setFlexRowTemplateHeight(flexModel, flexNode);
                            }
                        }
                        this.adjustFlexContainersInRows(wModel, sectionNodes[i], data[i][1], i, true);
                    }
                } else {
                    this.adjustFlexContainersInRows(wModel, segNode, data, undefined, true);
                }

                return wNode.offsetHeight;
            }
        },

        setFlexRowTemplateHeight: function(flexModel, flexNode) {
            var containerId = flexNode.childNodes[0].getAttribute("kcontainerID");
            containerId && $KW.Utils.updateContainerDataInDOM(flexNode, containerId);
            $KW.FlexUtils.setFlexContainerStyle(flexModel, flexNode);
        },

        adjustSectionIndex: function(node) {
            var sections = node.childNodes;
            var secindex, index;
            for(var i = 0; i < sections.length; i++) {
                var rows = sections[i].childNodes;
                
                for(var j = 1; j < rows.length; j++) {
                    secindex = (i + IndexJL) + "," + (j + IndexJL - 1);
                    index = (j + IndexJL - 1);
                    rows[j].setAttribute("index", index);
                    rows[j].setAttribute("secindex", secindex);
                }
                if(rows[0]) {
                    rows[0].setAttribute("index", (i + IndexJL) + ",-1");
                    rows[0].setAttribute("secindex", (i + IndexJL) + ",-1");
                }
            }
        },

        applySectionRowSkin: function(widgetModel, holder, startRowIndex, startSectionIndex) {
            
            var sections = holder.childNodes;
            var askin = widgetModel.alternaterowskin || widgetModel.askin || "";
            var rowSkin = widgetModel.rowskin || widgetModel.skin || "";
            var rowData, skin = "";
            var firstTimeRowCheck = true;
            startSectionIndex = startSectionIndex || 0;
            for(var i = startSectionIndex; i < sections.length; i++) {
                var rows = sections[i].childNodes;
                var rowIndex = 1;
                if(firstTimeRowCheck) {
                    firstTimeRowCheck = false;
                    if(startRowIndex && startRowIndex != -1)
                        rowIndex = startRowIndex;
                }
                for(var j = rowIndex; j < rows.length; j++) {
                    var context = module.getContextByNode(widgetModel, rows[j]);
                    rowData = widgetModel.data[i + IndexJL][j];
                    if(rowData) {
                        rowData.metainfo = rowData.metaInfo || rowData.metainfo;
                    }
                    skin = (rowData && rowData.metainfo && rowData.metainfo.skin) || ((j % 2 == 0 && askin) ? askin : rowSkin);
                    rows[j].className = skin;
                    if(widgetModel.separatorthickness && widgetModel.separatorcolor) {
                        if(!widgetModel.separatorrequired) {
                            rows[j].style.borderBottom = "none";
                            continue;
                        }
                        if(context.rowIndex == widgetModel.data[context.sectionIndex][1]) 
                            continue;
                        var r = parseInt(widgetModel.separatorcolor.substring(0, 2), 16),
                            g = parseInt(widgetModel.separatorcolor.substring(2, 4), 16),
                            b = parseInt(widgetModel.separatorcolor.substring(4, 6), 16);
                        var o = 1 - (parseInt(widgetModel.separatorcolor.substring(6, 8), 16) / 100);
                        rows[j].style.borderBottom = widgetModel.separatorthickness + "px solid rgba(" + r + "," + g + "," + b + "," + o + ")";
                    }
                }
            }
        },

        
        invertMapAndData: function(widget, data) {
            var map = widget.widgetdatamap;
            if(map) {
                map = $KU.isArray(map) ? map[IndexJL] : map;
                var keys = $KU.getkeys(map);
                var newmap = {};
                var newdata = IndexJL ? [null] : [];

                for(var i = 0; i < keys.length; i++) {
                    newmap[map[keys[i]]] = keys[i];
                }

                var newkeys = $KU.getkeys(newmap);
                if(data[IndexJL] instanceof Array) {
                    var index = IndexJL;
                    var sectionData;
                    for(var i = IndexJL; i < data.length; i++) {

                        var innerData = data[i][1 + IndexJL];
                        newdata[index] = {};
                        sectionData = data[i][IndexJL];

                        if(sectionData && typeof sectionData == "string" && sectionData.toLowerCase().indexOf("i18n.getlocalizedstring") != -1)
                            newdata[index]["sectionLabel"] = $KU.getI18NValue(sectionData);
                        else if(sectionData instanceof Object) {
                            newdata[index]["sectionLabel"] = {};
                            for(var sKey in sectionData) {
                                if(newmap[sKey]) {
                                    var sValue = sectionData[sKey];
                                    if(sValue && typeof sValue == "string" && sValue.toLowerCase().indexOf("i18n.getlocalizedstring") != -1)
                                        newdata[index]["sectionLabel"][newmap[sKey]] = $KU.getI18NValue(sValue);
                                    else
                                        newdata[index]["sectionLabel"][newmap[sKey]] = sValue;
                                }
                            }
                            sectionData["template"] && (newdata[index]["sectionLabel"]["template"] = sectionData["template"]);
                            sectionData["accessibilityConfig"] && (newdata[index]["sectionLabel"]["accessibilityConfig"] = sectionData["accessibilityConfig"]);
                        } else
                            newdata[index]["sectionLabel"] = sectionData;

                        for(var j = IndexJL; j < innerData.length; j++, index++) {
                            newdata[index] = newdata[index] || {};
                            for(var k = 0; k < newkeys.length; k++) {
                                
                                var value = innerData[j][newkeys[k]];
                                if(value && typeof value == "string" && value.toLowerCase().indexOf("i18n.getlocalizedstring") != -1)
                                    newdata[index][newmap[newkeys[k]]] = $KU.getI18NValue(value);
                                else
                                    newdata[index][newmap[newkeys[k]]] = value;
                            }
                            var metaInfo = innerData[j]["metainfo"] || innerData[j]["metaInfo"];
                            metaInfo && (newdata[index]["metainfo"] = metaInfo);
                            innerData[j]["template"] && (newdata[index]["template"] = innerData[j]["template"]);
                            innerData[j]["accessibilityConfig"] && (newdata[index]["accessibilityConfig"] = innerData[j]["accessibilityConfig"]);
                        }

                        if(innerData.length == IndexJL)
                            index++;
                    }

                } else {
                    for(var i = IndexJL; i < data.length; i++) {
                        newdata[i] = {};

                        for(var j = 0; j < newkeys.length; j++) {
                            
                            var value = data[i][newkeys[j]];

                            if(value && typeof value == "string"
                            && value.toLowerCase().indexOf("i18n.getlocalizedstring") != -1) {
                                newdata[i][newmap[newkeys[j]]] = $KU.getI18NValue(value);
                            } else {
                                newdata[i][newmap[newkeys[j]]] = value;
                            }
                        }
                        var metaInfo = data[i]["metainfo"] || data[i]["metaInfo"];
                        if(metaInfo) {
                            newdata[i]["metainfo"] = $KU.cloneObj(metaInfo);

                            for(var j = 0; j < newkeys.length; j++) {
                                if(newdata[i]["metainfo"][newkeys[j]]) {
                                    newdata[i]["metainfo"][newmap[newkeys[j]]] = metaInfo[newkeys[j]];

                                    if(newmap[newkeys[j]] != newkeys[j]) {
                                        delete newdata[i]["metainfo"][newkeys[j]];
                                    }
                                }
                            }
                        }
                        if(data[i]["template"]) {
                            newdata[i]["template"] = data[i]["template"];
                        }

                        if(data[i]["accessibilityConfig"]) {
                            newdata[i]["accessibilityConfig"] = data[i]["accessibilityConfig"];
                        }

                    }
                }

                return newdata;
            } else {
                return data;
            }
        },

        updateImageIdentifier: function(imageModel, container) {
            if(container.wType == "Segment" && container.selectionindicator == imageModel.id && container.behavior != "default" && container.selectimage && container.unselectimage) {
                var indicator = $KU.inArray(container.selectedRows, (IndexJL) ? [null, container.seccounter, container.rowcounter] : [container.seccounter, container.rowcounter])[0] ? container.selectimage : container.unselectimage;
                imageModel.src = indicator;
            }
        },

        renderFlexContainer: function(flexModel, context, rowData, segmentModel, rowIndex, secIndex) {
            var htmlString = "";
            var boxHTML = "";
            var length;
            var count = 0;
            var style = "";
            var wrapperBegin = "";
            var wrapperClose = "";
            var widgetData = rowData[$KW.Utils.getWidgetPathByModel(flexModel)];
            $KW.Utils.updateChildModel(flexModel, widgetData);
            if(!flexModel.isvisible)
                return "";
            if(flexModel.pf === flexModel.id) {
                module.updateTemplateContext(flexModel, rowIndex, secIndex);
            }
            flexModel.kuid = $KU.generateKUID();
            this.applyWidgetFocusSkin(widgetData, flexModel, segmentModel);
            var computedSkin = $KW.skins.getWidgetSkinList(flexModel, context);
            var boxstyle = " position:relative;" + (flexModel.clipbounds == true ? "overflow:hidden;" : "") + (flexModel.zindex ? "z-index:" + flexModel.zindex : "") + $KW.skins.getBaseStyle(flexModel, context);

            htmlString += "<div id='flexcontainer_wrapper' class=' ' style='" + $KW.skins.getMarginSkin(flexModel, context) + "'>";
            htmlString += "<div class = 'kwt100 " + computedSkin + "'" + $KW.Utils.getBaseHtml(flexModel, context) + " style='" + boxstyle + "'>";

            var wArrary = flexModel.widgets();
            length = wArrary.length;

            for(var i = 0; i < length; i++) {
                var childModel = wArrary[i];
                var widgetData = rowData[$KW.Utils.getWidgetPathByModel(childModel)];
                $KW.Utils.updateChildModel(childModel, widgetData);
                childModel.kuid = $KU.generateKUID();
                if(childModel.wType == "Image") {
                    module.updateImageIdentifier(childModel, context.container);
                }
                if(!childModel.isvisible) {
                    continue;
                }

                this.applyWidgetFocusSkin(widgetData, childModel, segmentModel);

                var css = "kcell " + $KW.skins.getWidgetAlignmentSkin(childModel) + (childModel.wType == "TPW" ? "  konycustomcss " : "");
                var style = $KW.FlexUtils.getFlexLayoutStyle(childModel);
                var overflow = " ";

                if((childModel.wType == 'FlexContainer' || childModel.wType == 'FlexScrollContainer') && !childModel.clipbounds) {
                    overflow = ';overflow:visible';
                } else {
                    overflow = ';overflow:hidden';
                    overflow += (childModel.wType == 'FlexContainer' ) ? ";" + $KU.cssPrefix + "box-shadow:none" : "";
                    css += childModel.skin;
                }

                wrapperBegin = "<div class = '" + css + "' style='" + style + overflow +"'>";
                wrapperClose = "</div>";

                if(childModel.wType == "FlexContainer") {
                    context.topLevelBox = true;
                    boxHTML = this.renderFlexContainer(childModel, context, rowData, segmentModel, rowIndex, secIndex);

                    if(boxHTML)
                        htmlString += wrapperBegin + boxHTML + wrapperClose;
                    else
                        count++;
                } else {
                    if((typeof widgetData != "undefined" && widgetData != "") || childModel.wType == "Line") {
                        htmlString += wrapperBegin + $KW[childModel.wType].render(childModel, context) + wrapperClose;
                    } else
                        count++;
                }
            }

            if(length == count)
                return "";

            htmlString += "</div></div>";
            return htmlString;
        },

        updateTemplateContext: function(widgetModel, rowIndex, secIndex) {
            var childList = widgetModel.children;
            var childModel, i;

            widgetModel.rowContext = {
                "rowIndex": rowIndex,
                "sectionIndex": secIndex
            };

            if(childList) {
                for(i = 0; i < childList.length; i++) {
                    childModel = widgetModel[childList[i]];
                    childModel = $KW.Utils.getActualWidgetModel(childModel);
                    if(childModel && childModel.children && childModel.children.length != 0) {
                        module.updateTemplateContext(childModel, rowIndex, secIndex);
                    } else {
                       childModel.rowContext = {
                            "rowIndex": rowIndex,
                            "sectionIndex": secIndex
                        };
                    }
                }
            }
        },

        updateTemplateContextAfterModifyData: function(segModel){
            var sec = 0;
            var template, i, j, size, rowSize;
            var clonedTemplates = segModel.clonedTemplates;
            var length = segModel.clonedTemplates.length;

            if(segModel.hasSections) {
                for(i = 0; i < length; i++) {
                    var sectionData = clonedTemplates[i];
                    template = sectionData[0];
                    module.updateTemplateContext(template, -1, i);

                    for(j=0; j < sectionData[1].length; j++) {
                        template = sectionData[1][j];
                        module.updateTemplateContext(template, j, i);
                    }
                }
            } else {
                for(i = 0; i < length; i++) {
                    template = clonedTemplates[i];
                    module.updateTemplateContext(template, i, sec);
                }
            }
        },



        applyWidgetFocusSkin: function(widgetData, childModel, segmentModel) {
            var segID = $KW.Utils.getKMasterWidgetID(segmentModel);
            var segChildID = $KW.Utils.getKMasterWidgetID(childModel);
            if(widgetData && widgetData.focusSkin) {
                var classSelector = "";
                if(segmentModel.hasSections) {
                    classSelector = "#" + segID + " li[secindex='" + segmentModel.seccounter + "," + segmentModel.rowcounter + "'] #" + segChildID + ":active";
                } else {
                    classSelector = "#" + segID + " li[index='" + segmentModel.rowcounter + "'] #" + segChildID + ":active";

                }
                $KW.skins.applyStyle(widgetData.focusSkin, classSelector, segmentModel.wType);
            }
            if(widgetData && widgetData.hoverSkin) {
                var classSelector = "";
                if(segmentModel.hasSections) {
                    classSelector = "#" + segID + " li[secindex='" + segmentModel.seccounter + "," + segmentModel.rowcounter + "'] #" + segChildID + ":hover";
                } else {
                    classSelector = "#" + segID + " li[index='" + segmentModel.rowcounter + "'] #" + segChildID + ":hover";

                }
                $KW.skins.applyStyle(widgetData.hoverSkin, classSelector, segmentModel.wType);
            }
        },

        applyRowSkin: function(segmentModel, holder, startRowIndex) {
            
            var rows = holder.childNodes;
            var askin = segmentModel.alternaterowskin || segmentModel.askin || "";
            var rowSkin = segmentModel.rowskin || segmentModel.skin || "";
            var rowData, skin = "";
            if(segmentModel.viewType == "pageview") {
                holder.parentElement.className = "kstripcontainer" + " " + rowSkin;
                return;
            }
            startRowIndex = startRowIndex || 0;
            for(var i = startRowIndex; i < rows.length; i++) {
                rowData = segmentModel.data[i + IndexJL];
                if(rowData) {
                    rowData.metainfo = rowData.metaInfo || rowData.metainfo;
                }
                skin = (rowData && rowData.metainfo && rowData.metainfo.skin) || ((i % 2 != 0 && askin) ? askin : rowSkin);
                rows[i].className = skin;
                if(i < rows.length - 1 && segmentModel.separatorthickness && segmentModel.separatorcolor) {
                    if(!segmentModel.separatorrequired) {
                        rows[i].style.borderBottom = "none";
                        continue;
                    }
                    var r = parseInt(segmentModel.separatorcolor.substring(0, 2), 16),
                        g = parseInt(segmentModel.separatorcolor.substring(2, 4), 16),
                        b = parseInt(segmentModel.separatorcolor.substring(4, 6), 16);
                    var o = 1 - (parseInt(segmentModel.separatorcolor.substring(6, 8), 16) / 100);
                    rows[i].style.borderBottom = segmentModel.separatorthickness + "px solid rgba(" + r + "," + g + "," + b + "," + o + ")";
                }
            }
        },

        applySectionHeaderSkin: function(segmentModel, skin) {
            var element = $KU.getNodeByModel(segmentModel);
            if(element) {
                var id = element.id;
                var headers = document.querySelectorAll("#" + id + ">ul>li:first-child");
                for(var i = 0; i < headers.length; i++) {
                    var header = headers[i];
                    header.style.border = "none";
                    header.className = skin + ' middleleftalign';
                }
            }
        },

        isClickableWidget: function(childModel) {
            if(childModel.isContainerWidget || childModel.wType == "Label" || childModel.wType == "Image" || childModel.wType == "RichText") {
                return false;
            } else {
                return true;
            }
        },

        
        updateData: function(childModel, childNode, segmentModel, row, canExecute, eventType) {
            if(segmentModel && row) {
                var index = parseInt(row.getAttribute("index"));
                var secIndex = 0 + IndexJL;
                var data = segmentModel.data;
                var item = null;
                var secIndices;
                var previousRowIndex = segmentModel.selectedrowindex;
                var toggleRowSelectionFlag = true;
                if(segmentModel.hasSections) {
                    secIndices = row.getAttribute("secindex").split(',');
                    secIndex = parseInt(secIndices[0]);
                }
                
                
                if(segmentModel.selectionbehavior == constants.SEGUI_SINGLE_SELECT_BEHAVIOR && (segmentModel.hasSections ? (segmentModel.selectedsectionindex == secIndex) && (segmentModel.focusedindex == index) : (segmentModel.focusedindex == index))) {
                    toggleRowSelectionFlag = false;
                }

                if(segmentModel.hasSections) { 
                    segmentModel.selectedsectionindex = secIndex;
                    index = parseInt(secIndices[1]);
                    if(index != -1) {
                        var sectionData = data[secIndex][1 + IndexJL];
                        item = sectionData[index];
                    } else {
                        item = data[secIndex][0 + IndexJL];
                    }
                } else {
                    segmentModel.selectedsectionindex = secIndex;
                    item = segmentModel.data[index];
                }

                if(index != -1) {
                    segmentModel.focusedindex = index;
                    segmentModel.selectedindex = (IndexJL) ? [null, secIndex, index] : [secIndex, index];
                    segmentModel.focuseditem = item;
                    segmentModel.selectedrowindex = (IndexJL) ? [null, secIndex, index] : [secIndex, index];
                    if(!segmentModel.selectionindicator || segmentModel.selectionbehavior == constants.SEGUI_DEFAULT_BEHAVIOR) {
                        segmentModel.selecteditems = (IndexJL) ? [null, item] : [item];
                    }
                }

                segmentModel.currentIndex = [secIndex, index];

                if(item) {
                    item.metainfo = item.metaInfo || item.metainfo;
                }
                var clickable = (item && item.metainfo) ? item.metainfo.clickable : true;
                
                if(segmentModel.selectionindicator && segmentModel.selectionbehavior != constants.SEGUI_DEFAULT_BEHAVIOR && index != -1) {
                    if(!this.isClickableWidget(childModel)) {
                        toggleRowSelectionFlag && this.toggleRowSelection(segmentModel, row.parentNode);
                    } else {
                        if(segmentModel.selectionbehavior == constants.SEGUI_SINGLE_SELECT_BEHAVIOR) {

                            segmentModel.focusedindex = previousRowIndex;
                            segmentModel.selectedrowindex = previousRowIndex;
                        }
                    }
                }

                if(segmentModel.selectionbehavior == constants.SEGUI_DEFAULT_BEHAVIOR) {
                    var selectedRows = IndexJL ? [null] : [];
                    var selectedData = IndexJL ? [null, segmentModel.selectedsectionindex, index] : [segmentModel.selectedsectionindex, index];
                    selectedRows.push(selectedData);
                    segmentModel.selectedRows = (selectedRows && selectedRows.length > IndexJL) ? selectedRows : null;
                    this.setSelectedItemsAndIndices(segmentModel);
                }

                segmentModel.selectedrowindices = segmentModel.selectedindices;

                $KW.Utils.updateContainerMasterData(segmentModel, item, childModel, childNode, eventType);
                segmentModel.currentIndex = [secIndex, index];

                if(clickable && canExecute) {
                    if((segmentModel.onclick || segmentModel.onrowclick) && !childNode.getAttribute("kcontainerID")) { 
                        spaAPM && spaAPM.sendMsg(segmentModel, 'onrowclick');

                        var itemData = module.getRowDataByIndex(segmentModel, (IndexJL) ? [null, secIndex, index] : [secIndex, index]);
                        var segmentref = $KU.returnEventReference(itemData.onclick || itemData.onrowclick || segmentModel.onclick || segmentModel.onrowclick);
                        segmentref && $KU.executeWidgetEventHandler(segmentModel, segmentref, secIndex, index, segmentModel.selectedState); 
                        
                    } else {
                        var clickedIndex = (IndexJL) ? [null, secIndex, index] : [secIndex, index];
                        var eventExecuted = kony.events.executeBoxEvent(childModel, module.getRowDataByIndex(segmentModel, clickedIndex), segmentModel);

                        if(index != -1) { 
                            var itemData = module.getRowDataByIndex(segmentModel, (IndexJL) ? [null, secIndex, index] : [secIndex, index]);
                            if(itemData) {
                                var segmentref = $KU.returnEventReference(itemData.onClick || itemData.onclick || itemData.onRowClick || itemData.onrowclick || segmentModel.onclick || segmentModel.onrowclick);
                            }
                            if(!eventExecuted && segmentref) {
                                if(segmentModel.selectionbehavior == constants.SEGUI_DEFAULT_BEHAVIOR) {
                                    $KU.executeWidgetEventHandler(segmentModel, segmentref, secIndex, index); 
                                } else {
                                    $KU.executeWidgetEventHandler(segmentModel, segmentref, secIndex, index, segmentModel.selectedState); 
                                }
                                $KU.onEventHandler(segmentModel);
                                
                            }
                        }
                    }
                    if(!kony.system.activity.hasActivity())
                        $KW.unLoadWidget();
                }
                
                var childMeta = item[childModel.id];
                if(childMeta && typeof childMeta == "object") {
                    if(childMeta.enable === false)
                        return false;
                }
            }
            return true;
        },

        toggleRowSelection: function(segmentModel, holder) {
            if(typeof segmentModel.selectedindex == "undefined") {
                var secIndex = 0 + IndexJL;
                var rowIndex = segmentModel.focusedindex;
            } else if(segmentModel.selectedindex) {
                var secIndex = segmentModel.selectedindex[0 + IndexJL];
                var rowIndex = segmentModel.selectedindex[1 + IndexJL];
            } else {
                var secIndex = segmentModel.selectedindices[0 + IndexJL][0 + IndexJL];
                var rowIndex = segmentModel.selectedindices[0 + IndexJL][1 + IndexJL][0 + IndexJL];
            }

            

            if(segmentModel.selectionbehavior == constants.SEGUI_MULTI_SELECT_BEHAVIOR) {
                segmentModel.selectedRows = (segmentModel.selectedRows) ? segmentModel.selectedRows : (IndexJL) ? [null] : [];
            } else if(segmentModel.selectionbehavior == constants.SEGUI_SINGLE_SELECT_BEHAVIOR) {
                segmentModel.selectedRows = segmentModel.selectedRows ? segmentModel.selectedRows : (IndexJL) ? [null] : [];
            }
            var data = (IndexJL) ? [null, secIndex, rowIndex] : [secIndex, rowIndex];
            var arrIndex = $KU.arrayIndex(segmentModel.selectedRows, data);
            if(arrIndex != -1) { 
                var selected = false;
                segmentModel.selectedRows.splice(arrIndex, 1);
            } else {
                var selected = true;
                if(segmentModel.selectionbehavior == constants.SEGUI_MULTI_SELECT_BEHAVIOR) {
                    segmentModel.selectedRows.push(data);
                } else {
                    segmentModel.selectedRows = (IndexJL) ? [null, data] : [data];
                }
            }
            segmentModel.selectedRows = (segmentModel.selectedRows && segmentModel.selectedRows.length > IndexJL) ? segmentModel.selectedRows : null;
            this.setSelectedItemsAndIndices(segmentModel);
            var element = $KU.getNodeByModel(segmentModel);
            var itemData = module.getRowDataByIndex(segmentModel, (IndexJL) ? [null, secIndex, rowIndex] : [secIndex, rowIndex]);
            var rowTemplate = itemData.template || itemData.rowtemplate || segmentModel.rowTemplate;
            if(typeof rowTemplate == "string") {
                rowTemplate = _kony.mvc.initializeSubViewController(rowTemplate);
            }
            var imgID = (rowTemplate ? rowTemplate.id : segmentModel.pf) + "_" + segmentModel.selectionindicator;
            var query = " [index='{index}'] [id='" + imgID + "']";
            query = segmentModel.hasSections ? (" ul:nth-child(" + (IndexJL ? secIndex : secIndex + 1) + ") " + query) : query;
            query = "#" + element.id + query;

            if(segmentModel.selectionindicator) {
                var childNode = document.querySelector(query.replace(/\{index\}/g, rowIndex));
                var src = (childNode && childNode.src) || "";
                src = src.substring(src.lastIndexOf("/") + 1, src.length);
                var img;
                var indicator = selected ? segmentModel.selectimage : segmentModel.unselectimage;
                src && (childNode.src = $KU.getImageURL(indicator));
                var rowEle = $KU.getParentByAttribute(childNode, "index");
                if(rowEle) {
                    rowEle.firstChild.setAttribute('aria-selected', selected);
                    selected ? rowEle.firstChild.setAttribute('role', "option") : rowEle.firstChild.removeAttribute('role', "option");
                }
            }
            if(segmentModel.selectionbehavior == constants.SEGUI_SINGLE_SELECT_BEHAVIOR) {
                if(segmentModel.selectionindicator) {
                    this.setImages(segmentModel, segmentModel.selectedRows);
                }
            }
            segmentModel.onselect && segmentModel.onselect(segmentModel, segmentModel.focusedindex, selected);
            segmentModel.selectedState = selected;
        },

        eventHandler: function(eventObject, target, sourceFormID) {
            var segWidgetModel = $KU.getModelByNode(target);
            if(target.getAttribute("kwidgettype") != 'Segment') {
                $KW.Utils.updateContainerData(segWidgetModel, target, true);
            }
        },

        setProgressIndicator: function(link, model) {
            var progressdiv = $KW.Utils.setProgressIndicator($KU.getParentByAttribute(link, kony.constants.KONY_WIDGET_TYPE), model);
            link.insertBefore(progressdiv, link.childNodes[0]);
        },

        setSelectedItemsAndIndices: function(segmentModel, ignoreIndices) {
            if(segmentModel.selectedRows) {
                segmentModel.selecteditems = (IndexJL) ? [null] : [];
                var sections = {};
                for(var i = IndexJL; i < segmentModel.selectedRows.length; i++) {
                    var segIndex = segmentModel.selectedRows[i][0 + IndexJL];;
                    var rowIndex = segmentModel.selectedRows[i][1 + IndexJL];
                    if(!ignoreIndices) {
                        if(!sections[segIndex]) sections[segIndex] = (IndexJL) ? [null] : [];
                        sections[segIndex].push(rowIndex);
                    }
                    if(segmentModel.hasSections) {
                        var sectionData = segmentModel.data[segIndex][1 + IndexJL];
                        var item = sectionData[rowIndex];
                    } else {
                        var item = segmentModel.data[rowIndex];
                    }
                    segmentModel.selecteditems.push(item);
                }
                if(!ignoreIndices) {
                    segmentModel.selectedindices = (IndexJL) ? [null] : [];
                    for(var k in sections) {
                        var section = (IndexJL) ? [null] : [];
                        section.push(parseInt(k, 10));
                        section.push(sections[k]);
                        segmentModel.selectedindices.push(section);
                    }
                }
                segmentModel.selectedindex = segmentModel.selectedRows[segmentModel.selectedRows.length - 1];
                segmentModel.selectedsectionindex = segmentModel.selectedindex[0 + IndexJL];
                segmentModel.focusedindex = segmentModel.selectedindex[1 + IndexJL];
                segmentModel.focuseditem = segmentModel.selecteditems[segmentModel.selecteditems.length - 1];
            } else {
                segmentModel.focusedindex = segmentModel.focuseditem = segmentModel.selectedsectionindex = segmentModel.selectedindex = segmentModel.selecteditems = null;
                if(!ignoreIndices) {
                    segmentModel.selectedindices = null;
                }
            }
        },

        setImages: function(widgetModel, selectedRows) {
            if(widgetModel.selectionbehavior != constants.SEGUI_DEFAULT_BEHAVIOR) {
                var element = $KU.getNodeByModel(widgetModel);
                if(element) {
                    
                    var src = $KU.getImageURL(widgetModel.selectimage);
                    var selectedImages = document.querySelectorAll('#' + element.id + ' li img[src="' + src + '"]');
                    for(var i = 0; i < selectedImages.length; i++) {
                        src = $KU.getImageURL(widgetModel.unselectimage);
                        selectedImages[i].setAttribute('src', src);
                        var rowEle = $KU.getParentByAttribute(selectedImages[i], "index");
                        if(rowEle) {
                            rowEle.firstChild.removeAttribute('aria-selected');
                            rowEle.firstChild.removeAttribute('role', "option");
                        }
                    }

                    if(selectedRows) {
                        if(widgetModel.selectionbehavior == constants.SEGUI_SINGLE_SELECT_BEHAVIOR) {
                            selectedRows = (IndexJL) ? [null, selectedRows[selectedRows.length - 1]] : [selectedRows[selectedRows.length - 1]];
                        }

                        
                        for(var i = IndexJL; i < selectedRows.length; i++) {
                            var itemData = module.getRowDataByIndex(widgetModel, [selectedRows[i][0], selectedRows[i][1]]);
                            var rowTemplate = itemData.template || itemData.rowtemplate || widgetModel.rowTemplate;
                            if(typeof rowTemplate == "string") {
                                rowTemplate = _kony.mvc.initializeSubViewController(rowTemplate);
                            }
                            if(widgetModel.hasSections) {
                                selectedImages = document.querySelectorAll('#' + element.id + ' li[secindex="' + selectedRows[i][0 + IndexJL] + ',' + selectedRows[i][1 + IndexJL] + '"] img#' + rowTemplate.id + '_' + widgetModel.selectionindicator);
                            } else {
                                selectedImages = document.querySelectorAll('#' + element.id + ' li[index="' + selectedRows[i][1 + IndexJL] + '"] img#' + rowTemplate.id + '_' + widgetModel.selectionindicator);
                            }
                            var src = $KU.getImageURL(widgetModel.selectimage);
                            for(var j = 0; j < selectedImages.length; j++) {
                                selectedImages[j].setAttribute('src', src);
                                var rowEle = $KU.getParentByAttribute(selectedImages[i], "index");
                                if(rowEle) {
                                    rowEle.firstChild.setAttribute('aria-selected', true);
                                    rowEle.firstChild.setAttribute('role', "option")
                                }
                            }
                        }
                    }
                }
                widgetModel.selectedRows = selectedRows;
                this.setSelectedItemsAndIndices(widgetModel);
            }
        },

        adjustAlreadySelectedProperties: function(widgetModel, action, secIndex, rowIndex) {
            if(action != "addall") {
                if(action == "setdata" || action == "removeall") {
                    widgetModel.selectedRows = null;
                }
                if(widgetModel.selectedRows) {
                    widgetModel.selectedRows = this.adjustSelectedRows(widgetModel.selectedRows, action, secIndex, rowIndex);
                    widgetModel.selectedRows && (widgetModel.selectedrowindex = widgetModel.selectedRows[widgetModel.selectedRows.length - 1]);
                }
                if(widgetModel.selectedrowindices) {
                    widgetModel.selectedrowindices = this.adjustSelectedRowIndices(widgetModel.selectedrowindices, action, secIndex, rowIndex);
                }
                if(!(widgetModel.viewtype == constants.SEGUI_VIEW_TYPE_PAGEVIEW &&
                    ["setdataat", "adddataat"].indexOf(action)!= -1)) {
                    this.setSelectedItemsAndIndices(widgetModel);
                }
            }
        },

        adjustSelectedRowIndices: function(sIndices, action, secIndex, rowIndex) {
            var sRowArray;
            switch(action) {
                case "addat":
                case "adddataat":
                    for(var i = IndexJL; i < sIndices.length; i++) {
                        sRowArray = sIndices[i][1 + IndexJL];
                        if(sIndices[i][0 + IndexJL] == secIndex) {
                            for(var j = IndexJL; j < sRowArray.length; j++) {

                                if(sRowArray[j] >= rowIndex)
                                    sRowArray[j] = sRowArray[j] + 1;
                            }
                            sIndices[i][1 + IndexJL] = sRowArray;
                        }

                    }

                    break;
                case "setdataat":
                case "removeat":
                    for(var i = IndexJL; i < sIndices.length; i++) {
                        sRowArray = sIndices[i][1 + IndexJL];
                        if(sIndices[i][0 + IndexJL] == secIndex) {
                            var arrIndex = $KU.arrayIndex(sRowArray, IndexJL + rowIndex);
                            if(arrIndex != -1) {
                                sRowArray.splice(arrIndex, 1);
                            }
                            if(action === "removeat") {
                                for(var j = IndexJL; j < sRowArray.length; j++) {
                                    if(sRowArray[j] > rowIndex)
                                        sRowArray[j] = sRowArray[j] - 1;
                                }
                            }
                            sIndices[i][1 + IndexJL] = sRowArray;
                        }
                    }
                    break;
                case "addsectionat":
                    for(var i = IndexJL; i < sIndices.length; i++) {
                        if(sIndices[i][0 + IndexJL] >= secIndex) {
                            sIndices[i][0 + IndexJL] = sIndices[i][0 + IndexJL] + 1;
                        }
                    }
                    break;
                case "removesectionat":
                case "setsectionat":
                    var removeIndexes = [];
                    for(var i = IndexJL; i < sIndices.length; i++) {
                        if(sIndices[i][0 + IndexJL] == secIndex) {
                            removeIndexes.push(i);
                        }
                    }
                    for(var i = 0; i < removeIndexes.length; i++) {
                        sIndices.splice(removeIndexes[i], 1);
                    }
                    if(action == "removesectionat") {
                        for(var i = IndexJL; i < sIndices.length; i++) {
                            if(sIndices[i][0 + IndexJL] > secIndex) {
                                sIndices[i][0 + IndexJL] = sIndices[i][0 + IndexJL] - 1;
                            }
                        }
                    }
                    break;
            }
            return(sIndices.length > IndexJL) ? sIndices : null;
        },

        adjustSelectedRows: function(sRows, action, secIndex, rowIndex) {
            switch(action) {
                case "addat":
                case "adddataat":
                    for(var i = IndexJL; i < sRows.length; i++) {
                        if(sRows[i][0 + IndexJL] == secIndex && sRows[i][1 + IndexJL] >= rowIndex) {
                            sRows[i][1 + IndexJL] = sRows[i][1 + IndexJL] + 1;
                        }
                    }
                    break;
                case "setdataat":
                    var arrIndex = $KU.arrayIndex(sRows, (IndexJL) ? [null, secIndex, rowIndex] : [secIndex, rowIndex]);
                    if(arrIndex != -1) {
                        sRows.splice(arrIndex, 1);
                    }
                    break;
                case "removeat":
                    var arrIndex = $KU.arrayIndex(sRows, (IndexJL) ? [null, secIndex, rowIndex] : [secIndex, rowIndex]);
                    if(arrIndex != -1) {
                        sRows.splice(arrIndex, 1);
                    }
                    for(var i = IndexJL; i < sRows.length; i++) {
                        if(sRows[i][0 + IndexJL] == secIndex && sRows[i][1 + IndexJL] > rowIndex) {
                            sRows[i][1 + IndexJL] = sRows[i][1 + IndexJL] - 1;
                        }
                    }
                    break;
                case "addsectionat":
                    for(var i = IndexJL; i < sRows.length; i++) {
                        if(sRows[i][0 + IndexJL] >= secIndex) {
                            sRows[i][0 + IndexJL] = sRows[i][0 + IndexJL] + 1;
                        }
                    }
                    break;
                case "removesectionat":
                case "setsectionat":
                    var removeIndexes = [];
                    for(var i = IndexJL; i < sRows.length; i++) {
                        if(sRows[i][0 + IndexJL] == secIndex) {
                            removeIndexes.push(i);
                        }
                    }
                    for(var i = 0; i < removeIndexes.length; i++) {
                        sRows.splice(removeIndexes[i], 1);
                    }
                    if(action == "removesectionat") {
                        for(var i = IndexJL; i < sRows.length; i++) {
                            if(sRows[i][0 + IndexJL] > secIndex) {
                                sRows[i][0 + IndexJL] = sRows[i][0 + IndexJL] - 1;
                            }
                        }
                    }
                    break;
            }
            return(sRows.length > IndexJL) ? sRows : null;
        },

        
        calculateSectionRowIndex: function(widgetModel, rowIndex, secIndex, boundaryConditionToBeConsidered) {
            if(typeof boundaryConditionToBeConsidered != "boolean") {
                return boundaryConditionToBeConsidered;
            }
            var result = false;
            rowIndex = (boundaryConditionToBeConsidered && rowIndex < IndexJL) ? IndexJL : rowIndex;
            if(!widgetModel.hasSections) { 
                if(rowIndex < IndexJL || rowIndex >= widgetModel.data.length) { 
                    if(boundaryConditionToBeConsidered) {
                        secIndex = IndexJL;
                        rowIndex = (rowIndex < IndexJL) ? IndexJL : (rowIndex >= widgetModel.data.length) ? widgetModel.data.length : rowIndex;
                        result = [secIndex, rowIndex];
                    }
                } else { 
                    secIndex = IndexJL;
                    result = [secIndex, rowIndex];
                }
            } else { 
                if(typeof secIndex != "number") { 
                    var rowData = null,
                        totalRows = 0,
                        secIndex = IndexJL,
                        tempRowIndex = rowIndex;
                    for(var i = IndexJL; i < widgetModel.data.length; i++) {
                        rowData = widgetModel.data[i][1 + IndexJL];
                        totalRows += rowData.length - IndexJL;
                        if(tempRowIndex >= totalRows + IndexJL) {
                            secIndex++;
                            rowIndex = tempRowIndex - totalRows;
                        } else {
                            break;
                        }
                    }

                    if(secIndex >= widgetModel.data.length) { 
                        if(boundaryConditionToBeConsidered) {
                            secIndex = widgetModel.data.length - 1;
                            result = (widgetModel.data[secIndex]) ? widgetModel.data[secIndex][1 + IndexJL].length : IndexJL;
                            result = [secIndex, rowIndex];
                        }
                    } else { 
                        rowData = widgetModel.data[secIndex][1 + IndexJL];
                        if(rowIndex < IndexJL) {
                            if(boundaryConditionToBeConsidered) {
                                result = [secIndex, IndexJL];
                            }
                        } else if(rowIndex >= rowData.length) { 
                            if(boundaryConditionToBeConsidered) {
                                result = [secIndex, rowData.length];
                            }
                        } else { 
                            result = [secIndex, rowIndex];
                        }
                    }
                } else { 
                    if(secIndex < IndexJL || secIndex >= widgetModel.data.length) { 
                        if(boundaryConditionToBeConsidered) {
                            if(secIndex < IndexJL) {
                                secIndex = IndexJL;
                                if(!widgetModel.data[secIndex]) { 
                                    rowIndex = IndexJL
                                } else {
                                    var rowData = widgetModel.data[secIndex][1 + IndexJL];
                                    if(rowIndex < IndexJL || rowIndex >= rowData.length) { 
                                        if(boundaryConditionToBeConsidered) {
                                            rowIndex = (rowIndex < IndexJL) ? IndexJL : (rowIndex >= widgetModel.data.length) ? widgetModel.data.length : rowIndex;
                                        }
                                    }
                                }
                            } else if(secIndex >= widgetModel.data.length) {
                                secIndex = widgetModel.data.length - IndexJL;
                                rowIndex = (widgetModel.data[secIndex]) ? widgetModel.data[secIndex][1 + IndexJL].length : IndexJL; 
                            }
                            result = [secIndex, rowIndex];
                        }
                    } else { 
                        var rowData = widgetModel.data[secIndex][1 + IndexJL];
                        if(rowIndex < IndexJL || rowIndex >= rowData.length) { 
                            if(boundaryConditionToBeConsidered) {
                                rowIndex = (rowIndex < IndexJL) ? IndexJL : (rowIndex >= rowData.length) ? rowData.length : rowIndex;
                                result = [secIndex, rowIndex];
                            }
                        } else {
                            result = [secIndex, rowIndex];
                        }
                    }
                }
            }
            return result;
        },

        updateSectionContent: function(widgetData, dataArray, action, rowIndex, secIndex) {
            switch(action) {
                case "setsectionat":
                    widgetData.splice(secIndex, 1, dataArray);
                    return;
                    break;
                case "addsectionat":
                    for(var i = IndexJL; i < dataArray.length; i++) {
                        widgetData.splice(secIndex++, 0, dataArray[i]);
                    }
                    return;
                    break;
                case "removesectionat":
                    widgetData.splice(secIndex, 1);
                    return;
                    break;
            }
            if(action == "addall") {
                if(dataArray[IndexJL] instanceof Array) {
                    $KU.addArray(widgetData, dataArray);
                }
            } else {
                var section = widgetData[secIndex];
                var sectionData = section && section[1 + IndexJL];
                if(sectionData) {
                    switch(action) {
                        case "setdataat":
                            sectionData.splice(rowIndex, 1, dataArray);
                            break;
                        case "addat":
                        case "adddataat":
                            if($KU.isArray(dataArray)) {
                                for(var i = IndexJL; i < dataArray.length; i++) {
                                    sectionData.splice(rowIndex++, 0, dataArray[i]);
                                }
                            } else
                                sectionData.splice(rowIndex, 0, dataArray);
                            break;
                        case "removeat":
                            sectionData.splice(rowIndex, 1);
                            break;
                    }
                }
            }
        },

        isSelectionOutOfBound: function(widgetModel, selection) {
            var outOfBound = false,
                secIndex = selection[0 + IndexJL],
                rowIndex = selection[1 + IndexJL];
            if(widgetModel.hasSections) {
                if(secIndex >= widgetModel.data.length) {
                    outOfBound = true;
                } else {
                    var rowData = widgetModel.data[secIndex][1 + IndexJL];
                    if(rowIndex > rowData.length) {
                        outOfBound = true;
                    }
                }
            } else {
                if(rowIndex >= widgetModel.data.length) {
                    outOfBound = true;
                }
            }
            return outOfBound;
        },

        getRowDataByIndex: function(widgetModel, index) { 
            if(widgetModel.data.length > IndexJL) {
                if($KU.isArray(widgetModel.data[0])) { 
                    if(index[IndexJL + 1] == -1) {
                        return widgetModel.data[index[0]][IndexJL];
                    } else {
                        return widgetModel.data[index[0]][IndexJL + 1][index[1]];
                    }
                } else {
                    return widgetModel.data[index[1]];
                }
            }
        },

        animateRows: function(segmentModel, animContext) {
            var element = $KU.getNodeByModel(segmentModel);
            if(!element)
                return;

            if(animContext) {
                var rows = animContext.context || animContext.rows;
                var animInfo = animContext.animation;
                if(!rows || !$KU.isArray(rows) || !animInfo || !animInfo.definition)
                    return;

                var widgetId = animContext.widgetID;
                var widgets = animContext.widgets || [];

                if(widgetId)
                    widgets.push(widgetId);

                this.animatableNodesCounter = 0;
                this.startEventCounter = 0;
                this.endEventCounter = 0;

                if(widgets && widgets.length > 0) {
                    var widgetRef;
                    for(var i = 0; i < rows.length; i++) {
                        var rowContext = rows[i];
                        var secIndex = rowContext.sectionIndex;
                        var rowIndex = rowContext.rowIndex;

                        var clonedTemplate = module.getClonedModel(segmentModel, rowIndex, secIndex);
                        if(!(clonedTemplate instanceof Object))
                            continue;
                        for(var j = 0; j < widgets.length; j++) {
                            widgetRef = clonedTemplate[widgets[j]];
                            if(widgetRef) {
                                var parentModel = widgetRef.parent;
                                if($KW.FlexUtils.isFlexContainer(parentModel)) {
                                    var listItem = module.getNodeByContext(segmentModel, rowContext);
                                    if(module.isTemplateVisible(segmentModel, listItem)) {
                                        var wNode = $KW.Utils.getWidgetNode(widgetRef, listItem);
                                        
                                        if(wNode) {
                                            var animDef = animInfo.definition;
                                            if(animDef.animate) {
                                                this.animatableNodesCounter++;
                                                var flexNode = $KW.Utils.getWidgetNode(parentModel, listItem);
                                                animDef.animate && animDef.animate(widgetRef, animInfo.config, animInfo.callbacks, {
                                                    node: wNode,
                                                    sectionIndex: secIndex,
                                                    rowIndex: rowIndex,
                                                    flexNode: flexNode,
                                                    containerModel: segmentModel,
                                                    widgetModel: widgetRef,
                                                    instance: this
                                                });
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                } else {
                    for(var i = 0; i < rows.length; i++) {
                        var rowContext = rows[i];
                        var listItem = module.getNodeByContext(segmentModel, rowContext);
                        if(listItem && module.isTemplateVisible(segmentModel, listItem) && !listItem.getAttribute('nodeToBeRemoved')) {
                            var secIndex = rowContext.sectionIndex;
                            var rowIndex = rowContext.rowIndex;
                            var clonedTemplate = module.getClonedModel(segmentModel, rowIndex, secIndex);
                            if(!(clonedTemplate instanceof Object))
                                continue;
                            var animDef = animInfo.definition;
                            if(animDef.applyRowAnimation) {
                                this.animatableNodesCounter++;
                                listItem.firstChild.wModel = clonedTemplate;
                                listItem.firstChild.context = {
                                    sectionIndex: secIndex,
                                    rowIndex: rowIndex,
                                    containerModel: segmentModel,
                                    widgetModel: clonedTemplate,
                                    instance: this,
                                    animType: 'segmentRow'
                                };
                                animDef.applyRowAnimation(listItem.firstChild, animInfo.config, animInfo.callbacks);

                            }
                        }
                    }
                }
            }
        },

        isTemplateVisible: function(segmentModel, listItem) {
            var scrollInstance = $KG[$KW.Utils.getKMasterWidgetID(segmentModel) + "_scroller"];
            if(scrollInstance) {
                var scrollTop = Math.abs(scrollInstance.y);
                var scrollBottom = scrollTop + scrollInstance.wrapperH;
                var tempHeight = listItem.offsetHeight;
                var tempTop = listItem.offsetTop;
                var tempBottom = tempTop + tempHeight;
                if(!(scrollBottom < tempTop || scrollTop > tempBottom))
                    return true;
                else
                    return false;
            }
            return true;
        },

        getFirstVisibleRow: function(segModel) {
            var row = this.iterateSegment(segModel, {
                needTopRow: true
            });
            if(row) {
                var context = this.getContextByNode(segModel, row);
                if(context.rowIndex == -1)
                    delete context.rowIndex;
                return context;
            }
            return null;
        },

        getLastVisibleRow: function(segModel) {
            var row = this.iterateSegment(segModel, {
                needBottomRow: true
            });
            if(row) {
                var context = this.getContextByNode(segModel, row);
                if(context.rowIndex == -1)
                    delete context.rowIndex;
                return context;
            }
            return null;
        },

        iterateSegment: function(segModel, config) {
            var node = $KU.getNodeByModel(segModel);
            var data = segModel.data;
            if(!node || !data || data.length == 0 || segModel.viewtype != constants.SEGUI_VIEW_TYPE_TABLEVIEW)
                return null;

            if(segModel.hasSections) {
                var sections = node.children;
                var sec;
                for(var i = 0; i < sections.length; i++) {
                    sec = sections[i];
                    var row = this.iterateAllItems(node, sec, config);
                    if(row)
                        return row;
                }
                return sec.children[sec.children.length - 1];
            } else {
                var ul = node.childNodes[0];
                var row = this.iterateAllItems(node, ul, config);
                if(row)
                    return row;
                else
                    return ul.children[ul.children.length - 1]
            }
        },

        iterateAllItems: function(node, ul, config) {
            var scrollerIns = $KG[node.id + '_scroller'];
            var scrollTop = 0;
            var scrollBottom = 0;
            if(scrollerIns) {
                scrollTop = Math.abs(scrollerIns.y);
                scrollBottom = scrollTop + scrollerIns.wrapperH;
            } else {
                scrollTop = node.scrollTop;
                scrollBottom = scrollTop + node.offsetHeight;
            }
            var rows = ul.children;
            for(var i = 0; i < rows.length; i++) {
                var row = rows[i];
                var rowTop = row.offsetTop;
                var rowBottom = rowTop + row.offsetHeight;
                
                if(config.needTopRow) {
                    if(scrollTop < rowBottom)
                        return row;
                }
                if(config.needBottomRow) {
                    if(scrollBottom < rowTop || scrollBottom <= rowBottom)
                        return row;
                }
            }
        },

        onRowDisplay: function(segModel) {
            var onRowDisplay = segModel.onrowdisplay;
            var listAnimation = segModel.listAnimation;
            if(!listAnimation && onRowDisplay) {
                segModel.listAnimation = new module.setAnimations(segModel);
            }
            if(listAnimation && !onRowDisplay) {
                if(!listAnimation.visibleAnimName && !listAnimation.inVisibleAnimName) {
                    listAnimation.cancelAnim();
                }
            }
        },

        getPortionNumber: function(segModel) {
            var portions = kony.segment.PORTIONS_PER_SEGMENT;
            return parseInt((portions * (segModel.contentOffsetMeasured.y)) / segModel.frame.height);
        },

        isLazyLoadingApplicable: function(segmentModel) {
            return segmentModel.autogrowMode != kony.flex.AUTOGROW_HEIGHT && segmentModel.viewtype == constants.SEGUI_VIEW_TYPE_TABLEVIEW && $KW.FlexUtils.isFlexWidget(segmentModel);
        },

        handleLazyLoadingOnScrollStart: function(segmentModel) {
            return; 
            var currentPortion = module.getPortionNumber(segmentModel);
            if(!segmentModel.currentPortion && currentPortion >= 0) {
                
                segmentModel.currentPortion = currentPortion;
            }
        },

        handleLazyLoadingOnScrollMove: function(segmentModel) {
            if(!module.isLazyLoadingApplicable(segmentModel))
                return;
            var currentPortion = module.getPortionNumber(segmentModel, 2);
            if(currentPortion > segmentModel.currentPortion) {
                
                segmentModel.currentPortion = currentPortion;
                module.renderSegmentTillGivenHeight(segmentModel, $KU.getNodeByModel(segmentModel), true, module.getHeightByNumberOfPortions(segmentModel, 1));
            }
        },

        handleLazyLoadingOnScrollEnd: function(segmentModel) {
            if(!module.isLazyLoadingApplicable(segmentModel))
                return;
            currentPortion = module.getPortionNumber(segmentModel);
            if(currentPortion > segmentModel.currentPortion) {
                
                segmentModel.currentPortion = currentPortion;
                module.renderSegmentTillGivenHeight(segmentModel, $KU.getNodeByModel(segmentModel), true, module.getHeightByNumberOfPortions(segmentModel, 3));
            }
            return true;
        },

        
        generateAndAdjustRow: function(segmentModel, segmentNode, rowIndex, secIndex) {
            var rowNode;

            var data = segmentModel.hasSections ? segmentModel.data[secIndex][1][rowIndex] : segmentModel.data[rowIndex];
            var _html = module.generateRows(segmentModel, segmentModel.context, [data], false, rowIndex, secIndex, false);
            if(!_html) {
                return 0;
            }
            var newRowHolderNode = document.createElement("div");
            newRowHolderNode.innerHTML = _html;
            var sectionNode = segmentModel.hasSections ? segmentNode.children[secIndex] : segmentNode.firstChild;
            _setModalAttributeToSegmentNodes(segmentModel, segmentNode, newRowHolderNode);
            sectionNode.appendChild(newRowHolderNode.firstChild);
            module.adjustFlexContainers(segmentModel, 'adddataat', secIndex, rowIndex);
            var clonedModel = module.getClonedModel(segmentModel, rowIndex, secIndex);
            rowNode = $KW.Segment.getNodeByContext(segmentModel, clonedModel.rowContext, clonedModel);
            rowNode && $KW.Utils.processContainerGestures(clonedModel, rowNode);

            if(segmentModel._searchCondition) {
                if(rowNode.parentNode.style.display == "none")
                    return 0;
            }

            return clonedModel.frame.height;
        },

        
        getLastRenderedRowOfSegment: function(segModel, segNode) {
            var row = {}, lastSectionIndex;
            if(segModel.hasSections) {
                if(segModel.clonedTemplates.length == 0) {
                    row = {sectionIndex: 0, rowIndex : 0};
                } else {
                    lastSectionIndex = segModel.clonedTemplates.length - 1;
                    row.sectionIndex = lastSectionIndex;
                    if(segModel.clonedTemplates[lastSectionIndex][1].length) {
                        row.rowIndex = segModel.clonedTemplates[lastSectionIndex][1].length - 1;
                    } else {
                        row.rowIndex = 0;
                    }
                }
            } else {
                if(segModel.clonedTemplates.length == 0) {
                    row = {rowIndex : 0};
                } else {
                    row.rowIndex = segModel.clonedTemplates.length - 1;
                }
            }
            return row;
        },

        
        generateAndAdjustHeader: function(segmentModel, segmentNode, secIndex) {
            if(module.isRenderedAllRows(segmentModel, -1, secIndex))
                return 0;
            var data = segmentModel.data[secIndex][0];
            var _html = module.generateRows(segmentModel, segmentModel.context, [
                [data, []]
            ], false, -1, secIndex, false);
            if(!_html) {
                return 0;
            }
            var newRowHolderNode = document.createElement("div");
            newRowHolderNode.innerHTML = _html;
            _setModalAttributeToSegmentNodes(segmentModel, segmentNode, newRowHolderNode);
            segmentNode.appendChild(newRowHolderNode.firstChild);
            secHeaderNode = segmentNode.lastChild;
            var flexNode = secHeaderNode.querySelector('div[kwidgettype="FlexContainer"]');
            if(flexNode) {
                var flexModel = module.getClonedModel(segmentModel, -1, secIndex);
                $KW.FlexContainer.forceLayout(flexModel, flexNode.parentNode);
                $KW.Utils.processContainerGestures(flexModel, flexNode);
            }

            if(segmentModel._searchCondition) {
                module.toggleHeaderVisibility(segmentModel, segmentNode.children[secIndex]);
                return 0;
            }

            return flexModel.frame.height;
        },

        
        generateAndAdjustSegmentTillContentOffSetReached: function(segmentModel, segmentNode, contentOffsetTopValue) {
            var renderedHeight = segmentNode.scrollHeight;
            var heightToBeRendered = contentOffsetTopValue + module.getHeightByNumberOfPortions(segmentModel, 3) - renderedHeight; 
            heightToBeRendered > 0 && module.renderSegmentTillGivenHeight(segmentModel, segmentNode, true, heightToBeRendered);
        },
        
        generateAndAdjustSegmentTillGivenIndexReached: function(segmentModel, segmentNode, selectedIndex) { 
            var rowIndex = selectedIndex[1];
            var sectionIndex = selectedIndex[0];
            var lastRow = module.getLastRenderedRowOfSegment(segmentModel, segmentNode);
            var renderedSpecifiedRow = false;
            if(segmentModel.hasSections) {
                if(sectionIndex < lastRow.sectionIndex || (sectionIndex == lastRow.sectionIndex && rowIndex <= lastRow.rowIndex)) {
                    renderedSpecifiedRow = true;
                }
            } else {
                if(rowIndex <= lastRow.rowIndex) {
                    renderedSpecifiedRow = true;
                }
            }
            if(renderedSpecifiedRow) {
                return;
            }
            module.renderSegmentTillGivenHeight(segmentModel, segmentNode, false);
            module.generateAndAdjustSegmentTillGivenIndexReached(segmentModel, segmentNode, selectedIndex);
        },

        thingsToDoAfterSegmentRendering: function(segModel, segNode, row, refreshScrollerInstance) {
            refreshScrollerInstance && module.refreshScrollerInstance(segModel);
            if(!segModel.hasSections) {
                module.applyRowSkin(segModel, segNode.childNodes[0], row.rowIndex);
            } else {
                module.applySectionRowSkin(segModel, segNode, row.rowIndex, row.sectionIndex);
            }
            segModel.listAnimation && segModel.listAnimation.initialized && segModel.listAnimation.syncList();

        },

        renderSegmentTillGivenHeight: function(segModel, segNode, refreshScrollerInstance, height) {
            var row = module.getLastRenderedRowOfSegment(segModel, segNode);
            
            if(module.isRenderedAllRows(segModel, row.rowIndex + 1, row.sectionIndex)) {
                return;
            }
            module.adjustFlexContainersInSegmentPage(segModel, segNode, row.rowIndex + 1, row.sectionIndex || 0, height);
            module.thingsToDoAfterSegmentRendering(segModel, segNode, row, refreshScrollerInstance);
            
            segModel.handleForceDragTimeout && clearTimeout(segModel.handleForceDragTimeout);
            segModel.handleForceDragTimeout = setTimeout(function() {
                var currentPortion = module.getPortionNumber(segModel);
                segModel.handleForceDragTimeout = null;
                if(currentPortion > segModel.currentPortion) {
                    segModel.currentPortion = currentPortion;
                    module.renderSegmentTillGivenHeight(segModel, segNode, false, height);
                }
            }, 500);
        },

        
        isRenderedAllRows: function(segModel, rowIndex, secIndex) {
            if(segModel.hasSections) {
                return segModel.data.length <= secIndex;
            } else {
                return segModel.data.length <= rowIndex;
            }
        },

        
        adjustFlexContainersInSegmentPage: function(segModel, segNode, rowIndex, secIndex, height) {
            var heightPending = height || segModel.frame.height;
            var heightSum = 0;
            var rowsData = [];
            if(segModel.hasSections)
                rowsData = segModel.data[secIndex] ? segModel.data[secIndex][1] : [];
            else
                rowsData = segModel.data;

            for(var i = rowIndex; i < rowsData.length; i++) {
                
                if(i == -1) {
                    heightSum += module.generateAndAdjustHeader(segModel, segNode, secIndex);
                } else {
                    heightSum += module.generateAndAdjustRow(segModel, segNode, i, secIndex);
                }
                if(heightSum >= heightPending) {
                    if(i === -1) {
                        module.generateAndAdjustRow(segModel, segNode, 0, secIndex);
                    }
                    break;
                }
            }

            if(segModel.hasSections && segModel._searchCondition) {
                module.toggleHeaderVisibility(segModel, segNode.children[secIndex]);
            }

            if(heightSum < heightPending && segModel.hasSections && !module.isRenderedAllRows(segModel, -1, secIndex + 1)) {
                module.adjustFlexContainersInSegmentPage(segModel, segNode, -1, secIndex + 1, heightPending - heightSum);
            }
        },

        adjustFlexContainersInSegmentAtRenderTime: function(segmentModel, segNode) {
            var row = module.getLastRenderedRowOfSegment(segmentModel, segNode);
            if(segmentModel.hasSections) {
                module.adjustFlexContainersInSegmentPage(segmentModel, segNode, -1, 0);
            } else {
                module.adjustFlexContainersInSegmentPage(segmentModel, segNode, 0, 0);
            }

            module.thingsToDoAfterSegmentRendering(segmentModel, segNode, row, false);
            module.renderSegmentTillGivenHeight(segmentModel, segNode, false, segmentModel.frame.height * 2);
            if(segmentModel.retainselection && segmentModel.selectedindex) {
                module.generateAndAdjustSegmentTillGivenIndexReached(segmentModel, segNode, segmentModel.selectedindex);
                module.renderSegmentTillGivenHeight(segmentModel, segNode, true, module.getHeightByNumberOfPortions(segmentModel, 3));
            }
            segmentModel.currentPortion = 0;
        },

        clearSearch: function(segmentModel) {
            var segNode, sectionNodes, rowNodes, secLen, rowLen, i, j;

            segmentModel._searchCondition = [];
            segmentModel._config = {};
            segNode = $KU.getNodeByModel(segmentModel);
            sectionNodes = segNode.children;
            secLen = sectionNodes.length;
            if(segmentModel.hasSections) {
                for(i = 0; i < secLen; i++) {
                    rowNodes = sectionNodes[i].childNodes;
                    rowLen = rowNodes.length;
                    for(j = 0; j < rowLen; j++) {
                        rowNodes[j].style.display = "block";
                    }
                }
            } else {
                rowNodes = sectionNodes[0].childNodes;
                rowLen = rowNodes.length;
                for(i = 0; i < rowLen; i++) {
                    rowNodes[i].style.display = "block";
                }
            }
        },

        getUpdatedSearchResults: function(segmentModel) {
            return module.getFilteredData(segmentModel);
        },

        searchText: function(searchCondition, config, segmentModel) {
            var callback = null, segNode = null, updateSegment = true, l = 0,
                filteredResult, lis = [], llen = 0;

            if(typeof config.updateSegment === 'boolean') {
                updateSegment = config.updateSegment;
            }

            if(typeof config.showSectionHeaderFooter != 'boolean') {
                config.showSectionHeaderFooter = true;
            }

            segmentModel._searchCondition = searchCondition;
            segmentModel._config = config;
            filteredResult = module.getFilteredData(segmentModel);
            if(updateSegment) {
                module.setResultOnSegmentUI(segmentModel);
            }
            return filteredResult;
        },

        getFilteredData: function(segmentModel) {
            var result = [], i = 0, j = 0, matched = false;
            var masterData = segmentModel.data;

            if(!segmentModel._searchCondition) return;

            if(segmentModel.hasSections) {
                for(i = 0; i < masterData.length; i++) {
                    for(j = 0; j < masterData[i][1].length; j++) {
                        matched = module.isRowMatchingSearchCriteria(segmentModel, masterData[i][1][j]);

                        if(matched) {
                            result.push([i, j]);
                        }

                    }
                }
            } else {
                for(i = 0; i < masterData.length; i++) {
                    matched = module.isRowMatchingSearchCriteria(segmentModel, masterData[i]);

                    if(matched) {
                        result.push([0, i]);
                    }

                }
            }

            return result;
        },


        isRowMatchingSearchCriteria : function(segmentModel, rowData) {
            var string, matched;
            var searchCondition = segmentModel._searchCondition;

            string = module.generateExpression(segmentModel, rowData, searchCondition);
            matched = eval(string);

            return matched;
        },

        generateExpression: function(segmentModel, rowData, searchCondition) {
            var string = '', i;
            var len = searchCondition.length;

            if(typeof searchCondition === 'object' && searchCondition.length == 1) {
                string += module.isOperandPassed(segmentModel, rowData, searchCondition[0]);
                return ('(' + string + ')');
            }

            for(i = 0; i < len; i++) {
                if(searchCondition[i] instanceof Array) {
                    string += module.generateExpression(segmentModel, rowData, searchCondition[i]);
                } else if(typeof searchCondition[i] === 'string') {
                    if(searchCondition[i] === constants.SEGUI_SEARCH_CRITERIA_OPERATOR_AND) {
                        operator = "&&";
                    } else {
                        operator = "||";
                    }

                    string += (' ' + operator + ' ');
                } else if(typeof searchCondition[i] === 'object' && searchCondition[i]) {
                    string += module.isOperandPassed(segmentModel, rowData, searchCondition[i]);
                }
            }
            return ('(' + string + ')');
        },

        isOperandPassed: function(segmentModel, rowData, searchCondition) {
            var caseSensitive, widgetList, caseSensitive, searchType,
                searchText, i, ilen, passed = false;

            if(typeof searchCondition.caseSensitive !== 'boolean') caseSensitive = true;
            caseSensitive = searchCondition.caseSensitive;

            if(searchCondition.searchableWidgets) {
                widgetList = searchCondition.searchableWidgets;
            } else {
                widgetList = module.getWidgetIdsFromRowData(segmentModel, rowData);
            }

            ilen = widgetList.length
            searchText = searchCondition.textToSearch;
            searchType = searchCondition.searchType ? searchCondition.searchType
                                                    : constants.SEGUI_SEARCH_CRITERIA_CONTAINS;

            for(i = 0; i < ilen; i++) {
                if(module.isOperandPassedByWidgetId(
                    segmentModel,
                    rowData,
                    widgetList[i],
                    caseSensitive,
                    searchType,
                    searchText
                )) {
                    passed = true;
                    break;
                }
            }

            return passed;
        },

        getWidgetIdsFromRowData: function(segmentModel, rowData) {
           var rowDataIds = Object.keys(rowData), r = 0,
               widgetdatamap = segmentModel.widgetdatamap,
               rlen = rowDataIds.length, widgetId = '',
               invertedDataMap = {}, widgetIds = [], rowDataId = '';

           for(widgetId in widgetdatamap) {
               if(widgetdatamap.hasOwnProperty(widgetId)) {
                   rowDataId = widgetdatamap[widgetId];
                   invertedDataMap[rowDataId] = widgetId;
               }
           }

           for(r = 0; r < rlen; r++) {
               widgetIds.push(invertedDataMap[rowDataIds[r]]);
           }

           return widgetIds;
        },

        isOperandPassedByWidgetId: function(segmentModel, rowData, widgetId, caseSensitive, searchType, searchText) {
            var passed = false, rowDataId = segmentModel.widgetdatamap[widgetId],
                info = module.infoOfSearchableWidgetInRow(
                    segmentModel, rowData, rowDataId, widgetId
                );

            if(info.isValid) {
                passed = module.matchWithConditionalOperator(
                    info.widgetType,
                    searchType,
                    searchText,
                    info.widgetText,
                    caseSensitive
                );
            }

            return passed;
        },

        infoOfSearchableWidgetInRow: function(segmentModel, rowData, rowDataId, widgetId) {
            var info = {isValid: false}, templateModel = null, widget = null, widgetData = null,
                validWidgetList = ['Button', 'Label', 'TextArea', 'TextField', 'Calendar'],
                validTextPropWidgetList = ['Button', 'Label', 'TextArea', 'TextField'];

            if(typeof rowDataId === 'string' && rowDataId
            && typeof widgetId === 'string' && widgetId
            && rowData.hasOwnProperty(rowDataId)) {
                widgetData = rowData[rowDataId];
                templateModel = rowData.template || segmentModel.rowtemplate;

                if(typeof templateModel === 'string') {
                    templateModel = _kony.mvc.initializeSubViewController(templateModel);
                }

                if(templateModel) {
                    !templateModel.pf && _konyConstNS.Form2.addHeaderorFooter.call(templateModel, templateModel);
                }

                widget = $KU.getValueFromObjectByPath(widgetId, templateModel);

                if(widget) {
                    info.widgetType = widget = widget.wType;

                    if(validWidgetList.indexOf(widget) !== -1) {
                        if(validTextPropWidgetList.indexOf(widget) !== -1) {
                            info.isValid = true;
                            info.widgetText = (typeof widgetData === 'string')
                                             ? widgetData : widgetData.text;
                        } else if(widget === 'Calendar') {
                            info.isValid = true;
                            info.widgetText = (widgetData instanceof Array)
                                             ? widgetData : widgetData.dateComponents;
                        }
                    }
                }
            }

            return info;
        },

        matchWithConditionalOperator: function(widgetType, searchType, searchText, widgetText, caseSensitive) {
            var matched = false, substring = '';

            if(!caseSensitive && typeof searchText === 'string') {
                searchText = searchText.toUpperCase();
            }

            if(!caseSensitive && typeof widgetText === 'string') {
                widgetText = widgetText.toUpperCase();
            }

            switch(searchType) {
                case constants.SEGUI_SEARCH_CRITERIA_CONTAINS :
                    if(typeof widgetText === 'string'
                    && widgetText.indexOf(searchText) !== -1) {
                        matched = true;
                    }
                break;

                case constants.SEGUI_SEARCH_CRITERIA_ENDSWITH :
                    substring = typeof widgetText === 'string'
                              ? widgetText.substr(-searchText.length) : null;

                    if(searchText === substring) {
                        matched = true;
                    }
                break;

                case constants.SEGUI_SEARCH_CRITERIA_STARTSWITH :
                    substring = typeof widgetText === 'string'
                              ? widgetText.substr(0, searchText.length) : null;

                    if(searchText === substring) {
                        matched = true;
                    }
                break;

                case constants.SEGUI_SEARCH_CRITERIA_GREATER :
                    if(widgetType === 'Calendar' && searchText instanceof Array) {
                        widgetText = module.convertDateToNumber(widgetText);
                        searchText = module.convertDateToNumber(searchText);

                        if(typeof widgetText === 'number' && typeof searchText === 'number') {
                            matched = (widgetText > searchText) ? true : false;
                        }
                    } else {
                        widgetText = module.convertStringToNumber(widgetText);
                        searchText = module.convertStringToNumber(searchText);

                        if(typeof widgetText === 'number' && typeof searchText === 'number') {
                            matched = (widgetText > searchText) ? true : false;
                        }
                    }
                break;

                case constants.SEGUI_SEARCH_CRITERIA_GREATER_EQUAL :
                    if(widgetType === 'Calendar' && searchText instanceof Array) {
                        widgetText = module.convertDateToNumber(widgetText);
                        searchText = module.convertDateToNumber(searchText);

                        if(typeof widgetText === 'number' && typeof searchText === 'number') {
                            matched = (widgetText >= searchText) ? true : false;
                        }
                    } else {
                        widgetText = module.convertStringToNumber(widgetText);
                        searchText = module.convertStringToNumber(searchText);

                        if(typeof widgetText === 'number' && typeof searchText === 'number') {
                            matched = (widgetText >= searchText) ? true : false;
                        }
                    }
                break;

                case constants.SEGUI_SEARCH_CRITERIA_LESSER :
                    if(widgetType === 'Calendar' && searchText instanceof Array) {
                        widgetText = module.convertDateToNumber(widgetText);
                        searchText = module.convertDateToNumber(searchText);

                        if(typeof widgetText === 'number' && typeof searchText === 'number') {
                            matched = (widgetText < searchText) ? true : false;
                        }
                    } else {
                        widgetText = module.convertStringToNumber(widgetText);
                        searchText = module.convertStringToNumber(searchText);

                        if(typeof widgetText === 'number' && typeof searchText === 'number') {
                            matched = (widgetText < searchText) ? true : false;
                        }
                    }
                break;

                case constants.SEGUI_SEARCH_CRITERIA_LESSER_EQUAL :
                    if(widgetType === 'Calendar' && searchText instanceof Array) {
                        widgetText = module.convertDateToNumber(widgetText);
                        searchText = module.convertDateToNumber(searchText);

                        if(typeof widgetText === 'number' && typeof searchText === 'number') {
                            matched = (widgetText <= searchText) ? true : false;
                        } else matched = true;
                    } else {
                        widgetText = module.convertStringToNumber(widgetText);
                        searchText = module.convertStringToNumber(searchText);

                        if(typeof widgetText === 'number' && typeof searchText === 'number') {
                            matched = (widgetText <= searchText) ? true : false;
                        }
                    }
                break;

                case constants.SEGUI_SEARCH_CRITERIA_STRICT_EQUAL :
                    if(widgetType === 'Calendar' && searchText instanceof Array) {
                        widgetText = module.convertDateToNumber(widgetText);
                        searchText = module.convertDateToNumber(searchText);

                        if(typeof widgetText === 'number' && typeof searchText === 'number') {
                            matched = (widgetText === searchText) ? true : false;
                        } else matched = true;
                    } else {
                        widgetText = module.convertStringToNumber(widgetText);
                        searchText = module.convertStringToNumber(searchText);

                        matched = (widgetText === searchText) ? true : false;
                    }
                break;

                case constants.SEGUI_SEARCH_CRITERIA_NOT_EQUAL :
                    if(widgetType === 'Calendar' && searchText instanceof Array) {
                        widgetText = module.convertDateToNumber(widgetText);
                        searchText = module.convertDateToNumber(searchText);

                        if(typeof widgetText === 'number' && typeof searchText === 'number') {
                            matched = (widgetText === searchText) ? true : false;
                        } else matched = true;
                    } else {
                        widgetText = module.convertStringToNumber(widgetText);
                        searchText = module.convertStringToNumber(searchText);

                        matched = (widgetText !== searchText) ? true : false;
                    }
                break;

                case constants.SEGUI_SEARCH_CRITERIA_NOT_CONTAINS :
                    if(typeof widgetText === 'string'
                    && widgetText.indexOf(searchText) === -1) {
                        matched = true;
                    }
                break;

                case constants.SEGUI_SEARCH_CRITERIA_NOT_ENDSWITH :
                    substring = typeof widgetText === 'string' ?
                                widgetText.substr(-searchText.length) : null;

                    if(searchText !== substring) {
                        matched = true;
                    }
                break;

                case constants.SEGUI_SEARCH_CRITERIA_NOT_STARTSWITH :
                    substring = typeof widgetText === 'string' ?
                                widgetText.substr(searchText.length) : null;

                    if(searchText !== substring) {
                        matched = true;
                    }
                break;
            }

            return matched;
        },

        convertStringToNumber: function(widgetData){
            var regx = new RegExp(/^\s*((\d+(\.\d+)?)|(\.\d+))\s*$/);

            if(regx.test(widgetData)) {
                widgetData = parseFloat(widgetData);
            }

            return widgetData;
        },

        convertDateToNumber: function(dc) {
            var dateNumber, valid = false;

            var isLeapYear = function(year) {
                var date = new Date(year, 1, 29, 0, 0, 0);
                return (date.getMonth() === 2) ? false : true;
            };

            var isValidDate = function(date, month, year) {
                if([1, 3, 5, 7, 8, 10, 12].indexOf(month) != -1
                && date >= 1 && date <= 31) {
                    return true;
                } else if([4, 6, 9, 11].indexOf(month) != -1
                && date >= 1 && date <= 30) {
                    return true;
                } else if(month === 2 && date >= 1) {
                    if(isLeapYear(year)) {
                        if(date <= 29) return true;
                    } else {
                        if(date <= 28) return true;
                    }
                } else {
                    return false;
                }
            };

            if($KU.isArray(dc) && [0, 3, 6].indexOf(dc.length) >= 0) {
                if(dc.length === 0) {
                    return 0;
                }

                
                if(typeof dc[2] === 'number' && dc[2] >= 1900 && dc[2] <= 2099
                && typeof dc[1] === 'number' && dc[1] >= 1 && dc[1] <= 12
                && isValidDate(dc[0], dc[1], dc[2])) {
                    valid = true;
                    dateNumber = new Date(dc[2], dc[1], dc[0]).getTime();
                } else return null;

                if(valid && dc.length === 6
                && typeof dc[3] === 'number' && dc[3] >= 0 && dc[3] <= 23
                && typeof dc[4] === 'number' && dc[4] >= 0 && dc[4] <= 59
                && typeof dc[5] === 'number' && dc[5] >= 0 && dc[5] <= 59) {
                    dateNumber = new Date(dc[2], dc[1], dc[0], dc[3], dc[4], dc[5]).getTime();
                }
            } else if(dc === null) {
                return 0;
            } else return null;

            return dateNumber;
        },

        setResultOnSegmentUI: function(segmentModel) {
            module.setFilterResultOnRenderedData(segmentModel);
            if(segmentModel.hasSections) module.setResultOnSegmentHeader(segmentModel);
            module.renderSegmentTillGivenHeight(segmentModel, $KU.getNodeByModel(segmentModel), true, module.getHeightByNumberOfPortions(segmentModel, 4));
        },

        setFilterResultOnRenderedData: function(segmentModel, segmentNode) {
            var segNode, visibility, secLen, rowLen, i, j;
            var sectionNodes, rowNodes, rowIndex;

            segNode = segmentNode || $KU.getNodeByModel(segmentModel);
            sectionNodes = segNode.children;
            secLen = sectionNodes.length;

            if(segmentModel.hasSections) {
                for(i = 0; i < secLen; i++) {
                    rowNodes = sectionNodes[i].childNodes;
                    rowLen = rowNodes.length;
                    for(j = 0; j < rowLen; j++) {
                        if(!rowNodes[j+1]) break;
                        rowIndex = rowNodes[j+1].getAttribute("index");
                        rowIndex = parseInt(rowIndex);
                        visibility = module.isRowVisible(segmentModel, rowNodes[j+1], rowIndex, i);
                    }
                }
            } else {
                rowNodes = sectionNodes[0].childNodes;
                rowLen = rowNodes.length;
                for(i = 0; i < rowLen; i++) {
                    rowIndex = rowNodes[i].getAttribute("index");
                    rowIndex = parseInt(rowIndex);
                    visibility = module.isRowVisible(segmentModel, rowNodes[i], rowIndex, 0);
                }
            }

        },

        isRowVisible: function (segmentModel, rowNode, rowIndex, sectionIndex) {
            var rowData = {};
            var matched = false;

            if(segmentModel.hasSections) rowData = segmentModel.data[sectionIndex][1][rowIndex];
            else rowData = segmentModel.data[rowIndex];

            matched = module.isRowMatchingSearchCriteria(segmentModel, rowData);

            if(matched) {
                rowNode.style.display = "block";
                return true;
            } else {
                rowNode.style.display = "none";
                return false;
            }

        },

        setResultOnSegmentHeader: function(segmentModel) {
            var segNode, sectionNodes, secLen, i;

            segNode = $KU.getNodeByModel(segmentModel);
            sectionNodes = segNode.children;
            secLen = sectionNodes.length;

            for(i = 0; i < secLen; i++) {
                module.toggleHeaderVisibility(segmentModel, sectionNodes[i]);
            }

        },

        toggleHeaderVisibility: function(segmentModel, sectionNode) {
            var headerNode, rowNodes;

            headerNode = sectionNode.childNodes[0];
            headerNode.style.display = "none";

            if(segmentModel._config.showSectionHeaderFooter) {
                rowNodes = sectionNode.querySelector(
                    'li:not([style*="display:none"]):not([style*="display: none"])'
                );
                if(rowNodes) headerNode.style.display = "block";
            }

        },

    
    registerScrollEvents: function(segmentModel) {
        segmentModel.enableScrolling = true;
        segmentModel.scrolldirection = kony.flex.SCROLL_VERTICAL;
        segmentModel.onScrollStart = module.handleLazyLoadingOnScrollStart;
        segmentModel.onScrolling = module.handleLazyLoadingOnScrollMove;
        segmentModel.onScrollEnd = module.handleLazyLoadingOnScrollEnd;
    },
    
    onHeightChangedToPreferredFromFixed: function(segmentModel, segNode) {
        var lastRowIndex = [],
            lastSectionIndex;
        segmentModel.previousHeight = undefined;
        if(segmentModel.hasSections) {
            lastSectionIndex = segmentModel.data.length - 1;
            lastRowIndex[0] = lastSectionIndex;
            lastRowIndex[1] = segmentModel.data[lastSectionIndex][1].length - 1;
        } else {
            lastRowIndex[0] = 0;
            lastRowIndex[1] = segmentModel.data.length - 1;
        }
        module.generateAndAdjustSegmentTillGivenIndexReached(segmentModel, segNode, lastRowIndex);
    },

    getHeightByNumberOfPortions: function(segmentModel, numberOfPortions) {
        var portionSize = segmentModel.frame.height / kony.segment.PORTIONS_PER_SEGMENT;
        return portionSize * numberOfPortions;
    },

    isSegmentVisible: function(segmentModel) {
        var pModel = null;
        if(!segmentModel.isvisible) {
            return false;
        }
        pModel = segmentModel.parent;
        while(pModel) {
            if (!pModel.isvisible) {
                return false;
            }
            pModel = pModel.parent;
        }
        return true;
    },
    
    isRenderRequired: function(segModel, segNode, action, row) {
        var lastRow = module.getLastRenderedRowOfSegment(segModel, segNode);
        var rowIndexCheckNeeded = false, sectionIndexCheckNeeded = false;
        var rowContext;
        var _getRowContextToCompare = function() {
            var results = {};
            if(['setdataat', 'setsectionat', 'removeat', 'removesectionat'].indexOf(action) != -1){
                return lastRow;
            }
            if(segModel.hasSections) {
                
                if(sectionIndexCheckNeeded && segModel.data[lastRow.sectionIndex][1].length == lastRow.rowIndex + 1) {
                    results.sectionIndex = lastRow.sectionIndex + 1;
                    results.rowIndex = 0;
                } else {
                    results.sectionIndex = lastRow.sectionIndex;
                    results.rowIndex = lastRow.rowIndex + 1;
                }

            } else {
                results.rowIndex = lastRow.rowIndex + 1;
            }
            return results;
        };
        if(['setdataat', 'removeat', 'addat', 'adddataat', 'addall'].indexOf(action) != -1) {
            rowIndexCheckNeeded = true;
        }
        if(['setsectionat', 'removesectionat', 'addsectionat', 'addall'].indexOf(action)!= -1) {
            sectionIndexCheckNeeded = true;
        }
        rowContext = _getRowContextToCompare();
        if(segModel.hasSections) {
            if(sectionIndexCheckNeeded) {
                if(row.sectionIndex > rowContext.sectionIndex) return false;
            } else {
                if(row.sectionIndex > rowContext.sectionIndex
                || (row.sectionIndex == lastRow.sectionIndex && row.rowIndex > rowContext.rowIndex)) {
                    return false;
                }
            }
        } else {
            if(rowIndexCheckNeeded && row.rowIndex > rowContext.rowIndex) return false;
        }
       
        if(['setdataat','setsectionat','removeat', 'removesectionat'].indexOf(action) != -1) {
            segModel.currentPortion =  module.getPortionNumber(segModel);
            module.renderSegmentTillGivenHeight(segModel, segNode, true, module.getHeightByNumberOfPortions(segModel, 4));
        }
        return true;
    },
    
    updateScrollTopOnScroll: function(segModel) {
        segModel.__y = segModel.contentOffsetMeasured.y;
    },

    registerSwipeGesture: function(widgetModel, widgetNode) {
        this.translateX = 0;
        this.transformProperty = kony.ui.makeAffineTransform();
        this.containerModel = widgetModel.containerId && $KW.Utils.getContainerModelById(widgetNode, widgetModel.containerId);
        this.useTranslate = widgetModel.widgetswipemove.translate;
        if(typeof widgetModel.widgetswipemove.minDeltaToInitiateSwipe === "undefined") {
            this.minDeltaToInitiateSwipe = 30;
        } else {
            this.minDeltaToInitiateSwipe = this.getValue(widgetModel, widgetModel.widgetswipemove.minDeltaToInitiateSwipe);
        }
        this.boundaryMin = this.getValue(widgetModel, widgetModel.widgetswipemove.Xboundaries[0]);
        this.boundaryMax = this.getValue(widgetModel, widgetModel.widgetswipemove.Xboundaries[1]);
    },

    resetSwipe: function(segmentModel, rowContext) {
        var _resetTranslateX = function(widgetModel, widgetNode) {
            var transformProperty = kony.ui.makeAffineTransform();
            var style, panInstance = widgetModel.swipeConfig;
            if(!panInstance) return;
            transformProperty.translate(0, 0);
            style = $KW.animUtils.applyTransform(widgetModel, transformProperty);
            widgetNode.style["transition"] = "transform 0.5s";
            widgetNode.style[vendor + "Transform"] = style;
            widgetNode.style["transform"] = style;
            panInstance.translateX = 0;
            panInstance.useTranslate = widgetModel.widgetswipemove.translate;
            panInstance.boundaryMin = panInstance.getValue(widgetModel, widgetModel.widgetswipemove.Xboundaries[0]);
            panInstance.boundaryMax = panInstance.getValue(widgetModel, widgetModel.widgetswipemove.Xboundaries[1]);
        };
        var _resetSwipeOnModel = function(wModel, wNode) {
            var i, widgets, childModel, childNode;
            if(wModel.widgetswipemove) {
                _resetTranslateX(wModel, wNode);
            }
            if($KW.FlexUtils.isFlexContainer(wModel)) {
                widgets = wModel.widgets();
                for(i = 0; i < widgets.length; i++) {
                    childModel = $KW.Utils.getActualWidgetModel(widgets[i]);
                    childNode = $KW.Utils.getView(childModel, wNode);
                    childNode = childNode.parentNode;
                    childNode && _resetSwipeOnModel(childModel, childNode);
                }
            }
        };
        var rowModel, rowNode;
        if(segmentModel.clonedTemplates && segmentModel.clonedTemplates.length) {
            if(!segmentModel.hasSections || (segmentModel.hasSections && segmentModel.clonedTemplates.length >= rowContext.secIndex)) {
                rowModel = module.getClonedModel(segmentModel, rowContext.rowIndex, rowContext.secIndex);
                rowNode = module.getNodeByContext(segmentModel, rowContext);
                rowNode && _resetSwipeOnModel(rowModel, rowNode);
            }
        }
    },

    resetSwipeMoveConfigOnTouchStart: function(widgetNode) {
        var _compareRowContexts = function(rowContext1, rowContext2) {
            if(rowContext1 && rowContext2) {
                if((rowContext1.sectionIndex === rowContext2.sectionIndex)
                && (rowContext1.rowIndex === rowContext2.rowIndex)) {
                    return true;
                }
            }
            return false;
        };
        var containerId = widgetNode && widgetNode.getAttribute("kcontainerID");
        var segmentModel = $KW.Utils.getContainerModelById(widgetNode, containerId);
        var context = module.getContextByNode(segmentModel, widgetNode);
        if(segmentModel.swipeSelectedConfig) {
             var currentRowContext = {
                'rowIndex': context.rowIndex,
                'sectionIndex': context.sectionIndex || 0
             }
            if(!_compareRowContexts(currentRowContext, segmentModel.swipeSelectedConfig.rowContext)) {
                module.resetSwipe(segmentModel, segmentModel.swipeSelectedConfig.rowContext);
                segmentModel.swipeSelectedConfig = null;
            }
        }
    }
};

    module.setAnimations = function(segModel, animInfo) {
        this.widgetModel = segModel;
        if(animInfo) {
            var visibleAnim = animInfo.visible;
            if(visibleAnim) {
                var animDef = visibleAnim.definition;
                if(animDef && animDef.getAnimationName) {
                    this.visibleAnimName = animDef.getAnimationName(visibleAnim.config, 'visible');
                }
            }
            var inVisibleAnim = animInfo.invisible;
            if(inVisibleAnim) {
                var animDef = inVisibleAnim.definition;
                if(animDef && animDef.getAnimationName) {
                    this.inVisibleAnimName = animDef.getAnimationName(inVisibleAnim.config, 'invisible');
                }
            }
        }
        this.animInfo = animInfo;
        this.initialized = false;
        this.init();
    };

    module.setAnimations.prototype = {
        init: function() {
            var wModel = this.widgetModel;
            var node = $KU.getNodeByModel(wModel);
            if(!node)
                return;
            this.node = node;
            if(this.visibleAnimName || this.inVisibleAnimName || wModel.onrowdisplay) {
                this.syncList();
                this.animateList(true);
                this.startAnim();
                this.initialized = true;
            }
        },

        startAnim: function() {
            var that = this;
            (function animate() {
                that.animateList();
                that.animCallback = nextFrame(animate);
            })();
        },

        destroy: function() {
            this.initialized = false;
            this.cancelAnim();
        },

        cancelAnim: function() {
            cancelFrame(this.animCallback);
        },

        syncList: function() {
            var wModel = this.widgetModel;
            this.items = [];
            var data = wModel.data;
            if(!data || data.length == 0)
                return;

            if(wModel.hasSections) {
                var sections = this.node.children;
                for(var i = 0; i < sections.length; i++) {
                    var sec = sections[i];
                    var rows = sec.children;
                    this.saveContext(wModel, rows);
                    for(var j = 0; j < rows.length; j++)
                        this.items.push(rows[j]);
                }
            } else {
                var rows = this.node.children[0].children;
                this.saveContext(wModel, rows);
                this.items = rows;
            }

            this.scrollTop = 0;
            this.scrollBottom = 0;
            var scrollerIns = $KG[$KW.Utils.getKMasterWidgetID(wModel) + '_scroller'];
            if(scrollerIns) {
                this.scrollTop = Math.abs(scrollerIns.y);
                this.scrollBottom = this.scrollTop + scrollerIns.wrapperH;
            } else {
                this.scrollTop = this.node.scrollTop;
                this.scrollBottom = this.scrollTop + this.node.offsetHeight;
            }

            var item;
            
            for(var i = 0, len = this.items.length; i < len; i++) {
                item = this.items[i];
                item._offsetHeight = item.offsetHeight;
                item._offsetTop = item.offsetTop;
                item._offsetBottom = item._offsetTop + item._offsetHeight;

                
                if(item._offsetBottom < this.scrollTop) {
                    item._state = 'past';
                }
                
                else if(item._offsetTop > this.scrollBottom) {
                    item._state = 'future';
                }
                
                else {
                    item._state = '';
                }
            }
        },

        saveContext: function(wModel, rows) {
            for(var i = 0; i < rows.length; i++) {
                var row = rows[i];
                var rowContext = module.getContextByNode(wModel, row);
                var rowIndex = rowContext.rowIndex;
                var secIndex = rowContext.sectionIndex;
                var clonedTemplate = module.getClonedModel(wModel, rowIndex, secIndex);
                row.itemContext = {
                    sectionIndex: secIndex,
                    rowIndex: rowIndex,
                    containerModel: wModel,
                    widgetModel: clonedTemplate,
                    animType: 'segmentRow'
                };
                if(clonedTemplate instanceof Object) {
                    row.wModel = clonedTemplate;
                    var visibleInfo = this.animInfo;
                    if(this.visibleAnimName) {
                        var animInfo = visibleInfo.visible;
                        var animDef = animInfo.definition;
                        row.wModel.originalFrames = animDef.animationDef;
                        animDef.saveWidgetState(row.wModel, row, animInfo.config, 'segmentRow');
                    }
                }
            }
        },

        animateList: function(force) {
            var wModel = this.widgetModel;
            this.scrollTop = 0;
            this.scrollBottom = 0;
            var scrollerIns = $KG[$KW.Utils.getKMasterWidgetID(wModel) + '_scroller'];
            if(scrollerIns) {
                this.scrollTop = Math.abs(scrollerIns.y);
                this.scrollBottom = this.scrollTop + scrollerIns.wrapperH;
                var maxScrollY = Math.abs(scrollerIns.maxScrollY);
                
                if(this.scrollTop >= maxScrollY || scrollerIns.y > 0)
                    return;
            } else {
                this.scrollTop = this.node.scrollTop;
                this.scrollBottom = this.scrollTop + this.node.offsetHeight;
            }

            if(this.scrollTop !== this.lastTop || force) {
                this.lastTop = this.scrollTop;
                var visible = this.visibleAnimName;
                var inVisible = this.inVisibleAnimName;
                var animInfo = this.animInfo;

                
                for(var i = 0, len = this.items.length; i < len; i++) {
                    var item = this.items[i];

                    
                    if(item._offsetBottom < this.scrollTop) {
                        item._state = 'past';
                    }
                    
                    else if(item._offsetTop > this.scrollBottom) {
                        item._state = 'future';
                    }
                    
                    else {
                        
                        if(item._state) {
                            if(wModel.onrowdisplay) {
                                if(this.initialized) {
                                    if(item._state == 'future') {
                                        var startRow = this.getFirstVisibleRowByIndex(i);
                                        this.executeRowDisplay(item, kony.segment.VISIBLE, startRow, item);
                                        this.executeRowDisplay(startRow, kony.segment.INVISIBLE, startRow, item);
                                    }
                                    if(item._state == 'past') {
                                        var endRow = this.getBottomVisibleRowByIndex(i);
                                        this.executeRowDisplay(item, kony.segment.VISIBLE, item, endRow);
                                        this.executeRowDisplay(endRow, kony.segment.INVISIBLE, item, endRow);
                                    }
                                }
                            } else if(visible) {
                                this.applyItemAnimation(item, animInfo.visible, visible);
                            }
                            item._state = '';
                        }
                    }
                }
            }
        },

        applyItemAnimation: function(item, animInfo, animName) {
            var animDef = animInfo.definition;
            var animKey = $KU.animation;
            animDef.getAnimConfig(animInfo.config, item);
            item.context = item.itemContext;
            
            item.style[animKey] = animName;
            animDef.registerAnimCallbacks(item, animInfo.callbacks);
        },

        executeRowDisplay: function(item, state, startRow, endRow) {
            var wModel = this.widgetModel;
            var startContext = {};
            var endContext = {};
            var itemContext = item.itemContext;
            var context = {
                sectionIndex: itemContext.sectionIndex,
                rowIndex: itemContext.rowIndex
            };
            if(startRow) {
                var startRowContext = startRow.itemContext;
                startContext = {
                    sectionIndex: startRowContext.sectionIndex,
                    rowIndex: startRowContext.rowIndex
                };
            }
            if(endRow) {
                var endRowContext = endRow.itemContext;
                endContext = {
                    sectionIndex: endRowContext.sectionIndex,
                    rowIndex: endRowContext.rowIndex
                };
            }
            wModel.onrowdisplay.call(wModel, wModel, state, context, startContext, endContext);
        },

        
        onRowDisplayHandler: function(eventInfo) {
            if(!eventInfo)
                return;
            var action = eventInfo.action;
            var newItems = eventInfo.newItems;
            var rowIndex = eventInfo.rowIndex;
            var secIndex = eventInfo.sectionIndex;
            var wModel = this.widgetModel;
            var node = this.node;
            var state = '';
            if(action == 'setdata' || action == 'setsectionat' || action == 'setdataat') {
                state = kony.segment.UPDATE;
            } else if(action == 'addall' || action == 'addsectionat' || action == 'adddataat') {
                state = kony.segment.ADD;
            } else {
                state = kony.segment.REMOVE;
            }
            switch(action) {
                case "setdata":
                case "addall":
                case "addsectionat":
                case "setsectionat":
                    
                    if(action == 'removeall')
                        newItems = wModel.hasSections ? this.node.childNodes.length : this.node.childNodes[0].childNodes.length;
                    if(wModel.hasSections) {
                        if(action == 'setsectionat' || action == 'removesectionat')
                            newItems = 1;
                        this.onRowDisplayForSections(state, secIndex, newItems);
                    } else {
                        var ul = node.childNodes[0];
                        this.onRowDisplayForRows(state, ul, rowIndex, newItems);
                    }
                    break;
                case "adddataat":
                case "setdataat":
                    
                    newItems = 1;
                    var wrapper = wModel.hasSections ? node.childNodes[secIndex] : node.childNodes[0];
                    this.onRowDisplayForRows(state, wrapper, rowIndex, newItems);
                    break;
            }
        },

        onRowDisplayForSections: function(state, secIndex, newItems) {
            var tempSecIndex = secIndex;
            for(var i = 0; i < newItems; i++) {
                var sec = this.node.childNodes[tempSecIndex];
                sec && this.onRowDisplayForRows(state, sec);
                tempSecIndex++;
            }
        },

        
        onRowDisplayForRows: function(state, wrapperNode, startIndex, noOfItems) {
            var wModel = this.widgetModel;
            var rows = wrapperNode.childNodes;
            if(!rows)
                return;
            var len = (typeof noOfItems != "undefined") ? noOfItems : rows.length;
            
            startIndex = (typeof startIndex != "undefined") ? (wModel.hasSections ? startIndex + 1 : startIndex) : 0;
            var item;
            for(var i = 0; i < len; i++) {
                item = rows[startIndex];
                if(module.isTemplateVisible(wModel, item)) {
                    var startRow = this.getFirstVisibleRowByIndex(len);
                    var endRow = this.getBottomVisibleRowByIndex(0);
                    this.executeRowDisplay(item, state, startRow, endRow);
                }
                startIndex++;
            }
        },

        getFirstVisibleRowByIndex: function(index) {
            for(var i = 0; i < index; i++) {
                var item = this.items[i];
                if(this.scrollTop <= item._offsetBottom)
                    return item;
            }
        },

        getBottomVisibleRowByIndex: function(index) {
            var len = this.items.length;
            for(var i = index; i < len; i++) {
                var item = this.items[i];
                if(this.scrollBottom <= item._offsetBottom)
                    return item;
            }
            return this.items[len - 1]; 
        }
    };

    module.applyRowsAnimationByAPI = function(segModel, action, listItems, rowIndex, secIndex, animObj) {
        if(!animObj || !animObj.definition || !animObj.definition.applyRowAnimation)
            return;

        var animDef = animObj.definition;
        this.action = action;
        this.wModel = segModel;
        this.animObj = animObj;

        switch(action) {
            case "adddataat":
            case "addat":
            case "setdataat":
            case "removeat":
                var row = listItems.firstChild;
                var clonedTemplate = module.getClonedModel(segModel, rowIndex, secIndex);
                if(!(clonedTemplate instanceof Object))
                    return;
                row.wModel = clonedTemplate;
                row.context = {
                    sectionIndex: secIndex,
                    rowIndex: rowIndex,
                    containerModel: segModel,
                    widgetModel: clonedTemplate,
                    instance: this,
                    animType: 'segmentRow'
                };
                animDef.applyRowAnimation(row, animObj.config, animObj.callbacks);
                break;

            case "addall":
                if(segModel.hasSections) {
                    this.animateSections(listItems, secIndex);
                } else
                    this.animateRows(listItems, rowIndex, secIndex);
                break;

            case "removeall":
            case "setdata":
                if(action == 'setdata') {
                    var segNode = $KU.getNodeByModel(segModel);
                    if(segModel.hasSections === false || segModel.viewtype === constants.SEGUI_VIEW_TYPE_PAGEVIEW)
                        segNode = segNode.childNodes[0];
                } else
                    var segNode = listItems;

                if(segModel.hasSections) {
                    this.animateSections(segNode.childNodes, 0);
                } else {
                    var rows = segNode.childNodes;
                    this.animateRows(rows, 0);
                }
                break;

            case "setsectionat":
            case "removesectionat":
                this.animateSections([listItems], secIndex);
                break;

            case "addsectionat":
                this.animateSections(listItems, secIndex);
                break;

        }
    };

    module.applyRowsAnimationByAPI.prototype = {
        animateSections: function(secs, secIndex) {
            for(var i = 0; i < secs.length; i++) {
                var sec = secs[i];
                var rows = sec.childNodes;
                
                this.animateRows([rows[0]], -1, secIndex);
                this.animateRows(rows, 0, secIndex, 1);
                secIndex++;
            }
        },

        animateRows: function(rows, rowIndex, secIndex, startIndex) {
            startIndex = startIndex || 0;
            var rowIndex = rowIndex;
            var secIndex = secIndex;
            var animObj = this.animObj;
            var animDef = animObj.definition;
            for(var i = startIndex; i < rows.length; i++) {
                var row = rows[i].firstChild;
                var clonedTemplate = module.getClonedModel(this.wModel, rowIndex, secIndex);
                if(!(clonedTemplate instanceof Object))
                    return;

                row.wModel = clonedTemplate;
                row.context = {
                    sectionIndex: secIndex,
                    rowIndex: rowIndex,
                    containerModel: this.wModel,
                    widgetModel: clonedTemplate,
                    instance: this,
                    animType: 'segmentRow'
                };
                animDef.applyRowAnimation(row, animObj.config, animObj.callbacks);
                rowIndex++;
            }
        },

        onAnimationEnd: function(row) {
            var segModel = this.wModel;
            var segNode = $KU.getNodeByModel(segModel);
            if(!segNode)
                return;

            if(this.action == 'removeall') {
                if(segModel.hasSections === false || segModel.viewtype === constants.SEGUI_VIEW_TYPE_PAGEVIEW)
                    segNode = segNode.childNodes[0];
                segNode.innerHTML = '';
            }

            if(this.action == 'removeat') {
                var context = module.getContextByNode(segModel, row);
                var secIndex = context.sectionIndex;
                var rowIndex = context.rowIndex;

                
                if(segModel.hasSections) {
                    var secNode = segNode.childNodes[secIndex];
                    secNode.removeChild(secNode.childNodes[rowIndex + 1]);
                    segModel.clonedTemplates[secIndex][1].splice(rowIndex, 1);
                } else {
                    var wrapperNode = segNode.childNodes[0];
                    wrapperNode.removeChild(wrapperNode.childNodes[rowIndex]);
                    segModel.clonedTemplates.splice(rowIndex, 1);
                }
            }

            if(this.action == "removesectionat") {
                var context = module.getContextByNode(segModel, row);
                var secIndex = context.sectionIndex;
                var secNode = segNode.childNodes[secIndex];
                if(!secNode || !(row.parentNode && row.parentNode.parentNode))
                    return;
                segNode.removeChild(secNode);
                segModel.clonedTemplates.splice(secIndex, 1);
            }

            if(this.action == 'removeall' || this.action == 'removeat' || this.action == 'removesectionat') {
                if(this.action != 'removeall') {
                    if(segModel.hasSections) {
                        module.adjustSectionIndex(segNode);
                        module.applySectionRowSkin(segModel, segNode);

                    } else {
                        var wrapper = segNode.childNodes[0];
                        $KU.adjustNodeIndex(wrapper, 0, "index");
                        module.applyRowSkin(segModel, wrapper);
                    }
                }
                var listAnimation = segModel.listAnimation;
                listAnimation && listAnimation.syncList();
            }
        }
    };
    module.registerSwipeGesture.prototype = {
        resetTransition: function(widgetNode) {
            widgetNode.parentNode.style.removeProperty('transition');
        },
        applyTransform: function(widgetModel, widgetNode, value, animate) {
            var style;
            this.transformProperty.translate(value, 0);
            style = $KW.animUtils.applyTransform(widgetModel, this.transformProperty);
            console.log('translating ', style);
            if(animate) widgetNode.parentNode.style["transition"] = "transform 0.5s";
            widgetNode.parentNode.style[vendor + "Transform"] = style;
            widgetNode.parentNode.style["transform"] = style;
        },
        getDirection: function(currentPosition) {
            if(this.startPosition > currentPosition)
                return 'RTL';
            return 'LTR';
        },
        getValue: function(widgetModel, value) {
            var valueObj = {}, valueInPx;
            valueObj = $KW.FlexUtils.getValueAndUnit(widgetModel, value);
            valueInPx = $KW.FlexUtils.getValueByParentFrame(widgetModel, valueObj, 'x');
            return valueInPx;
        },
        enforceTranslateValue: function(value, minValue, maxValue) {
            if(value < minValue)
                value = minValue;
            if(value > maxValue)
                value = maxValue;
            return value;
        },
        getResultFromConfig: function(widgetModel, direction, translateXValue, config) {
            var result = null;
            var configs, start, end;
            configs = (direction === 'RTL' ? config.swipeLeft : config.swipeRight);
            configs = configs || [];
            for(i = 0; i < configs.length; i++) {
                start = this.getValue(widgetModel, configs[i].translateRange[0]);
                end = this.getValue(widgetModel, configs[i].translateRange[1]);
                if(start < translateXValue && translateXValue < end) {
                    result = configs[i];
                    break;
                }
            }
            return result;
        },
        compareRowContexts: function(rowContext1, rowContext2) {
            if(rowContext1 && rowContext2) {
                if((rowContext1.sectionIndex === rowContext2.sectionIndex)
                && (rowContext1.rowIndex === rowContext2.rowIndex)) {
                    return true;
                }
            }
            return false;
        },
        resetSwipeCofigIfNeeded: function(widgetModel) {
            if(!this.compareRowContexts(widgetModel.rowContext, this.containerModel.swipeSelectedConfig.rowContext)) {
                $KW.Segment.resetSwipe(this.containerModel, this.containerModel.swipeSelectedConfig.rowContext);
            }
        },
        gestureStart: function(widgetModel, context) {
            this.startPosition = context.x1;
            this.resetTransition(context.widgetNode);
            this.containerModel && this.containerModel.swipeSelectedConfig && this.resetSwipeCofigIfNeeded(widgetModel);
            if(this.containerModel) {
                this.containerModel.swipeSelectedConfig = {rowContext: widgetModel.rowContext};
            }
        },
        gestureMove: function(widgetModel, context) {
            var direction, panDistance;

            if(Math.abs(context.x2 - this.startPosition) <= this.minDeltaToInitiateSwipe) {
                return;
            }
            direction = this.getDirection(context.x2);
            panDistance = this.translateX + context.x2 - this.startPosition;
            panDistance = this.enforceTranslateValue(panDistance, this.boundaryMin, this.boundaryMax);
            if(this.useTranslate) {
                this.applyTransform(widgetModel, context.widgetNode, panDistance);
            }
        },
        gestureEnd: function(widgetModel, context) {
            var callbackContext = {}, matchedConfig, direction, panDistance;

            if(Math.abs(context.x2 - this.startPosition) <= this.minDeltaToInitiateSwipe) {
                return;
            }
            direction = this.getDirection(context.x2);
            panDistance = this.translateX + context.x2 - this.startPosition;
            panDistance = this.enforceTranslateValue(panDistance, this.boundaryMin, this.boundaryMax);
            matchedConfig = this.getResultFromConfig(widgetModel,direction, panDistance, widgetModel.widgetswipemove);
            if(matchedConfig == null) {
                this.applyTransform(widgetModel, context.widgetNode, this.translateX, true);
            } else {
                this.translateX = this.getValue(widgetModel, matchedConfig.translatePos);
                this.applyTransform(widgetModel, context.widgetNode, this.translateX, true);
                this.useTranslate = matchedConfig.translate;
                if(matchedConfig.callback) {
                    callbackContext.widgetInfo = this.containerModel;
                    callbackContext.rowIndex = widgetModel.rowContext.rowIndex;
                    callbackContext.sectionIndex  = widgetModel.rowContext.sectionIndex ;
                    matchedConfig.callback.call(widgetModel, widgetModel, callbackContext);
                }
            }
        }
    };

    return module;
}());


$KW.Image = (function() {
    
    

    var module = {
        initialize: function() {
            kony.events.addEvent("click", "Image", this.eventHandler);
            kony.events.addEvent("onorientationchange", "Image", this.imgOrientationHandler);
        },

        imgOrientationHandler: function() {
            var widgetNode = arguments[0] ? $KU.getNodeByModel(arguments[0]) : document;
            var editImages = widgetNode && widgetNode.querySelectorAll("img[kwidgettype='Image']");
            if(editImages) {
                for(var i = 0; i < editImages.length; i++) {
                    var editImage = editImages[i];
                    module.imgResizeHandler(editImage, "orientationchange");
                }
            }
        },

        
        updateView: function(widgetModel, propertyName, propertyValue, oldPropertyValue) {
            var element = $KU.getNodeByModel(widgetModel), imageParent, scrollerNode;

            switch(propertyName) {
                case "src":

                    
                    widgetModel.srcType = 1;
                    if(!element)
                        return;
                    element.parentNode.parentNode.innerHTML = this.render(widgetModel, new $KW.WidgetGenerationContext(widgetModel.pf));

                    
                    if(widgetModel.touches) {
                        element = $KU.getNodeByModel(widgetModel);
                        var touchtypes = ["touchstart", "touchmove", "touchend"];
                        for(var i =0; i < touchtypes.length; i++) {
                            var eventtype = touchtypes[i];
                            if(widgetModel.touches[eventtype]){
                                $KW.Utils.removetouch(widgetModel, eventtype, false);
                                $KW.Utils.updateModelWithTouches(widgetModel, eventtype, widgetModel.touches[eventtype].callback);
                                widgetModel.touches[eventtype]["instance"] = new $KW.touch.TouchEvents(widgetModel, element.parentNode, eventtype,  widgetModel.touches[eventtype].callback);
                            }
                        }
                    }
                    break;

                case "base64":
                    widgetModel.srcType = 2;
                    
                    if(element && propertyValue) {
                        element.src = this.getBase64String(propertyValue);
                    }
                    break;

                case "referenceheight":
                case "referencewidth":
                case "imagescalemode":
                    element && (element.parentNode.parentNode.innerHTML = this.render(widgetModel, new $KW.WidgetGenerationContext(widgetModel.pf)));
                    $KW.FlexContainer.attachDragEvent(widgetModel);
                    break;

            }
        },

        
        render: function(imageModel, context) {
            var computedSkin = $KW.skins.getSplitSkinsBetweenWidgetAndParentDiv(imageModel, context);
            var htmlString = "";
            var style = "";
            imageModel.loaded = false;
            var isFlexWidget = $KW.FlexUtils.isFlexWidget(imageModel);
            var imgId = imageModel.pf + "_" + imageModel.id;
            var kmasterObj = $KW.Utils.getMasterIDObj(imageModel);
            if(kmasterObj.id != "") {
                imgId = kmasterObj.id;
            }

            if(context.scrollBoxID)
                imageModel.scrollBoxID = context.scrollBoxID;

            var isWaitAllowed = true;
            if($KU.inArray($KU.imgCache, imageModel.src, true))
                isWaitAllowed = false;
            
            if(isWaitAllowed && imageModel.imagewhiledownloading)
                new Image().src = $KU.getImageURL(imageModel.imagewhiledownloading);

            imageModel.imagewhiledownloading = imageModel.imagewhiledownloading || $KG["imagewhiledownloading"] || "imgload.gif";
            var css = $KW.skins.getVisibilitySkin(imageModel) + (isFlexWidget ? " middlecenteralign" : "");
            var useWidgetSize = '';

            if(context.ispercent === false) {
                useWidgetSize = context.layoutDir ? "float:" + context.layoutDir : "";
            } else {
                useWidgetSize = "width:100%";
            }

            if(imageModel.srcType == 2)
                imgsrc = this.getBase64String(imageModel.base64);
            else
                imgsrc = $KU.getImageURL(imageModel.src)

            var onimgonload = "$KU.imgLoadHandler(arguments[0],this)";


            var dimensions = this.getImageDimensions(imageModel, context.ispercent);

            style += (dimensions.width != undefined ? ("width:" + dimensions.width + "px;") : "") + (dimensions.height != undefined ? ("height:" + dimensions.height + "px;") : "") + (isFlexWidget ? "font-size:0px;display:block;" : "");

            onimgonload = dimensions.onimgonload || onimgonload;
            if(dimensions.maxwidth) {
                style = dimensions.maxwidth;
            }

            
            
            


            htmlString += "<span id='" + imgId + "_span' class='" + css + " " + computedSkin[0] + "' style='display:inline-block;" + (isWaitAllowed && imageModel.src ? "background:url(" + $KU.getImageURL(imageModel.imagewhiledownloading) + ") center center no-repeat;" : ";") + $KW.skins.getMarginSkin(imageModel, context) + $KW.skins.getPaddingSkin(imageModel, context) + useWidgetSize + ";" + style + (isFlexWidget? 'height: 100%' : '') + "' " + kmasterObj.kmasterid + " >";

            
            style += $KW.skins.getBlurStyle(imageModel);

            htmlString += "<img class='" + "' src='" + imgsrc + "'" + $KW.Utils.getBaseHtml(imageModel, context) + "onload= " + onimgonload + " onerror='$KU.imgLoadHandler(arguments[0],this)' ";

            if(!(imageModel.name == "kony.ui.Image2" || imageModel.name == "konyLua.Image2") && imageModel.scalemode == "maintainaspectratio") {
                style = "width:100%;";
            } else if(imageModel.scalemode == "retaininitialimagedimensions") {
                style = "";
            }

            if(isWaitAllowed && imageModel.src) {
                style += "opacity:0;";
            }
            style += "visibility:hidden;";
            var downloadComplete = imageModel.ondownloadcomplete || "";
            if(downloadComplete) {
                downloadComplete = (typeof(downloadComplete) == 'function') ? $KU.getFunctionName(imageModel.ondownloadcomplete) : imageModel.ondownloadcomplete;
                downloadComplete = " ondownloadcomplete= '" + downloadComplete + "'";
            }
            htmlString += "style= '" + style + "'" + downloadComplete + "/></span>";


            return htmlString;
        },

        getImageDimensions: function(imageModel, contextIsPercent) {
            var dimensions = {}; 
            if(imageModel.imagescalemode == constants.IMAGE_SCALE_MODE_FIT_TO_DIMENSIONS) 
            {
                var isFlexWidget = $KW.FlexUtils.isFlexWidget(imageModel);
                if(!isFlexWidget) {
                    if(imageModel.referencewidth) {
                        if(contextIsPercent == false)
                            dimensions.width = imageModel.referencewidth;
                        else
                            dimensions.width = (((screen.width * (imageModel.containerweight / 100)) > imageModel.referencewidth) ? imageModel.referencewidth : (screen.width * (imageModel.containerweight / 100)));

                        dimensions.height = imageModel.referenceheight;
                    } else
                        dimensions.maxwidth = "max-width:100%;";
                }
            } else if((imageModel.name == "kony.ui.Image2" || imageModel.name == "konyLua.Image2") && imageModel.imagescalemode == constants.IMAGE_SCALE_MODE_MAINTAIN_ASPECT_RATIO) 
            {
                imageModel.ispercent = contextIsPercent;
                dimensions.onimgonload = "$KW.Image.imgLoadHandler2(arguments[0])";
            } else if(!imageModel.referencewidth && imageModel.heightwidth && imageModel.imagescalemode != constants.IMAGE_SCALE_MODE_MAINTAIN_ASPECT_RATIO) {
                var dim = (imageModel.heightwidth).split(",");
                dimensions.width = dim[1];
                dimensions.height = dim[0];
            } else {
                dimensions.maxwidth = "max-width:100%;";
            }
            return dimensions;
        },

        getBase64String: function(propertyValue) {
            return "data:image/png;base64," + propertyValue;
        },

        eventHandler: function(eventObject, target) {
            var imgWidgetModel = $KU.getModelByNode(target),
                containerId = target.getAttribute("kcontainerID");
            

            $KAR && $KAR.sendRecording(imgWidgetModel, 'click', {'target': target, 'eventType': 'uiAction'});
            if(containerId) {
                $KW.Utils.updateContainerData(imgWidgetModel, target, true);
            } else {
                var executed = kony.events.executeBoxEvent(imgWidgetModel);
                var tabId = target.getAttribute("ktabid");
                if(!executed && tabId) {
                    $KW.TabPane && $KW.TabPane.executeTabEvent(imgWidgetModel, target, true);
                }
            }
        },

        imgLoadHandler2: function(event) {
            event = event || window.event;
            img = event.target || event.srcElement;
            if(!img.parentNode || (img.parentNode && !img.parentNode.parentNode)) return;
            this.imgResizeHandler(img, event.type);
        },

        imgResizeHandler: function(img, eventType) {
            if(!document.body.contains(img)) {
                return;
            }
            var tabPaneID = img.getAttribute("ktabpaneid");
            var type = img.getAttribute("kwidgettype");

            var targetWidgetID = (type == 'Image') ? $KU.getElementID(img.getAttribute("id")) : img.getAttribute("id");
            var src = img.src;
            var imageModel = $KU.getModelByNode(img);
            if(img.getAttribute("kcontainerID")) {
                imageModel = $KW.Utils.getClonedModelByContainer(imageModel, img, img.getAttribute("kcontainerID"));
            }

            var actimgdim = module.getNaturalDimensions(img);

            if(eventType == "load") {
                var isWaitAllowed = true;
                if($KU.inArray($KU.imgCache, imageModel.src, true))
                    isWaitAllowed = false;
                else
                    $KU.imgCache.push(imageModel.src);
                
                if(isWaitAllowed || img.parentNode.style.background.indexOf("url") != -1) {
                    var span = img.parentNode;
                    if(span) {
                        if(span.style.removeProperty)
                            span.style.removeProperty("background");
                        else
                            span.style.background = "none";
                    }
                    if($KU.isiPhone || kony.appinit.isSafari) {
                        setTimeout(function(){
                            img.style[$KU.transition] = "";
                        },500);
                    }
                    img.style[$KU.transition] = "opacity 500ms ease-in-out";
                    img.style.opacity = 1;
                }
            }

            
            imageModel.loaded = true;
            if(imageModel.animInfo) {
                var info = imageModel.animInfo;
                info.instance.animate(imageModel, info.animConfig, info.animCallback);
            }

            
            if(!img.parentNode || (!actimgdim.width || !actimgdim.height)) return;

            var ondownloadcompleteref = $KU.returnEventReference(imageModel.ondownloadcomplete);
            if(ondownloadcompleteref) {
                $KU.executeWidgetEventHandler(imageModel, ondownloadcompleteref, src, true);
            }

            var imgwidth = img.parentNode.parentNode.offsetWidth;
            if(imageModel.containerWeight >= 0 && imgwidth == 0)
                imgwidth = actimgdim.width;

            var isFlexWidget = $KW.FlexUtils.isFlexWidget(imageModel);
            
            if(!isFlexWidget) {
                var dimensions = []; 
                dimensions = module.imgDimCalculation(imageModel, actimgdim, imgwidth);
                img.style.width = img.parentNode.style.width = dimensions[1] + "px";
                img.style.height = img.parentNode.style.height = dimensions[0] + "px";
            }
            img.style.display = "";
            img.style.visibility = "visible";
            img.parentNode.parentNode.style["font-size"] = "0px";

            $KU.onImageLoadComplete(imageModel, img);
        },

        getNaturalDimensions: function(img) {
            var actimgdim = {};
            if(typeof img.naturalWidth == "undefined") { 
                var i = new Image();
                i.src = img.src;
                actimgdim.width = i.width;
                actimgdim.height = i.height;
            } else {
                actimgdim.width = img.naturalWidth;
                actimgdim.height = img.naturalHeight;
            }
            return actimgdim;
        },

        imgDimCalculation: function(imageModel, actimgdim, imgwidth) {
            var dimensions = [];
            var aspectRatio = (actimgdim.width / actimgdim.height);
            if(!imageModel.referencewidth) {
                if(imageModel.ispercent === false) {
                    dimensions[1] = actimgdim.width;
                    dimensions[0] = actimgdim.height;
                } else {
                    if(actimgdim.width <= imgwidth) {
                        if(imageModel.referenceheight && actimgdim.height > imageModel.referenceheight) {
                            dimensions[0] = imageModel.referenceheight;
                            dimensions[1] = dimensions[0] * aspectRatio;
                        } else {
                            dimensions[1] = actimgdim.width;
                            dimensions[0] = actimgdim.height;
                        }
                    } else {
                        dimensions[1] = imgwidth;
                        if(!imageModel.referenceheight)
                            dimensions[0] = dimensions[1] / aspectRatio;
                        else {
                            dimensions[0] = dimensions[1] / aspectRatio;
                            if(dimensions[0] > imageModel.referenceheight) {
                                dimensions[0] = imageModel.referenceheight;
                                dimensions[1] = dimensions[0] * aspectRatio;
                            }
                        }
                    }

                }
            } else {
                if(imageModel.ispercent === false) {
                    if(actimgdim.width < imageModel.referencewidth) {
                        dimensions[1] = actimgdim.width;
                        dimensions[0] = actimgdim.height;
                    } else {
                        dimensions[1] = imageModel.referencewidth;
                        dimensions[0] = dimensions[1] / aspectRatio;
                    }

                } else {
                    var computedimgwidth = (imageModel.referencewidth <= imgwidth) ? imageModel.referencewidth : imgwidth;
                    if(!imageModel.referenceheight) {
                        if(actimgdim.width < computedimgwidth) {
                            dimensions[0] = actimgdim.height;
                            dimensions[1] = actimgdim.width;
                        } else {
                            dimensions[1] = computedimgwidth;
                            dimensions[0] = dimensions[1] / aspectRatio;
                        }
                    } else {
                        var checkDim = (actimgdim.width < computedimgwidth) ? (actimgdim.height < imageModel.referenceheight ? true : false) : false;
                        if(!checkDim) {
                            dimensions[1] = (((imgwidth) > imageModel.referencewidth) ? imageModel.referencewidth : (imgwidth));
                            dimensions[0] = imageModel.referenceheight;
                            var imgdim = (dimensions[1] / aspectRatio) < dimensions[0] ? (dimensions[1] / aspectRatio) : false;
                            if(imgdim === false)
                                dimensions[1] = (dimensions[0] * aspectRatio <= imageModel.referencewidth) ? dimensions[0] * aspectRatio : false;
                            else
                                dimensions[0] = imgdim;
                        } else {
                            dimensions[0] = actimgdim.height;
                            dimensions[1] = actimgdim.width;
                        }
                    }
                }
            }

            if(dimensions[1] > 0 && dimensions[1] < 1)
                dimensions[1] = 1;

            if(dimensions[0] > 0 && dimensions[0] < 1)
                dimensions[0] = 1;

            if(document.getElementsByTagName('body')[0].getAttribute("formWidth") != null) {
                $KW.Form.adjustBodyWidth();
            }
            return dimensions;
        },

        setBase64Img: function(widgetModel) {
            if(widgetModel.src && !widgetModel.src.startsWith("http")) { 
                var req = new XMLHttpRequest();
                req.onreadystatechange = function() {
                    if(req.readyState == 4 && req.status == 200) {
                        widgetModel.base64 = $KU.getBase64(req.responseText) || null;
                    }
                }
                req.open('GET', $KU.getImageURL(widgetModel.src), true);
                if(req.overrideMimeType)
                    req.overrideMimeType('text/plain; charset=x-user-defined');
                req.send(null);
            } else
                widgetModel.base64 = null;
        },

    };


    return module;
}());





$KW.SlotView = (function() {
    
    

    var module = function(container, imagesArray, options) {
        this.arguments = {};
        this.arguments.container = container;
        
        
        this.arguments.totalFrames = imagesArray.length;
        this.imagesArray = imagesArray;

        
        this.options = {
            imageIndexOffset: 1, 
            loaders: 3, 
            initialLoad: 4, 
            noCache: false, 
            initialPos: [0, 0], 
            invert: [true, false], 

            infiniteAxis: [true, false], 

            autoPlay: false, 
            fps: 25, 

            grabbable: true, 
            grabRotateDistance: 1000, 

            throwable: true, 
            minThrowDuration: 0.5, 
            maxThrowDuration: 1.5, 

            spinnable: true, 
            minSpinDuration: 3, 

            intro: module.SpinIntro, 
            introSpins: 0.5, 
            introDuration: 1, 

            mobileTotalFrames: null 
        }

        
        for(i in options) this.options[i] = options[i];

        this.initialize();
    };

    
    module.SpinIntro = function(vr) {
        var totalFrames = vr.options.fps * vr.options.introDuration,
            introInitialRow = (typeof vr.options.introInitialRow != 'undefined') ? vr.options.introInitialRow : vr.options.initialPos[1],
            rowDiff = introInitialRow - vr.options.initialPos[1],
            queue = [];

        for(var i = 0; i < totalFrames; i++) {
            var percent = i / totalFrames,
                speed = Math.pow(percent - 1, 4),
                posX = Math.floor(speed * vr.totalFrames[0] * vr.options.introSpins) + vr.options.initialPos[0],
                posY = Math.floor(speed * rowDiff) + vr.options.initialPos[1];

            
            
            if(!queue.length || queue[queue.length - 1][0] != posX || queue[queue.length - 1][1] != posY) {
                queue.push(vr.validatePos([posX, posY], true));
            }
        }

        return queue;
    };

    module.options = {};

    module.prototype.initialize = function() {
        
        function convertToArray(mixed, second) {
            return(typeof mixed[0] == 'undefined') ? [mixed, second] : mixed;
        }

        if(this.options.noCache) this.random = Math.floor(Math.random() * 10000000);

        
        
        this.mobile = $KU.isTouchSupported;
        if(this.mobile) {
            
            this.options.autoPlay = true;
            this.options.spinnable = false;
            this.options.throwable = true;

            this.mobileStrings = {
                mousedown: 'touchstart',
                mousemove: 'touchmove',
                mouseup: 'touchend'
            };
        }

        
        this.container = document.getElementById(this.arguments.container);
        
        this.vr = document.getElementById(this.arguments.container).children[0];
        

        
        
        

        
        this.totalFrames = convertToArray(this.arguments.totalFrames, 1);
        if(this.mobile && this.options.mobileTotalFrames) {
            var actual = this.totalFrames;
            this.totalFrames = convertToArray(this.options.mobileTotalFrames, 1);
            this.frameMultipliers = [actual[0] / this.totalFrames[0], actual[1] / this.totalFrames[1]];
        } else {
            this.frameMultipliers = [1, 1];
        }
        this.options.initialPos = convertToArray(this.options.initialPos, 0);

        this.options.invert = convertToArray(this.options.invert, false);

        this.frames = [];
        for(var i = 0; i < this.totalFrames[0]; i++) {
            this.frames[i] = [];
        }

        
        this.playIntervalDuration = 1000 / this.options.fps;
        this.minSpinIntervalDuration = (this.options.minSpinDuration * 1000) / this.totalFrames[0];
        this.minThrowFrames = Math.floor(this.options.minThrowDuration * this.options.fps);
        this.maxThrowFrames = Math.floor(this.options.maxThrowDuration * this.options.fps);

        
        this.currentPos;
        this.playing = false;
        this.grabbing = false;
        this.spinning = false;

        if(this.options.intro) {
            
            this.introSequence = this.options.intro(this);
            this.loader = new module.LoaderController(this, this.introSequence.slice(0), this.playIntro.bind(this));
        } else {
            this.loadAllFrames();
            this.gotoPos(this.options.initialPos);
            this.makeInteractive();

            
            if(this.options.autoPlay) {
                this.play();
            }
        }
    };

    
    module.prototype.getStr = function(str) {
        return this.mobile ? this.mobileStrings[str] : str;
    };

    module.prototype.getEvent = function(event) {
        if(!event)
            event = window.event;
        if(event.touches) {
            
            if(event.touches.length > 1) return false;

            if(event.touches.length) {
                event.clientX = event.touches[0].clientX;
                event.clientY = event.touches[0].clientY;
            }
        }

        return event;
    };

    
    module.prototype.playIntro = function() {
            this.introInterval = setInterval(this.gotoNextIntroFrame.bind(this), this.playIntervalDuration);
            this.loadAllFrames();
        },

        module.prototype.gotoNextIntroFrame = function() {
            this.gotoPos(this.introSequence.shift());

            
            if(!this.introSequence.length) {
                clearInterval(this.introInterval);
                this.makeInteractive();
            }
        };

    
    module.prototype.isPosLoaded = function(pos) {
        return(typeof this.frames[pos[0]] != 'undefined' && typeof this.frames[pos[0]][pos[1]] != 'undefined');
    };

    module.prototype.createLoadPlan = function(total, skip) {
        if(!skip) return [0];
        var plan = [];
        do {
            for(var i = 0; i < total; i += skip) {
                var f = Math.floor(i);
                if(plan.indexOf(f) == -1) {
                    plan.push(f);
                }
            }
            if(skip == 1) return plan;
            if((skip /= 2) < 1) skip = 1;
        } while (true);
    };

    module.prototype.loadAllFrames = function() {
        
        var queue = [],
            skipX = Math.floor(this.totalFrames[0] / this.options.initialLoad),
            planX = this.createLoadPlan(this.totalFrames[0], skipX),
            skipY = Math.floor(this.totalFrames[1] / this.options.initialLoad),
            planY = this.createLoadPlan(this.totalFrames[1], skipY);

        for(var y = 0; y < planY.length; y++) {
            for(var x = 0; x < planX.length; x++) {
                queue.push(this.validatePos([planX[x] + this.options.initialPos[0], planY[y] + this.options.initialPos[1]], true));
            }
        }

        
        this.loader = new module.LoaderController(this, queue);

        queue = null;
        skipX = null;
        planX = null;
        skipY = null;
        planY = null;
    };

    module.prototype.getImageSource = function(pos) {
        var x = this.options.invert[0] ? (this.totalFrames[0] - 1) - pos[0] : pos[0],
            y = this.options.invert[1] ? (this.totalFrames[1] - 1) - pos[1] : pos[1],
            frame = (Math.floor(y * this.totalFrames[0] * this.frameMultipliers[0] * this.frameMultipliers[1]) + Math.floor(x * this.frameMultipliers[0]) + this.options.imageIndexOffset) + '';


        

        
        
        return $KU.getImageURL(this.imagesArray[frame - 1]) + (this.options.noCache ? '?' + this.random : '');
    };

    module.prototype.makeInteractive = function() {
        if(this.options.grabbable) {
            
            this.bindGrabStart = this.onGrabStart.bind(this);
            this.bindGrabChange = this.onGrabChange.bind(this);
            this.bindGrabEnd = this.onGrabEnd.bind(this);
            
            kony.events.addEventListener(this.vr.parentNode, this.getStr('mousedown'), this.bindGrabStart);
        }
    };

    module.prototype.destroy = function() {
        this.unmakeInteractive();
        delete this.frames;
        delete this.introSequence;
        delete this.loader;
    };

    module.prototype.unmakeInteractive = function() {
        if(this.mobile) {
            if(this.vr && this.vr.children[0]) {
                kony.events.removeEventListener(this.vr.children[0], 'touchmove', this.bindGrabChange);
                kony.events.removeEventListener(this.vr.children[0], 'touchend', this.bindGrabEnd);
            }
        }

        if(this.options.grabbable) {
            
            if(this.vr && this.vr.parentNode)
                kony.events.removeEventListener(this.vr.parentNode, this.getStr('mousedown'), this.bindGrabStart);
        }
    };

    module.prototype.atPosition = function(pos) {
        return(this.currentPos && pos[0] == this.currentPos[0] && pos[1] == this.currentPos[1]);
    };

    module.prototype.play = function() {
        if(this.playing) return;
        this.playing = true;
        this.playInterval = setInterval(this.gotoNextFrame.bind(this), this.playIntervalDuration);
    };

    module.prototype.pause = function() {
        if(!this.playing) return;
        this.playing = false;
        clearInterval(this.playInterval);
    };

    module.prototype.gotoNextFrame = function() {
        this.gotoPos([this.currentPos[0] + 1, this.currentPos[1]]);
    };

    module.prototype.validatePos = function(pos, forceContinuous) {
        for(var i = 0; i < 2; i++) {
            if(forceContinuous || this.options.infiniteAxis[i]) {
                while(pos[i] > this.totalFrames[i] - 1) {
                    pos[i] -= this.totalFrames[i];
                }
                while(pos[i] < 0) {
                    pos[i] += this.totalFrames[i];
                }
            } else {
                if(pos[i] > this.totalFrames[i] - 1) {
                    pos[i] = this.totalFrames[i] - 1;
                }
                if(pos[i] < 0) {
                    pos[i] = 0;
                }
            }
        }
        return pos;
    };

    module.prototype.gotoPos = function(pos, force) {
        
        pos = this.validatePos(pos);

        
        if(!force && this.atPosition(pos)) return;

        
        this.currentPos = pos;

        this.frame = this.frames[pos[0]][pos[1]];
        if(typeof this.frame != 'undefined' && this.frame.nodeType) {
            if(this.currentFrame)
                this.vr.removeChild(this.currentFrame);
            else if(this.vr.children[0])
                this.vr.removeChild(this.vr.children[0]); 
            this.currentFrame = this.frame;
            
            this.vr.appendChild(this.currentFrame);
        } else {
            this.loader.loadNow(pos);
        }
        delete this.frame;
    };

    
    module.prototype.onGrabStart = function(event) {
        if(!(event = this.getEvent(event))) return;

        this.grabbing = true;

        kony.events.addEventListener(document, this.getStr('mousemove'), this.bindGrabChange);
        kony.events.addEventListener(document, this.getStr('mouseup'), this.bindGrabEnd);

        if(this.mobile) {
            
            kony.events.addEventListener(this.vr.children[0], 'touchmove', this.bindGrabChange);
            kony.events.addEventListener(this.vr.children[0], 'touchend', this.bindGrabEnd);
        }

        this.grabHistory = [event];
        this.onGrabChange.clientX = this.onGrabChange.clientY = null;
        this.grabHistoryInterval = setInterval(this.updateGrabHistory.bind(this), 10);

        
        this.onGrabStart.clientX = event.clientX;
        this.onGrabStart.clientY = event.clientY;
        this.onGrabStart.playing = this.playing;
        this.onGrabStart.pos = this.currentPos;

        
        this.pause();
        this.stopThrowing();

        
        kony.events.preventDefault(event);
    };

    module.prototype.onGrabChange = function(event) {
        if(!(event = this.getEvent(event))) return;

        
        if(!(event.clientX == this.onGrabStart.clientX && event.clientY == this.onGrabStart.clientY)) {

            
            this.onGrabChange.clientX = event.clientX;
            this.onGrabChange.clientY = event.clientY;

            var pos = this.getGrabPos(event);
            if(pos) this.gotoPos(pos);
        }

        
        kony.events.preventDefault(event);
    };

    module.prototype.getGrabPos = function(event) {
        if(!event)
            event = window.event;

        var diffX = event.clientX - this.onGrabStart.clientX,
            diffY = event.clientY - this.onGrabStart.clientY,
            percentDiffX = diffX / this.options.grabRotateDistance,
            percentDiffY = diffY / this.options.grabRotateDistance,
            frameDiffX = Math.round(this.totalFrames[0] * percentDiffX),
            frameDiffY = Math.round(this.totalFrames[1] * percentDiffY),
            posX = this.onGrabStart.pos[0] + frameDiffX,
            posY = this.onGrabStart.pos[1] + frameDiffY;

        return [posX, posY];
    };

    module.prototype.updateGrabHistory = function() {
        var func = this.onGrabChange.clientX ? this.onGrabChange : this.onGrabStart;
        this.grabHistory.unshift({
            clientX: func.clientX,
            clientY: func.clientY
        });
        if(this.grabHistory.length > 3) {
            this.grabHistory.splice(3);
        }
    };

    module.prototype.onGrabEnd = function(event) {
        if(!(event = this.getEvent(event))) return;

        this.grabbing = false;
        kony.events.removeEventListener(document, this.getStr('mousemove'), this.bindGrabChange);
        kony.events.removeEventListener(document, this.getStr('mouseup'), this.bindGrabEnd);
        clearInterval(this.grabHistoryInterval);

        
        if(this.onGrabStart.playing) {
            this.play();
        } else if(this.options.throwable) {
            var diffX = event.clientX - this.grabHistory[this.grabHistory.length - 1].clientX,
                diffY = event.clientY - this.grabHistory[this.grabHistory.length - 1].clientY,
                loaded = true;

            if(diffX || diffY) {
                var dist = Math.sqrt(Math.pow(diffX, 2) + Math.pow(diffY, 2)),
                    frames = Math.floor(dist / 5),
                    clientX = this.grabHistory[this.grabHistory.length - 1].clientX,
                    clientY = this.grabHistory[this.grabHistory.length - 1].clientY,
                    changeX = true,
                    changeY = true;

                
                if(frames < this.minThrowFrames) frames = this.minThrowFrames;
                else if(frames > this.maxThrowFrames) frames = this.maxThrowFrames;

                this.throwSequence = [];

                for(var i = 0; i < frames; i++) {
                    var percent = i / frames,
                        speed = Math.pow(percent - 1, 2),
                        clientX = Math.floor(speed * diffX) + clientX,
                        clientY = Math.floor(speed * diffY) + clientY,
                        pos = this.validatePos(this.getGrabPos({
                            clientX: clientX,
                            clientY: clientY
                        }));

                    
                    
                    if(!changeX) pos[0] = this.throwSequence[this.throwSequence.length - 1][0];
                    else if(this.throwSequence.length && pos[0] == this.throwSequence[this.throwSequence.length - 1][0]) changeX = false;
                    if(!changeY) pos[1] = this.throwSequence[this.throwSequence.length - 1][1];
                    else if(this.throwSequence.length && pos[1] == this.throwSequence[this.throwSequence.length - 1][1]) changeY = false;

                    
                    if(!this.isPosLoaded(pos)) {
                        loaded = false;
                        break;
                    }

                    this.throwSequence.push(pos);
                }

                if(loaded) {
                    this.throwing = true;
                    this.throwInterval = setInterval(this.throwStep.bind(this), this.playIntervalDuration);
                }
            }
        }
    };

    module.prototype.throwStep = function() {
        this.gotoPos(this.throwSequence.shift());
        if(!this.throwSequence.length) {
            this.stopThrowing();
        }
    };

    module.prototype.stopThrowing = function() {
        if(!this.throwing) return;
        this.throwing = false;
        clearInterval(this.throwInterval);
    };

    module.prototype.onclick = function(event) {
        if(this.focussed) return;

        this.vr.focus();
    };

    
    module.LoaderController = function(vr, queue, onLoad) {
        this.vr = vr;
        this.queue = queue;
        this.onLoad = onLoad;
        this.retiredLoaders = new Array();

        for(var i = 0; i < this.vr.options.loaders; i++) {
            this.loadNext(new module.Loader(this));
        }
    };

    module.LoaderController.prototype.loadNext = function(loader) {
        if(this.queue.length) {
            loader.load(this.queue.shift());
        } else {
            this.retiredLoaders.push(loader);
            if(this.retiredLoaders.length == this.vr.options.loaders && typeof this.onLoad == 'function') {
                this.onLoad();
                this.onLoad = null;
            }
        }
    };

    module.LoaderController.prototype.loadNow = function(pos) {
        if(this.retiredLoaders.length) {
            this.retiredLoaders.shift().load(pos);
        } else {
            this.queue.unshift(pos);
        }
    };

    
    module.Loader = function(controller) {
        this.controller = controller;
        this.loadNext = this.controller.loadNext.bind(this.controller);
    };

    module.Loader.prototype.load = function(pos) {
        this.pos = pos;

        
        if(this.controller.vr.isPosLoaded(pos)) {
            this.controller.loadNext(this);
            return;
        }

        this.img = new Image();
        this.img.onload = this.onLoad.bind(this);
        var widgetModel = this.controller.vr.options.model;
        var heightwidth = widgetModel.heightwidth;
        if((heightwidth && heightwidth != "0,0") || (widgetModel.referencewidth || widgetModel.referenceheight)) {
            var dimensions = heightwidth ? heightwidth.split(",") : [widgetModel.referenceheight, widgetModel.referencewidth];
            this.img.style.width = dimensions[1] + "px";
            this.img.style.height = dimensions[0] + "px";
        } else {
            this.img.style.width = "100%"; 
        }

        this.controller.vr.frames[this.pos[0]][this.pos[1]] = true;
        this.img.src = this.controller.vr.getImageSource(this.pos);
        delete this.img;
    };

    module.Loader.prototype.onLoad = function(event) {
        if(!event)
            event = window.event;
        var target = event.target || event.srcElement || this.img;
        this.controller.vr.frames[this.pos[0]][this.pos[1]] = target;
        if(target && target.onload)
            delete target.onload;
        $KU.setImgAspectRatio(this.controller.vr.options.model, target);
        if(this.controller.vr.atPosition(this.pos))
            this.controller.vr.gotoPos(this.pos, true);
        
        this.loadNext(this);
    };


    return module;
}());


$KW.Browser = (function() {
    
    var _getIFrameNode = function(widgetModel){
        var widgetNode, iFrameNode;

        if(widgetModel.url && !module.isExternalUrl(widgetModel.url)) {
            widgetNode = $KW.Utils.getContentNodeFromNodeByModel(widgetModel);
            if(widgetNode) {
                iFrameNode = widgetNode.childNodes[0];
                return iFrameNode;
            }
        }
        return null;
    };
    

    var module = {
        initialize: function() {
            kony.events.addEvent("onorientationchange", "Browser", this.orientationHandler);
        },

        initializeView: function(formId) {
            $KU.setScrollBoxesHeight(formId, "Browser");
        },

        orientationHandler: function(formId, orientation) {
            $KU.setScrollBoxesHeight(formId, "Browser");

        },

        localFileRenderImpl: function(widgetModel, computedSkin, context) {
            var platformver = $KG["platformver"] ? $KG["platformver"] : "";
            var height = "height:100%;";
            var htmlString = "";
            var browserModel = widgetModel;
            var iframesrc = kony.appinit.getStaticContentPath() + platformver + "web/localfiles/" + browserModel.url;
            var baseHtmlStr = $KW.Utils.getBaseHtml(browserModel, context);
            htmlString += "<div " + baseHtmlStr + " style='" + height + $KW.skins.getPaddingSkin(browserModel) + "'>";
            htmlString += "<iframe width='100%' height='100%' style='overflow:auto;-webkit-overflow-scrolling: touch !important;' onLoad='$KW.Browser.prepareIframe(this," + widgetModel + ")' src='";
            htmlString += iframesrc;
            htmlString += "' id = 'iframe_" + browserModel.id + "' name='" + browserModel.id + "' kwidgettype='KonyLocalFrame'></iframe>";
            htmlString += "</div>";

            return htmlString;
        },

        updateView: function(widgetModel, propertyName, propertyValue, oldPropertyValue) {
            switch(propertyName) {
                case "requesturlconfig":
                    if(IndexJL) {
                        widgetModel.url = propertyValue.url;
                        widgetModel.method = propertyValue.requestmethod;
                        widgetModel.data = propertyValue.requestdata;
                    }
                    var element = $KU.getNodeByModel(widgetModel);
                    var platformver = $KG["platformver"] ? $KG["platformver"] : "";
                    if(propertyValue.URL.startsWith("http") || propertyValue.URL.startsWith("https") || propertyValue.URL.startsWith("www.")) {
                        this.openUrllink(widgetModel.url, widgetModel.method, widgetModel.data, [widgetModel.pf, widgetModel.id].join('_'));
                    } else {
                        if(element) {
                            var iframeNode = element.querySelector('iframe[kwidgettype="KonyLocalFrame"]');

                            if(iframeNode) {
                                iframeNode.src = kony.appinit.getStaticContentPath() + platformver + "\\" + "web\\localfiles\\" + propertyValue.URL;
                            } else {
                                var htmlString = "";
                                var computedSkin = $KW.skins.getWidgetSkinList(widgetModel, {});
                                htmlString = module.localFileRenderImpl(widgetModel, computedSkin, {});
                                element.parentNode.innerHTML = htmlString;
                            }
                        }
                    }
                    break;

                case "htmlstring":
                    var element = $KU.getNodeByModel(widgetModel);
                    if(element)
                        element.innerHTML = propertyValue;
                    break;
            }
        },

        openUrllink: function(url, method, data, name) {
            if(url) {
                if(url.startsWith("www.")) {
                    url = "http://" + url;
                }
                if(data && !data[0].length == 0) {
                    var args = [];
                    if(data instanceof Array && data[0] instanceof Array) {
                        for(var i = 0; i < data.length; i++) {
                            args.push([data[i][0], data[i][1]].join("="));
                        }
                    } else {
                        for(var k in data) {
                            args.push(k + "=" + data[k]);
                        }
                    }
                    args = args.join("&");
                    if(args)
                        url = url + "?" + args;
                }
                return window.open(url, name);
            }
        },

        isExternalUrl: function(url) {
            if(url.startsWith("http") || url.startsWith("https") || url.startsWith("www."))
                return true;
            else
                return false;
        },

        render: function(browserModel, context) {
            var computedSkin = $KW.skins.getWidgetSkinList(browserModel, context);
            $KU.updateScrollFlag(browserModel);
            var htmlString = "";
            if(browserModel.htmlstring) {
                var htmlString = "";
                var baseHtmlStr = $KW.Utils.getBaseHtml(browserModel, context);
                var heightWidthString = "";
                if($KW.FlexUtils.isFlexWidget(browserModel)) {
                    heightWidthString = " height:100%; width:100%;";
                }


                htmlString += "<div " + baseHtmlStr + " style='" + $KW.skins.getPaddingSkin(browserModel) + " " + $KW.skins.getBaseStyle(browserModel, context) + "' class='" + computedSkin + "'>";
                htmlString += browserModel.htmlstring;
                htmlString += "</div>";
                return htmlString;
            } else if(browserModel.url) {
                if(this.isExternalUrl(browserModel.url)) {
                    
                    var windowHandler = "webView" + browserModel.id;
                    $KG[windowHandler] = this.openUrllink(browserModel.url, browserModel.method, browserModel.data, $KW.Utils.getKMasterWidgetID(browserModel));
                    
                } else {
                    htmlString = module.localFileRenderImpl(browserModel, computedSkin, {});
                }
            }
            return htmlString;
        },

        eventHandler: function(eventObject, target) {},

        unloadEventHandler: function(widget) {

        },
        cangoback: function(webwidgetID) {

        },

        cangoforward: function(webwidgetID) {

        },

        clearhistory: function(webwidgetID) {

        },

        prepareIframe: function(that, browserModel) {
            var iFrame = that;
            var iFrameHead = iFrame.contentDocument.head;
            var myscript = document.createElement('script');
            if(browserModel.enablenativecommunication) {
                myscript.text = "if(typeof(kony) == 'undefined' || kony){kony={}};var executeInNativeCtx = function(userCallBackInNative){var parentdocument = parent['document'];var scriptTag = parentdocument.createElement('script');scriptTag.text=userCallBackInNative;parentdocument.head.appendChild(scriptTag);};kony.evaluateJavaScriptInNativeContext = executeInNativeCtx;";
            } else {
                myscript.text = "if(typeof(kony) == 'undefined' || kony){kony={}};var executeInNativeCtx = function(){throw ('enableNativeCommunciation property of the browser widget is set to false. Please set to true before invoking kony.executeInNativeContext !');};kony.evaluateJavaScriptInNativeContext = executeInNativeCtx;";
            }
            iFrameHead.appendChild(myscript);
        },

        evaluateJavaScript: function(widgetModel, jscript) {
            var element = $KW.Utils.getContentNodeFromNodeByModel(widgetModel);
            var thislocalframe = element.querySelector("iframe[kwidgettype='KonyLocalFrame']");
            if(thislocalframe) {
                kony.web.logger("log", "executing javascript in " + widgetModel.id + " window handler");
                var iframeHead = thislocalframe.contentDocument.head;
                if(iframeHead == null || iframeHead == undefined) {
                    var appendHead = document.createElement("head");
                    thislocalframe.contentDocument.appendChild(appendHead);
                    iframeHead = thislocalframe.contentDocument.head;
                }
                var iframeDocument = thislocalframe.contentDocument;
                var iframeScript = iframeDocument.createElement("script");
                iframeScript.text = jscript;
                iframeHead.appendChild(iframeScript);
            }
        },

        goBack: function(widgetModel) {
            var iFrameNode = _getIFrameNode(widgetModel);

            
            if(iFrameNode) {
                iFrameNode.contentWindow.history.back();
            }
        },
        goForward: function(widgetModel) {
            var iFrameNode = _getIFrameNode(widgetModel);

            
            if(iFrameNode) {
                iFrameNode.contentWindow.history.forward();
            }
        },
        reload: function(widgetModel) {
            var iFrameNode = _getIFrameNode(widgetModel);

            
            if(iFrameNode) {
                iFrameNode.contentWindow.location.reload(true);
            }
        }
    };


    return module;
}());


$KW.DataGrid = (function() {
    
    

    var module = {
        initialize: function() {
            kony.events.addEvent("click", "DataGrid", this.eventHandler);
        },

        initializeView: function(formId) {
            this.updateTableHeight(formId);
            this.resizeColumns(formId);
            this.updateColumnWidth(formId);
        },

        updateView: function(widgetModel, propertyName, propertyValue, oldPropertyValue) {
            var element = $KU.getNodeByModel(widgetModel);
            if(element && widgetModel.enablescrollbar == 1 && widgetModel.dockingheader)
                element = $KU.getElementById(widgetModel.pf + "_" + widgetModel.id + "_body").childNodes[0];

            switch(propertyName) {
                case "skin":
                case "alternateskin":
                case "rownormalskin":
                case "rowalternateskin":
                    element && this.applyRowSkin(widgetModel, element);
                    break;

                case "focusskin":
                case "rowfocusskin":
                    
                    break;

                case "headerskin":
                    if(element) {
                        var headerRow = element.tHead && element.tHead.rows[0];
                        if(headerRow) headerRow.className = propertyValue;
                    }
                    break;

                case "gridlinecolor":
                case "gridlinestyle":
                    this.applyCellBorder(widgetModel);
                    break;


                case "showcolumnheaders":
                    if(element) {
                        var headerRow = element.tHead && element.tHead.rows[0];
                        if(headerRow) {
                            if(propertyValue)
                                headerRow.style.display = "";
                            else
                                headerRow.style.display = "none";
                        }
                    }
                    break

                case "ismultiselect":
                    if(!propertyValue && widgetModel.selectedindices) {
                        widgetModel.selectedindices = widgetModel.selecteditems = null;
                        this.setSelectedItems(widgetModel, true);
                    }
                    break;

                case "data":
                    $KU.isArray(propertyValue) && this.modifyContent(widgetModel, propertyValue, "setdata");
                    break;

                case "columnheadersconfig":
                    if(element) {
                        var htmlstring = module.render(widgetModel, widgetModel.context);
                        element.parentNode.innerHTML = htmlstring;
                    }
                    break;
            }
        },

        
        render: function(gridModel, context) {
            gridModel.context = context;
            this.initializeGrid(gridModel);
            var parentModel = gridModel.parent;
            if($KW.FlexUtils.isFlexContainer(parentModel))
                gridModel.layoutConfig.self = true;
            return this.create(gridModel, context);
        },

        
        initializeGrid: function(gridModel) {
            if(!gridModel.columnheadersconfig)
                return;

            gridModel.rowcount = (gridModel.data && gridModel.data.length - IndexJL) || 0;
            gridModel.gridlinestyle = gridModel.gridlinestyle || "solid";
            gridModel.gridlinecolor = gridModel.gridlinecolor || "666666";
            gridModel.focusedindex = gridModel.selectedindex = gridModel.focusedindex || gridModel.selectedindex || null;
            gridModel.focuseditem = gridModel.selecteditem = gridModel.focuseditem || gridModel.selecteditem || null;
            gridModel.selectedindices = gridModel.selectedindices || null;
            gridModel.selecteditems = gridModel.selecteditems || null;
            if(gridModel.ismultiselect && gridModel.selectedindices && !gridModel.selecteditems) {
                this.setSelectedItems(gridModel);
            }
            gridModel.cellBorder = "thin " + gridModel.gridlinestyle + " #" + gridModel.gridlinecolor.substr(0, 6);
        },

        create: function(gridModel, context) {
            var rowdata = gridModel.data || (IndexJL ? [null] : []);
            var computedSkin = $KW.skins.getWidgetSkinList(gridModel, gridModel.context);
            var margin = $KW.skins.getMarginSkin(gridModel, context);

            var htmlString = "";
            gridModel.clonedTemplates = [];

            
            var computedSkinArray = computedSkin.split(" ");
            if(context.isPercent == true)
                computedSkinArray[1] = "";
            computedSkin = computedSkinArray.join(" ");

            if((gridModel.enablescrollbar == 1 && !gridModel.dockingheader) || $KW.FlexUtils.isFlexWidget(gridModel)) {

                htmlString += "<div class='" + computedSkin + "' style='overflow-y: auto; overflow-x: hidden;border-collapse:collapse;" + margin + "'>"
                htmlString += "<table style='width:100%;border-collapse:collapse;table-layout:fixed;'  " + $KW.Utils.getBaseHtml(gridModel, gridModel.context) + ">";
            } else {
                var wstyle = "border-collapse:collapse;table-layout:fixed;"
                if(context.ispercent == false)
                    wstyle += " display: inline-block;"
                htmlString += "<table style='" + wstyle + margin + "' class='" + computedSkin + "' " + $KW.Utils.getBaseHtml(gridModel, gridModel.context) + ">";
            }
            var columnModel = gridModel.columnheadersconfig;
            if(columnModel) {

                var header = this.headerBuilder(columnModel, gridModel);
                htmlString += this.appendRowTag(gridModel, header, true);

                var body = this.createBody(gridModel, rowdata, {"isNew":false,
                                                                "rowIndex": 0,
                                                                "colIndex": 0});
                htmlString += this.appendRowTag(gridModel, body || [], false, 1, true, true);
            }
            htmlString += "</table>";
            if((gridModel.enablescrollbar == 1 && !gridModel.dockingheader) || $KW.FlexUtils.isFlexWidget(gridModel)) {
                htmlString += "</div>"
            }
            return htmlString;
        },

        
        headerBuilder: function(columnModel, gridModel) {
            gridModel.columnids = [];
            gridModel.columntype = [];
            for(var i = IndexJL; i < columnModel.length; i++) {
                gridModel.columnids.push(columnModel[i].columnid);
                gridModel.columntype.push(columnModel[i].columntype);
            }
            var padding = $KW.skins.getBaseStyle(gridModel);
            var border = "word-wrap:break-word;border:" + gridModel.cellBorder + " ; font-weight:inherit;";
            var thTmpl = "<th id='{id}' style='overflow:hidden;" + padding + border + "' width='{width}%' class='{class}' type='{type}' colno='{colno}' colindex='{colindex}'>";
            var temp = null;
            var headerStr = "";
            var headerHTML = [];
            var colInfo = "";

            for(var i = IndexJL; i < columnModel.length; i++) {
                colInfo = columnModel[i];
                var width = (colInfo.columnwidthinpercentage || 0);
                var align = colInfo.columncontentalignment || "";
                align = $KW.skins.getContentAlignment(gridModel, align);

                temp = thTmpl.replace(/\{id\}/g, colInfo.columnid);
                temp = temp.replace(/\{width\}/g, width);
                temp = temp.replace(/\{class\}/g, align);
                temp = temp.replace(/\{type\}/g, colInfo.columntype);
                temp = temp.replace(/\{colno\}/g, i);
                temp = temp.replace(/\{colindex}/g, "0," + i);
                var headerTemp = colInfo.columnheadertemplate;
                if(headerTemp) {
                    temp = temp.replace(/\{colindex}/g, i);
                    var boxModel = headerTemp.template;
                    var rowData = headerTemp.data;
                    gridModel.widgetsData = rowData;
                    if(boxModel) {
                        gridModel.counter = 0;
                        temp += $KW.DataGrid.handleLayout(gridModel, boxModel, rowData).htmlString;
                    }
                    gridModel.widgetsData = ""
                    headerStr = temp + '</th>';
                } else {
                    headerStr = temp + ($KU.escapeHTMLSpecialEntities(colInfo.columnheadertext) || "") + '</th>';
                }
                headerHTML.push(headerStr);
            }
            return headerHTML;
        },

        
        createBody: function(gridModel, rowdata, metaData) {
            var bodyrowhtmlstr;
            var padding = $KW.skins.getBaseStyle(gridModel);
            var noOfItemsToRemove = (metaData.isNew == false) ? 1 : 0;
            var rowIndex = metaData.rowIndex;
            var colIndex = metaData.colIndex || 0;

            if(rowdata.length > IndexJL) {
                var border = "word-wrap:break-word;border:" + gridModel.cellBorder;
                var textTmpl = "<td id='{id}' width='{width}%' style='overflow:hidden;" + padding + border + "' class='{class}' colindex='{colindex}' >{text}</td>";
                var imgTmpl = "<td id='{id}' width='{width}%' style='overflow:hidden;" + padding + border + "' class='{class}' colindex='{colindex}'><img src={src} class='{class}' onload='$KW.DataGrid.imgLoadHandler(arguments[0],this)'></td>";
                var temp = null;
                var bodyrowhtml = [];
                var noofcolumns = 0;
                var id, colInfo = "";
                var colspan = 1;
                gridModel.counter = 1; 
                noofcolumns = gridModel.columnids.length;

                for(var i = IndexJL; i < rowdata.length; i++) {
                    bodyrowhtml[i - IndexJL] = [];
                    colIndex = 0;
                    gridModel.clonedTemplates.splice(rowIndex, noOfItemsToRemove, []);
                    for(var j = 0; j < noofcolumns; j++) {
                        id = gridModel.columnids[j];
                        colInfo = gridModel.columnheadersconfig[j + IndexJL];
                        colIndex++;
                        var type = gridModel.columntype[j];
                        var width = (colInfo.columnwidthinpercentage || 0);
                        var skin = "";
                        colspan = 1;
                        var cIndex = i + "," + j;
                        var cData = "";

                        if(rowdata[i]["metainfo"]) {
                            skin = rowdata[i]["metainfo"][id + "_skin"];
                            skin = skin || "";
                        }
                        var align = colInfo.columncontentalignment || "";
                        align = $KW.skins.getContentAlignment(gridModel, align);
                        type = type || "text";

                        if(type == "text") {
                            var text = (rowdata[i][id] && rowdata[i][id] != null) ? rowdata[i][id] : "";
                            text = text.replace(/\$0/g, '$$$$0');
                            
                            text = text.replace(/\$_/g, '$$$$_');
                            temp = textTmpl.replace(/\{text\}/g, $KU.escapeHTMLSpecialEntities(text));
                            cData = $KU.escapeHTMLSpecialEntities(text);
                            temp = temp.replace(/\{class\}/g, (skin + " " + align + " " + padding));
                        } else if(type == "image") {
                            var imgsrc = rowdata[i][id] && $KU.getImageURL(rowdata[i][id]);
                            cData = imgsrc;
                            temp = imgTmpl.replace(/\{src\}/g, imgsrc || "''");
                            temp = temp.replace(/\{class\}/g, align + " " + padding);
                        } else if(type == "template") {
                            var colData = rowdata[i][id];
                            if(colData["metainfo"]) {
                                if(colData["metainfo"]["colspan"]) {
                                    colspan = colData["metainfo"]["colspan"]
                                }
                            }
                            temp = "<td id='{id}' width='{width}%' style='overflow:hidden;" + padding + border + "' class='{class}' colindex='{colindex}' colspan='" + colspan + "'>";
                            temp = temp.replace(/\{class\}/g, (skin + " " + align + " " + padding));
                            var boxModel = colData.template || colInfo.columndatatemplate;
                            if(boxModel && colData) {
                                gridModel.widgetsData = colData;
                                var clonedData = $KW.DataGrid.handleLayout(gridModel, boxModel, colData);
                                temp += clonedData.htmlString;
                                cData = clonedData.clonedModel;
                            }

                            temp += '</td>';
                        }
                        gridModel.clonedTemplates[rowIndex].splice(colIndex, noOfItemsToRemove, cData);
                        temp = temp.replace(/\{colindex\}/g, cIndex);
                        temp = temp.replace(/\{width\}/g, width);
                        
                        temp = temp.replace(/\{id}/g, id);
                        bodyrowhtml[i - IndexJL][j] = temp;
                        j = j + (colspan - 1);
                    }
                    gridModel.counter++;
                    rowIndex++;
                }
            }
            return bodyrowhtml;
        },

        appendRowTag: function(gridModel, htmlArray, headerflag, index, generateTable, generateTBody) {
            var html = "";

            if(headerflag == true) {
                html += "<thead><tr index=0 " + $KW.Utils.getBaseHtml(gridModel, gridModel.context) + (gridModel.headerskin ? " class='" + gridModel.headerskin + "'" : "") + (gridModel.showcolumnheaders != "undefined" && gridModel.showcolumnheaders == false ? " style='display:none'" : "") + ">";
                if(gridModel.enablescrollbar == 1 && gridModel.dockingheader) {
                    html += "<td colspan='" + gridModel.columnheadersconfig.length + "'><div><table id='" + gridModel.pf + "_" + gridModel.id + "_head' width='100%' style='border-collapse:collapse;table-layout: fixed;'  ><tr >"
                }
                for(var i = 0; i < htmlArray.length; i++) {
                    html += htmlArray[i];
                }
                if(gridModel.enablescrollbar == 1 && gridModel.dockingheader) {
                    html += "</tr></table></div></td>"
                }
                html += '</tr></thead>';
            } else {
                var askin = gridModel.rowalternateskin || gridModel.alternateskin || "";
                var rskin = gridModel.rownormalskin || gridModel.skin || "";
                if(gridModel.enablescrollbar == 1 && gridModel.dockingheader && generateTable) {
                    html += "<tr><td colspan='" + gridModel.columnheadersconfig.length + "'><div style='width:100%;overflow-y: auto; overflow-x: hidden;border-collapse:collapse;' id='" + gridModel.pf + "_" + gridModel.id + "_body' name='scrollablewidget_" + gridModel.wType + "'><table style='border-collapse:collapse;width:100%' " + $KW.Utils.getBaseHtml(gridModel, gridModel.context) + " >"
                }
                if(generateTBody)
                    html += "<tbody>";
                if(htmlArray) {
                    for(var i = 0; i < htmlArray.length; i++) {
                        var metaInfo = gridModel.data[i + IndexJL].metainfo;
                        var skin = (metaInfo && metaInfo.skin) || ((i % 2 != 0 && askin) ? askin : rskin);
                        if(gridModel.ismultiselect && gridModel.selectedindices) {
                            if($KU.inArray(gridModel.selectedindices, (IndexJL ? index : index - 1))[0] && gridModel.rowfocusskin)
                                skin = gridModel.rowfocusskin;
                        }
                        html += "<tr index=" + index + $KW.Utils.getBaseHtml(gridModel, gridModel.context) + (skin ? " class='" + skin + "'" : "") + ">";
                        for(var j = 0; j < gridModel.columnids.length; j++) {
                            html += htmlArray[i][j];
                        }
                        html += '</tr>';
                        index++;
                    }
                }
                if(generateTBody)
                    html += "</tbody>";
                if(gridModel.enablescrollbar == 1 && gridModel.dockingheader && generateTable) {
                    html += "</table></div></td></tr>"
                }
            }
            return html;
        },

        handleLayout: function(gridModel, boxModel, layoutData) {
            var context = gridModel.context;
            var tabpaneID = context.tabpaneID; 
            context.container = gridModel;
            context.template_generator = boxModel;
            context.tabpaneID = "";
            if(!boxModel.pf) {
                _konyConstNS.Form2.addHeaderorFooter.call(boxModel, boxModel);
            }
            boxModel.isTemplate = true; 
            var clonedModel = owl.deepCopy(boxModel, null, false);
            $KW.Utils.updateLayoutData(gridModel, clonedModel, layoutData);
            context.setTopLevelBox(true);
            var htmlString = $KW[clonedModel.wType].render(clonedModel, context);
            context.setTopLevelBox(false);
            context.tabpaneID = tabpaneID;
            context.container = "";
            context.template_generator = "";
            return {"htmlString": htmlString,
                    "clonedModel": clonedModel}
        },

        getClonedModelOfWidget: function(wModel, wNode, containerId) {
            var gridModel = $KW.Utils.getContainerModelById(wNode, containerId);
            if(!gridModel)
                return;
            var context = module.getContextByNode(gridModel, wNode);
            var clonedTemp = module.getClonedModel(gridModel, context.rowIndex, context.colIndex);
            return clonedTemp[wModel.id];
        },

        getContextByNode: function(gridModel, wNode) {
            var cellNode = $KU.getParentByAttribute(wNode, "colindex");
            var rowIndex = cellNode.getAttribute('colindex').split(',')[0];
            var colIndex = cellNode.getAttribute('colindex').split(',')[1];

            return {
                rowIndex: rowIndex,
                colIndex: colIndex
            };
        },

        getClonedModel: function(gridModel, rowIndex, colIndex) {
            return gridModel.clonedTemplates[rowIndex][colIndex];
        },

        imgLoadHandler: function(event, img) {
            event = event || window.event;
            img = event.target || event.srcElement;
            var nWidth = img.naturalWidth || img.width;
            var nHeight = img.naturalHeight || img.height;
            var cell = img.parentNode;
            var padding = parseInt($KU.getStyle(cell, "padding-left").replace("px", ""), 10) + parseInt($KU.getStyle(cell, "padding-right").replace("px", ""), 10);
            var cellWidth = cell.clientWidth - padding;

            if(nWidth > cellWidth) {
                img.style.width = cellWidth + "px";
                var aspectratio = nWidth / nHeight;
                img.style.height = Math.round(1 / aspectratio * cellWidth) + "px";
            }
        },

        eventHandler: function(event, target) {
            if(!event)
                event = window.event;
            var cell = $KU.getParentByAttribute(event.target || event.srcElement, "colindex");
            var index = parseInt(target.getAttribute("index"), 10);
            var gridModel = $KU.getModelByNode(target);
            (index > 0) && module.setFocusedIndex(gridModel, target, cell, index);
            module.rowClickHandler(gridModel, index, cell);
        },

        rowClickHandler: function(gridModel, index, cell) {
            var event;
            spaAPM && spaAPM.sendMsg(gridModel, 'onrowselected');
            $KAR && $KAR.sendRecording(gridModel, 'click', {'colIndex': cell.getAttribute("colindex"), 'eventType': 'uiAction'});
            if(index == 0) { 
                var colInfo = gridModel.columnheadersconfig[parseInt(cell.getAttribute("colno"), 10)];
                event = $KU.returnEventReference(colInfo.columnonclick || colInfo.columnOnClick || "");
            } else { 
                event = $KU.returnEventReference(gridModel.onrowselected);
            }
            
            event && $KU.executeWidgetEventHandler(gridModel, event);
        },

        updateData: function(childModel, childNode, gridModel, row, canExecute) {
            if(gridModel && row) {
                var index = parseInt(row.getAttribute("index"));
                var cell, item;
                if(index == "0") {
                    cell = $KU.getParentByAttribute(childNode, "colindex");
                    var colInfo = gridModel.columnheadersconfig[cell.cellIndex + IndexJL];
                    var headerTemp = colInfo.columnheadertemplate;
                    if(headerTemp) {
                        item = headerTemp.data;
                    } else
                        item = colInfo.columnheadertext;
                    var cellindex = parseInt(cell.getAttribute("colindex").split(",")[1]);
                    gridModel.selectedcellindex = [cellindex, cell.id];
                    gridModel.selectedcellitem = item;
                } else {
                    var column = $KU.getParentByAttribute(childNode, "colindex");
                    this.setFocusedIndex(gridModel, row, column, index);
                    item = gridModel.focuseditem[column.id];
                }
                item && $KW.Utils.updateContainerMasterData(gridModel, item, childModel, childNode);

                if(canExecute) {
                    var eventExecuted = kony.events.executeBoxEvent(childModel, item, gridModel, "", index);
                    if(!eventExecuted) {
                        this.rowClickHandler(gridModel, index, cell);
                    }
                }

            }
        },

        setFocusedIndex: function(gridModel, row, column, index) {
            if(index > 0) {
                index = IndexJL ? index : index - 1;
                gridModel.selectedindex = gridModel.focusedindex = index;
                gridModel.selecteditem = gridModel.focuseditem = gridModel.data[index];
                if(!gridModel.ismultiselect) {
                    gridModel.selectedindices = IndexJL ? [null, index] : [index];
                    this.setSelectedItems(gridModel, true);
                }
                var cellindex = parseInt(column.getAttribute("colindex").split(",")[1]);
                gridModel.selectedcellindex = [cellindex, column.id];
                gridModel.selectedcellitem = gridModel.focuseditem[column.id];
            }
            gridModel.ismultiselect && this.setSelectedIndices(gridModel, row);
        },

        setSelectedIndices: function(gridModel, row) {
            if(gridModel.ismultiselect) {
                var indices = gridModel.selectedindices || (IndexJL ? [null] : []);
                var items = gridModel.selecteditems || (IndexJL ? [null] : []);
                var index = gridModel.focusedindex;
                var result = $KU.inArray(indices, index);
                if(result[0]) {
                    indices.splice(result[1], 1);
                    items.splice(result[1], 1);
                    if(gridModel.rowfocusskin) {
                        var skin = this.getRowSkin(gridModel, index);
                        row.className = skin || "";
                    }
                } else {
                    indices.push(index);
                    items.push(gridModel.data[index]);
                    gridModel.rowfocusskin && (row.className = gridModel.rowfocusskin);
                }
                gridModel.selectedindices = (indices.length > IndexJL) ? indices : null;
                gridModel.selecteditems = (items.length > IndexJL) ? items : null;
            }
        },

        setSelectedItems: function(gridModel, applyFocusSkin) {
            if(gridModel.selectedindices) {
                gridModel.selecteditems = IndexJL ? [null] : [];
                for(var i = IndexJL; i < gridModel.selectedindices.length; i++) {
                    gridModel.data && gridModel.data[gridModel.selectedindices[i]] && gridModel.selecteditems.push(gridModel.data[gridModel.selectedindices[i]]);
                }
            }
            if(applyFocusSkin) {
                var element = $KU.getNodeByModel(gridModel);
                if(element) {
                    var rows = element.tBodies[0].rows;
                    for(var i = 0; i < rows.length; i++) {
                        if((gridModel.selectedindices && $KU.inArray(gridModel.selectedindices, i + IndexJL)[0]) || (!gridModel.ismultiselect && gridModel.selectedindex == i + IndexJL))
                            rows[i].className = gridModel.rowfocusskin
                        else {
                            var skin = this.getRowSkin(gridModel, i + IndexJL);
                            rows[i].className = skin || "";
                        }
                    }
                }

            }
        },

        getRowSkin: function(gridModel, index) {
            var rowSkin = gridModel.rownormalskin || gridModel.skin || "";
            var askin = gridModel.rowalternateskin || gridModel.alternateskin || "";
            var metaInfo = gridModel.data[index]["metainfo"];
            return(metaInfo && metaInfo.skin) ? metaInfo.skin : (((parseInt(index, 10) - IndexJL) % 2 != 0 && askin) ? askin : rowSkin);
        },

        updateIndices: function(gridModel, action, index) {
            if(gridModel.data && gridModel.data.length > IndexJL) {
                var indices = gridModel.selectedindices;
                if(action == "addat") {
                    for(var i = IndexJL; i < indices.length; i++) {
                        if(indices[i] >= index)
                            indices[i] = indices[i] + 1;
                    }
                } else { 
                    var result = $KU.inArray(indices, index);
                    result[0] && indices.splice(result[1], 1);
                    for(var i = IndexJL; i < indices.length; i++) {
                        if(indices[i] >= index)
                            indices[i] = indices[i] - 1;
                    }
                }
                gridModel.selectedindices = indices.length > IndexJL ? indices : null;
                this.setSelectedItems(gridModel);
            } else {
                gridModel.selectedindices = gridModel.selecteditems = null;
            }
        },

        updateColumnWidth: function(formId) {
            var dataGridBodyDiv = document.querySelectorAll("#" + formId + " div[name='scrollablewidget_DataGrid']");
            for(var i = 0; i < dataGridBodyDiv.length; i++) {
                var bodyDiv = dataGridBodyDiv[i];
                var id = bodyDiv.getAttribute("id");
                id = id.split("_")[1];

                var gridModel = $KU.getModelByNode(bodyDiv.childNodes[0]);
                if(gridModel.enablescrollbar == 1 && gridModel.dockingheader && bodyDiv.clientWidth) {
                    var header = document.getElementById(gridModel.pf + "_" + gridModel.id + "_head");
                    var scrollbarWidth = bodyDiv.offsetWidth - bodyDiv.clientWidth;
                    header.style.width = header.parentNode.offsetWidth - scrollbarWidth + "px";
                }
            }
        },

        updateTableHeight: function(formId) {
            var grids = document.querySelectorAll("#" + formId + " table[kwidgettype='DataGrid']");
            var height;
            for(var i = 0; i < grids.length; i++) {
                var grid = grids[i];
                var gridModel = $KU.getModelByNode(grid);
                if(gridModel.enablescrollbar == 1 && (gridModel.containerheightinpixel || gridModel.containerheight)) {
                    if(gridModel.containerheightinpixel)
                        height = gridModel.containerheightinpixel;
                    else if(gridModel.containerheight) {
                        height = Math.round((grid.offsetWidth * gridModel.containerheight) / 100);
                    }
                    if(gridModel.dockingheader) {
                        $KU.getElementById(grid.id + "_body").style.maxHeight = height + "px";
                    } else
                        grid.parentNode.style.maxHeight = height + "px";

                }
            }
        },


        
        setData: function(widgetModel, dataArray) {
            widgetModel.focusedindex = widgetModel.focuseditem = widgetModel.selectedindex = widgetModel.selecteditem = widgetModel.selectedindices = widgetModel.selecteditems = null;

            $KU.isArray(dataArray) && this.modifyContent(widgetModel, dataArray, "setdata");
        },

        addAll: function(widgetModel, dataArray, key) {
            $KU.isArray(dataArray) && this.modifyContent(widgetModel, dataArray, "addall");
        },

        removeAll: function(widgetModel) {
            widgetModel.focusedindex = widgetModel.focuseditem = widgetModel.selectedindex = widgetModel.selecteditem = widgetModel.selectedindices = widgetModel.selecteditems = null;

            this.modifyContent(widgetModel, IndexJL ? [null] : [], "removeall");
        },

        removeAt: function(widgetModel, index) {
            (!isNaN(index) && index >= IndexJL) && this.modifyContent(widgetModel, [], "removeat", index);
        },

        
        setDataAt: function(widgetModel, dataObj, index) {
            (!isNaN(index) && index >= IndexJL && dataObj instanceof Object) && this.modifyContent(widgetModel, dataObj, "setdataat", index);
        },

        addDataAt: function(widgetModel, dataObj, index) {
            (!isNaN(index) && index >= IndexJL && dataObj instanceof Object) && this.modifyContent(widgetModel, dataObj, "addat", index);
        },

        
        setCellData: function(widgetModel, rowIndex, columnID, data) {
            (!isNaN(rowIndex) && data) && this.modifyContent(widgetModel, data, "setcelldata", rowIndex, columnID);
        },

        setHeaderCellDataAt: function(widgetModel, columnID, data) {
            (columnID && data) && this.modifyContent(widgetModel, data, "setheadercelldata", '', columnID);
        },

        applyCellSkin: function(widgetModel, rowIndex, columnID, skinID) {
            !isNaN(rowIndex) && this.modifyContent(widgetModel, skinID, "applycellskin", rowIndex, columnID);
        },

        selectAll: function(widgetModel, flag) {
            this.modifyContent(widgetModel, flag, "selectall");
        },

        setTBodyInnerHTML: function(tBody, html, action) {
            if(!$KU.isIE)
                tBody.innerHTML = html;
            else {
                
                var temp = this.createTemp();
                if(action == "setdata") {
                    temp.innerHTML = "<table>" + html + "</table>";
                    while(tBody.children.length > 0) { 
                        tBody.removeChild(tBody.children[0]);
                    }
                    while(temp.firstChild.children.length > 0) {
                        tBody.appendChild(temp.firstChild.children[0]);
                    }
                } else {
                    temp.innerHTML = "<table><tbody>" + html + "</tbody></table>";
                    if(tBody.tagName == 'TABLE') 
                        tBody.appendChild(temp.firstChild.firstChild);
                    else
                        tBody.parentNode.replaceChild(temp.firstChild.firstChild, tBody);
                }
            }
        },

        setTRInnerHTML: function(tr, html, index) {
            if(!$KU.isIE)
                tr.innerHTML = html;
            else {
                var temp = this.createTemp();
                temp.innerHTML = "<table><tbody><tr class='" + tr.className + "' index='" + index + "'>" + html + "</tr></tbody></table>";
                tr.parentNode.replaceChild(temp.firstChild.firstChild.firstChild, tr);
            }
        },

        createTemp: function() {
            var temp = document.getElementById("__temp");
            if(!temp) {
                temp = document.createElement("div");
                temp.id = "__temp";
            }
            return temp;
        },

        modifyContent: function(gridModel, dataArray, action, index, columnID) { 
            if(gridModel) {
                if(action != "setcelldata" && action != "applycellskin" && action != "selectall") {
                    gridModel.canUpdateUI = false;
                    $KW.Utils.updateContent(gridModel, "data", dataArray, action, index);
                    gridModel.canUpdateUI = true;
                }
                if(gridModel.data)
                    gridModel.rowcount = gridModel.data.length - IndexJL;

                var gridObj = $KU.getNodeByModel(gridModel);
                if(gridModel.enablescrollbar == 1 && gridModel.dockingheader)
                    gridObj = $KU.getElementById(gridModel.pf + "_" + gridModel.id + "_body").childNodes[0];

                var holder = gridObj && (gridObj.tBodies[0] || gridObj);
                var metaData = {"isNew" : false, "rowIndex" : index};
                if(holder) {
                    var cellIndex;
                    switch(action) {

                        case "setdata":
                            gridModel.clonedTemplates = [];
                            metaData.rowIndex = 0;
                            var header = this.headerBuilder(gridModel.columnheadersconfig, gridModel);
                            var innerHTML = this.appendRowTag(gridModel, header, true);
                            var body = this.createBody(gridModel, dataArray, metaData);
                            innerHTML += this.appendRowTag(gridModel, body, false, 1, false, true);
                            this.setTBodyInnerHTML(gridObj, innerHTML, "setdata");
                            break;

                        case "setdataat":
                            var dataArray = IndexJL ? [null, dataArray] : [dataArray];
                            var existingRow = holder.rows[index - IndexJL];

                            if(existingRow)
                                var innerHTML = this.createBody(gridModel, dataArray, metaData)[0].join("");
                            this.setTRInnerHTML(existingRow, innerHTML, index);
                            break;

                        case "addall":
                            var index = holder.rows.length;
                            metaData.rowIndex = index;
                            var body = this.createBody(gridModel, dataArray, metaData);
                            var innerHTML = holder.innerHTML + this.appendRowTag(gridModel, body, false, index + 1, false, false);
                            this.setTBodyInnerHTML(holder, innerHTML);

                            if(gridModel.enablescrollbar == 1 && gridModel.dockingheader) {
                                $KU.isIE && (holder = $KU.getElementById(gridModel.pf + "_" + gridModel.id + "_body").childNodes[0]);

                                var addedRow = holder.rows[index];
                                addedRow && addedRow.scrollIntoView(true);
                            }
                            break;

                        case "addat":
                            var rIndex = (index <= IndexJL) ? 0 : (index > gridModel.rowcount ? gridModel.rowcount : index);
                            var wrapper = document.createElement("div");
                            var dataArray = IndexJL ? [null, dataArray] : [dataArray];
                            wrapper.innerHTML = "<table><tr index=" + rIndex + $KW.Utils.getBaseHtml(gridModel, {
                                tabpaneID: gridObj.getAttribute("ktabpaneid")
                            }) + "></tr></table>";
                            metaData.isNew = true;
                            metaData.rowIndex = rIndex;
                            var innerHTML = this.createBody(gridModel, dataArray, metaData)[0].join("");
                            var newRow = wrapper.firstChild.rows[0];
                            if(index >= holder.rows.length)
                                holder.appendChild(newRow);
                            else
                                holder.insertBefore(newRow, holder.rows[index - IndexJL]);
                            this.setTRInnerHTML(newRow, innerHTML, index);
                            break;

                        case "setcelldata":
                        case "applycellskin":
                        case "setheadercelldata":
                            var result = $KU.inArray(gridModel.columnids, columnID);
                            if(result[0]) {
                                var htmlRow;
                                var rowData;
                                cellIndex = result[1];
                                var template = "";
                                var oldSkin;
                                var colInfo = gridModel.columnheadersconfig[cellIndex];
                                if(action == "setheadercelldata") {
                                    if(gridModel.showColumnHeaders) {
                                        index = 0;
                                        var headerTemp = colInfo.columnheadertemplate;
                                        if(headerTemp && headerTemp.template) {
                                            template = headerTemp.template;
                                            headerTemp.data = dataArray;
                                        }
                                        htmlRow = holder.parentNode.tHead.rows[0];
                                    }
                                } else {
                                    rowData = gridModel.data[index];
                                    if(rowData) {
                                        if(action == "setcelldata") {
                                            var rowTemp = colInfo.columndatatemplate;
                                            rowTemp && (template = rowTemp);
                                            rowData[columnID] = dataArray;
                                            htmlRow = holder.rows[index - IndexJL];
                                        } else {
                                            var metaInfo = rowData.metainfo || {};
                                            oldSkin = metaInfo[columnID + "_skin"];
                                            metaInfo[columnID + "_skin"] = dataArray;
                                            rowData.metainfo = metaInfo;
                                            htmlRow = holder.rows[index - IndexJL];
                                        }

                                    }
                                }

                                if(htmlRow) {
                                    if(action == "applycellskin") {
                                        if(oldSkin)
                                            $KU.removeClassName(htmlRow.cells[cellIndex], oldSkin);
                                        $KU.addClassName(htmlRow.cells[cellIndex], dataArray);
                                    } else {
                                        if(template) {
                                            gridModel.widgetsData = dataArray;
                                            htmlRow.cells[cellIndex].innerHTML = $KW.DataGrid.handleLayout(gridModel, template, dataArray);
                                        } else
                                            htmlRow.cells[cellIndex].innerHTML = dataArray;
                                    }
                                }
                            }
                            break;

                        case "removeall":
                            this.setTBodyInnerHTML(holder, "");
                            gridModel.clonedTemplates = [];
                            break;

                        case "removeat":
                            gridModel.clonedTemplates.splice(index, 1);
                            holder.rows[index - IndexJL] && holder.removeChild(holder.rows[index - IndexJL]);
                            break;

                        case "selectall":
                            if(gridModel.ismultiselect && gridModel.data && dataArray) {
                                var indices = IndexJL ? [null] : [];
                                for(var i = IndexJL; i < gridModel.data.length; i++) {
                                    indices.push(i);
                                }
                                gridModel.selectedindices = indices;
                            }
                            if(!dataArray) {
                                gridModel.selectedindices = gridModel.selecteditems = null;

                            }
                            this.setSelectedItems(gridModel, true);
                            break;

                        default:

                    }
                    this.adjustNodeIndex(holder);
                    if(action == "addat" || action == "removeat") {
                        gridModel.ismultiselect && gridModel.selectedindices && this.updateIndices(gridModel, action, index);
                    }
                    if(action == "addat" || action == "removeat" || action == "addall")
                        this.applyRowSkin(gridModel);

                    this.adjustFlexContainers(gridModel, action, index, cellIndex);
                }
                this.updateColumnWidth(gridModel.pf);
            }
        },

        adjustNodeIndex: function(node) { 
            var rows = node.childNodes;
            if(rows) {
                for(var i = 0; i < rows.length; i++) {
                    rows[i].setAttribute("index", i + 1);
                    cells = rows[i].cells;
                    for(var j = 0; cells && j < cells.length; j++) {
                        cells[j].setAttribute("colindex", i + "," + j);
                    }
                }
            }
        },

        addArray: function(srcArray, targetArray) {
            for(var i = 0; i < targetArray.length; i++) {
                srcArray.push(targetArray[i]);
            }
            return srcArray;
        },

        toggleVisibilty: function(model, data) {
            var node = $KU.getNodeByModel(model);
            var isFlexWidget = $KW.FlexUtils.isFlexWidget(model);
            if(isFlexWidget)
                node = node.parentNode;
            if(data && data.length > 0 && model.isvisible) {
                node.style.display = "";
                $KU.removeClassName(node, "hide");
            } else
                node.style.display = "none";
        },

        applyRowSkin: function(gridModel) {
            var holder = $KU.getNodeByModel(gridModel);
            var rows = holder.tBodies[0].rows;
            var rowSkin = gridModel.rownormalskin || gridModel.skin || "";
            var askin = gridModel.rowalternateskin || gridModel.alternateskin || "";
            
            if(rowSkin || askin) {
                for(var i = 0; i < rows.length; i++) {
                    var metaInfo = gridModel.data[i + IndexJL]["metainfo"];
                    var skin = (metaInfo && metaInfo.skin) ? metaInfo.skin : ((i % 2 != 0 && askin) ? askin : rowSkin);
                    if(gridModel.ismultiselect && gridModel.rowfocusskin && gridModel.selectedindices && $KU.inArray(gridModel.selectedindices, i + IndexJL)[0])
                        rows[i].className = gridModel.rowfocusskin;
                    else
                        rows[i].className = skin;
                }
            }
        },

        applyCellBorder: function(widgetModel) {
            var element = $KU.getNodeByModel(widgetModel);
            widgetModel.cellBorder = "thin " + widgetModel.gridlinestyle + " #" + widgetModel.gridlinecolor.substr(0, 6);
            if(element) {
                var applyStyle = function(rows) {
                    for(var i = 0; i < rows.length; i++) {
                        var row = rows[i];
                        for(var j = 0; j < row.cells.length; j++) {
                            row.cells[j].style.border = widgetModel.cellBorder;
                        }
                    }
                }
                applyStyle(element.tHead && element.tHead.rows);

                if(widgetModel.enablescrollbar == 1 && widgetModel.dockingheader)
                    element = $KU.getElementById(widgetModel.pf + "_" + widgetModel.id + "_body").childNodes[0];

                applyStyle(element.tBodies[0].rows);
            }
        }

        , resizeColumns: function(formId) {
            var grids = document.querySelectorAll("#" + formId + " table[kwidgettype='DataGrid']");
            for(var i = 0; i < grids.length; i++) {
                var grid = grids[i];
                var gridModel = $KU.getModelByNode(grid);
                if(gridModel.allowcolumnresize) {
                    gridModel.crInstance = new module.ColumnResize(grid, gridModel);
                    gridModel.crInstance.init();
                }
            }
        },

        
        adjustColumnResizeGrips: function(formId) {
            var grids = document.querySelectorAll("#" + formId + " table[kwidgettype='DataGrid']");
            for(var i = 0; i < grids.length; i++) {
                var grid = grids[i];
                var gridModel = $KU.getModelByNode(grid);
                if(gridModel.allowcolumnresize && gridModel.crInstance) {
                    var cr = gridModel.crInstance;
                    cr.syncGrips();
                    cr.syncColWidth();
                }
            }
        },

        
        adjustFlexContainers: function(model, action, rowIndex, colIndex) {
            $KU.needOptimization = false;
            var grid = $KU.getNodeByModel(model);
            var type = 'FlexContainer';
            switch(action) {
                case "setdata":
                    this.adjustFlexContainersInDataGrid(model, grid);
                    break;
                case "setdataat":
                case "addat":
                    var row = grid.tBodies[0].rows[rowIndex];
                    row && this.adjustFlexContainersInRows(row);
                    break;
                case "addall":
                    var rows = grid.tBodies[0].rows;
                    for(var i = rowIndex; i < rows.length; i++) {
                        this.adjustFlexContainersInRows(rows[i]);
                    }
                    break;
                case "setcelldata":
                case "setheadercelldata":
                    var column = grid.querySelector('[colindex="' + rowIndex + ',' + colIndex + '"]');
                    column && this.adjustFlexContainer(column);
                    break;
            }
            $KU.needOptimization = true;
        },

        adjustFlexContainersInDataGrid: function(wModel, wNode) {
            var masterData = wModel.data;
            if(masterData.length > 0) {
                var headerRow = wNode.tHead.rows[0];
                headerRow && this.adjustFlexContainersInRows(headerRow);
                var rows = wNode.tBodies[0].rows;
                for(var i = 0; i < rows.length; i++) {
                    this.adjustFlexContainersInRows(rows[i]);
                }
            }
        },

        adjustFlexContainersInRows: function(row) {
            var cells = row.cells;
            for(var i = 0; i < cells.length; i++) {
                this.adjustFlexContainer(cells[i]);
            }
        },

        adjustFlexContainer: function(cell) {
            var flexNode = cell.querySelector('div[kwidgettype="FlexContainer"]');
            if(flexNode) {
                var flexModel = $KU.getModelByNode(flexNode);
                $KW.FlexContainer.forceLayout(flexModel, flexNode.parentNode);
            }
        }
    };

    module.ColumnResize = function(grid, gridModel) {
        this.dragColumns = grid.rows[0].cells;
        this.minWidth = 17;
        if(!this.dragColumns) return;
        this.t = $(grid);
        this.t.g = [];
        this.t.c = [];
        this.t.w = this.t.width();
        this.t.cs = parseInt(kony.appinit.isIE ? grid.cellSpacing || grid.currentStyle.borderSpacing : $KU.getStyle(grid, "border-spacing")) || 2;
        this.t.b = parseInt(kony.appinit.isIE ? grid.border || grid.currentStyle.borderLeftWidth : $KU.getStyle(grid, 'border-left-width')) || 1; 
        this.t.ln = this.dragColumns.length;

        this.saveBodyCursor;

        this.cGrips = document.createElement("div");
        this.cGrips.id = grid.id + "_cGrips";
        this.cGrips.className = "colgrips";
        this.cGrips.style.margin = $KU.joinArray(gridModel.margin, "% ") + "%";
        grid.parentNode.insertBefore(this.cGrips, grid);
        this.t.gc = this.t.prev();
    };

    module.ColumnResize.prototype = {
        init: function() {
            for(var i = 0; i < this.dragColumns.length; i++) {
                if(i != this.t.ln - 1) {
                    this.cGrips.innerHTML += "<div class='colgrip' index='" + i + "'><div class='colresizer'></div></div>";
                } else
                    this.cGrips.innerHTML += "<div class='lastcolgrip' index='" + i + "'></div>";

                var c = {
                    col: this.dragColumns[i]
                };
                c.w = this.width(this.dragColumns[i]);
                this.t.c.push(c)
            }

            this.handleEventListener = this.handleEvent.bind(this);
            for(var i = 0; i < this.cGrips.children.length; i++) {
                this.t.g.push({
                    grip: this.cGrips.children[i]
                });
                if(i < this.t.ln - 1) kony.events.addEventListener(this.cGrips.childNodes[i], "mousedown", this.handleEventListener);
            }

            this.syncGrips();
        },

        syncGrips: function() {
            this.t.gc.style.width = this.width(this.t) + 'px'; 
            for(var i = 0; i < this.t.ln; i++) { 
                var c = this.t.c[i].col;
                this.t.g[i].grip.style.left = this.offset(c).left - this.offset(this.t).left + c.offsetWidth + this.t.cs / 2 + 'px';
                this.t.g[i].grip.style.height = this.t.c[0].col.offsetHeight + 'px';
            }
        },

        handleEvent: function(e) {
            switch(e.type) {
                case 'mousedown':
                    return this.startColumnDrag(e);
                    break;
                case 'mousemove':
                    return this.columnDrag(e);
                    break;
                case 'mouseup':
                    return this.stopColumnDrag(e);
                    break;
            }
        },

        startColumnDrag: function(e) {

            
            var currentTarget = e.currentTarget || e.srcElement.parentNode; 
            this.curGripNo = parseInt(currentTarget.getAttribute("index"));
            var g = this.t.g[this.curGripNo];
            g.ox = e.pageX || e.clientX;
            g.l = this.position(g.grip).left;

            kony.events.addEventListener(document, "mousemove", this.handleEventListener);
            kony.events.addEventListener(document, "mouseup", this.handleEventListener);

            this.saveBodyCursor = document.body.style.cursor;
            document.body.style.cursor = 'w-resize'

            if(this.t.c[this.curGripNo].l)
                for(var i = 0, c; i < this.t.ln; i++) {
                    c = this.t.c[i];
                    c.l = false;
                    c.w = this.width(c.col);
                }

            kony.events.preventDefault(e);
        },

        width: function(elem) {
            return elem.offsetWidth - this.xPadding(elem) - this.xBorder(elem);
        },

        xPadding: function(elem) {
            return parseFloat($KU.getStyle(elem, "padding-left").replace("px", "")) + parseFloat($KU.getStyle(elem, "padding-right").replace("px", ""));
        },

        xBorder: function(elem) {
            return parseFloat($KU.getStyle(elem, "border-left-width").replace("px", "")) + parseFloat($KU.getStyle(elem, "border-right-width").replace("px", ""));
        },

        offset: function(elem) {
            var docElem, body, clientTop, clientLeft, scrollTop, scrollLeft,
                box = {
                    top: 0,
                    left: 0
                },
                doc = elem.ownerDocument;

            docElem = doc.documentElement;
            body = doc.body;
            if(!doc) {
                return;
            }
            if(typeof elem.getBoundingClientRect !== "undefined") {
                box = elem.getBoundingClientRect();
            }
            clientTop = docElem.clientTop || body.clientTop || 0;
            clientLeft = docElem.clientLeft || body.clientLeft || 0;
            scrollTop = window.pageYOffset || docElem.scrollTop;
            scrollLeft = window.pageXOffset || docElem.scrollLeft;
            return {
                top: box.top + scrollTop - clientTop,
                left: box.left + scrollLeft - clientLeft
            };
        },

        position: function(elem) {
            var offsetParent = this.offsetParent(elem),
                offset = this.offset(elem),
                parentOffset = this.root.test(offsetParent.nodeName) ? {
                    top: 0,
                    left: 0
                } : this.offset(offsetParent);

            
            
            
            offset.top -= parseFloat($KU.getStyle(elem, "margin-top")) || 0;
            offset.left -= parseFloat($KU.getStyle(elem, "margin-left")) || 0;

            
            parentOffset.top += parseFloat($KU.getStyle(offsetParent, "border-top-width")) || 0;
            parentOffset.left += parseFloat($KU.getStyle(offsetParent, "border-left-width")) || 0;

            
            return {
                top: offset.top - parentOffset.top,
                left: offset.left - parentOffset.left
            };
        },

        offsetParent: function(elem) {
            var offsetParent = elem.offsetParent || document.body;
            while(offsetParent && (!this.root.test(offsetParent.nodeName) && $KU.getStyle(elem, "position") === "static")) {
                offsetParent = offsetParent.offsetParent;
            }
            return offsetParent || document.body;
        },

        columnDrag: function(e) {
            var gInfo = this.t.g[this.curGripNo];
            var x = (e.pageX || e.clientX) - gInfo.ox + gInfo.l; 
            var mw = this.minWidth,
                i = this.curGripNo; 
            var l = this.t.cs * 1.5 + mw + this.t.b;

            var max = i == this.t.ln - 1 ? this.width(this.t) - l : this.position(this.t.g[i + 1].grip).left - this.t.cs - mw; 
            var min = i ? this.position(this.t.g[i - 1].grip).left + this.t.cs + mw : l; 

            x = Math.max(min, Math.min(max, x)); 
            gInfo.x = x;
            gInfo.grip.style.left = x + 'px'; 
            this.syncCols();
            this.syncGrips(); 
            kony.events.preventDefault(e);
        },

        stopColumnDrag: function(e) {
            kony.events.removeEventListener(document, "mousemove", this.handleEventListener);
            kony.events.removeEventListener(document, "mouseup", this.handleEventListener);
            document.body.style.cursor = this.saveBodyCursor;

            var gInfo = this.t.g[this.curGripNo];
            if(gInfo.x) { 
                this.syncCols(true);
                this.syncGrips(); 
            }
            kony.events.preventDefault(e);
        },

        syncCols: function(isOver) {
            var gInfo = this.t.g[this.curGripNo];
            var i = this.curGripNo;
            var inc = gInfo.x - gInfo.l,
                c = this.t.c[i],
                c2 = this.t.c[i + 1];
            var w = c.w + inc;
            var w2 = c2.w - inc; 
            c.col.style.width = w + 'px';
            c2.col.style.width = w2 + 'px';
            if(isOver) {
                c.w = w;
                c2.w = w2;
            }
        },

        syncColWidth: function() {
            for(var i = 0; i < this.t.c.length; i++) {
                var c = this.t.c[i];
                c.w = this.width(c.col);
            }
        }
    };


    return module;
}());


$KW.Map = (function() {
    
    
    var getMarkerByIndex = function(index, locationDataList, mapWidget) {
        if(!module.map) {
            return;
        }
        
        if(mapWidget.markers.length) {
            marker = mapWidget.markers[index];
            return marker;
        }
        if(!locationDataList) {
            
            var locationDataList = mapWidget.locationdata;
        }

        var map = module.map;
        var urlt = null;
        var imageURL = (locationDataList[index].lat == undefined) ? locationDataList[index][4 + IndexJL] : (locationDataList[index].image || mapWidget.defaultpinimage);
        urlt = getPinImageURL(imageURL);

        var lat = (locationDataList[index].lat == undefined) ? locationDataList[index][IndexJL] : locationDataList[index].lat;
        var lon = (locationDataList[index].lat == undefined) ? locationDataList[index][1 + IndexJL] : locationDataList[index].lon;
        var desc = (locationDataList[index].lat == undefined) ? locationDataList[index][3 + IndexJL] : locationDataList[index].desc;
        var name = (locationDataList[index].lat == undefined) ? locationDataList[index][2 + IndexJL] : locationDataList[index].name;
        var marker = new google.maps.Marker({
            position: new google.maps.LatLng(lat, lon),
            map: map,
            icon: urlt,
            html: desc,
            hdrdescp: name,
            indexpoint: index
        });
        
        return marker;
    };

    var ConvertDataMaptoData = function(Model, data) {
        var map = Model.widgetdatamapforcallout || {}; 
        var masterdata = {};
        var keys = $KU.getkeys(map);
        var newmap = {};
        for(var i = 0; i < keys.length; i++) {
            newmap[map[keys[i]]] = keys[i];
        }
        var newkeys = $KU.getkeys(newmap);
        for(var j = 0; j < newkeys.length; j++) {
            
            var value = data[newkeys[j]];
            if(value && typeof value != "object" && typeof value !== "number" && value.toLowerCase().indexOf("i18n.getlocalizedstring") != -1)
                masterdata[newkeys[j]] = $KU.getI18NValue(value);
            else
                masterdata[keys[j]] = value;
        }
        return masterdata;
    };

    var CreateMarker = function(markerobj) {
        $KG.__markers = {};
        var mapModel = getMapModel();
        var index = 0;
        var mapCanvasElement = document.querySelectorAll('[name=map_canvas]')[0];
        var mapid = mapCanvasElement.getAttribute("id");
        var contentString = '<div kwidgettype="Kinfowindow" kinfoid="' + mapid + '"';
        var contentStringEnd = '</div>';
        for(var i = IndexJL; i < (markerobj.length - 1); i++) {
            var id = i;
            imageURL = markerobj[i].image;
            urlt = getPinImageURL(imageURL);
            var myLatlng1 = new google.maps.LatLng(markerobj[i].lat, markerobj[i].lon);
            var cmarker = new google.maps.Marker({
                id: id,
                position: myLatlng1,
                map: map,
                icon: urlt,
                html: markerobj[i].desc,
                hdrdescp: markerobj[i].name,
                indexpoint: i,

                draggable: true
            });
            $KG.__markers[id] = cmarker;

            google.maps.event.addListener(cmarker, 'dragend', function(marker) {
                return function() {

                    geocoder.geocode({
                        'latLng': cmarker.getPosition()
                    }, function(results, status) {
                        if(status == google.maps.GeocoderStatus.OK) {
                            module.RenderTheDirection($KG.__markers[0].getPosition(), $KG.__markers[1].getPosition(), markerobj[2]);
                        }
                    });

                }
            }(cmarker));
            new google.maps.event.addListener(cmarker, "click", function() {

                mapModel.onpinselect && mapModel.onpinselect(mapModel.locationdata[parseInt(this.indexpoint)]);


                if(this.showcallout || this.showcallout == undefined) {
                    var infowindow = new google.maps.InfoWindow({
                        content: contentString + ' mappointno="' + index + '">' + "<b>" + name + "</b> <br />" + desc + contentStringEnd
                    });
                    infowindow.setContent(contentString + ' mappointno="' + this.indexpoint + '">' + "<b>" + this.hdrdescp + "</b> <br />" + this.html + contentStringEnd);
                    infowindow.open(map, this);
                }
            });
            cmarker.setMap(map);

        }
    };

    var getInfoWindowByIndex = function(index, locationDataList) {
        if(!module.map) {
            return;
        }
        if(!locationDataList) {
            var mapWidget = getMapModel();
            var locationDataList = mapWidget.locationdata;
        }

        
        
        var mapCanvasElement = document.querySelectorAll('[name=map_canvas]')[0];
        var mapid = mapCanvasElement.getAttribute("id");
        var contentString = '<div kwidgettype="Kinfowindow" kinfoid="' + mapid + '"';
        var contentStringEnd = '</div>';
        var desc = (locationDataList[index].lat == undefined) ? locationDataList[index][3 + IndexJL] : locationDataList[index].desc;
        var name = (locationDataList[index].lat == undefined) ? locationDataList[index][2 + IndexJL] : locationDataList[index].name;
        return new google.maps.InfoWindow({
            content: contentString + ' mappointno="' + index + '">' + "<b>" + name + "</b> <br />" + desc + contentStringEnd
        });
    };

    var setParentForTemplateChildren = function(boxModel, children, parentModel) {
        boxModel.pf = parentModel.id;
        if(children && children.length > 0) {
            for(var i = 0; i < children.length; i++) {
                boxModel[children[i]].pf = parentModel.id;
                setParentForTemplateChildren(boxModel[children[i]], boxModel[children[i]].children, parentModel);
            }
        }
        kony.ui.Form2.prototype.createFormLevelHierarchy.call(parentModel, parentModel.ownchildrenref);
    };

    var _setEnabledMap = function(widgetModel, node) {
        var targetEl = node;

        if(widgetModel && (widgetModel.mapsrc === "static" || $KU.isBlackBerryNTH || ($KU.isWindowsPhone && $KU.isIE9))) {
            targetEl = node.getElementsByTagName("table")[0];
        }

        if(!targetEl) return;

        if(widgetModel.disabled === true || node.getAttribute("kdisabled") === "true") {
            var mask = document.createElement("div");
            mask.style.background = "#fff";
            mask.style.bottom = "0";
            mask.style.left = "0";
            mask.style.opacity = "0.5";
            mask.style.position = "absolute";
            mask.style.right = "0";
            mask.style.top = "0";
            mask.style.zIndex = "2147483647";
            mask.className = "google_map_mask";

            if(!!targetEl && !targetEl.querySelectorAll(".google_map_mask")[0]) {
                widgetModel.oldPosition = targetEl.style.position;
                targetEl.style.position = "relative";
                targetEl.appendChild(mask);
            }
        }
        if(widgetModel.disabled === false || node.getAttribute("kdisabled") === "false" && targetEl) {
            var mask = targetEl.querySelectorAll(".google_map_mask")[0];
            targetEl.style.position = !!widgetModel.oldPosition && widgetModel.oldPosition;
            !!mask && mask.parentNode.removeChild(mask);
        }
    };

    
    var initializeInfoBox = function() {
        if(typeof InfoBox === "undefined") {
            var script = document.createElement("script");
            script.type = "text/javascript";
            script.src = $KG.platformver+"jslib/tparty/googlemaps/infobox.js";
            document.body.appendChild(script);
            
            var callback = function() {
                infobox = new InfoBox();
            }
            if(!script.addEventListener) {
                script.onreadystatechange = function() {
                    (this.readyState == 'complete' || this.readyState == 'loaded') && callback();
                };
            } else
                script.onload = callback;
        }
    };

    
    var mapClickEventHandler = function(event) {
        var mapModel = getMapModel();
        if(mapModel.onclick) {
            var maphandler = $KU.returnEventReference(mapModel.onclick);
            var lat = event.latLng && event.latLng.lat();
            var lng = event.latLng && event.latLng.lng();
            
            maphandler && maphandler.call(mapModel, mapModel, {
                "lat": lat,
                "lon": lng
            });
        }
        $KAR && $KAR.sendRecording(mapModel, 'click', {'clickData': event, 'eventType': 'uiAction'});
        
        event.preventDefault && event.preventDefault();
        event.stopPropagation && event.stopPropagation();
    };

    var createInfobox = function(infobox, infoOptions) {
        initializeInfoBox();
        var mapModel = getMapModel();
        if(mapModel.enablemultiplecallouts) {
            infobox = new InfoBox();
        } else {
            pinInfoWindowCloseAll(mapModel);
        }
        var mapElement = $KU.getNodeByModel(mapModel);
        if(mapModel.calloutwidth < 1 || mapModel.calloutwidth > 100)
            mapModel.calloutwidth = 80;
        var infobox_width = mapModel.calloutwidth && (((mapElement.offsetWidth) * mapModel.calloutwidth * 0.01) + "px") || "280px";
        var infobox_left = parseInt(infobox_width, 10) / -2;
        var infobox_top = 0;
        var calloutPostion = mapModel.calloutPostion || "top";
        if(calloutPostion != "bottom") {
            infobox.alignBottom_ = true;
            var mIcon = infoOptions.icon;
            
            if(typeof infoOptions.icon == 'object') {
                mIcon = infoOptions.icon.url;
            }
            var mapKey = mIcon.slice(mIcon.lastIndexOf("/") + 1);
            infobox_top = -(module.pinImageSize[mapKey] ? module.pinImageSize[mapKey].height : 30);
        }
        infobox.content_ = getContentString(infoOptions.coData),
            infobox.disableAutoPan_ = false,
            infobox.position_ = infoOptions.position,
            infobox.maxWidth_ = 450,
            infobox.pixelOffset_ = new google.maps.Size(infobox_left, infobox_top),
            infobox.zIndex_ = 10,
            infobox.boxStyle_ = {
                opacity: 1,
                width: infobox_width,
                background: "none"
            },
            infobox.enableEventPropagation_ = true,
            infobox.closeBoxURL_ = "",
            infoOptions.data && $KW.Utils.updateLayoutData(mapModel, infoOptions.coData, infoOptions.data); 
        infobox.infoBoxClearance_ = new google.maps.Size(0, 0);
        return infobox;
    };

    var getContentString = function(mapCalloutData) {
        var contentString = "";
        var mapModel = getMapModel();
        var mapInfoTemplateData = mapCalloutData.template || mapModel.callouttemplate;
        if(typeof mapInfoTemplateData == "string") {
            mapInfoTemplateData = _kony.mvc.initializeSubViewController(mapInfoTemplateData);
        }
        if(mapInfoTemplateData) {
            mapInfoTemplateData.isTemplate = true;
            mapInfoTemplateData.formPathId = mapModel.formPathId;
            $KG.allTemplates[mapInfoTemplateData.id] = mapInfoTemplateData;
            setParentForTemplateChildren(mapInfoTemplateData, mapInfoTemplateData.children, mapInfoTemplateData);
            var data = ConvertDataMaptoData(mapModel, mapCalloutData);
            data && $KW.Utils.updateLayoutData(mapModel, mapInfoTemplateData, data);
            
            if(mapInfoTemplateData.wType == "FlexContainer") {
                var mapCanvasElement = document.querySelectorAll('[name=map_canvas]')[0];
                $KG.isUILayedOut = false;
                contentString = $KW.FlexContainer.render(mapInfoTemplateData, {});
                if(mapModel.calloutwidth < 1 || mapModel.calloutwidth > 100)
                    mapModel.calloutwidth = 80;
                var infobox_width = mapModel.calloutwidth && (((mapCanvasElement.offsetWidth) * mapModel.calloutwidth * 0.01) + "px") || "280px";
                var wrapper = document.createElement("DIV");
                wrapper.innerHTML = contentString;
                wrapper.style.width = infobox_width;
                mapCanvasElement.appendChild(wrapper);
                $KW.FlexContainer.forceLayout(mapInfoTemplateData, wrapper.children[0]);
                contentString = wrapper.innerHTML;
                mapCanvasElement.removeChild(wrapper);
                $KG.isUILayedOut = true;
                $KW.Utils.initializeGestures(mapInfoTemplateData);
            }
            setTimeout(function() {
                $KW.Utils.initializeGestures(mapInfoTemplateData);
            }, 500);
        }
        return contentString;
    };

    var getPinImageURL = function(imageURL) {
        if(typeof imageURL == 'object')
            imageURL = imageURL.source;
        return $KU.getImageURL(imageURL);
    };

    var createDataObjects = function(mapModel) {
        mapModel.pinMarkers = {};
        mapModel.pinInfowindow = {};
        mapModel.circleDataMap = {};
        mapModel.circleData = {};
        mapModel.polygonDataMap = {};
        mapModel.polygonData = {};
        mapModel.polylineDataMap = {};
        mapModel.polylineData = {};
    };

    var _loadMapScripts = function() {
        
        if((typeof google === "undefined" || typeof google.maps === "undefined") && !module.mapScriptRequested) {
            module.mapScriptRequested = true;
            
            
            var mapModel = getMapModel();
            var clientId = mapModel && mapModel.mapClientId;
            var mapApiKey = mapModel.mapApiKey;
            var script = document.createElement("script");
            script.type = "text/javascript";
            
            
            var appProtocol = "https:";
            if(window.location.protocol.indexOf("http") != -1) {
                appProtocol = window.location.protocol;
            }
            if(mapApiKey) {
                script.src = appProtocol + "//maps-api-ssl.google.com/maps/api/js?sensor=false"+ ("&key=" + mapApiKey) +"&callback=$KW.Map.setUpInteractiveCanvasMap";
            }
            else {
                script.src = appProtocol + "//maps-api-ssl.google.com/maps/api/js?sensor=false"+ ( !!clientId && ("&client=" + clientId) || "") +"&callback=$KW.Map.setUpInteractiveCanvasMap";
            }

            document.body.appendChild(script);
        } else {
            return;
        }
        
        var main = $KU.getElementById("__MainContainer");
        if(!main) {
            module.isMainContaineraVailable = false;
        } else {
            module.isMainContaineraVailable = true;
        }
    };

    var mapEventHandler = function(eventObject, target) {
        var id = target.id;
        var mapElem = document.getElementById(target.getAttribute("kformname") + "_static_map");
        var imgsrc = mapElem.getAttribute("src");
        var arr = imgsrc.match(/center=(.*)&/);
        var arr2 = arr[1].split(",");
        if(id.indexOf("_left") != -1) {
            arr2[1] = parseFloat(arr2[1]) - 0.002;
            mapElem.src = imgsrc.replace(/center=(.*)&/, "center=" + arr2[0] + "," + arr2[1] + "&");
        } else if(id.indexOf("_right") != -1) {
            arr2[1] = parseFloat(arr2[1]) + 0.002;
            mapElem.src = imgsrc.replace(/center=(.*)&/, "center=" + arr2[0] + "," + arr2[1] + "&");
        } else if(id.indexOf("_up") != -1) {
            arr2[0] = parseFloat(arr2[0]) - 0.002;
            mapElem.src = imgsrc.replace(/center=(.*)&/, "center=" + arr2[0] + "," + arr2[1] + "&");
        } else if(id.indexOf("_down") != -1) {
            arr2[0] = parseFloat(arr2[0]) + 0.002;
            mapElem.src = imgsrc.replace(/center=(.*)&/, "center=" + arr2[0] + "," + arr2[1] + "&");
        } else if(id.indexOf("_zoomin") != -1) {
            var zoomarr = imgsrc.match(/zoom=(.*)&size/);
            zoomarr = parseInt(zoomarr[1]) + 1;
            mapElem.src = imgsrc.replace(/zoom(.*)&size/, "zoom=" + zoomarr + "&size");
        } else if(id.indexOf("_zoomout") != -1) {
            var zoomarr = imgsrc.match(/zoom=(.*)&size/);
            zoomarr = parseInt(zoomarr[1]) - 1;
            mapElem.src = imgsrc.replace(/zoom(.*)&size/, "zoom=" + zoomarr + "&size");
        }
        

    };

    var mapInfoWindowEventHandler = function(eventObject, target) {
        while(!target.getAttribute("kwidgettype"))
            target = target.parentNode;
        var targetWidgetInfo = target.getAttribute("kinfoid");
        var targetWidgetID = $KU.getElementID(targetWidgetInfo); 
        var mapPointNo = target.getAttribute("mappointno");
        var mapModel = kony.model.getWidgetModel(module.formID, targetWidgetID);
        if(!mapModel) mapModel = getMapModel();
        var selectEvent = $KU.returnEventReference(mapModel.onselection);
        if(isNaN(parseInt(mapPointNo, 10))) {
            selectEvent && $KU.executeWidgetEventHandler(mapModel, selectEvent, mapModel[mapModel.id + "navigatetoloc"]);
            $KAR && $KAR.sendRecording(mapModel, 'clickOnPinCallout', {'locationData': mapModel[mapModel.id + "navigatetoloc"], 'eventType': 'uiAction'});
            
        } else {
            selectEvent && $KU.executeWidgetEventHandler(mapModel, selectEvent, mapModel.locationdata[parseInt(mapPointNo, 10)]);
            $KAR && $KAR.sendRecording(mapModel, 'clickOnPinCallout', {'locationData': mapModel.locationdata[parseInt(mapPointNo, 10)], 'eventType': 'uiAction'});
            
        }
    };

    var _setMapsHeight = function(formId) {
        var mapElementsBody = document.querySelectorAll("#" + formId + " div[kwidgettype='googlemap']");

        if(mapElementsBody) {
            for(var i = 0; i < mapElementsBody.length; i++) {
                var mapElement = mapElementsBody[i];
                var mapModel = $KU.getModelByNode(mapElement);
                if(!mapModel) {
                    var targetWidgetID = mapElement.getAttribute("id").split('_')[1];
                    var sourceFormID = mapElement.getAttribute("id").split('_')[0];
                    var tabPaneID = mapElement.getAttribute("ktabpaneid");
                    mapModel = kony.model.getWidgetModel(sourceFormID, targetWidgetID, tabPaneID);
                }
                $KU.setScrollHeight(mapModel);
            }
        }
    };

    var setPins = function(mapModel, mapData) {
        var data = mapModel.locationData;
        var newData = [];
        if(data && data.length > 0) {
            for(var i = 0; i < mapData.length; ++i) {
                var addItFlag = true;
                for(var j = 0; j < data.length; ++j) {
                    if(data[j].id == mapData[i].id) {
                        addItFlag = false;
                        break;
                    }
                }
                addItFlag && newData.push(mapData[i]);
            }
            newData = data.concat(newData);
        } else {
            newData = mapData;
        }
        mapModel.locationData = newData;
    };

    var getPinAndIndexFromLocationData = function(mapModel, pinId) {
        var data = mapModel.locationData;
        if(data && data.length > 0) {
            for(var i = 0; i < data.length; i++) {
                if(data[i].id == pinId) {
                    return {
                        index: i,
                        data: data[i]
                    };
                }
            }
        }
        return;
    };

    var removeShape = function(mapModel, shapeType, shapeId) {
        if(mapModel[shapeType + "DataMap"][shapeId]) {
            mapModel[shapeType + "DataMap"][shapeId].setMap(null);
            delete mapModel[shapeType + "DataMap"][shapeId];
            delete mapModel[shapeType + "Data"][shapeId];
        }
    };

    var drawShapes = function(mapModel) {
        for(var circleId in mapModel.circleData) {
            drawCircle(mapModel, mapModel.circleData[circleId]);
        }
        for(var polygonId in mapModel.polygonData) {
            drawPolygon(mapModel, mapModel.polygonData[polygonId]);
        }
        for(var polylineId in mapModel.polylineData) {
            drawPolyline(mapModel, mapModel.polylineData[polylineId]);
        }
    };

    var drawCircle = function(mapModel, circledt) {
        var lineColor = '#FF0000',
            fillColor = "white",
            lineWidth = 2;
        var navigateandzoom = true;
        if(circledt) {
            var latValue = circledt.centerLocation.lat;
            var lonValue = circledt.centerLocation.lon;
            var radius = circledt.radius * 10000;
            if(circledt.circleConfig) {
                lineColor = circledt.circleConfig.lineColor;
                fillColor = circledt.circleConfig.fillColor;
                lineWidth = circledt.circleConfig.lineWidth;
            }
            if(circledt.navigateAndZoom)
                navigateandzoom = circledt.navigateAndZoom;

            
            var centerLoc = new google.maps.LatLng(latValue, lonValue);
            if(navigateandzoom)
                module.map.panTo(centerLoc);

            var _circle = new google.maps.Circle({
                strokeColor: lineColor,
                strokeWeight: lineWidth,
                fillColor: fillColor,
                map: module.map,
                center: centerLoc,
                radius: radius
            });
            mapModel.circleDataMap[circledt.id] = _circle;
        }
    };

    var drawPolygon = function(mapModel, polygondt) {
        var lineColor = '#FF0000',
            fillColor = "white",
            lineWidth = 2,
            polyArrya = [];
        if(polygondt) {
            var polyCoords = polygondt.locations;
            if(polyCoords && polyCoords.length > 0 && polyCoords[0].lon) {
                for(var i = 0; i < polyCoords.length; i++) {
                    polyCoords[i].lng = polyCoords[i].lon;
                    polyCoords[i].lat = parseFloat(polyCoords[i].lat);
                    polyCoords[i].lng = parseFloat(polyCoords[i].lng);
                    delete polyCoords[i].lon;
                }
            }
            polyArrya.push(polyCoords);

            if(polygondt.polygonConfig) {
                lineColor = polygondt.polygonConfig.lineColor;
                fillColor = polygondt.polygonConfig.fillColor;
                lineWidth = polygondt.polygonConfig.lineWidth;

                if(polygondt.polygonConfig.innerPolygons) {
                    var innerPolyCoords = polygondt.polygonConfig.innerPolygons;
                    var inner, index;
                    for(index = 0; index < innerPolyCoords.length; index++) {
                        inner = innerPolyCoords[index];
                        polyArrya.push(inner);
                        if(inner && inner[0].lon) {
                            for(var i = 0; i < inner.length; i++) {
                                inner[i].lng = inner[i].lon;
                                inner[i].lat = parseFloat(inner[i].lat);
                                inner[i].lng = parseFloat(inner[i].lng);
                                delete inner[i].lon;
                            }
                        }
                    }
                }
            }
        }
        var polyGon = new google.maps.Polygon({
            strokeColor: lineColor,
            strokeWeight: lineWidth,
            fillColor: fillColor
        });
        
        polyGon.setMap(module.map);
        polyGon.setPaths(polyArrya);
        mapModel.polygonDataMap[polygondt.id] = polyGon;
    };

    var setPolylinePinData = function(polylinedata, pindata, locationpt) {
        if(!polylinedata) return;
        var pinLocation = polylinedata[locationpt];
        if(pinLocation) {
            if(!pinLocation.id)
                pinLocation.id = polylinedata.id + "_" + locationpt;
            pindata.push(pinLocation);
        }
    };

    var drawPolyline = function(mapModel, polylinedata) {
        var lineColor = '#FF0000',
            lineWidth = 2,
            polylineCoordinates = [],
            pindata = [];
        if(polylinedata) {
            setPolylinePinData(polylinedata, pindata, "startLocation");
            setPolylinePinData(polylinedata, pindata, "endLocation");
            if(pindata.length > 0) {
                createMarkersForLocations(mapModel, pindata);
            }
            var polyCoords = polylinedata.locations;
            if(polyCoords && polyCoords.length > 0 && polyCoords[0].lon) {
                for(var i = 0; i < polyCoords.length; i++) {
                    polyCoords[i].lng = polyCoords[i].lon;
                    polyCoords[i].lat = parseFloat(polyCoords[i].lat);
                    polyCoords[i].lng = parseFloat(polyCoords[i].lng);
                    delete polyCoords[i].lon;
                }
            }
            polylineCoordinates = polyCoords;
            if(polylinedata.polylineConfig) {
                lineColor = $KW.skins.convertHexValuetoRGBAForMap(polylinedata.polylineConfig.lineColor);
                lineWidth = polylinedata.polylineConfig.lineWidth;
            }
        }
        var polyLine = new google.maps.Polyline({
            path: polylineCoordinates,
            strokeColor: lineColor,
            strokeWeight: lineWidth
        });
        polyLine.setMap(module.map);
        mapModel.polylineDataMap[polylinedata.id] = polyLine;
    };

    var pinInfoWindowCloseAll = function(mapModel) {
        var pinInfowindow = mapModel.pinInfowindow;
        for(var pinId in pinInfowindow) {
            if(pinInfowindow.hasOwnProperty(pinId)) {
                pinInfoWindowClose(mapModel, pinId);
            }
        }
    };

    var pinInfoWindowClose = function(mapModel, pinId) {
        var infowindow = mapModel.pinInfowindow[pinId];
        infowindow && infowindow.close();
        delete mapModel.pinInfowindow[pinId];
    };

    
    var cachePinSizeAndSetupMarkers = function(mapModel, imageObj, markerOptions, navigateToFlag) {
        
        if(typeof module.pinImageSize === 'undefined')
            module.pinImageSize = {};

        var urlt = getPinImageURL(imageObj);
        var img = new Image();
        img.src = urlt;
        var mapKey = urlt.slice(urlt.lastIndexOf("/") + 1);
        markerOptions.icon = urlt;

        var anchorPosition = kony.map.PIN_IMG_ANCHOR_BOTTOM_CENTER;
        if(typeof imageObj == 'object' && imageObj.anchor) {
            anchorPosition = imageObj.anchor;
        }
        if(anchorPosition == kony.map.PIN_IMG_ANCHOR_BOTTOM_CENTER) {
            if(navigateToFlag) setMarkerNavigateTo(mapModel, markerOptions);
            else setMarkerOnMap(mapModel, markerOptions);
        }
        if(!module.pinImageSize[mapKey]) {
            
            img.onload = function() {
                module.pinImageSize[mapKey] = {
                    height: this.naturalHeight,
                    width: this.naturalWidth
                };
                invokeAnchorMarker(mapModel, markerOptions, urlt, anchorPosition, this.naturalHeight, this.naturalWidth, navigateToFlag);
            }
        } else {
            invokeAnchorMarker(mapModel, markerOptions, urlt, anchorPosition, module.pinImageSize[mapKey].height, module.pinImageSize[mapKey].width, navigateToFlag);
        }
    };

    var invokeAnchorMarker = function(mapModel, markerOptions, url, anchorPosition, height, width, navigateToFlag) {
        if(anchorPosition != kony.map.PIN_IMG_ANCHOR_BOTTOM_CENTER) {
            markerOptions.icon = getAnchorMarkerIcon(url, anchorPosition, height, width);
            if(navigateToFlag) setMarkerNavigateTo(mapModel, markerOptions);
            else setMarkerOnMap(mapModel, markerOptions);
        }
    };

    
    var getAnchorMarkerIcon = function(url, anchorPosition, height, width) {
        switch(anchorPosition) {
            case kony.map.PIN_IMG_ANCHOR_TOP_LEFT:
                height = height + height;
                width = width;
                break;
            case kony.map.PIN_IMG_ANCHOR_TOP_RIGHT:
                height = height + height;
                width = 0;
                break;
            case kony.map.PIN_IMG_ANCHOR_TOP_CENTER:
                height = height + height;;
                width = parseInt(width / 2, 10);
                break;
            case kony.map.PIN_IMG_ANCHOR_CENTER:
                height = parseInt(height / 2, 10) + height;
                width = parseInt(width / 2, 10);
                break;
            case kony.map.PIN_IMG_ANCHOR_BOTTOM_LEFT:
                height = height;
                width = width;
                break;
            case kony.map.PIN_IMG_ANCHOR_BOTTOM_RIGHT:
                height = height;
                width = 0;
                break;
            case kony.map.PIN_IMG_ANCHOR_MIDDLE_LEFT:
                height = parseInt(height / 2, 10) + height;
                width = width;
                break;
            case kony.map.PIN_IMG_ANCHOR_MIDDLE_RIGHT:
                height = parseInt(height / 2, 10) + height;
                width = 0;
                break;
            case kony.map.PIN_IMG_ANCHOR_BOTTOM_CENTER:
                height = height;
                width = parseInt(width / 2, 10);
                break;
        }

        return {
            url: url,
            anchor: new google.maps.Point(width, height)
        };
    };

    var createMarkersForLocations = function(mapModel, mapdata) {
        for(var i = IndexJL; i < (mapdata.length); i++) {
            var imageURL = '';
            var myLatlng1 = new google.maps.LatLng(mapdata[i].lat, mapdata[i].lon);
            if(mapdata[IndexJL].lat == undefined) {
                imageURL = (mapdata[i][4 + IndexJL] || mapModel.defaultpinimage);
                myLatlng1 = new google.maps.LatLng(mapdata[i][IndexJL], mapdata[i][1 + IndexJL]);
            } else {
                imageURL = (mapdata[i].image || mapModel.defaultpinimage);
            }
            var desc = (mapdata[IndexJL].lat == undefined) ? mapdata[i][3 + IndexJL] : mapdata[i].desc;
            var name = (mapdata[IndexJL].lat == undefined) ? mapdata[i][2 + IndexJL] : mapdata[i].name;
            var showcallout = (mapdata[IndexJL].lat == undefined) ? mapdata[i][5 + IndexJL] : (mapdata[i].showcallout || mapdata[i].showCallout);
            var coData = mapdata[i].calloutData || mapdata[i].calloutdata;
            var pinId = mapdata[i].id || "noPinId";
            var markerOptions = {
                position: myLatlng1,
                html: desc,
                hdrdescp: name,
                map: module.map,
                indexpoint: i,
                pinId: pinId,
                coData: coData,
                showcallout: showcallout
            };
            cachePinSizeAndSetupMarkers(mapModel, imageURL, markerOptions, false); 
        }
    };

    var setMarkerOnMap = function(mapModel, markerOptions) {
        var marker1 = new google.maps.Marker(markerOptions);
        mapModel.markers.push(marker1);
        delete mapModel.pinMarkers[markerOptions.pinId];
        mapModel.pinMarkers[markerOptions.pinId] = marker1;
        new google.maps.event.addListener(marker1, "click", function() {
            if(!this.eventFromNavigateTo) {
                var pinClickEvent = $KU.returnEventReference(mapModel.onpinclick);
                pinClickEvent && pinClickEvent.call(mapModel, mapModel, mapModel.locationdata[parseInt(this.indexpoint)]);
                $KAR && $KAR.sendRecording(mapModel, 'clickOnPin', {'locationData': mapModel.locationdata[parseInt(this.indexpoint)], 'eventType': 'uiAction'});
            } 
            pinInfoWindowClose(mapModel, this.pinId);
            if(this.showcallout || this.showcallout == undefined || this.forceShowcallout) {
                if(this.coData) {
                    infobox = createInfobox(infobox, markerOptions);
                    infobox.open(this.map, this);
                    mapModel.pinInfowindow[this.pinId] = infobox;
                } else {
                    var infowindow = new google.maps.InfoWindow({
                        content: "holding..."
                    });
                    var contentString = '<div kwidgettype="Kinfowindow" kinfoid="' + mapModel.id + '"';
                    infowindow.setContent(contentString + ' mappointno="' + this.indexpoint + '">' + '<b kwidgettype="Kinfowindow" kinfoid="' + mapModel.id + '" mappointno="' + this.indexpoint + '">' + this.hdrdescp + "</b> <br />" + this.html + '</div>');
                    infowindow.open(this.map, this);
                    if(mapModel.autocenterpinonclick) {
                        this.map.setCenter(this.getPosition());
                    }
                    mapModel.pinInfowindow[this.pinId] = infowindow;
                }
            }
            this.forceShowcallout = false; 
            this.eventFromNavigateTo = false; 
        });
        marker1.setMap(markerOptions.map);
    };

    var setMarkerNavigateTo = function(mapModel, markerOptions) {
        var locationData = markerOptions.locationData;
        var index = "navigatetoloc";
        marker = new google.maps.Marker(markerOptions);
        if(!markerOptions.visible) marker.setMap(null);
        mapModel[mapModel.id + index] = locationData;
        if(markerOptions.showcallout) {
            var coData = locationData.calloutData || locationData.calloutdata;
            if(coData) {
                markerOptions.coData = coData;
                infobox = createInfobox(infobox, markerOptions);
                new google.maps.event.addListener(marker, "click", function() {
                    if(mapModel.autocenterpinonclick) {
                        this.map.setCenter(this.getPosition());
                    }
                    infobox.open(this.map, infobox);
                });
                infobox.open(this.map, infobox);
            } else {
                var infowindow = new google.maps.InfoWindow({
                    content: '<div kwidgettype="Kinfowindow" kinfoid="' + mapModel.id + '" mappointno="' + index + '"> <b>' + markerOptions.hdrdescp + '</b> <br />' + markerOptions.html + '</div>',
                });
                if(locationData && locationData.showcallout) {
                    new google.maps.event.addListener(marker, "click", function() {
                        if(mapModel.autocenterpinonclick) {
                            this.map.setCenter(this.getPosition());
                        }
                        infowindow.open(this.map, this);
                    });
                }
                infowindow.open(this.map, marker);
            }
        }
    };

    
    var onMapLoadedHandler = function() {
        var mapModel = getMapModel();
        if(!mapModel.loadedFlag) {
            mapModel.loadedFlag = true;
            
            if(mapModel.onmaploaded) {
                var maploadedhandler = $KU.returnEventReference(mapModel.onmaploaded);
                
                maploadedhandler && maploadedhandler.call(mapModel, mapModel);
            }
        }
        new google.maps.event.removeListener(module.tilesLoadedEventListener);
    };

    
    var mapBoundsChangeHandler = function() {
        var mapModel = getMapModel();
        if(mapModel.onboundschanged) {
            var boundschangedhandler = $KU.returnEventReference(mapModel.onboundschanged);
            if(boundschangedhandler) {
                var bounds = module.map.getBounds();
                var boundsval = {
                    "center": [bounds.getCenter().lat(), bounds.getCenter().lng()],
                    "northEast": [bounds.getNorthEast().lat(), bounds.getNorthEast().lng()],
                    "southWest": [bounds.getSouthWest().lat(), bounds.getSouthWest().lng()],
                    "latspan": bounds.toSpan().lat(),
                    "lonspan": bounds.toSpan().lng()
                };
                boundschangedhandler.call(mapModel, mapModel, boundsval);
            }
        }
    };

    var getMarkerDataforStaticMaps = function(mapModel) {
        var mapdata = mapModel.locationdata || mapModel.address;
        var markers = "";
        for(var i = IndexJL; i < mapdata.length; i++) {
            var lat = (mapdata[IndexJL].lat == undefined) ? mapdata[i][IndexJL] : mapdata[i].lat;
            var lon = (mapdata[IndexJL].lat == undefined) ? mapdata[i][1 + IndexJL] : mapdata[i].lon;
            (typeof mapModel.newPinimage != undefined) && (markers += "icon:" + mapModel.newPinimage + "%7C");
            
            markers += lat + "," + lon;
            if(i != mapdata.length)
                markers += "&markers=";
        }
        return markers;
    };

    var getMapModel = function() {
        var mapModel;
        if(module.kmasterID) {
            mapModel = $KU.getWidgetModelByID(module.formID + "_" + module.kmasterID + "_" + module.mapID);
        } else {
            mapModel = kony.model.getWidgetModel(module.formID, module.mapID);
        }
        return mapModel;
    };

    var mapModeChangedinGUIEventHandler = function () {
        var mapModel = getMapModel();
        if(mapModel) {
            switch(mapModel.map.mapTypeId) {
                case 'satellite':
                    mapModel.mode = constants.MAP_VIEW_MODE_SATELLITE;
                    break;
                case 'hybrid':
                    mapModel.mode = constants.MAP_VIEW_MODE_HYBRID;
                    break;
                case 'terrain':
                    mapModel.mode = constants.MAP_VIEW_MODE_TERRAIN;
                    break;
                case 'polygon':
                    mapModel.mode = constants.MAP_VIEW_MODE_POLYGON;
                    break;
                default :
                    mapModel.mode = constants.MAP_VIEW_MODE_NORMAL;
                    break;
            }
        }
    };
    

    var module = {
        formID: null,
        mapID: null,
        kmasterID: null,
        map: null,
        navigateToArgs: null,
        navigateToLocationArgs: null,
        mapScriptRequested: false,
        mapScriptLoaded: false,
        currentLatitude: null,
        currentLongitude: null,
        currentZoom: 15,
        routeToLocationArgs: null,
        circleData: null,
        polygonData: null,
        circleDataMap: null,
        polygonDataMap: null,

        initialize: function() {
            kony.events.addEvent("click", "Kinfowindow", mapInfoWindowEventHandler);
            kony.events.addEvent("click", 'Kstaticmap', mapEventHandler);
            kony.events.addEvent("onorientationchange", "Map", _setMapsHeight);
        },

        initializeView: function(formId) {
            
            if(document.querySelectorAll("div[name=map_canvas]").length > 0) {
                _loadMapScripts();
            }
            
            _setMapsHeight(formId);

        },

        updateView: function(widgetModel, propertyName, propertyValue, oldPropertyValue) {
            switch(propertyName) {
                case "address":
                case "locationdata":
                    if((widgetModel.mapsrc === "static") || $KU.isBlackBerryNTH || ($KU.isWindowsPhone && $KU.isIE9)) {
                        var mapElem = document.getElementById(widgetModel.pf + "_static_map");
                        if(!mapElem)
                            return;
                        var imgsrc = mapElem.getAttribute("src");
                        if(propertyName == "locationdata") {
                            var markers = getMarkerDataforStaticMaps(widgetModel);
                            if(imgsrc.indexOf("&markers") != -1) {
                                mapElem.src = imgsrc;
                                mapElem.src = mapElem.src.replace(/center=(.*)$/, "");
                                var center = "center=" + (!!propertyValue.length && propertyValue[0].lat || 0) + "," + (!!propertyValue.length && propertyValue[0].lon || 0) + "&";
                                mapElem.src += center;
                                mapElem.src += imgsrc.match(/markers=(.*)$/)[0] + markers;
                            } else
                                mapElem.src = imgsrc + "&markers=" + markers;
                        } else {
                            if(imgsrc.indexOf("&markers") != -1) {
                                imgsrc = imgsrc.replace(/markers=(.*)$/, "").replace("&markers=", "");
                            }
                            mapElem.src = imgsrc.replace(/center=(.*)&/, "center=" + propertyValue.location + "&markers=color:red%7C" + propertyValue.location);
                        }

                    } else {
                        var mapNode = $KU.getNodeByModel(widgetModel);
                        if(!mapNode)
                            return;
                        if(module.mapScriptLoaded) {
                            var main = $KU.getElementById("__MainContainer"); 
                            if(!main) {
                                module.isMainContaineraVailable = false;
                            } else {
                                this.setUpInteractiveCanvasMap();
                            }
                        } else {
                            _loadMapScripts();
                        }
                    }
                    break;

                case "zoom":
                case "zoomlevel":
                    if(widgetModel.map) {
                        widgetModel.map.setZoom(propertyValue);
                    }
                    break;

                case "showzoomcontrol":
                    if(widgetModel.map) {
                        widgetModel.map.setOptions({zoomControl: propertyValue});
                    }
                    break;

                case "mode":
                    if($KU.isBlackBerryNTH || ($KU.isWindowsPhone && $KU.isIE9)) {
                        var mapElem = document.getElementById(widgetModel.pf + "_static_map");
                        if(!mapElem)
                            return;
                        var imgsrc = mapElem.getAttribute("src");
                        var mapMode = "";

                        switch(parseInt(widgetModel.mode, 10)) {
                            case 2:
                                mapMode = "satellite";
                                break;

                            case 3:
                                mapMode = "hybrid";
                                break;

                            case 5:
                                mapMode = "polygon";
                                break;

                            case 7:
                                mapMode = "terrain";
                                break;

                            default:
                                mapMode = "normal";
                        }
                        if(propertyName == "mode")
                            mapElem.src = imgsrc.replace(/maptype=(.*)&mobile/, ("maptype=" + mapMode + "&mobile"));
                        else if(propertyName == "zoom" || propertyName == "zoomlevel")
                            mapElem.src = imgsrc.replace(/zoom(.*)&size/, "zoom=" + parseInt(propertyValue) + "&size");
                    } else {
                        var mapCanvasElement = document.querySelectorAll('[name=map_canvas]')[0];
                        mapCanvasElement && this.setUpInteractiveCanvasMap();
                    }
                    break;

                case "defaultpinimage":
                    var mapCanvasElement = document.querySelectorAll('[name=map_canvas]')[0];
                    if((widgetModel && widgetModel.mapsrc === "static") || $KU.isBlackBerryNTH || ($KU.isWindowsPhone && $KU.isIE9)) {
                        var pinimageurl = getPinImageURL(propertyValue);
                        pinimageurl = widgetModel.newPinimage = location.origin + "/" + pinimageurl;
                        this.setUpInteractiveCanvasMap();
                    } else {
                        widgetModel.defaultpinimage = propertyValue;
                        mapCanvasElement && this.setUpInteractiveCanvasMap();
                    }
                    break;
            }

        },

        render: function(mapModel, context) {
            mapModel.needScroller = true;
            mapModel.loadedFlag = false; 
            createDataObjects(mapModel);
            this.formID = mapModel.pf;
            this.mapID = mapModel.id;
            var computedSkin = $KW.skins.getWidgetSkinList(mapModel, context);
            var htmlString = "",
                controls = "";
            var mapsrc = mapModel.mapsrc || mapModel.mapsource;
            var appProtocol = "https:";
            if(window.location.protocol.indexOf("http") != -1) {
                appProtocol = window.location.protocol;
            }

            if((mapsrc === "static") || $KU.isBlackBerryNTH || ($KU.isWindowsPhone && $KU.isIE9)) {
                var visibility = $KW.skins.getVisibilitySkin(mapModel);
                var mapMode = "";
                switch(parseInt(mapModel.mode, 10)) {
                    case 2:
                        mapMode = "satellite";
                        break;

                    case 3:
                        mapMode = "hybrid";
                        break;

                    case 5:
                        mapMode = "polygon";
                        break;

                    case 7:
                        mapMode = "terrain";
                        break;

                    default:
                        mapMode = "normal";
                }
                var mapdata = mapModel.locationdata || mapModel.address;
                var centrallat = 0;
                var centrallon = 0;
                var markers = "";
                
                if(mapdata && mapdata[IndexJL]) {
                    centrallat = (mapdata[IndexJL].lat == undefined) ? mapdata[IndexJL][IndexJL] : mapdata[IndexJL].lat;
                    centrallon = (mapdata[IndexJL].lat == undefined) ? mapdata[IndexJL][1 + IndexJL] : mapdata[IndexJL].lon;
                    markers = getMarkerDataforStaticMaps(mapModel);
                }

                var upimage = getPinImageURL(mapModel.upimg ? mapModel.upimg : "tupF.png");
                var downimage = getPinImageURL(mapModel.downimg ? mapModel.downimg : "tdownF.png");
                var rightimage = getPinImageURL(mapModel.rightimg ? mapModel.rightimg : "trightF.png");
                var leftimage = getPinImageURL(mapModel.leftimg ? mapModel.leftimg : "tleftF.png");
                var zoominimage = getPinImageURL(mapModel.zoomin ? mapModel.zoomin : "zoomin.png");
                var zoomoutimage = getPinImageURL(mapModel.zoomout ? mapModel.zoomout : "zoomout.png");

                controls = "<table>" +
                    "<tr><td><img kwidgettype ='Kstaticmap' kformname='" + mapModel.pf + "' id='" + mapModel.id + "_up_event' src = '" + upimage + "'/></td>" +
                    "<td><img kwidgettype ='Kstaticmap' kformname='" + mapModel.pf + "' id='" + mapModel.id + "_down_event' src = '" + downimage + "'/></td>" +
                    "<td><img kwidgettype ='Kstaticmap' kformname='" + mapModel.pf + "' id='" + mapModel.id + "_right_event' src = '" + rightimage + "'/></td>" +
                    "<td><img kwidgettype ='Kstaticmap' kformname='" + mapModel.pf + "' id='" + mapModel.id + "_left_event' src = '" + leftimage + "'/></td>" +
                    "<td><img kwidgettype ='Kstaticmap' kformname='" + mapModel.pf + "' id='" + mapModel.id + "_zoomin_event' src = '" + zoominimage + "'/></td>" +
                    "<td><img kwidgettype ='Kstaticmap' kformname='" + mapModel.pf + "' id='" + mapModel.id + "_zoomout_event' src = '" + zoomoutimage + "'/></td></tr></table>";

                if(mapModel.disabled) {
                    controls = "<table style='position:relative;'>" +
                        "<tr><td>" +
                        "<div style='background:#fff;bottom:0;left:0;opacity:0.5;filter: progid:DXImageTransform.Microsoft.Alpha(Opacity=50);filter:alpha(opacity=50);position:absolute;right:0;top:0;z-index:2147483647' class='google_map_mask'></div>" +
                        "<img kwidgettype ='Kstaticmap' kformname='" + mapModel.pf + "' id='" + mapModel.id + "_up_event' src = '" + upimage + "'/></td>" +
                        "<td><img kwidgettype ='Kstaticmap' kformname='" + mapModel.pf + "' id='" + mapModel.id + "_down_event' src = '" + downimage + "'/></td>" +
                        "<td><img kwidgettype ='Kstaticmap' kformname='" + mapModel.pf + "' id='" + mapModel.id + "_right_event' src = '" + rightimage + "'/></td>" +
                        "<td><img kwidgettype ='Kstaticmap' kformname='" + mapModel.pf + "' id='" + mapModel.id + "_left_event' src = '" + leftimage + "'/></td>" +
                        "<td><img kwidgettype ='Kstaticmap' kformname='" + mapModel.pf + "' id='" + mapModel.id + "_zoomin_event' src = '" + zoominimage + "'/></td>" +
                        "<td><img kwidgettype ='Kstaticmap' kformname='" + mapModel.pf + "' id='" + mapModel.id + "_zoomout_event' src = '" + zoomoutimage + "'/></td></tr>" +
                        "</table>";
                    
                    
                }

                
                htmlString = "<div id='" + mapModel.pf + "_" + mapModel.id + "'class='" + visibility + "' style='" + $KW.skins.getMarginSkin(mapModel, context) + $KW.skins.getPaddingSkin(mapModel) + "' kwidgettype='Map' >" + controls;
                htmlString += "<img id='" + mapModel.pf + "_static_map' alt='Map Widget' style='width:100%;' src='"+appProtocol+"'://maps.google.com/maps/api/staticmap?sensor=false&zoom=15&size=400x400&format=png32&maptype=" + mapMode + "&mobile=true&center=" + centrallat + "," + centrallon +
                    "&markers=" + markers + "'/></div>";

            } else if(mapsrc == "native") {
                mapModel.widgetdata = appProtocol + "//maps.google.com/maps?q=17.447326,78.371358";
                htmlString = "<a style='text-decoration:none;' href='" + mapModel.widgetdata + "'>Google Map Name</a>"
            } else {
                var isPolygonview = "";
                if(mapModel.mapview === "5" || mapModel.mode == "5") {
                    isPolygonview = " mapview='polygon' ";
                }
                mapModel.formPathId = mapModel.pf + '_' + mapModel.id;


                htmlString = "<div kwidgettype='googlemap'  " + $KW.Utils.getBaseHtml(mapModel, context) + "  name='map_canvas'" + isPolygonview + " style='height:500px;" + $KW.skins.getMarginSkin(mapModel, context) + $KW.skins.getPaddingSkin(mapModel) + "' class='" + computedSkin +
                    "' konywidgetdata='" + mapModel.widgetdata + "'></div>";

                if(mapModel.kmasterid) mapModel.formPathId = mapModel.pf + '_' + mapModel.kmasterid + '_' + mapModel.id;

                this.kmasterID = mapModel.kmasterid;

            }
            return htmlString;
        },

        setUpInteractiveCanvasMap: function() {
            if("undefined" === typeof google) {
                
                $KG["mapScriptLoaded"] = false;
                module.mapScriptLoaded = false;
                return;
            }
            var mapModel = getMapModel();
            if(!mapModel)
                return;
            $KG["mapScriptLoaded"] = true;
            module.mapScriptLoaded = true;
            mapModel.markers = []; 
            
            if(mapModel && mapModel.mapsrc === "static" && ($KU.isBlackBerryNTH || ($KU.isWindowsPhone && $KU.isIE9))) {
                var mapElem = document.getElementById(mapModel.pf + "_static_map");
                var imgsrc = mapElem.getAttribute("src");
                var markers = getMarkerDataforStaticMaps(mapModel);
                imgsrc = imgsrc.replace(/markers=(.*)$/, "");
                mapElem.src = imgsrc + "&markers=" + markers;

            } else {
                var mapCanvasElement = document.querySelectorAll('[name=map_canvas]')[0];

                $KG["mapScriptLoaded"] = "false";
                if(mapCanvasElement) {
                    try {
                        var mapModel = getMapModel();
                        switch(parseInt(mapModel.mode, 10)) {
                            case 2:
                                var mapMode = google.maps.MapTypeId.SATELLITE;
                                break;

                            case 3:
                                var mapMode = google.maps.MapTypeId.HYBRID;
                                break;

                            case 7:
                                var mapMode = google.maps.MapTypeId.TERRAIN;
                                break;

                            default:
                                var mapMode = google.maps.MapTypeId.ROADMAP;
                        }
                    } catch(e) {
                        window.console && kony.web.logger("log", "google : map script has not loaded yet");
                        return;
                    }
                    
                    var mapview = mapCanvasElement.getAttribute("mapview");

                    var mapdata = mapModel.locationdata || mapModel.address;
                    var mapjsondata = mapdata;
                    var centralzoom = mapModel.zoomlevel || 15;
                    var myOptions = {
                        zoom: centralzoom,
                        disableDefaultUI: true,
                        zoomControl: mapModel.showzoomcontrol,
                        navigationControl: true,
                        mapTypeControl: mapModel.displaymaptypecontrols,
                        scaleControl: true,
                        mapTypeId: mapMode
                    };
                    var map;
                    
                    if(mapdata) {
                        var geocoder = new google.maps.Geocoder();
                        if(mapdata.location) {
                            map = new google.maps.Map(mapCanvasElement, myOptions)
                            geocoder.geocode({
                                'address': mapdata.location
                            }, function(results, status) {
                                if(status == google.maps.GeocoderStatus.OK) {
                                    map.setCenter(results[0].geometry.location);
                                    var marker = new google.maps.Marker({
                                        map: map,
                                        position: results[0].geometry.location
                                    });
                                }
                            });
                        } else if(mapdata.length >= 1 + IndexJL) {
                            var centrallat = mapdata[IndexJL].lat,
                                centrallon = mapdata[IndexJL].lon;
                            var points = [],
                                myLatlng, myOptions;

                            if(mapdata[IndexJL].lat == undefined) {
                                centrallat = mapdata[IndexJL][IndexJL];
                                centrallon = mapdata[IndexJL][1 + IndexJL];
                            }
                            
                            myLatlng = new google.maps.LatLng(centrallat, centrallon);
                            myOptions.center = myLatlng;
                            map = new google.maps.Map(mapCanvasElement, myOptions);
                            module.map = map;
                            mapModel.map = map;

                            initializeInfoBox();

                            if(mapview == null && mapModel.mode != "5") {
                                createMarkersForLocations(mapModel, mapdata);
                            } else {
                                var polyPoint = '';
                                for(var i = IndexJL; i < (mapdata.length); i++) {

                                    if(mapdata[IndexJL].lat == undefined) {
                                        polyPoint = new google.maps.LatLng(mapdata[i][IndexJL], mapdata[i][IndexJL]);
                                    } else {
                                        polyPoint = new google.maps.LatLng(mapdata[i].lat, mapdata[i].lon);
                                    }
                                    points.push(polyPoint);
                                }
                                var bermudaTriangle = new google.maps.Polygon({
                                    paths: points,
                                    strokeColor: "#FF0000",
                                    strokeOpacity: 0.8,
                                    strokeWeight: 3,
                                    fillColor: "#FF0000",
                                    fillOpacity: 0.35
                                });
                                bermudaTriangle.setMap(map);
                            }

                        } else if(mapdata.length == 0) {
                            
                            myOptions.center = new google.maps.LatLng(0, 0);
                            map = new google.maps.Map(mapCanvasElement, myOptions);
                            module.map = map;
                            mapModel.map = map;
                        }
                    } else {
                        myOptions.center = new google.maps.LatLng(0, 0);
                        map = new google.maps.Map(mapCanvasElement, myOptions);
                        module.map = map;
                        mapModel.map = map;
                        
                    }
                    _setEnabledMap(mapModel, mapCanvasElement);
                    if(module.navigateToArgs) {
                        module.navigateTo(module.navigateToArgs.mapModel, module.navigateToArgs.index, module.navigateToArgs.showCallOut);
                    }
                    if(module.navigateToLocationArgs) {
                        module.navigateToLocation(module.navigateToLocationArgs.mapModel, module.navigateToLocationArgs.locationData, module.navigateToLocationArgs.showCallOut, module.navigateToLocationArgs.dropPin);
                    }
                    if(module.routeToLocationArgs) {
                        module.navigateToLocation(module.routeToLocationArgs.mapModel, module.routeToLocationArgs.startlocationData, module.routeToLocationArgs.endlocationData, module.routeToLocationArgs.waypointslocation, module.routeToLocationArgs.routeConfig);
                    }
                    new google.maps.event.addListener(this.map, 'click', mapClickEventHandler);
                    new google.maps.event.addListener(this.map, 'bounds_changed', mapBoundsChangeHandler);
                    var tilesLoadedEventListener = new google.maps.event.addListener(this.map, 'tilesloaded', onMapLoadedHandler);
                    module.tilesLoadedEventListener = tilesLoadedEventListener;
                    drawShapes(mapModel);
                    if(map) {
                        map.zoom_changed = function() {
                            mapModel.zoomlevel = map.getZoom();
                        };
                    }
                    new google.maps.event.addListener(this.map, 'maptypeid_changed', mapModeChangedinGUIEventHandler);
                }
            }
        },

        routeLocations: function(mapWidget, startLocation, endLocation, locations, routeConfig) {
            if(!this.map) {
                return;
            }
            markers = {};
            
            var rendererOptions = {
                draggable: true,
                suppressMarkers: true,
                polylineOptions: {
                    strokeColor: routeConfig.lineColor,
                    strokeOpacity: 1,
                    strokeWeight: routeConfig.lineWidth
                }
            };
            directionsService = new google.maps.DirectionsService();
            directionsDisplay = new google.maps.DirectionsRenderer(rendererOptions);
            geocoder = new google.maps.Geocoder();
            var startlocation = new google.maps.LatLng(startLocation.lat, startLocation.lon);
            var endlocation = new google.maps.LatLng(endLocation.lat, endLocation.lon);
            var mapCanvasElement = document.querySelectorAll('[name=map_canvas]')[0];
            var myOptions = {
                zoom: 13,
                mapTypeId: google.maps.MapTypeId.ROADMAP,
                center: startlocation
            };


            map = new google.maps.Map(mapCanvasElement, myOptions);
            directionsDisplay.setMap(map);
            this.map = map;
            mapWidget.map = map;

            this.RenderTheDirection(startlocation, endlocation, locations);
            var markerObject = [startLocation, endLocation, locations];
            CreateMarker(markerObject);
        },

        navigateTo: function(mapWidget, index, showcallout) {
            if(!this.navigateToArgs) {
                this.navigateToArgs = {
                    'mapModel': mapWidget,
                    'index': index,
                    'showCallOut': showcallout
                };
            }
            if(!this.map) {
                return;
            }
            var index = parseInt(index);
            var map = this.map;
            var centrallat = '';
            var centrallon = '';
            var mapdata = mapWidget.locationdata;

            
            if(index < 1 && index >= mapdata.length) {
                return;
            }
            if(mapdata[index]) {
                centrallat = mapdata[index].lat;
                centrallon = mapdata[index].lon;
                if(mapdata[index].lat == undefined) {
                    centrallat = mapdata[index][IndexJL];
                    centrallon = mapdata[index][1 + IndexJL];
                }
            }

            map.setCenter(new google.maps.LatLng(centrallat, centrallon));

            if(showcallout) {
                
                var marker = getMarkerByIndex(index, mapdata, mapWidget);
                marker.forceShowcallout = true; 
                marker.eventFromNavigateTo = true; 
                google.maps.event.trigger(marker, "click");
            }
            this.navigateToArgs = null;
        },

        navigateToLocation: function(mapWidget, locationData, showcallout, dropPin) {
            if(!this.navigateToLocationArgs) {
                this.navigateToLocationArgs = {
                    'mapModel': mapWidget,
                    'locationData': locationData,
                    'showCallOut': showcallout,
                    'dropPin': dropPin
                };
            }
            if(!this.map) {
                return;
            }

            var lat = (locationData.lat) ? locationData.lat : locationData[IndexJL];
            var lon = (locationData.lon) ? locationData.lon : locationData[1 + IndexJL];
            var desc = (locationData.lat == undefined) ? locationData[3 + IndexJL] : locationData.desc;
            var name = (locationData.lat == undefined) ? locationData[2 + IndexJL] : locationData.name;
            var imageURL = (locationData.lat == undefined) ? locationData[4 + IndexJL] : (locationData.image || mapWidget.defaultpinimage);
            var urlt = (dropPin) ? getPinImageURL(imageURL) : null;
            var urlt = "";
            if(dropPin) {
                dropPin = true;
                urlt = getPinImageURL(imageURL);
            } else {
                if(typeof(marker) != 'undefined')
                    marker.setMap(null);
            }
            if(typeof(infowindow) != 'undefined') {
                infowindow.close();
            }
            var position = new google.maps.LatLng(lat, lon);
            this.map.setCenter(position);
            var markerOptions = {
                position: position,
                html: desc,
                icon: urlt,
                hdrdescp: name,
                visible: dropPin,
                map: this.map,
                locationData: locationData,
                showcallout: showcallout
            };
            cachePinSizeAndSetupMarkers(mapWidget, urlt, markerOptions, true);
            this.navigateToLocationArgs = null;
        },

        setEnabledMap: function(widgetModel, node) {
            _setEnabledMap(widgetModel, node);
        },

        loadMapScripts: function() {
            _loadMapScripts();
        },

        setMapsHeight: function(formId) {
            _setMapsHeight(formId);
        },

        RenderTheDirection: function(startLocation, endLocation, locations) {
            var waypointslocation = [];
            if(locations && locations != undefined) {
                for(var i = 0; i < locations.length; i++) {
                    waypointslocation[i] = new google.maps.LatLng(locations[i].lat, locations[i].lon);
                    waypointslocation[i] = {
                        location: waypointslocation[i] + ""
                    };
                }
            }
            var request = {
                origin: startLocation,
                destination: endLocation,
                waypoints: waypointslocation,
                travelMode: google.maps.TravelMode.DRIVING
            };
            directionsService.route(request, function(result, status) {
                if(status == google.maps.DirectionsStatus.OK) {
                    directionsDisplay.setDirections(result);
                }
            });

        },

        dismissCallout: function(mapid, location) {
            if(!mapid.enablemultiplecallouts) {
                if(typeof infobox != "undefined") infobox.close();
                
            } else if(location) {
                var pinId;
                if(location instanceof Array) {
                    pinId = location[0].id;
                } else {
                    pinId = location.id;
                }
                pinInfoWindowClose(mapid, pinId);
            }
        },

        
        addPin: function(mapModel, pindata) {
            setPins(mapModel, [pindata]);
        },

        
        addPins: function(mapModel, pindataArr) {
            setPins(mapModel, pindataArr);
        },

        
        updatePin: function(mapModel, pindata) {
            var existingPindataObj = getPinAndIndexFromLocationData(mapModel, pindata.id);
            if(!existingPindataObj)
                return;
            var existingPindata = existingPindataObj.data;
            this.removePin(mapModel, pindata, false);
            for(var key in pindata) {
                if(pindata.hasOwnProperty(key)) {
                    existingPindata[key] = pindata[key]
                }
            }
            mapModel.locationData[existingPindataObj.index] = existingPindata;
            createMarkersForLocations(mapModel, [existingPindata]);
        },

        
        updatePins: function(mapModel, pindataArr) {
            for(var i = 0; i < pindataArr.length; i++) {
                this.updatePin(mapModel, pindataArr[i]);
            }
        },

        
        removePin: function(mapModel, pindata, delLocDataFlag) {
            var marker = mapModel.pinMarkers[pindata.id];
            marker && marker.setMap(null);
            delete mapModel.pinMarkers[pindata.id];
            if(delLocDataFlag) {
                var existingPindataObj = getPinAndIndexFromLocationData(mapModel, pindata.id);
                if(!existingPindataObj)
                    return;
                mapModel.locationData.splice(existingPindataObj.index, 1);
            }
        },

        
        removePins: function(mapModel, pindataArr, delLocDataFlag) {
            
            for(var i = 0; i < pindataArr.length; i++) {
                this.removePin(mapModel, pindataArr[i], true);
            }
        },

        addPolygon: function(mapModel, polydata) {
            removePolygon(mapModel, polydata.id);
            mapModel.polygonData[polydata.id] = polydata;
            drawPolygon(mapModel, polydata);
        },

        addCircle: function(mapModel, circledata) {
            removeCircle(mapModel, circledata.id);
            mapModel.circleData[circledata.id] = circledata;
            drawCircle(mapModel, circledata);
        },

        addPolyline: function(mapModel, polylinedata) {
            if(mapModel.polylineData[polylinedata.id])
                removePolyline(mapModel, polylinedata.id);
            mapModel.polylineData[polylinedata.id] = polylinedata;
            drawPolyline(mapModel, polylinedata);
        },

        removePolygon: function(mapModel, polygonID) {
            removeShape(mapModel, "polygon", polygonID);
        },

        removeCircle: function(mapModel, circleID) {
            removeShape(mapModel, "circle", circleID);
        },

        removePolyline: function(mapModel, polylineID) {
            var pindata = [];
            setPolylinePinData(mapModel.polylineData[polylineID], pindata, "startLocation");
            setPolylinePinData(mapModel.polylineData[polylineID], pindata, "endLocation");
            if(pindata.length > 0)
                this.removePins(mapModel, pindata);
            removeShape(mapModel, "polyline", polylineID);
        },

        
        setCalloutVisibility: function(mapModel, visibilityFlag, pindataArr) {
            if(!mapModel.enablemultiplecallouts)
                return;
            
            for(var i = 0; i < pindataArr.length; i++) {
                if(visibilityFlag) {
                    var marker = mapModel.pinMarkers[pindataArr[i].id];
                    marker && google.maps.event.trigger(marker, "click");
                } else {
                    pinInfoWindowClose(mapModel, pindataArr[i].id);
                }
            }
        },

        clear: function(mapModel) {
            for(var circleId in mapModel.circleDataMap) {
                removeCircle(mapModel, circleId);
            }
            for(var polygonId in mapModel.polygonDataMap) {
                removePolygon(mapModel, polygonId);
            }
            for(var polylineId in mapModel.polylineDataMap) {
                removePolyline(mapModel, polylineId);
            }
            mapModel.locationData = []; 
        }
    };


    return module;
}());



$KW.TabPane = (function() {



    var module = {
        ANIMATION_DELAY : 500,

        initialize: function(){
            kony.events.addEvent("click", "Tab", this.eventHandler);
            kony.events.addEvent("click", "TabArrow", this.eventHandlerArrow);
            kony.events.addEvent("onorientationchange", "TabPane", this.orientationHandler);
        },

        initializeView: function(formId){
            this.toggleDisable(formId); 
            setTimeout(function(){
                module.setTabsHeight(formId);
            }, 1);

            $KW.touch.computeSnapWidths(formId, "Tabpane");
            $KU.setScrollBoxesHeight(formId, "TabPane");
        },

        orientationHandler: function(formId, orientation) {
            $KU.setScrollBoxesHeight(formId, "TabPane");
        },

        updateView: function(widgetModel, propertyName, propertyValue, oldPropertyValue){
            var tabView = widgetModel.viewtype;
            switch (propertyName) {
                case "activeskin":
                    if (tabView === 'tabview') {
                        for (var i = 0; i < widgetModel.children.length; i++) {
                            var cTabID = $KW.Utils.getKMasterWidgetID(widgetModel[widgetModel.children[i]]);
                            var tabWidgetBody = $KU.getElementById(cTabID + "_Body");
                            var tabWidgetLi = $KU.getElementById(cTabID + "_Li");
                            var tabWidgetA = $KU.getElementById(cTabID + "_A");

                            if (tabWidgetBody && tabWidgetBody.getAttribute('activebody') === '1') {
                                $KU.removeClassName(tabWidgetLi, oldPropertyValue + 'li');
                                $KU.removeClassName(tabWidgetA, oldPropertyValue + 'lia');
                                $KU.addClassName(tabWidgetLi, propertyValue + 'li');
                                $KU.addClassName(tabWidgetA, propertyValue + 'lia');
                            }
                        }

                    }else{
                        for (var i = 0; i < widgetModel.children.length; i++) {
                            var cTabID = $KW.Utils.getKMasterWidgetID(widgetModel[widgetModel.children[i]]);
                            var tabElementHeader = $KU.getElementById(cTabID + '_Header');
                            if (tabElementHeader) {
                                if (tabElementHeader.getAttribute('active') === '1') {
                                    $KU.removeClassName(tabElementHeader, oldPropertyValue);
                                    $KU.addClassName(tabElementHeader, propertyValue);
                                }
                            }
                        }
                    }
                    break;

                case "inactiveskin":
                     if (tabView === 'tabview') {
                         for (var i = 0; i < widgetModel.children.length; i++) {
                             var cTabID = $KW.Utils.getKMasterWidgetID(widgetModel[widgetModel.children[i]]);
                             var tabWidgetBody = $KU.getElementById(cTabID + "_Body");
                             var tabWidgetLi = $KU.getElementById(cTabID + "_Li");
                             var tabWidgetA = $KU.getElementById(cTabID + "_A");

                             if (tabWidgetBody && tabWidgetBody.getAttribute('activebody') === '0') {
                                 $KU.removeClassName(tabWidgetLi, oldPropertyValue + 'li');
                                 $KU.removeClassName(tabWidgetA, oldPropertyValue + 'lia');
                                 $KU.addClassName(tabWidgetLi, propertyValue + 'li');
                                 $KU.addClassName(tabWidgetA, propertyValue + 'lia');
                             }
                         }

                    }else{
                        for (var i = 0; i < widgetModel.children.length; i++) {
                            var cTabID = $KW.Utils.getKMasterWidgetID(widgetModel[widgetModel.children[i]]);
                            var tabElementHeader = $KU.getElementById(cTabID + '_Header');
                            if (tabElementHeader) {
                                if (tabElementHeader.getAttribute('active') === '0') {
                                    $KU.removeClassName(tabElementHeader, oldPropertyValue);
                                    $KU.addClassName(tabElementHeader, propertyValue);
                                }
                            }
                        }
                    }
                    break;

                    case "activetab":
                        var tabPaneWidget = $KU.getElementById($KW.Utils.getKMasterWidgetID(widgetModel));
                        if(propertyValue >= 0 && propertyValue < widgetModel.children.length){
                        widgetModel.activetab = propertyValue;
                        if(widgetModel.activetabs)
                            widgetModel.activetabs[IndexJL] = propertyValue;


                        if(widgetModel.viewtype === constants.TABPANE_VIEW_TYPE_PAGEVIEW){
                                var tabID = widgetModel.children[widgetModel.activetab];
                                module.changeActiveTabSkin(widgetModel,tabID);
                                var tabWidgetBody = $KU.getElementById( $KW.Utils.getKMasterWidgetID(widgetModel) + "_Body");
                                if(tabWidgetBody)
                                {
                                    var imgsElement = tabWidgetBody.children[0];
                                    var swipeContext = widgetModel.swipeContext;
                                    swipeContext.currentPage = widgetModel.activetab;
                                    $KW.touch.scrollImages(imgsElement, swipeContext.imageWidth * swipeContext.currentPage, $KU.swipeDuration, false, {"tabPaneModel":widgetModel,"tabID":tabID});
                                    $KW.touch.updatePageIndicator(tabPaneWidget, swipeContext, widgetModel);
                                }
                        }else{
                            this.repaint(tabPaneWidget, widgetModel);
                        }

                        }
                    break;

                    case "activetabs":
                        var tabPaneWidget = $KU.getElementById($KW.Utils.getKMasterWidgetID(widgetModel));

                        if(widgetModel.viewtype === constants.TABPANE_VIEW_TYPE_PAGEVIEW){
                                var tabID = widgetModel.children[widgetModel.activetab];
                                module.changeActiveTabSkin(widgetModel,tabID);
                                var imgsElement = $KU.getElementById( $KW.Utils.getKMasterWidgetID(widgetModel) + "_Body").children[0];
                                var swipeContext = widgetModel.swipeContext;
                                swipeContext.currentPage = widgetModel.activetab;
                                $KW.touch.scrollImages(imgsElement, swipeContext.imageWidth * swipeContext.currentPage, $KU.swipeDuration, false, {"tabPaneModel":widgetModel,"tabID":tabID});
                                $KW.touch.updatePageIndicator(tabPaneWidget, swipeContext, widgetModel);
                        }else{
                            this.repaint(tabPaneWidget, widgetModel);
                        }



                        break;

                    case "viewconfig":

                        var tabPaneWidget = $KU.getElementById($KW.Utils.getKMasterWidgetID(widgetModel));
                        if(propertyValue && !IndexJL){
                            widgetModel.viewconfig.collapsibleviewconfig = propertyValue.collapsibleViewConfig;
                            if(widgetModel.viewconfig.collapsibleviewconfig){
                                widgetModel.viewconfig.collapsibleviewconfig.onclick = propertyValue.collapsibleviewconfig.onClick;
                                widgetModel.expandedimage = widgetModel.viewconfig.collapsibleviewconfig.expandedimage = propertyValue.collapsibleviewconfig.expandedImage;
                                widgetModel.collapsedimage = widgetModel.viewconfig.collapsibleviewconfig.collapsedimage = propertyValue.collapsibleviewconfig.collapsedImage;
                                widgetModel.imageposition = widgetModel.viewconfig.collapsibleviewconfig.imageposition = propertyValue.collapsibleviewconfig.imagePosition;
                                widgetModel.tabnamealignment = widgetModel.viewconfig.collapsibleviewconfig.tabnamealignment = propertyValue.collapsibleviewconfig.tabNameAlignment;
                                widgetModel.toggletabs = widgetModel.viewconfig.collapsibleviewconfig.toggletabs = propertyValue.collapsibleviewconfig.toggleTabs;
                            }
                            if(widgetModel.viewConfig.pageViewConfig){
                                var pvconfigparams = propertyValue.pageViewConfig;
                                widgetModel.viewConfig.pageViewConfig = propertyValue.pageViewConfig;
                                widgetModel.pageondotimage = pvconfigparams.pageOnDotImage;
                                widgetModel.pageoffdotimage = pvconfigparams.pageOffDotImage;
                                widgetModel.needpageindicator = pvconfigparams.needPageIndicator;
                            }
                        }

                        this.repaint(tabPaneWidget, widgetModel);
                        break;

                    case "viewtype":
                        var tabPaneWidget = $KU.getElementById($KW.Utils.getKMasterWidgetID(widgetModel));
                        widgetModel.viewtype = propertyValue;

                        if(widgetModel.viewconfig)
                            widgetModel.toggletabs = widgetModel.viewconfig.collapsibleviewconfig.toggletabs;

                        this.repaint(tabPaneWidget, widgetModel);
                        break;



                    case "headertemplatedata":
                        var tab = $KU.getElementById($KW.Utils.getKMasterWidgetID(widgetModel) + "_Div");
                        if(tab && widgetModel.headertemplate && propertyValue instanceof Object){
                            var template = widgetModel.headertemplate;
                            var data = widgetModel.headertemplatedata;
                            widgetModel.context = {};
                            widgetModel.widgetsData = data;
                            tab.innerHTML = $KW.Utils.handleLayout(widgetModel, template, data);
                        }
                        break;
            }
        },

        render: function(tabPaneModel, context){
            var tabView = tabPaneModel.viewtype;
            var htmlString = "";
            $KU.updateScrollFlag(tabPaneModel);
            if(tabView == "tabview" || tabView == constants.TABPANE_VIEW_TYPE_PAGEVIEW){
                this.adjustActiveTabs(tabPaneModel);
                htmlString = this.generateTabView(tabPaneModel,context);
            }else{
                if (tabPaneModel.toggletabs === true){
                    this.adjustActiveTabs(tabPaneModel);
                    htmlString = this.generateAccordionView(tabPaneModel,context);
                }else{
                    htmlString = this.generateCollapsibleView(tabPaneModel,context);
                }
            }

            return htmlString;
        },

        repaint: function(tabPaneWidget, widgetModel){
            if(tabPaneWidget){
                if(widgetModel.viewtype === 'tabview' || widgetModel.viewtype == constants.TABPANE_VIEW_TYPE_PAGEVIEW){
                    tabPaneWidget.innerHTML = module.generateTabView(widgetModel,widgetModel.context,true);
                    setTimeout(function(){
                        module.checkArrows(widgetModel);
                    }, 1);

                    if(widgetModel.viewtype == constants.TABPANE_VIEW_TYPE_PAGEVIEW){
                        setTimeout(function(){
                            $KW.touch.computeSnapWidths(widgetModel.pf, "Tabpane");
                        }, 2);

                        var bodyElem = document.getElementById(tabPaneWidget.id + "_Body");
                        var pScrollerInstance = new $KW.touch.pageviewScroller(bodyElem, {widgetModel: widgetModel});
                        $KG[bodyElem.id] = pScrollerInstance;

                        this.updatePageFooter(widgetModel);

                    }
                    module.adjustFlexContainers(widgetModel);
                }
                else if(widgetModel.viewtype === 'collapsibleview' && widgetModel.toggletabs === 'true'){
                    tabPaneWidget.innerHTML = module.generateAccordionView(widgetModel,widgetModel.context,true);
                    setTimeout(function(){
                        module.setTabsHeight(widgetModel.pf);
                    }, 1);
                }
                else{
                    tabPaneWidget.innerHTML = module.generateCollapsibleView(widgetModel,widgetModel.context,true);
                    setTimeout(function(){
                        module.setTabsHeight(widgetModel.pf);
                    }, 1);
                }
            }
        },

        adjustFlexContainers: function(tabPaneModel){
            $KU.needOptimization = false;
            $KW.Form.initializeFlexContainersInBox(tabPaneModel);
            $KU.needOptimization = true;
        },

        generateTabView: function(tabPaneModel,context,updateViewFlag){
            var htmlString = '';
            var formModel = tabPaneModel;
            var margin = $KW.skins.getBaseStyle(tabPaneModel, context);
            var padding = $KW.skins.getPaddingSkin(tabPaneModel);
            var css = $KW.skins.getVisibilitySkin(tabPaneModel);
            var baseHtml = " ktabpaneid='" + tabPaneModel.id + "' kformname='" + tabPaneModel.pf + "' ";

            var paneId = tabPaneModel.pf + "_" + tabPaneModel.id;
            var kmasterObj = $KW.Utils.getMasterIDObj(tabPaneModel);
            if(kmasterObj.id != ""){
                paneId = kmasterObj.id;
            }
            var kmasterid = kmasterObj.kmasterid;
            var tabId;
            var marginPadding = $KW.skins.getMarginSkin(tabPaneModel, context) + $KW.skins.getPaddingSkin(tabPaneModel);
            if(!updateViewFlag)
                htmlString += "<div id = '" + paneId + "' class='" + css + "' style='" + marginPadding + "' kformname='" + tabPaneModel.pf + "' kwidgettype='TabPane' "+kmasterid+">";

            if(tabPaneModel.viewconfig.tabViewConfig && tabPaneModel.viewconfig.tabViewConfig.headerPosition == constants.TAB_HEADER_POSITION_BOTTOM){
                if(tabPaneModel.viewtype == constants.TABPANE_VIEW_TYPE_PAGEVIEW)
                    htmlString += "<div id = '" + paneId + "_Body' style='position:relative' name='touchcontainer_Tabpane' class='kstripcontainer' "+kmasterid+">";
                else
                    htmlString += "<div id = '" + paneId + "_Body' style='position:relative' "+kmasterid+">";

                if(tabPaneModel.viewtype == constants.TABPANE_VIEW_TYPE_PAGEVIEW){
                    htmlString += "<div id='imgs' class= 'kstrip' style='";
                    if(kony.appinit.isIE) {
                        htmlString += "position:relative";
                    }
                    htmlString += "'>";
                }
                for (var j = 0; j < tabPaneModel.children.length; j++) {
                    var tabModel = formModel[tabPaneModel.children[j]];
                    tabPaneModel.context = context;
                    htmlString += this.generateTabViewBody(tabPaneModel,tabModel,j,context);

                }
                htmlString += "</div>";

                if(tabPaneModel.viewtype == constants.TABPANE_VIEW_TYPE_PAGEVIEW)
                    htmlString += "</div>";

                htmlString += "<div class='ktable kwt100' id = '" + paneId + "_Header' style='position:relative;table-layout:fixed;' "+kmasterid+">";
                htmlString += "<div class='krow  kwt100'>";

                if(tabPaneModel.viewconfig.tabViewConfig && tabPaneModel.viewconfig.tabViewConfig.image1)
                    htmlString += "<div style='text-align: center;vertical-align: middle;' id = '" + paneId + "_L' class='kcell kwt2 hide' kwidgettype='TabArrow' "+kmasterid+"><img src='"+$KU.getImageURL(tabPaneModel.viewconfig.tabViewConfig.image1)+"' /></div>";
                else
                    htmlString += "<div id = '" + paneId + "_L' class='kcell kwt2 hide' style='background-color:red;'" + baseHtml + " kwidgettype='TabArrow' "+kmasterid+">Left</div>";

                htmlString += "<div id = '" + paneId + "_C' class=' kwt96' style='overflow:hidden;margin:auto;' "+kmasterid+">";
                htmlString += "<ul id = '" + paneId + "_Ul' class='middleleftalign' style='padding-bottom: 3px;white-space:nowrap;position:relative' "+kmasterid+">";

                for (var i = 0; i < tabPaneModel.children.length; i++) {

                    var tabModel = formModel[tabPaneModel.children[i]];
                    htmlString += this.generateTabViewLi(tabPaneModel,tabModel,i);
                }

                htmlString += "</ul>";
                htmlString += "</div>";

                if(tabPaneModel.viewconfig.tabViewConfig && tabPaneModel.viewconfig.tabViewConfig.image2)
                    htmlString += "<div style='text-align: center;vertical-align: middle;' id = '" + paneId + "_R' class='kcell kwt2 hide' kwidgettype='TabArrow' "+kmasterid+"><img src='"+$KU.getImageURL(tabPaneModel.viewconfig.tabViewConfig.image2)+"' /></div>";
                else
                    htmlString += "<div id = '" + paneId + "_R' class='kcell kwt2 hide' style='background-color:red;'" + baseHtml + " kwidgettype='TabArrow' "+kmasterid+">Right</div>";
                htmlString += "</div>";
                htmlString += "</div>";
            }else if(tabPaneModel.viewconfig.tabViewConfig && tabPaneModel.viewconfig.tabViewConfig.headerPosition == constants.TAB_HEADER_POSITION_LEFT){

                htmlString += "<div class='ktable kwt100' style='table-layout:fixed;'>";
                htmlString += "<div class='krow kwt100'>";

                if(tabPaneModel.viewconfig.tabViewConfig.headerContainerWeight)
                    htmlString += "<div class='kcell topcenteralign kwt"+tabPaneModel.viewconfig.tabViewConfig.headerContainerWeight+"'>";
                else
                    htmlString += "<div class='kcell topcenteralign kwt50'>";

                if(tabPaneModel.viewconfig.tabViewConfig && tabPaneModel.viewconfig.tabViewConfig.image1)
                    htmlString += "<div style='text-align: center;vertical-align: middle;' id = '" + paneId + "_T' class='kwt100 hide' kwidgettype='TabArrow' "+kmasterid+"><img src='"+$KU.getImageURL(tabPaneModel.viewconfig.tabViewConfig.image1)+"' /></div>";
                else
                    htmlString += "<div id = '" + paneId + "_T' class='kwt100 hide' style='background-color:red;'" + baseHtml + " kwidgettype='TabArrow' "+kmasterid+">Top</div>";

                htmlString += "<div id = '" + paneId + "_Header' class='kwt100' style='overflow:hidden;' "+kmasterid+">";

                htmlString += "<ul id = '" + paneId + "_Ul' class='middleleftalign' style='padding-bottom: 3px;position:relative;' "+kmasterid+">";

                for (var i = 0; i < tabPaneModel.children.length; i++) {

                    var tabModel = formModel[tabPaneModel.children[i]];
                    htmlString += this.generateTabViewSide(tabPaneModel,tabModel,i);
                }

                htmlString += "</ul>";
                htmlString += "</div>";

                if(tabPaneModel.viewconfig.tabViewConfig && tabPaneModel.viewconfig.tabViewConfig.image2)
                    htmlString += "<div style='text-align: center;vertical-align: middle;' id = '" + paneId + "_B' class='kwt100 hide' kwidgettype='TabArrow' "+kmasterid+"><img src='"+$KU.getImageURL(tabPaneModel.viewconfig.tabViewConfig.image2)+"' /></div>";
                else
                    htmlString += "<div id = '" + paneId + "_B' class='kwt100 hide' style='background-color:red;'" + baseHtml + " kwidgettype='TabArrow' "+kmasterid+">Bottom</div>";

                htmlString += "</div>";

                if(tabPaneModel.viewconfig.tabViewConfig.headerContainerWeight)
                    htmlString += "<div class='kcell kwt"+ (100-tabPaneModel.viewconfig.tabViewConfig.headerContainerWeight)+"'>";
                else
                    htmlString += "<div class='kcell kwt50'>";


                htmlString += "<div id = '" + paneId + "_Body' "+kmasterid+">";

                for (var j = 0; j < tabPaneModel.children.length; j++) {
                    var tabModel = formModel[tabPaneModel.children[j]];
                    tabPaneModel.context = context;
                    htmlString += this.generateTabViewBody(tabPaneModel,tabModel,j,context);

                }
                htmlString += "</div>";

                htmlString += "</div>";

                htmlString += "</div>";
                htmlString += "</div>";

            }else if(tabPaneModel.viewconfig.tabViewConfig && tabPaneModel.viewconfig.tabViewConfig.headerPosition == constants.TAB_HEADER_POSITION_RIGHT){

                htmlString += "<div class='ktable kwt100' style='table-layout:fixed;'>";
                htmlString += "<div class='krow kwt100'>";

                if(tabPaneModel.viewconfig.tabViewConfig.headerContainerWeight)
                    htmlString += "<div class='kcell kwt"+ (100-tabPaneModel.viewconfig.tabViewConfig.headerContainerWeight)+"'>";
                else
                    htmlString += "<div class='kcell kwt50'>";

                htmlString += "<div id = '" + paneId + "_Body' "+kmasterid+">";

                for (var j = 0; j < tabPaneModel.children.length; j++) {
                    var tabModel = formModel[tabPaneModel.children[j]];
                    tabPaneModel.context = context;
                    htmlString += this.generateTabViewBody(tabPaneModel,tabModel,j,context);

                }
                htmlString += "</div>";

                htmlString += "</div>";

                if(tabPaneModel.viewconfig.tabViewConfig.headerContainerWeight)
                    htmlString += "<div class='kcell topcenteralign kwt"+tabPaneModel.viewconfig.tabViewConfig.headerContainerWeight+"'>";
                else
                    htmlString += "<div class='kcell topcenteralign kwt50'>";

                if(tabPaneModel.viewconfig.tabViewConfig && tabPaneModel.viewconfig.tabViewConfig.image1)
                    htmlString += "<div style='text-align: center;vertical-align: middle;' id = '" + paneId + "_T' class='kwt100 hide' kwidgettype='TabArrow'><img src='"+$KU.getImageURL(tabPaneModel.viewconfig.tabViewConfig.image1)+"' "+kmasterid+" /></div>";
                else
                    htmlString += "<div id = '" + paneId + "_T' class='kwt100 hide' style='background-color:red;'" + baseHtml + " kwidgettype='TabArrow' "+kmasterid+">Top</div>";

                htmlString += "<div id = '" + paneId + "_Header' class='kwt100' style='overflow:hidden;' "+kmasterid+">";

                htmlString += "<ul id = '" + paneId + "_Ul' class='middleleftalign' style='padding-bottom: 3px;position:relative;' "+kmasterid+">";

                for (var i = 0; i < tabPaneModel.children.length; i++) {

                    var tabModel = formModel[tabPaneModel.children[i]];
                    htmlString += this.generateTabViewSide(tabPaneModel,tabModel,i);
                }

                htmlString += "</ul>";
                htmlString += "</div>";

                if(tabPaneModel.viewconfig.tabViewConfig && tabPaneModel.viewconfig.tabViewConfig.image2)
                    htmlString += "<div style='text-align: center;vertical-align: middle;' id = '" + paneId + "_B' class='kwt100 hide' kwidgettype='TabArrow' "+kmasterid+"><img src='"+$KU.getImageURL(tabPaneModel.viewconfig.tabViewConfig.image2)+"' /></div>";
                else
                    htmlString += "<div id = '" + paneId + "_B' class='kwt100 hide' style='background-color:red;'" + baseHtml + " kwidgettype='TabArrow' "+kmasterid+">Bottom</div>";

                htmlString += "</div>";
                htmlString += "</div>";
                htmlString += "</div>";

            }

            else{
                if(tabPaneModel.viewtype !== constants.TABPANE_VIEW_TYPE_PAGEVIEW)
                    htmlString += "<div class='ktable kwt100' id = '" + paneId + "_Header' style='position:relative;table-layout:fixed;' "+kmasterid+">";
                else
                    htmlString += "<div class='ktable kwt100' id = '" + paneId + "_Header' style='position:relative;table-layout:fixed;display:none' "+kmasterid+">";

                htmlString += "<div class='krow  kwt100'>";

                if(tabPaneModel.viewconfig.tabViewConfig && tabPaneModel.viewconfig.tabViewConfig.image1)
                    htmlString += "<div style='text-align: center;vertical-align: middle;' id = '" + paneId + "_L' class='kcell kwt2 hide' kwidgettype='TabArrow' "+kmasterid+"><img src='"+$KU.getImageURL(tabPaneModel.viewconfig.tabViewConfig.image1)+"' /></div>";
                else
                    htmlString += "<div id = '" + paneId + "_L' class='kcell kwt2 hide' style='background-color:red;'" + baseHtml + " kwidgettype='TabArrow' "+kmasterid+">Left</div>";

                htmlString += "<div id = '" + paneId + "_C' class='kwt96' style='overflow:hidden;margin:auto' "+kmasterid+">";
                htmlString += "<ul id = '" + paneId + "_Ul' class='middleleftalign' style='padding-bottom: 3px;white-space:nowrap;position:relative' "+kmasterid+">";




            for (var i = 0; i < tabPaneModel.children.length; i++) {

                var tabModel = formModel[tabPaneModel.children[i]];
                htmlString += this.generateTabViewLi(tabPaneModel,tabModel,i);
            }

            htmlString += "</ul>";
            htmlString += "</div>";


            if(tabPaneModel.viewconfig.tabViewConfig && tabPaneModel.viewconfig.tabViewConfig.image2)
                    htmlString += "<div style='text-align: center;vertical-align: middle;' id = '" + paneId + "_R' class='kcell kwt2 hide' kwidgettype='TabArrow' "+kmasterid+"><img src='"+$KU.getImageURL(tabPaneModel.viewconfig.tabViewConfig.image2)+"' /></div>";
            else
                htmlString += "<div id = '" + paneId + "_R' class='kcell kwt2 hide' style='background-color:red;'" + baseHtml + " kwidgettype='TabArrow' "+kmasterid+">Right</div>";
            htmlString += "</div>";
            htmlString += "</div>";

            if(tabPaneModel.viewtype == constants.TABPANE_VIEW_TYPE_PAGEVIEW)
                htmlString += "<div id = '" + paneId + "_Body' style='position:relative' name='touchcontainer_Tabpane' "+baseHtml+" class='kstripcontainer' "+kmasterid+">";
            else
                htmlString += "<div id = '" + paneId + "_Body' style='position:relative' "+kmasterid+">";

            if(tabPaneModel.viewtype == constants.TABPANE_VIEW_TYPE_PAGEVIEW){
                htmlString += "<div id='imgs' class= 'kstrip' style='";
                if(kony.appinit.isIE) {
                    htmlString += "position:relative";
                }
                htmlString += "'>";
            }



            for (var j = 0; j < tabPaneModel.children.length; j++) {
                var tabModel = formModel[tabPaneModel.children[j]];
                tabPaneModel.context = context;
                htmlString += this.generateTabViewBody(tabPaneModel,tabModel,j,context);

            }
            htmlString += "</div>";

            if(tabPaneModel.viewtype == constants.TABPANE_VIEW_TYPE_PAGEVIEW){
                htmlString += "</div>";
                htmlString += this.generatePageFooter(tabPaneModel);
            }

            }

            if(!updateViewFlag)
                htmlString += "</div>";

            return htmlString;
        },

        generateTabViewLi: function(tabPaneModel,tabModel,index){
            var activeSkin = tabPaneModel.activeskin || "";
            var inActiveSkin = tabPaneModel.inactiveskin || "";
            var baseHtml = " ktabpaneid='" + tabPaneModel.id + "' kformname='" + tabPaneModel.pf + "' ";
            var htmlString = "";

            var tabId = tabModel.pf + "_" + tabModel.id;
            var kmasterObj = $KW.Utils.getMasterIDObj(tabModel);
            if(kmasterObj.id != ""){
                tabId = kmasterObj.id;
            }
            var hcw = tabPaneModel.viewconfig.tabViewConfig && tabPaneModel.viewconfig.tabViewConfig.headerContainerWeight;
            htmlString += "<li id = '" + tabId + "_Li' index=" + index + " style='display:inline-block;vertical-align:bottom;"+(hcw?("width:"+hcw+"%"):tabModel.header?"width:25%":"")+"' class='" + (index != (tabPaneModel.activetab - IndexJL) ? inActiveSkin : activeSkin) + "li' kwidgettype='Tab'" + baseHtml + " "+kmasterObj.kmasterid+">";

            htmlString += "<div id = '" + tabId + "_A' style='' index=" + index + " kwidgettype='Tab' tabHeader='true'" + baseHtml + "href='#' class='" + (index != (tabPaneModel.activetab - IndexJL) ? inActiveSkin : activeSkin) + ((inActiveSkin || activeSkin) ? "lia'" : "'" ) + " "+kmasterObj.kmasterid+">";

            var context = {};
            if(tabModel.header){
            context.tabpaneID = tabPaneModel.id;
            context.tabID = tabModel.id;
            tabModel.header.pf = tabModel.pf;
            context.renderingTabHeader = true;
            context.pf = tabModel.pf;
            context.topLevelBox = true;
                this.setPfForTabHeader(tabModel.header,context);
            }
            if(tabModel.header){
                htmlString += $KW[tabModel.header.wType].render(tabModel.header, context);
            }else{
                if(tabModel.image)
                    htmlString += "<img id = '"+ tabId+"_Header_Image' src='" + $KU.getImageURL(tabModel.image) + "' "+kmasterObj.kmasterid+" />";

                if(tabModel.tabname){
                    htmlString += kony.appinit.isIE? "<div kwidgettype " : "<div ";
                    if(tabModel.image)
                        htmlString += " style='display:inline-block' ";
                    htmlString += ">"+tabModel.tabname+"</div>";
                }
            }
            htmlString += "</div>";
            htmlString += "</li>";

            return htmlString;
        },

        generateTabViewSide: function(tabPaneModel,tabModel,index){
            var activeSkin = tabPaneModel.activeskin || "";
            var inActiveSkin = tabPaneModel.inactiveskin || "";
            var baseHtml = " ktabpaneid='" + tabPaneModel.id + "' kformname='" + tabPaneModel.pf + "' ";
            var htmlString = "";

            var tabId = tabModel.pf + "_" + tabModel.id;
            var kmasterObj = $KW.Utils.getMasterIDObj(tabModel);
            if(kmasterObj.id != ""){
                tabId = kmasterObj.id;
            }
            var context = {};
            if(tabModel.header){
            context.tabpaneID = tabPaneModel.id;
            context.tabID = tabModel.id;
            tabModel.header.pf = tabModel.pf;
            context.renderingTabHeader = true;
            context.pf = tabModel.pf;
            context.topLevelBox = true;
                this.setPfForTabHeader(tabModel.header,context);
            }


            
            

            htmlString += "<li id = '" + tabId + "_Li' index=" + index + " style='display:inline' class='" + (index != (tabPaneModel.activetab - IndexJL) ? inActiveSkin : activeSkin) + "li' kwidgettype='Tab'" + baseHtml + " "+kmasterObj.kmasterid+">";

            htmlString += "<div id = '" + tabId + "_A' index=" + index + " style='display:block' kwidgettype='Tab' tabHeader='true'" + baseHtml + "href='#' class='" + (index != (tabPaneModel.activetab - IndexJL) ? inActiveSkin : activeSkin) + ((inActiveSkin || activeSkin) ? "lia'" : "'" ) + " "+kmasterObj.kmasterid+">";

            if(tabModel.header){
                htmlString += $KW[tabModel.header.wType].render(tabModel.header, context);
            }else{
                if(tabModel.image)
                    htmlString += "<div style='float:left' ><img id = '"+ tabId+"_Header_Image' src='" + $KU.getImageURL(tabModel.image) + "' "+kmasterObj.kmasterid+"/></div>";

                if(tabModel.tabname){
                    htmlString += "<div>"+tabModel.tabname+"</div>";
                }
            }
            htmlString += "</div>";
            htmlString += "</li>";

            
            

            return htmlString;
        },
        generateTabViewBody: function(tabPaneModel,tabModel,index,context){
            var htmlString = "";
            var baseHtml = " ktabpaneid='" + tabPaneModel.id + "' kformname='" + tabPaneModel.pf + "' ";
            var marginPadding = $KW.skins.getMarginSkin(tabModel, context) + $KW.skins.getPaddingSkin(tabModel);
            var skin = (tabModel.wType == 'FlexContainer') ? "" : (tabModel.skin || "");

            tabId = tabModel.pf + "_" + tabModel.id;
            var kmasterObj = $KW.Utils.getMasterIDObj(tabModel);
            if(kmasterObj.id != ""){
                tabId = kmasterObj.id;
            }
            htmlString += "<div id = '" + tabId + "_Body' kwidgettype='tabviewTabBody'" + baseHtml;
            if (index != (tabPaneModel.activetab - IndexJL)) {


                if(tabPaneModel.viewtype == constants.TABPANE_VIEW_TYPE_PAGEVIEW)
                    htmlString += "class='show " + skin + "' activebody='0' ";
                else
                    htmlString += "class='hide " + skin + "' activebody='0' ";


            }
            else {
                htmlString += "class='show " + skin + "' activebody='1' ";
            }

            htmlString += " style='"+marginPadding+"' "+kmasterObj.kmasterid+">";

            htmlString += this.renderTab(tabPaneModel, tabModel, context);
            htmlString += "</div>";

            return htmlString;
        },

        generateCollapsibleView: function(tabPaneModel, context, updateViewFlag){
            var formModel = tabPaneModel;
            var htmlString = '';
            var margin = $KW.skins.getMarginSkin(tabPaneModel, context);
            var padding = $KW.skins.getPaddingSkin(tabPaneModel);
            var css = $KW.skins.getVisibilitySkin(tabPaneModel);
            var tabPaneId = tabPaneModel.pf+"_"+ tabPaneModel.id;
            var kmasterObj = $KW.Utils.getMasterIDObj(tabPaneModel);
            if(kmasterObj.id != ""){
                tabPaneId = kmasterObj.id;
            }
            if(!updateViewFlag){
                var marginPadding = $KW.skins.getMarginSkin(tabPaneModel, context) + $KW.skins.getPaddingSkin(tabPaneModel);
                htmlString += "<div class='" + css + "' style='" + marginPadding + "' id = '" + tabPaneId + "' kformname='" + tabPaneModel.pf + "' kwidgettype='TabPane' "+kmasterObj.kmasterid+">";
            }

            tabPaneModel.context = context;

            for (var i = 0; i < tabPaneModel.children.length; i++) {

                var tabModel = formModel[tabPaneModel.children[i]];
                tabPaneModel.context = context;
                htmlString += this.generateCollapsibleViewTab(tabPaneModel,tabModel,i,context);
            }

            if(!updateViewFlag){
                htmlString += "</div>";
            }
            return htmlString;
        },

        generateCollapsibleViewTab : function(tabPaneModel,tabModel,index,context){
            var htmlString = "";
            var activeSkin = tabPaneModel.activeskin || "";
            var inActiveSkin = tabPaneModel.inactiveskin || "";

            var baseHtml = " ktabpaneid='" + tabPaneModel.id + "' kformname='" + tabPaneModel.pf + "' ";
            var collapsibleImgSrc = tabPaneModel.collapsedimage ? $KU.getImageURL(tabPaneModel.collapsedimage) : "";
            var expandedImgSrc = tabPaneModel.expandedimage ? $KU.getImageURL(tabPaneModel.expandedimage) : "";
            var marginPadding = $KW.skins.getMarginSkin(tabModel, context) + $KW.skins.getPaddingSkin(tabModel);

            var isActive = this.isActiveTab(tabPaneModel,tabModel);

            var tabId = tabModel.pf + "_" + tabModel.id;
            var kmasterObj = $KW.Utils.getMasterIDObj(tabModel);
            if(kmasterObj.id != ""){
                tabId = kmasterObj.id;
            }
            htmlString += "<div id = '" + tabId + "_Tab' "+kmasterObj.kmasterid+">";
            htmlString += "<div id = '" + tabId + "_Header' index=" + index + baseHtml + "kwidgettype='Tab' tabHeader='true' class='" + (isActive ? activeSkin : inActiveSkin) + "'" + (isActive ? " active='1'" : " active='0'") + " "+kmasterObj.kmasterid+">";



            if(tabModel.header){
                var contextHeader ={};
                contextHeader.tabpaneID = tabPaneModel.id;
                contextHeader.tabID = tabModel.id;
                tabModel.header.pf = tabModel.pf;
                contextHeader.renderingTabHeader = true;
                contextHeader.pf = tabModel.pf;
                contextHeader.topLevelBox = true;
                    this.setPfForTabHeader(tabModel.header,contextHeader);
                htmlString += $KW[tabModel.header.wType].render(tabModel.header, contextHeader);
            }else{


            htmlString += "<div class = 'ktable kwt100' style='text-decoration: inherit;table-layout: auto;'>";
            htmlString += "<div class = 'krow kwt100' >";

            if (tabPaneModel.imageposition == 'left') {
                htmlString += "<div class = 'kcell kwt2 middlecenteralign' >";
                htmlString += "<img style='vertical-align: middle' ";
                if (!isActive) {
                    if (tabPaneModel.collapsedimage)
                        htmlString += "src='" + collapsibleImgSrc + "'";
                }
                else {
                    if (tabPaneModel.expandedimage)
                        htmlString += "src='" + expandedImgSrc + "'";
                }
                htmlString += " id='" + tabId + "_Img' kwidgettype='Tab'" + baseHtml + " "+kmasterObj.kmasterid+"/>";
                htmlString += "</div>";
            }
            htmlString += "<div class = 'kcell kwt98 middleleftalign' >";
            if(tabModel.image)
                htmlString += "<div style='float:left'><img id = '"+ tabId+"_Header_Image' src='" + $KU.getImageURL(tabModel.image) + "' "+kmasterObj.kmasterid+" /></div>";

            htmlString += "<div id = '" + tabId + "_Div' kwidgettype='Tab' " + baseHtml;

            if (tabPaneModel.tabnamealignment)
                htmlString += "style='text-align:" + tabPaneModel.tabnamealignment + "' ";
            htmlString += " "+kmasterObj.kmasterid+">";
            if(tabModel.tabname)
                htmlString += tabModel.tabname;

            htmlString += "</div>";

            htmlString += "</div>";

            if (tabPaneModel.imageposition === 'right') {
                htmlString += "<div class = 'kcell kwt2 middlecenteralign' >";
                htmlString += "<img style='vertical-align: middle' ";
                if (isActive) {
                    if (tabPaneModel.collapsedimage)
                        htmlString += "src='" + collapsibleImgSrc + "'";
                }
                else {
                    if (tabPaneModel.expandedimage)
                        htmlString += "src='" + expandedImgSrc + "'";
                }
                htmlString += " id='" + tabId + "_Img' kwidgettype='Tab'" + baseHtml + " "+kmasterObj.kmasterid+"/>";
                htmlString += "</div>";
            }
            htmlString += "</div></div>";

            }

            htmlString += "</div>";

            htmlString += "<div id = '" + tabId + "_Body' class='" + (isActive ? "tabactivebody " : "tabinactivebody ") + (tabModel.skin || "") + "' kwidgettype='collapsibleTabBody' style='display:none;"+marginPadding+"' "+kmasterObj.kmasterid+">";

            tabPaneModel.context = context;
            htmlString += this.renderTab(tabPaneModel, tabModel, context);
            htmlString += "</div>";
            htmlString += "</div>";


            return htmlString;
        },

        isActiveTab: function(tabPaneModel,tabModel){
            if(!tabPaneModel.activetabs)
                 return false;

            for (var i = 0; i < tabPaneModel.children.length; i++) {
                if(tabPaneModel.children[i] == tabModel.id)
                    break;
             }
             for (var j = IndexJL; j < tabPaneModel.activetabs.length; j++) {
                if(tabPaneModel.activetabs[j] == (i+IndexJL))
                    return true;
             }
             return false;
        },

        generateAccordionView: function(tabPaneModel, context, updateViewFlag){
            var formModel = tabPaneModel;
            var htmlString = "";
            var margin = $KW.skins.getMarginSkin(tabPaneModel, context);
            var padding = $KW.skins.getPaddingSkin(tabPaneModel);
            var css = $KW.skins.getVisibilitySkin(tabPaneModel);
            var tabPaneId = tabPaneModel.pf+"_"+ tabPaneModel.id;
            var kmasterObj = $KW.Utils.getMasterIDObj(tabPaneModel);
            if(kmasterObj.id != ""){
                tabPaneId = kmasterObj.id;
            }
            var marginPadding = $KW.skins.getMarginSkin(tabPaneModel, context) + $KW.skins.getPaddingSkin(tabPaneModel);
            if(!updateViewFlag)
                htmlString += "<div class='" + css + "' style='" + marginPadding + "' id = '" + tabPaneId + "' kformname='" + tabPaneModel.pf + "' kwidgettype='TabPane' "+kmasterObj.kmasterid+">";

               var activeSkin = tabPaneModel.activeskin || "";
            var inActiveSkin = tabPaneModel.inactiveskin || "";
            var tabId;
            var baseHtml = " ktabpaneid='" + tabPaneModel.id + "' kformname='" + tabPaneModel.pf + "' ";

            var collapsibleImgSrc = tabPaneModel.collapsedimage ? $KU.getImageURL(tabPaneModel.collapsedimage) : "";
            var expandedImgSrc = tabPaneModel.expandedimage ? $KU.getImageURL(tabPaneModel.expandedimage) : "";

            tabPaneModel.context = context;

            for (var i = 0; i < tabPaneModel.children.length; i++) {

                var tabModel = formModel[tabPaneModel.children[i]];
                htmlString += this.generateAccordionViewTab(tabPaneModel,tabModel,i,context);
            }
            if(!updateViewFlag){
                htmlString += "</div>";
            }
            return htmlString;
        },

        generateAccordionViewTab :function(tabPaneModel,tabModel,index,context){
            var tabId = tabModel.pf + "_" + tabModel.id;
            var kmasterObj = $KW.Utils.getMasterIDObj(tabModel);
            if(kmasterObj.id != ""){
                tabId = kmasterObj.id;
            }
            var baseHtml = " ktabpaneid='" + tabPaneModel.id + "' kformname='" + tabPaneModel.pf + "' ";
            var activeSkin = tabPaneModel.activeskin || "";
            var inActiveSkin = tabPaneModel.inactiveskin || "";
            var collapsibleImgSrc = tabPaneModel.collapsedimage ? $KU.getImageURL(tabPaneModel.collapsedimage) : "";
            var expandedImgSrc = tabPaneModel.expandedimage ? $KU.getImageURL(tabPaneModel.expandedimage) : "";
            var marginPadding = $KW.skins.getMarginSkin(tabModel, context) + $KW.skins.getPaddingSkin(tabModel);

            var htmlString = "";

            htmlString += "<div id = '" + tabId + "_Tab' "+kmasterObj.kmasterid+">";

            htmlString += "<div id = '" + tabId + "_Header' index=" + index + baseHtml + "kwidgettype='Tab' "+kmasterObj.kmasterid+" tabHeader='true' class='" + ((index == (tabPaneModel.activetab - IndexJL)) ? activeSkin + "' active='1'>" : inActiveSkin + "' active='0'>");


            if(tabModel.header){
                var contextHeader ={};
                contextHeader.tabpaneID = tabPaneModel.id;
                contextHeader.tabID = tabModel.id;
                tabModel.header.pf = tabModel.pf;
                contextHeader.renderingTabHeader = true;
                contextHeader.pf = tabModel.pf;
                contextHeader.topLevelBox = true;
                    this.setPfForTabHeader(tabModel.header,contextHeader);
                htmlString += $KW[tabModel.header.wType].render(tabModel.header, contextHeader);
            }else{


            htmlString += "<div class = 'ktable kwt100' style='text-decoration: inherit;table-layout: auto;'>";
            htmlString += "<div class = 'krow kwt100' >";

            if (tabPaneModel.imageposition === 'left') {
                htmlString += "<div class = 'kcell kwt2 middleleftalign' >";
                htmlString += "<img ";
                if (index == (tabPaneModel.activetab - IndexJL)) {
                    if (tabPaneModel.collapsedimage)
                        htmlString += "src='" + collapsibleImgSrc + "'";
                }
                else {
                    if (tabPaneModel.expandedimage)
                        htmlString += "src='" + expandedImgSrc + "'";
                }
                htmlString += " id='" + tabId + "_Img' kwidgettype='Tab'" + baseHtml + " "+kmasterObj.kmasterid+"/>";
                htmlString += "</div>";

            }
            htmlString += "<div class = 'kcell kwt98 middleleftalign' >";
            if(tabModel.image)
                htmlString += "<div style='float:left'><img id = '"+ tabId+"_Header_Image' src='" + $KU.getImageURL(tabModel.image) + "' "+kmasterObj.kmasterid+" /></div>";
            htmlString += "<div id = '" + tabId + "_Div' kwidgettype='Tab'" + baseHtml;
            if (tabPaneModel.tabnamealignment)
                htmlString += "style='text-align:" + tabPaneModel.tabnamealignment + "' ";
            htmlString += ""+kmasterObj.kmasterid+" >";

            if(tabModel.tabname)
                htmlString += tabModel.tabname;

            htmlString += "</div>";

            htmlString += "</div>";

            if (tabPaneModel.imageposition === 'right') {
                htmlString += "<div class = 'kcell kwt2 middleleftalign' >";
                htmlString += "<img ";
                if (index == (tabPaneModel.activetab - IndexJL)) {
                    if (tabPaneModel.collapsedimage)
                        htmlString += "src='" + collapsibleImgSrc + "'";
                }
                else {
                    if (tabPaneModel.expandedimage)
                        htmlString += "src='" + expandedImgSrc + "'";
                }
                htmlString += " id='" + tabId + "_Img' kwidgettype='Tab'" + baseHtml + " "+kmasterObj.kmasterid+"/>";
                htmlString += "</div>";
            }

            htmlString += "</div></div>";

            }

            htmlString += "</div>";

            htmlString += "<div id = '" + tabId + "_Body' class='" + (index == (tabPaneModel.activetab-IndexJL) ? "tabactivebody " : "tabinactivebody ") + (tabModel.skin || "") + "' kwidgettype='collapsibleTabBody' style='display:none;"+marginPadding+"' "+kmasterObj.kmasterid+">";

            htmlString += this.renderTab(tabPaneModel, tabModel, context);
            htmlString += "</div>";
            htmlString += "</div>";

            return htmlString;
        },

        renderTab: function(tabPaneModel, tabModel, context){
            var htmlString = "";
            context = context || {};
            context.tabpaneID = tabPaneModel.id;
            if(tabModel.wType == 'FlexContainer'){
                htmlString = $KW.FlexContainer.render(tabModel, context);
            }
            else if (tabModel.children) {
                if (tabModel.layouttype == constants.CONTAINER_LAYOUT_GRID) {
                    htmlString = $KW.Grid.render(tabModel, context);
                }
                else{
                    for (var k = 0; k < tabModel.children.length; k++) {
                        var childModel = tabPaneModel[tabModel.children[k]];
                        context.topLevelBox = true;
                        htmlString += $KW[childModel.wType].render(childModel, context);
                        context.topLevelBox = false;
                    }
                }
            }
            context.tabpaneID = "";
            return htmlString;
        },

        setTabsHeight: function(formId){
            var tabviewElementsBody = document.querySelectorAll("#" + formId + " div[kwidgettype='tabviewTabBody']");
            var taboninithandler;
            if(tabviewElementsBody)
            {
                for(var i=0; i<tabviewElementsBody.length; i++ )
                {
                     var tabviewElementBody = tabviewElementsBody[i];
                    var tabModel;
                    if(tabviewElementBody.getAttribute("kmasterid")){
                        var id = tabviewElementBody.getAttribute("id");
                        tabModel = $KU.getWidgetModelByID(id.substring(0, id.lastIndexOf("_")));  
                    }else{
                         var targetWidgetID = tabviewElementBody.getAttribute("id").split('_')[1];
                         var tabPaneID = tabviewElementBody.getAttribute("ktabpaneid");
                         var sourceFormID = tabviewElementBody.getAttribute("kformname");
                         tabModel = kony.model.getWidgetModel(sourceFormID, targetWidgetID, tabPaneID);
                     }

                     this.checkArrows(tabModel.parent); 

                     if(tabviewElementBody.getAttribute("activebody") === '1'){
                        taboninithandler = $KU.returnEventReference(tabModel.oninit);
                         tabModel.oninit && $KU.executeWidgetEventHandler(tabModel, taboninithandler);
                         if(tabModel.oninit)
                            delete tabModel.oninit;
                    }
                 }
            }

            var tabElementsBody = document.querySelectorAll("#" + formId + " div[kwidgettype='collapsibleTabBody']");
            if(tabElementsBody)
            {
                for (var i = 0; i < tabElementsBody.length; i++) {
                    var tabElementBody = tabElementsBody[i];
                    var tabModel;
                    if(tabElementBody.getAttribute("kmasterid")){
                        var id = tabElementBody.getAttribute("id");
                        tabModel = $KU.getWidgetModelByID(id.substring(0, id.lastIndexOf("_")));  
                    }else{
                        var targetWidgetID = tabElementBody.parentNode.getAttribute("id").split('_')[1];
                        var tabPaneID = tabElementBody.previousSibling.getAttribute("ktabpaneid");
                        var sourceFormID = tabElementBody.previousSibling.getAttribute("kformname");
                        tabModel = kony.model.getWidgetModel(sourceFormID, targetWidgetID, tabPaneID);
                    }

                    

                    if (tabElementBody.previousSibling.getAttribute("active") === '1') {
                        taboninithandler = $KU.returnEventReference(tabModel.oninit);
                         tabModel.oninit && $KU.executeWidgetEventHandler(tabModel, taboninithandler);
                        module.expandTab(tabModel, tabElementBody);
                    }
                    else {
                        module.collapseTab(tabModel, tabElementBody);
                    }

                    if (tabElementBody.previousSibling.getAttribute("active") === '1') {
                        if (tabModel.oninit)
                            delete tabModel.oninit;
                    }
                }

            }
        },

        toggleDisable: function(formId){
            var tabPanes = document.querySelectorAll("#" + formId + " div[kwidgettype='TabPane']");
            for(var i=0; i<tabPanes.length; i++ ){
                var tabPaneModel = $KU.getModelByNode(tabPanes[i]);
                tabPaneModel.disabled != undefined && $KW.APIUtils.setenabled(tabPaneModel, (tabPaneModel.disabled == true ? false : true));
                var tabs = tabPaneModel.children;
                if(tabs){
                    for(var j=0; j<tabs.length; j++ ){
                        var tabModel = tabPaneModel[tabs[j]];
                        (tabModel && tabModel.disabled != undefined) && $KW.APIUtils.setenabled(tabModel, (tabModel.disabled == true ? false : true));
                    }
                }
            }
        },

        collapseTab: function(tabModel, tabWidget){
            tabWidget.style.height = tabWidget.scrollHeight + 'px';
            var duration = tabModel.transDuration ? parseInt(tabModel.transDuration): module.ANIMATION_DELAY;
            setTimeout(function(){
                tabWidget.style.overflow = 'hidden';
                if (kony.appinit.useTransition) {
                    tabWidget.style[$KU.transition] = 'height ' + duration + 'ms ease';
                    tabWidget.style.height = '0px';
                }
                else {
                    $("#" + tabWidget.id).animate({
                        height: "0px"
                    }, duration);
                }

            }, 1);

            setTimeout(function(){
                $KU.addClassName(tabWidget, 'hide');
            }, duration);
        },

        expandTab: function(tabModel, tabWidget){
            tabWidget.style.display = 'block';
            tabWidget.style.overflow = 'hidden';

            $KU.removeClassName(tabWidget, 'hide');
            module.adjustFlexContainers(tabModel.parent);
            var duration = tabModel.transDuration ? parseInt(tabModel.transDuration): module.ANIMATION_DELAY;
            if (kony.appinit.useTransition) {
                tabWidget.style[$KU.transition] = 'height ' + duration + 'ms ease';
                tabWidget.style.height = tabWidget.scrollHeight + 'px';
            }
            else {
                $("#" + tabWidget.id).animate({
                    height: tabWidget.scrollHeight + 'px'
                }, duration);
            }
            setTimeout(function(){
                module.setTabsHeightAuto(tabWidget);
            }, duration + 100);
        },

        setTabsHeightAuto: function(tabElementBody){
            tabElementBody.style[$KU.transition] = '';
            tabElementBody.style.height = 'auto';
        },

        
        addTab: function(tabPaneModel, tabId, tabName, tabImage, box, masterDataLoad) {
            tabPaneModel.addTab(tabId, tabName, tabImage, box, masterDataLoad);
        },

        addChildTab: function(tabPaneModel,tabModel){
            var tabPaneElement = $KU.getNodeByModel(tabPaneModel);
            var tabLiId = $KW.Utils.getKMasterWidgetID(tabModel)+"_Li";
            var tabLiElement = $KU.getElementById(tabLiId);

            if(tabPaneElement && !tabLiElement){
                var index = tabPaneModel.children.length;
                this.addChildTabAt(tabPaneModel,tabModel,index);
            }
        },

        removeTabAt: function(tabPaneModel, index, isFromById) {
            index = parseInt(index);
            if(index >= IndexJL && !isFromById)
                index = index - IndexJL;

            if(index >= 0 && index <= tabPaneModel.children.length){
                var tabModel = tabPaneModel[tabPaneModel.children[index]];
                if(tabModel)
                    _konyConstNS.ContainerWidget.prototype.remove.call(tabPaneModel, tabModel);

                if(tabPaneModel.viewtype == constants.TABPANE_VIEW_TYPE_PAGEVIEW || tabPaneModel.viewtype == "tabview" || (tabPaneModel.toggletabs && (tabPaneModel.toggletabs === true))){


                    if(tabPaneModel.activetab == (index+IndexJL)){
                        tabPaneModel.activetab = IndexJL;
                        tabPaneModel.activetabs[IndexJL] = tabPaneModel.activetab;
                        this.updateView(tabPaneModel,"activetab",tabPaneModel.activetab,tabPaneModel.activetab);
                        if(tabPaneModel.viewtype != constants.TABPANE_VIEW_TYPE_PAGEVIEW){
                            return;
                        }


                    }
                    if(tabPaneModel.activetab > (index+IndexJL)){
                        tabPaneModel.activetab -= 1;
                        tabPaneModel.activetabs[IndexJL] = tabPaneModel.activetab;
                    }
                }else{
                    var indexAvailable = $KU.inArray(tabPaneModel.activetabs,parseInt(index)+IndexJL);
                    if(indexAvailable[0])
                        tabPaneModel.activetabs.splice(indexAvailable[1],1);

                    if(tabPaneModel.activetabs.length == IndexJL){
                        if(IndexJL)
                            tabPaneModel.activetabs = [null,1];
                        else
                            tabPaneModel.activetabs = [0];

                        this.updateView(tabPaneModel,"activetabs",tabPaneModel.activetabs,tabPaneModel.activetabs);
                        return;
                    }else{
                        for(var i=IndexJL; i<tabPaneModel.activetabs.length; i++ ){
                            var temp = tabPaneModel.activetabs[i];
                            if(temp > index)
                                tabPaneModel.activetabs[i] = temp - 1;
                        }
                    }
                }

                if(tabPaneModel.viewtype == "tabview" || tabPaneModel.viewtype == constants.TABPANE_VIEW_TYPE_PAGEVIEW){

                    var tabpaneElement = $KU.getNodeByModel(tabPaneModel);
                    if(tabpaneElement){
                        var tabpaneUlElement = $KU.getElementById($KW.Utils.getKMasterWidgetID(tabPaneModel) + "_Ul");
                        if(tabpaneUlElement.children[index])
                            tabpaneUlElement.removeChild(tabpaneUlElement.children[index]);

                        var tabpaneBodyElement = $KU.getElementById($KW.Utils.getKMasterWidgetID(tabPaneModel) + "_Body");
                        if(tabPaneModel.viewtype == constants.TABPANE_VIEW_TYPE_PAGEVIEW)
                            tabpaneBodyElement = tabpaneBodyElement.children[0];
                        if(tabpaneBodyElement.children[index])
                            tabpaneBodyElement.removeChild(tabpaneBodyElement.children[index]);
                    }

                    

                    this.checkArrows(tabPaneModel);

                    if(tabPaneModel.viewtype == constants.TABPANE_VIEW_TYPE_PAGEVIEW){
                        this.updatePageFooter(tabPaneModel);
                    }
                }else{
                    var tabElement = $KU.getElementById($KW.Utils.getKMasterWidgetID(tabModel)+"_Tab");
                    if(tabElement){
                        tabElement.parentNode.removeChild(tabElement);
                    }
                }

                this.adjustTabIndex(tabPaneModel);
                module.initializeView(tabPaneModel.pf);
            }
        },

        removeTabById: function(tabPaneModel, tabID) {
            if(tabID && tabID.id)
                tabID = tabID.id;

            var removeTabID = "";
            if(tabPaneModel[tabID]) {
                removeTabID = $KW.Utils.getKMasterWidgetID(tabPaneModel[tabID]);
            }
            else {
                return;
            }

            if(tabPaneModel.viewtype == "tabview" || tabPaneModel.viewtype == constants.TABPANE_VIEW_TYPE_PAGEVIEW){
                var tabElement = $KU.getElementById(removeTabID + "_Li");
                if(tabElement){
                    var index = tabElement.getAttribute("index");
                    module.removeTabAt(tabPaneModel,index,true);
                }
            }else{
                var tabElementHeader = $KU.getElementById(removeTabID + "_Header");
                if(tabElementHeader){
                    var index = tabElementHeader.getAttribute("index");
                    module.removeTabAt(tabPaneModel,index,true);
                }
            }
        },

        
        setTabName: function(tabPaneModel, tabId, tabName){
            var tabModel = tabPaneModel[tabId];
            if(tabModel){
                tabModel.tabname = tabName;
                var tabId = $KW.Utils.getKMasterWidgetID(tabModel);
                if(tabPaneModel.viewtype == "tabview" || tabPaneModel.viewtype == constants.TABPANE_VIEW_TYPE_PAGEVIEW){
                    var anchorElem = $KU.getElementById(tabId + '_A');
                    if(anchorElem){
                        var tabDiv = anchorElem.childNodes[0];
                        if(tabModel.image)
                            tabDiv = anchorElem.childNodes[1];
                        tabDiv.innerText = tabName;
                    }
                }
                else if(tabPaneModel.viewtype === 'collapsibleview'){
                    var divElem = $KU.getElementById(tabId + '_Div');
                    if(divElem)
                        divElem.innerText = tabName;
                }
            }
        },

        addTabAt: function(tabPaneModel, tabId, tabName, tabImage, box,index){
            tabPaneModel.addTabAt( tabId, tabName, tabImage, box, index);
        },

        addChildTabAt:function(tabPaneModel, tabModel, index){
            index = parseInt(index);
            var tabPaneElement = $KU.getNodeByModel(tabPaneModel);

            if(index < IndexJL)
                index = IndexJL;
            if(index >= tabPaneModel.children.length)
                index = tabPaneModel.children.length - 1 + IndexJL;

            if(tabPaneModel.viewtype == "tabview" || tabPaneModel.viewtype == constants.TABPANE_VIEW_TYPE_PAGEVIEW){

                var tabLiId = $KW.Utils.getKMasterWidgetID(tabModel) + "_Li";
                var tabLiElement = $KU.getElementById(tabLiId);
                if(tabPaneElement && !tabLiElement){

                    var htmlString = "";
                    var activeSkin = tabPaneModel.activeskin || "";
                    var inActiveSkin = tabPaneModel.inactiveskin || "";
                    var baseHtml = " ktabpaneid='" + tabPaneModel.id + "' kformname='" + tabPaneModel.pf + "'";
                    var uLElement = $KU.getElementById($KW.Utils.getKMasterWidgetID(tabPaneModel) + '_Ul');
                    var bodyElement = $KU.getElementById($KW.Utils.getKMasterWidgetID(tabPaneModel) + '_Body');

                    if(tabPaneModel.viewtype == constants.TABPANE_VIEW_TYPE_PAGEVIEW)
                        bodyElement = bodyElement.children[0];

                    if(index < tabPaneModel.activetab){
                        tabPaneModel.activetab += 1;
                        tabPaneModel.activetabs[IndexJL] = tabPaneModel.activetab;
                    }
                    else if(index == tabPaneModel.activetab){
                        if(uLElement.childNodes.length > 0){
                            var activeLi = uLElement.childNodes[index];
                            var activeLia = uLElement.childNodes[index].childNodes[0];
                            var activeBody = bodyElement.childNodes[index];
                            $KU.removeClassName(activeLi, tabPaneModel.activeskin+'li');
                            $KU.addClassName(activeLi, tabPaneModel.inactiveskin+'li');
                            $KU.removeClassName(activeLia, tabPaneModel.activeskin+'lia');
                            $KU.addClassName(activeLia, tabPaneModel.inactiveskin+'lia');
                            $KU.removeClassName(activeBody, 'show');
                            $KU.addClassName(activeBody, 'hide');
                            activeBody.setAttribute('activebody','0');
                        }
                    }

                    if(tabPaneModel.viewconfig.tabViewConfig && (tabPaneModel.viewconfig.tabViewConfig.headerPosition == constants.TAB_HEADER_POSITION_LEFT || tabPaneModel.viewconfig.tabViewConfig.headerPosition == constants.TAB_HEADER_POSITION_RIGHT)){
                        htmlString = this.generateTabViewSide(tabPaneModel,tabModel,index);
                    }else{
                        htmlString = this.generateTabViewLi(tabPaneModel,tabModel,index);
                    }

                    var wrapper = document.createElement("div");
                    wrapper.innerHTML = htmlString;

                    if(uLElement.children[index - IndexJL])
                        uLElement.insertBefore(wrapper.children[0], uLElement.children[index - IndexJL]);
                    else
                        uLElement.appendChild(wrapper.children[0]);

                    htmlString = this.generateTabViewBody(tabPaneModel,tabModel,index,tabPaneModel.context);

                    wrapper = document.createElement("div");
                    wrapper.innerHTML = htmlString;

                    if(bodyElement.children[index - IndexJL])
                        bodyElement.insertBefore(wrapper.children[0], bodyElement.children[index - IndexJL]);
                    else
                        bodyElement.appendChild(wrapper.children[0]);

                    this.checkArrows(tabPaneModel);

                    if(tabPaneModel.viewtype == constants.TABPANE_VIEW_TYPE_PAGEVIEW){
                        this.updatePageFooter(tabPaneModel);
                    }

                }

            }else if(tabPaneModel.viewtype === 'collapsibleview'){
                var tabElement = $KU.getElementById($KW.Utils.getKMasterWidgetID(tabModel) + "_Tab");
                if(tabPaneElement && !tabElement){
                    if(tabPaneModel.toggletabs === false)
                        htmlString = this.generateCollapsibleViewTab(tabPaneModel,tabModel,index,tabPaneModel.context);
                    else
                        htmlString = this.generateAccordionViewTab(tabPaneModel,tabModel,index,tabPaneModel.context);

                    wrapper = document.createElement("div");
                    wrapper.innerHTML = htmlString;

                    var tapPaneNode = $KU.getNodeByModel(tabPaneModel);
                    if(tapPaneNode.children[index - IndexJL])
                        tapPaneNode.insertBefore(wrapper.children[0], tapPaneNode.children[index - IndexJL]);
                    else
                        tapPaneNode.appendChild(wrapper.children[0]);

                    if(tabPaneModel.toggletabs){
                        tabElement = $KU.getElementById($KW.Utils.getKMasterWidgetID(tabModel) + "_Tab");
                        this.collapseTab(tabModel, tabElement.children[1]);
                    }
                    for(var i=IndexJL; i<tabPaneModel.activetabs.length; i++ ){
                        var temp = tabPaneModel.activetabs[i];
                        if(temp >= index)
                            tabPaneModel.activetabs[i] = temp + 1;
                    }
                    tabPaneModel.activetab = tabPaneModel.activetabs[IndexJL];
                }
            }
            this.adjustTabIndex(tabPaneModel);
            tabPaneElement && $KW.Utils.initializeNewWidgets(tabModel.ownchildrenref);
            module.initializeView(tabPaneModel.pf);
        },

        adjustTabIndex: function(tabPaneModel) {
            var tabpaneElement = $KU.getNodeByModel(tabPaneModel);
            if(tabpaneElement){
                if(tabPaneModel.viewtype == "tabview" || tabPaneModel.viewtype == constants.TABPANE_VIEW_TYPE_PAGEVIEW){
                    var tabpaneUlElement = $KU.getElementById($KW.Utils.getKMasterWidgetID(tabPaneModel) + "_Ul");
                    for (var i = 0; i < tabpaneUlElement.children.length; i++) {
                        var tabLi = tabpaneUlElement.children[i];
                        tabLi.setAttribute("index",i);
                        tabLi.children[0].setAttribute("index",i);
                    }
                }else{
                    for (var j = 0; j < tabpaneElement.children.length; j++) {
                        var tab = tabpaneElement.children[j];
                        tab.children[0].setAttribute("index",j);
                    }
                }
            }
        },

        setTabImage: function(tabPaneModel, tabId,tabImage){
            var tabModel = tabPaneModel[tabId];
            if(tabModel && tabModel.image && !tabModel.header){
                tabModel.image = tabImage;
                var tabId = $KW.Utils.getKMasterWidgetID(tabModel);
                if(tabPaneModel.viewtype == "tabview" || tabPaneModel.viewtype === 'collapsibleview'){
                    var imgElem = $KU.getElementById(tabId + '_Header_Image');
                    if(imgElem)
                        imgElem.src= $KU.getImageURL(tabImage);
                }
            }
        },

        
        executeTabEvent: function (wModel, target, canSwitch) {
            
            var tabNode = $KU.getParentByAttribute(target, "index");
            var tabId = target.getAttribute("ktabid");
            var tabPaneId = target.getAttribute("ktabpaneid");
            var formId = target.getAttribute("kformname");

            var tabModel = kony.model.getWidgetModel(formId, tabId, tabPaneId);
            var tabPaneModel = kony.model.getWidgetModel(formId, tabPaneId);

            module.changeActiveTabSkin(tabPaneModel,tabId);
        },

        eventHandler: function(eventObject, target, srcElement, canExecute){
            var tabModel,tabPaneModel,tabID,baseTabID;
            if(target.getAttribute("kmasterid")){
                var id = target.getAttribute("id");
                tabModel = $KU.getWidgetModelByID(id.substring(0, id.lastIndexOf("_")));  
                tabPaneModel = tabModel.parent; 
                tabID = tabModel.id;
                baseTabID = $KW.Utils.getKMasterWidgetID(tabModel);
            }else{
                var targetWidgetID = target.getAttribute("id");
                var tabPaneID = target.getAttribute("ktabpaneid");
                var sourceFormID = target.getAttribute("kformname");
                var tabArray = targetWidgetID.split("_");
                tabID = tabArray[1];
                baseTabID = tabArray[0] + "_" +tabArray[1];
                tabModel = kony.model.getWidgetModel(sourceFormID, tabID, tabPaneID);
                tabPaneModel = kony.model.getWidgetModel(sourceFormID, tabPaneID);
            }
            var duration = tabModel.transDuration ? parseInt(tabModel.transDuration): module.ANIMATION_DELAY;
            var taboninithandler = $KU.returnEventReference(tabModel.oninit);
            var isExpanded = false;
            if(tabModel.oninit) {
                $KU.executeWidgetEventHandler(tabModel, taboninithandler);
            }
            $KAR && $KAR.sendRecording(tabPaneModel, 'click', {'tabID': tabID, 'target': target, 'eventType': 'uiAction'});


            var tabWidget = $KU.getElementById(baseTabID + "_Body");
            var tabWidgetHeader = $KU.getElementById(baseTabID + "_Header");
            var tabWidgetImg = $KU.getElementById(baseTabID + "_Img");
            var tabWidgetClickedLi = $KU.getElementById(baseTabID + "_Li");

            
            if(tabPaneModel.viewtype === 'collapsibleview' && tabPaneModel.toggletabs === false ){
                if(tabWidget.style.height === "auto"){

                    module.collapseTab(tabModel, tabWidget);
                    if(tabPaneModel.inactiveskin){
                        setTimeout(
                            function (){
                                if(tabPaneModel.inactiveskin)
                                    tabWidgetHeader.className = tabPaneModel.inactiveskin;
                            }, duration);
                    }

                    tabWidgetHeader.setAttribute("active",'0');
                    var index = tabWidgetHeader.getAttribute("index");
                    tabPaneModel.activetabs = tabPaneModel.activetabs || [];
                    var indexAvailable = $KU.inArray(tabPaneModel.activetabs,parseInt(index)+IndexJL);

                    if(indexAvailable[0])
                        tabPaneModel.activetabs.splice(indexAvailable[1],1);

                    if(tabPaneModel.expandedimage && tabWidgetImg){
                        setTimeout(
                            function (){
                                tabWidgetImg.src = $KU.getImageURL(tabPaneModel.expandedimage);
                            }, duration);
                    }

                }
                else{
                    isExpanded = true;
                    tabPaneModel.activetabs = tabPaneModel.activetabs || [];
                    var index = tabWidgetHeader.getAttribute("index");
                    var indexAvailable = $KU.inArray(tabPaneModel.activeTabs, parseInt(index)+IndexJL);
                    if(!indexAvailable[0]){
                        tabPaneModel.activetabs.push(parseInt(index)+IndexJL);
                        if(IndexJL)
                            $KI.table.sort(tabPaneModel.activetabs)
                        else
                            tabPaneModel.activetabs.sort();
                    }
                    tabWidget.style.display = 'block';
                    module.expandTab(tabModel, tabWidget);
                    if(tabPaneModel.activeskin)
                        tabWidgetHeader.className = tabPaneModel.activeskin;
                    tabWidgetHeader.setAttribute("active",'1');

                    if(tabPaneModel.collapsedimage && tabWidgetImg)
                        tabWidgetImg.src = $KU.getImageURL(tabPaneModel.collapsedimage);
                }
                
            }

                else if(tabPaneModel.viewtype === 'tabview' || tabPaneModel.viewtype === constants.TABPANE_VIEW_TYPE_PAGEVIEW){  
                module.changeActiveTabSkin(tabPaneModel,tabID);
                if(tabPaneModel.viewtype == constants.TABPANE_VIEW_TYPE_PAGEVIEW){
                    var imgsElement = $KU.getElementById( $KW.Utils.getKMasterWidgetID(tabPaneModel) + "_Body").children[0];
                    var swipeContext = tabPaneModel.swipeContext;
                    swipeContext.currentPage = tabWidgetClickedLi.getAttribute("index")*1;
                    $KW.touch.scrollImages(imgsElement, swipeContext.imageWidth * swipeContext.currentPage, $KU.swipeDuration, false, {"tabPaneModel":tabPaneModel,"tabID":tabID,"tabArray":tabArray});
                }


            }
            else if(tabPaneModel.viewtype === 'collapsibleview' && tabPaneModel.toggletabs === true )
            { 
                var isActive = tabWidgetHeader.getAttribute('active');
                for (var i = 0; i < tabPaneModel.children.length; i++) {
                    var childTabId = $KW.Utils.getKMasterWidgetID(tabPaneModel[tabPaneModel.children[i]]);
                    var childTab = $KU.getElementById(childTabId + "_Body");
                    var childTabHeader = $KU.getElementById(childTabId + "_Header");
                    var childTabImg = $KU.getElementById(childTabId + "_Img");

                    if (tabPaneModel.children[i] === tabID) {
                        if (tabWidget.style.height === "0px") {
                            if (tabPaneModel.activetab == 0){
                                tabPaneModel.activetab = i + IndexJL;
                                tabPaneModel.activetabs[IndexJL] = tabPaneModel.activetab;
                            }
                            isExpanded = true;
                            module.expandTab(tabModel, tabWidget);
                            if (tabPaneModel.activeskin)
                                tabWidgetHeader.className = tabPaneModel.activeskin;

                            tabWidgetHeader.setAttribute("active", '1');

                            if (tabPaneModel.collapsedimage && tabWidgetImg)
                                tabWidgetImg.src = $KU.getImageURL(tabPaneModel.collapsedimage);

                            tabPaneModel.activetab = i + IndexJL;
                            tabPaneModel.activetabs = IndexJL ? [null, tabPaneModel.activetab] : [tabPaneModel.activetab];
                        }
                        else {
                            module.collapseTab(tabModel, tabWidget);
                            if (tabPaneModel.inactiveskin)
                                setTimeout(function(){
                                    tabWidgetHeader.className = tabPaneModel.inactiveskin;
                                    tabWidgetHeader.setAttribute("active", '0');
                                }, duration);

                            if (tabPaneModel.expandedimage && tabWidgetImg)
                                setTimeout(function(){
                                    tabWidgetImg.src = $KU.getImageURL(tabPaneModel.expandedimage);
                                }, duration);

                            tabPaneModel.activetab = null;
                            tabPaneModel.activetabs = null;
                        }
                    }
                    else {
                        if (childTab.style.height !== '0px') {
                            childTab.style.display = 'block';
                            module.collapseTab(tabModel, childTab);
                            if (tabPaneModel.inactiveskin)
                                childTabHeader.className = tabPaneModel.inactiveskin;
                            if (tabPaneModel.expandedimage && tabWidgetImg)
                                childTabImg.src = $KU.getImageURL(tabPaneModel.expandedimage);

                            childTabHeader.setAttribute("active", '0');
                        }
                    }
                }
            }

            if(tabModel.oninit)
                delete tabModel.oninit;

            
            $KW.Utils.reinitializeWidgets(tabPaneModel);
            

            spaAPM && spaAPM.sendMsg(tabPaneModel, 'ontabclick');
            var tabpaneonclickhandler = $KU.returnEventReference(tabPaneModel.onclick || tabPaneModel.ontabclick);
            if((canExecute == true || typeof canExecute == 'undefined') && tabpaneonclickhandler){
                $KU.executeWidgetEventHandler(tabModel,tabpaneonclickhandler,tabPaneModel.activetab, isExpanded);
                $KU.onEventHandler(tabModel);
            }

            
            if($KW.Map && $KW.Map.map && google){
                $KW.Map.setMapsHeight(tabPaneModel.pf);
                google.maps.event.trigger($KW.Map.map, 'resize');
            }
        },

        adjustActiveTabs: function(tabPaneModel){
            if(!tabPaneModel.activetabs)
                return;
            var tempArray = IndexJL ? [null] : [];
            tempArray.push(tabPaneModel.activetabs[IndexJL]);
            tabPaneModel.activetabs = tempArray;
        }

        ,
        changeActiveTabSkin: function(tabPaneModel,tabID){
            for (var i = 0; i < tabPaneModel.children.length; i++) {
                var childTabId = $KW.Utils.getKMasterWidgetID(tabPaneModel[tabPaneModel.children[i]]);
                var tabWidgetBody = $KU.getElementById(childTabId + "_Body");
                var tabWidgetLi = $KU.getElementById(childTabId + "_Li");
                var tabWidgetA = $KU.getElementById(childTabId + "_A");

                if (tabPaneModel.children[i] === tabID) {
                    if(tabPaneModel.viewtype != constants.TABPANE_VIEW_TYPE_PAGEVIEW)
                        tabWidgetBody.className = 'show ' + ((tabPaneModel[tabPaneModel.children[i]].skin) ? tabPaneModel[tabPaneModel.children[i]].skin : "");
                    if (tabPaneModel.activeskin) {
                        
                        
                        $KU.removeClassName(tabWidgetLi, tabPaneModel.inactiveskin + 'li');
                        $KU.removeClassName(tabWidgetA, tabPaneModel.inactiveskin + 'lia');
                        $KU.addClassName(tabWidgetLi, tabPaneModel.activeskin + 'li');
                        $KU.addClassName(tabWidgetA, tabPaneModel.activeskin + 'lia');
                        tabWidgetBody.setAttribute("activebody", '1');
                    }
                    
                    tabPaneModel.activetab = i + IndexJL;
                    tabPaneModel.activetabs[IndexJL] = tabPaneModel.activetab;
                }
                else {
                    if(tabPaneModel.viewtype != constants.TABPANE_VIEW_TYPE_PAGEVIEW)
                        tabWidgetBody.className = 'hide ' + ((tabPaneModel[tabPaneModel.children[i]].skin) ? tabPaneModel[tabPaneModel.children[i]].skin : "");
                    
                    tabWidgetBody.setAttribute("activebody", '0');

                    $KU.removeClassName(tabWidgetLi, tabPaneModel.activeskin + 'li');
                    $KU.removeClassName(tabWidgetA, tabPaneModel.activeskin + 'lia');

                    $KU.addClassName(tabWidgetLi, tabPaneModel.inactiveskin + 'li');
                    $KU.addClassName(tabWidgetA, tabPaneModel.inactiveskin + 'lia');
                }

                module.adjustFlexContainers(tabPaneModel);
            }
        },

        updateData: function(childModel, childNode, tabPaneModel, row, canExecute, updateMasterData){
            if(tabPaneModel && row){
                var containerID = childNode.getAttribute("kcontainerID");
                var tabModel = tabPaneModel[containerID];
                var item = tabModel.headertemplatedata;
                (updateMasterData && item) &&  $KW.Utils.updateContainerMasterData(tabModel, item, childModel, childNode);
                var eventExecuted = false;
                if(canExecute){
                    eventExecuted = kony.events.executeBoxEvent(childModel);
                }
                this.eventHandler("", row, "", !eventExecuted);
            }
        },

        eventHandlerArrow: function(eventObject, target, srcElement, canExecute){
            var tabPaneModel, baseTabID, direction;
            if(target.getAttribute("kmasterid")){
                var id = target.getAttribute("id");
                baseTabID = id.substring(0, id.lastIndexOf("_")); 
                tabPaneModel = $KU.getWidgetModelByID(baseTabID);
                direction = id.substring(id.lastIndexOf("_")+1,id.length);
            }else{
                var tabPaneID = target.getAttribute("ktabpaneid");
                var sourceFormID = target.getAttribute("kformname");
                tabPaneModel = kony.model.getWidgetModel(sourceFormID, tabPaneID);
                var targetID = target.getAttribute("id");
                var tabArray = targetID.split("_");
                baseTabID = tabArray[0] + "_" +tabArray[1];
                direction = tabArray[2];
            }
            var ulElement = $KU.getElementById(baseTabID + "_Ul");

            if(ulElement){
                if(!ulElement.style.left)
                    ulElement.style.left = '0px';

                if(!ulElement.style.top)
                    ulElement.style.top = '0px';

                var leftPosition = ulElement.style.left;
                var topPosition = ulElement.style.top;
                var leftPositionInteger = parseInt(leftPosition.replace(/px/,""),10);
                var topPositionInteger = parseInt(topPosition.replace(/px/,""),10);

                var scrollWidthDelta = Math.abs(ulElement.scrollWidth - ulElement.offsetWidth);

                var ulHeightWithoutScroll = ulElement.parentNode.offsetHeight;
                var ulHeightWithScroll = ulElement.parentNode.scrollHeight;

                if(kony.appinit.isIE)
                    ulHeightWithScroll = ulElement.scrollHeight;

                var scrollHeightDelta = Math.abs(ulHeightWithScroll - ulHeightWithoutScroll);

                if(direction === "R" && leftPositionInteger != -scrollWidthDelta){
                    if((leftPositionInteger-50) <= -scrollWidthDelta)
                        ulElement.style.left = -scrollWidthDelta+'px';
                    else
                        ulElement.style.left = (leftPositionInteger-50)+'px';
                }
                if(direction === "L" && leftPositionInteger != 0){
                    if((leftPositionInteger+50) <= -50 && (leftPositionInteger+50) <= 0)
                        ulElement.style.left = (leftPositionInteger+50)+'px';
                    else
                        ulElement.style.left = '0px';
                }


                if(direction === "T" && topPositionInteger != 0){
                    if((topPositionInteger+50) <= -50 && (topPositionInteger+50) <= 0)
                        ulElement.style.top = (topPositionInteger+50)+'px';
                    else
                        ulElement.style.top = '0px';
                }
                if(direction === "B" && topPositionInteger != -scrollHeightDelta){
                    if((topPositionInteger-50) <= -scrollHeightDelta)
                        ulElement.style.top = -scrollHeightDelta+'px';
                    else
                        ulElement.style.top = (topPositionInteger-50)+'px';
                }

            }
        },

        checkArrows: function(tabPaneModel){
            
            var tabPaneID = $KW.Utils.getKMasterWidgetID(tabPaneModel);
            var ulElement = $KU.getElementById( tabPaneID + "_Ul");
            var lArrow = $KU.getElementById( tabPaneID + "_L");
            var rArrow = $KU.getElementById( tabPaneID + "_R");

            var tArrow = $KU.getElementById( tabPaneID + "_T");
            var bArrow = $KU.getElementById( tabPaneID + "_B");

            

            var parentNode = ulElement.parentNode;
            if(Math.abs(parentNode.scrollWidth - parentNode.offsetWidth) >1){
                if(lArrow)
                    $KU.removeClassName(lArrow, 'hide');

                if(rArrow)
                    $KU.removeClassName(rArrow, 'hide');
                $KU.addClassName(ulElement.parentNode, 'kwt96');

            }else{
                if(lArrow)
                    $KU.addClassName(lArrow, 'hide');

                if(rArrow)
                    $KU.addClassName(rArrow, 'hide');

                $KU.removeClassName(ulElement.parentNode, 'kwt96');
                ulElement.style.left = '0px';

            }

            if(tabPaneModel.viewconfig.tabViewConfig && ((tabPaneModel.viewconfig.tabViewConfig.headerPosition == constants.TAB_HEADER_POSITION_LEFT) || (tabPaneModel.viewconfig.tabViewConfig.headerPosition == constants.TAB_HEADER_POSITION_RIGHT))){
                var bodyElement = $KU.getElementById( tabPaneID + "_Body");
                ulElement.parentNode.style.height = Math.ceil(bodyElement.offsetWidth * 0.15) + 'px';
            }

            var ulHeightWithoutScroll = ulElement.parentNode.offsetHeight;
            var ulHeightWithScroll = ulElement.parentNode.scrollHeight;

            if(kony.appinit.isIE)
                ulHeightWithScroll = ulElement.scrollHeight;

            if(ulHeightWithScroll > ulHeightWithoutScroll){
                if(tArrow)
                    $KU.removeClassName(tArrow, 'hide');

                if(bArrow)
                    $KU.removeClassName(bArrow, 'hide');

            }else{
                if(tArrow)
                    $KU.addClassName(tArrow, 'hide');

                if(bArrow)
                    $KU.addClassName(bArrow, 'hide');

                ulElement.style.top = '0px';
            }
        },

        setPfForTabHeader: function(widget,context){
            if(widget && widget.children){
                for (var i = 0; i < widget.children.length; i++) {
                    widget[widget.children[i]].pf = context.pf;
                    widget[widget.children[i]].tabId = context.tabID;
                    if(widget[widget.children[i]].children)
                        this.setPfForTabHeader(widget[widget.children[i]],context);
                }
            }
        },

        generatePageFooter: function(tabPaneModel) {
            var htmlString = "";
            var src = "";
            var segpag = tabPaneModel.paginationconfig;
            var left = (segpag && segpag.hdistance) || 0;
            if(tabPaneModel.children.length > IndexJL) {
                var alignment = !left || (left == 0);
                var htmlattrs = alignment ? "align='center'" : "style='text-align: left;'";
                if(tabPaneModel.needpageindicator)
                    htmlString +="<div class='ktable kwt100 '  id='"+$KW.Utils.getKMasterWidgetID(tabPaneModel)+"_footer' >";
                else
                    htmlString +="<div class='ktable kwt100 ' style='display:none' id='"+$KW.Utils.getKMasterWidgetID(tabPaneModel)+"_footer' >";
                htmlString += "<div class='krow kwt100' " + htmlattrs + "><div class='kcell'>";
                tabPaneModel.pageondotimage = tabPaneModel.pageondotimage || "whitedot.gif";
                tabPaneModel.pageoffdotimage = tabPaneModel.pageoffdotimage || "blackdot.gif";
                for(var i = IndexJL; i < tabPaneModel.children.length; i++)
                {
                    src = (typeof tabPaneModel.activetab != "number" && i == IndexJL) ? tabPaneModel.pageondotimage : (tabPaneModel.activetab == i) ? tabPaneModel.pageondotimage : tabPaneModel.pageoffdotimage;
                    htmlString += "<span onclick='$KW.touch.navigationDotsHandler(this)' index='" + i + "'><img style='padding-left:4px' src='" + $KU.getImageURL(src) + "' /></span>";
                }
                htmlString += "</div></div></div>";
            }
            return htmlString;
        },

        updatePageFooter: function(tabPaneModel) {
            var htmlFooterString = this.generatePageFooter(tabPaneModel);
            var wrapper = document.createElement("div");
            var bodyElem = document.getElementById($KW.Utils.getKMasterWidgetID(tabPaneModel) + "_Body");
            wrapper.innerHTML = htmlFooterString;
            bodyElem.parentNode.removeChild(bodyElem.nextSibling);
            bodyElem.parentNode.appendChild(wrapper.children[0]);
        },

        adjustFlexContainersInTab : function(wModel, wNode){
            var headers = wNode.querySelectorAll("div[tabHeader='true']");
            for(var i = 0; i< headers.length; i++){
                this.adjustFlexContainersInTabRows(headers[i]);
            }
        },

        adjustFlexContainersInTabRows : function(rows){
            var flexNode = rows.querySelector('div[kwidgettype="FlexContainer"]');
            if(flexNode){
                var flexModel = $KU.getModelByNode(flexNode);
                $KW.FlexContainer.forceLayout(flexModel, flexNode.parentNode);
            }
        }
    };


    return module;
}());

$KW.Switch = (function() {
    
    

    var module = {
        initialize: function() {
            kony.events.addEvent("click", "Switch", this.eventHandler);
            kony.events.addEvent("onorientationchange", "Switch", this.adjustSwitchWidth);
        },

        initializeView: function(formId, node) {
            this.adjustSwitchWidth(formId, true, node);
            this.adjustSwitchHeight(formId, node);
        },

        updateView: function(widgetModel, propertyName, propertyValue, oldPropertyValue) {
            var element = $KU.getNodeByModel(widgetModel);
            var isCustomSwitch = module.isCustomSwitch(widgetModel);

            if(!element)
                return;
            element = $KW.Utils.getClonedTemplateNode(element, widgetModel, propertyName);

            var nodesInSwitch = module.getNodesInSwitch(element, widgetModel);

            switch(propertyName) {
                case "selectedindex":
                    this.adjustSwitch(widgetModel, element, "all 0.125s ease-in-out");
                    break;
                case "leftsidetext":
                    if(isCustomSwitch) {
                        nodesInSwitch.leftTextNode.innerHTML = $KU.escapeHTMLSpecialEntities(propertyValue);
                    } else {
                        nodesInSwitch.onNode.innerHTML = $KU.escapeHTMLSpecialEntities(propertyValue);
                    }
                    break;
                case "rightsidetext":
                    if(isCustomSwitch) {
                        nodesInSwitch.rightTextNode.innerHTML = $KU.escapeHTMLSpecialEntities(propertyValue);
                    } else {
                        nodesInSwitch.offNode.innerHTML = $KU.escapeHTMLSpecialEntities(propertyValue);
                    }
                    break;
                case "thumbwidth":
                case "thumbheight":
                case "trackwidth":
                case "trackheight":
                    if(isCustomSwitch) {
                        var htmlString = this.render(widgetModel, {
                            tabpaneID: element.getAttribute("ktabpaneid")
                        }); 
                        element = element.parentNode;
                        element.innerHTML = htmlString;
                        this.adjustSwitch(widgetModel, element.firstElementChild, "all 0.4s ease-in-out");
                    }
                    break;
                case "thumbtext":
                    if(isCustomSwitch)
                        nodesInSwitch.thumbTextNode.innerHTML = $KU.escapeHTMLSpecialEntities(propertyValue);
                    break;
                case "thumbskin":
                    if(module.isCustomSwitch(widgetModel)) {
                        var switchState = ['thumbon', 'thumboff'][widgetModel.selectedIndex];
                        $KU.removeClassName(nodesInSwitch.thumbNode, oldPropertyValue + switchState);
                        $KU.addClassName(nodesInSwitch.thumbNode, propertyValue + switchState);
                    }
                    break;
            }
        },

        addA11YAttribute: function(switchModel, switchDiv, forceAriaLabel) {
            if(!switchModel.accessibilityConfig || forceAriaLabel) {
                if(switchModel.leftsidetext && switchModel.selectedIndex === 0) {
                    switchDiv.setAttribute('aria-label', switchModel.leftsidetext);
                } else if(switchModel.rightsidetext) {
                    switchDiv.setAttribute('aria-label', switchModel.rightsidetext);
                }
            }
        },

        renderIOSgt6Switch: function(switchModel, context, params) {
            var switchStyle = [
                "",
                "background-image : none",
                "height   : 31px;",
                "padding  : 0",
                "position : relative",
                "width    : 51px",
                "-webkit-border-radius: 15.5px;",
                "background-size:100%",
                "display : inline-block;",
                ""
            ].join(";");
            var thumbStyle = [
                "",
                "border     : 0",
                "background : #FFF",
                "height     : 28px",
                "position   : relative",
                "width      : 28px",
                "top        : 1.5px",
                "z-index    : 3",
                "-webkit-border-radius:14px",
                "-webkit-box-shadow:1px 1px 3px 0 rgba(0,0,0,0.3)",
                ""
            ].join(";");
            var onStyle = [
                "",
                "display:none",
                ""
            ].join(";");
            var thumbSpanStyle = [
                "",
                "display:none",
                ""
            ].join(";");
            var offStyle = [
                "",
                "background       : #FFF",
                "background-image : none",
                "border   : 1px solid #ccc",
                "height   : 31px",
                "left     : 0",
                "margin   : 0",
                "padding  : 0",
                "position : absolute",
                "top      : 0",
                "width    : 51px",
                "z-index  : 2",
                "-webkit-border-radius:15.5px",
                ""
            ].join(";");

            switchStyle += $KW.skins.getBlurStyle(switchModel);

            var htmlString = "<div role='option' aria-selected='" + ['true', 'false'][switchModel.selectedIndex] +
                "' " + params.substituteAccessAttr + $KW.Utils.getBaseHtml(switchModel, context) + "class='switch " +
                params.computedSkin + " " + (switchModel.skin ? switchModel.skin + "on" : "") + "' style='" +
                params.margin + switchStyle + (!switchModel.skin ? ";background: #4FD065" : "") + "'>" +
                "<div  id='" + switchModel.id + "_on' style='" + onStyle + "'>" + params.lText + "</div>" +
                "<div class='thumb' id='" + switchModel.id + "_thumb' style='" +
                thumbStyle + "'>" + "<span style='" +
                thumbSpanStyle + "'></span></div>" +
                "<div  id='" + switchModel.id + "_off' style='" +
                offStyle + "'>" + params.rText + "</div>" +
                "</div>";
            return htmlString;
        },

        renderSwitchOtherThanIOSgt6: function(switchModel, context, params) {
            var switchStyle = $KW.skins.getBlurStyle(switchModel);
            var htmlString = "<div role='option' aria-selected='" + ['true', 'false'][switchModel.selectedIndex] + "' " +
                params.substituteAccessAttr + $KW.Utils.getBaseHtml(switchModel, context) + "class='kwt100 switch " +
                params.computedSkin + "' style='" + params.margin + switchStyle + "'>" +
                "<div aria-hidden='true' class='" + (switchModel.skin ? (switchModel.skin + "on") : "on konycustomcss") +
                "' id='" + switchModel.id + "_on'>" + params.lText + "</div>" +
                "<div aria-hidden='true' class='thumb' id='" + switchModel.id + "_thumb'> <span></span></div>" +
                "<div aria-hidden='true' class=' " + (switchModel.skin ? (switchModel.skin + "off") : "off konycustomcss") +
                "' id='" + switchModel.id + "_off'>" + params.rText + "</div>" +
                "</div>";
            return htmlString;
        },

        render: function(switchModel, context) {
            var computedSkin = $KW.skins.getWidgetSkinList(switchModel, context);
            var margin = $KW.skins.getMarginSkin(switchModel, context);
            var lText = switchModel.leftsidetext || "ON";
            var rText = switchModel.rightsidetext || "OFF";
            var isCustomSwitch = module.isCustomSwitch(switchModel);
            var substituteAccessAttr = "";
            if(switchModel.accessibilityConfig == undefined) {
                if(switchModel.leftsidetext && switchModel.selectedIndex === 0) {
                    substituteAccessAttr = " aria-label='" + switchModel.leftsidetext + "' ";
                } else if(switchModel.rightsidetext) {
                    substituteAccessAttr = " aria-label='" + switchModel.rightsidetext + "' ";
                }
            }

            if(isCustomSwitch) {
                lText = switchModel.leftsidetext;
                rText = switchModel.rightsidetext;
            }

            switchModel.selectedindex = (switchModel.selectedindex == IndexJL) ? IndexJL : IndexJL + 1;
            var params = {
                "computedSkin": computedSkin,
                "margin": margin,
                "lText": lText,
                "rText": rText,
                "substituteAccessAttr": substituteAccessAttr
            };

            if(isCustomSwitch) {
                return module.renderCustomSwitch(switchModel, context, params);
            } else {
                return module.renderSwitchOtherThanIOSgt6(switchModel, context, params);
            }
            return htmlString;
        },

        adjustSwitchWidth: function(formId, attachEvent, node) {
            var switches = node ? node.querySelectorAll("div[kwidgettype='Switch']") : document.querySelectorAll("#" + formId + " div[kwidgettype='Switch']");
            for(var i = 0; i < switches.length; i++) {
                var switchModel = $KU.getModelByNode(switches[i]);
                var containerId = switches[i].getAttribute("kcontainerID");
                if(containerId) {
                    switchModel = $KW.Utils.getClonedModelByContainer(switchModel, switches[i], containerId);
                }
                module.adjustWidth(switchModel, switches[i], attachEvent);
            }
        },

        adjustWidthOtherThanIOSgt6: function(switchModel, switchNode, attachEvent) {
            var nodesInSwitch = module.getNodesInSwitch(switchNode, switchModel);
            nodesInSwitch.onNode.style.marginRight = "-6px";
            nodesInSwitch.offNode.style.marginLeft = "-6px";
            switchModel.cWidth = (Math.floor(switchNode.clientWidth / 2));
            switchModel.sWidth = switchModel.cWidth + (switchNode.clientWidth % 2) + 6;
            nodesInSwitch.onNode.style.width = (switchModel.sWidth - 2) + "px"; 
            nodesInSwitch.offNode.style.width = switchModel.sWidth + "px"; 
            nodesInSwitch.thumbSpan.style.width = switchModel.cWidth + "px"; 
            module.adjustSwitch(switchModel, switchNode, "none"); 

            if($KU.isIE11) {
                for(var i = 0; i < switchNode.children.length; i++) {
                    switchNode.children[i].style.flex = 'none';
                }
            }
        },

        adjustWidth: function(switchModel, switchNode, attachEvent) {
            if(module.isCustomSwitch(switchModel)) {
                module.adjustSwitch(switchModel, switchNode, "none");
            } else {
                module.adjustWidthOtherThanIOSgt6(switchModel, switchNode, attachEvent);
            }
        },

        toggleSwitch: function(model, target) {
            var switchDiv = target; 
            var kdisabled = switchDiv.getAttribute("kdisabled");
            var containerId = target.getAttribute("kcontainerID");
            var nodesInSwitch = module.getNodesInSwitch(switchDiv, model);
            if(containerId) {
                model = $KW.Utils.getClonedModelByContainer(model, target, containerId);
            }
            if(switchDiv && kdisabled != "true") {
                this.applyTrans(switchDiv, model, $KU.isIOSgt6 && "all 0.4s ease-in-out" || "all 0.125s ease-in-out");
                if(model.selectedindex == IndexJL) {
                    model.selectedindex = IndexJL + 1;
                    if((module.isCustomSwitch(model))) {
                        this.applyTrans(switchDiv, model, "all 0.4s ease-in-out");
                        nodesInSwitch.thumbNode.style[$KU.transform] = translateOpen + nodesInSwitch.onNode.offsetLeft + "px,0" + translateClose;
                    } else {
                        nodesInSwitch.onNode.style[$KU.transform] = translateOpen + (-(model.cWidth + 8)) + "px,0" + translateClose;
                        nodesInSwitch.thumbNode.style[$KU.transform] = translateOpen + (-model.cWidth + 2) + "px,0" + translateClose;
                        nodesInSwitch.offNode.style[$KU.transform] = translateOpen + (-model.cWidth) + "px,0" + translateClose;
                    }
                } else {
                    model.selectedindex = IndexJL;
                    if((module.isCustomSwitch(model))) {
                        this.applyTrans(switchDiv, model, "all 0.4s ease-in-out");
                        var size = module.getAbsoluteDimensions(model, nodesInSwitch);
                        var transValue = (parseInt(size.trackWidth) - parseInt(size.thumbWidth) + nodesInSwitch.onNode.offsetLeft - nodesInSwitch.thumbNode.offsetLeft) + kony.flex.PX;
                        nodesInSwitch.thumbNode.style[$KU.transform] = translateOpen + transValue + ",0" + translateClose;
                    } else {
                        nodesInSwitch.onNode.style[$KU.transform] = translateOpen + "0,0" + translateClose;
                        nodesInSwitch.thumbNode.style[$KU.transform] = translateOpen + "0,0" + translateClose;
                        nodesInSwitch.offNode.style[$KU.transform] = translateOpen + "0,0" + translateClose;
                    }
                }
                spaAPM && spaAPM.sendMsg(model, 'onslide');
                var eventRef = $KU.returnEventReference(model.onslide || model.onslidercallback);
                switchDiv.setAttribute("aria-selected", [true, false][model.selectedIndex]); 
                module.addA11YAttribute(model, switchDiv); 
                if(module.isCustomSwitch(model)) {
                    module.adjustLabelsForCustomSwitch(model, switchDiv);
                    nodesInSwitch.onNode.className = (model.skin ? model.skin + (["on", "off"][model.selectedIndex]) :
                        (["on switch", "off switch"][model.selectedIndex]));
                    nodesInSwitch.thumbNode.className = (model.thumbskin ? model.thumbskin + (["thumbon", "thumboff"][model.selectedIndex]) :
                        (["on switch", "off switch"][model.selectedIndex]));
                }
                $KAR && $KAR.sendRecording(model, 'toggle', {'target': target, 'eventType': 'uiAction'});
                $KU.callTargetEventHandler(model, target, "onslide");
                eventRef && $KU.onEventHandler(model);
            }
        },

        adjustSwitch: function(model, switchDiv, trans) {
            var nodesInSwitch = module.getNodesInSwitch(switchDiv, model);
            this.applyTrans(switchDiv, model, trans);
            if(module.isCustomSwitch(model)) {
                module.adjustSwitchAlignment(model, switchDiv);
                module.adjustLabelsForCustomSwitch(model, switchDiv);
            }

            if(model.selectedindex == IndexJL) {
                nodesInSwitch.onNode.style[$KU.transform] = translateOpen + nodesInSwitch.onNode.offsetLeft + ",0" + translateClose;
                if((module.isCustomSwitch(model))) {
                    var size = module.getAbsoluteDimensions(model, nodesInSwitch);
                    var transValue = (parseInt(size.trackWidth) - parseInt(size.thumbWidth) + nodesInSwitch.onNode.offsetLeft - nodesInSwitch.thumbNode.offsetLeft) + kony.flex.PX;
                    nodesInSwitch.thumbNode.style[$KU.transform] = translateOpen + transValue + ",0" + translateClose;
                    return;
                }
                nodesInSwitch.thumbNode.style[$KU.transform] = translateOpen + "0,0" + translateClose;
                nodesInSwitch.offNode.style[$KU.transform] = translateOpen + "7px,0" + translateClose;
            } else {
                if((module.isCustomSwitch(model))) {
                    nodesInSwitch.thumbNode.style[$KU.transform] = translateOpen + 0 + "px,0" + translateClose;
                    return;
                }
                nodesInSwitch.onNode.style[$KU.transform] = translateOpen + (-(model.cWidth + 6)) + "px,0" + translateClose;
                nodesInSwitch.thumbNode.style[$KU.transform] = translateOpen + (-model.cWidth + 2) + "px,0" + translateClose;
                nodesInSwitch.offNode.style[$KU.transform] = translateOpen + (-model.cWidth) + "px,0" + translateClose
            }
        },

        applyTrans: function(switchDiv, model, trans) {
            var nodesInSwitch = module.getNodesInSwitch(switchDiv, model);
            nodesInSwitch.thumbNode.style[$KU.transition] = trans;
            nodesInSwitch.onNode.style[$KU.transition] = trans;
            if(nodesInSwitch.offNode) nodesInSwitch.offNode.style[$KU.transition] = trans;
        },

        eventHandler: function(eventObject, target) {
            var switchModel = $KU.getModelByNode(target);
            module.toggleSwitch(switchModel, target);
        },

        adjustThumbHeight: function(node, model, event) {
            var nodesInSwitch = module.getNodesInSwitch(node, model);
            event.target.naturalHeight = event.target.naturalHeight || event.target.height;
            nodesInSwitch.onNode.style.height = nodesInSwitch.offNode.style.height = (event.target.naturalHeight + "px");
            nodesInSwitch.thumbSpan.style.height = ((event.target.naturalHeight - 2) + "px");
        },

        adjustSwitchHeight: function(formId, node) {
            var switches = node ? node.querySelectorAll("div[kwidgettype='Switch']") : document.querySelectorAll("#" + formId + " div[kwidgettype='Switch']");
            for(var i = 0; i < switches.length; i++) {
                var switchModel = $KU.getModelByNode(switches[i]);
                module.adjustHeight(switchModel, switches[i]);
            };
        },

        adjustHeight: function(switchModel, switchNode) {
            var nodesInSwitch = module.getNodesInSwitch(switchNode, switchModel);
            if(module.isCustomSwitch(switchModel)) {
                return;
            }
            nodesInSwitch.onNode.style.minHeight = "27px";
            nodesInSwitch.offNode.style.minHeight = "27px";

            if(switchModel.skin)
                var skinBackground = $KU.getCSSPropertyFromRule((switchModel.skin + 'on'), 'background-image');
            if(skinBackground) {
                var imageSwitchOn = skinBackground.replace(/url\(([^\)]*)\)/, '$1');
                $KU.imagePreloader(imageSwitchOn, function(node) {
                    return function(e) {
                        kony.events.preventDefault(e);
                        module.adjustThumbHeight(node, switchModel, e);
                    }
                }(switchNode));
            }
        },

        adjustLabelsForCustomSwitch: function(model, switchDiv) {
            var nodesInSwitch = module.getNodesInSwitch(switchDiv, model);
            var trackLabelLeft = nodesInSwitch.leftTextNode;
            var trackLabelRight = nodesInSwitch.rightTextNode;
            var thumbLabel = nodesInSwitch.thumbTextNode;

            trackLabelLeft.style.display = ["block", "none"][model.selectedIndex];
            trackLabelRight.style.display = ["none", "block"][model.selectedIndex];
            thumbLabel.style.display = "block";
        },

        getAbsoluteDimensions: function(model, nodesInSwitch) {
            var switchLayout = module.computeValuesForCustomSwtich(model),
                size = {};

            size.trackHeight = (switchLayout.trackheight.indexOf('%')) ? nodesInSwitch.onNode.offsetHeight : parseFloat(switchLayout.trackheight.replace('px', ''));
            size.thumbHeight = (switchLayout.thumbheight.indexOf('%')) ? nodesInSwitch.thumbNode.offsetHeight : parseFloat(switchLayout.thumbheight.replace('px', ''));
            size.trackWidth = (switchLayout.trackwidth.indexOf('%')) ? nodesInSwitch.onNode.offsetWidth : parseFloat(switchLayout.trackwidth.replace('px', ''));
            size.thumbWidth = (switchLayout.thumbwidth.indexOf('%')) ? nodesInSwitch.thumbNode.offsetWidth : parseFloat(switchLayout.thumbwidth.replace('px', ''));
            return size;
        },

        adjustTopMargin: function(model, nodesInSwitch, size) {
            var trackMarginTop = -1,
                thumbMarginTop = -1;

            trackMarginTop = '-' + (size.trackHeight / 2) + 'px';
            thumbMarginTop = '-' + (size.thumbHeight / 2) + 'px';

            nodesInSwitch.onNode.style.marginTop = trackMarginTop;
            nodesInSwitch.thumbNode.style.marginTop = thumbMarginTop;
        },

        adjustLabelAlignment: function(model, nodesInSwitch, size) {
            nodesInSwitch.leftTextNode.style.lineHeight = size.trackHeight + 'px';
            nodesInSwitch.rightTextNode.style.lineHeight = size.trackHeight + 'px';
            nodesInSwitch.thumbTextNode.style.lineHeight = size.thumbHeight + 'px';
        },

        adjustSwitchAlignment: function(model, switchDiv) {
            var nodesInSwitch = module.getNodesInSwitch(switchDiv, model);
            var size = module.getAbsoluteDimensions(model, nodesInSwitch);

            module.adjustTopMargin(model, nodesInSwitch, size);
            module.adjustLabelAlignment(model, nodesInSwitch, size);
        },

        isCustomSwitch: function(switchModel) {
            if(switchModel.thumbwidth && switchModel.thumbheight && switchModel.trackwidth && switchModel.trackheight)
                return true;
        },

        renderCustomSwitch: function(switchModel, context, params) {
            params.thumbText = switchModel.thumbtext;
            var switchLayout = module.computeValuesForCustomSwtich(switchModel);

            var switchStyle = 'background-image : none; padding  : 0; display : inline-block;' +
                ' background-size:100%; height : 100%; width : 100%;';

            switchStyle += $KW.skins.getBlurStyle(switchModel);

            var onStyle = 'display: inline-block; position: absolute; height:' + switchLayout.trackheight +
                '; width: ' + switchLayout.trackwidth + ' ; top : 50%; left : 0px;';

            var thumbStyle = 'height : ' + switchLayout.thumbheight + '; width : ' + switchLayout.thumbwidth +
                '; position : absolute; top : 50%; z-index : 3;' +
                ' -webkit-box-shadow:1px 1px 3px 0 rgba(0,0,0,0.3); overflow: hidden';

            var htmlString = '<div role="option" aria-selected="' + ["true", "false"][switchModel.selectedIndex] + '" ' +
                params.substituteAccessAttr + $KW.Utils.getBaseHtml(switchModel, context) +
                ' style="' + params.margin + switchStyle + (!switchModel.skin ? ';background: #4FD065' : '') + '"' +
                ' class="switch ' + params.computedSkin + '">';

            htmlString += '<div  id="' + switchModel.id + '" style="' + onStyle + '"' + 'class=" ' +
                ' ' + (switchModel.skin ? (switchModel.selectedindex == 0 ? switchModel.skin + 'on"' : switchModel.skin + 'off"') : 'on switch"') +
                '>' + '<label style="float:left; padding-left: 5px;">' +
                (params.lText ? params.lText : " ") + '</label>' +
                '<label style="float:right; padding-right: 5px;">' +
                (params.rText ? params.rText : " ") + '</label>' + '</div>';

            htmlString += '<div id="' + switchModel.id + '_thumb" style="' + thumbStyle + '"' + ' class=" ' + ' ' +
                (switchModel.thumbskin ? (switchModel.selectedindex == 0 ? switchModel.thumbskin + 'thumbon"' : switchModel.thumbskin + 'thumboff"') :
                    'off switch"') + '">' + '<label style="">' + (params.thumbText ? params.thumbText : " ") +
                '</label>' + '</div>' + '</div>';

            return htmlString;
        },

        computeValuesForCustomSwtich: function(switchModel) {
            var switchLayout = {};
            switchLayout.trackwidth = this.getComputedCustomSwtichValue(switchModel, switchModel.trackwidth);
            switchLayout.trackheight = this.getComputedCustomSwtichValue(switchModel, switchModel.trackheight);
            switchLayout.thumbwidth = this.getComputedCustomSwtichValue(switchModel, switchModel.thumbwidth);
            switchLayout.thumbheight = this.getComputedCustomSwtichValue(switchModel, switchModel.thumbheight);
            switchLayout.height = this.getComputedCustomSwtichValue(switchModel, switchModel.height);
            switchLayout.width = this.getComputedCustomSwtichValue(switchModel, switchModel.width);
            return switchLayout;
        },

        getComputedCustomSwtichValue: function(switchModel, value, propertyName) {
            if(!$KU.isValidCSSLength(value)) {
                return null;
            }
            var resultObj = $KW.FlexUtils.getValueAndUnit(switchModel, value);
            return resultObj.value + resultObj.unit;
        },

        getNodesInSwitch: function(element, switchModel) {
            var nodesInSwitch = {};
            nodesInSwitch.thumbNode = element.children[1];
            nodesInSwitch.onNode = element.children[0];

            if(module.isCustomSwitch(switchModel)) {
                nodesInSwitch.leftTextNode = element.children[0].firstElementChild;
                nodesInSwitch.rightTextNode = element.children[0].lastElementChild;
                nodesInSwitch.thumbTextNode = element.children[1].firstElementChild;
            } else {
                nodesInSwitch.thumbSpan = element.children[1].firstElementChild;
                nodesInSwitch.offNode = element.children[2];
            }
            return nodesInSwitch;
        }
    };


    return module;
}());


$KW.RichText = (function() {
    
    

    var module = {
        initialize: function() {
            kony.events.addEvent("click", "RichText", this.eventHandler);
        },

        updateView: function(widgetModel, propertyName, propertyValue, oldPropertyValue) {
            var element = $KU.getNodeByModel(widgetModel);
            if(!element)
                return;
            element = $KW.Utils.getClonedTemplateNode(element, widgetModel, propertyName);

            switch(propertyName) {
                case "text":
                    element.innerHTML = propertyValue;
                    break;
                case "linkskin":
                    this.setLinkSkin(widgetModel, element);
                    break;
                case "linkfocusskin":
                    this.setLinkFocusSkin(widgetModel, element);
                    break;
            }
        },

        render: function(richTextModel, context) {
            this.setLinkSkin(richTextModel);
            this.setLinkFocusSkin(richTextModel);
            var computedSkin = $KW.skins.getWidgetSkinList(richTextModel, context);
            var htmlString = "<div" + $KW.Utils.getBaseHtml(richTextModel, context) + "class='" + computedSkin + "' style='white-space:pre-wrap;word-wrap:break-word;" + $KW.skins.getBaseStyle(richTextModel, context);
            if(context.ispercent === false)
                htmlString += "display:inline-block;" + (context.layoutDir ? ("float:" + context.layoutDir) : "");
            htmlString += ";text-align:" + $KW.skins.getContentAlignment(richTextModel) + "'>" + richTextModel.text + "</div>";
            if($KW.Utils.isWidgetDisabled(richTextModel, context))
                htmlString = htmlString.replace(/href=["'].*?["']/g, "href='javascript:void(0)'");
            return htmlString;
        },

        eventHandler: function(eventObject, target, data) {
            var richWidgetModel = $KU.getModelByNode(target),
                containerId = target.getAttribute("kcontainerID");
            
            spaAPM && spaAPM.sendMsg(richWidgetModel, 'onclick');

            $KAR && $KAR.sendRecording(richWidgetModel, 'click', {'data': data, 'target': target, 'eventType': 'uiAction'});

            if(containerId) {
                $KW.Utils.updateContainerData(richWidgetModel, target, true);
            } else if(richWidgetModel.onclick) {
                var richtextref = $KU.returnEventReference(richWidgetModel.onclick);
                if(richtextref) {
                    if(data) {
                        
                        $KU.executeWidgetEventHandler(richWidgetModel, richtextref, data[0], {
                            href: data[1]
                        });
                    } else {
                        $KU.executeWidgetEventHandler(richWidgetModel, richtextref);
                    }
                    $KU.onEventHandler(richWidgetModel);
                }
            } else if(data && data[1]) { 
                if(data[1].charAt(0) == "#") { 
                    
                    kony.events.stopPropagation(eventObject);
                    kony.events.preventDefault(eventObject);
                }
                var aLink = data[1].substring(1, data[1].length);
                var element = document.querySelector('a[name="' + aLink + '"]');
                var scrollerInstance = $KG[$KG["__currentForm"].id + '_scroller'];
                if(scrollerInstance && element) {
                    scrollerInstance.scrollToElement(element, 200);
                }
            }
        },

        setLinkSkin: function(richTextModel, node) {
            var linkSkin = richTextModel.linkskin;
            if(!linkSkin)
                return;

            if(node) {
                
                var selector = "#" + node.id + " > a"
                $KW.skins.applyStyle(linkSkin, selector);
            }

        },

        setLinkFocusSkin: function(richTextModel, node) {
            var linkFocusSkin = richTextModel.linkfocusskin;
            if(!linkFocusSkin)
                return;

            if(node) {
                
                var selector = "#" + node.id + " > a:active"
                $KW.skins.applyStyle(linkFocusSkin, selector);
            }
        }
    };


    return module;
}());


$KW.FlexContainer = (function() {
    
    

    var module = {
        initialize: function() {
            kony.events.addEvent("click", "FlexContainer", this.eventHandler);
            kony.events.addEvent("keydown", "FlexContainer", this.keydownEventHandler);
            kony.events.addEvent("onorientationchange", "FlexContainer", this.orientationHandler);
        },

        initializeView: function(formId) {
            
            this.attachResizeEvent(formId, "FlexContainer");
        },

        orientationHandler: function(formId, orientation) {
            
        },

        
        updateView: function(widgetModel, propertyName, propertyValue, oldPropertyValue) {
            var element = $KU.getNodeByModel(widgetModel);
            if(!element)
                return;

            switch(propertyName) {
                case "clipbounds":
                    var isFlexWidget = $KW.FlexUtils.isFlexWidget(widgetModel);
                    element = isFlexWidget ? element.parentNode.parentNode : element;
                    var wrapperNode = isFlexWidget ? element.parentNode.parentNode : element;
                    if(propertyValue == false) {
                        element.style.overflow = "visible";
                        wrapperNode.style.overflow = "visible";
                    } else {
                        element.style.overflow = "hidden";
                        element.style.boxShadow = "none";
                        wrapperNode.style.overflow = "hidden";
                    }
                    break;
                case "layouttype":
                    module.adjustFlexContainer(widgetModel);
                    break;
            }
        },

        render: function(flexModel, context) {
            if(flexModel.isMaster) {
                $KI.i18n && $KI.i18n.translateFormModel(flexModel);
            }
            return this.renderTableLayout(flexModel, context);
        },

        renderTableLayout: function(flexModel, context) {
            var computedSkin = $KW.skins.getWidgetSkinList(flexModel, context);
            var isFlexWidget = $KW.FlexUtils.isFlexContainer(flexModel);
            var overflow = "";
            if(isFlexWidget && (flexModel.clipbounds == true)) {
                overflow = "overflow:hidden;box-shadow:none";
            }
            var boxstyle = " position:relative;" + overflow + (flexModel.zindex ? "z-index:" + flexModel.zindex : "");
            var style = (flexModel.parent && flexModel.parent.wType == 'TabPane') ? '' : $KW.skins.getBaseStyle(flexModel, context);

            var htmlString = "";
            htmlString += "<div id='flexcontainer_wrapper' class=' ' style='width:100%; " + style + "'>";
            htmlString += "<div class = 'kwt100 " + computedSkin + "'" + $KW.Utils.getBaseHtml(flexModel, context) + " style='" + boxstyle + "'>";


            var wArrary = flexModel.widgets();
            if(wArrary.length > 0) {
                htmlString += this.renderChildren(flexModel, wArrary, context);
            }

            htmlString += "</div></div>";
            return htmlString;
        },

        renderChildren: function(flexModel, wArrary, context) {
            var htmlString = "";
            for(var i = 0; i < wArrary.length; i++) {
                var childModel = wArrary[i];
                if($KG.appbehaviors["lazyLoadDOM"] == true && childModel.isvisible == false) {
                    continue;
                }
                var css = "kcell " + (childModel.wType == "TPW" ? "konycustomcss " : "") + (childModel.isvisible ? "" : "hide ");
                var style = $KW.FlexUtils.getFlexLayoutStyle(childModel);
                var overflow = "";
                if((childModel.wType == 'FlexContainer' || childModel.wType == 'FlexScrollContainer') && !childModel.clipbounds) {
                    overflow = ';overflow:visible';
                } else {
                    overflow = ';overflow:hidden';
                    overflow += ((childModel.wType == 'FlexContainer' || childModel.wType == 'FlexScrollContainer') && childModel.clipbounds) ? ";" + $KU.cssPrefix + "box-shadow:none" : "";
                    css += childModel.skin;
                }
                htmlString += "<div class = '" + css + "' style='" + style + overflow + ((childModel.wType == 'TextArea' || childModel.wType == 'Switch' || childModel.wType == 'Image') ? 'font-size:0px' : '') + "'>";
                htmlString += $KW[childModel.wType].render(childModel, context);
                htmlString += "</div>";
            }
            return htmlString;
        },

        adjustFlexContainers: function(containerModel, containerNode) {
            if(containerModel.wType == 'Segment') {
                $KW.Segment.adjustFlexContainersInSegment(containerModel, containerNode);
            }
            if(containerModel.wType == 'CollectionView') {
                $KW.CollectionView.adjustFlexContainersInCollectionView(containerModel, containerNode);
                if(containerModel.layouttype != kony.collectionview.LAYOUT_CUSTOM)
                    $KW.CollectionView.applyLineSpaceAndItemSpace(containerModel, containerNode);
            }
            else if(containerModel.wType == 'DataGrid') {
                $KW.DataGrid.adjustFlexContainersInDataGrid(containerModel, containerNode);
            } else if(containerModel.wType == 'TabPane') {
                $KW.TabPane.adjustFlexContainersInTab(containerModel, containerNode);
            }
        },

        adjustFlexContainer: function(flexModel, flexNode) {
            if(!flexNode) {
                if(flexModel.wType == 'Form')
                    flexNode = document.getElementById(flexModel.id + "_scroller") || document.getElementById(flexModel.id);
                else
                    flexNode = flexNode || $KW.Utils.getWidgetNode(flexModel);
            }
            if(!flexNode)
                return;
            if(flexModel.wType == 'FlexContainer' && flexModel.autogrowHeight) {
                flexModel.layoutConfig.children = true;
            }
            var widgets = flexModel.widgets();
            $KW.FlexLayoutEngine.performFlexLayout(flexModel.layouttype, flexModel, flexNode, widgets);
        },

        forceLayout: function(flexModel, flexNode) {
            if(flexModel.wType == 'Form')
                flexNode = document.getElementById(flexModel.id + "_scroller") || document.getElementById(flexModel.id);
            else
                flexNode = flexNode || $KW.Utils.getWidgetNode(flexModel);

            if(flexNode && flexModel.isvisible) {
                var containerId = (flexModel.wType == 'FlexContainer') ? flexNode.childNodes[0].getAttribute("kcontainerID") : flexNode.getAttribute("kcontainerID");
                containerId && $KW.Utils.updateContainerDataInDOM(flexNode, containerId);

                if((flexModel.parent && !$KW.FlexUtils.isFlexWidget(flexModel) && flexModel.wType != 'Form') || (flexModel.wType == 'FlexContainer' && !flexModel.parent)) {
                    var containerModel = flexNode.dataObj && flexNode.dataObj.containerModel;
                    if(containerModel && containerModel.wType == 'CollectionView' && containerModel.layouttype == kony.collectionview.LAYOUT_CUSTOM) {
                        flexModel.finalFrame = {};
                        $KW.FlexLayoutEngine.computeLayoutValues(flexModel, flexNode, containerModel.frame);
                        $KW.FlexLayoutEngine.determineSize($KU.getNodeByModel(containerModel), flexModel, flexNode);
                        var dimensions = $KW.FlexUtils.getWidgetDimensions(flexModel, flexNode);
                        $KW.FlexLayoutEngine.determineX(flexModel, dimensions, flexNode, containerModel.frame);
                        $KW.FlexLayoutEngine.determineY(flexModel, dimensions, flexNode, containerModel.frame);
                        $KW.FlexUtils.setWidgetPosition(flexModel, flexModel.finalFrame, flexNode);
                        flexModel.frame = $KW.FlexLayoutEngine.getWidgetFrame(flexModel, dimensions, flexModel.finalFrame);
                    } else {
                        $KW.FlexUtils.setFlexContainerStyle(flexModel, flexNode);
                        flexModel.frame = $KW.FlexUtils.getWidgetFrame(flexModel, flexNode);
                    }
                    flexModel.dolayout && $KU.executeWidgetEventHandler(flexModel, flexModel.dolayout);
                }
                if(flexModel.wType == 'Form') {
                    flexModel.frame = $KW.FlexUtils.getWidgetFrame(flexModel, flexNode);
                }
                if(flexModel.wType == 'FlexContainer') {
                    var computedStyle = $KU.getComputedStyle(flexNode);
                    if(computedStyle) {
                        flexModel.hBorder = parseInt(computedStyle["border-left-width"], 10) + parseInt(computedStyle["border-right-width"], 10);
                        flexModel.vBorder = parseInt(computedStyle["border-top-width"], 10) + parseInt(computedStyle["border-bottom-width"], 10);
                    }
                    
                    
                }
                this.adjustFlexContainer(flexModel, flexNode);
            }
        },

        keydownEventHandler: function(eventObject, target) {
            var keyCode = eventObject.keyCode;
            if(keyCode == 32 || keyCode == 13) {
                $KW.FlexContainer.eventHandler(eventObject, target);
            }
        },

        eventHandler: function(eventObject, target) {
            var widgetModel = $KU.getModelByNode(target),
            containerId = target.getAttribute("kcontainerID");
            widgetModel = $KW.Utils.getActualWidgetModel(widgetModel);

            $KAR && $KAR.sendRecording(widgetModel, 'click', {'target': target, 'eventType': 'uiAction'});

            spaAPM && spaAPM.sendMsg(widgetModel, 'onclick');
            
            if(containerId) {
                $KW.Utils.updateContainerData(widgetModel, target, true);
            } else {
                var executed = kony.events.executeBoxEvent(widgetModel);
                var tabId = target.getAttribute("ktabid");
                if(!executed && tabId) {
                    $KW.TabPane && $KW.TabPane.executeTabEvent(widgetModel, target, true);
                }
            }
        },

        attachResizeEvent: function(formId, type) {
            var flexContainers = document.querySelectorAll("#" + formId + " div[kwidgettype='" + type + "']");
            for(var i = 0; i < flexContainers.length; i++) {
                var flexModel = $KU.getModelByNode(flexContainers[i]);
                var flexNode = flexContainers[i];
                flexModel.onDrag && new $KW.touch.Drag(flexModel, flexNode, flexNode, '', this.dragEvent, flexNode);
                var children = flexModel.children;
                for(var j = 0; children && j < children.length; j++) {
                    var wModel = flexModel[children[j]];
                    this.attachDragEvent(wModel);
                }
            }
        },

        attachDragEvent: function(wModel) {
            if(wModel.onDrag) {
                var node = $KU.getNodeByModel(wModel);
                node = node.parentNode;
                new $KW.touch.Drag(wModel, node, node, '', this.dragEvent, node);
            }
        },

        dragEvent: function(dragNode, x, y, type) {
            dragNode = dragNode.getAttribute("kwidgettype") ? dragNode : dragNode.childNodes[0];
            var flexModel = $KU.getModelByNode(dragNode);
            flexModel.onDrag && flexModel.onDrag(flexModel, x, y, type);
        },

        executeOnParent: function(flexModel, callback, args) {
            if(!flexModel._konyControllerName)
                return;
            var formModel = $KG["__currentForm"];
            if($KU.checkHeaderFooterTemplate(formModel, flexModel)) {
                var parentModel = formModel;
            } else {
                var widgetModel = $KU.getWidgetModelByID(flexModel.formPathId);
                if(!widgetModel) {
                    kony.web.logger("warn", "widgetModel is not available");
                    return;
                } else {
                    var parentModel = widgetModel;
                    while(parentModel) {
                        parentModel = parentModel.parent;
                        if(parentModel._konyControllerName)
                            break;
                    }
                }
            }
            _kony.mvc.executeInJsContext(parentModel, callback, args);
        },


        addChild: function(boxModel, wArray) {
            var box = $KU.getNodeByModel(boxModel);
            if(box && wArray.length > 0) {
                kony.events.executeActionOnComponent(wArray, "preshow", true);
                $KU.updatei18nProperties(wArray);
                var wrapper = document.createElement("div");
                wrapper.innerHTML = module.appendChildren(boxModel, wArray);

                while(wrapper.children.length > 0) {
                    box.appendChild(wrapper.children[0]);
                }

                $KU.layoutNewWidgets(boxModel, wArray);
                $KW.Utils.initializeNewWidgets(wArray);
                kony.events.executeActionOnComponent(wArray, "postshow", false);
            }
        },

        addChildat: function(boxModel, wArray, index, counter) {
            var box = $KU.getNodeByModel(boxModel);
            if(box) {
                kony.events.executeActionOnComponent(wArray, "preshow", true);
                $KU.updatei18nProperties(wArray);
                var wrapper = document.createElement("div");
                wrapper.innerHTML = module.appendChildren(boxModel, wArray);
                index = index < 0 ? 0 : index;
                if(typeof counter !== 'undefined') {
                    box.insertBefore(wrapper.childNodes[0], box.childNodes[counter]);
                }
                else {
                    box.insertBefore(wrapper.childNodes[0], box.childNodes[index]);
                }

                $KU.layoutNewWidgets(boxModel, wArray);
                $KW.Utils.initializeNewWidgets(wArray);
                kony.events.executeActionOnComponent(wArray, "postshow", false);
            }
        },

        appendChildren: function(boxModel, wArray) {
            var context = new $KW.WidgetGenerationContext(boxModel.pf);
            return $KW.FlexContainer.renderChildren(boxModel, wArray, context);

        },

        
        add: function() {
            var boxobj = arguments[0];

            if(boxobj && "add" in boxobj) {
                var widarray = [].slice.call(arguments, 1);
                boxobj.add(widarray);
            }
        },

        addAt: function(boxModel, widgetref, index) {
            if(widgetref == null) return;
            boxModel && boxModel.addAt(widgetref, index);
        },

        remove: function(boxModel, widgetref) {
            boxModel && boxModel.remove(widgetref);
        },

        removeAt: function(boxModel, index) {
            return boxModel && boxModel.removeAt(index);
        },

        widgets: function(boxModel) {
            return boxModel && boxModel.widgets();
        },

        DOMremove: function(boxModel, widgetref) {
            var box = $KU.getNodeByModel(boxModel);
            if(box && widgetref) {
                for(var i = 0; i < boxModel.children.length; i++) {
                    if(widgetref.id == boxModel.children[i]) {
                        box.removeChild(box.children[i]);
                        break;
                    }
                }
            }
        },

        DOMremoveAll: function(boxModel) {
            var box = $KU.getNodeByModel(boxModel);
            if(box) {
                box.innerHTML = "";
            }
        }
    };


    return module;
}());

$KW.FlexScrollContainer = (function() {
    
    

    var module = {
        initialize: function() {
            kony.events.addEvent("click", "FlexScrollContainer", this.eventHandler);
            kony.events.addEvent("onorientationchange", "FlexScrollContainer", this.orientationHandler);
        },

        initializeView: function(formId) {
            $KW.FlexContainer.attachResizeEvent(formId, "FlexScrollContainer");
            var scrollNodes = document.querySelectorAll("#" + formId + " div[kwidgettype='FlexScrollContainer']");
            $KW.Utils.initializeScrollEvents(scrollNodes);
            $KW.APIUtils.getModelForContentOffset(formId, "FlexScrollContainer");
            setTimeout(function() {
                for(var i = 0; i < scrollNodes.length; i++) {
                    var model = $KU.getModelByNode(scrollNodes[i]);
                    if(model.reverselayoutdirection) {
                        model.scrollToEnd();
                    }
                }
            }, 0);
        },

        
        updateView: function(widgetModel, propertyName, propertyValue, oldPropertyValue) {
            var element = $KU.getNodeByModel(widgetModel);
            if(!element)
                return;
            var scrolldirection = $KW.stringifyScrolldirection[widgetModel.scrolldirection];
            switch(propertyName) {
                case "enableScrolling":
                case "scrollDirection":
                    if(widgetModel.enablescrolling) {
                        if(scrolldirection == "horizontal") {
                            element.style.overflowX = "auto";
                            element.style.overflowY = "hidden";
                        } else if(scrolldirection == "vertical") {
                            element.style.overflowX = "hidden";
                            element.style.overflowY = "auto";
                        } else if(scrolldirection == "both") {
                            element.style.overflowX = "auto";
                            element.style.overflowY = "auto";
                        } else if(scrolldirection == "none") {
                            element.style.overflowX = "hidden";
                            element.style.overflowY = "hidden";
                        }
                    } else {
                        element.style.overflowX = "hidden";
                        element.style.overflowY = "hidden";
                    }
                    break;
                case "scrollDirection":
                    if(widgetModel.wType == 'Form')
                        scrolldirection = "vertical";

                    if(scrolldirection == "horizontal") {
                        element.style.overflowX = "auto";
                        element.style.overflowY = "hidden";
                    } else if(scrolldirection == "vertical") {
                        element.style.overflowX = "hidden";
                        element.style.overflowY = "auto";
                    } else if(scrolldirection == "both") {
                        element.style.overflowX = "auto";
                        element.style.overflowY = "auto";
                    } else if(scrolldirection == "none") {
                        element.style.overflowX = "hidden";
                        element.style.overflowY = "hidden";
                    }
                    break;
                case "onScrollStart":
                    var onscrollstart = widgetModel.onscrollstart;
                    
                    $KU.executeWidgetEventHandler(widgetModel, onscrollstart);
                    break;
                case "onScrollTouchReleased":
                    break;
                case "onScrolling":
                    var onscrolling = widgetModel.onscrolling;
                    
                    $KU.executeWidgetEventHandler(widgetModel, onscrolling);
                    break;
                case "onDecelerationStarted":
                    break;
                case "onScrollEnd":
                    var onscrollend = widgetModel.onscrollend;
                    
                    $KU.executeWidgetEventHandler(widgetModel, onscrollend);
                    break;
                case "contentOffset":
                    module.setContentOffSet(widgetModel, widgetModel.contentOffset, true);
                    break;
            }
        },

        render: function(boxModel, context) {
            var boxStyle = kony.widgets.skins.getMarginSkin(boxModel, context) + kony.widgets.skins.getPaddingSkin(boxModel) + $KW.skins.getBaseStyle(boxModel, context);
            var computedSkin = kony.widgets.skins.getWidgetSkinList(boxModel, context);
            var scrolldirection = kony.widgets.stringifyScrolldirection[boxModel.scrolldirection];
            var style = boxModel.enableScrolling ? ((scrolldirection == "both") ? "overflow-x:auto;overflow-y:auto;" : (scrolldirection == "horizontal" ? "overflow-x:auto;overflow-y:hidden;" : scrolldirection == "vertical" ? "overflow-y:auto;overflow-x:hidden;" : scrolldirection == "none" ? "overflow-x:hidden;overflow-y:hidden;" : "")) : "";

            var htmlString = "<div style='position:relative;" + style + boxStyle + "' class ='" + computedSkin + "'" + kony.widgets.Utils.getBaseHtml(boxModel, context) + " swipeDirection='" + scrolldirection + "'>";
            var wArray = boxModel.widgets();
            if(wArray.length > 0) {
                htmlString += $KW.FlexContainer.renderChildren(boxModel, wArray, context);
            }
            htmlString += "</div>";
            return htmlString;
        },

        forceLayout: function(flexModel, flexNode) {
            $KW.FlexContainer.forceLayout(flexModel, flexNode);
        },

        getContentOffsetMeasured: function(flexModel) {
            var contentOffSet = {
                x: 0,
                y: 0
            };
            var flexNode = $KU.getNodeByModel(flexModel);
            if(flexNode) {
                contentOffSet.x = -flexNode.scrollLeft;
                contentOffSet.y = -flexNode.scrollTop;
            }
            return contentOffSet;
        },

        getContentSizeMeasured: function(flexModel) {
            var flexNode = $KU.getNodeByModel(flexModel);
            var contentSize = {
                width: 0,
                height: 0
            };
            if(flexNode) {
                contentSize.width = flexNode.scrollWidth;
                contentSize.height = flexNode.scrollHeight;
            }
            return contentSize;
        },

        setContentOffSet: function(flexModel, contentOffSet, animate) {
            var flexNode = $KU.getNodeByModel(flexModel);
            if(flexNode) {
                $KW.APIUtils.setfocus(flexModel);
                var offsetX = $KW.FlexUtils.getValueByParentFrame(flexModel, $KW.FlexUtils.getValueAndUnit(flexModel, contentOffSet.x), 'x', flexModel.frame);
                var offsetY = $KW.FlexUtils.getValueByParentFrame(flexModel, $KW.FlexUtils.getValueAndUnit(flexModel, contentOffSet.y), 'y', flexModel.frame);
                flexNode.scrollLeft = offsetX;
                flexNode.scrollTop = offsetY;
            }
        },

        scrollToWidget: function(flexModel, wModel, animate) {
            var flexNode = $KU.getNodeByModel(flexModel);
            if(flexNode) {
                $KW.APIUtils.setfocus(flexModel);
                var wFrame = wModel.frame;
                flexNode.scrollLeft = wFrame.x;
                flexNode.scrollTop = wFrame.y;
            }
        },

        scrollToEnd: function(flexModel, animate) {
            var flexNode = $KU.getNodeByModel(flexModel);
            if(flexNode) {
                $KW.APIUtils.setfocus(flexModel);
                switch(flexModel.scrolldirection) {
                    case kony.flex.SCROLL_HORIZONTAL:
                        flexNode.scrollLeft = flexNode.scrollWidth;
                        break;
                    case kony.flex.SCROLL_VERTICAL:
                        flexNode.scrollTop = flexNode.scrollHeight;
                        break;
                    case kony.flex.SCROLL_BOTH:
                        flexNode.scrollLeft = flexNode.scrollWidth;
                        flexNode.scrollTop = flexNode.scrollHeight;
                        break;
                }
            }
        }
    };


    return module;
}());


$KW.Video = $KW.Audio = $KW.Media = (function() {
    
    

    var module = {
        initializeView: function(formId) {
            if(!$KU.isAndroid)
                return;
            var videos = document.querySelectorAll("#" + formId + " video");
            for(var i = 0; i < videos.length; i++) {
                var video = videos[i];
                kony.events.addEventListener(video, 'click', function(event) {
                    event = event || window.event;
                    if(event.srcElement.getAttribute("kdisabled") == "true") {
                        kony.events.stopPropagation(event);
                        kony.events.preventDefault(event);
                        return;
                    } else
                        event.srcElement.play();
                }, false);
                kony.events.addEventListener(video, 'playing', function(event) {
                    event = event || window.event;
                    event.srcElement.playing = true;
                }, false);
            }
        },

        updateView: function(widgetModel, propertyName, propertyValue, oldPropertyValue) {
            var element = $KU.getNodeByModel(widgetModel);
            if(!element)
                return;

            switch(propertyName) {
                case "source":
                    var srcDiv = this.getSrc(widgetModel);
                    var computedSkin = $KW.skins.getWidgetSkinList(widgetModel, {
                        formID: widgetModel.pf
                    });
                    element.setAttribute("class", computedSkin + srcDiv[1]);
                    element.innerHTML = srcDiv[0];
                    break;
            }
        },

        render: function(mediaModel, context) {
            var computedSkin = $KW.skins.getWidgetSkinList(mediaModel, context);
            var html = $KW.Utils.getBaseHtml(mediaModel, context)
            var tabpane = context.tabpaneID ? (" ktabpaneid=" + context.tabpaneID) : "";
            var autoplay = mediaModel.autoplay ? " autoplay='autoplay'" : "";
            var poster = mediaModel.poster ? (" poster=" + $KU.getImageURL(mediaModel.poster)) : "";
            var style = " style='" + $KW.skins.getMarginSkin(mediaModel, context) + ";" + $KW.skins.getPaddingSkin(mediaModel) + "'";
            var loop = mediaModel.loop ? " loop='loop'" : "";
            
            var controls = (mediaModel.controls || mediaModel.controls == undefined) ? " controls='controls'" : "";
            var heightwidth = mediaModel.heightwidth; 
            if(heightwidth) 
            {
                heightwidth = heightwidth.split(",");
                heightwidth = (heightwidth[1] != "0" ? (" width=" + heightwidth[1] + "px ") : "") + (heightwidth[0] != "0" ? ("height=" + heightwidth[0] + "px ") : "");
            }
            var htmlString = "";

            if(mediaModel.wType == "Video")
                htmlString = "<video" + html + controls + heightwidth + autoplay + poster + loop + tabpane;
            else
                htmlString = "<audio" + html + " controls='controls'" + autoplay + loop + tabpane;

            htmlString += style;
            var src = this.getSrc(mediaModel);
            htmlString += " class = '" + computedSkin + src[1] + "'>";

            if(mediaModel.wType == "Video")
                htmlString += src[0] + (mediaModel.text || "") + "</video>";
            else
                htmlString += src[0] + (mediaModel.text || "") + "</audio>";

            return htmlString;
        },

        

        
        getSrc: function(mediaModel) {
            var notype = false;
            var platform = $KU.getPlatform();
            if(platform.name == "android" && platform.version <= 2.2)
                notype = true;

            var wType = mediaModel.wType.toLowerCase();
            var srcString = skin = "";
            var total = count = 0;
            var source = mediaModel.source;
            if($KU.isArray(source)) {
                for(var i = 1; i < source.length; i++) {
                    total++;
                    if(source[i][2]) {
                        var type = wType + "/" + source[i][1];
                        srcString += "<source src='" + source[i][2] + "'" + (source[i][1] == "mp4" && notype ? "" : " type='" + type + "'") + "/>";
                    } else
                        count++;
                }

            } else {
                for(var key in source) {
                    total++;
                    if(source[key]) {
                        var type = wType + "/" + key;
                        srcString += "<source src='" + source[key] + "'" + (key == "mp4" && notype ? "" : " type='" + type + "'") + "/>";
                    } else
                        count++;
                }
            }

            if(total == count && mediaModel.isvisible)
                skin = " hide";
            return [srcString, skin];
        },

        eventHandler: function(eventObject, target) {},

        play: function(widgetModel) {
            var video = $KU.getNodeByModel(widgetModel);
            if(video) {
                video.currentTime = 0;
                video.play();
            }
        },

        pause: function(widgetModel) {
            var video = $KU.getNodeByModel(widgetModel);
            if(video) {
                video.pause();
            }
        },

        resume: function(widgetModel) {
            var video = $KU.getNodeByModel(widgetModel);
            if(video) {
                video.play();
            }
        },

        stop: function(widgetModel) {
            var video = $KU.getNodeByModel(widgetModel);
            if(video) {
                video.pause();
                video.currentTime = 0;
            }
        },

        isPlaying: function(widgetModel) {
            var video = $KU.getNodeByModel(widgetModel);
            var isPlaying = false;
            if(video) {
                isPlaying = !video.paused && !video.ended;
            }
            return isPlaying;
        },

        getCurrentPosition: function(widgetModel) {
            var video = $KU.getNodeByModel(widgetModel);
            if(video) {
                return video.currentTime;
            }
            return 0;
        },

        getDuration: function(widgetModel) {
            var video = $KU.getNodeByModel(widgetModel);
            if(video) {
                return video.duration;
            }
            return 0;
        },

        getBufferPercentage: function(widgetModel) {
            var video = $KU.getNodeByModel(widgetModel);
            var buffPercentage = 0;
            if(video) {
                var totalDuration = video.duration;
                var bufferDuration = 0;
                for(i = 0; i < video.buffered.length; i++) {
                    bufferDuration = bufferDuration + video.buffered.end(i) - video.buffered.start(i)
                }
                buffPercentage = 100 * bufferDuration / totalDuration
            }
            return buffPercentage;
        },

        seekTo: function(widgetModel, seekTime) {
            var video = $KU.getNodeByModel(widgetModel);
            if(video) {
                video.pause();
                video.currentTime = seekTime;
                video.play();
            }
        }
    };


    return module;
}());
$KI.media = {
    record: function(config) {
        var _audioRecorder = null, _record = null;
        if(arguments.length === 2) {
            config = arguments[1];
        }
        $KU.logExecuting('kony.media.record');
        if(!(navigator.mediaDevices && navigator.mediaDevices.getUserMedia && typeof MediaRecorder != 'undefined')) {
            config.onFailure && config.onFailure('Audio API is not supported in your browser');
        } else {
            _record = {
                startRecording: function() {
                    navigator.mediaDevices.getUserMedia({audio:true}).then(function(stream) {
                        _audioRecorder = new MediaRecorder(stream);
                        _audioRecorder.start();
                        kony.web.logger('info', 'recording audio');
                    }).catch( function(err) {
                        config.onFailure && config.onFailure('Error :' + err);
                    });
                },
                stopRecording: function() {
                    if(_audioRecorder) {
                        _audioRecorder.ondataavailable = function(e) {
                            config.onSuccess && config.onSuccess(URL.createObjectURL(e.data));
                            _audioRecorder = null;
                        }
                        _audioRecorder.stop();
                    } else {
                        config.onFailure && config.onFailure('Failed during stop recording');
                    }
                }
            }
        }
        $KU.logExecutingFinished('kony.media.record');
        return _record;
    }
}


$KW.Calendar = (function() {
    var DD = 'dd',
        MM = 'MM',
        mm = 'mm',
        yyyy = 'yyyy',
        yy = 'yy',
        separator_ = '-',
        seperator = '/',
        cseperator = '/',
        dateformat = 'MM/dd/yyyy',
        calendarDaysValue, calendarMonthsValues, active, activeCalendarPopUp;

    
    var _addClass = function(element, className, skinTypes, config) {

        if(skinTypes && skinTypes.length && skinTypes.indexOf("selected") == -1) {
            if(_hasClass(element, config.gridCellSelectedSkin))
               _removeClass(element,  config.gridCellSelectedSkin);
            if(_hasClass(element, config.gridCellFromDateSkin))
               _removeClass(element,  config.gridCellFromDateSkin);
            if(_hasClass(element, config.gridCellToDateSkin))
               _removeClass(element,  config.gridCellToDateSkin);

        }
        if(!_hasClass(element, className)) {

            element.className = (element.className === '') ? className : element.className + ' ' + className;
        }

    };
    var _convertToDateArray = function(model, dates) {
            var i, tempDate, tempDates = [];
                for(i = 0; i < dates.length; i++) {
                    tempDates[i] = (new Date(dates[i][2], dates[i][1] - 1, dates[i][0])).setHours(0, 0, 0, 0);
                }
            return tempDates;
    };

    var _getselectedDates = function(model) {
        var selecteddate = [];
           if(model.selectiontype) {
              switch(model.selectiontype) {
                case constants.CALENDAR_SELECTION_TYPE_SINGLE_SELECT :
                var d = model.datecomponents;
                    d = new Date(d[2], d[1] - 1, d[0]);
                    d = d.setHours(0, 0, 0, 0);
                    selecteddate.push(d)
                    break;
                case constants.CALENDAR_SELECTION_TYPE_MULTI_SELECT :
                    var s = (model.displayDates && model.displayDates.length) ? model.displayDates : model.selecteddates;
                    selecteddate = _convertToDateArray(model, s);
                    break;
                case constants.CALENDAR_SELECTION_TYPE_RANGE_SELECT :
                    selecteddate = _convertToDateArray(model, model.displayDates);
              }
            }

        return selecteddate;
    };

    var _applySkinsnew = function(model) {
        var holdingDate,commondates=[],commonapi_flag=false, config = model.viewconfig.gridconfig || model.viewconfig.gridConfig || {},
            enablerangeofdates_date = model.enablerangeofdates_Dates,
            dates_setenabled = model.setenabled_dates,
            enablerangeofdates_startDate = model.enablerangeofdates_startDate,
            enablerangeofdates_endDate = model.enablerangeofdates_endDate,
            pickerStyle = _getGridTheme(model.gridTheme),
            specialDates = model.specialDates,commonapi_flag=false,commondates=[],
            selected, element, i, dateCells, date, dates, stateOfthis = 0,
            j, k;
        var _getAPIStateOfDay = function(model, date) {
            var startDate, endDate, stateOfthis = {"API":"","state":0};
                if(dates_setenabled && dates_setenabled.indexOf(date) != -1 && model.setenablestate == 0) {
                    return {"API":"setenabledskin" , "state": 1 };
                }
                else if(dates_setenabled && dates_setenabled.indexOf(date) != -1 && model.setenablestate == 1) {
                    return {"API":"setenabledskin" , "state": 0 };
                }
                if(enablerangeofdates_startDate && enablerangeofdates_endDate) {
                    if(model.enablerangeofdates_state === 0 && (date >= enablerangeofdates_startDate && date <= enablerangeofdates_endDate )
                    || model.enablerangeofdates_state === 1 && (date < enablerangeofdates_startDate || date > enablerangeofdates_endDate ))
                        return {"API":"enablerangeofdates" , "state": 1 };
                    else if(model.enablerangeofdates_state === 1 && (date >= enablerangeofdates_startDate && date <= enablerangeofdates_endDate ))
                        return {"API":"enablerangeofdates" , "state": 0 };
                }

                if(model.validstartdate) {
                    startDate = new Date(model.validstartdate[2], model.validstartdate[1] - 1, model.validstartdate[0]).setHours(0, 0, 0, 0);
                }
                if(model.validenddate) {
                    endDate = new Date(model.validenddate[2], model.validenddate[1] - 1, model.validenddate[0]).setHours(0, 0, 0, 0);
                }
                if((startDate && startDate !== 0) && (endDate && endDate !== 0)) {
                    if(date < startDate || date > endDate) {
                        stateOfthis = {"API":"" , "state": 1 };
                    }
                }
                else if(!startDate && endDate) {
                    if(date > endDate) {
                        stateOfthis = {"API":"" , "state": 1 };
                    }
                }
                else if(!endDate && startDate) {
                    if(date < startDate) {
                        stateOfthis = {"API":"" , "state": 1 };
                    }
                }
            return stateOfthis;
        },
        _getPossibleGridCellSkinTypes = function(datecomp, cell, selecteddate, enablerangeofdates_date,enddate, dates_setenabled, specialDates, setenablestate , enablerangestate) {
            var today = new Date(), skins = [];
                today = today.setHours(0, 0, 0, 0);
            var currentdate = new Date(datecomp[2], datecomp[1] - 1, datecomp[0]);
                currentdate = currentdate.setHours(0, 0, 0, 0);
            if(_hasClass(cell, '-k-w-c-nextMonth') || _hasClass(cell, '-k-w-c-lastMonth')) {
                skins.push("inactive");
                skins.push("prevnext");
                return skins;
            }
            else {
                var setdateskindates = [];
                skins.push("gridcell");
                if(new Date(currentdate).getDay() == 0 || new Date(currentdate).getDay() == 6 ) {
                    skins.push("weekend");
                    if(!config.allowWeekendSelectable) {
                        skins.push("inactive");
                        skins.push("inactiveweekend");
                    }

                }
                if(new Date(currentdate).valueOf() == today.valueOf())
                    skins.push("today");
                if(selecteddate && selecteddate.length && selecteddate.indexOf(currentdate) !== -1)
                    skins.push("selected");
                if(specialDates){
                    for(var k in specialDates) {
                        dates = specialDates[k];
                        if(dates.length) {
                            for(var i =0 ;i < dates.length ; i++){
                                var d = dates[i];
                                    d = new Date(d[2], d[1] - 1, d[0]);
                                    d = d.setHours(0, 0, 0, 0);
                                    setdateskindates.push(d);
                            }
                        }
                    }
                    if(setdateskindates && setdateskindates.length && setdateskindates.indexOf(currentdate) != -1){
                        skins.push("specialDates");
                    }
                }
                var apiState = _getAPIStateOfDay(model, currentdate);

                if(apiState && apiState.state) {
                    skins.push("inactive");
                    if(apiState.API && apiState.API != "")
                        skins.push(apiState.API);

                }
                else if(apiState.API && apiState.API != "")
                    skins.push(apiState.API);
                
            }

            return skins;
        },
        notclickableCell = function(element, skinName, skinTypes) {
            element.setAttribute("kwidgettype", "DisabledCal");
            if(!(skinTypes && skinTypes.indexOf("today") != -1 && skinTypes.indexOf("selected") == -1))
                element.className = skinName;
            element.removeAttribute('kwidgettype');
            element.removeAttribute('k-w-c-hold-day');
        },
        setenabledSkinType = function(date, element, config, finalSkinType) {
            var skin = "";

            if(model.setenablestate == 0 && dates_setenabled && dates_setenabled.length && dates_setenabled.indexOf(date) > -1) {

                skin = model.setenableSkin ? model.setenableSkin : config.gridCellInactiveDaysSkin;
                notclickableCell(element, skin, finalSkinType);
            }
            else if(model.setenablestate == 1 &&  dates_setenabled && dates_setenabled.length && dates_setenabled.indexOf(date) > -1) {
                skin = model.setenableSkin ? model.setenableSkin : config.gridCellSkin;

            }

            return skin;
        },
        enablerangeofdatesskinType = function(date, element, config, finalSkinType) {
            var skin = "";

            if(model.enablerangeofdates_state == 0 && date >= enablerangeofdates_startDate && date <= enablerangeofdates_endDate) {
                skin = model.enablerangeofdatesSkin ? model.enablerangeofdatesSkin : config.gridCellInactiveDaysSkin;
                notclickableCell(element, skin, finalSkinType);
            }
            if(model.enablerangeofdates_state == 1) {
                if(date < enablerangeofdates_startDate || date > enablerangeofdates_endDate) {
                    skin = config.gridCellInactiveDaysSkin;
                    notclickableCell(element, skin, finalSkinType);
                } else {
                    skin = model.enablerangeofdatesSkin ? model.enablerangeofdatesSkin : config.gridCellSkin;

                }
            }
            return skin;
        },
        apilevelSkintype = function(element, date, config, finalSkinType, state){
            var skin = "";

            if(dates_setenabled && dates_setenabled.length && dates_setenabled.indexOf(date) != -1) {
                skin = setenabledSkinType(date,element, config, finalSkinType);
            }
            else if(enablerangeofdates_endDate && enablerangeofdates_startDate) {
                skin = enablerangeofdatesskinType(date, element, config, finalSkinType);
            }
            if(skin == "") {
                if(state == "active") {
                    skin = config.gridCellSkin
                }
                else if(state == "inactive") {
                    skin = config.gridCellInactiveDaysSkin;
                }
            }

        return skin;
        },
        getSpecialDateSkin = function(date, specialDates) {
            var skin = config.gridCellSkin;

            for(var k in specialDates) {
                dates = specialDates[k];
                if(dates.length) {
                    for(var i =0 ;i < dates.length ; i++){
                    var d = dates[i];
                        d = new Date(d[2], d[1] - 1, d[0]);
                        d = d.setHours(0, 0, 0, 0);
                    if(d.valueOf() == date.valueOf())
                        skin = k;
                    }
                }
            }
                    return skin;
        },
        isInactiveweekend = function(date) {
            var day = new Date(date).getDay();

            if((day == 0 || day ==6) && !(config.allowWeekendSelectable)) {
                return true;
            }
            return false;
        },
        getSelectedDateSkinValue = function(date) {
            var skin = config.gridCellSelectedSkin;

            if(module.isRangeCalendar(model)) {
                var selected = _convertToDateArray(model, model.displayDates);
                if(selected && selected.length) {
                    var holdingDate = cells[c].getAttribute('k-w-c-hold-day').split(',');
                        holdingDate = new Date(holdingDate[2], holdingDate[1] - 1, holdingDate[0]);
                    var selectionIndex = selected.indexOf(holdingDate.setHours(0, 0, 0, 0));
                    if(selectionIndex == 0) {
                        skin = config.gridCellFromDateSkin;
                    }
                    else if(selectionIndex == selected.length - 1) {
                        skin = config.gridCellToDateSkin;
                    }
                }
            }
            return skin;

        },
        getFinalSkin = function(finalSkinType, date) {
            var skin = "";

            switch(finalSkinType) {
                case "gridcell":
                    skin = (skinTypes.indexOf("setenabledskin") != -1 || skinTypes.indexOf("enablerangeofdates") != -1) ? apilevelSkintype(cells[c], date, config, skinTypes,"active") : config.gridCellSkin;
                    break;
                case "weekend":
                    skin = config.gridCellWeekendSkin;
                    break;
                case "today":
                    skin = config.gridCellTodaySkin;
                    break;
                case "selected":
                    skin = getSelectedDateSkinValue(date);
                    break;
                case "inactive":
                    skin = (skinTypes.indexOf("setenabledskin") != -1 || skinTypes.indexOf("enablerangeofdates") != -1) ? apilevelSkintype(cells[c], date, config, skinTypes,"inactive") : config.gridCellInactiveDaysSkin;
                    break;
                case "specialDates":
                    skin = getSpecialDateSkin(date, specialDates);
                    break;
            }
            return skin;
        };

        var cells = document.querySelectorAll('div.kony-w-c-actualDates > div.-kony-w-c-table > div.-kony-w-c-row > div[w-type="Calendar"]');
        var config = model.viewconfig.gridconfig || model.viewconfig.gridConfig || {};
        var gridConfig = null, c = 0, clen = cells.length, skin = '',
            skinPriorityList = model.skinprioritylist;
            s = 0, slen = 0, skinTypes = null, finalSkinType = '';
        var selecteddate = _getselectedDates(model);

            for(c=0; c<clen; c++) {
                var datecomp = cells[c].getAttribute('k-w-c-date-retrieve').split(',');
                var date = new Date(datecomp[2], datecomp[1] - 1, datecomp[0]);
                    date = date.setHours(0, 0, 0, 0);
                skinTypes = _getPossibleGridCellSkinTypes(datecomp,cells[c],selecteddate, enablerangeofdates_startDate, enablerangeofdates_endDate, dates_setenabled,specialDates); 
                slen = skinPriorityList.length;
                var t = new Date();
                    t = t.setHours(0, 0, 0, 0);
                for(s=0; s<slen; s++) {
                    if(skinTypes.indexOf(skinPriorityList[s]) >= 0) {
                        finalSkinType = skinPriorityList[s];
                        break;
                    }
                }
                if(finalSkinType) {
                    skin = skinTypes.indexOf("prevnext") == -1 ? getFinalSkin(finalSkinType, date) : config.gridCellInactiveDaysSkin;
                    if(skin === "") {
                        var ind = skinPriorityList.indexOf(finalSkinType);
                        for(var s=(ind+1); s<slen; s++) {
                            if(skinTypes.indexOf(skinPriorityList[s]) >= 0 && getFinalSkin(skinPriorityList[s], date) !== "") {
                                skin = getFinalSkin(skinPriorityList[s], date);
                                break;
                            }
                        }

                    }
                    if(skinTypes.indexOf("today") != -1 && skinTypes.indexOf("selected") == -1)
                        skin =config.gridCellTodaySkin;
                    _addClass(cells[c], skin, skinTypes, config);
                }
            }
    };

    var _applySkins = function(model) {
        var holdingDate, config = model.viewconfig.gridconfig || model.viewconfig.gridConfig || {},
            datesAll = model.datesGroupSimplified,
            pickerStyle = _getGridTheme(model.gridTheme),
            specialDates = model.specialDates,
            selected, element, i, dateCells, date, dates, stateOfthis = 0,
            j, k, _addClassToCell = function(element, selectedDate, holdingDate, config, selectionType) {
                var currentDate = new Date(),
                    indexOfCell = element.getAttribute('weekday') * 1,
                    selectionIndex, isRangeCalendar = (selectionType == constants.CALENDAR_SELECTION_TYPE_RANGE_SELECT) ? true : false;
                if(selectedDate) {
                    selectionIndex = selectedDate.indexOf(holdingDate.setHours(0, 0, 0, 0));
                }
                _removeSelectedSkins(element, config, isRangeCalendar);
                if(selectionIndex > -1) {
                    if(pickerStyle == kony.calendar.MODERN) {
                        if(holdingDate.setHours(0, 0, 0, 0) == currentDate.setHours(0, 0, 0, 0)) {
                            _addClass(element, config.gridCellSelectedTodaySkin);
                        } else {
                            _addClass(element, config.gridCellSelectedSkin);
                        }
                    } else {
                        _addClass(element, config.gridCellSelectedSkin);
                    }
                    if(selectionType == constants.CALENDAR_SELECTION_TYPE_RANGE_SELECT) {
                        if(selectionIndex == 0) {
                            _addClass(element, config.gridCellFromDateSkin);
                        } else if(selectionIndex == selectedDate.length - 1) {
                            _addClass(element, config.gridCellToDateSkin);
                        }
                    }
                } else if(holdingDate.setHours(0, 0, 0, 0) == currentDate.setHours(0, 0, 0, 0)) {
                    _addClass(element, config.gridCellTodaySkin);
                } else if(indexOfCell == 0 || indexOfCell == 6) { 
                    _addClass(element, config.gridCellWeekendSkin);
                } else {
                    _addClass(element, config.gridCellSkin);
                }
            },
            _convertToDateArray = function(model, dates) {
                var i, tempDate, tempDates = [];
                for(i = 0; i < dates.length; i++) {
                    tempDates[i] = (new Date(dates[i][2], dates[i][1] - 1, dates[i][0])).setHours(0, 0, 0, 0);
                }
                return tempDates;
            },
            _getStateOfDay = function(model, date) {
                var startDate, endDate, stateOfthis = 0;
                if(model.validstartdate) {
                    startDate = new Date(model.validstartdate[2], model.validstartdate[1] - 1, model.validstartdate[0]).setHours(0, 0, 0, 0);
                }
                if(model.validenddate) {
                    endDate = new Date(model.validenddate[2], model.validenddate[1] - 1, model.validenddate[0]).setHours(0, 0, 0, 0);
                }

                if((startDate && startDate !== 0) && (endDate && endDate !== 0)) {
                    if(date < startDate || date > endDate) {
                        stateOfthis = 1;
                    }
                } else if(!startDate && endDate) {
                    if(date > endDate) {
                        stateOfthis = 1;
                    }
                } else if(!endDate && startDate) {
                    if(date < startDate) {
                        stateOfthis = 1;
                    }
                }
                return stateOfthis;
            },
            _removeSelectedSkins = function(element, config, isRangeCalendar) {
                _removeClass(element, config.gridCellSkin);
                _removeClass(element, config.gridCellSelectedSkin);
                _removeClass(element, config.gridCellWeekendSkin);
                pickerStyle == kony.calendar.MODERN && _removeClass(element, config.gridCellSelectedTodaySkin);
                if(isRangeCalendar) {
                    _removeClass(element, config.gridCellFromDateSkin);
                    _removeClass(element, config.gridCellToDateSkin);
                }
            },
            _setRowSkin = function(skinName) {
                element.setAttribute("kwidgettype", "DisabledCal");
                element.className = skinName;
                element.removeAttribute('kwidgettype');
                element.removeAttribute('k-w-c-hold-day');
            };
        dateCells = document.querySelectorAll('#' + module.active + ' [k-w-c-hold-day]');
        if(module.isMultiRangeCalendar(model)) {
            selected = _convertToDateArray(model, model.displayDates);
        } else {
            if(model.day != 0) {
                selected = [(new Date(model.year, model.month - 1, model.day)).setHours(0, 0, 0, 0)];
            }
        }
        for(i = 0; i < dateCells.length; i++) {
            holdingDate = dateCells[i].getAttribute('k-w-c-hold-day').split(',');
            element = dateCells[i];
            holdingDate = new Date(holdingDate[2], holdingDate[1] - 1, holdingDate[0]);
            _addClassToCell(element, selected, holdingDate, config, model.selectiontype);
            date = holdingDate.setHours(0, 0, 0, 0);
            stateOfthis = _getStateOfDay(model, date);
            if(stateOfthis == 1) {
                _setRowSkin(config.gridCellInactiveDaysSkin);
            }
            if(datesAll) { 
                if(model.datesState == 0 && datesAll.length > 0 && datesAll.indexOf(date) > -1) {
                    _setRowSkin(config.gridCellInactiveDaysSkin);
                }
                if(model.datesState == 1 && datesAll.length > 0) {
                    if(datesAll.indexOf(date) <= -1) {
                        stateOfthis = 1;
                        _setRowSkin(config.gridCellInactiveDaysSkin);
                    } else {
                        _removeClass(element, config.gridCellWeekendSkin);
                        _removeClass(element, config.gridCellSkin);
                        if(!_hasClass(element, config.gridCellSelectedSkin) &&
                            !_hasClass(element, config.gridCellTodaySkin) &&
                            (pickerStyle != kony.calendar.MODERN || !_hasClass(element, config.gridCellSelectedTodaySkin))) {
                            _addClass(element, model.datesGroupSkin);
                        }
                    }
                }
            }
            
            if(specialDates) { 
                date = element.getAttribute('k-w-c-date-retrieve').split(',');
                for(k in specialDates) {
                    dates = model.specialDates[k];
                    if(dates) {
                        for(j = 0; j < dates.length; j++) {
                            if(dates[j]) {
                                dateNN = new Date(dates[j][2], dates[j][1] - 1, dates[j][0]).setHours(0, 0, 0, 0);
                                if(new Date(date[2], date[1] - 1, date[0]).setHours(0, 0, 0, 0) == dateNN) {
                                    _removeClass(element, config.gridCellWeekendSkin);
                                    _removeClass(element, config.gridCellSkin);
                                    _removeClass(element, model.datesGroupSkin);
                                    if(!_hasClass(element, config.gridCellSelectedSkin) &&
                                        !_hasClass(element, config.gridCellTodaySkin) &&
                                        (pickerStyle != kony.calendar.MODERN || !_hasClass(element, config.gridCellSelectedTodaySkin))) {
                                        _addClass(element, k);
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    };


    var _between = function(from, to) {
        var addDays = function(inpD, days) {
                var date = new Date(inpD.valueOf());
                date.setDate(date.getDate() + days);
                return date;
            },
            dateArray = new Array(),
            currentDate = from;
            currentDate = new Date(currentDate).setHours(0, 0, 0, 0);
        while(currentDate.valueOf() <= to.valueOf()) {
            dateArray.push(new Date(currentDate).setHours(0, 0, 0, 0));
            currentDate = addDays(currentDate, 1);
        }
        return dateArray;
    };
    var _chunks = function(array, size) {
        var results = [];
        while(array.length) {
            results.push(array.splice(0, size));
        }
        return results;
    };
    
    var _convertToModelDate = function(date, dateFormat) {
        var formattedDateArray = null,
            dateArray = null,
            modelDate = new Array(),
            dateObj = {},
            dayIndex = 0 
            ,
            monthIndex = 1,
            yearValue;

        if(dateFormat != null && date) {

            formattedDateArray = dateFormat.split(seperator);
            if(date instanceof Array) {
                dateArray = date;
            } else {
                dateArray = date.split(seperator);
            }
            yearValue = dateArray[2];
            if(formattedDateArray[0] !== "dd") {
                monthIndex = 0;
                dayIndex = 1;
                if(formattedDateArray[2] !== "yyyy" || formattedDateArray[2].length > 3) {
                    
                    yearValue = dateArray[2].substring(2, 4);
                }
            }

            modelDate[dayIndex] = dateArray[0];
            dateObj.day = dateArray[0];

            modelDate[monthIndex] = dateArray[1];
            dateObj.month = dateArray[1];

            modelDate[2] = yearValue;
            dateObj.year = dateArray[2];
        }

        dateObj.date = modelDate;
        dateObj.dateText = modelDate[0] + seperator + modelDate[1] + seperator + modelDate[2];
        dateObj.selectdate = dateObj.month + seperator + dateObj.day + seperator + dateObj.year; 
        dateObj.pagedate = dateObj.month + seperator + dateObj.year; 

        return dateObj;
    };
    var _dateFormatter = function(format, date, check, inputYear) {
        var trim = function(str) {
                return str.replace(/ +(?= )/g, '').replace(/^\s+|\s+$/g, '').replace(/[^a-zA-Z0-9]/g, '_').replace(/_+(?=_)/g, '').split('_');
            },
            months = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'],
            monthsS = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'],
            days = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'],
            DayNames = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'],
            day, month, dummyDate, dateObj, dateObject, ob, year, obj = {},
            fmt, mm, mmm, mmmm, yy, yyyy, d, dd, ddd, dddd, doo, i;
        if(check && format) {
            check = trim(check);
            fmt = trim(format.toLowerCase());
            if(fmt.length != check.length) {
                return false;
            }
            for(m = 0, n = fmt.length; m < n; m++) {
                obj[fmt[m]] = check[m];
            }
            for(i in obj) {
                if(obj.hasOwnProperty(i)) {
                    switch(i) {
                        case "mmm":
                            month = monthsS.indexOf(obj[i]) + 1;
                            if(month == 0) return false;
                            break;
                        case "mmmm":
                            month = months.indexOf(obj[i]) + 1;
                            if(month == 0) return false;
                            break;
                        case "mm":
                            month = obj[i] * 1;
                            if(month < 1 || month > 12) return false;
                            break;
                        case "dd":
                        case "d":
                            day = obj[i] * 1;
                            if(day <= 0) return false;
                            break;
                        case "do":
                            day = parseInt(obj[i], 10);
                            if(day <= 0) return false;
                            break;
                        case "yy":
                        case "yyyy":
                            if(obj[i] != "") {
                                year = ("" + obj[i]).length > 2 ? (obj[i] * 1) : (obj[i] * 1 + ((Math.floor(inputYear / 100) * 100) || 2000));
                            } else {
                                year = ("" + obj[i]).length > 2 ? (obj[i] * 1) : (obj[i] * 1 + (new Date().getFullYear()));
                            }
                            if(year > 2099 || year < 1900) return false;
                            break;
                    }
                }
            }
            dummyDate = 1;
            dateObject = new Date(year, month - 1, day || dummyDate);
            if(Object.prototype.toString.call(dateObject) === "[object Date]") {
                if((dateObject.getFullYear() == year) && (dateObject.getMonth() + 1 == month) && (dateObject.getDate() == (day || dummyDate))) {
                    date = [day || dummyDate, month, year];
                } else {
                    return false;
                }
            }
        } else if(date) {
            try {
                for(ob = 0; ob < 3; ob++) {
                    date[ob] = +date[ob];
                }
            } catch(e) {
                kony.web.logger("error", e);
            }
        }

        if(!format || !date) return false;
        format = '' + format.toLowerCase().replace(/ +(?= )/g, '').replace(/^\s+|\s+$/g, '');
        dateObj = new Date(date[2], date[1] - 1, date[0]);
        mm = date[1] <= 9 ? "0" + date[1].toString() : date[1];
        mmm = monthsS[date[1] - 1];
        mmmm = months[date[1] - 1];
        yy = (date[2] + "").substring(2, 4);
        yyyy = date[2];
        dd = (date[0] >= 1 && date[0] < 10 ? "0" + date[0].toString() : date[0]);
        d = date[0];
        ddd = days[dateObj.getDay()];
        dddd = DayNames[dateObj.getDay()];
        doo = date[0] + ((date[0] <= 20) && date[0] >= 10 ? "th" : ["st", "nd", "rd"][(date[0] % 10) - 1] || "th");
        return {
            date: date,
            string: format.replace('dddd', dddd).replace('mmmm', mmmm).replace('mmm', mmm).replace('mm', mm).replace('ddd', ddd).replace('dd', dd).replace('d', d).replace('yyyy', yyyy).replace('yy', yy).replace('do', doo)
        }
    };
    var _dayTextAlignmentInCell = function(value) {
        
        var style = {};
        value = value.toLowerCase().split('_');
        style["vertical-align"] = (value[2] && value[2] == "center" ? "middle" : value[2]) || "middle";
        style["text-align"] = value[3] || "center";
        return style;
    };
    var _dismissCalendar = function() {
        module.destroyCalendar(1);
    };
    var _eventDateSelectedMultiSelect = function(calendarModel, target, result, applyLink) {
        var index, selectedDate;
        if(result != false) {
            selectedDate = module.setTimeInDateComponents([result.date.slice(0)])[0];
            index = $KU.inArray(calendarModel.displayDates, selectedDate);
            if(index[0]) {
                calendarModel.displayDates.splice(index[1], 1);
            } else {
                calendarModel.displayDates.push(selectedDate);
            }
            if(calendarModel.displayDates.length > 0) {
                applyLink.style.visibility = 'visible';
            } else {
                applyLink.style.visibility = 'hidden';
            }
            if(kony.application.getApplicationBehavior("newCalendarskinApifeature"))
                _applySkinsnew(calendarModel);
            else
                _applySkins(calendarModel);
        }
    };
    var _eventDateSelectedRangeSelect = function(calendarModel, target, result, applyLink) {
        var datesLength, tempDateObj, index, selectedDate;
        if(result != false) {
            selectedDate = module.setTimeInDateComponents([result.date.slice(0)])[0];
            datesLength = calendarModel.displayDates.length;
            index = $KU.inArray(calendarModel.displayDates, selectedDate);
            if(datesLength == 1 && !index[0]) {
                calendarModel.displayDates = _getDatesInRange(calendarModel, [calendarModel.displayDates[0], selectedDate]);
                applyLink.style.visibility = 'visible';
            } else {
                calendarModel.displayDates = [selectedDate];
                applyLink.style.visibility = 'hidden';
            }

            if(kony.application.getApplicationBehavior("newCalendarskinApifeature"))
                _applySkinsnew(calendarModel);
            else
                _applySkins(calendarModel);
        }
    };
    var _eventDateSelectedSingleSelect = function(calendarModel, target, result) {
        var calendarElement = module.activeCalendarNode,
            calendarInputField, a11yCalendarUpdate, currentDate = new Date(),
            formElement, calenEventref, containerID = calendarElement.getAttribute("kcontainerID");
        calendarElement.className = calendarElement.className.replace('konyplaceholder', "");
        if(result != false) {
            calendarModel.dateComponents = result.date;
            if(calendarElement) {
                calendarInputField = _getCalInputNode(calendarElement);
                calendarInputField.value = result.string;
                $KU.removeClassName(calendarInputField, 'konyplaceholder');
            }
        }
        if(containerID) {
            calendarModel.datecomponents = calendarModel.date = result.date.slice(0, 3);
        }

        $KAR && $KAR.sendRecording(calendarModel, 'selectDate', {'selection': result.date.slice(0, 3), 'target': calendarElement, 'eventType': 'uiAction'});
        calendarModel._startG = [0, calendarModel.datecomponents[1], calendarModel.datecomponents[2]];
        calendarModel.month = calendarModel.datecomponents[1];
        calendarModel.day = calendarModel.datecomponents[0];
        calendarModel.year = calendarModel.datecomponents[2];
        calendarModel.minutes = currentDate.getMinutes();
        calendarModel.hour = currentDate.getHours();
        calendarModel.seconds = currentDate.getSeconds();
        spaAPM && spaAPM.sendMsg(calendarModel, 'onselection');
        if(calendarModel.accessibilityconfig) {
            a11yCalendarUpdate = calendarModel.accessibilityconfig.a11yLabel ? calendarModel.accessibilityconfig.a11yLabel : "";
            a11yCalendarUpdate += ' ' + calendarModel.date;
        } else {
            a11yCalendarUpdate = "Calendar " + calendarModel.date;
        }
        calendarElement.setAttribute('aria-label', a11yCalendarUpdate);
        formElement = document.getElementById(calendarModel.pf);
        if(formElement) {
            formElement.setAttribute('aria-hidden', false);
        }
        module.destroyCalendar(undefined, calendarElement.id);
        calenEventref = $KU.returnEventReference(calendarModel.onselection);
        $KU.callTargetEventHandler(calendarModel, calendarElement, 'onselection');
        calenEventref && $KU.onEventHandler(calendarModel);
        calendarElement.focus();
    };
    var _eventHandler = function(eventObject, target) {
        var maxYearLimit = 2099,
            minYearLimit = 1900,
            date = {},
            series, flag, calendarId, calendarModel, calendarNode, containerId, config, endDate, startDate, title, temp, closeLink = document.getElementById('calendar-close-link'),
            applyLink = document.getElementById('calendar-apply-link'),
            titleOnPopUpVisibility = document.getElementById('-k-w-c-cal-title'),
            calendarConfig, _getCalendarRootNode = function(targetNode) {
                if(targetNode.tagName === 'INPUT' || targetNode.tagName === 'IMG') {
                    targetNode = targetNode.parentNode;
                }
                return targetNode;
            };

        if(!module.activeCalendarNode) {
            module.activeCalendarNode = _getCalendarRootNode(target);
        }
        calendarNode = module.activeCalendarNode;
        if(closeLink != null || closeLink != undefined) {
            closeLink.style.visibility = 'visible';
        }
        if(titleOnPopUpVisibility) {
            titleOnPopUpVisibility.style.visibility = 'visible';
        }
        calendarId = module.activeCalendarNode.getAttribute("id");
        containerId = module.activeCalendarNode.getAttribute("kcontainerid");
        calendarModel = _getCalendarModelFormCalendarNode(module.activeCalendarNode, containerId);
        title = calendarModel.title;
        if(!calendarModel.viewconfig) {
            calendarModel.viewconfig = {
                gridconfig: {}
            };
        }
        startDate = calendarModel.validstartdate;
        endDate = calendarModel.validenddate;
        calendarConfig = calendarModel.viewconfig.gridconfig || calendarModel.viewconfig.gridConfig || {};

        if(containerId) {
            _updateModelByContainerData(calendarModel, target, calendarId, containerId);
            if(!module.isMultiRangeCalendar(calendarModel) &&
                !calendarModel.datecomponents) {
                _setCurrentDate(calendarModel);
            }
        }

        if(!calendarModel) return;
        if(target.className.indexOf('-kony-w-c-yemo') > -1) {
            _eventHandlerSaveCurrentSelection(calendarModel, target);
            return _eventHandlerYemoSelected(calendarModel, target, closeLink, titleOnPopUpVisibility);
        } else if(target.className.indexOf('-kony-w-c-next-nav') > -1) {
            return _eventHandlerGoToNextMonth(calendarModel, target, maxYearLimit);
        } else if(target.className.indexOf('-kony-w-c-prev-nav') > -1) {
            return _eventHandlerGoToPreviousMonth(calendarModel, target, minYearLimit);
        } else if(target.getAttribute('k-w-c-hold-day')) {
            return _eventHandlerSelectedHoldDay(calendarModel, target, applyLink);
        } else if(target.className.indexOf('-kony-w-c-navigator-month') > -1) {
            return _eventHandlerMonthSelected(calendarModel, target, closeLink, titleOnPopUpVisibility);
        } else if(target.className.indexOf('-kony-w-c-navigator-year') > -1) {
            return _eventHandlerYearSelected(target, closeLink, titleOnPopUpVisibility);
        } else if(target.className.indexOf("-kony-w-c-cancel-nav") > -1) {
            return _eventHandlerCancelSelected(target, closeLink, titleOnPopUpVisibility);
        } else if(target.className.indexOf(calendarConfig.doneButtonSkin) > -1) {
            return _eventHandlerApplySelected(calendarModel, target);
        } else if(target.className.indexOf("-kony-w-c-go-nav") > -1) {
            return _eventHandlerOkSelected(calendarModel, closeLink, titleOnPopUpVisibility);
        } else if(target.className.indexOf("-kony-w-c-left-ym-p") > -1) {
            return _eventHandlerYearLeftArrowSelected(closeLink, titleOnPopUpVisibility, minYearLimit);
        } else if(target.className.indexOf("-kony-w-c-right-ym-p") > -1) {
            return _eventHandlerYearRightArrowSelected(closeLink, titleOnPopUpVisibility, maxYearLimit);
        } else if(target.className.indexOf(calendarConfig.cancelButtonSkin) > -1) {
            return _eventHandlerCloseSelected(calendarModel);
        } else if(calendarId === calendarModel.id) {
            return false; 
        }
        _reAssignData(calendarModel); 
        if(module.isMultiRangeCalendar(calendarModel)) {
            temp = calendarModel.selectedDates || [];
            if(temp.length > 0) {
                date = {
                    "yyyy": temp[0][2],
                    "mm": temp[0][1]
                };
                if(calendarModel.selectiontype == constants.CALENDAR_SELECTION_TYPE_MULTI_SELECT) {
                    calendarModel.displayDates = temp.slice(0);
                } else {
                    calendarModel.displayDates = _getDatesInRange(calendarModel, temp);
                }
            } else {
                temp = new Date();
                date.yyyy = temp.getFullYear();
                date.mm = temp.getMonth() + 1;
                calendarModel.displayDates = [];
            }
            if(date) {
                series = _series(date.yyyy, date.mm, calendarModel.noOfMonths);
                flag = true;
            }

        }
        module.destroyCalendar(null, null, target);
        module.activeCalendarNode = calendarNode;
        _show(calendarModel, target, series, flag);
        if(calendarModel.displayDates && calendarModel.displayDates.length > 0) {
            applyLink = document.getElementById('calendar-apply-link')
            applyLink.style.visibility = 'visible';
        }
        _eventHandlerSetFocus(target);
    };
    var _eventHandlerApplySelected = function(calendarModel, target, titleOnPopUpVisibility) {
        var calendarElement = module.activeCalendarNode,
            formElement, a11yCalendarUpdate, containerID = calendarElement.getAttribute("kcontainerID"),
            displayDates = calendarModel.displayDates,
            formattedDate = "",
            formElement, a11yCalendarUpdate, calInput;
        if(calendarModel.selectiontype == constants.CALENDAR_SELECTION_TYPE_MULTI_SELECT) {
            calendarModel.selectedDates = displayDates.length > 0 ? displayDates.slice(0) : [];
        } else if(calendarModel.selectiontype == constants.CALENDAR_SELECTION_TYPE_RANGE_SELECT) {
            if(displayDates.length >= 2) {
                calendarModel.selectedDates = [
                    displayDates[0],
                    displayDates[displayDates.length - 1]
                ];
            } else {
                if(kony.application.getApplicationBehavior("newCalendarskinApifeature")) {
                    calendarModel.selectedDates = calendarModel.selectedDates;

                }
                else
                   calendarModel.selectedDates = [];
            }
        }
        calendarModel.displayDates = [];
        if(containerID) {
            calendarModel.selecteddates = module.setTimeInDateComponents(calendarModel.selectedDates);
        }
        formattedDate = _getDisplayDate(calendarModel);
        calInput = _getCalInputNode(calendarElement);
        calInput.value = formattedDate;
        calendarModel.formatteddate = formattedDate;
        if(calendarModel.accessibilityconfig) {
            a11yCalendarUpdate = calendarModel.accessibilityconfig.a11yLabel ? calendarModel.accessibilityconfig.a11yLabel : "";
            a11yCalendarUpdate += ' ' + formattedDate;
        } else {
            a11yCalendarUpdate = "Calendar " + formattedDate;
        }
        calendarElement.setAttribute('aria-label', a11yCalendarUpdate);
        formElement = document.getElementById(calendarModel.pf);
        if(formElement) {
            formElement.setAttribute('aria-hidden', false);
        }
        spaAPM && spaAPM.sendMsg(calendarModel, 'onselection');
        module.destroyCalendar(undefined, calendarElement.id);
        calenEventref = $KU.returnEventReference(calendarModel.onselection);
        $KU.callTargetEventHandler(calendarModel, calendarElement, 'onselection');
        calenEventref && $KU.onEventHandler(calendarModel);
        calendarElement.focus();
    };
    var _eventHandlerCancelSelected = function(target, closeLink, titleOnPopUpVisibility) {
        var calID = module.activeCalendarNode.getAttribute('id'),
            monthElement = document.querySelector("#" + calID + "-k-w-c-datepicker .-kony-w-c-navigator-month-selected"),
            yearElement = document.querySelector("#" + calID + "-k-w-c-datepicker .-kony-w-c-navigator-year-selected"),
            selym, element;

        monthElement && _removeClass(monthElement, '-kony-w-c-navigator-month-selected'); 
        yearElement && _removeClass(yearElement, '-kony-w-c-navigator-year-selected'); 
        if(monthElement || yearElement) {
            closeLink.style.visibility = "hidden";
            if(titleOnPopUpVisibility) {
                titleOnPopUpVisibility.style.visibility = 'hidden';
            }
            selym = document.querySelectorAll("#" + calID + "-k-w-c-datepicker .-k-w-c-nav-selected-ym")[0];
            selym.innerHTML = "";
        } else {
            element = document.getElementById(calID + "-k-w-c-navigator-scrim");
            element.parentNode.removeChild(element);
            _removeTabIndexs();
            if(document.activeElement) {
                document.activeElement.blur();
            }
            document.querySelectorAll('.-kony-w-c-popup-container')[0].setAttribute('aria-hidden', false);
            _eventHandlerSetFocus(undefined, true);
        }
        return false;
    };
    var _eventHandlerCloseSelected = function(calendarModel) {
        var targetCalendarId = module.activeCalendarNode.getAttribute('id'),
            element = document.getElementById(targetCalendarId + "-k-w-c-datepicker"),
            calendarElement = module.activeCalendarNode,
            formElement;
        if(calendarElement) {
            calendarElement = _getCalInputNode(calendarElement);
            if(calendarElement.value == "") {
                module.clear(calendarModel);
            }
        }
        element.parentNode.removeChild(element);
        formElement = document.getElementById(calendarModel.pf);
        if(formElement != null) {
            formElement.setAttribute('aria-hidden', false);
        }
        module.destroyCalendar(undefined, calendarElement.id);
        calendarModel.displayDates = [];
        return;
    };
    var _eventHandlerGoToNextMonth = function(calendarModel, target, maxYearLimit) {
        var activeDP = document.getElementById(module.activeCalendarNode.getAttribute('id') + "-k-w-c-datepicker"),
            div = document.querySelectorAll("#" + activeDP.id + ' .-kony-w-c-popup-container')[0],
            month = div.getAttribute('month'),
            year = div.getAttribute('year'),
            series;
        if(Number(year) < maxYearLimit) {
            series = _series(year, month, (calendarModel.noofmonths || 1) * 1 + 1);
            series.splice(0, 1);
        } else if(Number(year) == maxYearLimit) {
            if(Number(month) < 12) {
                series = _series(year, month, (calendarModel.noofmonths || 1) * 1 + 1);
                series.splice(0, 1);
            } else {
                return;
            }
        }
        _show(calendarModel, module.activeCalendarNode, series);
        _eventHandlerSetFocus(module.activeCalendarNode);
        return;
    };
    var _eventHandlerGoToPreviousMonth = function(calendarModel, target, minYearLimit) {
        var activeDP = document.getElementById(module.activeCalendarNode.getAttribute('id') + "-k-w-c-datepicker"),
            div = document.querySelectorAll("#" + activeDP.id + ' .-kony-w-c-popup-container')[0],
            month = div.getAttribute('month'),
            year = div.getAttribute('year'),
            series;
        if(month == 1) {
            month = 12;
            year = year - 1;
        } else {
            month = month - 1;
        }
        if(Number(year) > minYearLimit) {
            series = _series(year, month, (calendarModel.noofmonths || 1));
        } else if(Number(year) == minYearLimit) {
            if(Number(month) > 0) {
                series = _series(year, month, (calendarModel.noofmonths || 1));
            }
        } else {
            return;
        }
        _show(calendarModel, module.activeCalendarNode, series);
        _eventHandlerSetFocus(module.activeCalendarNode);
        return;
    };
    var _eventHandlerImgIcon = function(eventObject, targetWidget) {
        var containerId = targetWidget.getAttribute("kcontainerid"), widgetModel = _getCalendarModelFormCalendarNode(targetWidget, containerId);
        if(widgetModel && widgetModel.wType === "Calendar") {
            if(eventObject.keyCode === 13 || eventObject.keyCode === 32) {
                module.open(widgetModel);
            }
        }
    }
    var _eventHandlerMonthSelected = function(calendarModel, target, closeLink, titleOnPopUpVisibility) {
        var calID = module.activeCalendarNode.getAttribute('id'),
            elements = document.querySelectorAll("#" + calID + "-k-w-c-datepicker  .-kony-w-c-navigator-month-selected"),
            selectedMnth, selectedym, selectedYear, year, month, i;
        closeLink.style.visibility = "hidden";
        if(titleOnPopUpVisibility) {
            titleOnPopUpVisibility.style.visibility = 'hidden';
        }
        for(i = 0; i < elements.length; i++) {
            if(elements[i] != target) {
                _removeClass(elements[i], '-kony-w-c-navigator-month-selected');
                _addClass(elements[i], '-kony-w-c-navigator-month');
            }
        }
        _addClass(target, '-kony-w-c-navigator-month-selected');
        selectedym = document.querySelectorAll("#" + calID + "-k-w-c-datepicker .-k-w-c-nav-selected-ym")[0];
        selectedYear = document.querySelectorAll("#" + calID + "-k-w-c-datepicker .-kony-w-c-navigator-year-selected")[0];
        if(selectedYear) {
            year = selectedYear.getAttribute('k-w-c-hold') * 1;
        }
        selectedMnth = document.querySelectorAll("#" + calID + "-k-w-c-datepicker  .-kony-w-c-navigator-month-selected")[0];
        if(selectedMnth) {
            month = calendarMonthsValues[(selectedMnth.getAttribute('k-w-c-hold') * 1) - 1];
        }
        selectedym.innerHTML = (year || "") + " " + (month || "");
        return false;
    };
    var _eventHandlerOkSelected = function(calendarModel, closeLink, titleOnPopUpVisibility) {
        var calID = module.activeCalendarNode.getAttribute('id'),
            selectedYear = document.querySelectorAll("#" + calID + "-k-w-c-datepicker .-kony-w-c-navigator-year-selected")[0],
            selectedMnth, element, num, mn, x, y, _hideLnks = function(calendarModel, closeLink, titleOnPopUpVisibility) {
                closeLink.style.visibility = "hidden";
                if(titleOnPopUpVisibility) {
                    titleOnPopUpVisibility.style.visibility = 'hidden';
                }
                alert(calendarModel.navigatorAlert);
            };
        if(selectedYear) {
            x = selectedYear.getAttribute('k-w-c-hold') * 1;
        }
        selectedMnth = document.querySelectorAll("#" + calID + "-k-w-c-datepicker .-kony-w-c-navigator-month-selected")[0];
        if(selectedMnth) {
            y = selectedMnth.getAttribute('k-w-c-hold') * 1;
        }
        num = x ? x : calendarModel.currentSelectedyearMonth[1].trim();
        mn = y ? y : calendarModel.currentSelectedMonth + 1;

        if(mn > 0 && !(mn >= 1 && mn <= 12)) {
            _hideLnks(calendarModel, closeLink, titleOnPopUpVisibility);
            return false;
        }
        number = parseInt(num, 10);
        if(num || mn) {
            element = document.getElementById(calID + "-k-w-c-navigator-scrim");
            element.parentNode.removeChild(element);
            series = _series((num || model.year || new Date().getFullYear()), (mn || calendarModel.month || new Date().getMonth() + 1), (calendarModel.noofmonths || 1) * 1 + 1);
            _show(calendarModel, module.activeCalendarNode, series);
        } else {
            _hideLnks(calendarModel, closeLink, titleOnPopUpVisibility);
            return false;
        }
        _removeTabIndexs();
        if(document.activeElement) {
            document.activeElement.blur();
        }
        document.querySelectorAll('.-kony-w-c-popup-container')[0].setAttribute('aria-hidden', false);
        _eventHandlerSetFocus(undefined, true);
        return false;
    };
    var _eventHandlerSaveCurrentSelection = function(calendarModel, target) {
        var counter;
        calendarModel.currentSelectedyearMonth = target.innerHTML.split(',');
        for(counter = 0; counter < calendarMonthsValues.length; counter++) {
            if(calendarModel.currentSelectedyearMonth[0] == calendarMonthsValues[counter]) {
                calendarModel.currentSelectedMonth = counter;
                break;
            }
        }
    };
    var selecteddaterange = [];
    var _eventHandlerSelectedHoldDay = function(calendarModel, target, applyLink) {
        var result;

        result = _dateFormatter(calendarModel.dateformat, target.getAttribute("k-w-c-hold-day").split(','));

        if(calendarModel.selectiontype == constants.CALENDAR_SELECTION_TYPE_RANGE_SELECT) {
            _eventDateSelectedRangeSelect(calendarModel, target, result, applyLink);
        } else if(calendarModel.selectiontype == constants.CALENDAR_SELECTION_TYPE_MULTI_SELECT) {
            _eventDateSelectedMultiSelect(calendarModel, target, result, applyLink);
        } else {
            _eventDateSelectedSingleSelect(calendarModel, target, result);
        }
    };


    var _eventHandlerSetFocus = function(target, setAttribute) {
        var monthYearDiv;
        target && target.blur();
        monthYearDiv = document.querySelector('.-kony-w-c-yemo');
        if(monthYearDiv) {
            setAttribute && monthYearDiv.setAttribute('tabindex', 1);
            monthYearDiv.focus();
        }
    };
    var _eventHandlerYearRightArrowSelected = function(closeLink, titleOnPopUpVisibility, maxYearLimit) {
        var calID = module.activeCalendarNode.getAttribute('id'),
            elements = document.querySelectorAll('#' + calID + '-k-w-c-navigator-scrim .-kony-w-c-navigator-year'),
            i, yy, empty;
        closeLink.style.visibility = "hidden";
        if(titleOnPopUpVisibility) {
            titleOnPopUpVisibility.style.visibility = 'hidden';
        }
        for(i = 0; i < elements.length; i++) {
            if(elements[i].innerHTML == "" && this.cellVisibility == false) {
                elements[i].style.visibility = "visible";
                if((elements[i - 1] != undefined) && elements[i - 1].innerHTML != "") {
                    elements[i].innerHTML = (Number(elements[i - 1].innerHTML) + 1);
                    elements[i].setAttribute("k-w-c-hold", (Number(elements[i].innerHTML)));

                } else {
                    elements[i].innerHTML = (Number(elements[elements.length - 1].innerHTML) + 1);
                    elements[i].setAttribute("k-w-c-hold", (Number(elements[elements.length - 1].innerHTML) + 1));
                }
                _removeClass(elements[i], '-kony-w-c-navigator-year-selected');

            } else {
                yy = elements[i].getAttribute('k-w-c-hold') * 1;
                if(yy + 16 <= maxYearLimit) {
                    elements[i].innerHTML = yy + 16;
                    elements[i].setAttribute("k-w-c-hold", (yy + 16));
                    if(Number(elements[i].innerHTML) == maxYearLimit) {
                        for(empty = i + 1; empty < 16; empty++) {
                            elements[empty].innerHTML = "";
                            elements[empty].style.visibility = "hidden";
                        }
                    } else {
                        elements[i].style.visibility = "visible";
                        this.cellVisibility = true;
                        elements[i].setAttribute("k-w-c-hold", (yy + 16));
                        _removeClass(elements[i], '-kony-w-c-navigator-year-selected');
                    }
                }
            }
        }
        return false;
    };
    var _eventHandlerYearLeftArrowSelected = function(closeLink, titleOnPopUpVisibility, minYearLimit) {
        var calID = module.activeCalendarNode.getAttribute('id'),
            elements = document.querySelectorAll('#' + calID + '-k-w-c-navigator-scrim .-kony-w-c-navigator-year'),
            yy, empty, i;
        closeLink.style.visibility = "hidden";
        if(titleOnPopUpVisibility) {
            titleOnPopUpVisibility.style.visibility = 'hidden';
        }
        for(i = 0; i < elements.length; i++) {
            if(elements[elements.length - 1].innerHTML == "") {
                elements[i].style.visibility = "visible";
                this.cellVisibility = true;
                if((elements[i - 1] != undefined) && elements[i - 1].innerHTML != "") {
                    elements[i].innerHTML = (Number(elements[i - 1].innerHTML) + 1);
                    elements[i].setAttribute("k-w-c-hold", (Number(elements[i].innerHTML)));
                } else {
                    elements[i].innerHTML = (Number(elements[i].innerHTML) - 16);
                    elements[i].setAttribute("k-w-c-hold", (Number(elements[i].innerHTML)));
                }
                _removeClass(elements[i], '-kony-w-c-navigator-year-selected');

            } else {
                yy = elements[i].getAttribute('k-w-c-hold') * 1;
                if(yy - 16 >= minYearLimit) {
                    elements[i].innerHTML = yy - 16;
                    elements[i].setAttribute("k-w-c-hold", (yy - 16));
                    if(yy - minYearLimit <= 16) {
                        for(empty = i - 1; empty >= 0; empty--) {
                            elements[empty].innerHTML = "";
                            elements[empty].style.visibility = "hidden";
                            this.cellVisibility = false;
                        }
                    } else {
                        elements[i].style.visibility = "visible";
                        elements[i].setAttribute("k-w-c-hold", (yy - 16));
                        _removeClass(elements[i], '-kony-w-c-navigator-year-selected');
                    }
                }
            }

        }
        return false;
    };
    var _eventHandlerYearSelected = function(target, closeLink, titleOnPopUpVisibility) {
        var calID = module.activeCalendarNode.getAttribute('id'),
            elements = document.querySelectorAll("#" + calID + "-k-w-c-datepicker .-kony-w-c-navigator-year-selected"),
            i, selym, selectedYear, selectedMnth, x, y;
        closeLink.style.visibility = "hidden";
        if(titleOnPopUpVisibility) {
            titleOnPopUpVisibility.style.visibility = 'hidden';
        }
        for(i = 0; i < elements.length; i++) {
            if(elements[i] != target) {
                _removeClass(elements[i], '-kony-w-c-navigator-year-selected');
                _addClass(elements[i], '-kony-w-c-navigator-year');
            }
        }
        _addClass(target, '-kony-w-c-navigator-year-selected');
        selym = document.querySelectorAll("#" + calID + "-k-w-c-datepicker .-k-w-c-nav-selected-ym")[0];
        selectedYear = document.querySelectorAll("#" + calID + "-k-w-c-datepicker .-kony-w-c-navigator-year-selected")[0];
        if(selectedYear) {
            x = selectedYear.getAttribute('k-w-c-hold') * 1;
        }
        selectedMnth = document.querySelectorAll("#" + calID + "-k-w-c-datepicker .-kony-w-c-navigator-month-selected")[0];
        if(selectedMnth) {
            y = calendarMonthsValues[(selectedMnth.getAttribute('k-w-c-hold') * 1) - 1];
        }
        selym.innerHTML = (y || "") + " " + (x || "");
        return false;
    };
    var _eventHandlerYemoSelected = function(calendarModel, target, closeLink, titleOnPopUpVisibility) {
        var div = document.createElement('div'),
            calID = module.activeCalendarNode.getAttribute('id'),
            element = document.getElementById(calID + '-k-w-c-datepicker'),
            template, yearMonthValue, currentYearValue;
        closeLink.style.visibility = 'hidden';
        if(titleOnPopUpVisibility) {
            titleOnPopUpVisibility.style.visibility = 'hidden';
        }
        if(target.innerText == undefined) {
            yearMonthValue = target.textContent.split(',');
        } else {
            yearMonthValue = target.innerText.split(',');
        }
        currentYearValue = yearMonthValue[1].trim();
        template = _navigatorTemplate(calendarModel, module.activeCalendarNode, currentYearValue);
        div.innerHTML = template;
        div.style.position = "absolute";
        div.style.height = div.style.width = "100%";
        div.className = "-k-w-c-navigator-scrim";
        div.style['background-color'] = "White";
        div.id = calID + "-k-w-c-navigator-scrim";
        div.setAttribute('w-type', "Calendar");
        div.firstChild.position = "absolute";
        div.firstChild.style['background-color'] = "white";
        element.appendChild(div);
        var ht = div.clientHeight,
            htp = div.firstChild.clientHeight,
            wt = div.clientWidth,
            wtp = div.firstChild.clientWidth;
        div.firstChild.position = "absolute";
        div.firstChild.style.top = ((ht - htp) / 2) + "px";
        div.firstChild.style.left = ((wt - wtp) / 2) + "px";
        div.style.top = div.style.left = "0px";
        _removeTabIndexs();
        if(document.activeElement) {
            document.activeElement.blur();
        }
        document.querySelectorAll('.-kony-w-c-popup-container')[0].setAttribute('aria-hidden', true);
        div.querySelectorAll('[w-type-inactive]')[0].setAttribute('tabindex', 1);
        div.querySelectorAll('[w-type-inactive]')[0].focus();
        return false;
    };
    var startlessthanend = function(calendarModel) {
        if(calendarModel.validstartdate && calendarModel.validstartdate.length && calendarModel.validenddate && calendarModel.validenddate.length) {
             validStartDateSet = new Date(calendarModel.validstartdate[2], calendarModel.validstartdate[1] - 1, calendarModel.validstartdate[0]).setHours(0, 0, 0, 0);
             validEndDateSet = new Date(calendarModel.validenddate[2], calendarModel.validenddate[1] - 1, calendarModel.validenddate[0]).setHours(0, 0, 0, 0);
             if(validStartDateSet < validEndDateSet) {
                 return true;
             }
             else
                return false;
        }
        return true;

    }
    var _isValidDateComponents = function(calendarModel) {
        var isValid;
         
        if(kony.application.getApplicationBehavior("newCalendarskinApifeature")) {
            if(calendarModel.enablerangeofdates_startDate || calendarModel.enablerangeofdates_endDate) {
                calendarModel.validstartdate = [];
                calendarModel.validenddate = [];
                isValid = true;
                kony.web.logger("error", "enableRangeOfDates API is already used");
            }
            else
            {
              if(module.isMultiRangeCalendar(calendarModel)) {
                isValid = module.isSelectedDatesValid(calendarModel, calendarModel.selecteddates);
               }
               else {
                isValid = module.isSelectedDatesValid(calendarModel, calendarModel.datecomponents);
               }
            }



        }
        else {
            if(module.isMultiRangeCalendar(calendarModel)) {
                isValid = module.isSelectedDatesValid(calendarModel, calendarModel.selecteddates);
            } else {
                isValid = module.isSelectedDatesValid(calendarModel, [calendarModel.datecomponents]);
            }



        }
        return isValid;
    };

    var _getCalInputNode = function(calendarElement) {
        var inputELement, childNodes = calendarElement.childNodes;
        if(childNodes[0].tagName === "INPUT") {
            inputELement = childNodes[0];
        } else {
            inputELement = childNodes[1];
        }
        return inputELement;

    };

    var _getCalImageNode = function(calendarElement) {
        var imageELement, childNodes = calendarElement.childNodes;
        if(childNodes[0].tagName === "IMG") {
            imageELement = childNodes[0];
        } else {
            imageELement = childNodes[1];
        }
        return imageELement;

    };

    var _generateCalendarTemplate = function(calendarModel, popupHeight, popupWidth) {
        var widgetContext = " kformname='" + calendarModel.pf + "'",
            counter, template = "",
            tempString = "",
            previousMonthI18Text = ($KG["i18nArray"] && $KG["i18nArray"]["platform.calendar.previousMonthLink"]) ? $KG["i18nArray"]["platform.calendar.previousMonthLink"] : "Previous Month",
            nextMonthI18Text = ($KG["i18nArray"] && $KG["i18nArray"]["platform.calendar.nextMonthLink"]) ? $KG["i18nArray"]["platform.calendar.nextMonthLink"] : "Next Month";
        if(calendarModel.tabpaneId) widgetContext = " ktabpaneid='" + calendarModel.tabpaneId + "' ";
        if(calendarModel.kmasterid) widgetContext = " kmasterid='" + calendarModel.kmasterid + "' ";
        template = '<div w-type="Calendar"  style="display:inline-block;" class="-kony-w-c-popup-container' + '" id="{{id}}" style="height:' + popupHeight + ';width:' + popupWidth + ';">' +
            '<div w-type="Calendar"  class="-kony-w-c-topSection"' + ' >' +
            '<div w-type="Calendar"  class="-kony-w-c-table" style=";width:100%;height:70%;">' +
            _generateHeaderRow(widgetContext, previousMonthI18Text, nextMonthI18Text) +
            '</div>' +
            '<div w-type="Calendar"  class="-kony-w-c-table -kony-w-c-daysHeader" style="width:100%;height:30%;">' +
            _generateDaysRow(widgetContext, calendarModel.cellWidths) +
            '</div>' +
            '</div>' +
            '<div w-type="Calendar" class="kony-w-c-actualDates">' +
            _generateDateCells(widgetContext, calendarModel.cellWidths) +
            '</div>' +
            '</div>';
        return template;
    };
    var _generateDateCells = function(widgetContext, cellWidth) {
        
        var i, j, dateCellsString = "";
        
        for(i = 8; i <= 49; i = i + 7) {
            dateCellsString += '<div w-type="Calendar"  class="-kony-w-c-table -kony-w-c-day-table" style="">' +
                '<div w-type="Calendar"  class="-kony-w-c-row -kony-w-c-day-row">';
            for(j = i; j <= i + 6; j++) {
                dateCellsString += '<div w-type="Calendar" ' + widgetContext + ' kwidgettype="Calendar" class="" id="-kony-w-c-cell-' + j + '"  style="width:' + cellWidth[i - 1] + ';display:table-cell; vertical-align:middle; text-align:center; height:100%;font-size:smaller; position:relative;"></div>';
            }
            dateCellsString += '</div>' +
                '</div>';
        }
        return dateCellsString;
    };
    var _generateDaysRow = function(widgetContext, cellWidth) {
        var i, daysTemplateString = "";
        daysTemplateString += '<div w-type="Calendar"  class="-kony-w-c-row">';
        
        for(i = 1; i <= 7; i++) {
            
            daysTemplateString += '<div ' + widgetContext + ' w-type = "Calendar" class="" id="-kony-w-c-cell-' + i + '" style="width:' + cellWidth[i - 1] + ';display:table-cell; vertical-align:middle; text-align:center; height:100%;font-size:smaller"></div>';
        }
        daysTemplateString += '</div>'
        return daysTemplateString;
    };
    var _generateHeaderRow = function(widgetContext, previousMonthI18Text, nextMonthI18Text) {
        var headerRowString = "";
        headerRowString = '<div w-type="Calendar"  class="-kony-w-c-row">' +
            '<div w-type="Calendar" ' + widgetContext + ' class="-kony-w-c-cell -kony-w-c-prev-nav" style="width:20%;text-align:left;display:table-cell"><img w-type="Calendar" class="-kony-w-c-prev-nav-left-link" alt="' + previousMonthI18Text + '" style="height:15px;width:25px;display:inline-block" /></div>' +
            '<div w-type="Calendar" ' + widgetContext + ' kwidgettype="Calendar" class="-kony-w-c-cell -kony-w-c-yemo" style="width:60%;display:table-cell;text-align:center;outline-color:#FFFFFF;" tabindex="1"></div>' +
            '<div w-type="Calendar" ' + widgetContext + ' class="-kony-w-c-cell -kony-w-c-next-nav" style="width:20%;text-align:right;display:table-cell;"><img w-type="Calendar" class="-kony-w-c-next-nav-right-link" alt="' + nextMonthI18Text + '" style="height:15px;width:25px;display:inline-block" /></div>' +
            '</div>';
        return headerRowString;
    };
    var _generateCalenderString = function(calendarModel, context) {
        var htmlString = "", contentAlignment;

        if(calendarModel.calendariconalignment === constants.CALENDAR_ICON_ALIGN_LEFT) {
            htmlString += _generateImageTagString(calendarModel, context);
            htmlString += _generateInputTagString(calendarModel, context);
        } else if(calendarModel.calendariconalignment === constants.CALENDAR_ICON_ALIGN_RIGHT ||
                  typeof calendarModel.calendariconalignment === "undefined") {
            htmlString += _generateInputTagString(calendarModel, context);
            htmlString += _generateImageTagString(calendarModel, context);
        } else if(calendarModel.calendariconalignment === constants.CALENDAR_ICON_ALIGN_AUTO) {
            contentAlignment = calendarModel.contentAlignment;
            if(contentAlignment === constants.CONTENT_ALIGN_MIDDLE_LEFT ||
               contentAlignment === constants.CONTENT_ALIGN_CENTER) {
                htmlString += _generateInputTagString(calendarModel, context);
                htmlString += _generateImageTagString(calendarModel, context);
            } else if(contentAlignment === constants.CONTENT_ALIGN_MIDDLE_RIGHT) {
                htmlString += _generateImageTagString(calendarModel, context);
                htmlString += _generateInputTagString(calendarModel, context);
            }
        }

        return htmlString;
    };
    var _generateImageTagString = function(calendarModel, context) {
        var imageTagString, altText = (calendarModel.accessibilityconfig && calendarModel.accessibilityconfig.hint) ? calendarModel.accessibilityconfig.hint : "Calendar",
            imgsrc = calendarModel.Image ? $KU.getImageURL(calendarModel.Image) : $KU.getImageURL("calbtn.gif"), ariaAttr = '';

        if(calendarModel.accessibilityconfig) {
            ariaAttr = $KU.getAccessibilityValues(calendarModel, calendarModel.accessibilityconfig);
        } else {
            ariaAttr = 'tabindex=0';
        }
        imageTagString = "<img id='" + calendarModel.id + "_img' type='image' src='" + imgsrc + "' style='float:right;vertical-align:middle' xalign='right' onload='$KW.Calendar.setCalElementStyle(this,false)'";
        imageTagString += "alt='" + altText + "'";
        if(calendarModel.kmasterid) {
            imageTagString += "kmasterid = '" + calendarModel.kmasterid + "'";
        }
        imageTagString += (calendarModel.title) ? " title='" + calendarModel.title + "'" : "";
        imageTagString += ariaAttr;
        imageTagString += " />";

        return imageTagString;
    };
    var _generateInputTagString = function(calendarModel, context) {
        var inputTagString
        , tabpaneID = context.tabpaneID || ""
        , isDisabled = $KW.Utils.isWidgetDisabled(calendarModel, context) || false, ariaTabIndex = 0;
        if(calendarModel.accessibilityconfig && calendarModel.accessibilityconfig.a11yARIA) {
            ariaTabIndex = calendarModel.accessibilityconfig.a11yARIA.tabindex ? calendarModel.accessibilityconfig.a11yARIA.tabindex : 0;
        }
        inputTagString = "<input id='" + calendarModel.id + "' style='" + $KU.cssPrefix + "appearance: none; text-align: inherit; vertical-align: middle;background:transparent;width:50%;text-decoration:inherit;' tabindex='"+ ariaTabIndex +"' name='calBody'";
        inputTagString += (calendarModel.placeholder) ? " placeholder='" + calendarModel.placeholder + "'" : "";
        inputTagString += (calendarModel.title) ? " title='" + calendarModel.title + "'" : "";
        inputTagString += (calendarModel.disabled) ? " disabled='true'" : "";
        if(calendarModel.kmasterid) {
            inputTagString += " kmasterid = '" + calendarModel.kmasterid + "'";
        }
        inputTagString += " kwidgettype='CalendarText' kformname='" + calendarModel.pf + "' " + (tabpaneID && " ktabpaneid='" + tabpaneID + "'");
        inputTagString += " onchange='$KW.Calendar.calendarTextfieldChangeEventHandler(arguments[0],this)'";
        inputTagString += (!(calendarModel.dateEditable || calendarModel.dateeditable) ? " readonly='readonly'" : "");
        inputTagString += (calendarModel.formatteddate) ? (" value='" + calendarModel.formatteddate + "'") : "";
        inputTagString += isDisabled ? " kdisabled='true' disabled='true'" : "";
        inputTagString += " type='text' />";

        return inputTagString;
    };
    var _getByClass = function(element, className) {
        return document.querySelectorAll('#' + element.id + " ." + className);
    };
    var _getBySele = function(element, selector) {
        return document.querySelectorAll('#' + element.id + " " + selector);
    };
    var _getCalendarModelFormCalendarNode = function(calendarNode, containerId) {
        var calendarModel, calendarId = calendarNode.getAttribute("id");
        if(calendarNode.getAttribute("kmasterid")) {
            calendarModel = $KU.getWidgetModelByID(calendarId);
        } else {
            calendarModel = kony.model.getWidgetModel(calendarNode.getAttribute("kformname"), $KU.getElementID(calendarId), calendarNode.getAttribute("ktabpaneid"));
        }
        if(containerId) {
            calendarModel = $KW.Utils.getClonedModelByContainer(calendarModel, calendarNode, containerId);
        }
        return calendarModel;
    };
    var _addDays = function(startDate, days) {
                var date = new Date(startDate.valueOf());
                date.setDate(date.getDate() + days);
                return date;
            };
    var _getDatesInRange = function(calendarModel, dateComponents) {
        var dates = [],
            checkdates = [],
            startDate, endDate, temp, tempDate,
            _getfromtoDate = function(dateComponent1, dateComponent2) {
                if(_isToGtFromDate(dateComponent1, dateComponent2)) {
                    return [dateComponent1, dateComponent2];
                }
                return [dateComponent2, dateComponent1];
            };
        if(dateComponents && dateComponents.length >= 2) {
            tempDate = _getfromtoDate(dateComponents[0], dateComponents[1]);
            startDate = new Date(tempDate[0][1] + "/" + tempDate[0][0] + "/" + tempDate[0][2]);
            dates.push(tempDate[0]);
            checkdates.push((new Date(tempDate[0][2], tempDate[0][1] - 1, tempDate[0][0])).setHours(0, 0, 0, 0))
            endDate = new Date(tempDate[1][1] + "/" + tempDate[1][0] + "/" + tempDate[1][2]);
            while(startDate < endDate) {
                startDate = _addDays(startDate, 1);
                temp = new Date(startDate);
                tempDate = [temp.getDate(), temp.getMonth() + 1, temp.getFullYear()];

                checkdates.push((new Date(tempDate[2], tempDate[1] - 1, tempDate[0])).setHours(0, 0, 0, 0))
                if(_isDateEnabled(calendarModel, [tempDate])) {
                    dates.push(tempDate);
                }

            }
        }
        if(kony.application.getApplicationBehavior("newCalendarskinApifeature")) {
            if(!isvalidrangeofselection(calendarModel , checkdates)) {
                dates = [];
                kony.web.logger("error", "Invalid Date selection Range");
                return dates;
            }
            else {
               return dates;
            }

        }
        else
            return dates;
    };
    var _getDisplayDate = function(calendarModel) {
        var formattedDate = "",
            displayDate = "",
            temp = calendarModel.selecteddates || [],
            dateFormat = calendarModel.dateformat,
            _concatinateDate = function(dates, format, seperator) {
                var i, temp, displayDate = "";
                for(i = 0; i < dates.length; i++) {
                    temp = _dateFormatter(format, dates[i]);
                    if(temp != false) {
                        displayDate += temp.string + seperator;
                    }
                }
                if(dates.length > 0) {
                    displayDate = displayDate.slice(0, seperator.length * -1);
                }
                return displayDate;
            };
        if(calendarModel.selectiontype == constants.CALENDAR_SELECTION_TYPE_RANGE_SELECT) {
            if(temp.length == 2) {
                displayDate = _concatinateDate([temp[0], temp[1]], dateFormat, " - ");
            }
        } else if(calendarModel.selectiontype == constants.CALENDAR_SELECTION_TYPE_MULTI_SELECT) {
            if(temp.length > 0) {
                displayDate = _concatinateDate(temp, dateFormat, ",")
            }
        }
        return displayDate;
    };
    var _getGridTheme = function(gridTheme) {
        var pickerStyle
        if(gridTheme) {
            pickerStyle = gridTheme;
        } else {
            if($KG.appbehaviors[constants.API_LEVEL] >= constants.API_LEVEL_8200) {
                pickerStyle = kony.calendar.MODERN;
            } else {
                pickerStyle = kony.calendar.LEGACY;
            }
        }
        return pickerStyle;
    };
    var _getOffset = function(elementNode) {
        var position = $KU.getPosition(elementNode);
        return [position.left, position.top];
    };
    var _hasClass = function(element, className) {
        return(' ' + element.className + ' ').indexOf(' ' + className + ' ') !== -1;
    };
    var _ideDateToString = function(date) {
        if(date) {
            try {
                if(date instanceof Array) {
                    date = eval(date);
                    date = date[0] + "/" + date[1] + "/" + date[2];
                }
            } catch(exception) {
                date = '';
            }
        }
        return date;
    };
    var _initializeCalendarModel = function(calendarModel) {
        var day
        , date, formattedDate = "",
        dateObj = {}
        , result, isValidDateSet = false;

        calendarModel.placeholder = calendarModel.placeholder || calendarModel.dateformat || calendarModel.format;
        if(module.isMultiRangeCalendar(calendarModel)) {
            isValidDateSet = module.isSelectedDatesValid(calendarModel, calendarModel.selecteddates);
            if(isValidDateSet) {
                formattedDate = _getDisplayDate(calendarModel);
                calendarModel.formatteddate = formattedDate;
                calendarModel.selectedDates = module.setTimeInDateComponents(calendarModel.selecteddates);
            } else {
                calendarModel.selecteddates = [];
                kony.web.logger("error", "Invalid date selection");
            }
        } else {
            if(calendarModel.date instanceof Array) {
                calendarModel.entereddate = calendarModel.date;
                if(calendarModel.date && calendarModel.date.length > 0) {
                    day = [calendarModel.date[0], calendarModel.date[1], calendarModel.date[2]]
                    result = _dateFormatter(calendarModel.dateformat, day);
                    if(result != false) {
                        calendarModel.dateComponents = result.date;
                        calendarModel.formatteddate = result.string;
                    }
                    calendarModel.day = result.date[0];
                    calendarModel.month = result.date[1];
                    calendarModel.year = result.date[2];
                } else {
                    calendarModel.day = null;
                    calendarModel.month = null;
                    calendarModel.year = null;
                }
                calendarModel.hour = calendarModel.minutes = calendarModel.seconds = 0;
            } else {
                calendarModel.formatteddate = calendarModel.date;
            }
            if(!dateObj.day) {
                calendarModel.format = calendarModel.dateformat;
                if(!calendarModel.datecomponents) {
                    _setCurrentDate(calendarModel);
                }
                date = _ideDateToString(calendarModel.datecomponents);
                dateObj = _convertToModelDate(date, calendarModel.dateformat);
                calendarModel.day = parseInt(dateObj.day, 10);
                calendarModel.month = parseInt(dateObj.month, 10);
                calendarModel.year = parseInt(dateObj.year, 10);
                calendarModel.selectdate = dateObj.selectdate;
                calendarModel.pagedate = dateObj.pagedate;
            }
        }

    };




    var commonDates = function (arr1, arr2) {
        var newArr = [];
        if(arr1 && arr2) {
            newArr = arr1.filter(function(v){ return arr2.indexOf(v) >= 0;})
            newArr.concat(arr2.filter(function(v){ return newArr.indexOf(v) >= 0;}));
        }
        return newArr;
    }
    var getRangeofDates = function(tempDate) {
        var dates = [];
        if(tempDate && tempDate.length >= 2) {

            startDate = new Date(tempDate[0][1] + "/" + tempDate[0][0] + "/" + tempDate[0][2]);


            endDate = new Date(tempDate[1][1] + "/" + tempDate[1][0] + "/" + tempDate[1][2]);
            while(startDate <= endDate) {

                temp = new Date(startDate);
                tempDate = [temp.getDate(), temp.getMonth() + 1, temp.getFullYear()];

                dates.push((new Date(tempDate[2], tempDate[1] - 1, tempDate[0])).setHours(0, 0, 0, 0));
                startDate = _addDays(startDate, 1);


            }
        }
        return dates;
    };



    var isvalidrangeofselection = function(calendarModel, dates) {
        var setenableddates = calendarModel.setenabled_dates, enablerangedates = calendarModel.enablerangeofdates_Dates,
            config = calendarModel.viewconfig.gridconfig || calendarModel.viewconfig.gridConfig || {};
        var isvalid = true;
        if(!config.allowWeekendSelectable) {

            for(var i =0; i<dates.length;i++) {
                if(new Date(dates[i]).getDay() === 0 || new Date(dates[i]).getDay() === 6) {
                    return false;
                }
            }

        }
        if(setenableddates && setenableddates.length && calendarModel.setenablestate == 0) {
            if(commonDates(setenableddates, dates).length) {
                return false;
            }

        }
        for(var i = 0;i<dates.length;i++) {
            if(calendarModel.enablestate == 0) {
                if(dates[i] >= calendarModel.startDate && dates[i] <= calendarModel.endDate) {
                    isvalid = false;
                    break;
                }
            }
            else if(calendarModel.enablestate == 1) {
                    if(dates[i] < calendarModel.startDate || dates[i] > calendarModel.endDate) {
                        isvalid = false;
                        break;
                    }



            }

        }





        return isvalid;




    }

    var _isDateEnabled = function(calendarModel, dates) {
        var i, date, dateValue, datesAll = calendarModel.datesGroupSimplified,
            validStartDateSet, validEndDateSet, minYearLimit = 1900, enablerangedates = calendarModel.enablerangeofdates_Dates,
            minStartDate, maxYearLimit = 2099,setenableddates = calendarModel.setenabled_dates,
            maxEndDate,enablerangeofdates_startDate = calendarModel.enablerangeofdates_startDate, enablerangeofdates_endDate= calendarModel.enablerangeofdates_endDate;
        var config = calendarModel.viewconfig.gridconfig || calendarModel.viewconfig.gridConfig || {};

        if(calendarModel.validstartdate) {
            validStartDateSet = new Date(calendarModel.validstartdate[2], calendarModel.validstartdate[1] - 1, calendarModel.validstartdate[0]).setHours(0, 0, 0, 0);
        }
        if(calendarModel.validenddate) {
            validEndDateSet = new Date(calendarModel.validenddate[2], calendarModel.validenddate[1] - 1, calendarModel.validenddate[0]).setHours(0, 0, 0, 0);
        }
        minStartDate = new Date(minYearLimit, 0, 1).setHours(0, 0, 0, 0); 
        maxEndDate = new Date(maxYearLimit, 11, 31).setHours(0, 0, 0, 0); 
        if(kony.application.getApplicationBehavior("newCalendarskinApifeature")) {
            if(calendarModel.selectiontype == 1)
                dates = [dates];
        }
        for(i = 0; i < dates.length; i++) {

               date = new Date(dates[i][2], dates[i][1] - 1, dates[i][0]).setHours(0, 0, 0, 0);

            if(!(minStartDate <= date && date <= maxEndDate)) {
                return false;
            }
            if((validStartDateSet && !(validStartDateSet <= date)) ||
                (validEndDateSet && !(date <= validEndDateSet))) {
                return false;
            }
            if(kony.application.getApplicationBehavior("newCalendarskinApifeature")) {
                if(config.allowWeekendSelectable != undefined && !config.allowWeekendSelectable) {
                    if(new Date(date).getDay() == 0 || new Date(date).getDay() == 6) {
                        return false;
                    }


                }
                if(setenableddates && setenableddates.length) {
                    if(calendarModel.setenablestate === 0 && setenableddates.indexOf(date) !== -1 )
                        return false;
                    else if(calendarModel.setenablestate === 1 && setenableddates.indexOf(date) !== -1)
                        return true;
                }

                if(enablerangeofdates_startDate && enablerangeofdates_endDate) {
                    if(calendarModel.enablerangeofdates_state === 0 && (date >= enablerangeofdates_startDate && date <= enablerangeofdates_endDate )
                        || calendarModel.enablerangeofdates_state === 1 && (date < enablerangeofdates_startDate || date > enablerangeofdates_endDate ))
                        return false;

                }

            }
            else {
                if(datesAll) { 
                   if(calendarModel.datesState == 0 && datesAll.length > 0 && datesAll.indexOf(date) > -1 ||
                      calendarModel.datesState == 1 && datesAll.length > 0 && datesAll.indexOf(date) <= -1) {
                       return false;
                    }
                }

            }
        }
        return true;
    };


    var _isToGtFromDate = function(dateComponent1, dateComponent2) {
        var date1, date2;
        date1 = new Date(dateComponent1[2], dateComponent1[1], dateComponent1[0]);
        date2 = new Date(dateComponent2[2], dateComponent2[1], dateComponent2[0]);
        if(date1 > date2) {
            return false;
        }
        return true;
    };
    var _month = function(month, year, shift) {
        var start = new Date(year, month - 1, 1).getDay(),
            days = [],
            day = 1,
            length = new Date(year, month, 0).getDate(),
            flag, prev = {},
            next = {},
            prevCount = 0,
            nextCount = 0,
            prevMonth, nextMonth, j, i, series;
        series = month == 1 ? _series(year - 1, 12, 3) : _series(year, month - 1, 3);
        prev.month = series[0][0];
        prev.year = series[0][1];
        next.month = series[2][0];
        next.year = series[2][1];
        prevMonth = new Date(prev.year, prev.month, 0).getDate(),
        nextMonth = new Date(next.year, next.month, 0).getDate();
        shift = shift || 0;
        if(shift > start) {
            shift -= 7
        }
        for(i = 0; i <= 6; i++) {
            days.push(calendarDaysValue[(i + shift + 7) % 7]);
        }
        for(i = 0; i < 6; i++) {
            for(j = 0; j <= 6; j++) {
                if(day <= length && (i > 0 || j + shift >= start)) {
                    days.push([day, {
                            d: day,
                            y: year,
                            m: month
                        },
                        new Date(year, month - 1, day).getDay()
                    ]);
                    day++;
                    flag = 1;
                } else {
                    if(flag) {
                        days.push(0);
                        nextCount += 1;
                    } else {
                        days.push(-1);
                        prevCount += 1;
                    }
                }
            }
        }
         for(i = 0; i < days.length; i++) {
            if(days[i] === 0) {
               days[i]= [flag, {
                            d: flag,
                            y: next.year,
                            m: next.month
                        },
                        new Date(next.year, (next.month - 1), flag).getDay(),
                        "nextinactive"
                ]
                flag++;
            } else if(days[i] == -1) {
                var dayz = prevMonth - prevCount + 1;
                days[i] = [dayz, {
                            d: dayz,
                            y: prev.year,
                            m: prev.month
                        },
                        new Date(prev.year, (prev.month - 1), dayz).getDay(),
                        "previnactive"
                ]
                prevCount--;
            }
        }
        return days;
    };
    var _navigatorTemplate = function(model, id, selectedYearValue) {
        var tabpaneID = model.tabpaneId,
            widgetContext = (" kformname='" + model.pf + "' ") + (tabpaneID && " ktabpaneid='" + tabpaneID + "' ") + (model.kmasterid && " kmasterid='" + model.kmasterid + "' "),
            navigatorString = "",
            _getNavigatorHeaderString = function(widgetContext, id) {
                var headerString = "",
                    cancelI18Text = $KG["i18nArray"] ? $KG["i18nArray"] ? $KG["i18nArray"]["platform.calendar.cancelImage"] : "Cancel Selection" : "Cancel Selection",
                    doneI18Text = $KG["i18nArray"] ? $KG["i18nArray"] ? $KG["i18nArray"]["platform.calendar.selectedImage"] : "Done Selecting" : "Done Selecting";
                headerString = "" +
                    "<div w-type='Calendar'  class='-kony-w-c-navigator-table' style='display:table;table-layout:fixed;height:15%;width:100%;'>" +
                    "<div w-type='Calendar'  style='display:table-row;width:100%;height:100%'>" +
                    "<div w-type='Calendar'  style='display:table-cell;width:15%;text-align:left;vertical-align:middle' class='-kony-w-c-cancel-nav' k-w-c-id='" + id + "' kwidgettype='Calendar' " + widgetContext + " >" +
                    "<img w-type='Calendar' alt='" + cancelI18Text + "' class='-kony-w-c-cancel-nav' style='height:50%;width:50%;' src='" + $KU.getImageURL("k-cancel.png") + "' k-w-c-id='" + id + "' kwidgettype='Calendar' " + widgetContext + " >" +
                    "</div>" +
                    "<div w-type='Calendar' w-type-inactive='true' style='display:table-cell;width:70%;text-align:center;vertical-align:middle' class='-k-w-c-nav-selected-ym" + "'>" +
                    "</div>" +
                    "<div w-type='Calendar'  style='display:table-cell;width:15%;text-align:right;vertical-align:middle' class='-kony-w-c-go-nav' k-w-c-id='" + id + "' kwidgettype='Calendar' " + widgetContext + " >" +
                    "<img w-type='Calendar'  alt='" + doneI18Text + "'class='-kony-w-c-go-nav' style='height:50%;width:50%;' src='" + $KU.getImageURL("k-go.png") + "' k-w-c-id='" + id + "' kwidgettype='Calendar' " + widgetContext + " >" +
                    "</div>" +
                    "</div>" +
                    "</div>";
                return headerString;
            },
            _getYearNavigationString = function(widgetContext, id) {
                var yearNavigationString = "",
                    leftArrowbg = $KU.getImageURL("left-arrow.png"),
                    rightArrowbg = $KU.getImageURL("right-arrow.png"),
                    previousYearsI18Key = $KG["i18nArray"] ? $KG["i18nArray"] ? $KG["i18nArray"]["platform.calendar.previousYearLink"] : "Previous set of Years" : "Previous set of Years",
                    nextYearsI18Key = $KG["i18nArray"] ? $KG["i18nArray"] ? $KG["i18nArray"]["platform.calendar.nextYearLink"] : "Next set of Years" : "Next set of Years";
                yearNavigationString = "" +
                    "<div w-type='Calendar'  class='-kony-w-c-navigator-table' style='display:table;table-layout:fixed;height:15%;width:100%'>" +
                    "<div w-type='Calendar'   style='display:table-row;width:100%;height:100%'>" +
                    "<div w-type='Calendar' style='display:table-cell;width:15%;text-align:left;vertical-align:middle' class='-kony-w-c-left-ym-p' k-w-c-id='" + id + "' kwidgettype='Calendar' " + widgetContext + " >" +
                    "<img class='-kony-w-c-left-ym-p' src = '" + leftArrowbg + "' alt='" + previousYearsI18Key + "' style='height:15px;width:25px;display:inline-block' k-w-c-id='" + id + "' kwidgettype='Calendar' " + widgetContext + " />" +
                    "</div>" +
                    "<div w-type-inactive='true'  w-type='Calendar' style='display:table-cell;width:70%;text-align:center;vertical-align:middle' class='-k-w-c-nav-yr-range'>" +
                    "</div>" +
                    "<div w-type='Calendar'  style='display:table-cell;width:15%;text-align:right;vertical-align:middle' class='-kony-w-c-right-ym-p' k-w-c-id='" + id + "' kwidgettype='Calendar' " + widgetContext + " >" +
                    "<img w-type='Calendar'  class='-kony-w-c-right-ym-p' src = '" + rightArrowbg + "' alt='" + nextYearsI18Key + "'style='height:15px;width:25px;display:inline-block' k-w-c-id='" + id + "' kwidgettype='Calendar' " + widgetContext + " />" +
                    "</div>" +
                    "</div>" +
                    "</div>";
                return yearNavigationString;
            },
            _getMonthsString = function(widgetContext, id) {
                var monthString = "",
                    months = calendarMonthsValues.slice(0),
                    monthsInRow, i, j;
                monthString += "<div w-type='Calendar'  class='-kony-w-c-navigator-table' style='display:table;table-layout:fixed;height:30%;width:100%;border-bottom:1px solid #FAFAFA'>";
                months = _chunks(months, 6);
                for(i = 0; i < months.length; i++) {
                    monthsInRow = months[i];
                    monthString += "<div w-type='Calendar'   style='display:table-row;width:100%;height:50%'>";
                    for(j = 0; j < monthsInRow.length; j++) {
                        monthString += "<div w-type='Calendar' role='option' aria-label='" + monthsInRow[j] + "' style='display:table-cell;width:15%;text-align:center;vertical-align:middle;font-size:smaller' class='-kony-w-c-navigator-month" + "' k-w-c-hold='" + ((i * 6) + (j + 1)) + "' k-w-c-id='" + id + "' kwidgettype='Calendar'" + widgetContext + " >" +
                            monthsInRow[j].substring(0, 3) +
                            "</div>";
                    }
                    monthString += "</div>";
                }
                monthString += "</div>";
                return monthString;
            },
            _getCounter = function(selectedYearValue) {
                var iterator, counter = 2001,
                    temp;
                if(selectedYearValue) {
                    selectedYearValue = Number(selectedYearValue);
                } else {
                    selectedYearValue = null;
                }
                if(selectedYearValue != null) {
                    if(selectedYearValue > counter) {
                        iterator = Math.floor((selectedYearValue - 2001) / 16);
                        for(temp = 0; temp < iterator; temp++) {
                            counter = counter + 16;
                        }
                    } else {
                        iterator = Math.ceil((2001 - selectedYearValue) / 16);
                        for(temp = 0; temp < iterator; temp++) {
                            counter = counter - 16;
                        }
                    }
                }
                return counter;
            },
            _getYearsString = function(widgetContext, id) {
                var i, yearsString = "",
                    counter;
                counter = _getCounter(selectedYearValue);
                for(i = 1; i <= 4; i++) { 
                    yearsString += "<div w-type='Calendar'   style='display:table-row;width:100%;height:25%'>";
                    for(j = 1; j <= 4; j++) { 
                        
                        if((counter > 1900 && counter < 2099) || counter == 2099 || counter == 1900) {
                            yearsString += "<div w-type='Calendar' role='option' aria-label = '" + counter + "' style='display:table-cell;width:25%;text-align:center;vertical-align:middle;font-size:smaller;visibility:visible;' class='-kony-w-c-navigator-year" + "' k-w-c-hold='" + counter + "' k-w-c-id='" + id + "' kwidgettype='Calendar' " + widgetContext + " >" +
                                counter +
                                "</div>";
                        } else {
                            yearsString += "<div w-type='Calendar' role='option' aria-label = '" + counter + "' style='display:table-cell;width:25%;text-align:center;vertical-align:middle;font-size:smaller;visibility:hidden;' class='-kony-w-c-navigator-year" + "' k-w-c-hold='" + counter + "' k-w-c-id='" + id + "' kwidgettype='Calendar' " + widgetContext + " >" +
                                counter +
                                "</div>";
                        }
                        counter++;
                    }
                    yearsString += "</div>";
                }
                return yearsString;
            };

        
        navigatorString = "<div w-type='Calendar' id='" + (model.id + "-k-w-c-navigator-") + "' class='-k-w-c-datepicker-navigator" + "' kwidgettype='Calendar' " + widgetContext + " style='height:" + model.popupHeight + ";width:" + model.popupWidth + ";position:absolute;background-color:White'>";

        
        navigatorString += _getNavigatorHeaderString(widgetContext, id);

        
        navigatorString += _getMonthsString(widgetContext, id);

        
        navigatorString += _getYearNavigationString(widgetContext, id);

        
        navigatorString += "<div w-type='Calendar'  class='-kony-w-c-navigator-table' style='display:table;table-layout:fixed;height:40%;width:100%'>";

        
        navigatorString += _getYearsString(widgetContext, id);

        
        navigatorString += "</div></div>";
        return navigatorString;
    };
    var _reAssignData = function(calendarModel) {
        
        var config, validMonth, yearStored, defaultSelectedCellSkin, defaulTodaySelectedCellSkin, pickerStyle = _getGridTheme(calendarModel.gridTheme),
            validYear;
        if(!calendarModel.datecomponents) {
            _setCurrentDate(calendarModel);
            calendarModel.minutes = 0;
            calendarModel.hour = 0;
            calendarModel.seconds = 0;
        }
        if(calendarModel.noofmonths < 1 || isNaN(calendarModel.noofmonths * 1)) {
            calendarModel.noofmonths = 1;
        }
        calendarModel.datesGroup = [];
        calendarModel.datesState = calendarModel.datesState || 0;
        calendarModel.dateformat = calendarModel.dateformat || calendarModel.format || "dd/mm/yyyy";
        
        calendarModel.popupHeight = calendarModel.popupHeight || Math.min.apply(Math, [300, window.innerHeight || document.documentElement.clientHeight]) + "px";
        calendarModel.popupWidth = calendarModel.popupWidth || Math.min.apply(Math, [300, window.innerWidth || document.documentElement.clientWidth]) + "px";
        
        calendarModel.startDay = calendarModel.startDay || 0;
        if(!calendarModel.viewconfig) {
            calendarModel.viewconfig = {
                gridConfig: {},
                gridconfig: {}
            };
        }
        config = calendarModel.viewconfig.gridconfig || calendarModel.viewconfig.gridConfig || {};
        config.gridCellWeekendSkin = config.gridCellWeekendSkin || config.gridcellweekendskin || "-kony-w-c-weekend-";
        config.gridCellInactiveDaysSkin = config.gridCellInactiveDaysSkin || config.gridcellinactivedaysskin || "-k-w-c-inactive";
        config.gridCellSkin = config.gridCellSkin || config.gridcellskin || "-kony-w-c-day-skin";
        if(calendarModel.selectiontype == constants.CALENDAR_SELECTION_TYPE_RANGE_SELECT) {
            defaultSelectedCellSkin = "-kony-w-c-selected-inrange";
            defaulTodaySelectedCellSkin = "-k-w-c-today-selected-inrange";
        } else {
            defaultSelectedCellSkin = "-kony-w-c-selected-";
            defaulTodaySelectedCellSkin = "-k-w-c-today-selected";
        }
        config.gridCellSelectedSkin = config.gridCellSelectedSkin || config.gridcellselectedskin || defaultSelectedCellSkin;
        config.gridCellTodaySkin = config.gridCellTodaySkin || config.gridcelltodayskin || "-kony-w-c-today-";
        if(pickerStyle == kony.calendar.LEGACY) {
            defaulTodaySelectedCellSkin = "";
        }
        config.gridCellSelectedTodaySkin = config.gridCellSelectedTodaySkin || config.gridcellselectedtodayskin || defaulTodaySelectedCellSkin;
        config.gridCellFromDateSkin = config.gridCellFromDateSkin || config.gridcellfromdateskin || "-k-w-c-cal-from-date";
        config.gridCellToDateSkin = config.gridCellToDateSkin || config.gridcelltodateskin || "-k-w-c-cal-to-date";
        config.doneButtonSkin = config.doneButtonSkin || '-k-w-c-apply-picker';
        config.cancelButtonSkin = config.cancelButtonSkin || '-k-w-c-close-picker';
        config.monthHeaderSkin = config.monthHeaderSkin || " -kony-w-c-yemo-skin";
        config.dayHeaderSkin = config.dayHeaderSkin || " -kony-w-c-day-label-cell";
        if(config.allowWeekendSelectable == undefined) {
            config.allowWeekendSelectable = config.allowweekendselectable;
        }
        if(calendarModel.validStartDate) {
            validMonth = calendarModel.validStartDate[2];
            validYear = calendarModel.validStartDate[1];
        }
        validYear = calendarModel.year || validYear || new Date().getFullYear(),
            validMonth = calendarModel.month || validMonth || new Date().getMonth() + 1;
        calendarModel.displayedMonths = calendarModel.displayedMonths || [validMonth, validYear]; 
        calendarModel.dayTextAlignmentInCell = calendarModel.dayTextAlignmentInCell || "CONTENT_ALIGN_CENTER";
        if(calendarModel.year) {
            yearStored = calendarModel.year.toString();
            if(yearStored.length > 4) {
                calendarModel.year = yearStored.substr(yearStored.length - 4) * 1;
            }
        }
        calendarModel.navigatorAlert = $KG["i18nArray"] && $KG["i18nArray"]["gridCalAlertI18Nkey"] ? kony.i18n.getLocalizedString("gridCalAlertI18Nkey") : (calendarModel.navigatorAlert || "Invalid Selection");
    };
    var _removeClass = function(element, className) {
        element.className = _trim((' ' + element.className + ' ').replace(' ' + className + ' ', ' '));
    };
    var _removeTabIndexs = function() {
        var previousTabIndexClear = document.querySelectorAll('[tabindex]'),
            i;
        for(i = 0; i < previousTabIndexClear.length; i++) {
            if("Calendar" === previousTabIndexClear[i].getAttribute('kwidgettype')) {
                previousTabIndexClear[i].removeAttribute('tabindex');
            }
        }
    };
    var _reposition = function(repositionFlag) {
        var calendarElement = document.querySelector("div[id$='-k-w-c-datepicker']"),
            calendarElementHeight, windowWidth, top, left;
        if(calendarElement) {
            calendarElementHeight = calendarElement.clientHeight;
            windowWidth = window.innerWidth || document.documentElement.clientWidth;
            top = (window.pageYOffset + ((window.innerHeight - calendarElementHeight) / 2));
            calendarElement.style.left = "0px";
            left = ((windowWidth - calendarElement.clientWidth) / 2);
            if((left * 2 + calendarElement.clientWidth) > windowWidth) {
                left = 0;
            }
            calendarElement.style.top = (top > 0 ? top : 0) + "px";
            calendarElement.style.left = left + "px";
            if(repositionFlag != 1) {
                calendarElement.innerHTML = calendarElement.innerHTML;
            }
        }
    };
    var _series = function(y, mn, nfm) {
        var ms = [
                [mn, y]
            ],
            m;
        y = parseInt(y, 10);
        mn = parseInt(mn, 10);
        for(m = 0; m < nfm - 1; m++) {
            if(mn + 1 > 12) {
                mn = 1;
                y += 1;
                ms.push([mn, y]);
            } else {
                mn += 1;
                ms.push([mn, y]);
            }
        }
        return ms;
    };
    var _setCurrentDate = function(calendarModel) {
        var todayDate = new Date();
        calendarModel.datecomponents = [];
        calendarModel.datecomponents = [0, 0, 0, 0, 0, 0];
        calendarModel.datecomponents[1] = todayDate.getMonth() + 1;
        calendarModel.datecomponents[2] = todayDate.getFullYear();
    };
    var _adjustFlexLayoutInCellTemplate = function(calendarModel) {
        var celltemplates = document.querySelectorAll("div[kcelltemplate]"),
            cellLength = celltemplates.length,
            cellItem = 0,
            height = 0,
            cellTemplateNode, calendarNode = null,
            templateNode = null;

        for(cellItem = 0; cellItem < cellLength; cellItem++) {
            cellTemplateNode = celltemplates[cellItem];
            calendarNode = cellTemplateNode.parentNode;
            _adjustStyleDivForTemplateInGridCell(calendarNode.childNodes[1]);
            calendarModel.celltemplate.layoutConfig = {
                self: true,
                children: true
            };
            templateNode = calendarNode.childNodes[1].firstElementChild;
            $KW.FlexContainer.forceLayout(calendarModel.celltemplate, templateNode);
        }
    };
    var _show = function(calendarModel, targetCalendar, ms, flag) {
        var calendarHTML = "",
            currentDate = new Date(),
            invalidSelectionAlert, numberOfMonths, popupHeight = calendarModel.popupHeight || "300px",
            popupWidth = calendarModel.popupWidth || "300px",
            mainContainer = document.getElementById("__MainContainer"),
            mouseEvent, startYear, startMonth, startDay, popupTemplate, formElement, children, navigators, monthData, element, exists, retDIV, close, id, i, _getTitleElement = function(calendarModel) {
                var title = document.createElement('div');
                title.className = "-k-w-c-cal-title";
                title.id = "-k-w-c-cal-title";
                title.setAttribute('w-type', 'Calendar');
                title.innerHTML = calendarModel.title;
                return title;
            },
            _getCloseElement = function(calendarModel, targetCalendarId) {
                var close = document.createElement('div'),
                    tabpaneID = calendarModel.tabpaneId,
                    closeText = $KG["i18nArray"] && $KG["i18nArray"]["gridCalCloseI18Nkey"] ? kony.i18n.getLocalizedString("gridCalCloseI18Nkey") : "Close",
                    calendarConfig = calendarModel.viewconfig.gridconfig || calendarModel.viewconfig.gridConfig || {};;
                close.innerHTML = "<a href='#' class=" + calendarConfig.cancelButtonSkin + " id='calendar-close-link' kformname='" + calendarModel.pf + "' kwidgettype='Calendar' " + (calendarModel.kmasterid ? " kmasterid='" + calendarModel.kmasterid + "' " : "") + +(tabpaneID ? "ktabpaneid='" + tabpaneID + "' " : "") + " style='float:right;'>" + closeText + "</a>";
                close.setAttribute('w-type', "Calendar");
                close.firstChild.setAttribute('k-w-c-id', targetCalendarId);
                return close;
            },
            _getApplyElement = function(calendarModel, targetCalendarId) {
                var apply = document.createElement('div'),
                    tabpaneID = calendarModel.tabpaneId,
                    applyText = $KG["i18nArray"] && $KG["i18nArray"]["gridCalApplyI18Nkey"] ? kony.i18n.getLocalizedString("gridCalApplyI18Nkey") : "Apply",
                    calendarConfig = calendarModel.viewconfig.gridconfig || calendarModel.viewconfig.gridConfig || {};;
                apply.innerHTML = "<a href='#' class=" + calendarConfig.doneButtonSkin + " id='calendar-apply-link' kformname='" + calendarModel.pf + "' kwidgettype='Calendar' " + (calendarModel.kmasterid ? " kmasterid='" + calendarModel.kmasterid + "' " : "") + +(tabpaneID ? "ktabpaneid='" + tabpaneID + "' " : "") + " style='float:right;margin-right:20px;visibility:hidden'>" + applyText + "</a>";
                apply.setAttribute('w-type', "Calendar");
                apply.firstChild.setAttribute('k-w-c-id', targetCalendarId);
                return apply;
            },
            _addScrimToDocument = function() {
                var scrim = document.createElement('div'),
                    documentBody, documentHeight;
                scrim.className = "k-w-c-scrim-for-popup";
                documentBody = document.body;
                documentHeight;
                if(document.height != undefined) {
                    documentHeight = document.height;
                } else {
                    if(documentBody.scrollHeight != undefined && documentBody.offsetHeight != undefined) {
                        if(!kony.appinit.isWindowsPhone) {
                            documentHeight = Math.max(documentBody.scrollHeight, documentBody.offsetHeight);
                        } else {
                            documentHeight = 100;
                        }
                    } else {
                        documentHeight = documentBody.scrollHeight || documentBody.offsetHeight;
                    }

                }
                if(!kony.appinit.isWindowsPhone) {
                    scrim.innerHTML = "<div style='height:" + documentHeight + "px;width:100%;opacity:0;line-height:100%'>&nbsp;</div>";
                } else {
                    scrim.innerHTML = "<div style='height:" + documentHeight + "%;width:100%;opacity:0;line-height:100%'>&nbsp;</div>";
                    scrim.style.height = "100%";
                }
                scrim.style.position = "absolute";
                scrim.style.top = scrim.style.left = "0px";
                scrim.style.height = "100%"; 
                scrim.style.width = "100%";
                scrim.style.zIndex = "1230";
                if($KU.isIE11)
                    scrim.style.transform = "translateZ(0px)";
                document.getElementById("__MainContainer").appendChild(scrim);
                kony.events.addEventListener(scrim, 'touchstart', _dismissCalendar);
            },
            _getContextWidgetNode = function(calendarModel, calendarNode, contextWidgetId) {
                var templateNode, contextWidgetNode;
                if(contextWidgetId === calendarModel.id) {
                    contextWidgetNode = calendarNode;
                } else {
                    templateNode = $KW.Utils.getContainerNodeByparent(calendarNode, calendarModel.pf);
                    contextWidgetNode = templateNode.parentNode.querySelector("div[id='"+calendarModel.pf+"_"+ contextWidgetId +"']");
                }
                return contextWidgetNode;
            },
            _setContextTopLeft = function(calendarModel, element, calendarNode) {
                var anchorPos, contextWidgetNode;
                if(typeof calendarModel.context.widget === 'string') {
                    contextWidgetNode = _getContextWidgetNode(calendarModel, calendarNode, calendarModel.context.widget);
                } else if(calendarModel.context.widget.isCloned) {
                    contextWidgetNode = _getContextWidgetNode(calendarModel, calendarNode, calendarModel.context.widget.id);
                }
                anchorPos = $KU.getAnchorPosition(calendarModel, element, contextWidgetNode);
                element.style.top = anchorPos.topPos + 'px';
                element.style.left = anchorPos.leftPos + 'px';
            },
            _setNonContextTopLeft = function(targetCalendar, element) {
                var position = _getOffset(targetCalendar);
                element.style.top = position[1] + targetCalendar.offsetHeight + "px";
                element.style.left = (((window.innerWidth || document.documentElement.clientWidth) - element.clientWidth) / 2) + "px";
            };
        this.invoked = this.invoked || {};
        this.invoked[targetCalendar.id] = this.invoked[targetCalendar.id] || {
            d: targetCalendar,
            i: targetCalendar.firstChild.id,
            s: ""
        };
        if(calendarModel.validStartDate) {
            startDay = calendarModel.validStartDate[0];
            startMonth = calendarModel.validStartDate[1];
            startYear = calendarModel.validStartDate[2];
        }
        startYear = calendarModel.year || startYear || currentDate.getFullYear();
        startMonth = calendarModel.month || startMonth || currentDate.getMonth() + 1;
        numberOfMonths = calendarModel.noofmonths;
        if(ms && ms[0] && !flag) {
            exists = true;
        }
        if(calendarModel.showcurrentdate) {
            startYear = currentDate.getFullYear();
            startMonth = currentDate.getMonth() + 1;
        }
        ms = ms || _series(startYear, startMonth, numberOfMonths);
        calendarModel.cellWidths = calendarModel.cellWidths || ["14.2857%;", "14.2857%;", "14.2857%;", "14.2857%;", "14.2857%;", "14.2857%;", "14.2857%;"];
        popupTemplate = _generateCalendarTemplate(calendarModel, popupHeight, popupWidth);
        element = document.getElementById(targetCalendar.id + '-k-w-c-datepicker') || document.createElement('div');
        if(element.id == "") {
            if(calendarModel.title) {
                element.appendChild(_getTitleElement(calendarModel));
            }
            element.id = targetCalendar.id + '-k-w-c-datepicker';
        }
        element.setAttribute('w-type', 'Calendar');
        this.invoked[targetCalendar.id].s = "active";
        children = _getByClass(element, '-kony-w-c-popup-container');
        calendarModel.displayedMonths = [ms[0][0], ms[0][1]];
        for(i = 0; i < Number(calendarModel.noofmonths); i++) {
            navigators = [1, 1];
            monthData = _month(ms[i][0], ms[i][1], calendarModel.startDay);
            id = ('-k-w-c-month-cmp-' + ms[i][0] + "-" + ms[i][1]);
            if(children[i]) {
                children[i].id = id;
            }
            popupTemplate = popupTemplate.replace('{{id}}', id);
            retDIV = _updateMonthData(monthData, calendarModel, popupTemplate, ms[i], navigators, children[i] || 0, targetCalendar.id);
            if(retDIV != 0) {
                element.appendChild(retDIV);
            }
        }
        if(exists == true) {
            if(kony.application.getApplicationBehavior("newCalendarskinApifeature"))
                _applySkinsnew(calendarModel);
            else
                _applySkins(calendarModel);
            return;
        }
        element.className = "-k-w-c-datepicker-holder-main " + _getGridTheme(calendarModel.gridTheme);
        element.style.position = "absolute";
        element.style.border = "1px solid #CCC";
        element.appendChild(_getCloseElement(calendarModel, targetCalendar.id));
        if(module.isMultiRangeCalendar(calendarModel)) {
            element.appendChild(_getApplyElement(calendarModel, targetCalendar.id));
        }
        element.style.zIndex = "1234";
        if($KU.isMobile() || $KU.isTablet) {
            element.setAttribute('dummy', 'a');
            element.style.display = "none";
            mainContainer.appendChild(element);
            element.style.display = "inline-block";
            _reposition(1);
            _addScrimToDocument();
            formElement = document.getElementById(calendarModel.pf);
            if(formElement != null) {
                formElement.setAttribute('aria-hidden', true);
            }
            if(calendarModel.context) {
                _setContextTopLeft(calendarModel, element, module.activeCalendarNode);
            }
        } else {
            mainContainer.appendChild(element);
            element.style.display = "inline-block";
            if(calendarModel.context) {
                _setContextTopLeft(calendarModel, element, module.activeCalendarNode);
            } else {
                _setNonContextTopLeft(targetCalendar, element);
            }
        }
        module.active = targetCalendar.id + '-k-w-c-datepicker';
        if(kony.application.getApplicationBehavior("newCalendarskinApifeature"))
                _applySkinsnew(calendarModel);
            else
                _applySkins(calendarModel);
        _adjustFlexLayoutInCellTemplate(calendarModel);
        mainContainer = ($KU.isWindowsPhone && $KU.isIE9) ? document : mainContainer;
        mouseEvent = kony.appinit.isFirefox ? "DOMMouseScroll" : "mousewheel";
        kony.events.addEventListener(mainContainer, mouseEvent, _dismissCalendar);
        kony.events.addEventListener(window, 'scroll', _dismissCalendar);
    };
    var _trim = function(stringToTrim) {
        return stringToTrim.trim ? stringToTrim.trim() : stringToTrim.replace(/^\s+|\s+$/g, '');
    };
    var _checkTemplateDefinedForGridCell = function(calendarModel, dateString) {
        var data, date, templateData, i = 0,
            templateDate = {},
            templateDateString;

        data = calendarModel.data;
        date = _dateFormatter(calendarModel.dateformat, [dateString.date[0], dateString.date[1], dateString.date[2]]);
        templateData = Object.keys(calendarModel.data);
        for(i = 0; i < templateData.length; i++) {
            
            templateDateString = templateData[i].split('/');
            templateDate = _dateFormatter(calendarModel.dateformat, [templateDateString[0], templateDateString[1], templateDateString[2]]);
            if(templateDate.string == date.string) {
                return i;
            }
        }
        return -1;
    };
    var _convertDataMaptoData = function(calendarModel, data, templateDate) {
        var map = calendarModel.widgetdatamapforcell || {},
            masterdata = {},
            keys = $KU.getkeys(map),
            newmap = {},
            newkeys = {},
            i = 0,
            j = 0,
            value = '';

        for(i = 0; i < keys.length; i++) {
            newmap[map[keys[i]]] = keys[i];
        }
        newkeys = $KU.getkeys(newmap);
        for(j = 0; j < newkeys.length; j++) {
            value = data[templateDate][newkeys[j]];
            if(value && typeof value != "object" && typeof value !== "number" && value.toLowerCase().indexOf("i18n.getlocalizedstring") != -1) {
                masterdata[newkeys[j]] = $KU.getI18NValue(value);
            } else {
                masterdata[keys[j]] = value;
            }
        }
        return masterdata;
    };
    var _renderGridCalendarCellTemplate = function(calendarModel, dateString, element, templateIndex, templateFlag) {
        var templateDiv = document.createElement('div');

        element.appendChild(templateDiv);
        templateDiv.setAttribute('kcellTemplate', true);
        if(templateFlag == 1) {
            _adjustStyleDivForTemplateInGridCell(element.childNodes[1]);
        }
        calCellTemplate = _createClonedTemplateUsingMasterData(calendarModel, templateIndex);
        _renderAndAdjustCellTemplateDimensions(calCellTemplate, element, calendarModel);
    };
    var _renderAndAdjustCellTemplateDimensions = function(calCellTemplate, element, calendarModel) {
        var templateHTML = $KW.FlexContainer.render(calCellTemplate, {}),
            templateNode;

        element.childNodes[1].innerHTML = templateHTML;
        templateNode = element.childNodes[1].firstElementChild;
        calCellTemplate.layoutConfig = {
            self: true,
            children: true
        };
        $KW.FlexContainer.forceLayout(calCellTemplate, templateNode);
        templateNode.style.height = element.childNodes[1].style.height;
    };
    var _createClonedTemplateUsingMasterData = function(calendarModel, templateIndex) {
        var calCellTemplate = owl.deepCopy(calendarModel.celltemplate, null, false);

        if(typeof calCellTemplate == "string") {
            calCellTemplate = _kony.mvc.initializeSubViewController(calCellTemplate);
        }
        _getMasterDataAndUpdateWidgetData(calendarModel, templateIndex, calCellTemplate);
        return calCellTemplate;
    };
    var _getMasterDataAndUpdateWidgetData = function(calendarModel, templateIndex, calCellTemplate) {
        var templateData = [],
            templateDateList = [],
            cellTemplateDate = '',
            templateContainerWidgetsLength, templateWidgetModel, templateWidgetData;

        if(calendarModel.data) {
            templateDateList = Object.keys(calendarModel.data)
            cellTemplateDate = templateDateList[templateIndex];
            templateData = _convertDataMaptoData(calendarModel, calendarModel.data, cellTemplateDate);
            _updateTemplateWidgetDataWithMasterData(calCellTemplate, templateData);
        }
    };
    var _updateTemplateWidgetDataWithMasterData = function(calCellTemplate, templateData) {
        var templateContainerWidgetsLength, templateWidgetModel, templateWidgetData,
            templateContainerWidgets, widgetCount = 0;

        templateContainerWidgets = calCellTemplate.widgets();
        templateContainerWidgetsLength = templateContainerWidgets.length;
        for(widgetCount = 0; widgetCount < templateContainerWidgetsLength; widgetCount++) {
            templateWidgetModel = templateContainerWidgets[widgetCount];
            templateWidgetData = templateData[templateWidgetModel.id];
            $KW.Utils.updateChildModel(templateWidgetModel, templateWidgetData);
        }
    };
    var _adjustStyleDivForTemplateInGridCell = function(templateDivElement) {
        templateDivElement.style.position = 'absolute';
        templateDivElement.style.left = '0px';
        templateDivElement.style.top = '0px';
        templateDivElement.style.height = '100%';
        templateDivElement.style.width = '100%';
    };
    var _updateMonthData = function(monthData, calendarModel, template, dateConfig, navigators, div, id) {
        
        var divFlag, config = calendarModel.viewconfig.gridconfig || calendarModel.viewconfig.gridConfig || {},
            isWeek = config.allowWeekendSelectable,
            flag = 0,
            monthHeader, leftImage, rightImage, currentMonthValue, imageSrcNextNavigation, dateString, dayTextAlignmentInCell, imageSrcPrevNavigation, bg, j, unit, daysHeader, element, _setPrevNextMonthElementStyleNAriaLabel = function(element, config, unit, flag) {
                if(flag == 0) {
                    element.className = " -k-w-c-lastMonth " + config.gridCellInactiveDaysSkin;
                    element.setAttribute('title', 'Previous month');
                } else if(flag == 1) {
                    element.className = " -k-w-c-nextMonth " + config.gridCellInactiveDaysSkin;
                    element.setAttribute('title', 'Next month');
                }

                if(!calendarModel.hidepreviousnextmonthdates) {
                     var dateString = _dateFormatter("dddd, do mmmm yyyy", [unit[1].d, unit[1].m, unit[1].y]);
                     element.setAttribute('role', 'option');
                     currentMonthValue = dateString.string.split(',')[1];
                     element.setAttribute('aria-label', currentMonthValue);
                     element.setAttribute('aria-disabled', true);
                }
                element.removeAttribute('kwidgettype');
                element.removeAttribute('k-w-c-hold-day');
                element.setAttribute('k-w-c-date-retrieve', (unit[1].d + "," + unit[1].m + "," + unit[1].y));
                element.innerHTML = calendarModel.hidepreviousnextmonthdates ? "" : ($KG["i18nArray"] && $KG["i18nArray"]["platform.calendar." + unit[0]]) ? $KG["i18nArray"]["platform.calendar." + unit[0]] : unit[0];
            },
            _setWeekElementStyleNAriaLabel = function(element, config, unit) {
                element.innerHTML = unit;
                element.setAttribute('role', 'option');
                if(unit == "MON" || unit == "SUN") {
                    element.setAttribute('aria-label', unit.toLowerCase() + 'day');
                } else if(unit == "TUE") {
                    element.setAttribute('aria-label', 'Tuesday');
                } else if(unit == "WED") {
                    element.setAttribute('aria-label', 'Wednesday');
                } else if(unit == "THU") {
                    element.setAttribute('aria-label', 'Thursday');
                } else if(unit == "FRI") {
                    element.setAttribute('aria-label', 'Friday');
                } else if(unit == "SAT") {
                    element.setAttribute('aria-label', 'Saturday');
                }
                element.className += " " + config.dayHeaderSkin;
            },
            _setNavigatorStyleNImage = function(calendarModel, navigatorElement, configImage, id, defaultImage) {
                var templateIndex = 0,
                    templateFlag = 0;

                if(configImage) {
                    
                    
                    navigatorElement.firstChild.src = $KU.getImageURL(configImage);
                    navigatorElement.firstChild.style.cssText = "max-width:60px;max-height:40px;";
                    
                    navigatorElement.firstChild.setAttribute('kformname', calendarModel.pf);
                } else {
                    navigatorElement.firstChild.setAttribute('src', defaultImage);
                    
                }
                navigatorElement.setAttribute('k-w-c-id', id);
                navigatorElement.firstChild.setAttribute('k-w-c-id', id);
                navigatorElement.setAttribute('kwidgettype', 'Calendar');
            };
        if(div == 0) {
            div = document.createElement('div');
            div.innerHTML = template;
            div = div.firstChild;
            document.body.appendChild(div);
            divFlag = 0;
        }
        _addClass(div, config.gridSkin);
        monthHeader = _getBySele(div, '.-kony-w-c-yemo')[0];
        if(calendarModel.hideMonthsHeader == true) {
            monthHeader.style.display = "none";
        }
        daysHeader = _getBySele(div, '.-kony-w-c-daysHeader')[0];
        if(calendarModel.hideDaysHeader == true) {
            daysHeader.style.display = "none";
        }
        div.setAttribute('month', dateConfig[0]);
        div.setAttribute('year', dateConfig[1]);
        monthHeader.innerHTML = calendarMonthsValues[dateConfig[0] - 1] + ", " + dateConfig[1];
        _addClass(monthHeader, config.monthHeaderSkin);
        monthHeader.setAttribute('k-w-c-id', id);
        for(j = 0; j < monthData.length; j++) {
            unit = monthData[j],
                element = _getBySele(div, '#-kony-w-c-cell-' + (j + 1))[0];
            element.className = "";
            dayTextAlignmentInCell = _dayTextAlignmentInCell(calendarModel.dayTextAlignmentInCell);
            element.style.textAlign = dayTextAlignmentInCell['text-align'];
            element.style.verticalAlign = dayTextAlignmentInCell['vertical-align'];
            if(typeof unit == "number" || unit[3]) { 
                _setPrevNextMonthElementStyleNAriaLabel(element, config, unit, flag);
            } else if(typeof unit == "string") { 
                _setWeekElementStyleNAriaLabel(element, config, unit);
            } else {
                flag = 1;
                if((unit[2] == 0 || unit[2] == 6) && (isWeek == false)) {
                    if(kony.application.getApplicationBehavior("newCalendarskinApifeature"))
                        element.className = "";
                    else
                        element.className = " " + config.gridCellInactiveDaysSkin;
                    element.innerHTML = ($KG["i18nArray"] && $KG["i18nArray"]["platform.calendar." + unit[0]]) ? $KG["i18nArray"]["platform.calendar." + unit[0]] : unit[0];
                    element.removeAttribute('kwidgettype');
                    element.setAttribute('k-w-c-date-retrieve', (unit[1].d + "," + unit[1].m + "," + unit[1].y));
                } else {
                    element.setAttribute('k-w-c-id', id);
                    element.setAttribute('kwidgettype', "Calendar");
                    element.setAttribute('weekday', unit[2]);
                    element.className += " -k-w-c-weekday-" + unit[2] + " -kony-w-c-day-";
                    element.setAttribute('k-w-c-hold-day', (unit[1].d + "," + unit[1].m + "," + unit[1].y));
                    element.setAttribute('k-w-c-date-retrieve', (unit[1].d + "," + unit[1].m + "," + unit[1].y));
                    element.innerHTML = ($KG["i18nArray"] && $KG["i18nArray"]["platform.calendar." + unit[0]]) ? $KG["i18nArray"]["platform.calendar." + unit[0]] : unit[0];
                    dateString = _dateFormatter("dddd, do mmmm yyyy", [unit[1].d, unit[1].m, unit[1].y]);
                    
                    element.setAttribute('role', 'option');
                    
                    
                    
                    
                    currentMonthValue = dateString.string.split(',')[1];
                    element.setAttribute('aria-label', currentMonthValue);
                    if(calendarModel.celltemplate) {
                        templateIndex = _checkTemplateDefinedForGridCell(calendarModel, dateString);
                        templateFlag = 0;
                        if(templateIndex >= 0) {
                            if((document.querySelectorAll("div[id$='-k-w-c-datepicker']").length) != 0) {
                                templateFlag = 1;
                            }
                            calendarModel.celltemplate.pf = calendarModel.celltemplate.id;
                            _renderGridCalendarCellTemplate(calendarModel, dateString, element, templateIndex, templateFlag);
                        }
                    }
                }
            }
        }
        bg = $KU.getImageURL("sprite.png");
        if(navigators[0] == 1) {
            navigatorElement = _getByClass(div, '-kony-w-c-prev-nav')[0];
            imageSrcNextNavigation = config.leftNavigationImage ? config.leftNavigationImage : config.leftnavigationimage;
            leftImage = $KU.getImageURL("left-arrow.png");
            _setNavigatorStyleNImage(calendarModel, navigatorElement, imageSrcNextNavigation, id, leftImage);
        }
        if(navigators[1] == 1) {
            navigatorElement = _getByClass(div, '-kony-w-c-next-nav')[0];
            imageSrcNextNavigation = config.rightNavigationImage ? config.rightNavigationImage : config.rightnavigationimage;
            rightImage = $KU.getImageURL("right-arrow.png");
            _setNavigatorStyleNImage(calendarModel, navigatorElement, imageSrcNextNavigation, id, rightImage);
        }
        if(divFlag == 0) {
            return div;
        } else {
            return 0;
        }
    };
    var _updateEnteredDate = function(calendarModel, target, containerId) {
        var result, calenEventref, isNodeUpdated = false,
            displayDate = calendarModel.formatteddate || "",
            dates, _getDatesComponents = function(calendarModel, dates) {
                var i, dateArray = [],
                    formattedDate, index;
                for(i = 0; i < dates.length; i++) {
                    formattedDate = _dateFormatter(calendarModel.dateformat, null, dates[i], dates[i][2]);
                    if(formattedDate) {
                        index = $KU.inArray(dateArray, formattedDate.date);
                        if(!index[0]) {
                            dateArray.push(formattedDate.date);
                        }
                    } else {
                        return;
                    }
                }
                dateArray = module.setTimeInDateComponents(dateArray);
                return dateArray;
            };
        result = target.value;
        if(calendarModel.selectiontype == constants.CALENDAR_SELECTION_TYPE_RANGE_SELECT) {
            dates = result ? result.split(" - ") : [];
        } else {
            dates = result ? result.split(",") : [];
        }
        dates = _getDatesComponents(calendarModel, dates);
        if(dates) {
            if(module.isSelectedDatesValid(calendarModel, dates)) {
                calendarModel.selectedDates = module.setTimeInDateComponents(dates);
                displayDate = _getDisplayDate(calendarModel);
                isNodeUpdated = true;
            } else {
                kony.web.logger("error", "Invalid date selection");
            }
        }
        target.value = displayDate;
        if(isNodeUpdated) {
            if(containerId) {
                calendarModel.selecteddates = calendarModel.selectedDates;
                $KW.Utils.updateContainerData(calendarModel, target.parentNode, false);
            }
            calenEventref = $KU.returnEventReference(calendarModel.ondone);
            calenEventref && $KU.callTargetEventHandler(calendarModel, target, "ondone");
        }
    };
    var _updateModelByContainerData = function(calendarModel, target, id, containerId) {
        var containerModel = $KW.Utils.getContainerModelById(target, containerId),
            dataIndex, calData, context, colInfo, row, cell, data;
        if(!containerModel)
            return;

        if(containerModel.wType == 'DataGrid') {
            row = $KU.getParentByAttribute(target, "index");
            cell = $KU.getParentByAttribute(target, "colindex");
            dataIndex = row.getAttribute("index");
            if(dataIndex == "0") {
                colInfo = containerModel.columnheadersconfig[cell.cellIndex];
                data = colInfo.columnheadertemplate.data;
            } else {
                data = containerModel.data[dataIndex][cell.id];
            }
        } else if(containerModel.wType == 'Segment') {
            context = $KW.Segment.getContextByNode(containerModel, target);
            if(containerModel.hasSections) {
                if(context.rowIndex == -1) {
                    data = containerModel.data[context.sectionIndex][0];
                } else {
                    data = containerModel.data[context.sectionIndex][1][context.rowIndex];
                }
            } else {
                data = containerModel.data[context.rowIndex];
            }
        } else if(containerModel.wType == 'CollectionView') {
            context = $KW.CollectionView.Utils.getContextByNode(containerModel, target);
            if(containerModel.hasSections) {
                if(context.itemIndex == -1) {
                    data = containerModel.data[context.sectionIndex][0];
                } else if(context.itemIndex == -2) {
                    data = containerModel.data[context.sectionIndex][2];
                } else {
                    data = containerModel.data[context.sectionIndex][1][context.itemIndex];
                }
            } else {
                data = containerModel.data[context.itemIndex];
            }
        }
        calData = data[calendarModel.id];
        if(calData) {
            if(module.isMultiRangeCalendar(calendarModel)) {
                calendarModel.selecteddates = calendarModel.selectedDates;
            } else {
                calendarModel.datecomponents = calData.dateComponents;
                calendarModel.dateformat = calendarModel.format = calData.dateFormat;
            }
        }
    };
    

    var module = {
        initialize: function() {
            kony.events.addEvent("click", "Calendar", _eventHandler);
            kony.events.addEvent("onorientationchange", "Calendar", _reposition);
            kony.events.addEvent("keydown", "Calendar", _eventHandlerImgIcon);
        },
        
        initializeView: function() {
            calendarDaysValue = (function() {
                var defaultDayValues = ['SUN', 'MON', 'TUE', 'WED', 'THU', 'FRI', 'SAT'],
                    localData = [],
                    i18Sunday, i18Monday, i18Tuesday, i18Wednesday, i18Thursday, i18Friday, i18Saturday;
                if($KG["i18nArray"] && $KG["i18nArray"]["weekdayI18Nkey"]) {
                    var localData = kony.i18n.getLocalizedString("weekdayI18Nkey");
                    if(localData) {
                        return localData.split(',');
                    } else {
                        return defaultDayValues;
                    }
                } else {
                    if($KG["i18nArray"]) {
                        i18Sunday = $KG["i18nArray"]["platform.calendar.sunday"] ? kony.i18n.getLocalizedString("platform.calendar.sunday") : defaultDayValues[0];
                        localData.push(i18Sunday);
                        i18Monday = $KG["i18nArray"]["platform.calendar.monday"] ? kony.i18n.getLocalizedString("platform.calendar.monday") : defaultDayValues[1];
                        localData.push(i18Monday);
                        i18Tuesday = $KG["i18nArray"]["platform.calendar.tuesday"] ? kony.i18n.getLocalizedString("platform.calendar.tuesday") : defaultDayValues[2];
                        localData.push(i18Tuesday);
                        i18Wednesday = $KG["i18nArray"]["platform.calendar.wednesday"] ? kony.i18n.getLocalizedString("platform.calendar.wednesday") : defaultDayValues[3];
                        localData.push(i18Wednesday);
                        i18Thursday = $KG["i18nArray"]["platform.calendar.thursday"] ? kony.i18n.getLocalizedString("platform.calendar.thursday") : defaultDayValues[4];
                        localData.push(i18Thursday);
                        i18Friday = $KG["i18nArray"]["platform.calendar.friday"] ? kony.i18n.getLocalizedString("platform.calendar.friday") : defaultDayValues[5];
                        localData.push(i18Friday);
                        i18Saturday = $KG["i18nArray"]["platform.calendar.saturday"] ? kony.i18n.getLocalizedString("platform.calendar.saturday") : defaultDayValues[6];
                        localData.push(i18Saturday);
                    }
                    if(localData.length > 0) {
                        return localData;
                    } else {
                        return defaultDayValues;
                    }
                }
            }());
            calendarMonthsValues = (function() {
                var localData = [],
                    i18January, i18February, i18March, i18April, i18May, i18June, i18July, i18August, i18September, i18October, i18November, i18December, defaultMonthValues = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
                if($KG["i18nArray"] && $KG["i18nArray"]["monthI18Nkey"]) {
                    localData = kony.i18n.getLocalizedString("monthI18Nkey");
                    if(localData) {
                        return localData.split(',');
                    } else {
                        return defaultMonthValues;
                    }
                } else {
                    if($KG["i18nArray"]) {
                        i18January = $KG["i18nArray"]["platform.calendar.january"] ? kony.i18n.getLocalizedString("platform.calendar.january") : defaultMonthValues[0];
                        localData.push(i18January);
                        i18February = $KG["i18nArray"]["platform.calendar.february"] ? kony.i18n.getLocalizedString("platform.calendar.february") : defaultMonthValues[1];
                        localData.push(i18February);
                        i18March = $KG["i18nArray"]["platform.calendar.march"] ? kony.i18n.getLocalizedString("platform.calendar.march") : defaultMonthValues[2];
                        localData.push(i18March);
                        i18April = $KG["i18nArray"]["platform.calendar.april"] ? kony.i18n.getLocalizedString("platform.calendar.april") : defaultMonthValues[3];
                        localData.push(i18April);
                        i18May = $KG["i18nArray"]["platform.calendar.may"] ? kony.i18n.getLocalizedString("platform.calendar.may") : defaultMonthValues[4];
                        localData.push(i18May);
                        i18June = $KG["i18nArray"]["platform.calendar.june"] ? kony.i18n.getLocalizedString("platform.calendar.june") : defaultMonthValues[5];
                        localData.push(i18June);
                        i18July = $KG["i18nArray"]["platform.calendar.july"] ? kony.i18n.getLocalizedString("platform.calendar.july") : defaultMonthValues[6];
                        localData.push(i18July);
                        i18August = $KG["i18nArray"]["platform.calendar.august"] ? kony.i18n.getLocalizedString("platform.calendar.august") : defaultMonthValues[7];
                        localData.push(i18August);
                        i18September = $KG["i18nArray"]["platform.calendar.september"] ? kony.i18n.getLocalizedString("platform.calendar.september") : defaultMonthValues[8];
                        localData.push(i18September);
                        i18October = $KG["i18nArray"]["platform.calendar.october"] ? kony.i18n.getLocalizedString("platform.calendar.october") : defaultMonthValues[9];
                        localData.push(i18October);
                        i18November = $KG["i18nArray"]["platform.calendar.november"] ? kony.i18n.getLocalizedString("platform.calendar.november") : defaultMonthValues[10];
                        localData.push(i18November);
                        i18December = $KG["i18nArray"]["platform.calendar.december"] ? kony.i18n.getLocalizedString("platform.calendar.december") : defaultMonthValues[11];
                        localData.push(i18December);
                    }
                    if(localData.length > 0) {
                        return localData;
                    } else {
                        return defaultMonthValues;
                    }
                }
            }());
        },
        updateView: function(widgetModel, propertyName, propertyValue, oldPropertyValue) {
            var element = $KU.getNodeByModel(widgetModel), dateValue,
                isValid, node, mode, imageElement, contentAlignment, childNodes = [];

            element = $KW.Utils.getClonedTemplateNode(element, widgetModel, propertyName);
            switch(propertyName) {
                case "date":
                    dateValue = _ideDateToString(widgetModel.date);
                    if(!dateValue) break;
                    widgetModel.entereddate = dateValue;
                    isValid = $KU.isValidDate(dateValue, "dd/mm/yyyy");
                    if(isValid) {
                        widgetModel.day = propertyValue[0];
                        widgetModel.month = propertyValue[1];
                        widgetModel.year = propertyValue[2];
                        this.updateCalDOMNode(widgetModel, element);
                    }
                    break;
                    case "hidePreviousNextMonthDates":
                            this.updateCalDOMNode(widgetModel, element);
                            break;
                    case "skinPriorityList":
                            this.updateCalDOMNode(widgetModel, element);
                            break;


                case "calendariconalignment":
                    childNodes = element.childNodes;

                    if(propertyValue === constants.CALENDAR_ICON_ALIGN_LEFT && childNodes[1].tagName === "IMG") {
                        element.insertBefore(childNodes[1], childNodes[0]);
                    } else if(propertyValue === constants.CALENDAR_ICON_ALIGN_RIGHT && childNodes[0].tagName === "IMG") {
                        element.insertBefore(childNodes[0], childNodes[2]);
                    } else if(propertyValue === constants.CALENDAR_ICON_ALIGN_AUTO) {
                        contentAlignment = widgetModel.contentAlignment;
                        if((contentAlignment === constants.CONTENT_ALIGN_MIDDLE_LEFT || contentAlignment === constants.CONTENT_ALIGN_CENTER)
                           && childNodes[0].tagName === "IMG") {
                            element.insertBefore(childNodes[0], childNodes[2]);
                        } else if(contentAlignment === constants.CONTENT_ALIGN_MIDDLE_RIGHT && childNodes[1].tagName === "IMG") {
                            element.insertBefore(childNodes[1], childNodes[0]);
                        }
                    }
                    break;

                case "datecomponents":
                    widgetModel.day = propertyValue[0];
                    widgetModel.month = propertyValue[1];
                    widgetModel.year = propertyValue[2];
                    widgetModel.hour = 0; 
                    widgetModel.minutes = 0; 
                    widgetModel.seconds = 0; 
                    this.updateCalDOMNode(widgetModel, element);
                    break;

                case "placeholder":
                    node = document.getElementById(widgetModel.id);
                    if(node && (node.value.indexOf('/') > -1 || node.value.indexOf('-') > -1)) {
                        return false;
                    }
                    propertyValue = propertyValue || widgetModel.dateformat || widgetModel.format;
                    if(widgetModel.placeholder != propertyValue) {
                        widgetModel.placeholder = propertyValue;
                    }
                    node && node.setAttribute("placeholder", widgetModel.placeholder);
                    break;

                case "calendaricon":
                    if(element) {
                        imageElement = _getCalImageNode(element);
                        imageElement.src = $KU.getImageURL(propertyValue);
                    }
                    widgetModel.Image = propertyValue;
                    break;

                case "dateformat":
                    this.updateCalDOMNode(widgetModel, element);
                    break;

                case "validstartdate":
                case "startdate":
                    if(kony.application.getApplicationBehavior("newCalendarskinApifeature")) {
                        if(startlessthanend(widgetModel)) {
                            if(!_isValidDateComponents(widgetModel)) {
                                widgetModel.validstartdate=oldPropertyValue;
                                kony.web.logger("error", "selected Dates cant be disabled");

                            }
                        }
                        else {
                            widgetModel.validstartdate=oldPropertyValue;
                            kony.web.logger("error", "start Date should be less than end date");
                        }
                    }
                    else {
                        if(!_isValidDateComponents(widgetModel)) {
                            module.clear(widgetModel);
                        }

                    }
                    break;


                case "validenddate":
                case "enddate":
                    if(kony.application.getApplicationBehavior("newCalendarskinApifeature")) {
                        if(startlessthanend(widgetModel)) {
                            if(!_isValidDateComponents(widgetModel)) {
                                widgetModel.validenddate=oldPropertyValue;
                                kony.web.logger("error", "selected Dates cant be disabled");

                            }
                        }
                        else {
                            widgetModel.validenddate=oldPropertyValue;
                            kony.web.logger("error", "start Date should be less than end date");
                        }
                    }
                    else {
                        if(!_isValidDateComponents(widgetModel)) {
                            module.clear(widgetModel);
                        }

                    }
                    break;

                case "titleonpopup":
                    widgetModel.title = propertyValue;
                    break;

                case "selecteddates":
                    this.updateCalDOMNode(widgetModel, element);
                    break;

                case "selectiontype":
                    module.destroyCalendar();
                    module.clear(widgetModel);
                    break;

                case "gridtheme":
                    module.destroyCalendar();
                    break;
                case "dateeditable":
                    mode = widgetModel.dateEditable;
                    if(element) {
                        if(!mode) {
                            element.firstChild.setAttribute('readonly', 'readonly');
                        } else {
                            element.firstChild.removeAttribute('readonly');
                        }
                    }
                    break;
            }
        },
        
        render: function(calendarModel, context) {
            var computedSkin = $KW.skins.getWidgetSkinList(calendarModel, context),
                htmlString = "",
                marginPaddding = $KW.skins.getBaseStyle(calendarModel, context),
                dateObj = {},
                kmasterObj = $KW.Utils.getMasterIDObj(calendarModel),
                id = (kmasterObj.id != "") ? kmasterObj.id : calendarModel.pf + "_" + calendarModel.id;

            if(calendarModel.viewtype === constants.CALENDAR_VIEW_TYPE_GRID_POPUP || calendarModel.viewtype === "default") {
                _initializeCalendarModel(calendarModel);
                module.updateCalDOMNode(calendarModel);
                if(context.ispercent === false) {
                    marginPaddding += " display: inline-block;"
                }
                htmlString = "<div kwidgetid='" + id + "' " + $KW.Utils.getBaseHtml(calendarModel, context) + " class='" + computedSkin + "'";
                htmlString += " style='text-align:" + $KW.skins.getContentAlignment(calendarModel) + "; vertical-align: middle;" + marginPaddding;
                htmlString += "'>";
                
                htmlString += _generateCalenderString(calendarModel, context);
                htmlString += "</div>";
            }
            return htmlString;
        },
        adjustCalendars: function(container) {
            var calElements = document.querySelectorAll("#" + container.pf + "_" + container.id + " input[name='calBody']");
            for(var i = 0; i < calElements.length; i++) {
                var calElement = calElements[i];
                module.setCalElementStyle(calElement, true);
            }
        },
        calendarTextfieldChangeEventHandler: function(eventObject, target) {
            var calendarNode = target.parentNode,
                calendarId = calendarNode.getAttribute("id"),
                calendarModel, containerId = calendarNode.getAttribute("kcontainerid"),
                dateValue, currentDate = new Date(), isValidDate,
                validStartDateSet, validEndDateSet, calenEventref, resultString, result;

            if(target.getAttribute("kmasterid")) {
                calendarModel = $KU.getWidgetModelByID(target.getAttribute("kformname") + "_" + $KU.getElementID(calendarId));
            } else {
                calendarId = calendarId.split("_").length > 2 ? calendarId.substring(0, calendarId.lastIndexOf("_")) : calendarId;
                calendarModel = kony.model.getWidgetModel(target.getAttribute("kformname"), $KU.getElementID(calendarId), target.getAttribute("ktabpaneid"));
            }
            if(containerId) {
                calendarModel = $KW.Utils.getClonedModelByContainer(calendarModel, target.parentNode, containerId);
            }
            dateValue = target.value;
            if(dateValue.length == 0) {
                calendarModel.clear();
                if(containerId) {
                    $KW.Utils.updateContainerData(calendarModel, calendarNode, false);
                }
                return false;
            }
            if(module.isMultiRangeCalendar(calendarModel)) {
                _updateEnteredDate(calendarModel, target, containerId);
                return;
            }
            result = _dateFormatter(calendarModel.dateformat, null, dateValue, calendarModel.dateComponents[2]);
            if(calendarModel.validstartdate) {
                validStartDateSet = new Date(calendarModel.validstartdate[2], calendarModel.validstartdate[1] - 1, calendarModel.validstartdate[0]);
            }
            if(calendarModel.validenddate) {
                validEndDateSet = new Date(calendarModel.validenddate[2], calendarModel.validenddate[1] - 1, calendarModel.validenddate[0]);
            }
            if(result) {
                resultString = new Date(result.date[2], result.date[1] - 1, result.date[0]);
                if((validStartDateSet && !(validStartDateSet <= resultString)) ||
                    (validEndDateSet && !(resultString <= validEndDateSet))) {
                    alert("Date is not set in the valid range. Please try again");
                    target.value = calendarModel.formatteddate || "";
                    return false;
                }
            }
            if(dateValue.length > 0 && calendarModel.dateComponents) {
                if(result != false) {
                    isValidDate = true;
                    calendarModel.dateComponents = result.date;
                    target.className = target.className.replace('konyplaceholder', "");
                    target.value = result.string;
                    if(containerId) {
                        calendarModel.datecomponents = calendarModel.date = result.date.slice(0, 3);
                    }
                    calendarModel._startG = calendarModel.datecomponents;
                    calendarModel.month = calendarModel.datecomponents[1];
                    calendarModel.day = calendarModel.datecomponents[0];
                    calendarModel.year = calendarModel.datecomponents[2];
                    if(containerId) {
                        $KW.Utils.updateContainerData(calendarModel, calendarNode, false);
                    }
                    calendarModel.minutes = currentDate.getMinutes();
                    calendarModel.hour = currentDate.getHours();
                    calendarModel.seconds = currentDate.getSeconds();

                } else {
                    isValidDate = false;
                    target.value = calendarModel.formatteddate || "";
                }
                calenEventref = $KU.returnEventReference(calendarModel.ondone);
                calenEventref && $KU.executeWidgetEventHandler(calendarModel, calenEventref,  isValidDate);
            }
        },
        clear: function(calendarModel) {
            var calendarElement = $KU.getNodeByModel(calendarModel);
            
            
            
            calendarModel.datecomponents = [null, null, null];
            calendarModel.entereddate = null;
            calendarModel.date = null;
            calendarModel.formatteddate = null;
            calendarModel.day = null;
            calendarModel.month = null;
            calendarModel.year = null;
            calendarModel.seconds = null;
            calendarModel.minutes = null;
            calendarModel.hour = null;
            calendarModel.selecteddates = [];
            if(module.isMultiRangeCalendar(calendarModel)) {
                calendarElement = $KW.Utils.getClonedTemplateNode(calendarElement, calendarModel, "selecteddates");
            } else {
                calendarElement = $KW.Utils.getClonedTemplateNode(calendarElement, calendarModel, "datecomponents");
            }
            if(calendarElement) {
                calendarElement = _getCalInputNode(calendarElement);
                calendarElement.value = "";
            }
            if(!kony.utils.placeholderSupported && calendarElement) {
                calendarModel.placeholder = calendarModel.placeholder || calendarModel.dateformat || calendarModel.format;
                calendarElement.value = calendarModel.placeholder;
                $KU.addClassName(calendarElement, 'konyplaceholder');
            }
        },
        destroyCalendar: function(ele, calendarElementID, targetWidget) {
            var elements, element, main, i, mouseEvent, calendarImgElement;
            _removeTabIndexs();
            if(!ele) {
                elements = document.querySelectorAll("div[id$='-k-w-c-datepicker'],.k-w-c-scrim-for-popup");
                for(i = 0, l = elements.length; i < l; i++) {
                    elements[i].parentNode.removeChild(elements[i]);
                    if($KU.isIE && targetWidget) {
                        if(targetWidget.getAttribute("kwidgettype") == "CalendarText" || targetWidget.getAttribute("kwidgettype") == "TextField") {
                            targetWidget.focus();
                        }
                    }
                }
            } else {
                elements = document.querySelectorAll('.k-w-c-scrim-for-popup')[0];
                element = document.getElementById(module.active);
                element && element.parentNode.removeChild(element);
                elements && elements.parentNode.removeChild(elements);
            }
            if(module.activeCalendarNode) {
                calendarImgElement = module.activeCalendarNode.querySelector('img');
                calendarImgElement.focus();
            }
            module.activeCalendarNode = null;
            main = ($KU.isWindowsPhone && $KU.isIE9) ? document : document.getElementById("__MainContainer");
            mouseEvent = kony.appinit.isFirefox ? "DOMMouseScroll" : "mousewheel";
            kony.events.removeEventListener(main, mouseEvent, _dismissCalendar);
            kony.events.removeEventListener(window, 'scroll', _dismissCalendar);
        },
        dismiss: function(model) {
            _dismissCalendar();
        },
        displayedMonth: function(model, month, year) {
            var ser = _series(year, month, (model.noofmonths || 1) * 1 + 1),
                ele = $KU.getNodeByModel(model);
            ele = $KW.Utils.getClonedTemplateNode(ele, model);
            if(!ele) return false;
            module.destroyCalendar(1);
            model.displayedMonths = [month, year];
            _reAssignData(model);
            _show(model, ele, ser, 1);
        },
        getDat: function(date, model) {
            var format, i;
            if(!date) return;
            format = (model.dateformat || model.format).toLowerCase().replace(/^\s+|\s+$/g, '').split('/'),
                result = {};
            date = date.split('/');
            for(i = 0; i < format.length; i++) {
                result[format[i]] = date[i];
            }
            return result;
        },
        isMultiRangeCalendar: function(calendarModel) {
            if((calendarModel.viewtype === constants.CALENDAR_VIEW_TYPE_GRID_POPUP ||
                    calendarModel.viewtype === "default") &&
                (calendarModel.selectiontype == constants.CALENDAR_SELECTION_TYPE_RANGE_SELECT ||
                    calendarModel.selectiontype == constants.CALENDAR_SELECTION_TYPE_MULTI_SELECT)) {
                return true;
            }
            return false;
        },
        isRangeCalendar: function(calendarModel) {
            if((calendarModel.viewtype === constants.CALENDAR_VIEW_TYPE_GRID_POPUP ||
                    calendarModel.viewtype === "default") &&
                (calendarModel.selectiontype == constants.CALENDAR_SELECTION_TYPE_RANGE_SELECT ) ){
                return true;
            }
            return false;
        },
        navigateToNextMonth: function(model) {
            var mn = model.displayedMonths[0],
                yy = model.displayedMonths[1],
                ser;
            _reAssignData(model);
            if(mn == 12) {
                mn = 1;
                yy = yy + 1;
            } else {
                mn = mn + 1;
            }
            ser = _series(yy, mn, (model.noofmonths || 1));
            module.displayedMonth(model, ser[0][0], ser[0][1]);
        },
        navigateToPreviousMonth: function(model) {
            var mn = model.displayedMonths[0],
                yy = model.displayedMonths[1],
                ser;
            _reAssignData(model);
            if(mn == 1) {
                mn = 12;
                yy = yy - 1;
            } else {
                mn = mn - 1;
            }
            ser = _series(yy, mn, (model.noofmonths || 1));
            module.displayedMonth(model, ser[0][0], ser[0][1])
        },
        open: function(model) {
            var node = $KU.getNodeByModel(model);
            node = $KW.Utils.getClonedTemplateNode(node, model);
            _eventHandler(null, node);
        },
        
        setCalElementStyle: function(calendarElement, inOrientation) {
            var calendarNode, calendarModel, calendarWrapperNode, textfieldElement, imageElement, calendarNodeStyle, calendarWrapperNodeStyle, imageElementWidth, calculatedWidth, wrapperWidth, radius, _addCalendarNodeBorderRadius = function(calendarNodeStyle, textfieldElement, imageElement) {
                    var topLeftRadius, bottomLeftRadius, topRightRadius, bottomRightRadius, rightRadius, leftRadius;
                    if(calendarNodeStyle["border-top-left-radius"])
                        topLeftRadius = parseInt(calendarNodeStyle["border-top-left-radius"].substring(0, calendarNodeStyle["border-top-left-radius"].indexOf("p")));
                    if(calendarNodeStyle["border-bottom-left-radius"])
                        bottomLeftRadius = parseInt(calendarNodeStyle["border-bottom-left-radius"].substring(0, calendarNodeStyle["border-bottom-left-radius"].indexOf("p")));
                    if(calendarNodeStyle["border-top-right-radius"])
                        topRightRadius = parseInt(calendarNodeStyle["border-top-right-radius"].substring(0, calendarNodeStyle["border-top-right-radius"].indexOf("p")));
                    if(calendarNodeStyle["border-bottom-right-radius"])
                        bottomRightRadius = parseInt(calendarNodeStyle["border-bottom-right-radius"].substring(0, calendarNodeStyle["border-bottom-right-radius"].indexOf("p")));

                    if(topLeftRadius <= bottomLeftRadius) {
                        leftRadius = parseInt(bottomLeftRadius / 2);
                        textfieldElement.style.marginLeft = leftRadius + 'px';
                    } else {
                        leftRadius = parseInt(topLeftRadius / 2);
                        textfieldElement.style.marginLeft = leftRadius + 'px';
                    }

                    if(topRightRadius <= bottomRightRadius) {
                        rightRadius = parseInt(bottomRightRadius / 2);
                        imageElement.style.marginRight = rightRadius + 'px';
                    } else {
                        rightRadius = parseInt(topRightRadius / 2);
                        imageElement.style.marginRight = rightRadius + 'px';
                    }

                    return {
                        "right": rightRadius,
                        "left": leftRadius
                    };
                },
                _setFontToTextField = function(calendarNode, textFieldNode) {
                    textfieldElement.style.fontFamily = calendarNodeStyle["font-family"];
                    textfieldElement.style.fontSize = calendarNodeStyle["font-size"];
                    textfieldElement.style.color = calendarNodeStyle["color"];
                    textfieldElement.style.fontWeight = calendarNodeStyle["font-weight"];
                    textfieldElement.style.fontStyle = calendarNodeStyle["font-style"];
                };
            textfieldElement = calendarElement;
            if(!inOrientation) {
                textfieldElement = _getCalInputNode(calendarElement.parentNode);
            }
            if(!textfieldElement) return;
            calendarNode = textfieldElement.parentNode;
            calendarModel = $KU.getModelByNode(calendarNode);
            if(calendarNode.style.display != "inline-block") {
                imageElement = _getCalImageNode(textfieldElement.parentNode);
                calendarWrapperNode = calendarNode.parentNode;

                calendarNodeStyle = $KU.getComputedStyle(calendarNode);
                _setFontToTextField(calendarNodeStyle, textfieldElement)
                if(calendarModel && calendarModel.calimgheight) {
                    imageElement.style.height = calendarModel.calimgheight;
                } else {
                    imageElement.style.height = textfieldElement.clientHeight + "px";
                }
                imageElement.style.width = "auto";

                radius = _addCalendarNodeBorderRadius(calendarNodeStyle, textfieldElement, imageElement);

                if(!calendarWrapperNode) return;

                calendarWrapperNodeStyle = $KU.getComputedStyle(calendarWrapperNode);
                wrapperWidth = calendarWrapperNodeStyle.width;
                if(wrapperWidth == "100%") {
                    wrapperWidth = calendarWrapperNode.clientWidth + 'px';
                }
                wrapperWidth = parseInt(wrapperWidth.substring(0, wrapperWidth.indexOf("p")));

                imageElementWidth = $KU.getComputedStyle(imageElement).width;
                if(imageElementWidth == "auto") {
                    imageElementWidth = imageElement.clientWidth + 'px';
                } else {
                    imageElementWidth = parseInt(imageElementWidth.substring(0, imageElementWidth.indexOf("p")));

                    if(!wrapperWidth) {
                        wrapperWidth = calendarWrapperNode.offsetWidth;
                    }
                    calculatedWidth = ((wrapperWidth - (2 * imageElementWidth) - radius.left - radius.right) / wrapperWidth) * 100;
                    if(isFinite(calculatedWidth)) {
                        textfieldElement.style.width = calculatedWidth + '%';
                    }
                }
            }
        },
        setcontext: function(popupModel, context) {
            if(popupModel instanceof Object && context instanceof Object) {
                popupModel.context = context;
            }
        },
        setDateSkin: function(calendarModel, dates, skin) {
            var i;
            for(i = 0, l = dates.length; i < l; i++) {
                if(kony.application.getApplicationBehavior("overrideCalendarSetDatesSkin")
                || $KG.appbehaviors[constants.API_LEVEL] >= constants.API_LEVEL_8400) {
                    calendarModel.specialDates = {};  
                    calendarModel.specialDates[skin] = dates;
                } else {
                    calendarModel.specialDates = calendarModel.specialDates || {};
                    if(!calendarModel.specialDates[skin]) {
                        calendarModel.specialDates[skin] = dates;
                    } else {
                        calendarModel.specialDates[skin].push.apply(calendarModel.specialDates[skin], dates);
                    }
                }
            }
        },
        setEnableAll: function(calendarModel) {
            calendarModel.datesGroup = "";
            calendarModel.datesGroupSimplified = "";
        },
        setEnabled: function(calendarModel, startdate, enddate, skin, isEnable) {
            var j, value, datesAll, datesComp, from, to;
            calendarModel.datesState = (isEnable == true ? 1 : 0);
            calendarModel.datesGroupSkin = skin;
            datesAll = [];
            if(startdate && startdate.length > 0 && startdate[0] instanceof Array) {
                calendarModel.datesGroup = startdate;
                datesComp = calendarModel.datesGroup;
                for(j = 0; j < datesComp.length; j++) {
                    value = datesComp[j];
                    if(value.length == value.length) {
                        datesAll.push(new Date(value[2], value[1] - 1, value[0]).setHours(0, 0, 0, 0));
                    }
                }
            } else {
                from = new Date(startdate[2], startdate[1] - 1, startdate[0]);
                to = new Date(enddate[2], enddate[1] - 1, enddate[0]);
                datesAll.push.apply(datesAll, _between(from, to));
            }
            calendarModel.datesGroupSimplified = datesAll;
        },
        setEnableAllnew: function(calendarModel, flag) {
            if(flag) {
                calendarModel.datesGroup = "";
                calendarModel.datesGroupSimplified = "";
                calendarModel.setenabled_dates = "";
                calendarModel.enablerangeofdates_Dates = "";
                calendarModel.enablerangeofdates_startDate="";
                calendarModel.enablerangeofdates_endDate="";
                calendarModel.validstartdate = "";
                calendarModel.validenddate = "";
            }
            else {
                module.setEnabled(calendarModel, null, null, "", flag);
            }
        },
        setEnablednew: function(calendarModel, startdate, enddate, skin, isEnable) {
            _addClass("","");
            var j, value, dates_enablerangeofdates, dates_setenabled , datesComp, from, to;
                calendarModel.datesState = (isEnable == true ? 1 : 0);
            var maxYearLimit = 2099,
                minYearLimit = 1900;

                dates_enablerangeofdates = [];
                dates_setenabled = [];

            var selectedDate = module.isRangeCalendar(calendarModel) ? getRangeofDates(calendarModel.selecteddates): _getselectedDates(calendarModel, calendarModel.selecteddates);
            if(startdate && startdate.length > 0 && startdate[0] instanceof Array) {
                calendarModel.setenablestate = (isEnable == true ? 1 : 0);
                calendarModel.setenableSkin = skin;
                calendarModel.datesGroup = startdate;
                datesComp = calendarModel.datesGroup;
                for(j = 0; j < datesComp.length; j++) {
                    value = datesComp[j];
                    if(value.length == value.length) {
                        dates_setenabled.push(new Date(value[2], value[1] - 1, value[0]).setHours(0, 0, 0, 0));
                    }
                }
                calendarModel.setenabled_dates = dates_setenabled;

                   if(!isvalidrangeofselection(calendarModel, selectedDate)) {
                      calendarModel.setenabled_dates = [];
                    kony.web.logger("error", "selected Dates cant be disabled");
                    }

            }
            else {
                if(startdate && startdate != null && startdate != "" && startdate != [] && startdate.indexOf(null) === -1)
                    from = new Date(startdate[2], startdate[1] - 1, startdate[0]).setHours(0,0,0,0);
                else
                    from = new Date(1900,0,1).setHours(0,0,0,0);
                if(enddate && enddate != null && enddate != [] && enddate != "" && enddate.indexOf(null) === -1)
                    to = new Date(enddate[2], enddate[1] - 1, enddate[0]).setHours(0,0,0,0);
                else
                    to = new Date(2099,11,31).setHours(0,0,0,0);
                var oldstart = calendarModel.enablerangeofdates_startDate;
                var oldend = calendarModel.enablerangeofdates_endDate;
                var oldstate = calendarModel.enablerangeofdates_state;
                var oldskin = calendarModel.enablerangeofdatesSkin;
                calendarModel.startDate = from;
                calendarModel.endDate = to;
                calendarModel.enablestate = (isEnable == true ? 1 : 0);

                if(from.valueOf() <= to.valueOf()) {
                    
                    
                    var oldstart = calendarModel.enablerangeofdates_startDate;
                    var oldend = calendarModel.enablerangeofdates_endDate;
                    var oldstate = calendarModel.enablerangeofdates_state;
                    var oldskin = calendarModel.enablerangeofdatesSkin;
                    calendarModel.startDate = from;
                    calendarModel.endDate = to;
                    calendarModel.enablestate = (isEnable == true ? 1 : 0);


                        if(isvalidrangeofselection(calendarModel, selectedDate)) {
                            calendarModel.enablerangeofdates_startDate = from;
                            calendarModel.enablerangeofdates_endDate = to;
                            calendarModel.validstartdate = "";
                            calendarModel.validenddate ="";
                            calendarModel.enablerangeofdates_state = (isEnable == true ? 1 : 0);
                            calendarModel.enablerangeofdatesSkin = skin;
                            calendarModel.startDate = from;
                            calendarModel.endDate = to;
                            calendarModel.enablestate = calendarModel.enablerangeofdates_state;


                        }
                        else {
                           
                           calendarModel.enablerangeofdates_startDate = oldstart;
                           calendarModel.enablerangeofdates_endDate = oldend;
                           calendarModel.enablerangeofdates_state = oldstate;
                           calendarModel.enablerangeofdatesSkin = oldskin;
                           calendarModel.startDate = oldstart;
                           calendarModel.endDate = oldend;
                           calendarModel.enablestate = oldstate;

                           kony.web.logger("error", "Selected Dates cant be disabled");
                        }

                }
                else {
                    calendarModel.enablerangeofdates_startDate = oldstart;
                    calendarModel.enablerangeofdates_endDate = oldend;
                    calendarModel.enablerangeofdates_state = oldstate;
                    calendarModel.enablerangeofdatesSkin = oldskin;
                    calendarModel.startDate = oldstart;
                    calendarModel.endDate = oldend;
                    calendarModel.enablestate = oldstate;
                    kony.web.logger("error", "Invalid Date range");


                }
            }


        },

        isSelectedDatesValid: function(calendarModel, value) {
            var isValidRange, isValid = false;
            if(value instanceof Array && value.length > 0) {
                if(calendarModel.selectiontype == constants.CALENDAR_SELECTION_TYPE_RANGE_SELECT) {
                    if(value.length == 2) {
                        if(kony.application.getApplicationBehavior("newCalendarskinApifeature")){
                           isValidRange = _isToGtFromDate(value[0], value[1]);
                           isValid = isValidRange && _isDateEnabled(calendarModel, value) && isvalidrangeofselection(calendarModel, getRangeofDates(value));

                        }
                        else {
                            isValidRange = _isToGtFromDate(value[0], value[1]);
                            isValid = isValidRange && _isDateEnabled(calendarModel, value);
                        }
                    }
                } else {
                    isValid = _isDateEnabled(calendarModel, value);
                }
            } else if(value == undefined || value.length == 0) {
                isValid = true;
            }
            return isValid;
        },
        setTimeInDateComponents: function(dateComponents) {
            var i;
            if(dateComponents instanceof Array) {
                for(i = 0; i < dateComponents.length; i++) {
                    if(!dateComponents[i][3]) dateComponents[i][3] = 0;
                    if(!dateComponents[i][4]) dateComponents[i][4] = 0;
                    if(!dateComponents[i][5]) dateComponents[i][5] = 0;
                }
                return dateComponents;
            }
        },
        
        updateCalDOMNode: function(calendarModel, element) {
            var dateValue = "",
                strDay = "",
                strMonth = "",
                result, calInput;
            if(module.isMultiRangeCalendar(calendarModel)) {
                dateValue = _getDisplayDate(calendarModel);
                calendarModel.formatteddate = dateValue;
                if(element) {
                    calInput = _getCalInputNode(element);
                    calInput.value = dateValue;
                }
            } else {
                if(!calendarModel.datecomponents) {
                    return false;
                }
                calendarModel.day = calendarModel.datecomponents[0];
                calendarModel.month = calendarModel.datecomponents[1];
                calendarModel.year = calendarModel.datecomponents[2];
                if(calendarModel.day && calendarModel.month && calendarModel.year) {
                    result = _dateFormatter(calendarModel.dateformat, [calendarModel.day, calendarModel.month, calendarModel.year]);
                    if(result != false) {
                        dateValue = result.string;
                    }
                    if(element) {
                        calInput = _getCalInputNode(element);
                        calInput.value = dateValue;
                    }
                    calendarModel.formatteddate = dateValue;
                    calendarModel.selectdate = strMonth + "/" + strDay + "/" + calendarModel.year;
                    calendarModel.pagedate = strMonth + "/" + calendarModel.year;
                } else {
                    calendarModel.formatteddate = dateValue;
                }
            }
        },

    };


    return module;
}());


$KW.Slider = (function() {
    
    

    var module = {
        initialize: function() {
            kony.events.addEvent("onorientationchange", "Slider", module.changeOrientation);
        },

        initializeView: function(formId, node) {
            var sliderNodes = node ? node.querySelectorAll("img[kwttype ='kSlider']") : document.querySelectorAll("#" + formId + " img[kwttype ='kSlider']");
            for(var i = 0; i < sliderNodes.length; i++) {
                this.attachSliderEvents(sliderNodes[i]);
            }

            var sliderouterNodes = node ? node.querySelectorAll("div[kwttype ='kSlider']") : document.querySelectorAll("#" + formId + " div[kwttype ='kSlider']");
            for(var i = 0; i < sliderouterNodes.length; i++) {
                kony.events.addEventListener(sliderouterNodes[i], "click", module.slideClick);
            }
        },

        attachSliderEvents: function(sliderNode) {
            kony.events.addEventListener(sliderNode, "touchstart", module.sliderStart);
            kony.events.addEventListener(sliderNode, "mousedown", module.sliderStart);
        },

        updateView: function(widgetModel, propertyName, propertyValue, oldPropertyValue) {
            var element = $KU.getNodeByModel(widgetModel);
            if(!element)
                return;

            switch(propertyName) {
                case "text":
                case "isvisible":
                    element.value = propertyValue;
                    break;

                case "leftskin":
                    widgetModel.leftskin = propertyValue;
                    $KU.removeClassName(element, oldPropertyValue);
                    $KU.addClassName(element, propertyValue);
                    break;
                case "rightskin":
                    widgetModel.rightskin = propertyValue;
                    $KU.removeClassName(element.parentNode, oldPropertyValue);
                    $KU.addClassName(element.parentNode, propertyValue);
                    break;
                case "thumbimage":
                    element.childNodes[0].src = $KU.getImageURL(propertyValue);
                    element.childNodes[0].setAttribute("thumbimage", $KU.getImageURL(propertyValue));
                    break;
                case "focusthumbimage":
                    element.childNodes[0].setAttribute("focusimage", $KU.getImageURL(propertyValue));
                    break;
                case "selectedvalue":
                    module.sliderUpdate(element, propertyValue);
                    break;
                case "containerweight":
                    
                    
                    this.imgLoad(element.firstChild);
                    break;
                case "minlabel":
                    var minLabelNode = document.getElementById(element.id + "_minLabel");
                    minLabelNode && (minLabelNode.innerHTML = propertyValue);
                    break;
                case "maxlabel":
                    var maxLabelNode = document.getElementById(element.id + "_maxLabel");
                    maxLabelNode && (maxLabelNode.innerHTML = propertyValue);
                    break;
                case "minlabelskin":
                    var minLabelNode = document.getElementById(element.id + "_minLabel");
                    $KU.removeClassName(minLabelNode, oldPropertyValue);
                    $KU.addClassName(minLabelNode, propertyValue);
                    break;
                case "maxlabelskin":
                    var maxLabelNode = document.getElementById(element.id + "_maxLabel");
                    $KU.removeClassName(maxLabelNode, oldPropertyValue);
                    $KU.addClassName(maxLabelNode, propertyValue);
                    break;
            }
        },

        validateSelectedValue: function(sliderModel) {
            if(sliderModel.selectedValue < sliderModel.min) {
                sliderModel.selectedValue = sliderModel.min
            }
            if(sliderModel.selectedValue > sliderModel.max) {
                sliderModel.selectedValue = sliderModel.max;
            }
        },

        render: function(sliderModel, context) {

            var htmlString = "";
            var id = sliderModel.pf + "_" + sliderModel.id;
            var kmasterObj = $KW.Utils.getMasterIDObj(sliderModel);
            if(kmasterObj.id != "") {
                id = kmasterObj.id;
            }
            module.validateSelectedValue(sliderModel);
            sliderModel.thickness = sliderModel.thickness || $KU.isIDevice && 2 || 5;
            var sliderleftskin = sliderModel.leftskin || sliderModel.leftSkin || "konysliderleft";
            var sliderrighttskin = sliderModel.rightskin || sliderModel.rightSkin || "konysliderright";
            var hideSkin = $KW.skins.getVisibilitySkin(sliderModel);
            var diff = sliderModel.max - sliderModel.min;

            var thumbimage = $KU.getImageURL(sliderModel.thumbimage) || $KU.getImageURL("slider.png");
            var focusthumbimage = $KU.getImageURL(sliderModel.focusthumbimage) || $KU.getImageURL("sliderfocus.png");
            var minlabeltext = sliderModel.minlabel || "";
            var maxlabeltext = sliderModel.maxlabel || "";
            sliderModel.view = sliderModel.view || "default";
            sliderModel.orientation = sliderModel.orientation || "horizontal";
            var horizontalleftstyle = '';
            if($KW.FlexUtils.isFlexWidget(sliderModel)) {
                horizontalleftstyle = 'height:0px;';
            }
            if(sliderModel.orientation == "horizontal") {
                htmlString += '<div' + " tabindex='0'" + 'style=" ' + $KW.skins.getMarginSkin(sliderModel, context) + '" class = "' + $KW.skins.getMarAdjustedContainerWeightSkin(sliderModel, 100) + hideSkin + '">';
                htmlString += '<div min= "' + sliderModel.min + '" max="' + sliderModel.max + '" diff ="' + diff + '" step ="' + sliderModel.step + '" kwttype ="kSlider" ';
                htmlString += 'id="' + id + '_outer" class="' + sliderrighttskin + '"  style=" height: ' + sliderModel.thickness + 'px;"';
                htmlString += ' kformname="' + sliderModel.pf + '" ' + kmasterObj.kmasterid + '>';

                htmlString += '<div role="slider" aria-valuenow="' + sliderModel.selectedvalue + '" ' + ' align="left"' + $KW.Utils.getBaseHtml(sliderModel, context) + ' class="' + sliderleftskin + '"';
                htmlString += 'style= "vertical-align:middle;  position: relative;' + horizontalleftstyle + ' ">';

                htmlString += '<img onload = "$KW.Slider.imgLoad(this, false)" kwttype ="kSlider" kformname="' + sliderModel.pf + '" id ="' + id + '_image" src ="' + thumbimage + '" thumbimage="' + thumbimage + '" focusimage ="' + focusthumbimage + '" style="  position: relative;  vertical-align:top;" ' + kmasterObj.kmasterid + '></img>';

                htmlString += '</div></div>';
                htmlString += '<div style="overflow:auto;position:relative;">';
                htmlString += '<label id="' + id + '_minLabel" style="float: left; "class="' + sliderModel.minlabelskin + '" ' + kmasterObj.kmasterid + '>' + minlabeltext + '</label>';
                htmlString += '<label id="' + id + '_maxLabel" style="float: right; "class="' + sliderModel.maxlabelskin + '" ' + kmasterObj.kmasterid + '>' + maxlabeltext + '</label>'
                htmlString += '</div>';

                htmlString += '</div>';
            } else {
                htmlString += '<div style="width:90%;" class="' + hideSkin + '">';
                
                htmlString += '<div style="margin-bottom: 2px;" >';
                htmlString += '<label id="' + id + '_maxLabel" class="' + sliderModel.maxlabelskin + '" ' + kmasterObj.kmasterid + '>' + maxlabeltext + '</label>';
                htmlString += '</div>';

                htmlString += '<div min= "' + sliderModel.min + '" max="' + sliderModel.max + '" diff ="' + diff + '" step ="' + sliderModel.step + '" kwttype ="kSlider" ';
                htmlString += 'id="' + id + '_outer" class="' + sliderrighttskin + '"  style="height: 150px; width: ' + sliderModel.thickness + 'px;"';
                htmlString += ' kformname="' + sliderModel.pf + '" ' + kmasterObj.kmasterid + '>';

                htmlString += '<div  align="left"' + $KW.Utils.getBaseHtml(sliderModel, context) + ' class="' + sliderleftskin + '"';
                htmlString += 'style= "vertical-align:middle;  position: relative; ">';

                htmlString += '<img onload = "$KW.Slider.imgLoad(this, false)" kwttype ="kSlider" kformname="' + sliderModel.pf + '" id ="' + id + '_image" src ="' + thumbimage + '" thumbimage="' + thumbimage + '" focusimage ="' + focusthumbimage + '"style="  position: relative;  vertical-align:top;" ' + kmasterObj.kmasterid + '></img>';

                htmlString += '</div></div>';
                htmlString += '<div style="margin-top: 2px;" >';
                htmlString += '<label id="' + id + '_minLabel" class="' + sliderModel.minlabelskin + '" ' + kmasterObj.kmasterid + '>' + minlabeltext + '</label>'
                htmlString += '</div>';


                htmlString += '</div>';
            }
            sliderModel.context = context;
            return htmlString;
        },

        completeMove: function(event) {
            
            if(!event)
                event = window.event;
            kony.events.preventDefault(event);

            var node = kony.globals["__activeSlider"];
            if(!node || !$KW.Utils.isWidgetInteractable(node)) return;
            var sliderModel = $KU.getModelByNode(node);
            var containerId = node.getAttribute("kcontainerID");
            if(containerId) {
                sliderModel = $KW.Utils.getClonedModelByContainer(sliderModel, node, containerId);
                if(!sliderModel)
                    return;
            }
            var touch = event.touches && event.touches[0] || event;
            var imgNode = node.firstChild;
            var outerNode = node.parentNode;
            imgNode.src = imgNode.getAttribute("focusimage");

            if(sliderModel.orientation == "horizontal") {
                var imgoffset = imgNode.offsetWidth / 2;
                var move = (touch.pageX || touch.clientX) - imgoffset;
                var cwidth = outerNode.offsetWidth;
                var bodyoffset = $KW.Utils.getPosition(outerNode).left - imgoffset;

                if(move < (bodyoffset))
                    move = bodyoffset;
                if(move >= (cwidth + bodyoffset)) {
                    move = cwidth + bodyoffset;
                }

                var nearstep = Math.round((move - bodyoffset) / sliderModel.stepwidth);
                if(nearstep * sliderModel.step <= (sliderModel.max - sliderModel.min)) {
                    sliderModel.selectedvalue = sliderModel.min + (nearstep * sliderModel.step);
                    var slidemovement = Math.round(nearstep * sliderModel.stepwidth);
                    node.style.width = (imgoffset + slidemovement) + "px";
                    var maxWidth = node.parentNode.offsetWidth;
                    var width = imgoffset + slidemovement;
                    node.style.width = (width > maxWidth ? maxWidth : width) + "px";
                    imgNode.style.left = (slidemovement - imgoffset) + "px";
                } else {
                    
                    sliderModel.selectedvalue = sliderModel.max;
                    node.style.width = (cwidth + imgoffset) + "px";
                    imgNode.style.left = (cwidth + imgoffset) + "px";
                }
            } else {
                var imgoffset = imgNode.offsetHeight / 2;
                var move = (touch.pageY || touch.clientY) - imgoffset;

                var cwidth = outerNode.offsetHeight;
                var bodyoffset = $KW.Utils.getOffset(outerNode).top - imgoffset;

                if(move < (bodyoffset))
                    move = bodyoffset;
                if(move >= (cwidth + bodyoffset)) {
                    move = cwidth + bodyoffset;
                }

                var nearstep = Math.round((move - bodyoffset) / sliderModel.stepwidth);
                if(nearstep * sliderModel.step <= (sliderModel.max - sliderModel.min)) {
                    sliderModel.selectedvalue = sliderModel.min + (nearstep * sliderModel.step);
                    var slidemovement = Math.round(nearstep * sliderModel.stepwidth);
                    node.style.height = (imgoffset + slidemovement) + "px";
                    imgNode.style.top = (slidemovement - imgoffset) + "px";
                }

            }

            if(sliderModel.view != "progress") {
                spaAPM && spaAPM.sendMsg(sliderModel, 'onslide');
                $KAR && $KAR.sendRecording(sliderModel, 'slide', {'selectedValue': sliderModel.selectedValue, 'target': node, 'eventType': 'uiAction'});
                $KU.callTargetEventHandler(sliderModel, node, 'onslide');
            }
        },

        sliderStart: function(event) {
            
            if(!event)
                event = window.event;
            var target = event.target || event.srcElement;
            kony.globals["__activeSlider"] = target.parentNode;
            var sliderModel = $KU.getModelByNode(target.parentNode);

            if($KW.Utils.isWidgetInteractable(target.parentNode, true)) {
                kony.events.addEventListener(document, "mousemove", module.completeMove);
                kony.events.addEventListener(document, "mouseup", module.completeEnd);

                kony.events.addEventListener(document, "touchmove", module.completeMove);
                kony.events.addEventListener(document, "touchend", module.completeEnd);
                kony.events.preventDefault(event);
            }
        },

        completeEnd: function(event) {
            
            if(!event)
                event = window.event;
            var target = event.target || event.srcElement;
            kony.events.removeEventListener(document, "mousemove", module.completeMove);
            kony.events.removeEventListener(document, "touchmove", module.completeMove);

            module.sliderEnd(event);
        },

        slideClick: function(event) {
            
            if(!event)
                event = window.event;
            var target = event.target || event.srcElement;
            kony.globals["__activeSlider"] = event.currentTarget.childNodes[0];

            
            if(!target.firstChild)
                return;
            var sliderModel = $KU.getModelByNode(target.firstChild) || $KU.getModelByNode(target);

            if($KW.Utils.isWidgetInteractable(target.parentNode, true) && sliderModel && sliderModel.view != "progress") {
                kony.events.addEventListener(target, "click", module.completeMove);
                
            }
        },

        sliderEnd: function(event) {
            

            if(!event)
                event = window.event;

            var node = kony.globals["__activeSlider"];
            if(!node) return;

            kony.events.removeEventListener(document, "mouseup", module.completeEnd);
            kony.events.removeEventListener(document, "touchend", module.completeEnd);
            var sliderModel = $KU.getModelByNode(node);
            var containerId = node.getAttribute("kcontainerID");
            if(containerId) {
                sliderModel = $KW.Utils.getClonedModelByContainer(sliderModel, node, containerId);
                if(!sliderModel)
                    return;
            }
            if(sliderModel.view != "progress") {
                spaAPM && spaAPM.sendMsg(sliderModel, 'onselection');
                
                var sliderhandler = $KU.returnEventReference(sliderModel.onselection);
                $KU.callTargetEventHandler(sliderModel, node, 'onselection');
                sliderhandler && $KU.onEventHandler(sliderModel);
            }

            var imgNode = node.firstChild;
            imgNode.src = imgNode.getAttribute("thumbimage");
            kony.globals["__activeSlider"] = '';
            return;
        },


        changeOrientation: function(target) {
            var sliderNodes = document.querySelectorAll("img[kwttype ='kSlider']");
            for(var i = 0; i < sliderNodes.length; i++) {
                module.imgLoad(sliderNodes[i]);
            }
        },

        imgLoad: function(target) {
            if(!target.complete)
                return;
            var slider = target.parentNode.parentNode;
            var wNode = target.parentNode;
            var sliderModel = $KU.getModelByNode(wNode);
            var containerId = wNode.getAttribute("kcontainerID");
            if(containerId) {
                sliderModel = $KW.Utils.getClonedModelByContainer(sliderModel, wNode, containerId);
            }
            if(!sliderModel)
                return;


            if(sliderModel.view == "progress") {
                target.style.display = "none";
            }

            var noofsteps = (sliderModel.max - sliderModel.min) / sliderModel.step;

            if(sliderModel.orientation == "horizontal") {
                var imght = target.offsetHeight - sliderModel.thickness;
                var imgwt = target.width;
                target.style.top = (-(imght) / 2) + "px";
                if(sliderModel.view == "progress")
                    target.parentNode.style.width = 0 + "px";
                else
                    target.parentNode.style.width = (imgwt / 2) + "px";

                target.parentNode.style.height = sliderModel.thickness + "px";
                var sliderwidth = slider.offsetWidth;
                var parentNode = slider.parentNode;
                var height = parentNode.offsetHeight;
                if($KW.FlexUtils.isFlexWidget(sliderModel) && height > imght) {
                    slider.style.position = 'relative';
                    var lblHeight = 0;
                    if(sliderModel.minlabel || sliderModel.maxlabel)
                        lblHeight = slider.nextSibling.offsetHeight;
                    var top = (height - lblHeight - (slider.offsetHeight / 2)) / 2;
                    slider.style.top = top + 'px';
                    slider.style.marginTop = slider.style.marginBottom = '';
                    if(sliderModel.minlabel || sliderModel.maxlabel)
                        slider.nextSibling.style.top = top + 3 + 'px';
                } else {
                    if(imght > 0) {
                        slider.style.marginTop = (imght / 2) + "px";
                        slider.style.marginBottom = (imght / 2) + "px";
                    }
                }
                parentNode.style.paddingLeft = (imgwt / 2) + "px";
                parentNode.style.paddingRight = (imgwt / 2) + "px";
                sliderwidth = parentNode.childNodes[0].offsetWidth;
            } else {
                var imght = target.height;
                var imgwt = target.offsetWidth - sliderModel.thickness;
                target.style.left = -((imgwt) / 2) + "px";
                if(sliderModel.view == "progress")
                    target.parentNode.style.height = "0px";
                else
                    target.parentNode.style.height = (imght / 2) + "px";

                target.parentNode.style.width = sliderModel.thickness + "px";
                var sliderwidth = slider.offsetHeight;

            }

            var stepwidth = sliderwidth / noofsteps;
            sliderModel.noofsteps = noofsteps;
            sliderModel.stepwidth = stepwidth;
            sliderModel.imgwt = imgwt;
            module.sliderLoad(sliderModel, target.parentNode);
        },

        sliderLoad: function(sliderModel, sliderNode) {
            var duration = 500;
            var imgNode = sliderNode.firstChild;
            if(sliderModel.orientation == "horizontal") {

                var imgoffset = imgNode.offsetWidth / 2;

                var outerNode = sliderNode.parentNode;
                var cwidth = outerNode.offsetWidth;
                var bodyoffset = $KW.Utils.getOffset(outerNode).left - imgoffset;

                var nearstep = sliderModel.selectedvalue - sliderModel.min;

                var move = (nearstep * sliderModel.stepwidth) / sliderModel.step;

                if(sliderModel.view == "progress") {
                    if(kony.appinit.useTransition) {
                        sliderNode.style[$KU.transition] = 'width ' + duration + 'ms ease';
                        sliderNode.style.width = (move + imgoffset) + "px";
                    } else {
                        $(sliderNode).animate({
                            width: (move + imgoffset) + "px"
                        }, duration);
                    }
                } else {
                    

                    sliderNode.style.width = (move) + "px";
                }

                imgNode.style.left = (move - imgoffset) + "px";
            } else {
                var imgoffset = imgNode.offsetHeight / 2;

                var outerNode = sliderNode.parentNode;
                var cwidth = outerNode.offsetHeight;
                var bodyoffset = $KW.Utils.getOffset(outerNode).top - imgoffset;

                var nearstep = sliderModel.selectedvalue - sliderModel.min;

                var move = (nearstep * sliderModel.stepwidth) / sliderModel.step;

                if(sliderModel.view == "progress") {
                    if(kony.appinit.useTransition) {
                        sliderNode.style[$KU.transition] = 'height ' + duration + 'ms ease';
                        sliderNode.style.height = (move + imgoffset) + "px";
                    } else {
                        $(sliderNode).animate({
                            height: (move + imgoffset) + "px"
                        }, duration);
                    }
                } else {
                    sliderNode.style.height = (move + imgoffset) + "px";
                }

                imgNode.style.top = (move - imgoffset) + "px";


            }

        },

        sliderUpdate: function(sliderNode, value, clonedModel) {
            var sliderModel = clonedModel || $KU.getModelByNode(sliderNode);
            if(value >= sliderModel.max)
                value = sliderModel.max;
            if(value <= sliderModel.min)
                value = sliderModel.min;
            
            var abc = value % sliderModel.step;
            if(abc != 0) {
                value = sliderModel.step * Math.round(value / sliderModel.step);
            }
            sliderModel.selectedvalue = value;
            module.sliderLoad(sliderModel, sliderNode);
        },

        adjustSliders: function(container) {
            var sliderNodes = document.querySelectorAll("#" + formId + " img[kwttype ='kSlider']");
            for(var i = 0; i < sliderElements.length; i++) {
                var sliderElement = sliderElements[i];
                module.imgLoad(sliderElement);
            }
        },

        animSlider: function(width, sliderModel, property) {
            if(!width) return 0;
            var sliderNode = $KU.getNodeByModel(sliderModel);
            var imgWidth = sliderNode.childNodes[0].naturalWidth;

            var valueObj = {
                value: parseFloat(width),
                unit: $KW.FlexUtils.getUnit(width)
            };
            var width = $KW.FlexUtils.getValueByParentFrame(sliderModel, valueObj, 'x');
            var width = parseInt(width, 10);
            var selectedValue = sliderModel.selectedvalue;

            width = (width - imgWidth) / 100;
            var nearstep = selectedValue - sliderModel.min;
            var move = (nearstep * width) / sliderModel.step;

            if(property == 'width')
                return(move + (imgWidth / 2)) + "px";
            else
                return(move - (imgWidth / 2)) + "px";
        }
    };


    return module;
}());


$KA = {};
$KA.Utils = {
    trackEvents: [],
    apmEnabled: false,

    
    eventExists: function(widgetType) {
        var supportedEvents = {
            'Button': ['onclick'],
            'Calendar': ['onclick', 'onselection'],
            'CheckBoxGroup': ['onclick', 'onselection'],
            'DataGrid': ['onrowselected'],
            'Image2': [],
            'RadioButtonGroup': ['onclick', 'onselection'],
            'RichText': ['onclick'],
            'Slider': ['onslide', 'onselection'],
            'TextField': ['ontextchange', 'ondone', 'onbeginediting', 'onendediting', 'onclick'],
            'TextArea2': ['ontextchange', 'ondone', 'onbeginediting', 'onendediting', 'onkeyup'],
            'Form': ['onorientationchange', 'onhide'],
            'TabPane': ['onclick', 'ontabclick'],
            'Segment': ['onrowclick', 'onswipe'],
            'Switch': ['onslide'],
            'ListBox': ['onclick', 'onselection'],
            'FlexContainer': ['onclick'],
            'FlexScrollContainer': ['onclick']
        };

        
        return true;
    },

    doNotTrack: function(eName) {
        if(this.trackEvents.length < 1)
            return true;

        if(eName == "show" && this.trackEvents.indexOf("FormEntry") > -1)
            return false;

        if(eName == "onhide" && this.trackEvents.indexOf("FormExit") > -1)
            return false;

        if(eName == "onorientationchange" && this.trackEvents.indexOf("Orientation") > -1)
            return false;

        if((["Gesture Tap", "Gesture Swipe", "Gesture LongPress", "Gesture Pan", "Gesture Rotation", "Gesture Pinch", "onswipe"].indexOf(eName) > -1) && this.trackEvents.indexOf("Gesture") > -1)
            return false;

        if((["onclick", "onselection", "onrowselected", "ontabclick", "onbeginediting", "onrowclick", "onslide", "TouchEvent"].indexOf(eName) > -1) && this.trackEvents.indexOf("Touch") > -1)
            return false;

        if(eName == "servicerequest" && this.trackEvents.indexOf("ServiceRequest") > -1)
            return false;

        if(eName == "serviceresponse" && this.trackEvents.indexOf("ServiceResponse") > -1)
            return false;

        if(eName == "error" && this.trackEvents.indexOf("Error") > -1)
            return false;

        if(eName == "exception" && this.trackEvents.indexOf("Exception") > -1)
            return false;

        if(eName == "AppTransition" && this.trackEvents.indexOf("AppTransition") > -1)
            return false;

        if(eName == "AppLoad" && this.trackEvents.indexOf("AppLoad") > -1)
            return false;


        return true;
    },

    init: function() {
        try {
            var konySdkInstance = kony.sdk.getDefaultInstance();
            spaAPM.metricsServiceObj = konySdkInstance.getMetricsService();
            $KG['foreGroundStartTime'] = 0;
            window.addEventListener('focus', function() {
                if($KG['foreGroundStartTime'] == 0) {
                    spaAPM && spaAPM.sendMsg($KG["__currentForm"], 'AppTransition', {
                        "status": 'Foreground',
                        "foredur": 0
                    });
                    spaAPM && spaAPM.sendMsg($KG["__currentForm"], 'show');
                    $KG['foreGroundStartTime'] = new Date().getTime();
                }
            });

            window.addEventListener('blur', function() {
                var curTime = new Date().getTime();
                var timeDiff = curTime - $KG['foreGroundStartTime'];
                spaAPM && spaAPM.sendMsg($KG["__currentForm"], 'AppTransition', {
                    "status": 'Background',
                    "foredur": timeDiff
                });
                spaAPM && spaAPM.sendMsg($KG["__currentForm"], 'onhide');
                $KG['foreGroundStartTime'] = 0;
            });
            return true;
        } catch(e) {
            kony.print("MetricsService can be initialize due to some issue in MBAAS SDK. " + e.message);
            return false;
        }
    }
};

spaAPM = {
    metricsServiceObj: null,
    timer: null,
    eventTypeMap: [
        "FormEntry",
        "FormExit",
        "Touch",
        "ServiceRequest",
        "ServiceResponse",
        "Gesture",
        "Orientation",
        "Error",
        "Exception",
        "Crash",
        "Custom",
        "ServiceCall",
        "AppTransition",
        "AppLoad"
    ],

    startTracking: function(eventList) {
        if(!eventList && !(eventList instanceof Array) && !appConfig.eventTypes)
            return;

        $KA.Utils.trackEvents = eventList ? eventList : appConfig.eventTypes;
        $KA.Utils.apmEnabled = !this.metricsServiceObj && $KA.Utils.init();
        if(this.metricsServiceObj) {
            this.metricsServiceObj.setEventTracking = this.setEventTracking.bind(this);
        }
    },

    setEventTracking: function(eventTypes) {
        var validEventTypes = [],
            i;
        if(eventTypes && eventTypes instanceof Array) {
            for(i = 0; i < eventTypes.length; i++) {
                if(this.eventTypeMap.indexOf(eventTypes[i]) > -1) {
                    validEventTypes.push(eventTypes[i]);
                }
            }
            $KA.Utils.trackEvents = validEventTypes;
        }
    },

    
    sendMsg: function(widget, eventName, objectParams) {
        if(!$KA.Utils.apmEnabled)
            return;

        if($KA.Utils.doNotTrack(eventName))
            return;


        var widgetID = widget.id;

        var currFrm = kony.application.getCurrentForm();
        var formID = currFrm ? currFrm.id : "";
        var evtSubType = null;
        var flowTag = "";
        kony.web.logger("log", "#######APM msg sent : ID : " + widgetID + "  eventname: " + eventName + " formID: " + formID);

        
        switch(eventName) {

            case 'onorientationchange':
                if(objectParams.orientation == "landscape")
                    this.metricsServiceObj.sendEvent("Orientation", "PORTRAIT_TO_LANDSCAPE", widgetID, null, flowTag, null);
                if(objectParams.orientation == "portrait")
                    this.metricsServiceObj.sendEvent("Orientation", "LANDSCAPE_TO_PORTRAIT", widgetID, null, flowTag, null);
                break;

            case 'show':
                this.timer = new Date().getTime(); 
                this.metricsServiceObj.sendEvent("FormEntry", widgetID, widgetID, null, flowTag, null);
                break;
            case 'onhide':
                if(this.timer)
                    this.timer = new Date().getTime() - this.timer; 

                this.metricsServiceObj.sendEvent("FormExit", widgetID, widgetID, null, flowTag, {
                    "formdur": this.timer
                });
                break;

            case 'Gesture Tap':
                this.metricsServiceObj.sendEvent("Gesture", "TAP_1", formID, widgetID, flowTag, null);
                break;

            case 'onswipe':
            case 'Gesture Swipe':
                if(objectParams && objectParams.swipeDirection) {
                    var dir = "";
                    switch(objectParams.swipeDirection) {
                        case $KW.touch.TouchContext.LEFT:
                            dir = "_LEFT";
                            break;
                        case $KW.touch.TouchContext.RIGHT:
                            dir = "_RIGHT";
                            break;
                        case $KW.touch.TouchContext.UP:
                            dir = "_UP";
                            break;
                        case $KW.touch.TouchContext.DOWN:
                            dir = "_DOWN";
                            break;
                    }
                    evtSubType = "SWIPE_1" + dir;
                } else {
                    evtSubType = "SWIPE_1";
                }
                this.metricsServiceObj.sendEvent("Gesture", evtSubType, formID, widgetID, flowTag, null);
                break;

            case 'Gesture LongPress':
                this.metricsServiceObj.sendEvent("Gesture", "LONGPRESS_1", formID, widgetID, flowTag, null);
                break;

            case 'Gesture Pan':
                this.metricsServiceObj.sendEvent("Gesture", "PAN_1", formID, widgetID, flowTag, null);
                break;

            case "Gesture Rotation":
                this.metricsServiceObj.sendEvent("Gesture", "ROTATION_2", formID, widgetID, flowTag, null);
                break;

            case 'Gesture Pinch':
                this.metricsServiceObj.sendEvent("Gesture", "PINCH_2", formID, widgetID, flowTag, null);
                break;

            case 'onbeginediting':
                evtSubType = widget.wType + "_Edit";
                this.metricsServiceObj.sendEvent("Touch", evtSubType, formID, widgetID, flowTag, null);
                break;

            case 'onslide':
                evtSubType = widget.wType + "_Slide";
                this.metricsServiceObj.sendEvent("Touch", evtSubType, formID, widgetID, flowTag, null);
                break;

            case 'onrowclick':
                evtSubType = widget.wType + "_Row_Click";
                this.metricsServiceObj.sendEvent("Touch", evtSubType, formID, widgetID, flowTag, null);
                break;

            case 'onrowselected':
                evtSubType = widget.wType + "_Row_Selected";
                this.metricsServiceObj.sendEvent("Touch", evtSubType, formID, widgetID, flowTag, null);
                break;

            case 'onselection':
                evtSubType = widget.wType + "_Selection";
                this.metricsServiceObj.sendEvent("Touch", evtSubType, formID, widgetID, flowTag, null);
                break;

            case 'ontabclick':
            case 'onclick':
                evtSubType = widget.wType + "_Click";
                this.metricsServiceObj.sendEvent("Touch", evtSubType, formID, widgetID, flowTag, null);
                break;

            case 'servicerequest':
                this.metricsServiceObj.sendEvent("ServiceRequest", widget, formID, null, flowTag, null);
                break;

            case 'serviceresponse':
                this.metricsServiceObj.sendEvent("ServiceResponse", widget, formID, null, flowTag, objectParams);
                break;

            case 'error':
                this.metricsServiceObj.sendEvent("Error", widget, formID, null, flowTag, objectParams);
                break;

            case 'exception':
                this.metricsServiceObj.sendEvent("Exception", widget, formID, null, flowTag, objectParams);
                break;

            case 'TouchEvent':
                if(objectParams.eventtype == 'mousedown' || objectParams.eventtype == 'touchstart') {
                    this.metricsServiceObj.sendEvent("Touch", 'onTouchStart', formID, widgetID, flowTag, null);
                } else if(objectParams.eventtype == 'touchend' || objectParams.eventtype == 'mouseup') {
                    this.metricsServiceObj.sendEvent("Touch", 'onTouchMove', formID, widgetID, flowTag, null);
                }
                break;
            case 'AppTransition':
                this.metricsServiceObj.sendEvent("AppTransition", objectParams.status, widgetID, null, flowTag, {
                    "foredur": objectParams.foredur
                });
                break;

            case 'AppLoad':
                this.metricsServiceObj.sendEvent("AppLoad", $KG['appid'], null, null, flowTag, {
                    "loaddur": objectParams.loaddur
                });
                break;
        }

        


    },

    apmErrorHandler: function(message, url, line, columnNo, error) {
        var errInfo = {};
        try {
            if(error && error.errorcode) { 
                errInfo["exceptioncode"] = error.errorcode;
                if(error && error.name) {
                    errInfo["exceptionmsg"] = error.name;
                }
                if(error && error.stack) {
                    errInfo["exceptionstacktrace"] = error.stack;
                }
                if(url) {
                    errInfo["exceptionfile"] = error.url;
                } else if(error && error.fileName) {
                    errInfo["exceptionfile"] = error.fileName;
                }
                if(line) {
                    errInfo["exceptionline"] = line;
                } else if(error && error.lineNumber) {
                    errInfo["exceptionline"] = error.lineNumber;
                }
                if(message) {
                    errInfo["exceptioncustommsg"] = message;
                } else if(error && error.message) {
                    errInfo["exceptioncustommsg"] = error.message;
                }

                spaAPM && spaAPM.sendMsg(errInfo["exceptioncode"], "exception", errInfo);
            } else { 
                errInfo["errcode"] = "";
                if(error && error.name) {
                    errInfo["errmsg"] = error.name;
                }
                if(error && error.stack) {
                    errInfo["errstacktrace"] = error.stack;
                }
                if(url) {
                    errInfo["errfile"] = error.url;
                } else if(error && error.fileName) {
                    errInfo["errfile"] = error.fileName;
                }
                if(line) {
                    errInfo["errline"] = line;
                } else if(error && error.lineNumber) {
                    errInfo["errline"] = error.lineNumber;
                }
                if(message) {
                    errInfo["errcustommsg"] = message;
                } else if(error && error.message) {
                    errInfo["errcustommsg"] = error.message;
                }

                spaAPM && spaAPM.sendMsg(errInfo["errcode"], "error", errInfo);
            }
        } catch(e) {
            kony.print("Some issue in window.onerror " + e.message);
        }
        return false;
    }
};
_kony.mvc = {
    Form2: function(bconfig, lconfig, pspconfig) {
        var formInstance;
        if(!bconfig._konyControllerName) {
            kony.web.logger("warn", "This API is applicable only for MVC projects");
            return;
        }
        if(arguments.length < 3) {
            formInstance = new kony.ui.Form2(bconfig);
        } else {
            formInstance = new kony.ui.Form2(bconfig, lconfig, pspconfig);
        }
        formInstance.destroy = undefined;
        return formInstance;
    },

    showForm: function(formModel) {
        if(formModel._konyControllerName) {
            formModel._show();
        } else {
            kony.web.logger("warn", "This API is applicable only for MVC projects");
        }
    },

    destroyForm: function(formModel) {
        $KU.logExecuting('kony.application.destroyForm');
        if(formModel._konyControllerName && formModel) {
            $KU.logExecutingWithParams('kony.application.destroyForm', formModel);
            formModel._destroy({"isMVC": true});
            $KU.logExecutingFinished('kony.application.destroyForm');
        } else {
            $KU.logWarnMessage("This API is applicable only for MVC projects");
        }
    }
};


$KW.KComponent = (function() {
    
    

    var module = {
        registerComponent: function(userObj) {
            if(!userObj)
                return 100;
            if(typeof userObj != 'object') {
                return 101;
            }

            var classname = userObj.classname;
            var name = userObj.name;
            var namespace = userObj.namespace;

            if(classname == null || classname.length <= 0) {
                return 102;
            }
            if(name == null || name.length <= 0) {
                return 102;
            }

            var userWidgetNamespace = window;
            if(namespace != null && namespace != "") {
                var namspaceArr = namespace.split(".");
                for(var i = 0; i < namspaceArr.length; i++) {
                    userWidgetNamespace = module.getNSObj(userWidgetNamespace, namspaceArr[i]);
                }
            }
            if(userWidgetNamespace[classname])
                return 103;

            userWidgetNamespace[classname] = function(bconfig, lconfig, pspconfig) {
                var retObj;
                if(bconfig.masterType == constants.MASTER_TYPE_USERWIDGET) {
                    retObj = kony.ui.KComponentTemplate(bconfig, lconfig, pspconfig, name);
                } else {
                    retObj = kony.ui.KMasterTemplate(bconfig, lconfig, pspconfig, name);
                }
                retObj.instancename = name;
                return retObj;
            }
            return 0;
        },

        getNSObj: function(userNS1, userNS2) {
            if(!userNS1[userNS2]) {
                userNS1[userNS2] = new Object();
            }
            return userNS1[userNS2];
        },

        render: function(UserWidgetModel, context) {
            var wModel = UserWidgetModel.userWidgetProxyObject;
            wModel.parent = UserWidgetModel.parent;
            return $KW[wModel.wType].render(wModel, context);
        },

        forceLayout: function(UserWidgetModel) {
            $KW.FlexContainer.forceLayout(UserWidgetModel.parent);
        }
    };


    return module;
}());


$KW.CollectionView = (function() {
    
    

    var module = {
        CollectionViewCounter: 0,

        initialize: function() {
            kony.events.addEvent("click", "CollectionView", module.eventHandler);
            kony.events.addEvent("onorientationchange", "CollectionView", module.orientationHandler);
        },

        initializeView: function(formId) {
            
            $KW.Scroller.initializeCollectionViewContainers(formId);
            var scrollNodes = document.querySelectorAll("#" + formId + " div[kwidgettype='CollectionView']");
            $KW.Utils.initializeScrollEvents(scrollNodes);
            $KW.APIUtils.getModelForContentOffset(formId, "CollectionView");
        },

        initializeNewWidgets: function(node) {
            $KW.Slider && $KW.Slider.initializeView(null, node);
            $KW.Switch && $KW.Switch.initializeView(null, node);
        },

        orientationHandler: function(formId, orientation) {
            $KU.setScrollBoxesHeight(formId, "CollectionView");
        },

        updateView: function(widgetModel, propertyName, propertyValue, oldPropertyValue) {
            var element = $KU.getNodeByModel(widgetModel);
            var options;
            if(!element) {
                return;
            }
            switch(propertyName) {
                case "itemskin":
                    module.Skin.updateTemplateSkin(widgetModel, element, propertyValue, oldPropertyValue, 'itemBox');
                    break;

                case "itemselectedskin":
                    module.Skin.setSelectedItemSkins(widgetModel, true, propertyValue, oldPropertyValue);
                    break;

                case "skin":
                    element = $KW.Utils.getWidgetNode(widgetModel);
                    $KU.removeClassName(element, oldPropertyValue);
                    $KU.addClassName(element, propertyValue);
                    break;
                case "sectionheaderskin":
                    if(widgetModel.hasSections) module.Skin.updateTemplateSkin(widgetModel, element, propertyValue, oldPropertyValue, 'HeaderBox');
                    break;
                case "sectionfooterskin":
                    if(widgetModel.hasSections) module.Skin.updateTemplateSkin(widgetModel, element, propertyValue, oldPropertyValue, 'FooterBox');
                    break;

                case "selecteditemindex":
                    if(propertyValue && module.Data.isSelectionOutOfBound(widgetModel, propertyValue)) {
                        return;
                    }

                    var _items = null;
                    widgetModel._items = (widgetModel._items) ? widgetModel._items : [];
                    if(propertyValue) {
                        _items = [propertyValue];
                        if(widgetModel.selectionbehavior == kony.collectionview.SINGLE_SELECT) {
                            var arrayIndex = $KU.arrayIndex(widgetModel._items, propertyValue);
                            if(arrayIndex != -1) {
                                _items = null;
                            } else {
                                widgetModel._items = _items;
                            }
                        } else if(widgetModel.selectionbehavior == kony.collectionview.MULTI_SELECT) {
                            var arrayIndex = $KU.arrayIndex(widgetModel._items, propertyValue);
                            if(arrayIndex != -1) {
                                widgetModel._items.splice(arrayIndex, 1);
                            } else {
                                widgetModel._items.push(propertyValue);
                            }
                        }
                    }
                    _items = (!_items) ? null : (_items.length > 0) ? _items : null;
                    module.Skin.adjustGridSkins(widgetModel, _items);

                    (propertyValue && element) && module.Utils.setFocus(widgetModel, element, propertyValue);
                    break;

                case "selecteditemindices":
                    if(propertyValue) {
                        var _items = [];
                        for(var i = 0; i < propertyValue.length; i++) {
                            var secIndex = parseInt(propertyValue[i][0], 10);
                            var rowIndexes = propertyValue[i][1];
                            for(var j = 0; j < rowIndexes.length; j++) {
                                var selection = [secIndex, rowIndexes[j]];
                                if(!module.Data.isSelectionOutOfBound(widgetModel, selection)) {
                                    var arrayIndex = $KU.arrayIndex(widgetModel._items, propertyValue);
                                    _items.push(selection);
                                    if(widgetModel.selectionbehavior == kony.collectionview.MULTI_SELECT) {
                                        if(arrayIndex != -1) {
                                            widgetModel._items.splice(arrayIndex, 1);
                                        } else {
                                            widgetModel._items.push(selection);
                                        }
                                    } else if(widgetModel.selectionbehavior == kony.collectionview.SINGLE_SELECT) {
                                        if(arrayIndex != -1) {
                                            _items = null;
                                        } else {
                                            widgetModel._items.push(propertyValue);
                                        }
                                    }
                                }
                            }
                        }
                        if(widgetModel.selectionbehavior != kony.collectionview.MULTI_SELECT) {
                            _items = (0) ? [null, _items[_items.length - 1]] : [_items[_items.length - 1]];
                        }
                        _items = (_items.length > 0) ? _items : null;
                    } else {
                        var _items = null;
                    }
                    module.Skin.adjustGridSkins(widgetModel, _items);
                    break;

                case "data":
                    if($KU.isArray(propertyValue)) {
                        module.Data.setData(widgetModel, propertyValue);
                    } else if(propertyValue === null) {
                        widgetModel._items = widgetModel.data = null;
                        module.setSelectedItemsAndIndices(widgetModel);
                    }
                    break;

                case "layouttype":
                    element = $KW.Utils.getWidgetNode(widgetModel);
                    if(propertyValue != oldPropertyValue && element) {
                        var parent = element.parentNode;
                        parent.innerHTML = module.generateCollectionView(widgetModel, widgetModel.context);
                        element = $KW.Utils.getContentNodeFromNodeByModel(widgetModel);
                        module.Utils.setCollectionViewHeightAndWidth(widgetModel);
                        module.Data.adjustFlexContainers(widgetModel, 'setdata');
                        module.applyLineSpaceAndItemSpace(widgetModel, element);
                        $KU.setScrollHeight(widgetModel, element);
                        if($KW.FlexUtils.isFlexContainer(widgetModel.parent)) {
                            widgetModel.layoutConfig.self = true; 
                            
                        }
                        module.Utils.reInitializeScrollerInstace(widgetModel);
                    }
                    break;

                case "selectionbehavior":
                    if(propertyValue != oldPropertyValue) {
                        module.Data.setData(widgetModel, widgetModel.data);
                    }
                    break;

                    
                case "retainselection":
                    if(widgetModel.retainSelection) {
                        module.Skin.adjustGridSkins(widgetModel, widgetModel._items);
                    } else {
                        module.Skin.resetItemSkins(widgetModel);
                    }
                    break;


                case "minLineSpace":
                case "minItemSpace":
                    module.applyLineSpaceAndItemSpace(widgetModel, $KW.Utils.getContentNodeFromNodeByModel(widgetModel));
                    module.Utils.refreshScrollerInstance(widgetModel);
                    break;
                case "reachingBeginningOffset":
                case "reachingEndOffset":
                    module.Utils.updateReachingOffsetValuesInPx(widgetModel);
                    break;
                case "scrollDirection":
                    var scrolldirection = widgetModel.scrolldirection;
                    if(scrolldirection == "horizontal") {
                        element.style.overflowX = "auto";
                        element.style.overflowY = "hidden";
                    } else if(scrolldirection == "vertical") {
                        element.style.overflowX = "hidden";
                        element.style.overflowY = "auto";
                    } else if(scrolldirection == "both") {
                        element.style.overflow = "auto";
                    } else if(scrolldirection == "none") {
                        element.style.overflow = "hidden";
                    }
                    break;
                case 'pulltorefreshview':
                case 'releasetopullrefreshview':
                case 'pushtorefreshview':
                case 'releasetopushrefreshview':
                    var element = $KU.getNodeByModel(widgetModel);
                    element && module.updatePushPullView(widgetModel, propertyName);
                    break;
            }
        },

        render: function(widgetModel, context) {
            var i, secIndex, rowIndexes, selection, arrayIndex;

            widgetModel.selecteditemindex = widgetModel.selecteditemindex || null;
            widgetModel.selecteditems = widgetModel.selecteditems || null;
            widgetModel.selecteditemindices = widgetModel.selecteditemindices || null;
            if(widgetModel.selecteditemindex) {
                setTimeout(function() {
                    module.Utils.setFocus(widgetModel, $KW.Utils.getContentNodeFromNodeByModel(widgetModel), widgetModel.selecteditemindex)
                }, 500);
            }


            $KU.updateScrollFlag(widgetModel);

            widgetModel.context = context;
            widgetModel.selectedState = false;
            var parentModel = widgetModel.parent;
            if($KW.FlexUtils.isFlexContainer(parentModel))
                widgetModel.layoutConfig.self = true;
            var htmlString = module.generateCollectionView(widgetModel, context);

            if(!widgetModel.selecteditemindices && widgetModel.selecteditemindex) {
                widgetModel._items = [widgetModel.selecteditemindex];
                module.setSelectedItemsAndIndices(widgetModel);
            } else if(!widgetModel.selecteditemindex && widgetModel.selecteditemindices) {
                widgetModel._items = (widgetModel._items) ? widgetModel._items : [];
                for(i = 0; i < widgetModel.selecteditemindices.length; i++) {
                    secIndex = parseInt(widgetModel.selecteditemindices[i][0], 10);
                    rowIndexes = widgetModel.selecteditemindices[i][1];
                    for(j = 0; j < rowIndexes.length; j++) {
                        selection = [secIndex, rowIndexes[j]];
                        if(!module.Data.isSelectionOutOfBound(widgetModel, selection)) {
                            arrayIndex = $KU.arrayIndex(widgetModel._items, widgetModel.selecteditemindices);
                            if(widgetModel.selectionbehavior === kony.collectionview.MULTI_SELECT) {
                                if(arrayIndex !== -1) {
                                    widgetModel._items.splice(arrayIndex, 1);
                                } else {
                                    widgetModel._items.push(selection);
                                }
                            } else if(widgetModel.selectionbehavior === kony.collectionview.SINGLE_SELECT) {
                                if(arrayIndex === -1) {
                                    widgetModel._items.push(widgetModel.selecteditemindices);
                                    widgetModel.selecteditemindex = selection;
                                }
                            }
                        }
                    }
                }
                if(widgetModel.selectionbehavior === kony.collectionview.MULTI_SELECT) widgetModel.selecteditemindex = selection;
                module.setSelectedItemsAndIndices(widgetModel);
            }
            if(widgetModel.retainselection && widgetModel.selecteditemindex) {
                setTimeout(function() {
                    module.Skin.setSelectedItemSkins(widgetModel, false)
                }, 100);
            }
            return htmlString;
        },

        getGridStyle: function(widgetModel) {
            var cStyle = "";
            if(widgetModel.layouttype == kony.collectionview.LAYOUT_HORIZONTAL) {
                cStyle = " display: flex; flex-direction: row; justify-content: space-between; flex-wrap: wrap;align-content: flex-start;";
            } else if(widgetModel.layouttype == kony.collectionview.LAYOUT_VERTICAL) {
                cStyle = " display: flex; flex-direction: column; justify-content: space-between; flex-wrap: wrap; align-content: flex-start;";
            } else { 
                cStyle = " position: relative; table-layout:fixed;";
            }
            return cStyle;
        },

        getScrollDirection: function(widgetModel) {
            switch(widgetModel.layouttype) {
                case kony.collectionview.LAYOUT_VERTICAL:
                    return "horizontal";
                case kony.collectionview.LAYOUT_HORIZONTAL:
                    return "vertical";
                case kony.collectionview.LAYOUT_CUSTOM:
                    return widgetModel.scrollDirection; 
            }
        },

        generateCollectionView: function(widgetModel, context) {
            var htmlString = "",
                data = widgetModel.data || [];
            widgetModel._secindex = null;
            var isFlexWidget = $KW.FlexUtils.isFlexWidget(widgetModel);
            var visibility = (!isFlexWidget && (!widgetModel.isvisible || data.length <= 0)) ? "hide" : ""; 

            var widgetSkin = (widgetModel.skin ? widgetModel.skin : "");
            var margin = $KW.skins.getBaseStyle(widgetModel, context);
            var padding = $KW.skins.getPaddingSkin(widgetModel);
            var scrollingevents = widgetModel.scrollingEvents;
            var wID = widgetModel.pf + "_" + widgetModel.id;
            var kmasterObj = $KW.Utils.getMasterIDObj(widgetModel);
            if(kmasterObj.id != "") {
                wID = kmasterObj.id;
            }
            widgetModel.clonedTemplates = [];
            if(data.length > 0) {
                widgetModel.hasSections = $KU.isArray(data[0]);
            }

            var cStyle = module.getGridStyle(widgetModel);
            var style = '';
            var scrolldirection = module.getScrollDirection(widgetModel);
            widgetModel.scrolldirection = scrolldirection;
            widgetModel.enableScrolling = true;
            style = ((scrolldirection == "both") ? "overflow:auto;" : (scrolldirection == "horizontal" ? "overflow-x:auto;overflow-y:hidden;" : scrolldirection == "vertical" ? "overflow-y:auto;overflow-x:hidden;" : "overflow:hidden;"));
            module.Skin.applyItemFocusSkin(widgetModel);

            
            htmlString += "<div" + $KW.Utils.getBaseHtml(widgetModel, context) + " style='" + padding + style + "' class='" + widgetSkin + "'>";
            htmlString += "<div style ='" + cStyle + "'>";

            if(data.length > 0) {
                htmlString += module.generateItems(widgetModel, context, data, false, 0, 0);
            }

            htmlString += "</div>";
            
            htmlString += "</div>";
            return htmlString;
        },

        generateGridHeader: function(model, context, data, template, itemIndex, secIndex, section, noOfItemsToRemove, templateType) {
            var accessAttr = "";
            var headerString = ""
            var trasform = "";
            var secSkin = "";
            var type = "";
            var headerStyle = "";


            if(section || section === "") { 
                var clonedHeaderTemplate;
                if(section instanceof Object) { 

                    if(typeof template == "string") {
                        template = _kony.mvc.initializeSubViewController(template);
                    }
                    $KG.allTemplates[template.id] = template;

                    accessAttr = $KU.getAccessibilityValues(model, section.accessibilityConfig, null, itemIndex);
                    var itemIndex = -1;
                    if(templateType == "Header") {
                        type = "HeaderBox";
                    } else if(templateType == "Footer") {
                        type = "FooterBox";
                        itemIndex = -2;
                    }
                    if(template && $KU.getkeys(section).length > 0) {

                        context.container = model;
                        if(!template.pf) {
                            _konyConstNS.Form2.addHeaderorFooter.call(template, template);
                        }
                        template.isTemplate = true;
                        kony.enableGettersSetters = true; 
                        clonedTemplate = owl.deepCopy(template, null, false);
                        kony.enableGettersSetters = false; 
                        
                        $KW.FlexUtils.setRTLtoTemplates(clonedTemplate);
                        clonedTemplate.isHeaderOrFooter = true;
                        clonedTemplate.parent = model;
                        sectionHtml = (clonedTemplate.wType == "FlexContainer") ? module.renderFlexContainer(clonedTemplate, context, section, model, itemIndex, secIndex) : "";
                        if(sectionHtml === "") {
                            sectionHtml = " ";
                        }

                        delete context.container;
                        if(clonedTemplate.transform)
                            trasform = $KW.animUtils.applyTransform(clonedTemplate, clonedTemplate.transform);


                        if(model.layouttype == kony.collectionview.LAYOUT_CUSTOM) {
                            headerStyle = "position: absolute; "
                        }
                        headerStyle += trasform ? $KU.cssPrefix + "transform:" + trasform : "" + ";" + $KW.Utils.getAnchorPoint(clonedTemplate);
                    }

                }
                if(sectionHtml) { 
                    
                    secSkin = module.Skin.getSectionSkin(clonedTemplate, model, templateType);

                    headerString += "<div kwidgettype='GridNode' type ='" + type + "' style='" + headerStyle + "' class='" + secSkin + " middleleftalign'  index='" + secIndex + "," + itemIndex + "' secindex='" + secIndex + "," + itemIndex + "'" + " kcontainerID = " + model.id + ">" + sectionHtml + "</div>";
                    
                }
                if(templateType == "Header") {
                    model.clonedTemplates.splice(secIndex, noOfItemsToRemove, [clonedTemplate ? clonedTemplate : section, []]);
                } else {
                    model.clonedTemplates[secIndex].push(clonedTemplate ? clonedTemplate : section);
                }

            }
            return headerString;
        },

        generateItems: function(model, context, data, liExists, rowIndex, secIndex, isNew) {
            var htmlString = "",
                seperator = "",
                sectionRows = 0,
                color = model.separatorcolor;
            
            var secRowIndex = 0,
                section = null,
                sectionHtml = "",
                rowHtml = "";
            var gridSkin = model.itemskin;
            var headertemplate, footertemplate, itemTemplate, boxModel;
            data = module.Utils.invertMapAndData(model, data);
            model.counter = rowIndex;
            var noOfItemsToRemove = (isNew == false) ? 1 : 0;


            for(var i = 0; i < data.length; i++) {
                secRowIndex = (!model.hasSections) ? (i - 0) : (data[i].sectionLabel) ? 0 : (secRowIndex + 1);
                var section;
                if(data[i].template || model.itemtemplate) {
                    
                    var tabpaneID = context.tabpaneID;
                    context.tabpaneID = "";
                }

                
                
                model.seccounter = secIndex;
                model.rowcounter = rowIndex;

                if(model.hasSections) {
                    if(data[i].gridHeader) {
                        headertemplate = data[i].gridHeader.template || model.sectionheadertemplate;
                        if(headertemplate) {
                            section = data[i].gridHeader;
                            if(section) {
                                if(i != 0) {
                                    secIndex++;
                                    rowIndex = 0;
                                }
                                headerString = module.generateGridHeader(model, context, data, headertemplate, rowIndex, secIndex, section, noOfItemsToRemove, "Header");
                                htmlString += headerString;
                            }
                        }
                    } else if(typeof data[i].gridHeader != "undefined") {
                        if(i != 0) {
                            secIndex++;
                            rowIndex = 0;
                        }
                        model.clonedTemplates.splice(secIndex, noOfItemsToRemove, [null, []]);
                    }
                }

                context.topLevelBox = true;
                context.container = model;
                trasform = "";
                itemTemplate = data[i].template || model.itemtemplate;
                if(typeof itemTemplate == "string") {
                    itemTemplate = _kony.mvc.initializeSubViewController(itemTemplate);
                }

                itemTemplate.formPathId = model.formPathId;
                $KG.allTemplates[itemTemplate.id] = itemTemplate;

                if(itemTemplate) {
                    !itemTemplate.pf && _konyConstNS.Form2.addHeaderorFooter.call(itemTemplate, itemTemplate); 
                }

                itemTemplate.isTemplate = true;
                kony.enableGettersSetters = true; 
                var clonedItemTemplate = owl.deepCopy(itemTemplate, null, false);
                kony.enableGettersSetters = false; 
                
                $KW.FlexUtils.setRTLtoTemplates(clonedItemTemplate);
                clonedItemTemplate.isHeaderOrFooter = false;
                clonedItemTemplate.parent = model;
                accessAttr = $KU.getAccessibilityValues(model, data[i].accessibilityConfig, null, rowIndex);
                rowHtml = (clonedItemTemplate.wType == "FlexContainer") ? module.renderFlexContainer(clonedItemTemplate, context, data[i], model, rowIndex, secIndex) : "";
                if(data[i].template || model.itemtemplate) {
                    context.tabpaneID = tabpaneID; 
                }

                if(model.hasSections) {
                    model.clonedTemplates[secIndex][1].splice(rowIndex, noOfItemsToRemove, clonedItemTemplate);
                } else {
                    model.clonedTemplates.splice(rowIndex, noOfItemsToRemove, clonedItemTemplate);
                }


                delete context.container;
                if(clonedItemTemplate.transform)
                    trasform = $KW.animUtils.applyTransform(clonedItemTemplate, clonedItemTemplate.transform);

                if(rowHtml) {
                    var computedSkin = module.Skin.getItemSkin(model, clonedItemTemplate, secIndex, rowIndex);
                    var positionStyle = "";
                    if(model.layouttype == kony.collectionview.LAYOUT_CUSTOM) {
                        positionStyle = "position: absolute; "
                    }
                    var style = $KW.Utils.getAnchorPoint(clonedItemTemplate) + " " + (trasform ? $KU.cssPrefix + "transform:" + trasform : "") + positionStyle;
                    

                    htmlString += "<div  kwidgettype='GridNode' type ='itemBox' id='flexcontainer_wrapper' style='" + style +
                        "' index=" + rowIndex + (model.hasSections ? " secindex='" + secIndex + "," + rowIndex + "'" : "") +
                        " kcontainerID = " + model.id;
                    htmlString += ">";

                }
                htmlString += rowHtml;
                if(rowHtml) {
                    htmlString += "</div>";
                }

                if(model.hasSections) {
                    if(data[i].gridFooter) {
                        footertemplate = data[i].gridFooter.template || model.sectionfootertemplate;
                        if(footertemplate) {
                            section = data[i].gridFooter;
                            if(section) {
                                htmlString += module.generateGridHeader(model, context, data, footertemplate, rowIndex, secIndex, section, 2, "Footer");
                            }
                        }
                    } else if(typeof data[i].gridFooter != "undefined") {
                        model.clonedTemplates[secIndex].push(null)
                    }
                }
                rowIndex++;
                model.counter++;
            }
            return htmlString;
        },

        renderFlexContainer: function(flexModel, context, rowData, widgetModel, rowIndex, secIndex) {
            var htmlString = "";
            var length;
            var count = 0;
            var style = "";
            var wrapperBegin = "";
            var wrapperClose = "";
            var widgetData = rowData[flexModel.id];
            $KW.Utils.updateChildModel(flexModel, widgetData);

            if(flexModel.pf === flexModel.id) {
                module.Utils.cleanupLayoutProps(flexModel, widgetModel.layouttype);
                module.updateTemplateContext(flexModel, rowIndex, secIndex);
            }
            module.Skin.applyWidgetFocusSkin(widgetData, flexModel, widgetModel);
            if(!flexModel.isvisible)
                return "";

            var computedSkin = $KW.skins.getWidgetSkin(flexModel, context);
            var boxstyle = " position:relative;" + (flexModel.clipbounds == true ? "overflow:hidden;" : "") + (flexModel.zindex ? "z-index:" + flexModel.zindex : "") + $KW.skins.getBaseStyle(flexModel, context);

            if(flexModel.pf !== flexModel.id) {
                htmlString += "<div id='flexcontainer_wrapper'  style='" + $KW.skins.getMarginSkin(flexModel, context) + "'>";
            }
            htmlString += "<div class = 'kwt100 " + computedSkin + "'" + $KW.Utils.getBaseHtml(flexModel, context) + " style='" + boxstyle + "'>";

            var wArrary = flexModel.widgets();
            length = wArrary.length;

            for(var i = 0; i < length; i++) {
                var childModel = wArrary[i];
                var widgetData = rowData[childModel.id];
                $KW.Utils.updateChildModel(childModel, widgetData);
                module.Skin.applyWidgetFocusSkin(widgetData, childModel, widgetModel);
                if(!childModel.isvisible) {
                    continue;
                }

                var css = "kcell " + $KW.skins.getWidgetAlignmentSkin(childModel) + (childModel.wType == "TPW" ? "  konycustomcss " : "");
                var style = $KW.FlexUtils.getFlexLayoutStyle(childModel);
                var boxHTML = "";
                wrapperBegin = "<div class = '" + css + "' style='" + style + ";overflow:hidden'>";
                wrapperClose = "</div>";

                if(childModel.wType == "FlexContainer") {
                    boxHTML = module.renderFlexContainer(childModel, context, rowData, widgetModel, rowIndex, secIndex);

                    if(boxHTML)
                        htmlString += wrapperBegin + boxHTML + wrapperClose;
                    else
                        count++;
                } else {
                    if(typeof widgetData != "undefined" && widgetData != "") {
                        htmlString += wrapperBegin + $KW[childModel.wType].render(childModel, context) + wrapperClose;
                    } else
                        count++;
                }
            }

            if(length == count)
                return "";

            htmlString += "</div>";
            if(flexModel.pf !== flexModel.id) {
                htmlString += "</div>";
            }
            return htmlString;
        },

        updateTemplateContext: function(widgetModel, itemIndex, secIndex) {
            var childList = widgetModel.children;
            var childModel, i;

            widgetModel.rowContext = {
                "itemIndex": itemIndex,
                "sectionIndex": secIndex
            };

            if(childList) {
                for(i = 0; i < childList.length; i++) {
                    childModel = widgetModel[childList[i]];
                    childModel = $KW.Utils.getActualWidgetModel(childModel);
                    if(childModel && childModel.children && childModel.children.length != 0) {
                        module.updateTemplateContext(childModel, itemIndex, secIndex);
                    } else {
                       childModel.rowContext = {
                            "itemIndex": itemIndex,
                            "sectionIndex": secIndex
                        };
                    }
                }
            }
        },

        updateTemplateContextAfterModifyData: function(cvModel) {
            var sec=0;
            var widgetModel, headerData, i, j, size, rowSize;

            if(cvModel.hasSections) {
                size = cvModel.data.length;
                for(i = 0; i < size; i++) {
                    headerData = cvModel.data[i] ? cvModel.data[i][0] : [];
                    if(headerData) {
                        widgetModel = cvModel.clonedTemplates[i][0];
                        module.updateTemplateContext(widgetModel, -1, i);
                    }
                    rowSize = cvModel.data[i][1].length;
                    for(j=0; j < rowSize; j++) {
                        widgetModel = cvModel.clonedTemplates[i][1][j];
                        module.updateTemplateContext(widgetModel, j, i);
                    }
                    if(cvModel.data[i][2]) {
                        widgetModel = cvModel.clonedTemplates[i][2];
                        module.updateTemplateContext(widgetModel, -2, i);
                    }
                }
            } else {
                rowSize = cvModel.data.length;
                for(i = 0; i < rowSize; i++) {
                    widgetModel = cvModel.clonedTemplates[i];
                    module.updateTemplateContext(widgetModel, i, sec);
                }
            }
        },

        generatePullOrPushViews: function(widgetModel, type, wID) {
            var htmlString = '';
            if(type == 'pull') {
                if(widgetModel.pulltorefreshview && widgetModel.releasetopullrefreshview) {
                    htmlString += module.renderPushPullView(widgetModel, 'pulltorefreshview', wID);
                    htmlString += module.renderPushPullView(widgetModel, 'releasetopullrefreshview', wID);
                }
            } else if(type == 'push') {
                if(widgetModel.pushToRefreshView && widgetModel.releaseToPushRefreshView) {
                    htmlString += module.renderPushPullView(widgetModel, 'pushtorefreshview', wID);
                    htmlString += module.renderPushPullView(widgetModel, 'releasetopushrefreshview', wID);
                }
            }
            return htmlString;
        },

        renderPushPullView: function(widgetModel, viewName, wID) {
            var htmlString = '';
            var _createCloneAndAssignBack = function(cvModel, view, wID) {
                kony.enableGettersSetters = true; 
                var clonedView = owl.deepCopy(cvModel[view], null, wID.replace(/_+/g, ''));
                kony.enableGettersSetters = false; 
                cvModel[view] = clonedView;
                $KG.allTemplates[cvModel[view].id] = cvModel[view];
            };
            _createCloneAndAssignBack(widgetModel, viewName, wID);
            widgetModel[viewName].pf = wID;
            if(widgetModel.layout == kony.collectionview.LAYOUT_HORIZONTAL) {
                widgetModel[viewName].width = "100%";
                if(!widgetModel[viewName].height) {
                    widgetModel[viewName].height = "50dp";
                }
            }
            if(widgetModel.layout == kony.collectionview.LAYOUT_VERTICAL) {
                widgetModel[viewName].height = "100%";
                if(!widgetModel[viewName].width) {
                    widgetModel[viewName].width = "50dp";
                }
            }

            htmlString += $KW.FlexContainer.render(widgetModel[viewName], {});
            return htmlString;
        },

        updatePushPullView: function(widgetModel, viewName) {
            var viewHolder = document.createElement('div');
            var scrollerNode = $KW.Utils.getContentNodeFromNodeByModel(widgetModel);
            var scrolleeId = scrollerNode.id;
            var index = scrolleeId.lastIndexOf('scrollee');
            var wID = scrolleeId.slice(0, index - 1);
            var node = null;
            viewHolder.innerHTML = module.renderPushPullView(widgetModel, viewName, wID);

            var pullViewNode = scrollerNode.children[0];
            var pushViewNode = scrollerNode.children[2];
            switch(viewName) {
                case 'pulltorefreshview':
                    pullViewNode.replaceChild(viewHolder.firstChild, pullViewNode.children[0]);
                    node = pullViewNode.children[0];
                    break;
                case 'releasetopullrefreshview':
                    pullViewNode.replaceChild(viewHolder.firstChild, pullViewNode.children[1]);
                    node = pullViewNode.children[1];
                    break;
                case 'pushtorefreshview':
                    pushViewNode.replaceChild(viewHolder.firstChild, pullViewNode.children[0]);
                    node = pushViewNode.children[0];
                    break;
                case 'releasetopushrefreshview':
                    pushViewNode.replaceChild(viewHolder.firstChild, pullViewNode.children[1]);
                    node = pushViewNode.children[1];
                    break;
            };

            widgetModel[viewName].parent = widgetModel;
            $KW.FlexContainer.forceLayout(widgetModel[viewName], node);
            if(['releasetopullrefreshview', 'releasetopushrefreshview'].indexOf(viewName) != -1) {
                $KU.addClassName(node, 'hide');
            }

            if(['releasetopullrefreshview', 'pulltorefreshview'].indexOf(viewName) != -1) {
                pullViewNode.style.width = (widgetModel.pulltorefreshview && widgetModel.pulltorefreshview.frame.width || 0) + 'px';
                pullViewNode.style.height = (widgetModel.pulltorefreshview && widgetModel.pulltorefreshview.frame.height || 0) + 'px';
            } else {
                pushViewNode.style.width = (widgetModel.pushtorefreshview && widgetModel.pushtorefreshview.frame.width || 0) + 'px';
                pushViewNode.style.height = (widgetModel.pushtorefreshview && widgetModel.pushtorefreshview.frame.height || 0) + 'px';
            }
        },

        
        updateData: function(childModel, childNode, widgetModel, row, canExecute, eventType) {
            if(widgetModel && row) {
                var context = module.Utils.getContextByNode(widgetModel, row);
                var itemIndex = context.itemIndex;
                var secIndex = (context.sectionIndex) ? context.sectionIndex : 0;
                var data = widgetModel.data;
                var item = null;
                var returnAfterDataUpdate = 0;

                if(widgetModel.selectionbehavior == kony.collectionview.SINGLE_SELECT && (widgetModel.hasSections ? (widgetModel._secindex == secIndex) && (widgetModel._focusedindex == itemIndex) : (widgetModel._focusedindex == itemIndex))) {
                    returnAfterDataUpdate = 1;
                }

                widgetModel._secindex = secIndex;

                if(itemIndex != -1 && itemIndex != -2) {
                    widgetModel._focusedindex = itemIndex;
                    widgetModel.selecteditemindex = [secIndex, itemIndex];
                }
                widgetModel.currentIndex = [secIndex, itemIndex];

                
                if(widgetModel.hasSections) {
                    if(itemIndex == -1) {
                        item = data[secIndex][0];
                    } else if(itemIndex == -2) {
                        item = data[secIndex][2];
                    } else {
                        var sectionData = data[secIndex][1];
                        item = sectionData[itemIndex];
                    }
                } else {

                    item = widgetModel.data[itemIndex];
                }

                if(item) {
                    item.metainfo = item.metaInfo || item.metainfo;
                }
                var clickable = (item && item.metainfo) ? item.metainfo.clickable : true;

                $KW.Utils.updateContainerMasterData(widgetModel, item, childModel, childNode, eventType);


                if(!returnAfterDataUpdate && itemIndex != -1 && itemIndex != -2) {
                    module.toggleRowSelection(widgetModel, row.parentNode);
                }

                var itemData = module.Data.getRowDataByIndex(widgetModel, [secIndex, itemIndex]);
                var eventRef = itemData ? $KU.returnEventReference(itemData.onitemselect || itemData.onItemSelect || widgetModel.onitemselect) : null;

                if(clickable && canExecute) {
                    if((widgetModel.onitemselect) && !childNode.getAttribute("kcontainerID")) { 
                        eventRef && $KU.executeWidgetEventHandler(widgetModel, eventRef, secIndex, itemIndex); 
                    } else {
                        var eventExecuted = kony.events.executeBoxEvent(childModel, itemData, widgetModel);
                        if(itemIndex != -1 && itemIndex != -2) { 
                            if(!eventExecuted && eventRef) {
                                $KU.executeWidgetEventHandler(widgetModel, eventRef, secIndex, itemIndex);
                                $KU.onEventHandler(widgetModel);
                            }
                        }
                    }
                    if(!kony.system.activity.hasActivity())
                        $KW.unLoadWidget();
                }
                
                var childMeta = item[childModel.id];
                if(childMeta && typeof childMeta == "object") {
                    if(childMeta.enable === false)
                        return false;
                }
            }
            return true;
        },

        toggleRowSelection: function(widgetModel, holder) {
            if(typeof widgetModel.selecteditemindex == "undefined") {
                var secIndex = 0;
                var rowIndex = widgetModel._focusedindex;
            } else if(widgetModel.selecteditemindex) {
                var secIndex = widgetModel.selecteditemindex[0];
                var rowIndex = widgetModel.selecteditemindex[1];
            } else {
                var secIndex = widgetModel.selecteditemindices[0][0];
                var rowIndex = widgetModel.selecteditemindices[0][1][0];
            }

            

            widgetModel._items = (widgetModel._items) ? widgetModel._items : [];

            var item = [secIndex, rowIndex];
            var _items = [];
            var arrIndex = $KU.arrayIndex(widgetModel._items, item);
            if(arrIndex != -1) { 
                var selected = false;
                widgetModel._items.splice(arrIndex, 1);
            } else {
                var selected = true;
                if(widgetModel.selectionbehavior == kony.collectionview.MULTI_SELECT) {
                    widgetModel._items.push(item);
                } else {
                    widgetModel._items = [item];
                }
            }
            _items.push(item);
            widgetModel._items = (widgetModel._items && widgetModel._items.length > 0) ? widgetModel._items : null;

            module.Skin.adjustGridSkins(widgetModel, _items);

            widgetModel.onselect && widgetModel.onselect(widgetModel, widgetModel.selectedItemIndex, selected);
            widgetModel.selectedState = selected;
        },

        eventHandler: function(eventObject, target, sourceFormID) {
            var widgetModel = $KU.getModelByNode(target);
            if(target.getAttribute("kwidgettype") != 'CollectionView') {
                $KW.Utils.updateContainerData(widgetModel, target, true);
            }
        },

        setSelectedItemsAndIndices: function(widgetModel, ignoreIndices) {
            if(widgetModel._items) {
                widgetModel.selecteditems = [];
                var sections = {};
                for(var i = 0; i < widgetModel._items.length; i++) {
                    var secIndex = widgetModel._items[i][0];;
                    var rowIndex = widgetModel._items[i][1];
                    if(!ignoreIndices) {
                        if(!sections[secIndex]) sections[secIndex] = [];
                        sections[secIndex].push(rowIndex);
                    }
                    if(widgetModel.hasSections) {
                        var sectionData = widgetModel.data[secIndex][1];
                        var item = sectionData[rowIndex];
                    } else {
                        var item = widgetModel.data[rowIndex];
                    }
                    widgetModel.selecteditems.push(item);
                }
                if(!ignoreIndices) {
                    widgetModel.selecteditemindices = [];
                    for(var k in sections) {
                        var section = (0) ? [null] : [];
                        section.push(parseInt(k, 10));
                        section.push(sections[k]);
                        widgetModel.selecteditemindices.push(section);
                    }
                }
            } else {
                widgetModel._secindex = widgetModel._focusedindex = null;
                widgetModel.selecteditems = null;
                widgetModel.selecteditemindex = null;
                if(!ignoreIndices) {
                    widgetModel.selecteditemindices = null;
                }
            }
        },

        applyLineSpaceAndItemSpace: function(CollecetionViewModel, CollecetionViewNode) {
            var data = CollecetionViewModel.data,
                rowNodes = [],
                _applyMarginForLastItem = function(model, width, height) {
                    var parentValue = 0;
                    var parentNode = $KU.getNodeByModel(model);
                    if(model.layouttype == kony.collectionview.LAYOUT_HORIZONTAL) {
                        var hBorder = parseInt($KU.getStyle(parentNode, "border-left-width"), 10) + parseInt($KU.getStyle(parentNode, "border-right-width"), 10);
                        var cvWidth = model.frame.width - hBorder;
                        prevWidget.flexNode.style.marginRight = cvWidth - width + 'px';
                    } else if(model.layouttype == kony.collectionview.LAYOUT_VERTICAL) {
                        var vBorder = parseInt($KU.getStyle(parentNode, "border-top-width"), 10) + parseInt($KU.getStyle(parentNode, "border-bottom-width"), 10);
                        var cvHeight = model.frame.height - vBorder;
                        prevWidget.flexNode.style.marginBottom = cvHeight - height + 'px';
                    }
                },
                _isItOfNewRow = function(width, currentSum, parentWidth) {
                    return width + currentSum > parentWidth;
                },
                _isItOfNewColumn = function(height, currentSum, parentHieght) {
                    return height + currentSum > parentHieght;
                },
                _getNodeAndModel = function(rowNode) {
                    var secIndex;
                    var flexNode = rowNode.querySelector('div[kwidgettype="FlexContainer"]');
                    if(flexNode) {
                        rowIndex = rowNode.getAttribute('index');
                        if(CollecetionViewModel.hasSections) {
                            secIndex = rowNode.getAttribute('secindex').split(',')[0];
                        }
                        var flexModel = module.Utils.getClonedModel(CollecetionViewModel, rowIndex, secIndex);
                        flexNode = flexNode.parentNode;
                        return {
                            flexNode: flexNode,
                            flexModel: flexModel
                        };
                    }
                },
                _resetMargin = function(wNode) {
                    wNode.style.removeProperty('margin');
                }
            if(data && data.length > 0) {

                var canApplyTop = false 
                    ,
                    canApplyLeft = false 
                    ,
                    cvWidth = CollecetionViewModel.frame.width 
                    ,
                    cvHeight = CollecetionViewModel.frame.height 
                    ,
                    heightSum = 0 
                    ,
                    i = 0,
                    isFirstItem = true,
                    itemSpace = module.Utils.getValueInPxBasedOnLayoutType('minItemSpace', CollecetionViewModel),
                    lineSpace = module.Utils.getValueInPxBasedOnLayoutType('minLineSpace', CollecetionViewModel),
                    WidthSum = 0 
                    ,
                    prevSecIndex = -1,
                    prevWidget = undefined;

                
                itemSpace = (itemSpace < 0) ? 0 : itemSpace;
                lineSpace = (lineSpace < 0) ? 0 : lineSpace;

                rowNodes = module.getCollectionViewBaseNode(CollecetionViewModel, CollecetionViewNode).children;
                for(i = 0; i < rowNodes.length; i++) {
                    var rowNode = rowNodes[i];
                    if(rowNode) {
                        if(CollecetionViewModel.hasSections) {
                            var currSectionIndex = rowNode.getAttribute('secindex').split(',')[0];
                            if(prevSecIndex != currSectionIndex) {
                                prevWidget && _applyMarginForLastItem(CollecetionViewModel, WidthSum, heightSum);
                                prevWidget = undefined;
                                canApplyTop = canApplyLeft = 0;
                                heightSum = WidthSum = 0;
                                isFirstItem = true;
                                prevSecIndex = currSectionIndex;
                            }
                        }
                        if(['HeaderBox', 'FooterBox'].indexOf(rowNode.getAttribute('type')) != -1)
                            continue
                        var currWidget = _getNodeAndModel(rowNode);
                        _resetMargin(currWidget.flexNode);
                        if(CollecetionViewModel.layouttype == kony.collectionview.LAYOUT_HORIZONTAL) {
                            var width = currWidget.flexModel.frame.width;
                            if(prevWidget && _isItOfNewRow(width, WidthSum + itemSpace, cvWidth)) {
                                WidthSum = 0;
                                canApplyTop = true;
                                if(isFirstItem) {
                                    var prevWidth = prevWidget.flexModel.frame.width;
                                    prevWidget.flexNode.style.marginLeft = (cvWidth - prevWidth) / 2 + 'px'; 
                                    prevWidget.flexNode.style.marginRight = (cvWidth - prevWidth) / 2 + 'px';
                                }
                                isFirstItem = true;
                            } else if(prevWidget) {
                                prevWidget.flexNode.style.marginRight = itemSpace + 'px';
                                WidthSum += itemSpace;
                                isFirstItem = false;
                            }
                            WidthSum += width;
                            if(canApplyTop)
                                currWidget.flexNode.style.marginTop = lineSpace + 'px';
                        } else if(CollecetionViewModel.layouttype == kony.collectionview.LAYOUT_VERTICAL) {
                            var height = currWidget.flexModel.frame.height;
                            if(prevWidget && _isItOfNewColumn(height, heightSum + itemSpace, cvHeight)) {
                                heightSum = 0;
                                canApplyLeft = true;
                                if(isFirstItem) {
                                    var prevHeight = prevWidget.flexModel.frame.height;
                                    prevWidget.flexNode.style.marginTop = (cvHeight - prevHeight) / 2 + 'px'; 
                                    prevWidget.flexNode.style.marginBottom = (cvHeight - prevHeight) / 2 + 'px';
                                }
                                isFirstItem = true;
                            } else if(prevWidget) {
                                prevWidget.flexNode.style.marginBottom = itemSpace + 'px';
                                heightSum += itemSpace;
                                isFirstItem = false;
                            }
                            heightSum += height;
                            if(canApplyLeft)
                                currWidget.flexNode.style.marginLeft = lineSpace + 'px';
                        }
                        prevWidget = currWidget;
                    }

                }
                prevWidget && _applyMarginForLastItem(CollecetionViewModel, WidthSum, heightSum);
            }
        },

        getCollectionViewBaseNode: function(wModel, node) {
            node = node || $KW.Utils.getContentNodeFromNodeByModel(wModel);
            node = node.children[0];
            return node;
        },

        adjustPullPushViewsInCollectionView: function(wModel, node) {
            
            var pullViewNode = node.children[0];
            var mainNode = node.children[1];
            var pushViewNode = node.children[2];
            var layouttype = wModel.layouttype;
            if(pullViewNode.children.length) {
                
                wModel.pulltorefreshview.parent = wModel;
                wModel.releasetopullrefreshview.parent = wModel;

                $KW.FlexContainer.forceLayout(wModel.pulltorefreshview, pullViewNode.children[0]);
                $KW.FlexContainer.forceLayout(wModel.releasetopullrefreshview, pullViewNode.children[1]);

                
                $KU.addClassName(pullViewNode.children[1], 'hide');

            }
            if(pushViewNode.children.length) {
                wModel.pushtorefreshview.parent = wModel;
                wModel.releasetopushrefreshview.parent = wModel;

                $KW.FlexContainer.forceLayout(wModel.pushtorefreshview, pushViewNode.children[0]);
                $KW.FlexContainer.forceLayout(wModel.releasetopushrefreshview, pushViewNode.children[1]);

                $KU.addClassName(pushViewNode.children[1], 'hide');
            }
            if(layouttype == kony.collectionview.LAYOUT_HORIZONTAL) {
                node.style.display = "block";
            } else {
                node.style.display = "flex";
            }
            pushViewNode.style.display = 'inline-block';
            pullViewNode.style.display = 'inline-block';

            pullViewNode.style.width = (wModel.pulltorefreshview && wModel.pulltorefreshview.frame.width || 0) + 'px';
            pullViewNode.style.height = (wModel.pulltorefreshview && wModel.pulltorefreshview.frame.height || 0) + 'px';

            pushViewNode.style.width = (wModel.pushtorefreshview && wModel.pushtorefreshview.frame.width || 0) + 'px';
            pushViewNode.style.height = (wModel.pushtorefreshview && wModel.pushtorefreshview.frame.height || 0) + 'px';
        },

        adjustFlexContainersInCollectionView: function(widgetModel, gridNode) {
            var data = widgetModel.data;

            if(data && data.length > 0) {
                itemNodes = module.getCollectionViewBaseNode(widgetModel, gridNode).children;
                for(var i = 0; i < itemNodes.length; i++) {
                    var itemNode = itemNodes[i];
                    var flexNode = itemNode.querySelector('div[kwidgettype="FlexContainer"]');
                    var secIndex, rowIndex, index;
                    if(widgetModel.hasSections) {
                        var index = itemNode.getAttribute("secindex").split(',');
                        secIndex = index[0];
                        rowIndex = index[1];
                    } else {
                        rowIndex = itemNode.getAttribute("index");
                        secIndex = -1;

                    }
                    var type = itemNode.getAttribute("type");

                    if(flexNode) {
                        if(type == "HeaderBox") {
                            var flexModel = module.Utils.getClonedModel(widgetModel, "header", secIndex);
                        } else if(type == "FooterBox") {
                            var flexModel = module.Utils.getClonedModel(widgetModel, "footer", secIndex);
                        } else {
                            var flexModel = module.Utils.getClonedModel(widgetModel, rowIndex, secIndex);
                        }
                        $KW.FlexContainer.forceLayout(flexModel, flexNode.parentNode);
                    }
                }
            }
        },

        scrollToItemAtIndex: function(CollecetionViewModel, itemObject, animate) {
            var cvNode = $KU.getNodeByModel(CollecetionViewModel);
            var itemIndex = itemObject.itemIndex;
            var sectionIndex = itemObject.sectionIndex;
            var element = null;
            var scrollerInstance
            var _setTopLeftToNode = function(cvModel, cvNode, left, top) {
                $KW.APIUtils.setfocus(cvModel);
                cvNode.scrollLeft = left;
                cvNode.scrollTop = top;
            };
            if(!cvNode)
                return;
            if(!(itemIndex >= 0) || (CollecetionViewModel.hasSections && !(sectionIndex >= 0)))
                return;
            if(CollecetionViewModel.hasSections) {
                element = cvNode.querySelector('[secindex=' + "\"" + sectionIndex + "," + itemIndex + "\"" + ']');
            } else {
                element = cvNode.querySelector('[index=' + "\"" + itemIndex + "\"" + ']');
            }
            _setTopLeftToNode(CollecetionViewModel, cvNode, element.offsetLeft, element.offsetTop); 
        }
    };

    module.Skin = {
        
        
        applyItemFocusSkin: function(model) {
            var itemTemplate = model.itemtemplate;
            var skin = itemTemplate.focusskin || model.itemselectedskin;
            var gridId = $KW.Utils.getKMasterWidgetID(model);
            if(skin) {
                var classSelector = "";
                classSelector = "#" + gridId + " [index]:active";
                $KW.skins.applyStyle(skin, classSelector, "FlexContainer");
            }
        },

        
        applyWidgetFocusSkin: function(widgetData, childModel, widgetModel) {
            var gridId = $KW.Utils.getKMasterWidgetID(widgetModel);
            var childId = $KW.Utils.getKMasterWidgetID(childModel);
            var focusSkin = childModel.focusskin;

            if(widgetData && widgetData.focusSkin) {
                focusSkin = widgetData.focusSkin;
            }
            if(!focusSkin && childModel.id === childModel.pf) {
                focusSkin = widgetModel.itemselectedskin;
            }
            if(focusSkin) {
                var classSelector = "";
                if(widgetModel.hasSections) {
                    classSelector = "#" + gridId + " div[secindex='" + childModel.rowContext.sectionIndex + "," + childModel.rowContext.itemIndex + "'] #" + childId + ":active";
                } else {
                    classSelector = "#" + gridId + " div[index='" + childModel.rowContext.itemIndex + "'] #" + childId + ":active";

                }
                $KW.skins.applyStyle(focusSkin, classSelector, widgetModel.wType);
            }
            var hoverSkin = childModel.hoverskin;
            if(widgetData && widgetData.hoverSkin) {
                hoverSkin = widgetData.hoverSkin || widgetData.hoverskin;
            }
            if(hoverSkin) {
                var classSelector = "";
                if(widgetModel.hasSections) {
                    classSelector = "#" + gridId + " div[secindex='" + childModel.rowContext.sectionIndex + "," + childModel.rowContext.itemIndex + "'] #" + childId + ":hover";
                } else {
                    classSelector = "#" + gridId + " div[index='" + childModel.rowContext.itemIndex + "'] #" + childId + ":hover";

                }
                $KW.skins.applyStyle(hoverSkin, classSelector, widgetModel.wType);
            }
        },

        setSelectedItemSkins: function(model, changedItemSelectedSkin, newSkin, oldSkin) {
            var elements = $KU.getNodeByModel(model);
            var selectedIndices = model.selecteditemindices;
            if(selectedIndices) {
                for(var sectionCounter = 0; sectionCounter < selectedIndices.length; sectionCounter++) {
                    var rowLength = selectedIndices[sectionCounter][1].length;
                    var rowItems = selectedIndices[sectionCounter][1];
                    var sectionIndex = selectedIndices[sectionCounter][0];
                    for(var rowCounter = 0; rowCounter < rowLength; rowCounter++) {
                        var selectedNode;
                        if(model.hasSections) {
                            selectedNode = elements.querySelector("div[type = 'itemBox'][index='" + rowItems[rowCounter] + "'][secindex='" + sectionIndex + "," + rowItems[rowCounter] + "']");
                        } else {
                            selectedNode = elements.querySelector("div[type = 'itemBox'][index='" + rowItems[rowCounter] + "']");
                        }
                        if(selectedNode) {
                            var clonedTemplate = module.Utils.getItemTemplateByNode(model, selectedNode);
                            if(changedItemSelectedSkin) {
                                if(!clonedTemplate.skin) {
                                    $KU.removeClassName(selectedNode, oldSkin);
                                    $KU.addClassName(selectedNode, newSkin);
                                }
                            } else {
                                var skin = module.Skin.getItemSkin(model, clonedTemplate);
                                var focusSkin = module.Skin.getItemFocusSkins(model, clonedTemplate);
                                $KU.removeClassName(selectedNode, skin);
                                $KU.addClassName(selectedNode, focusSkin);
                            }
                        }
                    }
                }
            }
        },

        updateTemplateSkin: function(model, element, skin, oldSkin, type) {
            if(element) {
                
                var sections = element.querySelectorAll("div[type = '" + type + "']");
                for(var i = 0; i < sections.length; i++) {
                    if($KU.hasClassName(sections[i], oldSkin)) {
                        var template = module.Utils.getItemTemplateByNode(model, sections[i]);
                        var prevSkin = template.skin;
                        if(prevSkin != oldSkin) {
                            $KU.removeClassName(sections[i], oldSkin);
                            $KU.addClassName(sections[i], skin);
                        }
                    }
                }
            }
        },

        getItemSkin: function(model, itemTemplate) {
            var computedSkin = itemTemplate.skin || model.itemskin;
            return computedSkin;
        },

        getItemFocusSkins: function(model, itemTemplate) {
            var skin = itemTemplate.focusskin || itemTemplate.focusSkin || model.itemselectedskin;
            return skin;
        },

        getSectionSkin: function(template, model, templateType) {
            var computedSkin = "";
            if(template.skin) {
                computedSkin = template.skin;
            } else {
                if(templateType == "Header" && model.sectionheaderskin) {
                    computedSkin = model.sectionheaderskin;
                } else if(templateType == "Footer" && model.sectionfooterskin) {
                    computedSkin = model.sectionfooterskin;
                }
            }
            return computedSkin;
        },

        resetItemSkins: function(model) {
            var wNode = $KU.getNodeByModel(model);
            var listOfItems = wNode.querySelectorAll("div[type = 'itemBox']");
            for(var i = 0; i < listOfItems.length; i++) {
                var clonedTemplate = module.Utils.getItemTemplateByNode(model, listOfItems[i]);
                var skin = module.Skin.getItemSkin(model, clonedTemplate);
                var focusSkin = module.Skin.getItemFocusSkins(model, clonedTemplate);
                $KU.removeClassName(listOfItems[i], focusSkin);
                $KU.addClassName(listOfItems[i], skin);
            }
        },

        
        adjustGridSkins: function(widgetModel, checkedItems) {
            var wNode = $KU.getNodeByModel(widgetModel);
            if(widgetModel.retainselection && wNode && checkedItems) {
                var counterLength = checkedItems.length;
                for(var checkedItemsCounter = 0; checkedItemsCounter < counterLength; checkedItemsCounter++) {
                    var checkedItem;
                    var secIndex = checkedItems[checkedItemsCounter][0];
                    var rowIndex = checkedItems[checkedItemsCounter][1];
                    var selectedModel;
                    var skin, focusSkin;

                    if(widgetModel.hasSections) {
                        checkedItem = wNode.querySelector("div[type = 'itemBox'][secindex='" + secIndex + "," + rowIndex + "']");
                    } else {
                        checkedItem = wNode.querySelector("div[type = 'itemBox'][index='" + rowIndex + "']")
                    }

                    var listOfItems = wNode.querySelectorAll("div[type = 'itemBox']");
                    for(var i = 0; i < listOfItems.length; i++) {
                        if(listOfItems[i] == checkedItem) {
                            selectedModel = module.Utils.getItemTemplateByNode(widgetModel, listOfItems[i]);
                            break;
                        }
                    }

                    skin = module.Skin.getItemSkin(widgetModel, selectedModel);
                    focusSkin = module.Skin.getItemFocusSkins(widgetModel, selectedModel);
                    if(widgetModel.selectionbehavior == kony.collectionview.SINGLE_SELECT) {
                        
                        module.Skin.resetItemSkins(widgetModel)
                        $KU.removeClassName(checkedItem, skin);
                        $KU.addClassName(checkedItem, focusSkin);
                    } else {
                        if($KU.hasClassName(checkedItem, skin)) {
                            $KU.removeClassName(checkedItem, skin);
                            $KU.addClassName(checkedItem, focusSkin);
                        } else {
                            $KU.removeClassName(checkedItem, focusSkin);
                            $KU.addClassName(checkedItem, skin);
                        }
                    }
                }
            }
            module.setSelectedItemsAndIndices(widgetModel);
        }
    };

    module.Data = {
        setData: function(model, data) {
            if($KU.isArray(data)) {
                if(data.length > 0) {
                    model.hasSections = $KU.isArray(data[0]);
                    module.Data.modifyContent(model, data, "setdata", null, null);
                } else {
                    module.Data.removeAll(model);
                }
            } else {
                throw new KonyError(102, "Error", "Invalid input.");
            }
        },

        addAll: function(model, data) {
            if($KU.isArray(data)) {
                if(!$KU.isArray(model.data)) {
                    model.data = (0) ? [null] : [];
                }
                if(typeof model.hasSections !== "boolean") model.hasSections = $KU.isArray(data[0]);
                module.Data.modifyContent(model, data, "addall", null, null);
            } else {
                throw new KonyError(102, "Error", "Invalid input.");
            }
        },

        removeAll: function(model) {
            module.Data.modifyContent(model, 0 ? [null] : [], "removeall", null, null);
        },

        removeDataAt: function(model, rowIndex, secIndex, count) {
            if(!isNaN(rowIndex) || (secIndex && !isNaN(secIndex))) {
                if(!module.Utils.isIndexAndCountValid(model, rowIndex, secIndex, count, false)) return;
                if(count != 0) {
                    count = (count == null || count == undefined) ? 1 : count;
                    if($KU.isArray(model.data) && model.data.length > 0) {
                        module.Data.modifyContent(model, [], "removedataat", rowIndex, secIndex, count);
                    }
                }
            } else {
                throw new KonyError(102, "Error", "Invalid input.");
            }
        },

        setDataAt: function(model, data, rowIndex, secIndex) {
            if($KU.isArray(data) && (!isNaN(rowIndex) || (secIndex && !isNaN(secIndex)))) {
                if(!module.Utils.isIndexAndCountValid(model, rowIndex, secIndex, null, false)) return;
                if($KU.isArray(model.data) && model.data.length > 0) {
                    module.Data.modifyContent(model, data, "setdataat", rowIndex, secIndex);
                }
            } else {
                throw new KonyError(102, "Error", "Invalid input.");
            }
        },

        addAt: function(model, data, rowIndex, secIndex) {
            if($KU.isArray(data) && (!isNaN(rowIndex) || (secIndex && !isNaN(secIndex)))) {
                if(!module.Utils.isIndexAndCountValid(model, rowIndex, secIndex, null, false)) return;
                if(!$KU.isArray(model.data)) {
                    model.data = [];
                }
                if(typeof model.hasSections !== "boolean") model.hasSections = $KU.isArray(data[0]);
                module.Data.modifyContent(model, data, "addat", rowIndex, secIndex);
            } else {
                throw new KonyError(102, "Error", "Invalid input.");
            }
        },

        addDataAt: function(model, data, rowIndex, secIndex) {
            if($KU.isArray(data) && (!isNaN(rowIndex) || (secIndex && !isNaN(secIndex)))) {
                if(!module.Utils.isIndexAndCountValid(model, rowIndex, secIndex, null, false, "adddataat")) return;
                if(!$KU.isArray(model.data)) {
                    model.data = [];
                }
                if(typeof model.hasSections !== "boolean") model.hasSections = $KU.isArray(data[0]);
                module.Data.modifyContent(model, data, "adddataat", rowIndex, secIndex);
            } else {
                throw new KonyError(102, "Error", "Invalid input.");
            }
        },

        setDataWithSections: function(model, data) {
            if($KU.isArray(data) && $KU.isArray(data[0])) {
                module.Data.setData(model, data);
            } else {
                throw new KonyError(102, "Error", "Invalid input.");
            }
        },

        addSectionAt: function(model, data, secIndex) {
            if(typeof model.hasSections !== "boolean" && $KU.isArray(data[0])) model.hasSections = true;

            if(model.hasSections === false) {
                throw new KonyError(103, "Error", "Invalid operation.");
            } else if(!$KU.isArray(data[0])) {
                throw new KonyError(102, "Error", "Invalid input.");
            }
            if(!module.Utils.isIndexAndCountValid(model, null, secIndex, null, false, "addsectionat")) return;
            if(model.hasSections === true) {
                if(!$KU.isArray(model.data)) {
                    model.data = (0) ? [null] : [];
                }
                module.Data.modifyContent(model, data, "addsectionat", 0, secIndex);
            }
        },

        setSectionAt: function(model, data, secIndex) {
            if(model.hasSections) {
                if($KU.isArray(data) && !isNaN(secIndex)) {
                    if(!module.Utils.isIndexAndCountValid(model, null, secIndex, null, false)) return;
                    var count = data.length;
                    if($KU.isArray(model.data)) module.Data.modifyContent(model, data, "setsectionat", 0, secIndex, count);
                } else {
                    throw new KonyError(102, "Error", "Invalid input.");
                }
            } else {
                throw new KonyError(103, "Error", "Invalid operation.");
            }
        },

        removeSectionAt: function(model, secIndex, count) {
            if(model.hasSections) {
                if(!isNaN(secIndex)) {
                    if(!module.Utils.isIndexAndCountValid(model, null, secIndex, count, true)) return;
                    if(count != 0) {
                        count = (count == null || count == undefined) ? 1 : count;
                        if($KU.isArray(model.data)) module.Data.modifyContent(model, null, "removesectionat", 0, secIndex, count);
                    }
                } else {
                    throw new KonyError(102, "Error", "Invalid input.");
                }
            } else {
                throw new KonyError(103, "Error", "Invalid operation.");
            }
        },

        modifyContent: function(model, data, action, rowIndex, secIndex, count) {
            var _updateCollectionViewModel = function(model, data, action, rowIndex, secIndex, count) {
                model.canUpdateUI = false;
                $KW.Utils.updateContent(model, "data", data, action, rowIndex, secIndex, count);
                module.Data.adjustAlreadySelectedProperties(model, action, secIndex, rowIndex);
                model.canUpdateUI = true;
            };
            var size, upperLimit, i, j, sectionData;
            var secRowIndexArray = [0, 0],
                boundaryConditionToBeConsidered = false;
            if(action == "addat" || action == "adddataat" || action == "addsectionat") {
                boundaryConditionToBeConsidered = true;
            } else if(action == "setdata" || action == "removeall") {
                boundaryConditionToBeConsidered = secRowIndexArray;
            } else if(action == "addall") {
                boundaryConditionToBeConsidered = (!model.hasSections) ? [0, model.data.length] : [model.data.length, 0];
            }
            secRowIndexArray = module.Data.calculateSectionRowIndex(model, rowIndex, secIndex, boundaryConditionToBeConsidered);

            if(!model || secRowIndexArray === false) return;

            secIndex = secRowIndexArray[0], rowIndex = secRowIndexArray[1];

            var segmentNode = $KU.getNodeByModel(model);

            if(!segmentNode) {
                _updateCollectionViewModel(model, data, action, rowIndex, secIndex, count);
                return; 
            }

            model.context = model.context ? model.context : {};
            model.context.tabpaneID = segmentNode.getAttribute("ktabpaneid") || "";

            
            var isFlexWidget = $KW.FlexUtils.isFlexWidget(model);
            
            if(!isFlexWidget)
                $KU.toggleVisibilty(segmentNode, model.data, model);

            
            if(model.hasSections === false && !segmentNode.firstChild) {
                var cStyle = module.getGridStyle(model);
                segmentNode.innerHTML = "<div style ='" + cStyle + "'></div>";
            }

            segmentNode = module.getCollectionViewBaseNode(model);

            var rowNode = null,
                secNodes = null,
                secNode = null,
                secInnerNodes = null;
            var newSections = 0,
                sectionStart = 0,
                sectionEnd = 0,
                sectionEndIndex = 0;
            if(model.hasSections) {
                sectionStart = (secIndex == 0) ? 0 : module.Utils.getElementsCountTillSections(model.data, secIndex);
                sectionEndIndex = (action === "removedataat") ? secIndex + 1 : ((count) ? secIndex + count : secIndex + 1);
                sectionEnd = (Object.keys(model.data).length > secIndex) ? module.Utils.getElementsCountTillSections(model.data, sectionEndIndex) : sectionStart;
                secInnerNodes = module.Utils.spliceObjectBasedOnIndex(segmentNode.childNodes, sectionStart, sectionEnd);
            }

            
            _updateCollectionViewModel(model, data, action, rowIndex, secIndex, count);

            if(action == "setdata")
                model.clonedTemplates = [];
            var onRowDisplayInfo;

            switch(action) {
                case "setdata":
                    if(model.hasSections) {
                        segmentNode.innerHTML = module.generateItems(model, model.context, model.data, false, rowIndex, secIndex);
                    } else {
                        segmentNode.innerHTML = module.generateItems(model, model.context, model.data, false, rowIndex, secIndex);
                        module.Utils.refreshScrollerInstance(model);
                    }
                    break;

                case "removeall":
                    segmentNode.innerHTML = "";
                    module.Utils.refreshScrollerInstance(model);
                    break;

                case "setsectionat":
                    var wrapper = document.createElement("div");
                    wrapper.innerHTML = module.generateItems(model, model.context, data, false, rowIndex, secIndex, false);
                    var newSec = wrapper.children;
                    for(var i = 0; i < secInnerNodes.length; i++) {
                        segmentNode.removeChild(secInnerNodes[i]);
                    }
                    var nextNode = segmentNode.childNodes[sectionStart];
                    while(newSec.length > 0) {
                        segmentNode.insertBefore(newSec[0], nextNode);
                    }
                    newSections = count;
                    break;

                case "removesectionat":
                    for(var i = 0; i < secInnerNodes.length; i++) {
                        segmentNode.removeChild(secInnerNodes[i]);
                    }
                    model.clonedTemplates.splice(secIndex, count);
                    break;

                case "addsectionat":
                    var wrapper = document.createElement("div");
                    wrapper.innerHTML = module.generateItems(model, model.context, data, false, rowIndex, secIndex);
                    newSections = wrapper.children;
                    var counter = 0;
                    while(wrapper.children.length > 0) {
                        segmentNode.insertBefore(wrapper.childNodes[0], segmentNode.childNodes[sectionStart + counter]);
                        counter++;
                    }
                    newSections = data.length;
                    break;

                case "addall":
                    var wrapper = document.createElement("div");
                    if(!model.hasSections) {
                        wrapper.innerHTML = module.generateItems(model, model.context, data, false, rowIndex, secIndex);
                        while(wrapper.children.length > 0) {
                            segmentNode.appendChild(wrapper.childNodes[0]);
                        }
                    } else {
                        newSections = data.length;
                        var tempSecIndex = secIndex;
                        for(var i = 0; i < data.length; i++) {
                            wrapper.innerHTML = module.generateItems(model, model.context, (0) ? [null, data[i]] : [data[i]], false, rowIndex, tempSecIndex);
                            while(wrapper.children.length > 0) {
                                segmentNode.appendChild(wrapper.childNodes[0]);
                            }
                            tempSecIndex++;
                        }

                    }
                    break;

                case "setdataat":
                    var wrapper = document.createElement('div');
                    if(!model.hasSections) {
                        var rowNode = module.Utils.spliceObjectBasedOnIndex(segmentNode.childNodes, rowIndex, rowIndex + data.length);
                        
                        wrapper.innerHTML = module.generateItems(model, model.context, data, true, rowIndex, secIndex, false);
                    } else {
                        var headerCount = (model.data[secIndex][0] !== null) ? 1 : 0;
                        var rowNode = secInnerNodes.splice(rowIndex + headerCount, data.length);
                        wrapper.innerHTML = module.generateItems(model, model.context, data, true, rowIndex, secIndex, false);
                    }
                    var rowNodeCount = 0;
                    while(wrapper.children.length > 0) {
                        rowNode[rowNodeCount].replaceWith(wrapper.childNodes[0]);
                        $KU.addAriatoElement(rowNode[rowNodeCount++], data.accessibilityConfig, model);
                    }
                    newSections = data.length;

                    break;

                case "removedataat":
                    if(!model.hasSections) {
                        var itemCounter = 0;
                        while(itemCounter < count) {
                            segmentNode.removeChild(segmentNode.childNodes[rowIndex + itemCounter]);
                            itemCounter++;
                        }
                        model.clonedTemplates.splice(rowIndex, count);
                    } else {
                        var itemCounter = 0;
                        var headerCount = (model.data[secIndex][0] !== null) ? 1 : 0;
                        while(itemCounter < count) {
                            segmentNode.removeChild(secInnerNodes[rowIndex + headerCount + itemCounter]);
                            itemCounter++;
                        }
                        model.clonedTemplates[secIndex][1].splice(rowIndex, count);
                    }
                    break;

                case "addat":
                case "adddataat":
                    for(var i = 0; i < data.length; i++) {
                        var refEl, _html = module.generateItems(model, model.context, (0 ? [null, data[i]] : [data[i]]), false, rowIndex + i, secIndex),
                            newRowHolderNode = document.createElement("div");
                        
                        if(_html) {
                            newRowHolderNode.innerHTML = _html;
                            if(!model.hasSections) {
                                if(segmentNode.style.display === "none") segmentNode.style.display = '';
                                if(segmentNode.parentNode.style.display === "none") segmentNode.parentNode.style.display = '';
                                refEl = segmentNode.childNodes[rowIndex + i] || null;
                                
                                segmentNode.insertBefore(newRowHolderNode.childNodes[0], refEl);
                            } else {
                                if(segmentNode) {
                                    var headerCount = (model.data[secIndex][0] !== null) ? 1 : 0;
                                    segmentNode.insertBefore(newRowHolderNode.childNodes[0], secInnerNodes[rowIndex + headerCount]);
                                }
                            }
                        }
                    }
                    newSections = data.length;
                    break;
            }

            if(action == "addat" || action == "adddataat" || action == "removedataat" || action == "addall" || action == "addsectionat" || action == "removesectionat") {
                if(!model.hasSections) {
                    $KU.adjustNodeIndex(segmentNode, rowIndex, "index");
                } else {
                    module.Data.adjustSectionIndex(model, segmentNode);
                }
            }


            model.context.tabpaneID = ""; 


            model.isvisible && module.Data.adjustFlexContainers(model, action, secIndex, rowIndex, newSections);
            module.updateTemplateContextAfterModifyData(model);

            
            var widgetModel;
            if(model.hasSections) {
                if(action === 'addsectionat' || action === 'setsectionat') {
                    size = secIndex + data.length;
                } else if(action === 'adddataat' || action === 'setdataat') {
                    size = secIndex + 1;
                } else if(action === 'addall' || action === 'setdata') {
                    size = secIndex + data.length;
                } else {
                    size = secIndex;
                }
                for(i = secIndex; i < size; i++) {
                    sectionData = model.clonedTemplates[i];
                    if(['addsectionat', 'setsectionat', 'addall', 'setdata'].indexOf(action) >= 0) {
                        if(sectionData[0]) {
                            widgetModel = sectionData[0];
                            rowNode = module.Utils.getNodeByContext(model, widgetModel.rowContext, widgetModel);
                            $KW.Utils.processContainerGestures(widgetModel, rowNode);
                        }
                        if(sectionData[2]) {
                            widgetModel = sectionData[2];
                            rowNode = module.Utils.getNodeByContext(model, widgetModel.rowContext, widgetModel);
                            rowNode && $KW.Utils.processContainerGestures(widgetModel, rowNode);
                        }
                    }
                    if(action === 'adddataat' || action === 'setdataat') {
                        upperLimit = rowIndex + data.length;
                    } else {
                        upperLimit = sectionData[1].length;
                    }
                    for(j = rowIndex; j < upperLimit; j++) {
                        widgetModel = sectionData[1][j];
                        rowNode = module.Utils.getNodeByContext(model, widgetModel.rowContext, widgetModel);
                        $KW.Utils.processContainerGestures(widgetModel, rowNode);
                    }
                }
            } else {
                if(action ===  'addall' || action === 'setdata') {
                    size = data.length + rowIndex;
                } else if(action === 'adddataat' || action ===  'setdataat') {
                    size = rowIndex + data.length;
                } else {
                    size = rowIndex;
                }
                for(i = rowIndex; i < size; i++) {
                    widgetModel = model.clonedTemplates[i];
                    rowNode = module.Utils.getNodeByContext(model, widgetModel.rowContext, widgetModel);
                    $KW.Utils.processContainerGestures(widgetModel, rowNode);
                }
            }

            module.Animation.handleOnItemDisplay(model);
            module.applyLineSpaceAndItemSpace(model, $KW.Utils.getContentNodeFromNodeByModel(model));
            if(action == "removeall") 
                model.clonedTemplates = [];
            $KW.FlexUtils.updateAutoGrowFlexConfig(model);
        },

        
        adjustFlexContainers: function(model, action, secIndex, rowIndex, newSections) {
            $KU.needOptimization = false;
            var segNode = $KW.Utils.getContentNodeFromNodeByModel(model);
            var type = 'FlexContainer';
            switch(action) {
                case "setdata":
                    module.adjustFlexContainersInCollectionView(model, segNode);
                    module.initializeNewWidgets(segNode);
                    break;

                case "setdataat":
                case "addat":
                case "adddataat":
                    var section = module.getCollectionViewBaseNode(model, segNode).childNodes;
                    var elementIndex = (secIndex === 0) ? rowIndex : (module.Utils.getElementsCountTillSections(model.data, secIndex) + rowIndex);
                    var headerCount = (model.data[secIndex][0]) ? 1 : 0;
                    
                    for(var i = 0; i < newSections; i++) {
                        var row = section[(model.hasSections) ? elementIndex + headerCount + i : elementIndex + i];
                        var flexNode = row.querySelector("div[kwidgettype='" + type + "']");
                        if(flexNode) {
                            var flexModel = module.Utils.getClonedModel(model, rowIndex + i, secIndex);
                            $KW.FlexContainer.forceLayout(flexModel, flexNode.parentNode);
                        }
                        module.initializeNewWidgets(row);
                    }
                    break;

                case "addall":
                    if(model.hasSections) {
                        this.adjustFlexContainerInSection(model, segNode, secIndex, rowIndex, newSections);
                    } else {
                        var section = segNode.childNodes[secIndex];
                        var rows = section.childNodes;
                        for(var i = rowIndex; i < rows.length; i++) {
                            var row = rows[i];
                            var flexNode = row.querySelector("div[kwidgettype='" + type + "']");
                            if(flexNode) {
                                var flexModel = module.Utils.getClonedModel(model, i, secIndex);
                                $KW.FlexContainer.forceLayout(flexModel, flexNode.parentNode);
                            }
                            module.initializeNewWidgets(row);
                        }
                    }
                    break;

                case "addsectionat":
                case "setsectionat":
                    this.adjustFlexContainerInSection(model, segNode, secIndex, rowIndex, newSections);
                    break;
            }
            $KU.needOptimization = true;
            if($KW.FlexUtils.isFlexWidget(model) && !model.needScroller && model.autogrowMode == kony.flex.AUTOGROW_HEIGHT && model.viewtype == constants.SEGUI_VIEW_TYPE_TABLEVIEW) {
                var parent = model.parent;
                parent.layoutConfig.children = true;
            }
        },

        adjustFlexContainerInSection: function(model, segNode, secIndex, rowIndex, newSections) {
            var sections = segNode.childNodes[1].childNodes;
            var data = model.data;
            var startIndex = secIndex;
            var previousElementCount = module.Utils.getElementsCountTillSections(data, secIndex);
            for(var i = 0; i < newSections; i++) {
                var rowItemsCount = data[startIndex + i][1].length;
                var rowStartNumber = previousElementCount;
                var headerFooterCount = (data[secIndex + i][0] !== null) ? ((data[secIndex + i][2] !== null) ? 2 : 1) : ((data[secIndex + i][2] !== null) ? 1 : 0)
                var elementsCount = rowItemsCount + headerFooterCount;
                for(var j = 0; j < elementsCount; j++) {
                    var element = sections[previousElementCount];
                    var flexNode = element.querySelector('div[kwidgettype="FlexContainer"]');
                    if(flexNode) {
                        var flexModel = module.Utils.getItemTemplateByNode(model, element);
                        $KW.FlexContainer.forceLayout(flexModel, flexNode.parentNode);
                    }
                    module.initializeNewWidgets(element);
                    previousElementCount++;
                }
            }
        },

        getAutoGrowSegmentHeight: function(wModel, wNode) {
            var height = 0;
            var data = wModel.data;
            var segNode = $KU.getNodeByModel(wModel);
            if(data && data.length > 0) {
                if(wModel.hasSections) {
                    var secLen = data.length;
                    var sectionNodes = segNode.childNodes;
                    for(var i = 0; i < secLen; i++) {
                        var secHeaderNode = sectionNodes[i].childNodes[0];
                        if(secHeaderNode) {
                            var flexNode = secHeaderNode.querySelector('div[kwidgettype="FlexContainer"]');
                            if(flexNode) {
                                var flexModel = $KU.getModelByNode(flexNode);
                                flexNode = flexNode.parentNode;
                                module.Data.setFlexitemtemplateHeight(flexModel, flexNode);
                            }
                        }
                        module.adjustFlexContainersInRows(wModel, sectionNodes[i], data[i][1], i, true);
                    }
                } else
                    module.adjustFlexContainersInRows(wModel, segNode, data, undefined, true);
                return wNode.offsetHeight;
            }
        },

        setFlexitemtemplateHeight: function(flexModel, flexNode) {
            var containerId = flexNode.childNodes[0].getAttribute("kcontainerID");
            containerId && $KW.Utils.updateContainerDataInDOM(flexNode, containerId);
            $KW.FlexUtils.setFlexContainerStyle(flexModel, flexNode);
        },

        adjustSectionIndex: function(model, node) {
            var data = model.data;
            var sections = node.childNodes;
            var secindex, index, i = 0,
                k = 0;
            for(var i = 0; i < data.length; i++) {
                
                if(data[i][0] != null) {
                    index = i + ",-1";
                    sections[k].setAttribute("index", index);
                    sections[k].setAttribute("secindex", index);
                    k++;
                }

                
                if(data[i][1] != null) {
                    for(var j = 0; j < data[i][1].length; j++) {
                        secindex = i + "," + j;
                        index = j;
                        sections[k].setAttribute("index", index);
                        sections[k].setAttribute("secindex", secindex);
                        k++;
                    }
                }

                
                if(data[i][2] != null) {
                    index = i + ",-2";
                    sections[k].setAttribute("index", index);
                    sections[k].setAttribute("secindex", index);
                    k++;
                }
            }
        },

        adjustAlreadySelectedProperties: function(widgetModel, action, secIndex, rowIndex) {
            if(action != "addall") {
                if(action == "setdata" || action == "removeall") {
                    widgetModel._items = null;
                }
                if(widgetModel._items) {
                    widgetModel._items = module.Data.adjustSelectedRows(widgetModel._items, action, secIndex, rowIndex);
                    widgetModel._items && (widgetModel.selecteditemindex = widgetModel._items[widgetModel._items.length - 1]);
                }
                if(widgetModel.selectedrowindices) {
                    widgetModel.selectedrowindices = module.Data.adjustSelectedRowIndices(widgetModel.selectedrowindices, action, secIndex, rowIndex);
                }
                module.setSelectedItemsAndIndices(widgetModel);
            }
        },

        adjustSelectedRowIndices: function(sIndices, action, secIndex, rowIndex) {
            var sRowArray;
            switch(action) {
                case "addat":
                case "adddataat":
                    for(var i = 0; i < sIndices.length; i++) {
                        sRowArray = sIndices[i][1 + 0];
                        if(sIndices[i][0 + 0] == secIndex) {
                            for(var j = 0; j < sRowArray.length; j++) {

                                if(sRowArray[j] >= rowIndex)
                                    sRowArray[j] = sRowArray[j] + 1;
                            }
                            sIndices[i][1 + 0] = sRowArray;
                        }

                    }

                    break;
                case "setdataat":
                case "removedataat":
                    for(var i = 0; i < sIndices.length; i++) {
                        sRowArray = sIndices[i][1 + 0];
                        if(sIndices[i][0 + 0] == secIndex) {
                            var arrIndex = $KU.arrayIndex(sRowArray, 0 + rowIndex);
                            if(arrIndex != -1) {
                                sRowArray.splice(arrIndex, 1);
                            }
                            if(action === "removedataat") {
                                for(var j = 0; j < sRowArray.length; j++) {
                                    if(sRowArray[j] > rowIndex)
                                        sRowArray[j] = sRowArray[j] - 1;
                                }
                            }
                            sIndices[i][1 + 0] = sRowArray;
                        }
                    }
                    break;
                case "addsectionat":
                    for(var i = 0; i < sIndices.length; i++) {
                        if(sIndices[i][0 + 0] >= secIndex) {
                            sIndices[i][0 + 0] = sIndices[i][0 + 0] + 1;
                        }
                    }
                    break;
                case "removesectionat":
                case "setsectionat":
                    var removeIndexes = [];
                    for(var i = 0; i < sIndices.length; i++) {
                        if(sIndices[i][0 + 0] == secIndex) {
                            removeIndexes.push(i);
                        }
                    }
                    for(var i = 0; i < removeIndexes.length; i++) {
                        sIndices.splice(removeIndexes[i], 1);
                    }
                    if(action == "removesectionat") {
                        for(var i = 0; i < sIndices.length; i++) {
                            if(sIndices[i][0 + 0] > secIndex) {
                                sIndices[i][0 + 0] = sIndices[i][0 + 0] - 1;
                            }
                        }
                    }
                    break;
            }
            return(sIndices.length > 0) ? sIndices : null;
        },

        adjustSelectedRows: function(sRows, action, secIndex, rowIndex) {
            switch(action) {
                case "addat":
                case "adddataat":
                    for(var i = 0; i < sRows.length; i++) {
                        if(sRows[i][0 + 0] == secIndex && sRows[i][1 + 0] >= rowIndex) {
                            sRows[i][1 + 0] = sRows[i][1 + 0] + 1;
                        }
                    }
                    break;
                case "setdataat":
                    var arrIndex = $KU.arrayIndex(sRows, (0) ? [null, secIndex, rowIndex] : [secIndex, rowIndex]);
                    if(arrIndex != -1) {
                        sRows.splice(arrIndex, 1);
                    }
                    break;
                case "removedataat":
                    var arrIndex = $KU.arrayIndex(sRows, (0) ? [null, secIndex, rowIndex] : [secIndex, rowIndex]);
                    if(arrIndex != -1) {
                        sRows.splice(arrIndex, 1);
                    }
                    for(var i = 0; i < sRows.length; i++) {
                        if(sRows[i][0 + 0] == secIndex && sRows[i][1 + 0] > rowIndex) {
                            sRows[i][1 + 0] = sRows[i][1 + 0] - 1;
                        }
                    }
                    break;
                case "addsectionat":
                    for(var i = 0; i < sRows.length; i++) {
                        if(sRows[i][0 + 0] >= secIndex) {
                            sRows[i][0 + 0] = sRows[i][0 + 0] + 1;
                        }
                    }
                    break;
                case "removesectionat":
                case "setsectionat":
                    var removeIndexes = [];
                    for(var i = 0; i < sRows.length; i++) {
                        if(sRows[i][0 + 0] == secIndex) {
                            removeIndexes.push(i);
                        }
                    }
                    for(var i = 0; i < removeIndexes.length; i++) {
                        sRows.splice(removeIndexes[i], 1);
                    }
                    if(action == "removesectionat") {
                        for(var i = 0; i < sRows.length; i++) {
                            if(sRows[i][0 + 0] > secIndex) {
                                sRows[i][0 + 0] = sRows[i][0 + 0] - 1;
                            }
                        }
                    }
                    break;
            }
            return(sRows.length > 0) ? sRows : null;
        },

        calculateSectionRowIndex: function(widgetModel, rowIndex, secIndex, boundaryConditionToBeConsidered) {
            if(typeof boundaryConditionToBeConsidered != "boolean") {
                return boundaryConditionToBeConsidered;
            }
            var result = false;
            rowIndex = (boundaryConditionToBeConsidered && rowIndex < 0) ? 0 : rowIndex;
            if(!widgetModel.hasSections) { 
                if(rowIndex < 0 || rowIndex >= widgetModel.data.length) { 
                    if(boundaryConditionToBeConsidered) {
                        secIndex = 0;
                        rowIndex = (rowIndex < 0) ? 0 : (rowIndex >= widgetModel.data.length) ? widgetModel.data.length : rowIndex;
                        result = [secIndex, rowIndex];
                    }
                } else { 
                    secIndex = 0;
                    result = [secIndex, rowIndex];
                }
            } else { 
                if(typeof secIndex != "number") { 
                    var rowData = null,
                        totalRows = 0,
                        secIndex = 0,
                        tempRowIndex = rowIndex;
                    for(var i = 0; i < widgetModel.data.length; i++) {
                        rowData = widgetModel.data[i][1 + 0];
                        totalRows += rowData.length - 0;
                        if(tempRowIndex >= totalRows + 0) {
                            secIndex++;
                            rowIndex = tempRowIndex - totalRows;
                        } else {
                            break;
                        }
                    }

                    if(secIndex >= widgetModel.data.length) { 
                        if(boundaryConditionToBeConsidered) {
                            secIndex = widgetModel.data.length - 1;
                            result = (widgetModel.data[secIndex]) ? widgetModel.data[secIndex][1 + 0].length : 0;
                            result = [secIndex, rowIndex];
                        }
                    } else { 
                        rowData = widgetModel.data[secIndex][1 + 0];
                        if(rowIndex < 0) {
                            if(boundaryConditionToBeConsidered) {
                                result = [secIndex, 0];
                            }
                        } else if(rowIndex >= rowData.length) { 
                            if(boundaryConditionToBeConsidered) {
                                result = [secIndex, rowData.length];
                            }
                        } else { 
                            result = [secIndex, rowIndex];
                        }
                    }
                } else { 
                    if(secIndex < 0 || secIndex >= widgetModel.data.length) { 
                        if(boundaryConditionToBeConsidered) {
                            if(secIndex < 0) {
                                secIndex = 0;
                                if(!widgetModel.data[secIndex]) { 
                                    rowIndex = 0
                                } else {
                                    var rowData = widgetModel.data[secIndex][1 + 0];
                                    if(rowIndex < 0 || rowIndex >= rowData.length) { 
                                        if(boundaryConditionToBeConsidered) {
                                            rowIndex = (rowIndex < 0) ? 0 : (rowIndex >= widgetModel.data.length) ? widgetModel.data.length : rowIndex;
                                        }
                                    }
                                }
                            } else if(secIndex >= widgetModel.data.length) {
                                secIndex = widgetModel.data.length - 0;
                                rowIndex = (widgetModel.data[secIndex]) ? widgetModel.data[secIndex][1 + 0].length : 0; 
                            }
                            result = [secIndex, rowIndex];
                        }
                    } else { 
                        var rowData = widgetModel.data[secIndex][1 + 0];
                        if(rowIndex < 0 || rowIndex >= rowData.length) { 
                            if(boundaryConditionToBeConsidered) {
                                rowIndex = (rowIndex < 0) ? 0 : (rowIndex >= rowData.length) ? rowData.length : rowIndex;
                                result = [secIndex, rowIndex];
                            }
                        } else {
                            result = [secIndex, rowIndex];
                        }
                    }
                }
            }
            return result;
        },

        updateSectionContent: function(widgetData, dataArray, action, rowIndex, secIndex, count) {
            switch(action) {
                case "setsectionat":
                    for(var i = 0; i < dataArray.length; i++) {
                        widgetData.splice(secIndex++, 1, dataArray[i]);
                    }
                    return;
                    break;
                case "addsectionat":
                    for(var i = 0; i < dataArray.length; i++) {
                        widgetData.splice(secIndex++, 0, dataArray[i]);
                    }
                    return;
                    break;
                case "removesectionat":
                    widgetData.splice(secIndex, count);
                    return;
                    break;
            }
            if(action == "addall") {
                if(dataArray[0] instanceof Array) {
                    $KU.addArray(widgetData, dataArray);
                }
            } else {
                var section = widgetData[secIndex];
                var sectionData = section && section[1];
                if(sectionData) {
                    switch(action) {
                        case "setdataat":
                            for(var i = 0; i < dataArray.length; i++) {
                                sectionData.splice(rowIndex++, 1, dataArray[i]);
                            }
                            break;
                        case "addat":
                        case "adddataat":
                            if($KU.isArray(dataArray)) {
                                for(var i = 0; i < dataArray.length; i++) {
                                    sectionData.splice(rowIndex++, 0, dataArray[i]);
                                }
                            } else
                                sectionData.splice(rowIndex, 0, dataArray);
                            break;
                        case "removedataat":
                            sectionData.splice(rowIndex, count);
                            break;
                    }
                }
            }
        },

        isSelectionOutOfBound: function(widgetModel, selection) {
            var outOfBound = false,
                secIndex = selection[0 + 0],
                rowIndex = selection[1 + 0];
            if(widgetModel.hasSections) {
                if(secIndex >= widgetModel.data.length) {
                    outOfBound = true;
                } else {
                    var rowData = widgetModel.data[secIndex][1 + 0];
                    if(rowIndex > rowData.length) {
                        outOfBound = true;
                    }
                }
            } else {
                if(rowIndex >= widgetModel.data.length) {
                    outOfBound = true;
                }
            }
            return outOfBound;
        },

        getRowDataByIndex: function(widgetModel, index) { 
            if(widgetModel.data.length > 0) {
                if($KU.isArray(widgetModel.data[0])) { 
                    if(index[1] == -1) {
                        return widgetModel.data[index[0]][0];
                    } else if(index[1] == -2) {
                        return widgetModel.data[index[0]][2];
                    } else {
                        return widgetModel.data[index[0]][1][index[1]];
                    }
                } else {
                    return widgetModel.data[index[1]];
                }
            }
        },

        
        appendLayoutDataAt: function(widgetModel, data, itemIndex, sectionIndex) {
            var clonedModel = null;
            var flag = false;
            var selfValueBefore = widgetModel.layoutConfig.self;
            var cvNode = $KU.getNodeByModel(widgetModel);
            if(!data || !$KU.isArray(data)) return;
            data = module.Utils.invertMapAndData(widgetModel, data);
            for(var i = 0; i < data.length; i++) {
                clonedModel = module.Utils.getClonedModel(widgetModel, itemIndex + i, sectionIndex);
                if(!clonedModel) continue;
                for(var widgetId in data[i]) {
                    if(!clonedModel[widgetId]) continue;
                    for(var layoutProperty in data[i][widgetId]) {
                        
                        if(['left', 'right', 'centerX', 'width', 'minWidth', 'maxWidth',
                                'top', 'bottom', 'centerY', 'height', 'minHeight', 'maxHeight', 'zindex'
                            ].indexOf(layoutProperty) != -1) {
                            flag = true;
                            clonedModel[widgetId][layoutProperty] = data[i][widgetId][layoutProperty];
                            $KW.Utils.updateClonedModelData(clonedModel[widgetId], widgetModel, layoutProperty);
                            cvNode && module.Data.adjustFlexContainers(widgetModel, 'adddataat', sectionIndex, itemIndex + i, 1);
                        }
                    }
                }
            }
            if(!selfValueBefore & flag) widgetModel.layoutConfig = {
                self: false,
                children: false
            };
        }
    };

    module.Utils = {
        isIndexAndCountValid: function(model, itemIndex, sectionIndex, count, isSectionCount, action) {
            var itemCount = 0;
            var dataLength = (model.data) ? model.data.length : 0
            var lengthToCheck = (action == "adddataat" || action == "addsectionat") ? dataLength + 1 : dataLength;
            if(sectionIndex && (parseInt(sectionIndex) < 0 || parseInt(sectionIndex) >= lengthToCheck)) {
                kony.web.logger("warn", "Invalid section index");
                return false;
            }
            if(itemIndex) {
                itemCount = (model.hasSections) ? ((model.data) ? model.data[sectionIndex][1].length : model.data.length) : (model.data) ? model.data : 0;
                if(parseInt(itemIndex) < 0 || parseInt(itemIndex) >= itemCount) {
                    kony.web.logger("warn", "Invalid item index");
                    return false;
                }

            }
            if(count && (count < 0 || ((isSectionCount && count + sectionIndex > model.data.length) || (count + itemIndex > ((model.hasSections) ? model.data[sectionIndex][1].length : model.data.length))))) {
                kony.web.logger("warn", "Invalid count");
                return false;
            }
            return true;
        },

        setFocus: function(widgetModel, element, index) {
            var indexStr = (widgetModel.hasSections) ? "secindex='" + index[0 + 0] + "," + index[1 + 0] + "'" : "index='" + index[1 + 0] + "'";
            element = document.querySelector("#" + element.id + " li[" + indexStr + "]");
            element && $KW.Widget.setfocus(widgetModel, null, element);
        },

        refreshScrollerInstance: function(widgetModel) {
            var element = $KU.getNodeByModel(widgetModel);
            if(element && widgetModel.needScroller) {
                var scrollInstance = $KG[element.id + "_scroller"];
                if(!scrollInstance)
                    return;
                scrollInstance.refresh();
            }
        },

        reInitializeScrollerInstace: function(widgetModel) {
            var element = $KU.getNodeByModel(widgetModel);
            if(element && widgetModel.needScroller) {
                var scrollerNode = document.getElementById(element.id + "_scroller");
                scrollerNode && $KW.Scroller.initialize([scrollerNode], "CollectionView");
            }
        },

        getClonedModel: function(cvModel, itemIndex, secIndex) {
            if(cvModel.hasSections) {
                if(itemIndex == "header" || itemIndex == -1 || typeof itemIndex == 'undefined') 
                    return cvModel.clonedTemplates[secIndex][0];
                else if(itemIndex == "footer" || itemIndex == -2)
                    return cvModel.clonedTemplates[secIndex][2];
                else
                    return cvModel.clonedTemplates[secIndex][1][itemIndex];
            } else
                return cvModel.clonedTemplates[itemIndex];
        },

        getContextByNode: function(segModel, wNode) {
            var row = $KU.getParentByAttribute(wNode, "index");
            if(segModel.hasSections) {
                var secIndices = row.getAttribute("secindex").split(',');
                return {
                    sectionIndex: parseInt(secIndices[0]),
                    itemIndex: parseInt(secIndices[1])
                };
            }
            return {
                itemIndex: parseInt(row.getAttribute("index"))
            };
        },

        getClonedModelOfWidget: function(wModel, wNode, containerId) {
            var segModel = $KW.Utils.getContainerModelById(wNode, containerId);
            if(!segModel)
                return;
            var clonedTemp = module.Utils.getItemTemplateByNode(segModel, wNode);
            return clonedTemp[wModel.id];
        },

        
        getNodeByContext: function(segModel, context, wModel) {
            var element = $KU.getNodeByModel(segModel);
            if(!element || !context)
                return;

            var secIndex = context.sectionIndex;
            var itemIndex = context.itemIndex;
            var querySelector;
            if(segModel.hasSections) {
                if($KU.isDefined(secIndex) && $KU.isDefined(itemIndex)) {
                    querySelector = "secindex='" + secIndex + "," + itemIndex + "'";
                } else if($KU.isDefined(secIndex)) {
                    querySelector = "secindex='" + secIndex + ",-1'";
                }
            } else if($KU.isDefined(itemIndex)) {
                querySelector = "index='" + itemIndex + "'";
            }
            if(querySelector) {
                var listItem = element.querySelector("[" + querySelector + "]");
                if(listItem) {
                    if(wModel) {
                        return $KW.Utils.getWidgetNode(wModel, listItem);
                    } else
                        return listItem;
                }
            }
        },

        updateDataByContext: function(context, wData) {
            var segModel = context.containerModel;
            if(!segModel || !context || !wData)
                return;
            var data = segModel.data;
            if(data && data.length > 0) {
                var rowData;
                var secIndex = context.sectionIndex;
                var rowIndex = context.itemIndex;
                if(segModel.hasSections) {
                    if($KU.isDefined(secIndex) && $KU.isDefined(rowIndex)) {
                        rowData = data[secIndex][1][rowIndex];
                    } else if($KU.isDefined(secIndex)) {
                        rowData = data[secIndex][0];
                    }
                } else if($KU.isDefined(rowIndex)) {
                    rowData = data[rowIndex];
                }
                if(rowData) {
                    var wModel = context.widgetModel;
                    if(wModel) {
                        var map = segModel.widgetdatamap;
                        var widgetKey = map ? map[wModel.id] : wModel.id;
                        var content = rowData[widgetKey];
                        if(!(content instanceof Object)) {
                            return;
                        }
                        for(var prop in wData) {
                            if($KU.isDefined(wData[prop]))
                                content[prop] = wData[prop];
                        }
                    }
                }
            }
        },

        setCollectionViewHeightAndWidth: function(wModel) {
            var wNode = module.getCollectionViewBaseNode(wModel);
            var topNode = $KU.getNodeByModel(wModel);
            var hBorder = parseInt($KU.getStyle(topNode, "border-left-width"), 10) + parseInt($KU.getStyle(topNode, "border-right-width"), 10);
            var vBorder = parseInt($KU.getStyle(topNode, "border-top-width"), 10) + parseInt($KU.getStyle(topNode, "border-bottom-width"), 10);
            wNode.style.height = wModel.frame.height - vBorder + 'px';
            wNode.style.width = wModel.frame.width - hBorder + 'px';
        },

        getItemTemplateByNode: function(wModel, itemNode) {
            var context = module.Utils.getContextByNode(wModel, itemNode);
            var itemIndex = context.itemIndex;
            var type = itemNode.getAttribute('type');
            if(type == 'HeaderBox' || itemIndex == -1) itemIndex = 'header';
            else if(type == 'FooterBox' || itemIndex == -2) itemIndex = 'footer';
            return module.Utils.getClonedModel(wModel, itemIndex, context.sectionIndex);
        },

        getElementsCountTillSections: function(data, sectionNumber) {
            var elementCount = 0,
                headerFooterCount = 0; 
            for(var i = 0; i < sectionNumber; i++) {
                headerFooterCount = (data[i][0] !== null) ? ((data[i][2] !== null) ? 2 : 1) : ((data[i][2] !== null) ? 1 : 0)
                elementCount = elementCount + headerFooterCount + data[i][1].length;
            }
            return elementCount;
        },

        spliceObjectBasedOnIndex: function(nodeList, startIndex, endIndex) {
            var nodes = [];
            for(var i = startIndex; i < endIndex; i++) {
                nodes.push(nodeList[i]);
            }
            return nodes;
        },

        invertMapAndData: function(widget, data) {
            function __renderContainer__(data, obj) {
                if(!obj) obj = {};
                for(var sKey in data) {
                    if(newmap[sKey]) {
                        var sValue = data[sKey];
                        if(sValue && typeof sValue == "string" && sValue.toLowerCase().indexOf("i18n.getlocalizedstring") != -1)
                            obj[newmap[sKey]] = $KU.getI18NValue(sValue);
                        else
                            obj[newmap[sKey]] = sValue;
                    }
                }
                data["template"] && (obj["template"] = data["template"]);
                data["accessibilityConfig"] && (obj["accessibilityConfig"] = data["accessibilityConfig"]);
                return obj;
            }

            var map = widget.widgetdatamap;
            if(map) {
                map = $KU.isArray(map) ? map[0] : map;
                var keys = $KU.getkeys(map);
                var newmap = {};
                var newdata = [];

                for(var i = 0; i < keys.length; i++) {
                    newmap[map[keys[i]]] = keys[i];
                }

                var newkeys = $KU.getkeys(newmap);
                if(data[0] instanceof Array) {
                    var index = 0;
                    var headerData, footerData;
                    for(var i = 0; i < data.length; i++) {
                        var innerData = data[i][1];
                        newdata[index] = {};
                        headerData = data[i][0];
                        footerData = data[i][2];
                        var headerindex = index;
                        if(headerData && typeof headerData == "string" && headerData.toLowerCase().indexOf("i18n.getlocalizedstring") != -1)
                            newdata[index]["gridHeader"] = $KU.getI18NValue(headerData);
                        else if(headerData instanceof Object) {
                            newdata[index]["gridHeader"] = __renderContainer__(headerData);
                        } else {
                            newdata[index]["gridHeader"] = headerData;
                        }

                        for(var j = 0; j < innerData.length; j++) {
                            newdata[index] = newdata[index] || {};
                            for(var k = 0; k < newkeys.length; k++) {
                                
                                var value = innerData[j][newkeys[k]];
                                if(value && typeof value == "string" && value.toLowerCase().indexOf("i18n.getlocalizedstring") != -1)
                                    newdata[index][newmap[newkeys[k]]] = $KU.getI18NValue(value);
                                else
                                    newdata[index][newmap[newkeys[k]]] = value;
                            }
                            var metaInfo = innerData[j]["metainfo"] || innerData[j]["metaInfo"];
                            metaInfo && (newdata[index]["metainfo"] = metaInfo);
                            innerData[j]["template"] && (newdata[index]["template"] = innerData[j]["template"]);
                            innerData[j]["accessibilityConfig"] && (newdata[index]["accessibilityConfig"] = innerData[j]["accessibilityConfig"]);
                            index++;
                        }

                        index = (headerindex == index) ? index : index - 1;
                        if(footerData && typeof footerData == "string" && footerData.toLowerCase().indexOf("i18n.getlocalizedstring") != -1)
                            newdata[index]["gridFooter"] = $KU.getI18NValue(footerData);
                        else if(footerData instanceof Object) {
                            newdata[index]["gridFooter"] = __renderContainer__(footerData);
                        } else {
                            newdata[index]["gridFooter"] = footerData;
                        }

                        index++;

                        if(innerData.length == 0)
                            index++;
                    }

                } else {
                    for(var i = 0; i < data.length; i++) {
                        newdata[i] = {};
                        for(var j = 0; j < newkeys.length; j++) {
                            
                            var value = data[i][newkeys[j]];
                            if(value && typeof varlue == "string" && value.toLowerCase().indexOf("i18n.getlocalizedstring") != -1)
                                newdata[i][newmap[newkeys[j]]] = $KU.getI18NValue(value);
                            else
                                newdata[i][newmap[newkeys[j]]] = value;
                        }
                        var metaInfo = data[i]["metainfo"] || data[i]["metaInfo"];
                        if(metaInfo) {
                            newdata[i]["metainfo"] = $KU.cloneObj(metaInfo);
                            for(var j = 0; j < newkeys.length; j++) {
                                if(newdata[i]["metainfo"][newkeys[j]]) {
                                    newdata[i]["metainfo"][newmap[newkeys[j]]] = metaInfo[newkeys[j]];
                                    if(newmap[newkeys[j]] != newkeys[j])
                                        delete newdata[i]["metainfo"][newkeys[j]];
                                }
                            }
                        }
                        if(data[i]["template"])
                            newdata[i]["template"] = data[i]["template"];
                        if(data[i]["accessibilityConfig"])
                            newdata[i]["accessibilityConfig"] = data[i]["accessibilityConfig"];

                    }
                }
                return newdata;
            } else
                return data;
        },

        cleanupLayoutProps: function(model, layouttype) {
            if(layouttype == kony.collectionview.LAYOUT_CUSTOM)
                return;
            model.left = model.right = 0
            model.centerX = model.centerY = undefined;
            model.top = model.bottom = 0;
            if(!model.isHeaderOrFooter)
                return;
            if(layouttype == kony.collectionview.LAYOUT_VERTICAL)
                model.height = '100%';
            else
                model.width = '100%';
        },

        getValueInPxBasedOnLayoutType: function(prop, model, layoutType) {
            var valueObj = $KW.FlexUtils.getValueAndUnit(model, model[prop]);
            var value = valueObj.value;
            var layouttype = layoutType != undefined ? layoutType : model.layouttype;
            if(valueObj.unit == kony.flex.PERCENTAGE) {
                if(layouttype == kony.collectionview.LAYOUT_VERTICAL) {
                    var width = model.frame.width;
                    value = (value * width) / 100;
                } else if(layouttype == kony.collectionview.LAYOUT_HORIZONTAL) {
                    var height = model.frame.height;
                    value = (value * height) / 100;
                }
            }
            return value || 0;
        },

        updateReachingOffsetValuesInPx: function(wModel) {
            switch(wModel.layouttype) {

                case kony.collectionview.LAYOUT_VERTICAL:
                case kony.collectionview.LAYOUT_HORIZONTAL:
                    wModel.reachingbeginningoffsetinPX = 0;
                    wModel.reachingendoffsetinPX = 0;
                    if(wModel.reachingbeginningoffset)
                        wModel.reachingbeginningoffsetinPX = module.Utils.getValueInPxBasedOnLayoutType('reachingbeginningoffset', wModel);
                    if(wModel.reachingendoffset)
                        wModel.reachingendoffsetinPX = module.Utils.getValueInPxBasedOnLayoutType('reachingendoffset', wModel);
                    break;
                case kony.collectionview.LAYOUT_CUSTOM:
                    wModel.reachingbeginningoffsetV = 0;
                    wModel.reachingbeginningoffsetH = 0;
                    wModel.reachingendoffsetV = 0;
                    wModel.reachingendoffsetH = 0;
                    if(wModel.reachingbeginningoffset) {
                        wModel.reachingbeginningoffsetV = module.Utils.getValueInPxBasedOnLayoutType('reachingbeginningoffset', wModel, kony.collectionview.LAYOUT_VERTICAL);
                        wModel.reachingbeginningoffsetH = module.Utils.getValueInPxBasedOnLayoutType('reachingbeginningoffset', wModel, kony.collectionview.LAYOUT_HORIZONTAL);
                    }
                    if(wModel.reachingendoffset) {
                        wModel.reachingendoffsetV = module.Utils.getValueInPxBasedOnLayoutType('reachingendoffset', wModel, kony.collectionview.LAYOUT_VERTICAL);
                        wModel.reachingendoffsetH = module.Utils.getValueInPxBasedOnLayoutType('reachingendoffset', wModel, kony.collectionview.LAYOUT_HORIZONTAL);
                    }
                    break;
            }
        }
    };

    module.Animation = {
        getVisibleItems: function(model) {
            var cvNode = $KU.getNodeByModel(model);
            var items = [];
            if(!cvNode || !model.data || model.data.length == 0)
                return null;
            var itemNodes = this.iterateAllItems(model, cvNode, {
                needVisible: true,
                needHeaderFooter: false
            });
            for(var i = 0; i < itemNodes.length; i++) {
                var clonedModel = module.Utils.getItemTemplateByNode(model, itemNodes[i]);
                if(model.hasSections) {
                    var secindex = itemNodes[i].getAttribute('secindex').split(',');
                    clonedModel.sectionIndex = parseInt(secindex[0]);
                    clonedModel.itemIndex = parseInt(secindex[1]);
                } else {
                    clonedModel.itemIndex = parseInt(itemNodes[i].getAttribute('index'))
                }
                clonedModel.containerType = 'CollectionView';
                clonedModel.cvModel = model;
                items.push(clonedModel);
            };
            return items;
        },

        getIndicesForVisibleItems: function(model) {
            var cvNode = $KU.getNodeByModel(model);
            var itemIndices = [];
            if(!cvNode || !model.data || model.data.length == 0)
                return null;
            var itemNodes = this.iterateAllItems(model, cvNode, {
                needVisible: true,
                needHeaderFooter: false
            });
            for(var i = 0; i < itemNodes.length; i++) {
                var context = module.Utils.getContextByNode(model, itemNodes[i]);
                itemIndices.push(context);
            };
            return itemIndices;
        },

        iterateAllItems: function(model, node, config) {
            var scrollerIns = $KG[node.id + '_scroller'];
            var scrollTop = 0;
            var scrollBottom = 0;
            var scrollLeft = 0;
            var scrollRight = 0;
            var _isBetween = function(value, min, max) {
                return value >= min && value <= max;
            };
            var _isHeaderFooter = function(model, node) {
                var context = module.Utils.getContextByNode(model, node);
                if(context.itemIndex == -1 || context.itemIndex == -2) {
                    return true;
                }
                return false;
            }
            if(scrollerIns) {
                scrollTop = Math.abs(scrollerIns.y);
                scrollBottom = scrollTop + scrollerIns.wrapperH;

                scrollLeft = Math.abs(scrollerIns.x);
                scrollRight = scrollLeft + scrollerIns.wrapperW;
            } else {
                scrollTop = node.scrollTop;
                scrollBottom = scrollTop + node.offsetHeight;

                scrollLeft = node.scrollLeft;
                scrollRight = scrollRight + node.offsetWidth;
            }
            var rows = module.getCollectionViewBaseNode(model).children;
            var items = [];
            for(var i = 0; i < rows.length; i++) {
                var row = rows[i];
                var rowTop = row.offsetTop;
                var rowBottom = rowTop + row.offsetHeight;
                var rowLeft = row.offsetLeft;
                var rowRight = rowLeft + row.offsetWidth;
                if(config.needVisible) {
                    if(!config.needHeaderFooter && _isHeaderFooter(model, row)) {
                        continue;
                    }
                    if((_isBetween(rowTop, scrollTop, scrollBottom) || _isBetween(rowBottom, scrollTop, scrollBottom)) &&
                        (_isBetween(rowLeft, scrollLeft, scrollRight) || _isBetween(rowRight, scrollLeft, scrollRight))) {
                        items.push(row);
                    }
                }
                if(config.needAll) {
                    items.push(row);
                }
            }
            if(config.needVisible || config.needAll)
                return items;
        },

        handleOnItemDisplay: function(wModel) {
            var wNode = $KU.getNodeByModel(wModel);
            if(!wNode)
                return;
            var visibleItems = module.Animation.getVisibleItems(wModel);
            var visibleIndeces = module.Animation.getIndicesForVisibleItems(wModel);
            var allItems = this.iterateAllItems(wModel, wNode, {
                needAll: true,
                needHeaderFooter: false
            });
            var i = 0;
            if(visibleItems) {
                for(var i = 0; i < visibleItems.length; i++) {
                    if(!visibleItems[i].onItemDisplayExecuted) {
                        if(wModel.onitemdisplay) {
                            
                            wModel.onitemdisplay(wModel, visibleIndeces[i].sectionIndex, visibleIndeces[i].itemIndex, visibleItems[i]);
                        }
                        visibleItems[i].onItemDisplayExecuted = true;
                    }
                    i++;
                };
            }
            if(allItems) {
                for(var i = 0; i < allItems.length; i++) {
                    var clonedModel = module.Utils.getItemTemplateByNode(wModel, allItems[i]);
                    if(visibleItems.indexOf(clonedModel) == -1) {
                        clonedModel.onItemDisplayExecuted = false;
                    }
                };
            }
        },

        applyItemAnimation: function(itemModel, animInstance, animationConfig, animCallbackConfig, wModel) {
            var itemNode = module.Utils.getNodeByContext(itemModel.cvModel, {
                itemIndex: itemModel.itemIndex,
                sectionIndex: itemModel.sectionIndex
            }, wModel);
            itemNode.wModel = itemModel;
            itemNode.context = {
                sectionIndex: itemModel.sectionIndex,
                itemIndex: itemModel.itemIndex,
                containerModel: itemModel.cvModel,
                widgetModel: itemModel,
                instance: itemModel,
                animType: 'collectionViewItem'
            };
            animInstance.applyRowAnimation && animInstance.applyRowAnimation(itemNode, animationConfig, animCallbackConfig);
        },

        getAnimationContext: function(clonedModel) {
            var context, flexNode;
            var node = $KW.Utils.getWidgetNode(clonedModel);
            var containerId = node && node.getAttribute("kcontainerID");
            var containerModel = $KW.Utils.getContainerModelById(node, containerId);
            var cvItemContext = {
                itemIndex: clonedModel.rowContext.itemIndex,
                sectionIndex: clonedModel.rowContext.sectionIndex
            };
            var parentModel = clonedModel.parent;
            if(clonedModel.isTemplate && clonedModel.containerType == 'CollectionView') { 
                flexNode = module.getCollectionViewBaseNode(containerModel);
                node = module.Utils.getNodeByContext(containerModel, cvItemContext);
            } else {
                flexNode = module.Utils.getNodeByContext(containerModel, cvItemContext, parentModel);
                node = $KW.Utils.getWidgetNode(clonedModel, flexNode);
            }
            context = {
                node: node,
                flexNode: flexNode,
                containerModel: containerModel,
                widgetModel: clonedModel,
                itemIndex: clonedModel.rowContext.itemIndex,
                sectionIndex: clonedModel.rowContext.sectionIndex
            };
            return context;
        }
    };


    return module;
}());

kony.nosql = (function() {
    var module = {}, _validTypes = [], _validOrders = [], _validOperators = [];

    var _deleteAllByIndex =  function(objectStore, index, keyRangeValue) {
        return new Promise(function(resolve, reject) {
            var cursor, i, recordToDelete = [], recordCount = 0, record, successCallback;

            successCallback = function(event) {
                recordCount++;
                if(recordCount === recordToDelete.length) {
                    resolve();
                }
            };

            cursor = index.openCursor(keyRangeValue);
            cursor.onsuccess = function(event) {
                var cursor = event.target.result, request;
                if(cursor) {
                    if(kony.appinit.isSafari) {
                        record = cursor.primaryKey;
                        recordToDelete.push(record);
                    } else {
                        request = cursor.delete();
                        request.onsuccess = function(event) {
                            
                        };
                        request.onerror = function(event) {
                            reject(event);
                        };
                    }
                    cursor.continue();
                } else {
                    if(recordToDelete.length == 0) { 
                        resolve();
                    } else {
                        for(i = 0; i< recordToDelete.length; i++) {
                            request = objectStore.delete(recordToDelete[i]);
                            request.onsuccess = successCallback.bind(this, recordCount, recordToDelete);
                            request.onerror = function(event) {
                                reject(event);
                            };
                        }
                    }
                }
            };
            cursor.onerror = function(event) {
                reject(event);
            };
        });
    };

    var _evaluate = function(record, rule) {
        var result = false, col = record[rule.column], val = rule.value;

        switch(rule.operator) {
            case module.ENDS_WITH:
                result = (col.indexOf(val) === (col.length - val.length)) ? true : false;
                break;
            case module.EQ:
                result = (col === val);
                break;
            case module.GT:
                result = (col > val);
                break;
            case module.GTE:
                result = (col >= val);
                break;
            case module.CONTAINS:
                result = (col.indexOf(val) >= 0) ? true : false;
                break;
            case module.LT:
                result = (col < val);
                break;
            case module.LTE:
                result = (col <= val);
                break;
            case module.NEQ:
                result = (col !== val);
                break;
            case module.NOT_CONTAINS:
                result = (col.indexOf(val) >= 0) ? false : true;
                break;
            case module.NOT_ENDS_WITH:
                result = (col.indexOf(val) === (col.length - val.length)) ? false : true;
                break;
            case module.NOT_STARTS_WITH:
                result = (col.indexOf(val) === 0) ? false : true;
                break;
            case module.STARTS_WITH:
                result = (col.indexOf(val) === 0) ? true : false;
                break;
            case module.REGEXP:
                val.lastIndex = 0;
                result = val.test(col);
                break;
            default:
                break;
        }

        return result;
    };

    var _expression = function(record, condition) {
        var str = '', c = 0, clen = condition.length;

        for(c=0; c<clen; c++) {
            if(condition[c] instanceof Array) {
                str += _expression(record, condition[c]);
            } else if(typeof condition[c] === 'string') {
                str += (' ' + condition[c] + ' ');
            } else if(typeof condition[c] === 'object' && condition[c]) {
                str += _evaluate(record, condition[c]);
            }
        }

        return ('(' + str + ')');
    }; 

    var _filterRecords = function(records, condition) {
        return records.filter(function(record){
            return _isConditionMatched(record, condition);
        });
    };
    
    var _getAll =  function(objectStore) {
        var records = [];
        return new Promise(function(resolve, reject) {
            var cursor = objectStore.openCursor();
            cursor.onsuccess = function(event) {
                var cursor = event.target.result, record;
                if(cursor) {
                    record = cursor.value;
                    records.push(record);
                    cursor.continue();
                } else {
                    resolve(records);
                }
            };
            cursor.onerror = function(event) {
                reject(event);
            };
        });
    };

    var _getAllByIndex =  function(index, keyRangeValue) {
        var records = [];
        return new Promise(function(resolve, reject) {
            var cursor = index.openCursor(keyRangeValue);
            cursor.onsuccess = function(event) {
                var cursor = event.target.result, record;
                if(cursor) {
                    record = cursor.value;
                    records.push(record);
                    cursor.continue();
                } else {
                    resolve(records);
                }
            };
            cursor.onerror = function(event) {
                reject(event);
            };
        });
    };

    var _getDataBaseName = function(dbName) {
        return kony.globals.appid + '_' + dbName;
    };

    var _getKeyRangeValue = function(data) {
        var keyRangeValue;
        switch(data.operator) {
            case module.EQ:
                keyRangeValue = IDBKeyRange.only(data.value);
            break;
            case module.GT:
                keyRangeValue = IDBKeyRange.lowerBound(data.value, true);
            break;
            case module.GTE:
                keyRangeValue = IDBKeyRange.lowerBound(data.value);
            break;
            case module.LT:
                keyRangeValue = IDBKeyRange.upperBound(data.value, true);
            break;
            case module.LTE:
                keyRangeValue = IDBKeyRange.upperBound(data.value);
            break;
            
        }
        return keyRangeValue;
    };

    var _getObjectValues= function(obj) {
        var values = [], key;

        for(key in obj) {
            if(obj.hasOwnProperty(key)) {
                values.push(obj[key]);
            }
        }
        return values;
    };

    var _isConditionOptimizable = function(conditionInstance, objectStore) {
        var canOperatorFitInKeyRange, column,isColumnIndexed, operator, isValueBoolean;

        if(!(conditionInstance instanceof kony.nosql.Condition)
        || conditionInstance.data.length !== 1) {
            return false;
        }

        column = conditionInstance.data[0].column;
        operator = conditionInstance.data[0].operator;
        isColumnIndexed = objectStore.indexNames.contains(column);
        canOperatorFitInKeyRange = (operator !== module.NEQ && operator !== module.REGEXP);
        isValueBoolean = (typeof conditionInstance.data[0].value === "boolean");

        return isColumnIndexed && canOperatorFitInKeyRange && !isValueBoolean;
    };

    var _isConditionMatched = function(record, condition) {
        return eval(_expression(record, condition));
    };

    var _notSupported = function() {
        kony.web.logger('error', 'Your browser doesn\'t support a stable version of IndexedDB.');
    };

    var _replaceRecordValues = function(record, valueObject, includeKeys) {
        var key;

        for(key in valueObject) {
            if(includeKeys instanceof Array) {
                if(includeKeys.indexOf(key) != -1) {
                    record[key] = valueObject[key];
                }
            } else {
                record[key] = valueObject[key];
            }
        }

        return record;
    };

    var _updateAllByIndex =  function(objectStore, index, keyRangeValue, updateObject) {
        return new Promise(function(resolve, reject) {
            var cursor, i, recordCount = 0, request, recordsToAdd = [], successCallback;

            successCallback = function(event) {
                recordCount++;
                if(recordCount === recordsToAdd.length) {
                    resolve();
                }
            };

            cursor = index.openCursor(keyRangeValue);
            cursor.onsuccess = function(event) {
                var cursor = event.target.result, record, request;
                if(cursor) {
                    record = cursor.value;
                    record = _replaceRecordValues(record, updateObject);
                    if(kony.appinit.isSafari) {
                        recordsToAdd.push(record);
                    } else {
                        request = cursor.update(record);
                        request.onsuccess = function(event) {
                            
                        };
                        request.onerror = function(event) {
                            reject();
                        };
                    }
                    cursor.continue();
                } else {
                    if(recordsToAdd.length == 0) {
                        resolve();
                    } else {
                        for(i = 0; i < recordsToAdd.length; i++) {
                            request = objectStore.put(recordsToAdd[i]);
                            request.onsuccess = successCallback.bind(this, recordCount, recordsToAdd);
                            request.onerror = function(event) {
                                reject(event);
                            };
                        }
                    }
                }
            };
            cursor.onerror = function(event) {
                reject(event);
            };
        });
    };


    var Condition = function(ruleOrCondition) {
        var data = [];

        if(this instanceof Condition) {
            Object.defineProperty(this, 'data', {
                configurable: true,
                enumerable: false,
                get: function() {
                    return (this.passReference) ? data : data.slice(0);
                }
            });
            Object.defineProperty(this, 'data', {
                configurable: false,
                enumerable: false,
                set: function(value) {}
            });

            if(ruleOrCondition instanceof Rule) {
                data.push({
                    "column":   ruleOrCondition.column,
                    "operator": ruleOrCondition.operator,
                    "value":    ruleOrCondition.value
                });
            } else if(ruleOrCondition instanceof Condition) {
                data.push(ruleOrCondition.data);
            } else {
                
            }
        } else {
            
        }
    };

    Object.defineProperty(Condition.prototype, 'addCondition', {
        configurable: false,
        enumerable: false,
        writable: false,
        value: function(type, condition) {
            if(_validTypes.indexOf(type) >= 0 && condition instanceof Condition) {
                this.passReference = true;
                this.data.push(type);
                this.data.push(condition.data);
                delete this.passReference;
            } else {
                
            }

            return this;
        }
    });

    Object.defineProperty(Condition.prototype, 'addRule', {
        configurable: false,
        enumerable: false,
        writable: false,
        value: function(type, rule) {
            if(_validTypes.indexOf(type) >= 0 && rule instanceof Rule) {
                this.passReference = true;
                this.data.push(type);
                this.data.push({
                    "column":   rule.column,
                    "operator": rule.operator,
                    "value":    rule.value
                });
                delete this.passReference;
            } else {
                
            }

            return this;
        }
    });

    
    Object.defineProperty(Condition.prototype, 'toString', {
        configurable: false,
        enumerable: false,
        writable: false,
        value: function() {
            var text = '';

            var stringifyCondition = function(condition) {
                var str = '', c = 0, clen = condition.length;

                for(c=0; c<clen; c++) {
                    if(condition[c] instanceof Array) {
                        str += stringifyCondition(condition[c]);
                    } else if(typeof condition[c] === 'string') {
                        str += (' ' + condition[c] + ' ');
                    } else if(typeof condition[c] === 'object' && condition[c]) {
                        str += stringifyRule(condition[c]);
                    }
                }

                return ('(' + str + ')');
            };

            var stringifyRule = function(rule) {
                var str = rule.column + ' ' + rule.operator + ' ';

                if(typeof rule.value === 'string') {
                    
                    str += ('"' + rule.value + '"');
                } else {
                    str += rule.value;
                }

                return str;
            };

            return stringifyCondition(this.data);
        }
    });

    var DataBase = function(db, dbType, dbOpenRequest) {
        Object.defineProperty(this, 'db', {
            configurable: false,
            enumerable: false,
            writable: false,
            value: db
        });
        Object.defineProperty(this, 'dbType', {
            configurable: false,
            enumerable: false,
            writable: false,
            value: dbType
        });
        Object.defineProperty(this, 'dbOpenRequest', {
            configurable: true,
            enumerable: false,
            writable: false,
            value: dbOpenRequest
        });

    };

    var Transaction = function(tx) {
        Object.defineProperty(this, 'tx', {
            configurable: false,
            enumerable: false,
            writable: false,
            value: tx
        });
    };

    var Result = function(data) {
        var index = -1, length = -1;

        data = (data instanceof Array) ? data : [];

        Object.defineProperty(this, 'data', {
            configurable: true,
            enumerable: false,
            get: function() {
                return (this.passReference) ? data : data.slice(0);
            }
        });
        Object.defineProperty(this, 'data', {
            configurable: false,
            enumerable: false,
            set: function(value) {}
        });


        Object.defineProperty(this, 'length', {
            configurable: true,
            enumerable: false,
            get: function() {
                if(length === -1) {
                    length = data.length;
                }

                return length;
            }
        });
        Object.defineProperty(this, 'length', {
            configurable: false,
            enumerable: false,
            set: function(value) {}
        });


        Object.defineProperty(this, 'next', {
            configurable: true,
            enumerable: false,
            get: function() {
                ++index;
                return (index >= 0 && index < data.length) ? true : false;
            }
        });
        Object.defineProperty(this, 'next', {
            configurable: false,
            enumerable: false,
            set: function(value) {}
        });


        Object.defineProperty(this, 'record', {
            configurable: true,
            enumerable: false,
            get: function() {
                return (index >= 0 && index < data.length) ? data[index] : null;
            }
        });
        Object.defineProperty(this, 'record', {
            configurable: false,
            enumerable: false,
            set: function(value) {}
        });
    };

    Object.defineProperty(Result.prototype, 'groupBy', {
        configurable: false,
        enumerable: false,
        writable: false,
        value: function(columnNames, index) {
            var data = null;

            this.passReference = true;
            data = this.data;
            delete this.passReference;
            var result  = {};

            function __prepareMap() {
                var row, name, i, j;
                for(i = 0; i < data.length; i++) {
                    row = data[i];
                    name = "";
                    for(j = 0; j < columnNames.length; j++) {
                        name += row[columnNames[j]];
                        if(j < columnNames.length -1) {
                            name += "&_"
                        }
                    }

                    if(name in result) {
                        result[name].push(row);
                    } else {
                        result[name] = [row];
                    }
                }
                
            }

            function __prepareResults() {
                var resultSet = [], i, key, finalResult = [];
                for(key in result) {
                    resultSet.push(result[key]);
                }

                if(typeof index === 'number') {
                    for(i = 0; i < resultSet.length; i++) {
                        if(index >= 0) {
                            finalResult.push(resultSet[i][index]);
                        } else {
                            key = resultSet[i].length + index
                            finalResult.push(resultSet[i][key]);
                        }
                    }
                    return finalResult
                } else {
                    return resultSet;
                }
            }

            if(columnNames instanceof Array) {
                try {
                    __prepareMap();
                    return __prepareResults();
                }
                catch (e) {
                    throw e;
                }
            }
        }
    });

    Object.defineProperty(Result.prototype, 'limit', {
        configurable: false,
        enumerable: false,
        writable: false,
        value: function(startIndex, recordCount) {
            var data = null, copy = null, c = 0, clen = 0;

            if(typeof startIndex === 'number'
            && typeof recordCount === 'number'
            && startIndex >= 0 && recordCount >= 0) {
                this.passReference = true;
                data = this.data;
                delete this.passReference;

                copy = data.splice(0);
                clen = copy.length;

                for(c=startIndex; c<=recordCount; c++) {
                    if(c < clen) {
                        data.push(copy[c]);
                    } else {
                        break;
                    }
                }
            } else {
                
            }

            return this;
        }
    });

    Object.defineProperty(Result.prototype, 'sort', {
        configurable: false,
        enumerable: false,
        writable: false,
        value: function(columnName, order) {
            var data = null;

            this.passReference = true;
            data = this.data;
            delete this.passReference;

            if(typeof columnName === 'function') {
                data.sort(columnName);
            } else if(typeof columnName === 'string'
            && _validOrders.indexOf(order) >= 0) {
                data.sort(function(a, b) {
                    a = a[columnName];
                    b = b[columnName];

                    if(order === kony.nosql.ASCENDING) {
                        return (a > b) ? 1 : (a < b) ? -1 : 0;
                    } else {
                        return (a > b) ? -1 : (a < b) ? 1 : 0;
                    }
                });
            } else if(columnName instanceof Array
            && _validOrders.indexOf(order) >= 0) {
                var i, sortedData = [];

                function __localsort(data, name, order) {
                    data.sort(function(a, b) {
                        a = a[name];
                        b = b[name];
                        if(order === kony.nosql.ASCENDING) {
                            return (a > b) ? 1 : (a < b) ? -1 : 0;
                        } else {
                            return (a > b) ? -1 : (a < b) ? 1 : 0;
                        }
                    });
                }

                function __groupByName(data, name) {
                    var i, result = [], temp = [], value;
                    temp.push(data[0]);
                    value = data[0][name];
                    for(i = 1; i < data.length; i++) {
                        if(data[i][name] == value) {
                            temp.push(data[i]);
                        } else {
                            if(temp.length == 1) {
                                result.push(temp[0]);
                            } else {
                                result.push(temp);
                            }
                            temp = [];
                            value = data[i][name];
                            temp.push(data[i]);
                        }
                    }
                    result.push(temp);
                    return result;
                }

                function __createFlatArray(result) {
                    var i, len, temp = [];
                    for( i = 0; i < result.length; i++) {
                        if(result[i] instanceof Array) {
                            for(len = 0; len < result[i].length; len++) {
                                temp.push(result[i][len]);
                            }
                        } else {
                            temp.push(result[i]);
                        }
                    }
                    return temp;
                }

                function __orderBY(data, index, order) {
                    var i, result = [], result1 = [];
                    if(index >= columnName.length) {
                        return data;
                    }

                    __localsort(data, columnName[index], order);
                    result = __groupByName(data, columnName[index]);
                    for(i = 0; i < result.length; i++) {
                       if(result[i] instanceof Array) {
                            result1 = __orderBY(result[i], index+1, order);
                            result[i] = result1;
                        }
                    }
                    result =  __createFlatArray(result);
                    return result;
                }

                sortedData = this.data;
                sortedData = __orderBY(sortedData, 0, order);
                data.splice(0, data.length);
                for(i =0; i < sortedData.length; i++) {
                    data.push(sortedData[i]);
                }

            } else {
                
            }

            return this;
        }
    });

    

    var Rule = function(column, operator, value) {
        if(this instanceof Rule) {
            if(arguments.length === 3
            && typeof column === 'string' && column
            && _validOperators.indexOf(operator) >= 0) {
                if(operator == module.REGEXP && !(value instanceof RegExp)) {
                    throw Error("Invalid arguments.");
                }

                Object.defineProperty(this, 'column', {
                    configurable: true,
                    enumerable: true,
                    get: function() {
                        return column;
                    }
                });
                Object.defineProperty(this, 'column', {
                    configurable: false,
                    enumerable: true,
                    set: function(val) {
                        column = val;
                    }
                });


                Object.defineProperty(this, 'operator', {
                    configurable: true,
                    enumerable: true,
                    get: function() {
                        return operator;
                    }
                });
                Object.defineProperty(this, 'operator', {
                    configurable: false,
                    enumerable: true,
                    set: function(val) {
                        operator = val;
                    }
                });


                Object.defineProperty(this, 'value', {
                    configurable: true,
                    enumerable: true,
                    get: function() {
                        return value;
                    }
                });
                Object.defineProperty(this, 'value', {
                    configurable: false,
                    enumerable: true,
                    set: function(val) {
                        value = val;
                    }
                });
            } else {
                
            }
        } else {
            
        }
    };

    var iDB = window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
    var indexedDB = {

        openDB : function (databaseName, version, upgradeCallback) {
            $KU.logExecuting('kony.nosql.openDatabase');
            $KU.logExecutingWithParams('kony.nosql.openDatabase', databaseName, version, upgradeCallback);
            return new Promise(function(resolve, reject) {
                var request, kdb;

                if(version) {
                    request = iDB.open(_getDataBaseName(databaseName), version);
                } else {
                    request = iDB.open(_getDataBaseName(databaseName));
                }
                request.onerror = function(event) {
                    reject(event.target.error);
                };
                request.onsuccess = function(event) {
                    var db = request.result;

                    kdb = kdb || new DataBase(db, 'indexedDB', request);
                    $KU.logExecutingFinished('kony.nosql.openDatabase');
                    resolve(kdb);
                };
                request.onupgradeneeded = function(event) {
                    var db = event.target.result;

                    kdb = new DataBase(db, 'indexedDB', request);
                    upgradeCallback && upgradeCallback(kdb);
                };
            });
        },

        createTable: function (kdb, tableName, config) {
            $KU.logExecuting('kony.nosql.createTable');
            $KU.logExecutingWithParams('kony.nosql.createTable', kdb, tableName, config);
            var i = 0, indexes = config.indexes || {}, db = kdb.db,
                primaryKey = config.primaryKey, index,
                autoIncrement = $KU.isArray(primaryKey) ? false : config.autoIncrement,
                objectStore = db.createObjectStore(tableName, {keyPath: primaryKey, autoIncrement: autoIncrement});

            for(index in indexes){
                objectStore.createIndex(index, index, indexes[index]);
            }
            $KU.logExecutingFinished('kony.nosql.createTable');
        },

        openTransaction: function (kdb, tableNames, accessType, callback) {
            $KU.logExecuting('kony.nosql.openTransaction');
            $KU.logExecutingWithParams('kony.nosql.openTransaction', kdb, tableNames, accessType, callback);
            return new Promise(function(resolve, reject) {
                var db = kdb.db, tx = db.transaction(tableNames, accessType),
                    ktx = new Transaction(tx);

                callback(ktx);
                tx.oncomplete = function(e){
                    $KU.logExecutingFinished('kony.nosql.openTransaction');
                    resolve(ktx);
                }
                tx.onerror = function(e) {
                    $KU.logErrorMessage('unknown error' + e);
                    reject(e.target.error);
                }
                tx.onabort = function(e) {
                    $KU.logErrorMessage('unknown error' + e);
                    reject(e.target.error);
                }
            });
        },

        addRecords: function (ktx, tableName, data) {
            $KU.logExecuting('kony.nosql.addRecords');
            $KU.logExecutingWithParams('kony.nosql.addRecords', ktx, tableName, data);
            return new Promise(function(resolve, reject) {
                var i = 0, storeReq = null, tx = ktx.tx,
                    store = tx.objectStore(tableName),
                    onerrorcb = function(event) {
                        $KU.logErrorMessage('unknown error' + event.target.error);
                        reject(event.target.error);
                    },
                    addNext = function() {
                        if(i < data.length) {
                            storeReq = store.add(data[i]);
                            storeReq.onsuccess = addNext;
                            storeReq.onerror = onerrorcb;
                            ++i;
                        } else {
                            $KU.logExecutingFinished('kony.nosql.addRecords');
                            resolve();
                        }
                    };

                addNext();
            });
        },

        fetchRecords: function(transactionObject, tableName, conditionInstance) {
            $KU.logExecuting('kony.nosql.fetchRecords');
            $KU.logExecutingWithParams('kony.nosql.fetchRecords', transactionObject, tableName, conditionInstance);
            return new Promise(function(resolve, reject) {
                var resultSet = null, objectStore, transaction, data, keyRangeValue, index;
                var successCallback = function(records) {
                    if(conditionInstance instanceof kony.nosql.Condition) {
                        records = _filterRecords(records, conditionInstance.data);
                    }
                    resultSet = new Result(records);
                    $KU.logExecutingFinished('kony.nosql.fetchRecords');
                    resolve(resultSet);
                };
                var errorCallback = function(event) {
                    kony.web.logger('error', 'unknown error' + event.target.error);
                    reject(event.target.error);
                };

                if(!transactionObject instanceof Transaction) {
                    $KU.logErrorMessage('Pass  proper transaction object');
                    reject({"errorMsg": "Pass  proper transaction object"});
                }

                transaction = transactionObject.tx;
                objectStore = transaction.objectStore(tableName);
                if(_isConditionOptimizable(conditionInstance, objectStore)) {
                    data = conditionInstance.data[0];
                    keyRangeValue = _getKeyRangeValue(data);
                    index = objectStore.index(data.column);
                    if(keyRangeValue) {
                        _getAllByIndex(index, keyRangeValue).then(function(records) {
                            resultSet = new Result(records);
                            resolve(resultSet);
                        }).catch(function(event) {
                            reject(event.target.error);
                        });
                    }

                } else {
                    if(objectStore.getAll) {
                        objectStore = objectStore.getAll();
                    } else {
                        _getAll(objectStore).then(function(records) {
                            successCallback(records);
                        }).catch(function(errorObj) {
                            errorCallback(errorObj);
                        });
                    }
                    objectStore.onsuccess = function(event){
                        successCallback(event.target.result);
                    };
                    objectStore.onerror = errorCallback;
                }
            });
        },

        updateRecords: function(transactionObject, tableName, updateObject, conditionInstance) {
            $KU.logExecuting('kony.nosql.updateRecords');
            $KU.logExecutingWithParams('kony.nosql.updateRecords', transactionObject, tableName, updateObject, conditionInstance);
            return new Promise(function(resolve, reject) {
                var index, objectStore, transaction, data, keyRangeValue;


                if(!transactionObject instanceof Transaction) {
                    $KU.logErrorMessage('Pass  proper transaction object');
                    reject({"errorMsg": "Pass  proper transaction object"});
                }

                transaction = transactionObject.tx;
                objectStore = transaction.objectStore(tableName);

                if(_isConditionOptimizable(conditionInstance, objectStore)) {
                    data = conditionInstance.data[0];
                    index = objectStore.index(data.column);
                    keyRangeValue = _getKeyRangeValue(data);
                    if(keyRangeValue) {
                        _updateAllByIndex(objectStore, index, keyRangeValue, updateObject).then(function() {
                            $KU.logExecutingFinished('kony.nosql.updateRecords');
                            resolve();
                        }).catch(function(event) {
                            $KU.logErrorMessage('unknown' + event.message);
                            reject({errorMsg: event.message});
                        });
                    }
                } else {
                    objectStore.openCursor().onsuccess = function(event) {
                        var cursor = event.target.result, record, request;

                        if(cursor) {
                            record = cursor.value;
                            if(!conditionInstance || _isConditionMatched(record, conditionInstance.data)) {

                                record = _replaceRecordValues(record, updateObject);
                                request = cursor.update(record);
                                request.onsuccess = function(event) {
                                    
                                };
                                request.onerror = function(event) {
                                    reject();
                                };
                            }
                            cursor.continue();
                        } else {
                            resolve();
                        }
                    };
                }
            });
        },

        deleteRecords: function(transactionObject, tableName, conditionInstance) {
            $KU.logExecuting('kony.nosql.deleteRecords');
            $KU.logExecutingWithParams('kony.nosql.deleteRecords', transactionObject, tableName, conditionInstance);
            return new Promise(function(resolve, reject) {
                var transaction, objectStore, data, keyRangeValue, index;

                if(!transactionObject instanceof Transaction) {
                    $KU.logErrorMessage('Pass  proper transaction object');
                    reject({"errorMsg": "Pass  proper transaction object"});
                }

                transaction = transactionObject.tx;
                objectStore = transaction.objectStore(tableName);

                if(_isConditionOptimizable(conditionInstance, objectStore)) {
                    data = conditionInstance.data[0];
                    keyRangeValue = _getKeyRangeValue(data);
                    index = objectStore.index(data.column);
                    if(keyRangeValue) {
                        _deleteAllByIndex(objectStore, index, keyRangeValue).then(function() {
                            $KU.logExecutingFinished('kony.nosql.deleteRecords');
                            resolve();
                        }).catch(function(event) {
                            $KU.logErrorMessage('unknown error' + event.message);
                            reject({errorMsg: event.message});
                        });
                    }
                } else {
                    objectStore.openCursor().onsuccess = function(event) {
                        var cursor = event.target.result, request;

                        if(cursor) {
                            if(!conditionInstance || _isConditionMatched(cursor.value, conditionInstance.data)) {
                                request = cursor.delete();

                                request.onsuccess = function(event) {
                                    
                                };
                                request.onerror = function(event) {
                                    reject(event.target.error);
                                };
                            }
                            cursor.continue();
                        } else {
                            resolve();
                        }
                    };
                }
            });
        },

        databaseExists: function(databaseName) {
            $KU.logExecuting('kony.nosql.databaseExists');
            $KU.logExecutingWithParams('kony.nosql.databaseExists', databaseName);
            return new Promise(function(resolve, reject) {
                var request = iDB.open(_getDataBaseName(databaseName));

                request.onupgradeneeded = function (event) {
                    event.target.transaction.abort();
                    $KU.logExecutingFinished('kony.nosql.databaseExists VIA from request.upgradeneeded ');
                    resolve(false);
                };
                request.onsuccess = function(event) {
                    var database = event.target.result;
                    $KU.logExecutingFinished('kony.nosql.databaseExists VIA from request.onsuccess');
                    resolve(true);
                    database.close();
                };
                request.onerror = function(event) {
                    $KU.logErrorMessage('unknown error' + event.target.error);
                    reject(event.target.error);
                };
            });
        },

        databaseVersion: function(databaseName) {
            return new Promise(function(resolve, reject) {
                var request = iDB.open(_getDataBaseName(databaseName));

                request.onupgradeneeded = function (event) {
                    event.target.transaction.abort();
                    resolve(0);
                };
                request.onsuccess = function(event) {
                    var database = event.target.result;
                    resolve(database.version);
                    database.close();
                };
                request.onerror = function(event) {
                    reject(event.target.error);
                };
            });
        },

        closeDatabase: function(databaseObject) {
            $KU.logExecuting('kony.nosql.closeDatabase');
            $KU.logExecutingWithParams('kony.nosql.closeDatabase', databaseObject);
            return new Promise(function(resolve, reject) {
                var db;

                if(databaseObject instanceof DataBase) {
                    db = databaseObject.db;
                    try {
                        db.close();
                        delete databaseObject.dbOpenRequest;
                        $KU.logExecutingFinished('kony.nosql.closeDatabase');
                        resolve();
                    } catch(error) {
                        $KU.logErrorMessage('unknown error' + error);
                        delete databaseObject.dbOpenRequest;
                        reject(error);
                    }
                } else {
                    $KU.logErrorMessage('Pass proper database object.');
                    reject({"errorMsg": "Pass proper database object."});
                }
            });
        },

        getTables: function(databaseObject) {
            $KU.logExecuting('kony.nosql.getTables');
            $KU.logExecutingWithParams('kony.nosql.getTables', databaseObject);
            return new Promise(function(resolve, reject) {
                var db;

                if(databaseObject instanceof DataBase) {
                    db = databaseObject.db;
                    $KU.logExecutingFinished('kony.nosql.getTables');
                    resolve(_getObjectValues(db.objectStoreNames));
                } else {
                    $KU.logErrorMessage('Pass proper database object.');
                    reject({errorMsg: 'Pass proper database object.'});
                }
            });
        },

        tableExists: function(databaseObject, tableName) {
            $KU.logExecuting('kony.nosql.tableExists');
            $KU.logExecutingWithParams('kony.nosql.tableExists', databaseObject, tableName);
            return new Promise(function(resolve, reject) {
                var tables, tableExists;

                if(databaseObject instanceof DataBase) {
                    kony.nosql.getTables(databaseObject).then(function(tables) {
                        if(tables.indexOf(tableName) != -1) {
                            tableExists = true;
                        } else {
                            tableExists = false;
                        }
                        $KU.logExecutingFinished('kony.nosql.tableExists');
                        resolve(tableExists);
                    }).catch(function(error) {
                        reject(error);
                    });
                } else {
                    $KU.logErrorMessage('Pass proper database object.');
                    reject({errorMsg: 'Pass proper database object.'});
                }
            });
        },

        getPrimaryKeys: function(databaseObject, tableName, transaction) {
            $KU.logExecuting('kony.nosql.getPrimaryKeys');
            $KU.logExecutingWithParams('kony.nosql.getPrimaryKeys', databaseObject, tableName, transaction);
            return new Promise(function(resolve, reject){
                var primaryKeys, objectStore;
                var _getPrimaryKeys = function(transactionObject) {
                    var primaryKeys = [];
                    transactionObject = transactionObject.tx;
                    objectStore = transactionObject.objectStore(tableName);
                    primaryKeys = (typeof objectStore.keyPath === 'string') ? [objectStore.keyPath] : objectStore.keyPath;
                    return primaryKeys;
                };
                kony.nosql.tableExists(databaseObject, tableName).then(function(exists) {
                    if(exists) {
                        if(!transaction) {
                            kony.nosql.openTransaction(databaseObject, [tableName], kony.nosql.READ_WRITE, function(transactionObject) {
                                primaryKeys =  _getPrimaryKeys(transactionObject);
                            }).then(function() {
                                $KU.logExecutingFinished('kony.nosql.getPrimaryKeys VIA if !transaction is true');
                                resolve(primaryKeys);
                            }).catch(function(error) {
                                reject(error);
                            });
                        } else {
                            $KU.logExecutingFinished('kony.nosql.getPrimaryKeys VIA !transaction is false');
                            resolve(_getPrimaryKeys(transaction));
                        }
                    } else {
                        $KU.logErrorMessage('Table doesn\'t exists.');
                        reject({errorMsg: 'Table doesn\'t exists.'});
                    }
                }).catch(function(error) {
                    reject(error);
                });
            });
        },

        deleteDatabase: function(databaseName) {
            $KU.logExecuting('kony.nosql.deleteDatabase');
            $KU.logExecutingWithParams('kony.nosql.deleteDatabase', databaseName);
            return new Promise(function(resolve, reject) {
                var request = iDB.deleteDatabase(_getDataBaseName(databaseName));

                request.onsuccess = function(event) {
                    $KU.logExecutingFinished('kony.nosql.deleteDatabase');
                    resolve();
                };
                request.onerror = function(event) {
                    $KU.logErrorMessage('unknown error' + event.target.error);
                    reject(event.target.error);
                };
            });
        },

        deleteTable: function(databaseObject, tableName) {
            $KU.logExecuting('kony.nosql.deleteTable');
            $KU.logExecutingWithParams('kony.nosql.deleteTable', databaseObject, tableName);
            return new Promise(function(resolve, reject) {
                var db;

                if(databaseObject instanceof DataBase) {
                    db = databaseObject.db;
                    db.deleteObjectStore(tableName);
                    $KU.logExecutingFinished('kony.nosql.deleteTable');
                    resolve();
                } else {
                    $KU.logErrorMessage('Pass proper database object.');
                    reject({errorMsg: 'Pass proper database object.'});
                }
            });
        },

        clearTable: function(transactionObject, tableName) {
            $KU.logExecuting('kony.nosql.clearTable');
            $KU.logExecutingWithParams('kony.nosql.clearTable', transactionObject, tableName);
            return new Promise(function(resolve, reject) {
                var objectStore, transaction, request;

                if(transactionObject instanceof Transaction) {
                    transaction = transactionObject.tx;
                    objectStore = transaction.objectStore(tableName);
                    request = objectStore.clear();

                    request.onsuccess = function(event) {
                        $KU.logExecutingFinished('kony.nosql.clearTable');
                        resolve();
                    };
                    request.onerror = function(event) {
                        reject(event.target.error);
                    };

                } else {
                    $KU.logErrorMessage('Pass proper transaction object.');
                    reject({errorMsg: 'Pass proper transaction object.'});
                }
            });
        },

        addOrReplaceRecords: function(transactionObject, tableName, records) {
            $KU.logExecuting('kony.nosql.addOrReplaceRecords');
            $KU.logExecutingWithParams('kony.nosql.addOrReplaceRecords', transactionObject, tableName, records);
            return new Promise(function(resolve, reject) {
                var i = 0, storeReq = null, transaction, store,
                onerrorcb = function(event) {
                    reject(event.target.error);
                },
                replaceNext = function() {
                    if(i < records.length) {
                        storeReq = store.put(records[i]);
                        storeReq.onsuccess = replaceNext;
                        storeReq.onerror = onerrorcb;
                        ++i;
                    } else {
                        $KU.logExecutingFinished('kony.nosql.addOrReplaceRecords');
                        resolve();
                    }
                };

                if(!transactionObject instanceof Transaction) {
                    $KU.logErrorMessage('Pass proper transaction object.');
                    reject({"errorMsg": "Pass proper transaction object."});
                }

                transaction = transactionObject.tx;
                store = transaction.objectStore(tableName);

                replaceNext();
            });
        },

        replaceRecords: function(transactionObject, tableName, replaceObject, conditionInstance) {
            $KU.logExecuting('kony.nosql.replaceRecords');
            $KU.logExecutingWithParams('kony.nosql.replaceRecords', transactionObject, tableName, replaceObject, conditionInstance);
            return new Promise(function(resolve, reject) {
                kony.nosql.fetchRecords(transactionObject, tableName, conditionInstance).then(function(resultSet) {
                    var i = 0, storeReq = null, transaction, store, records = resultSet.data,
                    onerrorcb = function(event) {
                        reject(event.target.error);
                    },
                    replaceNext = function() {
                        var record, primaryKeys;
                        if(i < records.length) {
                            record = records[i];
                            primaryKeys = (typeof store.keyPath === 'string') ? [store.keyPath] : store.keyPath;

                            record = _replaceRecordValues(replaceObject, record, primaryKeys);

                            storeReq = store.put(record);
                            storeReq.onsuccess = replaceNext;
                            storeReq.onerror = onerrorcb;
                            ++i;
                        } else {
                            $KU.logExecutingFinished('kony.nosql.replaceRecords');
                            resolve();
                        }
                    };

                    if(!transactionObject instanceof Transaction) {
                        $KU.logErrorMessage('Pass proper transaction object.');
                        reject({"errorMsg": "Pass proper transaction object."});
                    }

                    transaction = transactionObject.tx;
                    store = transaction.objectStore(tableName);

                    replaceNext();
                }).catch(function(error) {
                    kony.web.logger('error','unknown error' + error);
                    reject(error);
                })
            });
        },


        createIndices: function(databaseObject, tableName, indexes) {
            $KU.logExecuting('kony.nosql.createIndices');
            $KU.logExecutingWithParams('kony.nosql.createIndices', databaseObject, tableName);
            return new Promise(function(resolve, reject) {

                var request, store, transaction, index;
                try {
                    request = databaseObject.dbOpenRequest;
                    transaction = request.transaction;
                    store = transaction.objectStore(tableName);

                    for(index in indexes) {
                        store.createIndex(index, index, indexes[index]);
                    }
                } catch (error) {
                    reject(error);
                }

                transaction.oncomplete = function(e){
                    kony.web.logger('log', 'transaction completed in createIndices');
                    resolve(true);
                }

            });
        },

        deleteIndices: function(databaseObject, tableName, indexes) {
            $KU.logExecuting('kony.nosql.deleteIndices');
            $KU.logExecutingWithParams('kony.nosql.deleteIndices', databaseObject, tableName);
            return new Promise(function(resolve, reject) {

                var request, store, transaction, index;
                try {
                    request = databaseObject.dbOpenRequest;
                    transaction = request.transaction;
                    store = transaction.objectStore(tableName);

                    for(index in indexes) {
                        store.deleteIndex(index);
                    }
                } catch (error) {
                    reject(error);
                }

                transaction.oncomplete = function(e){
                    kony.web.logger('log', 'transaction completed in deleteIndices');
                    resolve(true);
                }
            });
        }

    };
    Object.defineProperty(module, 'Condition', {configurable:false, enumerable:false, writable:false, value: Condition});
    Object.defineProperty(module, 'Rule', {configurable:false, enumerable:false, writable:false, value: Rule});

    Object.defineProperty(module, 'AND', {configurable:false, enumerable:false, writable:false, value: '&&'});
    Object.defineProperty(module, 'ASCENDING', {configurable:false, enumerable:false, writable:false, value: 'ASC'});
    Object.defineProperty(module, 'DESCENDING', {configurable:false, enumerable:false, writable:false, value: 'DESC'});
    Object.defineProperty(module, 'EQ', {configurable:false, enumerable:false, writable:false, value: '='});
    Object.defineProperty(module, 'GT', {configurable:false, enumerable:false, writable:false, value: '>'});
    Object.defineProperty(module, 'GTE', {configurable:false, enumerable:false, writable:false, value: '>='});
    Object.defineProperty(module, 'LT', {configurable:false, enumerable:false, writable:false, value: '<'});
    Object.defineProperty(module, 'LTE', {configurable:false, enumerable:false, writable:false, value: '<='});
    Object.defineProperty(module, 'NEQ', {configurable:false, enumerable:false, writable:false, value: '!='});
    Object.defineProperty(module, 'OR', {configurable:false, enumerable:false, writable:false, value: '||'});
    Object.defineProperty(module, 'REGEXP', {configurable:false, enumerable:false, writable:false, value: null});

    
    Object.defineProperty(module, 'READ', {configurable:false, enumerable:false, writable:false, value: 'read'});
    Object.defineProperty(module, 'READ_WRITE', {configurable:false, enumerable:false, writable:false, value: 'readwrite'});

    _validTypes.push(module.AND);
    _validTypes.push(module.OR);

    _validOrders.push(module.ASCENDING);
    _validOrders.push(module.DESCENDING);

    _validOperators.push(module.EQ);
    _validOperators.push(module.GT);
    _validOperators.push(module.GTE);
    _validOperators.push(module.LT);
    _validOperators.push(module.LTE);
    _validOperators.push(module.NEQ);
    _validOperators.push(module.REGEXP);

    module.openDatabase = (iDB) ? indexedDB.openDB : _notSupported;
    module.createTable = (iDB) ? indexedDB.createTable : _notSupported;
    module.openTransaction = (iDB) ? indexedDB.openTransaction : _notSupported;
    module.addRecords = (iDB) ? indexedDB.addRecords : _notSupported;
    module.fetchRecords = (iDB) ? indexedDB.fetchRecords : _notSupported;
    module.updateRecords = (iDB) ? indexedDB.updateRecords : _notSupported;
    module.deleteRecords = (iDB) ? indexedDB.deleteRecords : _notSupported;
    module.databaseExists = (iDB) ? indexedDB.databaseExists : _notSupported;
    module.databaseVersion = (iDB) ? indexedDB.databaseVersion : _notSupported;
    module.closeDatabase = (iDB) ? indexedDB.closeDatabase : _notSupported;
    module.getTables = (iDB) ? indexedDB.getTables : _notSupported;
    module.tableExists = (iDB) ? indexedDB.tableExists : _notSupported;
    module.getPrimaryKeys = (iDB) ? indexedDB.getPrimaryKeys : _notSupported;
    module.deleteDatabase = (iDB) ? indexedDB.deleteDatabase : _notSupported;
    module.deleteTable = (iDB) ? indexedDB.deleteTable : _notSupported;
    module.clearTable = (iDB) ? indexedDB.clearTable : _notSupported;
    module.addOrReplaceRecords = (iDB) ? indexedDB.addOrReplaceRecords : _notSupported;
    module.replaceRecords = (iDB) ? indexedDB.replaceRecords : _notSupported;
    module.createIndices =  (iDB) ? indexedDB.createIndices : _notSupported;
    module.deleteIndices =  (iDB) ? indexedDB.deleteIndices : _notSupported;


    return module;
}());


var getJasmineRequireObj = (function (jasmineGlobal) {
  var jasmineRequire;

  if (typeof module !== 'undefined' && module.exports && typeof exports !== 'undefined') {
    if (typeof global !== 'undefined') {
      jasmineGlobal = global;
    } else {
      jasmineGlobal = {};
    }
    jasmineRequire = exports;
  } else {
    if (typeof window !== 'undefined' && typeof window.toString === 'function' && window.toString() === '[object GjsGlobal]') {
      jasmineGlobal = window;
    }
    jasmineRequire = jasmineGlobal.jasmineRequire = {};
  }

  function getJasmineRequire() {
    return jasmineRequire;
  }

  getJasmineRequire().core = function(jRequire) {
    var j$ = {};

    jRequire.base(j$, jasmineGlobal);
    j$.util = jRequire.util(j$);
    j$.errors = jRequire.errors();
    j$.formatErrorMsg = jRequire.formatErrorMsg();
    j$.Any = jRequire.Any(j$);
    j$.Anything = jRequire.Anything(j$);
    j$.CallTracker = jRequire.CallTracker(j$);
    j$.MockDate = jRequire.MockDate();
    j$.getClearStack = jRequire.clearStack(j$);
    j$.Clock = jRequire.Clock();
    j$.DelayedFunctionScheduler = jRequire.DelayedFunctionScheduler(j$);
    j$.Env = jRequire.Env(j$);
    j$.StackTrace = jRequire.StackTrace(j$);
    j$.ExceptionFormatter = jRequire.ExceptionFormatter(j$);
    j$.Expectation = jRequire.Expectation();
    j$.buildExpectationResult = jRequire.buildExpectationResult();
    j$.JsApiReporter = jRequire.JsApiReporter();
    j$.matchersUtil = jRequire.matchersUtil(j$);
    j$.ObjectContaining = jRequire.ObjectContaining(j$);
    j$.ArrayContaining = jRequire.ArrayContaining(j$);
    j$.ArrayWithExactContents = jRequire.ArrayWithExactContents(j$);
    j$.pp = jRequire.pp(j$);
    j$.QueueRunner = jRequire.QueueRunner(j$);
    j$.ReportDispatcher = jRequire.ReportDispatcher(j$);
    j$.Spec = jRequire.Spec(j$);
    j$.Spy = jRequire.Spy(j$);
    j$.SpyFactory = jRequire.SpyFactory(j$);
    j$.SpyRegistry = jRequire.SpyRegistry(j$);
    j$.SpyStrategy = jRequire.SpyStrategy(j$);
    j$.StringMatching = jRequire.StringMatching(j$);
    j$.UserContext = jRequire.UserContext(j$);
    j$.Suite = jRequire.Suite(j$);
    j$.Timer = jRequire.Timer();
    j$.TreeProcessor = jRequire.TreeProcessor();
    j$.version = jRequire.version();
    j$.Order = jRequire.Order();
    j$.DiffBuilder = jRequire.DiffBuilder(j$);
    j$.NullDiffBuilder = jRequire.NullDiffBuilder(j$);
    j$.ObjectPath = jRequire.ObjectPath(j$);
    j$.GlobalErrors = jRequire.GlobalErrors(j$);

    j$.Truthy = jRequire.Truthy(j$);
    j$.Falsy = jRequire.Falsy(j$);
    j$.Empty = jRequire.Empty(j$);
    j$.NotEmpty = jRequire.NotEmpty(j$);

    j$.matchers = jRequire.requireMatchers(jRequire, j$);

    return j$;
  };

  return getJasmineRequire;
})(this);

getJasmineRequireObj().requireMatchers = function(jRequire, j$) {
  var availableMatchers = [
      'nothing',
      'toBe',
      'toBeCloseTo',
      'toBeDefined',
      'toBeFalsy',
      'toBeGreaterThan',
      'toBeGreaterThanOrEqual',
      'toBeLessThan',
      'toBeLessThanOrEqual',
      'toBeNaN',
      'toBeNegativeInfinity',
      'toBeNull',
      'toBePositiveInfinity',
      'toBeTruthy',
      'toBeUndefined',
      'toContain',
      'toEqual',
      'toHaveBeenCalled',
      'toHaveBeenCalledBefore',
      'toHaveBeenCalledTimes',
      'toHaveBeenCalledWith',
      'toHaveClass',
      'toMatch',
      'toThrow',
      'toThrowError',
      'toThrowMatching',
    ],
    matchers = {};

  for (var i = 0; i < availableMatchers.length; i++) {
    var name = availableMatchers[i];
    matchers[name] = jRequire[name](j$);
  }

  return matchers;
};

getJasmineRequireObj().base = function(j$, jasmineGlobal) {
  j$.unimplementedMethod_ = function() {
    throw new Error('unimplemented method');
  };

  
  j$.MAX_PRETTY_PRINT_DEPTH = 8;
  
  j$.MAX_PRETTY_PRINT_ARRAY_LENGTH = 50;
  
  j$.MAX_PRETTY_PRINT_CHARS = 1000;
  
  j$.DEFAULT_TIMEOUT_INTERVAL = 20000;

  j$.getGlobal = function() {
    return jasmineGlobal;
  };

  
  j$.getEnv = function(options) {
    var env = j$.currentEnv_ = j$.currentEnv_ || new j$.Env(options);
    
    return env;
  };

  j$.isArray_ = function(value) {
    return j$.isA_('Array', value);
  };

  j$.isObject_ = function(value) {
    return !j$.util.isUndefined(value) && value !== null && j$.isA_('Object', value);
  };

  j$.isString_ = function(value) {
    return j$.isA_('String', value);
  };

  j$.isNumber_ = function(value) {
    return j$.isA_('Number', value);
  };

  j$.isFunction_ = function(value) {
    return j$.isA_('Function', value);
  };

  j$.isAsyncFunction_ = function(value) {
    return j$.isA_('AsyncFunction', value);
  };

  j$.isTypedArray_ = function(value) {
    return j$.isA_('Float32Array', value) ||
      j$.isA_('Float64Array', value) ||
      j$.isA_('Int16Array', value) ||
      j$.isA_('Int32Array', value) ||
      j$.isA_('Int8Array', value) ||
      j$.isA_('Uint16Array', value) ||
      j$.isA_('Uint32Array', value) ||
      j$.isA_('Uint8Array', value) ||
      j$.isA_('Uint8ClampedArray', value);
  };

  j$.isA_ = function(typeName, value) {
    return j$.getType_(value) === '[object ' + typeName + ']';
  };

  j$.isError_ = function(value) {
    if (value instanceof Error) {
      return true;
    }
    if (value && value.constructor && value.constructor.constructor &&
      (value instanceof (value.constructor.constructor('return this')()).Error)) {
      return true;
    }
    return false;
  };

  j$.getType_ = function(value) {
    return Object.prototype.toString.apply(value);
  };

  j$.isDomNode = function(obj) {
    return obj.nodeType > 0;
  };

  j$.isMap = function(obj) {
    return typeof jasmineGlobal.Map !== 'undefined' && obj.constructor === jasmineGlobal.Map;
  };

  j$.isSet = function(obj) {
    return typeof jasmineGlobal.Set !== 'undefined' && obj.constructor === jasmineGlobal.Set;
  };

  j$.isPromise = function(obj) {
    return typeof jasmineGlobal.Promise !== 'undefined' && obj.constructor === jasmineGlobal.Promise;
  };

  j$.fnNameFor = function(func) {
    if (func.name) {
      return func.name;
    }

    var matches = func.toString().match(/^\s*function\s*(\w+)\s*\(/) ||
      func.toString().match(/^\s*\[object\s*(\w+)Constructor\]/);

    return matches ? matches[1] : '<anonymous>';
  };

  
  j$.any = function(clazz) {
    return new j$.Any(clazz);
  };

  
  j$.anything = function() {
    return new j$.Anything();
  };

  
  j$.truthy = function() {return new j$.Truthy();};

  
  j$.falsy = function() {return new j$.Falsy();};

  
  j$.empty = function() {return new j$.Empty();};

  
  j$.notEmpty = function() {return new j$.NotEmpty();};

  
  j$.objectContaining = function(sample) {
    return new j$.ObjectContaining(sample);
  };

  
  j$.stringMatching = function(expected) {
    return new j$.StringMatching(expected);
  };

  
  j$.arrayContaining = function(sample) {
    return new j$.ArrayContaining(sample);
  };

  
  j$.arrayWithExactContents = function(sample) {
    return new j$.ArrayWithExactContents(sample);
  };

  j$.isSpy = function(putativeSpy) {
    if (!putativeSpy) {
      return false;
    }
    return putativeSpy.and instanceof j$.SpyStrategy &&
      putativeSpy.calls instanceof j$.CallTracker;
  };
};

getJasmineRequireObj().util = function(j$) {

  var util = {};

  util.inherit = function(childClass, parentClass) {
    var Subclass = function() {
    };
    Subclass.prototype = parentClass.prototype;
    childClass.prototype = new Subclass();
  };

  util.htmlEscape = function(str) {
    if (!str) {
      return str;
    }
    return str.replace(/&/g, '&amp;')
      .replace(/</g, '&lt;')
      .replace(/>/g, '&gt;');
  };

  util.argsToArray = function(args) {
    var arrayOfArgs = [];
    for (var i = 0; i < args.length; i++) {
      arrayOfArgs.push(args[i]);
    }
    return arrayOfArgs;
  };

  util.isUndefined = function(obj) {
    return obj === void 0;
  };

  util.arrayContains = function(array, search) {
    var i = array.length;
    while (i--) {
      if (array[i] === search) {
        return true;
      }
    }
    return false;
  };

  util.clone = function(obj) {
    if (Object.prototype.toString.apply(obj) === '[object Array]') {
      return obj.slice();
    }

    var cloned = {};
    for (var prop in obj) {
      if (obj.hasOwnProperty(prop)) {
        cloned[prop] = obj[prop];
      }
    }

    return cloned;
  };

  util.cloneArgs = function(args) {
    var clonedArgs = [];
    var argsAsArray = j$.util.argsToArray(args);
    for(var i = 0; i < argsAsArray.length; i++) {
      var str = Object.prototype.toString.apply(argsAsArray[i]),
        primitives = /^\[object (Boolean|String|RegExp|Number)/;

      
      if (!argsAsArray[i] || str.match(primitives)) {
        clonedArgs.push(argsAsArray[i]);
      } else {
        clonedArgs.push(j$.util.clone(argsAsArray[i]));
      }
    }
    return clonedArgs;
  };

  util.getPropertyDescriptor = function(obj, methodName) {
    var descriptor,
      proto = obj;

    do {
      descriptor = Object.getOwnPropertyDescriptor(proto, methodName);
      proto = Object.getPrototypeOf(proto);
    } while (!descriptor && proto);

    return descriptor;
  };

  util.objectDifference = function(obj, toRemove) {
    var diff = {};

    for (var key in obj) {
      if (util.has(obj, key) && !util.has(toRemove, key)) {
        diff[key] = obj[key];
      }
    }

    return diff;
  };

  util.has = function(obj, key) {
    return Object.prototype.hasOwnProperty.call(obj, key);
  };

  function anyMatch(pattern, lines) {
    var i;

    for (i = 0; i < lines.length; i++) {
      if (lines[i].match(pattern)) {
        return true;
      }
    }

    return false;
  }

  function errorWithStack() {
    
    
    var error = new Error();

    if (error.stack) {
      return error;
    }

    
    try {
      throw new Error();
    } catch (e) {
      return e;
    }
  }

  function callerFile() {
    var trace = new j$.StackTrace(errorWithStack().stack);
    return trace.frames[2].file;
  }

  util.jasmineFile = (function() {
    var result;

    return function() {
      var trace;

      if (!result) {
        result = callerFile();
      }

      return result;
    };
  }());

  return util;
};

getJasmineRequireObj().Spec = function(j$) {
  function Spec(attrs) {
    this.expectationFactory = attrs.expectationFactory;
    this.resultCallback = attrs.resultCallback || function() {};
    this.id = attrs.id;
    this.description = attrs.description || '';
    this.queueableFn = attrs.queueableFn;
    this.beforeAndAfterFns = attrs.beforeAndAfterFns || function() { return {befores: [], afters: []}; };
    this.userContext = attrs.userContext || function() { return {}; };
    this.onStart = attrs.onStart || function() {};
    this.getSpecName = attrs.getSpecName || function() { return ''; };
    this.expectationResultFactory = attrs.expectationResultFactory || function() { };
    this.queueRunnerFactory = attrs.queueRunnerFactory || function() {};
    this.catchingExceptions = attrs.catchingExceptions || function() { return true; };
    this.throwOnExpectationFailure = !!attrs.throwOnExpectationFailure;

    if (!this.queueableFn.fn) {
      this.pend();
    }

    
    this.result = {
      id: this.id,
      description: this.description,
      fullName: this.getFullName(),
      failedExpectations: [],
      passedExpectations: [],
      deprecationWarnings: [],
      pendingReason: ''
    };
  }

  Spec.prototype.addExpectationResult = function(passed, data, isError) {
    var expectationResult = this.expectationResultFactory(data);
    if (passed) {
      this.result.passedExpectations.push(expectationResult);
    } else {
      this.result.failedExpectations.push(expectationResult);

      if (this.throwOnExpectationFailure && !isError) {
        throw new j$.errors.ExpectationFailed();
      }
    }
  };

  Spec.prototype.expect = function(actual) {
    return this.expectationFactory(actual, this);
  };

  Spec.prototype.execute = function(onComplete, excluded) {
    var self = this;

    var onStart = {
      fn: function(done) {
        self.onStart(self, done);
      }
    };

    var complete = {
      fn: function(done) {
        self.queueableFn.fn = null;
        self.result.status = self.status(excluded);
        self.resultCallback(self.result, done);
      }
    };

    var fns = this.beforeAndAfterFns();
    var regularFns = fns.befores.concat(this.queueableFn);

    var runnerConfig = {
      isLeaf: true,
      queueableFns: regularFns,
      cleanupFns: fns.afters,
      onException: function () {
        self.onException.apply(self, arguments);
      },
      onComplete: function() {
        onComplete(self.result.status === 'failed' && new j$.StopExecutionError('spec failed'));
      },
      userContext: this.userContext()
    };

    if (this.markedPending || excluded === true) {
      runnerConfig.queueableFns = [];
      runnerConfig.cleanupFns = [];
    }

    runnerConfig.queueableFns.unshift(onStart);
    runnerConfig.cleanupFns.push(complete);

    this.queueRunnerFactory(runnerConfig);
  };

  Spec.prototype.onException = function onException(e) {
    if (Spec.isPendingSpecException(e)) {
      this.pend(extractCustomPendingMessage(e));
      return;
    }

    if (e instanceof j$.errors.ExpectationFailed) {
      return;
    }

    this.addExpectationResult(false, {
      matcherName: '',
      passed: false,
      expected: '',
      actual: '',
      error: e
    }, true);
  };

  Spec.prototype.pend = function(message) {
    this.markedPending = true;
    if (message) {
      this.result.pendingReason = message;
    }
  };

  Spec.prototype.getResult = function() {
    this.result.status = this.status();
    return this.result;
  };

  Spec.prototype.status = function(excluded) {
    if (excluded === true) {
      return 'excluded';
    }

    if (this.markedPending) {
      return 'pending';
    }

    if (this.result.failedExpectations.length > 0) {
      return 'failed';
    } else {
      return 'passed';
    }
  };

  Spec.prototype.getFullName = function() {
    return this.getSpecName(this);
  };

  Spec.prototype.addDeprecationWarning = function(deprecation) {
    if (typeof deprecation === 'string') {
      deprecation = { message: deprecation };
    }
    this.result.deprecationWarnings.push(this.expectationResultFactory(deprecation));
  };

  var extractCustomPendingMessage = function(e) {
    var fullMessage = e.toString(),
        boilerplateStart = fullMessage.indexOf(Spec.pendingSpecExceptionMessage),
        boilerplateEnd = boilerplateStart + Spec.pendingSpecExceptionMessage.length;

    return fullMessage.substr(boilerplateEnd);
  };

  Spec.pendingSpecExceptionMessage = '=> marked Pending';

  Spec.isPendingSpecException = function(e) {
    return !!(e && e.toString && e.toString().indexOf(Spec.pendingSpecExceptionMessage) !== -1);
  };

  return Spec;
};

if (typeof window == void 0 && typeof exports == 'object') {
  exports.Spec = jasmineRequire.Spec;
}



getJasmineRequireObj().Order = function() {
  function Order(options) {
    this.random = 'random' in options ? options.random : true;
    var seed = this.seed = options.seed || generateSeed();
    this.sort = this.random ? randomOrder : naturalOrder;

    function naturalOrder(items) {
      return items;
    }

    function randomOrder(items) {
      var copy = items.slice();
      copy.sort(function(a, b) {
        return jenkinsHash(seed + a.id) - jenkinsHash(seed + b.id);
      });
      return copy;
    }

    function generateSeed() {
      return String(Math.random()).slice(-5);
    }

    
    
    
    

    function jenkinsHash(key) {
      var hash, i;
      for(hash = i = 0; i < key.length; ++i) {
        hash += key.charCodeAt(i);
        hash += (hash << 10);
        hash ^= (hash >> 6);
      }
      hash += (hash << 3);
      hash ^= (hash >> 11);
      hash += (hash << 15);
      return hash;
    }

  }

  return Order;
};

getJasmineRequireObj().Env = function(j$) {
  
  function Env(options) {
    options = options || {};

    var self = this;
    var global = options.global || j$.getGlobal();

    var totalSpecsDefined = 0;

    var realSetTimeout = j$.getGlobal().setTimeout;
    var realClearTimeout = j$.getGlobal().clearTimeout;
    var clearStack = j$.getClearStack(j$.getGlobal());
    this.clock = new j$.Clock(global, function () { return new j$.DelayedFunctionScheduler(); }, new j$.MockDate(global));

    var runnableResources = {};

    var currentSpec = null;
    var currentlyExecutingSuites = [];
    var currentDeclarationSuite = null;
    var throwOnExpectationFailure = false;
    var stopOnSpecFailure = false;
    var random = true;
    var seed = null;
    var handlingLoadErrors = true;
    var hasFailures = false;

    var currentSuite = function() {
      return currentlyExecutingSuites[currentlyExecutingSuites.length - 1];
    };

    var currentRunnable = function() {
      return currentSpec || currentSuite();
    };

    var globalErrors = null;

    var installGlobalErrors = function() {
      if (globalErrors) {
        return;
      }

      globalErrors = new j$.GlobalErrors();
      globalErrors.install();
    };

    if (!options.suppressLoadErrors) {
      installGlobalErrors();
      globalErrors.pushListener(function(message, filename, lineno) {
        topSuite.result.failedExpectations.push({
          passed: false,
          globalErrorType: 'load',
          message: message,
          filename: filename,
          lineno: lineno
        });
      });
    }

    this.specFilter = function() {
      return true;
    };

    this.addSpyStrategy = function(name, fn) {
      if(!currentRunnable()) {
        throw new Error('Custom spy strategies must be added in a before function or a spec');
      }
      runnableResources[currentRunnable().id].customSpyStrategies[name] = fn;
    };

    this.addCustomEqualityTester = function(tester) {
      if(!currentRunnable()) {
        throw new Error('Custom Equalities must be added in a before function or a spec');
      }
      runnableResources[currentRunnable().id].customEqualityTesters.push(tester);
    };

    this.addMatchers = function(matchersToAdd) {
      if(!currentRunnable()) {
        throw new Error('Matchers must be added in a before function or a spec');
      }
      var customMatchers = runnableResources[currentRunnable().id].customMatchers;
      for (var matcherName in matchersToAdd) {
        customMatchers[matcherName] = matchersToAdd[matcherName];
      }
    };

    j$.Expectation.addCoreMatchers(j$.matchers);

    var nextSpecId = 0;
    var getNextSpecId = function() {
      return 'spec' + nextSpecId++;
    };

    var nextSuiteId = 0;
    var getNextSuiteId = function() {
      return 'suite' + nextSuiteId++;
    };

    var expectationFactory = function(actual, spec) {
      return j$.Expectation.Factory({
        util: j$.matchersUtil,
        customEqualityTesters: runnableResources[spec.id].customEqualityTesters,
        customMatchers: runnableResources[spec.id].customMatchers,
        actual: actual,
        addExpectationResult: addExpectationResult
      });

      function addExpectationResult(passed, result) {
        return spec.addExpectationResult(passed, result);
      }
    };

    var defaultResourcesForRunnable = function(id, parentRunnableId) {
      var resources = {spies: [], customEqualityTesters: [], customMatchers: {}, customSpyStrategies: {}};

      if(runnableResources[parentRunnableId]){
        resources.customEqualityTesters = j$.util.clone(runnableResources[parentRunnableId].customEqualityTesters);
        resources.customMatchers = j$.util.clone(runnableResources[parentRunnableId].customMatchers);
      }

      runnableResources[id] = resources;
    };

    var clearResourcesForRunnable = function(id) {
        spyRegistry.clearSpies();
        delete runnableResources[id];
    };

    var beforeAndAfterFns = function(suite) {
      return function() {
        var befores = [],
          afters = [];

        while(suite) {
          befores = befores.concat(suite.beforeFns);
          afters = afters.concat(suite.afterFns);

          suite = suite.parentSuite;
        }

        return {
          befores: befores.reverse(),
          afters: afters
        };
      };
    };

    var getSpecName = function(spec, suite) {
      var fullName = [spec.description],
          suiteFullName = suite.getFullName();

      if (suiteFullName !== '') {
        fullName.unshift(suiteFullName);
      }
      return fullName.join(' ');
    };

    
    var buildExpectationResult = j$.buildExpectationResult,
        exceptionFormatter = new j$.ExceptionFormatter(),
        expectationResultFactory = function(attrs) {
          attrs.messageFormatter = exceptionFormatter.message;
          attrs.stackFormatter = exceptionFormatter.stack;

          return buildExpectationResult(attrs);
        };

    var maximumSpecCallbackDepth = 20;
    var currentSpecCallbackDepth = 0;

    this.throwOnExpectationFailure = function(value) {
      throwOnExpectationFailure = !!value;
    };

    this.throwingExpectationFailures = function() {
      return throwOnExpectationFailure;
    };

    this.stopOnSpecFailure = function(value) {
      stopOnSpecFailure = !!value;
    };

    this.stoppingOnSpecFailure = function() {
      return stopOnSpecFailure;
    };

    this.randomizeTests = function(value) {
      random = !!value;
    };

    this.randomTests = function() {
      return random;
    };

    this.seed = function(value) {
      if (value) {
        seed = value;
      }
      return seed;
    };

    this.deprecated = function(deprecation) {
      var runnable = currentRunnable() || topSuite;
      runnable.addDeprecationWarning(deprecation);
      if(typeof console !== 'undefined' && typeof console.error === 'function') {
        console.error('DEPRECATION:', deprecation);
      }
    };

    var queueRunnerFactory = function(options, args) {
      var failFast = false;
      if (options.isLeaf) {
        failFast = throwOnExpectationFailure;
      } else if (!options.isReporter) {
        failFast = stopOnSpecFailure;
      }
      options.clearStack = options.clearStack || clearStack;
      options.timeout = {setTimeout: realSetTimeout, clearTimeout: realClearTimeout};
      options.fail = self.fail;
      options.globalErrors = globalErrors;
      options.completeOnFirstError = failFast;
      options.onException = options.onException || function(e) {
        (currentRunnable() || topSuite).onException(e);
      };
      options.deprecated = self.deprecated;

      new j$.QueueRunner(options).execute(args);
    };

    var topSuite = new j$.Suite({
      env: this,
      id: getNextSuiteId(),
      description: 'Jasmine__TopLevel__Suite',
      expectationFactory: expectationFactory,
      expectationResultFactory: expectationResultFactory
    });
    defaultResourcesForRunnable(topSuite.id);
    currentDeclarationSuite = topSuite;

    this.topSuite = function() {
      return topSuite;
    };

    
    var reporter = new j$.ReportDispatcher([
      
      'jasmineStarted',
      
      'jasmineDone',
      
      'suiteStarted',
      
      'suiteDone',
      
      'specStarted',
      
      'specDone'
    ], queueRunnerFactory);

    this.execute = function(runnablesToRun) {
      var self = this;
      installGlobalErrors();

      if(!runnablesToRun) {
        if (focusedRunnables.length) {
          runnablesToRun = focusedRunnables;
        } else {
          runnablesToRun = [topSuite.id];
        }
      }

      var order = new j$.Order({
        random: random,
        seed: seed
      });

      var processor = new j$.TreeProcessor({
        tree: topSuite,
        runnableIds: runnablesToRun,
        queueRunnerFactory: queueRunnerFactory,
        nodeStart: function(suite, next) {
          currentlyExecutingSuites.push(suite);
          defaultResourcesForRunnable(suite.id, suite.parentSuite.id);
          reporter.suiteStarted(suite.result, next);
        },
        nodeComplete: function(suite, result, next) {
          if (suite !== currentSuite()) {
            throw new Error('Tried to complete the wrong suite');
          }

          clearResourcesForRunnable(suite.id);
          currentlyExecutingSuites.pop();

          if (result.status === 'failed') {
            hasFailures = true;
          }

          reporter.suiteDone(result, next);
        },
        orderChildren: function(node) {
          return order.sort(node.children);
        },
        excludeNode: function(spec) {
          return !self.specFilter(spec);
        }
      });

      if(!processor.processTree().valid) {
        throw new Error('Invalid order: would cause a beforeAll or afterAll to be run multiple times');
      }

      
      reporter.jasmineStarted({
        totalSpecsDefined: totalSpecsDefined,
        order: order
      }, function() {
        currentlyExecutingSuites.push(topSuite);

        processor.execute(function () {
          clearResourcesForRunnable(topSuite.id);
          currentlyExecutingSuites.pop();
          var overallStatus, incompleteReason;

          if (hasFailures || topSuite.result.failedExpectations.length > 0) {
            overallStatus = 'failed';
          } else if (focusedRunnables.length > 0) {
            overallStatus = 'incomplete';
            incompleteReason = 'fit() or fdescribe() was found';
          } else if (totalSpecsDefined === 0) {
            overallStatus = 'incomplete';
            incompleteReason = 'No specs found';
          } else {
            overallStatus = 'passed';
          }

          
          reporter.jasmineDone({
            overallStatus: overallStatus,
            incompleteReason: incompleteReason,
            order: order,
            failedExpectations: topSuite.result.failedExpectations,
            deprecationWarnings: topSuite.result.deprecationWarnings
          }, function() {});
        });
      });
    };

    
    this.addReporter = function(reporterToAdd) {
      reporter.addReporter(reporterToAdd);
    };

    this.provideFallbackReporter = function(reporterToAdd) {
      reporter.provideFallbackReporter(reporterToAdd);
    };

    this.clearReporters = function() {
      reporter.clearReporters();
    };

    var spyFactory = new j$.SpyFactory(function() {
      var runnable = currentRunnable();

      if (runnable) {
        return runnableResources[runnable.id].customSpyStrategies;
      }

      return {};
    });

    var spyRegistry = new j$.SpyRegistry({
      currentSpies: function() {
        if(!currentRunnable()) {
          throw new Error('Spies must be created in a before function or a spec');
        }
        return runnableResources[currentRunnable().id].spies;
      },
      createSpy: function(name, originalFn) {
        return self.createSpy(name, originalFn);
      }
    });

    this.allowRespy = function(allow){
      spyRegistry.allowRespy(allow);
    };

    this.spyOn = function() {
      return spyRegistry.spyOn.apply(spyRegistry, arguments);
    };

    this.spyOnProperty = function() {
      return spyRegistry.spyOnProperty.apply(spyRegistry, arguments);
    };

    this.createSpy = function(name, originalFn) {
      return spyFactory.createSpy(name, originalFn);
    };

    this.createSpyObj = function(baseName, methodNames) {
      return spyFactory.createSpyObj(baseName, methodNames);
    };

    var ensureIsFunction = function(fn, caller) {
      if (!j$.isFunction_(fn)) {
        throw new Error(caller + ' expects a function argument; received ' + j$.getType_(fn));
      }
    };

    var ensureIsFunctionOrAsync = function(fn, caller) {
      if (!j$.isFunction_(fn) && !j$.isAsyncFunction_(fn)) {
        throw new Error(caller + ' expects a function argument; received ' + j$.getType_(fn));
      }
    };

    function ensureIsNotNested(method) {
      var runnable = currentRunnable();
      if (runnable !== null && runnable !== undefined) {
        throw new Error('\'' + method + '\' should only be used in \'describe\' function');
      }
    }

    var suiteFactory = function(description) {
      var suite = new j$.Suite({
        env: self,
        id: getNextSuiteId(),
        description: description,
        parentSuite: currentDeclarationSuite,
        expectationFactory: expectationFactory,
        expectationResultFactory: expectationResultFactory,
        throwOnExpectationFailure: throwOnExpectationFailure
      });

      return suite;
    };

    this.describe = function(description, specDefinitions) {
      ensureIsNotNested('describe');
      ensureIsFunction(specDefinitions, 'describe');
      var suite = suiteFactory(description);
      if (specDefinitions.length > 0) {
        throw new Error('describe does not expect any arguments');
      }
      if (currentDeclarationSuite.markedPending) {
        suite.pend();
      }
      addSpecsToSuite(suite, specDefinitions);
      return suite;
    };

    this.xdescribe = function(description, specDefinitions) {
      ensureIsNotNested('xdescribe');
      ensureIsFunction(specDefinitions, 'xdescribe');
      var suite = suiteFactory(description);
      suite.pend();
      addSpecsToSuite(suite, specDefinitions);
      return suite;
    };

    var focusedRunnables = [];

    this.fdescribe = function(description, specDefinitions) {
      ensureIsNotNested('fdescribe');
      ensureIsFunction(specDefinitions, 'fdescribe');
      var suite = suiteFactory(description);
      suite.isFocused = true;

      focusedRunnables.push(suite.id);
      unfocusAncestor();
      addSpecsToSuite(suite, specDefinitions);

      return suite;
    };

    function addSpecsToSuite(suite, specDefinitions) {
      var parentSuite = currentDeclarationSuite;
      parentSuite.addChild(suite);
      currentDeclarationSuite = suite;

      var declarationError = null;
      try {
        specDefinitions.call(suite);
      } catch (e) {
        declarationError = e;
      }

      if (declarationError) {
        suite.onException(declarationError);
      }

      currentDeclarationSuite = parentSuite;
    }

    function findFocusedAncestor(suite) {
      while (suite) {
        if (suite.isFocused) {
          return suite.id;
        }
        suite = suite.parentSuite;
      }

      return null;
    }

    function unfocusAncestor() {
      var focusedAncestor = findFocusedAncestor(currentDeclarationSuite);
      if (focusedAncestor) {
        for (var i = 0; i < focusedRunnables.length; i++) {
          if (focusedRunnables[i] === focusedAncestor) {
            focusedRunnables.splice(i, 1);
            break;
          }
        }
      }
    }

    var specFactory = function(description, fn, suite, timeout) {
      totalSpecsDefined++;
      var spec = new j$.Spec({
        id: getNextSpecId(),
        beforeAndAfterFns: beforeAndAfterFns(suite),
        expectationFactory: expectationFactory,
        resultCallback: specResultCallback,
        getSpecName: function(spec) {
          return getSpecName(spec, suite);
        },
        onStart: specStarted,
        description: description,
        expectationResultFactory: expectationResultFactory,
        queueRunnerFactory: queueRunnerFactory,
        userContext: function() { return suite.clonedSharedUserContext(); },
        queueableFn: {
          fn: fn,
          timeout: function() { return timeout || j$.DEFAULT_TIMEOUT_INTERVAL; }
        },
        throwOnExpectationFailure: throwOnExpectationFailure
      });

      return spec;

      function specResultCallback(result, next) {
        clearResourcesForRunnable(spec.id);
        currentSpec = null;

        if (result.status === 'failed') {
          hasFailures = true;
        }

        reporter.specDone(result, next);
      }

      function specStarted(spec, next) {
        currentSpec = spec;
        defaultResourcesForRunnable(spec.id, suite.id);
        reporter.specStarted(spec.result, next);
      }
    };

    this.it = function(description, fn, timeout) {
      ensureIsNotNested('it');
      
      
      if (arguments.length > 1 && typeof fn !== 'undefined') {
        ensureIsFunctionOrAsync(fn, 'it');
      }
      var spec = specFactory(description, fn, currentDeclarationSuite, timeout);
      if (currentDeclarationSuite.markedPending) {
        spec.pend();
      }
      currentDeclarationSuite.addChild(spec);
      return spec;
    };

    this.xit = function(description, fn, timeout) {
      ensureIsNotNested('xit');
      
      
      if (arguments.length > 1 && typeof fn !== 'undefined') {
        ensureIsFunctionOrAsync(fn, 'xit');
      }
      var spec = this.it.apply(this, arguments);
      spec.pend('Temporarily disabled with xit');
      return spec;
    };

    this.fit = function(description, fn, timeout){
      ensureIsNotNested('fit');
      ensureIsFunctionOrAsync(fn, 'fit');
      var spec = specFactory(description, fn, currentDeclarationSuite, timeout);
      currentDeclarationSuite.addChild(spec);
      focusedRunnables.push(spec.id);
      unfocusAncestor();
      return spec;
    };

    this.expect = function(actual) {
      if (!currentRunnable()) {
        throw new Error('\'expect\' was used when there was no current spec, this could be because an asynchronous test timed out');
      }

      return currentRunnable().expect(actual);
    };

    this.beforeEach = function(beforeEachFunction, timeout) {
      ensureIsNotNested('beforeEach');
      ensureIsFunctionOrAsync(beforeEachFunction, 'beforeEach');
      currentDeclarationSuite.beforeEach({
        fn: beforeEachFunction,
        timeout: function() { return timeout || j$.DEFAULT_TIMEOUT_INTERVAL; }
      });
    };

    this.beforeAll = function(beforeAllFunction, timeout) {
      ensureIsNotNested('beforeAll');
      ensureIsFunctionOrAsync(beforeAllFunction, 'beforeAll');
      currentDeclarationSuite.beforeAll({
        fn: beforeAllFunction,
        timeout: function() { return timeout || j$.DEFAULT_TIMEOUT_INTERVAL; }
      });
    };

    this.afterEach = function(afterEachFunction, timeout) {
      ensureIsNotNested('afterEach');
      ensureIsFunctionOrAsync(afterEachFunction, 'afterEach');
      afterEachFunction.isCleanup = true;
      currentDeclarationSuite.afterEach({
        fn: afterEachFunction,
        timeout: function() { return timeout || j$.DEFAULT_TIMEOUT_INTERVAL; }
      });
    };

    this.afterAll = function(afterAllFunction, timeout) {
      ensureIsNotNested('afterAll');
      ensureIsFunctionOrAsync(afterAllFunction, 'afterAll');
      currentDeclarationSuite.afterAll({
        fn: afterAllFunction,
        timeout: function() { return timeout || j$.DEFAULT_TIMEOUT_INTERVAL; }
      });
    };

    this.pending = function(message) {
      var fullMessage = j$.Spec.pendingSpecExceptionMessage;
      if(message) {
        fullMessage += message;
      }
      throw fullMessage;
    };

    this.fail = function(error) {
      if (!currentRunnable()) {
        throw new Error('\'fail\' was used when there was no current spec, this could be because an asynchronous test timed out');
      }

      var message = 'Failed';
      if (error) {
        message += ': ';
        if (error.message) {
          message += error.message;
        } else if (jasmine.isString_(error)) {
          message += error;
        } else {
          
          message += jasmine.pp(error);
        }
      }

      currentRunnable().addExpectationResult(false, {
        matcherName: '',
        passed: false,
        expected: '',
        actual: '',
        message: message,
        error: error && error.message ? error : null
      });

      if (self.throwingExpectationFailures()) {
        throw new Error(message);
      }
    };
  }

  return Env;
};

getJasmineRequireObj().JsApiReporter = function() {

  var noopTimer = {
    start: function(){},
    elapsed: function(){ return 0; }
  };

  
  function JsApiReporter(options) {
    var timer = options.timer || noopTimer,
        status = 'loaded';

    this.started = false;
    this.finished = false;
    this.runDetails = {};

    this.jasmineStarted = function() {
      this.started = true;
      status = 'started';
      timer.start();
    };

    var executionTime;

    this.jasmineDone = function(runDetails) {
      this.finished = true;
      this.runDetails = runDetails;
      executionTime = timer.elapsed();
      status = 'done';
    };

    
    this.status = function() {
      return status;
    };

    var suites = [],
      suites_hash = {};

    this.suiteStarted = function(result) {
      suites_hash[result.id] = result;
    };

    this.suiteDone = function(result) {
      storeSuite(result);
    };

    
    this.suiteResults = function(index, length) {
      return suites.slice(index, index + length);
    };

    function storeSuite(result) {
      suites.push(result);
      suites_hash[result.id] = result;
    }

    
    this.suites = function() {
      return suites_hash;
    };

    var specs = [];

    this.specDone = function(result) {
      specs.push(result);
    };

    
    this.specResults = function(index, length) {
      return specs.slice(index, index + length);
    };

    
    this.specs = function() {
      return specs;
    };

    
    this.executionTime = function() {
      return executionTime;
    };

  }

  return JsApiReporter;
};

getJasmineRequireObj().Any = function(j$) {

  function Any(expectedObject) {
    if (typeof expectedObject === 'undefined') {
      throw new TypeError(
        'jasmine.any() expects to be passed a constructor function. ' +
        'Please pass one or use jasmine.anything() to match any object.'
      );
    }
    this.expectedObject = expectedObject;
  }

  Any.prototype.asymmetricMatch = function(other) {
    if (this.expectedObject == String) {
      return typeof other == 'string' || other instanceof String;
    }

    if (this.expectedObject == Number) {
      return typeof other == 'number' || other instanceof Number;
    }

    if (this.expectedObject == Function) {
      return typeof other == 'function' || other instanceof Function;
    }

    if (this.expectedObject == Object) {
      return other !== null && typeof other == 'object';
    }

    if (this.expectedObject == Boolean) {
      return typeof other == 'boolean';
    }

    
    if (typeof Symbol != 'undefined' && this.expectedObject == Symbol) {
      return typeof other == 'symbol';
    }
    

    return other instanceof this.expectedObject;
  };

  Any.prototype.jasmineToString = function() {
    return '<jasmine.any(' + j$.fnNameFor(this.expectedObject) + ')>';
  };

  return Any;
};

getJasmineRequireObj().Anything = function(j$) {

  function Anything() {}

  Anything.prototype.asymmetricMatch = function(other) {
    return !j$.util.isUndefined(other) && other !== null;
  };

  Anything.prototype.jasmineToString = function() {
    return '<jasmine.anything>';
  };

  return Anything;
};

getJasmineRequireObj().ArrayContaining = function(j$) {
  function ArrayContaining(sample) {
    this.sample = sample;
  }

  ArrayContaining.prototype.asymmetricMatch = function(other, customTesters) {
    if (!j$.isArray_(this.sample)) {
      throw new Error('You must provide an array to arrayContaining, not ' + j$.pp(this.sample) + '.');
    }

    for (var i = 0; i < this.sample.length; i++) {
      var item = this.sample[i];
      if (!j$.matchersUtil.contains(other, item, customTesters)) {
        return false;
      }
    }

    return true;
  };

  ArrayContaining.prototype.jasmineToString = function () {
    return '<jasmine.arrayContaining(' + jasmine.pp(this.sample) +')>';
  };

  return ArrayContaining;
};

getJasmineRequireObj().ArrayWithExactContents = function(j$) {

  function ArrayWithExactContents(sample) {
    this.sample = sample;
  }

  ArrayWithExactContents.prototype.asymmetricMatch = function(other, customTesters) {
    if (!j$.isArray_(this.sample)) {
      throw new Error('You must provide an array to arrayWithExactContents, not ' + j$.pp(this.sample) + '.');
    }

    if (this.sample.length !== other.length) {
      return false;
    }

    for (var i = 0; i < this.sample.length; i++) {
      var item = this.sample[i];
      if (!j$.matchersUtil.contains(other, item, customTesters)) {
        return false;
      }
    }

    return true;
  };

  ArrayWithExactContents.prototype.jasmineToString = function() {
    return '<jasmine.arrayWithExactContents ' + j$.pp(this.sample) + '>';
  };

  return ArrayWithExactContents;
};

getJasmineRequireObj().Empty = function (j$) {

  function Empty() {}

  Empty.prototype.asymmetricMatch = function (other) {
    if (j$.isString_(other) || j$.isArray_(other) || j$.isTypedArray_(other)) {
      return other.length === 0;
    }

    if (j$.isMap(other) || j$.isSet(other)) {
      return other.size === 0;
    }

    if (j$.isObject_(other)) {
      return Object.keys(other).length === 0;
    }
    return false;
  };

  Empty.prototype.jasmineToString = function () {
    return '<jasmine.empty>';
  };

  return Empty;
};

getJasmineRequireObj().Falsy = function(j$) {

  function Falsy() {}

  Falsy.prototype.asymmetricMatch = function(other) {
    return !other;
  };

  Falsy.prototype.jasmineToString = function() {
    return '<jasmine.falsy>';
  };

  return Falsy;
};

getJasmineRequireObj().NotEmpty = function (j$) {

  function NotEmpty() {}

  NotEmpty.prototype.asymmetricMatch = function (other) {
    if (j$.isString_(other) || j$.isArray_(other) || j$.isTypedArray_(other)) {
      return other.length !== 0;
    }

    if (j$.isMap(other) || j$.isSet(other)) {
      return other.size !== 0;
    }

    if (j$.isObject_(other)) {
      return Object.keys(other).length !== 0;
    }

    return false;
  };

  NotEmpty.prototype.jasmineToString = function () {
    return '<jasmine.notEmpty>';
  };

  return NotEmpty;
};

getJasmineRequireObj().ObjectContaining = function(j$) {

  function ObjectContaining(sample) {
    this.sample = sample;
  }

  function getPrototype(obj) {
    if (Object.getPrototypeOf) {
      return Object.getPrototypeOf(obj);
    }

    if (obj.constructor.prototype == obj) {
      return null;
    }

    return obj.constructor.prototype;
  }

  function hasProperty(obj, property) {
    if (!obj) {
      return false;
    }

    if (Object.prototype.hasOwnProperty.call(obj, property)) {
      return true;
    }

    return hasProperty(getPrototype(obj), property);
  }

  ObjectContaining.prototype.asymmetricMatch = function(other, customTesters) {
    if (typeof(this.sample) !== 'object') { throw new Error('You must provide an object to objectContaining, not \''+this.sample+'\'.'); }

    for (var property in this.sample) {
      if (!hasProperty(other, property) ||
          !j$.matchersUtil.equals(this.sample[property], other[property], customTesters)) {
        return false;
      }
    }

    return true;
  };

  ObjectContaining.prototype.jasmineToString = function() {
    return '<jasmine.objectContaining(' + j$.pp(this.sample) + ')>';
  };

  return ObjectContaining;
};

getJasmineRequireObj().StringMatching = function(j$) {

  function StringMatching(expected) {
    if (!j$.isString_(expected) && !j$.isA_('RegExp', expected)) {
      throw new Error('Expected is not a String or a RegExp');
    }

    this.regexp = new RegExp(expected);
  }

  StringMatching.prototype.asymmetricMatch = function(other) {
    return this.regexp.test(other);
  };

  StringMatching.prototype.jasmineToString = function() {
    return '<jasmine.stringMatching(' + this.regexp + ')>';
  };

  return StringMatching;
};

getJasmineRequireObj().Truthy = function(j$) {

  function Truthy() {}

  Truthy.prototype.asymmetricMatch = function(other) {
    return !!other;
  };

  Truthy.prototype.jasmineToString = function() {
    return '<jasmine.truthy>';
  };

  return Truthy;
};

getJasmineRequireObj().CallTracker = function(j$) {

  
  function CallTracker() {
    var calls = [];
    var opts = {};

    this.track = function(context) {
      if(opts.cloneArgs) {
        context.args = j$.util.cloneArgs(context.args);
      }
      calls.push(context);
    };

    
    this.any = function() {
      return !!calls.length;
    };

    
    this.count = function() {
      return calls.length;
    };

    
    this.argsFor = function(index) {
      var call = calls[index];
      return call ? call.args : [];
    };

    
    this.all = function() {
      return calls;
    };

    
    this.allArgs = function() {
      var callArgs = [];
      for(var i = 0; i < calls.length; i++){
        callArgs.push(calls[i].args);
      }

      return callArgs;
    };

    
    this.first = function() {
      return calls[0];
    };

    
    this.mostRecent = function() {
      return calls[calls.length - 1];
    };

    
    this.reset = function() {
      calls = [];
    };

    
    this.saveArgumentsByValue = function() {
      opts.cloneArgs = true;
    };

  }

  return CallTracker;
};

getJasmineRequireObj().clearStack = function(j$) {
  var maxInlineCallCount = 10;

  function messageChannelImpl(global, setTimeout) {
    var channel = new global.MessageChannel(),
        head = {},
        tail = head;

    var taskRunning = false;
    channel.port1.onmessage = function() {
      head = head.next;
      var task = head.task;
      delete head.task;

      if (taskRunning) {
        global.setTimeout(task, 0);
      } else {
        try {
          taskRunning = true;
          task();
        } finally {
          taskRunning = false;
        }
      }
    };

    var currentCallCount = 0;
    return function clearStack(fn) {
      currentCallCount++;

      if (currentCallCount < maxInlineCallCount) {
        tail = tail.next = { task: fn };
        channel.port2.postMessage(0);
      } else {
        currentCallCount = 0;
        setTimeout(fn);
      }
    };
  }

  function getClearStack(global) {
    var currentCallCount = 0;
    var realSetTimeout = global.setTimeout;
    var setTimeoutImpl = function clearStack(fn) {
        Function.prototype.apply.apply(realSetTimeout, [global, [fn, 0]]);
    };

    if (j$.isFunction_(global.setImmediate)) {
      var realSetImmediate = global.setImmediate;
      return function(fn) {
        currentCallCount++;

        if (currentCallCount < maxInlineCallCount) {
          realSetImmediate(fn);
        } else {
          currentCallCount = 0;

          setTimeoutImpl(fn);
        }
      };
    } else if (!j$.util.isUndefined(global.MessageChannel)) {
      return messageChannelImpl(global, setTimeoutImpl);
    } else {
      return setTimeoutImpl;
    }
  }

  return getClearStack;
};

getJasmineRequireObj().Clock = function() {

  var NODE_JS = typeof process !== 'undefined' && process.versions && typeof process.versions.node === 'string';

  
  function Clock(global, delayedFunctionSchedulerFactory, mockDate) {
    var self = this,
      realTimingFunctions = {
        setTimeout: global.setTimeout,
        clearTimeout: global.clearTimeout,
        setInterval: global.setInterval,
        clearInterval: global.clearInterval
      },
      fakeTimingFunctions = {
        setTimeout: setTimeout,
        clearTimeout: clearTimeout,
        setInterval: setInterval,
        clearInterval: clearInterval
      },
      installed = false,
      delayedFunctionScheduler,
      timer;

    self.FakeTimeout = FakeTimeout;

    
    self.install = function() {
      if(!originalTimingFunctionsIntact()) {
        throw new Error('Jasmine Clock was unable to install over custom global timer functions. Is the clock already installed?');
      }
      replace(global, fakeTimingFunctions);
      timer = fakeTimingFunctions;
      delayedFunctionScheduler = delayedFunctionSchedulerFactory();
      installed = true;

      return self;
    };

    
    self.uninstall = function() {
      delayedFunctionScheduler = null;
      mockDate.uninstall();
      replace(global, realTimingFunctions);

      timer = realTimingFunctions;
      installed = false;
    };

    
    self.withMock = function(closure) {
      this.install();
      try {
        closure();
      } finally {
        this.uninstall();
      }
    };

    
    self.mockDate = function(initialDate) {
      mockDate.install(initialDate);
    };

    self.setTimeout = function(fn, delay, params) {
      return Function.prototype.apply.apply(timer.setTimeout, [global, arguments]);
    };

    self.setInterval = function(fn, delay, params) {
      return Function.prototype.apply.apply(timer.setInterval, [global, arguments]);
    };

    self.clearTimeout = function(id) {
      return Function.prototype.call.apply(timer.clearTimeout, [global, id]);
    };

    self.clearInterval = function(id) {
      return Function.prototype.call.apply(timer.clearInterval, [global, id]);
    };

    
    self.tick = function(millis) {
      if (installed) {
        delayedFunctionScheduler.tick(millis, function(millis) { mockDate.tick(millis); });
      } else {
        throw new Error('Mock clock is not installed, use jasmine.clock().install()');
      }
    };

    return self;

    function originalTimingFunctionsIntact() {
      return global.setTimeout === realTimingFunctions.setTimeout &&
        global.clearTimeout === realTimingFunctions.clearTimeout &&
        global.setInterval === realTimingFunctions.setInterval &&
        global.clearInterval === realTimingFunctions.clearInterval;
    }

    function replace(dest, source) {
      for (var prop in source) {
        dest[prop] = source[prop];
      }
    }

    function setTimeout(fn, delay) {
      if (!NODE_JS) {
        return delayedFunctionScheduler.scheduleFunction(fn, delay, argSlice(arguments, 2));
      }

      var timeout = new FakeTimeout();

      delayedFunctionScheduler.scheduleFunction(fn, delay, argSlice(arguments, 2), false, timeout);

      return timeout;
    }

    function clearTimeout(id) {
      return delayedFunctionScheduler.removeFunctionWithId(id);
    }

    function setInterval(fn, interval) {
      if (!NODE_JS) {
        return delayedFunctionScheduler.scheduleFunction(fn, interval, argSlice(arguments, 2), true);
      }

      var timeout = new FakeTimeout();

      delayedFunctionScheduler.scheduleFunction(fn, interval, argSlice(arguments, 2), true, timeout);

      return timeout;
    }

    function clearInterval(id) {
      return delayedFunctionScheduler.removeFunctionWithId(id);
    }

    function argSlice(argsObj, n) {
      return Array.prototype.slice.call(argsObj, n);
    }
  }

  
  function FakeTimeout() {}

  FakeTimeout.prototype.ref = function () {
    return this;
  };

  FakeTimeout.prototype.unref = function () {
    return this;
  };

  return Clock;
};

getJasmineRequireObj().DelayedFunctionScheduler = function(j$) {
  function DelayedFunctionScheduler() {
    var self = this;
    var scheduledLookup = [];
    var scheduledFunctions = {};
    var currentTime = 0;
    var delayedFnCount = 0;
    var deletedKeys = [];

    self.tick = function(millis, tickDate) {
      millis = millis || 0;
      var endTime = currentTime + millis;

      runScheduledFunctions(endTime, tickDate);
      currentTime = endTime;
    };

    self.scheduleFunction = function(funcToCall, millis, params, recurring, timeoutKey, runAtMillis) {
      var f;
      if (typeof(funcToCall) === 'string') {
        
        f = function() { return eval(funcToCall); };
        
      } else {
        f = funcToCall;
      }

      millis = millis || 0;
      timeoutKey = timeoutKey || ++delayedFnCount;
      runAtMillis = runAtMillis || (currentTime + millis);

      var funcToSchedule = {
        runAtMillis: runAtMillis,
        funcToCall: f,
        recurring: recurring,
        params: params,
        timeoutKey: timeoutKey,
        millis: millis
      };

      if (runAtMillis in scheduledFunctions) {
        scheduledFunctions[runAtMillis].push(funcToSchedule);
      } else {
        scheduledFunctions[runAtMillis] = [funcToSchedule];
        scheduledLookup.push(runAtMillis);
        scheduledLookup.sort(function (a, b) {
          return a - b;
        });
      }

      return timeoutKey;
    };

    self.removeFunctionWithId = function(timeoutKey) {
      deletedKeys.push(timeoutKey);

      for (var runAtMillis in scheduledFunctions) {
        var funcs = scheduledFunctions[runAtMillis];
        var i = indexOfFirstToPass(funcs, function (func) {
          return func.timeoutKey === timeoutKey;
        });

        if (i > -1) {
          if (funcs.length === 1) {
            delete scheduledFunctions[runAtMillis];
            deleteFromLookup(runAtMillis);
          } else {
            funcs.splice(i, 1);
          }

          
          
          break;
        }
      }
    };

    return self;

    function indexOfFirstToPass(array, testFn) {
      var index = -1;

      for (var i = 0; i < array.length; ++i) {
        if (testFn(array[i])) {
          index = i;
          break;
        }
      }

      return index;
    }

    function deleteFromLookup(key) {
      var value = Number(key);
      var i = indexOfFirstToPass(scheduledLookup, function (millis) {
        return millis === value;
      });

      if (i > -1) {
        scheduledLookup.splice(i, 1);
      }
    }

    function reschedule(scheduledFn) {
      self.scheduleFunction(scheduledFn.funcToCall,
        scheduledFn.millis,
        scheduledFn.params,
        true,
        scheduledFn.timeoutKey,
        scheduledFn.runAtMillis + scheduledFn.millis);
    }

    function forEachFunction(funcsToRun, callback) {
      for (var i = 0; i < funcsToRun.length; ++i) {
        callback(funcsToRun[i]);
      }
    }

    function runScheduledFunctions(endTime, tickDate) {
      tickDate = tickDate || function() {};
      if (scheduledLookup.length === 0 || scheduledLookup[0] > endTime) {
        tickDate(endTime - currentTime);
        return;
      }

      do {
        deletedKeys = [];
        var newCurrentTime = scheduledLookup.shift();
        tickDate(newCurrentTime - currentTime);

        currentTime = newCurrentTime;

        var funcsToRun = scheduledFunctions[currentTime];

        delete scheduledFunctions[currentTime];

        forEachFunction(funcsToRun, function(funcToRun) {
          if (funcToRun.recurring) {
            reschedule(funcToRun);
          }
        });

        forEachFunction(funcsToRun, function(funcToRun) {
          if (j$.util.arrayContains(deletedKeys, funcToRun.timeoutKey)) {
            
            return;
          }
          funcToRun.funcToCall.apply(null, funcToRun.params || []);
        });
        deletedKeys = [];
      } while (scheduledLookup.length > 0 &&
              
              
                 currentTime !== endTime  &&
                 scheduledLookup[0] <= endTime);

      
      if (currentTime !== endTime) {
        tickDate(endTime - currentTime);
      }
    }
  }

  return DelayedFunctionScheduler;
};

getJasmineRequireObj().errors = function() {
  function ExpectationFailed() {}

  ExpectationFailed.prototype = new Error();
  ExpectationFailed.prototype.constructor = ExpectationFailed;

  return {
    ExpectationFailed: ExpectationFailed
  };
};
getJasmineRequireObj().ExceptionFormatter = function(j$) {

  function ExceptionFormatter(options) {
    var jasmineFile = (options && options.jasmineFile) || j$.util.jasmineFile();
    this.message = function(error) {
      var message = '';

      if (error.name && error.message) {
        message += error.name + ': ' + error.message;
      } else {
        message += error.toString() + ' thrown';
      }

      if (error.fileName || error.sourceURL) {
        message += ' in ' + (error.fileName || error.sourceURL);
      }

      if (error.line || error.lineNumber) {
        message += ' (line ' + (error.line || error.lineNumber) + ')';
      }

      return message;
    };

    this.stack = function(error) {
      if (!error || !error.stack) {
        return null;
      }

      var stackTrace = new j$.StackTrace(error.stack);
      var lines = filterJasmine(stackTrace);
      var result = '';

      if (stackTrace.message) {
        lines.unshift(stackTrace.message);
      }

      result += formatProperties(error);
      result += lines.join('\n');

      return result;
    };

    function filterJasmine(stackTrace) {
      var result = [],
        jasmineMarker = stackTrace.style === 'webkit' ? '<Jasmine>' : '    at <Jasmine>';

      stackTrace.frames.forEach(function(frame) {
        if (frame.file && frame.file !== jasmineFile) {
          result.push(frame.raw);
        } else if (result[result.length - 1] !== jasmineMarker) {
          result.push(jasmineMarker);
        }
      });

      return result;
    }

    function formatProperties(error) {
      if (!(error instanceof Object)) {
        return;
      }

      var ignored = ['name', 'message', 'stack', 'fileName', 'sourceURL', 'line', 'lineNumber', 'column', 'description'];
      var result = {};
      var empty = true;

      for (var prop in error) {
        if (j$.util.arrayContains(ignored, prop)) {
          continue;
        }
        result[prop] = error[prop];
        empty = false;
      }

      if (!empty) {
        return 'error properties: ' + j$.pp(result) + '\n';
      }

      return '';
    }
  }

  return ExceptionFormatter;
};

getJasmineRequireObj().Expectation = function() {

  
  function Expectation(options) {
    this.util = options.util || { buildFailureMessage: function() {} };
    this.customEqualityTesters = options.customEqualityTesters || [];
    this.actual = options.actual;
    this.addExpectationResult = options.addExpectationResult || function(){};
    this.isNot = options.isNot;

    var customMatchers = options.customMatchers || {};
    for (var matcherName in customMatchers) {
      this[matcherName] = Expectation.prototype.wrapCompare(matcherName, customMatchers[matcherName]);
    }
  }

  Expectation.prototype.wrapCompare = function(name, matcherFactory) {
    return function() {
      var args = Array.prototype.slice.call(arguments, 0),
        expected = args.slice(0),
        message = '';

      args.unshift(this.actual);

      var matcher = matcherFactory(this.util, this.customEqualityTesters),
          matcherCompare = matcher.compare;

      function defaultNegativeCompare() {
        var result = matcher.compare.apply(null, args);
        result.pass = !result.pass;
        return result;
      }

      if (this.isNot) {
        matcherCompare = matcher.negativeCompare || defaultNegativeCompare;
      }

      var result = matcherCompare.apply(null, args);

      if (!result.pass) {
        if (!result.message) {
          args.unshift(this.isNot);
          args.unshift(name);
          message = this.util.buildFailureMessage.apply(null, args);
        } else {
          if (Object.prototype.toString.apply(result.message) === '[object Function]') {
            message = result.message();
          } else {
            message = result.message;
          }
        }
      }

      if (expected.length == 1) {
        expected = expected[0];
      }

      
      this.addExpectationResult(
        result.pass,
        {
          matcherName: name,
          passed: result.pass,
          message: message,
          error: result.error,
          actual: this.actual,
          expected: expected 
        }
      );
    };
  };

  Expectation.addCoreMatchers = function(matchers) {
    var prototype = Expectation.prototype;
    for (var matcherName in matchers) {
      var matcher = matchers[matcherName];
      prototype[matcherName] = prototype.wrapCompare(matcherName, matcher);
    }
  };

  Expectation.Factory = function(options) {
    options = options || {};

    var expect = new Expectation(options);

    
    
    options.isNot = true;
    expect.not = new Expectation(options);

    return expect;
  };

  return Expectation;
};


getJasmineRequireObj().buildExpectationResult = function() {
  function buildExpectationResult(options) {
    var messageFormatter = options.messageFormatter || function() {},
      stackFormatter = options.stackFormatter || function() {};

    
    var result = {
      matcherName: options.matcherName,
      message: message(),
      stack: stack(),
      passed: options.passed
    };

    if(!result.passed) {
      result.expected = options.expected;
      result.actual = options.actual;
    }

    return result;

    function message() {
      if (options.passed) {
        return 'Passed.';
      } else if (options.message) {
        return options.message;
      } else if (options.error) {
        return messageFormatter(options.error);
      }
      return '';
    }

    function stack() {
      if (options.passed) {
        return '';
      }

      var error = options.error;
      if (!error) {
        if (options.stack) {
          error = options;
        } else {
          try {
            throw new Error(message());
          } catch (e) {
            error = e;
          }
        }
      }
      return stackFormatter(error);
    }
  }

  return buildExpectationResult;
};

getJasmineRequireObj().formatErrorMsg = function() {
  function generateErrorMsg(domain, usage) {
    var usageDefinition = usage ? '\nUsage: ' + usage : '';

    return function errorMsg(msg) {
      return domain + ' : ' + msg + usageDefinition;
    };
  }

  return generateErrorMsg;
};

getJasmineRequireObj().GlobalErrors = function(j$) {
  function GlobalErrors(global) {
    var handlers = [];
    global = global || j$.getGlobal();

    var onerror = function onerror() {
      var handler = handlers[handlers.length - 1];

      if (handler) {
        handler.apply(null, Array.prototype.slice.call(arguments, 0));
      } else {
        throw arguments[0];
      }
    };

    this.install = function install() {
      if (global.process && global.process.listeners && j$.isFunction_(global.process.on)) {
        var originalHandlers = global.process.listeners('uncaughtException');
        global.process.removeAllListeners('uncaughtException');
        global.process.on('uncaughtException', onerror);

        this.uninstall = function uninstall() {
          global.process.removeListener('uncaughtException', onerror);
          for (var i = 0; i < originalHandlers.length; i++) {
            global.process.on('uncaughtException', originalHandlers[i]);
          }
        };
      } else {
        var originalHandler = global.onerror;
        

        this.uninstall = function uninstall() {
          global.onerror = originalHandler;
        };
      }
    };

    this.pushListener = function pushListener(listener) {
      handlers.push(listener);
    };

    this.popListener = function popListener() {
      handlers.pop();
    };
  }

  return GlobalErrors;
};

getJasmineRequireObj().DiffBuilder = function(j$) {
  return function DiffBuilder() {
    var path = new j$.ObjectPath(),
        mismatches = [];

    return {
      record: function (actual, expected, formatter) {
        formatter = formatter || defaultFormatter;
        mismatches.push(formatter(actual, expected, path));
      },

      getMessage: function () {
        return mismatches.join('\n');
      },

      withPath: function (pathComponent, block) {
        var oldPath = path;
        path = path.add(pathComponent);
        block();
        path = oldPath;
      }
    };

    function defaultFormatter (actual, expected, path) {
      return 'Expected ' +
        path + (path.depth() ? ' = ' : '') +
        j$.pp(actual) +
        ' to equal ' +
        j$.pp(expected) +
        '.';
    }
  };
};

getJasmineRequireObj().matchersUtil = function(j$) {
  

  return {
    equals: equals,

    contains: function(haystack, needle, customTesters) {
      customTesters = customTesters || [];

      if ((Object.prototype.toString.apply(haystack) === '[object Set]')) {
        return haystack.has(needle);
      }

      if ((Object.prototype.toString.apply(haystack) === '[object Array]') ||
        (!!haystack && !haystack.indexOf))
      {
        for (var i = 0; i < haystack.length; i++) {
          if (equals(haystack[i], needle, customTesters)) {
            return true;
          }
        }
        return false;
      }

      return !!haystack && haystack.indexOf(needle) >= 0;
    },

    buildFailureMessage: function() {
      var args = Array.prototype.slice.call(arguments, 0),
        matcherName = args[0],
        isNot = args[1],
        actual = args[2],
        expected = args.slice(3),
        englishyPredicate = matcherName.replace(/[A-Z]/g, function(s) { return ' ' + s.toLowerCase(); });

      var message = 'Expected ' +
        j$.pp(actual) +
        (isNot ? ' not ' : ' ') +
        englishyPredicate;

      if (expected.length > 0) {
        for (var i = 0; i < expected.length; i++) {
          if (i > 0) {
            message += ',';
          }
          message += ' ' + j$.pp(expected[i]);
        }
      }

      return message + '.';
    }
  };

  function isAsymmetric(obj) {
    return obj && j$.isA_('Function', obj.asymmetricMatch);
  }

  function asymmetricMatch(a, b, customTesters, diffBuilder) {
    var asymmetricA = isAsymmetric(a),
        asymmetricB = isAsymmetric(b),
        result;

    if (asymmetricA && asymmetricB) {
      return undefined;
    }

    if (asymmetricA) {
      result = a.asymmetricMatch(b, customTesters);
      if (!result) {
        diffBuilder.record(a, b);
      }
      return result;
    }

    if (asymmetricB) {
      result = b.asymmetricMatch(a, customTesters);
      if (!result) {
        diffBuilder.record(a, b);
      }
      return result;
    }
  }

  function equals(a, b, customTesters, diffBuilder) {
    customTesters = customTesters || [];
    diffBuilder = diffBuilder || j$.NullDiffBuilder();

    return eq(a, b, [], [], customTesters, diffBuilder);
  }

  
  
  function eq(a, b, aStack, bStack, customTesters, diffBuilder) {
    var result = true, i;

    var asymmetricResult = asymmetricMatch(a, b, customTesters, diffBuilder);
    if (!j$.util.isUndefined(asymmetricResult)) {
      return asymmetricResult;
    }

    for (i = 0; i < customTesters.length; i++) {
      var customTesterResult = customTesters[i](a, b);
      if (!j$.util.isUndefined(customTesterResult)) {
        if (!customTesterResult) {
          diffBuilder.record(a, b);
        }
        return customTesterResult;
      }
    }

    if (a instanceof Error && b instanceof Error) {
      result = a.message == b.message;
      if (!result) {
        diffBuilder.record(a, b);
      }
      return result;
    }

    
    
    if (a === b) {
      result = a !== 0 || 1 / a == 1 / b;
      if (!result) {
        diffBuilder.record(a, b);
      }
      return result;
    }
    
    if (a === null || b === null) {
      result = a === b;
      if (!result) {
        diffBuilder.record(a, b);
      }
      return result;
    }
    var className = Object.prototype.toString.call(a);
    if (className != Object.prototype.toString.call(b)) {
      diffBuilder.record(a, b);
      return false;
    }
    switch (className) {
      
      case '[object String]':
        
        
        result = a == String(b);
        if (!result) {
          diffBuilder.record(a, b);
        }
        return result;
      case '[object Number]':
        
        
        result = a != +a ? b != +b : (a === 0 ? 1 / a == 1 / b : a == +b);
        if (!result) {
          diffBuilder.record(a, b);
        }
        return result;
      case '[object Date]':
      case '[object Boolean]':
        
        
        
        result = +a == +b;
        if (!result) {
          diffBuilder.record(a, b);
        }
        return result;
      
      case '[object RegExp]':
        return a.source == b.source &&
          a.global == b.global &&
          a.multiline == b.multiline &&
          a.ignoreCase == b.ignoreCase;
    }
    if (typeof a != 'object' || typeof b != 'object') {
      diffBuilder.record(a, b);
      return false;
    }

    var aIsDomNode = j$.isDomNode(a);
    var bIsDomNode = j$.isDomNode(b);
    if (aIsDomNode && bIsDomNode) {
      
      result = a.isEqualNode(b);
      if (!result) {
        diffBuilder.record(a, b);
      }
      return result;
    }
    if (aIsDomNode || bIsDomNode) {
      diffBuilder.record(a, b);
      return false;
    }

    var aIsPromise = j$.isPromise(a);
    var bIsPromise = j$.isPromise(b);
    if (aIsPromise && bIsPromise) {
      return a === b;
    }

    
    
    var length = aStack.length;
    while (length--) {
      
      
      if (aStack[length] == a) { return bStack[length] == b; }
    }
    
    aStack.push(a);
    bStack.push(b);
    var size = 0;
    
    
    if (className == '[object Array]') {
      var aLength = a.length;
      var bLength = b.length;

      diffBuilder.withPath('length', function() {
        if (aLength !== bLength) {
          diffBuilder.record(aLength, bLength);
          result = false;
        }
      });

      for (i = 0; i < aLength || i < bLength; i++) {
        diffBuilder.withPath(i, function() {
          result = eq(i < aLength ? a[i] : void 0, i < bLength ? b[i] : void 0, aStack, bStack, customTesters, diffBuilder) && result;
        });
      }
      if (!result) {
        return false;
      }
    } else if (j$.isMap(a) && j$.isMap(b)) {
      if (a.size != b.size) {
        diffBuilder.record(a, b);
        return false;
      }

      var keysA = [];
      var keysB = [];
      a.forEach( function( valueA, keyA ) {
        keysA.push( keyA );
      });
      b.forEach( function( valueB, keyB ) {
        keysB.push( keyB );
      });

      
      
      var mapKeys = [keysA, keysB];
      var cmpKeys = [keysB, keysA];
      var mapIter, mapKey, mapValueA, mapValueB;
      var cmpIter, cmpKey;
      for (i = 0; result && i < mapKeys.length; i++) {
        mapIter = mapKeys[i];
        cmpIter = cmpKeys[i];

        for (var j = 0; result && j < mapIter.length; j++) {
          mapKey = mapIter[j];
          cmpKey = cmpIter[j];
          mapValueA = a.get(mapKey);

          
          
          
          if (isAsymmetric(mapKey) || isAsymmetric(cmpKey) &&
              eq(mapKey, cmpKey, aStack, bStack, customTesters, j$.NullDiffBuilder())) {
            mapValueB = b.get(cmpKey);
          } else {
            mapValueB = b.get(mapKey);
          }
          result = eq(mapValueA, mapValueB, aStack, bStack, customTesters, j$.NullDiffBuilder());
        }
      }

      if (!result) {
        diffBuilder.record(a, b);
        return false;
      }
    } else if (j$.isSet(a) && j$.isSet(b)) {
      if (a.size != b.size) {
        diffBuilder.record(a, b);
        return false;
      }

      var valuesA = [];
      a.forEach( function( valueA ) {
        valuesA.push( valueA );
      });
      var valuesB = [];
      b.forEach( function( valueB ) {
        valuesB.push( valueB );
      });

      
      var setPairs = [[valuesA, valuesB], [valuesB, valuesA]];
      var stackPairs = [[aStack, bStack], [bStack, aStack]];
      var baseValues, baseValue, baseStack;
      var otherValues, otherValue, otherStack;
      var found;
      var prevStackSize;
      for (i = 0; result && i < setPairs.length; i++) {
        baseValues = setPairs[i][0];
        otherValues = setPairs[i][1];
        baseStack = stackPairs[i][0];
        otherStack = stackPairs[i][1];
        
        for (var k = 0; result && k < baseValues.length; k++) {
          baseValue = baseValues[k];
          found = false;
          
          for (var l = 0; !found && l < otherValues.length; l++) {
            otherValue = otherValues[l];
            prevStackSize = baseStack.length;
            
            found = eq(baseValue, otherValue, baseStack, otherStack, customTesters, j$.NullDiffBuilder());
            if (!found && prevStackSize !== baseStack.length) {
              baseStack.splice(prevStackSize);
              otherStack.splice(prevStackSize);
            }
          }
          result = result && found;
        }
      }

      if (!result) {
        diffBuilder.record(a, b);
        return false;
      }
    } else {

      
      
      var aCtor = a.constructor, bCtor = b.constructor;
      if (aCtor !== bCtor &&
          isFunction(aCtor) && isFunction(bCtor) &&
          a instanceof aCtor && b instanceof bCtor &&
          !(aCtor instanceof aCtor && bCtor instanceof bCtor)) {

        diffBuilder.record(a, b, constructorsAreDifferentFormatter);
        return false;
      }
    }

    
    var aKeys = keys(a, className == '[object Array]'), key;
    size = aKeys.length;

    
    if (keys(b, className == '[object Array]').length !== size) {
      diffBuilder.record(a, b, objectKeysAreDifferentFormatter);
      return false;
    }

    for (i = 0; i < size; i++) {
      key = aKeys[i];
      
      if (!j$.util.has(b, key)) {
        diffBuilder.record(a, b, objectKeysAreDifferentFormatter);
        result = false;
        continue;
      }

      diffBuilder.withPath(key, function() {
        if(!eq(a[key], b[key], aStack, bStack, customTesters, diffBuilder)) {
          result = false;
        }
      });
    }

    if (!result) {
      return false;
    }

    
    aStack.pop();
    bStack.pop();

    return result;
  }

  function keys(obj, isArray) {
    var allKeys = Object.keys ? Object.keys(obj) :
      (function(o) {
          var keys = [];
          for (var key in o) {
              if (j$.util.has(o, key)) {
                  keys.push(key);
              }
          }
          return keys;
      })(obj);

    if (!isArray) {
      return allKeys;
    }

    if (allKeys.length === 0) {
        return allKeys;
    }

    var extraKeys = [];
    for (var i = 0; i < allKeys.length; i++) {
      if (!/^[0-9]+$/.test(allKeys[i])) {
        extraKeys.push(allKeys[i]);
      }
    }

    return extraKeys;
  }

  function has(obj, key) {
    return Object.prototype.hasOwnProperty.call(obj, key);
  }

  function isFunction(obj) {
    return typeof obj === 'function';
  }

  function objectKeysAreDifferentFormatter(actual, expected, path) {
    var missingProperties = j$.util.objectDifference(expected, actual),
        extraProperties = j$.util.objectDifference(actual, expected),
        missingPropertiesMessage = formatKeyValuePairs(missingProperties),
        extraPropertiesMessage = formatKeyValuePairs(extraProperties),
        messages = [];

    if (!path.depth()) {
      path = 'object';
    }

    if (missingPropertiesMessage.length) {
      messages.push('Expected ' + path + ' to have properties' + missingPropertiesMessage);
    }

    if (extraPropertiesMessage.length) {
      messages.push('Expected ' + path + ' not to have properties' + extraPropertiesMessage);
    }

    return messages.join('\n');
  }

  function constructorsAreDifferentFormatter(actual, expected, path) {
    if (!path.depth()) {
      path = 'object';
    }

    return 'Expected ' +
      path + ' to be a kind of ' +
      j$.fnNameFor(expected.constructor) +
      ', but was ' + j$.pp(actual) + '.';
  }

  function formatKeyValuePairs(obj) {
    var formatted = '';
    for (var key in obj) {
      formatted += '\n    ' + key + ': ' + j$.pp(obj[key]);
    }
    return formatted;
  }
};

getJasmineRequireObj().nothing = function() {
  
  function nothing() {
    return {
      compare: function() {
        return {
          pass: true
        };
      }
    };
  }

  return nothing;
};

getJasmineRequireObj().NullDiffBuilder = function(j$) {
  return function() {
    return {
      withPath: function(_, block) {
        block();
      },
      record: function() {}
    };
  };
};

getJasmineRequireObj().ObjectPath = function(j$) {
  function ObjectPath(components) {
    this.components = components || [];
  }

  ObjectPath.prototype.toString = function() {
    if (this.components.length) {
      return '$' + map(this.components, formatPropertyAccess).join('');
    } else {
      return '';
    }
  };

  ObjectPath.prototype.add = function(component) {
    return new ObjectPath(this.components.concat([component]));
  };

  ObjectPath.prototype.depth = function() {
    return this.components.length;
  };

  function formatPropertyAccess(prop) {
    if (typeof prop === 'number') {
      return '[' + prop + ']';
    }

    if (isValidIdentifier(prop)) {
      return '.' + prop;
    }

    return '[\'' + prop + '\']';
  }

  function map(array, fn) {
    var results = [];
    for (var i = 0; i < array.length; i++) {
      results.push(fn(array[i]));
    }
    return results;
  }

  function isValidIdentifier(string) {
    return /^[A-Za-z\$_][A-Za-z0-9\$_]*$/.test(string);
  }

  return ObjectPath;
};

getJasmineRequireObj().toBe = function() {
  
  function toBe() {
    return {
      compare: function(actual, expected) {
        return {
          pass: actual === expected
        };
      }
    };
  }

  return toBe;
};

getJasmineRequireObj().toBeCloseTo = function() {
  
  function toBeCloseTo() {
    return {
      compare: function(actual, expected, precision) {
        if (precision !== 0) {
          precision = precision || 2;
        }

        if (expected === null || actual === null) {
          throw new Error('Cannot use toBeCloseTo with null. Arguments evaluated to: ' +
            'expect(' + actual + ').toBeCloseTo(' + expected + ').'
          );
        }

        var pow = Math.pow(10, precision + 1);
        var delta = Math.abs(expected - actual);
        var maxDelta = Math.pow(10, -precision) / 2;

        return {
          pass: Math.round(delta * pow) / pow <= maxDelta
        };
      }
    };
  }

  return toBeCloseTo;
};

getJasmineRequireObj().toBeDefined = function() {
  
  function toBeDefined() {
    return {
      compare: function(actual) {
        return {
          pass: (void 0 !== actual)
        };
      }
    };
  }

  return toBeDefined;
};

getJasmineRequireObj().toBeFalsy = function() {
  
  function toBeFalsy() {
    return {
      compare: function(actual) {
        return {
          pass: !!!actual
        };
      }
    };
  }

  return toBeFalsy;
};

getJasmineRequireObj().toBeGreaterThan = function() {
  
  function toBeGreaterThan() {
    return {
      compare: function(actual, expected) {
        return {
          pass: actual > expected
        };
      }
    };
  }

  return toBeGreaterThan;
};


getJasmineRequireObj().toBeGreaterThanOrEqual = function() {
  
  function toBeGreaterThanOrEqual() {
    return {
      compare: function(actual, expected) {
        return {
          pass: actual >= expected
        };
      }
    };
  }

  return toBeGreaterThanOrEqual;
};

getJasmineRequireObj().toBeLessThan = function() {
  
  function toBeLessThan() {
    return {

      compare: function(actual, expected) {
        return {
          pass: actual < expected
        };
      }
    };
  }

  return toBeLessThan;
};

getJasmineRequireObj().toBeLessThanOrEqual = function() {
  
  function toBeLessThanOrEqual() {
    return {

      compare: function(actual, expected) {
        return {
          pass: actual <= expected
        };
      }
    };
  }

  return toBeLessThanOrEqual;
};

getJasmineRequireObj().toBeNaN = function(j$) {
  
  function toBeNaN() {
    return {
      compare: function(actual) {
        var result = {
          pass: (actual !== actual)
        };

        if (result.pass) {
          result.message = 'Expected actual not to be NaN.';
        } else {
          result.message = function() { return 'Expected ' + j$.pp(actual) + ' to be NaN.'; };
        }

        return result;
      }
    };
  }

  return toBeNaN;
};

getJasmineRequireObj().toBeNegativeInfinity = function(j$) {
  
  function toBeNegativeInfinity() {
    return {
      compare: function(actual) {
        var result = {
          pass: (actual === Number.NEGATIVE_INFINITY)
        };

        if (result.pass) {
          result.message = 'Expected actual to be -Infinity.';
        } else {
          result.message = function() { return 'Expected ' + j$.pp(actual) + ' not to be -Infinity.'; };
        }

        return result;
      }
    };
  }

  return toBeNegativeInfinity;
};

getJasmineRequireObj().toBeNull = function() {
  
  function toBeNull() {
    return {
      compare: function(actual) {
        return {
          pass: actual === null
        };
      }
    };
  }

  return toBeNull;
};

getJasmineRequireObj().toBePositiveInfinity = function(j$) {
  
  function toBePositiveInfinity() {
    return {
      compare: function(actual) {
        var result = {
          pass: (actual === Number.POSITIVE_INFINITY)
        };

        if (result.pass) {
          result.message = 'Expected actual to be Infinity.';
        } else {
          result.message = function() { return 'Expected ' + j$.pp(actual) + ' not to be Infinity.'; };
        }

        return result;
      }
    };
  }

  return toBePositiveInfinity;
};

getJasmineRequireObj().toBeTruthy = function() {
  
  function toBeTruthy() {
    return {
      compare: function(actual) {
        return {
          pass: !!actual
        };
      }
    };
  }

  return toBeTruthy;
};

getJasmineRequireObj().toBeUndefined = function() {
  
  function toBeUndefined() {
    return {
      compare: function(actual) {
        return {
          pass: void 0 === actual
        };
      }
    };
  }

  return toBeUndefined;
};

getJasmineRequireObj().toContain = function() {
  
  function toContain(util, customEqualityTesters) {
    customEqualityTesters = customEqualityTesters || [];

    return {
      compare: function(actual, expected) {

        return {
          pass: util.contains(actual, expected, customEqualityTesters)
        };
      }
    };
  }

  return toContain;
};

getJasmineRequireObj().toEqual = function(j$) {
  
  function toEqual(util, customEqualityTesters) {
    customEqualityTesters = customEqualityTesters || [];

    return {
      compare: function(actual, expected) {
        var result = {
            pass: false
          },
          diffBuilder = j$.DiffBuilder();

        result.pass = util.equals(actual, expected, customEqualityTesters, diffBuilder);

        
        result.message = diffBuilder.getMessage();

        return result;
      }
    };
  }

  return toEqual;
};

getJasmineRequireObj().toHaveBeenCalled = function(j$) {

  var getErrorMsg = j$.formatErrorMsg('<toHaveBeenCalled>', 'expect(<spyObj>).toHaveBeenCalled()');

  
  function toHaveBeenCalled() {
    return {
      compare: function(actual) {
        var result = {};

        if (!j$.isSpy(actual)) {
          throw new Error(getErrorMsg('Expected a spy, but got ' + j$.pp(actual) + '.'));
        }

        if (arguments.length > 1) {
          throw new Error(getErrorMsg('Does not take arguments, use toHaveBeenCalledWith'));
        }

        result.pass = actual.calls.any();

        result.message = result.pass ?
          'Expected spy ' + actual.and.identity + ' not to have been called.' :
          'Expected spy ' + actual.and.identity + ' to have been called.';

        return result;
      }
    };
  }

  return toHaveBeenCalled;
};

getJasmineRequireObj().toHaveBeenCalledBefore = function(j$) {

  var getErrorMsg = j$.formatErrorMsg('<toHaveBeenCalledBefore>', 'expect(<spyObj>).toHaveBeenCalledBefore(<spyObj>)');

  
  function toHaveBeenCalledBefore() {
    return {
      compare: function(firstSpy, latterSpy) {
        if (!j$.isSpy(firstSpy)) {
          throw new Error(getErrorMsg('Expected a spy, but got ' + j$.pp(firstSpy) + '.'));
        }
        if (!j$.isSpy(latterSpy)) {
          throw new Error(getErrorMsg('Expected a spy, but got ' + j$.pp(latterSpy) + '.'));
        }

        var result = { pass: false };

        if (!firstSpy.calls.count()) {
          result.message = 'Expected spy ' +  firstSpy.and.identity + ' to have been called.';
          return result;
        }
        if (!latterSpy.calls.count()) {
          result.message = 'Expected spy ' +  latterSpy.and.identity + ' to have been called.';
          return result;
        }

        var latest1stSpyCall = firstSpy.calls.mostRecent().invocationOrder;
        var first2ndSpyCall = latterSpy.calls.first().invocationOrder;

        result.pass = latest1stSpyCall < first2ndSpyCall;

        if (result.pass) {
          result.message = 'Expected spy ' + firstSpy.and.identity + ' to not have been called before spy ' + latterSpy.and.identity + ', but it was';
        } else {
          var first1stSpyCall = firstSpy.calls.first().invocationOrder;
          var latest2ndSpyCall = latterSpy.calls.mostRecent().invocationOrder;

          if(first1stSpyCall < first2ndSpyCall) {
            result.message = 'Expected latest call to spy ' + firstSpy.and.identity + ' to have been called before first call to spy ' + latterSpy.and.identity + ' (no interleaved calls)';
          } else if (latest2ndSpyCall > latest1stSpyCall) {
            result.message = 'Expected first call to spy ' + latterSpy.and.identity + ' to have been called after latest call to spy ' + firstSpy.and.identity + ' (no interleaved calls)';
          } else {
            result.message = 'Expected spy ' + firstSpy.and.identity + ' to have been called before spy ' + latterSpy.and.identity;
          }
        }

        return result;
      }
    };
  }

  return toHaveBeenCalledBefore;
};

getJasmineRequireObj().toHaveBeenCalledTimes = function(j$) {

  var getErrorMsg = j$.formatErrorMsg('<toHaveBeenCalledTimes>', 'expect(<spyObj>).toHaveBeenCalledTimes(<Number>)');

  
  function toHaveBeenCalledTimes() {
    return {
      compare: function(actual, expected) {
        if (!j$.isSpy(actual)) {
          throw new Error(getErrorMsg('Expected a spy, but got ' + j$.pp(actual) + '.'));
        }

        var args = Array.prototype.slice.call(arguments, 0),
          result = { pass: false };

        if (!j$.isNumber_(expected)){
          throw new Error(getErrorMsg('The expected times failed is a required argument and must be a number.'));
        }

        actual = args[0];
        var calls = actual.calls.count();
        var timesMessage = expected === 1 ? 'once' : expected + ' times';
        result.pass = calls === expected;
        result.message = result.pass ?
          'Expected spy ' + actual.and.identity + ' not to have been called ' + timesMessage + '. It was called ' +  calls + ' times.' :
          'Expected spy ' + actual.and.identity + ' to have been called ' + timesMessage + '. It was called ' +  calls + ' times.';
        return result;
      }
    };
  }

  return toHaveBeenCalledTimes;
};

getJasmineRequireObj().toHaveBeenCalledWith = function(j$) {

  var getErrorMsg = j$.formatErrorMsg('<toHaveBeenCalledWith>', 'expect(<spyObj>).toHaveBeenCalledWith(...arguments)');

  
  function toHaveBeenCalledWith(util, customEqualityTesters) {
    return {
      compare: function() {
        var args = Array.prototype.slice.call(arguments, 0),
          actual = args[0],
          expectedArgs = args.slice(1),
          result = { pass: false };

        if (!j$.isSpy(actual)) {
          throw new Error(getErrorMsg('Expected a spy, but got ' + j$.pp(actual) + '.'));
        }

        if (!actual.calls.any()) {
          result.message = function() { return 'Expected spy ' + actual.and.identity + ' to have been called with ' + j$.pp(expectedArgs) + ' but it was never called.'; };
          return result;
        }

        if (util.contains(actual.calls.allArgs(), expectedArgs, customEqualityTesters)) {
          result.pass = true;
          result.message = function() { return 'Expected spy ' + actual.and.identity + ' not to have been called with ' + j$.pp(expectedArgs) + ' but it was.'; };
        } else {
          result.message = function() { return 'Expected spy ' + actual.and.identity + ' to have been called with ' + j$.pp(expectedArgs) + ' but actual calls were ' + j$.pp(actual.calls.allArgs()).replace(/^\[ | \]$/g, '') + '.'; };
        }

        return result;
      }
    };
  }

  return toHaveBeenCalledWith;
};

getJasmineRequireObj().toHaveClass = function(j$) {
  
  function toHaveClass(util, customEqualityTesters) {
    return {
      compare: function(actual, expected) {
        if (!isElement(actual)) {
          throw new Error(j$.pp(actual) + ' is not a DOM element');
        }

        return {
          pass: actual.classList.contains(expected)
        };
      }
    };
  }

  function isElement(maybeEl) {
    return maybeEl &&
      maybeEl.classList &&
      j$.isFunction_(maybeEl.classList.contains);
  }

  return toHaveClass;
};

getJasmineRequireObj().toMatch = function(j$) {

  var getErrorMsg = j$.formatErrorMsg('<toMatch>', 'expect(<expectation>).toMatch(<string> || <regexp>)');

  
  function toMatch() {
    return {
      compare: function(actual, expected) {
        if (!j$.isString_(expected) && !j$.isA_('RegExp', expected)) {
          throw new Error(getErrorMsg('Expected is not a String or a RegExp'));
        }

        var regexp = new RegExp(expected);

        return {
          pass: regexp.test(actual)
        };
      }
    };
  }

  return toMatch;
};

getJasmineRequireObj().toThrow = function(j$) {

  var getErrorMsg = j$.formatErrorMsg('<toThrow>', 'expect(function() {<expectation>}).toThrow()');

  
  function toThrow(util) {
    return {
      compare: function(actual, expected) {
        var result = { pass: false },
          threw = false,
          thrown;

        if (typeof actual != 'function') {
          throw new Error(getErrorMsg('Actual is not a Function'));
        }

        try {
          actual();
        } catch (e) {
          threw = true;
          thrown = e;
        }

        if (!threw) {
          result.message = 'Expected function to throw an exception.';
          return result;
        }

        if (arguments.length == 1) {
          result.pass = true;
          result.message = function() { return 'Expected function not to throw, but it threw ' + j$.pp(thrown) + '.'; };

          return result;
        }

        if (util.equals(thrown, expected)) {
          result.pass = true;
          result.message = function() { return 'Expected function not to throw ' + j$.pp(expected) + '.'; };
        } else {
          result.message = function() { return 'Expected function to throw ' + j$.pp(expected) + ', but it threw ' +  j$.pp(thrown) + '.'; };
        }

        return result;
      }
    };
  }

  return toThrow;
};

getJasmineRequireObj().toThrowError = function(j$) {

  var getErrorMsg =  j$.formatErrorMsg('<toThrowError>', 'expect(function() {<expectation>}).toThrowError(<ErrorConstructor>, <message>)');

  
  function toThrowError () {
    return {
      compare: function(actual) {
        var errorMatcher = getMatcher.apply(null, arguments),
          thrown;

        if (typeof actual != 'function') {
          throw new Error(getErrorMsg('Actual is not a Function'));
        }

        try {
          actual();
          return fail('Expected function to throw an Error.');
        } catch (e) {
          thrown = e;
        }

        if (!j$.isError_(thrown)) {
          return fail(function() { return 'Expected function to throw an Error, but it threw ' + j$.pp(thrown) + '.'; });
        }

        return errorMatcher.match(thrown);
      }
    };

    function getMatcher() {
      var expected, errorType;

      if (arguments[2]) {
        errorType = arguments[1];
        expected = arguments[2];
        if (!isAnErrorType(errorType)) {
          throw new Error(getErrorMsg('Expected error type is not an Error.'));
        }

        return exactMatcher(expected, errorType);
      } else if (arguments[1]) {
        expected = arguments[1];

        if (isAnErrorType(arguments[1])) {
          return exactMatcher(null, arguments[1]);
        } else {
          return exactMatcher(arguments[1], null);
        }
      } else {
        return anyMatcher();
      }
    }

    function anyMatcher() {
      return {
        match: function(error) {
          return pass('Expected function not to throw an Error, but it threw ' + j$.fnNameFor(error) + '.');
        }
      };
    }

    function exactMatcher(expected, errorType) {
      if (expected && !isStringOrRegExp(expected)) {
        if (errorType) {
          throw new Error(getErrorMsg('Expected error message is not a string or RegExp.'));
        } else {
          throw new Error(getErrorMsg('Expected is not an Error, string, or RegExp.'));
        }
      }

      function messageMatch(message) {
        if (typeof expected == 'string') {
          return expected == message;
        } else {
          return expected.test(message);
        }
      }

      var errorTypeDescription = errorType ? j$.fnNameFor(errorType) : 'an exception';

      function thrownDescription(thrown) {
        var thrownName = errorType ? j$.fnNameFor(thrown.constructor) : 'an exception',
            thrownMessage = '';

        if (expected) {
          thrownMessage = ' with message ' + j$.pp(thrown.message);
        }

        return thrownName + thrownMessage;
      }

      function messageDescription() {
        if (expected === null) {
          return '';
        } else if (expected instanceof RegExp) {
          return ' with a message matching ' + j$.pp(expected);
        } else {
          return ' with message ' + j$.pp(expected);
        }
      }

      function matches(error) {
        return (errorType === null || error instanceof errorType) &&
          (expected === null || messageMatch(error.message));
      }

      return {
        match: function(thrown) {
          if (matches(thrown)) {
            return pass(function() {
              return 'Expected function not to throw ' + errorTypeDescription + messageDescription() + '.';
            });
          } else {
            return fail(function() {
              return 'Expected function to throw ' + errorTypeDescription + messageDescription() +
                ', but it threw ' + thrownDescription(thrown) + '.';
            });
          }
        }
      };
    }

    function isStringOrRegExp(potential) {
      return potential instanceof RegExp || (typeof potential == 'string');
    }

    function isAnErrorType(type) {
      if (typeof type !== 'function') {
        return false;
      }

      var Surrogate = function() {};
      Surrogate.prototype = type.prototype;
      return j$.isError_(new Surrogate());
    }
  }

  function pass(message) {
    return {
      pass: true,
      message: message
    };
  }

  function fail(message) {
    return {
      pass: false,
      message: message
    };
  }

  return toThrowError;
};

getJasmineRequireObj().toThrowMatching = function(j$) {
  var usageError =  j$.formatErrorMsg('<toThrowMatching>', 'expect(function() {<expectation>}).toThrowMatching(<Predicate>)');

  
  function toThrowMatching() {
    return {
      compare: function(actual, predicate) {
        var thrown;

        if (typeof actual !== 'function') {
          throw new Error(usageError('Actual is not a Function'));
        }

        if (typeof predicate !== 'function') {
          throw new Error(usageError('Predicate is not a Function'));
        }

        try {
          actual();
          return fail('Expected function to throw an exception.');
        } catch (e) {
          thrown = e;
        }

        if (predicate(thrown)) {
          return pass('Expected function not to throw an exception matching a predicate.');
        } else {
            return fail(function() {
              return 'Expected function to throw an exception matching a predicate, ' +
                'but it threw ' + thrownDescription(thrown) + '.';
            });
        }
      }
    };
  }

  function thrownDescription(thrown) {
    if (thrown && thrown.constructor) {
      return j$.fnNameFor(thrown.constructor) + ' with message ' +
        j$.pp(thrown.message);
    } else {
      return j$.pp(thrown);
    }
  }

  function pass(message) {
    return {
      pass: true,
      message: message
    };
  }

  function fail(message) {
    return {
      pass: false,
      message: message
    };
  }

  return toThrowMatching;
};

getJasmineRequireObj().MockDate = function() {
  function MockDate(global) {
    var self = this;
    var currentTime = 0;

    if (!global || !global.Date) {
      self.install = function() {};
      self.tick = function() {};
      self.uninstall = function() {};
      return self;
    }

    var GlobalDate = global.Date;

    self.install = function(mockDate) {
      if (mockDate instanceof GlobalDate) {
        currentTime = mockDate.getTime();
      } else {
        currentTime = new GlobalDate().getTime();
      }

      global.Date = FakeDate;
    };

    self.tick = function(millis) {
      millis = millis || 0;
      currentTime = currentTime + millis;
    };

    self.uninstall = function() {
      currentTime = 0;
      global.Date = GlobalDate;
    };

    createDateProperties();

    return self;

    function FakeDate() {
      switch(arguments.length) {
        case 0:
          return new GlobalDate(currentTime);
        case 1:
          return new GlobalDate(arguments[0]);
        case 2:
          return new GlobalDate(arguments[0], arguments[1]);
        case 3:
          return new GlobalDate(arguments[0], arguments[1], arguments[2]);
        case 4:
          return new GlobalDate(arguments[0], arguments[1], arguments[2], arguments[3]);
        case 5:
          return new GlobalDate(arguments[0], arguments[1], arguments[2], arguments[3],
                                arguments[4]);
        case 6:
          return new GlobalDate(arguments[0], arguments[1], arguments[2], arguments[3],
                                arguments[4], arguments[5]);
        default:
          return new GlobalDate(arguments[0], arguments[1], arguments[2], arguments[3],
                                arguments[4], arguments[5], arguments[6]);
      }
    }

    function createDateProperties() {
      FakeDate.prototype = GlobalDate.prototype;

      FakeDate.now = function() {
        if (GlobalDate.now) {
          return currentTime;
        } else {
          throw new Error('Browser does not support Date.now()');
        }
      };

      FakeDate.toSource = GlobalDate.toSource;
      FakeDate.toString = GlobalDate.toString;
      FakeDate.parse = GlobalDate.parse;
      FakeDate.UTC = GlobalDate.UTC;
    }
  }

  return MockDate;
};

getJasmineRequireObj().pp = function(j$) {

  function PrettyPrinter() {
    this.ppNestLevel_ = 0;
    this.seen = [];
    this.length = 0;
    this.stringParts = [];
  }

  function hasCustomToString(value) {
    
    
    return j$.isFunction_(value.toString) && value.toString !== Object.prototype.toString && (value.toString() !== Object.prototype.toString.call(value));
  }

  PrettyPrinter.prototype.format = function(value) {
    this.ppNestLevel_++;
    try {
      if (j$.util.isUndefined(value)) {
        this.emitScalar('undefined');
      } else if (value === null) {
        this.emitScalar('null');
      } else if (value === 0 && 1/value === -Infinity) {
        this.emitScalar('-0');
      } else if (value === j$.getGlobal()) {
        this.emitScalar('<global>');
      } else if (value.jasmineToString) {
        this.emitScalar(value.jasmineToString());
      } else if (typeof value === 'string') {
        this.emitString(value);
      } else if (j$.isSpy(value)) {
        this.emitScalar('spy on ' + value.and.identity);
      } else if (value instanceof RegExp) {
        this.emitScalar(value.toString());
      } else if (typeof value === 'function') {
        this.emitScalar('Function');
      } else if (value.nodeType === 1) {
        this.emitDomElement(value);
      } else if (typeof value.nodeType === 'number') {
        this.emitScalar('HTMLNode');
      } else if (value instanceof Date) {
        this.emitScalar('Date(' + value + ')');
      } else if (j$.isSet(value)) {
        this.emitSet(value);
      } else if (j$.isMap(value)) {
        this.emitMap(value);
      } else if (j$.isTypedArray_(value)) {
        this.emitTypedArray(value);
      } else if (value.toString && typeof value === 'object' && !j$.isArray_(value) && hasCustomToString(value)) {
        this.emitScalar(value.toString());
      } else if (j$.util.arrayContains(this.seen, value)) {
        this.emitScalar('<circular reference: ' + (j$.isArray_(value) ? 'Array' : 'Object') + '>');
      } else if (j$.isArray_(value) || j$.isA_('Object', value)) {
        this.seen.push(value);
        if (j$.isArray_(value)) {
          this.emitArray(value);
        } else {
          this.emitObject(value);
        }
        this.seen.pop();
      } else {
        this.emitScalar(value.toString());
      }
    } catch (e) {
      if (this.ppNestLevel_ > 1 || !(e instanceof MaxCharsReachedError)) {
        throw e;
      }
    } finally {
      this.ppNestLevel_--;
    }
  };

  PrettyPrinter.prototype.iterateObject = function(obj, fn) {
    var objKeys = keys(obj, j$.isArray_(obj));
    var isGetter = function isGetter(prop) {};

    if (obj.__lookupGetter__) {
      isGetter = function isGetter(prop) {
        var getter = obj.__lookupGetter__(prop);
        return !j$.util.isUndefined(getter) && getter !== null;
      };

    }
    var length = Math.min(objKeys.length, j$.MAX_PRETTY_PRINT_ARRAY_LENGTH);
    for (var i = 0; i < length; i++) {
      var property = objKeys[i];
      fn(property, isGetter(property));
    }

    return objKeys.length > length;
  };

  PrettyPrinter.prototype.emitScalar = function(value) {
    this.append(value);
  };

  PrettyPrinter.prototype.emitString = function(value) {
    this.append('\'' + value + '\'');
  };

  PrettyPrinter.prototype.emitArray = function(array) {
    if (this.ppNestLevel_ > j$.MAX_PRETTY_PRINT_DEPTH) {
      this.append('Array');
      return;
    }
    var length = Math.min(array.length, j$.MAX_PRETTY_PRINT_ARRAY_LENGTH);
    this.append('[ ');
    for (var i = 0; i < length; i++) {
      if (i > 0) {
        this.append(', ');
      }
      this.format(array[i]);
    }
    if(array.length > length){
      this.append(', ...');
    }

    var self = this;
    var first = array.length === 0;
    var truncated = this.iterateObject(array, function(property, isGetter) {
      if (first) {
        first = false;
      } else {
        self.append(', ');
      }

      self.formatProperty(array, property, isGetter);
    });

    if (truncated) { this.append(', ...'); }

    this.append(' ]');
  };

  PrettyPrinter.prototype.emitSet = function(set) {
    if (this.ppNestLevel_ > j$.MAX_PRETTY_PRINT_DEPTH) {
      this.append('Set');
      return;
    }
    this.append('Set( ');
    var size = Math.min(set.size, j$.MAX_PRETTY_PRINT_ARRAY_LENGTH);
    var i = 0;
    set.forEach( function( value, key ) {
      if (i >= size) {
        return;
      }
      if (i > 0) {
        this.append(', ');
      }
      this.format(value);

      i++;
    }, this );
    if (set.size > size){
      this.append(', ...');
    }
    this.append(' )');
  };

  PrettyPrinter.prototype.emitMap = function(map) {
    if (this.ppNestLevel_ > j$.MAX_PRETTY_PRINT_DEPTH) {
      this.append('Map');
      return;
    }
    this.append('Map( ');
    var size = Math.min(map.size, j$.MAX_PRETTY_PRINT_ARRAY_LENGTH);
    var i = 0;
    map.forEach( function( value, key ) {
      if (i >= size) {
        return;
      }
      if (i > 0) {
        this.append(', ');
      }
      this.format([key,value]);

      i++;
    }, this );
    if (map.size > size){
      this.append(', ...');
    }
    this.append(' )');
  };

  PrettyPrinter.prototype.emitObject = function(obj) {
    var ctor = obj.constructor,
        constructorName;

    constructorName = typeof ctor === 'function' && obj instanceof ctor ?
      j$.fnNameFor(obj.constructor) :
      'null';

    this.append(constructorName);

    if (this.ppNestLevel_ > j$.MAX_PRETTY_PRINT_DEPTH) {
      return;
    }

    var self = this;
    this.append('({ ');
    var first = true;

    var truncated = this.iterateObject(obj, function(property, isGetter) {
      if (first) {
        first = false;
      } else {
        self.append(', ');
      }

      self.formatProperty(obj, property, isGetter);
    });

    if (truncated) { this.append(', ...'); }

    this.append(' })');
  };

  PrettyPrinter.prototype.emitTypedArray = function(arr) {
    var constructorName = j$.fnNameFor(arr.constructor),
      limitedArray = Array.prototype.slice.call(arr, 0, j$.MAX_PRETTY_PRINT_ARRAY_LENGTH),
      itemsString = Array.prototype.join.call(limitedArray, ', ');

    if (limitedArray.length !== arr.length) {
      itemsString += ', ...';
    }

    this.append(constructorName + ' [ ' + itemsString + ' ]');
  };

  PrettyPrinter.prototype.emitDomElement = function(el) {
    var closingTag = '</' + el.tagName.toLowerCase() + '>';

    if (el.innerHTML === '') {
      this.append(el.outerHTML.replace(closingTag, ''));
    } else {
      var tagEnd = el.outerHTML.indexOf(el.innerHTML);
      this.append(el.outerHTML.substring(0, tagEnd));
      this.append('...' + closingTag);
    }
  };

  PrettyPrinter.prototype.formatProperty = function(obj, property, isGetter) {
      this.append(property);
      this.append(': ');
      if (isGetter) {
        this.append('<getter>');
      } else {
        this.format(obj[property]);
      }
  };

  PrettyPrinter.prototype.append = function(value) {
    var result = truncate(value, j$.MAX_PRETTY_PRINT_CHARS - this.length);
    this.length += result.value.length;
    this.stringParts.push(result.value);

    if (result.truncated) {
      throw new MaxCharsReachedError();
    }
  };


  function truncate(s, maxlen) {
    if (s.length <= maxlen) {
      return { value: s, truncated: false };
    }

    s = s.substring(0, maxlen - 4) + ' ...';
    return { value: s, truncated: true };
  }

  function MaxCharsReachedError() {
    this.message = 'Exceeded ' + j$.MAX_PRETTY_PRINT_CHARS +
      ' characters while pretty-printing a value';
  }

  MaxCharsReachedError.prototype = new Error();

  function keys(obj, isArray) {
    var allKeys = Object.keys ? Object.keys(obj) :
      (function(o) {
          var keys = [];
          for (var key in o) {
              if (j$.util.has(o, key)) {
                  keys.push(key);
              }
          }
          return keys;
      })(obj);

    if (!isArray) {
      return allKeys;
    }

    if (allKeys.length === 0) {
        return allKeys;
    }

    var extraKeys = [];
    for (var i = 0; i < allKeys.length; i++) {
      if (!/^[0-9]+$/.test(allKeys[i])) {
        extraKeys.push(allKeys[i]);
      }
    }

    return extraKeys;
  }
  return function(value) {
    var prettyPrinter = new PrettyPrinter();
    prettyPrinter.format(value);
    return prettyPrinter.stringParts.join('');
  };
};

getJasmineRequireObj().QueueRunner = function(j$) {
  function StopExecutionError() {}
  StopExecutionError.prototype = new Error();
  j$.StopExecutionError = StopExecutionError;

  function once(fn) {
    var called = false;
    return function() {
      if (!called) {
        called = true;
        fn.apply(null, arguments);
      }
      return null;
    };
  }

  function QueueRunner(attrs) {
    var queueableFns = attrs.queueableFns || [];
    this.queueableFns = queueableFns.concat(attrs.cleanupFns || []);
    this.firstCleanupIx = queueableFns.length;
    this.onComplete = attrs.onComplete || function() {};
    this.clearStack = attrs.clearStack || function(fn) {fn();};
    this.onException = attrs.onException || function() {};
    this.userContext = attrs.userContext || new j$.UserContext();
    this.timeout = attrs.timeout || {setTimeout: setTimeout, clearTimeout: clearTimeout};
    this.fail = attrs.fail || function() {};
    this.globalErrors = attrs.globalErrors || { pushListener: function() {}, popListener: function() {} };
    this.completeOnFirstError = !!attrs.completeOnFirstError;
    this.errored = false;

    window.jasmineOnError = this.onException;
    if (typeof(this.onComplete) !== 'function') {
      throw new Error('invalid onComplete ' + JSON.stringify(this.onComplete));
    }
    this.deprecated = attrs.deprecated;
  }

  QueueRunner.prototype.execute = function() {
    var self = this;
    this.handleFinalError = function(error) {
      self.onException(error);
    };
    this.globalErrors.pushListener(this.handleFinalError);
    this.run(0);
  };

  QueueRunner.prototype.skipToCleanup = function(lastRanIndex) {
    if (lastRanIndex < this.firstCleanupIx) {
      this.run(this.firstCleanupIx);
    } else {
      this.run(lastRanIndex + 1);
    }
  };

  QueueRunner.prototype.clearTimeout = function(timeoutId) {
    Function.prototype.apply.apply(this.timeout.clearTimeout, [j$.getGlobal(), [timeoutId]]);
  };

  QueueRunner.prototype.setTimeout = function(fn, timeout) {
    return Function.prototype.apply.apply(this.timeout.setTimeout, [j$.getGlobal(), [fn, timeout]]);
  };

  QueueRunner.prototype.attempt = function attempt(iterativeIndex) {
    var self = this, completedSynchronously = true,
      handleError = function handleError(error) {
        onException(error);
        next(error);
      },
      cleanup = once(function cleanup() {
        self.clearTimeout(timeoutId);
        self.globalErrors.popListener(handleError);
      }),
      next = once(function next(err) {
        cleanup();

        if (j$.isError_(err)) {
          if (!(err instanceof StopExecutionError)) {
            self.fail(err);
          }
          self.errored = errored = true;
        }

        function runNext() {
          if (self.completeOnFirstError && errored) {
            self.skipToCleanup(iterativeIndex);
          } else {
            self.run(iterativeIndex + 1);
          }
        }

        if (completedSynchronously) {
          self.setTimeout(runNext);
        } else {
          runNext();
        }
      }),
      errored = false,
      queueableFn = self.queueableFns[iterativeIndex],
      timeoutId;

    next.fail = function nextFail() {
      self.fail.apply(null, arguments);
      self.errored = errored = true;
      next();
    };

    self.globalErrors.pushListener(handleError);

    if (queueableFn.timeout) {
      timeoutId = self.setTimeout(function() {
        var error = new Error('Timeout - Async callback was not invoked within timeout specified by jasmine.DEFAULT_TIMEOUT_INTERVAL.');
        onException(error);
        next();
      }, queueableFn.timeout());
    }

    try {
      if (queueableFn.fn.length === 0) {
        var maybeThenable = queueableFn.fn.call(self.userContext);

        if (maybeThenable && j$.isFunction_(maybeThenable.then)) {
          maybeThenable.then(next, onPromiseRejection);
          completedSynchronously = false;
          return { completedSynchronously: false };
        }
      } else {
        queueableFn.fn.call(self.userContext, next);
        completedSynchronously = false;
        return { completedSynchronously: false };
      }
    } catch (e) {
      onException(e);
      self.errored = errored = true;
    }

    cleanup();
    return { completedSynchronously: true, errored: errored };

    function onException(e) {
      self.onException(e);
      self.errored = errored = true;
    }

    function onPromiseRejection(e) {
      onException(e);
      next();
    }
  };

  QueueRunner.prototype.run = function(recursiveIndex) {
    var length = this.queueableFns.length,
      self = this,
      iterativeIndex;


    for(iterativeIndex = recursiveIndex; iterativeIndex < length; iterativeIndex++) {
      var result = this.attempt(iterativeIndex);

      if (!result.completedSynchronously) {
        return;
      }

      self.errored = result.errored;

      if (this.completeOnFirstError && result.errored) {
        this.skipToCleanup(iterativeIndex);
        return;
      }
    }

    this.clearStack(function() {
      self.globalErrors.popListener(self.handleFinalError);
      self.onComplete(self.errored && new StopExecutionError());
    });

  };

  return QueueRunner;
};

getJasmineRequireObj().ReportDispatcher = function(j$) {
  function ReportDispatcher(methods, queueRunnerFactory) {

    var dispatchedMethods = methods || [];

    for (var i = 0; i < dispatchedMethods.length; i++) {
      var method = dispatchedMethods[i];
      this[method] = (function(m) {
        return function() {
          dispatch(m, arguments);
        };
      }(method));
    }

    var reporters = [];
    var fallbackReporter = null;

    this.addReporter = function(reporter) {
      reporters.push(reporter);
    };

    this.provideFallbackReporter = function(reporter) {
      fallbackReporter = reporter;
    };

    this.clearReporters = function() {
      reporters = [];
    };

    return this;

    function dispatch(method, args) {
      if (reporters.length === 0 && fallbackReporter !== null) {
          reporters.push(fallbackReporter);
      }
      var onComplete = args[args.length - 1];
      args = j$.util.argsToArray(args).splice(0, args.length - 1);
      var fns = [];
      for (var i = 0; i < reporters.length; i++) {
        var reporter = reporters[i];
        addFn(fns, reporter, method, args);
      }

      queueRunnerFactory({
        queueableFns: fns,
        onComplete: onComplete,
        isReporter: true
      });
    }

    function addFn(fns, reporter, method, args) {
      var fn = reporter[method];
      if (!fn) {
        return;
      }

      var thisArgs = j$.util.cloneArgs(args);
      if (fn.length <= 1) {
        fns.push({
          fn: function () {
            return fn.apply(reporter, thisArgs);
          }
        });
      } else {
        fns.push({
          fn: function (done) {
            return fn.apply(reporter, thisArgs.concat([done]));
          }
        });
      }
    }
  }

  return ReportDispatcher;
};


getJasmineRequireObj().interface = function(jasmine, env) {
  var jasmineInterface = {
    

    
    describe: function(description, specDefinitions) {
      return env.describe(description, specDefinitions);
    },

    
    xdescribe: function(description, specDefinitions) {
      return env.xdescribe(description, specDefinitions);
    },

    
    fdescribe: function(description, specDefinitions) {
      return env.fdescribe(description, specDefinitions);
    },

    
    it: function() {
      return env.it.apply(env, arguments);
    },

    
    xit: function() {
      return env.xit.apply(env, arguments);
    },

    
    fit: function() {
      return env.fit.apply(env, arguments);
    },

    
    beforeEach: function() {
      return env.beforeEach.apply(env, arguments);
    },

    
    afterEach: function() {
      return env.afterEach.apply(env, arguments);
    },

    
    beforeAll: function() {
      return env.beforeAll.apply(env, arguments);
    },

    
    afterAll: function() {
      return env.afterAll.apply(env, arguments);
    },

    
    expect: function(actual) {
      return env.expect(actual);
    },

    
    pending: function() {
      return env.pending.apply(env, arguments);
    },

    
    fail: function() {
      return env.fail.apply(env, arguments);
    },

    
    spyOn: function(obj, methodName) {
      return env.spyOn(obj, methodName);
    },

    
    spyOnProperty: function(obj, methodName, accessType) {
      return env.spyOnProperty(obj, methodName, accessType);
    },

    jsApiReporter: new jasmine.JsApiReporter({
      timer: new jasmine.Timer()
    }),

    
    jasmine: jasmine
  };

  
  jasmine.addCustomEqualityTester = function(tester) {
    env.addCustomEqualityTester(tester);
  };

  
  jasmine.addMatchers = function(matchers) {
    return env.addMatchers(matchers);
  };

  
  jasmine.clock = function() {
    return env.clock;
  };

  
  jasmine.createSpy = function(name, originalFn) {
    return env.createSpy(name, originalFn);
  };

  
  jasmine.createSpyObj = function(baseName, methodNames) {
    return env.createSpyObj(baseName, methodNames);
  };

  
  jasmine.addSpyStrategy = function(name, factory) {
    return env.addSpyStrategy(name, factory);
  };

  return jasmineInterface;
};

getJasmineRequireObj().Spy = function (j$) {

  var nextOrder = (function() {
    var order = 0;

    return function() {
      return order++;
    };
  })();

  
  function Spy(name, originalFn, customStrategies) {
    var numArgs = (typeof originalFn === 'function' ? originalFn.length : 0),
      wrapper = makeFunc(numArgs, function () {
        return spy.apply(this, Array.prototype.slice.call(arguments));
      }),
      strategyDispatcher = new SpyStrategyDispatcher({
        name: name,
        fn: originalFn,
        getSpy: function () {
          return wrapper;
        },
        customStrategies: customStrategies
      }),
      callTracker = new j$.CallTracker(),
      spy = function () {
        
        var callData = {
          object: this,
          invocationOrder: nextOrder(),
          args: Array.prototype.slice.apply(arguments)
        };

        callTracker.track(callData);
        var returnValue = strategyDispatcher.exec(this, arguments);
        callData.returnValue = returnValue;

        return returnValue;
      };

    function makeFunc(length, fn) {
      switch (length) {
        case 1 : return function (a) { return fn.apply(this, arguments); };
        case 2 : return function (a,b) { return fn.apply(this, arguments); };
        case 3 : return function (a,b,c) { return fn.apply(this, arguments); };
        case 4 : return function (a,b,c,d) { return fn.apply(this, arguments); };
        case 5 : return function (a,b,c,d,e) { return fn.apply(this, arguments); };
        case 6 : return function (a,b,c,d,e,f) { return fn.apply(this, arguments); };
        case 7 : return function (a,b,c,d,e,f,g) { return fn.apply(this, arguments); };
        case 8 : return function (a,b,c,d,e,f,g,h) { return fn.apply(this, arguments); };
        case 9 : return function (a,b,c,d,e,f,g,h,i) { return fn.apply(this, arguments); };
        default : return function () { return fn.apply(this, arguments); };
      }
    }

    for (var prop in originalFn) {
      if (prop === 'and' || prop === 'calls') {
        throw new Error('Jasmine spies would overwrite the \'and\' and \'calls\' properties on the object being spied upon');
      }

      wrapper[prop] = originalFn[prop];
    }

    
    wrapper.and = strategyDispatcher.and;
    
    wrapper.withArgs = function() {
      return strategyDispatcher.withArgs.apply(strategyDispatcher, arguments);
    };
    wrapper.calls = callTracker;

    return wrapper;
  }


  function SpyStrategyDispatcher(strategyArgs) {
    var baseStrategy = new j$.SpyStrategy(strategyArgs);
    var argsStrategies = new StrategyDict(function() {
      return new j$.SpyStrategy(strategyArgs);
    });

    this.and = baseStrategy;

    this.exec = function(spy, args) {
      var strategy = argsStrategies.get(args);

      if (!strategy) {
        if (argsStrategies.any() && !baseStrategy.isConfigured()) {
          throw new Error('Spy \'' + strategyArgs.name + '\' receieved a call with arguments ' + j$.pp(Array.prototype.slice.call(args)) + ' but all configured strategies specify other arguments.');
        } else {
          strategy = baseStrategy;
        }
      }

      return strategy.exec(spy, args);
    };

    this.withArgs = function() {
      return { and: argsStrategies.getOrCreate(arguments) };
    };
  }

  function StrategyDict(strategyFactory) {
    this.strategies = [];
    this.strategyFactory = strategyFactory;
  }

  StrategyDict.prototype.any = function() {
    return this.strategies.length > 0;
  };

  StrategyDict.prototype.getOrCreate = function(args) {
    var strategy = this.get(args);

    if (!strategy) {
      strategy = this.strategyFactory();
      this.strategies.push({
        args: args,
        strategy: strategy
      });
    }

    return strategy;
  };

  StrategyDict.prototype.get = function(args) {
    var i;

    for (i = 0; i < this.strategies.length; i++) {
      if (j$.matchersUtil.equals(args, this.strategies[i].args)) {
        return this.strategies[i].strategy;
      }
    }
  };

  return Spy;
};

getJasmineRequireObj().SpyFactory = function(j$) {

  function SpyFactory(getCustomStrategies) {
    var self = this;

    this.createSpy = function(name, originalFn) {
      return j$.Spy(name, originalFn, getCustomStrategies());
    };

    this.createSpyObj = function(baseName, methodNames) {
      var baseNameIsCollection = j$.isObject_(baseName) || j$.isArray_(baseName);

      if (baseNameIsCollection && j$.util.isUndefined(methodNames)) {
        methodNames = baseName;
        baseName = 'unknown';
      }

      var obj = {};
      var spiesWereSet = false;

      if (j$.isArray_(methodNames)) {
        for (var i = 0; i < methodNames.length; i++) {
          obj[methodNames[i]] = self.createSpy(baseName + '.' + methodNames[i]);
          spiesWereSet = true;
        }
      } else if (j$.isObject_(methodNames)) {
        for (var key in methodNames) {
          if (methodNames.hasOwnProperty(key)) {
            obj[key] = self.createSpy(baseName + '.' + key);
            obj[key].and.returnValue(methodNames[key]);
            spiesWereSet = true;
          }
        }
      }

      if (!spiesWereSet) {
        throw 'createSpyObj requires a non-empty array or object of method names to create spies for';
      }

      return obj;
    };
  }

  return SpyFactory;
};

getJasmineRequireObj().SpyRegistry = function(j$) {

  var getErrorMsg = j$.formatErrorMsg('<spyOn>', 'spyOn(<object>, <methodName>)');

  function SpyRegistry(options) {
    options = options || {};
    var global = options.global || j$.getGlobal();
    var createSpy = options.createSpy;
    var currentSpies = options.currentSpies || function() { return []; };

    this.allowRespy = function(allow){
      this.respy = allow;
    };

    this.spyOn = function(obj, methodName) {

      if (j$.util.isUndefined(obj) || obj === null) {
        throw new Error(getErrorMsg('could not find an object to spy upon for ' + methodName + '()'));
      }

      if (j$.util.isUndefined(methodName) || methodName === null) {
        throw new Error(getErrorMsg('No method name supplied'));
      }

      if (j$.util.isUndefined(obj[methodName])) {
        throw new Error(getErrorMsg(methodName + '() method does not exist'));
      }

      if (obj[methodName] && j$.isSpy(obj[methodName])  ) {
        if ( !!this.respy ){
          return obj[methodName];
        }else {
          throw new Error(getErrorMsg(methodName + ' has already been spied upon'));
        }
      }

      var descriptor = Object.getOwnPropertyDescriptor(obj, methodName);

      if (descriptor && !(descriptor.writable || descriptor.set)) {
        throw new Error(getErrorMsg(methodName + ' is not declared writable or has no setter'));
      }

      var originalMethod = obj[methodName],
        spiedMethod = createSpy(methodName, originalMethod),
        restoreStrategy;

      if (Object.prototype.hasOwnProperty.call(obj, methodName) || (obj === global && methodName === 'onerror')) {
        restoreStrategy = function() {
          obj[methodName] = originalMethod;
        };
      } else {
        restoreStrategy = function() {
          if (!delete obj[methodName]) {
            obj[methodName] = originalMethod;
          }
        };
      }

      currentSpies().push({
        restoreObjectToOriginalState: restoreStrategy
      });

      obj[methodName] = spiedMethod;

      return spiedMethod;
    };

    this.spyOnProperty = function (obj, propertyName, accessType) {
      accessType = accessType || 'get';

      if (j$.util.isUndefined(obj)) {
        throw new Error('spyOn could not find an object to spy upon for ' + propertyName + '');
      }

      if (j$.util.isUndefined(propertyName)) {
        throw new Error('No property name supplied');
      }

      var descriptor = j$.util.getPropertyDescriptor(obj, propertyName);

      if (!descriptor) {
        throw new Error(propertyName + ' property does not exist');
      }

      if (!descriptor.configurable) {
        throw new Error(propertyName + ' is not declared configurable');
      }

      if(!descriptor[accessType]) {
        throw new Error('Property ' + propertyName + ' does not have access type ' + accessType);
      }

      if (j$.isSpy(descriptor[accessType])) {
        
        throw new Error(propertyName + ' has already been spied upon');
      }

      var originalDescriptor = j$.util.clone(descriptor),
        spy = createSpy(propertyName, descriptor[accessType]),
        restoreStrategy;

      if (Object.prototype.hasOwnProperty.call(obj, propertyName)) {
        restoreStrategy = function() {
          Object.defineProperty(obj, propertyName, originalDescriptor);
        };
      } else {
        restoreStrategy = function() {
          delete obj[propertyName];
        };
      }

      currentSpies().push({
        restoreObjectToOriginalState: restoreStrategy
      });

      descriptor[accessType] = spy;

      Object.defineProperty(obj, propertyName, descriptor);

      return spy;
    };

    this.clearSpies = function() {
      var spies = currentSpies();
      for (var i = spies.length - 1; i >= 0; i--) {
        var spyEntry = spies[i];
        spyEntry.restoreObjectToOriginalState();
      }
    };
  }

  return SpyRegistry;
};

getJasmineRequireObj().SpyStrategy = function(j$) {

  
  function SpyStrategy(options) {
    options = options || {};

    
    this.identity = options.name || 'unknown';
    this.originalFn = options.fn || function() {};
    this.getSpy = options.getSpy || function() {};
    this.plan = this._defaultPlan = function() {};

    var k, cs = options.customStrategies || {};
    for (k in cs) {
      if (j$.util.has(cs, k) && !this[k]) {
        this[k] = createCustomPlan(cs[k]);
      }
    }
  }

  function createCustomPlan(factory) {
    return function() {
      var plan = factory.apply(null, arguments);

      if (!j$.isFunction_(plan)) {
        throw new Error('Spy strategy must return a function');
      }

      this.plan = plan;
      return this.getSpy();
    };
  }

  
  SpyStrategy.prototype.exec = function(context, args) {
    return this.plan.apply(context, args);
  };

  
  SpyStrategy.prototype.callThrough = function() {
    this.plan = this.originalFn;
    return this.getSpy();
  };

  
  SpyStrategy.prototype.returnValue = function(value) {
    this.plan = function() {
      return value;
    };
    return this.getSpy();
  };

  
  SpyStrategy.prototype.returnValues = function() {
    var values = Array.prototype.slice.call(arguments);
    this.plan = function () {
      return values.shift();
    };
    return this.getSpy();
  };

  
  SpyStrategy.prototype.throwError = function(something) {
    var error = (something instanceof Error) ? something : new Error(something);
    this.plan = function() {
      throw error;
    };
    return this.getSpy();
  };

  
  SpyStrategy.prototype.callFake = function(fn) {
    if(!(j$.isFunction_(fn) || j$.isAsyncFunction_(fn))) {
      throw new Error('Argument passed to callFake should be a function, got ' + fn);
    }
    this.plan = fn;
    return this.getSpy();
  };

  
  SpyStrategy.prototype.stub = function(fn) {
    this.plan = function() {};
    return this.getSpy();
  };

  SpyStrategy.prototype.isConfigured = function() {
    return this.plan !== this._defaultPlan;
  };

  return SpyStrategy;
};

getJasmineRequireObj().StackTrace = function(j$) {
  function StackTrace(rawTrace) {
    var lines = rawTrace
      .split('\n')
      .filter(function(line) { return line !== ''; });

    if (lines[0].match(/^Error/)) {
      this.message = lines.shift();
    } else {
      this.message = undefined;
    }

    var parseResult = tryParseFrames(lines);
    this.frames = parseResult.frames;
    this.style = parseResult.style;
  }

  var framePatterns = [
    
    
    
    
    { re: /^\s*at ([^\)]+) \(([^\)]+)\)$/, fnIx: 1, fileLineColIx: 2, style: 'v8' },

    
    
    { re: /\s*at (.+)$/, fileLineColIx: 1, style: 'v8' },

    
    
    
    { re: /^(([^@\s]+)@)?([^\s]+)$/, fnIx: 2, fileLineColIx: 3, style: 'webkit' }
  ];

  
  
  function tryParseFrames(lines) {
    var style = null;
    var frames = lines.map(function(line) {
      var convertedLine = first(framePatterns, function(pattern) {
        var overallMatch = line.match(pattern.re),
          fileLineColMatch;
        if (!overallMatch) { return null; }

        fileLineColMatch = overallMatch[pattern.fileLineColIx].match(
          /^(.*):(\d+):\d+$/);
        if (!fileLineColMatch) { return null; }

        style = style || pattern.style;
        return {
          raw: line,
          file: fileLineColMatch[1],
          line: parseInt(fileLineColMatch[2], 10),
          func: overallMatch[pattern.fnIx]
        };
      });

      return convertedLine || { raw: line };
    });

    return {
      style: style,
      frames: frames
    };
  }

  function first(items, fn) {
    var i, result;

    for (i = 0; i < items.length; i++) {
      result = fn(items[i]);

      if (result) {
        return result;
      }
    }
  }

  return StackTrace;
};

getJasmineRequireObj().Suite = function(j$) {
  function Suite(attrs) {
    this.env = attrs.env;
    this.id = attrs.id;
    this.parentSuite = attrs.parentSuite;
    this.description = attrs.description;
    this.expectationFactory = attrs.expectationFactory;
    this.expectationResultFactory = attrs.expectationResultFactory;
    this.throwOnExpectationFailure = !!attrs.throwOnExpectationFailure;

    this.beforeFns = [];
    this.afterFns = [];
    this.beforeAllFns = [];
    this.afterAllFns = [];

    this.children = [];

    
    this.result = {
      id: this.id,
      description: this.description,
      fullName: this.getFullName(),
      failedExpectations: [],
      deprecationWarnings: []
    };
  }

  Suite.prototype.expect = function(actual) {
    return this.expectationFactory(actual, this);
  };

  Suite.prototype.getFullName = function() {
    var fullName = [];
    for (var parentSuite = this; parentSuite; parentSuite = parentSuite.parentSuite) {
      if (parentSuite.parentSuite) {
        fullName.unshift(parentSuite.description);
      }
    }
    return fullName.join(' ');
  };

  Suite.prototype.pend = function() {
    this.markedPending = true;
  };

  Suite.prototype.beforeEach = function(fn) {
    this.beforeFns.unshift(fn);
  };

  Suite.prototype.beforeAll = function(fn) {
    this.beforeAllFns.push(fn);
  };

  Suite.prototype.afterEach = function(fn) {
    this.afterFns.unshift(fn);
  };

  Suite.prototype.afterAll = function(fn) {
    this.afterAllFns.unshift(fn);
  };

  function removeFns(queueableFns) {
    for(var i = 0; i < queueableFns.length; i++) {
      queueableFns[i].fn = null;
    }
  }

  Suite.prototype.cleanupBeforeAfter = function() {
    removeFns(this.beforeAllFns);
    removeFns(this.afterAllFns);
    removeFns(this.beforeFns);
    removeFns(this.afterFns);
  };

  Suite.prototype.addChild = function(child) {
    this.children.push(child);
  };

  Suite.prototype.status = function() {
    if (this.markedPending) {
      return 'pending';
    }

    if (this.result.failedExpectations.length > 0) {
      return 'failed';
    } else {
      return 'passed';
    }
  };

  Suite.prototype.canBeReentered = function() {
    return this.beforeAllFns.length === 0 && this.afterAllFns.length === 0;
  };

  Suite.prototype.getResult = function() {
    this.result.status = this.status();
    return this.result;
  };

  Suite.prototype.sharedUserContext = function() {
    if (!this.sharedContext) {
      this.sharedContext = this.parentSuite ? this.parentSuite.clonedSharedUserContext() : new j$.UserContext();
    }

    return this.sharedContext;
  };

  Suite.prototype.clonedSharedUserContext = function() {
    return j$.UserContext.fromExisting(this.sharedUserContext());
  };

  Suite.prototype.onException = function() {
    if (arguments[0] instanceof j$.errors.ExpectationFailed) {
      return;
    }

    var data = {
      matcherName: '',
      passed: false,
      expected: '',
      actual: '',
      error: arguments[0]
    };
    var failedExpectation = this.expectationResultFactory(data);

    if (!this.parentSuite) {
      failedExpectation.globalErrorType = 'afterAll';
    }

    this.result.failedExpectations.push(failedExpectation);
  };

  Suite.prototype.addExpectationResult = function () {
    if(isFailure(arguments)) {
      var data = arguments[1];
      this.result.failedExpectations.push(this.expectationResultFactory(data));
      if(this.throwOnExpectationFailure) {
        throw new j$.errors.ExpectationFailed();
      }
    }
  };

  Suite.prototype.addDeprecationWarning = function(deprecation) {
    if (typeof deprecation === 'string') {
      deprecation = { message: deprecation };
    }
    this.result.deprecationWarnings.push(this.expectationResultFactory(deprecation));
  };

  function isFailure(args) {
    return !args[0];
  }

  return Suite;
};

if (typeof window == void 0 && typeof exports == 'object') {
  exports.Suite = jasmineRequire.Suite;
}

getJasmineRequireObj().Timer = function() {
  var defaultNow = (function(Date) {
    return function() { return new Date().getTime(); };
  })(Date);

  function Timer(options) {
    options = options || {};

    var now = options.now || defaultNow,
      startTime;

    this.start = function() {
      startTime = now();
    };

    this.elapsed = function() {
      return now() - startTime;
    };
  }

  return Timer;
};

getJasmineRequireObj().TreeProcessor = function() {
  function TreeProcessor(attrs) {
    var tree = attrs.tree,
        runnableIds = attrs.runnableIds,
        queueRunnerFactory = attrs.queueRunnerFactory,
        nodeStart = attrs.nodeStart || function() {},
        nodeComplete = attrs.nodeComplete || function() {},
        orderChildren = attrs.orderChildren || function(node) { return node.children; },
        excludeNode = attrs.excludeNode || function(node) { return false; },
        stats = { valid: true },
        processed = false,
        defaultMin = Infinity,
        defaultMax = 1 - Infinity;

    this.processTree = function() {
      processNode(tree, true);
      processed = true;
      return stats;
    };

    this.execute = function(done) {
      if (!processed) {
        this.processTree();
      }

      if (!stats.valid) {
        throw 'invalid order';
      }

      var childFns = wrapChildren(tree, 0);

      queueRunnerFactory({
        queueableFns: childFns,
        userContext: tree.sharedUserContext(),
        onException: function() {
          tree.onException.apply(tree, arguments);
        },
        onComplete: done
      });
    };

    function runnableIndex(id) {
      for (var i = 0; i < runnableIds.length; i++) {
        if (runnableIds[i] === id) {
          return i;
        }
      }
    }

    function processNode(node, parentExcluded) {
      var executableIndex = runnableIndex(node.id);

      if (executableIndex !== undefined) {
        parentExcluded = false;
      }

      if (!node.children) {
        var excluded = parentExcluded || excludeNode(node);
        stats[node.id] = {
          excluded: excluded,
          willExecute: !excluded && !node.markedPending,
          segments: [{
            index: 0,
            owner: node,
            nodes: [node],
            min: startingMin(executableIndex),
            max: startingMax(executableIndex)
          }]
        };
      } else {
        var hasExecutableChild = false;

        var orderedChildren = orderChildren(node);

        for (var i = 0; i < orderedChildren.length; i++) {
          var child = orderedChildren[i];

          processNode(child, parentExcluded);

          if (!stats.valid) {
            return;
          }

          var childStats = stats[child.id];

          hasExecutableChild = hasExecutableChild || childStats.willExecute;
        }

        stats[node.id] = {
          excluded: parentExcluded,
          willExecute: hasExecutableChild
        };

        segmentChildren(node, orderedChildren, stats[node.id], executableIndex);

        if (!node.canBeReentered() && stats[node.id].segments.length > 1) {
          stats = { valid: false };
        }
      }
    }

    function startingMin(executableIndex) {
      return executableIndex === undefined ? defaultMin : executableIndex;
    }

    function startingMax(executableIndex) {
      return executableIndex === undefined ? defaultMax : executableIndex;
    }

    function segmentChildren(node, orderedChildren, nodeStats, executableIndex) {
      var currentSegment = { index: 0, owner: node, nodes: [], min: startingMin(executableIndex), max: startingMax(executableIndex) },
          result = [currentSegment],
          lastMax = defaultMax,
          orderedChildSegments = orderChildSegments(orderedChildren);

      function isSegmentBoundary(minIndex) {
        return lastMax !== defaultMax && minIndex !== defaultMin && lastMax < minIndex - 1;
      }

      for (var i = 0; i < orderedChildSegments.length; i++) {
        var childSegment = orderedChildSegments[i],
          maxIndex = childSegment.max,
          minIndex = childSegment.min;

        if (isSegmentBoundary(minIndex)) {
          currentSegment = {index: result.length, owner: node, nodes: [], min: defaultMin, max: defaultMax};
          result.push(currentSegment);
        }

        currentSegment.nodes.push(childSegment);
        currentSegment.min = Math.min(currentSegment.min, minIndex);
        currentSegment.max = Math.max(currentSegment.max, maxIndex);
        lastMax = maxIndex;
      }

      nodeStats.segments = result;
    }

    function orderChildSegments(children) {
      var specifiedOrder = [],
          unspecifiedOrder = [];

      for (var i = 0; i < children.length; i++) {
        var child = children[i],
            segments = stats[child.id].segments;

        for (var j = 0; j < segments.length; j++) {
          var seg = segments[j];

          if (seg.min === defaultMin) {
            unspecifiedOrder.push(seg);
          } else {
            specifiedOrder.push(seg);
          }
        }
      }

      specifiedOrder.sort(function(a, b) {
        return a.min - b.min;
      });

      return specifiedOrder.concat(unspecifiedOrder);
    }

    function executeNode(node, segmentNumber) {
      if (node.children) {
        return {
          fn: function(done) {
            var onStart = {
              fn: function(next) {
                nodeStart(node, next);
              }
            };

            queueRunnerFactory({
              onComplete: function () {
                node.cleanupBeforeAfter();
                nodeComplete(node, node.getResult(), done);
              },
              queueableFns: [onStart].concat(wrapChildren(node, segmentNumber)),
              userContext: node.sharedUserContext(),
              onException: function () {
                node.onException.apply(node, arguments);
              }
            });
          }
        };
      } else {
        return {
          fn: function(done) { node.execute(done, stats[node.id].excluded); }
        };
      }
    }

    function wrapChildren(node, segmentNumber) {
      var result = [],
          segmentChildren = stats[node.id].segments[segmentNumber].nodes;

      for (var i = 0; i < segmentChildren.length; i++) {
        result.push(executeNode(segmentChildren[i].owner, segmentChildren[i].index));
      }

      if (!stats[node.id].willExecute) {
        return result;
      }

      return node.beforeAllFns.concat(result).concat(node.afterAllFns);
    }
  }

  return TreeProcessor;
};

getJasmineRequireObj().UserContext = function(j$) {
  function UserContext() {
  }

  UserContext.fromExisting = function(oldContext) {
    var context = new UserContext();

    for (var prop in oldContext) {
      if (oldContext.hasOwnProperty(prop)) {
        context[prop] = oldContext[prop];
      }
    }

    return context;
  };

  return  UserContext;
};

getJasmineRequireObj().version = function() {
  return '3.1.0';
};






jasmineRequire.html = function(j$) {
  j$.ResultsNode = jasmineRequire.ResultsNode();
  j$.HtmlReporter = jasmineRequire.HtmlReporter(j$);
  j$.QueryString = jasmineRequire.QueryString();
  j$.HtmlSpecFilter = jasmineRequire.HtmlSpecFilter();
};

jasmineRequire.HtmlReporter = function(j$) {

  var noopTimer = {
    start: function() {},
    elapsed: function() { return 0; }
  };

  function ResultsStateBuilder() {
    this.topResults = new j$.ResultsNode({}, '', null);
    this.currentParent = this.topResults;
    this.specsExecuted = 0;
    this.failureCount = 0;
    this.pendingSpecCount = 0;
  }

  ResultsStateBuilder.prototype.suiteStarted = function(result) {
    this.currentParent.addChild(result, 'suite');
    this.currentParent = this.currentParent.last();
  };

  ResultsStateBuilder.prototype.suiteDone = function(result) {
    this.currentParent.updateResult(result);
    if (this.currentParent !== this.topResults) {
      this.currentParent = this.currentParent.parent;
    }

    if (result.status === 'failed') {
      this.failureCount++;
    }
  };

  ResultsStateBuilder.prototype.specStarted = function(result) {
  };

  ResultsStateBuilder.prototype.specDone = function(result) {
    this.currentParent.addChild(result, 'spec');

    if (result.status !== 'excluded') {
      this.specsExecuted++;
    }

    if (result.status === 'failed') {
      this.failureCount++;
    }

    if (result.status == 'pending') {
      this.pendingSpecCount++;
    }
  };



  function HtmlReporter(options) {
    var env = options.env || {},
      getContainer = options.getContainer,
      createElement = options.createElement,
      createTextNode = options.createTextNode,
      navigateWithNewParam = options.navigateWithNewParam || function() {},
      addToExistingQueryString = options.addToExistingQueryString || defaultQueryString,
      filterSpecs = options.filterSpecs,
      timer = options.timer || noopTimer,
      htmlReporterMain,
      symbols,
      deprecationWarnings = [];

    this.initialize = function() {
      clearPrior();
      htmlReporterMain = createDom('div', {className: 'jasmine_html-reporter'},
        createDom('div', {className: 'jasmine-banner'},
          createDom('a', {className: 'jasmine-title', href: 'http://jasmine.github.io/', target: '_blank'}),
          createDom('span', {className: 'jasmine-version'}, j$.version)
        ),
        createDom('ul', {className: 'jasmine-symbol-summary'}),
        createDom('div', {className: 'jasmine-alert'}),
        createDom('div', {className: 'jasmine-results'},
          createDom('div', {className: 'jasmine-failures'})
        )
      );
      getContainer().appendChild(htmlReporterMain);
    };

    var totalSpecsDefined;
    this.jasmineStarted = function(options) {
      totalSpecsDefined = options.totalSpecsDefined || 0;
      timer.start();
    };

    var summary = createDom('div', {className: 'jasmine-summary'});

    var stateBuilder = new ResultsStateBuilder();

    this.suiteStarted = function(result) {
      stateBuilder.suiteStarted(result);
    };

    this.suiteDone = function(result) {
      stateBuilder.suiteDone(result);

      if (result.status === 'failed') {
        failures.push(failureDom(result));
      }
      addDeprecationWarnings(result);
    };

    this.specStarted = function(result) {
      stateBuilder.specStarted(result);
    };

    var failures = [];
    this.specDone = function(result) {
      stateBuilder.specDone(result);

      if(noExpectations(result) && typeof console !== 'undefined' && typeof console.error !== 'undefined') {
        console.error('Spec \'' + result.fullName + '\' has no expectations.');
      }

      if (!symbols){
        symbols = find('.jasmine-symbol-summary');
      }

      symbols.appendChild(createDom('li', {
          className: noExpectations(result) ? 'jasmine-empty' : 'jasmine-' + result.status,
          id: 'spec_' + result.id,
          title: result.fullName
        }
      ));

      if (result.status === 'failed') {
        failures.push(failureDom(result));
      }

      addDeprecationWarnings(result);
    };

    this.jasmineDone = function(doneResult) {
      var banner = find('.jasmine-banner');
      var alert = find('.jasmine-alert');
      var order = doneResult && doneResult.order;
      alert.appendChild(createDom('span', {className: 'jasmine-duration'}, 'finished in ' + timer.elapsed() / 1000 + 's'));

      banner.appendChild(optionsMenu(env));

      if (stateBuilder.specsExecuted < totalSpecsDefined) {
        var skippedMessage = 'Ran ' + stateBuilder.specsExecuted + ' of ' + totalSpecsDefined + ' specs - run all';
        var skippedLink = addToExistingQueryString('spec', '');
        alert.appendChild(
          createDom('span', {className: 'jasmine-bar jasmine-skipped'},
            createDom('a', {href: skippedLink, title: 'Run all specs'}, skippedMessage)
          )
        );
      }
      var statusBarMessage = '';
      var statusBarClassName = 'jasmine-overall-result jasmine-bar ';
      var globalFailures = (doneResult && doneResult.failedExpectations) || [];
      var failed = stateBuilder.failureCount + globalFailures.length > 0;

      if (totalSpecsDefined > 0 || failed) {
        statusBarMessage += pluralize('spec', stateBuilder.specsExecuted) + ', ' + pluralize('failure', stateBuilder.failureCount);
        if (stateBuilder.pendingSpecCount) { statusBarMessage += ', ' + pluralize('pending spec', stateBuilder.pendingSpecCount); }
      }

      if (doneResult.overallStatus === 'passed') {
        statusBarClassName += ' jasmine-passed ';
      } else if (doneResult.overallStatus === 'incomplete') {
        statusBarClassName += ' jasmine-incomplete ';
        statusBarMessage = 'Incomplete: ' + doneResult.incompleteReason + ', ' + statusBarMessage;
      } else {
        statusBarClassName += ' jasmine-failed ';
      }

      var seedBar;
      if (order && order.random) {
        seedBar = createDom('span', {className: 'jasmine-seed-bar'},
          ', randomized with seed ',
          createDom('a', {title: 'randomized with seed ' + order.seed, href: seedHref(order.seed)}, order.seed)
        );
      }

      alert.appendChild(createDom('span', {className: statusBarClassName}, statusBarMessage, seedBar));

      var errorBarClassName = 'jasmine-bar jasmine-errored';
      var afterAllMessagePrefix = 'AfterAll ';

      for(i = 0; i < globalFailures.length; i++) {
        alert.appendChild(createDom('span', {className: errorBarClassName}, globalFailureMessage(globalFailures[i])));
      }

      function globalFailureMessage(failure) {
        if (failure.globalErrorType === 'load') {
          var prefix = 'Error during loading: ' + failure.message;

          if (failure.filename) {
            return prefix + ' in ' + failure.filename + ' line ' + failure.lineno;
          } else {
            return prefix;
          }
        } else {
          return afterAllMessagePrefix + failure.message;
        }
      }

      addDeprecationWarnings(doneResult);

      var warningBarClassName = 'jasmine-bar jasmine-warning';
      for(i = 0; i < deprecationWarnings.length; i++) {
        var warning = deprecationWarnings[i];
        alert.appendChild(createDom('span', {className: warningBarClassName}, 'DEPRECATION: ' + warning));
      }

      var results = find('.jasmine-results');
      results.appendChild(summary);

      summaryList(stateBuilder.topResults, summary);

      if (failures.length) {
        alert.appendChild(
          createDom('span', {className: 'jasmine-menu jasmine-bar jasmine-spec-list'},
            createDom('span', {}, 'Spec List | '),
            createDom('a', {className: 'jasmine-failures-menu', href: '#'}, 'Failures')));
        alert.appendChild(
          createDom('span', {className: 'jasmine-menu jasmine-bar jasmine-failure-list'},
            createDom('a', {className: 'jasmine-spec-list-menu', href: '#'}, 'Spec List'),
            createDom('span', {}, ' | Failures ')));

        find('.jasmine-failures-menu').onclick = function() {
          setMenuModeTo('jasmine-failure-list');
        };
        find('.jasmine-spec-list-menu').onclick = function() {
          setMenuModeTo('jasmine-spec-list');
        };

        setMenuModeTo('jasmine-failure-list');

        var failureNode = find('.jasmine-failures');
        for (i = 0; i < failures.length; i++) {
          failureNode.appendChild(failures[i]);
        }
      }
    };

    return this;

    function failureDom(result) {
      var failure =
        createDom('div', {className: 'jasmine-spec-detail jasmine-failed'},
          failureDescription(result, stateBuilder.currentParent),
          createDom('div', {className: 'jasmine-messages'})
        );
      var messages = failure.childNodes[1];

      for (var i = 0; i < result.failedExpectations.length; i++) {
        var expectation = result.failedExpectations[i];
        messages.appendChild(createDom('div', {className: 'jasmine-result-message'}, expectation.message));
        messages.appendChild(createDom('div', {className: 'jasmine-stack-trace'}, expectation.stack));
      }

      return failure;
    }

    function summaryList(resultsTree, domParent) {
      var specListNode;
      for (var i = 0; i < resultsTree.children.length; i++) {
        var resultNode = resultsTree.children[i];
        if (filterSpecs && !hasActiveSpec(resultNode)) {
          continue;
        }
        if (resultNode.type === 'suite') {
          var suiteListNode = createDom('ul', {className: 'jasmine-suite', id: 'suite-' + resultNode.result.id},
            createDom('li', {className: 'jasmine-suite-detail jasmine-' + resultNode.result.status},
              createDom('a', {href: specHref(resultNode.result)}, resultNode.result.description)
            )
          );

          summaryList(resultNode, suiteListNode);
          domParent.appendChild(suiteListNode);
        }
        if (resultNode.type === 'spec') {
          if (domParent.getAttribute('class') !== 'jasmine-specs') {
            specListNode = createDom('ul', {className: 'jasmine-specs'});
            domParent.appendChild(specListNode);
          }
          var specDescription = resultNode.result.description;
          if(noExpectations(resultNode.result)) {
            specDescription = 'SPEC HAS NO EXPECTATIONS ' + specDescription;
          }
          if(resultNode.result.status === 'pending' && resultNode.result.pendingReason !== '') {
            specDescription = specDescription + ' PENDING WITH MESSAGE: ' + resultNode.result.pendingReason;
          }
          specListNode.appendChild(
            createDom('li', {
                className: 'jasmine-' + resultNode.result.status,
                id: 'spec-' + resultNode.result.id
              },
              createDom('a', {href: specHref(resultNode.result)}, specDescription)
            )
          );
        }
      }
    }

    function optionsMenu(env) {
      var optionsMenuDom = createDom('div', { className: 'jasmine-run-options' },
        createDom('span', { className: 'jasmine-trigger' }, 'Options'),
        createDom('div', { className: 'jasmine-payload' },
          createDom('div', { className: 'jasmine-stop-on-failure' },
            createDom('input', {
              className: 'jasmine-fail-fast',
              id: 'jasmine-fail-fast',
              type: 'checkbox'
            }),
            createDom('label', { className: 'jasmine-label', 'for': 'jasmine-fail-fast' }, 'stop execution on spec failure')),
          createDom('div', { className: 'jasmine-throw-failures' },
            createDom('input', {
              className: 'jasmine-throw',
              id: 'jasmine-throw-failures',
              type: 'checkbox'
            }),
            createDom('label', { className: 'jasmine-label', 'for': 'jasmine-throw-failures' }, 'stop spec on expectation failure')),
          createDom('div', { className: 'jasmine-random-order' },
            createDom('input', {
              className: 'jasmine-random',
              id: 'jasmine-random-order',
              type: 'checkbox'
            }),
            createDom('label', { className: 'jasmine-label', 'for': 'jasmine-random-order' }, 'run tests in random order'))
        )
      );

      var failFastCheckbox = optionsMenuDom.querySelector('#jasmine-fail-fast');
      failFastCheckbox.checked = env.stoppingOnSpecFailure();
      failFastCheckbox.onclick = function() {
        navigateWithNewParam('failFast', !env.stoppingOnSpecFailure());
      };

      var throwCheckbox = optionsMenuDom.querySelector('#jasmine-throw-failures');
      throwCheckbox.checked = env.throwingExpectationFailures();
      throwCheckbox.onclick = function() {
        navigateWithNewParam('throwFailures', !env.throwingExpectationFailures());
      };

      var randomCheckbox = optionsMenuDom.querySelector('#jasmine-random-order');
      randomCheckbox.checked = env.randomTests();
      randomCheckbox.onclick = function() {
        navigateWithNewParam('random', !env.randomTests());
      };

      var optionsTrigger = optionsMenuDom.querySelector('.jasmine-trigger'),
        optionsPayload = optionsMenuDom.querySelector('.jasmine-payload'),
        isOpen = /\bjasmine-open\b/;

      optionsTrigger.onclick = function() {
        if (isOpen.test(optionsPayload.className)) {
          optionsPayload.className = optionsPayload.className.replace(isOpen, '');
        } else {
          optionsPayload.className += ' jasmine-open';
        }
      };

      return optionsMenuDom;
    }

    function failureDescription(result, suite) {
      var wrapper = createDom('div', {className: 'jasmine-description'},
        createDom('a', {title: result.description, href: specHref(result)}, result.description)
      );
      var suiteLink;

      while (suite && suite.parent) {
        wrapper.insertBefore(createTextNode(' > '), wrapper.firstChild);
        suiteLink = createDom('a', {href: suiteHref(suite)}, suite.result.description);
        wrapper.insertBefore(suiteLink, wrapper.firstChild);

        suite = suite.parent;
      }

      return wrapper;
    }

    function suiteHref(suite) {
      var els = [];

      while (suite && suite.parent) {
        els.unshift(suite.result.description);
        suite = suite.parent;
      }

      return addToExistingQueryString('spec', els.join(' '));
    }

    function addDeprecationWarnings(result) {
      if (result && result.deprecationWarnings) {
        for(var i = 0; i < result.deprecationWarnings.length; i++) {
          var warning = result.deprecationWarnings[i].message;
          if (!j$.util.arrayContains(warning)) {
            deprecationWarnings.push(warning);
          }
        }
      }
    }

    function find(selector) {
      return getContainer().querySelector('.jasmine_html-reporter ' + selector);
    }

    function clearPrior() {
      
      var oldReporter = find('');

      if(oldReporter) {
        getContainer().removeChild(oldReporter);
      }
    }

    function createDom(type, attrs, childrenVarArgs) {
      var el = createElement(type);

      for (var i = 2; i < arguments.length; i++) {
        var child = arguments[i];

        if (typeof child === 'string') {
          el.appendChild(createTextNode(child));
        } else {
          if (child) {
            el.appendChild(child);
          }
        }
      }

      for (var attr in attrs) {
        if (attr == 'className') {
          el[attr] = attrs[attr];
        } else {
          el.setAttribute(attr, attrs[attr]);
        }
      }

      return el;
    }

    function pluralize(singular, count) {
      var word = (count == 1 ? singular : singular + 's');

      return '' + count + ' ' + word;
    }

    function specHref(result) {
      return addToExistingQueryString('spec', result.fullName);
    }

    function seedHref(seed) {
      return addToExistingQueryString('seed', seed);
    }

    function defaultQueryString(key, value) {
      return '?' + key + '=' + value;
    }

    function setMenuModeTo(mode) {
      htmlReporterMain.setAttribute('class', 'jasmine_html-reporter ' + mode);
    }

    function noExpectations(result) {
      return (result.failedExpectations.length + result.passedExpectations.length) === 0 &&
        result.status === 'passed';
    }

    function hasActiveSpec(resultNode) {
      if (resultNode.type == 'spec' && resultNode.result.status != 'excluded') {
        return true;
      }

      if (resultNode.type == 'suite') {
        for (var i = 0, j = resultNode.children.length; i < j; i++) {
          if (hasActiveSpec(resultNode.children[i])) {
            return true;
          }
        }
      }
    }
  }

  return HtmlReporter;
};

jasmineRequire.HtmlSpecFilter = function() {
  function HtmlSpecFilter(options) {
    var filterString = options && options.filterString() && options.filterString().replace(/[-[\]{}()*+?.,\\^$|#\s]/g, '\\$&');
    var filterPattern = new RegExp(filterString);

    this.matches = function(specName) {
      return filterPattern.test(specName);
    };
  }

  return HtmlSpecFilter;
};

jasmineRequire.ResultsNode = function() {
  function ResultsNode(result, type, parent) {
    this.result = result;
    this.type = type;
    this.parent = parent;

    this.children = [];

    this.addChild = function(result, type) {
      this.children.push(new ResultsNode(result, type, this));
    };

    this.last = function() {
      return this.children[this.children.length - 1];
    };

    this.updateResult = function(result) {
      this.result = result;
    };
  }

  return ResultsNode;
};

jasmineRequire.QueryString = function() {
  function QueryString(options) {

    this.navigateWithNewParam = function(key, value) {
      options.getWindowLocation().search = this.fullStringWithNewParam(key, value);
    };

    this.fullStringWithNewParam = function(key, value) {
      var paramMap = queryStringToParamMap();
      paramMap[key] = value;
      return toQueryString(paramMap);
    };

    this.getParam = function(key) {
      return queryStringToParamMap()[key];
    };

    return this;

    function toQueryString(paramMap) {
      var qStrPairs = [];
      for (var prop in paramMap) {
        qStrPairs.push(encodeURIComponent(prop) + '=' + encodeURIComponent(paramMap[prop]));
      }
      return '?' + qStrPairs.join('&');
    }

    function queryStringToParamMap() {
      var paramStr = options.getWindowLocation().search.substring(1),
        params = [],
        paramMap = {};

      if (paramStr.length > 0) {
        params = paramStr.split('&');
        for (var i = 0; i < params.length; i++) {
          var p = params[i].split('=');
          var value = decodeURIComponent(p[1]);
          if (value === 'true' || value === 'false') {
            value = JSON.parse(value);
          }
          paramMap[decodeURIComponent(p[0])] = value;
        }
      }

      return paramMap;
    }

  }

  return QueryString;
};







(function() {

  
  window.jasmine = jasmineRequire.core(jasmineRequire);

  
  jasmineRequire.html(jasmine);

  
  var env = jasmine.getEnv();

  
  var jasmineInterface = jasmineRequire.interface(jasmine, env);

  
  extend(window, jasmineInterface);

  

  var queryString = new jasmine.QueryString({
    getWindowLocation: function() { return window.location; }
  });

  var filterSpecs = !!queryString.getParam("spec");

  var stoppingOnSpecFailure = queryString.getParam("failFast");
  env.stopOnSpecFailure(stoppingOnSpecFailure);

  var throwingExpectationFailures = queryString.getParam("throwFailures");
  env.throwOnExpectationFailure(throwingExpectationFailures);

  var random = queryString.getParam("random");

  if (random !== undefined && random !== "") {
    env.randomizeTests(random);
  }

  var seed = queryString.getParam("seed");
  if (seed) {
    env.seed(seed);
  }

  
  var htmlReporter = new jasmine.HtmlReporter({
    env: env,
    navigateWithNewParam: function(key, value) { return queryString.navigateWithNewParam(key, value); },
    addToExistingQueryString: function(key, value) { return queryString.fullStringWithNewParam(key, value); },
    getContainer: function() { return document.body; },
    createElement: function() { return document.createElement.apply(document, arguments); },
    createTextNode: function() { return document.createTextNode.apply(document, arguments); },
    timer: new jasmine.Timer(),
    filterSpecs: filterSpecs
  });

  
  env.addReporter(jasmineInterface.jsApiReporter);
  env.addReporter(htmlReporter);

  
  var specFilter = new jasmine.HtmlSpecFilter({
    filterString: function() { return queryString.getParam("spec"); }
  });

  env.specFilter = function(spec) {
    return specFilter.matches(spec.getFullName());
  };

  
  window.setTimeout = window.setTimeout;
  window.setInterval = window.setInterval;
  window.clearTimeout = window.clearTimeout;
  window.clearInterval = window.clearInterval;

  
  

  window.jasmineOnload = function() {
    
    
    
    htmlReporter.initialize();
    
  };

  
  function extend(destination, source) {
    for (var property in source) destination[property] = source[property];
    return destination;
  }
}());



$KW.Camera = (function() {

    var module = {

        initialize: function() {
            kony.events.addEvent("click", "Camera", this.eventHandler);
        },

        updateView: function(widgetModel, propertyName, propertyValue, oldPropertyValue) {
           var element = $KU.getNodeByModel(widgetModel);
           if(!element)
               return;
           element = element.firstElementChild;
           switch(propertyName) {
                case "poster":
                    element.setAttribute("poster", $KU.getImageURL(propertyValue));
                    break;
            }
        },

        render: function(widgetModel, context) {
            var computedSkin = $KW.skins.getWidgetSkinList(widgetModel, context);
            var posterImage = widgetModel.poster || "cameraicon.png" ;
            var PosterUrlImage = $KU.getImageURL(posterImage);
            var htmlString = "";
            htmlString = "<div " + $KW.Utils.getBaseHtml(widgetModel, context) + " kwidgettype = 'KCamera'  class= '" + computedSkin + "'>";
            htmlString += "<video autoplay playsinline poster = '" + PosterUrlImage + "' style='height:100%;width:100%' ></video>";
            htmlString += "<canvas style = 'display:none;' </canvas></div>";
            return htmlString;
        },

        isCameraVisible: function(widgetModel) {
            var pModel = null;
            if(!widgetModel.isvisible) {
                return false;
            }
            pModel = widgetModel.parent;
            while(pModel) {
                if (!pModel.isvisible) {
                    return false;
                }
                pModel = pModel.parent;
            }
            return true;
        },

        openCamera: function(widgetModel) {
            if(!module.isCameraVisible(widgetModel))
                return;
            var widgetNode = $KU.getNodeByModel(widgetModel);
            var constraints, feedSource;
            if(!widgetNode)
                return;
            widgetNode = widgetNode.firstElementChild;
            if(widgetModel.cameraSource === constants.CAMERA_SOURCE_REAR) {
                feedSource = "environment";
                constraints = { video: { facingMode: { exact: feedSource } }, audio: true }
            } else {
                feedSource = "user";
                if(kony.appinit.isFirefox) {
                    constraints = { video: { facingMode:  feedSource  }, audio: true }
                } else {
                    constraints = { video: { facingMode: { exact:  feedSource }  }, audio:true };
                }
            }
            if(navigator.mediaDevices && navigator.mediaDevices.getUserMedia) {
                navigator.mediaDevices.getUserMedia(constraints).then(function(stream) {
                    widgetNode.srcObject = stream;
                    widgetNode.play();
                }).catch(function(err) {
                    kony.web.logger("error", "Error: " + err);
                    var onFailEventRef = $KU.returnEventReference(widgetModel.onFailure);
                    if(err.name === "NotAllowedError") {
                        onFailEventRef && $KU.executeWidgetEventHandler(widgetModel, onFailEventRef, constants.CAMERA_PERMISSION_DENIED)
                    } else {
                        if(widgetModel.cameraSource === constants.CAMERA_SOURCE_REAR) {
                            onFailEventRef && $KU.executeWidgetEventHandler(widgetModel, onFailEventRef, constants.CAMERA_SOURCE_REAR_UNAVAILABLE);
                        } else {
                            onFailEventRef && $KU.executeWidgetEventHandler(widgetModel, onFailEventRef, constants.CAMERA_SOURCE_FRONT_UNAVAILABLE);
                        }
                    }
                });
            } else {
                var onFailEventRef = $KU.returnEventReference(widgetModel.onFailure);
                onFailEventRef && $KU.executeWidgetEventHandler(widgetModel, onFailEventRef, constants.CAMERA_NOT_SUPPORTED);
            }
        },

        closeCamera: function(widgetModel) {
            if(!module.isCameraVisible(widgetModel))
                return;
            var widgetNode = $KU.getNodeByModel(widgetModel);
            if(!widgetNode)
                return;
            widgetNode = widgetNode.firstElementChild;
            var tracks = [], i;
            if(widgetNode.srcObject) {
                tracks = widgetNode.srcObject.getTracks();
                for(i = 0; i < tracks.length; i++) {
                    tracks[i].stop();
                }
                widgetNode.srcObject = null;
            }
        },

        takePicture: function(widgetModel) {
            var scale = $KU.dpi;
            if(!module.isCameraVisible(widgetModel))
                return;
            var widgetNode = $KU.getNodeByModel(widgetModel);
            if(!widgetNode)
                return;
            widgetNode = widgetNode.firstElementChild;
            if(widgetModel.isvisible && widgetNode.srcObject) {
                var imageCanvas = $KU.getNodeByModel(widgetModel).lastElementChild;
                imageCanvas.height = widgetModel.frame.height * scale;
                imageCanvas.width = widgetModel.frame.width * scale;
                var context = imageCanvas.getContext('2d');
                context.scale(scale, scale);
                try {
                    context.drawImage(widgetNode , 0, 0, widgetModel.frame.height, widgetModel.frame.width);
                    widgetModel.rawbytes = imageCanvas.toDataURL().split(",")[1];
                    if(widgetModel.rawbytes){
                        var onCaptureEventRef = $KU.returnEventReference(widgetModel.oncapture);
                        onCaptureEventRef && $KU.executeWidgetEventHandler(widgetModel, onCaptureEventRef);
                    }
                } catch(err) {
                    var onCaptureFailEventRef = $KU.returnEventReference(widgetModel.oncapturefailure);
                    onCaptureFailEventRef && $KU.executeWidgetEventHandler(widgetModel, onCaptureFailEventRef);
                    var onFailEventRef = $KU.returnEventReference(widgetModel.onfailure);
                    onFailEventRef && $KU.executeWidgetEventHandler(widgetModel, onFailEventRef, constants.CAMERA_CAPTURE_FAILED);
                }
            }
        },

        startVideoCapture: function(widgetModel, config) {
            if(!module.isCameraVisible(widgetModel))
                return;
            var widgetNode = $KU.getNodeByModel(widgetModel);
            var constraints, feedSource, tracks = [], i;
            if(!widgetNode)
                return;
            widgetNode = widgetNode.firstElementChild;
            if(!widgetNode.srcObject)
                return;
            if(widgetModel.cameraSource === constants.CAMERA_SOURCE_REAR) {
                var feedSource = "environment";
                constraints = { video: { facingMode: { exact: feedSource } }, audio:true };
            } else {
                var feedSource = "user";
                if(kony.appinit.isFirefox) {
                    constraints = { video: { facingMode:  feedSource  }, audio:true }
                } else {
                    constraints = { video: { facingMode: { exact:  feedSource }  }, audio:true };
                }
            }
            if(navigator.mediaDevices && navigator.mediaDevices.getUserMedia) {
                navigator.mediaDevices.getUserMedia(constraints).then(function(stream) {
                    widgetModel.videoData = [];
                    widgetModel.Recorder = new MediaRecorder(stream);
                    widgetModel.Recorder.start();
                    kony.web.logger("log", widgetModel.Recorder.state);
                    if(widgetModel.videoDuration && config.callback) {
                        setTimeout(function() {
                            if(widgetModel.Recorder.state === "recording") {
                                widgetModel.Recorder.stop();
                                tracks = widgetModel.Recorder.stream.getTracks();
                                for(i = 0; i < tracks.length; i++) {
                                    tracks[i].stop();
                                }
                                $KW.Camera.dataAvailableCreateBlob(widgetModel, config.callback);
                            } else {
                                var onFailEventRef = $KU.returnEventReference(widgetModel.onFailure);
                                onFailEventRef && $KU.executeWidgetEventHandler(widgetModel, onFailEventRef, constants.CAMERA_VIDEO_RECORDING_FAILED);
                            }
                        }, widgetModel.videoDuration*1000);
                    }
                }).catch(function(err) {
                    kony.web.logger("error", "Error: " + err);
                    var onFailEventRef = $KU.returnEventReference(widgetModel.onFailure);
                    onFailEventRef && $KU.executeWidgetEventHandler(widgetModel, onFailEventRef, constants.CAMERA_VIDEO_RECORDING_FAILED);
                });
            } else {
                var onFailEventRef = $KU.returnEventReference(widgetModel.onFailure);
                onFailEventRef && $KU.executeWidgetEventHandler(widgetModel, onFailEventRef, constants.CAMERA_NOT_SUPPORTED);
            }
        },

        dataAvailableCreateBlob: function(widgetModel, callback) {
            widgetModel.Recorder.ondataavailable = function(e) {
                widgetModel.videoData.push(e.data);
                if(widgetModel.Recorder.state === "inactive") {
                    widgetModel.blob = new Blob(widgetModel.videoData, { type:'video/mp4' });
                    widgetModel.videoUrl = URL.createObjectURL(widgetModel.blob);
                    var configCallback = $KU.returnEventReference(callback);
                    configCallback && $KU.executeWidgetEventHandler(widgetModel, configCallback, widgetModel.videoUrl);
                }
            }
        },

        stopVideoCapture: function(widgetModel, config) {
            if(!module.isCameraVisible(widgetModel))
                return;
            var tracks = [], i;
            if(widgetModel.isvisible && config.callback && widgetModel.Recorder && widgetModel.Recorder.state === "recording") {
                widgetModel.Recorder.stop();
                tracks = widgetModel.Recorder.stream.getTracks();
                for(i = 0; i < tracks.length; i++) {
                    tracks[i].stop();
                }
                $KW.Camera.dataAvailableCreateBlob(widgetModel, config.callback);
            } else {
                var onFailEventRef = $KU.returnEventReference(widgetModel.onFailure);
                onFailEventRef && $KU.executeWidgetEventHandler(widgetModel, onFailEventRef, constants.CAMERA_VIDEO_RECORDING_FAILED);
            }
        },

        eventHandler: function(eventObject, target) {
            var widgetModel = $KU.getModelByNode(target);
            if(!target.firstElementChild.srcObject)
                $KW.Camera.openCamera(widgetModel);
        }
    }
    return module;

}());


$KW.Canvas = (function() {
    

    var DEFAULT_DASHLINECONFIG  = [1, 1],
        DEFAULT_SHAPECOLOR = "00000000",
        SOLIDLINECONFIG = [],
        DEFAULT_THICKNESS = 1;

    var clearRect = function(canvasModel, ctx) {
        ctx.clearRect(0, 0, canvasModel.frame.width, canvasModel.frame.height);
    };

    var drawLine = function(ctx, shape, widgetFrame){
        var lconfiglen = 0, index = 0, lineConfig = shape.lineStyleConfig,
            lineWidth = DEFAULT_THICKNESS, points = shape.points, linepts = [];
        if(points && points.length == 2) {
            linepts.push(getValue(points[0][0], 'x', widgetFrame));
            linepts.push(getValue(points[0][1], 'y', widgetFrame));
            linepts.push(getValue(points[1][0], 'x', widgetFrame));
            linepts.push(getValue(points[1][1], 'y', widgetFrame));
            ctx.beginPath();
            if(kony.canvas.LINE_STYLE_DASHED === shape.lineStyle
            || kony.canvas.LINE_STYLE_DOTTED === shape.lineStyle) {
                if(lineConfig){
                    lconfiglen = lineConfig.length -1;
                    for(index = 0; index <= lconfiglen; index++) {
                        lineConfig[index] = getValue(lineConfig[index]);
                    }
                } else {
                    lineConfig = DEFAULT_DASHLINECONFIG;
                }
                ctx.setLineDash(lineConfig);
            } else {
                ctx.setLineDash(SOLIDLINECONFIG);
            }

            

            if(shape.thickness) {
                lineWidth = getValue(shape.thickness);
            }
            ctx.lineWidth = lineWidth;
            ctx.strokeStyle = getStrokeStyle(ctx, shape.strokeColor, linepts, lineWidth);
            ctx.moveTo(linepts[0], linepts[1]);
            ctx.lineTo(linepts[2], linepts[3]);
            ctx.stroke();
        }
    };

    var getStrokeStyle = function(ctx, strokeColor, points, lineThickness) {
        var strokeStyle = $KW.skins.convertHexValuetoRGBA(DEFAULT_SHAPECOLOR);

        if(strokeColor) {
            if(typeof strokeColor === 'string') {
                strokeStyle = $KW.skins.convertHexValuetoRGBA(strokeColor);
            } else if(typeof strokeColor === 'object') {
                switch(strokeColor.color_type) {
                    case 'one':
                        strokeStyle = $KW.skins.convertHexValuetoRGBA(strokeColor.color);
                        break;
                    case 'two':
                        strokeStyle = getStrokeStyleTwoStepGradient(ctx, strokeColor, points, lineThickness);
                        break;
                    case 'ms_gradient':
                        strokeStyle = getStrokeStyleMSGradient(ctx, strokeColor, points, lineThickness);
                        break;
                }
            }
        }
        return strokeStyle;
    };

    var getStrokeStyleTwoStepGradient = function(ctx, strokeColor, points, lineThickness) {
        var gradient = null, x1 = 0, x2 = 0, y1 = 0, y2 = 0, topcolor = '',
            bottomcolor = '', thinknessby2 = parseFloat(lineThickness/2);

        topcolor = $KW.skins.convertHexValuetoRGBA(strokeColor.top_color);
        bottomcolor = $KW.skins.convertHexValuetoRGBA(strokeColor.bottom_color);
        if(strokeColor.style == "hg" || strokeColor.style == "hs") {
            x1 = points[0];
            y1 = points[1];
            x2 = points[2];
            y2 = points[3];
        } else if(strokeColor.style == "vg" || strokeColor.style == "vs") {
            x1 = points[0];
            y1 = (points[1] - thinknessby2);
            x2 = points[0];
            y2 = (points[1] + thinknessby2);
        }
        gradient = ctx.createLinearGradient(x1, y1, x2, y2);
        gradient.addColorStop(0, topcolor);
        if(strokeColor.style == "vs" || strokeColor.style == "hs") {
            gradient.addColorStop(0.5, topcolor);
            gradient.addColorStop(0.5, bottomcolor);
        }
        gradient.addColorStop(1, bottomcolor);

        return gradient;
    };

    var getStrokeStyleMSGradient = function(ctx, strokeColor, points, lineThickness) {
        var gradient = null, x1 = 0, x2 = 0, y1 = 0, y2 = 0,
            i = 0, thinknessby2 = parseFloat(lineThickness/2);

        if('toRight' == strokeColor.gradientType) {
            x1 = points[0];
            y1 = points[1];
            x2 = points[2];
            y2 = points[3];
        } else if('toLeft' == strokeColor.gradientType) {
            x1 = points[2];
            y1 = points[3];
            x2 = points[0];
            y2 = points[1];
        } else if('toBottom' == strokeColor.gradientType) {
            x1 = points[0];
            y1 = (points[1] - thinknessby2);
            x2 = points[0];
            y2 = (points[1] + thinknessby2);
        } else if('toTop' == strokeColor.gradientType) {
            x1 = points[0];
            y1 = (points[1] + thinknessby2);
            x2 = points[0];
            y2 = (points[1] - thinknessby2);
        }
        gradient = ctx.createLinearGradient(x1, y1, x2, y2);
        for(i = 0; i < strokeColor.colors.length && i < strokeColor.cs.length; i++) {
            gradient.addColorStop(parseFloat(strokeColor.cs[i])/100,  $KW.skins.convertHexValuetoRGBA(strokeColor.colors[i]));
        }

        return gradient;
    };

    var getIndexFromShapesData = function(canvasModel, shapeId) {
        var i = 0, data = canvasModel.shapesdata, returnIndex = -1;
        if(data && data.length > 0) {
            for(i = 0; i < data.length; i++) {
                if(data[i].shapeid === shapeId) returnIndex = i;
            }
        }
        return returnIndex;
    };

    var getValue = function(value, axis, widgetFrame){
        var valueObj = $KW.FlexUtils.splitValueAndUnit(value);
        return $KW.FlexUtils.getValueByWidgetFrame(valueObj, axis, widgetFrame);
    };

    var updateShapeData = function(canvasModel, shapeData) {
        var key, returnflag = false, existingShapeData = {}, updateData = {},
            index = getIndexFromShapesData(canvasModel, shapeData.shapeid);

        if(index !== -1) {
            existingShapeData = canvasModel.shapesdata[index];
            for(key in existingShapeData) {
                if(existingShapeData.hasOwnProperty(key)) {
                    updateData[key] = existingShapeData[key]
                }
            }
            for(key in shapeData) {
                if(shapeData.hasOwnProperty(key) || key !== 'shapeType') {
                    updateData[key] = shapeData[key]
                }
            }

            if(kony.canvas.SHAPE_TYPE_LINE === updateData.shapeType) {
                validateLineData(updateData);
            }

            canvasModel.shapesdata[index] = updateData;
            returnflag = true;
        }
        return returnflag;
    };

    var getDataObj = function(dataArr) {
        var i = 0, returnDataObj = {};
        if(dataArr && dataArr.length > 0) {
            for(i = 0; i < dataArr.length; ++i) {
                returnDataObj[dataArr[i].shapeid] = dataArr[i];
            }
        }
        return returnDataObj;
    };

    var validateShapesData = function(dataArr) {
        var i = 0, len = 0, validDataObj = {};
        if(dataArr instanceof Array) {
            len = dataArr.length - 1;
            for(i = 0; i <= len; ++i) {
                if(!dataArr[i].shapeid) {
                    throw new KonyError(6001, "Invalid shapesData", "shapesData does not have mandatory value shapeid.");
                } else if(!dataArr[i].shapeType) {
                    throw new KonyError(6001, "Invalid shapesData", "shapesData does not have mandatory value shapeType.");

                } else if(validDataObj[dataArr[i].shapeid]) {
                    throw new KonyError(6002, "Invalid shapesData", "shapesData has duplicate shape identifier. " + dataArr[i].shapeid);
                } else {
                    if(kony.canvas.SHAPE_TYPE_LINE === dataArr[i].shapeType) {
                        validateLineData(dataArr[i]);
                    } else {
                        throw new KonyError(6001, "Invalid shapesData", "Not a valid shapeType.");
                    }
                    validDataObj[dataArr[i].shapeid] = dataArr[i];
                }
            }
        }
    };

    var validateLineData = function(shapeLineData) {
        validateLinePts(shapeLineData.points);
    };

    var validateLinePts = function(points, flag) {
        var innerDataValidDataFlag = (typeof flag != 'undefined' ? flag : true);

        if(points instanceof Array) {
            if(points.length != 2 ) {
                throw new KonyError(6001, "Invalid shapesData", "shapesData does not have mandatory value points for shapeType line.");
            } else if(innerDataValidDataFlag) {
               validateLinePts(points[0], false);
               validateLinePts(points[1], false);
            }
        } else {
            throw new KonyError(6001, "Invalid shapesData", "shapesData does not have mandatory value points for shapeType line.");
        }
    };

    
    var _addShapes = function(canvasModel, shapesDataArr) {
        var i = 0, addData = [], existingDataObj = getDataObj(canvasModel.shapesdata);
        if(shapesDataArr && shapesDataArr.length > 0) {
            for(i = 0; i < shapesDataArr.length; ++i) {
                 if(existingDataObj[shapesDataArr[i].shapeid]) {
                    throw new KonyError('CanvasError', 'addShapes:: already shapeid exists');
                 } else {
                    addData.push(shapesDataArr[i]);
                 }
            }
            canvasModel.shapesdata = canvasModel.shapesdata.concat(addData);
            _drawShapesOnCanvas(canvasModel);
        }
    };

    var _clearCanvas = function(canvasModel) {
        var ctx, canvasNode = $KU.getNodeByModel(canvasModel);;
        ctx = canvasNode.getContext('2d');
        canvasModel.shapesdata = [];
        clearRect(canvasModel, ctx);
    };

    var _drawShapesOnCanvas = function(canvasModel, canvasNode) {
        var index = 0, shape = null, ctx = null, scale = $KU.dpi,
        shapesdata = canvasModel.shapesdata, len = 0;
        canvasNode = canvasNode || $KU.getNodeByModel(canvasModel);
        canvasNode.width = canvasModel.frame.width * scale;
        canvasNode.height = canvasModel.frame.height * scale;
        ctx = canvasNode.getContext('2d');
        ctx.scale(scale, scale);
        clearRect(canvasModel, ctx);
        len = shapesdata ? shapesdata.length - 1 : -1;
        for(index = 0; index <= len ; index++) {
            shape = shapesdata[index];
            if(kony.canvas.SHAPE_TYPE_LINE === shape.shapeType) {
                drawLine(ctx, shape, canvasModel.frame);
            }
        }
    };

    var _removeShapes = function(canvasModel, shapeIds) {
        var index = -1, loopIndex = 0, isremoved = false;
        for(loopIndex = 0; loopIndex < shapeIds.length; ++loopIndex) {
            index = getIndexFromShapesData(canvasModel, shapeIds[loopIndex]);
            if(index != -1) {
                canvasModel.shapesdata.splice(index, 1);
                isremoved = true;
            }
        }
        isremoved && _drawShapesOnCanvas(canvasModel);
    };

    var _updateShapes = function(canvasModel, shapesData) {
        var loopIndex = 0, isupdated = false;
        for(loopIndex = 0; loopIndex < shapesData.length; ++loopIndex) {
            isupdated = updateShapeData(canvasModel, shapesData[loopIndex]) || isupdated;
        }
        isupdated && _drawShapesOnCanvas(canvasModel);
    };

    

    var module = {

        onWidgetLayout: function(canvasModel, canvasNode) {
            validateShapesData(canvasModel.shapesdata);
            _drawShapesOnCanvas(canvasModel, canvasNode);
        },

        addShapes: function(canvasModel, shapesData) {
            validateShapesData(shapesData);
            _addShapes(canvasModel, shapesData);
        },

        updateShapes: function(canvasModel, shapesData) {
            _updateShapes(canvasModel, shapesData);
        },

        removeShapes: function(canvasModel, shapeIds) {
            _removeShapes(canvasModel, shapeIds);
        },

        clear: function(canvasModel) {
            _clearCanvas(canvasModel);
        },

        updateView: function(canvasModel, propertyName, propertyValue, oldPropertyValue) {
            switch(propertyName) {
                case "shapesdata":
                    var element = $KU.getNodeByModel(canvasModel);
                    if(element) {
                        validateShapesData(canvasModel.shapesdata);
                        _drawShapesOnCanvas(canvasModel, element);
                    }
                    break;
            }
        },

        render: function(canvasModel, context) {
            var htmlString = "";
            var baseHtmlStr = $KW.Utils.getBaseHtml(canvasModel, context);
            var computedSkin = $KW.skins.getWidgetSkinList(canvasModel, context);
            htmlString += "<canvas " + baseHtmlStr + " style='" + $KW.skins.getPaddingSkin(canvasModel) + " " + $KW.skins.getBaseStyle(canvasModel, context) + "' class='" + computedSkin + "'>";
            htmlString += "</canvas>";
            return htmlString;
        }
     };


    return module;
}());

kony.inherits = function(subClass, baseClass) {
    function inherit() {}

    inherit.prototype = baseClass.prototype;
    subClass.prototype = new inherit();
    subClass.prototype.constructor = subClass;
    subClass.baseConstructor = baseClass;
    subClass.superClass = baseClass.prototype;
};

kony.ui = {
    Widget: function(bconfig, lconfig, pspconfig) {
        
        if(arguments.length < 3)
            throw new KonyError(101, "Error", "Invalid number of arguments"); 

        if(bconfig.id === undefined || bconfig.id === null || bconfig.id === '') {
            throw new KonyError(1102, 'WidgetError', 'Widget cannot be created due to invalid input data.');
        }
        this.constructorList = [bconfig, lconfig, pspconfig];
        this.id = bconfig.id;
        this.focusskin = bconfig.focusSkin;
        this.isvisible = bconfig.isVisible === undefined ? true : (bconfig.isVisible && true);
        bconfig.i18n_text && (this.i18n_text = bconfig.i18n_text);
        this.containerweight = lconfig.containerWeight || 0;

        this.retainflexpositionproperties = this.retainFlexPositionProperties = lconfig.retainFlexPositionProperties;
        this.retaincontentalignment = this.retainContentAlignment = lconfig.retainContentAlignment;

        var requireContentAlignment = $KW.FlexUtils.shouldApplyRTL(this, "contentAligment");

        this.contentalignment = (requireContentAlignment) ? $KW.Utils.getMirrorAlignment(lconfig.contentAlignment) : lconfig.contentAlignment; 
        this.isContentAlignmentMirrored = requireContentAlignment;

        this.widgetalignment = lconfig.widgetAlignment;
        this.marginInPixel = lconfig.marginInPixel;
        this.paddingInPixel = lconfig.paddingInPixel;
        this.hexpand = (typeof lconfig.hExpand == "undefined") ? false : lconfig.hExpand;

        this.enabled = false;
        this.canUpdateUI = true;
        this.onclick = bconfig.onClick;
        if($KC.widgetDataRecording == true) {
            this._internals = {
                'clientBounds' : {},
                'touchEventsTimeConsumed': {}
            };
        }
        this.accessibilityconfig = bconfig.accessibilityConfig;
        this.widgetswipemove = bconfig.widgetSwipeMove;

        defineGetter(this, "widgetSwipeMove", function() {
            return this.widgetswipemove;
        });

        defineSetter(this, "widgetSwipeMove", function(val) {
            var oldValue = this.widgetswipemove;
            this.widgetswipemove = val;
            kony.model.updateView(this, "widgetSwipeMove", val, oldValue);
        });

        defineGetter(this, "accessibilityConfig", function() {
            return this.accessibilityconfig;
        });

        defineSetter(this, "accessibilityConfig", function(val) {
            var oldValue = this.accessibilityconfig;
            this.accessibilityconfig = val;
            kony.model.updateView(this, "accessibilityConfig", val, oldValue);

        });

        var requireFlexRTL = $KW.FlexUtils.shouldApplyRTL(this, "flexPosition");
        this._margin = (!lconfig.margin) ? [0, 0, 0, 0] : lconfig.margin;
        defineGetter(this, "margin", function() {
            return this._margin;
        });
        defineSetter(this, "margin", function(val) {
            this._margin = val;
            $KU.isArray(val) && kony.model.updateView(this, "margin", val);
        });

        this._padding = (!lconfig.padding) ? [0, 0, 0, 0] : (requireFlexRTL) ? $KW.Utils.getMirroredMarginPadding(lconfig.padding) : lconfig.padding;
        defineGetter(this, "padding", function() {
            return this._padding;
        });
        defineSetter(this, "padding", function(val) {
            var oldvalue = this._padding;
            this._padding = val;
            $KU.isArray(val) && kony.model.updateView(this, "padding", val);
            var iscontentDriven = $KU.inArray($KU.contentDrivenWidgets, this.wType)[0];
            iscontentDriven && $KW.FlexUtils.setLayoutConfig(this, val, oldvalue);
        });

        this._skin = bconfig.skin;
        defineGetter(this, "skin", function() {
            return this._skin;
        });
        defineSetter(this, "skin", function(val) {
            var oldvalue = this._skin;
            this._skin = val;
            if(this.canUpdateUI) { 
                kony.model.updateView(this, "skin", val, oldvalue);
                var iscontentDriven = $KU.inArray($KU.contentDrivenWidgets, this.wType)[0];
                iscontentDriven && $KW.FlexUtils.setLayoutConfig(this, val, oldvalue);
            }
        });

        this.disabled = (typeof bconfig.enable === 'boolean') ? !bconfig.enable : false;
        defineGetter(this, "enable", function() {
            return !this.disabled;
        });
        defineSetter(this, "enable", function(val) {
            this.disabled = !val;
            $KW.APIUtils.setenabled(this, val);
        });


        this.onDrag = bconfig.onDrag;
        this.frame = {
            x: 0,
            y: 0,
            width: 0,
            height: 0
        };
        this.layoutConfig = {
            self: true,
            children: false
        };

        this._left = (requireFlexRTL) ? bconfig.right : bconfig.left;
        defineGetter(this, "left", function() {
            return this._left;
        });
        defineSetter(this, "left", function(val) {
            var oldvalue = this._left;
            this._left = val;
            $KW.FlexUtils.setLayoutConfig(this, val, oldvalue);
            $KW.FlexUtils.handleContainerData(this, val, "left");
        });

        this._right = (requireFlexRTL) ? bconfig.left : bconfig.right;
        defineGetter(this, "right", function() {
            return this._right;
        });
        defineSetter(this, "right", function(val) {
            var oldvalue = this._right;
            this._right = val;
            $KW.FlexUtils.setLayoutConfig(this, val, oldvalue);
            $KW.FlexUtils.handleContainerData(this, val, "right");
        });

        this.isFlexPositionPropertiesMirrored = requireFlexRTL;

        this._top = bconfig.top;
        defineGetter(this, "top", function() {
            return this._top;
        });
        defineSetter(this, "top", function(val) {
            var oldvalue = this._top;
            this._top = val;
            $KW.FlexUtils.setLayoutConfig(this, val, oldvalue);
            $KW.FlexUtils.handleContainerData(this, val, "top");
        });

        this._bottom = bconfig.bottom;
        defineGetter(this, "bottom", function() {
            return this._bottom;
        });
        defineSetter(this, "bottom", function(val) {
            var oldvalue = this._bottom;
            this._bottom = val;
            $KW.FlexUtils.setLayoutConfig(this, val, oldvalue);
            $KW.FlexUtils.handleContainerData(this, val, "bottom");
        });

        this._width = bconfig.width;
        defineGetter(this, "width", function() {
            return this._width;
        });
        defineSetter(this, "width", function(val) {
            var oldvalue = this._width;
            this._width = val;
            $KW.FlexUtils.setLayoutConfig(this, val, oldvalue);
            $KW.FlexUtils.handleContainerData(this, val, "width");
        });

        this._height = bconfig.height;
        defineGetter(this, "height", function() {
            return this._height;
        });
        defineSetter(this, "height", function(val) {
            var oldvalue = this._height;
            this._height = val;
            $KW.FlexUtils.setLayoutConfig(this, val, oldvalue);
            $KW.FlexUtils.handleContainerData(this, val, "height");
        });

        this.minwidth = bconfig.minWidth;
        defineGetter(this, "minWidth", function() {
            return this.minwidth;
        });
        defineSetter(this, "minWidth", function(val) {
            var oldvalue = this.minwidth;
            this.minwidth = val;
            $KW.FlexUtils.setLayoutConfig(this, val, oldvalue);
            $KW.FlexUtils.handleContainerData(this, val, "minWidth");
        });

        this.maxwidth = bconfig.maxWidth;
        defineGetter(this, "maxWidth", function() {
            return this.maxwidth;
        });
        defineSetter(this, "maxWidth", function(val) {
            var oldvalue = this.maxwidth;
            this.maxwidth = val;
            $KW.FlexUtils.setLayoutConfig(this, val, oldvalue);
            $KW.FlexUtils.handleContainerData(this, val, "maxWidth");
        });

        this.minheight = bconfig.minHeight;
        defineGetter(this, "minHeight", function() {
            return this.minheight;
        });
        defineSetter(this, "minHeight", function(val) {
            var oldvalue = this.minheight;
            this.minheight = val;
            $KW.FlexUtils.setLayoutConfig(this, val, oldvalue);
            $KW.FlexUtils.handleContainerData(this, val, "minHeight");
        });

        this.maxheight = bconfig.maxHeight;
        defineGetter(this, "maxHeight", function() {
            return this.maxheight;
        });
        defineSetter(this, "maxHeight", function(val) {
            var oldvalue = this.maxheight;
            this.maxheight = val;
            $KW.FlexUtils.setLayoutConfig(this, val, oldvalue);
            $KW.FlexUtils.handleContainerData(this, val, "maxHeight");
        });

        this.centerx = bconfig.centerX;
        defineGetter(this, "centerX", function() {
            return this.centerx;
        });
        defineSetter(this, "centerX", function(val) {
            var oldvalue = this.centerx;
            this.centerx = val;
            $KW.FlexUtils.setLayoutConfig(this, val, oldvalue);
            $KW.FlexUtils.handleContainerData(this, val, "centerX");
        });

        this.centery = bconfig.centerY;
        defineGetter(this, "centerY", function() {
            return this.centery;
        });
        defineSetter(this, "centerY", function(val) {
            var oldvalue = this.centery;
            this.centery = val;
            $KW.FlexUtils.setLayoutConfig(this, val, oldvalue);
            $KW.FlexUtils.handleContainerData(this, val, "centerY");
        });

        this.zindex = bconfig.zIndex || 1;
        defineGetter(this, "zIndex", function() {
            return this.zindex;
        });
        defineSetter(this, "zIndex", function(val) {
            if(this.zindex !== val) {
                this.zindex = val;
                kony.model.updateView(this, "zindex", val);
                $KU.checkAndReCalculateTopFlexModal(this);
            }
        });

        this.dolayout = bconfig.doLayout;
        defineGetter(this, "doLayout", function() {
            return this.dolayout;
        });
        defineSetter(this, "doLayout", function(val) {
            this.dolayout = val;
        });

        this._opacity = (typeof bconfig.opacity == "undefined") ? 1 : bconfig.opacity;
        defineGetter(this, "opacity", function() {
            return this._opacity;
        });
        defineSetter(this, "opacity", function(val) {
            this._opacity = val;
            kony.model.updateView(this, "opacity", val);
        });

        this._transform = bconfig.transform;
        defineGetter(this, "transform", function() {
            return this._transform;
        });
        defineSetter(this, "transform", function(val) {
            this._transform = val;
            kony.model.updateView(this, "transform", val);
        });

        this.anchorpoint = bconfig.anchorPoint;
        defineGetter(this, "anchorPoint", function() {
            return this.anchorpoint;
        });
        defineSetter(this, "anchorPoint", function(val) {
            anchorpoint = val;
            kony.model.updateView(this, "anchorpoint", val);
        });

        this.backgroundcolor = bconfig.backgroundColor;
        defineGetter(this, "backgroundColor", function() {
            return this.backgroundcolor;
        })
        defineSetter(this, "backgroundColor", function(val) {
            this.backgroundcolor = val;
            kony.model.updateView(this, "backgroundcolor", val);
        });

        this.borderwidth = bconfig.borderWidth;
        defineGetter(this, "borderWidth", function() {
            return this.borderwidth;
        })
        defineSetter(this, "borderWidth", function(val) {
            this.borderwidth = val;
            kony.model.updateView(this, "borderwidth", val);
        });


        this.bordercolor = bconfig.borderColor;
        defineGetter(this, "borderColor", function(val) {
            return this.bordercolor;
        })
        defineSetter(this, "borderColor", function(val) {
            this.bordercolor = val;
            kony.model.updateView(this, "bordercolor", val);
        });

        this.cornerradius = bconfig.cornerRadius;
        defineGetter(this, "cornerRadius", function() {
            return this.cornerradius;
        })
        defineSetter(this, "cornerRadius", function(val) {
            this.cornerradius = val;
            kony.model.updateView(this, "cornerradius", val);
        });

        defineGetter(this, "shadowColor", function() {
            return this.shadowcolor;
        });

        defineSetter(this, "shadowColor", function(val) {
            this.shadowcolor = val;
            kony.model.updateView(this, "shadowcolor", val);
        });

        defineGetter(this, "shadowRadius", function() {
            return this.shadowradius;
        });

        defineSetter(this, "shadowRadius", function(val) {
            this.shadowradius = val;
            kony.model.updateView(this, "shadowradius", val);
        });

        defineGetter(this, "shadowOffset", function() {
            return this.shadowoffset;
        });

        defineSetter(this, "shadowOffset", function(val) {
            this.shadowoffset = val;
            kony.model.updateView(this, "shadowoffset", val);
        });

       this.flexblur = bconfig.blur || {
            enabled: false,
            value: 0
        };
        defineGetter(this, "blur", function() {
            return this.flexblur;
        });
        defineSetter(this, "blur", function(val) {
            var oldVal = this.flexblur;
            this.flexblur = val;
            if(val && (val.enabled == undefined || val.value == undefined)) {
                this.flexblur = oldVal;
                throw new KonyError(102, "Exception", "Invalid input.");
            }
            kony.model.updateView(this, "flexblur", val, oldVal);
        });

        kony.ui.Widget.prototype.setGetterSetter.call(this);

        
        this.onTouchStart = bconfig.onTouchStart;
        this.onTouchMove = bconfig.onTouchMove;
        this.onTouchEnd = bconfig.onTouchEnd;
        this.onscrollwidgetposition = bconfig.onScrollWidgetPosition;
        this.layouttype = lconfig.layoutType || kony.flex.VBOX_LAYOUT;
        this.layoutmeta = lconfig.layoutMeta;
        this.gridCell = lconfig.gridCell;
        this.onhover = pspconfig.onHover;
        this.cursortype = pspconfig.cursorType;
    },

    ContainerWidget: function(bconfig, lconfig, pspconfig) {
        kony.ui.ContainerWidget.baseConstructor.call(this, bconfig, lconfig, pspconfig);

        if(this.name != "kony.ui.FlexContainer")
            this.orientation = bconfig.orientation || constants.BOX_LAYOUT_HORIZONTAL;
        this.percent = (lconfig.percent === undefined) ? true : lconfig.percent;
        if(this.percent === false) this.widgetdirection = lconfig.layoutAlignment; 
        this.isContainerWidget = true;
        
        this.ownchildrenref = [];
        this.children = [];
    },

    GroupWidget: function(bconfig, lconfig, pspconfig) {
        kony.ui.GroupWidget.baseConstructor.call(this, bconfig, lconfig, pspconfig);
        this.onselection = bconfig.onSelection;
        this.masterdata = bconfig.masterData;
        this.masterdatamap = bconfig.masterDataMap;
        this.selectedkeyvalue = null;
        this.selectedkey = bconfig.selectedKey || null;
        kony.ui.GroupWidget.prototype.setGetterSetter.call(this);
    },

    createAnimation: function(animDef) {
        
        $KU.logExecuting('kony.ui.createAnimation');
        $KU.logExecutingWithParams('kony.ui.createAnimation', animDef);
        $KU.logExecutingFinished('kony.ui.createAnimation');
        return new $KW.Animator(animDef);
    },

    makeAffineTransform: function() {
        
        $KU.logExecuting('kony.ui.makeAffineTransform');
        $KU.logExecutingWithParams('kony.ui.makeAffineTransform');
        $KU.logExecutingFinished('kony.ui.makeAffineTransform');
        return new $KW.Transform();
    },

    enableCapturingAnimationRuntimeData: function() {
        $KG.appbehaviors["captureAniamtionData"] = true;
    },

    disableCapturingAnimationRuntimeData: function() {
        $KG.appbehaviors["captureAniamtionData"] = false;
    }

};

kony.inherits(kony.ui.GroupWidget, kony.ui.Widget);
kony.inherits(kony.ui.ContainerWidget, kony.ui.Widget);


kony.ui.Widget.prototype.setVisibility = function(isvisible) {
    var oldValue = this.isvisible, parentModel = this.parent, counter;

    if($KG.appbehaviors["lazyLoadDOM"] == true) {
        if(isvisible == true && this._isRendered != true) {
            this.isvisible = isvisible;
            counter = $KU.getWidgetVisibleIndex(parentModel, this);
            $KW.FlexContainer.addChildat(parentModel, [this], null, counter);
        }
        if(oldValue != isvisible) {
            $KW.APIUtils.setvisibility(this, isvisible);
            $KU.checkAndReCalculateTopFlexModal(this);
        }
    }
    else {
        $KW.APIUtils.setvisibility(this, isvisible);
        $KU.checkAndReCalculateTopFlexModal(this);
    }



};

kony.ui.Widget.prototype.setFocus = function() {
    $KW.APIUtils.setfocus(this);
};

kony.ui.Widget.prototype.setEnabled = function(isenabled) {
    $KW.APIUtils.setenabled(this, isenabled);
};

kony.ui.Widget.prototype.addGestureRecognizer = function(gesturetype, setupparams, gesturehandler) {
    return($KW.Widget.addgesturerecognizer(this, gesturetype, setupparams, gesturehandler));
};

kony.ui.Widget.prototype.setGestureRecognizer = function(gesturetype, setupparams, gesturehandler) {
    return($KW.Widget.setgesturerecognizer(this, gesturetype, setupparams, gesturehandler));
};

kony.ui.Widget.prototype.removeGestureRecognizer = function(gesturetype) {
    $KW.Widget.removegesturerecognizer(this, gesturetype);
};


kony.ui.Widget.prototype.toString = function() {
    return JSON.stringify(this, $KU.jsonReplacer);
};

kony.ui.Widget.prototype.removeFromParent = function() {
    
    if(!this.parent)
        return;
    if(this.parent.id == this.pf)
        formWidgetExtendRemove.call(this.parent, this);
    else
        boxWidgetExtendRemove.call(this.parent, this);
};

kony.ui.Widget.prototype.setWidgetFrame = function(frame, wNode) {
    $KW.Utils.setWidgetFrame(this, frame, wNode);
};

kony.ui.Widget.prototype.animate = function(animInstance, animationConfig, animCallbackConfig) {
    if(animInstance) {
        
        animInstance.animate && animInstance.animate(this, animationConfig, animCallbackConfig);
    }
};

kony.ui.Widget.prototype.getPreferredSize = function(frame) {
    return $KW.FlexUtils.getPreferredSize(this, frame);
};

kony.ui.Widget.prototype.convertPointToWidget = function(point, toWidget) {
    return $KW.FlexUtils.convertPointToWidget(this, point, toWidget);
};

kony.ui.Widget.prototype.convertPointFromWidget = function(point, fromWidget) {
    return $KW.FlexUtils.convertPointFromWidget(this, point, fromWidget);
};


kony.ui.Widget.prototype.clone = function(newidPrefix) {
    return owl.deepCopy(this, undefined, newidPrefix || "");
};


kony.ui.Widget.prototype.unregisterForPeekandPop =
kony.ui.Widget.prototype.setOnPop =
    kony.ui.Widget.prototype.setOnPeek =
    kony.ui.Widget.prototype.registerForPeekandPop =
    kony.ui.Widget.prototype.setBadge =
    kony.ui.Widget.prototype.getBadge = function() {
        kony.web.logger("warn", "This method is not supported in SPA");
    };

kony.ui.Widget.prototype.setGetterSetter = function() {
    defineGetter(this, "contentAlignment", function() {
        return this.contentalignment;
    });
    defineSetter(this, "contentAlignment", function(val) {
        var oldvalue = this.contentalignment;
        this.contentalignment = val;
        kony.model.updateView(this, "contentalignment", val, oldvalue);
    });

    defineGetter(this, "containerWeight", function() {
        return this.containerweight;
    });
    defineSetter(this, "containerWeight", function(val) {
        var oldvalue = this.containerweight;
        this.containerweight = val;
        kony.model.updateView(this, "containerweight", val, oldvalue);
    });

    defineGetter(this, "focusSkin", function() {
        return this.focusskin;
    });
    defineSetter(this, "focusSkin", function(val) {
        var oldvalue = this.focusskin;
        this.focusskin = val;
        kony.model.updateView(this, "focusskin", val, oldvalue);
    });
    defineGetter(this, "hoverSkin", function() {
        return this.hoverskin;
    });
    defineSetter(this, "hoverSkin", function(val) {
        var oldvalue = this.hoverskin;
        this.hoverskin = val;
        kony.model.updateView(this, "hoverskin", val, oldvalue);
    });
    defineGetter(this, "isVisible", function() {
        return this.isvisible;
    });
    defineSetter(this, "isVisible", function(val) {
        var oldValue = this.isvisible;

        if(oldValue != val) {
            this.setVisibility(val);
        }
    });

    defineGetter(this, "onClick", function() {
        return this.onclick;
    });

    defineSetter(this, "onClick", function(val) {
        this.onclick = val;
    });

    defineGetter(this, "onTouchStart", function() {
        return this.ontouchstart;
    });

    defineSetter(this, "onTouchStart", function(val) {
        this.ontouchstart = val;
        kony.model.updateView(this, "touchstart", val);
    });

    defineGetter(this, "onScrollWidgetPosition", function() {
        return this.onscrollwidgetposition;
    });

    defineSetter(this, "onScrollWidgetPosition", function(val) {
        this.onscrollwidgetposition = val;
    });

    defineGetter(this, "onTouchMove", function() {
        return this.ontouchmove;
    });

    defineSetter(this, "onTouchMove", function(val) {
        this.ontouchmove = val;
        kony.model.updateView(this, "touchmove", val);
    });

    defineGetter(this, "onTouchEnd", function() {
        return this.ontouchend;
    });

    defineSetter(this, "onTouchEnd", function(val) {
        this.ontouchend = val;
        kony.model.updateView(this, "touchend", val);
    });
    defineGetter(this, "onHover", function() {
        return this.onhover;

    });

    defineSetter(this, "onHover", function(val) {
        this.onhover = val;


        new $KI.HoverInit(this);
    });

    defineGetter(this, "cursorType", function() {
        return this.cursortype;
    });

    defineSetter(this, "cursorType", function(val) {
        this.cursortype = val;
        kony.model.updateView(this, "cursortype", val);
    });
};


kony.ui.ContainerWidget.prototype.add = function(widgetarray) {
    containerWidgetExtendAdd.call(this, widgetarray);
};

kony.ui.ContainerWidget.prototype.addAt = function(widgetref, index) {
    containerWidgetExtendAddAt.call(this, widgetref, index);
};

kony.ui.ContainerWidget.prototype.remove = function(widgetref) {
    containerWidgetExtendRemove.call(this, widgetref);
};

kony.ui.ContainerWidget.prototype.removeAt = function(index) {
    return containerWidgetExtendRemoveAt.call(this, index);
};

kony.ui.ContainerWidget.prototype.removeAll = function(index) {
    return containerWidgetExtendRemoveAll.call(this, index);
};

kony.ui.ContainerWidget.prototype.widgets = function() {
    return this.ownchildrenref;
};


kony.ui.ContainerWidget.prototype.setparent = function(widgetarray) {
    containerWidgetExtendSetParent.call(this, widgetarray);
};

kony.ui.ContainerWidget.prototype.createhierarchy = function(widgetarray) {
    containerWidgetExtendCreateHierarchy.call(this, widgetarray);
};

kony.ui.ContainerWidget.prototype.removeReferences = function(widgetref) {
    containerWidgetExtendRemoveReferences.call(this, widgetref);
};

kony.ui.GroupWidget.prototype.setGetterSetter = function() {
    defineGetter(this, "onSelection", function() {
        return this.onselection;
    });
    defineSetter(this, "onSelection", function(val) {
        this.onselection = val;
    });

    defineGetter(this, "masterData", function() {
        return this.masterdata;
    });
    defineSetter(this, "masterData", function(val) {
        this.masterdata = val;
        $KW[this.wType]["updateView"](this, "masterdata", val);
    });

    defineGetter(this, "masterDataMap", function() {
        return this.masterdatamap;
    });
    defineSetter(this, "masterDataMap", function(val) {
        this.masterdatamap = val;
        $KW[this.wType]["updateView"](this, "masterdatamap", val);
    });

    defineGetter(this, "selectedKey", function() {
        return this.selectedkey;
    });
    defineSetter(this, "selectedKey", function(val) {
        this.selectedkey = val;
        $KW[this.wType]["updateView"](this, "selectedkey", val);
    });

    
    defineGetter(this, "selectedKeyValue", function() {
        return this.selectedkeyvalue;
    });
    defineSetter(this, "selectedKeyValue", function() {});

};

_konyConstNS = IndexJL ? konyLua : kony.ui;


kony.ui.Form2 = function(bconfig, lconfig, pspconfig) {
    if(arguments.length < 3)
        bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("Form2"));

    this.layouttype = bconfig.layoutType || lconfig.layoutType || kony.flex.VBOX_LAYOUT;
    if(this.layouttype == kony.flex.VBOX_LAYOUT || this.layouttype == constants.CONTAINER_LAYOUT_GRID)
        kony.ui.Form2.baseConstructor.call(this, bconfig, lconfig, pspconfig);
    else {
        kony.ui.FlexScrollContainer.call(this, bconfig, lconfig, pspconfig);
        $KU.extend(Object.getPrototypeOf ? Object.getPrototypeOf(this) : this.constructor.prototype, kony.ui.FlexScrollContainer.prototype);
    }

    this.type = bconfig.type; 
    this.needAppMenu = this.needappmenu = bconfig.needAppMenu === undefined ? true : (bconfig.needAppMenu && true);
    this.enabledForIdleTimeout = this.enabledforidletimeout = bconfig.enabledForIdleTimeout || pspconfig.enabledForIdleTimeout || false;
    bconfig.i18n_title && (this.i18n_title = bconfig.i18n_title);
    this.headers = bconfig.headers && bconfig.headers.splice(0, bconfig.headers.length); 
    this.footers = bconfig.footers && bconfig.footers.splice(0, bconfig.footers.length);
    this.addWidgets = bconfig.addWidgets;
    this.onDestroy = bconfig.onDestroy;
    this.init = bconfig.init;
    this.preshow = bconfig.preShow;
    this.postshow = bconfig.postShow;
    this.onhide = bconfig.onHide || pspconfig.onHide;
    this.breakpoints = bconfig.breakpoints || pspconfig.breakpoints;
    this.onbreakpointhandler = bconfig.onBreakpointHandler || pspconfig.onBreakpointHandler;
    this.onbreakpointchange = bconfig.onBreakpointChange || pspconfig.onBreakpointChange;
    this.onresize = bconfig.onResize || pspconfig.onResize;
    this.preorientationchange = bconfig.preOrientationChange;

    defineGetter(this, "layoutType", function() {
        return this.layouttype;
    });

    this.addWidgetsEventWidgetsList = [];
    this.initEventWidgetsList = [];
    this.displayOrientation = lconfig.displayOrientation || constants.FORM_DISPLAY_ORIENTATION_BOTH; 
    this.resetFocusToTop = pspconfig.resetFocusToTop;
    this.useTransform = pspconfig.useTransform;
    this.retainScrollPosition = this.retainscrollposition = pspconfig.retainScrollPosition || false;
    this.dockableAppmenu = this.dockableappmenu = pspconfig.dockableAppmenu;
    this.dockableHeader = this.dockableheader = pspconfig.dockableHeader;
    this.dockableFooter = this.dockablefooter = pspconfig.dockableFooter;
    this.intransitionconfig = pspconfig.inTransitionConfig;
    this.outtransitionconfig = pspconfig.outTransitionConfig;
    this._konyControllerName = bconfig._konyControllerName;

    this.allboxes = [];
    this.wType = "Form";
    this.addWidgetsdone = this.initdone = false;
    if(!this.addWidgets) {
        this.addWidgetsdone = true;
    }
    this.name = "kony.ui.Form2";
    $KG.allforms[this.id] = this;

    defineGetter(this, "layoutType", function() {
        return this.layouttype;
    });

    var title = bconfig.title;
    defineGetter(this, "title", function() {
        if(this.i18n_title && this.i18n_title.toLowerCase().indexOf("i18n.getlocalizedstring") != -1) {
            return $KU.getI18NValue(this.i18n_title);
        } else
            return title;
    });
    defineSetter(this, "title", function(val) {
        var oldvalue = title;
        title = val;
        if(this.canUpdateUI) {
            
            this.i18n_title = "";
            $KW[this.wType]["updateView"](this, "title", val);

        }
    });


    kony.ui.Form2.prototype.setGetterSetter();

    this.headers && this.commonHeaderFooterSetup("headers");
    this.footers && this.commonHeaderFooterSetup("footers");

    var addWidgets = bconfig.addWidgets;
    defineGetter(this, "addWidgets", function() {
        return addWidgets;
    });
    defineSetter(this, "addWidgets", function(val) {
        addWidgets = val;
        this.addWidgetsdone = false;

    });

    this.formgetter = function() {
        var id = bconfig.id;
        var that = this;
        if(!this._konyControllerName) {
            defineGetter(window, id, function() {
                if($KC.widgetDataRecording == true &&
                    (!$KG.__currentForm || $KG.__currentForm.id !== that.id)) {
                    $KC.konyCOPFormAccess[that.id] = true;
                }
                if(!that.addWidgetsdone) {
                    that.addWidgetsdone = true;
                    that.ownchildrenref = [];
                    that.children = [];
                    that.addWidgets && that.addWidgets(that);
                    
                    $KU.widgets.invokeAddWidgetsEventForInternalWidgets(that.addWidgetsEventWidgetsList);
                }
                return that;
            });
        } else {
            if($KC.widgetDataRecording == true &&
                (!$KG.__currentForm || $KG.__currentForm.id !== that.id)) {
                $KC.konyCOPFormAccess[that.id] = true;
            }
            if(!that.addWidgetsdone) {
                that.addWidgetsdone = true;
                that.ownchildrenref = [];
                that.children = [];
                that.addWidgets && that.addWidgets(that);
                
                $KU.widgets.invokeAddWidgetsEventForInternalWidgets(that.addWidgetsEventWidgetsList);
            }
            return that;
        }

    };

    this.formsetter = function() {
        var id = bconfig.id;
        var that = this;
        defineSetter(window, id, function() {
            return that;
        });
    };

    this.formgetter();
    if(!this._konyControllerName) {
        this.formsetter();
    }

    this.ondeviceback = pspconfig.onDeviceBack;
    defineGetter(this, "onDeviceBack", function() {
        return this.ondeviceback;
    });

    defineSetter(this, "onDeviceBack", function(val) {
        this.ondeviceback = val;
    });

    Object.defineProperty(this, "topLayerFCModal", {
        configurable: true,
        enumerable: false,
        get: function() {
            return this._topLayerFCModal;
        },
        set: function(val) {
            this._topLayerFCModal = val;
        }
    });
};

kony.inherits(kony.ui.Form2, kony.ui.ContainerWidget);


kony.ui.Form2.prototype.add = function() {
    var widgetarray = [].slice.call(arguments);
    formWidgetExtendAdd.call(this, widgetarray);
    $KU.checkAndReCalculateTopFlexModal(this, this);
};

kony.ui.Form2.prototype.addAt = function(widgetref, index) {
    formWidgetExtendAddAt.call(this, widgetref, index);
    $KU.checkAndReCalculateTopFlexModal(this, this);
};

kony.ui.Form2.prototype.destroy = function() {
    this._destroy({"isMVC": false});
};

kony.ui.Form2.prototype._destroy = function(destroyparam) {
    if($KG["__currentForm"].id === this.id) {
        kony.web.logger("warn", "Current form destroy can not be done");
        return;
    }
    var widgets = this.widgets();
    for(var i = 0; i < widgets.length; i++) {
        removeReferencesFromTopLevelModel(widgets[i]);
        if(widgets[i] instanceof _konyConstNS.ContainerWidget) {
            widgets[i] = $KW.Utils.getActualWidgetModel(widgets[i]);
            if(widgets[i].wType === "FlexContainer")
                widgets[i].destroy();
            delete this[widgets[i].id];
        }
    }
    this.onDestroy && this.onDestroy(this);
    this.addWidgetsdone = false;
    this.initdone = false;
    this.ownchildrenref = [];
    this.children = [];
    if(destroyparam.isMVC) delete $KG.allforms[this.id];
};

kony.ui.Form2.prototype.remove = function(widgetref) {
    formWidgetExtendRemove.call(this, widgetref);
    $KU.checkAndReCalculateTopFlexModal(this, this);
};

kony.ui.Form2.prototype.removeAt = function(index) {
    var removedWidget = formWidgetExtendRemoveAt.call(this, index);

    $KU.checkAndReCalculateTopFlexModal(this, this);
    return removedWidget;
};

kony.ui.Form2.prototype.removeAll = function() {
    formWidgetExtendRemoveAll.call(this);
    $KU.checkAndReCalculateTopFlexModal(this, this);
};

kony.ui.Form2.prototype.show = function() {
    if(!this._konyControllerName) {
        this._show();
    } else {
        throw new Error("this API is not applicable on Form " + this.id);
    }
};

kony.ui.Form2.prototype.closeNavigationDrawer =
    kony.ui.Form2.prototype.openNavigationDrawer =
    kony.ui.Form2.prototype.setBackgroundImageForNavbar =
    kony.ui.Form2.prototype.setLeftBarButtonItems =
    kony.ui.Form2.prototype.setRightBarButtonItems =
    kony.ui.Form2.prototype.setTitleVerticalPositionAdjustment =
    kony.ui.Form2.prototype.hideTitleBar =
    kony.ui.Form2.prototype.replaceAt =
    kony.ui.Form2.prototype.setTitleBarLeftSideButtonSkin =
    kony.ui.Form2.prototype.setTitleBarRightSideButtonSkin =
    kony.ui.Form2.prototype.setPreviewActionItems =
    kony.ui.Form2.prototype.setZoomScale =
    kony.ui.Form2.prototype.showTitleBar = function() {
        kony.web.logger("warn", "This form method is not supported in SPA");
    };

kony.ui.Form2.prototype._show = function() {
    if($KC.widgetDataRecording == true) {
        var key;
        if($KC.konyCOPFormAccess) {
            if($KC.konyCOPFormAccess[this.id]) {
                delete $KC.konyCOPFormAccess[this.id];
            }

            for(key in $KC.konyCOPFormAccess) {
                $KC.konyCOPPrerenderFormAccessedData[key] = true;
            }

            $KC.konyCOPFormAccess = {};

            if(typeof $KC.konyCOPPrerenderFormAccessedData[this.id] === 'undefined') {
                $KC.konyCOPPrerenderFormAccessedData[this.id] = false;
            }
        }

        if($KG.__currentForm) {
            $KC.generateFormJSONAfterRender($KG.__currentForm);
        }
    }

    if(!this.addWidgetsdone) {
        this.addWidgetsdone = true;
        this.ownchildrenref = [];
        this.children = [];
        if(this.addWidgets) {
            if(typeof this.addWidgets == "string") {
                window[this.addWidgets](this);
            } else if(typeof this.addWidgets == "function") {
                this.addWidgets(this);
            }
        }
        
        $KU.widgets.invokeAddWidgetsEventForInternalWidgets(this.addWidgetsEventWidgetsList);
    }
    $KG.allforms[this.id] = this;

    if(this.name == "kony.ui.Form") {
        !this.masterdataloaddone && this.masterdataload && this.masterdataload.call(this);
        !this.transactionaldataloaddone && this.transactionaldataload && this.transactionaldataload.call(this);
        this.transactionaldataloaddone = this.masterdataloaddone = true;
    } else {
        if(!this.initdone && this.init) {
            $KU.executeWidgetEventHandler(this, this.init);
        }
        
        $KU.widgets.invokeInitEventForInternalWidgets(this.initEventWidgetsList);
        this.initdone = true;
    }
    $KW.Form.show(this);
};

kony.ui.Form2.prototype.scrollToWidget = function(widgetref) {
    $KW.Form.scrollToWidget(this, widgetref);
};

kony.ui.Form2.prototype.scrollToBeginning = function() {
    $KW.Form.scrollToBeginning(this);
};

kony.ui.Form2.prototype.scrollToEnd = function() {
    $KW.Form.scrollToEnd(this);
};

kony.ui.Form2.prototype.widgets = function() {
    return kony.ui.ContainerWidget.prototype.widgets.call(this);
};


kony.ui.Form2.prototype.createFormLevelHierarchy = function(widgetarray) {
    formWidgetExtendCreateFormLevelHierarchy.call(this, widgetarray);
};

kony.ui.Form2.prototype.commonHeaderFooterSetup = function(containertype) {
    formWidgetExtendCommonHeaderFooterSetup.call(this, containertype);
};

kony.ui.Form2.prototype._registerForAddWidgetsEvent = function(widgetarray) {
    this.addWidgetsEventWidgetsList.push(widgetarray);
};

kony.ui.Form2.prototype._unRegisterForAddWidgetsEvent = function(widgetarray) {
    
};

kony.ui.Form2.prototype._registerForInitEvent = function(widgetarray) {
    this.initEventWidgetsList.push(widgetarray);
};

kony.ui.Form2.prototype._unRegisterForInitEvent = function(widgetarray) {
    
};

kony.ui.Form2.prototype.setGetterSetter = function() {
    defineGetter(this, "preShow", function() {
        return this.preshow;
    });
    defineSetter(this, "preShow", function(val) {
        this.preshow = val;
    });

    defineGetter(this, "postShow", function() {
        return this.postshow;
    });
    defineSetter(this, "postShow", function(val) {
        this.postshow = val;
    });

    defineGetter(this, "onHide", function() {
        return this.onhide;
    });
    defineSetter(this, "onHide", function(val) {
        this.onhide = val;
    });
    defineGetter(this, "onBreakpointHandler", function() {
        return this.onbreakpointhandler;
    });
    defineSetter(this, "onBreakpointHandler", function(val) {
        this.onbreakpointhandler = val;
    });
    defineGetter(this, "onBreakpointChange", function() {
        return this.onbreakpointchange;
    });
    defineSetter(this, "onBreakpointChange", function(val) {
        this.onbreakpointchange = val;
    });
    defineGetter(this, "onResize", function() {
        return this.onresize;
    });
    defineSetter(this, "onResize", function(val) {
        this.onresize = val;
    });
    defineGetter(this, "inTransitionConfig", function() {
        return this.intransitionconfig;
    });
    defineSetter(this, "inTransitionConfig", function(val) {
        this.intransitionconfig = val;
    });

    defineGetter(this, "outTransitionConfig", function() {
        return this.outtransitionconfig;
    });
    defineSetter(this, "outTransitionConfig", function(val) {
        this.outtransitionconfig = val;
    });
    defineGetter(this, "_konyControllerName", function() {
        return this.konyControllerName;
    });
    defineSetter(this, "_konyControllerName", function(val) {
        this.konyControllerName = val;
    });


};


kony.ui.Form2.getallboxes = function(widgetarray) {
    var wArray = widgetarray;
    if(!(widgetarray instanceof Array))
        wArray = [widgetarray];
    formWidgetExtendGetAllBoxes.call(this, wArray);
};

kony.ui.Form2.addHeaderorFooter = function() {
    formWidgetExtendaddHeaderorFooter.call(this, arguments);
};


kony.ui.Form = function(bconfig, lconfig, pspconfig) {
    kony.ui.Form.baseConstructor.call(this, bconfig, lconfig, pspconfig);

    this.transactionaldataload = bconfig.transactionalDataLoad;
    this.masterdataload = bconfig.masterDataLoad;
    this.transactionaldataloaddone = this.masterdataloaddone = false;

    this.type = pspconfig.formType; 

    this.preShow = this.preshow = pspconfig.preShow;
    this.postShow = this.postshow = pspconfig.postShow;
    this.onHide = this.onhide = pspconfig.onHide;

    this.needAppMenu = this.needappmenu = pspconfig.needAppLevelMenu === undefined ? true : (pspconfig.needAppLevelMenu && true);

    this.headers = pspconfig.globalHeaders && pspconfig.globalHeaders.splice(0);
    this.footers = pspconfig.globalFooters && pspconfig.globalFooters.splice(0);

    this.headers && this.commonHeaderFooterSetup("headers");
    this.footers && this.commonHeaderFooterSetup("footers");

    this.name = "kony.ui.Form";
};

kony.inherits(kony.ui.Form, kony.ui.Form2);


kony.ui.Button = function(bconfig, lconfig, pspconfig) {
    if(arguments.length < 3)
        bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("Button"));

    kony.ui.Button.baseConstructor.call(this, bconfig, lconfig, pspconfig);

    this.displaytext = (lconfig.displayText === undefined) ? true : (lconfig.displayText && true);
    this.rawBytes = bconfig.rawBytes; 

    
    this.canUpdateUI = true;
    this.wType = "Button";
    this.name = "kony.ui.Button"

    this._text = bconfig.text || "";
    defineGetter(this, "text", function() {
        return this._text;
    });
    defineSetter(this, "text", function(val) {
        var oldvalue = this._text;
        this._text = val;
        if(this.canUpdateUI) {
            
            this.i18n_text = "";
            $KW[this.wType]["updateView"](this, "text", val);
            $KW.FlexUtils.setLayoutConfig(this, val, oldvalue);
        }
    });
    this.tooltip = pspconfig.toolTip;

    defineGetter(this, "toolTip", function() {
        return this.tooltip;
    });

    defineSetter(this, "toolTip", function(val) {
        this.tooltip = val;
        kony.model.updateView(this, "tooltip", val);
    });
};

kony.inherits(kony.ui.Button, kony.ui.Widget);


kony.ui.Label = function(bconfig, lconfig, pspconfig) {
    if(arguments.length < 3)
        bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("Label"));

    kony.ui.Label.baseConstructor.call(this, bconfig, lconfig, pspconfig);

    
    this.canUpdateUI = true;
    this.wType = "Label";
    this.name = "kony.ui.Label";

    this._text = bconfig.text || "";
    defineGetter(this, "text", function() {
        return this._text;
    });
    defineSetter(this, "text", function(val) {
        var oldvalue = this._text;
        this._text = val;
        if(this.canUpdateUI) {
            
            this.i18n_text = "";
            $KW[this.wType]["updateView"](this, "text", val);
            $KW.FlexUtils.setLayoutConfig(this, val, oldvalue);
        }
    });

    var textCopyable = pspconfig.textCopyable;
    defineGetter(this, "textCopyable", function() {
        return this.textcopyable;
    });
    defineSetter(this, "textCopyable", function(val) {
        this.textcopyable = val;
        $KW[this.wType]["updateView"](this, "textcopyable", val);
    });

    
    this.linespacing = bconfig.lineSpacing;
    defineGetter(this, "lineSpacing", function() {
        return this.linespacing;
    });
    defineSetter(this, "lineSpacing", function(val) {
        this.linespacing = val;
        $KW[this.wType]["updateView"](this, "linespacing", val);
    });
    this.tooltip = pspconfig.toolTip || "";
    defineGetter(this, "toolTip", function() {
        return this.tooltip;
    });

    defineSetter(this, "toolTip", function(val) {
        this.tooltip = val;
        kony.model.updateView(this, "tooltip", val);
    });
};

kony.inherits(kony.ui.Label, kony.ui.Widget);



kony.ui.Line = function(bconfig, lconfig, pspconfig) {
    if(arguments.length < 3)
        bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("Line"));

    kony.ui.Line.baseConstructor.call(this, bconfig, lconfig, pspconfig);

    
    this.wType = "Line";
    this.name = "kony.ui.Line";

    var thickness = lconfig.thickness;
    defineGetter(this, "thickness", function() {
        return thickness;
    });
    defineSetter(this, "thickness", function(val) {
        thickness = val;
        $KW[this.wType]["updateView"](this, "thickness", val);
    });


};

kony.inherits(kony.ui.Line, kony.ui.Widget);




kony.ui.Switch = function(bconfig, lconfig, pspconfig) {
    if(arguments.length < 3)
        bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("Switch"));

    kony.ui.Switch.baseConstructor.call(this, bconfig, lconfig, pspconfig);
    this.skin = bconfig.skin; 
    this.leftsidetext = bconfig.leftSideText || "";
    this.rightsidetext = bconfig.rightSideText || "";
    bconfig.i18n_rightSideText && (this.i18n_rightsidetext = bconfig.i18n_rightSideText);
    bconfig.i18n_leftSideText && (this.i18n_leftsidetext = bconfig.i18n_leftSideText);

    
    this.wType = "Switch";
    this.name = "kony.ui.Switch";

    this.onslide = bconfig.onSlide || null;
    this.selectedindex = (bconfig.selectedIndex == IndexJL) ? IndexJL : IndexJL + 1;

    this.thumbwidth = bconfig.thumbWidth || "";
    this.thumbheight = bconfig.thumbHeight || "";
    this.trackwidth = bconfig.trackWidth || "";
    this.trackheight = bconfig.trackHeight || "";
    this.thumbtext = bconfig.thumbText || "";
    this.thumbskin = bconfig.thumbSkin;

    this.setGetterSetter();
};

kony.inherits(kony.ui.Switch, kony.ui.Widget);

kony.ui.Switch.prototype.setGetterSetter = function() {
    defineGetter(this, "leftSideText", function() {
        return this.leftsidetext;
    });
    defineSetter(this, "leftSideText", function(val) {
        var oldvalue = this.leftsidetext;
        this.leftsidetext = val;
        if(this.canUpdateUI) {
            
            this.i18n_leftSideText = "";
            $KW[this.wType]["updateView"](this, "leftsidetext", val);
        }
    });

    defineGetter(this, "rightSideText", function() {
        return this.rightsidetext;
    });
    defineSetter(this, "rightSideText", function(val) {
        var oldvalue = this.rightsidetext;
        if(oldvalue != val) {
            this.rightsidetext = val;
            if(this.canUpdateUI) {
                
                this.i18n_rightSideText = "";
                $KW[this.wType]["updateView"](this, "rightsidetext", val);
            }
        }
    });

    defineGetter(this, "onSlide", function() {
        return this.onslide;
    });
    defineSetter(this, "onSlide", function(val) {
        this.onslide = val;
    });

    defineGetter(this, "selectedIndex", function() {
        return this.selectedindex;
    });
    defineSetter(this, "selectedIndex", function(val) {
        var oldvalue = this.selectedindex;
        if(oldvalue != val) {
            this.selectedindex = val;
            $KW[this.wType]["updateView"](this, "selectedindex", val, oldvalue);
        }
    });

    defineGetter(this, "thumbWidth", function() {
        return this.thumbwidth;
    });
    defineSetter(this, "thumbWidth", function(val) {
        var oldvalue = this.thumbwidth;
        if(oldvalue != val) {
            this.thumbwidth = val;
            if(this.canUpdateUI) {
                $KW[this.wType]["updateView"](this, "thumbwidth", val);
            }
        }
    });

    defineGetter(this, "thumbHeight", function() {
        return this.thumbheight;
    });
    defineSetter(this, "thumbHeight", function(val) {
        var oldvalue = this.thumbheight;
        if(oldvalue != val) {
            this.thumbheight = val;
            if(this.canUpdateUI) {
                $KW[this.wType]["updateView"](this, "thumbheight", val);
            }
        }
    });

    defineGetter(this, "trackHeight", function() {
        return this.trackheight;
    });
    defineSetter(this, "trackHeight", function(val) {
        var oldvalue = this.trackheight;
        if(oldvalue != val) {
            this.trackheight = val;
            if(this.canUpdateUI) {
                $KW[this.wType]["updateView"](this, "trackheight", val);
            }
        }
    });

    defineGetter(this, "trackWidth", function() {
        return this.trackwidth;
    });
    defineSetter(this, "trackWidth", function(val) {
        var oldvalue = this.trackwidth;
        if(oldvalue != val) {
            this.trackwidth = val;
            if(this.canUpdateUI) {
                $KW[this.wType]["updateView"](this, "trackwidth", val);
            }
        }
    });

    defineGetter(this, "thumbText", function() {
        return this.thumbtext;
    });
    defineSetter(this, "thumbText", function(val) {
        var oldvalue = this.thumbtext;
        if(oldvalue != val) {
            this.thumbtext = val;
            if(this.canUpdateUI) {
                $KW[this.wType]["updateView"](this, "thumbtext", val);
            }
        }
    });

    defineGetter(this, "thumbSkin", function() {
        return this.thumbskin;
    });
    defineSetter(this, "thumbSkin", function(val) {
        var oldvalue = this.thumbskin;
        if(oldvalue != val) {
            this.thumbskin = val;
            if(this.canUpdateUI) {
                $KW[this.wType]["updateView"](this, "thumbskin", val, oldvalue);
            }
        }
    });

};


kony.ui.Phone = function(bconfig, lconfig, pspconfig) {
    if(arguments.length < 3)
        bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("Phone"));

    kony.ui.Phone.baseConstructor.call(this, bconfig, lconfig, pspconfig);

    
    this.canUpdateUI = true;
    this.wType = "Phone";
    this.name = "kony.ui.Phone";

    this._text = bconfig.text || "";
    defineGetter(this, "text", function() {
        return this._text;
    });
    defineSetter(this, "text", function(val) {
        var oldvalue = this._text;
        this._text = val;
        if(this.canUpdateUI) {
            
            this.i18n_text = "";
            $KW[this.wType]["updateView"](this, "text", val);
            $KW.FlexUtils.setLayoutConfig(this, val, oldvalue);
        }
    });
};

kony.inherits(kony.ui.Phone, kony.ui.Widget);


kony.ui.CustomWidget = function(bconfig, lconfig, pspconfig) {
    kony.ui.CustomWidget.baseConstructor.call(this, bconfig, lconfig, pspconfig);

    var defineGettersAndSetters = function(instance, property, pspconfig) {
        defineGetter(instance, property, function() {
            
            return pspconfig[property];
        });
        defineSetter(instance, property, function(value) {
            var oldVal = pspconfig[property];
            pspconfig[property] = value;
            
            var nsArr = pspconfig.widgetName.split('.'),
                namespace = window;
            for(var j = 0; j < nsArr.length; j++) {
                namespace = namespace[nsArr[j]];
            }
            namespace["modelChange"](instance, property, pspconfig[property]);
        });
    };

    
    this.wType = "TPW";
    for(var k in pspconfig) {
        defineGettersAndSetters(this, k, pspconfig);
    }

};

kony.inherits(kony.ui.CustomWidget, kony.ui.Widget);



kony.ui.Alert = function(param1, param2, param3) {
    $KU.logExecuting('kony.ui.Alert');
    $KU.logExecutingWithParams('kony.ui.Alert', param1, param2, param3);
    $KU.logExecutingFinished('kony.ui.Alert');
    $KI.window.alert(param1, param2, param3);
};

kony.ui.Calendar = function(bconfig, lconfig, pspconfig) {
    if(arguments.length < 3)
        bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("Calendar"));

    kony.ui.Calendar.baseConstructor.call(this, bconfig, lconfig, pspconfig);

    
    this.wType = "Calendar";
    this.name = "kony.ui.Calendar";
    this.datecomponents = bconfig.dateComponents || [];
    this.dateformat = this.format = bconfig.dateFormat || constants.CALENDAR_DATE_FORMAT_DEFAULT;
    this.formatteddate = this.date; 
    this.validstartdate = bconfig.validStartDate;
    this.validenddate = bconfig.validEndDate;
    this.viewtype = this.advview = bconfig.viewType || constants.CALENDAR_VIEW_TYPE_DEFAULT;
    this.viewconfig = bconfig.viewConfig;
    this.calendaricon = this.Image = bconfig.calendarIcon;
    this.calendariconalignment = bconfig.calendarIconAlignment;
    this.onselection = bconfig.onSelection;
    this.ondone = bconfig.onDone;
    this.titleonpopup = this.title = pspconfig.titleOnPopup;
    this.noofmonths = pspconfig.noOfMonths || pspconfig.noofmonths || 1;
    this.dateeditable = true;
    this.calimgheight = pspconfig.calImgHeight;
    this.gridtheme = pspconfig.gridTheme;
    this.celltemplate = pspconfig.cellTemplate;
    this.widgetdatamapforcell = pspconfig.widgetDataMapForCell;
    this.hidepreviousnextmonthdates = bconfig.hidePreviousNextMonthDates || false;
    if(kony.application.getApplicationBehavior("newCalendarskinApifeature")){
        this.skinprioritylist = bconfig.skinPriorityList || ["inactive" , "selected", "specialDates", "gridcell", "weekend", "today"];
    }


    var data = pspconfig.data;
    defineGetter(this, "data", function() {
        return data;
    });
    defineSetter(this, "data", function(val) {
        data = val;
        this.canUpdateUI && $KW[this.wType]["updateView"](this, "data", val);
    });

    defineGetter(this, "calendarIconAlignment", function() {
        return this.calendariconalignment;
    });
    defineSetter(this, "calendarIconAlignment", function(val) {
        var oldValue = this.calendariconalignment;
        if(oldValue !== val) {
            this.calendariconalignment = val;
            this.canUpdateUI && $KW[this.wType]["updateView"](this, "calendariconalignment", val);
        }
    });

    defineGetter(this, "widgetDataMapForCell", function() {
        return this.widgetdatamapforcell;
    });
    defineSetter(this, "widgetDataMapForCell", function(val) {
        this.widgetdatamapforcell = val;
    });

    defineGetter(this, "hidePreviousNextMonthDates", function() {
        return this.hidepreviousnextmonthdates;
    });
    defineSetter(this, "hidePreviousNextMonthDates", function(val) {
        var oldValue = this.hidepreviousnextmonthdates;
        if(oldValue !== val && this.canUpdateUI) {
            this.hidepreviousnextmonthdates = val;
            $KW[this.wType]["updateView"](this, "hidePreviousNextMonthDates", val);
         }
    });
    defineGetter(this, "skinPriorityList", function() {
        if(kony.application.getApplicationBehavior("newCalendarskinApifeature")){
            return this.skinprioritylist;
        }
        else
            return;
    });
    defineSetter(this, "skinPriorityList", function(val) {
        if(kony.application.getApplicationBehavior("newCalendarskinApifeature")){
            var oldValue = this.skinprioritylist;
            if(oldValue !== val && this.canUpdateUI) {
                this.skinprioritylist = val;
                $KW[this.wType]["updateView"](this, "skinPriorityList", val);
            }
        }
    });
    defineGetter(this, "calImgHeight", function() {
        return this.calimgheight;
    });
    defineSetter(this, "calImgHeight", function(val) {
        this.calimgheight = val;
    });

    var placeholder = bconfig.placeholder;
    defineGetter(this, "placeholder", function() {
        return placeholder;
    });

    defineSetter(this, "placeholder", function(val) {
        placeholder = val;
        this.canUpdateUI && $KW[this.wType]["updateView"](this, "placeholder", val);
    });

    defineGetter(this, "dateEditable", function() {
        return this.dateeditable;
    });

    defineSetter(this, "dateEditable", function(val) {
        if(!val == true || !!val == true) {
            this.dateeditable = val;
            this.canUpdateUI && $KW[this.wType]["updateView"](this, "dateeditable", val);
        }
    });

    defineGetter(this, "gridTheme", function() {
        return this.gridtheme;
    });

    defineSetter(this, "gridTheme", function(val) {
        var oldValue = this.gridtheme;
        if(oldValue !== val) {
            this.gridtheme = val;
            this.canUpdateUI && $KW[this.wType]["updateView"](this, "gridtheme", val);
        }
    });

    this.selectiontype = pspconfig.selectionType || constants.CALENDAR_SELECTION_TYPE_SINGLE_SELECT;
    defineGetter(this, "selectionType", function() {
        return this.selectiontype;
    });

    defineSetter(this, "selectionType", function(val) {
        var oldValue = this.selectiontype;
        if(oldValue !== val) {
            this.selectiontype = val;
            this.canUpdateUI && $KW[this.wType]["updateView"](this, "selectiontype", val);
        }
    });

    this.selecteddates = bconfig.selectedDates;
    defineGetter(this, "selectedDates", function() {
        return this.selecteddates;
    });

    defineSetter(this, "selectedDates", function(val) {
        var oldValue = this.selecteddates,
            isValidDateSet;
        if($KW.Calendar.isMultiRangeCalendar(this) &&
            !$KU.equals(oldValue, val)) {
            isValidDateSet = $KW.Calendar.isSelectedDatesValid(this, val);
            if(isValidDateSet) {
                this.selecteddates = $KW.Calendar.setTimeInDateComponents(val);
                this.canUpdateUI && $KW[this.wType]["updateView"](this, "selecteddates", val);
            } else {
                kony.web.logger("error", "Invalid date selection");
            }
        }
    });


    var date = bconfig.date;
    defineGetter(this, "date", function() {
        if($KW.Calendar.isMultiRangeCalendar(this)) {
            return;
        }
        $KW.Calendar.updateCalDOMNode(this);
        if(this.formatteddate) {
            return this.formatteddate;
        } else {
            return null;
        }
    });

    defineSetter(this, "date", function(val) {
        if($KW.Calendar.isMultiRangeCalendar(this)) {
            return;
        }
        this.Date = val;
        if(!val || !val.length) {
            return false;
        }
        if(typeof val == "string") {
            var dEY = $KW.Calendar.getDat(val, this);
        } else {
            var dEY = {
                dd: val[0],
                mm: val[1],
                yyyy: val[2]
            };
        }
        if(val && val.length) {
            this.day = dEY.dd;
            this.month = dEY.mm;
            this.year = dEY.yyyy || dEY.yy;

            if(!this.datecomponents) {
                this.datecomponents = [];
            }

            this.datecomponents[0] = dEY.dd;
            this.datecomponents[1] = dEY.mm;
            this.datecomponents[2] = dEY.yyyy || dEY.yy;
            this.datecomponents[3] = 0;
            this.datecomponents[4] = 0;
            this.datecomponents[5] = 0;
        } else {
            this.day = this.month = this.year = null;
        }
        this.hour = this.minutes = this.seconds = 0;
        this.canUpdateUI && $KW[this.wType]["updateView"](this, "date", val);
    });
    this.showcurrentdate = pspconfig.showCurrentDate;
    this.setGetterSetter();
};

kony.inherits(kony.ui.Calendar, kony.ui.Widget);

kony.ui.Calendar.prototype.setGetterSetter = function() {
    defineGetter(this, "titleOnPopup", function() {
        return this.title;
    });
    defineSetter(this, "titleOnPopup", function(val) {
        this.titleonpopup = this.title = val;
    });

    defineGetter(this, "onSelection", function() {
        return this.onselection;
    });
    defineSetter(this, "onSelection", function(val) {
        this.onselection = val;
    });

    defineGetter(this, "onDone", function() {
        return this.ondone;
    });
    defineSetter(this, "onDone", function(val) {
        this.ondone = val;
    });

    defineGetter(this, "calendarIcon", function() {
        return this.calendaricon;
    });
    defineSetter(this, "calendarIcon", function(val) {
        this.calendaricon = this.Image = val;
        $KW[this.wType]["updateView"](this, "calendaricon", val);
    });

    defineGetter(this, "viewConfig", function() {
        return this.viewconfig;
    });
    defineSetter(this, "viewConfig", function(val) {
        this.viewconfig = val;
        $KW[this.wType]["updateView"](this, "viewconfig", val);
    });

    defineGetter(this, "viewType", function() {
        return this.advview;
    });
    defineSetter(this, "viewType", function(val) {
        this.advview = val;
        $KW[this.wType]["updateView"](this, "viewtype", val);
    });

    defineGetter(this, "validEndDate", function() {
        return this.validenddate;
    });
    defineSetter(this, "validEndDate", function(val) {
        var oldval = this.validenddate
        this.validenddate = val;
        $KW[this.wType]["updateView"](this, "validenddate", val, oldval);
    });

    defineGetter(this, "validStartDate", function() {
        return this.validstartdate;
    });
    defineSetter(this, "validStartDate", function(val) {
        var oldval = this.validstartdate;
        this.validstartdate = val;

        $KW[this.wType]["updateView"](this, "validstartdate", val, oldval);
    });

    defineGetter(this, "dateFormat", function() {
        return this.format;
    });
    defineSetter(this, "dateFormat", function(val) {
        var oldval = this.dateformat;
        this.dateformat = this.format = val;
        $KW[this.wType]["updateView"](this, "dateformat", val);
        if(this.placeholder == oldval) {
            $KW[this.wType]["updateView"](this, "placeholder", val);
        } else {
            $KW[this.wType]["updateView"](this, "placeholder", this.placeholder || val);
        }
    });

    defineGetter(this, "dateComponents", function() {
        if($KW.Calendar.isMultiRangeCalendar(this)) {
            return;
        }
        if(this.hour === undefined) {
            this.hour = this.datecomponents[3];
        }
        if(this.minutes === undefined) {
            this.minutes = this.datecomponents[4];
        }
        if(this.seconds === undefined) {
            this.seconds = this.datecomponents[5];
        }
        return [this.day, this.month, this.year, this.hour, this.minutes, this.seconds];
    });
    defineSetter(this, "dateComponents", function(val) {
        if($KW.Calendar.isMultiRangeCalendar(this)) {
            return;
        }
        var oldval = this.datecomponents;
        if(kony.application.getApplicationBehavior("newCalendarskinApifeature")){
            isValidDateSet = $KW.Calendar.isSelectedDatesValid(this, val);
            if(isValidDateSet) {
               this.datecomponents = this.date = val.slice(0, 3);
            }
            else {
               this.datecomponents = this.date = oldval;
               kony.web.logger("error", "Disabled Dates can't be selected");
            }
        }
        else {
            this.datecomponents = this.date = val.slice(0, 3);


        }
        $KW[this.wType]["updateView"](this, "datecomponents", val);
    });

    defineGetter(this, "formattedDate", function() {
        $KW.Calendar.updateCalDOMNode(this);
        return this.formatteddate;
    });

    defineSetter(this, "showCurrentDate", function(val) {
        this.showcurrentdate = val;
    });

    defineGetter(this, "showCurrentDate", function() {
        return this.showcurrentdate;
    });
    defineGetter(this, "noOfMonths", function() {
        return this.noofmonths;
    });

    defineSetter(this, "noOfMonths", function(val) {
        this.noofmonths = val;
    });
};


kony.ui.Calendar.prototype.setEnabled = function(dates, skin, enable) {
    if(typeof dates == "boolean") { 
        $KW.APIUtils.setenabled(this, dates);
        return false;
    } else {
        if(dates instanceof Array && typeof skin == "string") {
            if(kony.application.getApplicationBehavior("newCalendarskinApifeature")) {
               $KW.Calendar.setEnablednew(this, dates, 0, skin, enable);
            }
            else {
                $KW.Calendar.setEnabled(this, dates, 0, skin, enable);
            }
        }
        else
           kony.web.logger("error", "Invalid parameters");

    }
};

kony.ui.Calendar.prototype.displayedMonth = function(month, year) {
    $KW.Calendar.displayedMonth(this, month, year);
};
kony.ui.Calendar.prototype.navigateToPreviousMonth = function() {
    $KW.Calendar.navigateToPreviousMonth(this);
};
kony.ui.Calendar.prototype.navigateToNextMonth = function() {
    $KW.Calendar.navigateToNextMonth(this);
};

kony.ui.Calendar.prototype.enableRangeOfDates = function(startdate, enddate, skin, enable) {
    if(kony.application.getApplicationBehavior("newCalendarskinApifeature")) {
        $KW.Calendar.setEnablednew(this, startdate, enddate, skin, enable);
    }
    else {
        $KW.Calendar.setEnabled(this, startdate, enddate, skin, enable);
    }
};

kony.ui.Calendar.prototype.setEnableAll = function(flag) {
    if(kony.application.getApplicationBehavior("newCalendarskinApifeature")) {
        $KW.Calendar.setEnableAllnew(this, flag);
    }
    else {
        $KW.Calendar.setEnableAll(this);
    }
};

kony.ui.Calendar.prototype.setDatesSkin = function(dates, skin) {
    $KW.Calendar.setDateSkin(this, dates, skin, true);
};

kony.ui.Calendar.prototype.clear = function() {
    $KW.Calendar.clear(this)
};

kony.ui.Calendar.prototype.open = function() {
    $KW.Calendar.open(this);
};

kony.ui.Calendar.prototype.dismiss = function() {
    $KW.Calendar.dismiss(this);
};

kony.ui.Calendar.prototype.setContext = function(context) {
    $KW.Calendar.setcontext(this, context);
};

kony.ui.Calendar.prototype.clearAppointments =
kony.ui.Calendar.prototype.clearData =
kony.ui.Calendar.prototype.deleteAppointments =
kony.ui.Calendar.prototype.getAppointments =
kony.ui.Calendar.prototype.modifyAppointment =
kony.ui.Calendar.prototype.removeDataAt =
kony.ui.Calendar.prototype.setData =
kony.ui.Calendar.prototype.setDataAt =
kony.ui.Calendar.prototype.switchToDate = function() {
    kony.web.logger("warn", "This Calendar method is not supported in SPA");
};


kony.ui.DataGrid = function(bconfig, lconfig, pspconfig) {
    if(arguments.length < 3)
        bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("DataGrid"));

    kony.ui.DataGrid.baseConstructor.call(this, bconfig, lconfig, pspconfig);

    this.focusedindex = this.focuseditem = this.selecteditems = this.selectedindices = null;
    this.headerskin = bconfig.headerSkin;
    this.rownormalskin = bconfig.rowNormalSkin;
    this.rowfocusskin = bconfig.rowFocusSkin;
    this.rowalternateskin = bconfig.rowAlternateSkin;
    this.showcolumnheaders = bconfig.showColumnHeaders;
    this.columnheadersconfig = bconfig.columnHeadersConfig;
    this.onrowselected = bconfig.onRowSelected;
    this.ismultiselect = bconfig.isMultiSelect;
    this.gridlinecolor = pspconfig.gridlineColor;
    this.onrightclick = pspconfig.onRightClick;
    defineGetter(this, "onRightClick", function() {
        return this.onrightclick;
    });

    this.contextmenu = pspconfig.contextMenu;
    defineGetter(this, "contextMenu", function() {
        return this.contextmenu;
    });

    this.selectedcellindex = this.selectedcellitem = null;
    this.enablescrollbar = pspconfig.enableScrollBar;
    this.containerheight = pspconfig.containerHeight;
    this.containerheightinpixel = pspconfig.containerHeightInPixel;
    this.dockingheader = pspconfig.dockingHeader;
    defineGetter(this, "enableScrollBar", function() {
        return this.enablescrollbar;
    });
    defineGetter(this, "containerHeight", function() {
        return this.containerheight;
    });
    defineGetter(this, "containerHeightInPixel", function() {
        return this.containerheightinpixel;
    });
    defineGetter(this, "dockingHeader", function() {
        return this.dockingheader;
    });

    this.allowcolumnresize = pspconfig.allowColumnResize;
    defineGetter(this, "allowColumnResize", function() {
        return this.allowcolumnresize;
    });
    var data = bconfig.data;
    defineGetter(this, "data", function() {
        return data;
    });

    defineSetter(this, "data", function(val) {
        data = val;
        this.canUpdateUI && $KW[this.wType]["updateView"](this, "data", val);
    });

    this.rowcount = (data && data.length - IndexJL) || 0;

    
    this.wType = "DataGrid";
    this.name = "kony.ui.DataGrid";
    this.canUpdateUI = true;
    this.selectedcellindex = this.selectedcellitem = null;
    var config = bconfig.columnHeadersConfig;
    if(config) {
        var hConfig = [];
        for(var i = 0; i < config.length; i++) {
            var col = {};
            col.columnid = config[i].columnID;
            col.columntype = config[i].columnType;
            col.columnheadertext = config[i].columnHeaderText;
            col.columnheadertemplate = config[i].columnHeaderTemplate;
            col.columndatatemplate = config[i].columnDataTemplate;
            col.columnwidthinpercentage = config[i].columnWidthInPercentage;
            col.columncontentalignment = config[i].columnContentAlignment
            col.columnonclick = config[i].columnOnClick;
            hConfig.push(col);
        }
        this.columnheadersconfig = hConfig;
    }
    this.setGetterSetter();
};

kony.inherits(kony.ui.DataGrid, kony.ui.Widget);

kony.ui.DataGrid.prototype.setGetterSetter = function() {
    defineGetter(this, "rowNormalSkin", function() {
        return this.rownormalskin;
    });

    defineSetter(this, "rowNormalSkin", function(val) {
        var oldvalue = this.rownormalskin;
        this.rownormalskin = val;
        $KW[this.wType]["updateView"](this, "rownormalskin", val, oldvalue);
    });

    defineGetter(this, "headerSkin", function() {
        return this.headerskin;
    });

    defineSetter(this, "headerSkin", function(val) {
        this.headerskin = val;
        $KW[this.wType]["updateView"](this, "headerskin", val);
    });

    defineGetter(this, "isMultiSelect", function() {
        return this.ismultiselect;
    });

    defineSetter(this, "isMultiSelect", function(val) {
        this.ismultiselect = val;
        $KW[this.wType]["updateView"](this, "ismultiselect", val);
    });

    defineGetter(this, "rowFocusSkin", function() {
        return this.rowfocusskin;
    });

    defineSetter(this, "rowFocusSkin", function(val) {
        this.rowfocusskin = val;
    });

    defineGetter(this, "rowAlternateSkin", function() {
        return this.rowalternateskin;
    });

    defineSetter(this, "rowAlternateSkin", function(val) {
        this.rowalternateskin = val;
        $KW[this.wType]["updateView"](this, "rowalternateskin", val);
    });

    defineGetter(this, "showColumnHeaders", function() {
        return this.showcolumnheaders;
    });

    defineSetter(this, "showColumnHeaders", function(val) {
        this.showcolumnheaders = val;
        $KW[this.wType]["updateView"](this, "showcolumnheaders", val);
    });

    defineGetter(this, "columnHeadersConfig", function() {
        return this.columnheadersconfig;
    });

    defineSetter(this, "columnHeadersConfig", function(config) {

        if(config) {
            var hConfig = [];
            for(var i = 0; i < config.length; i++) {
                var col = {};
                col.columnid = config[i].columnid || config[i].columnID;
                col.columntype = config[i].columntype || config[i].columnType;
                col.columnheadertext = config[i].columnheadertext || config[i].columnHeaderText;
                col.columnheadertemplate = config[i].columnheadertemplate || config[i].columnHeaderTemplate;
                col.columndatatemplate = config[i].columndatatemplate || config[i].columnDataTemplate;
                col.columnwidthinpercentage = config[i].columnwidthinpercentage || config[i].columnWidthInPercentage;
                col.columncontentalignment = config[i].columncontentalignment || config[i].columnContentAlignment
                col.columnonclick = config[i].columnonclick || config[i].columnOnClick;
                hConfig.push(col);
            }
            this.columnheadersconfig = hConfig;
        }
        
        $KW[this.wType]["updateView"](this, "columnheadersconfig", config);
    });

    defineGetter(this, "gridlineColor", function() {
        return this.gridlinecolor;
    });

    defineSetter(this, "gridlineColor", function(val) {
        this.gridlinecolor = val;
        $KW[this.wType]["updateView"](this, "gridlinecolor", val);
    });

    defineSetter(this, "onRowSelected", function(val) {
        this.onrowselected = val;
    });

    defineGetter(this, "selectedIndex", function() {
        return this.focusedindex;
    });

    defineGetter(this, "selectedItem", function() {
        return this.focuseditem;
    });

    defineGetter(this, "selectedItems", function() {
        return this.selecteditems;
    });

    defineGetter(this, "selectedIndices", function() {
        return this.selectedindices;
    })

    defineGetter(this, "rowCount", function() {
        return this.rowcount;
    });
    defineGetter(this, "selectedCellIndex", function() {
        return this.selectedcellindex;
    });

    defineGetter(this, "selectedCellItem", function() {
        return this.selectedcellitem;
    });
};


kony.ui.DataGrid.prototype.applyCellSkin = function(rowindex, columnid, skin) {
    $KW.DataGrid.applyCellSkin(this, rowindex, columnid, skin);
}

kony.ui.DataGrid.prototype.setData = function(dataarray) {
    $KW.DataGrid.setData(this, dataarray);
};

kony.ui.DataGrid.prototype.setDataAt = function(dataobj, index) {
    $KW.DataGrid.setDataAt(this, dataobj, index);
};

kony.ui.DataGrid.prototype.addDataAt = function(dataobj, index) {
    $KW.DataGrid.addDataAt(this, dataobj, index);
};

kony.ui.DataGrid.prototype.addAll = function(dataarray) {
    $KW.DataGrid.addAll(this, dataarray);
};

kony.ui.DataGrid.prototype.removeAt = function(index) {
    $KW.DataGrid.removeAt(this, index);
};

kony.ui.DataGrid.prototype.removeAll = function() {
    $KW.DataGrid.removeAll(this);
};

kony.ui.DataGrid.prototype.selectAllRows = function(flag) {
    $KW.DataGrid.selectAll(this, flag);
};

kony.ui.DataGrid.prototype.setCellDataAt = function(rowIndex, columnID, data) {
    $KW.DataGrid.setCellData(this, rowIndex, columnID, data);
};

kony.ui.DataGrid.prototype.setHeaderCellDataAt = function(columnID, data) {
    $KW.DataGrid.setHeaderCellDataAt(this, columnID, data);
};


kony.ui.CheckBoxGroup = function(bconfig, lconfig, pspconfig) {
    if(arguments.length < 3)
        bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("CheckBoxGroup"));

    kony.ui.CheckBoxGroup.baseConstructor.call(this, bconfig, lconfig, pspconfig);

    this.itemorientation = lconfig.itemOrientation || constants.CHECKBOX_ITEM_ORIENTATION_VERTICAL;

    
    this.wType = "CheckBoxGroup";
    this.name = "kony.ui.CheckBoxGroup";

    this.selectedkeys = bconfig.selectedKeys || null;
    this.selectedkeyvalues = null;

    this.viewtype = pspconfig.viewType || "defaultview";

    this.size = pspconfig.size || 18;
    this.checkedimage = pspconfig.checkedImage || "checkboxselected.png";
    this.uncheckedimage = pspconfig.uncheckedImage || "checkboxnormal.png";

    kony.ui.CheckBoxGroup.prototype.setGetterSetter.call(this);
};

kony.inherits(kony.ui.CheckBoxGroup, kony.ui.GroupWidget);

kony.ui.CheckBoxGroup.prototype.setGetterSetter = function() {
    defineGetter(this, "selectedKeys", function() {
        return this.selectedkeys;
    });
    defineSetter(this, "selectedKeys", function(val) {
        this.selectedkeys = val;
        $KW[this.wType]["updateView"](this, "selectedkeys", val);
    });

    defineGetter(this, "selectedKeyValues", function() {
        return this.selectedkeyvalues;
    });


    defineSetter(this, "viewType", function(val) {
        this.viewtype = val;
        $KW[this.wType]["updateView"](this, "viewtype", val);
    });

    defineGetter(this, "viewType", function() {
        return this.viewtype;
    });

    defineSetter(this, "checkedImage", function(val) {
        this.checkedimage = val;
        $KW[this.wType]["updateView"](this, "checkedimage", val);
    });

    defineGetter(this, "checkedImage", function() {
        return this.checkedimage;
    });

    defineSetter(this, "uncheckedImage", function(val) {
        this.uncheckedimage = val;
        $KW[this.wType]["updateView"](this, "uncheckedimage", val);
    });

    defineGetter(this, "uncheckedImage", function() {
        return this.uncheckedimage;
    });


    defineSetter(this, "dimension", function(val) {
        this.size = val;
        $KW[this.wType]["updateView"](this, "size", val);
    });

    defineGetter(this, "dimension", function() {
        return this.size;
    });


};




kony.ui.ListBox = function(bconfig, lconfig, pspconfig) {
    if(arguments.length < 3)
        bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("ListBox"));

    kony.ui.ListBox.baseConstructor.call(this, bconfig, lconfig, pspconfig);

    
    this.wType = "ListBox";
    this.name = "kony.ui.ListBox";
    this.selectedkeys = pspconfig.selectedKeys || null;
    this.selectedkeyvalues = null;
    defineGetter(this, "selectedKeys", function() {
        return this.selectedkeys;
    });
    defineSetter(this, "selectedKeys", function(val) {
        this.selectedkeys = val;
        $KW[this.wType]["updateView"](this, "selectedkeys", val);
    });

    defineGetter(this, "selectedKeyValues", function() {
        return this.selectedkeyvalues;
    });
    this.multiple = pspconfig.multiSelect;
    this.multiselectrows = pspconfig.multiSelectRows;
    this.editableareaskin = pspconfig.editableAreaSkin || "";
    this.viewtype = pspconfig.viewType;
    this.autosuggest = pspconfig.autoSuggest || false;

    defineGetter(this, "multiSelectRows", function() {
        return this.multiselectrows;
    });
    defineSetter(this, "multiSelectRows", function(val) {
        this.multiselectrows = val;
        $KW[this.wType]["updateView"](this, "multiselectrows", val);
    });

    defineGetter(this, "editableAreaSkin", function() {
        return this.editableareaskin;
    });
    defineSetter(this, "editableAreaSkin", function(val) {
        this.editableareaskin = val;
        $KW[this.wType]["updateView"](this, "editableareaskin", val);
    });

    defineGetter(this, "viewType", function() {
        return this.viewtype;
    });
    defineSetter(this, "viewType", function(val) {
        this.viewtype = val;
        $KW[this.wType]["updateView"](this, "viewtype", val);
    });

    defineGetter(this, "autoSuggest", function() {
        return this.autosuggest;
    });
    defineSetter(this, "autoSuggest", function(val) {
        this.autosuggest = val;
        $KW[this.wType]["updateView"](this, "autosuggest", val);
    });
};

kony.inherits(kony.ui.ListBox, kony.ui.GroupWidget);


kony.ui.RadioButtonGroup = function(bconfig, lconfig, pspconfig) {
    if(arguments.length < 3)
        bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("RadioButtonGroup"));

    kony.ui.RadioButtonGroup.baseConstructor.call(this, bconfig, lconfig, pspconfig);

    this.itemorientation = lconfig.itemOrientation || constants.RADIOGROUP_ITEM_ORIENTATION_VERTICAL;

    
    this.wType = "RadioButtonGroup";
    this.name = "kony.ui.RadioButtonGroup";

    this.viewtype = pspconfig.viewType || "defaultview";
    this.size = pspconfig.size || 18;
    this.checkedimage = pspconfig.checkedImage || "radiobuttonselected.png";
    this.uncheckedimage = pspconfig.uncheckedImage || "radiobuttonnormal.png";

    kony.ui.RadioButtonGroup.prototype.setGetterSetter.call(this);
};

kony.inherits(kony.ui.RadioButtonGroup, kony.ui.GroupWidget);

kony.ui.RadioButtonGroup.prototype.setGetterSetter = function() {
    defineSetter(this, "viewType", function(val) {
        this.viewtype = val;
        $KW[this.wType]["updateView"](this, "viewtype", val);
    });

    defineGetter(this, "viewType", function() {
        return this.viewtype;
    });

    defineSetter(this, "checkedImage", function(val) {
        this.checkedimage = val;
        $KW[this.wType]["updateView"](this, "checkedimage", val);
    });

    defineGetter(this, "checkedImage", function() {
        return this.checkedimage;
    });

    defineSetter(this, "uncheckedImage", function(val) {
        this.uncheckedimage = val;
        $KW[this.wType]["updateView"](this, "uncheckedimage", val);
    });

    defineGetter(this, "uncheckedImage", function() {
        return this.uncheckedimage;
    });

    defineSetter(this, "dimension", function(val) {
        this.size = val;
        $KW[this.wType]["updateView"](this, "size", val);
    });

    defineGetter(this, "dimension", function() {
        return this.size;
    });



};


kony.ui.PickerView = function(bconfig, lconfig, pspconfig) {
    if(arguments.length < 3)
        bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("PickerView"));

    kony.ui.PickerView.baseConstructor.call(this, bconfig, lconfig, pspconfig);

    
    this.wType = "PickerView";
    this.name = "kony.ui.PickerView";

    this.onselect = bconfig.onSelect;
    this.setGetterSetter();
};

kony.inherits(kony.ui.PickerView, kony.ui.CheckBoxGroup);


kony.ui.PickerView.prototype.setComponentData = function(compIndex, compData) {
    $KW.PickerView.setcomponentdata(this, compIndex, compData);
};

kony.ui.PickerView.prototype.setSelectedKeyInComponent = function(key, compIndex) {
    $KW.PickerView.setselectedkeyincomponent(this, key, compIndex);
};

kony.ui.PickerView.prototype.setGetterSetter = function() {
    defineGetter(this, "onSelect", function() {
        return this.onselect;
    });

    defineSetter(this, "onSelect", function(val) {
        this.onselect = val;
    });
};


kony.ui.Image2 = function(bconfig, lconfig, pspconfig) {
    if(arguments.length < 3)
        bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("Image2"));

    kony.ui.Image2.baseConstructor.call(this, bconfig, lconfig, pspconfig);

    this.ondownloadcomplete = bconfig.onDownloadComplete;
    this.imageWhileDownloading = this.imagewhiledownloading = bconfig.imageWhileDownloading;
    this.imageWhenFailed = this.imagewhenfailed = bconfig.imageWhenFailed;
    this.referencewidth = lconfig.referenceWidth;
    this.referenceheight = lconfig.referenceHeight;
    this.imagescalemode = (typeof lconfig.imageScaleMode == "undefined") ? constants.IMAGE_SCALE_MODE_MAINTAIN_ASPECT_RATIO : lconfig.imageScaleMode;
    
    this.canUpdateUI = true;
    this.skin = bconfig.skin;

    
    this.wType = "Image";
    this.name = "kony.ui.Image2";

    var src = bconfig.src;
    if(src) this.srcType = 1;

    defineGetter(this, "src", function() {
        return src;
    });

    defineSetter(this, "src", function(val) {
        this.srctype = 1;
        var oldsrc = this.src;
        src = val;
        this.canUpdateUI && $KW[this.wType]["updateView"](this, "src", val, oldsrc);
    });


    var base64 = null;
    defineGetter(this, "base64", function() {
        return base64;
    });
    defineSetter(this, "base64", function(val) {
        this.srcType = 2;
        base64 = val;
        $KW[this.wType]["updateView"](this, "base64", val);
    });
    this.tooltip = pspconfig.toolTip;

    defineGetter(this, "toolTip", function() {
        return this.tooltip;
    });

    defineSetter(this, "toolTip", function(val) {
        this.tooltip = val;
        kony.model.updateView(this, "tooltip", val);
    });
    this.setGetterSetter();
};

kony.inherits(kony.ui.Image2, kony.ui.Widget);

kony.ui.Image2.prototype.setGetterSetter = function() {
    defineGetter(this, "imageScaleMode", function() {
        return this.imagescalemode;
    });
    defineSetter(this, "imageScaleMode", function(val) {
        this.imagescalemode = val;
        $KW[this.wType]["updateView"](this, "imagescalemode", val);
    });

    defineGetter(this, "referenceHeight", function() {
        return this.referenceheight;
    });
    defineSetter(this, "referenceHeight", function(val) {
        this.referenceheight = val;
        $KW[this.wType]["updateView"](this, "referenceheight", val);
    });

    defineGetter(this, "referenceWidth", function() {
        return this.referencewidth;
    });
    defineSetter(this, "referenceWidth", function(val) {
        this.referencewidth = val;
        $KW[this.wType]["updateView"](this, "referencewidth", val);
    });

    defineGetter(this, "onDownloadComplete", function() {
        return this.ondownloadcomplete;
    });
    defineSetter(this, "onDownloadComplete", function(val) {
        this.ondownloadcomplete = val;
    });
};


kony.ui.Image = function(bconfig, lconfig, pspconfig) {
    kony.ui.Image.baseConstructor.call(this, bconfig, lconfig, pspconfig);

    
    this.scaleMode = this.scalemode = pspconfig.scaleMode;
    this.heightwidth = pspconfig.heightWidth;
    this.imageWhileDownloading = this.imagewhiledownloading = pspconfig.imageWhileDownloading;
    this.imageWhenFailed = this.imagewhenfailed = pspconfig.imageWhenFailed;
    this.skin = bconfig.skin;

    this.name = "kony.ui.Image";

};
kony.inherits(kony.ui.Image, kony.ui.Image2);

kony.ui.Image2.prototype.scale =
kony.ui.Image2.prototype.cropToRect =
kony.ui.Image2.prototype.getImageWidth =
kony.ui.Image2.prototype.getImageHeight =
kony.ui.Image2.prototype.getImageAsRawBytes = function() {
    kony.web.logger("warn", "This Image method is not supported in SPA");
};


kony.ui.Map = function(bconfig, lconfig, pspconfig) {
    if(arguments.length < 3)
        bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("Map"));

    kony.ui.Map.baseConstructor.call(this, bconfig, lconfig, pspconfig);

    this.provider = bconfig.provider || constants.MAP_PROVIDER_GOOGLE;
    this.mapApiKey = bconfig.mapKey; 
    this.mapClientId = bconfig.clientId; 
    this.navControlsImageConfig = pspconfig.navControlsImageConfig;
    this.mapSource = this.mapsrc = pspconfig.mapSource;
    this.screenLevelWidget = bconfig.screenLevelWidget;
    this.defaultpinimage = bconfig.defaultPinImage;
    this.locationdata = bconfig.locationData;
    this.zoomlevel = pspconfig.zoomLevel;
    this.showzoomcontrol = pspconfig.showZoomControl || true;
    this.markers = [];
    this.displaymaptypecontrols = true;
    this.onpinclick = bconfig.onPinClick;
    this.onselection = bconfig.onSelection;
    this.onboundschanged = bconfig.onBoundsChanged;
    this.autocenterpinonclick = bconfig.autoCenterPinOnClick;
    this.onmaploaded = bconfig.onMapLoaded;
    this.enablemultiplecallouts = bconfig.enableMultipleCallouts;
    this.containerheight = lconfig.containerHeight;
    this.containerheightreference = lconfig.containerHeightReference || constants.CONTAINER_HEIGHT_BY_FORM_REFERENCE;

    defineGetter(this, "mapKey", function() {
        return this.mapApiKey;
    });
    defineSetter(this, "mapKey", function(val) {
        this.mapApiKey = val;
    });
    defineGetter(this, "autoCenterPinOnClick", function() {
        return this.autocenterpinonclick;
    });
    defineSetter(this, "autoCenterPinOnClick", function(val) {
        this.autocenterpinonclick = val;
    });
    defineGetter(this, "containerHeight", function() {
        return this.containerheight;
    });
    defineSetter(this, "containerHeight", function(val) {
        this.containerheight = val;
        kony.model.updateView(this, "containerheight", val);
    });

    defineGetter(this, "displayMapTypeControls", function() {
        return this.displaymaptypecontrols;
    });
    defineSetter(this, "displayMapTypeControls", function(val) {
        this.displaymaptypecontrols = val;
    });

    defineGetter(this, "containerHeightReference", function() {
        return this.containerheightreference;
    });
    defineSetter(this, "containerHeightReference", function(val) {
        this.containerheightreference = val;
        kony.model.updateView(this, "containerheightreference", val);
    });


    
    this.wType = "Map";
    this.name = "kony.ui.Map";

    var address = pspconfig.address;
    defineGetter(this, "address", function() {
        return address;
    });
    defineSetter(this, "address", function(val) {
        address = val;
        $KW[this.wType]["updateView"](this, "address", val);
    });

    
    this.calloutPostion = bconfig.calloutPostion;

    this.widgetdatamapforcallout = bconfig.widgetDataMapForCallout; 
    defineGetter(this, "widgetDataMapForCallout", function() {
        return this.widgetdatamapforcallout;
    });
    defineSetter(this, "widgetDataMapForCallout", function(val) {
        this.widgetdatamapforcallout = val;
    });

    this.callouttemplate = bconfig.calloutTemplate;
    this.calloutwidth = bconfig.calloutWidth;
    defineGetter(this, "calloutTemplate", function() {
        return this.callouttemplate;
    });
    defineSetter(this, "calloutTemplate", function(val) {
        this.callouttemplate = val;
    });

    
    defineGetter(this, "calloutWidth", function() {
        return this.calloutwidth;
    });
    defineSetter(this, "calloutWidth", function(val) {
        this.calloutwidth = val;
        $KW.Map.setUpInteractiveCanvasMap();
    });

    var mode = pspconfig.mode || constants.MAP_VIEW_MODE_NORMAL;
    defineGetter(this, "mode", function() {
        return mode;
    });
    defineSetter(this, "mode", function(val) {
        mode = val;
        $KW[this.wType]["updateView"](this, "mode", val);
    });

    this.setGetterSetter();
    bconfig.locationData && $KW[this.wType]["updateView"](this, "locationdata", bconfig.locationData);
};

kony.inherits(kony.ui.Map, kony.ui.Widget);

kony.ui.Map.prototype.setGetterSetter = function() {
    defineGetter(this, "zoomLevel", function() {
        return this.zoomlevel;
    });
    defineSetter(this, "zoomLevel", function(val) {
        this.zoomlevel = val;
        $KW[this.wType]["updateView"](this, "zoomlevel", val);
    });

    defineGetter(this, "showZoomControl", function() {
        return this.showzoomcontrol;
    });
    defineSetter(this, "showZoomControl", function(val) {
        this.showzoomcontrol = val;
        $KW[this.wType]["updateView"](this, "showzoomcontrol", val);
    });

    defineGetter(this, "locationData", function() {
        return this.locationdata;
    });
    defineSetter(this, "locationData", function(val) {
        this.locationdata = val;
        $KW[this.wType]["updateView"](this, "locationdata", val);
    });

    defineGetter(this, "defaultPinImage", function() {
        return this.defaultpinimage;
    });
    defineSetter(this, "defaultPinImage", function(val) {
        this.defaultpinimage = val;
        $KW[this.wType]["updateView"](this, "defaultpinimage", val);
    });

    defineGetter(this, "onPinClick", function() {
        return this.onpinclick;
    });
    defineSetter(this, "onPinClick", function(val) {
        this.onpinclick = val;
    });

    defineGetter(this, "onSelection", function() {
        return this.onselection;
    });
    defineSetter(this, "onSelection", function(val) {
        this.onselection = val;
    });

    defineGetter(this, "onBoundsChanged", function() {
        return this.onboundschanged;
    });
    defineSetter(this, "onBoundsChanged", function(val) {
        this.onboundschanged = val;
    });
    defineGetter(this, "onMapLoaded", function() {
        return this.onmaploaded;
    });
    defineSetter(this, "onMapLoaded", function(val) {
        this.onmaploaded = val;
    });
    defineGetter(this, "enableMultipleCallouts", function() {
        return this.enablemultiplecallouts;
    });
    defineSetter(this, "enableMultipleCallouts", function(val) {
        this.enablemultiplecallouts = val;
    });
};


kony.ui.Map.prototype.navigateTo = function(index, showcallout) {
    $KW.Map.navigateTo(this, index, showcallout);
};

kony.ui.Map.prototype.navigateToLocation = function(locationData, showcallout, dropPin) {
    $KW.Map.navigateToLocation(this, locationData, showcallout, dropPin);
};
kony.ui.Map.prototype.routeLocations = function(startLocation, endLocation, locations, routeConfig) {
    $KW.Map.routeLocations(this, startLocation, endLocation, locations, routeConfig);
};
kony.ui.Map.prototype.dismissCallout = function(mapid, location) {
    $KW.Map.dismissCallout(this, mapid, location);
};
kony.ui.Map.prototype.setCalloutVisibility = function(visibilityFlag, pindataArr) {
    $KW.Map.setCalloutVisibility(this, visibilityFlag, pindataArr);
};
kony.ui.Map.prototype.addPin = function(pindata) {
    $KW.Map.addPin(this, pindata);
};
kony.ui.Map.prototype.addPins = function(pindataArr) {
    $KW.Map.addPins(this, pindataArr);
};
kony.ui.Map.prototype.updatePin = function(pindata) {
    $KW.Map.updatePin(this, pindata);
};
kony.ui.Map.prototype.updatePins = function(pindataArr) {
    $KW.Map.updatePins(this, pindataArr);
};
kony.ui.Map.prototype.removePin = function(pindata) {
    $KW.Map.removePin(this, pindata, true);
};
kony.ui.Map.prototype.removePins = function(pindataArr) {
    $KW.Map.removePins(this, pindataArr);
};
kony.ui.Map.prototype.addPolygon = function(polydata) {
    $KW.Map.addPolygon(this, polydata);
};
kony.ui.Map.prototype.addPolyline = function(polylinedata) {
    $KW.Map.addPolyline(this, polylinedata);
};
kony.ui.Map.prototype.addCircle = function(circleData) {
    this.locationdata = [circleData.centerLocation];
    $KW.Map.addCircle(this, circleData);
};
kony.ui.Map.prototype.clear = function() {
    $KW.Map.clear(this);
};
kony.ui.Map.prototype.removeCircle = function(circleID) {
    $KW.Map.removeCircle(this, circleID);
};
kony.ui.Map.prototype.removePolygon = function(polygonID) {
    $KW.Map.removePolygon(this, polygonID);
};
kony.ui.Map.prototype.removePolyline = function(polylineID) {
    $KW.Map.removePolyline(this, polylineID);
};


kony.ui.Browser = function(bconfig, lconfig, pspconfig) {
    if(arguments.length < 3)
        bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("Browser"));

    kony.ui.Browser.baseConstructor.call(this, bconfig, lconfig, pspconfig);

    this.onSuccess = bconfig.onSuccess; 
    this.onFailure = bconfig.onFailure; 
    this.screenLevelWidget = bconfig.screenLevelWidget; 
    this.enableZoom = bconfig.enableZoom; 
    this.detectTelNumber = bconfig.detectTelNumber; 

    this.readconfig = function(val) {
        this.url = val.URL;
        this.method = val.requestMethod;
        this.data = val.requestData;
    }

    bconfig.requestURLConfig && this.readconfig(bconfig.requestURLConfig);
    this.requesturlconfig = bconfig.requestURLConfig;
    this.htmlstring = bconfig.htmlString;


    this.containerheight = lconfig.containerHeight;
    this.containerheightreference = lconfig.containerHeightReference || constants.CONTAINER_HEIGHT_BY_FORM_REFERENCE;

    this.enablenativecommunication = bconfig.enableNativeCommunication ? true : false;


    
    this.wType = "Browser";
    this.name = "kony.ui.Browser";

    this.setGetterSetter();
};

kony.inherits(kony.ui.Browser, kony.ui.Widget);

kony.ui.Browser.prototype.setGetterSetter = function() {
    defineGetter(this, "htmlString", function() {
        return this.htmlstring;
    });
    defineSetter(this, "htmlString", function(val) {
        this.htmlstring = val;
        $KW[this.wType]["updateView"](this, "htmlstring", val);
    });

    defineGetter(this, "requestURLConfig", function() {
        return this.requesturlconfig;
    });
    defineSetter(this, "requestURLConfig", function(val) {
        this.requesturlconfig = val;
        this.readconfig(val);
        $KW[this.wType]["updateView"](this, "requesturlconfig", val);
    });
    defineGetter(this, "containerHeight", function() {
        return this.containerheight;
    });

    defineSetter(this, "containerHeight", function(val) {
        this.containerheight = val;
        kony.model.updateView(this, "containerheight", val);
    });

    defineGetter(this, "containerHeightReference", function() {
        return this.containerheightreference;
    });

    defineSetter(this, "containerHeightReference", function(val) {
        this.containerheightreference = val;
        kony.model.updateView(this, "containerheightreference", val);
    });

    defineGetter(this, "enableNativeCommunication", function() {
        return this.enablenativecommunication;
    });

};


kony.ui.Browser.prototype.isCordovaAppsEnabled =
    kony.ui.Browser.prototype.isHtmlPreviewEnabled =
    kony.ui.Browser.prototype.isWebAppDevelopmentEnabled =
    kony.ui.Browser.prototype.loadData =
    kony.ui.Browser.prototype.getHTMLFilesInWebFolder =
    kony.ui.Browser.prototype.canGoBack =
    kony.ui.Browser.prototype.canGoForward =
    kony.ui.Browser.prototype.clearHistory = function() {
        kony.web.logger("warn", "This Browser method is not supported in SPA");
    };

kony.ui.Browser.prototype.evaluateJavaScript = function(jscript) {
    $KW.Browser.evaluateJavaScript(this, jscript);
};

kony.ui.Browser.prototype.evaluateJavaScriptdepri = function(jscript) {
    kony.web.logger("log", "executing javascript in " + this.id + " window handler");
    var scr = document.createElement('script');
    scr.innerHTML = this.id + "Err = null; try{" + jscript + "}catch(e){" + this.id + "Err=e" + "}";
    if($KG["webView" + this.id] && !$KG["webView" + this.id].closed) {
        
        var anchor = document.createElement('a');
        anchor.href = this.url;
        if(window.location.origin != anchor.origin) {
            throw {
                "errorCode": "104",
                "name": "Not supported Error",
                "message": "Not supported Error"
            }
        }
        $KG["webView" + this.id].document.head.appendChild(scr);
        if($KG["webView" + this.id][this.id + "Err"] != null) { 
            throw {
                "errorCode": "106",
                "name": "Unknown Error",
                "message": "Unknown Error"
            }
        }
    } else {
        document.head.appendChild(scr);
        if(window[this.id + "Err"] != null) { 
            throw {
                "errorCode": "106",
                "name": "Unknown Error",
                "message": "Unknown Error"
            }
        }
    }

    return null;
};

kony.ui.Browser.prototype.evaluateJavaScriptAsync = function(jscript) {
    return null;
};

kony.ui.Browser.prototype.setResponse =
kony.ui.Browser.prototype.requestURLConfig = function() {
    kony.web.logger("warn", "This Browser method is not supported in SPA");
};

kony.ui.Browser.prototype.goBack = function() {
    $KW.Browser.goBack(this);
};

kony.ui.Browser.prototype.goForward = function() {
    $KW.Browser.goForward(this);
};

kony.ui.Browser.prototype.reload = function() {
    $KW.Browser.reload(this);
};


kony.ui.RichText = function(bconfig, lconfig, pspconfig) {
    if(arguments.length < 3)
        bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("RichText"));

    kony.ui.RichText.baseConstructor.call(this, bconfig, lconfig, pspconfig);

    this._text = bconfig.text || "";
    defineGetter(this, "text", function() {
        return this._text;
    });
    defineSetter(this, "text", function(val) {
        var oldvalue = this._text;
        this._text = val;
        if(this.canUpdateUI) {
            
            this.i18n_text = "";
            $KW[this.wType]["updateView"](this, "text", val);
            $KW.FlexUtils.setLayoutConfig(this, val, oldvalue);
        }
    });

    this.linkskin = bconfig.linkSkin;
    this.linkfocusskin = pspconfig.linkFocusSkin;

    defineGetter(this, "linkSkin", function() {
        return this.linkskin;
    });
    defineSetter(this, "linkSkin", function(val) {
        this.linkskin = val;
        $KW[this.wType]["updateView"](this, "linkskin", val);
    });

    defineGetter(this, "linkFocusSkin", function() {
        return this.linkfocusskin;
    });
    defineSetter(this, "linkFocusSkin", function(val) {
        this.linkfocusskin = val;
        $KW[this.wType]["updateView"](this, "linkfocusskin", val);
    });

    
    this.canUpdateUI = true;
    this.wType = "RichText";
    this.name = "kony.ui.RichText";
};

kony.inherits(kony.ui.RichText, kony.ui.Widget);


kony.ui.FlexContainer = function(bconfig, lconfig, pspconfig) {
    if(arguments.length < 3)
        bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("FlexContainer"));

    this.name = "kony.ui.FlexContainer";
    kony.ui.FlexContainer.baseConstructor.call(this, bconfig, lconfig, pspconfig);
    this.wType = "FlexContainer";
    this.allboxes = []; 
    this.autogrowMode = bconfig.autogrowMode;
    this.autogrowHeight = false;
    this.canMeasureChildrenHeight = true;
    this.hBorder = 0;
    this.vBorder = 0;
    
    this.isMaster = bconfig.isMaster === undefined ? false : (bconfig.isMaster && true);
    this.preshow = bconfig.preShow;
    this.postshow = bconfig.postShow;
    this.onhide = bconfig.onHide;
    
    this.addWidgets = bconfig.addWidgets;
    this.onDestroy = bconfig.onDestroy;
    this.init = bconfig.init;
    this.addWidgetsdone = this.initdone = false;
    this.enableonscrollwidgetpositionforsubwidgets = bconfig.enableOnScrollWidgetPositionForSubwidgets || false;
    bconfig.i18n_tabName && (this.i18n_tabname = bconfig.i18n_tabName);

    if(!this.addWidgets) {
        this.addWidgetsdone = true;
    }

    var addWidgets = bconfig.addWidgets;
    defineGetter(this, "addWidgets", function() {
        return addWidgets;
    });
    defineSetter(this, "addWidgets", function(val) {
        addWidgets = val;
        this.addWidgetsdone = false;
    });

    this.retainflowhorizontalalignment = this.retainFlowHorizontalAlignment = lconfig.retainFlowHorizontalAlignment;
    var shouldMirrorLayoutDirection = (bconfig.layoutType === kony.flex.FLOW_HORIZONTAL) && $KW.FlexUtils.shouldApplyRTL(this, "layoutAlignment");
    this.reverselayoutdirection = (shouldMirrorLayoutDirection) ? !bconfig.reverseLayoutDirection : bconfig.reverseLayoutDirection;
    defineGetter(this, "reverseLayoutDirection", function() {
        return this.reverselayoutdirection;
    });
    defineSetter(this, "reverseLayoutDirection", function(val) {
        var oldvalue = this.reverselayoutdirection;
        this.reverselayoutdirection = val;
        $KW.FlexUtils.setChildrenConfig(this, val, oldvalue);
    });

    this.defineContainerGetter = function(parent) {
        if(this.addWidgets) {
            var id = bconfig.id;
            var that = this;
            defineGetter(parent, id, function() {
                $KU.invokeAddWidgets(that);
                $KU.invokeWidgetInit(that);
                return that;
            });
        }
    };

    this.defineContainerSetter = function(parent) {
        if(this.addWidgets) {
            var id = bconfig.id;
            var that = this;
            defineSetter(parent, id, function() {
                return that;
            });
        }
    };
    

    this.layouttype = bconfig.layoutType || kony.flex.FREE_FORM;
    defineGetter(this, "layoutType", function() {
        return this.layouttype;
    });
    defineSetter(this, "layoutType", function(val) {
        var oldvalue = this.layouttype;
        if(val != oldvalue) {
            this.layouttype = val;
            $KW.FlexUtils.setLayoutConfig(this, val, oldvalue);
            $KW.FlexUtils.setChildrenConfig(this, val, oldvalue);
            $KW[this.wType]["updateView"](this, "layouttype", val);
        }
    });

    this.clipbounds = (typeof bconfig.clipBounds == "undefined") ? true : bconfig.clipBounds;
    defineGetter(this, "clipBounds", function() {
        return this.clipbounds;
    });
    defineSetter(this, "clipBounds", function(val) {
        this.clipbounds = val;
        $KW[this.wType]["updateView"](this, "clipbounds", val);
    });



    this.dolayout = bconfig.doLayout;
    defineGetter(this, "doLayout", function() {
        return this.dolayout;
    });
    defineSetter(this, "doLayout", function(val) {
        this.dolayout = val;
    });

    defineGetter(this, "_konyControllerName", function() {
        return this.konyControllerName;
    });
    defineSetter(this, "_konyControllerName", function(val) {
        this.konyControllerName = val;
    });

    defineGetter(this, "preShow", function() {
        return this.preshow;
    });
    defineSetter(this, "preShow", function(val) {
        this.preshow = val;
    });

    defineGetter(this, "postShow", function() {
        return this.postshow;
    });
    defineSetter(this, "postShow", function(val) {
        this.postshow = val;
    });

    defineGetter(this, "onHide", function() {
        return this.onhide;
    });
    defineSetter(this, "onHide", function(val) {
        this.onhide = val;
    });

    this.ismodalcontainer = bconfig.isModalContainer;

    defineGetter(this, "isModalContainer", function() {
        return this.ismodalcontainer;
    });
    defineSetter(this, "isModalContainer", function(val) {
        if(val != this.ismodalcontainer) {
            this.ismodalcontainer = val;
            $KU.checkAndReCalculateTopFlexModal(this);
        }
    });
};

kony.inherits(kony.ui.FlexContainer, kony.ui.ContainerWidget);


kony.ui.FlexContainer.prototype.destroy = function() {
    var widgets = this.widgets();
    for(var i = 0; i < widgets.length; i++) {
        removeReferencesFromTopLevelModel(widgets[i]);
        if(widgets[i] instanceof _konyConstNS.ContainerWidget) {
            widgets[i] = $KW.Utils.getActualWidgetModel(widgets[i]);
            if(widgets[i].wType === "FlexContainer")
                widgets[i].destroy();
            delete this[widgets[i].id];
        }
    }
    this.onDestroy && this.onDestroy(this);
    this.addWidgetsdone = false;
    this.initdone = false;
    this.ownchildrenref = [];
    this.children = [];
};

kony.ui.FlexContainer.prototype.add = function() {
    var widgetarray = [].slice.call(arguments);
    boxWidgetExtendAdd.call(this, widgetarray);
    $KU.checkAndReCalculateTopFlexModal(this);
};

kony.ui.FlexContainer.prototype.addAt = function(widgetref, index) {
    boxWidgetExtendAddAt.call(this, widgetref, index);
    $KU.checkAndReCalculateTopFlexModal(this);
};

kony.ui.FlexContainer.prototype.addAll = function(widgetref, index) {
    boxWidgetExtendAddAt.call(this, widgetref, index);
    $KU.checkAndReCalculateTopFlexModal(this);
};

kony.ui.FlexContainer.prototype.remove = function(widgetref) {
    boxWidgetExtendRemove.call(this, widgetref);
    $KU.checkAndReCalculateTopFlexModal(this);
};

kony.ui.FlexContainer.prototype.removeAt = function(index) {
    var removedWidget = boxWidgetExtendRemoveAt.call(this, index);

    $KU.checkAndReCalculateTopFlexModal(this);
    return removedWidget;
};

kony.ui.FlexContainer.prototype.removeAll = function() {
    boxWidgetExtendRemoveAll.call(this);
    $KU.checkAndReCalculateTopFlexModal(this);
};

kony.ui.FlexContainer.prototype.widgets = function() {
    return kony.ui.ContainerWidget.prototype.widgets.call(this);
};

kony.ui.FlexContainer.prototype.forceLayout = function() {
    $KW.FlexContainer.forceLayout(this);
};

kony.ui.FlexContainer.prototype.setDefaultUnit = function(unit) {
    this.defaultunit = unit;
};

kony.ui.FlexContainer.prototype.executeOnParent = function() {
    if(arguments.length >= 1) {
        var callback = arguments[0];
        var args = [];
        if(arguments.length >= 2) {
            args = [].slice.call(arguments);
            args = args.slice(1, args.length);
        }
        $KW.FlexContainer.executeOnParent(this, callback, args);

    }
};

kony.ui.FlexContainer.prototype._registerForAddWidgetsEvent = function(widgetarray) {
    
};

kony.ui.FlexContainer.prototype._unRegisterForAddWidgetsEvent = function(widgetarray) {
    
};

kony.ui.FlexContainer.prototype._registerForInitEvent = function(widgetarray) {
    
};

kony.ui.FlexContainer.prototype._unRegisterForInitEvent = function(widgetarray) {
    
};

kony.ui.FlexScrollContainer = function(bconfig, lconfig, pspconfig) {
    if(arguments.length < 3)
        bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("FlexScrollContainer"));

    kony.ui.FlexScrollContainer.baseConstructor.call(this, bconfig, lconfig, pspconfig);
    this.name = "kony.ui.FlexScrollContainer";
    this.wType = "FlexScrollContainer";
    this.allboxes = []; 

    this.enablescrolling = (typeof bconfig.enableScrolling == "undefined") ? true : bconfig.enableScrolling;
    defineGetter(this, "enableScrolling", function() {
        return this.enablescrolling;
    });
    defineSetter(this, "enableScrolling", function(val) {
        this.enablescrolling = val;
        $KW[this.wType]["updateView"](this, "enableScrolling", val);
    });

    this.scrolldirection = (typeof bconfig.scrollDirection == "undefined") ? kony.flex.SCROLL_HORIZONTAL : bconfig.scrollDirection;
    defineGetter(this, "scrollDirection", function() {
        return this.scrolldirection;
    });
    defineSetter(this, "scrollDirection", function(val) {
        this.scrolldirection = val;
        $KW[this.wType]["updateView"](this, "scrollDirection", val);
    });
    this.contentoffset = bconfig.contentOffset;
    defineGetter(this, "contentOffset", function() {
        return this.contentoffset;
    });
    defineSetter(this, "contentOffset", function(val) {
        this.contentoffset = val;
        $KW.FlexScrollContainer.updateView(this, "contentOffset", val);
    });

    this.contentsize = bconfig.contentSize;
    defineGetter(this, "contentSize", function() {
        return this.contentsize;
    });
    defineSetter(this, "contentSize", function(val) {
        this.contentsize = val;
    });

    defineGetter(this, "enableOnScrollWidgetPositionForSubwidgets", function() {
        return this.enableonscrollwidgetpositionforsubwidgets;
    });
    defineSetter(this, "enableOnScrollWidgetPositionForSubwidgets", function(val) {
        this.enableonscrollwidgetpositionforsubwidgets = val;
    });

    defineGetter(this, "contentOffsetMeasured", function() {
        return $KW.APIUtils.getContentOffsetMeasured(this);
    });

    this.contentsize = bconfig.contentSize;
    defineGetter(this, "contentSizeMeasured", function() {
        return $KW.FlexScrollContainer.getContentSizeMeasured(this);
    });
    defineSetter(this, "contentSizeMeasured", function(val) {});



    this.bounce = (typeof bconfig.bounces == "undefined") ? true : bconfig.bounces;
    defineGetter(this, "bounces", function() {
        return this.bounce;
    });
    defineSetter(this, "bounces", function(val) {
        this.bounce = val;
        $KW[this.wType]["updateView"](this, "bounces", val);
    });

    this.allowhorizontalbounce = (typeof bconfig.allowHorizontalBounce == "undefined") ? true : bconfig.allowHorizontalBounce;
    defineGetter(this, "allowHorizontalBounce", function() {
        return this.allowhorizontalbounce;
    });
    defineSetter(this, "allowHorizontalBounce", function(val) {
        this.allowhorizontalbounce = val;
        $KW[this.wType]["updateView"](this, "allowHorizontalBounce", val);
    });

    this.allowverticalbounce = (typeof bconfig.allowVerticalBounce == "undefined") ? true : bconfig.allowVerticalBounce;
    defineGetter(this, "allowVerticalBounce", function() {
        return this.allowverticalbounce;
    });
    defineSetter(this, "allowVerticalBounce", function(val) {
        this.allowverticalbounce = val;
        $KW[this.wType]["updateView"](this, "allowVerticalBounce", val);
    });

    this.horizontalscrollindicator = (typeof bconfig.horizontalScrollIndicator == "undefined") ? true : bconfig.horizontalScrollIndicator;
    defineGetter(this, "horizontalScrollIndicator", function() {
        return this.horizontalscrollindicator;
    });
    defineSetter(this, "horizontalScrollIndicator", function(val) {
        this.horizontalscrollindicator = val;
        $KW[this.wType]["updateView"](this, "horizontalScrollIndicator", val);
    });

    this.verticalscrollindicator = (typeof bconfig.verticalScrollIndicator == "undefined") ? true : bconfig.verticalScrollIndicator;
    defineGetter(this, "verticalScrollIndicator", function() {
        return this.verticalscrollindicator;
    });
    defineSetter(this, "verticalScrollIndicator", function(val) {
        this.verticalscrollindicator = val;
        $KW[this.wType]["updateView"](this, "verticalScrollIndicator", val);
    });


    this.pagineenabled = (typeof bconfig.pagineEnabled == "undefined") ? false : bconfig.pagineEnabled;
    defineGetter(this, "pagineEnabled", function() {
        return this.pagineenabled;
    });
    defineSetter(this, "pagineEnabled", function(val) {
        this.pagineenabled = val;
    });

    this.dragg = false;
    defineGetter(this, "dragging", function() {
        var scrollerId = $KW.Utils.getKMasterWidgetID(this) + "_scroller";
        if($KG[scrollerId]) {
            return $KG[scrollerId].dragging;
        }
        return false;
    });
    defineSetter(this, "dragging", function(val) {
        
    });

    defineGetter(this, "tracking", function() {
        var scrollerId = $KW.Utils.getKMasterWidgetID(this) + "_scroller";
        if($KG[scrollerId]) {
            return $KG[scrollerId].tracking;
        }
        return false;
    });
    defineSetter(this, "tracking", function(val) {
        
    });


    defineGetter(this, "decelerating", function() {
        var scrollerId = $KW.Utils.getKMasterWidgetID(this) + "_scroller";
        if($KG[scrollerId]) {
            return !this.tracking && $KG[scrollerId].animating;
        }
        return false;
    });
    defineSetter(this, "decelerating", function(val) {
        
    });



    this.onscrollstart = bconfig.onScrollStart;
    defineGetter(this, "onScrollStart", function() {
        return this.onscrollstart;
    });
    defineSetter(this, "onScrollStart", function(val) {
        this.onscrollstart = val;
        $KW[this.wType]["updateView"](this, "onScrollStart", val);
    });

    this.onscrolltouchreleased = bconfig.onScrollTouchReleased;
    defineGetter(this, "onScrollTouchReleased", function() {
        return this.onscrolltouchreleased;
    });
    defineSetter(this, "onScrollTouchReleased", function(val) {
        this.onscrolltouchreleased = val;
        $KW[this.wType]["updateView"](this, "onScrollTouchReleased", val);
    });

    this.onscrolling = bconfig.onScrolling;
    defineGetter(this, "onScrolling", function() {
        return this.onscrolling;
    });
    defineSetter(this, "onScrolling", function(val) {
        this.onscrolling = val;
        $KW[this.wType]["updateView"](this, "onScrolling", val);
    });

    this.ondecelerationstarted = bconfig.onDecelerationStarted;
    defineGetter(this, "onDecelerationStarted", function() {
        return this.ondecelerationstarted;
    });
    defineSetter(this, "onDecelerationStarted", function(val) {
        this.ondecelerationstarted = val;
        $KW[this.wType]["updateView"](this, "onDecelerationStarted", val);
    });

    this.onscrollend = bconfig.onScrollEnd;
    defineGetter(this, "onScrollEnd", function() {
        return this.onscrollend;
    });
    defineSetter(this, "onScrollEnd", function(val) {
        this.onscrollend = val;
        $KW[this.wType]["updateView"](this, "onScrollEnd", val);
    });

    this.scrollingevents = bconfig.scrollingEvents || null;
    if(this.scrollingevents) {
        this.scrollingevents.onreachingbeginning = bconfig.scrollingEvents.onReachingBegining;
        this.scrollingevents.onreachingend = bconfig.scrollingEvents.onReachingEnd;
    }

    this.pullkey = bconfig.pullToRefreshI18NKey || "";
    this.releasepullkey = bconfig.releaseToPullRefreshI18NKey || "";
    this.pushkey = bconfig.pushToRefreshI18NKey || "";
    this.releasepushkey = bconfig.releaseToPushRefreshI18NKey || "";

    this.pullskin = bconfig.pullToRefreshSkin || "";
    this.pushskin = bconfig.pushToRefreshSkin || "";

    this.pullicon = bconfig.pullToRefreshIcon || "";
    this.pushicon = bconfig.pushToRefreshIcon || "";
    this.animateicons = bconfig.animateIcons || "";

    defineGetter(this, "scrollingEvents", function() {
        return this.scrollingevents;
    });
    defineSetter(this, "scrollingEvents", function(val) {
        this.scrollingevents = val;
        if(this.scrollingevents) {
            this.scrollingevents.onreachingbeginning = this.scrollingevents.onReachingBegining;
            this.scrollingevents.onreachingend = this.scrollingevents.onReachingEnd;
        }
        $KW[this.wType]["updateView"](this, "scrollingevents", val);
    });

    
    defineGetter(this, "pullToRefreshI18NKey", function() {
        return this.pullkey;
    });
    defineSetter(this, "pullToRefreshI18NKey", function(val) {
        this.pullkey = val;
        $KW[this.wType]["updateView"](this, "pullkey", val);
    });

    
    defineGetter(this, "releaseToPullRefreshI18NKey", function() {
        return this.releasepullkey;
    });
    defineSetter(this, "releaseToPullRefreshI18NKey", function(val) {
        this.releasepullkey = val;
        $KW[this.wType]["updateView"](this, "releasepullkey", val);
    });

    
    defineGetter(this, "pushToRefreshI18NKey", function() {
        return this.pushkey;
    });
    defineSetter(this, "pushToRefreshI18NKey", function(val) {
        this.pushkey = val;
        $KW[this.wType]["updateView"](this, "pushkey", val);
    });

    
    defineGetter(this, "releaseToPushRefreshI18NKey", function() {
        return this.releasepushkey;
    });
    defineSetter(this, "releaseToPushRefreshI18NKey", function(val) {
        this.releasepushkey = val;
        $KW[this.wType]["updateView"](this, "releasepushkey", val);
    });

    
    defineGetter(this, "pullToRefreshSkin", function() {
        return this.pullskin;
    });
    defineSetter(this, "pullToRefreshSkin", function(val) {
        this.pullskin = val;
        $KW[this.wType]["updateView"](this, "pullskin", val);
    });

    
    defineGetter(this, "pushToRefreshSkin", function() {
        return this.pushskin;
    });
    defineSetter(this, "pushToRefreshSkin", function(val) {
        this.pushskin = val;
        $KW[this.wType]["updateView"](this, "pushskin", val);
    });

    
    defineGetter(this, "pullToRefreshIcon", function() {
        return this.pullicon;
    });
    defineSetter(this, "pullToRefreshIcon", function(val) {
        this.pullicon = val;
        $KW[this.wType]["updateView"](this, "pullicon", val);
    });

    defineGetter(this, "pushToRefreshIcon", function() {
        return this.pushicon;
    });
    defineSetter(this, "pushToRefreshIcon", function(val) {
        this.pushicon = val;
        $KW[this.wType]["updateView"](this, "pushicon", val);
    });

    defineGetter(this, "animateIcons", function() {
        return this.animateicons;
    });
    defineSetter(this, "animateIcons", function(val) {
        this.animateicons = val;
        $KW[this.wType]["updateView"](this, "animateicons", val);
    });
};

kony.inherits(kony.ui.FlexScrollContainer, kony.ui.FlexContainer);

kony.ui.FlexScrollContainer.prototype.forceLayout = function() {
    $KW.FlexScrollContainer.forceLayout(this);
};

kony.ui.FlexScrollContainer.prototype.setContentOffset = function(contentOffSet, animate) {
    $KW.FlexScrollContainer.setContentOffSet(this, contentOffSet, animate);
};

kony.ui.FlexScrollContainer.prototype.scrollToWidget = function(widget, animate) {
    $KW.FlexScrollContainer.scrollToWidget(this, widget, animate);
};

kony.ui.FlexScrollContainer.prototype.scrollToEnd = function() {
    $KW.FlexScrollContainer.scrollToEnd(this);
};

kony.ui.FlexScrollContainer.prototype.setZoomScale = function() {
    kony.web.logger("warn", "This FlexScrollContainer method is not supported in SPA");
};


kony.ui.SegmentedUI2 = function(bconfig, lconfig, pspconfig) {
    if(arguments.length < 3)
        bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("SegmentedUI2"));

    kony.ui.SegmentedUI2.baseConstructor.call(this, bconfig, lconfig, pspconfig);
    this.groupcells = bconfig.groupCells || false;
    this.screenLevelWidget = bconfig.screenLevelWidget || false;
    this.widgetskin = bconfig.widgetSkin;
    this.skin = bconfig.skin;
    this.rowskin = bconfig.rowSkin;
    this.focusskin = bconfig.rowFocusSkin;
    this.askin = bconfig.alternateRowSkin;
    this.sectionheaderskin = bconfig.sectionHeaderSkin;
    this.widgetdatamap = bconfig.widgetDataMap;
    this.rowtemplate = bconfig.rowTemplate;
    this.sectionheadertemplate = bconfig.sectionHeaderTemplate;
    this.separatorrequired = bconfig.separatorRequired || false;
    this.separatorthickness = bconfig.separatorThickness;
    this.separatorcolor = bconfig.separatorColor;
    this.viewtype = bconfig.viewType;
    this.autogrowMode = bconfig.autogrowMode;
    this.onrowclick = bconfig.onRowClick;
    this.onrowdisplay = bconfig.onRowDisplay;
    this.retainselection = bconfig.retainSelection || false;
    this.needpageindicator = bconfig.needPageIndicator || false;
    this.pageondotimage = bconfig.pageOnDotImage || false;
    this.pageoffdotimage = bconfig.pageOffDotImage || false;
    this.onswipe = bconfig.onSwipe;
    this.showscrollbars = bconfig.showScrollbars;
    this.scrollingevents = bconfig.scrollingEvents || false;
    this.contentoffset = bconfig.contentOffset;
    this.stoprerenderonsetdataat = bconfig.stopRerenderOnSetDataAt || false;

    if(this.scrollingevents) {
        this.scrollingevents.onreachingbeginning = bconfig.scrollingEvents.onReachingBegining;
        this.scrollingevents.onreachingend = bconfig.scrollingEvents.onReachingEnd;
    }
    this.selectionbehavior = bconfig.selectionBehavior || constants.SEGUI_DEFAULT_BEHAVIOR;
    this.selectionbehaviorconfig = bconfig.selectionBehaviorConfig;
    this.selectedindex = bconfig.selectedIndex || null;
    this.selecteditems = null;
    this.selectedindices = bconfig.selectedIndices || null;
    this.selectedrowindex = bconfig.selectedRowIndex || null;
    this.selectedrowindices = bconfig.selectedRowIndices || null;

    this.containerheight = lconfig.containerHeight;
    this.containerheightreference = lconfig.containerHeightReference || constants.CONTAINER_HEIGHT_BY_FORM_REFERENCE;
    
    this.__y = 0;
    var data = bconfig.data;
    defineGetter(this, "data", function() {
        return data;
    });

    defineSetter(this, "data", function(val) {
        data = val;
        this.canUpdateUI && $KW[this.wType]["updateView"](this, "data", val);
    });
    defineGetter(this, "contentOffsetMeasured", function() {
        return $KW.APIUtils.getContentOffsetMeasured(this);
    });
    defineGetter(this, "contentOffset", function() {
        return this.contentoffset;
    });
    defineSetter(this, "contentOffset", function(val) {
        this.contentoffset = val;
        if(typeof val === "undefined" || val === null || typeof val.x === "undefined" || typeof val.y === "undefined") {
            return;
        }
        
        this.__y = 0;
        return $KW.APIUtils.setContentOffSet(this, val, true);
    });
    this.onrightclick = pspconfig.onRightClick;
    defineGetter(this, "onRightClick", function() {
        return this.onrightclick;
    });

    this.contextmenu = pspconfig.contextMenu;
    defineGetter(this, "contextMenu", function() {
        return this.contextmenu;
    });
    
    this.retainscrollpositionmode = bconfig.retainScrollPositionMode || constants.SEGUI_SCROLL_POSITION_DEFAULT;

    this.clonedTemplates = [];
    this.setGetterSetter();

    
    this.wType = "Segment";
    this.name = "kony.ui.SegmentedUI2";
    this.canUpdateUI = true;
};

kony.inherits(kony.ui.SegmentedUI2, kony.ui.Widget);

kony.ui.SegmentedUI2.prototype.setGetterSetter = function() {
    defineGetter(this, "widgetSkin", function() {
        return this.widgetskin;
    });
    defineSetter(this, "widgetSkin", function(val) {
        var oldvalue = this.widgetskin;
        this.widgetskin = val;
        $KW[this.wType]["updateView"](this, "widgetskin", val, oldvalue);
    });

    defineGetter(this, "rowSkin", function() {
        return this.rowskin;
    });
    defineSetter(this, "rowSkin", function(val) {
        var oldvalue = this.skin;
        this.rowskin = val;
        $KW[this.wType]["updateView"](this, "rowskin", val, oldvalue);
    });

    defineGetter(this, "rowFocusSkin", function() {
        return this.focusskin;
    });
    defineSetter(this, "rowFocusSkin", function(val) {
        var oldvalue = this.focusskin;
        this.focusskin = val;
        kony.model.updateView(this, "focusskin", val);
    });

    defineGetter(this, "alternateRowSkin", function() {
        return this.askin;
    });
    defineSetter(this, "alternateRowSkin", function(val) {
        var oldvalue = this.askin;
        this.askin = val;
        $KW[this.wType]["updateView"](this, "askin", val, oldvalue);
    });

    defineGetter(this, "sectionHeaderSkin", function() {
        return this.sectionheaderskin;
    });
    defineSetter(this, "sectionHeaderSkin", function(val) {
        var oldvalue = this.sectionheaderskin
        this.sectionheaderskin = val;
        $KW[this.wType]["updateView"](this, "sectionskin", val, oldvalue);
    });

    defineGetter(this, "widgetDataMap", function() {
        return this.widgetdatamap;
    });
    defineSetter(this, "widgetDataMap", function(val) {
        this.widgetdatamap = val;
    });

    defineGetter(this, "rowTemplate", function() {
        return this.rowtemplate;
    });
    defineSetter(this, "rowTemplate", function(val) {
        this.rowtemplate = val;
    });

    defineGetter(this, "sectionHeaderTemplate", function() {
        return this.sectionheadertemplate;
    });
    defineSetter(this, "sectionHeaderTemplate", function(val) {
        this.sectionheadertemplate = val;
    });

    defineGetter(this, "separatorRequired", function() {
        return this.separatorrequired;
    });
    defineSetter(this, "separatorRequired", function(val) {
        this.separatorrequired = val;
        $KW[this.wType]["updateView"](this, "separatorrequired", val);
    });

    defineGetter(this, "separatorThickness", function() {
        return this.separatorthickness;
    });
    defineSetter(this, "separatorThickness", function(val) {
        this.separatorthickness = val;
        $KW[this.wType]["updateView"](this, "separatorthickness", val);
    });

    defineGetter(this, "separatorColor", function() {
        return this.separatorcolor;
    });
    defineSetter(this, "separatorColor", function(val) {
        this.separatorcolor = val;
        $KW[this.wType]["updateView"](this, "separatorcolor", val);
    });

    defineGetter(this, "viewType", function() {
        return this.viewtype;
    });
    defineSetter(this, "viewType", function(val) {
        var oldvalue = this.viewtype
        this.viewtype = val;
        $KW[this.wType]["updateView"](this, "viewtype", val, oldvalue);
    });

    defineGetter(this, "onRowClick", function() {
        return this.onrowclick;
    });

    defineSetter(this, "onRowClick", function(val) {
        this.onrowclick = val;
    });

    defineGetter(this, "onRowDisplay", function() {
        return this.onrowdisplay;
    });

    defineSetter(this, "onRowDisplay", function(val) {
        this.onrowdisplay = val;
        $KW.Segment.onRowDisplay(this);
    });

    defineGetter(this, "retainSelection", function() {
        return this.retainselection;
    });
    defineSetter(this, "retainSelection", function(val) {
        this.retainselection = val;
    });

    defineGetter(this, "needPageIndicator", function() {
        return this.needpageindicator;
    });
    defineSetter(this, "needPageIndicator", function(val) {
        this.needpageindicator = val;
        $KW[this.wType]["updateView"](this, "needpageindicator", val);
    });

    defineGetter(this, "pageOnDotImage", function() {
        return this.pageondotimage;
    });
    defineSetter(this, "pageOnDotImage", function(val) {
        this.pageondotimage = val;
        $KW[this.wType]["updateView"](this, "pageondotimage", val);
    });

    defineGetter(this, "pageOffDotImage", function() {
        return this.pageoffdotimage;
    });
    defineSetter(this, "pageOffDotImage", function(val) {
        this.pageoffdotimage = val;
        $KW[this.wType]["updateView"](this, "pageoffdotimage", val);
    });

    defineGetter(this, "onSwipe", function() {
        return this.onswipe;
    });
    defineSetter(this, "onSwipe", function(val) {
        this.onswipe = val;
    });

    defineGetter(this, "showScrollbars", function() {
        return this.showscrollbars;
    });
    defineSetter(this, "showScrollbars", function(val) {
        this.showscrollbars = val;
    });

    defineGetter(this, "scrollingEvents", function() {
        return this.scrollingevents;
    });
    defineSetter(this, "scrollingEvents", function(val) {
        this.scrollingevents = val;
        if(this.scrollingevents) {
            this.scrollingevents.onreachingbeginning = val.onReachingBegining;
            this.scrollingevents.onreachingend = val.onReachingEnd;
        }
    });

    defineGetter(this, "containerHeight", function() {
        return this.containerheight;
    });

    defineSetter(this, "containerHeight", function(val) {
        this.containerheight = val;
        kony.model.updateView(this, "containerheight", val);
    });

    defineGetter(this, "containerHeightReference", function() {
        return this.containerheightreference;
    });

    defineSetter(this, "containerHeightReference", function(val) {
        this.containerheightreference = val;
        kony.model.updateView(this, "containerheightreference", val);
    });

    defineGetter(this, "selectionBehavior", function() {
        return this.selectionbehavior;
    });
    defineSetter(this, "selectionBehavior", function(val) {
        var oldvalue = this.selectionbehavior;
        this.selectionbehavior = val;
        $KW[this.wType]["updateView"](this, "selectionbehavior", val, oldvalue);
    });

    defineGetter(this, "selectionBehaviorConfig", function() {
        return this.selectionbehaviorconfig;
    });
    defineSetter(this, "selectionBehaviorConfig", function(val) {
        this.selectionbehaviorconfig = val;
        $KW[this.wType]["updateView"](this, "selectionbehaviorconfig", val);
    });

    defineGetter(this, "selectedIndex", function() {
        return this.selectedindex;
    });
    defineSetter(this, "selectedIndex", function(val) {
        this.selectedindex = val;
        $KW[this.wType]["updateView"](this, "selectedindex", val);
    });

    defineGetter(this, "selectedItems", function() {
        return this.selecteditems;
    });

    defineGetter(this, "selectedRowItems", function() {
        return this.selecteditems;
    });

    defineGetter(this, "selectedIndices", function() {
        return this.selectedindices;
    });
    defineSetter(this, "selectedIndices", function(val) {
        this.selectedindices = val;
        $KW[this.wType]["updateView"](this, "selectedindices", val);
    });

    defineGetter(this, "selectedRowIndex", function() {
        return this.selectedrowindex;
    });

    defineSetter(this, "selectedRowIndex", function(val) {
        this.selectedrowindex = val;
        $KW[this.wType]["updateView"](this, "selectedindex", val);
    });

    defineGetter(this, "selectedRowIndices", function() {
        return this.selectedrowindices;
    });

    defineSetter(this, "selectedRowIndices", function(val) {
        this.selectedrowindices = val;
        $KW[this.wType]["updateView"](this, "selectedindices", val);
    });

    defineGetter(this, "stopRerenderOnSetDataAt", function() {
        return this.stoprerenderonsetdataat;
    });

    defineSetter(this, "stopRerenderOnSetDataAt", function(val) {
        this.stoprerenderonsetdataat = val;
    });


    this.scrollingevents = this.scrollingevents || {};
    this.scrollingevents.scrollObj = this;
    if(this.scrollingevents) {
        defineGetter(this.scrollingEvents, "onReachingBegining", function() {
            return this.onreachingbeginning;
        });
        defineSetter(this.scrollingEvents, "onReachingBegining", function(val) {
            this.onreachingbeginning = val;
            $KW[this.scrollObj.wType]["updateView"](this.scrollObj, "onreachingbeginning", val);
        });

        defineGetter(this.scrollingEvents, "onReachingEnd", function() {
            return this.onreachingend;
        });
        defineSetter(this.scrollingEvents, "onReachingEnd", function(val) {
            this.onreachingend = val;
            $KW[this.scrollObj.wType]["updateView"](this.scrollObj, "onreachingend", val);
        });
    }

    defineGetter(this, "retainScrollPositionMode", function() {
        return this.retainscrollpositionmode;
    });

    defineSetter(this, "retainScrollPositionMode", function(val) {
        var oldvalue = this.retainscrollpositionmode;
        if(oldvalue != val) {
            this.retainscrollpositionmode = val;
            this.__y = 0;
        }
    });
}

kony.ui.SegmentedUI2.prototype.addAll = function(dataArray, animObj) {
    $KW.Segment.addAll(this, dataArray, animObj);
};

kony.ui.SegmentedUI2.prototype.addDataAt = function(dataArray, rowIndex, sectionIndex, animObj) {
    $KW.Segment.addDataAt(this, dataArray, rowIndex, sectionIndex, animObj);
};

kony.ui.SegmentedUI2.prototype.addSectionAt = function(dataArray, sectionIndex, animObj) {
    $KW.Segment.addSectionAt(this, dataArray, sectionIndex, animObj);
};

kony.ui.SegmentedUI2.prototype.removeAll = function(animObj) {
    $KW.Segment.removeAll(this, animObj);
};

kony.ui.SegmentedUI2.prototype.removeAt = function(rowIndex, sectionIndex, animObj) {
    $KW.Segment.removeAt(this, rowIndex, sectionIndex, animObj);
};

kony.ui.SegmentedUI2.prototype.removeSectionAt = function(sectionIndex, animObj) {
    $KW.Segment.removeSectionAt(this, sectionIndex, animObj);
};

kony.ui.SegmentedUI2.prototype.setData = function(dataArray, animObj) {
    $KW.Segment.setData(this, dataArray, animObj);
};

kony.ui.SegmentedUI2.prototype.setDataAt = function(dataObj, rowIndex, sectionIndex, animObj) {
    $KW.Segment.setDataAt(this, dataObj, rowIndex, sectionIndex, animObj);
};

kony.ui.SegmentedUI2.prototype.setSectionAt = function(dataArray, sectionIndex, animObj) {
    $KW.Segment.setSectionAt(this, dataArray, sectionIndex, animObj);
};


kony.ui.SegmentedUI2.prototype.setDataWithSections = function(dataArray) {
    $KW.Segment.setDataWithSections(this, dataArray);
};

kony.ui.SegmentedUI2.prototype.animateRows = function(animContext) {
    new $KW.Segment.animateRows(this, animContext);
};

kony.ui.SegmentedUI2.prototype.setAnimations = function(animObj) {
    if(this.listAnimation) 
        this.listAnimation.destroy();
    this.listAnimation = new $KW.Segment.setAnimations(this, animObj);
};

kony.ui.SegmentedUI2.prototype.getFirstVisibleRow = function() {
    return $KW.Segment.getFirstVisibleRow(this);
};

kony.ui.SegmentedUI2.prototype.getLastVisibleRow = function() {
    return $KW.Segment.getLastVisibleRow(this);
};

kony.ui.SegmentedUI2.prototype.searchText = function(searchCondition, config) {
    return $KW.Segment.searchText(searchCondition, config, this);
};

kony.ui.SegmentedUI2.prototype.getUpdatedSearchResults = function() {
    return $KW.Segment.getUpdatedSearchResults(this);
};

kony.ui.SegmentedUI2.prototype.clearSearch = function() {
    return $KW.Segment.clearSearch(this);
};
kony.ui.SegmentedUI2.prototype.resetSwipeMove = function(rowContext) {
    return $KW.Segment.resetSwipe(this, rowContext);
};

kony.ui.SegmentedUI = function(bconfig, lconfig, pspconfig) {
    kony.ui.SegmentedUI.baseConstructor.call(this, bconfig, lconfig, pspconfig);

    this.skin = bconfig.skin;

    this.askin = bconfig.aSkin;

    this.sectionheaderskin = pspconfig.secSkin;

    this.name = "kony.ui.SegmentedUI";

    retainSelection = pspconfig.retainSelection || false;
    viewType = this.viewtype = pspconfig.view;
    selectionBehavior = this.selectionbehavior = pspconfig.behavior || constants.SEGUI_DEFAULT_BEHAVIOR;
    separatorThickness = this.separatorthickness = pspconfig.sepThickness;
    separatorColor = this.separatorcolor = pspconfig.sepColor;
    onRowClick = this.onrowclick = bconfig.onClick;
    this.separatorrequired = true;

    this.focuseditem = null; 
    defineGetter(this, "focusedItem", function() {
        return this.focuseditem;
    });

    this.focusedindex = bconfig.focusedIndex || null;
    defineGetter(this, "focusedIndex", function() {
        return this.focusedindex;
    });
    defineSetter(this, "focusedIndex", function(val) {
        this.focusedindex = val;
        $KW[this.wType]["updateView"](this, "focusedindex", val);
    });

    this.needpageindicator = pspconfig.isPageIndicatorNeeded || null;
    defineGetter(this, "isPageIndicatorNeeded", function() {
        return this.needpageindicator;
    });
    defineSetter(this, "isPageIndicatorNeeded", function(val) {
        this.needpageindicator = val;
        $KW[this.wType]["updateView"](this, "needpageindicator", val);
    });
};
kony.inherits(kony.ui.SegmentedUI, kony.ui.SegmentedUI2);


kony.ui.TextBox2 = function(bconfig, lconfig, pspconfig) {
    if(arguments.length < 3)
        bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("TextBox2"));

    kony.ui.TextBox2.baseConstructor.call(this, bconfig, lconfig, pspconfig);

    this.autoCorrect = this.autocorrect = pspconfig.autoCorrect || false;
    this.autoComplete = this.autocomplete = pspconfig.autoComplete || false;
    this.pattern = pspconfig.pattern;
    this.placeholderskin = pspconfig.placeholderSkin;

    this.secureTextEntry = this.securetextentry = bconfig.secureTextEntry;
    this.maxtextlength = bconfig.maxTextLength;
    this.textinputmode = bconfig.textInputMode || constants.TEXTBOX_INPUT_MODE_ANY;
    this.keyboardtype = bconfig.keyBoardStyle || constants.TEXTBOX_KEY_BOARD_STYLE_DEFAULT;
    this.restrictcharactersset = bconfig.restrictCharactersSet;

    this.containerheightmode = lconfig.containerHeightMode || constants.TEXTBOX_DEFAULT_PLATFORM_HEIGHT;
    this.containerheight = lconfig.containerHeight;
    this.containerheightreference = lconfig.containerHeightReference;
    bconfig.i18n_placeholder && (this.i18n_placeholder = bconfig.i18n_placeholder);
    this.ondone = bconfig.onDone;
    this.onkeydown = pspconfig.onKeyDown;
    this.onkeyup = pspconfig.onKeyUp;
    this.onbeginediting = pspconfig.onBeginEditing;
    this.onendediting = pspconfig.onEndEditing;
    this.ontextchange = bconfig.onTextChange || pspconfig.onTextChange;

    this.autocapitalize = bconfig.autoCapitalize || constants.TEXTBOX_AUTO_CAPITALIZE_NONE;

    this._text = bconfig.text || "";
    defineGetter(this, "text", function() {
        return this._text;
    });
    defineSetter(this, "text", function(val) {
        this._text = val;
        if(this.canUpdateUI) {
            
            this.i18n_text = "";
            $KW[this.wType]["updateView"](this, "text", val);
        }
    });

    this._placeholder = bconfig.placeholder || "";
    defineGetter(this, "placeholder", function() {
        return this._placeholder;
    });
    defineSetter(this, "placeholder", function(val) {
        this._placeholder = val;
        if(this.canUpdateUI) {
            this.i18n_placeholder = ""; 
            $KW[this.wType]["updateView"](this, "placeholder", val);
        }
    });


    defineGetter(this, "placeholderSkin", function() {
        return this.placeholderskin;
    });

    defineSetter(this, "placeholderSkin", function(val) {
        var oldvalue = this.placeholderskin;
        this.placeholderskin = val;
        $KW[this.wType]["updateView"](this, "placeholderskin", val);
    });


    var pattern = pspconfig.pattern;
    this._pattern = pspconfig.pattern;
    defineGetter(this, "pattern", function() {
        return this._pattern;
    });
    defineSetter(this, "pattern", function(val) {
        this._pattern = val;
        $KW[this.wType]["updateView"](this, "pattern", val);
    });

    this._name = pspconfig.name || "";
    defineGetter(this, "name", function() {
        return this._name;
    });
    defineSetter(this, "name", function(val) {
        this._name = val;
        $KW[this.wType]["updateView"](this, "name", val);
    });

    
    this.canUpdateUI = true;
    this.wType = "TextField";
    this.__name = "kony.ui.TextBox2";



    kony.ui.TextBox2.prototype.setGetterSetter.call(this);
};

kony.inherits(kony.ui.TextBox2, kony.ui.Widget);

kony.ui.TextBox2.prototype.setSelection = function(startIndex, endIndex) {
    $KW.TextField.setSelection(this, startIndex, endIndex);
};

kony.ui.TextBox2.prototype.getSelection = function() {
    return $KW.TextField.getSelection(this);
};

kony.ui.TextBox2.prototype.setGetterSetter = function() {
    defineGetter(this, "maxTextLength", function() {
        return this.maxtextlength;
    });
    defineSetter(this, "maxTextLength", function(val) {
        this.maxtextlength = val;
        $KW[this.wType]["updateView"](this, "maxtextlength", val);
    });

    defineGetter(this, "textInputMode", function() {
        return this.textinputmode || this.mode;
    });
    defineSetter(this, "textInputMode", function(val) {
        this.textinputmode = this.mode = val;
        $KW[this.wType]["updateView"](this, "textinputmode", val);
    });

    defineGetter(this, "keyBoardStyle", function() {
        return this.keyboardtype;
    });
    defineSetter(this, "keyBoardStyle", function(val) {
        this.keyboardtype = val;
        $KW[this.wType]["updateView"](this, "keyboardtype", val);
    });

    defineGetter(this, "onDone", function() {
        return this.ondone;
    });
    defineSetter(this, "onDone", function(val) {
        this.ondone = val;
    });

    defineGetter(this, "onKeyDown", function() {
        return this.onkeydown;
    });
    defineSetter(this, "onKeyDown", function(val) {
        this.onkeydown = val;
    });

    defineGetter(this, "onKeyUp", function() {
        return this.onkeyup;
    });
    defineSetter(this, "onKeyUp", function(val) {
        this.onkeyup = val;
    });

    defineGetter(this, "onBeginEditing", function() {
        return this.onbeginediting;
    });
    defineSetter(this, "onBeginEditing", function(val) {
        this.onbeginediting = val;
    });

    defineGetter(this, "onEndEditing", function() {
        return this.onendediting;
    });
    defineSetter(this, "onEndEditing", function(val) {
        this.onendediting = val;
    });

    defineGetter(this, "onTextChange", function() {
        return this.ontextchange;
    });
    defineSetter(this, "onTextChange", function(val) {
        this.ontextchange = val;
    });

    defineGetter(this, "autoCapitalize", function() {
        return this.autocapitalize;
    });
    defineSetter(this, "autoCapitalize", function(val) {
        this.autocapitalize = val;
        $KW[this.wType]["updateView"](this, "autocapitalize", val);
    });

    defineGetter(this, "containerHeightMode", function() {
        return this.containerheightmode;
    });
    defineSetter(this, "containerHeightMode", function(val) {
        this.containerheightmode = val;
        $KW[this.wType]["updateView"](this, "containerheightmode", val);
    });

    defineGetter(this, "containerHeight", function() {
        return this.containerheight;
    });
    defineSetter(this, "containerHeight", function(val) {
        this.containerheight = val;
        $KW[this.wType]["updateView"](this, "containerheight", val);
    });

    defineGetter(this, "containerHeightReference", function() {
        return this.containerheightreference;
    });
    defineSetter(this, "containerHeightReference", function(val) {
        this.containerheightreference = val;
        $KW[this.wType]["updateView"](this, "containerheightreference", val);
    });
    defineGetter(this, "secureTextEntry", function() {
        return this.securetextentry;
    });
    defineSetter(this, "secureTextEntry", function(val) {
        this.securetextentry = val;
        $KW[this.wType]["updateView"](this, "securetextentry", val);
    });
    defineGetter(this, "restrictCharactersSet", function() {
        return this.restrictcharactersset;
    });
    defineSetter(this, "restrictCharactersSet", function(val) {
        this.restrictcharactersset = val;
    });


};





kony.ui.TextArea2 = function(bconfig, lconfig, pspconfig) {
    if(arguments.length < 3)
        bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("TextArea2"));

    kony.ui.TextArea2.baseConstructor.call(this, bconfig, lconfig, pspconfig);

    this.wType = "TextArea";
    this.name = "kony.ui.TextArea2";

    this.numberofvisiblelines = bconfig.numberOfVisibleLines;
    this.setGetterSetter();

};
kony.inherits(kony.ui.TextArea2, kony.ui.TextBox2);

kony.ui.TextArea2.prototype.setGetterSetter = function() {
    defineGetter(this, "numberOfVisibleLines", function() {
        return this.numberofvisiblelines;
    });
    defineSetter(this, "numberOfVisibleLines", function(val) {
        this.numberofvisiblelines = val;
        $KW[this.wType]["updateView"](this, "numberofvisiblelines", val);
    });
};



kony.ui.TabPane = function(bconfig, lconfig, pspconfig) {
    if(arguments.length < 3)
        bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("TabPane"));

    kony.ui.TabPane.baseConstructor.call(this, bconfig, lconfig, pspconfig);

    
    this.wType = "TabPane";
    this.name = "kony.ui.TabPane";
    this.screenLevelWidget = bconfig.screenLevelWidget || false;
    this.isMaster = true; 
    this.activeskin = bconfig.activeSkin;
    this.activefocusskin = bconfig.activeFocusSkin;
    this.inactiveskin = bconfig.inactiveSkin;
    this.viewtype = bconfig.viewType; 
    this.viewconfig = bconfig.viewConfig; 
    if(bconfig.viewConfig && bconfig.viewConfig.collapsibleViewConfig) {
        this.viewconfig.collapsibleviewconfig = this.viewconfig.collapsibleViewConfig;
        this.viewconfig.collapsibleviewconfig.onclick = this.viewconfig.collapsibleviewconfig.onClick;
        this.viewconfig.collapsibleviewconfig.expandedimage = this.viewconfig.collapsibleviewconfig.expandedImage;
        this.viewconfig.collapsibleviewconfig.collapsedimage = this.viewconfig.collapsibleviewconfig.collapsedImage;
        this.viewconfig.collapsibleviewconfig.imageposition = this.viewconfig.collapsibleviewconfig.imagePosition;
        this.viewconfig.collapsibleviewconfig.tabnamealignment = this.viewconfig.collapsibleviewconfig.tabNameAlignment;
        this.viewconfig.collapsibleviewconfig.toggletabs = this.viewconfig.collapsibleviewconfig.toggleTabs;
    }

    this.ontabclick = bconfig.onTabClick;

    this.retainpositionintab = bconfig.retainPositionInTab; 
    this.needpageindicator = bconfig.needPageIndicator;
    this.selectedtabindex = bconfig.selectedTabIndex;

    this.containerheight = lconfig.containerHeight;
    this.containerheightreference = lconfig.containerHeightReference || constants.CONTAINER_HEIGHT_BY_FORM_REFERENCE;

    if(bconfig.viewConfig && bconfig.viewConfig.collapsibleViewConfig) {
        var configparams = bconfig.viewConfig.collapsibleViewConfig;
        
        this.collapsedimage = configparams.expandedImage;
        this.expandedimage = configparams.collapsedImage;
        this.toggletabs = configparams.toggleTabs;
        this.imageposition = configparams.imagePosition;
        this.tabnamealignment = configparams.tabNameAlignment;
    }
    if(bconfig.viewConfig && bconfig.viewConfig.pageViewConfig) {
        var pvconfigparams = bconfig.viewConfig.pageViewConfig;
        this.pageondotimage = pvconfigparams.pageOnDotImage;
        this.pageoffdotimage = pvconfigparams.pageOffDotImage;
        this.needpageindicator = pvconfigparams.needPageIndicator;
    }

    this.activetabs = bconfig.activeTabs;
    if((this.viewtype == constants.TABPANE_VIEW_TYPE_TABVIEW || this.viewtype == constants.TABPANE_VIEW_TYPE_PAGEVIEW) && (!this.activetabs || (this.activetabs && this.activetabs.length == 0))) {
        this.activetabs = [0];
        this.activetab = 0;
    }
    if(this.activetabs && this.activetabs.length > 0)
        this.activetab = this.activetabs[0];

    this.setGetterSetter();
};

kony.inherits(kony.ui.TabPane, kony.ui.ContainerWidget);

kony.ui.TabPane.prototype.setGetterSetter = function() {
    defineGetter(this, "activeSkin", function() {
        return this.activeskin;
    });
    defineSetter(this, "activeSkin", function(val) {
        var oldval = this.activeskin;
        this.activeskin = val;
        $KW[this.wType]["updateView"](this, "activeskin", val, oldval);
    });

    defineGetter(this, "activeFocusSkin", function() {
        return this.activefocusskin;
    });
    defineSetter(this, "activeFocusSkin", function(val) {
        var oldval = this.activefocusskin;
        this.activefocusskin = val;
        kony.model.updateView(this, "activefocusskin", val, oldval);
    });

    defineGetter(this, "inactiveSkin", function() {
        return this.inactiveskin;
    });
    defineSetter(this, "inactiveSkin", function(val) {
        var oldval = this.inactiveskin;
        this.inactiveskin = val;
        $KW[this.wType]["updateView"](this, "inactiveskin", val, oldval);
    });

    defineGetter(this, "viewType", function() {
        return this.viewtype;
    });
    defineSetter(this, "viewType", function(val) {
        this.viewtype = val;
        if((this.viewtype == constants.TABPANE_VIEW_TYPE_TABVIEW || this.viewtype == constants.TABPANE_VIEW_TYPE_PAGEVIEW) && (!this.activetabs || (this.activetabs && this.activetabs.length == 0))) {
            this.activetabs = [0];
            this.activetab = 0;
        }
        if(this.activetabs && this.activetabs.length > 0)
            this.activetab = this.activetabs[0];
        $KW[this.wType]["updateView"](this, "viewtype", val);
    });

    defineGetter(this, "containerHeight", function() {
        return this.containerheight;
    });

    defineSetter(this, "containerHeight", function(val) {
        this.containerheight = val;
        kony.model.updateView(this, "containerheight", val);
    });

    defineGetter(this, "containerHeightReference", function() {
        return this.containerheightreference;
    });

    defineSetter(this, "containerHeightReference", function(val) {
        this.containerheightreference = val;
        kony.model.updateView(this, "containerheightreference", val);
    });

    defineGetter(this, "viewConfig", function() {
        return this.viewconfig;
    });
    defineSetter(this, "viewConfig", function(val) {
        this.viewconfig = val;
        $KW[this.wType]["updateView"](this, "viewconfig", val);
    });

    defineGetter(this, "onTabClick", function() {
        return this.ontabclick;
    });
    defineSetter(this, "onTabClick", function(val) {
        this.ontabclick = val;
        $KW[this.wType]["updateView"](this, "ontabclick", val);
    });

    defineGetter(this, "retainPositionInTab", function() {
        return this.retainpositionintab;
    });
    defineSetter(this, "retainPositionInTab", function(val) {
        this.retainpositionintab = val;
        $KW[this.wType]["updateView"](this, "retainpositionintab", val);
    });

    defineGetter(this, "needPageIndicator", function() {
        return this.needpageindicator;
    });
    defineSetter(this, "needPageIndicator", function(val) {
        this.needpageindicator = val;
        $KW[this.wType]["updateView"](this, "needpageindicator", val);
    });

    defineGetter(this, "selectedTabIndex", function() {
        return this.selectedtabindex;
    });
    defineSetter(this, "selectedTabIndex", function(val) {
        this.selectedtabindex = val;
        $KW[this.wType]["updateView"](this, "selectedtabindex", val);
    });

    defineGetter(this, "activeTabs", function() {
        return this.activetabs;
    });
    defineSetter(this, "activeTabs", function(val) {
        this.activetabs = val;
        if((this.viewtype == constants.TABPANE_VIEW_TYPE_TABVIEW || this.viewtype == constants.TABPANE_VIEW_TYPE_PAGEVIEW) && (!val || (val && val.length == 0))) {
            this.activetabs = [0];
            this.activetab = 0;
        }
        if(this.activetabs && this.activetabs.length > 0)
            this.activetab = this.activetabs[0];
        $KW[this.wType]["updateView"](this, "activetabs", val);
    });

    defineGetter(this, "activeTab", function() {
        return this.activetabs[0];
    });
    defineSetter(this, "activeTab", function(val) {
        this.activetabs[0] = val;
        $KW[this.wType]["updateView"](this, "activetab", val);
    });
};


kony.ui.TabPane.prototype.addTab = function(tabId, tabName, tabImage, box, masterDataLoad) {
    var widgetref;
    if(arguments.callee.arguments.length == 3) {
        widgetref = tabName;
        widgetref.id = tabId;
        widgetref.header = tabImage;
        kony.ui.Form2.prototype.createFormLevelHierarchy.call(widgetref.header, [widgetref.header]);
        widgetref.header.isheader = true;
        kony.ui.ContainerWidget.prototype.createhierarchy.call(widgetref.header, widgetref.header.ownchildrenref);
    } else {
        widgetref = box;
        widgetref.id = tabId;
        widgetref.tabname = tabName;
        widgetref.image = tabImage;
        widgetref.oninit = masterDataLoad;
    }
    this.allboxes = [];
    widgetref.name = "kony.ui.Tab";

    var addChild = "true";

    if(addChild == "true") {
        kony.ui.ContainerWidget.prototype.add.call(this, [widgetref]);
    }

    kony.ui.Form2.prototype.createFormLevelHierarchy.call(this, [widgetref]);
    
    if($KG.allforms[this.pf]) {
        kony.ui.Form2.prototype.createFormLevelHierarchy.call($KG.allforms[this.pf], [widgetref]);
    }
    kony.ui.ContainerWidget.prototype.createhierarchy.call(this, widgetref.ownchildrenref);
    $KW.TabPane.addChildTab(this, widgetref);
    $KU.checkAndReCalculateTopFlexModal(this);
};

kony.ui.TabPane.prototype.addTabAt = function(tabId, tabName, tabImage, box, index) {
    var widgetref;
    if(arguments.callee.arguments.length == 4) {
        widgetref = tabName;
        widgetref.id = tabId;
        widgetref.header = tabImage;
        kony.ui.Form2.prototype.createFormLevelHierarchy.call(widgetref.header, [widgetref.header]);
        widgetref.header.isheader = true;
        index = box;
        kony.ui.ContainerWidget.prototype.createhierarchy.call(widgetref.header, widgetref.header.ownchildrenref);
    } else {
        widgetref = box;
        widgetref.id = tabId;
        widgetref.tabname = tabName;
        widgetref.image = tabImage;
    }
    this.allboxes = [];
    widgetref.name = "kony.ui.Tab";

    var addChildAt = "true";
    if(addChildAt == "true") {
        kony.ui.ContainerWidget.prototype.addAt.call(this, widgetref, index);
    }

    kony.ui.Form2.prototype.createFormLevelHierarchy.call(this, [widgetref]);
    
    if($KG.allforms[this.pf]) {
        kony.ui.Form2.prototype.createFormLevelHierarchy.call($KG.allforms[this.pf], [widgetref]);
    }
    kony.ui.ContainerWidget.prototype.createhierarchy.call(this, widgetref.ownchildrenref);
    $KW.TabPane.addChildTabAt(this, widgetref, index);
    $KU.checkAndReCalculateTopFlexModal(this);
};

kony.ui.TabPane.prototype.removeTabAt = function(index) {
    $KW.TabPane.removeTabAt(this, index);
    $KU.checkAndReCalculateTopFlexModal(this);
};

kony.ui.TabPane.prototype.removeTabById = function(tabId) {
    $KW.TabPane.removeTabById(this, tabId);
    $KU.checkAndReCalculateTopFlexModal(this);
};

kony.ui.TabPane.prototype.setTabName = function(tabId, tabName) {
    $KW.TabPane.setTabName(this, tabId, tabName);
};

kony.ui.TabPane.prototype.setTabImage = function(tabId, tabImage) {
    $KW.TabPane.setTabImage(this, tabId, tabImage);
};


kony.ui.Slider = function(bconfig, lconfig, pspconfig) {
    if(arguments.length < 3)
        bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("Slider"));

    kony.ui.Slider.baseConstructor.call(this, bconfig, lconfig, pspconfig);

    this.min = bconfig.min;
    this.max = bconfig.max;
    this.step = bconfig.step;

    this.onslide = bconfig.onSlide;
    this.onselection = bconfig.onSelection;
    this.leftskin = bconfig.leftSkin;
    this.rightskin = bconfig.rightSkin;
    this.thumbimage = bconfig.thumbImage;
    this.focusthumbimage = bconfig.focusThumbImage;
    if(bconfig.selectedValue == "undefined" || bconfig.selectedValue == null) {
        this.selectedvalue = Math.abs((bconfig.min + (bconfig.min - bconfig.max) / 2))
    } else {
        this.selectedvalue = bconfig.selectedValue;
    }


    this.widgetalignment = lconfig.widgetAlignment;
    var margin = (!lconfig.margin) ? [0, 0, 0, 0] : lconfig.margin;
    this.margin = margin;

    this.minlabel = pspconfig.minLabel;
    this.maxlabel = pspconfig.maxLabel;
    this.minlabelskin = pspconfig.minLabelSkin;
    this.maxlabelskin = pspconfig.maxLabelSkin;
    this.thickness = pspconfig.thickness;
    this.view = pspconfig.viewType;
    this.orientation = pspconfig.orientation;
    
    this.wType = "Slider";
    this.name = "kony.ui.Slider";

    this.setGetterSetter();
};

kony.inherits(kony.ui.Slider, kony.ui.Widget);

kony.ui.Slider.prototype.setGetterSetter = function() {
    defineGetter(this, "selectedValue", function() {
        return this.selectedvalue;
    });
    defineSetter(this, "selectedValue", function(val) {
        this.selectedvalue = val;
        $KW[this.wType]["updateView"](this, "selectedvalue", val);
    });

    defineGetter(this, "focusThumbImage", function() {
        return this.focusthumbimage;
    });
    defineSetter(this, "focusThumbImage", function(val) {
        this.focusthumbimage = val;
        $KW[this.wType]["updateView"](this, "focusthumbimage", val);
    });

    defineGetter(this, "thumbImage", function() {
        return this.thumbimage;
    });
    defineSetter(this, "thumbImage", function(val) {
        this.thumbimage = val;
        $KW[this.wType]["updateView"](this, "thumbimage", val);
    });

    defineGetter(this, "rightSkin", function() {
        return this.rightskin;
    });
    defineSetter(this, "rightSkin", function(val) {
        
        $KW[this.wType]["updateView"](this, "rightskin", val, this.rightskin);
    });

    defineGetter(this, "leftSkin", function() {
        return this.leftskin;
    });
    defineSetter(this, "leftSkin", function(val) {
        $KW[this.wType]["updateView"](this, "leftskin", val, this.leftskin);
        
    });

    defineGetter(this, "minLabel", function() {
        return this.minlabel;
    });
    defineSetter(this, "minLabel", function(val) {
        
        $KW[this.wType]["updateView"](this, "minlabel", val, this.minlabel);
    });

    defineGetter(this, "maxLabel", function() {
        return this.maxlabel;
    });
    defineSetter(this, "maxLabel", function(val) {
        
        $KW[this.wType]["updateView"](this, "maxlabel", val, this.maxlabel);
    });

    defineGetter(this, "maxLabelSkin", function() {
        return this.maxlabelskin;
    });
    defineSetter(this, "maxLabelSkin", function(val) {
        
        $KW[this.wType]["updateView"](this, "maxlabelskin", val, this.maxlabelskin);
    });

    defineGetter(this, "minLabelSkin", function() {
        return this.minlabelskin;
    });
    defineSetter(this, "minLabelSkin", function(val) {
        
        $KW[this.wType]["updateView"](this, "minlabelskin", val, this.minlabelskin);
    });

    defineGetter(this, "onSelection", function() {
        return this.onselection;
    });
    defineSetter(this, "onSelection", function(val) {
        this.onselection = val;
    });

    defineGetter(this, "onSlide", function() {
        return this.onslide;
    });
    defineSetter(this, "onSlide", function(val) {
        this.onslide = val;
    });
};


kony.ui.Video = function(bconfig, lconfig, pspconfig) {
    if(arguments.length < 3)
        bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("Video"));

    kony.ui.Video.baseConstructor.call(this, bconfig, lconfig, pspconfig);

    
    this.wType = "Video";
    this.name = "kony.ui.Video";


    var source = bconfig.source;
    defineGetter(this, "source", function() {
        return source;
    });
    defineSetter(this, "source", function(val) {
        source = val;
        $KW[this.wType]["updateView"](this, "source", val);
    });

    
    var controls = pspconfig.controls || bconfig.controls;
    this.controls = pspconfig.controls || bconfig.controls;
    defineGetter(this, "controls", function() {
        return controls;
    });
    defineSetter(this, "controls", function(val) {
        controls = val;
        $KW[this.wType]["updateView"](this, "controls", val);
    });

    var poster = pspconfig.poster || bconfig.poster;
    defineGetter(this, "poster", function() {
        return poster;
    });
    defineSetter(this, "poster", function(val) {
        poster = val;
        $KW[this.wType]["updateView"](this, "poster", val);
    });


};
kony.inherits(kony.ui.Video, kony.ui.Widget);

kony.ui.Video.prototype.setSource = function(source) {
    this.source = source;
};

kony.ui.Video.prototype.play = function() {
    $KW.Video.play(this);
};

kony.ui.Video.prototype.pause = function(source) {
    $KW.Video.pause(this);
};

kony.ui.Video.prototype.resume = function(source) {
    $KW.Video.resume(this);
};

kony.ui.Video.prototype.stop = function(source) {
    $KW.Video.stop(this);
};

kony.ui.Video.prototype.seekTo = function(seekTime) {
    $KW.Video.seekTo(this, seekTime);
};

kony.ui.Video.prototype.isPlaying = function() {
    return $KW.Video.isPlaying(this);
};

kony.ui.Video.prototype.getCurrentPosition = function() {
    return $KW.Video.getCurrentPosition(this);
};

kony.ui.Video.prototype.getDuration = function() {
    return $KW.Video.getDuration(this);
};

kony.ui.Video.prototype.getBufferPercentage = function() {
    return $KW.Video.getBufferPercentage(this);
};

kony.ui.KMasterTemplate = function(bconfig, lconfig, pspconfig, template) {
    var args = [];
    if(arguments.length < 3) {
        bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("UserWidget"));
        args.push(bconfig);
    } else {
        args.push(bconfig);
        args.push(lconfig);
        args.push(pspconfig);
    }

    var wModel = _kony.mvc.initializeMasterController(template, bconfig.id, args);

    var requireFlexRTL = $KW.FlexUtils.shouldApplyRTL(wModel, "flexPosition");
    for(var prop in bconfig) {
        if(requireFlexRTL) {
            if(prop == "left") {
                wModel["right"] = bconfig["left"];
            } else if(prop == "right") {
                wModel["left"] = bconfig["right"];
            } else {
                wModel[prop] = bconfig[prop];
            }
        } else {
            wModel[prop] = bconfig[prop];
        }
    }
    wModel.isMaster = true;
    
    if(wModel.children) {
        for(var i = 0; i < wModel.children.length; i++) {
            var childModel = wModel[wModel.children[i]];
            updateImmediateMasterToChilds(childModel, wModel);
        }
    }
    _kony.mvc.setMasterContract(wModel, wModel.id, template);
    return wModel;
};

kony.ui.KComponentTemplate = function(bconfig, lconfig, pspconfig, template) {
    var args = [];
    if(arguments.length < 3) {
        bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("KComponent"));
        args.push(bconfig);
    } else {
        args.push(bconfig);
        args.push(lconfig);
        args.push(pspconfig);
    }
    var userWidgetinstance = new kony.ui.KComponent(bconfig, lconfig, pspconfig);
    var userWidgetobj = _kony.mvc.initializeMasterController(template, userWidgetinstance.id, args);
    var requireFlexRTL = $KW.FlexUtils.shouldApplyRTL(userWidgetobj, "flexPosition");
    var doNotOverrideProps = ['preShow', 'postShow', 'destroy', 'onHide']; 

    for(var prop in bconfig) {
        if(doNotOverrideProps.indexOf(prop) == -1) {
            if(requireFlexRTL) {
                if(prop == "left") {
                    userWidgetobj["right"] = bconfig["left"]; 
                } else if(prop == "right") {
                    userWidgetobj["left"] = bconfig["right"];
                } else {
                    userWidgetobj[prop] = bconfig[prop];
                }
            } else {
                userWidgetobj[prop] = bconfig[prop];
            }
        }
	}
    userWidgetobj['height'] = bconfig['height']; 
    userWidgetobj._userWidget = true;
    userWidgetobj.isMaster = true;
    userWidgetinstance.userWidgetProxyObject = userWidgetobj;
    userWidgetinstance._konyControllerName = userWidgetobj._konyControllerName;
    $KU.invokeAddWidgets(userWidgetobj);

    var overrideProps = ["accessibilityConfig", "margin", "padding", "skin", "left", "right", "top", "bottom", "width", "height", "minWidth", "maxWidth", "minHeight", "maxHeight", "centerX", "centerY", "zIndex", "doLayout", "opacity", "transform", "anchorPoint", "backgroundColor", "borderWidth", "borderColor", "cornerRadius", "enableScrolling", "scrollDirection", "contentOffset", "contentSize", "contentOffsetMeasured", "contentSizeMeasured", "bounces", "allowHorizontalBounce", "allowVerticalBounce", "horizontalScrollIndicator", "verticalScrollIndicator", "pagineEnabled", "dragging", "tracking", "decelerating", "onScrollStart", "onScrollTouchReleased", "onScrolling", "onDecelerationStarted", "onScrollEnd", "layoutType", "clipBounds", "contentAlignment", "containerWeight", "focusSkin", "isVisible", "onClick", "onTouchStart", "onTouchMove", "onTouchEnd"];
    for(var val in overrideProps) {
        (function(prop) {
            Object.defineProperty(userWidgetinstance, prop, {
                get: function() {
                    return userWidgetinstance.userWidgetProxyObject[prop];
                },
                set: function(newVal) {
                    userWidgetinstance.userWidgetProxyObject[prop] = newVal;
                }
            });
        })(overrideProps[val]);
    }

    _kony.mvc.setMasterContract(userWidgetinstance, userWidgetinstance.id, template);

    return userWidgetinstance;
};


kony.ui.KComponent = function(bconfig, lconfig, pspconfig) {

    if(arguments.length < 3)
        bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("KComponent"));

    kony.ui.KComponent.baseConstructor.call(this, bconfig, lconfig, pspconfig);
    this.wType = "KComponent";
    this.name = "kony.ui.KComponent";

    
    this.ownchildrenref = [];
    this.children = [];
    this.allboxes = [];

};

kony.inherits(kony.ui.KComponent, kony.ui.FlexContainer);

kony.ui.KComponent.prototype.forceLayout = function() {
    $KW.KComponent.forceLayout(this);
};


kony.ui.CollectionView = function(bconfig, lconfig, pspconfig) {
    if(arguments.length < 3)
        bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("SegmentedUI2"));

    kony.ui.CollectionView.baseConstructor.call(this, bconfig, lconfig, pspconfig);

    this.skin = bconfig.skin;
    this.itemskin = bconfig.itemSkin;
    this.itemselectedskin = bconfig.itemSelectedSkin;
    this.sectionheaderskin = bconfig.sectionHeaderSkin;
    this.sectionfooterskin = bconfig.sectionFooterSkin;

    this.widgetdatamap = bconfig.widgetDataMap;
    this.itemtemplate = bconfig.itemTemplate;
    this.sectionheadertemplate = bconfig.sectionHeaderTemplate;
    this.sectionfootertemplate = bconfig.sectionFooterTemplate;
    this.pulltorefreshview = bconfig.pullToRefreshView;
    this.releasetopullrefreshview = bconfig.releaseToPullRefreshView;
    this.pushtorefreshview = bconfig.pushToRefreshView;
    this.releasetopushrefreshview = bconfig.releaseToPushRefreshView;

    this.enableReordering = bconfig.enableReordering || false;

    this.layouttype = bconfig.layout || kony.collectionview.LAYOUT_HORIZONTAL;
    this.autogrowMode = bconfig.autogrowMode;


    this.retainselection = bconfig.retainSelection || false;
    this.contentoffset = bconfig.contentOffset;

    this.selectionbehavior = bconfig.selectionBehavior || kony.collectionview.SINGLE_SELECT;
    this.selecteditemindex = bconfig.selectedItemIndex || null;
    this.selecteditemindices = bconfig.selectedItemIndices || null;
    this.selecteditems = null;

    this.minlinespace = bconfig.minLineSpace;
    this.minitemspace = bconfig.minItemSpace;

    this.onitemselect = bconfig.onItemSelect;
    this.scrolldirection = bconfig.scrollDirection;

    this.onscrollstart = bconfig.onScrollStart;
    defineGetter(this, "onScrollStart", function() {
        return this.onscrollstart;
    });
    defineSetter(this, "onScrollStart", function(val) {
        this.onscrollstart = val;
        $KW[this.wType]["updateView"](this, "onScrollStart", val);
    });
    this.onscrollend = bconfig.onScrollEnd;
    defineGetter(this, "onScrollEnd", function() {
        return this.onscrollend;
    });
    defineSetter(this, "onScrollEnd", function(val) {
        this.onscrollend = val;
        $KW[this.wType]["updateView"](this, "onScrollEnd", val);
    });

    this.onscrolling = bconfig.onScrolling;
    defineGetter(this, "onScrolling", function() {
        return this.onscrolling;
    });
    defineSetter(this, "onScrolling", function(val) {
        this.onscrolling = val;
        $KW[this.wType]["updateView"](this, "onScrolling", val);
    });
    this.onscrolltouchreleased = bconfig.onScrollTouchReleased;
    defineGetter(this, "onScrollTouchReleased", function() {
        return this.onscrolltouchreleased;
    });
    defineSetter(this, "onScrollTouchReleased", function(val) {
        this.onscrolltouchreleased = val;
        $KW[this.wType]["updateView"](this, "onScrollTouchReleased", val);
    });

    var data = bconfig.data;
    defineGetter(this, "data", function() {
        return data;
    });

    defineSetter(this, "data", function(val) {
        data = val;
        this.canUpdateUI && $KW[this.wType]["updateView"](this, "data", val);
    });
    this.showscrollbars = bconfig.showScrollbars;
    this.scrollingevents = bconfig.scrollingEvents || false;
    this.clonedTemplates = [];
    this.setGetterSetter();

    
    this.wType = "CollectionView";
    this.name = "kony.ui.CollectionView";
    this.canUpdateUI = true;
};

kony.inherits(kony.ui.CollectionView, kony.ui.Widget);

kony.ui.CollectionView.prototype.setGetterSetter = function() {
    defineGetter(this, "itemSkin", function() {
        return this.itemskin;
    });
    defineSetter(this, "itemSkin", function(val) {
        var oldvalue = this.itemskin;
        this.itemskin = val;
        $KW[this.wType]["updateView"](this, "itemskin", val, oldvalue);
    });

    defineGetter(this, "itemSelectedSkin", function() {
        return this.itemselectedskin;
    });
    defineSetter(this, "itemSelectedSkin", function(val) {
        var oldvalue = this.itemselectedskin;
        this.itemselectedskin = val;
        kony.model.updateView(this, "itemselectedskin", val, oldvalue);
    });


    defineGetter(this, "sectionHeaderSkin", function() {
        return this.sectionheaderskin;
    });
    defineSetter(this, "sectionHeaderSkin", function(val) {
        var oldvalue = this.sectionheaderskin;
        this.sectionheaderskin = val;
        $KW[this.wType]["updateView"](this, "sectionheaderskin", val, oldvalue);
    });

    defineGetter(this, "sectionFooterSkin", function() {
        return this.sectionfooterskin;
    });
    defineSetter(this, "sectionFooterSkin", function(val) {
        var oldvalue = this.sectionfooterskin;
        this.sectionfooterskin = val;
        $KW[this.wType]["updateView"](this, "sectionfooterskin", val, oldvalue);
    });

    defineGetter(this, "widgetDataMap", function() {
        return this.widgetdatamap;
    });
    defineSetter(this, "widgetDataMap", function(val) {
        this.widgetdatamap = val;
    });

    defineGetter(this, "itemTemplate", function() {
        return this.itemtemplate;
    });
    defineSetter(this, "itemTemplate", function(val) {
        this.itemtemplate = val;
    });

    defineGetter(this, "sectionHeaderTemplate", function() {
        return this.sectionheadertemplate;
    });
    defineSetter(this, "sectionHeaderTemplate", function(val) {
        this.sectionheadertemplate = val;
    });

    defineGetter(this, "sectionFooterTemplate", function() {
        return this.sectionfootertemplate;
    });
    defineSetter(this, "sectionFooterTemplate", function(val) {
        this.sectionfootertemplate = val;
    });

    defineGetter(this, "pullToRefreshView", function() {
        return this.pulltorefreshview;
    });
    defineSetter(this, "pullToRefreshView", function(val) {
        var oldvalue = this.pulltorefreshview;
        this.pulltorefreshview = val;
        $KW[this.wType]["updateView"](this, "pulltorefreshview", val, oldvalue);
    });

    defineGetter(this, "releaseToPullRefreshView", function() {
        return this.releasetopullrefreshview;
    });
    defineSetter(this, "releaseToPullRefreshView", function(val) {
        var oldvalue = this.releasetopullrefreshview;
        this.releasetopullrefreshview = val;
        $KW[this.wType]["updateView"](this, "releasetopullrefreshview", val, oldvalue);
    });

    defineGetter(this, "pushToRefreshView", function() {
        return this.pushtorefreshview;
    });
    defineSetter(this, "pushToRefreshView", function(val) {
        var oldvalue = this.pushtorefreshview;
        this.pushtorefreshview = val;
        $KW[this.wType]["updateView"](this, "pushtorefreshview", val, oldvalue);
    });

    defineGetter(this, "releaseToPushRefreshView", function() {
        return this.releasetopushrefreshview;
    });
    defineSetter(this, "releaseToPushRefreshView", function(val) {
        var oldvalue = this.releasetopushrefreshview;
        this.releasetopushrefreshview = val;
        $KW[this.wType]["updateView"](this, "releasetopushrefreshview", val, oldvalue);
    });

    defineGetter(this, "onItemSelect", function() {
        return this.onitemselect;
    });
    defineSetter(this, "onItemSelect", function(val) {
        this.onitemselect = val;
    });



    defineGetter(this, "showScrollbars", function() {
        return this.showscrollbars;
    });
    defineSetter(this, "showScrollbars", function(val) {
        this.showscrollbars = val;
    });

    defineGetter(this, "scrollingEvents", function() {
        return this.scrollingevents;
    });
    defineSetter(this, "scrollingEvents", function(val) {
        this.scrollingevents = val;
        $KW[this.wType]["updateView"](this, "scrollingevents", val);
    });

    defineGetter(this, "selectionBehavior", function() {
        return this.selectionbehavior;
    });
    defineSetter(this, "selectionBehavior", function(val) {
        var oldvalue = this.selectionbehavior;
        this.selectionbehavior = val;
        $KW[this.wType]["updateView"](this, "selectionbehavior", val, oldvalue);
    });

    defineGetter(this, "layout", function() {
        return this.layouttype;
    });
    defineSetter(this, "layout", function(val) {
        var oldvalue = this.layouttype;
        this.layouttype = val;
        $KW[this.wType]["updateView"](this, "layouttype", val, oldvalue);
    });
    defineGetter(this, "selectedItems", function() {
        return this.selecteditems;
    });

    defineGetter(this, "selectedItemIndex", function() {
        return this.selecteditemindex;
    });
    defineSetter(this, "selectedItemIndex", function(val) {
        this.selecteditemindex = val;
        $KW[this.wType]["updateView"](this, "selecteditemindex", val);
    });

    defineGetter(this, "selectedItemIndices", function() {
        return this.selecteditemindices;
    });
    defineSetter(this, "selectedItemIndices", function(val) {
        this.selecteditemindices = val;
        $KW[this.wType]["updateView"](this, "selecteditemindices", val);
    });

    defineGetter(this, "contentOffsetMeasured", function() {
        return $KW.APIUtils.getContentOffsetMeasured(this);
    });
    defineGetter(this, "contentOffset", function() {
        return this.contentoffset;
    });
    defineSetter(this, "contentOffset", function(val) {
        this.contentoffset = val;
        if(typeof val === "undefined" || val === null || typeof val.x === "undefined" || typeof val.y === "undefined") {
            return;
        }
        return $KW.APIUtils.setContentOffSet(this, val, true);
    });

    defineGetter(this, "minLineSpace", function() {
        return this.minlinespace;
    });

    defineSetter(this, "minLineSpace", function(val) {
        this.minlinespace = val;
        this.canUpdateUI && $KW[this.wType]["updateView"](this, "minLineSpace", val);
    });
    defineGetter(this, "minItemSpace", function() {
        return this.minitemspace;
    });

    defineSetter(this, "minItemSpace", function(val) {
        this.minitemspace = val;
        this.canUpdateUI && $KW[this.wType]["updateView"](this, "minItemSpace", val);
    });
    defineGetter(this, "onItemDisplay", function() {
        return this.onitemdisplay;
    });
    defineSetter(this, "onItemDisplay", function(val) {
        this.onitemdisplay = val;
    });

    defineGetter(this, "retainSelection", function() {
        return this.retainselection;
    });
    defineSetter(this, "retainSelection", function(val) {
        var oldvalue = this.retainselection;
        this.retainselection = val;
        if(oldvalue != val) {
            $KW[this.wType]["updateView"](this, "retainselection", val, oldvalue);
        }
    });
    defineGetter(this, "reachingBeginningOffset", function() {
        return this.reachingbeginningoffset;
    });
    defineSetter(this, "reachingBeginningOffset", function(val) {
        this.reachingbeginningoffset = val;
        $KW[this.wType]["updateView"](this, "reachingBeginningOffset", val);
    });

    defineGetter(this, "reachingEndOffset", function() {
        return this.reachingendoffset;
    });
    defineSetter(this, "reachingEndOffset", function(val) {
        this.reachingendoffset = val;
        $KW[this.wType]["updateView"](this, "reachingEndOffset", val);
    });
    defineGetter(this, "scrollDirection", function() {
        return this.scrolldirection;
    });
    defineSetter(this, "scrollDirection", function(val) {
        this.scrolldirection = val;
        $KW[this.wType]["updateView"](this, "scrollDirection", val);
    });
};



kony.ui.CollectionView.prototype.setData = function(dataArray) {
    $KW.CollectionView.Data.setData(this, dataArray);
};

kony.ui.CollectionView.prototype.addAll = function(dataArray) {
    $KW.CollectionView.Data.addAll(this, dataArray);
};

kony.ui.CollectionView.prototype.addDataAt = function(dataArray, rowIndex, sectionIndex) {
    $KW.CollectionView.Data.addDataAt(this, dataArray, rowIndex, sectionIndex);
};

kony.ui.CollectionView.prototype.addSectionAt = function(dataArray, sectionIndex) {
    $KW.CollectionView.Data.addSectionAt(this, dataArray, sectionIndex);
};

kony.ui.CollectionView.prototype.removeAll = function() {
    $KW.CollectionView.Data.removeAll(this);
};

kony.ui.CollectionView.prototype.removeDataAt = function(rowIndex, sectionIndex, count) {
    $KW.CollectionView.Data.removeDataAt(this, rowIndex, sectionIndex, count);
};

kony.ui.CollectionView.prototype.removeSectionAt = function(sectionIndex, count) {
    $KW.CollectionView.Data.removeSectionAt(this, sectionIndex, count);
};

kony.ui.CollectionView.prototype.setDataAt = function(dataObj, rowIndex, sectionIndex) {
    $KW.CollectionView.Data.setDataAt(this, dataObj, rowIndex, sectionIndex);
};

kony.ui.CollectionView.prototype.setSectionAt = function(dataArray, sectionIndex) {
    $KW.CollectionView.Data.setSectionAt(this, dataArray, sectionIndex);
};


kony.ui.CollectionView.prototype.setDataWithSections = function(dataArray) {
    $KW.CollectionView.Data.setDataWithSections(this, dataArray);
};

kony.ui.CollectionView.prototype.animateRows = function(animContext) {
    new $KW.CollectionView.Data.animateRows(this, animContext);
};

kony.ui.CollectionView.prototype.setAnimations = function(animObj) {
    if(this.listAnimation) 
        this.listAnimation.destroy();
    this.listAnimation = new $KW.CollectionView.setAnimations(this, animObj);
};

kony.ui.CollectionView.prototype.getFirstVisibleItem = function() {
    return $KW.CollectionView.Data.getFirstVisibleItem(this);
};

kony.ui.CollectionView.prototype.getLastVisibleItem = function() {
    return $KW.CollectionView.Data.getLastVisibleItem(this);
};

kony.ui.CollectionView.prototype.scrollToItemAtIndex = function(itemObject) {
    return $KW.CollectionView.scrollToItemAtIndex(this, itemObject);
};

kony.ui.CollectionView.prototype.getVisibleItems = function() {
    return $KW.CollectionView.Animation.getVisibleItems(this);
};

kony.ui.CollectionView.prototype.getIndicesForVisibleItems = function() {
    return $KW.CollectionView.Animation.getIndicesForVisibleItems(this);
};

kony.ui.CollectionView.prototype.appendLayoutDataAt = function(dataObj, rowIndex, sectionIndex) {
    $KW.CollectionView.Data.appendLayoutDataAt(this, dataObj, rowIndex, sectionIndex);
};


kony.ui.Camera = function(bconfig, lconfig, pspconfig) {
	if(arguments.length < 3)
		bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("Camera"));

	kony.ui.Camera.baseConstructor.call(this, bconfig, lconfig, pspconfig);
	this.wType = "Camera";
	this.videoduration = bconfig.videoDuration;
	this.rawbytes = "";

	defineGetter(this, "rawBytes", function() {
	    return this.rawbytes;
	});

	defineSetter(this, "rawBytes", function(val) {});

	defineGetter(this, "videoDuration", function() {
	    return this.videoduration;
	});

	defineSetter(this, "videoDuration", function(val) {
	    this.videoduration = val;
	});

	this._poster = pspconfig.poster;

	defineGetter(this, "poster", function() {
		return this._poster;
	});
	defineSetter(this, "poster", function(val) {
		this._poster = val;
	    $KW[this.wType]["updateView"](this, "poster", val);
	});

	this.camerasource = pspconfig.cameraSource;

	defineGetter(this, "cameraSource", function() {
		return this.camerasource;
	});

	defineSetter(this, "cameraSource", function(val) {
	    this.camerasource = val;
	});

	this.oncapture = bconfig.onCapture;

	defineGetter(this, "onCapture", function() {
        return this.oncapture;
    });

    defineSetter(this, "onCapture", function(val) {
        this.oncapture = val;
    });

    this.oncapturefailed = bconfig.onCaptureFailed;

    defineGetter(this, "onCaptureFailed", function() {
        return this.oncapturefailed;
    });

    defineSetter(this, "onCaptureFailed", function(val) {
        this.oncapturefailed = val;
    });

    this.onfailure = bconfig.onFailure;

    defineGetter(this, "onFailure", function() {
        return this.onfailure;
    });

    defineSetter(this, "onFailure", function(val) {
        this.onfailure = val;
    });


};

kony.inherits(kony.ui.Camera, kony.ui.Widget);

kony.ui.Camera.prototype.startVideoCapture = function(config) {
	$KW.Camera.startVideoCapture(this, config);
};

kony.ui.Camera.prototype.stopVideoCapture = function(config) {
	$KW.Camera.stopVideoCapture(this, config);
};

kony.ui.Camera.prototype.takePicture = function() {
	 $KW.Camera.takePicture(this);
};

kony.ui.Camera.prototype.openCamera = function() {
	$KW.Camera.openCamera(this);
};

kony.ui.Camera.prototype.closeCamera = function() {
	$KW.Camera.closeCamera(this);
};

kony.ui.Canvas = function(bconfig, lconfig, pspconfig) {
    if(arguments.length < 3)
        bconfig = lconfig = pspconfig = $KU.mergeDefaults(bconfig, $KU.getAllDefaults("Canvas"));

    kony.ui.Canvas.baseConstructor.call(this, bconfig, lconfig, pspconfig);
    this.shapesdata = bconfig.shapesData;

    
    this.wType = "Canvas";
    this.name = "kony.ui.Canvas";

    this.setGetterSetter();
};

kony.inherits(kony.ui.Canvas, kony.ui.Widget);

kony.ui.Canvas.prototype.setGetterSetter = function() {
    defineGetter(this, "shapesData", function() {
        return this.shapesdata;
    });
    defineSetter(this, "shapesData", function(val) {
        this.shapesdata = val;
        $KW[this.wType]["updateView"](this, "shapesdata", val);
    });
};


kony.ui.Canvas.prototype.addShapes = function(shapesData) {
    $KW.Canvas.addShapes(this, shapesData);
};

kony.ui.Canvas.prototype.updateShapes = function(shapesData) {
    $KW.Canvas.updateShapes(this, shapesData);
};

kony.ui.Canvas.prototype.removeShapes = function(shapeIds) {
    $KW.Canvas.removeShapes(this, shapeIds);
};

kony.ui.Canvas.prototype.clear = function() {
    $KW.Canvas.clear(this);
};

kony.type = function(arg) {
	$KU.logExecuting('kony.type');
	$KU.logExecutingWithParams('kony.type', arg);
    var result  = $KI.type(arg);

    if (result == "table" || result == "object") {
          result = arg.name == undefined ? result : arg.name;
    }
    $KU.logExecutingFinished('kony.type');
    return result;
};


if($KI.crypto) {
    kony.crypto = {
            newKey: $KI.crypto.newkey,
            saveKey: $KI.crypto.savekey,
            createHash: $KI.crypto.createhash,
            retrievePublicKey: $KI.crypto.retrievepublickey,
            deleteKey: $KI.crypto.deletekey,
            readKey: $KI.crypto.readkey,
            encrypt: $KI.crypto.encrypt,
            decrypt: $KI.crypto.decrypt,
            createHMacHash: $KI.crypto.createHMacHash,
            createPBKDF2Key: $KI.crypto.createPBKDF2Key
    };
}


if ($KI.db) {
    kony.db = {
        openDatabase: $KI.db.opendatabase,
        transaction: $KI.db.transaction,
        readTransaction: $KI.db.readtransaction,
        executeSql: $KI.db.executesql,
        sqlResultsetRowItem:$KI.db.sqlresultsetrowitem,
        changeVersion: $KI.db.changeversion
    };
}


if($KI.ds) {
    kony.ds = {
        "delete" : $KI.ds.Delete,
        remove: $KI.ds.Delete,
        read : $KI.ds.read,
        save : $KI.ds.save
    };
}


if($KI.i18n) {
    kony.i18n = {
        deleteResourceBundle: $KI.i18n.deleteresourcebundle,
        getLocalizedString: $KI.i18n.getlocalizedstring,
        getCurrentLocale: $KI.i18n.getcurrentlocale,
        isResourceBundlePresent: $KI.i18n.isresourcebundlepresent,
        setCurrentLocale: $KI.i18n.setcurrentlocale,
        setCurrentLocaleAsync: $KI.i18n.setcurrentlocaleasync,
        setDefaultLocale: $KI.i18n.setdefaultlocale,
        setDefaultLocaleAsync: $KI.i18n.setdefaultlocaleasync,
        setResourceBundle: $KI.i18n.setresourcebundle,
        updateResourceBundle:$KI.i18n.updateresourcebundle,
        getCurrentDeviceLocale:$KI.i18n.getcurrentdevicelocale,
        getSupportedLocales:$KI.i18n.getsupportedlocales,
        isLocaleSupportedByDevice:$KI.i18n.islocalesupportedbydevice,
        setLocaleLayoutConfig:$KI.i18n.setlocalelayoutconfig
    };
}


if($KI.localstorage) {
    kony.store = {
        key: $KI.localstorage.key,
        getItem: $KI.localstorage.getitem,
        removeItem: $KI.localstorage.removeitem,
        setItem: $KI.localstorage.setitem,
        clear: $KI.localstorage.clear,
        length: $KI.localstorage.length
    };
}


if($KI.geolocation) {
    kony.location = {
        clearWatch: $KI.geolocation.clearwatch,
        getCurrentPosition: $KI.geolocation.getcurrentposition,
        watchPosition: $KI.geolocation.watchposition,
        PERMISSION_DENIED: 1,
        POSITION_UNAVAILABLE: 2,
        TIMEOUT: 3
    };
}




if($KI.os) {
    kony.os = {
        toNumber: $KI.os.tonumber,
        toCurrency: $KI.os.tocurrency,
        freeMemory: $KI.os.freememory,
        userAgent: $KI.os.useragent,
        deviceInfo: $KI.os.platform,  
        hasGPSSupport: $KI.os.hasgpssupport,  
        hasCameraSupport: $KI.os.hascamerasupport,
        hasTouchSupport: $KI.os.hastouchsupport,
        hasOrientationSupport: $KI.os.hasorientationsupport,
        hasAccelerometerSupport: $KI.os.hasaccelerometersupport,
        getDeviceCurrentOrientation: $KI.os.getdevicecurrentorientation,
        httpheaders: $KI.os.httpheaders,
        getApplicationMode : $KI.os.getapplicationmode,
        setApplicationMode : $KI.os.setapplicationmode,
        setApplicationScrollMode : $KI.os.setapplicationscrollmode,
        getAppContext: $KI.os.getappcontext,
        print: $KI.os.print,
        addHiddenField : tobeimplemented,
        getBatteryLevel : tobeimplemented,
        getBatteryState : tobeimplemented,
        readHiddenField : tobeimplemented,
        registerBatteryChange : tobeimplemented,
        removeAllMetaTags : tobeimplemented,
        removeMetaTag  : tobeimplemented,
        startSecureTransaction : tobeimplemented,
        unregisterBatteryChange : tobeimplemented,

        
        RESOURCE_LOCATION : 0,
        RESOURCE_CAMERA : 1,
        RESOURCE_PHOTO_GALLERY : 2,
        RESOURCE_CONTACTS : 3,
        RESOURCE_CALENDAR : 4,
        RESOURCE_EXTERNAL_STORAGE : 5
    };
}


if($KI.net) {
    kony.net = {
        HttpRequest : $KI.net.HttpRequest,
        FormData : $KI.net.FormData,
        MultipartFormData : $KI.net.MultipartFormData,
        invokeServiceAsync : $KI.net.invokeserviceasync,
        invokeService : $KI.net.invokeService,
        cancel : $KI.net.cancel,
        isNetworkAvailable : $KI.net.isNetworkAvailable,
        setNetworkCallbacks : $KI.net.setNetworkCallbacks,
        getActiveNetworkType : $KI.net.getActiveNetworkType,
        getCookies : $KI.net.getCookies,
        clearCookies : $KI.net.clearCookies,
        loadClientCertificate : $KI.net.loadClientCertificate,
        removeAllCachedResponses : $KI.net.removeAllCachedResponses,
        removeIntegrityCheck : $KI.net.removeIntegrityCheck,
        setIntegrityCheck : $KI.net.setIntegrityCheck,
        urlDecode : $KI.net.urlDecode,
        urlEncode : $KI.net.urlEncode
    };
}


if($KI.phone) {
    kony.phone = {
        dial: $KI.phone.dial,
        openMediaGallery: $KI.phone.openmediagallery, 
        addCalendarEvent: $KI.phone.addCalendarEvent,
        findCalendarEvents: $KI.phone.findCalendarEvents,
        openEmail: $KI.phone.openEmail,
        removeCalendarEvent: $KI.phone.removeCalendarEvent,
        sendSMS: $KI.phone.sendSMS
    };
}


if($KI.screenrecorder) {
    kony.screenrecorder = {
        start: $KI.screenrecorder.start,
        stop: $KI.screenrecorder.stop,
        pause: $KI.screenrecorder.pause,
        resume: $KI.screenrecorder.resume,
        getrecordeddata: $KI.screenrecorder.getrecordeddata,
        getrecordingstate: $KI.screenrecorder.getrecordingstate
    };
}

kony.screenshot = $KI.screenshot;


if($KI.string) {
    kony.string = {
        rep: $KI.string.rep,
        reverse: $KI.string.reverse,
        trim: $KI.string.trim,
        equalsIgnoreCase: $KI.string.equalsignorecase,
        startsWith: $KI.string.startswith,
        endsWith: $KI.string.endswith,
        isNumeric: $KI.string.isnumeric,
        containsChars: $KI.string.containschars,
        containsOnlyGivenChars: $KI.string.containsonlygivenchars,
        containsNoGivenChars: $KI.string.containsnogivenchars,
        isAsciiAlpha: $KI.string.isasciialpha,
        isAsciiAlphaNumeric: $KI.string.isasciialphanumeric,
        isValidEmail: $KI.string.isvalidemail
    };
}


if($KI.timer) {
    kony.timer = {
        schedule: $KI.timer.schedule,
        cancel: $KI.timer.cancel,
        setCallBack: $KI.timer.setcallback
    };
}


if($KI.themes) {
    kony.theme = {
        createTheme: $KI.themes.createtheme,
        deleteTheme: $KI.themes.deletetheme,
        getCurrentThemeData: $KI.themes.getcurrentthemedata,
        getCurrentTheme: $KI.themes.getcurrenttheme,
        getAllThemes: $KI.themes.allthemes,
        isThemePresent: $KI.themes.isthemepresent,
        setCurrentTheme: $KI.themes.setcurrenttheme,
        packagedthemes:$KI.themes.packagedthemes
    };
}

kony.convertToBase64 = $KI.converttobase64;
kony.convertToRawBytes = $KI.converttorawbytes;

kony.print = $KI.print;
kony.props = {};
kony.props.getProperty = $KI.props.getProperty;



if(!kony.stream) kony.stream = {};

kony.stream.registerDataStream = tobeimplemented;
kony.stream.deregisterDataStream = tobeimplemented;
kony.stream.setCallback = tobeimplemented;


if(!kony.accelerometer) kony.accelerometer = {};

kony.accelerometer.registerAccelerationEvents = tobeimplemented;
kony.accelerometer.retrieveCurrentAcceleration = tobeimplemented;
kony.accelerometer.startMonitoringAcceleration = tobeimplemented;
kony.accelerometer.stopMonitoringAcceleration = tobeimplemented;
kony.accelerometer.unregisterAccelerationEvents = tobeimplemented;


if(!kony.forcetouch) kony.forcetouch = {};

kony.forcetouch.getQuickActionItems = tobeimplemented;
kony.forcetouch.getStaticQuickActionItems = tobeimplemented;
kony.forcetouch.removeQuickActionItems = tobeimplemented;
kony.forcetouch.removeQuickActionItems = tobeimplemented;
kony.forcetouch.setQuickActionItems = tobeimplemented;


if(!kony.keychain) kony.keychain = {};

kony.keychain.remove = tobeimplemented;
kony.keychain.retrieve = tobeimplemented;
kony.keychain.save = tobeimplemented;


if(!kony.localAuthentication) kony.localAuthentication = {};

kony.localAuthentication.authenticate = tobeimplemented;
kony.localAuthentication.getBiometryType = tobeimplemented;
kony.localAuthentication.cancelAuthentication = tobeimplemented;
kony.localAuthentication.getStatusForAuthenticationMode = tobeimplemented;


if(!kony.media) kony.media = {};

kony.media.createFromFile = tobeimplemented;
kony.media.createFromUri = tobeimplemented;
kony.media.record = $KI.media.record;


if(!kony.localnotifications) kony.localnotifications = {};

kony.localnotifications.cancel = tobeimplemented;
kony.localnotifications.create = tobeimplemented;
kony.localnotifications.getNotifications = tobeimplemented;
kony.localnotifications.setCallbacks = tobeimplemented;


if(!kony.notificationsettings) kony.notificationsettings = {};

kony.notificationsettings.createAction = tobeimplemented;
kony.notificationsettings.createCategory = tobeimplemented;
kony.notificationsettings.registerCategory = tobeimplemented;


if(!kony.push) kony.push = {};
kony.push.deRegister = $KI.push.deregister;
kony.push.register = $KI.push.register;
kony.push.setCallbacks = $KI.push.setCallbacks;

if(!kony.contact) kony.contact = {};

kony.contact.add = tobeimplemented;
kony.contact.details = tobeimplemented;
kony.contact.find = tobeimplemented;
kony.contact.remove = tobeimplemented;


if(!kony.lang) kony.lang = {};

kony.lang.setUncaughtExceptionHandler = $KI.setUncaughtExceptionHandler;
kony.lang.getUncaughtExceptionHandler = $KI.getUncaughtExceptionHandler;


if(!kony.map) kony.map = {};

kony.map.containsLocation  = tobeimplemented;
kony.map.distanceBetween = tobeimplemented;
kony.map.decode = tobeimplemented;
kony.map.searchRoutes = tobeimplemented;


if(!kony.filter) kony.filter = {};

kony.filter.createFilter = tobeimplemented;


if(!kony.image) kony.image = {};

kony.image.createImage = tobeimplemented;
kony.image.createImageFromSnapShot = tobeimplemented;
kony.image.cropImageInTiles = tobeimplemented;
kony.image.cropImageInTilesForRects = tobeimplemented;


if(!kony.camera) kony.camera = {};

kony.camera.releaseRawBytes = tobeimplemented;


if(!kony.backgroundtasks) kony.backgroundtasks = {};

kony.backgroundtasks.startTask = tobeimplemented;
kony.backgroundtasks.stopTask = tobeimplemented;
kony.backgroundtasks.getTaskDetails = tobeimplemented;


if(!kony.shareExtensions) kony.shareExtensions = {};

kony.shareExtensions.popConfigurationViewController = tobeimplemented;
kony.shareExtensions.pushConfigurationViewController = tobeimplemented;
kony.shareExtensions.setExtensionsCallbacks = tobeimplemented;

if(!kony.todayExtension) kony.todayExtension = {};
kony.todayExtension.setExtensionsCallbacks = tobeimplemented ;

if(!kony.actionExtension) kony.actionExtension = {};
kony.actionExtension.setExtensionsCallbacks = tobeimplemented ;

if(!kony.intentExtension) kony.intentExtension = {};
kony.intentExtension.setExtensionsCallbacks = tobeimplemented ;

if(!kony.iMessageExtensions) kony.iMessageExtensions = {};
kony.iMessageExtensions.setExtensionsCallbacks = tobeimplemented ;

if(!kony.notificationContentExtension) kony.notificationContentExtension = {};
kony.notificationContentExtension.setExtensionsCallbacks = tobeimplemented ;


kony.runOnMainThread = tobeimplemented ;
kony.runOnWorkerThread = tobeimplemented ;

if(!com) com = {};
if(!com.kony) com.kony = {};

com.kony.Beacon = tobeimplemented;
com.kony.BeaconManager = tobeimplemented;
com.kony.BeaconRegion = tobeimplemented;
com.kony.PeripheralManager = tobeimplemented;
com.kony.isPassLibraryAvailable = tobeimplemented;
com.kony.PassLibrary = tobeimplemented;

com.kony.Beacon.prototype.getrssi =
com.kony.Beacon.prototype.getMajor =
com.kony.Beacon.prototype.getMinor =
com.kony.Beacon.prototype.getAccuracy =
com.kony.Beacon.prototype.getProximity =
com.kony.Beacon.prototype.getProximityUUIDString =

com.kony.BeaconManager.prototype.getRangedRegions =
com.kony.BeaconManager.prototype.authorizationStatus =
com.kony.BeaconManager.prototype.getMonitoredRegions =
com.kony.BeaconManager.prototype.requestStateForRegion =
com.kony.BeaconManager.prototype.stopRangingBeaconsInRegion =
com.kony.BeaconManager.prototype.startMonitoringBeaconRegion =
com.kony.BeaconManager.prototype.startRangingBeaconsInRegion =
com.kony.BeaconManager.prototype.stopMonitoringBeaconsRegion =
com.kony.BeaconManager.prototype.isRangingAvailableForBeaconRegions =
com.kony.BeaconManager.prototype.setAuthorizationStatusChangedCallback =
com.kony.BeaconManager.prototype.setMonitoringStartedForRegionCallback =
com.kony.BeaconManager.prototype.isMonitoringAvailableForBeaconRegions =

com.kony.PeripheralManager.prototype.isAdvertising =
com.kony.PeripheralManager.prototype.stopAdvertising =
com.kony.PeripheralManager.prototype.authorizationStatus =
com.kony.PeripheralManager.prototype.startAdvertisingWithMeasuredPower =

com.kony.PassLibrary.prototype.addPassWithCompletionCallback =
com.kony.PassLibrary.prototype.addPassesWithCompletionCallback =
com.kony.PassLibrary.prototype.containsPass =
com.kony.PassLibrary.prototype.getPassWithTypeIdentifierAndSerialNumber =
com.kony.PassLibrary.prototype.getPasses =
com.kony.PassLibrary.prototype.removePass =
com.kony.PassLibrary.prototype.replacePassWithPass = tobeimplemented;

kony.application = {

    
    createAppMenu:$KW.Appmenu && $KW.Appmenu.createappmenu,
    setCurrentAppMenu:$KW.Appmenu && $KW.Appmenu.setcurrentappmenu,
    getCurrentAppMenu:$KW.Appmenu && $KW.Appmenu.getcurrentappmenu,
    setAppMenuFocusByID:$KW.Appmenu && $KW.Appmenu.setappmenufocusbyid,
    addAppMenuItemAt:$KW.Appmenu && $KW.Appmenu.addappmenuitemat,
    removeAppMenuItemAt:$KW.Appmenu && $KW.Appmenu.removeappmenuitemat,
    setAppMenu: $KW.Appmenu && $KW.Appmenu.setappmenu,
    setAppMenuFocusIndex: $KW.Appmenu && $KW.Appmenu.setappmenufocusindex,
    showAppMenuItems: $KW.Appmenu && $KW.Appmenu.showappmenuitems,
    hideAppMenuItems: $KW.Appmenu && $KW.Appmenu.hideappmenuitems,
    
    setBMState   : kony.bm.setBMState,
    resetBMState : kony.bm.resetBMState,
    getBMState   : kony.bm.getBMState,
    getFormId    : kony.bm.getFormId,
    addBMState   : kony.bm.addBMState,
    removeBMState: kony.bm.removeBMState,

    exit: $KI.exit,

    getPreviousForm: $KW.Form && $KW.Form.getPreviousForm,
    getCurrentForm: $KW.Form && $KW.Form.getCurrentForm,
    getCurrentBreakpoint: $KW.Form && $KW.Form.getCurrentBreakpoint,

    removeGestureRecognizerForAllForms: $KW.Widget && $KW.Widget.removegesturerecognizerforallforms,
    setGestureRecognizerForAllForms: $KW.Widget && $KW.Widget.setgesturerecognizerforallforms,
    addGestureRecognizerForAllForms: $KW.Widget && $KW.Widget.addgesturerecognizerforallforms,

    getApplicationMode: $KI.os && $KI.os.getapplicationmode,
    setApplicationMode: $KI.os && $KI.os.setapplicationmode,
    setApplicationInitializationEvents: $KI.setappevents,

    registerForIdleTimeout: $KI.appevents && $KI.appevents.registerforidletimeout,
    unregisterForIdleTimeout:$KI.appevents && $KI.appevents.unregisterforidletimeout,

    
    setApplicationBadgeValue: tobeimplemented,
    getApplicationBadgeValue: tobeimplemented,
    setAppMenuBadgeValue: tobeimplemented,
    getAppMenuBadgeValue: tobeimplemented,

    appReset: $KI.appreset,

    setAppHeaders: $KI.setappheaders,
    setAppFooters: $KI.setappfooters,
    setApplicationCallbacks: $KI.setapplicationcallbacks,
    addApplicationCallbacks: $KI.addapplicationcallbacks,
    removeApplicationCallbacks: $KI.removeapplicationcallbacks,
    setApplicationBehaviors: $KI.setapplicationbehaviors,
    getApplicationBehavior: $KI.getapplicationbehavior,

    
    registerUserWidget: $KW.KComponent.registerComponent,
    registerMaster: $KW.KComponent.registerComponent,

    showLoadingScreen : $KI.window && $KI.window.showLoadingScreen,
    dismissLoadingScreen : $KI.window && $KI.window.dismissLoadingScreen,
    setupWidgetDataRecording :  $KI.setupWidgetDataRecording,
    setSeoDataReadyFlag :  $KI.setSeoDataReadyFlag,
    removeSeoDataReadyFlag :  $KI.removeSeoDataReadyFlag,
    openURL: $KI.window.openURL,
    openURLAsync: $KI.window.openURLAsync,
    openMediaURL : $KI.window.openURL,

    
    PERMISSION_DENIED  : 0,
    PERMISSION_GRANTED : 1,
    PERMISSION_RESTRICTED : 2,
    RESOURCE_NOT_SUPPORTED : 3,
    
    checkPermission: function(resourceId, options){
        $KU.logExecuting('kony.application.checkPermission');
        if(arguments.length < 1){
            $KU.logErrorMessage('Invalid no of arguments');
            throw new KonyError(101, "Error", "Invalid number of arguments");
            return;
        }
        $KU.logExecutingWithParams('kony.application.checkPermission', resourceId, options);
        switch (resourceId) {
            case kony.os.RESOURCE_LOCATION :
            case kony.os.RESOURCE_CAMERA :
            case kony.os.RESOURCE_PHOTO_GALLERY :
            case kony.os.RESOURCE_CALENDAR :
                $KU.logExecutingFinished('kony.application.checkPermission VIA if resource permission granted ');
                return {status:kony.application.PERMISSION_GRANTED, canRequestPermission: false };
            case kony.os.RESOURCE_CONTACTS :
            case kony.os.RESOURCE_EXTERNAL_STORAGE :
            default:
                $KU.logExecutingFinished('kony.application.checkPermission VIA if resource permission is not granted or resource is not supported');
                return {status:kony.application.RESOURCE_NOT_SUPPORTED, canRequestPermission: false };
        }
    },

    
    requestPermission: function(resourceId, callback, options){
        $KU.logExecuting('kony.application.requestPermission');
        $KU.logExecutingWithParams('kony.application.requestPermission', resourceId, callback, options);
        if(arguments.length < 2){
            $KU.logErrorMessage('Invalid no of arguments');
            throw new KonyError(101, "Error", "Invalid number of arguments");
            return;
        }
        if(!( typeof callback === "function")){
            $KU.logErrorMessage('Invalid callback function');
            throw new KonyError(102, "Error", "Invalid input.");
            return;
        }

        switch (resourceId) {
            case kony.os.RESOURCE_LOCATION :
            case kony.os.RESOURCE_CAMERA :
            case kony.os.RESOURCE_PHOTO_GALLERY :
            case kony.os.RESOURCE_CALENDAR :
                $KU.logExecutingFinished('kony.application.requestPermission VIA if resource permission granted');
                callback({status:kony.application.PERMISSION_GRANTED, canRequestPermission: false });
                break;
            case kony.os.RESOURCE_CONTACTS :
            case kony.os.RESOURCE_EXTERNAL_STORAGE :
            default:
                $KU.logExecutingFinished('kony.application.requestPermission VIA if if resource permission is not granted or resource is not supported');
                callback({status:kony.application.RESOURCE_NOT_SUPPORTED, canRequestPermission: false });
        }
    },
    
    openApplicationSettings: function(){
        $KU.logWarnMessage("openApplicationSettings API is not supported.");
    },

    isPopupBlocked: function(cb) {
        $KU.logExecuting('kony.application.isPopupBlocked');
        $KU.logExecutingWithParams('kony.application.isPopupBlocked', cb);
        var test;
        setTimeout(function() {
            test = window.open(null);
            try {
                test.close();
                $KU.logExecutingFinished('kony.application.isPopupBlocked VIA enabling popups');
                cb && cb(false); 
            } catch (e) {
                $KU.logExecutingFinished('kony.application.isPopupBlocked VIA disabling popups');
                cb && cb(true); 
            }
        }, 2000);
    },

    isImageTurnedOff: function(cb) {
        $KU.logExecuting('kony.application.isImageTurnedOff');
        $KU.logExecutingWithParams('kony.application.isImageTurnedOff', cb);
        var isCompleted;
        var __kspaimage = document.createElement("img");
        __kspaimage.src = $KU.getImageURL('slider.png');
        __kspaimage.id = "__kspaimage";
        __kspaimage.style.visibility="hidden";
        document.body.appendChild(__kspaimage);
        setTimeout(function() {
            isCompleted =  __kspaimage.complete;
            if(!isCompleted) {
                $KU.logExecutingFinished('kony.application.isImageTurnedOff VIA !isCompleted == true');
                cb && cb(true);
            } else {
                $KU.logExecutingFinished('kony.application.isImageTurnedOff VIA !isCompleted == false');
                cb && cb(false);
            }
            document.body.removeChild(__kspaimage);
        }, 1000);
    },

    addSettingsMenuItemAt                      : tobeimplemented,
    beginBackgroundTask                        : tobeimplemented,
    createSettingsMenu                            : tobeimplemented,
    destroyForm                                : tobeimplemented,
    disableZoomedOutView                         : tobeimplemented,
    endBackgroundTask                            : tobeimplemented,
    getApplicationState                        : tobeimplemented,
    getAppWindow                                : tobeimplemented,
    getCurrentSettingsMenu                        : tobeimplemented,
    getPreviousSessionParams                    : tobeimplemented,
    invalidateSession                            : tobeimplemented,
    launchApp                                    : tobeimplemented,
    registerOnKeyPress                            : tobeimplemented,
    removeSecondaryTile                        : tobeimplemented,
    removeSettingsMenuItemAt                    : tobeimplemented,
    setApplicationLayout                        : tobeimplemented,
    setApplicationProperties                    : tobeimplemented,
    setAppTile                                    : tobeimplemented,
    setCheckBoxSelectionImageAlignment            : tobeimplemented,
    setCurrentSettingsMenu                        : tobeimplemented,
    setDefaultTextboxPadding                    : tobeimplemented,
    setRespectImageSizeForImageWidgetAlignment : tobeimplemented,
    setSecondaryTile                           : tobeimplemented,
    setZoomedOutView                            : tobeimplemented,
    zoomIn                                        : tobeimplemented
};

function tobeimplemented() {
    kony.web.logger("warn", "API to be implemented Yet");
};

kony.application.settings = {
    read : tobeimplemented ,
    write : tobeimplemented
};

kony.mvc = kony.mvc || {};
kony.mvc.BaseController = function() {
    function BaseController(viewId1) {
        this.viewId = viewId1;
        var viewModel;
        defineGetter(this, "view", function() {
            if (viewModel === undefined) {
                viewModel = this.__initializeView(this);
                if (Object.prototype.hasOwnProperty.call(this, "onViewCreated")) {
                    this["onViewCreated"].apply(this)
                }
            }
            return viewModel
        });
        defineSetter(this, "view", function(val) {
            viewModel = val
        })
    }
    BaseController.prototype.destroy = function() {
        if (this.onDestroy) {
            this.onDestroy()
        }
        this.view = null;
        this.viewId = null
    };
    return BaseController
}();
kony.mvc = kony.mvc || {};
inheritsFrom = function(child, parent) {
    child.prototype = Object.create(parent.prototype)
};
kony.mvc.FormController = function() {
    function FormController(viewId1) {
        var navContext;
        this.navigationMode = 0;
        this.__initializeView = function(objController) {
            var retForm = null;
            var viewFileName = objController.viewId;
            if (Object.prototype.hasOwnProperty.call(this, "onCreateView")) {
                viewFileName = this["onCreateView"].apply(this, null);
                if (typeof viewFileName === "object" && Object.prototype.hasOwnProperty.call(viewFileName, "id")) {
                    retForm = viewFileName
                } else {
                    formCreateFunc = require(viewFileName);
                    var formConfig = formCreateFunc(objController);
                    if (Object.prototype.toString.call(formConfig) === "[object Array]") {
                        formConfig[0]._konyControllerName = objController.Name;
                        retForm = new _kony.mvc.Form2(formConfig[0], formConfig[1], formConfig[2])
                    } else {
                        formConfig._konyControllerName = objController.Name;
                        retForm = new _kony.mvc.Form2(formConfig)
                    }
                }
            } else {
                formCreateFunc = require(viewFileName);
                var formConfig = formCreateFunc(objController);
                if (Object.prototype.toString.call(formConfig) === "[object Array]") {
                    formConfig[0]._konyControllerName = objController.Name;
                    retForm = new _kony.mvc.Form2(formConfig[0], formConfig[1], formConfig[2])
                } else {
                    formConfig._konyControllerName = objController.Name;
                    retForm = new _kony.mvc.Form2(formConfig)
                }
            }
            retForm.mvcInitializeView = false;
            retForm._konyControllerName = objController.Name;
            _kony.mvc.ctrlname2ControllerMap[retForm._konyControllerName] = objController;
            _kony.mvc.viewId2ControllerNameMap[retForm.id] = objController.Name;
            _kony.mvc.viewName2viewId[objController.viewId] = retForm.id;
            retForm.mvcInitializeView = true;
            return retForm
        };
        this.__showView = function(param) {
            if (null != this.view) {
                navContext = param;
                _kony.mvc.showForm(this.view)
            }
        };
        defineGetter(this, "navigationContext", function() {
            return navContext
        });
        defineSetter(this, "navigationContext", function(val) {
            throw new Error("Setter for Navigation context is not allowed.")
        });
        kony.mvc.BaseController.call(this, viewId1)
    }
    inheritsFrom(FormController, kony.mvc.BaseController);
    FormController.prototype.pauseNavigation = function() {
        if (this.navigationMode == 1) {
            this.navigationMode = 2
        } else {
            kony.print("No form navigation is in progress hence cannot be paused.")
        }
    };
    FormController.prototype.resumeNavigation = function() {
        if (this.navigationMode == 2) {
            this.navigationMode = 0;
            this.__showView()
        } else {
            kony.print("No form navigation is in paused state hence cannot be resumed.")
        }
    };
    FormController.prototype.show = function(param, isBackNavigation) {
        this.navigationMode = 1;
        if (this.onNavigate) {
            this.onNavigate.call(this, param, isBackNavigation)
        }
        if (this.navigationMode == 1) {
            this.navigationMode = 0;
            this.__showView(param)
        }
    };
    FormController.prototype.getPreviousForm = function() {
        var prevForm = kony.application.getPreviousForm();
        if (null != prevForm) {
            if (prevForm._konyControllerName) return prevForm.id;
            else return prevForm
        }
        return null
    };
    FormController.prototype.getPreviousFormFriendlyName = function() {
        var prevForm = kony.application.getPreviousForm();
        if (null != prevForm) {
            var fName = kony.mvc.registry.getFriendlyName(prevForm.id);
            if (null != fName) return fName;
            else return prevForm.id
        }
        return null
    };
    FormController.prototype.getCurrentForm = function() {
        var currForm = kony.application.getCurrentForm();
        if (null != currForm) {
            if (currForm._konyControllerName) return currForm.id;
            else return currForm
        }
        return null
    };
    FormController.prototype.getCurrentFormFriendlyName = function() {
        var currForm = kony.application.getCurrentForm();
        var fName = kony.mvc.registry.getFriendlyName(currForm.id);
        if (null != fName) return fName;
        else return currForm.id;
        return null
    };
    FormController.prototype.destroy = function() {
        if (null != this.view) {
            if (this.view.onDestroy) {
                var destroyFunc = this.view.onDestroy;
                this.view.onDestroy = null;
                destroyFunc.call(this)
            }
            _kony.mvc.destroyForm(this.view)
        }
        kony.mvc.BaseController.prototype.destroy.call(this)
    };
    return FormController
}();
_kony = _kony || {};
_kony.mvc = _kony.mvc || {};
kony.mvc = kony.mvc || {};
kony.utils = kony.utils || {};

function accessorDescriptor(field, fun) {
    var desc = {
        enumerable: true,
        configurable: true
    };
    desc[field] = fun;
    return desc
}

function defineGetter(obj, prop, get) {
    if (Object.defineProperty) return Object.defineProperty(obj, prop, accessorDescriptor("get", get));
    if (Object.prototype.__defineGetter__) return obj.__defineGetter__(prop, get);
    throw new Error("browser does not support getters")
}

function defineSetter(obj, prop, set) {
    if (Object.defineProperty) return Object.defineProperty(obj, prop, accessorDescriptor("set", set));
    if (Object.prototype.__defineSetter__) return obj.__defineSetter__(prop, set);
    throw new Error("browser does not support setters")
}
inheritsFrom = function(child, parent) {
    child.prototype = Object.create(parent.prototype)
};
_kony.mvc.ctrlname2ControllerMap = {};
_kony.mvc.viewId2ControllerNameMap = {};
_kony.mvc.formNavigateInProgress = [];
_kony.mvc.formNavigateCounter = 0;
_kony.mvc.viewName2viewId = {};
kony.utils.LoadJSFile = function(fileName) {
    var retForm = null;
    controllerConfig = require(fileName); {
        retForm = controllerConfig
    }
    return retForm
};
kony.mvc.isControllerAvailable = function(formFriendlyName) {
    var ctrlName = null,
        tmpFormName = null,
        formID = formFriendlyName,
        returnFlag = false;
    tmpFormName = kony.mvc.registry.get(formID);
    if (null != tmpFormName) formID = tmpFormName;
    if (formID in _kony.mvc.viewName2viewId) {
        formID = _kony.mvc.viewName2viewId[formID]
    }
    if (null != formID) {
        if (formID in _kony.mvc.viewId2ControllerNameMap) {
            ctrlName = _kony.mvc.viewId2ControllerNameMap[formID];
            if (ctrlName in _kony.mvc.ctrlname2ControllerMap) {
                returnFlag = true
            }
        }
    }
    return returnFlag
};
kony.application.destroyForm = function(formFriendlyName) {
    var tmpController = null;
    var formID = formFriendlyName;
    var tmpFormName = kony.mvc.registry.get(formID);
    if (null != tmpFormName) {
        formID = tmpFormName
    }
    var fileName = formID;
    if (formID in _kony.mvc.viewName2viewId) {
        formID = _kony.mvc.viewName2viewId[formID]
    }
    if (null != formID) {
        if (formID in _kony.mvc.viewId2ControllerNameMap) {
            var ctrlName = _kony.mvc.viewId2ControllerNameMap[formID];
            if (ctrlName in _kony.mvc.ctrlname2ControllerMap) {
                tmpController = _kony.mvc.ctrlname2ControllerMap[ctrlName];
                if (null != tmpController) tmpController.destroy();
                delete _kony.mvc.ctrlname2ControllerMap[ctrlName];
                delete _kony.mvc.viewId2ControllerNameMap[formID];
                if (fileName in _kony.mvc.viewName2viewId) {
                    delete _kony.mvc.viewName2viewId[fileName]
                }
            }
        }
    }
};
konyNavigate2Form = function(formFriendlyName) {
    var deeplinkFormNav = new kony.mvc.Navigation(formFriendlyName);
    deeplinkFormNav.navigate()
};
_kony.mvc.navigateBack2Form = function(formFriendlyName) {
    var controller = _kony.mvc.GetController(formFriendlyName, true);
    if (!controller) {
        kony.print("########## No controller is found to navigate #####");
        throw "Controller Not Found"
    }
    controller.show.call(controller, null, true)
};
_kony.mvc.destroyController = function(konyControllerName) {
    var tmpController = null;
    if (konyControllerName in _kony.mvc.ctrlname2ControllerMap) {
        tmpController = _kony.mvc.ctrlname2ControllerMap[konyControllerName];
        if (null != tmpController) {
            tmpController.destroy()
        }
        tmpController = null;
        delete _kony.mvc.ctrlname2ControllerMap[konyControllerName]
    }
};
_kony.mvc.executeInJsContext = function(templateView, functionName, subargs) {
    if (templateView._konyControllerName in _kony.mvc.ctrlname2ControllerMap) {
        var viewName = templateView._konyControllerName;
        var tmpController = _kony.mvc.ctrlname2ControllerMap[viewName];
        if (null != tmpController) {
            if (typeof functionName === "string" || functionName instanceof String) {
                tmpController[functionName].apply(tmpController, subargs)
            } else {
                functionName.apply(tmpController, subargs)
            }
        }
    } else {
        var eventobject = null;
        if (subargs.length > 0) {
            var tempCallerObject = subargs[0];
            if (typeof tempCallerObject === "object" && Object.prototype.hasOwnProperty.call(tempCallerObject, "id")) {
                eventobject = tempCallerObject;
                subargs.shift()
            }
        }
        if (null != eventobject) {
            functionName.apply(eventobject, subargs)
        } else {
            if (typeof templateView === "object" && Object.prototype.hasOwnProperty.call(templateView, "id")) {
                functionName.apply(templateView, subargs)
            } else {
                subargs.unshift(templateView);
                functionName.apply(null, subargs)
            }
        }
    }
};
_kony.mvc.assignFunctions2Controller = function(tmpController, controllers) {
    if (controllers.length > 1) {
        var allFunctions = {};
        for (var i = 0; i < controllers.length; i++) {
            var extensionLevel = "extensionLevel" + i;
            tmpController[extensionLevel] = {};
            if (i == 0) tmpController["parent"] = {};
            for (var key in controllers[i]) {
                if (i < controllers.length && _kony.mvc.isValidControllerKey(key)) {
                    if (typeof controllers[i][key] === "function") {
                        tmpController[extensionLevel][key] = controllers[i][key].bind(tmpController);
                        if (i == 0) tmpController["parent"][key] = controllers[i][key].bind(tmpController)
                    } else {
                        tmpController[extensionLevel][key] = controllers[i][key];
                        if (i == 0) tmpController["parent"][key] = controllers[i][key]
                    }
                }
                allFunctions[key] = controllers[i][key]
            }
        }
        for (var key in allFunctions) {
            if (_kony.mvc.isValidControllerKey(key)) {
                if (typeof allFunctions[key] === "function") {
                    tmpController[key] = allFunctions[key].bind(tmpController)
                } else {
                    tmpController[key] = allFunctions[key]
                }
            }
        }
    } else {
        var config2 = controllers[0];
        for (var key in config2) {
            if (_kony.mvc.isValidControllerKey(key) && typeof config2 === "object" && Object.prototype.hasOwnProperty.call(config2, key)) {
                if (typeof config2[key] === "function") {
                    tmpController[key] = config2[key].bind(tmpController)
                } else {
                    tmpController[key] = config2[key]
                }
            }
        }
    }
};
_kony.mvc.isValidControllerKey = function(key) {
    return key != "prototype" && key != "view" && key != "viewId" && key != "userWidgetName" && key != "__initializeView" && key != "name"
};
_konyControllerCounter = 0;
globalObj = this;
var stringToFunction = function(str) {
    var arr = str.split(".");
    var fn = globalObj || this;
    for (var i = 0, len = arr.length; i < len; i++) {
        fn = fn[arr[i]]
    }
    if (typeof fn !== "function") {
        throw new Error("function not found")
    }
    return fn
};
_kony.mvc.GetControllerAsync = function(formFriendlyName, successCallBack, errorCallback) {
    var tmpController = null,
        ctrlName = null,
        levels = null,
        i = 0,
        formID = formFriendlyName,
        requireFileList = [],
        controllerTypePath = null,
        tmpControllerName = null,
        controllerType = null,
        controllerTypeFile = null,
        extensionControllersList = null,
        tmpFormName = kony.mvc.registry.get(formID);
    if (null != tmpFormName) {
        formID = tmpFormName
    }
    if (formID in _kony.mvc.viewName2viewId) {
        formID = _kony.mvc.viewName2viewId[formID]
    }
    if (null != formID) {
        if (formID in _kony.mvc.viewId2ControllerNameMap) {
            ctrlName = _kony.mvc.viewId2ControllerNameMap[formID];
            if (ctrlName in _kony.mvc.ctrlname2ControllerMap) {
                tmpController = _kony.mvc.ctrlname2ControllerMap[ctrlName]
            }
            successCallBack(tmpController)
        } else {
            requireFileList = [];
            tmpControllerName = kony.mvc.registry.getControllerName(formFriendlyName);
            controllerType = kony.mvc.registry.getControllerType(formFriendlyName);
            controllerTypeFile = kony.mvc.registry.getControllerTypeFile(formFriendlyName);
            extensionControllersList = kony.mvc.registry.getControllerExtName(formFriendlyName);
            if (null == tmpControllerName) {
                tmpControllerName = formID + "Controller"
            }
            requireFileList.push(tmpControllerName);
            if (null != controllerType) {
                if (null == controllerTypeFile) {
                    controllerTypePath = controllerType.replace(/\./g, "/")
                } else {
                    controllerTypePath = controllerTypeFile.replace(/\./g, "/")
                }
                requireFileList.push(controllerTypePath)
            }
            if (null != extensionControllersList) {
                if (typeof extensionControllersList === "string") {
                    requireFileList.push(extensionControllersList)
                } else {
                    levels = extensionControllersList.length;
                    for (i = 0; i < levels; i++) {
                        if (null != extensionControllersList[i]) {
                            requireFileList.push(extensionControllersList[i])
                        } else {
                            break
                        }
                    }
                }
            }
            requireFileList.push(_kony.mvc.registryMap[formFriendlyName].name);
            require(requireFileList, function(config) {
                var ctor = null;
                if (null == controllerType) {
                    tmpController = new kony.mvc.FormController(formID)
                } else {
                    ctor = stringToFunction(controllerType);
                    tmpController = new ctor(formID)
                }
                tmpController.Name = tmpControllerName + "_" + (++_konyControllerCounter).toString();
                _kony.mvc.loadAllExtensionControllers(tmpController, config, formFriendlyName);
                successCallBack(tmpController)
            }, function(err) {
                errorCallback(err)
            })
        }
    }
};
_kony.mvc.GetController = function(formFriendlyName, isForm) {
    var tmpController = null;
    var formID = formFriendlyName;
    var tmpFormName = kony.mvc.registry.get(formID);
    if (null != tmpFormName) {
        formID = tmpFormName
    }
    if (formID in _kony.mvc.viewName2viewId) {
        formID = _kony.mvc.viewName2viewId[formID]
    }
    if (null != formID) {
        if (isForm && formID in _kony.mvc.viewId2ControllerNameMap) {
            var ctrlName = _kony.mvc.viewId2ControllerNameMap[formID];
            if (ctrlName in _kony.mvc.ctrlname2ControllerMap) {
                tmpController = _kony.mvc.ctrlname2ControllerMap[ctrlName]
            }
        } else {
            var tmpControllerName = kony.mvc.registry.getControllerName(formFriendlyName);
            if (null == tmpControllerName) {
                tmpControllerName = formID + "Controller"
            }
            var config = kony.utils.LoadJSFile(tmpControllerName);
            if (isForm) {
                var controllerType = kony.mvc.registry.getControllerType(formFriendlyName);
                if (null == controllerType) {
                    tmpController = new kony.mvc.FormController(formID)
                } else {
                    var controllerTypeFile = kony.mvc.registry.getControllerTypeFile(formFriendlyName);
                    var controllerTypePath = null;
                    if (null == controllerTypeFile) {
                        controllerTypePath = controllerType.replace(/\./g, "/")
                    } else {
                        controllerTypePath = controllerTypeFile.replace(/\./g, "/")
                    }
                    kony.utils.LoadJSFile(controllerTypePath);
                    var ctor = stringToFunction(controllerType);
                    tmpController = new ctor(formID)
                }
            } else {
                var controllerType = kony.mvc.registry.getControllerType(formFriendlyName);
                if (null == controllerType) {
                    tmpController = new kony.mvc.TemplateController(formID)
                } else {
                    var controllerTypeFile = kony.mvc.registry.getControllerTypeFile(formFriendlyName);
                    var controllerTypePath = null;
                    if (null == controllerTypeFile) {
                        controllerTypePath = controllerType.replace(/\./g, "/")
                    } else {
                        controllerTypePath = controllerTypeFile.replace(/\./g, "/")
                    }
                    kony.utils.LoadJSFile(controllerTypePath);
                    var ctor = stringToFunction(controllerType);
                    tmpController = new ctor(formID)
                }
            }
            tmpController.Name = tmpControllerName + "_" + (++_konyControllerCounter).toString();
            _kony.mvc.loadAllExtensionControllers(tmpController, config, formFriendlyName);
            var x = tmpController.view
        }
    }
    return tmpController
};
_kony.mvc.loadAllExtensionControllers = function(tmpController, config, formFriendlyName) {
    var controllers = [];
    controllers.push(config);
    var config2 = {};
    var tmpControllerName2 = kony.mvc.registry.getControllerExtName(formFriendlyName);
    if (null != tmpControllerName2) {
        if (typeof tmpControllerName2 === "string") {
            config2 = kony.utils.LoadJSFile(tmpControllerName2);
            controllers.push(config2)
        } else {
            var levels = tmpControllerName2.length;
            for (var i = 0; i < levels; i++) {
                if (null != tmpControllerName2[i]) {
                    config2 = kony.utils.LoadJSFile(tmpControllerName2[i]);
                    controllers.push(config2)
                } else {
                    break
                }
            }
        }
    }
    _kony.mvc.assignFunctions2Controller(tmpController, controllers)
};
_kony.mvc.CreateMasterWidgetController = function(userWidgetName, uwInstanceName, args) {
    var tmpController = null;
    var formID = userWidgetName;
    var tmpFormName = kony.mvc.registry.get(formID);
    if (null != tmpFormName) {
        formID = tmpFormName
    }
    if (null != formID) {
        var tmpControllerName = kony.mvc.registry.getControllerName(userWidgetName);
        if (null == tmpControllerName) {
            tmpControllerName = formID + "Controller"
        }
        var uwPath = userWidgetName.replace(/\./g, "/");
        var config = kony.utils.LoadJSFile(uwPath + "/" + tmpControllerName);
        var controllerType = kony.mvc.registry.getControllerType(userWidgetName);
        if (null == controllerType) {
            tmpController = new kony.mvc.MasterController(userWidgetName, formID, uwInstanceName)
        } else {
            var controllerTypeFile = kony.mvc.registry.getControllerTypeFile(userWidgetName);
            var controllerTypePath = null;
            if (null == controllerTypeFile) {
                controllerTypePath = controllerType.replace(/\./g, "/")
            } else {
                controllerTypePath = controllerTypeFile.replace(/\./g, "/")
            }
            kony.utils.LoadJSFile(controllerTypePath);
            var ctor = stringToFunction(controllerType);
            tmpController = new ctor(userWidgetName, formID, uwInstanceName)
        }
        tmpController.args = args;
        tmpController.Name = tmpControllerName + "_" + (++_konyControllerCounter).toString();
        var masterType = constants.MASTER_TYPE_USERWIDGET;
        if (Object.prototype.toString.call(args) === "[object Array]") {
            if (null != args[0]["masterType"]) {
                masterType = args[0]["masterType"]
            }
        } else {
            masterType = args["masterType"]
        }
        tmpController.masterType = masterType;
        if (masterType == constants.MASTER_TYPE_USERWIDGET) {
            _kony.mvc.loadAllExtensionControllers(tmpController, config, userWidgetName)
        } else {
            var controllers = [];
            controllers.push(config);
            _kony.mvc.assignFunctions2Controller(tmpController, controllers)
        }
        if (tmpController.initializeProperties) {
            tmpController.initializeProperties()
        }
        if (Object.prototype.hasOwnProperty.call(tmpController, "constructor")) {
            tmpController["constructor"].apply(tmpController, args)
        }
    }
    return tmpController
};
_kony.mvc.initializeSubViewController = function(friendlyName) {
    var tmpController = _kony.mvc.GetController(friendlyName, false);
    return tmpController.view
};
_kony.mvc.initializeMasterController = function(userWidgetName, uwInstanceName, args) {
    var tmpController = _kony.mvc.CreateMasterWidgetController(userWidgetName, uwInstanceName, args);
    return tmpController.view
};
_kony.mvc.initializeFormViewController = function(friendlyName) {
    var tmpController = _kony.mvc.GetController(friendlyName, true);
    return tmpController.view
};
_kony = _kony || {};
_kony.mvc = _kony.mvc || {};
_kony.mvc.setData2UserWidget = function(userWidgetInstance, newClonedRowView, data, isSetViewProps) {
    var controllerName = userWidgetInstance._konyControllerName;
    if (controllerName in _kony.mvc.ctrlname2ControllerMap) {
        var tmpController = _kony.mvc.ctrlname2ControllerMap[controllerName];
        if (null == tmpController) return;
        var tempView = tmpController.view;
        tmpController.view = newClonedRowView;
        var xx = tmpController.view.bottom;
        if (typeof data === "object") {
            for (var m in data) {
                if (Object.prototype.hasOwnProperty.call(tmpController, m)) {
                    tmpController[m] = data[m]
                } else if (isSetViewProps) {
                    tempView[m] = data[m]
                }
            }
        }
        tmpController.view = tempView
    }
};
_kony.mvc.setMasterWidgetContract = function(userWidgetInstance, tmpController) {
    var lstFunctions = Object.getOwnPropertyNames(tmpController).filter(function(p) {
        return typeof tmpController[p] === "function" && p != "__initializeView"
    });
    _kony.mvc.setFunctions(userWidgetInstance, lstFunctions, tmpController);
    var lstProperties = Object.getOwnPropertyNames(tmpController).filter(function(p) {
        return typeof tmpController[p] != "function" && p != "viewId" && p != "view" && p != "userWidgetName"
    });
    _kony.mvc.setProperties(userWidgetInstance, lstProperties, tmpController);
    var view111 = tmpController.view;
    var lstFunctionsOnMaster = _kony.mvc.getMethods(userWidgetInstance);
    var lstFunctions = _kony.mvc.getMethods(view111).filter(function(p) {
        return lstFunctionsOnMaster.indexOf(p) <= -1
    });
    _kony.mvc.setFunctions(userWidgetInstance, lstFunctions, view111, true);
    var lstPropertiesOnMaster = _kony.mvc.getProperties(userWidgetInstance);
    var lstProperties = _kony.mvc.getProperties(view111).filter(function(p) {
        return lstPropertiesOnMaster.indexOf(p) <= -1
    });
    _kony.mvc.setProperties(userWidgetInstance, lstProperties, view111);
    var children = _kony.mvc.getAllChildren(view111);
    _kony.mvc.setProperties(userWidgetInstance, children, view111)
};
_kony.mvc.getAllChildren = function(viewInstance) {
    var childIds = [];
    if (viewInstance.widgets) {
        var children = viewInstance.widgets();
        for (var i = 0; i < children.length; i++) {
            var child = children[i];
            childIds.push(child.id);
            if (child._konyControllerName == null) {
                var grandChildren = _kony.mvc.getAllChildren(child);
                for (var j = 0; j < grandChildren.length; j++) {
                    childIds.push(grandChildren[j])
                }
            }
        }
    }
    return childIds
};
_kony.mvc.getMethods = function(obj) {
    var res = Object.getOwnPropertyNames(obj).filter(function(p) {
        return typeof obj[p] === "function"
    });
    for (var m in obj) {
        if (typeof obj[m] == "function") {
            res.push(m)
        }
    }
    return res
};
_kony.mvc.getProperties = function(obj) {
    var res = Object.getOwnPropertyNames(obj).filter(function(p) {
        return typeof obj[p] != "function"
    });
    for (var m in obj) {
        if (typeof obj[m] != "function") {
            res.push(m)
        }
    }
    return res
};
_kony.mvc.setMasterContract = function(userWidgetInstance) {
    var config = {};
    if (null == userWidgetInstance || userWidgetInstance._konyInitialized) return;
    var usInstanceName = userWidgetInstance._konyControllerName;
    if (usInstanceName in _kony.mvc.ctrlname2ControllerMap) {
        var tmpController = _kony.mvc.ctrlname2ControllerMap[usInstanceName];
        if (null == tmpController) return;
        var xx = tmpController.view.bottom;
        if (tmpController.masterType == constants.MASTER_TYPE_USERWIDGET) {
            if (appConfig && appConfig.testAutomation && appConfig.testAutomation.scriptsURL) {
                _kony.mvc.setMasterWidgetContract(userWidgetInstance, tmpController)
            }
            _kony.mvc.setUserWidgetContract(userWidgetInstance, tmpController)
        } else {
            _kony.mvc.setMasterWidgetContract(userWidgetInstance, tmpController)
        }
        userWidgetInstance._konyInitialized = true
    }
};
_kony.mvc.setUserWidgetContract = function(userWidgetInstance, tmpController) {
    var userWidgetName = tmpController.userWidgetName;
    var uwPath = userWidgetName;
    var n = userWidgetName.lastIndexOf(".");
    var configFileName = userWidgetName + "Config";
    if (n >= 0) {
        configFileName = configFileName.substring(n + 1);
        uwPath = userWidgetName.replace(/\./g, "/")
    }
    var configFileName = uwPath + "/" + configFileName;
    var master = require(configFileName);
    if (null == master) return;
    if (null != master["properties"]) {
        var propertiesOnMaster = master["properties"];
        _kony.mvc.setProperties(userWidgetInstance, propertiesOnMaster, tmpController)
    }
    if (null != master["apis"]) {
        var apisOnMaster = master["apis"];
        _kony.mvc.setFunctions(userWidgetInstance, apisOnMaster, tmpController)
    }
    if (null != master["events"]) {
        var eventsOnMaster = master["events"];
        _kony.mvc.setEvents(userWidgetInstance, eventsOnMaster, tmpController)
    }
    return
};
_kony.mvc.setProperties = function(userWidgetInstance, properties, tmpController) {
    if (null == properties || null == userWidgetInstance || null == tmpController) return;
    if (userWidgetInstance === tmpController) return;
    for (i = 0; i < properties.length; i++) {
        var oneProperty = properties[i];
        if (typeof oneProperty === "string") {
            oneProperty = {
                name: oneProperty,
                writable: true,
                enumerable: true,
                configurable: true
            }
        }
        var propName = oneProperty["name"];
        defineGetter(userWidgetInstance, propName, function(propertyName) {
            return function() {
                return tmpController[propertyName]
            }
        }(propName));
        if (null != oneProperty["writable"] && oneProperty["writable"]) {
            defineSetter(userWidgetInstance, propName, function(propertyName) {
                return function(val) {
                    tmpController[propertyName] = val
                }
            }(propName))
        }
    }
};
_kony.mvc.setFunctions = function(userWidgetInstance, lstAPIs, tmpController, isView) {
    if (null == lstAPIs || null == userWidgetInstance || null == tmpController) return;
    for (i = 0; i < lstAPIs.length; i++) {
        var propName = lstAPIs[i];
        if (isView) {
            userWidgetInstance[propName] = function(propertyName) {
                return function() {
                    tmpController[propertyName].apply(tmpController, arguments)
                }
            }(propName)
        } else {
            userWidgetInstance[propName] = tmpController[propName].bind(tmpController)
        }
    }
};
_kony.mvc.setEvents = function(userWidgetInstance, lstEvents, tmpController) {
    if (null == lstEvents || null == userWidgetInstance || null == tmpController) return;
    if (userWidgetInstance === tmpController) return;
    for (i = 0; i < lstEvents.length; i++) {
        var propName = lstEvents[i];
        defineGetter(userWidgetInstance, propName, function(propertyName) {
            return function() {
                return tmpController[propertyName]
            }
        }(propName));
        defineSetter(userWidgetInstance, propName, function(propertyName) {
            return function(val) {
                tmpController[propertyName] = val
            }
        }(propName))
    }
};
kony.mvc = kony.mvc || {};
kony.utils = kony.utils || {};
kony.mvc.Navigation = function() {
    function Navigation(formname, objModel) {
        var model = objModel;
        this.getModel = function() {
            if (null == model) {
                var controller = _kony.mvc.GetController(formFriendlyName, true);
                if (!controller) {
                    kony.print("########## No controller is found to navigate #####");
                    throw "Controller Not Found"
                }
                if (controller.getModel) model = controller.getModel()
            }
            return model
        };
        this.setModel = function(objModel) {
            model = objModel
        };
        var formFriendlyName = formname;
        this.navigate = function(param) {
            var syncLoad = kony.application.getApplicationBehavior("FormControllerSyncLoad");
            if (null == syncLoad || true == syncLoad) {
                var controller = _kony.mvc.GetController(formFriendlyName, true);
                if (!controller) {
                    kony.print("########## No controller is found to navigate for form " + formFriendlyName);
                    throw "Controller Not Found"
                }
                if (null == model) {
                    if (controller.getModel) model = controller.getModel.call(controller)
                }
                if (controller.setModel) controller.setModel.call(controller, model);
                controller.show.call(controller, param, false)
            } else {
                var len = _kony.mvc.formNavigateInProgress.length;
                if (len == 0) {
                    _kony.mvc.formNavigateCounter = 0
                } else {
                    _kony.mvc.formNavigateCounter++
                }
                _kony.mvc.formNavigateInProgress.push("Form" + _kony.mvc.formNavigateCounter);
                if (_kony.mvc.formNavigateCounter == 0) {
                    navigateCallback(formFriendlyName, param, _kony.mvc.formNavigateCounter)
                } else {
                    scheduleNavigateTimer(formFriendlyName, param, _kony.mvc.formNavigateCounter)
                }
            }
        };
        var scheduleNavigateTimer = function(formFriendlyName, param, navigateCounter) {
            kony.timer.schedule("Form" + navigateCounter, function() {
                if (_kony.mvc.formNavigateInProgress.indexOf("Form" + (navigateCounter - 1)) < 0) {
                    kony.timer.cancel("Form" + navigateCounter);
                    navigateCallback(formFriendlyName, param, navigateCounter)
                }
            }, .01, true)
        };
        var navigateCallback = function(formFriendlyName, param, navigateCounter) {
            _kony.mvc.GetControllerAsync(formFriendlyName, function(controller) {
                var index;
                if (!controller) {
                    kony.print("########## No controller is found to navigate for form " + formFriendlyName);
                    throw "Controller Not Found"
                }
                if (null == model) {
                    if (controller.getModel) model = controller.getModel.call(controller)
                }
                if (controller.setModel) controller.setModel.call(controller, model);
                controller.show.call(controller, param, false);
                index = _kony.mvc.formNavigateInProgress.indexOf("Form" + navigateCounter);
                _kony.mvc.formNavigateInProgress.splice(index, 1)
            }, function(err) {
                kony.print("Error: Unable to load Form Controller -" + err);
                throw "Controller or Form Not Found"
            })
        }
    }
    return Navigation
}();
kony.mvc = kony.mvc || {};
inheritsFrom = function(child, parent) {
    child.prototype = Object.create(parent.prototype)
};
kony.mvc.TemplateController = function(viewId1) {
    this.__initializeView = function(objController) {
        var retForm = null;
        var viewFileName = objController.viewId;
        if (Object.prototype.hasOwnProperty.call(this, "onCreateView")) {
            viewFileName = this["onCreateView"].apply(this, null);
            if (typeof viewFileName === "object" && Object.prototype.hasOwnProperty.call(viewFileName, "id")) {
                retForm = viewFileName
            } else {
                formCreateFunc = require(viewFileName);
                retForm = formCreateFunc(objController)
            }
        } else {
            formCreateFunc = require(viewFileName);
            retForm = formCreateFunc(objController)
        }
        retForm._konyControllerName = objController.Name;
        _kony.mvc.ctrlname2ControllerMap[retForm._konyControllerName] = objController;
        _kony.mvc.viewId2ControllerNameMap[retForm.id] = objController.Name;
        _kony.mvc.viewName2viewId[objController.viewId] = retForm.id;
        return retForm
    };
    kony.mvc.BaseController.call(this, viewId1);
    this.executeOnParent = function(callback, args) {
        this.view.executeOnParent(callback, args)
    };
    this.getCurrentView = function(childWidget) {
        while (childWidget.parent != null) {
            if (childWidget.id == this.view.id) break;
            childWidget = childWidget.parent
        }
        return childWidget
    }
};
inheritsFrom(kony.mvc.TemplateController, kony.mvc.BaseController);
kony.mvc.MasterController = function(uwName, viewId1, newID) {
    this.__initializeView = function(objController) {
        var retForm = null;
        var uwPath = this.userWidgetName.replace(/\./g, "/");
        var viewFileName = objController.viewId;
        if (Object.prototype.hasOwnProperty.call(this, "onCreateView")) {
            viewFileName = this["onCreateView"].apply(this, null);
            if (typeof viewFileName === "object" && Object.prototype.hasOwnProperty.call(viewFileName, "id")) {
                retForm = viewFileName
            } else {
                var formCreateFunc = kony.utils.LoadJSFile(uwPath + "/" + viewFileName);
                retForm = formCreateFunc(objController)
            }
        } else {
            var formCreateFunc = kony.utils.LoadJSFile(uwPath + "/" + viewFileName);
            retForm = formCreateFunc(objController)
        }
        retForm._konyControllerName = objController.Name;
        _kony.mvc.ctrlname2ControllerMap[retForm._konyControllerName] = objController;
        if (newID != null) {
            _kony.mvc.viewId2ControllerNameMap[newID] = objController.Name;
            _kony.mvc.viewName2viewId[objController.viewId] = newID
        } else {
            _kony.mvc.viewId2ControllerNameMap[retForm.id] = objController.Name;
            _kony.mvc.viewName2viewId[objController.viewId] = retForm.id
        }
        return retForm
    };
    this.userWidgetName = uwName;
    this.getCurrentView = function(childWidget) {
        while (childWidget.parent != null) {
            if (childWidget.id == this.view.id) break;
            childWidget = childWidget.parent
        }
        return childWidget
    };
    kony.mvc.BaseController.call(this, viewId1)
};
inheritsFrom(kony.mvc.MasterController, kony.mvc.BaseController);
_kony = _kony || {};
_kony.mvc = _kony.mvc || {};
if (kony.mvc == undefined) kony.mvc = {};
if (kony.mvc.registry == undefined) kony.mvc.registry = {};
_kony.mvc.registryMap = {};
kony.mvc.registry.add = function(friendlyName, formid, formCtrllrName, formCtrllrExtName) {
    if (friendlyName in _kony.mvc.registryMap) {
        kony.print("########## A form with friendly name " + friendlyName + " is already exists in registry.")
    } else {
        var formProps = {};
        formProps["name"] = formid;
        if (typeof formCtrllrName === "string") {
            formProps["controllerName"] = formCtrllrName;
            formProps["controllerExtName"] = formCtrllrExtName
        } else {
            for (var propName in formCtrllrName) {
                if (propName != "name") {
                    formProps[propName] = formCtrllrName[propName]
                }
            }
        }
        _kony.mvc.registryMap[friendlyName] = formProps
    }
};
kony.mvc.registry.remove = function(friendlyName) {
    if (friendlyName in _kony.mvc.registryMap) {
        delete _kony.mvc.registryMap[friendlyName]
    } else {
        kony.print("########## No form with friendly name " + friendlyName + " is found in registry")
    }
};
kony.mvc.registry.get = function(friendlyName) {
    if (friendlyName in _kony.mvc.registryMap) {
        var formProps = _kony.mvc.registryMap[friendlyName];
        if (null != formProps) {
            return formProps["name"]
        }
    } else {
        kony.print("########## No form with friendly name " + friendlyName + " is found in registry");
        return null
    }
};
kony.mvc.registry.getFriendlyName = function(formID) {
    for (var friendlyName in _kony.mvc.registryMap) {
        if (_kony.mvc.registryMap.hasOwnProperty(friendlyName)) {
            var formProps = _kony.mvc.registryMap[friendlyName];
            if (null != formProps) {
                if (formID == formProps["name"]) return friendlyName
            }
        }
    }
    return null
};
kony.mvc.registry.getControllerName = function(friendlyName) {
    if (friendlyName in _kony.mvc.registryMap) {
        var formProps = _kony.mvc.registryMap[friendlyName];
        if (null != formProps) {
            return formProps["controllerName"]
        }
    } else {
        kony.print("########## No form with friendly name " + friendlyName + " is found in registry");
        return null
    }
};
kony.mvc.registry.getControllerType = function(friendlyName) {
    if (friendlyName in _kony.mvc.registryMap) {
        var formProps = _kony.mvc.registryMap[friendlyName];
        if (null != formProps) {
            return formProps["controllerType"]
        }
    } else {
        kony.print("########## No form with friendly name " + friendlyName + " is found in registry");
        return null
    }
};
kony.mvc.registry.getControllerTypeFile = function(friendlyName) {
    if (friendlyName in _kony.mvc.registryMap) {
        var formProps = _kony.mvc.registryMap[friendlyName];
        if (null != formProps) {
            return formProps["controllerTypeFileName"]
        }
    } else {
        kony.print("########## No form with friendly name " + friendlyName + " is found in registry");
        return null
    }
};
kony.mvc.registry.getControllerExtName = function(friendlyName) {
    if (friendlyName in _kony.mvc.registryMap) {
        var formProps = _kony.mvc.registryMap[friendlyName];
        if (null != formProps) {
            return formProps["controllerExtName"]
        }
    } else {
        kony.print("########## No form with friendly name " + friendlyName + " is found in registry");
        return null
    }
};
kony = kony || {};
kony.model = kony.model || {};
kony.model.Util = kony.model.Util || {};
kony.model.Util.perfStats = [];
kony.model.Util.perftimecal = function(startTag, endTag, startTS, endTS) {
    if (kony.model.Util.isPerfTestReq === false) return;
    var formattedStartTS = startTS.getMinutes() + ":" + startTS.getSeconds() + ":" + startTS.getMilliseconds();
    var formattedEndTS = endTS.getMinutes() + ":" + endTS.getSeconds() + ":" + endTS.getMilliseconds();
    var starttime = startTS.getTime();
    var endtime = endTS.getTime();
    var res = endtime - starttime;
    var caliculatedTS = new Date;
    caliculatedTS.setTime(res);
    var formattedCalicutedTS = caliculatedTS.getUTCMinutes() + ":" + caliculatedTS.getUTCSeconds() + ":" + caliculatedTS.getUTCMilliseconds();
    kony.model.Util.perfStats.push(startTag + " " + formattedStartTS);
    kony.model.Util.perfStats.push(endTag + " " + formattedEndTS);
    kony.model.Util.perfStats.push("Total time taken is >> " + formattedCalicutedTS)
};
kony.model.Util.perlogout = function() {
    if (kony.model.Util.isPerfTestReq === false) return;
    for (var i = 0; i < kony.model.Util.perfStats.length; i++) {
        kony.model.log.info("[PERF][INFO] :" + kony.model.Util.perfStats[i])
    }
    kony.model.Util.perfStats = []
};
kony.model.Util.matchIgnoreCase = function(string1, string2) {
    if (string1 === null || string2 === null || string1 === undefined || string2 === undefined) {
        return false
    } else if (string1.toUpperCase() === string2.toUpperCase()) {
        return true
    } else {
        return false
    }
};
kony.model.Util.clone = function(src) {
    return clone(src);

    function clone(src) {
        function mixin(dest, source, copyFunc) {
            var name, s, i, empty = {};
            for (name in source) {
                s = source[name];
                if (!(name in dest) || dest[name] !== s && (!(name in empty) || empty[name] !== s)) {
                    dest[name] = copyFunc ? copyFunc(s) : s
                }
            }
            return dest
        }
        if (!src || typeof src != "object" || Object.prototype.toString.call(src) === "[object Function]") {
            return src
        }
        if (src.nodeType && "cloneNode" in src) {
            return src.cloneNode(true)
        }
        if (src instanceof Date) {
            return new Date(src.getTime())
        }
        if (src instanceof RegExp) {
            return new RegExp(src)
        }
        var r, i, l;
        if (src instanceof Array) {
            r = [];
            for (i = 0, l = src.length; i < l; ++i) {
                if (i in src) {
                    r.push(clone(src[i]))
                }
            }
        } else {
            r = src.constructor ? new src.constructor : {}
        }
        return mixin(r, src, clone)
    }
};
kony.model.Util.mergeJSONs = function(json1, json2) {
    if (!json1) return json2;
    if (!json2) return json1;
    var result = {};
    for (var key in json1) {
        result[key] = json1[key]
    }
    for (var key in json2)
        if (!result.hasOwnProperty(key)) result[key] = json2[key];
    return result
};
kony = kony || {};
kony.model = kony.model || {};
kony.model.log = kony.model.log || {};
kony.model.constants = kony.model.constants || {};
kony.model.constants.isForTesting = undefined;
kony.model.constants.TestConstants = {};
kony.model.constants["picklist"] = "picklist";
kony.model.constants["reference"] = "reference";
kony.model.constants["picklistmultiselect"] = "picklistmultiselect";
kony.model.constants["extendedfield"] = "extendedfield";
kony.model.constants["entityMetadataMap"] = {};
kony.model.constants["INTEGER_MIN_VALUE"] = -2147483648;
kony.model.constants["INTEGER_MAX_VALUE"] = 2147483647;
kony.model.constants.credStoreUsername = "username";
kony.model.constants.credStorePassword = "password";
kony.model.constants.credStoreOptions = "options";
kony.model.constants.credStoreIdentityService = "identityServiceName";
kony.model.constants.credStoreName = "credentials";
kony.model.constants.OperationType = {
    NO_FILTER: 1,
    FILTER_BY_PRIMARY_KEY: 2,
    ADD: 3
};
kony.model.constants.ValidationType = {
    CREATE: 1,
    UPDATE: 1
};
kony.model.constants.MatchType = {
    EQUALS: {
        value: "=",
        name: "EQUALS"
    },
    GREATER: {
        value: ">",
        name: "GREATER"
    },
    GREATEREQUAL: {
        value: ">=",
        name: "GREATEREQUAL"
    },
    LESS: {
        value: "<",
        name: "LESS"
    },
    LESSEQUAL: {
        value: "<=",
        name: "LESSEQUAL"
    },
    STARTSWITH: {
        value: "LIKE",
        name: "STARTSWITH"
    },
    CONTAINS: {
        value: "LIKE",
        name: "CONTAINS"
    },
    LIKE: {
        value: "LIKE",
        name: "LIKE"
    },
    ENDSWITH: {
        value: "LIKE",
        name: "ENDSWITH"
    },
    NOTEQUAL: {
        value: "<>",
        name: "NOTEQUAL"
    },
    ISNULL: {
        value: "IS NULL",
        name: "ISNULL"
    },
    ISNOTNULL: {
        value: "IS NOT NULL",
        name: "ISNOTNULL"
    }
};
kony = kony || {};
kony.model = kony.model || {};
kony.model.DataStore = function() {
    function DataStore() {
        var inMemoryData = {};
        this.getDataByKey = function(key) {
            if (inMemoryData.hasOwnProperty(key)) return inMemoryData[key]
        };
        this.setDataByKey = function(key, data) {
            inMemoryData[key] = data
        }
    }
    DataStore.prototype.storeData = function(key, data, inMemory) {
        if (inMemory == true) this.setDataByKey(key, data);
        else kony.store.setItem(key, data)
    };
    DataStore.prototype.getData = function(key, inMemory) {
        if (inMemory == true) return this.getDataByKey(key);
        else return kony.store.getItem(key)
    };
    return DataStore
}();
kony.model.AuthenticationManager = function() {
    function AuthenticationManager() {}
    AuthenticationManager.prototype.authenticate = function(params, successCallback, errorCallback) {
        try {
            var appFactoryInstance = kony.model.ApplicationContext.getFactorySharedInstance();
            var authParams = params["authParams"];
            var options = params["options"];
            var identityServiceName = params["identityServiceName"];
            var appLoginDetails = {
                authParams: authParams,
                options: options,
                identityServiceName: identityServiceName
            };
            var dataStoreObj = kony.model.ApplicationContext.getFactorySharedInstance().createDataStoreObject();
            dataStoreObj.storeData("UserCredentials", appLoginDetails, true);
            kony.model.ApplicationContext.setUserCredentialObj(dataStoreObj);
            authenticateService()
        } catch (e) {
            kony.model.log.error("Error while authentication: " + e.toString());
            var exception = appFactoryInstance.createExceptionObject(kony.model.ExceptionCode.CD_ERROR_OFFLINE_LOGIN_FAILURE, kony.model.ExceptionCode.MSG_ERROR_OFFLINE_LOGIN_FAILURE);
            errorCallback(exception)
        }

        function authenticateService() {
            kony.model.log.info("Getting SDK IdentityService");
            var identityClient = kony.sdk.getCurrentInstance().getIdentityService(identityServiceName);
            kony.model.ApplicationContext.setIdentityService(identityClient);
            kony.model.log.info("Making SDK login Call");
            identityClient.login(authParams, authSuccess, authError)
        }

        function authSuccess() {
            kony.model.log.info("SDK login Success");
            var isAppSyncEnabled = options["access"] === "offline" ? true : false;
            kony.model.ApplicationContext.setOnlineStatus(!isAppSyncEnabled);
            successCallback()
        }

        function authError(err) {
            kony.model.log.error("SDK login Failed " + err);
            var exception = appFactoryInstance.createExceptionObject(kony.model.ExceptionCode.CD_ERROR_LOGIN_FAILURE, kony.model.ExceptionCode.MSG_ERROR_LOGIN_FAILURE, err);
            errorCallback(exception)
        }
    };
    AuthenticationManager.prototype.saveUserDetails = function() {
        var storeObj = kony.model.ApplicationContext.getFactorySharedInstance().createDataStoreObject();
        var credentialObj = kony.model.ApplicationContext.getUserCredentialObj().getData("UserCredentials", true);
        var authParams = credentialObj["authParams"];
        var username = authParams["userid"];
        var options = credentialObj["options"];
        var identityServiceName = credentialObj["identityServiceName"];
        var credentials_store = {};
        credentials_store[kony.model.constants.credStoreUsername] = username;
        credentials_store[kony.model.constants.credStoreOptions] = options;
        credentials_store[kony.model.constants.credStoreIdentityService] = identityServiceName;
        storeObj.storeData(kony.model.constants.credStoreName, credentials_store)
    };
    AuthenticationManager.prototype.getSavedUserDetails = function() {
        var storeObj = kony.model.ApplicationContext.getFactorySharedInstance().createDataStoreObject();
        var credentialObj = storeObj.getData(kony.model.constants.credStoreName);
        return credentialObj
    };
    AuthenticationManager.prototype.execute = function(params, success, error) {
        this.authenticate(params, success, error)
    };
    return AuthenticationManager
}();
kony = kony || {};
kony.model = kony.model || {};
kony.model.AppFactory = function() {
    function AppFactory() {}
    AppFactory.prototype.createExceptionObject = function(errCode, errMsg, errorObj) {
        return new kony.model.Exception(errCode, errMsg, errorObj)
    };
    AppFactory.prototype.createSyncManagerObject = function() {
        return new kony.model.SyncManagerMF
    };
    AppFactory.prototype.createDataObject = function(data) {
        return new kony.model.Data(data)
    };
    AppFactory.prototype.createModelObject = function(context, entityName, serviceName, options) {
        if (entityName) {
            var modelObj;
            var modelHandler = kony.model[serviceName][entityName + "Model"];
            var modelExtensionHandler = kony.model[serviceName][entityName + "ModelExtension"];
            var metadataStore = context.getMetadataStore();
            var entityMetadata = metadataStore.getEntityMetadata(entityName, serviceName, options);
            if (entityMetadata) {
                var configOptions = {};
                configOptions["serviceName"] = serviceName;
                configOptions["options"] = options;
                modelObj = new modelHandler(context, entityMetadata, configOptions)
            } else {
                kony.model.log.error("error in entity controller factory, entity meta data for " + entityName + " undefined")
            }
            if (modelExtensionHandler !== undefined && typeof modelExtensionHandler === "function") {
                modelExtensionObj = new modelExtensionHandler(modelObj);
                modelObj.setControllerExtensionObject(modelExtensionObj)
            } else {
                kony.model.log.error("error in entity controller factory, model Extension Object for " + entityName + " is undefined")
            }
            return modelObj
        }
    };
    AppFactory.prototype.createViewObject = function(modelConfig, konyForm) {
        return new kony.model.View(modelConfig, konyForm)
    };
    AppFactory.prototype.createConfigClassObject = function(configObj) {
        return new kony.model.ConfigClass(configObj)
    };
    AppFactory.prototype.createAuthenticationManager = function() {
        var authManager = new kony.model.AuthenticationManager;
        if (kony.model.ApplicationContext) kony.model.ApplicationContext.setAuthManager(authManager);
        return authManager
    };
    AppFactory.prototype.getAuthManager = function() {
        if (kony.model.ApplicationContext && kony.model.ApplicationContext.getAuthManager()) return kony.model.ApplicationContext.getAuthManager();
        else return this.createAuthManager()
    };
    AppFactory.prototype.createDataStoreObject = function() {
        return new kony.model.DataStore
    };
    AppFactory.prototype.createAppInitManagerObject = function() {
        return new kony.model.AppInitManager
    };
    AppFactory.prototype.createMetadataServiceManagerObject = function() {
        return new kony.model.MetadataServiceManagerMF
    };
    AppFactory.prototype.createSegmentFieldObject = function(widgetid, fieldInfo) {
        return new kony.model.SegmentField(widgetid, fieldInfo)
    };
    AppFactory.prototype.createSearchInfoObject = function(widgetid, searchVal) {
        return new kony.model.searchInfo(widgetid, searchVal)
    };
    AppFactory.prototype.createSegmentWidgetConfigObject = function(widgetid, widgetConfig) {
        return new kony.model.SegmentWidgetConfig(widgetid, widgetConfig)
    };
    AppFactory.prototype.createWidgetConfigObject = function(widgetid, widgetConfig) {
        return new kony.model.widgetConfig(widgetid, widgetConfig)
    };
    AppFactory.prototype.createORMControllerObject = function(appContext, options) {
        return new kony.model.persistent.ORMControllerMFAPP(appContext, options)
    };
    AppFactory.prototype.createORMControllerOdataObject = function(applicationContext) {
        return new kony.model.persistent.ORMControllerMFAPPOData(applicationContext)
    };
    AppFactory.prototype.createORMControllerOdataExpandObject = function(applicationContext) {
        return new kony.model.persistent.ORMControllerMFAPPODataExpand(applicationContext)
    };
    AppFactory.prototype.createORMControllerSQLObject = function(applicationContext) {
        return new kony.model.persistent.ORMControllerMFAPPSQL(applicationContext)
    };
    AppFactory.prototype.createGroupWidgetsContextOffline = function(config, contextData) {
        return new kony.model.persistent.GroupWidgetsContextOffline(config, contextData)
    };
    AppFactory.prototype.createGroupWidgetsContextOnline = function(config, contextData) {
        return new kony.model.persistent.GroupWidgetsContextOnline(config, contextData)
    };
    AppFactory.prototype.createGroupWidgetsContextCommon = function(config, contextData) {
        return new kony.model.persistent.GroupWidgetsContextCommon(config, contextData)
    };
    AppFactory.prototype.createMetadataStore = function() {
        return new kony.model.MetadataStore
    };
    return AppFactory
}();
kony = kony || {};
kony.model = kony.model || {};
kony.model.ApplicationContext = function() {
    function ApplicationContext() {
        var storedCredentialObj;
        this.formObjects = undefined;
        this.metadataStore = undefined;
        this.configParams = undefined;
        this.modelObjects = {};
        this.authManager = undefined;
        this.metadataOptions = {};
        this.setCredentialObj = function(obj) {
            storedCredentialObj = obj
        };
        this.getCredentialObj = function() {
            return storedCredentialObj
        }
    }
    var appContextInstance = new ApplicationContext;
    var factoryObj;
    var IS_ONLINE = true;
    var identityService = undefined;
    var metaDataServiceManager = undefined;
    ApplicationContext.prototype.getAppInstance = function() {
        if (!appContextInstance) appContextInstance = new ApplicationContext;
        return appContextInstance
    };
    ApplicationContext.prototype.getFactorySharedInstance = function() {
        if (!factoryObj) factoryObj = new kony.model.AppFactory;
        return factoryObj
    };
    ApplicationContext.prototype.getMetadataServiceManager = function() {
        if (!metaDataServiceManager) {
            metaDataServiceManager = new kony.model.MetadataServiceManagerMF
        }
        return metaDataServiceManager
    };
    ApplicationContext.prototype.isAppsFirstLogin = function(params) {
        var username = params["username"];
        if (!username && params["authParams"]) {
            username = params["authParams"]["userid"]
        }
        var options = params["options"];
        var identityServiceName = params["identityServiceName"];
        var credStore = kony.store.getItem(kony.model.constants.credStoreName);
        if (credStore !== null && credStore !== undefined) {
            var storedOptions = credStore[kony.model.constants.credStoreOptions];
            var storedIdentityServiceName = credStore[kony.model.constants.credStoreIdentityService];
            var storedUsername = credStore[kony.model.constants.credStoreUsername];
            if (storedUsername !== undefined && storedOptions !== undefined && kony.model.Util.matchIgnoreCase(storedUsername, username) && kony.model.Util.matchIgnoreCase(storedOptions.access, options.access) && kony.model.Util.matchIgnoreCase(storedIdentityServiceName, identityServiceName)) {
                return false
            }
        }
        return true
    };
    ApplicationContext.prototype.appServicesLogin = function(params, loginSuccessCallback, loginErrorCallback) {
        try {
            var options = params["options"];
            var syncOptions = params["syncOptions"];
            var isOffline = options["access"] === "offline" ? true : false;
            var configParams = params["configParams"];
            var metadataOptions = params["metadataOptions"];
            var syncParams = {
                syncOptions: syncOptions
            };
            var authConfig = {};
            authConfig["authParams"] = params["authParams"];
            authConfig["options"] = params["options"];
            authConfig["identityServiceName"] = params["identityServiceName"];
            authConfig["showLoadingscreen"] = true;
            var appfactoryInstance = this.getFactorySharedInstance();
            if (configParams && configParams.constructor === Object && Object.keys(configParams).length > 0) {
                kony.model.ApplicationContext.setConfigParams(configParams)
            }
            var initManager = appfactoryInstance.createAppInitManagerObject();
            initManager.registerService("AuthenticationServiceManager", {
                object: appfactoryInstance.createAuthenticationManager(),
                params: authConfig
            });
            initManager.registerService("MetadataServiceManager", {
                object: appfactoryInstance.createMetadataServiceManagerObject(),
                params: {
                    options: options,
                    metadataOptions: metadataOptions
                }
            });
            if (isOffline) {
                initManager.registerService("SyncManager", {
                    object: appfactoryInstance.createSyncManagerObject(),
                    params: syncParams
                })
            }
            initManager.executeRegistedServices(loginSuccessCallback, loginErrorCallback)
        } catch (err) {
            var exception;
            kony.model.ApplicationContext.dismissLoadingScreen();
            kony.model.log.error("Error while authentication: " + err.toString());
            if (err !== undefined && err !== null) {
                exception = this.getFactorySharedInstance().createExceptionObject(kony.model.ExceptionCode.CD_ERROR_APP_INITIALIZATION_FAILED, kony.model.ExceptionCode.MSG_ERROR_APP_INITIALIZATION_FAILED)
            } else exception = this.getFactorySharedInstance().createExceptionObject(kony.model.ExceptionCode.CD_ERROR_APP_INITIALIZATION_FAILED, kony.model.ExceptionCode.MSG_ERROR_APP_INITIALIZATION_FAILED);
            loginErrorCallback(exception)
        }
    };
    ApplicationContext.prototype.getObjectService = function(options, objectServiceName) {
        try {
            var objectService;
            if (options.hasOwnProperty("mock") && options["mock"] == true) {
                kony.model.log.info("Initialising mocked object service");
                kony.model.log.info("Getting SDK ObjectService");
                objectService = kony.sdk.getCurrentInstance().getObjectService(objectServiceName, {
                    access: objectServiceName
                })
            } else {
                kony.model.log.info("Getting SDK ObjectService");
                objectService = kony.sdk.getCurrentInstance().getObjectService(objectServiceName, options)
            }
            return objectService
        } catch (error) {
            throw this.getFactorySharedInstance().createExceptionObject(kony.model.ExceptionCode.CD_ERROR_INITIALIZING_METADATA_PROVIDER, kony.model.ExceptionCode.MSG_ERROR_INITIALIZING_METADATA_PROVIDER + " -- " + error.message)
        }
    };
    ApplicationContext.prototype.logout = function(logoutSucCallback, logoutErrCallback) {
        var logoutTS = new Date;
        try {
            this.reset();
            var identityService = kony.model.ApplicationContext.getIdentityService();
            if (identityService) {
                identityService.logout(success, logoutErrCallback)
            } else {
                success()
            }

            function success() {
                var logoutEndTS = new Date;
                kony.model.Util.perftimecal("Logout >>", "Logout Ended >>", logoutTS, logoutEndTS);
                kony.model.Util.perlogout();
                logoutSucCallback()
            }
        } catch (err) {
            logoutErrCallback(this.getFactorySharedInstance().createExceptionObject(kony.model.ExceptionCode.CD_ERROR_FAILED_TO_LOGOUT, kony.model.ExceptionCode.MSG_ERROR_FAILED_TO_LOGOUT + " : " + err.toString(), err))
        }
    };
    ApplicationContext.prototype.showLoadingScreen = function(text) {
        var configParams = kony.model.ApplicationContext.getConfigParams();
        if (configParams && configParams["ShowLoadingScreenFunction"]) {
            var userDefinedLoadingScreen = configParams["ShowLoadingScreenFunction"];
            userDefinedLoadingScreen(text)
        } else {
            text = " " + text + " \n";
            kony.application.showLoadingScreen(null, text, constants.LOADING_SCREEN_POSITION_ONLY_CENTER, true, true, null)
        }
    };
    ApplicationContext.prototype.showSyncLoadingScreen = function(text) {
        var configParams = kony.model.ApplicationContext.getConfigParams();
        if (configParams && configParams["ShowSyncLoadingScreenFunction"]) {
            var userDefinedLoadingScreen = configParams["ShowSyncLoadingScreenFunction"];
            userDefinedLoadingScreen(text)
        } else {
            text = " " + text + " \n";
            kony.application.showLoadingScreen(null, text, constants.LOADING_SCREEN_POSITION_ONLY_CENTER, true, true, null)
        }
    };
    ApplicationContext.prototype.dismissLoadingScreen = function() {
        var configParams = kony.model.ApplicationContext.getConfigParams();
        if (configParams && configParams["DismissLoadingScreenFunction"]) {
            var userDefinedLoadingScreen = configParams["DismissLoadingScreenFunction"];
            userDefinedLoadingScreen()
        } else {
            kony.application.dismissLoadingScreen()
        }
    };
    ApplicationContext.prototype.dismissSyncLoadingScreen = function() {
        var configParams = kony.model.ApplicationContext.getConfigParams();
        if (configParams && configParams["DismissSyncLoadingScreenFunction"]) {
            var userDefinedLoadingScreen = configParams["DismissSyncLoadingScreenFunction"];
            userDefinedLoadingScreen()
        } else {
            kony.application.dismissLoadingScreen()
        }
    };
    ApplicationContext.prototype.getAuthManager = function() {
        return this.authManager
    };
    ApplicationContext.prototype.setAuthManager = function(authManager) {
        this.authManager = authManager
    };
    ApplicationContext.prototype.setUserCredentialObj = function(obj) {
        this.setCredentialObj(obj)
    };
    ApplicationContext.prototype.getUserCredentialObj = function() {
        return this.getCredentialObj()
    };
    ApplicationContext.prototype.setOnlineStatus = function(isOnline) {
        IS_ONLINE = isOnline === true ? true : false
    };
    ApplicationContext.prototype.isAppSyncEnabled = function() {
        return IS_ONLINE === false ? true : false
    };
    ApplicationContext.prototype.getMetadataStore = function() {
        if (!this.metadataStore) this.metadataStore = new kony.model.MetadataStore;
        return this.metadataStore
    };
    ApplicationContext.prototype.getSyncManager = function() {
        if (!this.syncManager) this.syncManager = this.getFactorySharedInstance().createSyncManagerObject();
        return this.syncManager
    };
    ApplicationContext.prototype.reset = function() {
        this.metadataStore = undefined;
        this.formObjects = undefined
    };
    ApplicationContext.prototype.setConfigParams = function(params) {
        if (this.configParams) {
            for (var key in params) this.configParams[key] = params[key]
        } else this.configParams = params
    };
    ApplicationContext.prototype.getConfigParams = function() {
        return this.configParams
    };
    ApplicationContext.prototype.getModel = function(entityName, serviceName, options) {
        var modelName = serviceName + "." + entityName;
        if (!this.modelObjects[modelName]) {
            this.modelObjects[modelName] = this.getFactorySharedInstance().createModelObject(this, entityName, serviceName, options)
        }
        this.modelObjects[modelName].setOptions(options);
        return this.modelObjects[modelName]
    };
    ApplicationContext.prototype.setIdentityService = function(identservice) {
        identityService = identservice
    };
    ApplicationContext.prototype.getIdentityService = function() {
        return identityService
    };
    ApplicationContext.prototype.login = function(params, loginSucCallback, loginErrCallback) {
        var authenticationManager = this.getFactorySharedInstance().createAuthenticationManager();
        authenticationManager.execute(params, loginSucCallback, loginErrCallback)
    };
    ApplicationContext.prototype.createModel = function(entityName, serviceName, options, metadataOptions, successCallback, errorCallback) {
        var model = serviceName + "." + entityName;
        var scopeObj = this;
        var modelObj;
        try {
            var modelHandler = kony.model[serviceName][entityName + "Model"];
            var modelExtensionHandler = kony.model[serviceName][entityName + "ModelExtension"];
            if (metadataOptions.getFromServer) {
                kony.model.ApplicationContext.getMetadataServiceManager().fetchForObject(serviceName, entityName, options, metadataOptions, metadataSuccCallback.bind(this), metadataErrCallback.bind(this))
            } else {
                if (scopeObj.modelObjects.hasOwnProperty(model)) {
                    scopeObj.modelObjects[model].setOptions(options);
                    successCallback(scopeObj.modelObjects[model])
                } else {
                    var metadataStore = scopeObj.getMetadataStore();
                    try {
                        if (!metadataStore.getEntityMetadata(entityName, serviceName, options)) {
                            kony.model.ApplicationContext.getMetadataServiceManager().fetchForObject(serviceName, entityName, options, metadataOptions, metadataSuccCallback, metadataErrCallback)
                        } else {
                            metadataSuccCallback()
                        }
                    } catch (err) {
                        kony.model.log.error("Error in fetching metadata for object service : " + objServiceName, err);
                        errorCallback.call(err)
                    }
                }
            }

            function metadataSuccCallback() {
                var metadataStore = scopeObj.getMetadataStore();
                var entityMetadata = metadataStore.getEntityMetadata(entityName, serviceName, options);
                if (entityMetadata) {
                    var configOptions = {};
                    configOptions["serviceName"] = serviceName;
                    configOptions["options"] = options;
                    modelObj = new modelHandler(scopeObj, entityMetadata, configOptions)
                } else {
                    kony.model.log.error("error in entity controller factory, entity meta data for " + entityName + " undefined")
                }
                if (modelExtensionHandler !== undefined && typeof modelExtensionHandler === "function") {
                    modelExtensionObj = new modelExtensionHandler(modelObj);
                    modelObj.setControllerExtensionObject(modelExtensionObj)
                } else {
                    kony.model.log.error("error in entity controller factory, model Extension Object for " + entityName + " is undefined")
                }
                scopeObj.modelObjects[model] = modelObj;
                scopeObj.modelObjects[model].setOptions(options);
                successCallback(scopeObj.modelObjects[model])
            }

            function metadataErrCallback(err) {
                kony.model.log.error("Error in fetching metadata for object service : " + objServiceName);
                errorCallback(err)
            }
        } catch (err) {
            errorCallback.call(err)
        }
    };
    ApplicationContext.prototype.initializeObjectServices = function(serviceEntityMap, successCallback, errorCallback) {
        var scopeObj = this;
        var indx1 = 0;
        var services = Object.keys(serviceEntityMap);
        initialiseServices();

        function initialiseServices() {
            if (indx1 >= services.length) {
                successCallback();
                return
            }
            var indx2 = 0;
            var entities;
            var options = serviceEntityMap[services[indx1]]["options"];
            var serviceName = services[indx1];
            var serviceMetadataOptions = serviceEntityMap[services[indx1]]["metadataOptions"];
            if (serviceEntityMap[services[indx1]]["entities"]) {
                entities = Object.keys(serviceEntityMap[services[indx1]]["entities"]);
                initialiseObject()
            } else {
                initialiseService()
            }

            function initialiseObject() {
                if (indx2 >= entities.length) {
                    metaSuccess();
                    return
                }
                var entityName = entities[indx2];
                var metadataOptions = serviceEntityMap[services[indx1]]["entities"][entities[indx2]]["metadataOptions"];
                if (!metadataOptions) metadataOptions = serviceMetadataOptions;
                if (metadataOptions.getFromServer) {
                    var model = serviceName + "." + entityName;
                    scopeObj.modelObjects[model] = null
                }
                kony.model.ApplicationContext.getMetadataServiceManager().fetchForObject(serviceName, entityName, options, metadataOptions, successCbk, errorCbk);

                function successCbk(data) {
                    indx2++;
                    initialiseObject()
                }

                function errorCbk(err) {
                    metaError(err)
                }
            }

            function initialiseService() {
                kony.model.ApplicationContext.getMetadataServiceManager().fetchForObjectService(serviceName, options, serviceMetadataOptions, metaSuccess, metaError)
            }

            function metaSuccess() {
                indx1++;
                initialiseServices()
            }

            function metaError(err) {
                errorCallback(err)
            }
        }
    };
    return appContextInstance
}();
kony = kony || {};
kony.model = kony.model || {};
kony.model.BaseModel = function() {
    function BaseModel(applicationContext, entityMetaData, configOptions) {
        var appContext = applicationContext;
        var entityMetadata = entityMetaData;
        var fields = entityMetaData.fields;
        var columnsMap = entityMetaData.columnsMap;
        var relatedEntities = entityMetaData.relatedEntities;
        var entityDefinition = undefined;
        var controllerExtensionObject = undefined;
        var serviceName = configOptions.serviceName;
        var options = configOptions.options;
        this.getServiceName = function() {
            return serviceName
        }, this.setServiceName = function(serviceNameVal) {
            serviceName = serviceNameVal
        }, this.getOptions = function() {
            return options
        }, this.setOptions = function(optionsObj) {
            options = optionsObj
        }, this.getObjectService = function() {
            return this.getApplicationContext().getObjectService(this.getOptions(), this.getServiceName())
        }, this.getControllerExtensionObject = function() {
            return controllerExtensionObject
        };
        this.setControllerExtensionObject = function(controllerExtension) {
            controllerExtensionObject = controllerExtension
        };
        this.getApplicationContext = function() {
            return appContext
        };
        this.getEntityMetaData = function() {
            return entityMetadata
        };
        this.getFields = function() {
            return fields
        };
        this.getColumnsMap = function() {
            return columnsMap
        };
        this.getRelatedEntities = function() {
            return relatedEntities
        };
        this.getAccessType = function() {
            if (options && options.hasOwnProperty("access") && options.access.toLowerCase() === "offline") return "offline";
            else return "online"
        };
        this.getDataObjectOnline = function(columnNames, dataModel) {
            var entityName = this.getValueForProperty("name");
            var self = this;
            var columnNamesString = "*";
            var primaryKeyColumns = this.getValueForProperty("primaryKey");
            for (var i = 0; i < primaryKeyColumns.length; i++) {
                if (columnNames.indexOf(primaryKeyColumns[i]) === -1) {
                    columnNames.push(primaryKeyColumns[i])
                }
            }
            for (var column in columnNames) {
                if (columnNamesString === "*") {
                    columnNamesString = columnNames[column]
                } else {
                    columnNamesString = columnNamesString + "," + columnNames[column]
                }
            }
            var queryStr = "$select=" + columnNamesString;
            kony.model.log.info("columnNamesString : " + columnNamesString);
            if (dataModel) {
                kony.model.log.info("DataModel object --\x3e ", dataModel);
                var primaryKeyValueMap = dataModel.getPrimaryKeyValueMap();
                if (primaryKeyValueMap) {
                    queryStr = queryStr.concat("&$filter=");
                    var primaryKeyValuesArr = Object.keys(primaryKeyValueMap);
                    for (var j = 1; j < primaryKeyValuesArr.length; j++) {
                        queryStr = queryStr.concat(primaryKeyValuesArr[j - 1] + " eq " + primaryKeyValueMap[primaryKeyValuesArr[j - 1]] + " and ")
                    }
                    queryStr = queryStr.concat(primaryKeyValuesArr[j - 1] + " eq " + primaryKeyValueMap[primaryKeyValuesArr[j - 1]])
                }
            }
            var dataObject = new kony.sdk.dto.DataObject(self.getValueForProperty("name"));
            dataObject.setOdataUrl(queryStr);
            return dataObject
        };
        this.getDataObjectOffline = function(columnNames, dataModel) {
            var self = this;
            var entityName = this.getValueForProperty("name");
            var tblDto = new kony.sdk.dto.Table(entityName, entityName, false);
            var selQuery = new kony.sdk.dto.SelectQuery(self.getServiceName(), tblDto);
            var primaryKeyColumns = this.getValueForProperty("primaryKey");
            for (var i = 0; i < primaryKeyColumns.length; i++) {
                if (columnNames.indexOf(primaryKeyColumns[i]) === -1) {
                    columnNames.push(primaryKeyColumns[i])
                }
            }
            for (var index in columnNames) {
                var colObj = new kony.sdk.dto.Column(tblDto, columnNames[index]);
                selQuery.addColumn(colObj)
            }
            if (dataModel) {
                var primaryKeyValueMap = dataModel.getPrimaryKeyValueMap();
                if (primaryKeyValueMap) {
                    var primaryKeyValuesArr = Object.keys(primaryKeyValueMap);
                    for (var j = 0; j < primaryKeyValuesArr.length; j++) {
                        var colObj = new kony.sdk.dto.Column(tblDto, primaryKeyValuesArr[j]);
                        var crtObj = new kony.sdk.dto.Match(colObj, kony.sdk.constants.MatchType.EQUALS, primaryKeyValueMap[primaryKeyValuesArr[j]]);
                        selQuery.addCriteria(crtObj)
                    }
                }
            }
            var dataObject = new kony.sdk.dto.DataObject(self.getValueForProperty("name"));
            dataObject.setSelectQueryObject(selQuery);
            return dataObject
        };
        this.getRequestOptions = function(options) {
            if (options && !options.hasOwnProperty("dataObject")) {
                var newOptions = {};
                newOptions["dataObject"] = options;
                return newOptions
            } else {
                return options
            }
        }
    }
    BaseModel.prototype.getValueForColumnProperty = function(columnName, key) {
        var propertyVal = null;
        if (columnName && key) {
            propertyVal = this.getColumnInfo(columnName)[key]
        }
        return propertyVal
    };
    BaseModel.prototype.getColumnNames = function() {
        var columnNames = [];
        for (var key in this.getColumnsMap()) {
            columnNames.push(key)
        }
        return columnNames
    };
    BaseModel.prototype.getValueForProperty = function(propertyName) {
        return this.getEntityMetaData()[propertyName]
    };
    BaseModel.prototype.getColumnInfo = function(columnName) {
        return this.getColumnsMap()[columnName]
    };
    BaseModel.prototype.getFieldPickListValues = function(columnName) {
        return this.getColumnInfo(columnName)["pickListValues"]
    };
    BaseModel.prototype.getChildRelationshipList = function(successCallback, errorCallback) {
        var scopeObj = this;
        var childRelationships = this.getValueForProperty("relationshipList");
        successCallback.call(scopeObj, childRelationships)
    };
    BaseModel.prototype.getRelationshipForChildEntityName = function(childEntityName, successCallback, errorCallback) {
        var scopeObj = this;
        var relatedEntities = this.getValueForProperty("relatedEntities");
        if (relatedEntities) {
            successCallback.call(scopeObj, relatedEntities[childEntityName])
        } else {
            errorCallback.call(scopeObj, relatedEntities)
        }
    };
    BaseModel.prototype.fetchDataForColumns = function(columnNames, onSuccess, onError, dataModel) {
        try {
            var self = this;
            var dataObject;
            if (this.getAccessType() === "offline") dataObject = this.getDataObjectOffline(columnNames, dataModel);
            else dataObject = this.getDataObjectOnline(columnNames, dataModel);
            this.fetch(dataObject, success, error)
        } catch (err) {
            kony.model.log.error("Error fetching data for columns in entity controller");
            var exception;
            exception = self.getApplicationContext().getFactorySharedInstance().createExceptionObject(kony.model.ExceptionCode.CD_ERROR_FETCHING_DATA_FOR_COLUMNS, kony.model.ExceptionCode.MSG_ERROR_FETCHING_DATA_FOR_COLUMNS, err);
            onError(exception)
        }

        function success(response) {
            kony.model.log.info("Success fetching data for columns in entity controller");
            onSuccess(response)
        }

        function error(err) {
            kony.model.log.error("Error fetching data for columns in entity controller");
            var exception = self.getApplicationContext().getFactorySharedInstance().createExceptionObject(kony.model.ExceptionCode.CD_ERROR_FETCHING_DATA_FOR_COLUMNS, kony.model.ExceptionCode.MSG_ERROR_FETCHING_DATA_FOR_COLUMNS, err);
            onError(exception)
        }
    };
    BaseModel.prototype.fetch = function(options, onSuccess, onError) {
        this.fetchResponseWithRecords(options, success, onError);

        function success(response) {
            response = response["records"];
            onSuccess(response)
        }
    };
    BaseModel.prototype.create = function(options, onSuccess, onError) {
        try {
            var scopeObj = this;
            var requestOptions = scopeObj.getRequestOptions(options);
            if (false === this.validate(requestOptions["dataObject"], kony.model.constants.ValidationType.CREATE)) {
                var exception = this.getApplicationContext().getFactorySharedInstance().createExceptionObject(kony.model.ExceptionCode.CD_ERROR_VALIDATION_CREATE, kony.model.ExceptionCode.MSG_ERROR_VALIDATION_CREATE);
                throw exception
            }
            var createInEntityCntrlTS = new Date;
            kony.model.log.info("Making SDK create Call");
            scopeObj.getObjectService().create(requestOptions, success, error)
        } catch (e) {
            var exception = scopeObj.getApplicationContext().getFactorySharedInstance().createExceptionObject(kony.model.ExceptionCode.CD_ERROR_CREATE, kony.model.ExceptionCode.MSG_ERROR_CREATE, e);
            onError(exception)
        }

        function success(response) {
            kony.model.log.info("SDK create Success");
            var createEndInEntityCntrlTS = new Date;
            kony.model.Util.perftimecal("Create in entity controller >>", "Create in entity controller done >>", createInEntityCntrlTS, createEndInEntityCntrlTS);
            onSuccess(response)
        }

        function error(e) {
            kony.model.log.error("SDK create Failed " + e);
            var exception = scopeObj.getApplicationContext().getFactorySharedInstance().createExceptionObject(kony.model.ExceptionCode.CD_ERROR_CREATE, kony.model.ExceptionCode.MSG_ERROR_CREATE, e);
            onError(exception)
        }
    };
    BaseModel.prototype.update = function(options, onSuccess, onError) {
        var updateInEntityCntrlTS = new Date;
        try {
            var scopeObj = this;
            var requestOptions = scopeObj.getRequestOptions(options);
            if (false === this.validate(requestOptions["dataObject"], kony.model.constants.ValidationType.UPDATE)) {
                var exception = this.getApplicationContext().getFactorySharedInstance().createExceptionObject(kony.model.ExceptionCode.CD_ERROR_VALIDATION_UPDATE, kony.model.ExceptionCode.MSG_ERROR_VALIDATION_UPDATE);
                throw exception
            }
            if (this.getAccessType() === "offline") {
                kony.model.log.info("Making SDK update Call");
                scopeObj.getObjectService().update(requestOptions, success, error)
            } else {
                kony.model.log.info("Making SDK partialUpdate Call");
                scopeObj.getObjectService().partialUpdate(requestOptions, success, error)
            }
        } catch (err) {
            var exception = scopeObj.getApplicationContext().getFactorySharedInstance().createExceptionObject(kony.model.ExceptionCode.CD_ERROR_UPDATE, kony.model.ExceptionCode.MSG_ERROR_UPDATE, err);
            onError(exception)
        }

        function success(response) {
            kony.model.log.info("SDK update Success");
            var updateEndInEntityCntrlTS = new Date;
            kony.model.Util.perftimecal("Update in entity controller >>", "Update in entity controller done >>", updateInEntityCntrlTS, updateEndInEntityCntrlTS);
            onSuccess(response)
        }

        function error(err) {
            kony.model.log.error("SDK update Failed " + err);
            var exception = scopeObj.getApplicationContext().getFactorySharedInstance().createExceptionObject(kony.model.ExceptionCode.CD_ERROR_UPDATE, kony.model.ExceptionCode.MSG_ERROR_UPDATE, err);
            onError(exception)
        }
    };
    BaseModel.prototype.partialUpdate = function(options, onSuccess, onError) {
        var scopeObj = this;
        scopeObj.update(options, onSuccess, onError)
    };
    BaseModel.prototype.completeUpdate = function(options, onSuccess, onError) {
        var updateInEntityCntrlTS = new Date;
        try {
            var scopeObj = this;
            var requestOptions = scopeObj.getRequestOptions(options);
            if (false === this.validate(requestOptions["dataObject"], kony.model.constants.ValidationType.UPDATE)) {
                var exception = this.getApplicationContext().getFactorySharedInstance().createExceptionObject(kony.model.ExceptionCode.CD_ERROR_VALIDATION_UPDATE, kony.model.ExceptionCode.MSG_ERROR_VALIDATION_UPDATE);
                throw exception
            }
            kony.model.log.info("Making SDK update Call");
            scopeObj.getObjectService().update(requestOptions, success, error)
        } catch (err) {
            var exception = scopeObj.getApplicationContext().getFactorySharedInstance().createExceptionObject(kony.model.ExceptionCode.CD_ERROR_UPDATE, kony.model.ExceptionCode.MSG_ERROR_UPDATE, err);
            onError(exception)
        }

        function success(response) {
            kony.model.log.info("SDK update Success");
            var updateEndInEntityCntrlTS = new Date;
            kony.model.Util.perftimecal("Update in entity controller >>", "Update in entity controller done >>", updateInEntityCntrlTS, updateEndInEntityCntrlTS);
            onSuccess(response)
        }

        function error(err) {
            kony.model.log.error("SDK update Failed " + err);
            var exception = scopeObj.getApplicationContext().getFactorySharedInstance().createExceptionObject(kony.model.ExceptionCode.CD_ERROR_UPDATE, kony.model.ExceptionCode.MSG_ERROR_UPDATE, err);
            onError(exception)
        }
    };
    BaseModel.prototype.remove = function(options, onSuccess, onError) {
        try {
            var scopeObj = this;
            var removeInEntityCntrlTS = new Date;
            var requestOptions = scopeObj.getRequestOptions(options);
            kony.model.log.info("Making SDK deleteRecord Call");
            scopeObj.getObjectService().deleteRecord(requestOptions, success, error)
        } catch (err) {
            var exception = scopeObj.getApplicationContext().getFactorySharedInstance().createExceptionObject(kony.model.ExceptionCode.CD_ERROR_DELETE, kony.model.ExceptionCode.MSG_ERROR_DELETE, err);
            onError(exception)
        }

        function success(response) {
            kony.model.log.info("SDK deleteRecord Success");
            var removeEndInEntityCntrlTS = new Date;
            kony.model.Util.perftimecal("Remove in entity controller >>", "Remove in entity controller done >>", removeInEntityCntrlTS, removeEndInEntityCntrlTS);
            onSuccess(response)
        }

        function error(err) {
            kony.model.log.error("SDK deleteRecord Failed " + err);
            var exception = scopeObj.getApplicationContext().getFactorySharedInstance().createExceptionObject(kony.model.ExceptionCode.CD_ERROR_DELETE, kony.model.ExceptionCode.MSG_ERROR_DELETE, err);
            onError(exception)
        }
    };
    BaseModel.prototype.removeByPrimaryKey = function(primaryKeyValueMap, onSuccess, onError) {
        try {
            var scopeObj = this;
            var entityName = this.getValueForProperty("name");
            var dataObject = new kony.sdk.dto.DataObject(scopeObj.getValueForProperty("name"));
            dataObject.setRecord(primaryKeyValueMap);
            this.remove(dataObject, success, error)
        } catch (err) {
            var exception = scopeObj.getApplicationContext().getFactorySharedInstance().createExceptionObject(kony.model.ExceptionCode.CD_ERROR_DELETE_BY_PRIMARY_KEY, kony.model.ExceptionCode.MSG_ERROR_DELETE_BY_PRIMARY_KEY, err);
            onError(exception)
        }

        function success(response) {
            kony.model.log.info("Record with primaryFieldValue - " + primaryKeyValueMap + " - of entity '" + entityName + "' deleted successfully");
            onSuccess(response)
        }

        function error(err) {
            var exception = scopeObj.getApplicationContext().getFactorySharedInstance().createExceptionObject(kony.model.ExceptionCode.CD_ERROR_DELETE_BY_PRIMARY_KEY, kony.model.ExceptionCode.MSG_ERROR_DELETE_BY_PRIMARY_KEY, err);
            onError(exception)
        }
    };
    BaseModel.prototype.executeSelectQuery = function(query, succCallback, errCallback) {
        try {
            var self = this;
            kony.model.log.info("Making SDK executeSelectQuery Call");
            this.getObjectService().executeSelectQuery(query, success, error);

            function success(response) {
                kony.model.log.info("SDK executeSelectQuery Call Success");
                var primaryKeyColumns = self.getValueForProperty("primaryKey");
                if (response && response.length > 0) {
                    for (var key in response) {
                        var primaryKeyValueMap = {};
                        for (var i = 0; i < primaryKeyColumns.length; i++) {
                            if (response[key].hasOwnProperty(primaryKeyColumns[i])) {
                                primaryKeyValueMap[primaryKeyColumns[i]] = response[key][primaryKeyColumns[i]]
                            }
                        }
                        response[key]["primaryKeyValueMap"] = primaryKeyValueMap
                    }
                }
                succCallback(response)
            }

            function error(err) {
                kony.model.log.error("SDK executeSelectQuery Call Failed " + err);
                var exception = self.getApplicationContext().getFactorySharedInstance().createExceptionObject(-1, "Error executing executeSelectQuery", err);
                errCallback(exception)
            }
        } catch (err) {
            kony.model.log.error("Error fetching data for columns in entity controller");
            var exception = self.getApplicationContext().getFactorySharedInstance().createExceptionObject(-1, "Error executing executeSelectQuery", err);
            errCallback(exception)
        }
    };
    BaseModel.prototype.fetchResponse = function(options, onSuccess, onError) {
        var fetchInEntityCntrlTS = new Date;
        try {
            var self = this;
            var requestOptions = self.getRequestOptions(options);
            kony.model.log.info("Making SDK fetch Call");
            self.getObjectService().fetch(requestOptions, success, error)
        } catch (e) {
            var exception;
            if (e instanceof kony.model.Exception) exception = self.getApplicationContext().getFactorySharedInstance().createExceptionObject(e.code, e.message, e);
            else exception = self.getApplicationContext().getFactorySharedInstance().createExceptionObject(kony.model.ExceptionCode.CD_ERROR_FETCH, kony.model.ExceptionCode.MSG_ERROR_FETCH, e);
            onError(exception)
        }

        function success(response) {
            kony.model.log.info("SDK fetch Success");
            var records = response["records"];
            var primaryKeyColumns = self.getValueForProperty("primaryKey");
            if (records && records.length > 0) {
                for (var key in records) {
                    var primaryKeyValueMap = {};
                    for (var i = 0; i < primaryKeyColumns.length; i++) {
                        if (records[key].hasOwnProperty(primaryKeyColumns[i])) {
                            primaryKeyValueMap[primaryKeyColumns[i]] = records[key][primaryKeyColumns[i]]
                        }
                    }
                    records[key]["primaryKeyValueMap"] = primaryKeyValueMap
                }
            }
            var fetchEndInEntityCntrlTS = new Date;
            kony.model.Util.perftimecal("Fetch in entity controller >>", "Fetch in entity controller done >>", fetchInEntityCntrlTS, fetchEndInEntityCntrlTS);
            onSuccess(response)
        }

        function error(err) {
            kony.model.log.error("Error in fetching data for given query", err);
            var exception = self.getApplicationContext().getFactorySharedInstance().createExceptionObject(kony.model.ExceptionCode.CD_ERROR_FETCH, kony.model.ExceptionCode.MSG_ERROR_FETCH, err);
            onError(exception)
        }
    };
    BaseModel.prototype.fetchResponseWithRecords = function(options, onSuccess, onError) {
        var self = this;
        this.fetchResponse(options, success, onError);

        function success(response) {
            if (!response.hasOwnProperty("records")) {
                for (var key in response) {
                    if (response[key] instanceof Array) {
                        response["records"] = response[key];
                        break
                    }
                }
                var records = response["records"];
                var primaryKeyColumns = self.getValueForProperty("primaryKey");
                if (records && records.length > 0) {
                    for (var key in records) {
                        var primaryKeyValueMap = {};
                        for (var i = 0; i < primaryKeyColumns.length; i++) {
                            if (records[key].hasOwnProperty(primaryKeyColumns[i])) {
                                primaryKeyValueMap[primaryKeyColumns[i]] = records[key][primaryKeyColumns[i]]
                            }
                        }
                        records[key]["primaryKeyValueMap"] = primaryKeyValueMap
                    }
                }
            }
            onSuccess(response)
        }
    };
    BaseModel.prototype.customVerb = function(verbName, options, success, error) {
        var customVerbStartInEntityCtrlTS = new Date;
        try {
            var self = this;
            var requestOptions = self.getRequestOptions(options);
            kony.model.log.info("Making SDK custom verb Call");
            this.getApplicationContext().getObjectService({
                access: "online"
            }, this.getServiceName()).customVerb(verbName, options, onSuccess, onError)
        } catch (e) {
            var exception;
            if (e instanceof kony.model.Exception) exception = self.getApplicationContext().getFactorySharedInstance().createExceptionObject(e.code, e.message, e);
            else exception = self.getApplicationContext().getFactorySharedInstance().createExceptionObject(kony.model.ExceptionCode.CD_ERROR_CUSTOMVERB, kony.model.ExceptionCode.MSG_ERROR_CUSTOMVERB, e);
            onError(exception)
        }

        function onSuccess(response) {
            kony.model.log.info("SDK fetch Success");
            var records = response["records"];
            var primaryKeyColumns = self.getValueForProperty("primaryKey");
            if (records && records.length > 0) {
                for (var key in records) {
                    var primaryKeyValueMap = {};
                    for (var i = 0; i < primaryKeyColumns.length; i++) {
                        if (records[key].hasOwnProperty(primaryKeyColumns[i])) {
                            primaryKeyValueMap[primaryKeyColumns[i]] = records[key][primaryKeyColumns[i]]
                        }
                    }
                    records[key]["primaryKeyValueMap"] = primaryKeyValueMap
                }
            }
            var customVerbEndInEntityCtrlTS = new Date;
            kony.model.Util.perftimecal("Customverb call in entity controller >>", "CustomVerb call in entity controller done >>", customVerbStartInEntityCtrlTS, customVerbEndInEntityCtrlTS);
            success(response)
        }

        function onError(err) {
            kony.model.log.error("Error in custom verb call", err);
            var exception = self.getApplicationContext().getFactorySharedInstance().createExceptionObject(kony.model.ExceptionCode.CD_ERROR_CUSTOMVERB, kony.model.ExceptionCode.MSG_ERROR_CUSTOMVERB, err);
            error(exception)
        }
    };
    BaseModel.prototype.validate = function(dataObject, validationType) {
        return this.getControllerExtensionObject().validate(dataObject, validationType)
    };
    return BaseModel
}();
kony = kony || {};
kony.model = kony.model || {};
kony.model.MetadataServiceManagerMF = function() {
    function MetadataServiceManagerMF() {}
    MetadataServiceManagerMF.prototype.fetch = function(options, serviceName, metadataOptions, successcallback, errorCallback) {
        var objectService = kony.model.ApplicationContext.getObjectService(options, serviceName);
        kony.model.log.info("Making SDK metadata Call");
        objectService.getMetadataOfAllObjects(metadataOptions, successcallback, errorCallback)
    };
    MetadataServiceManagerMF.prototype.apply = function(response, options, serviceName, successcallback, errorCallback) {
        var entityMetaDataMap = {};
        for (var objectName in response) {
            var metadata = response[objectName];
            entityMetaDataMap[objectName] = metadata;
            var fields = metadata.columns;
            entityMetaDataMap[objectName]["columnsMap"] = {};
            for (var j = 0; j < fields.length; j++) {
                var field = fields[j];
                entityMetaDataMap[objectName]["columnsMap"][field.name] = field
            }
            setRelatedEntities(metadata);
            if (kony.model.ApplicationContext) {
                var metadataStore = kony.model.ApplicationContext.getMetadataStore();
                metadataStore.setEntityMetadata(entityMetaDataMap[objectName], objectName, serviceName, options)
            }
        }

        function setRelatedEntities(metadata) {
            var relationList = metadata["relationshipList"];
            var relatedEntities = {};
            for (var idx in relationList) {
                var relation = relationList[idx];
                var relatedEntity = {};
                relatedEntity["relationshipFields"] = relation.relationshipFields;
                relatedEntity["relationshipType"] = relation.relationshipType;
                relatedEntity["relationshipName"] = relation.relationshipName;
                relatedEntities[relation.relatedEntity] = relatedEntity
            }
            metadata["relatedEntities"] = relatedEntities
        }
        var result = {};
        result["dataModel"] = entityMetaDataMap;
        if (successcallback) successcallback(result)
    };
    MetadataServiceManagerMF.prototype.fetchForAllObjectServices = function(options, metadataOptions, success, error) {
        var self = this;

        function getAllObjectServicesFromSdk() {
            var objectServicesMapFromSdk = kony.model.Util.clone(kony.sdk.getCurrentInstance().objectsvc);
            if (kony.sdk.registeredobjsvcs)
                if (objectServicesMapFromSdk) objectServicesMapFromSdk = kony.model.Util.mergeJSONs(objectServicesMapFromSdk, kony.sdk.registeredobjsvcs);
                else objectServicesMapFromSdk = kony.sdk.registeredobjsvcs;
            var objectServicesNames = [];
            for (var key in objectServicesMapFromSdk) {
                if (key.indexOf("_metadata") === -1) {
                    objectServicesNames.push(key)
                }
            }
            return objectServicesNames
        }
        var objectServicesList = getAllObjectServicesFromSdk();
        var osvIndx = 0;
        self.fetch(options, objectServicesList[osvIndx], metadataOptions, successCbk, errorCbk);

        function successCbk(response) {
            kony.model.log.info("SDK metadata Call Success for ObjectService " + objectServicesList[osvIndx]);
            self.apply(response, options, objectServicesList[osvIndx]);
            osvIndx++;
            if (osvIndx >= objectServicesList.length) {
                success(response);
                return
            }
            self.fetch(options, objectServicesList[osvIndx], metadataOptions, successCbk, errorCbk)
        }

        function errorCbk(err) {
            kony.model.log.error("error fetching metadata" + JSON.stringify(err));
            error(err)
        }
    };
    MetadataServiceManagerMF.prototype.fetchForObjectService = function(serviceName, options, metadataOptions, success, error) {
        var self = this;
        self.fetch(options, serviceName, metadataOptions, successCbk, errorCbk);

        function successCbk(response) {
            self.apply(response, options, serviceName);
            success(response)
        }

        function errorCbk(err) {
            kony.model.log.error("error fetching metadata" + JSON.stringify(err));
            error(err)
        }
    };
    MetadataServiceManagerMF.prototype.fetchForObject = function(serviceName, entityName, options, metadataOptions, success, error) {
        var self = this;
        var objectService = kony.model.ApplicationContext.getObjectService(options, serviceName);
        kony.model.log.info("Making SDK metadata Call");
        objectService.getMetadataOfObject(entityName, metadataOptions, successCbk, errorCbk);

        function successCbk(response) {
            kony.model.log.info("SDK metadata Call Success for Object " + entityName);
            var res = {};
            res[entityName] = response;
            self.apply(res, options, serviceName);
            success(response)
        }

        function errorCbk(err) {
            kony.model.log.error("error fetching metadata" + JSON.stringify(err));
            error(err)
        }
    };
    MetadataServiceManagerMF.prototype.execute = function(params, success, error) {
        var scopeObj = this;
        this.fetchForAllObjectServices(params["options"], params["metadataOptions"], fetchSuccess, fetchError);

        function fetchSuccess(response) {
            success(response);
            return
        }

        function fetchError(err) {
            error(err);
            return
        }
    };
    return MetadataServiceManagerMF
}();
kony = kony || {};
kony.model = kony.model || {};
kony.model.MetadataStore = function() {
    function MetadataStore() {
        var serviceMetadata = {};
        this.getServiceMetadata = function(serviceName, options) {
            return serviceMetadata[serviceName]
        };
        this.setServiceMetadata = function(metadata, serviceName, options) {
            serviceMetadata[serviceName] = metadata
        }
    }
    MetadataStore.prototype.getEntityMetadata = function(entity, serviceName, options) {
        var svcMetadata = this.getServiceMetadata(serviceName, options);
        if (svcMetadata && svcMetadata[entity]) return svcMetadata[entity]
    };
    MetadataStore.prototype.setEntityMetadata = function(metadata, entity, serviceName, options) {
        var svcMetadata = this.getServiceMetadata(serviceName, options);
        if (!svcMetadata) svcMetadata = {};
        svcMetadata[entity] = metadata;
        this.setServiceMetadata(svcMetadata, serviceName, options)
    };
    return MetadataStore
}();
kony = kony || {};
kony.model = kony.model || {};
kony.model.log = kony.model.log || {};
kony.model.Util = kony.model.Util || {};
if (typeof kony.model.log === "undefined") {
    kony.model.log = {}
}
kony.model.log.NONE = {
    value: 0,
    name: "none",
    code: "NONE"
};
kony.model.log.FATAL = {
    value: 1,
    name: "fatal",
    code: "FATAL"
};
kony.model.log.ERROR = {
    value: 2,
    name: "error",
    code: "ERROR"
};
kony.model.log.WARN = {
    value: 3,
    name: "warn",
    code: "WARN"
};
kony.model.log.INFO = {
    value: 4,
    name: "info",
    code: "INFO"
};
kony.model.log.DEBUG = {
    value: 5,
    name: "debug",
    code: "DEBUG"
};
kony.model.log.TRACE = {
    value: 6,
    name: "trace",
    code: "TRACE"
};
kony.model.currentLogLevel = kony.model.log.INFO;
kony.model.log.trace = function(msg, params) {
    kony.model.logger(kony.model.log.TRACE, "MVVM", msg, params)
};
kony.model.log.debug = function(msg, params) {
    kony.model.logger(kony.model.log.DEBUG, "MVVM", msg, params)
};
kony.model.log.info = function(msg, params) {
    kony.model.logger(kony.model.log.INFO, "MVVM", msg, params)
};
kony.model.log.warn = function(msg, params) {
    kony.model.logger(kony.model.log.WARN, "MVVM", msg, params)
};
kony.model.log.error = function(msg, params) {
    kony.model.logger(kony.model.log.ERROR, "MVVM", msg, params)
};
kony.model.log.fatal = function(msg, params) {
    kony.model.logger(kony.model.log.FATAL, "MVVM", msg, params)
};
kony.model.log.setLogLevel = function(level, logSuccessCallback, logFailureCallback) {
    switch (level) {
        case kony.model.log.NONE:
            kony.model.currentLogLevel = kony.model.log.NONE;
            break;
        case kony.model.log.TRACE:
            kony.model.currentLogLevel = kony.model.log.TRACE;
            break;
        case kony.model.log.INFO:
            kony.model.currentLogLevel = kony.model.log.INFO;
            break;
        case kony.model.log.WARN:
            kony.model.currentLogLevel = kony.model.log.WARN;
            break;
        case kony.model.log.ERROR:
            kony.model.currentLogLevel = kony.model.log.ERROR;
            break;
        case kony.model.log.FATAL:
            kony.model.currentLogLevel = kony.model.log.FATAL;
            break;
        case kony.model.log.DEBUG:
            kony.model.currentLogLevel = kony.model.log.DEBUG;
            break;
        default:
            kony.model.log.error("Failed in setting log level " + level);
            logFailureCallback("Failed in setting log level " + level);
            return
    }
    kony.model.log.info("Log Level successfully set to " + kony.model.currentLogLevel.name);
    logSuccessCallback("Log Level successfully set to " + kony.model.currentLogLevel.name)
};
kony.model.log.isDebugEnabled = function() {
    return kony.model.currentLogLevel.value >= kony.model.log.DEBUG.value
};
kony.model.log.isTraceEnabled = function() {
    return kony.model.currentLogLevel.value >= kony.model.log.TRACE.value
};
kony.model.log.isInfoEnabled = function() {
    return kony.model.currentLogLevel.value >= kony.model.log.INFO.value
};
kony.model.log.isWarnEnabled = function() {
    return kony.model.currentLogLevel.value >= kony.model.log.WARN.value
};
kony.model.log.isFatalEnabled = function() {
    return kony.model.currentLogLevel.value >= kony.model.log.FATAL.value
};
kony.model.log.isErrorEnabled = function() {
    return kony.model.currentLogLevel.value >= kony.model.log.ERROR.value
};
kony.model.log.isNoneEnabled = function() {
    return kony.model.currentLogLevel.value === kony.model.log.NONE.value
};
kony.model.log.getCurrentLogLevel = function() {
    return kony.model.currentLogLevel
};
kony.model.Util.isNullOrUndefined = function(val) {
    if (val === null || val === undefined) {
        return true
    } else {
        return false
    }
};
kony.model.Util.isValidJs = function(inputTable) {
    if (kony.model.Util.isNullOrUndefined(inputTable)) {
        return false
    }
    return kony.type(inputTable) === "object" || kony.type(inputTable) === "Object" || kony.type(inputTable) === "Array"
};
kony.model.logger = function(logLevel, tag, msg, params) {
    if (logLevel.value <= kony.model.currentLogLevel.value) {
        params = typeof params === "undefined" ? "" : params;
        if (tag === undefined || tag === null) {
            tag = "AFN"
        }
        if (kony.model.Util.isValidJs(params)) {
            params = kony.model.Util.stringifyObject(params)
        }
        var date = (new Date).toLocaleDateString();
        var time = (new Date).toLocaleTimeString();
        var level = logLevel.code;
        var formattedMessage = "[" + date + "][" + time + "][" + tag + "][" + level + "] : " + msg + " " + params;
        if (kony.model.error_alert && logLevel.value == kony.model.log.ERROR.value) alert(formattedMessage);
        kony.print(formattedMessage)
    }
};
kony.model.Util.stringifyObject = function(obj) {
    var str;
    try {
        if (obj instanceof Error || obj instanceof kony.model.Exception) {
            str = obj.toString()
        } else {
            str = JSON.stringify(obj)
        }
    } catch (e) {
        str = ""
    }
    return str
};
kony.model.print = function(statement) {
    if (typeof kony !== "undefined" && typeof kony.print === "function") {
        kony.print(statement)
    } else if (typeof console !== "undefined" && typeof console.log === "function") {
        console.log(statement)
    }
};
kony = kony || {};
kony.model = kony.model || {};
kony.model.DataAccessAppsExceptionCode = {
    CD_ERROR_10000: 1e4,
    CD_ERROR_10001: 10001,
    CD_ERROR_10002: 10002,
    CD_ERROR_10003: 10003,
    CD_ERROR_10004: 10004,
    CD_ERROR_10005: 10005,
    CD_ERROR_10006: 10006,
    CD_ERROR_10007: 10007,
    CD_ERROR_10008: 10008,
    CD_ERROR_10009: 10009,
    CD_ERROR_10010: 10010,
    CD_ERROR_10011: 10011,
    CD_ERROR_10012: 10012,
    CD_ERROR_10013: 10013,
    CD_ERROR_10014: 10014,
    CD_ERROR_10015: 10015,
    CD_ERROR_10016: 10016,
    CD_ERROR_10017: 10017,
    CD_ERROR_10018: 10018,
    CD_ERROR_10019: 10019,
    CD_ERROR_10020: 10020,
    CD_ERROR_10021: 10021,
    CD_ERROR_10022: 10022,
    CD_ERROR_10023: 10023,
    CD_ERROR_10024: 10024,
    CD_ERROR_10025: 10025,
    CD_ERROR_10026: 10026,
    CD_ERROR_10027: 10027,
    CD_ERROR_10028: 10028,
    CD_ERROR_10029: 10029,
    CD_ERROR_10030: 10030,
    CD_ERROR_10031: 10031,
    CD_ERROR_10032: 10032,
    CD_ERROR_10033: 10033,
    CD_ERROR_10034: 10034,
    CD_ERROR_10035: 10035,
    CD_ERROR_10036: 10036,
    CD_ERROR_10037: 10037,
    CD_ERROR_10038: 10038,
    CD_ERROR_10039: 10039,
    CD_ERROR_10040: 10040,
    CD_ERROR_10041: 10041,
    CD_ERROR_10042: 10042,
    CD_ERROR_10043: 10043,
    CD_ERROR_10044: 10044,
    CD_ERROR_10045: 10045,
    CD_ERROR_10046: 10046,
    CD_ERROR_10047: 10047,
    CD_ERROR_10048: 10048,
    CD_ERROR_10049: 10049,
    CD_ERROR_10050: 10050,
    CD_ERROR_10051: 10051,
    CD_ERROR_10052: 10052,
    CD_ERROR_10053: 10053,
    CD_ERROR_10054: 10054,
    CD_ERROR_10055: 10055,
    CD_ERROR_10056: 10056,
    CD_ERROR_10057: 10057,
    CD_ERROR_10058: 10058,
    CD_ERROR_10059: 10059,
    CD_ERROR_10060: 10060,
    CD_ERROR_10061: 10061,
    CD_ERROR_10062: 10062,
    CD_ERROR_10063: 10063,
    CD_ERROR_10064: 10064,
    CD_ERROR_10065: 10065,
    CD_ERROR_10066: 10066,
    CD_ERROR_10067: 10067,
    CD_ERROR_10068: 10068,
    CD_ERROR_10069: 10069,
    CD_ERROR_10070: 10070,
    CD_ERROR_10071: 10071,
    CD_ERROR_10072: 10072,
    CD_ERROR_10073: 10073,
    CD_ERROR_10074: 10074,
    CD_ERROR_10075: 10075,
    CD_ERROR_10076: 10076,
    CD_ERROR_10077: 10077,
    CD_ERROR_10078: 10078,
    CD_ERROR_10079: 10079,
    CD_ERROR_10080: 10080,
    CD_ERROR_10081: 10081,
    CD_ERROR_10082: 10082,
    CD_ERROR_10083: 10083,
    CD_ERROR_10084: 10084,
    CD_ERROR_10085: 10085,
    CD_ERROR_10086: 10086,
    CD_ERROR_10087: 10087,
    CD_ERROR_10088: 10088,
    CD_ERROR_10089: 10089,
    CD_ERROR_10090: 10090,
    CD_ERROR_10091: 10091,
    CD_ERROR_10092: 10092,
    CD_ERROR_10094: 10094,
    CD_ERROR_10095: 10095,
    CD_ERROR_10096: 10096,
    CD_ERROR_10097: 10097,
    CD_ERROR_10098: 10098,
    CD_ERROR_10099: 10099,
    CD_ERROR_10100: 10100,
    CD_ERROR_10101: 10101,
    CD_ERROR_10102: 10102,
    CD_ERROR_10104: 10104,
    CD_ERROR_10105: 10105,
    CD_ERROR_10106: 10106,
    CD_ERROR_10108: 10108,
    CD_ERROR_10109: 10109,
    CD_ERROR_10110: 10110,
    CD_ERROR_10111: 10111,
    CD_ERROR_10112: 10112,
    CD_ERROR_10113: 10113,
    CD_ERROR_10114: 10114,
    CD_ERROR_10115: 10115,
    CD_ERROR_10116: 10116,
    CD_ERROR_10117: 10117,
    CD_ERROR_10118: 10118,
    CD_ERROR_10119: 10119,
    CD_ERROR_10120: 10120,
    CD_ERROR_10121: 10121,
    CD_ERROR_10122: 10122,
    CD_ERROR_10123: 10123,
    CD_ERROR_10124: 10124,
    CD_ERROR_10125: 10125,
    CD_ERROR_10126: 10126,
    CD_ERROR_10127: 10127,
    CD_ERROR_10128: 10128,
    CD_ERROR_10129: 10129,
    CD_ERROR_10130: 10130,
    CD_ERROR_10131: 10131,
    CD_ERROR_10132: 10132,
    CD_ERROR_10133: 10133,
    CD_ERROR_10134: 10134,
    CD_ERROR_10135: 10135,
    CD_ERROR_10136: 10136,
    CD_ERROR_10137: 10137,
    CD_ERROR_10138: 10138,
    CD_ERROR_10139: 10139,
    CD_ERROR_10140: 10140,
    CD_ERROR_10141: 10141,
    CD_ERROR_10142: 10142,
    CD_ERROR_10143: 10143,
    CD_ERROR_10144: 10144,
    CD_ERROR_10145: 10145,
    CD_ERROR_10146: 10146,
    CD_ERROR_10147: 10147,
    CD_ERROR_10148: 10148,
    CD_ERROR_10149: 10149,
    MSG_ERROR_10000: "Unable to execute delete query",
    MSG_ERROR_10001: "SQLLite Error occurred",
    MSG_ERROR_10002: "Invalid Table configuration in the Database",
    MSG_ERROR_10003: "Entity does not exist in the Database",
    MSG_ERROR_10004: "There is no relationship/definiton defined for the Entity in Enterprise DB",
    MSG_ERROR_10005: "Invalid column name",
    MSG_ERROR_10006: "Column does not exist in the Database",
    MSG_ERROR_10007: "Unable to execute Insert query",
    MSG_ERROR_10008: "Specified column datatype doesnot match with datatype from field mapping",
    MSG_ERROR_10009: "Unique constraint check failed as the data already exist in DB",
    MSG_ERROR_10010: "Specified foreign key is not found",
    MSG_ERROR_10011: "Unable to execute Select query",
    MSG_ERROR_10012: "Invalid Meta Column Name Usage. Correct usage is COLUMNNAME__f",
    MSG_ERROR_10013: "Invalid Meta Column Name Usage in Join Clause. Correct usage is COLUMNNAME__f",
    MSG_ERROR_10014: "Unable to execute update query",
    MSG_ERROR_10015: "No columns specified for updating",
    MSG_ERROR_10016: "Column name either null or empty in update builder",
    MSG_ERROR_10017: "Specified foreign key is not found, Rolled back transaction",
    MSG_ERROR_10018: "Value is null",
    MSG_ERROR_10019: "Column data type does not match the value",
    MSG_ERROR_10020: "No columns specified for update",
    MSG_ERROR_10021: "Invalid table name",
    MSG_ERROR_10022: "Connection NOT created from pool",
    MSG_ERROR_10023: "User id invalid",
    MSG_ERROR_10024: "Invalid arguments to com.kony.common.DataAccess.Query.Between Constructor",
    MSG_ERROR_10025: "Invalid arguments to setColumn of com.kony.common.DataAccess.Query.Between",
    MSG_ERROR_10026: "Invalid arguments to setRange of com.kony.common.DataAccess.Query.Between",
    MSG_ERROR_10027: "Invalid Column name passed to com.kony.common.DataAccess.Query.Column Constructor .\nExpected:Table\nActual:",
    MSG_ERROR_10028: "Invalid data type for the attribute in com.kony.common.DataAccess.Query.Column Constructor",
    MSG_ERROR_10029: "Invalid ColumnName to SetName of com.kony.common.DataAccess.Query.Column",
    MSG_ERROR_10030: "Invalid arguments to setTable of com.kony.common.DataAccess.Query.Column",
    MSG_ERROR_10031: "Invalid arguments to com.kony.common.DataAccess.Query.Range.DateRange Constructor",
    MSG_ERROR_10032: "Invalid arguments to setEnd of com.kony.common.DataAccess.Query.Range.DateRange",
    MSG_ERROR_10033: "Invalid arguments to setStart of com.kony.common.DataAccess.Query.Range.DateRange",
    MSG_ERROR_10034: "Invalid arguments to com.kony.common.DataAccess.Query.Range.DecimalRange Constructor",
    MSG_ERROR_10035: "Invalid arguments to setEnd of com.kony.common.DataAccess.Query.Range.DecimalRange",
    MSG_ERROR_10036: "Invalid arguments to setStart of com.kony.common.DataAccess.Query.Range.DecimalRange",
    MSG_ERROR_10037: "Invalid data type for the attribute subSelect in com.kony.common.DataAccess.Query.Exists Constructor \nExpected:SelectQuery\nActual:",
    MSG_ERROR_10038: "Invalid data type for the attribute subSelect in com.kony.common.DataAccess.Query.Exists.prototype.setSubSelect \nExpected:SelectQuery\nActual:",
    MSG_ERROR_10039: "Invalid arguments to com.kony.common.DataAccess.Query.Expression Constructor",
    MSG_ERROR_10040: "Invalid number of arguments to com.kony.common.DataAccess.Query.Expression",
    MSG_ERROR_10041: "Invalid Operator type passed to com.kony.common.DataAccess.Query.Expression",
    MSG_ERROR_10042: "Invalid arguments for the attribute com.kony.common.DataAccess.Query.Expression initExpression",
    MSG_ERROR_10043: "Invalid arguments for the attribute com.kony.common.DataAccess.Query.Expression setExpression",
    MSG_ERROR_10044: "Invalid arguments for the attribute com.kony.common.DataAccess.Query.Expression setTerm",
    MSG_ERROR_10045: "Invalid arguments to setEnd of com.kony.common.DataAccess.Query.Range.FloatRange",
    MSG_ERROR_10046: "Invalid arguments to setStart of com.kony.common.DataAccess.Query.Range.FloatRange",
    MSG_ERROR_10047: "Invalid argument for the attribute in com.kony.common.DataAccess.Query.Group",
    MSG_ERROR_10048: "Invalid arguments for the attribute in com.kony.common.DataAccess.Query.Group.prototype.setColumn",
    MSG_ERROR_10049: "Invalid number of arguments passed to com.kony.common.DataAccess.Query.InCriteria",
    MSG_ERROR_10050: "Invalid arguments for getInCriteriaByTableAndCollection in com.kony.common.DataAccess.Query.InCriteria",
    MSG_ERROR_10051: "Invalid arguments for getInCriteriaByColumnAndCollection in com.kony.common.DataAccess.Query.InCriteria",
    MSG_ERROR_10052: "Invalid arguments for getColumnForTable in com.kony.common.DataAccess.Query.InCriteria",
    MSG_ERROR_10053: "Invalid arguments to com.kony.common.DataAccess.Query.Range.IntegerRange Constructor",
    MSG_ERROR_10054: "Invalid arguments to setEnd of com.kony.common.DataAccess.Query.Range.IntegerRange",
    MSG_ERROR_10055: "Invalid arguments to setStart of com.kony.common.DataAccess.Query.Range.IntegerRange",
    MSG_ERROR_10056: "Invalid arguments passed for  com.kony.common.DataAccess.Query.Join",
    MSG_ERROR_10057: "Invalid arguments passed for the method in com.kony.common.DataAccess.Query.Join",
    MSG_ERROR_10058: "Invalid arguments passed for the method setCriteria in com.kony.common.DataAccess.Query.Join",
    MSG_ERROR_10059: "Invalid arguments passed for the method setTable in com.kony.common.DataAccess.Query.Join",
    MSG_ERROR_10060: "Invalid arguments passed for the method setJoinType in com.kony.common.DataAccess.Query.Join",
    MSG_ERROR_10061: "Invalid arguments passed for the method initCriteria in com.kony.common.DataAccess.Query.Join",
    MSG_ERROR_10062: "Insufficient input passed to com.kony.common.DataAccess.Query.And Constructor",
    MSG_ERROR_10063: "Invalid data type for com.kony.common.DataAccess.Query.And Expected value Criteria",
    MSG_ERROR_10064: "Insufficient input passed to com.kony.common.DataAccess.Query.Or Constructor",
    MSG_ERROR_10065: "Invalid data type for com.kony.common.DataAccess.Query.Or Expected value Criteria",
    MSG_ERROR_10066: "Insufficient input passed to com.kony.common.DataAccess.Query.Not Constructor",
    MSG_ERROR_10067: "Invalid data type for com.kony.common.DataAccess.Query.Not Expected value Criteria",
    MSG_ERROR_10068: "Invalid match type passed in com.kony.common.DataAccess.Query.Match.prototype.initMatchByColumn",
    MSG_ERROR_10069: "Invalid value passed in com.kony.common.DataAccess.Query.Match.prototype.initMatchByColumn",
    MSG_ERROR_10070: "Invalid arguments passed for the method initMatchByColumn in com.kony.common.DataAccess.Query.Match.prototype.initMatchByColumn.",
    MSG_ERROR_10071: "Invalid match type passed in com.kony.common.DataAccess.Query.Match.prototype.initMatchByTableAndColName",
    MSG_ERROR_10072: "Invalid value passed in com.kony.common.DataAccess.Query.Match.prototype.initMatchByTableAndColName",
    MSG_ERROR_10073: "Invalid columnName passed in com.kony.common.DataAccess.Query.Match.prototype.initMatchByTableAndColName",
    MSG_ERROR_10074: "Invalid arguments passed for the method initMatchByTableAndColName in com.kony.common.DataAccess.Query.Match",
    MSG_ERROR_10075: "Match object not initialized properly  in com.kony.common.DataAccess.Query.Match",
    MSG_ERROR_10076: "Invalid arguments passed for the constructor in com.kony.common.DataAccess.Query.Order",
    MSG_ERROR_10077: "Invalid arguments for the method setColumn in com.kony.common.DataAccess.Query.Order",
    MSG_ERROR_10078: "Invalid arguments to com.kony.common.DataAccess.Query.Range.StringRange Constructor",
    MSG_ERROR_10079: "Invalid arguments to setEnd of com.kony.common.DataAccess.Query.Range.StringRange",
    MSG_ERROR_10080: "Invalid arguments to setStart of com.kony.common.DataAccess.Query.Range.StringRange",
    MSG_ERROR_10081: "Invalid Arguments passed to DeleteBuilder.addCriteria",
    MSG_ERROR_10082: "Invalid data type for the attribute in DeleteBuilder.addCriteria. Expected: Criteria | Actual:",
    MSG_ERROR_10083: "Invalid data type for the attribute in DeleteBuilder . Expected: Table | Actual:",
    MSG_ERROR_10084: "Invalid data type for the attribute in com.kony.common.DataAccess.Query.InsertQuery .\nExpected:Table\nActual:",
    MSG_ERROR_10085: "Invalid data type for the attribute in com.kony.common.DataAccess.Query.InsertQuery.prototype.addColumn .\nExpected:Column\nActual:",
    MSG_ERROR_10086: "Invalid data type for the attribute in com.kony.common.DataAccess.Query.InsertQuery.prototype.addColumnToTable .\nExpected:String\nActual:",
    MSG_ERROR_10087: "Invalid data type for the attribute in com.kony.common.DataAccess.Query.InsertQuery.prototype.addColumnToTable .\nExpected:Table\nActual:",
    MSG_ERROR_10088: "Invalid data type for the attribute in com.kony.common.DataAccess.Query.InsertQuery.prototype.removeColumn .\nExpected:Table\nActual:",
    MSG_ERROR_10089: "Invalid Arguments passed to SelectBuilder",
    MSG_ERROR_10090: "Invalid data type for the attribute in SelectBuilder .\nExpected:Table\nActual:",
    MSG_ERROR_10091: "Invalid Arguments passed to selectBuilder.addColumn",
    MSG_ERROR_10092: "Invalid data type for the attribute in selectBuilder.addColumn .\nExpected:Column\nActual:",
    MSG_ERROR_10094: "Invalid data type for the attribute in SelectBuilder.\nExpected:Table\nActual:",
    MSG_ERROR_10095: "Invalid Arguments of Alias passed to selectBuilder ",
    MSG_ERROR_10096: "Invalid data type for the attribute in selectBuilder.\nExpected:Table\nActual:",
    MSG_ERROR_10097: "Invalid Arguments passed to selectBuilder.addCriteria",
    MSG_ERROR_10098: "Invalid data type for the attribute in selectBuilder.addCriteria .\nExpected:Criteria\nActual:",
    MSG_ERROR_10099: "Invalid Arguments passed to selectBuilder.addGroup",
    MSG_ERROR_10100: "Invalid data type for the attribute in selectBuilder.addGroup .\nExpected:Group\nActual:",
    MSG_ERROR_10101: "Invalid Arguments passed to selectBuilder.addJoin",
    MSG_ERROR_10102: "Invalid data type for the attribute in SelectBuilder.addJoin .\nExpected:Criteria\nActual:",
    MSG_ERROR_10104: "Invalid data type for the attribute in SelectBuilder",
    MSG_ERROR_10105: "Invalid Arguments passed to selectBuilder.addOrder",
    MSG_ERROR_10106: "Invalid data type for the attribute in selectBuilder.addOrder \nExpected:Order\nActual:",
    MSG_ERROR_10108: "Invalid data type for the attribute in SelectBuilder \nExpected:Table\nActual:",
    MSG_ERROR_10109: "Invalid Arguments passed to selectBuilder.removeColumn",
    MSG_ERROR_10110: "Invalid data type for the attribute in selectBuilder.removeColumn \nExpected:Column\nActual:",
    MSG_ERROR_10111: "Invalid Arguments passed to selectBuilder.removeCriteria",
    MSG_ERROR_10112: "Invalid data type for the attribute in selectBuilder.removeCriteria \nExpected:Criteria\nActual:",
    MSG_ERROR_10113: "Invalid Arguments passed to selectBuilder.removeGroup",
    MSG_ERROR_10114: "Invalid data type for the attribute in selectBuilder.removeGroup \nExpected:Group\nActual:",
    MSG_ERROR_10115: "Invalid Arguments passed to selectBuilder.removeJoin",
    MSG_ERROR_10116: "Invalid data type for the attribute in selectBuilder.removeJoin \nExpected:Group\nActual:",
    MSG_ERROR_10117: "Invalid data type for the attribute in SelectBuilder \nExpected:Group\nActual:",
    MSG_ERROR_10118: "Invalid Arguments passed to UpdateQuery",
    MSG_ERROR_10119: "Invalid data type for the attribute in UpdateQuery .\nExpected:Table\nActual:",
    MSG_ERROR_10120: "Invalid Arguments passed to UpdateBuilder.addColumn method",
    MSG_ERROR_10121: "Invalid data type for the attribute in UpdateBuilder.addColumn method",
    MSG_ERROR_10122: "Invalid Arguments passed to UpdateBuilder.addColumnByColumnNameAndValue",
    MSG_ERROR_10123: "Invalid data type for the attribute in UpdateBuilder.addColumnByColumnNameAndValue",
    MSG_ERROR_10124: "Invalid Arguments passed to UpdateBuilder.addCriteria",
    MSG_ERROR_10125: "Invalid data type for the attribute in UpdateBuilder.addCriteria .\nExpected:Criteria\nActual:",
    MSG_ERROR_10126: "Invalid Arguments passed to UpdateBuilder.removeCriteria",
    MSG_ERROR_10127: "Invalid data type for the attribute in UpdateBuilder.removeCriteria .\nExpected:Criteria\nActual:",
    MSG_ERROR_10128: "Invalid Arguments passed to UpdateBuilder",
    MSG_ERROR_10129: "Invalid data type for the attribute in UpdateBuilder .\nExpected:Table\nActual:",
    MSG_ERROR_10130: "Invalid number of arguments to com.kony.common.DataAccess.Query.InsertQuery.prototype.addColumn",
    MSG_ERROR_10131: "unknown database error occured. please verify the table and columns names.",
    MSG_ERROR_10132: "No parent keys found.",
    MSG_ERROR_10133: "field object is empty",
    MSG_ERROR_10134: "Given JoinType doesn't support",
    MSG_ERROR_10135: "Cannot insert record as the integrity failed with",
    MSG_ERROR_10136: "error occurred during language fetch",
    MSG_ERROR_10137: "No logical fields exist for the table",
    MSG_ERROR_10138: "unknown database error occured. please verify the table and column names/values.",
    MSG_ERROR_10139: "Invalid number of arguments to com.kony.common.DataAccess.Query.Match",
    MSG_ERROR_10140: "Invalid number of arguments to com.kony.common.DataAccess.Query.Join",
    MSG_ERROR_10141: "Entity with name doesn't exist",
    MSG_ERROR_10142: "Invalid Meta Column Name Usage, Correct usage COLUMNNAME__f",
    MSG_ERROR_10143: "Table does not exist in the database",
    MSG_ERROR_10144: "Column does not exist in table",
    MSG_ERROR_10145: "Table is undefined.Please provide valid table name",
    MSG_ERROR_10146: "Invalid Arguments passed to DeleteBuilder",
    MSG_ERROR_10147: "Invalid Arguments passed to InsertBuilder",
    MSG_ERROR_10148: "No data found to update with the selected criteria",
    MSG_ERROR_10149: "The request could not be completed."
};
kony.model.Exception = function() {
    function toStringRecursive(exception, output) {
        var intermOutput;
        if (exception == undefined) return output.append("");
        if (exception.getErrorObj()) {
            if (exception.getErrorObj().name && exception.getErrorObj().message) output.append(exception.getErrorObj().name + ": " + exception.getErrorObj().message + ": " + exception.getErrorObj().sourceURL);
            else output.append(JSON.stringify(exception.getErrorObj()));
            output.append("\n");
            return output.append(exception.code + ":" + exception.message + "\n")
        }
        intermOutput = toStringRecursive(exception.exceptionObj, output);
        intermOutput.append(exception.code + ":" + exception.message);
        intermOutput.append("\n");
        return intermOutput
    }

    function getRootErrObj(exception) {
        if (exception && exception.exceptionObj != undefined && exception.getErrorObj() == undefined) {
            var intermErrObj = getRootErrObj(exception.exceptionObj);
            return intermErrObj
        } else if (exception && exception.exceptionObj == undefined && exception.getErrorObj() != undefined) {
            return exception.getErrorObj()
        } else {
            return undefined
        }
    }

    function Exception(code, message, exceptionObj) {
        this.code = typeof code === "number" ? code : -1;
        this.message = typeof message === "string" ? message : "";
        this.name = "Exception";
        var actualErrorObj;
        if (exceptionObj instanceof kony.model.Exception) {
            this.exceptionObj = exceptionObj;
            actualErrorObj = undefined
        } else {
            actualErrorObj = exceptionObj;
            this.exceptionObj = undefined
        }
        this.getErrorObj = function() {
            return actualErrorObj
        };
        this.getParentException = function() {
            return this.exceptionObj
        }
    }
    inheritsFrom(Exception, Error);
    Exception.prototype.toString = function() {
        var output = new kony.model.Util.StringBuffer;
        output = toStringRecursive(this, output);
        return output.toString()
    };
    Exception.prototype.alert = function(full) {
        if (full === true) {
            var output = new kony.model.Util.StringBuffer;
            output = toStringRecursive(this, output);
            alert(output.toString())
        } else alert(this.code + ":" + this.name + ":" + this.message)
    };
    Exception.prototype.setSyncResponse = function(response) {
        this.syncresponse = response
    };
    Exception.prototype.getRootErrorObj = function() {
        var rootErrObj = getRootErrObj(this);
        return rootErrObj
    };
    return Exception
}();
kony.model.ExceptionCode = {
    CD_ERROR_LOADING_TEMPLATES: 3,
    CD_ERROR_FAILED_TO_CREATE_RECORD: 9,
    CD_ERROR_FAILED_TO_UPDATE_RECORD: 10,
    CD_ERROR_CALLBACK_NOT_A_FUNCTION: 11,
    CD_ERROR_LOGIN_FAILURE: 12,
    CD_ERROR_SESSION_TOKEN_INVALID: 13,
    CD_ERROR_FAILED_TO_SAVE_FORM: 14,
    CD_ERROR_FAILED_TO_FETCH_DATA: 15,
    CD_ERROR_FAILED_TO_INITIALIZE_FORM: 16,
    CD_ERROR_FETCHING_METADATA: 17,
    CD_ERROR_MORE_RECORDS_FOUND: 18,
    CD_ERROR_FETCHING_TEMPLATES: 19,
    CD_ERROR_FETCHING_FORMS: 20,
    CD_ERROR_INITIALIZING_UI_CONFIG_DATA_PROVIDER: 21,
    CD_ERROR_INITIALIZING_METADATA_PROVIDER: 22,
    CD_ERROR_INITIALIZING_DATA_PROVIDER: 23,
    CD_ERROR_FAILED_TO_LOAD_APPLICATION: 24,
    CD_ERROR_APP_INITIALIZATION_FAILED: 25,
    CD_ERROR_INITIALIZING_SAAS_APP: 26,
    CD_ERROR_FORMVIEWCONTROLLER_NOT_FOUND: 27,
    CD_ERROR_NAVIGATION_STACK_EMPTY: 28,
    CD_ERROR_FORM_NOT_FOUND: 29,
    CD_ERROR_METADATA_FOR_ENTITY_NOT_FOUND: 30,
    CD_ERROR_NO_FIELDS_MODIFIED_UPDATE_FAILED: 31,
    CD_ERROR_PRIMARY_FIELD_VALUE_NOT_FOUND: 32,
    CD_ERROR_UNDEFINED_WIDGET_CONTROLLER: 33,
    CD_ERROR_FAILED_TO_LOGOUT: 35,
    CD_ERROR_FAILED_LOADING_MASTER_DATA: 36,
    CD_ERROR_FAILED_TO_NAVIGATE_TO_FORM: 37,
    CD_ERROR_PARSING_JSONS: 38,
    CD_ERROR_FAILED_LOADING_FORMS: 39,
    CD_ERROR_FAILED_FORM_INIT_WHILE_CALLBACK: 40,
    CD_ERROR_KONY_FORM_OBJECT_UNDEFINED: 41,
    CD_ERROR_SAVE_CANNOT_SET_PRIMARY_KEY: 42,
    CD_ERROR_FETCH_FAILED_FOR_CHILD_ENTITY: 43,
    CD_ERROR_GET_NEXT_LIST: 44,
    CD_ERROR_UNSUPPORTED_SEGMENT_TYPE: 45,
    CD_ERROR_NOT_INHERITING_VIEW_CONTROLLER: 46,
    CD_ERROR_NOT_INHERITING_WIDGET_CONTROLLER: 47,
    CD_ERROR_FAILED_BINDING_DATA_TO_WIDGET: 48,
    CD_ERROR_PAGINATION_NOT_ENABLED_FOR_SEGMENT: 49,
    CD_ERROR_PARAM_VALUE_NOT_DEFINED_IN_QUERYPARAM: 50,
    CD_ERROR_BRACES_ARE_NOT_DEFINED_PROPERLY: 51,
    CD_ERROR_ADDITIONAL_FIELDS_ARE_NOT_DEFINED_PROPERLY: 52,
    CD_ERROR_QUERY_NOT_DEFINED_PROPERLY: 53,
    CD_ERROR_QUERYPARAMS_NOT_DEFINED_PROPERLY: 54,
    CD_ERROR_MATCHOPERATOR_NOT_DEFINED_PROPERLY: 55,
    CD_ERROR_DATA_VALIDATION_FIELD_NOT_CREATEABLE: 56,
    CD_ERROR_DATA_VALIDATION_FIELD_NOT_UPDATEABLE: 57,
    CD_ERROR_DATA_VALIDATION_FIELD_NOT_NULLABLE: 58,
    CD_ERROR_DATA_VALIDATION_INVALID_INPUT_DATA: 59,
    CD_ERROR_DATA_VALIDATION_INVALID_MODEL: 60,
    CD_ERROR_DATA_VALIDATION_INVALID_ENTITY: 61,
    CD_ERROR_DATA_VALIDATION_ENTITYMETADATA_NOTFOUND: 62,
    CD_ERROR_CREATING_APPMENU: 63,
    CD_ERROR_FETCHING_APPMENU_DATA: 64,
    CD_ERROR_FIELD_NOT_PRESENT: 65,
    cd_ERROR_ENITTY_NOT_PRESENT: 66,
    CD_TENANT_NOT_SYNC_ENABLED: 67,
    CD_INVALID_QUERY: 68,
    CD_ERROR_FETCH_USER_PROFILE_FAILURE: 69,
    CD_RESOURCE_NO_CREATE_PERMISSION: 74,
    CD_RESOURCE_NO_READ_PERMISSION: 75,
    CD_RESOURCE_NO_UPDATE_PERMISSION: 76,
    CD_RESOURCE_NO_DELETE_PERMISSION: 77,
    CD_ERROR_OFFLINE_LOGIN_FAILURE: 70,
    CD_ERROR_UNABLE_TO_SYNC: 71,
    CD_ERROR_UNABLE_TO_GET_SYNC_CONFIG: 72,
    CD_ERROR_UNABLE_TO_RESET_SYNC: 73,
    CD_ERROR_NO_RESPONSE_RECEIVED: 78,
    CD_ERROR_NETWORK_UNAVAILABLE: 79,
    CD_ERROR_IN_SET_ADDITIONAL_FIELDS: 80,
    CD_ERROR_IN_SET_QUERY: 81,
    CD_ERROR_IN_SET_QUERY_PARAMS: 82,
    CD_ERROR_ENTER_VALID_TENANT_NAME: 83,
    CD_ERROR_NAVIGATION_CONTROLLER_NOT_DEFINED: 84,
    CD_ERROR_ENTITY_NOT_SPECIFIED: 85,
    CD_ERROR_FORMTYPE_NOT_SPECIFIED: 86,
    CD_ERROR_FORM_NOT_DEFINED_FOR_RECORDTYPE: 87,
    CD_ERROR_RECORDTYPES_NOT_AVAILABLE: 88,
    CD_ERROR_FORMSFORRECORDTYPES_MAP_NOT_DEFINED: 89,
    CD_ERROR_SAAS_INSTANCE_NOTDEFINED: 90,
    CD_ERROR_INVALID_ENTITY: 91,
    CD_VERSION_UNSUPPORTED_ERROR: 92,
    CD_ERROR_ASSOCIATING_RECORD: 93,
    CD_ERROR_DISOCIATING_RECORD: 94,
    CD_ERROR_NOT_INSTANCE_OF_CUSTOMINFO: 95,
    CD_ERROR_FORM_ENTITY_NOT_FOUND: 96,
    CD_ERROR_FORM_PRIMARY_FIELDVALUE_NOT_FOUND: 97,
    CD_ERROR_CANNOT_ASSOCIATE_DISSOCIATE_OF_SAME_ENTITY: 98,
    CD_ERROR_SAVING_MULTI_ENTITY_LABEL: 99,
    CD_ERROR_SAVING_CHILD_CONTAINER: 100,
    CD_ERROR_DECODING_BASE64_FORMJS: 102,
    CD_ERROR_BATCH_INSERT: 103,
    CD_ERROR_LOCAL_DB_CONNECTION: 104,
    CD_ERROR_EXECUTE_SINGLE_SQL_QUERY: 105,
    CD_UPGRADE_UNAVAILABLE: 106,
    CD_ERROR_I18N: 107,
    CD_INVALID_LOGIN_HANDLER_RESPONSE: 108,
    CD_ERROR_FAILED_TO_QUERY_DATA: 109,
    CD_ERROR_LOADING_THEME: 110,
    CD_ERROR_SETTING_THEME: 111,
    CD_ERROR_FETCHING_THEME: 112,
    CD_ERROR_MULTIPLE_DEFAULT_THEME: 113,
    CD_ERROR_CREATING_THEME: 114,
    CD_ERROR_METHOD_INVALID: 115,
    CD_ERROR_INVALID_HTTPCUSTOMREQUEST_INPUT: 116,
    CD_ERROR_INVALID_INPUT: 117,
    CD_ERROR_INVALID_INPUT_TYPE: 118,
    CD_ERROR_INVALID_PAYLOAD: 119,
    CD_ERROR_INVALID_DATAPROVIDER_TYPE: 120,
    CD_ERROR_DATAPROVIDER_NOT_INTIALIZED: 121,
    CD_ERROR_INVALID_CUSTOMSERVICE_INPUT_PARAM: 122,
    CD_ERROR_UNEXPECTED_CUSTOMRESPONSE: 123,
    CD_CLOUD_UNAUTHORISED_FOR_DATAPROVIDER: 124,
    CD_CREDSTORE_NOT_FOUND: 125,
    CD_CREDENTIAL_MISMATCH_WITH_CREDSTORE: 126,
    CD_ERROR_TENANT_NOT_SPECIFIED: 50003,
    CD_ERROR_UNABLE_TO_CONNECT: 50004,
    CD_ERROR_SYNC_FAILURE: 50005,
    CD_ERROR_LANDING_PAGE_NOT_DEFINED: 50007,
    CD_ERROR_INVALID_PARAM1: 50008,
    CD_ERROR_ENTITY_CONTROLLER_NOT_DEFINED: 10001,
    CD_ERROR_IN_ENTITY_DEFINITION: 10002,
    CD_ERROR_IN_RETREIVNING_CHILD_RELATIONSHIPLIST: 10003,
    CD_ERROR_FETCHING_DATA_FOR_COLUMNS: 10004,
    CD_ERROR_FETCHING_CHILD_RELATIONSHP_FOR_ENTITY: 10005,
    CD_ERROR_PROCESSING_CHILD_RELATIONSHIPLIST: 10006,
    CD_ERROR_FETCH: 10007,
    CD_ERROR_CREATE: 10008,
    CD_ERROR_UPDATE: 10009,
    CD_ERROR_UPDATE_BY_PRIMARY_KEY: 10010,
    CD_ERROR_DELETE: 10011,
    CD_ERROR_DELETE_BY_PRIMARY_KEY: 10012,
    CD_ERROR_VALIDATION_UPDATE: 10013,
    CD_ERROR_VALIDATION_CREATE: 10014,
    CD_ERROR_GET_WIDGET_DATA_FORMMODEL: 20001,
    CD_ERROR_SET_WIDGET_DATA_FORMMODEL: 20002,
    CD_ERROR_FORMMODEL_PROPERTY_VALUE_CHANGED: 20003,
    CD_ERROR_FORMMODEL_CLEAR: 20004,
    CD_ERROR_FORMMODEL_DESTROY: 20005,
    CD_ERROR_FORMMODEL_UPDATE: 20006,
    CD_ERROR_FORMMODEL_SHOWVIEW: 20007,
    CD_ERROR_FORMMODEL_SET_MASTERDATA: 20008,
    CD_ERROR_FORMMODEL_GET_MASTERDATA: 20009,
    CD_ERROR_FORMMODEL_SET_VIEW_ATTRIBUTE: 20010,
    CD_ERROR_FORMMODEL_GET_VIEW_ATTRIBUTE: 20011,
    CD_ERROR_FORMMODEL_PERFORM_ACTION_ONVIEW: 20012,
    CD_ERROR_FORMMODEL_PERFORM_ACTION: 20013,
    CD_ERROR_NOTIFYING_OBSERVERS: 20014,
    CD_ERROR_FORMMODEL_PROPERTIES_INIT: 20015,
    CD_ERROR_FETCH_IN_CONTROLLER: 30001,
    CD_ERROR_BIND_IN_CONTROLLER: 30002,
    CD_ERROR_SAVE_IN_CONTROLLER: 30003,
    CD_ERROR_DELETE_IN_CONTROLLER: 30004,
    CD_ERROR_LOADDATA_SHOWFORM_CONTROLLER: 30005,
    CD_ERROR_GETTING_ENTITY_CONTROLLER: 30006,
    CD_ERROR_GETTING_ENTITY_METADATA: 30007,
    CD_ERROR_FETCH_IN_BASE_CONTROLLER_EXTENSION: 30008,
    CD_ERROR_BIND_IN_BASE_CONTROLLER_EXTENSION: 30009,
    CD_ERROR_SAVE_IN_BASE_CONTROLLER_EXTENSION: 30010,
    CD_ERROR_ACTION_NOT_FOUND_IN_CONTROLLER: 30011,
    CD_ERROR_FORMATDATA_IN_BASE_CONTROLLER_EXTENSION: 30012,
    CD_ERROR_FORMATDATA_IN_CONTROLLER: 30013,
    CD_ERROR_DELETE_IN_BASE_CONTROLLER_EXTENSION: 30014,
    CD_ERROR_GENERATE_RECORDS_IN_BASE_CONTROLLER_EXTENSION: 30015,
    CD_ERROR_FETCH_IN_CONTROLLER_EXTENSION: 40013,
    CD_ERROR_BINDDATA_IN_CONTROLLER_EXTENSION: 40014,
    CD_ERROR_SAVEDATA_IN_CONTROLLER_EXTENSION: 40015,
    CD_ERROR_DELETEDATA_IN_CONTROLLER_EXTENSION: 40016,
    CD_ERROR_PROCESSDATA_IN_CONTROLLER_EXTENSION: 40017,
    CD_ERROR_SHOWFORM_IN_CONTROLLER_EXTENSION: 40018,
    CD_ERROR_GET_DATA_WIDGETS_OF_FORM: 60001,
    CD_ERROR_GETTING_QUERY_WIDGETS_MAPPING: 60002,
    CD_ERROR_ORM_CONTROLLER_FETCH_RECORDS: 70001,
    CD_ERROR_ORM_CONTROLLER_FETCH_RECORDS_QUERIES_NOT_DEFINED: 70002,
    CD_ERROR_ORM_CONTROLLER_FETCH_RECORD_PK_NOT_DEFINED: 70003,
    CD_ERROR_ORM_CONTROLLER_FETCH_RECORD_PK: 70004,
    CD_ERROR_ORM_CONTROLLER_FETCH_RECORDS_BY_NATIVE_QUERY: 70005,
    CD_ERROR_ORM_CONTROLLER_FETCH_RECORDS_BY_COLUMN_DEFINITION: 70006,
    CD_ERROR_ORM_CONTROLLER_SAVE_RECORD: 70007,
    CD_ERROR_ORM_CONTROLLER_SAVE_RECORDS: 70008,
    CD_ERROR_ORM_CONTROLLER_REMOVE_RECORD: 70009,
    CD_ERROR_ORM_CONTROLLER_REMOVE_RECORDS: 70010,
    CD_ERROR_ORM_CONTROLLER_FETCH_CHILD_RELATIONSHIP: 70011,
    CD_ERROR_ORM_CONTROLLER_RESULTSET_TO_OBJECT_CONVERSION: 70012,
    CD_ERROR_ORM_CONTROLLER_PREPARE_FETCH_QUERY: 70013,
    CD_ERROR_ORM_CONTROLLER_UNMARSHALL_TO_MODEL_OBJECT: 70014,
    CD_ERROR_ORM_CONTROLLER_FETCH_AND_BIND_DATA_STRATEGY: 70015,
    CD_ERROR_PREPARING_QUERY_STRING: 90001,
    CD_ERROR_APP_INIT_FORMS: 90002,
    CD_ERROR_INVALID_DATA_OBJECT: 90003,
    CD_ERROR_CUSTOMVERB: 90004,
    MSG_ERROR_CUSTOMVERB: "Error while invoking custom verb",
    MSG_ERROR_SAAS_INSTANCE_NOTDEFINED: "kony.model.ApplicationContext.INSTANCE is not defined",
    MSG_ERROR_FORMSFORRECORDTYPES_MAP_NOT_DEFINED: "FormsForRecordTypes map is not defined or it has no entities",
    MSG_ERROR_RECORDTYPES_NOT_AVAILABLE: "No record types available from service",
    MSG_ERROR_FORM_NOT_DEFINED_FOR_RECORDTYPE: "no default forms for given formType ",
    MSG_ERROR_FORMTYPE_NOT_SPECIFIED: "Please specify formType for record type",
    MSG_ERROR_ENTITY_NOT_SPECIFIED: "Please specify entity to get record types",
    MSG_ERROR_MATCHOPERATOR_NOT_DEFINED_PROPERLY: "Match Operator is not mentioned properly in the query",
    MSG_ERROR_QUERYPARAMS_NOT_DEFINED_PROPERLY: "Queryparams are not defined properly",
    MSG_ERROR_QUERY_NOT_DEFINED_PROPERLY: "Query is not defined properly",
    MSG_ERROR_ADDITIONAL_FIELDS_ARE_NOT_DEFINED_PROPERLY: "Additinal Fields should be described in an Array Format Only",
    MSG_ERROR_BRACES_ARE_NOT_DEFINED_PROPERLY: "Braces are not defined properly in the query",
    MSG_ERROR_PARAM_VALUE_NOT_DEFINED_IN_QUERYPARAM: "Parameter value is not defined for this parameter",
    MSG_ERROR_DATA_VALIDATION_FIELD_NOT_CREATEABLE: "Form Validation Error- Field is not createable",
    MSG_ERROR_DATA_VALIDATION_FIELD_NOT_UPDATEABLE: "Form Validation Error - Field is not updateable",
    MSG_ERROR_DATA_VALIDATION_FIELD_NOT_NULLABLE: "Form Validation Error - Field is not nullable",
    MSG_ERROR_DATA_VALIDATION_INVALID_INPUT_DATA: "Form Validation Error - Invalid input data",
    MSG_ERROR_DATA_VALIDATION_INVALID_MODEL: "Form Validation Error - Invalid Model",
    MSG_ERROR_DATA_VALIDATION_INVALID_ENTITY: "Form Validation Error - Invalid Entity",
    MSG_ERROR_DATA_VALIDATION_ENTITYMETADATA_NOTFOUND: "Form Validation Error - EntityMetaData Not Found",
    MSG_ERROR_FETCHING_APPMENU_DATA: "Error fetching data for app menu",
    MSG_ERROR_CREATING_APPMENU: "Error creating app menu",
    CD_ERROR_WIDGETID_NOT_DEFINED: 50,
    CD_ERROR_PROCESSING_FORMCONFIG: 51,
    CD_ERROR_TAGNAME_NOTVALID: 52,
    CD_ERROR_EVENTNAME_NOT_DEFINED: 53,
    CD_ERROR_WIDGET_INSTANCE_NOT: 54,
    CD_ERROR_WHILE_PROCESSING_WIDGETCONFIG: 55,
    CD_ERROR_PRESAVECALLBACK_NOT_A_FUNCTION: 56,
    CD_ERROR_IN_DATACALLBACK: 57,
    CD_ERROR_IN_PRESAVECALLBACK: 58,
    CD_ERROR_NOT_MODEL_INSTANCE: 59,
    MSG_ERROR_NOT_MODEL_INSTANCE: "result of callback is not a model instance",
    MSG_ERROR_IN_PRESAVECALLBACK: "PreSave callback execution got failed",
    MSG_ERROR_IN_DATACALLBACK: "Data Call Back Execution got failed",
    MSG_ERROR_PRESAVECALLBACK_NOT_A_FUNCTION: "presave call back is not a function",
    MSG_ERROR_WHILE_PROCESSING_WIDGETCONFIG: "error while processing widget config of ",
    MSG_ERROR_WIDGET_INSTANCE_NOT: "it should be instance of kony.model.widgetConfig",
    MSG_ERROR_EVENTNAME_NOT_DEFINED: "event name is not defined",
    MSG_ERROR_WIDGETID_NOT_DEFINED: "Widget id is not specifed",
    MSG_ERROR_PROCESSING_FORMCONFIG: "error while processing form config",
    MSG_ERROR_TAGNAME_NOTVALID: "specified tag name not valid ",
    MSG_ERROR_PAGINATION_NOT_ENABLED_FOR_SEGMENT: "Pagination not enabled for this segment",
    MSG_ERROR_FAILED_BINDING_DATA_TO_WIDGET: "Failed to bind data to widget",
    MSG_ERROR_NOT_INHERITING_WIDGET_CONTROLLER: "Does not inherit WidgetController class ",
    MSG_ERROR_NOT_INHERITING_VIEW_CONTROLLER: "Does not inherit ViewController class ",
    MSG_ERROR_UNSUPPORTED_SEGMENT_TYPE: "segment widget type is not yet supported",
    MSG_ERROR_GET_NEXT_LIST: "Get next list error - Data Records recieved < 0 ",
    MSG_ERROR_FETCH_FAILED_FOR_CHILD_ENTITY: "failed to get data for child entity",
    MSG_ERROR_SAVE_CANNOT_SET_PRIMARY_KEY: "cannot save form, cannot explicitly set primary key value",
    MSG_ERROR_KONY_FORM_OBJECT_UNDEFINED: "kony form object is undefined",
    MSG_ERROR_FAILED_FORM_INIT_WHILE_CALLBACK: "failed to initilaize the form while executing datacallback",
    MSG_ERROR_FAILED_LOADING_FORMS: "Failed to load form",
    MSG_ERROR_PARSING_JSONS: "Error while parsing forms JSON",
    MSG_ERROR_FAILED_TO_NAVIGATE_TO_FORM: "failed to navigate to form ",
    MSG_ERROR_FAILED_LOADING_MASTER_DATA: "failed to laod master data",
    MSG_ERROR_FAILED_TO_LOGOUT: "Failed to logout",
    MSG_ERROR_UNDEFINED_WIDGET_CONTROLLER: "Undefined widget controller",
    MSG_ERROR_PRIMARY_FIELD_VALUE_NOT_FOUND: "cannot save form, primary field value not found",
    MSG_ERROR_NO_FIELDS_MODIFIED_UPDATE_FAILED: "Cannot save form, no fields are modified",
    MSG_ERROR_METADATA_FOR_ENTITY_NOT_FOUND: "metadata could not found for entity ",
    MSG_ERROR_FORM_NOT_FOUND: "Form not found",
    MSG_ERROR_EXPECTED_BOOLEAN: "First parameter must be boolean",
    MSG_ERROR_NAVIGATION_STACK_EMPTY: "Navigation stack is empty",
    MSG_ERROR_FORMVIEWCONTROLLER_NOT_FOUND: "form view controller not found",
    MSG_ERROR_INITIALIZING_SAAS_APP: "Error Initializing SaaS Application",
    MSG_ERROR_APP_INITIALIZATION_FAILED: "Application initialization failed",
    MSG_ERROR_FAILED_TO_LOAD_APPLICATION: "Failed to Load Application",
    MSG_ERROR_INITIALIZING_DATA_PROVIDER: "Unable to initialize data provider",
    MSG_ERROR_INITIALIZING_METADATA_PROVIDER: "Unable to initialize meta data provider",
    MSG_ERROR_INITIALIZING_UI_CONFIG_DATA_PROVIDER: "Unable to initialize UI Config data provider",
    MSG_ERROR_FETCHING_FORMS: "Error fetching forms",
    MSG_ERROR_FETCHING_TEMPLATES: "Error fetching templates",
    MSG_ERROR_MORE_RECORDS_FOUND: "Expected one record but found more than one",
    MSG_ERROR_FETCHING_METADATA: "Error fetching metadata for entity",
    MSG_ERROR_FAILED_TO_INITIALIZE_FORM: "Failed to initialize form",
    MSG_ERROR_FAILED_TO_FETCH_DATA: "Failed to fetch data for form",
    MSG_ERROR_FAILED_TO_SAVE_FORM: "Failed to save form",
    MSG_ERROR_SESSION_TOKEN_INVALID: "Invalid session token",
    MSG_ERROR_LOGIN_FAILURE: "Login failure",
    MSG_ERROR_OFFLINE_LOGIN_FAILURE: "Login failure in offline mode",
    MSG_ERROR_CALLBACK_NOT_A_FUNCTION: "Callbacks not a function",
    MSG_ERROR_FAILED_TO_CREATE_RECORD: "Failed to create record",
    MSG_ERROR_FAILED_TO_UPDATE_RECORD: "Failed to update record",
    MSG_ERROR_LOADING_TEMPLATES: "Error loading templates",
    MSG_ERROR_FIELD_NOT_PRESENT: "Invalid field mapped",
    MSG_ERROR_ENITTY_NOT_PRESENT: "Invalid Entity mapped",
    MSG_TENANT_NOT_SYNC_ENABLED: "Cloud is not sync enabled",
    MSG_INVALID_QUERY: "Query framed is invalid",
    MSG_ERROR_FETCH_USER_PROFILE_FAILURE: "Unable to fetch the user profile",
    MSG_ERROR_UNABLE_TO_SYNC: "Sync failed",
    MSG_ERROR_UNABLE_TO_GET_SYNC_CONFIG: "Unable to get sync configuration",
    MSG_ERROR_NETWORK_UNAVAILABLE: "Device is not connected to network. Please check your connection and try again.",
    MSG_ERROR_UNABLE_TO_RESET_SYNC: "Sync reset failed",
    MSG_HAMBURGER_MENU_WRONG_CONFIG: "Wrong Hamburger Menu config",
    MSG_HAMBURGER_MENU_INITIALIZATION_FAILED: "Failed to initialize Hamburger Menu",
    MSG_HAMBURGER_MENU_WRONG_FORM_TYPE: "Hamburger Menu wrong form type",
    MSG_HAMBURGER_MENU_WRONG_SKIN: "Main flex form skin is not provided with form bg color",
    MSG_RESOURCE_NO_CREATE_PERMISSION: "User does not have permission to create {}",
    MSG_RESOURCE_NO_READ_PERMISSION: "User does not have permission to read{}",
    MSG_RESOURCE_NO_UPDATE_PERMISSION: "User does not have permission to update {}",
    MSG_RESOURCE_NO_DELETE_PERMISSION: "User does not have permission to delete {}",
    MSG_NETWORK_UNAVAILABLE: "Network unavailable or disconnected",
    MSG_ERROR_NO_RESPONSE_RECEIVED: "No response received",
    MSG_ERROR_IN_SET_ADDITIONAL_FIELDS: "Error in setAdditionalFields",
    MSG_ERROR_IN_SET_QUERY: "Error in setQuery",
    MSG_ERROR_IN_SET_QUERY_PARAMS: "Error in setQueryParams",
    MSG_ERROR_ENTER_VALID_TENANT_NAME: "Enter a valid cloud name",
    MSG_ERROR_NAVIGATION_CONTROLLER_NOT_DEFINED: "Navigation controller not defined",
    MSG_ERROR_INVALID_ENTITY: "Invalid Entity Name",
    MSG_VERSION_UNSUPPORTED_ERROR: " You are trying to connect to older version of the Kony MobileFabric App Services. This app requires Kony MobileFabric App Services version to be $VERSION or greater ",
    MSG_ERROR_ASSOCIATING_RECORD: "Error associating record",
    MSG_ERROR_DISOCIATING_RECORD: "Error dissociating record",
    MSG_ERROR_NOT_INSTANCE_OF_CUSTOMINFO: "info object not an instance of kony.model.CustomInfo class",
    MSG_ERROR_FORM_ENTITY_NOT_FOUND: "Entity of form not found",
    MSG_ERROR_FORM_PRIMARY_FIELDVALUE_NOT_FOUND: "Primary field value for form is not found",
    MSG_ERROR_CANNOT_ASSOCIATE_DISSOCIATE_OF_SAME_ENTITY: "Cannot associate/dissociate records of same entity",
    MSG_ERROR_SAVING_MULTI_ENTITY_LABEL: "Error saving mutli entity label data",
    MSG_ERROR_SAVING_CHILD_CONTAINER: "Error saving child container data",
    MSG_UPGRADE_UNAVAILABLE: "upgraded version of this cloud is not available, please try diabling connect to upgraded version",
    MSG_ERROR_I18N: "I18n Error ",
    MSG_INVALID_LOGIN_HANDLER_RESPONSE: "invalid response object returned by login handler",
    MSG_ERROR_FAILED_TO_QUERY_DATA: "failed to query data for the widget",
    MSG_ERROR_BATCH_INSERT: "Exception occurred while batchInsert",
    MSG_ERROR_LOCAL_DB_CONNECTION: "Error in getting localdb connection",
    MSG_ERROR_EXECUTE_SINGLE_SQL_QUERY: "Exception occurred while executeSingleSqlQuery",
    MSG_ERROR_DECODING_BASE64_FORMJS: "Error while decoding base64 formJS",
    MSG_ERROR_LOADING_THEME: "error loading theme",
    MSG_ERROR_SETTING_THEME: "error setting theme to the application",
    MSG_ERROR_FETCHING_THEME: "error fetching theme from datasource",
    MSG_ERROR_MULTIPLE_DEFAULT_THEME: "error, more than once default themes returned",
    MSG_ERROR_CREATING_THEME: "error while creating theme",
    MSG_ERROR_METHOD_INVALID: "method type invalid , should be either GET/POST/PUT/DELETE",
    MSG_ERROR_INVALID_HTTPCUSTOMREQUEST_INPUT: "method type expected, httpcustomrequest accepts a string parameter of the method type",
    MSG_ERROR_INVALID_INPUT: "expected two string inputs",
    MSG_ERROR_INVALID_INPUT_TYPE: "expected string type as input",
    MSG_ERROR_INVALID_PAYLOAD: "invalid payload, expected only one parameter",
    MSG_ERROR_INVALID_DATAPROVIDER_TYPE: "expected rest dataprovider object",
    MSG_ERROR_DATAPROVIDER_NOT_INTIALIZED: "dataprovider object not intialized",
    MSG_ERROR_INVALID_CUSTOMSERVICE_INPUT_PARAM: "expected httpcustomrequest input param",
    MSG_ERROR_UNEXPECTED_CUSTOMRESPONSE: "expected customresponse key in response",
    MSG_CLOUD_UNAUTHORISED_FOR_DATAPROVIDER: "Invalid dataProviderKey or Present cloud is not authorised for the suggested data provider",
    MSG_CREDSTORE_NOT_FOUND: "Login failure in offline mode. CredStore is not created yet",
    MSG_CREDENTIAL_MISMATCH_WITH_CREDSTORE: "Login failure in offline mode. User Credentials did not match with credStore",
    MSG_ERROR_IN_ENTITY_DEFINITION: "Error in getting entity definition in model",
    MSG_ERROR_IN_RETREIVNING_CHILD_RELATIONSHIPLIST: "Error in retreiving child relationship list in model",
    MSG_ERROR_FETCHING_DATA_FOR_COLUMNS: "Error fetching data for columns in model",
    MSG_ERROR_FETCHING_CHILD_RELATIONSHP_FOR_ENTITY: "Error fetching relationship for child entity in model",
    MSG_ERROR_PROCESSING_CHILD_RELATIONSHIPLIST: "Error processing child relationship list in getRelationshipForChildEntityName in model",
    MSG_ERROR_FETCH: "Error in fetching data in model",
    MSG_ERROR_CREATE: "Error in create in model",
    MSG_ERROR_UPDATE: "Error in update in model",
    MSG_ERROR_UPDATE_BY_PRIMARY_KEY: "Error in update by primarykey in model",
    MSG_ERROR_DELETE: "Error in delete in model",
    MSG_ERROR_DELETE_BY_PRIMARY_KEY: "Error in delete by primarykey in model",
    MSG_ERROR_FETCH_IN_CONTROLLER_EXTENSION: "Error in fetch in controller extension",
    MSG_ERROR_BINDDATA_IN_CONTROLLER_EXTENSION: "Error in bindData in controller extension",
    MSG_ERROR_SAVEDATA_IN_CONTROLLER_EXTENSION: "Error in saveData in controller extension",
    MSG_ERROR_DELETEDATA_IN_CONTROLLER_EXTENSION: "Error in deleteData in controller extension",
    MSG_ERROR_ENTITY_CONTROLLER_NOT_DEFINED: "Model is not defined",
    MSG_ERROR_FETCH_IN_BASE_CONTROLLER_EXTENSION: "Error in fetchData of BaseControllerExtension",
    MSG_ERROR_BIND_IN_BASE_CONTROLLER_EXTENSION: "Error in bindData of BaseControllerExtension",
    MSG_ERROR_SAVE_IN_BASE_CONTROLLER_EXTENSION: "Error in saveData of BaseControllerExtension",
    MSG_ERROR_DELETE_IN_BASE_CONTROLLER_EXTENSION: "Error in saveData of BaseControllerExtension",
    MSG_ERROR_GENERATE_RECORDS_IN_BASE_CONTROLLER_EXTENSION: "Error in generateRecords of BaseControllerExtension",
    MSG_ERROR_ACTION_NOT_FOUND_IN_CONTROLLER: "Error action not found in controller for actionName",
    MSG_ERROR_APP_INIT_FORMS: "Error in application init forms",
    MSG_ERROR_ORM_CONTROLLER_FETCH_RECORDS: "Error in persistent controller's fetch records",
    MSG_ERROR_ORM_CONTROLLER_FETCH_RECORDS_QUERIES_NOT_DEFINED: "Error in persistent controller's fetch records, odata queries not defined",
    MSG_ERROR_ORM_CONTROLLER_FETCH_RECORD_PK_NOT_DEFINED: "Error in persistent controller's fetch by PK, PK not defined",
    MSG_ERROR_ORM_CONTROLLER_FETCH_RECORD_PK: "Error in persistent controller's fetch by PK",
    MSG_ERROR_ORM_CONTROLLER_FETCH_RECORDS_BY_NATIVE_QUERY: "Error in persistent controller's fetch with native query",
    MSG_ERROR_ORM_CONTROLLER_FETCH_RECORDS_BY_COLUMN_DEFINITION: "Error in persistent controller's fetch by columns",
    MSG_ERROR_ORM_CONTROLLER_SAVE_RECORD: "Error in persistent controller's save record",
    MSG_ERROR_ORM_CONTROLLER_SAVE_RECORDS: "Error in persistent controller's save records",
    MSG_ERROR_ORM_CONTROLLER_REMOVE_RECORD: "Error in persistent controller's remove record",
    MSG_ERROR_ORM_CONTROLLER_REMOVE_RECORDS: "Error in persistent controller's remove records",
    MSG_ERROR_ORM_CONTROLLER_FETCH_CHILD_RELATIONSHIP: "Error in persistent controller's fetch child relationship",
    MSG_ERROR_ORM_CONTROLLER_RESULTSET_TO_OBJECT_CONVERSION: "Error in persistent controller's resultset to record object conversion",
    MSG_ERROR_ORM_CONTROLLER_PREPARE_FETCH_QUERY: "Error in persistent controller's prepare fetch query",
    MSG_ERROR_ORM_CONTROLLER_UNMARSHALL_TO_MODEL_OBJECT: "Error in persistent controller's unmarshall record object to form model object",
    MSG_ERROR_ORM_CONTROLLER_FETCH_AND_BIND_DATA_STRATEGY: "Error in persistent controller's fetch and bind data strategy",
    MSG_ERROR_GET_DATA_WIDGETS_OF_FORM: "Error getting data widgets of form",
    MSG_ERROR_GETTING_QUERY_WIDGETS_MAPPING: "Error getting queryWidgetsMapping",
    MSG_ERROR_PREPARING_QUERY_STRING: "Error in preparing query string",
    MSG_ERROR_NOTIFYING_OBSERVERS: "Error notifying observers of formmodel",
    MSG_ERROR_GET_WIDGET_DATA_FORMMODEL: "Error getting widget data of formmodel",
    MSG_ERROR_SET_WIDGET_DATA_FORMMODEL: "Error setting widget data of formmodel",
    MSG_ERROR_FORMMODEL_PROPERTY_VALUE_CHANGED: "Error in propertyValueChanged of formmodel",
    MSG_ERROR_FORMMODEL_CLEAR: "Error in clear of formmodel",
    MSG_ERROR_FORMMODEL_DESTROY: "Error in destroy of formmodel",
    MSG_ERROR_FORMMODEL_UPDATE: "Error in update of formmodel",
    MSG_ERROR_FORMMODEL_SET_MASTERDATA: "Error in setMasterData of formmodel",
    MSG_ERROR_FORMMODEL_GET_MASTERDATA: "Error in getMasterData of formmodel",
    MSG_ERROR_FORMMODEL_SET_VIEW_ATTRIBUTE: "Error settingView attribute by property in formmodel",
    MSG_ERROR_FORMMODEL_GET_VIEW_ATTRIBUTE: "Error gettingView attribute by property in formmodel",
    MSG_ERROR_FORMMODEL_PERFORM_ACTION_ONVIEW: "Error in performActionOnView of formmodel",
    MSG_ERROR_FORMMODEL_PERFORM_ACTION: "Error in performAction of formmodel",
    MSG_ERROR_FORMMODEL_PROPERTIES_INIT: "Error in initialization of formmodel properties",
    MSG_ERROR_FETCH_IN_CONTROLLER: "Error in fetch of controller",
    MSG_ERROR_BIND_IN_CONTROLLER: "Error in bind of controller",
    MSG_ERROR_SAVE_IN_CONTROLLER: "Error in save of controller",
    MSG_ERROR_DELETE_IN_CONTROLLER: "Error in delete of controller",
    MSG_ERROR_LOADDATA_SHOWFORM_CONTROLLER: "Error in load data and show form of controller",
    MSG_ERROR_GETTING_ENTITY_CONTROLLER: "Error getting model from formcontroller",
    MSG_ERROR_GETTING_ENTITY_METADATA: "Error getting entity metadata from formcontroller",
    MSG_ERROR_INVALID_DATA_OBJECT: "Error while reading data, expected data object",
    MSG_ERROR_PROCESSDATA_IN_CONTROLLER_EXTENSION: "Error while formatting data in controller extension",
    MSG_ERROR_FORMATDATA_IN_BASE_CONTROLLER_EXTENSION: "Error while formatting data in base controller extension",
    MSG_ERROR_FORMATDATA_IN_CONTROLLER: "Error while formatting data in controller",
    MSG_ERROR_VALIDATION_UPDATE: "Error validating data in update model",
    MSG_ERROR_VALIDATION_CREATE: "Error validating data in create model",
    MSG_ERROR_SHOWFORM_IN_CONTROLLER_EXTENSION: "Error in showForm in controller extension"
};


kony.license = {};
var appConfig = undefined;
kony.license.disableMetricReporting = function() {
    kony.ds.save(["true"], "LicenseDisableFlag");
}

kony.licensevar = {};
kony.licensevar.didAppWentInBackground = false;
kony.license.timeoutValue = 14400 ;
kony.license.version = "9.0.0.1";
kony.licensevar.currentSessionId = "";
kony.licensevar.latestSessionCreationTimestamp = "";
kony.licensevar.maxSessionCountLimit = 100;
kony.licensevar.changeHandlers = [];
kony.licensevar.isLicenseUrlAvailable = true;
kony.licensevar.isISTNetworkCallProcessingInProgress = false;
kony.licensevar.deferredNewSessionsCounter = 0;
kony.licensevar.isInteractive = false;
kony.licensevar.isPostAppInitCalled = false;
kony.licensevar.timesAppBecomeInteractive = 0;
kony.licensevar.maxDeferSessionCount = 15;
kony.licensevar.appLaunch = "appLaunch";

kony.licensevar.appStateCallbackFunction = function () {
    kony.licensevar.timesAppBecomeInteractive++;
    kony.license.log("appStateCallbackFunction:: isPostAppInitCalled :" + kony.licensevar.isPostAppInitCalled + " ,isInteractive :" + kony.licensevar.isInteractive);
    if (kony.licensevar.isInteractive === false) {
        kony.licensevar.isInteractive = true;
        kony.license.log("App is in interactive state");
        if (kony.licensevar.isPostAppInitCalled === true) {
            
            kony.license.log("Creating and sending a new interactive session details.");
            kony.license.sendNewIST();
        }
    }
    else {
        kony.license.log("Warning: appStateCallbackFunction is called "+kony.licensevar.timesAppBecomeInteractive+" times, ignoring the interactive app state event");
    }
};

kony.licensevar.callbacksObjList = {};
kony.licensevar.callbacksObjList.isAppLaunchedForInteraction = {};
kony.licensevar.callbacksObjList.isAppLaunchedForInteraction.appStateCallbackFunction = kony.licensevar.appStateCallbackFunction;

kony.license.maxWaitTimeToHandleMultipleNewSessions = 60;


kony.license.setLogging = function(boolValue){
    if(boolValue === true){
        kony.ds.save([true], "LicenseLoggingFlag");
    }else{
        kony.ds.save([false], "LicenseLoggingFlag");
    }
}

kony.license.log = function(msg){
    try{
        var logCondition = kony.ds.read("LicenseLoggingFlag");
    }catch(e){
        
    }
    if (logCondition != undefined && logCondition[0] != undefined && logCondition[0]!=null && logCondition[0]===true) {
        kony.print("[License] :"+msg);
    }
}

kony.license.isLicenseUrlAvailable = function() {
    return kony.licensevar.isLicenseUrlAvailable;
}

kony.license.setIsLicenseUrlAvailable = function(value) {
    kony.licensevar.isLicenseUrlAvailable = value;
}

kony.license.getSessionId = function() {
    return kony.licensevar.currentSessionId;
}


var konyUserID = function () {

    var dataStorekeys = {};
    dataStorekeys.encryptedKonyuserId = "konyUserID_ENC";
    dataStorekeys.konyuserId = "konyUserID";
    var encryptionSalt = "konyUserID_ENC";
    var encryptionAlgo = "aes";

    
    var getKonyUserID = function () {
        var userInfo = new Array();
        var userId = kony.ds.read(dataStorekeys.encryptedKonyuserId);
        if (userId === undefined || userId === null || userId[0] === undefined) {
            userId = kony.ds.read(dataStorekeys.konyuserId);
            if (userId != undefined && userId != null && userId[0] != undefined) {
                userId = userId[0];
                setKonyUserID(userId);
                kony.ds.remove(dataStorekeys.konyuserId);
            }
            else {
                return null;
            }

        }
        else {
            userId = decryptText(userId[0], encryptionSalt, encryptionAlgo);
        }

        userInfo.push(userId);
        return userInfo;
    };

    
    var setKonyUserID = function (userId) {
        if (userId == undefined || userId == null || typeof userId !== 'string') {
            return;
        }

        var userId = encryptText(userId, encryptionSalt, encryptionAlgo);
        var userInfo = new Array();
        userInfo.push(userId);
        kony.ds.save(userInfo, dataStorekeys.encryptedKonyuserId);
    };

    
    function generateSecureKeyFromText(salt) {
        var secureKey = salt;

        if (salt != undefined || salt != null) {
            secureKey = kony.crypto.newKey("passphrase", 128, {
                passphrasetext: salt,
                subalgo: encryptionAlgo,
                passphrasehashalgo: "md5"
            });
        }
        return secureKey;
    }

    
    function encryptText(text, salt, encryptionAlgo) {
        var channel = kony.os.deviceInfo().name.toString().toLowerCase();
        if (channel.indexOf("windows") > -1) {
            return text;
        }

        var secureSalt = generateSecureKeyFromText([ salt ]);
        var encryptedText = kony.crypto.encrypt(encryptionAlgo, secureSalt, text, {});
        if(channel !== "thinclient") {
            encryptedText = kony.convertToBase64(encryptedText);
        }
        return encryptedText;
    }

    
    function decryptText(text, salt, decryptionAlgo) {
        var channel = kony.os.deviceInfo().name.toString().toLowerCase();
        if (channel.indexOf("windows") > -1) {
            return text;
        }

        var secureSalt = generateSecureKeyFromText([ salt ]);
        var rawBytes = text;
        if(channel !== "thinclient") {
            rawBytes = kony.convertToRawBytes(text);
        }

        var decryptText =kony.crypto.decrypt(decryptionAlgo, secureSalt, rawBytes, {});
        return decryptText;
    }

    return {"set": setKonyUserID, "get": getKonyUserID};
}

kony.license.registerChangeListener = function(changeHandler) {

    if (!changeHandler) {
        return;
    }
    
    var changes = {};
    var userId = konyUserID().get.call(this)
    changes["sessionId"] = kony.licensevar.currentSessionId;
    if (userId != undefined && userId[0] != undefined && userId[0]!=null) {
        changes["userId"] = userId[0];
    }
    changeHandler(changes);

    
    kony.licensevar.changeHandlers.push(changeHandler);
};

kony.license.notifyChangesToListeners = function() {
    for (var i = 0; i < kony.licensevar.changeHandlers.length; i++) {
        var changes = {};
        var userId = konyUserID().get.call(this);
        changes["sessionId"] = kony.licensevar.currentSessionId;
        if (userId != undefined && userId[0] != undefined && userId[0]!=null) {
            changes["userId"] = userId[0];
        }
        var changeHandler = kony.licensevar.changeHandlers[i];
        changeHandler(changes);
    }
};



kony.license.processDeferredNewSessions = function () {
    kony.license.log("sending deferred launch date - "+kony.licensevar.currentSessionId);
    kony.licensevar.isISTNetworkCallProcessingInProgress = false;
    kony.licensevar.deferredNewSessionsCounter = 0;
    kony.license.pushKonySessionsToServer(true);
}



kony.license.startLicenseService = function() {
        "use strict";
        var deviceInfo = kony.os.deviceInfo();
        kony.license.log("startLicenseService deviceInfo " + JSON.stringify(deviceInfo));
        

        function getLicenseUrl() {
            var url = "";
            if (appConfig.isturlbase) {
                url = appConfig.isturlbase + "/IST";
            } else if (appConfig.secureurl) {
                url = getFromServerUrl(appConfig.secureurl, "IST");
            } else if (appConfig.url) {
                url = getFromServerUrl(appConfig.url, "IST");
            }
            return url;
        }

       
        

        function getFromServerUrl(url, path) {
            if (!url) {
                return null;
            }
            
            
            kony.license.log("Entering into getfromserverurl when IST-base url is not defined");
            if (deviceInfo.name === "thinclient") {
                url = url.replace(/mwservlet\/*$/i, "");
                return url + path;
            } else {
                var exactSubString = url.match(/mwservlet/i);
                var newUrl = null;
                if (exactSubString) {
                    var exactSubStringLength = "mwservlet".length;
                    var lastSubStringIndex = url.lastIndexOf(exactSubString);
                    var subString = url.slice(0, lastSubStringIndex);
                    var index = (lastSubStringIndex + exactSubStringLength);
                    var subString2 = url.slice(index, url.length);
                    var has = /[a-zA-Z0-9]/.test(subString2);
                    if (!has) {
                        newUrl = subString;
                    } else {
                        newUrl = url;
                    }
                } else {
                    newUrl = url;
                }
                return newUrl + path;
            }
        }

        function getApplicationType(name) {
            if (name === "thinclient") {
                return "spa";
            }
            var appMode = kony.application.getApplicationMode();
            if (appMode === constants.APPLICATION_MODE_NATIVE) {
                return "native";
            } else if (appMode === constants.APPLICATION_MODE_HYBRID) {
                return "hybrid";
            } else if (appMode === constants.APPLICATION_MODE_WRAPPER) {
                return "mixedmode";
            } else {
                return "";
            }
        }

        

        kony.setUserID = function(userId,fromLoginFlag) {
            
			if(fromLoginFlag == undefined || fromLoginFlag == null){
				fromLoginFlag = false;
			}

            var userIDflagGet = kony.ds.read("userIDFromLicenseFlag");
             
            if(userIDflagGet && (userIDflagGet[0] == "true") && fromLoginFlag) {
                return;
            }

            

            
            if(!fromLoginFlag) {
                var userIDflagSet = new Array;
                userIDflagSet.push("true");
                kony.ds.save(userIDflagSet,"userIDFromLicenseFlag");
            }

            
            konyUserID().set.call(this, userId);
            kony.license.notifyChangesToListeners();
        }

        kony.license.generateUUID = function() {
                var S4 = function() {
                    return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
                };
                return (new Date().getTime() + '-' + S4() + '-' + S4() + '-' + S4());
        }
        
        kony.license.isCloud = function() {
                
                

                var isLicenseEnabled = true;
                var LicenseCheck = kony.ds.read("LicenseDisableFlag");
                if (LicenseCheck && (LicenseCheck[0] === "true" || LicenseCheck === "true" ))  {
                    isLicenseEnabled = false;
                }
                if (kony.license.isLicenseUrlAvailable() === false) {
                    isLicenseEnabled = false;
                }
                return isLicenseEnabled;
        }

        
        kony.license.getCurrentDateTime = function() {
                kony.license.log("getCurrentDateTime..");
                var nowDate, month, formatDate;
                nowDate = new Date();
                month = nowDate.getUTCMonth() + 1;
                formatDate = (("00" + nowDate.getUTCFullYear()).slice(-4)) + "-" + (("00" + month).slice(-2)) + "-" + (("00" + nowDate.getUTCDate()).slice(-2)) + " " + (("00" + nowDate.getUTCHours()).slice(-2)) + ":" + (("00" + nowDate.getUTCMinutes()).slice(-2)) + ":" + (("00" + nowDate.getUTCSeconds()).slice(-2));
                return formatDate;
        }

        

        kony.license.appendLicenseTrackingKeys = function(requestType,reportData) {
                kony.license.log("appendLicenseTrackingKeys deviceinfo ---> " + JSON.stringify(deviceInfo));
                var inputParams = {};
                 if (kony.license.isCloud() === true) {
                    inputParams.plat = deviceInfo.name;
                    if (typeof(kony.sdk) !== "undefined"){
                        inputParams.chnl = kony.sdk.getChannelType();
                        inputParams.did = kony.sdk.getDeviceId();
                        inputParams.plat = kony.sdk.getPlatformName();    
                    }
                    else{
                        
                        
                        
                        inputParams.chnl = "fpApp";
                        inputParams.did = "fp-"+kony.license.generateUUID();
                        inputParams.plat = "fp";
                    }
                    
                    inputParams.aid = appConfig.appId;
                    inputParams.aver = appConfig.appVersion;
                    inputParams.aname = appConfig.appName;
                    
                    if (typeof konyRef !== "undefined" && konyRef != null && konyRef.mainRef) {
                        inputParams.mfaid = konyRef.mainRef.appId;
                        inputParams.mfbaseid = konyRef.mainRef.baseId;
                        inputParams.mfaname = konyRef.mainRef.name;
                    }
                    if (kony.application.getCurrentForm()) {
                        var fid = kony.application.getCurrentForm().id;
                        if (fid) {
                            inputParams.fid = fid;
                        }
                    }
                    inputParams.atype = getApplicationType(deviceInfo.name);
                    inputParams.os = deviceInfo.version;
                    inputParams.stype = "b2c";
                    inputParams.dm = deviceInfo.model;
                    inputParams.ua = kony.os.userAgent();
                    inputParams.sessiontype = kony.licensevar.isInteractive === true ? "I" : "NI";
                     var userId = konyUserID().get.call(this);
                    if (userId !== undefined && userId !== null && userId.length > 0) {
                        inputParams.kuid = userId[0];
                    } else {
                        inputParams.kuid = "";
                    }
                    if (requestType === "session") {
                        kony.license.checkAndCreateSession();
                        if(kony.licensevar.isISTNetworkCallProcessingInProgress === true || kony.licensevar.deferredNewSessionsCounter > 0){
                            
                            if(kony.licensevar.deferredNewSessionsCounter > 0) {
                                try{
                                    kony.license.log("cancelling the previous timer, as in span of "
                                        +kony.license.maxWaitTimeToHandleMultipleNewSessions+ " seconds, a new IST was fired immediately");
                                    kony.timer.cancel("konySession"+(kony.licensevar.deferredNewSessionsCounter-1));
                                } catch(erObj) {
                                    kony.license.log("error - "+JSON.stringify(erObj)+",  while cancelling the deferred session timer" +
                                        " to send launch dates with timer id"+(kony.licensevar.deferredNewSessionsCounter-1));
                                }
                            }
                            kony.timer.schedule(("konySession"+(kony.licensevar.deferredNewSessionsCounter++)),
                                kony.license.processDeferredNewSessions, kony.license.maxWaitTimeToHandleMultipleNewSessions, false);
                                kony.license.log("another session is in progress , we will try again");
                            return {}; 
                        }
                        
                        var offlineData = kony.license.getStoredSession();
                        inputParams.launchDates = offlineData;
                        kony.licensevar.isISTNetworkCallProcessingInProgress = true;
                        inputParams.svcid = "RegisterKonySession";
                        kony.license.log("---------->LaunchDates : " + inputParams.launchDates);
                    } else {
                        var uuid = kony.ds.read("konyUUID");
                        if (uuid !== undefined && uuid !== null && uuid.length > 0) {
                            inputParams.rsid = uuid[0];
                        } else {
                            inputParams.rsid = kony.license.generateUUID().toString();
                        }
                    }
                }
                kony.license.log("input params in appendLicenseTrackingKeys are " + JSON.stringify(inputParams));
                return inputParams;
            
        }

        
        kony.license.checkAndCreateSession = function() {
                kony.license.log("check and create session..");
                var uuid = kony.ds.read("konyUUID");
                if (uuid !== undefined && uuid !== null && uuid.length > 0) {
                   kony.licensevar.currentSessionId = uuid[0];
                } else {
                   kony.license.createSession();
                } 
        }

        
        var sdkTimerCounter = 0 ;
        kony.license.createSession = function() {
            
            if(sdkTimerCounter != 0) {
                try{
                    kony.timer.cancel("konyLicenseTimeout"+(sdkTimerCounter-1));
                } catch(erObj) {
                    kony.license.log("the error object while cancelling the timer is"+ erObj);
                }
            }
            var uuid = new Array();
            kony.licensevar.currentSessionId = kony.license.generateUUID().toString();
            kony.licensevar.latestSessionCreationTimestamp = kony.license.getCurrentDateTime();
            uuid.push(kony.licensevar.currentSessionId);
            kony.ds.save(uuid, "konyUUID");
            kony.license.storeSession();
            kony.license.notifyChangesToListeners();
            kony.timer.schedule(("konyLicenseTimeout"+(sdkTimerCounter++)),kony.license.sendNewIST,kony.license.timeoutValue,false);
        }

        kony.license.storeSession = function(){
            var uuid = kony.licensevar.currentSessionId;
            var offlineData = kony.license.getStoredSession();
            if (offlineData === undefined || offlineData === null) {
                offlineData = new Array();
            }
            var currentSession = new Array();
            currentSession.push(uuid);
            currentSession.push(kony.licensevar.latestSessionCreationTimestamp);
            var sessionType = kony.licensevar.isInteractive === true ? "I" : "NI";
            currentSession.push(sessionType);

            if(offlineData.length === 0 || offlineData[(offlineData.length-1)][0] !== currentSession[0]){
                if(offlineData.length > 0 && kony.licensevar.deferredNewSessionsCounter > 0){
                    
                    offlineData.pop();
                }
                offlineData.push(currentSession);
            }else{
                kony.license.log("Ignoring duplicate session: "+JSON.stringify(currentSession));
                offlineData[offlineData.length - 1][2] = kony.licensevar.isInteractive.toString();
            }
            if(offlineData.length > kony.licensevar.maxSessionCountLimit){
                kony.license.log("Trimming to latest " + kony.licensevar.maxSessionCountLimit + " records, total records found - " + offlineData.length);
                var sliceValue = offlineData.length - kony.licensevar.maxSessionCountLimit;
                offlineData = offlineData.slice(sliceValue);
            }
            kony.ds.save(offlineData, "konyOfflineAccessData");
            kony.license.log("offlineData saved");
        };

        kony.license.getStoredSession = function(){
            return kony.ds.read("konyOfflineAccessData");
        };
            
        kony.license.sendNewIST = function() {
            kony.license.createSession();
            kony.license.pushKonySessionsToServer(true);           
        }

        
        kony.license.handleISTInvocation = function(sessionURL, input, options) {
                var storedSessions = kony.license.getStoredSession();
                if((!kony.licensevar.isInteractive && storedSessions && (storedSessions.length >= kony.licensevar.maxDeferSessionCount)) || kony.licensevar.isInteractive) {
                   kony.license.invokeIST(sessionURL, input, kony.license.licenseUsageServiceSuccessCallback, kony.license.licenseUsageServiceFailureCallback, options);
                } else {
                   kony.licensevar.isISTNetworkCallProcessingInProgress = false;
                }
        }

        
        kony.license.licenseUsageServiceSuccessCallback = function (result){
                kony.licensevar.isISTNetworkCallProcessingInProgress = false;
                kony.license.log("launch dates sent successfully. result - "+JSON.stringify(result));
                
                kony.ds.remove("konyOfflineAccessData");
                kony.ds.remove("konyOfflineSessionsCount");
        }

        
        kony.license.licenseUsageServiceFailureCallback = function(result)
        {       
                kony.licensevar.isISTNetworkCallProcessingInProgress = false;
                kony.license.log("launch dates weren't sent successfully. result - "+JSON.stringify(result));
                
                var count, offlineCount;
                
                offlineCount = kony.ds.read("konyOfflineSessionsCount");
                if (offlineCount === undefined || offlineCount === null || offlineCount.length < 1) {
                    offlineCount = new Array();
                    offlineCount.push(1);
                } else if (!(offlineCount[0] >= 500)) {
                    
                    count = offlineCount[0] + 1;
                    offlineCount[0] = count;
                }
                kony.ds.save(offlineCount, "konyOfflineSessionsCount");
            }

        kony.license.captureKonyLicenseUsage = function(newLaunch) {
            
            kony.license.pushKonySessionsToServer(newLaunch);
        }

        
        kony.license.pushKonySessionsToServer = function(newLaunch) {
                kony.license.log("capturing license information..");
                
                var nowDate, lastDate, diff, sessionURL;
                var timeCheck = 1800000;
                var isNewSession = true;
                if (newLaunch === undefined || newLaunch === null) {
                    newLaunch = false;
                } else if (newLaunch !== true) {
                    newLaunch = false;
                }
                if (kony.license.isCloud() === false) {
                    kony.license.log("session tracking is turned off");
                    isNewSession = false;
                }
                if (kony.ds.read("konyLastAccessTime") !== undefined && kony.ds.read("konyLastAccessTime") !== null) {
                    nowDate = new Date();
                    lastDate = new Date(kony.ds.read("konyLastAccessTime")[0]);
                    diff = nowDate.getTime() - lastDate.getTime();
                    if (diff < timeCheck && newLaunch === false) {
                        isNewSession = false;
                    } else {
                        kony.ds.remove("konyLastAccessTime");
                    }
                }

                if (isNewSession === true) {
                    var input = {};
                    var options = {};
                    if (deviceInfo.name !== "thinclient") {
                        options["httpRequestOptions"] = [];
                        options["httpRequestOptions"]["timeoutIntervalForRequest"]=60;  
                    }
                    sessionURL = getLicenseUrl();
                    input.konyreportingparams = JSON.stringify(kony.license.appendLicenseTrackingKeys("session"),null);
                    options["disableIntegrity"] = true;
                    if(input.konyreportingparams !== "{}"){
                    	kony.license.handleISTInvocation(sessionURL, input, options);
                    }
                }
        }

        
        kony.license.backgroundTimeCapture = function() {
                kony.license.log("app is going to background..");
                if (kony.license.isCloud() === true) {
                    var accessDetails = new Array();
                    accessDetails.push(new Date().toString());
                    kony.ds.save(accessDetails, "konyLastAccessTime");
                }
        }

        
        kony.license.clearLastAccess = function() {
                kony.license.log("clear last access..");
                if (kony.license.isCloud() === true) {
                    kony.ds.remove("konyLastAccessTime");
                }
        }

        
        kony.license.setAppCallbacksOverride = function() {
                kony.license.log("overriding kony.application.setApplicationCallbacks..");
                var oldImplementation = kony.application.setApplicationCallbacks;

                function newImplementation(eventsDefinition) {
                    if (kony.license.isCloud() === true) {
                        if (eventsDefinition !== undefined && eventsDefinition !== null) {
                            if (eventsDefinition.onforeground !== undefined && eventsDefinition.onforeground !== null) {
                                var userForeFunction = eventsDefinition.onforeground;
                                var newForeFunction = function() {
                                    if(kony.licensevar.didAppWentInBackground === true){
                                        kony.license.pushKonySessionsToServer(false);
                                    }
                                    if (deviceInfo.name !== "thinclient " && typeof(kony.sync) !== "undefined") {
                                        kony.sync.isAppInBackground = false;
                                    }
                                    kony.licensevar.didAppWentInBackground = false;
                                    userForeFunction();
                                };
                                eventsDefinition.onforeground = newForeFunction;
                            }
                            if (eventsDefinition.onbackground !== undefined && eventsDefinition.onbackground !== null) {
                                var userBackFunction = eventsDefinition.onbackground;
                                var newBackFunction = function() {
                                    kony.licensevar.didAppWentInBackground = true;
                                    kony.license.backgroundTimeCapture();
                                    if (typeof(kony.sdk) !== "undefined" && typeof(kony.sdk.metric) !== "undefined") {
                                        kony.sdk.metric.saveInDS();
                                    }
                                    if (deviceInfo.name !== "thinclient " && typeof(kony.sync) !== "undefined") {
                                        kony.sync.isAppInBackground = true;
                                    }
                                    userBackFunction();
                                };
                                eventsDefinition.onbackground = newBackFunction;
                            }
                            if (eventsDefinition.onappterminate !== undefined && eventsDefinition.onappterminate !== null) {
                                var userTerminateFunction = eventsDefinition.onappterminate;
                                var newTerminateFunction = function() {
                                    kony.license.clearLastAccess();
                                    if (typeof(kony.sdk) !== "undefined" && typeof(kony.sdk.metric) !== "undefined") {
                                        kony.sdk.metric.saveInDS();
                                    }
                                    userTerminateFunction();
                                };
                                eventsDefinition.onappterminate = newTerminateFunction;
                            }
                        }
                    }
                    return oldImplementation(eventsDefinition);
                }
                kony.application.setApplicationCallbacks = newImplementation;
                if (deviceInfo.name !== "thinclient ") {
                    var callbackEvents = {
                        onforeground: function() {},
                        onbackground: function() {},
                        onappterminate: function() {}
                    };

                    kony.application.setApplicationCallbacks(callbackEvents);
                }
        }

        
        kony.license.invokeServiceAsyncOverride = function() {
                kony.license.log("overriding kony.net.invokeServiceAsync..");
                var oldImplementation = kony.net.invokeServiceAsync;

                function newImplementation(url, input, callback, config, requestType, reportData) {
                    if (kony.license.isCloud() === true) {
                        if (input === undefined || input === null) {
                            input = {};
                        }
                        if (input !== undefined && input !== null && !isGetRequest(input)) {
                            if (requestType !== undefined && requestType !== null) {
                                input.konyreportingparams = processKonyReportingParams(input.konyreportingparams, requestType, reportData);
                            } else {
                                input.konyreportingparams = processKonyReportingParams(input.konyreportingparams, null, null);
                            }
                        }
                    }
                    return oldImplementation(url, input, callback, config);

                    function processKonyReportingParams(params, requestType, reportData) {
                        var params2 = kony.license.appendLicenseTrackingKeys(requestType, reportData);
                        if (!params) {
                            return JSON.stringify(params2);
                        } else {
                            try {
                                if (typeof(params) === "string") {
                                    params = JSON.parse(params);
                                }
                                for (var key in params2) {
                                    if (typeof(params[key]) === "undefined") {
                                        params[key] = params2[key];
                                    }
                                }
                                return JSON.stringify(params);
                            } catch (e) {
                                kony.license.log("unable to parse params " + params);
                                return JSON.stringify(params2);
                            }


                        }
                    }

                    function isGetRequest(inputParams) {
                        if (inputParams && inputParams.httpconfig && inputParams.httpconfig.method && inputParams.httpconfig.method === "get") {
                            return true;
                        }
                        return false;
                    }
                }
                kony.net.invokeServiceAsync = newImplementation;
        }

        
        kony.license.invokeServiceSyncOverride = function() {
                kony.license.log("overriding kony.net.invokeServiceSync..");
                var oldImplementation = kony.net.invokeServiceSync;

                function newImplementation(url, input, isblocking) {
                    if (kony.license.isCloud() === true) {
                        if (input === undefined || input === null) {
                            input = {};
                        }
                        if (input !== undefined && input !== null) {
                            input.konyreportingparams = JSON.stringify(kony.license.appendLicenseTrackingKeys(null));
                        }
                    }
                    return oldImplementation(url, input, isblocking);
                }
                kony.net.invokeServiceSync = newImplementation;
        }

        
        kony.license.setAppInitializationEventsOverride = function() {
                var oldImplementation = kony.application.setApplicationInitializationEvents;
                function newImplementation(eventsDefinition) {
                    kony.license.log("setApplicationInitializationEvents events " + eventsDefinition);
                    kony.licensevar.isPostAppInitCalled = true;
                    if (kony.license.isCloud() === true) {
                        if (eventsDefinition !== undefined && eventsDefinition !== null) {
                            if (eventsDefinition.postappinit !== undefined && eventsDefinition.postappinit !== null) {
                                var userFunction = eventsDefinition.postappinit;
                                var newFunction = function() {
                                    kony.license.pushKonySessionsToServer(true);
									
									
									kony.ds.save([true], kony.licensevar.appLaunch);
									
                                    var userForm = userFunction.apply(this,arguments);
                                    if (userForm !== undefined || userForm !== null) {
                                        return userForm;
                                    }
                                };
                                eventsDefinition.postappinit = newFunction;
                            } else {
                                var newFunction = function() {
                                    kony.license.pushKonySessionsToServer(true);
									kony.ds.save([true], kony.licensevar.appLaunch);
                                };
                                eventsDefinition.postappinit = newFunction;
                            }
                        }
                    }
                    return oldImplementation(eventsDefinition);
                }
                kony.application.setApplicationInitializationEvents = newImplementation;
        }
        
       kony.license.apiOverride =function() {
                kony.license.log("Entering apiOverride..");
                
                if (deviceInfo.name !== "thinclient") {
                    kony.license.setAppCallbacksOverride();
                } else {
                    
                    kony.licensevar.isInteractive = true;
                }
                kony.license.invokeServiceAsyncOverride();
                kony.license.invokeServiceSyncOverride();
                kony.license.setAppInitializationEventsOverride();
        }

        kony.license.apiOverride();
        kony.application.addApplicationCallbacks(kony.licensevar.callbacksObjList);
        if (deviceInfo.name !== "thinclient") {
            Object.seal(kony.license);
            Object.freeze(kony.license);
        }
        kony.license.log("license loading completed");
}


kony.license.invokeIST = function(url, params, successCallback, failureCallback, options) {
    if(typeof(url)==="undefined" || url === undefined || url === null || url === ""){
        failureCallback("license url can't be null or empty");
        return;
    }

    var headers = {"Content-Type":"application/x-www-form-urlencoded"};
    
    if(kony.hasOwnProperty("sdk") && kony.sdk.getCurrentInstance && kony.sdk.getCurrentInstance()){
        url = kony.sdk.getCurrentInstance().appendGlobalParams(url, headers, params);
    }

    var httpRequest = new kony.net.HttpRequest();
    if(options && options["httpRequestOptions"] && options["httpRequestOptions"] instanceof Object && options["httpRequestOptions"]["timeoutIntervalForRequest"]){
        httpRequest.timeout = options["httpRequestOptions"]["timeoutIntervalForRequest"] * 1000;
    }
    httpRequest.open("POST", url);

    function localRequestCallback(result) {
        var readyState = Number(httpRequest.readyState.toString());
        var status = Number(httpRequest.status.toString());
        kony.license.log("localRequestCallback in state :"+readyState+" with status :"+status);
        var response = null;
        if (readyState === 4) {
            var isFailure = true;
            if ((status >= 200 && status < 300)|| status === 504) {
                if (status!== 504){
                    try{
                        response = JSON.parse(JSON.stringify(httpRequest.response)); 
                        if(typeof(response) === "string"){
                            response = JSON.parse(response);	
                        }
                        response.url = url;
                        if(response && (typeof(response.opstatus) === "undefined" || response.opstatus == 0)){
                            isFailure = false;
                        }
                    } catch (e){
                        kony.license.log("error while extracting response :"+e);
                    } 
                } else{
                    isFailure = false;
                }
            }
            if( isFailure === true){
                var errorResponse = {
                    "error": "failure in sending IST call with status as :" + status,
                    "url" : url
                };
                failureCallback(errorResponse);
            } else{
                successCallback(response);
            }
        }
    }

    
    paramsTable = new kony.net.FormData();
    for (var key in params) {
        if (typeof(params[key]) != "undefined") {
            if (typeof(params[key]) !== "string") {
                params[key] = JSON.stringify(params[key]);
            }
            paramsTable.append((key), (params[key]));
        }
    }
    kony.license.log("paramsTable formed is "+paramsTable.toString());
    
    for (var headerKey in headers ) {
        if(headers.hasOwnProperty(headerKey)){
            httpRequest.setRequestHeader(headerKey , headers[headerKey]);
        }
    }   
    
    httpRequest.onReadyStateChange = localRequestCallback;
    
    httpRequest.send(paramsTable);
    
}


function cloudSessionCallback() {
    kony.license.log("Cloud session timed out.");
    kony.ds.remove("konyLastAccessTime");
    kony.ds.remove("konyUUID");
    kony.ds.remove("konyCustomReportData");
    kony.ds.remove("konyOfflineAccessData");
    kony.license.pushKonySessionsToServer();
    kony.cloud.appevents.unregisterforidletimeout();
    kony.cloud.appevents.registerforidletimeout(30, cloudSessionCallback);
}

kony.license.startLicenseService();

$KC = (function() {

    
    var _directPropertyMap = {
        'margin': 'Margin',
        'padding': 'Padding',
        'children': 'Children',
        'visiblecells': 'visibleCells'
    };
    var _variancePropertyMap = {
        'Properties': '',
        'VaryingTops': '',
        'varyingLefts': '',
        'varyingHeights': '',
        'varyingWidths': '',
        'VisibilityChanged': ''
    };
    var _dataSet = {};
    var _inlinePropertyMap = {
        'name': 'Type',
        'id': 'ID',
        '__name': 'Type'
    };
    var _inlineFramePropertyMap = {
        'height': 'Height',
        'width': 'Width',
        'x': 'Left',
        'y': 'Top'
    };
    var _inlineClientBounds = {
        'x': 'LeftFromScreen',
        'y': 'TopFromScreen',
        'scrollheight': 'scrollheight',
        'scrollwidth': 'scrollwidth',
        'contentWidth': 'contentWidth',
        'contentHeight': 'contentHeight',
        'numberOfLines': 'numberOfLines'
    };

    var _timeConsumingEventData = {
        'touchstart': 'onTouchStart',
        'mousedown': 'onTouchStart',
        'touchmove': 'onTouchMove',
        'mousemove': 'onTouchMove',
        'touchend': 'onTouchEnd',
        'mouseup': 'onTouchEnd'
    };

    var _widgetSpecificProperties = {
        'Form': {'enableScrolling': 'enableScrolling', 'contentSizeMeasured': {'height': 'contentHeight', 'width': 'contentWidth'}},
        'FlexScrollContainer': {'enableScrolling': 'enableScrolling', 'contentSizeMeasured': {'height': 'contentHeight', 'width': 'contentWidth'}, 'layoutType': 'layoutType'},
        'Segment': {'enableScrolling': 'enableScrolling'},
        'FlexContainer': {'layoutType': 'layoutType'}

    };

    

    var _addDirectProperties = function(widgetModel, formID) {
        var directProperties = {};
        var key, margin, mappedMargin = {}, child, children, childMap, flatClonedModels, count;

        for(key in _directPropertyMap) {
            if(key === 'children' || key === 'visiblecells') {
                children = [];
                if(key === 'children') { 
                    children = widgetModel.widgets && widgetModel.widgets();
                } else if(key === 'visiblecells') { 
                    if(widgetModel.wType === 'Segment') {
                        children = widgetModel.clonedTemplates || [];
                        if(widgetModel.hasSections) {
                            flatClonedModels = [];
                            for(count = 0; count < children.length; count++) {
                                flatClonedModels.push(children[count][0]);
                                flatClonedModels = flatClonedModels.concat(children[count][1]);
                            }
                            children = flatClonedModels;
                        }
                    }
                }
                if(children && children.length > 0) {
                    childMap = [];
                    for(child = 0; child <children.length; child++) {
                        if(children[child].isVisible === true) {
                            childMap.push(_recursivelyGetWidgetData(children[child], formID));
                        }
                    }
                    directProperties[_directPropertyMap[key]] = childMap;
                } else {
                    if(key === 'children') {
                        directProperties[_directPropertyMap[key]] = [];
                    }
                }
            } else if(key === 'margin' || key === 'padding') {
                margin = widgetModel[key];
                mappedMargin = {
                    'left': margin[0],
                    'top': margin[1],
                    'right': margin[2],
                    'bottom': margin[3]
                };
                directProperties[_directPropertyMap[key]] = mappedMargin;
            }
        }

        return directProperties;
    };

    var _addVarianceProperties = function(widgetModel, formID) {
        
        var varianceProperties = {};

        varianceProperties = _variancePropertyMap;

        return varianceProperties;
    };

    var _addInlineProperties = function(widgetModel, formID) {
        var inlineProperties = {}, contentSize;
        var key, wType = widgetModel.wType, widgetSpecificProperties, subKey,
        subProperty, value;

        for(key in _inlinePropertyMap) {
            if(!inlineProperties[_inlinePropertyMap[key]] && typeof _inlinePropertyMap[key] !== "undefined") {
                if(_inlinePropertyMap[key] === 'Type' &&
                   widgetModel.masterType === constants.MASTER_TYPE_DEFAULT || widgetModel.name === "kony.ui.KComponent") {
                    inlineProperties[_inlinePropertyMap[key]] = 'kony.ui.User';
                } else {
                    inlineProperties[_inlinePropertyMap[key]] = widgetModel[key];
                }
            }
        }

        for(key in _inlineFramePropertyMap) {
            inlineProperties[_inlineFramePropertyMap[key]] = widgetModel.frame[key];
        }

        for(key in _inlineClientBounds) {
            if(widgetModel._internals.clientBounds[key]) {
                inlineProperties[_inlineClientBounds[key]] = widgetModel._internals.clientBounds[key] || 0;
            }
        }

        widgetSpecificProperties = _widgetSpecificProperties[wType];

        if(widgetSpecificProperties) {
            for(key in widgetSpecificProperties) {
                subKey = widgetSpecificProperties[key];
                value = widgetModel[key];
                if(key === "layoutType") {
                    if(value == kony.flex.FLOW_HORIZONTAL) {
                        value = "FLOW_HORIZONTAL";
                    } else if(value == kony.flex.FLOW_VERTICAL) {
                        value = "FLOW_VERTICAL";
                    } else {
                        value = "FREE_FORM";
                    }
                }
                if(typeof subKey === 'object') {
                    for(subProperty in subKey) {
                        inlineProperties[subKey[subProperty]] = value[subProperty];
                    }
                } else {
                    inlineProperties[subKey] = value;
                }
            }
        }

        return inlineProperties;
    };

    var _formatXML = function(xml) {
        var formatted = '', indent= '', i, node;
        var tab = '\t', nodes = xml.split(/>\s*</);
        for(i = 0; i < nodes.length; i++) {
            node = nodes[i];
            if(node.match( /^\/\w/ )) {
               indent = indent.substring(tab.length); 
            }
            formatted += indent + '<' + node + '>\r\n';
            if(node.match( /^<?\w[^>]*[^\/]$/ )) {
                indent += tab;              
            }
        }

        return formatted.substring(1, formatted.length-3);
    }

    var _generateAllWidgetsXML = function(data) {
        var widget, xml = '', key;

        if(data) {
            if(data instanceof Array) {
                for(key = 0; key < data.length; key++) {
                    widget = data[key];

                    xml += '<WidgetData ' + _generateInlineXML(widget) + '>';

                    xml += _generateDirectXML(widget);

                    xml += _generateTimeConsumingEventXML(widget);

                    xml += _generateVarianceXML(widget);

                    xml += '</WidgetData>';
                }

            } else {
                for(key in data) {
                    if($KG.appbehaviors["responsive"] === true) {
                        xml += _generateFormXMLforDesktop(data[key]);
                    } else {
                        xml += _generateFormXMLforSpa(data[key]);
                                                                 
                                                                 
                    }
                }
            }
        }

        return xml;
    };

    var _generateFormXMLforDesktop = function(formData) {
        var widget, xml = '', isInlineSet = false;

        xml += '<WidgetData ' + _generateInlineXMLForDesktopForm(formData[Object.keys(formData)[0]])  + '>';
        for(key in formData) {

            widget = formData[key];

            xml += '<Breakpoint value = "' + key +'" '+ _generateInlineXMLForDesktopForm(widget, true) + '>';

            xml += _generateDirectXML(widget);

            xml += _generateTimeConsumingEventXML(widget);

            xml += _generateVarianceXML(widget);

            xml += '</Breakpoint>';
        }
        xml += '</WidgetData>';

        return xml;
    };

    var _generateFormXMLforSpa = function(formData) {
        var xml = '';

        xml += '<WidgetData ' + _generateInlineXML(formData) + '>';

        xml += _generateDirectXML(formData);

        xml += _generateTimeConsumingEventXML(formData);

        xml += _generateVarianceXML(formData);

        xml += '</WidgetData>';

        return xml;
    };

    var _generateDirectXML = function(data) {
        var key, directProperties = data.directProperties, xml = '', subKey, subProperty;

        for(key in directProperties) {
            subProperty = directProperties[key];
            if(key === 'Children' || key === 'visibleCells') {
                xml += '<' + key + '>';
                xml += _generateAllWidgetsXML(subProperty);
                xml += '</' + key + '>';
            } else if(key === 'Margin' || key === 'Padding') {
                xml += '<' + key + '>';
                for(subKey in subProperty) {
                    xml += '<' + subKey + '>';
                    xml += subProperty[subKey];
                    xml += '</' + subKey + '>';
                }
                xml += '</' + key + '>';
            }
        }

        return xml;
    };

    var _generateTimeConsumingEventXML = function(data) {
        var xml, widgetInternals = data._model._internals, touchEventData = {}, key;

        xml = '<touchEventsTimeConsumed>';
        if(widgetInternals && widgetInternals.touchEventsTimeConsumed) {
            touchEventData = widgetInternals.touchEventsTimeConsumed;
            for(key in _timeConsumingEventData) {
                if(touchEventData[key]) {
                    xml += '<' + _timeConsumingEventData[key] + '>';
                    xml += touchEventData[key];
                    xml += '</' + _timeConsumingEventData[key] + '>';
                }
            }
        }
        xml += '</touchEventsTimeConsumed>';

        return xml;
    };

    var _setFormAccessDetails = function() {
        var key, subKey;

        for(key in _dataSet) {
            if($KG.appbehaviors["responsive"] === true)  {
                for(subKey in _dataSet[key]) {
                    _dataSet[key][subKey].inlineProperties.FormLoadedBeforeShow = $KC.konyCOPPrerenderFormAccessedData[key];
                    if($KC.konyCOPFormAccess && $KC.konyCOPFormAccess[key]) {
                        _dataSet[key][subKey].inlineProperties.FormLoadedBeforeShow = $KC.konyCOPFormAccess[key];
                    }
                }
            } else {
                _dataSet[key].inlineProperties.FormLoadedBeforeShow = $KC.konyCOPPrerenderFormAccessedData[key];
                if($KC.konyCOPFormAccess && $KC.konyCOPFormAccess[key]) {
                    _dataSet[key].inlineProperties.FormLoadedBeforeShow = $KC.konyCOPFormAccess[key];
                }
            }
        }
    };

    var _generateInlineXML = function(data) {
        var key, inlineProperties = data.inlineProperties, seperator = ' ', xml = '', equator = '=', quotes = '"';

        for(key in inlineProperties) {
            xml += key + equator + quotes + inlineProperties[key] + quotes + seperator;
        }
        xml = xml.trim();

        return xml;
    };

    var _generateInlineXMLForDesktopForm = function(data, breakpointInline) {
        var key, inlineProperties = data.inlineProperties, seperator = ' ', xml = '', equator = '=', quotes = '"';
        if(breakpointInline) {

            for(key in inlineProperties) {
                if(key != 'Type' && key != 'ID') {
                    xml += key + equator + quotes + inlineProperties[key] + quotes + seperator;
                }
            }

        } else {
            xml += 'Type = "'+ inlineProperties.Type +'" ID = "' + inlineProperties.ID  +'"';
        }

        xml = xml.trim();
        return xml;
    };

    var _generateVarianceXML = function(data) {
        var key, varianceProperties = data.varianceProperties, xml = '';

        for(key in varianceProperties) {
            xml += '<' + key + '>' + varianceProperties[key] + '</' + key + '>';
        }

        return xml;
    };

    var _recursivelyGetWidgetData = function(widgetModel, formID) {
        

        var dataSet= {};

        
        dataSet.inlineProperties = _addInlineProperties(widgetModel, formID);

        widgetModel = $KW.Utils.getActualWidgetModel(widgetModel);

        
        dataSet.directProperties = _addDirectProperties(widgetModel, formID);

        
        dataSet.varianceProperties = _addVarianceProperties(widgetModel, formID);

        dataSet._model = widgetModel;

        return dataSet;
    };

    var module = {
        konyCOPFormAccess : {},
        konyCOPPrerenderFormAccessedData : {},
        widgetDataRecording : false,
        isRecording : false,

        setClientBoundsForXML: function(wModel, wNode) {
            var height, childNode, lineHeight, lineSize, display, noOfLines;

            wModel._internals.clientBounds = wNode.getBoundingClientRect();
            if(wModel.wType === 'FlexContainer') {
                wModel._internals.clientBounds.scrollheight = wNode.firstChild.firstChild.scrollHeight;
                wModel._internals.clientBounds.scrollwidth = wNode.firstChild.firstChild.scrollWidth;
            } else if(['Label', 'Button', 'RichText'].indexOf(wModel.wType) != -1) {
                childNode = $KW.Utils.getWidgetNode(wModel, wNode);

                height = childNode.style.height;
                display = childNode.style.display;

                childNode.style.display = 'block';
                childNode.style.height ='auto';
                wModel._internals.clientBounds.contentWidth = childNode.scrollWidth;
                wModel._internals.clientBounds.contentHeight = childNode.scrollHeight;

                if(wModel.wType != 'RichText') {
                    fontSize = parseInt($KU.getStyle(childNode, "font-size"));
                    lineHeight = $KU.getStyle(childNode, "line-height");
                    if(lineHeight == "normal") {
                      lineSize = fontSize * 1.2;
                    } else {
                      lineSize = fontSize * parseInt(lineHeight);
                    }
                    noOfLines = wModel._internals.clientBounds.contentHeight/lineSize;
                    wModel._internals.clientBounds.numberOfLines = Math.ceil(noOfLines);
                }

                childNode.style.height = height;
                childNode.style.display = display;
            }
        },
        generateFormJSONAfterRender: function(formModel) {
            var widgetData = _recursivelyGetWidgetData(formModel, formModel.id);
            var breakpoints, breakpointValue;
            if($KG.appbehaviors["responsive"] === true) {
                breakpointValue = $KW.Form.getCurrentBreakpoint();
                if(breakpointValue == constants.BREAKPOINT_MAX_VALUE) {
                    breakpoints = formModel.breakpoints;
                    breakpointValue = breakpoints[breakpoints.length -1];
                }
                if(!_dataSet[formModel.id]) _dataSet[formModel.id] = {};
                _dataSet[formModel.id][breakpointValue] = widgetData;
            } else {
                _dataSet[formModel.id] = widgetData;
            }
            
        },
        generateXMLFormJSON: function() {
            module.generateFormJSONAfterRender($KG.__currentForm);
            _setFormAccessDetails();
            var xml = '<?xml version="1.0" encoding="UTF-8"?><AppData xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema">'
            var channel, _appLoadTime, loadTimeXML = "", platform = $KG.platformver;

            if(window.performance.getEntriesByType('paint').length > 0) {
                _appLoadTime = window.performance.getEntriesByType('paint')[1].startTime;
            }

            loadTimeXML += _appLoadTime ? '<AppLoadTime>'+ _appLoadTime +'</AppLoadTime>' : '';
            if(kony.appinit.isMob) channel = "MOBILE";
            else if(kony.appinit.isTablet) channel = "TABLET";
            else channel = "DESKTOP";

            platform = platform.slice(0, -1);
            xml += '<AppName>' + $KG.appid + '</AppName>' +
                    loadTimeXML +
                   '<ScreenHeight>' + screen.availHeight + '</ScreenHeight>' +
                   '<ScreenWidth>' + screen.availWidth + '</ScreenWidth>' +
                   '<Channel>' + channel + '</Channel>' +
                   '<Platform>' + platform + '</Platform>' +
                   '<DevicePixelRatio>' + window.devicePixelRatio + '</DevicePixelRatio>';



            xml += '<AllWidgets>';

            xml += _generateAllWidgetsXML(_dataSet);

            xml += '</AllWidgets>';

            xml += '</AppData>'

            xml = _formatXML(xml);

            return xml;
        }
    };

    return module;
})();
